/* Generated from library.scm by the CHICKEN compiler
   http://www.call-cc.org
   Version 6.0.0pre1 ((HEAD detached at 6.0.0pre1)) (rev 05be15d4)
   linux-unix-gnu-x86-64 [ 64bit dload ptables ]
   command line: library.scm -optimize-level 2 -include-path . -include-path ./ -inline -ignore-repository -feature chicken-bootstrap -no-warnings -specialize -consult-types-file ./types.db -explicit-use -no-trace -output-file library.c -no-module-registration -emit-import-library chicken.bitwise -emit-import-library chicken.bytevector -emit-import-library chicken.fixnum -emit-import-library chicken.flonum -emit-import-library chicken.gc -emit-import-library chicken.keyword -emit-import-library chicken.platform -emit-import-library chicken.plist -emit-import-library chicken.io -emit-import-library chicken.process-context
   unit: library
   uses: build-version library
*/
#include "chicken.h"

#include <errno.h>
#include <float.h>

#ifdef HAVE_SYSEXITS_H
# include <sysexits.h>
#endif

#ifndef EX_SOFTWARE
# define EX_SOFTWARE	70
#endif

#define C_close_file(p)	      (C_fclose((C_FILEPTR)(C_port_file(p))), C_SCHEME_UNDEFINED)
#define C_a_f64peek(ptr, c, b, i)  C_flonum(ptr, ((double *)C_data_pointer(b))[ C_unfix(i) ])
#define C_fetch_c_strlen(b, i) C_fix(strlen((C_char *)C_block_item(b, C_unfix(i))))
#define C_asciiz_strlen(str) C_fix(strlen(C_c_string(str)))
#define C_peek_c_string(b, i, to, len) (C_memcpy(C_data_pointer(to), (C_char *)C_block_item(b, C_unfix(i)), C_unfix(len)), C_SCHEME_UNDEFINED)
#define C_free_mptr(p, i)     (C_free((void *)C_block_item(p, C_unfix(i))), C_SCHEME_UNDEFINED)
#define C_free_sptr(p, i)     (C_free((void *)(((C_char **)C_block_item(p, 0))[ C_unfix(i) ])), C_SCHEME_UNDEFINED)

#define C_a_get_current_seconds(ptr, c, dummy)  C_int64_to_num(ptr, time(NULL))
#define C_peek_c_string_at(ptr, i)    ((C_char *)(((C_char **)ptr)[ i ]))

#define C_utf_bytes_needed(b)  C_fix(C_utf_expect(C_unfix(b)))

static C_word
fast_read_line_from_file(C_word str, C_word port, C_word size) {
  int n = C_unfix(size);
  int i;
  int c;
  char *buf = C_c_string(str);
  C_FILEPTR fp = C_port_file(port);

  if ((c = C_getc(fp)) == EOF) {
    if (ferror(fp)) {
      clearerr(fp);
      return C_fix(-1);
    } else { /* feof (fp) */
      return C_SCHEME_END_OF_FILE;
    }
  }

  C_ungetc(c, fp);

  for (i = 0; i < n; i++) {
    c = C_getc(fp);

    if(c == EOF && ferror(fp)) {
      clearerr(fp);
      return C_fix(-(i + 1));
    }

    switch (c) {
    case '\r':	if ((c = C_getc(fp)) != '\n') C_ungetc(c, fp);
    case EOF:	clearerr(fp);
    case '\n':	return C_fix(i);
    }
    buf[i] = c;
  }
  return C_SCHEME_FALSE;
}

static C_word
fast_read_string_from_file(C_word dest, C_word port, C_word len, C_word pos)
{
  size_t m;
  int n = C_unfix (len);
  C_char * buf = C_c_string(dest) + C_unfix(pos);
  C_FILEPTR fp = C_port_file (port);

  if(feof(fp)) return C_SCHEME_END_OF_FILE;

  m = fread (buf, sizeof (char), n, fp);

  if (m < n) {
    if (ferror(fp)) /* Report to Scheme, which may retry, so clear errors */
      clearerr(fp);
    else if (feof(fp) && 0 == m) /* eof but m > 0? Return data first, below */
      return C_SCHEME_END_OF_FILE; /* Calling again will get us here */
  }

  return C_fix (m);
}

static C_word
shallow_equal(C_word x, C_word y)
{
  /* assumes x and y are non-immediate */
  int i, len = C_header_size(x);

  if(C_header_size(y) != len) return C_SCHEME_FALSE;
  else return C_mk_bool(!C_memcmp((void *)x, (void *)y, len * sizeof(C_word)));
}

static C_word
signal_debug_event(C_word mode, C_word msg, C_word args)
{
  C_DEBUG_INFO cell;
  C_word av[ 3 ];
  cell.enabled = 1;
  cell.event = C_DEBUG_SIGNAL;
  cell.loc = "";
  cell.val = "";
  av[ 0 ] = mode;
  av[ 1 ] = msg;
  av[ 2 ] = args;
  C_debugger(&cell, 3, av);
  return C_SCHEME_UNDEFINED;
}

static C_word C_i_sleep_until_interrupt(C_word secs)
{
   while(C_i_process_sleep(secs) == C_fix(-1) && errno == EINTR);
   return C_SCHEME_UNDEFINED;
}

#ifdef NO_DLOAD2
# define HAVE_DLOAD 0
#else
# define HAVE_DLOAD 1
#endif

#ifdef C_ENABLE_PTABLES
# define HAVE_PTABLES 1
#else
# define HAVE_PTABLES 0
#endif

#ifdef C_GC_HOOKS
# define HAVE_GCHOOKS 1
#else
# define HAVE_GCHOOKS 0
#endif

#if defined(C_CROSS_CHICKEN) && C_CROSS_CHICKEN
# define IS_CROSS_CHICKEN 1
#else
# define IS_CROSS_CHICKEN 0
#endif


#define C_chdir(str) C_fix(chdir(C_c_string(str)))
#define C_curdir(buf, size) (getcwd(C_c_string(buf), size) ? C_fix(strlen(C_c_string(buf))) : C_SCHEME_FALSE)



static C_PTABLE_ENTRY *create_ptable(void);
C_noret_decl(C_build_2dversion_toplevel)
C_extern void C_ccall C_build_2dversion_toplevel(C_word c,C_word *av) C_noret;
C_noret_decl(C_library_toplevel)
C_extern void C_ccall C_library_toplevel(C_word c,C_word *av) C_noret;

static C_word lf[1631];
static double C_possibly_force_alignment;
static C_char li0[] C_aligned={C_lihdr(0,0,14),40,115,99,104,101,109,101,35,110,111,116,32,120,41,0,0};
static C_char li1[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,98,111,111,108,101,97,110,63,32,120,41,0,0,0,0,0};
static C_char li2[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,101,113,63,32,120,32,121,41};
static C_char li3[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,101,113,118,63,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li4[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,101,113,117,97,108,63,32,120,32,121,41,0,0,0,0,0};
static C_char li5[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,102,41};
static C_char li6[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,98,111,111,108,101,97,110,61,63,32,120,32,121,32,46,32,109,111,114,101,41,0,0,0};
static C_char li7[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,102,41};
static C_char li8[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,115,121,109,98,111,108,61,63,32,120,32,121,32,46,32,109,111,114,101,41,0,0,0,0};
static C_char li9[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,112,97,105,114,63,32,120,41};
static C_char li10[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,111,110,115,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li11[] C_aligned={C_lihdr(0,0,14),40,115,99,104,101,109,101,35,99,97,114,32,120,41,0,0};
static C_char li12[] C_aligned={C_lihdr(0,0,14),40,115,99,104,101,109,101,35,99,100,114,32,120,41,0,0};
static C_char li13[] C_aligned={C_lihdr(0,0,21),40,115,99,104,101,109,101,35,115,101,116,45,99,97,114,33,32,120,32,121,41,0,0,0};
static C_char li14[] C_aligned={C_lihdr(0,0,21),40,115,99,104,101,109,101,35,115,101,116,45,99,100,114,33,32,120,32,121,41,0,0,0};
static C_char li15[] C_aligned={C_lihdr(0,0,15),40,115,99,104,101,109,101,35,99,97,100,114,32,120,41,0};
static C_char li16[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,99,97,100,100,114,32,120,41};
static C_char li17[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,97,100,100,100,114,32,120,41,0,0,0,0,0,0,0};
static C_char li18[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,100,100,100,100,114,32,120,41,0,0,0,0,0,0,0};
static C_char li19[] C_aligned={C_lihdr(0,0,15),40,115,99,104,101,109,101,35,99,97,97,114,32,120,41,0};
static C_char li20[] C_aligned={C_lihdr(0,0,15),40,115,99,104,101,109,101,35,99,100,97,114,32,120,41,0};
static C_char li21[] C_aligned={C_lihdr(0,0,15),40,115,99,104,101,109,101,35,99,100,100,114,32,120,41,0};
static C_char li22[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,99,97,97,97,114,32,120,41};
static C_char li23[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,99,97,97,100,114,32,120,41};
static C_char li24[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,99,97,100,97,114,32,120,41};
static C_char li25[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,99,100,97,97,114,32,120,41};
static C_char li26[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,99,100,97,100,114,32,120,41};
static C_char li27[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,99,100,100,97,114,32,120,41};
static C_char li28[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,99,100,100,100,114,32,120,41};
static C_char li29[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,97,97,97,97,114,32,120,41,0,0,0,0,0,0,0};
static C_char li30[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,97,97,97,100,114,32,120,41,0,0,0,0,0,0,0};
static C_char li31[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,97,97,100,97,114,32,120,41,0,0,0,0,0,0,0};
static C_char li32[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,97,97,100,100,114,32,120,41,0,0,0,0,0,0,0};
static C_char li33[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,97,100,97,97,114,32,120,41,0,0,0,0,0,0,0};
static C_char li34[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,97,100,97,100,114,32,120,41,0,0,0,0,0,0,0};
static C_char li35[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,97,100,100,97,114,32,120,41,0,0,0,0,0,0,0};
static C_char li36[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,100,97,97,97,114,32,120,41,0,0,0,0,0,0,0};
static C_char li37[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,100,97,97,100,114,32,120,41,0,0,0,0,0,0,0};
static C_char li38[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,100,97,100,97,114,32,120,41,0,0,0,0,0,0,0};
static C_char li39[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,100,97,100,100,114,32,120,41,0,0,0,0,0,0,0};
static C_char li40[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,100,100,97,97,114,32,120,41,0,0,0,0,0,0,0};
static C_char li41[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,100,100,97,100,114,32,120,41,0,0,0,0,0,0,0};
static C_char li42[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,99,100,100,100,97,114,32,120,41,0,0,0,0,0,0,0};
static C_char li43[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,110,117,108,108,63,32,120,41};
static C_char li44[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,108,105,115,116,32,46,32,108,115,116,41,0,0,0,0,0};
static C_char li45[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,108,101,110,103,116,104,32,108,115,116,41,0,0,0,0,0};
static C_char li46[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,108,105,115,116,45,116,97,105,108,32,108,115,116,32,105,41};
static C_char li47[] C_aligned={C_lihdr(0,0,23),40,115,99,104,101,109,101,35,108,105,115,116,45,114,101,102,32,108,115,116,32,105,41,0};
static C_char li48[] C_aligned={C_lihdr(0,0,15),40,108,111,111,112,32,108,115,116,32,114,101,115,116,41,0};
static C_char li49[] C_aligned={C_lihdr(0,0,21),40,115,99,104,101,109,101,35,114,101,118,101,114,115,101,32,108,115,116,48,41,0,0,0};
static C_char li50[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,109,101,109,113,32,120,32,108,115,116,41,0,0,0,0,0};
static C_char li51[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,109,101,109,118,32,120,32,108,115,116,41,0,0,0,0,0};
static C_char li52[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li53[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,109,101,109,98,101,114,32,120,32,108,115,116,32,46,32,114,101,115,116,41,0,0,0,0};
static C_char li54[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,97,115,115,113,32,120,32,108,115,116,41,0,0,0,0,0};
static C_char li55[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,97,115,115,118,32,120,32,108,115,116,41,0,0,0,0,0};
static C_char li56[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li57[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,97,115,115,111,99,32,120,32,108,115,116,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li58[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,108,105,115,116,63,32,120,41};
static C_char li59[] C_aligned={C_lihdr(0,0,18),40,115,99,104,101,109,101,35,115,116,114,105,110,103,63,32,120,41,0,0,0,0,0,0};
static C_char li60[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,108,101,110,103,116,104,32,115,41};
static C_char li61[] C_aligned={C_lihdr(0,0,23),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,114,101,102,32,115,32,105,41,0};
static C_char li62[] C_aligned={C_lihdr(0,0,26),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,115,101,116,33,32,115,32,105,32,99,41,0,0,0,0,0,0};
static C_char li63[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,115,115,32,102,41,0,0,0,0,0};
static C_char li64[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,115,116,114,105,110,103,61,63,32,120,32,121,32,46,32,109,111,114,101,41,0,0,0,0};
static C_char li65[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,115,115,32,102,41,0,0,0,0,0};
static C_char li66[] C_aligned={C_lihdr(0,0,31),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,99,105,61,63,32,120,32,121,32,46,32,109,111,114,101,41,0};
static C_char li67[] C_aligned={C_lihdr(0,0,25),40,115,99,104,101,109,101,35,101,120,97,99,116,45,62,105,110,101,120,97,99,116,32,120,41,0,0,0,0,0,0,0};
static C_char li68[] C_aligned={C_lihdr(0,0,14),40,115,99,104,101,109,101,35,97,98,115,32,120,41,0,0};
static C_char li69[] C_aligned={C_lihdr(0,0,6),67,95,112,108,117,115,0,0};
static C_char li70[] C_aligned={C_lihdr(0,0,7),67,95,109,105,110,117,115,0};
static C_char li71[] C_aligned={C_lihdr(0,0,7),67,95,116,105,109,101,115,0};
static C_char li72[] C_aligned={C_lihdr(0,0,21),40,115,99,104,101,109,101,35,113,117,111,116,105,101,110,116,32,97,32,98,41,0,0,0};
static C_char li73[] C_aligned={C_lihdr(0,0,22),40,115,99,104,101,109,101,35,114,101,109,97,105,110,100,101,114,32,97,32,98,41,0,0};
static C_char li74[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,109,111,100,117,108,111,32,97,32,98,41,0,0,0,0,0};
static C_char li75[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,101,118,101,110,63,32,110,41};
static C_char li76[] C_aligned={C_lihdr(0,0,15),40,115,99,104,101,109,101,35,111,100,100,63,32,110,41,0};
static C_char li77[] C_aligned={C_lihdr(0,0,9),67,95,110,101,113,117,97,108,112,0,0,0,0,0,0,0};
static C_char li78[] C_aligned={C_lihdr(0,0,10),67,95,103,114,101,97,116,101,114,112,0,0,0,0,0,0};
static C_char li79[] C_aligned={C_lihdr(0,0,7),67,95,108,101,115,115,112,0};
static C_char li80[] C_aligned={C_lihdr(0,0,20),67,95,103,114,101,97,116,101,114,95,111,114,95,101,113,117,97,108,95,112,0,0,0,0};
static C_char li81[] C_aligned={C_lihdr(0,0,17),67,95,108,101,115,115,95,111,114,95,101,113,117,97,108,95,112,0,0,0,0,0,0,0};
static C_char li82[] C_aligned={C_lihdr(0,0,18),40,115,99,104,101,109,101,35,110,117,109,98,101,114,63,32,120,41,0,0,0,0,0,0};
static C_char li83[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,114,101,97,108,63,32,120,41};
static C_char li84[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,114,97,116,105,111,110,97,108,63,32,110,41,0,0,0,0};
static C_char li85[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,105,110,116,101,103,101,114,63,32,120,41,0,0,0,0,0};
static C_char li86[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,101,120,97,99,116,63,32,120,41,0,0,0,0,0,0,0};
static C_char li87[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,105,110,101,120,97,99,116,63,32,120,41,0,0,0,0,0};
static C_char li88[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,122,101,114,111,63,32,110,41};
static C_char li89[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,112,111,115,105,116,105,118,101,63,32,110,41,0,0,0,0};
static C_char li90[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,110,101,103,97,116,105,118,101,63,32,110,41,0,0,0,0};
static C_char li91[] C_aligned={C_lihdr(0,0,18),67,95,110,117,109,98,101,114,95,116,111,95,115,116,114,105,110,103,0,0,0,0,0,0};
static C_char li92[] C_aligned={C_lihdr(0,0,18),40,115,99,104,101,109,101,35,115,121,109,98,111,108,63,32,120,41,0,0,0,0,0,0};
static C_char li93[] C_aligned={C_lihdr(0,0,18),40,115,99,104,101,109,101,35,118,101,99,116,111,114,63,32,120,41,0,0,0,0,0,0};
static C_char li94[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,108,101,110,103,116,104,32,118,41};
static C_char li95[] C_aligned={C_lihdr(0,0,23),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,114,101,102,32,118,32,105,41,0};
static C_char li96[] C_aligned={C_lihdr(0,0,26),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,115,101,116,33,32,118,32,105,32,120,41,0,0,0,0,0,0};
static C_char li97[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,99,104,97,114,63,32,120,41};
static C_char li98[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,99,104,97,114,45,62,105,110,116,101,103,101,114,32,99,41};
static C_char li99[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,105,110,116,101,103,101,114,45,62,99,104,97,114,32,110,41};
static C_char li100[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,99,115,32,102,41,0,0,0,0,0};
static C_char li101[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,99,104,97,114,61,63,32,99,49,32,99,50,32,46,32,109,111,114,101,41,0,0,0,0};
static C_char li102[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,99,115,32,102,41,0,0,0,0,0};
static C_char li103[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,99,104,97,114,62,63,32,99,49,32,99,50,32,46,32,109,111,114,101,41,0,0,0,0};
static C_char li104[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,99,115,32,102,41,0,0,0,0,0};
static C_char li105[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,99,104,97,114,60,63,32,99,49,32,99,50,32,46,32,109,111,114,101,41,0,0,0,0};
static C_char li106[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,99,115,32,102,41,0,0,0,0,0};
static C_char li107[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,99,104,97,114,62,61,63,32,99,49,32,99,50,32,46,32,109,111,114,101,41,0,0,0};
static C_char li108[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,99,115,32,102,41,0,0,0,0,0};
static C_char li109[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,99,104,97,114,60,61,63,32,99,49,32,99,50,32,46,32,109,111,114,101,41,0,0,0};
static C_char li110[] C_aligned={C_lihdr(0,0,22),40,115,99,104,101,109,101,35,99,104,97,114,45,117,112,99,97,115,101,32,99,41,0,0};
static C_char li111[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,99,104,97,114,45,100,111,119,110,99,97,115,101,32,99,41};
static C_char li112[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,99,104,97,114,45,117,112,112,101,114,45,99,97,115,101,63,32,99,41,0,0,0,0,0};
static C_char li113[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,99,104,97,114,45,108,111,119,101,114,45,99,97,115,101,63,32,99,41,0,0,0,0,0};
static C_char li114[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,99,104,97,114,45,110,117,109,101,114,105,99,63,32,99,41};
static C_char li115[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,99,104,97,114,45,119,104,105,116,101,115,112,97,99,101,63,32,99,41,0,0,0,0,0};
static C_char li116[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,99,104,97,114,45,97,108,112,104,97,98,101,116,105,99,63,32,99,41,0,0,0,0,0};
static C_char li117[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,46,99,104,97,114,35,100,105,103,105,116,45,118,97,108,117,101,32,99,41,0,0,0,0,0};
static C_char li118[] C_aligned={C_lihdr(0,0,21),40,115,99,104,101,109,101,35,112,114,111,99,101,100,117,114,101,63,32,120,41,0,0,0};
static C_char li119[] C_aligned={C_lihdr(0,0,7),67,95,97,112,112,108,121,0};
static C_char li120[] C_aligned={C_lihdr(0,0,8),67,95,118,97,108,117,101,115};
static C_char li121[] C_aligned={C_lihdr(0,0,18),67,95,99,97,108,108,95,119,105,116,104,95,118,97,108,117,101,115,0,0,0,0,0,0};
static C_char li122[] C_aligned={C_lihdr(0,0,22),40,115,99,104,101,109,101,35,105,110,112,117,116,45,112,111,114,116,63,32,120,41,0,0};
static C_char li123[] C_aligned={C_lihdr(0,0,23),40,115,99,104,101,109,101,35,111,117,116,112,117,116,45,112,111,114,116,63,32,120,41,0};
static C_char li124[] C_aligned={C_lihdr(0,0,26),40,115,99,104,101,109,101,35,98,105,110,97,114,121,45,112,111,114,116,63,32,112,111,114,116,41,0,0,0,0,0,0};
static C_char li125[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,116,101,120,116,117,97,108,45,112,111,114,116,63,32,112,111,114,116,41,0,0,0,0,0};
static C_char li126[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,112,111,114,116,63,32,120,41};
static C_char li127[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,105,110,112,117,116,45,112,111,114,116,45,111,112,101,110,63,32,112,41,0,0,0,0,0};
static C_char li128[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,111,117,116,112,117,116,45,112,111,114,116,45,111,112,101,110,63,32,112,41,0,0,0,0};
static C_char li129[] C_aligned={C_lihdr(0,0,22),40,115,99,104,101,109,101,35,101,111,102,45,111,98,106,101,99,116,63,32,120,41,0,0};
static C_char li130[] C_aligned={C_lihdr(0,0,21),40,115,99,104,101,109,101,35,101,118,97,108,32,120,32,46,32,101,110,118,41,0,0,0};
static C_char li131[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,105,110,116,101,114,97,99,116,105,111,110,45,101,110,118,105,114,111,110,109,101,110,116,41};
static C_char li132[] C_aligned={C_lihdr(0,0,36),40,115,99,104,101,109,101,35,115,99,104,101,109,101,45,114,101,112,111,114,116,45,101,110,118,105,114,111,110,109,101,110,116,32,110,41,0,0,0,0};
static C_char li133[] C_aligned={C_lihdr(0,0,25),40,115,99,104,101,109,101,35,110,117,108,108,45,101,110,118,105,114,111,110,109,101,110,116,41,0,0,0,0,0,0,0};
static C_char li134[] C_aligned={C_lihdr(0,0,34),40,115,99,104,101,109,101,35,108,111,97,100,32,102,105,108,101,110,97,109,101,32,46,32,101,118,97,108,117,97,116,111,114,41,0,0,0,0,0,0};
static C_char li135[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,98,97,115,101,35,102,105,120,110,117,109,63,32,120,41};
static C_char li136[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,98,97,115,101,35,102,108,111,110,117,109,63,32,120,41};
static C_char li137[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,98,97,115,101,35,98,105,103,110,117,109,63,32,120,41};
static C_char li138[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,98,97,115,101,35,114,97,116,110,117,109,63,32,120,41};
static C_char li139[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,112,108,120,110,117,109,63,32,120,41,0,0,0,0,0,0,0};
static C_char li140[] C_aligned={C_lihdr(0,0,31),40,99,104,105,99,107,101,110,46,98,97,115,101,35,101,120,97,99,116,45,105,110,116,101,103,101,114,63,32,120,41,0};
static C_char li141[] C_aligned={C_lihdr(0,0,24),67,95,113,117,111,116,105,101,110,116,95,97,110,100,95,114,101,109,97,105,110,100,101,114};
static C_char li142[] C_aligned={C_lihdr(0,0,8),40,97,49,50,53,56,56,41};
static C_char li143[] C_aligned={C_lihdr(0,0,16),40,97,49,50,53,57,52,32,100,105,118,32,114,101,109,41};
static C_char li144[] C_aligned={C_lihdr(0,0,34),40,99,104,105,99,107,101,110,46,98,97,115,101,35,113,117,111,116,105,101,110,116,38,109,111,100,117,108,111,32,120,32,121,41,0,0,0,0,0,0};
static C_char li145[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,98,97,115,101,35,102,105,110,105,116,101,63,32,120,41};
static C_char li146[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,98,97,115,101,35,105,110,102,105,110,105,116,101,63,32,120,41,0,0,0,0,0,0};
static C_char li147[] C_aligned={C_lihdr(0,0,21),40,99,104,105,99,107,101,110,46,98,97,115,101,35,110,97,110,63,32,120,41,0,0,0};
static C_char li148[] C_aligned={C_lihdr(0,0,8),67,95,115,105,103,110,117,109};
static C_char li149[] C_aligned={C_lihdr(0,0,21),40,99,104,105,99,107,101,110,46,98,97,115,101,35,97,100,100,49,32,110,41,0,0,0};
static C_char li150[] C_aligned={C_lihdr(0,0,21),40,99,104,105,99,107,101,110,46,98,97,115,101,35,115,117,98,49,32,110,41,0,0,0};
static C_char li151[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,98,97,115,101,35,101,114,114,111,114,32,46,32,97,114,103,115,41,0,0,0,0,0};
static C_char li152[] C_aligned={C_lihdr(0,0,23),40,99,104,105,99,107,101,110,46,98,97,115,101,35,118,111,105,100,32,46,32,95,41,0};
static C_char li153[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,98,97,115,101,35,112,114,111,109,105,115,101,63,32,120,41,0,0,0,0,0,0,0};
static C_char li154[] C_aligned={C_lihdr(0,0,25),40,35,35,115,121,115,35,109,97,107,101,45,112,114,111,109,105,115,101,32,112,114,111,99,41,0,0,0,0,0,0,0};
static C_char li155[] C_aligned={C_lihdr(0,0,8),40,97,49,50,55,48,57,41};
static C_char li156[] C_aligned={C_lihdr(0,0,31),40,99,104,105,99,107,101,110,46,98,97,115,101,35,109,97,107,101,45,112,114,111,109,105,115,101,32,111,98,106,41,0};
static C_char li157[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,108,115,116,32,122,41,0,0,0,0};
static C_char li158[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,98,97,115,101,35,102,111,108,100,108,32,102,32,122,32,108,115,116,41,0,0,0,0};
static C_char li159[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li160[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,98,97,115,101,35,102,111,108,100,114,32,102,32,122,32,108,115,116,41,0,0,0,0};
static C_char li161[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,98,97,115,101,35,111,110,45,101,120,105,116,32,116,104,117,110,107,41,0,0,0,0};
static C_char li162[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,98,97,115,101,35,101,120,105,116,32,46,32,114,101,115,116,41,0,0,0,0,0,0};
static C_char li163[] C_aligned={C_lihdr(0,0,36),40,99,104,105,99,107,101,110,46,98,97,115,101,35,101,109,101,114,103,101,110,99,121,45,101,120,105,116,32,46,32,114,101,115,116,41,0,0,0,0};
static C_char li164[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,98,97,115,101,35,105,100,101,110,116,105,116,121,32,120,41,0,0,0,0,0,0,0};
static C_char li165[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,112,114,101,100,115,41,0,0,0,0};
static C_char li166[] C_aligned={C_lihdr(0,0,11),40,102,95,49,50,56,51,57,32,120,41,0,0,0,0,0};
static C_char li167[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,111,110,106,111,105,110,32,46,32,112,114,101,100,115,41,0,0};
static C_char li168[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,112,114,101,100,115,41,0,0,0,0};
static C_char li169[] C_aligned={C_lihdr(0,0,11),40,102,95,49,50,56,55,50,32,120,41,0,0,0,0,0};
static C_char li170[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,98,97,115,101,35,100,105,115,106,111,105,110,32,46,32,112,114,101,100,115,41,0,0};
static C_char li171[] C_aligned={C_lihdr(0,0,13),40,102,95,49,50,57,49,56,32,46,32,95,41,0,0,0};
static C_char li172[] C_aligned={C_lihdr(0,0,13),40,102,95,49,50,57,50,48,32,46,32,95,41,0,0,0};
static C_char li173[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,111,110,115,116,97,110,116,108,121,32,46,32,120,115,41,0,0};
static C_char li174[] C_aligned={C_lihdr(0,0,13),40,102,95,49,50,57,51,48,32,120,32,121,41,0,0,0};
static C_char li175[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,98,97,115,101,35,102,108,105,112,32,112,114,111,99,41};
static C_char li176[] C_aligned={C_lihdr(0,0,16),40,102,95,49,50,57,51,56,32,46,32,97,114,103,115,41};
static C_char li177[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,111,109,112,108,101,109,101,110,116,32,112,41,0,0,0,0,0};
static C_char li178[] C_aligned={C_lihdr(0,0,8),40,97,49,50,57,54,52,41};
static C_char li179[] C_aligned={C_lihdr(0,0,16),40,102,95,49,50,57,53,57,32,46,32,97,114,103,115,41};
static C_char li180[] C_aligned={C_lihdr(0,0,14),40,114,101,99,32,102,48,32,46,32,102,110,115,41,0,0};
static C_char li181[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,111,109,112,111,115,101,32,46,32,102,110,115,41,0,0,0,0};
static C_char li182[] C_aligned={C_lihdr(0,0,11),40,102,95,49,51,48,49,48,32,120,41,0,0,0,0,0};
static C_char li183[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,102,110,115,41,0,0,0,0,0,0};
static C_char li184[] C_aligned={C_lihdr(0,0,22),40,99,104,105,99,107,101,110,46,98,97,115,101,35,111,32,46,32,102,110,115,41,0,0};
static C_char li185[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li186[] C_aligned={C_lihdr(0,0,13),40,102,95,49,51,48,50,53,32,108,115,116,41,0,0,0};
static C_char li187[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,98,97,115,101,35,108,105,115,116,45,111,102,63,32,112,114,101,100,41,0,0,0,0};
static C_char li188[] C_aligned={C_lihdr(0,0,13),40,102,95,49,51,48,55,53,32,46,32,95,41,0,0,0};
static C_char li189[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,112,114,111,99,115,41,0,0,0,0};
static C_char li190[] C_aligned={C_lihdr(0,0,16),40,102,95,49,51,48,56,57,32,46,32,97,114,103,115,41};
static C_char li191[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,98,97,115,101,35,101,97,99,104,32,46,32,112,114,111,99,115,41,0,0,0,0,0};
static C_char li192[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,98,97,115,101,35,98,119,112,45,111,98,106,101,99,116,63,32,120,41,0,0,0,0};
static C_char li193[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,98,97,115,101,35,119,101,97,107,45,99,111,110,115,32,120,32,121,41,0,0,0,0};
static C_char li194[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,98,97,115,101,35,119,101,97,107,45,112,97,105,114,63,32,120,41,0,0,0,0,0};
static C_char li195[] C_aligned={C_lihdr(0,0,22),40,99,104,105,99,107,101,110,46,98,97,115,101,35,97,116,111,109,63,32,120,41,0,0};
static C_char li196[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li197[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,98,97,115,101,35,116,97,105,108,63,32,120,32,121,41};
static C_char li198[] C_aligned={C_lihdr(0,0,9),40,108,111,111,112,32,110,115,41,0,0,0,0,0,0,0};
static C_char li199[] C_aligned={C_lihdr(0,0,32),40,99,104,105,99,107,101,110,46,98,97,115,101,35,105,110,116,101,114,115,112,101,114,115,101,32,108,115,116,32,120,41};
static C_char li200[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li201[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,98,97,115,101,35,98,117,116,108,97,115,116,32,108,115,116,41,0,0,0,0,0,0};
static C_char li202[] C_aligned={C_lihdr(0,0,17),40,108,111,111,112,32,108,105,115,116,115,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li203[] C_aligned={C_lihdr(0,0,31),40,99,104,105,99,107,101,110,46,98,97,115,101,35,102,108,97,116,116,101,110,32,46,32,108,105,115,116,115,48,41,0};
static C_char li204[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,108,115,116,115,41,0,0,0,0,0};
static C_char li205[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,98,97,115,101,35,106,111,105,110,32,108,115,116,115,32,46,32,108,115,116,41,0,0};
static C_char li206[] C_aligned={C_lihdr(0,0,15),40,108,111,111,112,32,98,108,115,116,32,108,115,116,41,0};
static C_char li207[] C_aligned={C_lihdr(0,0,32),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,111,109,112,114,101,115,115,32,98,108,115,116,32,108,115,116,41};
static C_char li208[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,104,97,114,45,102,111,108,100,99,97,115,101,32,99,41,0,0};
static C_char li209[] C_aligned={C_lihdr(0,0,34),40,99,104,105,99,107,101,110,46,98,97,115,101,35,115,116,114,105,110,103,45,102,111,108,100,99,97,115,101,32,115,116,114,41,0,0,0,0,0,0};
static C_char li210[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li211[] C_aligned={C_lihdr(0,0,15),40,102,95,49,51,52,55,49,32,120,32,108,115,116,41,0};
static C_char li212[] C_aligned={C_lihdr(0,0,43),40,99,104,105,99,107,101,110,46,98,97,115,101,35,97,108,105,115,116,45,117,112,100,97,116,101,33,32,120,32,121,32,108,115,116,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li213[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li214[] C_aligned={C_lihdr(0,0,42),40,99,104,105,99,107,101,110,46,98,97,115,101,35,97,108,105,115,116,45,117,112,100,97,116,101,32,107,32,118,32,108,115,116,32,46,32,114,101,115,116,41,0,0,0,0,0,0};
static C_char li215[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li216[] C_aligned={C_lihdr(0,0,15),40,102,95,49,51,54,54,51,32,120,32,108,115,116,41,0};
static C_char li217[] C_aligned={C_lihdr(0,0,37),40,99,104,105,99,107,101,110,46,98,97,115,101,35,97,108,105,115,116,45,114,101,102,32,120,32,108,115,116,32,46,32,114,101,115,116,41,0,0,0};
static C_char li218[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,108,41};
static C_char li219[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,98,97,115,101,35,114,97,115,115,111,99,32,120,32,108,115,116,32,46,32,116,115,116,41,0,0,0,0,0,0,0};
static C_char li220[] C_aligned={C_lihdr(0,0,33),40,115,99,104,101,109,101,35,111,112,101,110,45,105,110,112,117,116,45,115,116,114,105,110,103,32,115,116,114,105,110,103,41,0,0,0,0,0,0,0};
static C_char li221[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,111,112,101,110,45,111,117,116,112,117,116,45,115,116,114,105,110,103,41,0,0,0,0,0};
static C_char li222[] C_aligned={C_lihdr(0,0,31),40,115,99,104,101,109,101,35,103,101,116,45,111,117,116,112,117,116,45,115,116,114,105,110,103,32,112,111,114,116,41,0};
static C_char li223[] C_aligned={C_lihdr(0,0,10),40,97,49,51,56,56,52,32,95,41,0,0,0,0,0,0};
static C_char li224[] C_aligned={C_lihdr(0,0,10),40,97,49,51,56,57,55,32,95,41,0,0,0,0,0,0};
static C_char li225[] C_aligned={C_lihdr(0,0,12),40,97,49,51,57,48,57,32,95,32,95,41,0,0,0,0};
static C_char li226[] C_aligned={C_lihdr(0,0,10),40,97,49,51,57,49,53,32,95,41,0,0,0,0,0,0};
static C_char li227[] C_aligned={C_lihdr(0,0,23),40,97,49,51,57,50,53,32,112,32,110,32,100,101,115,116,32,115,116,97,114,116,41,0};
static C_char li228[] C_aligned={C_lihdr(0,0,33),40,115,99,104,101,109,101,35,111,112,101,110,45,105,110,112,117,116,45,98,121,116,101,118,101,99,116,111,114,32,98,118,41,0,0,0,0,0,0,0};
static C_char li229[] C_aligned={C_lihdr(0,0,18),40,97,100,100,32,98,118,32,115,116,97,114,116,32,101,110,100,41,0,0,0,0,0,0};
static C_char li230[] C_aligned={C_lihdr(0,0,8),40,103,101,116,116,101,114,41};
static C_char li231[] C_aligned={C_lihdr(0,0,12),40,97,49,51,57,55,51,32,112,32,99,41,0,0,0,0};
static C_char li232[] C_aligned={C_lihdr(0,0,23),40,97,49,51,57,57,48,32,112,32,98,118,32,115,116,97,114,116,32,101,110,100,41,0};
static C_char li233[] C_aligned={C_lihdr(0,0,12),40,97,49,51,57,57,54,32,95,32,95,41,0,0,0,0};
static C_char li234[] C_aligned={C_lihdr(0,0,31),40,115,99,104,101,109,101,35,111,112,101,110,45,111,117,116,112,117,116,45,98,121,116,101,118,101,99,116,111,114,41,0};
static C_char li235[] C_aligned={C_lihdr(0,0,6),40,102,97,105,108,41,0,0};
static C_char li236[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,103,101,116,45,111,117,116,112,117,116,45,98,121,116,101,118,101,99,116,111,114,32,112,41};
static C_char li237[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,43,32,120,32,121,41};
static C_char li238[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,45,32,120,32,121,41};
static C_char li239[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,42,32,120,32,121,41};
static C_char li240[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,61,32,120,32,121,41};
static C_char li241[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,62,32,120,32,121,41};
static C_char li242[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,60,32,120,32,121,41};
static C_char li243[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,62,61,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li244[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,60,61,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li245[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,109,105,110,32,120,32,121,41,0,0,0,0,0,0};
static C_char li246[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,109,97,120,32,120,32,121,41,0,0,0,0,0,0};
static C_char li247[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,110,101,103,32,120,41};
static C_char li248[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,97,110,100,32,120,32,121,41,0,0,0,0,0,0};
static C_char li249[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,105,111,114,32,120,32,121,41,0,0,0,0,0,0};
static C_char li250[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,120,111,114,32,120,32,121,41,0,0,0,0,0,0};
static C_char li251[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,110,111,116,32,120,41};
static C_char li252[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,115,104,108,32,120,32,121,41,0,0,0,0,0,0};
static C_char li253[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,115,104,114,32,120,32,121,41,0,0,0,0,0,0};
static C_char li254[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,111,100,100,63,32,120,41,0,0,0,0,0,0,0};
static C_char li255[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,101,118,101,110,63,32,120,41,0,0,0,0,0,0};
static C_char li256[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,108,101,110,32,120,41};
static C_char li257[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,47,32,120,32,121,41};
static C_char li258[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,103,99,100,32,120,32,121,41,0,0,0,0,0,0};
static C_char li259[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,109,111,100,32,120,32,121,41,0,0,0,0,0,0};
static C_char li260[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,114,101,109,32,120,32,121,41,0,0,0,0,0,0};
static C_char li261[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,43,63,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li262[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,45,63,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li263[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,42,63,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li264[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,105,120,110,117,109,35,102,120,47,63,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li265[] C_aligned={C_lihdr(0,0,19),40,35,35,115,121,115,35,100,101,98,117,103,45,109,111,100,101,63,41,0,0,0,0,0};
static C_char li266[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,98,97,115,101,35,119,97,114,110,105,110,103,32,109,115,103,32,46,32,97,114,103,115,41,0,0,0,0,0,0,0};
static C_char li267[] C_aligned={C_lihdr(0,0,32),40,99,104,105,99,107,101,110,46,98,97,115,101,35,110,111,116,105,99,101,32,109,115,103,32,46,32,97,114,103,115,41};
static C_char li268[] C_aligned={C_lihdr(0,0,37),40,99,104,105,99,107,101,110,46,98,97,115,101,35,101,110,97,98,108,101,45,119,97,114,110,105,110,103,115,32,46,32,98,111,111,108,41,0,0,0};
static C_char li269[] C_aligned={C_lihdr(0,0,30),40,35,35,115,121,115,35,101,114,114,111,114,47,101,114,114,110,111,32,101,114,114,32,46,32,97,114,103,115,41,0,0};
static C_char li270[] C_aligned={C_lihdr(0,0,4),67,95,103,99,0,0,0,0};
static C_char li271[] C_aligned={C_lihdr(0,0,21),40,35,35,115,121,115,35,115,101,116,115,108,111,116,32,120,32,105,32,121,41,0,0,0};
static C_char li272[] C_aligned={C_lihdr(0,0,22),40,35,35,115,121,115,35,115,101,116,105,115,108,111,116,32,120,32,105,32,121,41,0,0};
static C_char li273[] C_aligned={C_lihdr(0,0,17),67,95,97,108,108,111,99,97,116,101,95,118,101,99,116,111,114,0,0,0,0,0,0,0};
static C_char li274[] C_aligned={C_lihdr(0,0,21),67,95,97,108,108,111,99,97,116,101,95,98,121,116,101,118,101,99,116,111,114,0,0,0};
static C_char li275[] C_aligned={C_lihdr(0,0,16),67,95,109,97,107,101,95,115,116,114,117,99,116,117,114,101};
static C_char li276[] C_aligned={C_lihdr(0,0,21),67,95,101,110,115,117,114,101,95,104,101,97,112,95,114,101,115,101,114,118,101,0,0,0};
static C_char li277[] C_aligned={C_lihdr(0,0,23),67,95,103,101,116,95,115,121,109,98,111,108,95,116,97,98,108,101,95,105,110,102,111,0};
static C_char li278[] C_aligned={C_lihdr(0,0,17),67,95,103,101,116,95,109,101,109,111,114,121,95,105,110,102,111,0,0,0,0,0,0,0};
static C_char li279[] C_aligned={C_lihdr(0,0,19),40,35,35,115,121,115,35,115,116,97,114,116,45,116,105,109,101,114,41,0,0,0,0,0};
static C_char li280[] C_aligned={C_lihdr(0,0,12),67,95,115,116,111,112,95,116,105,109,101,114,0,0,0,0};
static C_char li281[] C_aligned={C_lihdr(0,0,12),67,95,115,116,111,112,95,116,105,109,101,114,0,0,0,0};
static C_char li282[] C_aligned={C_lihdr(0,0,18),40,35,35,115,121,115,35,115,116,111,112,45,116,105,109,101,114,41,0,0,0,0,0,0};
static C_char li283[] C_aligned={C_lihdr(0,0,20),40,35,35,115,121,115,35,105,109,109,101,100,105,97,116,101,63,32,120,41,0,0,0,0};
static C_char li284[] C_aligned={C_lihdr(0,0,19),40,35,35,115,121,115,35,109,101,115,115,97,103,101,32,115,116,114,41,0,0,0,0,0};
static C_char li285[] C_aligned={C_lihdr(0,0,16),40,35,35,115,121,115,35,98,121,116,101,32,120,32,105,41};
static C_char li286[] C_aligned={C_lihdr(0,0,16),40,35,35,115,121,115,35,104,97,108,116,32,109,115,103,41};
static C_char li287[] C_aligned={C_lihdr(0,0,8),67,95,98,101,99,111,109,101};
static C_char li288[] C_aligned={C_lihdr(0,0,21),40,35,35,115,121,115,35,98,108,111,99,107,45,114,101,102,32,120,32,105,41,0,0,0};
static C_char li289[] C_aligned={C_lihdr(0,0,14),67,95,97,112,112,108,121,95,118,97,108,117,101,115,0,0};
static C_char li290[] C_aligned={C_lihdr(0,0,14),67,95,99,111,112,121,95,99,108,111,115,117,114,101,0,0};
static C_char li291[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,98,108,111,99,107,45,115,101,116,33,32,120,32,105,32,121,41};
static C_char li292[] C_aligned={C_lihdr(0,0,43),40,99,104,105,99,107,101,110,46,116,105,109,101,35,99,117,114,114,101,110,116,45,112,114,111,99,101,115,115,45,109,105,108,108,105,115,101,99,111,110,100,115,41,0,0,0,0,0};
static C_char li293[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,116,105,109,101,35,99,117,114,114,101,110,116,45,115,101,99,111,110,100,115,41,0,0};
static C_char li294[] C_aligned={C_lihdr(0,0,23),40,99,104,105,99,107,101,110,46,116,105,109,101,35,99,112,117,45,116,105,109,101,41,0};
static C_char li295[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,99,104,101,99,107,45,115,116,114,117,99,116,117,114,101,32,120,32,121,32,46,32,108,111,99,41,0,0,0,0,0,0,0};
static C_char li296[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,99,104,101,99,107,45,98,108,111,98,32,120,32,46,32,108,111,99,41,0,0,0,0,0,0};
static C_char li297[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,99,104,101,99,107,45,112,97,105,114,32,120,32,46,32,108,111,99,41,0,0,0,0,0,0};
static C_char li298[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,99,104,101,99,107,45,108,105,115,116,32,120,32,46,32,108,111,99,41,0,0,0,0,0,0};
static C_char li299[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,99,104,101,99,107,45,115,116,114,105,110,103,32,120,32,46,32,108,111,99,41,0,0,0,0};
static C_char li300[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,99,104,101,99,107,45,110,117,109,98,101,114,32,120,32,46,32,108,111,99,41,0,0,0,0};
static C_char li301[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,99,104,101,99,107,45,102,105,120,110,117,109,32,120,32,46,32,108,111,99,41,0,0,0,0};
static C_char li302[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,99,104,101,99,107,45,98,121,116,101,118,101,99,116,111,114,32,120,32,46,32,108,111,99,41};
static C_char li303[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,99,104,101,99,107,45,101,120,97,99,116,32,120,32,46,32,108,111,99,41,0,0,0,0,0};
static C_char li304[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,99,104,101,99,107,45,105,110,101,120,97,99,116,32,120,32,46,32,108,111,99,41,0,0,0};
static C_char li305[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,99,104,101,99,107,45,115,121,109,98,111,108,32,120,32,46,32,108,111,99,41,0,0,0,0};
static C_char li306[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,99,104,101,99,107,45,107,101,121,119,111,114,100,32,120,32,46,32,108,111,99,41,0,0,0};
static C_char li307[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,99,104,101,99,107,45,118,101,99,116,111,114,32,120,32,46,32,108,111,99,41,0,0,0,0};
static C_char li308[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,99,104,101,99,107,45,99,104,97,114,32,120,32,46,32,108,111,99,41,0,0,0,0,0,0};
static C_char li309[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,99,104,101,99,107,45,98,111,111,108,101,97,110,32,120,32,46,32,108,111,99,41,0,0,0};
static C_char li310[] C_aligned={C_lihdr(0,0,30),40,35,35,115,121,115,35,99,104,101,99,107,45,108,111,99,97,116,105,118,101,32,120,32,46,32,108,111,99,41,0,0};
static C_char li311[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,99,104,101,99,107,45,105,110,116,101,103,101,114,32,120,32,46,32,108,111,99,41,0,0,0};
static C_char li312[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,99,104,101,99,107,45,101,120,97,99,116,45,105,110,116,101,103,101,114,32,120,32,46,32,108,111,99,41,0,0,0,0,0};
static C_char li313[] C_aligned={C_lihdr(0,0,36),40,35,35,115,121,115,35,99,104,101,99,107,45,101,120,97,99,116,45,117,105,110,116,101,103,101,114,32,120,32,46,32,108,111,99,41,0,0,0,0};
static C_char li314[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,99,104,101,99,107,45,114,101,97,108,32,120,32,46,32,108,111,99,41,0,0,0,0,0,0};
static C_char li315[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,99,104,101,99,107,45,114,97,110,103,101,32,105,32,102,114,111,109,32,116,111,32,46,32,108,111,99,41,0,0,0,0,0};
static C_char li316[] C_aligned={C_lihdr(0,0,45),40,35,35,115,121,115,35,99,104,101,99,107,45,114,97,110,103,101,47,105,110,99,108,117,100,105,110,103,32,105,32,102,114,111,109,32,116,111,32,46,32,108,111,99,41,0,0,0};
static C_char li317[] C_aligned={C_lihdr(0,0,31),40,35,35,115,121,115,35,99,104,101,99,107,45,115,112,101,99,105,97,108,32,112,116,114,32,46,32,108,111,99,41,0};
static C_char li318[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,99,104,101,99,107,45,99,108,111,115,117,114,101,32,120,32,46,32,108,111,99,41,0,0,0};
static C_char li319[] C_aligned={C_lihdr(0,0,20),40,108,112,32,112,114,111,109,105,115,101,32,102,111,114,119,97,114,100,41,0,0,0,0};
static C_char li320[] C_aligned={C_lihdr(0,0,18),40,115,99,104,101,109,101,35,102,111,114,99,101,32,111,98,106,41,0,0,0,0,0,0};
static C_char li321[] C_aligned={C_lihdr(0,0,7),67,95,100,108,111,97,100,0};
static C_char li322[] C_aligned={C_lihdr(0,0,18),67,95,115,101,116,95,100,108,111,112,101,110,95,102,108,97,103,115,0,0,0,0,0,0};
static C_char li323[] C_aligned={C_lihdr(0,0,42),40,35,35,115,121,115,35,101,114,114,111,114,45,110,111,116,45,97,45,112,114,111,112,101,114,45,108,105,115,116,32,97,114,103,32,46,32,114,101,115,116,41,0,0,0,0,0,0};
static C_char li324[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,101,114,114,111,114,45,98,97,100,45,110,117,109,98,101,114,32,97,114,103,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li325[] C_aligned={C_lihdr(0,0,36),40,35,35,115,121,115,35,101,114,114,111,114,45,98,97,100,45,105,110,116,101,103,101,114,32,97,114,103,32,46,32,114,101,115,116,41,0,0,0,0};
static C_char li326[] C_aligned={C_lihdr(0,0,42),40,35,35,115,121,115,35,101,114,114,111,114,45,98,97,100,45,101,120,97,99,116,45,105,110,116,101,103,101,114,32,97,114,103,32,46,32,114,101,115,116,41,0,0,0,0,0,0};
static C_char li327[] C_aligned={C_lihdr(0,0,43),40,35,35,115,121,115,35,101,114,114,111,114,45,98,97,100,45,101,120,97,99,116,45,117,105,110,116,101,103,101,114,32,97,114,103,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li328[] C_aligned={C_lihdr(0,0,36),40,35,35,115,121,115,35,101,114,114,111,114,45,98,97,100,45,105,110,101,120,97,99,116,32,97,114,103,32,46,32,114,101,115,116,41,0,0,0,0};
static C_char li329[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,101,114,114,111,114,45,98,97,100,45,114,101,97,108,32,97,114,103,32,46,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li330[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,101,114,114,111,114,45,98,97,100,45,98,97,115,101,32,97,114,103,32,46,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li331[] C_aligned={C_lihdr(0,0,11),40,99,111,112,121,32,110,111,100,101,41,0,0,0,0,0};
static C_char li332[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,108,115,116,115,41,0,0,0,0,0};
static C_char li333[] C_aligned={C_lihdr(0,0,22),40,115,99,104,101,109,101,35,97,112,112,101,110,100,32,46,32,108,115,116,115,41,0,0};
static C_char li334[] C_aligned={C_lihdr(0,0,15),40,108,111,111,112,32,108,115,116,32,114,101,115,116,41,0};
static C_char li335[] C_aligned={C_lihdr(0,0,25),40,35,35,115,121,115,35,102,97,115,116,45,114,101,118,101,114,115,101,32,108,115,116,48,41,0,0,0,0,0,0,0};
static C_char li336[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,109,97,107,101,45,98,121,116,101,118,101,99,116,111,114,32,115,105,122,101,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li337[] C_aligned={C_lihdr(0,0,31),40,35,35,115,121,115,35,109,97,107,101,45,115,116,114,105,110,103,32,115,105,122,101,32,46,32,114,101,115,116,41,0};
static C_char li338[] C_aligned={C_lihdr(0,0,36),40,35,35,115,121,115,35,98,117,102,102,101,114,45,62,115,116,114,105,110,103,32,98,117,102,32,115,116,97,114,116,32,108,101,110,41,0,0,0,0};
static C_char li339[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,117,116,102,45,100,101,99,111,100,101,114,32,98,117,102,32,115,116,97,114,116,32,108,101,110,32,107,41,0,0,0,0,0};
static C_char li340[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,117,116,102,45,101,110,99,111,100,101,114,32,98,117,102,32,115,116,97,114,116,32,108,101,110,32,107,41,0,0,0,0,0};
static C_char li341[] C_aligned={C_lihdr(0,0,30),40,35,35,115,121,115,35,117,116,102,45,115,99,97,110,110,101,114,32,115,116,97,116,101,32,98,121,116,101,41,0,0};
static C_char li342[] C_aligned={C_lihdr(0,0,36),40,35,35,115,121,115,35,108,97,116,105,110,45,100,101,99,111,100,101,114,32,98,118,32,115,116,97,114,116,32,108,101,110,32,107,41,0,0,0,0};
static C_char li343[] C_aligned={C_lihdr(0,0,36),40,35,35,115,121,115,35,108,97,116,105,110,45,101,110,99,111,100,101,114,32,98,118,32,115,116,97,114,116,32,108,101,110,32,107,41,0,0,0,0};
static C_char li344[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,108,97,116,105,110,45,115,99,97,110,110,101,114,32,115,116,97,116,101,32,98,121,116,101,41};
static C_char li345[] C_aligned={C_lihdr(0,0,37),40,35,35,115,121,115,35,98,105,110,97,114,121,45,100,101,99,111,100,101,114,32,98,118,32,115,116,97,114,116,32,108,101,110,32,107,41,0,0,0};
static C_char li346[] C_aligned={C_lihdr(0,0,37),40,35,35,115,121,115,35,98,105,110,97,114,121,45,101,110,99,111,100,101,114,32,98,118,32,115,116,97,114,116,32,108,101,110,32,107,41,0,0,0};
static C_char li347[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,98,105,110,97,114,121,45,115,99,97,110,110,101,114,32,115,116,97,116,101,32,98,121,116,101,41,0,0,0,0,0,0,0};
static C_char li348[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,101,110,99,111,100,105,110,103,45,104,111,111,107,32,101,110,99,32,107,41,0,0,0,0,0};
static C_char li349[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,101,110,99,111,100,105,110,103,45,104,111,111,107,32,101,110,99,32,107,41,0,0,0,0,0};
static C_char li350[] C_aligned={C_lihdr(0,0,44),40,35,35,115,121,115,35,114,101,103,105,115,116,101,114,45,101,110,99,111,100,105,110,103,32,110,97,109,101,115,32,100,101,99,32,101,110,99,32,115,99,97,110,41,0,0,0,0};
static C_char li351[] C_aligned={C_lihdr(0,0,20),40,97,49,53,49,56,52,32,100,101,99,111,100,101,114,32,95,32,95,41,0,0,0,0};
static C_char li352[] C_aligned={C_lihdr(0,0,49),40,35,35,115,121,115,35,98,117,102,102,101,114,45,62,115,116,114,105,110,103,47,101,110,99,111,100,105,110,103,32,98,117,102,32,115,116,97,114,116,32,108,101,110,32,101,110,99,41,0,0,0,0,0,0,0};
static C_char li353[] C_aligned={C_lihdr(0,0,20),40,97,49,53,49,57,54,32,95,32,101,110,99,111,100,101,114,32,95,41,0,0,0,0};
static C_char li354[] C_aligned={C_lihdr(0,0,40),40,35,35,115,121,115,35,101,110,99,111,100,101,45,98,117,102,102,101,114,32,98,118,32,115,116,97,114,116,32,108,101,110,32,101,110,99,32,107,41};
static C_char li355[] C_aligned={C_lihdr(0,0,20),40,97,49,53,50,48,56,32,100,101,99,111,100,101,114,32,95,32,95,41,0,0,0,0};
static C_char li356[] C_aligned={C_lihdr(0,0,40),40,35,35,115,121,115,35,100,101,99,111,100,101,45,98,117,102,102,101,114,32,98,118,32,115,116,97,114,116,32,108,101,110,32,101,110,99,32,107,41};
static C_char li357[] C_aligned={C_lihdr(0,0,22),40,97,49,53,50,50,57,32,98,117,102,32,115,116,97,114,116,32,108,101,110,41,0,0};
static C_char li358[] C_aligned={C_lihdr(0,0,20),40,97,49,53,50,50,48,32,95,32,101,110,99,111,100,101,114,32,95,41,0,0,0,0};
static C_char li359[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,101,110,99,111,100,101,45,99,104,97,114,32,99,32,98,118,32,101,110,99,41,0,0,0,0};
static C_char li360[] C_aligned={C_lihdr(0,0,20),40,97,49,53,50,52,50,32,98,117,102,32,115,116,97,114,116,32,95,41,0,0,0,0};
static C_char li361[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,100,101,99,111,100,101,45,99,104,97,114,32,98,118,32,101,110,99,32,115,116,97,114,116,41};
static C_char li362[] C_aligned={C_lihdr(0,0,14),40,108,111,111,112,32,115,116,97,116,101,32,105,41,0,0};
static C_char li363[] C_aligned={C_lihdr(0,0,19),40,97,49,53,50,53,49,32,100,101,99,32,95,32,115,99,97,110,41,0,0,0,0,0};
static C_char li364[] C_aligned={C_lihdr(0,0,34),40,35,35,115,121,115,35,114,101,97,100,45,99,104,97,114,47,101,110,99,111,100,105,110,103,32,112,32,101,110,99,32,107,41,0,0,0,0,0,0};
static C_char li365[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,109,97,107,101,45,115,116,114,105,110,103,32,115,105,122,101,32,46,32,102,105,108,108,41};
static C_char li366[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,105,32,108,115,41,0,0,0,0,0};
static C_char li367[] C_aligned={C_lihdr(0,0,30),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,62,108,105,115,116,32,115,32,46,32,114,101,115,116,41,0,0};
static C_char li368[] C_aligned={C_lihdr(0,0,14),40,108,111,111,112,32,105,32,112,32,108,115,116,41,0,0};
static C_char li369[] C_aligned={C_lihdr(0,0,26),40,115,99,104,101,109,101,35,108,105,115,116,45,62,115,116,114,105,110,103,32,108,115,116,48,41,0,0,0,0,0,0};
static C_char li370[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,112,32,108,32,110,41,0,0,0,0};
static C_char li371[] C_aligned={C_lihdr(0,0,30),40,35,35,115,121,115,35,114,101,118,101,114,115,101,45,108,105,115,116,45,62,115,116,114,105,110,103,32,108,41,0,0};
static C_char li372[] C_aligned={C_lihdr(0,0,12),40,100,111,108,111,111,112,50,48,52,56,41,0,0,0,0};
static C_char li373[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,102,105,108,108,33,32,115,32,99,32,46,32,114,101,115,116,41};
static C_char li374[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,99,111,112,121,32,115,32,46,32,114,101,115,116,41,0,0,0};
static C_char li375[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,50,49,48,54,32,105,41,0,0};
static C_char li376[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,50,49,49,50,32,105,41,0,0};
static C_char li377[] C_aligned={C_lihdr(0,0,39),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,99,111,112,121,33,32,116,111,32,97,116,32,102,114,111,109,32,46,32,114,101,115,116,41,0};
static C_char li378[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,115,117,98,115,116,114,105,110,103,32,115,32,115,116,97,114,116,32,101,110,100,41,0,0,0};
static C_char li379[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,115,117,98,115,116,114,105,110,103,32,115,32,115,116,97,114,116,32,46,32,101,110,100,41};
static C_char li380[] C_aligned={C_lihdr(0,0,17),40,108,111,111,112,32,115,32,108,101,110,32,115,115,32,102,41,0,0,0,0,0,0,0};
static C_char li381[] C_aligned={C_lihdr(0,0,28),40,99,111,109,112,97,114,101,32,115,49,32,115,50,32,109,111,114,101,32,108,111,99,32,99,109,112,41,0,0,0,0};
static C_char li382[] C_aligned={C_lihdr(0,0,22),40,97,49,54,48,50,51,32,99,109,112,32,108,101,110,49,32,108,101,110,50,41,0,0};
static C_char li383[] C_aligned={C_lihdr(0,0,30),40,115,99,104,101,109,101,35,115,116,114,105,110,103,60,63,32,115,49,32,115,50,32,46,32,109,111,114,101,41,0,0};
static C_char li384[] C_aligned={C_lihdr(0,0,22),40,97,49,54,48,52,55,32,99,109,112,32,108,101,110,49,32,108,101,110,50,41,0,0};
static C_char li385[] C_aligned={C_lihdr(0,0,30),40,115,99,104,101,109,101,35,115,116,114,105,110,103,62,63,32,115,49,32,115,50,32,46,32,109,111,114,101,41,0,0};
static C_char li386[] C_aligned={C_lihdr(0,0,22),40,97,49,54,48,55,49,32,99,109,112,32,108,101,110,49,32,108,101,110,50,41,0,0};
static C_char li387[] C_aligned={C_lihdr(0,0,31),40,115,99,104,101,109,101,35,115,116,114,105,110,103,60,61,63,32,115,49,32,115,50,32,46,32,109,111,114,101,41,0};
static C_char li388[] C_aligned={C_lihdr(0,0,22),40,97,49,54,48,57,50,32,99,109,112,32,108,101,110,49,32,108,101,110,50,41,0,0};
static C_char li389[] C_aligned={C_lihdr(0,0,31),40,115,99,104,101,109,101,35,115,116,114,105,110,103,62,61,63,32,115,49,32,115,50,32,46,32,109,111,114,101,41,0};
static C_char li390[] C_aligned={C_lihdr(0,0,17),40,108,111,111,112,32,115,32,108,101,110,32,115,115,32,102,41,0,0,0,0,0,0,0};
static C_char li391[] C_aligned={C_lihdr(0,0,28),40,99,111,109,112,97,114,101,32,115,49,32,115,50,32,109,111,114,101,32,108,111,99,32,99,109,112,41,0,0,0,0};
static C_char li392[] C_aligned={C_lihdr(0,0,22),40,97,49,54,49,55,51,32,99,109,112,32,108,101,110,49,32,108,101,110,50,41,0,0};
static C_char li393[] C_aligned={C_lihdr(0,0,33),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,99,105,60,63,32,115,49,32,115,50,32,46,32,109,111,114,101,41,0,0,0,0,0,0,0};
static C_char li394[] C_aligned={C_lihdr(0,0,22),40,97,49,54,49,57,55,32,99,109,112,32,108,101,110,49,32,108,101,110,50,41,0,0};
static C_char li395[] C_aligned={C_lihdr(0,0,33),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,99,105,62,63,32,115,49,32,115,50,32,46,32,109,111,114,101,41,0,0,0,0,0,0,0};
static C_char li396[] C_aligned={C_lihdr(0,0,22),40,97,49,54,50,50,49,32,99,109,112,32,108,101,110,49,32,108,101,110,50,41,0,0};
static C_char li397[] C_aligned={C_lihdr(0,0,34),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,99,105,60,61,63,32,115,49,32,115,50,32,46,32,109,111,114,101,41,0,0,0,0,0,0};
static C_char li398[] C_aligned={C_lihdr(0,0,22),40,97,49,54,50,52,50,32,99,109,112,32,108,101,110,49,32,108,101,110,50,41,0,0};
static C_char li399[] C_aligned={C_lihdr(0,0,34),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,99,105,62,61,63,32,115,49,32,115,50,32,46,32,109,111,114,101,41,0,0,0,0,0,0};
static C_char li400[] C_aligned={C_lihdr(0,0,25),40,35,35,115,121,115,35,115,116,114,105,110,103,45,97,112,112,101,110,100,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li401[] C_aligned={C_lihdr(0,0,16),40,108,111,111,112,32,115,116,114,115,32,110,32,117,108,41};
static C_char li402[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,97,112,112,101,110,100,32,46,32,97,108,108,41,0,0,0,0};
static C_char li403[] C_aligned={C_lihdr(0,0,23),40,115,99,104,101,109,101,35,115,116,114,105,110,103,32,46,32,99,104,97,114,115,41,0};
static C_char li404[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,99,104,97,114,45,62,117,116,102,56,45,115,116,114,105,110,103,32,99,41,0,0,0,0,0};
static C_char li405[] C_aligned={C_lihdr(0,0,20),40,100,111,108,111,111,112,50,50,57,56,32,104,100,32,116,108,32,99,41,0,0,0,0};
static C_char li406[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,108,115,116,32,105,41,0,0,0,0};
static C_char li407[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,104,111,112,32,108,115,116,32,110,41,0,0,0,0,0,0,0};
static C_char li408[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,43,32,120,32,121,41};
static C_char li409[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,45,32,120,32,121,41};
static C_char li410[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,42,32,120,32,121,41};
static C_char li411[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,47,32,120,32,121,41};
static C_char li412[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,42,43,32,120,32,121,32,122,41,0,0,0,0,0};
static C_char li413[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,103,99,100,32,120,32,121,41,0,0,0,0,0,0};
static C_char li414[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,47,63,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li415[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,61,32,120,32,121,41};
static C_char li416[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,62,32,120,32,121,41};
static C_char li417[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,60,32,120,32,121,41};
static C_char li418[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,62,61,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li419[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,60,61,32,120,32,121,41,0,0,0,0,0,0,0};
static C_char li420[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,110,101,103,32,120,41};
static C_char li421[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,109,97,120,32,120,32,121,41,0,0,0,0,0,0};
static C_char li422[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,109,105,110,32,120,32,121,41,0,0,0,0,0,0};
static C_char li423[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,102,108,111,111,114,32,120,41,0,0,0,0,0,0};
static C_char li424[] C_aligned={C_lihdr(0,0,29),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,116,114,117,110,99,97,116,101,32,120,41,0,0,0};
static C_char li425[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,114,111,117,110,100,32,120,41,0,0,0,0,0,0};
static C_char li426[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,99,101,105,108,105,110,103,32,120,41,0,0,0,0};
static C_char li427[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,115,105,110,32,120,41};
static C_char li428[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,99,111,115,32,120,41};
static C_char li429[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,116,97,110,32,120,41};
static C_char li430[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,97,115,105,110,32,120,41,0,0,0,0,0,0,0};
static C_char li431[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,97,99,111,115,32,120,41,0,0,0,0,0,0,0};
static C_char li432[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,97,116,97,110,32,120,41,0,0,0,0,0,0,0};
static C_char li433[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,97,116,97,110,50,32,120,32,121,41,0,0,0,0};
static C_char li434[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,115,105,110,104,32,120,41,0,0,0,0,0,0,0};
static C_char li435[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,99,111,115,104,32,120,41,0,0,0,0,0,0,0};
static C_char li436[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,116,97,110,104,32,120,41,0,0,0,0,0,0,0};
static C_char li437[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,97,115,105,110,104,32,120,41,0,0,0,0,0,0};
static C_char li438[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,97,99,111,115,104,32,120,41,0,0,0,0,0,0};
static C_char li439[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,97,116,97,110,104,32,120,41,0,0,0,0,0,0};
static C_char li440[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,101,120,112,32,120,41};
static C_char li441[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,101,120,112,116,32,120,32,121,41,0,0,0,0,0};
static C_char li442[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,108,111,103,32,120,41};
static C_char li443[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,115,113,114,116,32,120,41,0,0,0,0,0,0,0};
static C_char li444[] C_aligned={C_lihdr(0,0,24),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,97,98,115,32,120,41};
static C_char li445[] C_aligned={C_lihdr(0,0,29),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,112,105,110,116,101,103,101,114,63,32,120,41,0,0,0};
static C_char li446[] C_aligned={C_lihdr(0,0,46),40,99,104,105,99,107,101,110,46,102,108,111,110,117,109,35,102,108,111,110,117,109,45,112,114,105,110,116,45,112,114,101,99,105,115,105,111,110,32,46,32,114,101,115,116,41,0,0};
static C_char li447[] C_aligned={C_lihdr(0,0,18),40,109,97,107,101,45,99,111,109,112,108,101,120,32,114,32,105,41,0,0,0,0,0,0};
static C_char li448[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,109,97,107,101,45,114,101,99,116,97,110,103,117,108,97,114,32,114,32,105,41,0,0,0};
static C_char li449[] C_aligned={C_lihdr(0,0,25),40,115,99,104,101,109,101,35,109,97,107,101,45,112,111,108,97,114,32,114,32,112,104,105,41,0,0,0,0,0,0,0};
static C_char li450[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,114,101,97,108,45,112,97,114,116,32,120,41,0,0,0,0};
static C_char li451[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,105,109,97,103,45,112,97,114,116,32,120,41,0,0,0,0};
static C_char li452[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,97,110,103,108,101,32,110,41};
static C_char li453[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,109,97,103,110,105,116,117,100,101,32,120,41,0,0,0,0};
static C_char li454[] C_aligned={C_lihdr(0,0,10),40,114,97,116,110,117,109,32,110,41,0,0,0,0,0,0};
static C_char li455[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,110,117,109,101,114,97,116,111,114,32,110,41,0,0,0,0};
static C_char li456[] C_aligned={C_lihdr(0,0,22),40,115,99,104,101,109,101,35,100,101,110,111,109,105,110,97,116,111,114,32,110,41,0,0};
static C_char li457[] C_aligned={C_lihdr(0,0,25),40,35,35,115,121,115,35,101,120,116,101,110,100,101,100,45,115,105,103,110,117,109,32,120,41,0,0,0,0,0,0,0};
static C_char li458[] C_aligned={C_lihdr(0,0,16),40,100,111,108,111,111,112,50,56,54,57,32,120,32,105,41};
static C_char li459[] C_aligned={C_lihdr(0,0,13),40,100,101,108,105,118,101,114,32,121,32,100,41,0,0,0};
static C_char li460[] C_aligned={C_lihdr(0,0,25),40,115,99,104,101,109,101,35,105,110,101,120,97,99,116,45,62,101,120,97,99,116,32,120,41,0,0,0,0,0,0,0};
static C_char li461[] C_aligned={C_lihdr(0,0,13),67,95,98,105,116,119,105,115,101,95,97,110,100,0,0,0};
static C_char li462[] C_aligned={C_lihdr(0,0,13),67,95,98,105,116,119,105,115,101,95,105,111,114,0,0,0};
static C_char li463[] C_aligned={C_lihdr(0,0,13),67,95,98,105,116,119,105,115,101,95,120,111,114,0,0,0};
static C_char li464[] C_aligned={C_lihdr(0,0,31),40,99,104,105,99,107,101,110,46,98,105,116,119,105,115,101,35,98,105,116,119,105,115,101,45,110,111,116,32,110,41,0};
static C_char li465[] C_aligned={C_lihdr(0,0,34),40,99,104,105,99,107,101,110,46,98,105,116,119,105,115,101,35,98,105,116,45,62,98,111,111,108,101,97,110,32,110,32,105,41,0,0,0,0,0,0};
static C_char li466[] C_aligned={C_lihdr(0,0,34),40,99,104,105,99,107,101,110,46,98,105,116,119,105,115,101,35,105,110,116,101,103,101,114,45,108,101,110,103,116,104,32,120,41,0,0,0,0,0,0};
static C_char li467[] C_aligned={C_lihdr(0,0,38),40,99,104,105,99,107,101,110,46,98,105,116,119,105,115,101,35,97,114,105,116,104,109,101,116,105,99,45,115,104,105,102,116,32,110,32,109,41,0,0};
static C_char li468[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,97,114,103,115,32,120,41,0,0,0};
static C_char li469[] C_aligned={C_lihdr(0,0,22),40,115,99,104,101,109,101,35,47,32,97,114,103,49,32,46,32,97,114,103,115,41,0,0};
static C_char li470[] C_aligned={C_lihdr(0,0,15),40,35,35,115,121,115,35,47,45,50,32,120,32,121,41,0};
static C_char li471[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,102,108,111,111,114,32,120,41};
static C_char li472[] C_aligned={C_lihdr(0,0,18),40,115,99,104,101,109,101,35,99,101,105,108,105,110,103,32,120,41,0,0,0,0,0,0};
static C_char li473[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,116,114,117,110,99,97,116,101,32,120,41,0,0,0,0,0};
static C_char li474[] C_aligned={C_lihdr(0,0,16),40,115,99,104,101,109,101,35,114,111,117,110,100,32,120,41};
static C_char li475[] C_aligned={C_lihdr(0,0,8),40,115,114,32,120,32,121,41};
static C_char li476[] C_aligned={C_lihdr(0,0,24),40,102,105,110,100,45,114,97,116,105,111,45,98,101,116,119,101,101,110,32,120,32,121,41};
static C_char li477[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,114,97,116,105,111,110,97,108,105,122,101,32,120,32,101,41};
static C_char li478[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,105,32,109,32,120,115,41,0,0,0};
static C_char li479[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,109,97,120,32,120,49,32,46,32,120,115,41,0,0,0,0};
static C_char li480[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,105,32,109,32,120,115,41,0,0,0};
static C_char li481[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,109,105,110,32,120,49,32,46,32,120,115,41,0,0,0,0};
static C_char li482[] C_aligned={C_lihdr(0,0,14),40,115,99,104,101,109,101,35,101,120,112,32,110,41,0,0};
static C_char li483[] C_aligned={C_lihdr(0,0,15),40,35,35,115,121,115,35,108,111,103,45,49,32,120,41,0};
static C_char li484[] C_aligned={C_lihdr(0,0,21),40,115,99,104,101,109,101,35,108,111,103,32,97,32,46,32,114,101,115,116,41,0,0,0};
static C_char li485[] C_aligned={C_lihdr(0,0,14),40,115,99,104,101,109,101,35,115,105,110,32,110,41,0,0};
static C_char li486[] C_aligned={C_lihdr(0,0,14),40,115,99,104,101,109,101,35,99,111,115,32,110,41,0,0};
static C_char li487[] C_aligned={C_lihdr(0,0,14),40,115,99,104,101,109,101,35,116,97,110,32,110,41,0,0};
static C_char li488[] C_aligned={C_lihdr(0,0,15),40,115,99,104,101,109,101,35,97,115,105,110,32,110,41,0};
static C_char li489[] C_aligned={C_lihdr(0,0,15),40,115,99,104,101,109,101,35,97,99,111,115,32,110,41,0};
static C_char li490[] C_aligned={C_lihdr(0,0,22),40,115,99,104,101,109,101,35,97,116,97,110,32,110,32,46,32,114,101,115,116,41,0,0};
static C_char li491[] C_aligned={C_lihdr(0,0,8),40,97,49,57,48,49,48,41};
static C_char li492[] C_aligned={C_lihdr(0,0,34),67,95,117,95,105,110,116,101,103,101,114,95,113,117,111,116,105,101,110,116,95,97,110,100,95,114,101,109,97,105,110,100,101,114,0,0,0,0,0,0};
static C_char li493[] C_aligned={C_lihdr(0,0,8),40,97,49,57,48,52,49,41};
static C_char li494[] C_aligned={C_lihdr(0,0,20),40,97,49,57,48,53,55,32,113,51,50,51,54,32,117,51,50,51,56,41,0,0,0,0};
static C_char li495[] C_aligned={C_lihdr(0,0,22),40,97,49,57,48,50,52,32,115,94,51,50,49,54,32,114,94,51,50,49,56,41,0,0};
static C_char li496[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,101,120,97,99,116,45,105,110,116,101,103,101,114,45,115,113,114,116,32,97,41,0,0,0,0};
static C_char li497[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,101,120,97,99,116,45,105,110,116,101,103,101,114,45,115,113,114,116,32,120,41,0,0,0};
static C_char li498[] C_aligned={C_lihdr(0,0,8),40,97,49,57,49,57,56,41};
static C_char li499[] C_aligned={C_lihdr(0,0,14),40,97,49,57,50,48,52,32,115,94,50,32,114,41,0,0};
static C_char li500[] C_aligned={C_lihdr(0,0,8),40,97,49,57,50,50,54,41};
static C_char li501[] C_aligned={C_lihdr(0,0,8),40,97,49,57,50,53,48,41};
static C_char li502[] C_aligned={C_lihdr(0,0,16),40,97,49,57,50,54,50,32,100,115,94,50,32,100,114,41};
static C_char li503[] C_aligned={C_lihdr(0,0,16),40,97,49,57,50,51,56,32,110,115,94,50,32,110,114,41};
static C_char li504[] C_aligned={C_lihdr(0,0,22),40,35,35,115,121,115,35,115,113,114,116,47,108,111,99,32,108,111,99,32,110,41,0,0};
static C_char li505[] C_aligned={C_lihdr(0,0,15),40,115,99,104,101,109,101,35,115,113,114,116,32,120,41,0};
static C_char li506[] C_aligned={C_lihdr(0,0,8),40,97,49,57,51,48,53,41};
static C_char li507[] C_aligned={C_lihdr(0,0,16),40,97,49,57,51,49,49,32,100,105,118,32,114,101,109,41};
static C_char li508[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,102,108,111,111,114,47,32,120,32,121,41,0,0,0,0,0};
static C_char li509[] C_aligned={C_lihdr(0,0,8),40,97,49,57,51,54,48,41};
static C_char li510[] C_aligned={C_lihdr(0,0,16),40,97,49,57,51,54,54,32,100,105,118,32,114,101,109,41};
static C_char li511[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,102,108,111,111,114,45,114,101,109,97,105,110,100,101,114,32,120,32,121,41,0,0,0,0};
static C_char li512[] C_aligned={C_lihdr(0,0,8),40,97,49,57,51,55,53,41};
static C_char li513[] C_aligned={C_lihdr(0,0,16),40,97,49,57,51,56,49,32,100,105,118,32,114,101,109,41};
static C_char li514[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,102,108,111,111,114,45,113,117,111,116,105,101,110,116,32,120,32,121,41,0,0,0,0,0};
static C_char li515[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,115,113,117,97,114,101,32,110,41,0,0,0,0,0,0,0};
static C_char li516[] C_aligned={C_lihdr(0,0,41),40,99,104,105,99,107,101,110,46,98,97,115,101,35,101,120,97,99,116,45,105,110,116,101,103,101,114,45,110,116,104,45,114,111,111,116,32,107,32,110,41,0,0,0,0,0,0,0};
static C_char li517[] C_aligned={C_lihdr(0,0,10),40,108,112,32,103,48,32,103,49,41,0,0,0,0,0,0};
static C_char li518[] C_aligned={C_lihdr(0,0,42),40,35,35,115,121,115,35,101,120,97,99,116,45,105,110,116,101,103,101,114,45,110,116,104,45,114,111,111,116,47,108,111,99,32,108,111,99,32,107,32,110,41,0,0,0,0,0,0};
static C_char li519[] C_aligned={C_lihdr(0,0,11),40,108,112,32,114,101,115,32,101,50,41,0,0,0,0,0};
static C_char li520[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,105,110,116,101,103,101,114,45,112,111,119,101,114,32,98,97,115,101,32,101,41,0,0,0,0};
static C_char li521[] C_aligned={C_lihdr(0,0,14),40,108,111,103,45,101,120,112,116,32,97,32,98,41,0,0};
static C_char li522[] C_aligned={C_lihdr(0,0,15),40,115,108,111,119,45,101,120,112,116,32,97,32,98,41,0};
static C_char li523[] C_aligned={C_lihdr(0,0,8),40,97,49,57,55,49,49,41};
static C_char li524[] C_aligned={C_lihdr(0,0,15),40,97,49,57,55,50,51,32,100,115,94,110,32,114,41,0};
static C_char li525[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,101,120,112,116,32,97,32,98,41,0,0,0,0,0,0,0};
static C_char li526[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,105,110,116,101,114,110,97,108,45,103,99,100,32,108,111,99,32,97,32,98,41,0,0,0,0};
static C_char li527[] C_aligned={C_lihdr(0,0,15),40,35,35,115,121,115,35,103,99,100,32,97,32,98,41,0};
static C_char li528[] C_aligned={C_lihdr(0,0,16),40,108,111,111,112,32,104,101,97,100,32,110,101,120,116,41};
static C_char li529[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,103,99,100,32,46,32,110,115,41,0,0,0,0,0,0,0};
static C_char li530[] C_aligned={C_lihdr(0,0,15),40,35,35,115,121,115,35,108,99,109,32,120,32,121,41,0};
static C_char li531[] C_aligned={C_lihdr(0,0,16),40,108,111,111,112,32,104,101,97,100,32,110,101,120,116,41};
static C_char li532[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,108,99,109,32,46,32,110,115,41,0,0,0,0,0,0,0};
static C_char li533[] C_aligned={C_lihdr(0,0,34),67,95,117,95,105,110,116,101,103,101,114,95,113,117,111,116,105,101,110,116,95,97,110,100,95,114,101,109,97,105,110,100,101,114,0,0,0,0,0,0};
static C_char li534[] C_aligned={C_lihdr(0,0,8),40,97,50,48,48,55,52,41};
static C_char li535[] C_aligned={C_lihdr(0,0,22),40,97,50,48,48,56,48,32,104,105,51,52,51,57,32,108,111,51,52,52,49,41,0,0};
static C_char li536[] C_aligned={C_lihdr(0,0,61),40,35,35,115,121,115,35,105,110,116,101,103,101,114,45,62,115,116,114,105,110,103,47,114,101,99,117,114,115,105,118,101,32,110,32,98,97,115,101,32,101,120,112,101,99,116,101,100,45,115,116,114,105,110,103,45,115,105,122,101,41,0,0,0};
static C_char li537[] C_aligned={C_lihdr(0,0,38),40,35,35,115,121,115,35,101,120,116,101,110,100,101,100,45,110,117,109,98,101,114,45,62,115,116,114,105,110,103,32,110,32,98,97,115,101,41,0,0};
static C_char li538[] C_aligned={C_lihdr(0,0,20),40,114,111,117,110,100,45,113,117,111,116,105,101,110,116,32,110,32,100,41,0,0,0,0};
static C_char li539[] C_aligned={C_lihdr(0,0,13),40,103,111,45,105,110,101,120,97,99,116,33,41,0,0,0};
static C_char li540[] C_aligned={C_lihdr(0,0,23),40,115,97,102,101,45,101,120,112,111,110,101,110,116,32,118,97,108,117,101,32,101,41,0};
static C_char li541[] C_aligned={C_lihdr(0,0,6),40,108,112,32,105,41,0,0};
static C_char li542[] C_aligned={C_lihdr(0,0,19),40,115,99,97,110,45,100,105,103,105,116,115,32,115,116,97,114,116,41,0,0,0,0,0};
static C_char li543[] C_aligned={C_lihdr(0,0,6),40,108,112,32,105,41,0,0};
static C_char li544[] C_aligned={C_lihdr(0,0,19),40,115,99,97,110,45,104,97,115,104,101,115,32,115,116,97,114,116,41,0,0,0,0,0};
static C_char li545[] C_aligned={C_lihdr(0,0,46),40,115,99,97,110,45,100,105,103,105,116,115,43,104,97,115,104,101,115,32,115,116,97,114,116,32,110,101,103,63,32,97,108,108,45,104,97,115,104,101,115,45,111,107,63,41,0,0};
static C_char li546[] C_aligned={C_lihdr(0,0,21),40,115,99,97,110,45,101,120,112,111,110,101,110,116,32,115,116,97,114,116,41,0,0,0};
static C_char li547[] C_aligned={C_lihdr(0,0,43),40,115,99,97,110,45,100,101,99,105,109,97,108,45,116,97,105,108,32,115,116,97,114,116,32,110,101,103,63,32,100,101,99,105,109,97,108,45,104,101,97,100,41,0,0,0,0,0};
static C_char li548[] C_aligned={C_lihdr(0,0,23),40,115,99,97,110,45,117,114,101,97,108,32,115,116,97,114,116,32,110,101,103,63,41,0};
static C_char li549[] C_aligned={C_lihdr(0,0,17),40,115,99,97,110,45,114,101,97,108,32,115,116,97,114,116,41,0,0,0,0,0,0,0};
static C_char li550[] C_aligned={C_lihdr(0,0,50),40,35,35,115,121,115,35,115,116,114,105,110,103,45,62,99,111,109,112,110,117,109,32,114,97,100,105,120,32,115,116,114,32,111,102,102,115,101,116,32,101,120,97,99,116,110,101,115,115,41,0,0,0,0,0,0};
static C_char li551[] C_aligned={C_lihdr(0,0,32),40,115,99,97,110,45,112,114,101,102,105,120,32,105,32,101,120,110,101,115,115,32,114,97,100,105,120,32,108,101,110,41};
static C_char li552[] C_aligned={C_lihdr(0,0,34),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,62,110,117,109,98,101,114,32,115,116,114,32,46,32,114,101,115,116,41,0,0,0,0,0,0};
static C_char li553[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,115,116,114,105,110,103,45,62,110,117,109,98,101,114,32,115,116,114,32,46,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li554[] C_aligned={C_lihdr(0,0,18),67,95,102,105,120,110,117,109,95,116,111,95,115,116,114,105,110,103,0,0,0,0,0,0};
static C_char li555[] C_aligned={C_lihdr(0,0,18),67,95,102,108,111,110,117,109,95,116,111,95,115,116,114,105,110,103,0,0,0,0,0,0};
static C_char li556[] C_aligned={C_lihdr(0,0,19),67,95,105,110,116,101,103,101,114,95,116,111,95,115,116,114,105,110,103,0,0,0,0,0};
static C_char li557[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li558[] C_aligned={C_lihdr(0,0,25),40,99,111,109,112,97,114,101,45,115,108,111,116,115,32,120,32,121,32,115,116,97,114,116,41,0,0,0,0,0,0,0};
static C_char li559[] C_aligned={C_lihdr(0,0,10),40,119,97,108,107,32,120,32,121,41,0,0,0,0,0,0};
static C_char li560[] C_aligned={C_lihdr(0,0,26),40,99,104,105,99,107,101,110,46,98,97,115,101,35,101,113,117,97,108,61,63,32,120,32,121,41,0,0,0,0,0,0};
static C_char li561[] C_aligned={C_lihdr(0,0,18),67,95,115,116,114,105,110,103,95,116,111,95,115,121,109,98,111,108,0,0,0,0,0,0};
static C_char li562[] C_aligned={C_lihdr(0,0,19),67,95,115,116,114,105,110,103,95,116,111,95,107,101,121,119,111,114,100,0,0,0,0,0};
static C_char li563[] C_aligned={C_lihdr(0,0,13),67,95,109,97,107,101,95,115,121,109,98,111,108,0,0,0};
static C_char li564[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,105,110,116,101,114,110,101,100,45,115,121,109,98,111,108,63,32,120,41,0,0,0,0,0,0};
static C_char li565[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,115,116,114,105,110,103,45,62,115,121,109,98,111,108,45,110,97,109,101,32,115,41,0,0,0};
static C_char li566[] C_aligned={C_lihdr(0,0,31),40,35,35,115,121,115,35,115,121,109,98,111,108,45,62,115,116,114,105,110,103,47,115,104,97,114,101,100,32,115,41,0};
static C_char li567[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,115,121,109,98,111,108,45,62,115,116,114,105,110,103,32,115,41};
static C_char li568[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,115,116,114,105,110,103,45,62,115,121,109,98,111,108,32,115,116,114,41,0,0,0,0,0,0};
static C_char li569[] C_aligned={C_lihdr(0,0,25),40,115,99,104,101,109,101,35,115,121,109,98,111,108,45,62,115,116,114,105,110,103,32,115,41,0,0,0,0,0,0,0};
static C_char li570[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,62,115,121,109,98,111,108,32,115,116,114,41,0,0,0,0,0};
static C_char li571[] C_aligned={C_lihdr(0,0,44),40,99,104,105,99,107,101,110,46,98,97,115,101,35,115,116,114,105,110,103,45,62,117,110,105,110,116,101,114,110,101,100,45,115,121,109,98,111,108,32,115,116,114,41,0,0,0,0};
static C_char li572[] C_aligned={C_lihdr(0,0,34),40,99,104,105,99,107,101,110,46,98,97,115,101,35,103,101,110,115,121,109,32,46,32,115,116,114,45,111,114,45,115,121,109,41,0,0,0,0,0,0};
static C_char li573[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,51,57,57,57,32,103,52,48,49,49,41,0,0,0,0};
static C_char li574[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,98,97,115,101,35,115,121,109,98,111,108,45,97,112,112,101,110,100,32,46,32,115,115,41,0,0,0,0,0,0,0};
static C_char li575[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,107,101,121,119,111,114,100,35,107,101,121,119,111,114,100,63,32,120,41,0,0,0,0};
static C_char li576[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,107,101,121,119,111,114,100,35,115,116,114,105,110,103,45,62,107,101,121,119,111,114,100,32,115,41,0,0,0,0,0};
static C_char li577[] C_aligned={C_lihdr(0,0,36),40,99,104,105,99,107,101,110,46,107,101,121,119,111,114,100,35,107,101,121,119,111,114,100,45,62,115,116,114,105,110,103,32,107,119,41,0,0,0,0};
static C_char li578[] C_aligned={C_lihdr(0,0,45),40,99,104,105,99,107,101,110,46,107,101,121,119,111,114,100,35,103,101,116,45,107,101,121,119,111,114,100,32,107,101,121,32,97,114,103,115,32,46,32,114,101,115,116,41,0,0,0};
static C_char li579[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,105,32,108,115,116,41,0,0,0,0};
static C_char li580[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,98,121,116,101,118,101,99,116,111,114,45,62,108,105,115,116,32,118,41,0,0,0,0,0,0};
static C_char li581[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,108,115,116,32,105,41,0,0,0,0};
static C_char li582[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,108,105,115,116,45,62,98,121,116,101,118,101,99,116,111,114,32,108,115,116,48,41,0,0,0};
static C_char li583[] C_aligned={C_lihdr(0,0,48),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,109,97,107,101,45,98,121,116,101,118,101,99,116,111,114,32,115,105,122,101,32,46,32,114,101,115,116,41};
static C_char li584[] C_aligned={C_lihdr(0,0,34),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,98,121,116,101,118,101,99,116,111,114,63,32,120,41,0,0,0,0,0,0};
static C_char li585[] C_aligned={C_lihdr(0,0,41),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,98,121,116,101,118,101,99,116,111,114,45,108,101,110,103,116,104,32,98,118,41,0,0,0,0,0,0,0};
static C_char li586[] C_aligned={C_lihdr(0,0,43),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,98,121,116,101,118,101,99,116,111,114,45,117,56,45,114,101,102,32,98,118,32,105,41,0,0,0,0,0};
static C_char li587[] C_aligned={C_lihdr(0,0,46),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,98,121,116,101,118,101,99,116,111,114,45,117,56,45,115,101,116,33,32,98,118,32,105,32,98,41,0,0};
static C_char li588[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,115,116,114,105,110,103,45,62,117,116,102,56,32,115,41,0,0,0,0,0};
static C_char li589[] C_aligned={C_lihdr(0,0,43),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,117,116,102,56,45,62,115,116,114,105,110,103,32,98,118,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li590[] C_aligned={C_lihdr(0,0,37),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,115,116,114,105,110,103,45,62,108,97,116,105,110,49,32,115,41,0,0,0};
static C_char li591[] C_aligned={C_lihdr(0,0,38),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,108,97,116,105,110,49,45,62,115,116,114,105,110,103,32,98,118,41,0,0};
static C_char li592[] C_aligned={C_lihdr(0,0,39),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,98,121,116,101,118,101,99,116,111,114,61,63,32,98,49,32,98,50,41,0};
static C_char li593[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li594[] C_aligned={C_lihdr(0,0,38),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,98,121,116,101,118,101,99,116,111,114,32,46,32,97,114,103,115,41,0,0};
static C_char li595[] C_aligned={C_lihdr(0,0,46),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,98,121,116,101,118,101,99,116,111,114,45,99,111,112,121,32,98,118,32,46,32,114,101,115,116,41,0,0};
static C_char li596[] C_aligned={C_lihdr(0,0,55),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,98,121,116,101,118,101,99,116,111,114,45,99,111,112,121,33,32,98,118,49,32,97,116,32,98,118,50,32,46,32,114,101,115,116,41,0};
static C_char li597[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li598[] C_aligned={C_lihdr(0,0,14),40,108,111,111,112,32,108,115,116,32,108,101,110,41,0,0};
static C_char li599[] C_aligned={C_lihdr(0,0,44),40,99,104,105,99,107,101,110,46,98,121,116,101,118,101,99,116,111,114,35,98,121,116,101,118,101,99,116,111,114,45,97,112,112,101,110,100,32,46,32,98,118,115,41,0,0,0,0};
static C_char li600[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,109,97,107,101,45,118,101,99,116,111,114,32,115,105,122,101,32,46,32,102,105,108,108,41};
static C_char li601[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li602[] C_aligned={C_lihdr(0,0,26),40,115,99,104,101,109,101,35,108,105,115,116,45,62,118,101,99,116,111,114,32,108,115,116,48,41,0,0,0,0,0,0};
static C_char li603[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li604[] C_aligned={C_lihdr(0,0,30),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,62,108,105,115,116,32,118,32,46,32,114,101,115,116,41,0,0};
static C_char li605[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,118,101,99,116,111,114,32,46,32,120,115,41,0,0,0,0};
static C_char li606[] C_aligned={C_lihdr(0,0,12),40,100,111,108,111,111,112,52,51,51,55,41,0,0,0,0};
static C_char li607[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,102,105,108,108,33,32,118,32,120,32,46,32,114,101,115,116,41};
static C_char li608[] C_aligned={C_lihdr(0,0,15),40,100,111,108,111,111,112,52,51,54,56,32,102,105,41,0};
static C_char li609[] C_aligned={C_lihdr(0,0,18),40,99,111,112,121,32,118,32,115,116,97,114,116,32,101,110,100,41,0,0,0,0,0,0};
static C_char li610[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,99,111,112,121,32,118,32,46,32,114,101,115,116,41,0,0,0};
static C_char li611[] C_aligned={C_lihdr(0,0,15),40,100,111,108,111,111,112,52,52,48,57,32,116,105,41,0};
static C_char li612[] C_aligned={C_lihdr(0,0,15),40,100,111,108,111,111,112,52,52,49,53,32,116,105,41,0};
static C_char li613[] C_aligned={C_lihdr(0,0,28),40,99,111,112,121,33,32,116,111,32,97,116,32,102,114,111,109,32,115,116,97,114,116,32,101,110,100,41,0,0,0,0};
static C_char li614[] C_aligned={C_lihdr(0,0,39),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,99,111,112,121,33,32,116,111,32,97,116,32,102,114,111,109,32,46,32,114,101,115,116,41,0};
static C_char li615[] C_aligned={C_lihdr(0,0,19),40,102,111,114,45,101,97,99,104,45,108,111,111,112,52,52,51,52,41,0,0,0,0,0};
static C_char li616[] C_aligned={C_lihdr(0,0,22),40,100,111,108,111,111,112,52,53,48,49,32,118,115,32,108,101,110,115,32,105,41,0,0};
static C_char li617[] C_aligned={C_lihdr(0,0,17),40,102,111,108,100,108,52,52,57,49,32,103,52,52,57,48,41,0,0,0,0,0,0,0};
static C_char li618[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,52,52,54,48,32,103,52,52,55,50,41,0,0,0,0};
static C_char li619[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,97,112,112,101,110,100,32,46,32,118,115,41,0,0,0,0,0};
static C_char li620[] C_aligned={C_lihdr(0,0,12),40,100,111,108,111,111,112,52,53,50,56,41,0,0,0,0};
static C_char li621[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,98,97,115,101,35,115,117,98,118,101,99,116,111,114,32,118,32,105,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li622[] C_aligned={C_lihdr(0,0,39),40,99,104,105,99,107,101,110,46,98,97,115,101,35,118,101,99,116,111,114,45,114,101,115,105,122,101,32,118,32,110,32,46,32,114,101,115,116,41,0};
static C_char li623[] C_aligned={C_lihdr(0,0,12),40,100,111,108,111,111,112,52,53,53,54,41,0,0,0,0};
static C_char li624[] C_aligned={C_lihdr(0,0,30),40,35,35,115,121,115,35,118,101,99,116,111,114,45,114,101,115,105,122,101,32,118,32,110,32,105,110,105,116,41,0,0};
static C_char li625[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,99,32,99,115,32,102,41,0,0,0};
static C_char li626[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,99,104,97,114,45,99,105,61,63,32,120,32,121,32,46,32,109,111,114,101,41,0,0,0};
static C_char li627[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,99,32,99,115,32,102,41,0,0,0};
static C_char li628[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,99,104,97,114,45,99,105,62,63,32,120,32,121,32,46,32,109,111,114,101,41,0,0,0};
static C_char li629[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,99,32,99,115,32,102,41,0,0,0};
static C_char li630[] C_aligned={C_lihdr(0,0,29),40,115,99,104,101,109,101,35,99,104,97,114,45,99,105,60,63,32,120,32,121,32,46,32,109,111,114,101,41,0,0,0};
static C_char li631[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,99,32,99,115,32,102,41,0,0,0};
static C_char li632[] C_aligned={C_lihdr(0,0,30),40,115,99,104,101,109,101,35,99,104,97,114,45,99,105,62,61,63,32,120,32,121,32,46,32,109,111,114,101,41,0,0};
static C_char li633[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,99,32,99,115,32,102,41,0,0,0};
static C_char li634[] C_aligned={C_lihdr(0,0,30),40,115,99,104,101,109,101,35,99,104,97,114,45,99,105,60,61,63,32,120,32,121,32,46,32,109,111,114,101,41,0,0};
static C_char li635[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li636[] C_aligned={C_lihdr(0,0,15),40,108,111,111,107,117,112,45,99,104,97,114,32,99,41,0};
static C_char li637[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,104,97,114,45,110,97,109,101,32,120,32,46,32,121,41,0,0};
static C_char li638[] C_aligned={C_lihdr(0,0,9),67,95,99,97,108,108,95,99,99,0,0,0,0,0,0,0};
static C_char li639[] C_aligned={C_lihdr(0,0,19),67,95,99,97,108,108,95,119,105,116,104,95,99,116,104,117,108,104,117,0,0,0,0,0};
static C_char li640[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li641[] C_aligned={C_lihdr(0,0,23),40,35,35,115,121,115,35,102,111,114,45,101,97,99,104,32,112,32,108,115,116,48,41,0};
static C_char li642[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li643[] C_aligned={C_lihdr(0,0,18),40,35,35,115,121,115,35,109,97,112,32,112,32,108,115,116,48,41,0,0,0,0,0,0};
static C_char li644[] C_aligned={C_lihdr(0,0,9),40,108,112,32,108,115,116,115,41,0,0,0,0,0,0,0};
static C_char li645[] C_aligned={C_lihdr(0,0,14),40,97,50,52,50,52,56,32,101,109,112,116,121,41,0,0};
static C_char li646[] C_aligned={C_lihdr(0,0,24),40,109,97,112,115,97,102,101,52,55,48,50,32,112,32,108,115,116,115,32,108,111,99,41};
static C_char li647[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,52,55,50,50,32,103,52,55,50,57,41,0,0,0,0,0,0,0};
static C_char li648[] C_aligned={C_lihdr(0,0,10),40,97,50,52,51,55,48,32,120,41,0,0,0,0,0,0};
static C_char li649[] C_aligned={C_lihdr(0,0,10),40,97,50,52,51,55,54,32,120,41,0,0,0,0,0,0};
static C_char li650[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,97,108,108,41,0,0,0,0,0,0};
static C_char li651[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,102,111,114,45,101,97,99,104,32,102,110,32,108,115,116,49,32,46,32,108,115,116,115,41};
static C_char li652[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,52,55,53,48,32,103,52,55,54,50,41,0,0,0,0};
static C_char li653[] C_aligned={C_lihdr(0,0,10),40,97,50,52,52,55,49,32,120,41,0,0,0,0,0,0};
static C_char li654[] C_aligned={C_lihdr(0,0,10),40,97,50,52,52,55,55,32,120,41,0,0,0,0,0,0};
static C_char li655[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,97,108,108,41,0,0,0,0,0,0};
static C_char li656[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,109,97,112,32,102,110,32,108,115,116,49,32,46,32,108,115,116,115,41,0,0,0,0,0};
static C_char li657[] C_aligned={C_lihdr(0,0,18),40,97,50,52,52,57,55,32,46,32,114,101,115,117,108,116,115,41,0,0,0,0,0,0};
static C_char li658[] C_aligned={C_lihdr(0,0,40),40,115,99,104,101,109,101,35,100,121,110,97,109,105,99,45,119,105,110,100,32,98,101,102,111,114,101,32,116,104,117,110,107,32,97,102,116,101,114,41};
static C_char li659[] C_aligned={C_lihdr(0,0,24),40,99,111,110,116,105,110,117,97,116,105,111,110,32,46,32,114,101,115,117,108,116,115,41};
static C_char li660[] C_aligned={C_lihdr(0,0,13),40,97,50,52,53,50,49,32,99,111,110,116,41,0,0,0};
static C_char li661[] C_aligned={C_lihdr(0,0,44),40,115,99,104,101,109,101,35,99,97,108,108,45,119,105,116,104,45,99,117,114,114,101,110,116,45,99,111,110,116,105,110,117,97,116,105,111,110,32,112,114,111,99,41,0,0,0,0};
static C_char li662[] C_aligned={C_lihdr(0,0,30),40,35,35,115,121,115,35,100,121,110,97,109,105,99,45,117,110,119,105,110,100,32,119,105,110,100,115,32,110,41,0,0};
static C_char li663[] C_aligned={C_lihdr(0,0,29),40,99,104,105,99,107,101,110,46,98,97,115,101,35,112,111,114,116,45,99,108,111,115,101,100,63,32,112,41,0,0,0};
static C_char li664[] C_aligned={C_lihdr(0,0,37),40,35,35,115,121,115,35,109,97,107,101,45,112,111,114,116,32,105,47,111,32,99,108,97,115,115,32,110,97,109,101,32,116,121,112,101,41,0,0,0};
static C_char li665[] C_aligned={C_lihdr(0,0,22),40,97,52,49,55,48,51,32,98,117,102,32,115,116,97,114,116,32,108,101,110,41,0,0};
static C_char li666[] C_aligned={C_lihdr(0,0,26),40,97,52,49,54,57,55,32,98,117,102,32,115,116,97,114,116,32,108,101,110,32,100,101,99,41,0,0,0,0,0,0};
static C_char li667[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li668[] C_aligned={C_lihdr(0,0,10),40,97,52,49,54,50,57,32,112,41,0,0,0,0,0,0};
static C_char li669[] C_aligned={C_lihdr(0,0,20),40,97,52,49,55,52,48,32,98,117,102,32,115,116,97,114,116,32,95,41,0,0,0,0};
static C_char li670[] C_aligned={C_lihdr(0,0,26),40,97,52,49,55,50,56,32,98,117,102,32,115,116,97,114,116,32,108,101,110,32,100,101,99,41,0,0,0,0,0,0};
static C_char li671[] C_aligned={C_lihdr(0,0,10),40,97,52,49,55,49,48,32,112,41,0,0,0,0,0,0};
static C_char li672[] C_aligned={C_lihdr(0,0,12),40,97,52,49,55,52,51,32,112,32,99,41,0,0,0,0};
static C_char li673[] C_aligned={C_lihdr(0,0,21),40,97,52,49,55,56,53,32,98,118,32,115,116,97,114,116,32,108,101,110,41,0,0,0};
static C_char li674[] C_aligned={C_lihdr(0,0,21),40,97,52,49,55,55,49,32,112,32,98,118,32,102,114,111,109,32,116,111,41,0,0,0};
static C_char li675[] C_aligned={C_lihdr(0,0,12),40,97,52,49,55,56,56,32,112,32,100,41,0,0,0,0};
static C_char li676[] C_aligned={C_lihdr(0,0,10),40,97,52,49,55,57,52,32,112,41,0,0,0,0,0,0};
static C_char li677[] C_aligned={C_lihdr(0,0,10),40,97,52,49,55,57,55,32,112,41,0,0,0,0,0,0};
static C_char li678[] C_aligned={C_lihdr(0,0,8),40,97,52,49,56,52,51,41};
static C_char li679[] C_aligned={C_lihdr(0,0,20),40,108,111,111,112,32,114,101,109,32,97,99,116,32,115,116,97,114,116,41,0,0,0,0};
static C_char li680[] C_aligned={C_lihdr(0,0,23),40,97,52,49,56,48,48,32,112,32,110,32,100,101,115,116,32,115,116,97,114,116,41,0};
static C_char li681[] C_aligned={C_lihdr(0,0,8),40,97,52,50,48,48,56,41};
static C_char li682[] C_aligned={C_lihdr(0,0,32),40,108,111,111,112,32,108,101,110,32,108,105,109,105,116,32,98,117,102,102,101,114,32,114,101,115,117,108,116,32,102,41};
static C_char li683[] C_aligned={C_lihdr(0,0,17),40,97,52,49,57,48,55,32,112,32,114,108,105,109,105,116,41,0,0,0,0,0,0,0};
static C_char li684[] C_aligned={C_lihdr(0,0,16),67,95,111,112,101,110,95,102,105,108,101,95,112,111,114,116};
static C_char li685[] C_aligned={C_lihdr(0,0,37),40,35,35,115,121,115,35,99,104,101,99,107,45,105,110,112,117,116,45,112,111,114,116,32,120,32,111,112,101,110,32,46,32,108,111,99,41,0,0,0};
static C_char li686[] C_aligned={C_lihdr(0,0,38),40,35,35,115,121,115,35,99,104,101,99,107,45,111,117,116,112,117,116,45,112,111,114,116,32,120,32,111,112,101,110,32,46,32,108,111,99,41,0,0};
static C_char li687[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,99,104,101,99,107,45,112,111,114,116,32,120,32,46,32,108,111,99,41,0,0,0,0,0,0};
static C_char li688[] C_aligned={C_lihdr(0,0,31),40,35,35,115,121,115,35,99,104,101,99,107,45,111,112,101,110,45,112,111,114,116,32,120,32,46,32,108,111,99,41,0};
static C_char li689[] C_aligned={C_lihdr(0,0,10),40,98,111,100,121,52,57,54,52,41,0,0,0,0,0,0};
static C_char li690[] C_aligned={C_lihdr(0,0,34),40,115,99,104,101,109,101,35,99,117,114,114,101,110,116,45,105,110,112,117,116,45,112,111,114,116,32,46,32,97,114,103,115,41,0,0,0,0,0,0};
static C_char li691[] C_aligned={C_lihdr(0,0,10),40,98,111,100,121,52,57,56,57,41,0,0,0,0,0,0};
static C_char li692[] C_aligned={C_lihdr(0,0,35),40,115,99,104,101,109,101,35,99,117,114,114,101,110,116,45,111,117,116,112,117,116,45,112,111,114,116,32,46,32,97,114,103,115,41,0,0,0,0,0};
static C_char li693[] C_aligned={C_lihdr(0,0,10),40,98,111,100,121,53,48,49,52,41,0,0,0,0,0,0};
static C_char li694[] C_aligned={C_lihdr(0,0,40),40,99,104,105,99,107,101,110,46,98,97,115,101,35,99,117,114,114,101,110,116,45,101,114,114,111,114,45,112,111,114,116,32,46,32,97,114,103,115,41};
static C_char li695[] C_aligned={C_lihdr(0,0,22),40,35,35,115,121,115,35,116,116,121,45,112,111,114,116,63,32,112,111,114,116,41,0,0};
static C_char li696[] C_aligned={C_lihdr(0,0,22),40,35,35,115,121,115,35,112,111,114,116,45,100,97,116,97,32,112,111,114,116,41,0,0};
static C_char li697[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,115,101,116,45,112,111,114,116,45,100,97,116,97,33,32,112,111,114,116,32,100,97,116,97,41};
static C_char li698[] C_aligned={C_lihdr(0,0,18),40,100,111,108,111,111,112,53,48,53,51,32,109,111,100,101,115,41,0,0,0,0,0,0};
static C_char li699[] C_aligned={C_lihdr(0,0,25),40,111,112,101,110,32,110,97,109,101,32,105,110,112,32,109,111,100,101,115,32,108,111,99,41,0,0,0,0,0,0,0};
static C_char li700[] C_aligned={C_lihdr(0,0,20),40,99,108,111,115,101,32,112,111,114,116,32,105,110,112,32,108,111,99,41,0,0,0,0};
static C_char li701[] C_aligned={C_lihdr(0,0,36),40,115,99,104,101,109,101,35,111,112,101,110,45,105,110,112,117,116,45,102,105,108,101,32,110,97,109,101,32,46,32,109,111,100,101,41,0,0,0,0};
static C_char li702[] C_aligned={C_lihdr(0,0,37),40,115,99,104,101,109,101,35,111,112,101,110,45,111,117,116,112,117,116,45,102,105,108,101,32,110,97,109,101,32,46,32,109,111,100,101,41,0,0,0};
static C_char li703[] C_aligned={C_lihdr(0,0,30),40,115,99,104,101,109,101,35,99,108,111,115,101,45,105,110,112,117,116,45,112,111,114,116,32,112,111,114,116,41,0,0};
static C_char li704[] C_aligned={C_lihdr(0,0,31),40,115,99,104,101,109,101,35,99,108,111,115,101,45,111,117,116,112,117,116,45,112,111,114,116,32,112,111,114,116,41,0};
static C_char li705[] C_aligned={C_lihdr(0,0,8),40,97,50,53,50,52,53,41};
static C_char li706[] C_aligned={C_lihdr(0,0,18),40,97,50,53,50,53,49,32,46,32,114,101,115,117,108,116,115,41,0,0,0,0,0,0};
static C_char li707[] C_aligned={C_lihdr(0,0,43),40,115,99,104,101,109,101,35,99,97,108,108,45,119,105,116,104,45,105,110,112,117,116,45,102,105,108,101,32,110,97,109,101,32,112,32,46,32,109,111,100,101,41,0,0,0,0,0};
static C_char li708[] C_aligned={C_lihdr(0,0,8),40,97,50,53,50,54,57,41};
static C_char li709[] C_aligned={C_lihdr(0,0,18),40,97,50,53,50,55,53,32,46,32,114,101,115,117,108,116,115,41,0,0,0,0,0,0};
static C_char li710[] C_aligned={C_lihdr(0,0,44),40,115,99,104,101,109,101,35,99,97,108,108,45,119,105,116,104,45,111,117,116,112,117,116,45,102,105,108,101,32,110,97,109,101,32,112,32,46,32,109,111,100,101,41,0,0,0,0};
static C_char li711[] C_aligned={C_lihdr(0,0,8),40,97,50,53,50,57,51,41};
static C_char li712[] C_aligned={C_lihdr(0,0,18),40,97,50,53,51,48,52,32,46,32,114,101,115,117,108,116,115,41,0,0,0,0,0,0};
static C_char li713[] C_aligned={C_lihdr(0,0,8),40,97,50,53,50,57,56,41};
static C_char li714[] C_aligned={C_lihdr(0,0,8),40,97,50,53,51,49,51,41};
static C_char li715[] C_aligned={C_lihdr(0,0,46),40,115,99,104,101,109,101,35,119,105,116,104,45,105,110,112,117,116,45,102,114,111,109,45,102,105,108,101,32,115,116,114,32,116,104,117,110,107,32,46,32,109,111,100,101,41,0,0};
static C_char li716[] C_aligned={C_lihdr(0,0,8),40,97,50,53,51,50,55,41};
static C_char li717[] C_aligned={C_lihdr(0,0,18),40,97,50,53,51,51,56,32,46,32,114,101,115,117,108,116,115,41,0,0,0,0,0,0};
static C_char li718[] C_aligned={C_lihdr(0,0,8),40,97,50,53,51,51,50,41};
static C_char li719[] C_aligned={C_lihdr(0,0,8),40,97,50,53,51,52,55,41};
static C_char li720[] C_aligned={C_lihdr(0,0,45),40,115,99,104,101,109,101,35,119,105,116,104,45,111,117,116,112,117,116,45,116,111,45,102,105,108,101,32,115,116,114,32,116,104,117,110,107,32,46,32,109,111,100,101,41,0,0,0};
static C_char li721[] C_aligned={C_lihdr(0,0,40),40,35,35,115,121,115,35,102,105,108,101,45,101,120,105,115,116,115,63,32,110,97,109,101,32,102,105,108,101,63,32,100,105,114,63,32,108,111,99,41};
static C_char li722[] C_aligned={C_lihdr(0,0,25),40,35,35,115,121,115,35,102,108,117,115,104,45,111,117,116,112,117,116,32,112,111,114,116,41,0,0,0,0,0,0,0};
static C_char li723[] C_aligned={C_lihdr(0,0,34),40,99,104,105,99,107,101,110,46,98,97,115,101,35,102,108,117,115,104,45,111,117,116,112,117,116,32,46,32,114,101,115,116,41,0,0,0,0,0,0};
static C_char li724[] C_aligned={C_lihdr(0,0,22),40,35,35,115,121,115,35,112,111,114,116,45,108,105,110,101,32,112,111,114,116,41,0,0};
static C_char li725[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,53,50,49,55,32,105,41,0,0};
static C_char li726[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li727[] C_aligned={C_lihdr(0,0,43),40,35,35,115,121,115,35,100,101,99,111,114,97,116,101,45,108,97,109,98,100,97,32,112,114,111,99,32,112,114,101,100,32,100,101,99,111,114,97,116,111,114,41,0,0,0,0,0};
static C_char li728[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li729[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,108,97,109,98,100,97,45,100,101,99,111,114,97,116,105,111,110,32,112,114,111,99,32,112,114,101,100,41,0,0,0,0,0};
static C_char li730[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,109,97,107,101,45,108,97,109,98,100,97,45,105,110,102,111,32,115,116,114,41,0,0,0,0};
static C_char li731[] C_aligned={C_lihdr(0,0,22),40,35,35,115,121,115,35,108,97,109,98,100,97,45,105,110,102,111,63,32,120,41,0,0};
static C_char li732[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,108,97,109,98,100,97,45,105,110,102,111,32,112,114,111,99,41};
static C_char li733[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,108,97,109,98,100,97,45,105,110,102,111,45,62,115,116,114,105,110,103,32,105,110,102,111,41};
static C_char li734[] C_aligned={C_lihdr(0,0,38),40,99,104,105,99,107,101,110,46,98,97,115,101,35,112,114,111,99,101,100,117,114,101,45,105,110,102,111,114,109,97,116,105,111,110,32,120,41,0,0};
static C_char li735[] C_aligned={C_lihdr(0,0,12),40,97,50,53,54,51,55,32,112,32,105,41,0,0,0,0};
static C_char li736[] C_aligned={C_lihdr(0,0,10),40,97,50,53,54,52,55,32,120,41,0,0,0,0,0,0};
static C_char li737[] C_aligned={C_lihdr(0,0,15),40,97,50,53,54,54,51,32,112,114,111,99,32,105,41,0};
static C_char li738[] C_aligned={C_lihdr(0,0,48),40,99,104,105,99,107,101,110,46,98,97,115,101,35,103,101,116,116,101,114,45,119,105,116,104,45,115,101,116,116,101,114,32,103,101,116,32,115,101,116,32,46,32,114,101,115,116,41};
static C_char li739[] C_aligned={C_lihdr(0,0,11),40,102,95,50,53,57,50,52,32,120,41,0,0,0,0,0};
static C_char li740[] C_aligned={C_lihdr(0,0,28),40,97,115,115,105,103,110,32,118,97,108,32,110,32,99,111,110,118,101,114,116,63,32,115,101,116,63,41,0,0,0,0};
static C_char li741[] C_aligned={C_lihdr(0,0,24),40,98,111,100,121,53,51,54,57,32,99,111,110,118,101,114,116,63,32,115,101,116,63,41};
static C_char li742[] C_aligned={C_lihdr(0,0,24),40,100,101,102,45,115,101,116,63,53,51,55,50,32,37,99,111,110,118,101,114,116,63,41};
static C_char li743[] C_aligned={C_lihdr(0,0,18),40,100,101,102,45,99,111,110,118,101,114,116,63,53,51,55,49,41,0,0,0,0,0,0};
static C_char li744[] C_aligned={C_lihdr(0,0,15),40,97,50,53,56,49,53,32,46,32,97,114,103,115,41,0};
static C_char li745[] C_aligned={C_lihdr(0,0,12),40,97,50,53,56,57,55,32,118,97,108,41,0,0,0,0};
static C_char li746[] C_aligned={C_lihdr(0,0,35),40,115,99,104,101,109,101,35,109,97,107,101,45,112,97,114,97,109,101,116,101,114,32,105,110,105,116,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li747[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,99,104,97,114,45,114,101,97,100,121,63,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li748[] C_aligned={C_lihdr(0,0,25),40,115,99,104,101,109,101,35,114,101,97,100,45,99,104,97,114,32,46,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li749[] C_aligned={C_lihdr(0,0,21),40,35,35,115,121,115,35,114,101,97,100,45,99,104,97,114,45,48,32,112,41,0,0,0};
static C_char li750[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,114,101,97,100,45,99,104,97,114,47,112,111,114,116,32,112,111,114,116,41,0,0,0,0,0};
static C_char li751[] C_aligned={C_lihdr(0,0,21),40,35,35,115,121,115,35,112,101,101,107,45,99,104,97,114,45,48,32,112,41,0,0,0};
static C_char li752[] C_aligned={C_lihdr(0,0,25),40,115,99,104,101,109,101,35,112,101,101,107,45,99,104,97,114,32,46,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li753[] C_aligned={C_lihdr(0,0,20),40,115,99,104,101,109,101,35,114,101,97,100,32,46,32,114,101,115,116,41,0,0,0,0};
static C_char li754[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,114,101,97,100,45,112,114,111,109,112,116,45,104,111,111,107,41};
static C_char li755[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,105,110,102,105,120,45,108,105,115,116,45,104,111,111,107,32,108,115,116,41,0,0,0,0,0};
static C_char li756[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,115,104,97,114,112,45,110,117,109,98,101,114,45,104,111,111,107,32,112,111,114,116,32,110,41};
static C_char li757[] C_aligned={C_lihdr(0,0,36),40,35,35,115,121,115,35,114,101,97,100,45,119,97,114,110,105,110,103,32,112,111,114,116,32,109,115,103,32,46,32,97,114,103,115,41,0,0,0,0};
static C_char li758[] C_aligned={C_lihdr(0,0,34),40,35,35,115,121,115,35,114,101,97,100,45,101,114,114,111,114,32,112,111,114,116,32,109,115,103,32,46,32,97,114,103,115,41,0,0,0,0,0,0};
static C_char li759[] C_aligned={C_lihdr(0,0,11),40,102,95,50,54,50,48,53,32,99,41,0,0,0,0,0};
static C_char li760[] C_aligned={C_lihdr(0,0,21),40,105,110,102,111,32,99,108,97,115,115,32,100,97,116,97,32,118,97,108,41,0,0,0};
static C_char li761[] C_aligned={C_lihdr(0,0,8),40,115,107,105,112,32,99,41};
static C_char li762[] C_aligned={C_lihdr(0,0,13),40,115,107,105,112,45,116,111,45,101,111,108,41,0,0,0};
static C_char li763[] C_aligned={C_lihdr(0,0,22),40,114,101,115,101,114,118,101,100,45,99,104,97,114,97,99,116,101,114,32,99,41,0,0};
static C_char li764[] C_aligned={C_lihdr(0,0,29),40,114,101,97,100,45,117,110,114,101,115,101,114,118,101,100,45,99,104,97,114,45,48,32,112,111,114,116,41,0,0,0};
static C_char li765[] C_aligned={C_lihdr(0,0,24),40,114,101,103,105,115,116,101,114,45,115,104,97,114,101,100,33,32,116,104,117,110,107,41};
static C_char li766[] C_aligned={C_lihdr(0,0,16),40,117,110,116,104,117,110,107,32,111,32,102,97,105,108,41};
static C_char li767[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,53,53,52,53,32,105,41,0,0};
static C_char li768[] C_aligned={C_lihdr(0,0,9),40,108,111,111,112,33,32,111,41,0,0,0,0,0,0,0};
static C_char li769[] C_aligned={C_lihdr(0,0,20),40,117,110,116,104,117,110,107,105,102,121,33,32,111,32,102,97,105,108,41,0,0,0,0};
static C_char li770[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,99,41};
static C_char li771[] C_aligned={C_lihdr(0,0,10),40,114,45,115,112,97,99,101,115,41,0,0,0,0,0,0};
static C_char li772[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,115,101,113,32,110,41,0,0,0,0};
static C_char li773[] C_aligned={C_lihdr(0,0,22),40,114,45,117,115,101,113,117,101,110,99,101,32,117,32,110,32,98,97,115,101,41,0,0};
static C_char li774[] C_aligned={C_lihdr(0,0,11),40,112,97,114,115,101,32,115,101,113,41,0,0,0,0,0};
static C_char li775[] C_aligned={C_lihdr(0,0,7),40,97,98,111,114,116,41,0};
static C_char li776[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,115,101,113,41,0,0,0,0,0,0};
static C_char li777[] C_aligned={C_lihdr(0,0,19),40,114,45,120,115,101,113,117,101,110,99,101,32,100,101,108,105,109,41,0,0,0,0,0};
static C_char li778[] C_aligned={C_lihdr(0,0,14),40,101,97,116,45,119,115,32,99,32,110,108,63,41,0,0};
static C_char li779[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,99,32,108,115,116,41,0,0,0,0};
static C_char li780[] C_aligned={C_lihdr(0,0,15),40,114,45,115,116,114,105,110,103,32,116,101,114,109,41,0};
static C_char li781[] C_aligned={C_lihdr(0,0,19),40,115,116,97,114,116,105,110,103,45,108,105,110,101,32,109,115,103,41,0,0,0,0,0};
static C_char li782[] C_aligned={C_lihdr(0,0,11),40,102,95,50,55,50,51,50,32,99,41,0,0,0,0,0};
static C_char li783[] C_aligned={C_lihdr(0,0,15),40,97,50,55,51,52,55,32,116,111,107,32,107,119,41,0};
static C_char li784[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,108,97,115,116,41,0,0,0,0,0};
static C_char li785[] C_aligned={C_lihdr(0,0,15),40,97,50,55,50,50,56,32,114,101,116,117,114,110,41,0};
static C_char li786[] C_aligned={C_lihdr(0,0,18),40,114,45,108,105,115,116,32,115,116,97,114,116,32,101,110,100,41,0,0,0,0,0,0};
static C_char li787[] C_aligned={C_lihdr(0,0,10),40,114,45,118,101,99,116,111,114,41,0,0,0,0,0,0};
static C_char li788[] C_aligned={C_lihdr(0,0,15),40,97,50,55,52,55,52,32,116,111,107,32,107,119,41,0};
static C_char li789[] C_aligned={C_lihdr(0,0,26),40,114,45,110,117,109,98,101,114,32,114,97,100,105,120,32,101,120,97,99,116,110,101,115,115,41,0,0,0,0,0,0};
static C_char li790[] C_aligned={C_lihdr(0,0,31),40,114,45,110,117,109,98,101,114,45,119,105,116,104,45,101,120,97,99,116,110,101,115,115,32,114,97,100,105,120,41,0};
static C_char li791[] C_aligned={C_lihdr(0,0,31),40,114,45,110,117,109,98,101,114,45,119,105,116,104,45,114,97,100,105,120,32,101,120,97,99,116,110,101,115,115,41,0};
static C_char li792[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,99,32,108,115,116,41,0,0,0,0};
static C_char li793[] C_aligned={C_lihdr(0,0,9),40,114,45,116,111,107,101,110,41,0,0,0,0,0,0,0};
static C_char li794[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,99,32,108,115,116,41,0,0,0,0};
static C_char li795[] C_aligned={C_lihdr(0,0,10),40,114,45,100,105,103,105,116,115,41,0,0,0,0,0,0};
static C_char li796[] C_aligned={C_lihdr(0,0,15),40,97,50,55,55,54,57,32,115,116,114,32,107,119,41,0};
static C_char li797[] C_aligned={C_lihdr(0,0,10),40,114,45,115,121,109,98,111,108,41,0,0,0,0,0,0};
static C_char li798[] C_aligned={C_lihdr(0,0,18),40,108,111,111,112,32,108,115,116,32,115,107,119,32,113,116,100,41,0,0,0,0,0,0};
static C_char li799[] C_aligned={C_lihdr(0,0,12),40,114,45,120,116,111,107,101,110,32,107,41,0,0,0,0};
static C_char li800[] C_aligned={C_lihdr(0,0,8),40,114,45,99,104,97,114,41};
static C_char li801[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li802[] C_aligned={C_lihdr(0,0,11),40,114,45,99,111,109,109,101,110,116,41,0,0,0,0,0};
static C_char li803[] C_aligned={C_lihdr(0,0,14),40,114,45,101,120,116,45,115,121,109,98,111,108,41,0,0};
static C_char li804[] C_aligned={C_lihdr(0,0,11),40,114,45,113,117,111,116,101,32,113,41,0,0,0,0,0};
static C_char li805[] C_aligned={C_lihdr(0,0,8),40,97,50,56,52,49,49,41};
static C_char li806[] C_aligned={C_lihdr(0,0,13),40,97,50,56,52,49,55,32,46,32,120,115,41,0,0,0};
static C_char li807[] C_aligned={C_lihdr(0,0,8),40,97,50,56,53,52,53,41};
static C_char li808[] C_aligned={C_lihdr(0,0,8),40,97,50,56,53,56,52,41};
static C_char li809[] C_aligned={C_lihdr(0,0,13),40,97,50,56,53,57,48,32,46,32,120,115,41,0,0,0};
static C_char li810[] C_aligned={C_lihdr(0,0,9),40,103,53,57,56,54,32,104,41,0,0,0,0,0,0,0};
static C_char li811[] C_aligned={C_lihdr(0,0,8),40,97,50,56,54,53,56,41};
static C_char li812[] C_aligned={C_lihdr(0,0,13),40,97,50,56,54,54,52,32,46,32,120,115,41,0,0,0};
static C_char li813[] C_aligned={C_lihdr(0,0,8),40,97,50,56,56,53,54,41};
static C_char li814[] C_aligned={C_lihdr(0,0,15),40,97,50,56,56,54,55,32,115,116,114,32,107,119,41,0};
static C_char li815[] C_aligned={C_lihdr(0,0,8),40,97,50,56,56,54,49,41};
static C_char li816[] C_aligned={C_lihdr(0,0,8),40,97,50,56,56,57,54,41};
static C_char li817[] C_aligned={C_lihdr(0,0,8),40,97,50,57,48,51,56,41};
static C_char li818[] C_aligned={C_lihdr(0,0,13),40,97,50,57,48,52,52,32,46,32,120,115,41,0,0,0};
static C_char li819[] C_aligned={C_lihdr(0,0,9),40,114,101,97,100,114,101,99,41,0,0,0,0,0,0,0};
static C_char li820[] C_aligned={C_lihdr(0,0,12),40,97,50,57,50,57,50,32,46,32,97,41,0,0,0,0};
static C_char li821[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,114,101,97,100,32,112,111,114,116,32,105,110,102,111,104,97,110,100,108,101,114,41,0,0,0};
static C_char li822[] C_aligned={C_lihdr(0,0,11),40,102,97,105,108,32,105,116,101,109,41,0,0,0,0,0};
static C_char li823[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,117,115,101,114,45,114,101,97,100,45,104,111,111,107,32,99,104,97,114,32,112,111,114,116,41};
static C_char li824[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,114,101,97,100,45,110,117,109,118,101,99,116,111,114,45,100,97,116,97,32,112,111,114,116,41};
static C_char li825[] C_aligned={C_lihdr(0,0,15),40,108,111,111,112,50,32,110,115,32,112,114,101,118,41,0};
static C_char li826[] C_aligned={C_lihdr(0,0,9),40,114,101,116,114,121,32,120,41,0,0,0,0,0,0,0};
static C_char li827[] C_aligned={C_lihdr(0,0,15),40,108,111,111,112,32,108,115,116,32,112,114,101,118,41,0};
static C_char li828[] C_aligned={C_lihdr(0,0,38),40,35,35,115,121,115,35,99,97,110,111,110,105,99,97,108,105,122,101,45,110,117,109,98,101,114,45,108,105,115,116,33,32,108,115,116,49,41,0,0};
static C_char li829[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,119,114,105,116,101,45,99,104,97,114,45,48,32,99,32,112,41};
static C_char li830[] C_aligned={C_lihdr(0,0,30),40,35,35,115,121,115,35,119,114,105,116,101,45,99,104,97,114,47,112,111,114,116,32,99,32,112,111,114,116,41,0,0};
static C_char li831[] C_aligned={C_lihdr(0,0,28),40,115,99,104,101,109,101,35,119,114,105,116,101,45,99,104,97,114,32,99,32,46,32,114,101,115,116,41,0,0,0,0};
static C_char li832[] C_aligned={C_lihdr(0,0,23),40,115,99,104,101,109,101,35,110,101,119,108,105,110,101,32,46,32,114,101,115,116,41,0};
static C_char li833[] C_aligned={C_lihdr(0,0,23),40,115,99,104,101,109,101,35,119,114,105,116,101,32,120,32,46,32,114,101,115,116,41,0};
static C_char li834[] C_aligned={C_lihdr(0,0,25),40,115,99,104,101,109,101,35,100,105,115,112,108,97,121,32,120,32,46,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li835[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,54,50,52,56,32,103,54,50,53,53,41,0,0,0,0,0,0,0};
static C_char li836[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,98,97,115,101,35,112,114,105,110,116,32,46,32,97,114,103,115,41,0,0,0,0,0};
static C_char li837[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,54,50,56,48,32,103,54,50,56,55,41,0,0,0,0,0,0,0};
static C_char li838[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,98,97,115,101,35,112,114,105,110,116,42,32,46,32,97,114,103,115,41,0,0,0,0};
static C_char li839[] C_aligned={C_lihdr(0,0,17),40,111,117,116,115,116,114,32,112,111,114,116,32,115,116,114,41,0,0,0,0,0,0,0};
static C_char li840[] C_aligned={C_lihdr(0,0,18),40,111,117,116,115,116,114,48,32,112,111,114,116,32,115,116,114,41,0,0,0,0,0,0};
static C_char li841[] C_aligned={C_lihdr(0,0,17),40,111,117,116,99,104,114,32,112,111,114,116,32,99,104,114,41,0,0,0,0,0,0,0};
static C_char li842[] C_aligned={C_lihdr(0,0,17),40,111,117,116,115,121,109,32,112,111,114,116,32,115,121,109,41,0,0,0,0,0,0,0};
static C_char li843[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li844[] C_aligned={C_lihdr(0,0,25),40,111,117,116,114,101,97,100,97,98,108,101,115,121,109,32,112,111,114,116,32,115,116,114,41,0,0,0,0,0,0,0};
static C_char li845[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li846[] C_aligned={C_lihdr(0,0,22),40,115,121,109,45,105,115,45,114,101,97,100,97,98,108,101,63,32,115,116,114,41,0,0};
static C_char li847[] C_aligned={C_lihdr(0,0,10),40,103,54,52,53,48,32,99,110,41,0,0,0,0,0,0};
static C_char li848[] C_aligned={C_lihdr(0,0,16),40,100,111,108,111,111,112,54,52,55,49,32,105,32,99,41};
static C_char li849[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,54,53,48,50,32,120,41,0,0};
static C_char li850[] C_aligned={C_lihdr(0,0,16),40,100,111,108,111,111,112,54,53,51,49,32,105,32,99,41};
static C_char li851[] C_aligned={C_lihdr(0,0,7),40,111,117,116,32,120,41,0};
static C_char li852[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,112,114,105,110,116,32,120,32,114,101,97,100,97,98,108,101,32,112,111,114,116,41,0,0,0};
static C_char li853[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,112,114,111,99,101,100,117,114,101,45,62,115,116,114,105,110,103,32,120,41,0,0,0,0,0};
static C_char li854[] C_aligned={C_lihdr(0,0,34),40,99,104,105,99,107,101,110,46,98,97,115,101,35,114,101,99,111,114,100,45,112,114,105,110,116,101,114,32,116,121,112,101,41,0,0,0,0,0,0};
static C_char li855[] C_aligned={C_lihdr(0,0,44),40,99,104,105,99,107,101,110,46,98,97,115,101,35,115,101,116,45,114,101,99,111,114,100,45,112,114,105,110,116,101,114,33,32,116,121,112,101,32,112,114,111,99,41,0,0,0,0};
static C_char li856[] C_aligned={C_lihdr(0,0,8),40,97,51,49,48,51,48,41};
static C_char li857[] C_aligned={C_lihdr(0,0,11),40,97,51,49,48,50,52,32,101,120,41,0,0,0,0,0};
static C_char li858[] C_aligned={C_lihdr(0,0,8),40,97,51,49,48,55,55,41};
static C_char li859[] C_aligned={C_lihdr(0,0,8),40,97,51,49,48,57,50,41};
static C_char li860[] C_aligned={C_lihdr(0,0,15),40,97,51,49,48,56,54,32,46,32,97,114,103,115,41,0};
static C_char li861[] C_aligned={C_lihdr(0,0,8),40,97,51,49,48,55,49,41};
static C_char li862[] C_aligned={C_lihdr(0,0,10),40,97,51,49,48,49,56,32,107,41,0,0,0,0,0,0};
static C_char li863[] C_aligned={C_lihdr(0,0,39),40,35,35,115,121,115,35,117,115,101,114,45,112,114,105,110,116,45,104,111,111,107,32,120,32,114,101,97,100,97,98,108,101,32,112,111,114,116,41,0};
static C_char li864[] C_aligned={C_lihdr(0,0,8),40,97,51,49,49,54,49,41};
static C_char li865[] C_aligned={C_lihdr(0,0,8),40,97,51,49,50,48,52,41};
static C_char li866[] C_aligned={C_lihdr(0,0,8),40,97,51,49,50,49,48,41};
static C_char li867[] C_aligned={C_lihdr(0,0,15),40,97,51,49,49,53,53,32,114,101,116,117,114,110,41,0};
static C_char li868[] C_aligned={C_lihdr(0,0,43),40,35,35,115,121,115,35,119,105,116,104,45,112,114,105,110,116,45,108,101,110,103,116,104,45,108,105,109,105,116,32,108,105,109,105,116,32,116,104,117,110,107,41,0,0,0,0,0};
static C_char li869[] C_aligned={C_lihdr(0,0,15),40,99,104,101,99,107,54,54,53,48,32,112,32,110,41,0};
static C_char li870[] C_aligned={C_lihdr(0,0,10),40,97,52,49,49,51,49,32,112,41,0,0,0,0,0,0};
static C_char li871[] C_aligned={C_lihdr(0,0,10),40,97,52,49,49,53,51,32,112,41,0,0,0,0,0,0};
static C_char li872[] C_aligned={C_lihdr(0,0,12),40,97,52,49,49,55,49,32,112,32,99,41,0,0,0,0};
static C_char li873[] C_aligned={C_lihdr(0,0,21),40,97,52,49,49,56,55,32,112,32,98,118,32,102,114,111,109,32,116,111,41,0,0,0};
static C_char li874[] C_aligned={C_lihdr(0,0,10),40,97,52,49,50,48,57,32,112,41,0,0,0,0,0,0};
static C_char li875[] C_aligned={C_lihdr(0,0,10),40,97,52,49,50,49,50,32,112,41,0,0,0,0,0,0};
static C_char li876[] C_aligned={C_lihdr(0,0,23),40,97,52,49,50,49,53,32,112,32,110,32,100,101,115,116,32,115,116,97,114,116,41,0};
static C_char li877[] C_aligned={C_lihdr(0,0,12),40,97,52,49,50,56,53,32,112,111,115,41,0,0,0,0};
static C_char li878[] C_aligned={C_lihdr(0,0,8),40,97,52,49,50,55,53,41};
static C_char li879[] C_aligned={C_lihdr(0,0,29),40,97,52,49,50,57,52,32,110,101,120,116,32,108,105,110,101,32,102,117,108,108,45,108,105,110,101,63,41,0,0,0};
static C_char li880[] C_aligned={C_lihdr(0,0,16),40,97,52,49,50,53,49,32,112,32,108,105,109,105,116,41};
static C_char li881[] C_aligned={C_lihdr(0,0,10),40,97,52,49,51,51,53,32,112,41,0,0,0,0,0,0};
static C_char li882[] C_aligned={C_lihdr(0,0,6),40,103,114,111,119,41,0,0};
static C_char li883[] C_aligned={C_lihdr(0,0,18),40,99,111,110,99,32,98,117,102,32,102,114,111,109,32,116,111,41,0,0,0,0,0,0};
static C_char li884[] C_aligned={C_lihdr(0,0,9),40,99,111,110,99,49,32,98,41,0,0,0,0,0,0,0};
static C_char li885[] C_aligned={C_lihdr(0,0,9),40,103,101,116,108,105,110,101,41,0,0,0,0,0,0,0};
static C_char li886[] C_aligned={C_lihdr(0,0,8),40,97,51,49,51,56,48,41};
static C_char li887[] C_aligned={C_lihdr(0,0,25),40,97,51,49,51,56,54,32,98,117,102,32,111,102,102,115,101,116,32,108,105,109,105,116,41,0,0,0,0,0,0,0};
static C_char li888[] C_aligned={C_lihdr(0,0,8),40,97,51,49,52,53,52,41};
static C_char li889[] C_aligned={C_lihdr(0,0,25),40,97,51,49,52,54,48,32,98,117,102,32,111,102,102,115,101,116,32,108,105,109,105,116,41,0,0,0,0,0,0,0};
static C_char li890[] C_aligned={C_lihdr(0,0,27),40,108,111,111,112,32,98,117,102,32,111,102,102,115,101,116,32,112,111,115,32,108,105,109,105,116,41,0,0,0,0,0};
static C_char li891[] C_aligned={C_lihdr(0,0,63),40,35,35,115,121,115,35,115,99,97,110,45,98,117,102,102,101,114,45,108,105,110,101,32,98,117,102,32,108,105,109,105,116,32,115,116,97,114,116,45,112,111,115,32,101,111,115,45,104,97,110,100,108,101,114,32,46,32,114,101,115,116,41,0};
static C_char li892[] C_aligned={C_lihdr(0,0,9),40,103,54,56,48,51,32,120,41,0,0,0,0,0,0,0};
static C_char li893[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,54,56,48,50,32,103,54,56,48,57,41,0,0,0,0,0,0,0};
static C_char li894[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,112,114,105,110,116,45,116,111,45,115,116,114,105,110,103,32,120,115,41,0,0,0,0,0,0};
static C_char li895[] C_aligned={C_lihdr(0,0,25),40,35,35,115,121,115,35,112,111,105,110,116,101,114,45,62,115,116,114,105,110,103,32,120,41,0,0,0,0,0,0,0};
static C_char li896[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li897[] C_aligned={C_lihdr(0,0,36),40,99,104,105,99,107,101,110,46,98,97,115,101,35,103,101,116,45,99,97,108,108,45,99,104,97,105,110,32,46,32,114,101,115,116,41,0,0,0,0};
static C_char li898[] C_aligned={C_lihdr(0,0,8),40,97,51,49,56,53,53,41};
static C_char li899[] C_aligned={C_lihdr(0,0,12),40,103,54,56,55,50,32,105,110,102,111,41,0,0,0,0};
static C_char li900[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,54,56,55,49,32,103,54,56,55,56,41,0,0,0,0,0,0,0};
static C_char li901[] C_aligned={C_lihdr(0,0,49),40,35,35,115,121,115,35,114,101,97,108,108,121,45,112,114,105,110,116,45,99,97,108,108,45,99,104,97,105,110,32,112,111,114,116,32,99,104,97,105,110,32,104,101,97,100,101,114,41,0,0,0,0,0,0,0};
static C_char li902[] C_aligned={C_lihdr(0,0,38),40,99,104,105,99,107,101,110,46,98,97,115,101,35,112,114,105,110,116,45,99,97,108,108,45,99,104,97,105,110,32,46,32,114,101,115,116,41,0,0};
static C_char li903[] C_aligned={C_lihdr(0,0,7),40,98,114,101,97,107,41,0};
static C_char li904[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,117,115,101,114,45,105,110,116,101,114,114,117,112,116,45,104,111,111,107,41,0,0,0,0,0};
static C_char li905[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,54,57,51,49,32,103,54,57,51,56,41,0,0,0,0,0,0,0};
static C_char li906[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li907[] C_aligned={C_lihdr(0,0,21),40,99,108,101,97,110,117,112,45,98,101,102,111,114,101,45,101,120,105,116,41,0,0,0};
static C_char li908[] C_aligned={C_lihdr(0,0,23),40,35,35,115,121,115,35,100,98,103,45,104,111,111,107,32,46,32,97,114,103,115,41,0};
static C_char li909[] C_aligned={C_lihdr(0,0,8),40,97,51,50,49,56,55,41};
static C_char li910[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,55,48,49,48,32,103,55,48,49,55,41,0,0,0,0,0,0,0};
static C_char li911[] C_aligned={C_lihdr(0,0,47),40,35,35,115,121,115,35,115,105,103,110,97,108,45,104,111,111,107,47,101,114,114,110,111,32,109,111,100,101,32,101,114,114,110,111,32,109,115,103,32,46,32,97,114,103,115,41,0};
static C_char li912[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,115,105,103,110,97,108,45,104,111,111,107,32,109,111,100,101,32,109,115,103,32,46,32,97,114,103,115,41,0,0,0,0,0};
static C_char li913[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,97,98,111,114,116,32,120,41,0,0,0,0,0};
static C_char li914[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,115,105,103,110,97,108,32,120,41,0,0,0,0};
static C_char li915[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,99,117,114,114,101,110,116,45,101,120,99,101,112,116,105,111,110,45,104,97,110,100,108,101,114,32,99,41,0,0,0,0,0};
static C_char li916[] C_aligned={C_lihdr(0,0,8),40,97,51,50,54,53,49,41};
static C_char li917[] C_aligned={C_lihdr(0,0,8),40,97,51,50,54,53,53,41};
static C_char li918[] C_aligned={C_lihdr(0,0,56),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,119,105,116,104,45,101,120,99,101,112,116,105,111,110,45,104,97,110,100,108,101,114,32,104,97,110,100,108,101,114,32,116,104,117,110,107,41};
static C_char li919[] C_aligned={C_lihdr(0,0,10),40,98,111,100,121,55,49,54,55,41,0,0,0,0,0,0};
static C_char li920[] C_aligned={C_lihdr(0,0,52),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,99,117,114,114,101,110,116,45,101,120,99,101,112,116,105,111,110,45,104,97,110,100,108,101,114,32,46,32,97,114,103,115,41,0,0,0,0};
static C_char li921[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,112,114,111,112,115,41,0,0,0,0};
static C_char li922[] C_aligned={C_lihdr(0,0,69),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,112,114,111,112,45,108,105,115,116,45,62,107,105,110,100,45,112,114,101,102,105,120,101,100,45,112,114,111,112,45,108,105,115,116,32,108,111,99,32,107,105,110,100,32,112,108,105,115,116,41,0,0,0};
static C_char li923[] C_aligned={C_lihdr(0,0,56),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,109,97,107,101,45,112,114,111,112,101,114,116,121,45,99,111,110,100,105,116,105,111,110,32,107,105,110,100,32,46,32,112,114,111,112,115,41};
static C_char li924[] C_aligned={C_lihdr(0,0,19),40,102,111,114,45,101,97,99,104,45,108,111,111,112,55,50,49,49,41,0,0,0,0,0};
static C_char li925[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,55,50,53,54,32,103,55,50,54,56,41,0,0,0,0};
static C_char li926[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,55,50,50,57,32,103,55,50,52,49,41,0,0,0,0};
static C_char li927[] C_aligned={C_lihdr(0,0,55),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,109,97,107,101,45,99,111,109,112,111,115,105,116,101,45,99,111,110,100,105,116,105,111,110,32,99,49,32,46,32,99,111,110,100,115,41,0};
static C_char li928[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,55,51,49,54,32,103,55,51,50,56,41,0,0,0,0};
static C_char li929[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,55,50,56,57,32,103,55,51,48,49,41,0,0,0,0};
static C_char li930[] C_aligned={C_lihdr(0,0,41),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,99,111,110,100,105,116,105,111,110,32,97,114,103,49,32,46,32,97,114,103,115,41,0,0,0,0,0,0,0};
static C_char li931[] C_aligned={C_lihdr(0,0,32),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,99,111,110,100,105,116,105,111,110,63,32,120,41};
static C_char li932[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,112,114,111,112,115,41,0,0,0,0};
static C_char li933[] C_aligned={C_lihdr(0,0,9),40,103,55,51,53,50,32,107,41,0,0,0,0,0,0,0};
static C_char li934[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,55,51,52,54,32,103,55,51,53,56,41,0,0,0,0};
static C_char li935[] C_aligned={C_lihdr(0,0,37),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,99,111,110,100,105,116,105,111,110,45,62,108,105,115,116,32,120,41,0,0,0};
static C_char li936[] C_aligned={C_lihdr(0,0,11),40,102,95,51,51,49,55,52,32,99,41,0,0,0,0,0};
static C_char li937[] C_aligned={C_lihdr(0,0,44),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,99,111,110,100,105,116,105,111,110,45,112,114,101,100,105,99,97,116,101,32,107,105,110,100,41,0,0,0,0};
static C_char li938[] C_aligned={C_lihdr(0,0,11),40,102,95,51,51,50,48,49,32,99,41,0,0,0,0,0};
static C_char li939[] C_aligned={C_lihdr(0,0,67),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,99,111,110,100,105,116,105,111,110,45,112,114,111,112,101,114,116,121,45,97,99,99,101,115,115,111,114,32,107,105,110,100,32,112,114,111,112,32,46,32,101,114,114,45,100,101,102,41,0,0,0,0,0};
static C_char li940[] C_aligned={C_lihdr(0,0,64),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,103,101,116,45,99,111,110,100,105,116,105,111,110,45,112,114,111,112,101,114,116,121,32,99,32,107,105,110,100,32,112,114,111,112,32,46,32,101,114,114,45,100,101,102,41};
static C_char li941[] C_aligned={C_lihdr(0,0,8),40,97,51,51,50,54,55,41};
static C_char li942[] C_aligned={C_lihdr(0,0,9),40,103,55,52,49,55,32,120,41,0,0,0,0,0,0,0};
static C_char li943[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,55,52,49,54,32,103,55,52,50,51,41,0,0,0,0,0,0,0};
static C_char li944[] C_aligned={C_lihdr(0,0,21),40,119,114,105,116,101,97,114,103,115,32,97,114,103,115,32,112,111,114,116,41,0,0,0};
static C_char li945[] C_aligned={C_lihdr(0,0,11),40,103,55,52,54,48,32,109,115,103,41,0,0,0,0,0};
static C_char li946[] C_aligned={C_lihdr(0,0,22),40,98,111,100,121,55,52,51,55,32,112,111,114,116,32,104,101,97,100,101,114,41,0,0};
static C_char li947[] C_aligned={C_lihdr(0,0,22),40,100,101,102,45,104,101,97,100,101,114,55,52,52,48,32,37,112,111,114,116,41,0,0};
static C_char li948[] C_aligned={C_lihdr(0,0,14),40,100,101,102,45,112,111,114,116,55,52,51,57,41,0,0};
static C_char li949[] C_aligned={C_lihdr(0,0,49),40,99,104,105,99,107,101,110,46,99,111,110,100,105,116,105,111,110,35,112,114,105,110,116,45,101,114,114,111,114,45,109,101,115,115,97,103,101,32,101,120,32,46,32,97,114,103,115,41,0,0,0,0,0,0,0};
static C_char li950[] C_aligned={C_lihdr(0,0,47),40,35,35,115,121,115,35,115,104,111,119,45,101,120,99,101,112,116,105,111,110,45,119,97,114,110,105,110,103,32,101,120,110,32,99,97,117,115,101,32,46,32,114,101,115,116,41,0};
static C_char li951[] C_aligned={C_lihdr(0,0,34),40,35,35,115,121,115,35,101,114,114,111,114,45,104,111,111,107,32,99,111,100,101,32,108,111,99,32,46,32,97,114,103,115,41,0,0,0,0,0,0};
static C_char li952[] C_aligned={C_lihdr(0,0,8),40,97,51,52,50,55,57,41};
static C_char li953[] C_aligned={C_lihdr(0,0,8),40,97,51,52,51,49,57,41};
static C_char li954[] C_aligned={C_lihdr(0,0,45),40,115,99,104,101,109,101,35,119,105,116,104,45,101,120,99,101,112,116,105,111,110,45,104,97,110,100,108,101,114,32,104,97,110,100,108,101,114,32,116,104,117,110,107,41,0,0,0};
static C_char li955[] C_aligned={C_lihdr(0,0,8),40,97,51,52,51,53,49,41};
static C_char li956[] C_aligned={C_lihdr(0,0,18),40,115,99,104,101,109,101,35,114,97,105,115,101,32,111,98,106,41,0,0,0,0,0,0};
static C_char li957[] C_aligned={C_lihdr(0,0,8),40,97,51,52,51,57,50,41};
static C_char li958[] C_aligned={C_lihdr(0,0,30),40,115,99,104,101,109,101,35,114,97,105,115,101,45,99,111,110,116,105,110,117,97,98,108,101,32,111,98,106,41,0,0};
static C_char li959[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,114,101,97,100,45,101,114,114,111,114,63,32,111,98,106,41};
static C_char li960[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,102,105,108,101,45,101,114,114,111,114,63,32,111,98,106,41};
static C_char li961[] C_aligned={C_lihdr(0,0,22),40,35,35,115,121,115,35,115,116,114,117,99,116,117,114,101,63,32,120,32,115,41,0,0};
static C_char li962[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,103,101,110,101,114,105,99,45,115,116,114,117,99,116,117,114,101,63,32,120,41,0,0,0,0};
static C_char li963[] C_aligned={C_lihdr(0,0,16),40,35,35,115,121,115,35,115,108,111,116,32,120,32,105,41};
static C_char li964[] C_aligned={C_lihdr(0,0,14),40,35,35,115,121,115,35,115,105,122,101,32,120,41,0,0};
static C_char li965[] C_aligned={C_lihdr(0,0,14),67,95,109,97,107,101,95,112,111,105,110,116,101,114,0,0};
static C_char li966[] C_aligned={C_lihdr(0,0,21),67,95,109,97,107,101,95,116,97,103,103,101,100,95,112,111,105,110,116,101,114,0,0,0};
static C_char li967[] C_aligned={C_lihdr(0,0,18),40,35,35,115,121,115,35,112,111,105,110,116,101,114,63,32,120,41,0,0,0,0,0,0};
static C_char li968[] C_aligned={C_lihdr(0,0,37),40,35,35,115,121,115,35,115,101,116,45,112,111,105,110,116,101,114,45,97,100,100,114,101,115,115,33,32,112,116,114,32,97,100,100,114,41,0,0,0};
static C_char li969[] C_aligned={C_lihdr(0,0,21),40,35,35,115,121,115,35,98,121,116,101,118,101,99,116,111,114,63,32,120,41,0,0,0};
static C_char li970[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,115,116,114,105,110,103,45,62,112,98,121,116,101,118,101,99,116,111,114,32,115,41,0,0,0};
static C_char li971[] C_aligned={C_lihdr(0,0,20),40,35,35,115,121,115,35,112,101,114,109,97,110,101,110,116,63,32,120,41,0,0,0,0};
static C_char li972[] C_aligned={C_lihdr(0,0,23),40,35,35,115,121,115,35,98,108,111,99,107,45,97,100,100,114,101,115,115,32,120,41,0};
static C_char li973[] C_aligned={C_lihdr(0,0,19),40,35,35,115,121,115,35,108,111,99,97,116,105,118,101,63,32,120,41,0,0,0,0,0};
static C_char li974[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,115,114,102,105,45,52,45,118,101,99,116,111,114,63,32,120,41};
static C_char li975[] C_aligned={C_lihdr(0,0,20),40,35,35,115,121,115,35,110,117,108,108,45,112,111,105,110,116,101,114,41,0,0,0,0};
static C_char li976[] C_aligned={C_lihdr(0,0,23),40,35,35,115,121,115,35,110,117,108,108,45,112,111,105,110,116,101,114,63,32,120,41,0};
static C_char li977[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,97,100,100,114,101,115,115,45,62,112,111,105,110,116,101,114,32,97,100,100,114,41,0,0,0};
static C_char li978[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,112,111,105,110,116,101,114,45,62,97,100,100,114,101,115,115,32,112,116,114,41,0,0,0,0};
static C_char li979[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,109,97,107,101,45,99,45,115,116,114,105,110,103,32,115,116,114,32,46,32,114,101,115,116,41};
static C_char li980[] C_aligned={C_lihdr(0,0,21),67,95,112,101,101,107,95,115,105,103,110,101,100,95,105,110,116,101,103,101,114,0,0,0};
static C_char li981[] C_aligned={C_lihdr(0,0,23),67,95,112,101,101,107,95,117,110,115,105,103,110,101,100,95,105,110,116,101,103,101,114,0};
static C_char li982[] C_aligned={C_lihdr(0,0,23),40,35,35,115,121,115,35,112,101,101,107,45,102,105,120,110,117,109,32,98,32,105,41,0};
static C_char li983[] C_aligned={C_lihdr(0,0,23),40,35,35,115,121,115,35,112,101,101,107,45,98,121,116,101,32,112,116,114,32,105,41,0};
static C_char li984[] C_aligned={C_lihdr(0,0,30),40,35,35,115,121,115,35,118,101,99,116,111,114,45,62,115,116,114,117,99,116,117,114,101,33,32,118,101,99,41,0,0};
static C_char li985[] C_aligned={C_lihdr(0,0,23),40,35,35,115,121,115,35,112,101,101,107,45,100,111,117,98,108,101,32,98,32,105,41,0};
static C_char li986[] C_aligned={C_lihdr(0,0,25),40,35,35,115,121,115,35,112,101,101,107,45,99,45,115,116,114,105,110,103,32,98,32,105,41,0,0,0,0,0,0,0};
static C_char li987[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,112,101,101,107,45,110,111,110,110,117,108,108,45,99,45,115,116,114,105,110,103,32,98,32,105,41,0,0,0,0,0,0,0};
static C_char li988[] C_aligned={C_lihdr(0,0,34),40,35,35,115,121,115,35,112,101,101,107,45,97,110,100,45,102,114,101,101,45,99,45,115,116,114,105,110,103,32,98,32,105,41,0,0,0,0,0,0};
static C_char li989[] C_aligned={C_lihdr(0,0,42),40,35,35,115,121,115,35,112,101,101,107,45,97,110,100,45,102,114,101,101,45,110,111,110,110,117,108,108,45,99,45,115,116,114,105,110,103,32,98,32,105,41,0,0,0,0,0,0};
static C_char li990[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,112,111,107,101,45,99,45,115,116,114,105,110,103,32,98,32,105,32,115,41,0,0,0,0,0};
static C_char li991[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,112,111,107,101,45,105,110,116,101,103,101,114,32,98,32,105,32,110,41,0,0,0,0,0,0};
static C_char li992[] C_aligned={C_lihdr(0,0,25),40,35,35,115,121,115,35,112,111,107,101,45,100,111,117,98,108,101,32,98,32,105,32,110,41,0,0,0,0,0,0,0};
static C_char li993[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li994[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,112,101,101,107,45,99,45,115,116,114,105,110,103,45,108,105,115,116,32,112,116,114,32,110,41};
static C_char li995[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li996[] C_aligned={C_lihdr(0,0,41),40,35,35,115,121,115,35,112,101,101,107,45,97,110,100,45,102,114,101,101,45,99,45,115,116,114,105,110,103,45,108,105,115,116,32,112,116,114,32,110,41,0,0,0,0,0,0,0};
static C_char li997[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,118,101,99,116,111,114,45,62,99,108,111,115,117,114,101,33,32,118,101,99,32,97,100,100,114,41,0,0,0,0,0,0,0};
static C_char li998[] C_aligned={C_lihdr(0,0,38),40,35,35,115,121,115,35,115,121,109,98,111,108,45,104,97,115,45,116,111,112,108,101,118,101,108,45,98,105,110,100,105,110,103,63,32,115,41,0,0};
static C_char li999[] C_aligned={C_lihdr(0,0,23),40,35,35,115,121,115,35,98,108,111,99,107,45,112,111,105,110,116,101,114,32,120,41,0};
static C_char li1000[] C_aligned={C_lihdr(0,0,31),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,99,104,97,114,45,97,114,103,117,109,101,110,116,32,120,41,0};
static C_char li1001[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,102,105,120,110,117,109,45,97,114,103,117,109,101,110,116,32,120,41,0,0,0,0,0,0,0};
static C_char li1002[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,102,108,111,110,117,109,45,97,114,103,117,109,101,110,116,32,120,41,0,0,0,0,0,0,0};
static C_char li1003[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,98,108,111,99,107,45,97,114,103,117,109,101,110,116,32,120,41};
static C_char li1004[] C_aligned={C_lihdr(0,0,34),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,99,112,108,120,110,117,109,45,97,114,103,117,109,101,110,116,32,120,41,0,0,0,0,0,0};
static C_char li1005[] C_aligned={C_lihdr(0,0,43),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,115,116,114,117,99,116,45,119,114,97,112,112,101,114,45,97,114,103,117,109,101,110,116,32,116,32,120,41,0,0,0,0,0};
static C_char li1006[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,115,116,114,105,110,103,45,97,114,103,117,109,101,110,116,32,120,41,0,0,0,0,0,0,0};
static C_char li1007[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,115,121,109,98,111,108,45,97,114,103,117,109,101,110,116,32,120,41,0,0,0,0,0,0,0};
static C_char li1008[] C_aligned={C_lihdr(0,0,34),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,112,111,105,110,116,101,114,45,97,114,103,117,109,101,110,116,32,120,41,0,0,0,0,0,0};
static C_char li1009[] C_aligned={C_lihdr(0,0,44),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,116,97,103,103,101,100,45,112,111,105,110,116,101,114,45,97,114,103,117,109,101,110,116,32,120,32,116,120,41,0,0,0,0};
static C_char li1010[] C_aligned={C_lihdr(0,0,48),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,114,97,110,103,101,100,45,105,110,116,101,103,101,114,45,97,114,103,117,109,101,110,116,32,111,98,106,32,115,105,122,101,41};
static C_char li1011[] C_aligned={C_lihdr(0,0,57),40,35,35,115,121,115,35,102,111,114,101,105,103,110,45,117,110,115,105,103,110,101,100,45,114,97,110,103,101,100,45,105,110,116,101,103,101,114,45,97,114,103,117,109,101,110,116,32,111,98,106,32,115,105,122,101,41,0,0,0,0,0,0,0};
static C_char li1012[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,119,114,97,112,45,115,116,114,117,99,116,32,116,121,112,101,32,114,101,99,41,0,0,0,0};
static C_char li1013[] C_aligned={C_lihdr(0,0,37),40,35,35,115,121,115,35,100,101,102,97,117,108,116,45,101,120,99,101,112,116,105,111,110,45,104,97,110,100,108,101,114,32,97,114,103,41,0,0,0};
static C_char li1014[] C_aligned={C_lihdr(0,0,38),40,35,35,115,121,115,35,109,97,107,101,45,116,104,114,101,97,100,32,116,104,117,110,107,32,115,116,97,116,101,32,110,97,109,101,32,113,41,0,0};
static C_char li1015[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,109,97,107,101,45,109,117,116,101,120,32,105,100,32,111,119,110,101,114,41,0,0,0,0,0};
static C_char li1016[] C_aligned={C_lihdr(0,0,16),40,35,35,115,121,115,35,115,99,104,101,100,117,108,101,41};
static C_char li1017[] C_aligned={C_lihdr(0,0,8),40,97,51,52,56,56,57,41};
static C_char li1018[] C_aligned={C_lihdr(0,0,15),40,97,51,52,56,56,48,32,114,101,116,117,114,110,41,0};
static C_char li1019[] C_aligned={C_lihdr(0,0,21),40,35,35,115,121,115,35,116,104,114,101,97,100,45,121,105,101,108,100,33,41,0,0,0};
static C_char li1020[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,107,105,108,108,45,111,116,104,101,114,45,116,104,114,101,97,100,115,32,116,104,117,110,107,41};
static C_char li1021[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,114,101,115,117,109,101,45,116,104,114,101,97,100,45,111,110,45,101,118,101,110,116,32,116,41};
static C_char li1022[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,115,117,115,112,101,110,100,45,116,104,114,101,97,100,45,111,110,45,101,118,101,110,116,32,116,41,0,0,0,0,0,0,0};
static C_char li1023[] C_aligned={C_lihdr(0,0,12),40,97,51,52,57,49,54,32,46,32,95,41,0,0,0,0};
static C_char li1024[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,115,108,101,101,112,45,117,110,116,105,108,45,105,110,116,101,114,114,117,112,116,41,0,0,0};
static C_char li1025[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,109,97,107,101,45,101,118,101,110,116,45,113,117,101,117,101,41};
static C_char li1026[] C_aligned={C_lihdr(0,0,31),40,35,35,115,121,115,35,97,100,100,45,101,118,101,110,116,45,116,111,45,113,117,101,117,101,33,32,113,32,101,41,0};
static C_char li1027[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,103,101,116,45,110,101,120,116,45,101,118,101,110,116,32,113,41};
static C_char li1028[] C_aligned={C_lihdr(0,0,7),40,97,103,97,105,110,41,0};
static C_char li1029[] C_aligned={C_lihdr(0,0,29),40,35,35,115,121,115,35,119,97,105,116,45,102,111,114,45,110,101,120,116,45,101,118,101,110,116,32,113,41,0,0,0};
static C_char li1030[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,98,97,115,101,35,115,108,101,101,112,45,104,111,111,107,32,110,41,0,0,0,0,0};
static C_char li1031[] C_aligned={C_lihdr(0,0,22),40,99,104,105,99,107,101,110,46,98,97,115,101,35,115,108,101,101,112,32,110,41,0,0};
static C_char li1032[] C_aligned={C_lihdr(0,0,16),67,95,99,111,110,116,101,120,116,95,115,119,105,116,99,104};
static C_char li1033[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,114,101,97,115,111,110,41,0,0,0};
static C_char li1034[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,105,110,116,101,114,114,117,112,116,45,104,111,111,107,32,114,101,97,115,111,110,32,115,116,97,116,101,41,0,0,0,0,0};
static C_char li1035[] C_aligned={C_lihdr(0,0,28),40,35,35,115,121,115,35,100,105,115,112,97,116,99,104,45,105,110,116,101,114,114,117,112,116,32,107,41,0,0,0,0};
static C_char li1036[] C_aligned={C_lihdr(0,0,20),40,35,35,115,121,115,35,117,112,100,97,116,101,45,101,114,114,110,111,41,0,0,0,0};
static C_char li1037[] C_aligned={C_lihdr(0,0,13),40,35,35,115,121,115,35,101,114,114,110,111,41,0,0,0};
static C_char li1038[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,55,57,49,50,32,99,41,0,0};
static C_char li1039[] C_aligned={C_lihdr(0,0,13),40,114,101,97,100,108,110,32,112,111,114,116,41,0,0,0};
static C_char li1040[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li1041[] C_aligned={C_lihdr(0,0,36),40,114,101,97,100,45,101,115,99,97,112,101,100,45,115,101,120,112,32,112,111,114,116,32,115,107,105,112,45,98,114,97,99,101,63,41,0,0,0,0};
static C_char li1042[] C_aligned={C_lihdr(0,0,15),40,100,111,108,111,111,112,55,57,52,55,32,108,110,41,0};
static C_char li1043[] C_aligned={C_lihdr(0,0,15),40,103,101,116,47,99,108,101,97,114,45,115,116,114,41,0};
static C_char li1044[] C_aligned={C_lihdr(0,0,27),40,108,111,111,112,50,32,108,115,116,32,110,101,120,116,45,115,116,114,105,110,103,32,97,99,99,41,0,0,0,0,0};
static C_char li1045[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li1046[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,117,115,101,114,45,114,101,97,100,45,104,111,111,107,32,99,104,97,114,32,112,111,114,116,41};
static C_char li1047[] C_aligned={C_lihdr(0,0,47),40,99,104,105,99,107,101,110,46,112,114,111,99,101,115,115,45,99,111,110,116,101,120,116,35,99,104,97,110,103,101,45,100,105,114,101,99,116,111,114,121,32,110,97,109,101,41,0};
static C_char li1048[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,99,104,97,110,103,101,45,100,105,114,101,99,116,111,114,121,45,104,111,111,107,32,100,105,114,41,0,0,0,0,0,0,0};
static C_char li1049[] C_aligned={C_lihdr(0,0,54),40,99,104,105,99,107,101,110,46,112,114,111,99,101,115,115,45,99,111,110,116,101,120,116,35,103,101,116,45,101,110,118,105,114,111,110,109,101,110,116,45,118,97,114,105,97,98,108,101,32,118,97,114,41,0,0};
static C_char li1050[] C_aligned={C_lihdr(0,0,59),40,99,104,105,99,107,101,110,46,112,114,111,99,101,115,115,45,99,111,110,116,101,120,116,35,115,101,116,45,101,110,118,105,114,111,110,109,101,110,116,45,118,97,114,105,97,98,108,101,33,32,118,97,114,32,118,97,108,41,0,0,0,0,0};
static C_char li1051[] C_aligned={C_lihdr(0,0,57),40,99,104,105,99,107,101,110,46,112,114,111,99,101,115,115,45,99,111,110,116,101,120,116,35,117,110,115,101,116,45,101,110,118,105,114,111,110,109,101,110,116,45,118,97,114,105,97,98,108,101,33,32,118,97,114,41,0,0,0,0,0,0,0};
static C_char li1052[] C_aligned={C_lihdr(0,0,8),40,115,99,97,110,32,106,41};
static C_char li1053[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li1054[] C_aligned={C_lihdr(0,0,51),40,99,104,105,99,107,101,110,46,112,114,111,99,101,115,115,45,99,111,110,116,101,120,116,35,103,101,116,45,101,110,118,105,114,111,110,109,101,110,116,45,118,97,114,105,97,98,108,101,115,41,0,0,0,0,0};
static C_char li1055[] C_aligned={C_lihdr(0,0,45),40,99,104,105,99,107,101,110,46,112,114,111,99,101,115,115,45,99,111,110,116,101,120,116,35,101,120,101,99,117,116,97,98,108,101,45,112,97,116,104,110,97,109,101,41,0,0,0};
static C_char li1056[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,112,114,111,99,101,115,115,45,99,111,110,116,101,120,116,35,97,114,103,99,43,97,114,103,118,41,0,0,0,0,0};
static C_char li1057[] C_aligned={C_lihdr(0,0,16),40,100,111,108,111,111,112,56,49,49,53,32,105,32,118,41};
static C_char li1058[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,112,114,111,99,101,115,115,45,99,111,110,116,101,120,116,35,97,114,103,118,41,0,0};
static C_char li1059[] C_aligned={C_lihdr(0,0,36),40,99,104,105,99,107,101,110,46,103,99,35,99,117,114,114,101,110,116,45,103,99,45,109,105,108,108,105,115,101,99,111,110,100,115,41,0,0,0,0};
static C_char li1060[] C_aligned={C_lihdr(0,0,32),40,99,104,105,99,107,101,110,46,103,99,35,115,101,116,45,103,99,45,114,101,112,111,114,116,33,32,102,108,97,103,41};
static C_char li1061[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,103,99,35,109,101,109,111,114,121,45,115,116,97,116,105,115,116,105,99,115,41,0,0};
static C_char li1062[] C_aligned={C_lihdr(0,0,20),67,95,114,101,103,105,115,116,101,114,95,102,105,110,97,108,105,122,101,114,0,0,0,0};
static C_char li1063[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,105,110,105,116,45,102,105,110,97,108,105,122,101,114,32,120,32,121,41,0,0,0,0,0,0};
static C_char li1064[] C_aligned={C_lihdr(0,0,25),40,99,104,105,99,107,101,110,46,103,99,35,102,105,110,97,108,105,122,101,114,63,32,120,41,0,0,0,0,0,0,0};
static C_char li1065[] C_aligned={C_lihdr(0,0,11),40,104,97,110,100,108,101,114,32,111,41,0,0,0,0,0};
static C_char li1066[] C_aligned={C_lihdr(0,0,10),40,104,97,110,100,108,101,32,111,41,0,0,0,0,0,0};
static C_char li1067[] C_aligned={C_lihdr(0,0,15),40,97,51,54,48,53,51,32,46,32,114,101,115,116,41,0};
static C_char li1068[] C_aligned={C_lihdr(0,0,15),40,97,51,54,48,55,52,32,112,114,111,99,32,105,41,0};
static C_char li1069[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,56,50,48,50,32,103,56,50,48,57,41,0,0,0,0,0,0,0};
static C_char li1070[] C_aligned={C_lihdr(0,0,37),40,99,104,105,99,107,101,110,46,103,99,35,109,97,107,101,45,102,105,110,97,108,105,122,101,114,32,46,32,111,98,106,101,99,116,115,41,0,0,0};
static C_char li1071[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,56,50,52,52,32,103,56,50,53,49,41,0,0,0,0,0,0,0};
static C_char li1072[] C_aligned={C_lihdr(0,0,41),40,99,104,105,99,107,101,110,46,103,99,35,97,100,100,45,116,111,45,102,105,110,97,108,105,122,101,114,32,102,32,46,32,111,98,106,101,99,116,115,41,0,0,0,0,0,0,0};
static C_char li1073[] C_aligned={C_lihdr(0,0,8),40,97,51,54,50,51,56,41};
static C_char li1074[] C_aligned={C_lihdr(0,0,11),40,97,51,54,50,51,50,32,101,120,41,0,0,0,0,0};
static C_char li1075[] C_aligned={C_lihdr(0,0,8),40,97,51,54,50,53,48,41};
static C_char li1076[] C_aligned={C_lihdr(0,0,8),40,97,51,54,50,55,51,41};
static C_char li1077[] C_aligned={C_lihdr(0,0,15),40,97,51,54,50,54,55,32,46,32,97,114,103,115,41,0};
static C_char li1078[] C_aligned={C_lihdr(0,0,8),40,97,51,54,50,52,52,41};
static C_char li1079[] C_aligned={C_lihdr(0,0,10),40,97,51,54,50,50,54,32,107,41,0,0,0,0,0,0};
static C_char li1080[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,56,50,55,54,32,105,41,0,0};
static C_char li1081[] C_aligned={C_lihdr(0,0,36),40,35,35,115,121,115,35,114,117,110,45,112,101,110,100,105,110,103,45,102,105,110,97,108,105,122,101,114,115,32,115,116,97,116,101,41,0,0,0,0};
static C_char li1082[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li1083[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,102,111,114,99,101,45,102,105,110,97,108,105,122,101,114,115,41};
static C_char li1084[] C_aligned={C_lihdr(0,0,21),40,99,104,105,99,107,101,110,46,103,99,35,103,99,32,46,32,97,114,103,41,0,0,0};
static C_char li1085[] C_aligned={C_lihdr(0,0,41),40,35,35,115,121,115,35,109,97,107,101,45,108,111,99,97,116,105,118,101,32,111,98,106,32,105,110,100,101,120,32,119,101,97,107,63,32,108,111,99,41,0,0,0,0,0,0,0};
static C_char li1086[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,112,108,105,115,116,35,112,117,116,33,32,115,121,109,32,112,114,111,112,32,118,97,108,41,0,0,0,0,0,0,0};
static C_char li1087[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,112,108,105,115,116,35,103,101,116,32,115,121,109,32,112,114,111,112,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li1088[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,112,116,108,41,0,0,0,0,0,0};
static C_char li1089[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,112,108,105,115,116,35,114,101,109,112,114,111,112,33,32,115,121,109,32,112,114,111,112,41,0,0,0,0,0,0,0};
static C_char li1090[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,112,108,105,115,116,41,0,0,0,0};
static C_char li1091[] C_aligned={C_lihdr(0,0,40),40,99,104,105,99,107,101,110,46,112,108,105,115,116,35,103,101,116,45,112,114,111,112,101,114,116,105,101,115,32,115,121,109,32,112,114,111,112,115,41};
static C_char li1092[] C_aligned={C_lihdr(0,0,10),40,112,110,117,109,32,110,117,109,41,0,0,0,0,0,0};
static C_char li1093[] C_aligned={C_lihdr(0,0,14),40,114,111,117,110,100,45,116,111,32,120,32,121,41,0,0};
static C_char li1094[] C_aligned={C_lihdr(0,0,12),40,112,109,101,109,32,98,121,116,101,115,41,0,0,0,0};
static C_char li1095[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,100,105,115,112,108,97,121,45,116,105,109,101,115,32,105,110,102,111,41,0,0,0,0,0,0};
static C_char li1096[] C_aligned={C_lihdr(0,0,17),67,95,100,117,109,112,95,104,101,97,112,95,115,116,97,116,101,0,0,0,0,0,0,0};
static C_char li1097[] C_aligned={C_lihdr(0,0,21),67,95,102,105,108,116,101,114,95,104,101,97,112,95,111,98,106,101,99,116,115,0,0,0};
static C_char li1098[] C_aligned={C_lihdr(0,0,32),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,115,111,102,116,119,97,114,101,45,116,121,112,101,41};
static C_char li1099[] C_aligned={C_lihdr(0,0,31),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,109,97,99,104,105,110,101,45,116,121,112,101,41,0};
static C_char li1100[] C_aligned={C_lihdr(0,0,37),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,109,97,99,104,105,110,101,45,98,121,116,101,45,111,114,100,101,114,41,0,0,0};
static C_char li1101[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,115,111,102,116,119,97,114,101,45,118,101,114,115,105,111,110,41,0,0,0,0,0};
static C_char li1102[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,98,117,105,108,100,45,112,108,97,116,102,111,114,109,41,0,0,0,0,0,0,0};
static C_char li1103[] C_aligned={C_lihdr(0,0,7),40,115,116,114,32,120,41,0};
static C_char li1104[] C_aligned={C_lihdr(0,0,41),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,99,104,105,99,107,101,110,45,118,101,114,115,105,111,110,32,46,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li1105[] C_aligned={C_lihdr(0,0,31),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,99,104,105,99,107,101,110,45,104,111,109,101,41,0};
static C_char li1106[] C_aligned={C_lihdr(0,0,38),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,105,110,99,108,117,100,101,45,112,97,116,104,32,46,32,114,101,115,116,41,0,0};
static C_char li1107[] C_aligned={C_lihdr(0,0,16),40,108,111,111,112,32,115,116,97,114,116,32,112,111,115,41};
static C_char li1108[] C_aligned={C_lihdr(0,0,23),40,35,35,115,121,115,35,115,112,108,105,116,45,112,97,116,104,32,112,97,116,104,41,0};
static C_char li1109[] C_aligned={C_lihdr(0,0,37),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,99,104,111,112,45,115,101,112,97,114,97,116,111,114,32,115,116,114,41,0,0,0};
static C_char li1110[] C_aligned={C_lihdr(0,0,31),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,105,110,99,108,117,100,101,45,112,97,116,104,41,0};
static C_char li1111[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,45,62,102,101,97,116,117,114,101,45,105,100,32,120,41,0,0,0,0,0,0,0};
static C_char li1112[] C_aligned={C_lihdr(0,0,9),40,99,104,101,99,107,32,102,41,0,0,0,0,0,0,0};
static C_char li1113[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,56,55,53,48,32,103,56,55,53,55,41,0,0,0,0,0,0,0};
static C_char li1114[] C_aligned={C_lihdr(0,0,41),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,114,101,103,105,115,116,101,114,45,102,101,97,116,117,114,101,33,32,46,32,102,115,41,0,0,0,0,0,0,0};
static C_char li1115[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,102,102,115,41,0,0,0,0,0,0};
static C_char li1116[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,56,55,55,51,32,103,56,55,56,53,41,0,0,0,0};
static C_char li1117[] C_aligned={C_lihdr(0,0,43),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,117,110,114,101,103,105,115,116,101,114,45,102,101,97,116,117,114,101,33,32,46,32,102,115,41,0,0,0,0,0};
static C_char li1118[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,105,100,115,41,0,0,0,0,0,0};
static C_char li1119[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,102,101,97,116,117,114,101,63,32,46,32,105,100,115,41,0,0,0,0,0,0,0};
static C_char li1120[] C_aligned={C_lihdr(0,0,16),67,95,114,101,116,117,114,110,95,116,111,95,104,111,115,116};
static C_char li1121[] C_aligned={C_lihdr(0,0,42),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,115,121,115,116,101,109,45,99,111,110,102,105,103,45,100,105,114,101,99,116,111,114,121,41,0,0,0,0,0,0};
static C_char li1122[] C_aligned={C_lihdr(0,0,41),40,99,104,105,99,107,101,110,46,112,108,97,116,102,111,114,109,35,115,121,115,116,101,109,45,99,97,99,104,101,45,100,105,114,101,99,116,111,114,121,41,0,0,0,0,0,0,0};
static C_char li1123[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,56,56,54,53,32,103,56,56,55,55,41,0,0,0,0};
static C_char li1124[] C_aligned={C_lihdr(0,0,17),40,115,99,104,101,109,101,35,102,101,97,116,117,114,101,115,41,0,0,0,0,0,0,0};
static C_char li1125[] C_aligned={C_lihdr(0,0,21),40,100,111,108,111,111,112,56,57,48,49,32,105,32,114,101,115,117,108,116,41,0,0,0};
static C_char li1126[] C_aligned={C_lihdr(0,0,27),40,115,99,104,101,109,101,35,109,97,107,101,45,108,105,115,116,32,110,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li1127[] C_aligned={C_lihdr(0,0,16),40,100,111,108,111,111,112,56,57,49,49,32,105,32,108,41};
static C_char li1128[] C_aligned={C_lihdr(0,0,26),40,115,99,104,101,109,101,35,108,105,115,116,45,115,101,116,33,32,108,32,110,32,111,98,106,41,0,0,0,0,0,0};
static C_char li1129[] C_aligned={C_lihdr(0,0,12),40,108,112,32,114,101,115,32,108,115,116,41,0,0,0,0};
static C_char li1130[] C_aligned={C_lihdr(0,0,22),40,115,99,104,101,109,101,35,108,105,115,116,45,99,111,112,121,32,108,115,116,41,0,0};
static C_char li1131[] C_aligned={C_lihdr(0,0,15),40,100,111,108,111,111,112,56,57,53,48,32,102,105,41,0};
static C_char li1132[] C_aligned={C_lihdr(0,0,18),40,115,45,62,118,32,115,32,115,116,97,114,116,32,101,110,100,41,0,0,0,0,0,0};
static C_char li1133[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,62,118,101,99,116,111,114,32,115,32,46,32,114,101,115,116,41};
static C_char li1134[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,116,105,32,102,105,41,0,0,0,0};
static C_char li1135[] C_aligned={C_lihdr(0,0,18),40,118,45,62,115,32,118,32,115,116,97,114,116,32,101,110,100,41,0,0,0,0,0,0};
static C_char li1136[] C_aligned={C_lihdr(0,0,32),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,62,115,116,114,105,110,103,32,118,32,46,32,114,101,115,116,41};
static C_char li1137[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,105,32,106,41,0,0,0,0,0,0};
static C_char li1138[] C_aligned={C_lihdr(0,0,19),40,102,111,114,45,101,97,99,104,45,108,111,111,112,57,48,49,51,41,0,0,0,0,0};
static C_char li1139[] C_aligned={C_lihdr(0,0,17),40,102,111,108,100,108,57,48,52,51,32,103,57,48,52,50,41,0,0,0,0,0,0,0};
static C_char li1140[] C_aligned={C_lihdr(0,0,7),40,103,57,48,57,49,41,0};
static C_char li1141[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,57,48,56,53,32,103,57,48,57,55,41,0,0,0,0};
static C_char li1142[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,57,48,56,48,32,105,41,0,0};
static C_char li1143[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,57,48,53,48,32,103,57,48,54,50,41,0,0,0,0};
static C_char li1144[] C_aligned={C_lihdr(0,0,35),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,109,97,112,32,112,114,111,99,32,115,116,114,32,46,32,109,111,114,101,41,0,0,0,0,0};
static C_char li1145[] C_aligned={C_lihdr(0,0,6),40,108,112,32,105,41,0,0};
static C_char li1146[] C_aligned={C_lihdr(0,0,19),40,102,111,114,45,101,97,99,104,45,108,111,111,112,57,49,51,54,41,0,0,0,0,0};
static C_char li1147[] C_aligned={C_lihdr(0,0,17),40,102,111,108,100,108,57,49,54,54,32,103,57,49,54,53,41,0,0,0,0,0,0,0};
static C_char li1148[] C_aligned={C_lihdr(0,0,7),40,103,57,50,49,52,41,0};
static C_char li1149[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,57,50,48,56,32,103,57,50,50,48,41,0,0,0,0};
static C_char li1150[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,57,50,48,51,32,105,41,0,0};
static C_char li1151[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,57,49,55,51,32,103,57,49,56,53,41,0,0,0,0};
static C_char li1152[] C_aligned={C_lihdr(0,0,40),40,115,99,104,101,109,101,35,115,116,114,105,110,103,45,102,111,114,45,101,97,99,104,32,112,114,111,99,32,115,116,114,32,46,32,109,111,114,101,41};
static C_char li1153[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,57,50,53,52,32,105,41,0,0};
static C_char li1154[] C_aligned={C_lihdr(0,0,19),40,102,111,114,45,101,97,99,104,45,108,111,111,112,57,50,54,52,41,0,0,0,0,0};
static C_char li1155[] C_aligned={C_lihdr(0,0,17),40,102,111,108,100,108,57,50,57,52,32,103,57,50,57,51,41,0,0,0,0,0,0,0};
static C_char li1156[] C_aligned={C_lihdr(0,0,7),40,103,57,51,52,50,41,0};
static C_char li1157[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,57,51,51,54,32,103,57,51,52,56,41,0,0,0,0};
static C_char li1158[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,57,51,51,49,32,105,41,0,0};
static C_char li1159[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,57,51,48,49,32,103,57,51,49,51,41,0,0,0,0};
static C_char li1160[] C_aligned={C_lihdr(0,0,33),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,109,97,112,32,112,114,111,99,32,118,32,46,32,109,111,114,101,41,0,0,0,0,0,0,0};
static C_char li1161[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,57,51,56,48,32,105,41,0,0};
static C_char li1162[] C_aligned={C_lihdr(0,0,19),40,102,111,114,45,101,97,99,104,45,108,111,111,112,57,51,57,48,41,0,0,0,0,0};
static C_char li1163[] C_aligned={C_lihdr(0,0,17),40,102,111,108,100,108,57,52,50,48,32,103,57,52,49,57,41,0,0,0,0,0,0,0};
static C_char li1164[] C_aligned={C_lihdr(0,0,7),40,103,57,52,54,56,41,0};
static C_char li1165[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,57,52,54,50,32,103,57,52,55,52,41,0,0,0,0};
static C_char li1166[] C_aligned={C_lihdr(0,0,14),40,100,111,108,111,111,112,57,52,53,55,32,105,41,0,0};
static C_char li1167[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,57,52,50,55,32,103,57,52,51,57,41,0,0,0,0};
static C_char li1168[] C_aligned={C_lihdr(0,0,38),40,115,99,104,101,109,101,35,118,101,99,116,111,114,45,102,111,114,45,101,97,99,104,32,112,114,111,99,32,118,32,46,32,109,111,114,101,41,0,0};
static C_char li1169[] C_aligned={C_lihdr(0,0,24),40,115,99,104,101,109,101,35,99,108,111,115,101,45,112,111,114,116,32,112,111,114,116,41};
static C_char li1170[] C_aligned={C_lihdr(0,0,8),40,97,51,57,48,55,57,41};
static C_char li1171[] C_aligned={C_lihdr(0,0,14),40,97,51,57,48,56,53,32,46,32,114,101,116,41,0,0};
static C_char li1172[] C_aligned={C_lihdr(0,0,33),40,115,99,104,101,109,101,35,99,97,108,108,45,119,105,116,104,45,112,111,114,116,32,112,111,114,116,32,112,114,111,99,41,0,0,0,0,0,0,0};
static C_char li1173[] C_aligned={C_lihdr(0,0,19),40,115,99,104,101,109,101,35,101,111,102,45,111,98,106,101,99,116,41,0,0,0,0,0};
static C_char li1174[] C_aligned={C_lihdr(0,0,23),40,115,99,104,101,109,101,35,112,101,101,107,45,117,56,32,46,32,114,118,97,114,41,0};
static C_char li1175[] C_aligned={C_lihdr(0,0,30),40,115,99,104,101,109,101,35,119,114,105,116,101,45,115,116,114,105,110,103,32,115,32,46,32,114,101,115,116,41,0,0};
static C_char li1176[] C_aligned={C_lihdr(0,0,19),40,100,111,108,111,111,112,57,53,56,54,32,120,32,105,32,120,115,41,0,0,0,0,0};
static C_char li1177[] C_aligned={C_lihdr(0,0,29),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,108,105,115,116,32,46,32,114,101,115,116,41,0,0,0};
static C_char li1178[] C_aligned={C_lihdr(0,0,10),40,103,57,54,49,48,32,114,108,41,0,0,0,0,0,0};
static C_char li1179[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li1180[] C_aligned={C_lihdr(0,0,29),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,108,105,110,101,32,46,32,97,114,103,115,41,0,0,0};
static C_char li1181[] C_aligned={C_lihdr(0,0,12),40,108,111,111,112,32,108,110,115,32,110,41,0,0,0,0};
static C_char li1182[] C_aligned={C_lihdr(0,0,30),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,108,105,110,101,115,32,46,32,114,101,115,116,41,0,0};
static C_char li1183[] C_aligned={C_lihdr(0,0,34),40,99,104,105,99,107,101,110,46,105,111,35,119,114,105,116,101,45,108,105,110,101,32,115,116,114,32,46,32,112,111,114,116,41,0,0,0,0,0,0};
static C_char li1184[] C_aligned={C_lihdr(0,0,16),40,108,111,111,112,32,115,116,97,114,116,32,110,32,109,41};
static C_char li1185[] C_aligned={C_lihdr(0,0,52),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,98,121,116,101,118,101,99,116,111,114,33,47,112,111,114,116,32,110,32,100,101,115,116,32,112,111,114,116,32,115,116,97,114,116,41,0,0,0,0};
static C_char li1186[] C_aligned={C_lihdr(0,0,23),40,97,51,57,55,52,52,32,100,98,117,102,32,115,116,97,114,116,32,108,101,110,41,0};
static C_char li1187[] C_aligned={C_lihdr(0,0,20),40,114,101,97,100,98,32,110,32,98,117,102,32,112,111,114,116,32,112,41,0,0,0,0};
static C_char li1188[] C_aligned={C_lihdr(0,0,14),40,102,105,110,105,115,104,32,98,121,116,101,115,41,0,0};
static C_char li1189[] C_aligned={C_lihdr(0,0,15),40,114,101,99,111,117,110,116,32,98,121,116,101,115,41,0};
static C_char li1190[] C_aligned={C_lihdr(0,0,16),40,108,111,111,112,32,112,32,110,32,117,110,32,98,110,41};
static C_char li1191[] C_aligned={C_lihdr(0,0,20),40,97,51,57,55,50,54,32,100,101,99,111,100,101,114,32,95,32,95,41,0,0,0,0};
static C_char li1192[] C_aligned={C_lihdr(0,0,48),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,115,116,114,105,110,103,33,47,112,111,114,116,32,110,32,100,101,115,116,32,112,111,114,116,32,115,116,97,114,116,41};
static C_char li1193[] C_aligned={C_lihdr(0,0,39),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,115,116,114,105,110,103,33,32,110,32,100,101,115,116,32,46,32,114,101,115,116,41,0};
static C_char li1194[] C_aligned={C_lihdr(0,0,41),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,98,121,116,101,118,101,99,116,111,114,33,32,100,101,115,116,32,46,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li1195[] C_aligned={C_lihdr(0,0,16),40,97,52,48,48,54,56,32,98,117,102,32,108,101,110,41};
static C_char li1196[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,115,116,114,105,110,103,47,112,111,114,116,32,110,32,112,41,0,0,0,0,0,0,0};
static C_char li1197[] C_aligned={C_lihdr(0,0,20),40,108,111,111,112,32,98,117,102,32,98,115,105,122,101,32,112,111,115,41,0,0,0,0};
static C_char li1198[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,114,101,97,100,45,114,101,109,97,105,110,105,110,103,32,112,32,107,41,0,0,0,0,0,0};
static C_char li1199[] C_aligned={C_lihdr(0,0,37),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,98,121,116,101,118,101,99,116,111,114,47,112,111,114,116,32,110,32,112,41,0,0,0};
static C_char li1200[] C_aligned={C_lihdr(0,0,31),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,115,116,114,105,110,103,32,46,32,114,101,115,116,41,0};
static C_char li1201[] C_aligned={C_lihdr(0,0,16),40,97,52,48,50,52,48,32,98,117,102,32,108,101,110,41};
static C_char li1202[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,98,121,116,101,118,101,99,116,111,114,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li1203[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,98,117,102,102,101,114,101,100,32,46,32,114,101,115,116,41,0,0,0,0,0,0,0};
static C_char li1204[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li1205[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,116,111,107,101,110,32,112,114,101,100,32,46,32,112,111,114,116,41,0,0,0,0,0};
static C_char li1206[] C_aligned={C_lihdr(0,0,29),40,99,104,105,99,107,101,110,46,105,111,35,114,101,97,100,45,98,121,116,101,32,46,32,114,101,115,116,41,0,0,0};
static C_char li1207[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,105,111,35,119,114,105,116,101,45,98,121,116,101,32,98,121,116,101,32,46,32,114,101,115,116,41,0,0,0,0,0};
static C_char li1208[] C_aligned={C_lihdr(0,0,39),40,99,104,105,99,107,101,110,46,105,111,35,119,114,105,116,101,45,98,121,116,101,118,101,99,116,111,114,32,98,118,32,46,32,114,101,115,116,41,0};
static C_char li1209[] C_aligned={C_lihdr(0,0,20),40,109,97,112,45,108,111,111,112,56,54,57,48,32,103,56,55,48,50,41,0,0,0,0};
static C_char li1210[] C_aligned={C_lihdr(0,0,19),40,102,111,114,45,101,97,99,104,45,108,111,111,112,56,54,52,56,41,0,0,0,0,0};
static C_char li1211[] C_aligned={C_lihdr(0,0,12),40,97,52,48,54,56,49,32,110,101,119,41,0,0,0,0};
static C_char li1212[] C_aligned={C_lihdr(0,0,16),67,95,98,117,105,108,100,95,112,108,97,116,102,111,114,109};
static C_char li1213[] C_aligned={C_lihdr(0,0,18),67,95,115,111,102,116,119,97,114,101,95,118,101,114,115,105,111,110,0,0,0,0,0,0};
static C_char li1214[] C_aligned={C_lihdr(0,0,20),67,95,109,97,99,104,105,110,101,95,98,121,116,101,95,111,114,100,101,114,0,0,0,0};
static C_char li1215[] C_aligned={C_lihdr(0,0,14),67,95,109,97,99,104,105,110,101,95,116,121,112,101,0,0};
static C_char li1216[] C_aligned={C_lihdr(0,0,15),67,95,115,111,102,116,119,97,114,101,95,116,121,112,101,0};
static C_char li1217[] C_aligned={C_lihdr(0,0,12),40,97,52,48,55,56,48,32,115,121,109,41,0,0,0,0};
static C_char li1218[] C_aligned={C_lihdr(0,0,16),40,97,52,48,55,56,57,32,115,121,109,32,108,115,116,41};
static C_char li1219[] C_aligned={C_lihdr(0,0,10),40,97,52,48,56,50,57,32,120,41,0,0,0,0,0,0};
static C_char li1220[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,97,114,103,115,41,0,0,0,0,0};
static C_char li1221[] C_aligned={C_lihdr(0,0,19),40,102,52,57,48,51,57,32,120,56,49,51,54,52,57,48,51,56,41,0,0,0,0,0};
static C_char li1222[] C_aligned={C_lihdr(0,0,19),40,102,52,57,48,52,53,32,120,56,49,50,50,52,57,48,52,52,41,0,0,0,0,0};
static C_char li1223[] C_aligned={C_lihdr(0,0,19),40,102,52,57,48,53,49,32,120,56,49,50,50,52,57,48,53,48,41,0,0,0,0,0};
static C_char li1224[] C_aligned={C_lihdr(0,0,8),40,97,52,48,57,49,48,41};
static C_char li1225[] C_aligned={C_lihdr(0,0,12),40,97,52,48,57,51,53,32,100,105,114,41,0,0,0,0};
static C_char li1226[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,55,48,55,56,32,103,55,48,56,53,41,0,0,0,0,0,0,0};
static C_char li1227[] C_aligned={C_lihdr(0,0,8),40,97,52,48,57,55,55,41};
static C_char li1228[] C_aligned={C_lihdr(0,0,9),40,103,55,49,48,52,32,120,41,0,0,0,0,0,0,0};
static C_char li1229[] C_aligned={C_lihdr(0,0,25),40,102,111,114,45,101,97,99,104,45,108,111,111,112,55,49,48,51,32,103,55,49,49,48,41,0,0,0,0,0,0,0};
static C_char li1230[] C_aligned={C_lihdr(0,0,15),40,97,52,49,48,56,57,32,46,32,97,114,103,115,41,0};
static C_char li1231[] C_aligned={C_lihdr(0,0,19),40,97,52,48,57,53,48,32,109,115,103,32,46,32,97,114,103,115,41,0,0,0,0,0};
static C_char li1232[] C_aligned={C_lihdr(0,0,8),40,97,52,49,48,57,50,41};
static C_char li1233[] C_aligned={C_lihdr(0,0,8),40,97,52,49,49,48,49,41};
static C_char li1234[] C_aligned={C_lihdr(0,0,15),40,97,52,49,49,48,55,32,46,32,114,101,115,116,41,0};
static C_char li1235[] C_aligned={C_lihdr(0,0,10),40,97,52,49,51,54,54,32,120,41,0,0,0,0,0,0};
static C_char li1236[] C_aligned={C_lihdr(0,0,14),40,97,52,49,51,55,53,32,120,32,105,32,121,41,0,0};
static C_char li1237[] C_aligned={C_lihdr(0,0,12),40,97,52,49,51,56,53,32,120,32,121,41,0,0,0,0};
static C_char li1238[] C_aligned={C_lihdr(0,0,12),40,97,52,49,51,57,53,32,120,32,121,41,0,0,0,0};
static C_char li1239[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,48,53,32,120,32,121,41,0,0,0,0};
static C_char li1240[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,49,53,32,120,32,121,41,0,0,0,0};
static C_char li1241[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,50,53,32,120,32,121,41,0,0,0,0};
static C_char li1242[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,51,53,32,120,32,121,41,0,0,0,0};
static C_char li1243[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,52,53,32,120,32,121,41,0,0,0,0};
static C_char li1244[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,53,53,32,120,32,121,41,0,0,0,0};
static C_char li1245[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,54,53,32,120,32,121,41,0,0,0,0};
static C_char li1246[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,55,53,32,120,32,121,41,0,0,0,0};
static C_char li1247[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,56,53,32,120,32,121,41,0,0,0,0};
static C_char li1248[] C_aligned={C_lihdr(0,0,12),40,97,52,49,52,57,53,32,120,32,121,41,0,0,0,0};
static C_char li1249[] C_aligned={C_lihdr(0,0,10),40,97,52,49,53,50,57,32,120,41,0,0,0,0,0,0};
static C_char li1250[] C_aligned={C_lihdr(0,0,13),40,97,52,49,53,48,53,32,112,114,111,99,41,0,0,0};
static C_char li1251[] C_aligned={C_lihdr(0,0,10),40,97,52,49,53,52,53,32,120,41,0,0,0,0,0,0};
static C_char li1252[] C_aligned={C_lihdr(0,0,10),40,97,52,49,54,48,48,32,120,41,0,0,0,0,0,0};
static C_char li1253[] C_aligned={C_lihdr(0,0,15),40,97,52,49,54,49,54,32,112,114,111,99,32,105,41,0};
static C_char li1254[] C_aligned={C_lihdr(0,0,16),40,97,52,49,53,55,49,32,103,101,116,32,115,101,116,41};
static C_char li1255[] C_aligned={C_lihdr(0,0,15),40,97,52,49,53,54,49,32,112,114,111,99,32,105,41,0};
static C_char li1256[] C_aligned={C_lihdr(0,0,10),40,116,111,112,108,101,118,101,108,41,0,0,0,0,0,0};


#define return(x) C_cblock C_r = (C_mpointer(&C_a,(void*)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub8111(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_word i=(C_word )(C_a0);
C_return(C_main_argv[C_unfix(i)]);
C_ret:
#undef return

return C_r;}

/* from chicken.process-context#executable-pathname in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
C_regparm static C_word stub8103(C_word C_buf){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_r=C_mpointer(&C_a,(void*)C_executable_pathname());
return C_r;}

/* from k35739 */
C_regparm static C_word stub8079(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_r=C_mpointer(&C_a,(void*)C_getenventry(t0));
return C_r;}

/* from chicken.process-context#_getenv */
C_regparm static C_word stub8071(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_word t0=(C_word )(C_a0);
C_r=C_mpointer(&C_a,(void*)C_getenv(t0));
return C_r;}

/* from k34725 */
C_regparm static C_word stub7746(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
void * t0=(void * )C_c_pointer_or_null(C_a0);
C_free(t0);
return C_r;}

/* from k34716 */
C_regparm static C_word stub7738(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
void * t0=(void * )C_c_pointer_or_null(C_a0);
int t1=(int )C_unfix(C_a1);
C_r=C_mpointer(&C_a,(void*)C_peek_c_string_at(t0,t1));
return C_r;}

/* from k34664 */
C_regparm static C_word stub7719(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
void * t0=(void * )C_c_pointer_or_null(C_a0);
int t1=(int )C_unfix(C_a1);
C_r=C_mpointer(&C_a,(void*)C_peek_c_string_at(t0,t1));
return C_r;}

#define return(x) C_cblock C_r = (C_mpointer(&C_a,(void*)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub6825(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_word x=(C_word )(C_a0);
C_return((C_char *)x);
C_ret:
#undef return

return C_r;}

/* from k20283 */
C_regparm static C_word stub3497(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
double t0=(double )C_c_double(C_a0);
int t1=(int )C_unfix(C_a1);
C_r=C_flonum(&C_a,ldexp(t0,t1));
return C_r;}

C_noret_decl(f45112)
static void C_ccall f45112(C_word c,C_word *av) C_noret;
C_noret_decl(f45311)
static void C_ccall f45311(C_word c,C_word *av) C_noret;
C_noret_decl(f45315)
static void C_ccall f45315(C_word c,C_word *av) C_noret;
C_noret_decl(f45445)
static void C_ccall f45445(C_word c,C_word *av) C_noret;
C_noret_decl(f45450)
static void C_ccall f45450(C_word c,C_word *av) C_noret;
C_noret_decl(f45457)
static void C_ccall f45457(C_word c,C_word *av) C_noret;
C_noret_decl(f45466)
static void C_ccall f45466(C_word c,C_word *av) C_noret;
C_noret_decl(f45475)
static void C_ccall f45475(C_word c,C_word *av) C_noret;
C_noret_decl(f49039)
static void C_ccall f49039(C_word c,C_word *av) C_noret;
C_noret_decl(f49045)
static void C_ccall f49045(C_word c,C_word *av) C_noret;
C_noret_decl(f49051)
static void C_ccall f49051(C_word c,C_word *av) C_noret;
C_noret_decl(f_11438)
static void C_ccall f_11438(C_word c,C_word *av) C_noret;
C_noret_decl(f_11440)
static void C_ccall f_11440(C_word c,C_word *av) C_noret;
C_noret_decl(f_11443)
static void C_ccall f_11443(C_word c,C_word *av) C_noret;
C_noret_decl(f_11446)
static void C_ccall f_11446(C_word c,C_word *av) C_noret;
C_noret_decl(f_11449)
static void C_ccall f_11449(C_word c,C_word *av) C_noret;
C_noret_decl(f_11452)
static void C_ccall f_11452(C_word c,C_word *av) C_noret;
C_noret_decl(f_11455)
static void C_ccall f_11455(C_word c,C_word *av) C_noret;
C_noret_decl(f_11471)
static C_word f_11471(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_11500)
static void C_ccall f_11500(C_word c,C_word *av) C_noret;
C_noret_decl(f_11516)
static C_word f_11516(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_11545)
static void C_ccall f_11545(C_word c,C_word *av) C_noret;
C_noret_decl(f_11548)
static void C_ccall f_11548(C_word c,C_word *av) C_noret;
C_noret_decl(f_11551)
static void C_ccall f_11551(C_word c,C_word *av) C_noret;
C_noret_decl(f_11554)
static void C_ccall f_11554(C_word c,C_word *av) C_noret;
C_noret_decl(f_11557)
static void C_ccall f_11557(C_word c,C_word *av) C_noret;
C_noret_decl(f_11560)
static void C_ccall f_11560(C_word c,C_word *av) C_noret;
C_noret_decl(f_11563)
static void C_ccall f_11563(C_word c,C_word *av) C_noret;
C_noret_decl(f_11566)
static void C_ccall f_11566(C_word c,C_word *av) C_noret;
C_noret_decl(f_11569)
static void C_ccall f_11569(C_word c,C_word *av) C_noret;
C_noret_decl(f_11572)
static void C_ccall f_11572(C_word c,C_word *av) C_noret;
C_noret_decl(f_11575)
static void C_ccall f_11575(C_word c,C_word *av) C_noret;
C_noret_decl(f_11578)
static void C_ccall f_11578(C_word c,C_word *av) C_noret;
C_noret_decl(f_11581)
static void C_ccall f_11581(C_word c,C_word *av) C_noret;
C_noret_decl(f_11584)
static void C_ccall f_11584(C_word c,C_word *av) C_noret;
C_noret_decl(f_11598)
static void C_ccall f_11598(C_word c,C_word *av) C_noret;
C_noret_decl(f_11605)
static void C_ccall f_11605(C_word c,C_word *av) C_noret;
C_noret_decl(f_11612)
static void C_ccall f_11612(C_word c,C_word *av) C_noret;
C_noret_decl(f_11626)
static void C_ccall f_11626(C_word c,C_word *av) C_noret;
C_noret_decl(f_11633)
static void C_ccall f_11633(C_word c,C_word *av) C_noret;
C_noret_decl(f_11647)
static void C_ccall f_11647(C_word c,C_word *av) C_noret;
C_noret_decl(f_11661)
static void C_ccall f_11661(C_word c,C_word *av) C_noret;
C_noret_decl(f_11679)
static void C_ccall f_11679(C_word c,C_word *av) C_noret;
C_noret_decl(f_11690)
static void C_ccall f_11690(C_word c,C_word *av) C_noret;
C_noret_decl(f_11701)
static void C_ccall f_11701(C_word c,C_word *av) C_noret;
C_noret_decl(f_11708)
static void C_ccall f_11708(C_word c,C_word *av) C_noret;
C_noret_decl(f_11719)
static void C_ccall f_11719(C_word c,C_word *av) C_noret;
C_noret_decl(f_11723)
static void C_ccall f_11723(C_word c,C_word *av) C_noret;
C_noret_decl(f_11730)
static void C_ccall f_11730(C_word c,C_word *av) C_noret;
C_noret_decl(f_11748)
static void C_ccall f_11748(C_word c,C_word *av) C_noret;
C_noret_decl(f_11759)
static void C_ccall f_11759(C_word c,C_word *av) C_noret;
C_noret_decl(f_11770)
static void C_ccall f_11770(C_word c,C_word *av) C_noret;
C_noret_decl(f_11777)
static void C_ccall f_11777(C_word c,C_word *av) C_noret;
C_noret_decl(f_11795)
static void C_ccall f_11795(C_word c,C_word *av) C_noret;
C_noret_decl(f_11806)
static void C_ccall f_11806(C_word c,C_word *av) C_noret;
C_noret_decl(f_11824)
static void C_ccall f_11824(C_word c,C_word *av) C_noret;
C_noret_decl(f_11830)
static void C_ccall f_11830(C_word c,C_word *av) C_noret;
C_noret_decl(f_11833)
static void C_ccall f_11833(C_word c,C_word *av) C_noret;
C_noret_decl(f_11836)
static void C_ccall f_11836(C_word c,C_word *av) C_noret;
C_noret_decl(f_11839)
static void C_ccall f_11839(C_word c,C_word *av) C_noret;
C_noret_decl(f_11842)
static void C_ccall f_11842(C_word c,C_word *av) C_noret;
C_noret_decl(f_11848)
static void f_11848(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_11881)
static void C_ccall f_11881(C_word c,C_word *av) C_noret;
C_noret_decl(f_11884)
static void C_ccall f_11884(C_word c,C_word *av) C_noret;
C_noret_decl(f_11887)
static void C_ccall f_11887(C_word c,C_word *av) C_noret;
C_noret_decl(f_11899)
static void f_11899(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_11912)
static void C_ccall f_11912(C_word c,C_word *av) C_noret;
C_noret_decl(f_11931)
static void C_ccall f_11931(C_word c,C_word *av) C_noret;
C_noret_decl(f_11934)
static void C_ccall f_11934(C_word c,C_word *av) C_noret;
C_noret_decl(f_11937)
static void C_ccall f_11937(C_word c,C_word *av) C_noret;
C_noret_decl(f_11949)
static void f_11949(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_11962)
static void C_ccall f_11962(C_word c,C_word *av) C_noret;
C_noret_decl(f_11986)
static void C_ccall f_11986(C_word c,C_word *av) C_noret;
C_noret_decl(f_11989)
static void C_ccall f_11989(C_word c,C_word *av) C_noret;
C_noret_decl(f_11992)
static void C_ccall f_11992(C_word c,C_word *av) C_noret;
C_noret_decl(f_11995)
static void C_ccall f_11995(C_word c,C_word *av) C_noret;
C_noret_decl(f_11998)
static void C_ccall f_11998(C_word c,C_word *av) C_noret;
C_noret_decl(f_12001)
static void C_ccall f_12001(C_word c,C_word *av) C_noret;
C_noret_decl(f_12008)
static C_word f_12008(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_12034)
static void C_ccall f_12034(C_word c,C_word *av) C_noret;
C_noret_decl(f_12041)
static C_word f_12041(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_12085)
static void C_ccall f_12085(C_word c,C_word *av) C_noret;
C_noret_decl(f_12088)
static void C_ccall f_12088(C_word c,C_word *av) C_noret;
C_noret_decl(f_12094)
static void C_ccall f_12094(C_word c,C_word *av) C_noret;
C_noret_decl(f_12097)
static void C_ccall f_12097(C_word c,C_word *av) C_noret;
C_noret_decl(f_12100)
static void C_ccall f_12100(C_word c,C_word *av) C_noret;
C_noret_decl(f_12103)
static void C_ccall f_12103(C_word c,C_word *av) C_noret;
C_noret_decl(f_12106)
static void C_ccall f_12106(C_word c,C_word *av) C_noret;
C_noret_decl(f_12114)
static void C_ccall f_12114(C_word c,C_word *av) C_noret;
C_noret_decl(f_12118)
static void C_ccall f_12118(C_word c,C_word *av) C_noret;
C_noret_decl(f_12121)
static void C_ccall f_12121(C_word c,C_word *av) C_noret;
C_noret_decl(f_12124)
static void C_ccall f_12124(C_word c,C_word *av) C_noret;
C_noret_decl(f_12127)
static void C_ccall f_12127(C_word c,C_word *av) C_noret;
C_noret_decl(f_12130)
static void C_ccall f_12130(C_word c,C_word *av) C_noret;
C_noret_decl(f_12133)
static void C_ccall f_12133(C_word c,C_word *av) C_noret;
C_noret_decl(f_12136)
static void C_ccall f_12136(C_word c,C_word *av) C_noret;
C_noret_decl(f_12139)
static void C_ccall f_12139(C_word c,C_word *av) C_noret;
C_noret_decl(f_12143)
static void C_ccall f_12143(C_word c,C_word *av) C_noret;
C_noret_decl(f_12146)
static void C_ccall f_12146(C_word c,C_word *av) C_noret;
C_noret_decl(f_12149)
static void C_ccall f_12149(C_word c,C_word *av) C_noret;
C_noret_decl(f_12152)
static void C_ccall f_12152(C_word c,C_word *av) C_noret;
C_noret_decl(f_12155)
static void C_ccall f_12155(C_word c,C_word *av) C_noret;
C_noret_decl(f_12163)
static void C_ccall f_12163(C_word c,C_word *av) C_noret;
C_noret_decl(f_12166)
static void C_ccall f_12166(C_word c,C_word *av) C_noret;
C_noret_decl(f_12173)
static void C_ccall f_12173(C_word c,C_word *av) C_noret;
C_noret_decl(f_12180)
static void C_ccall f_12180(C_word c,C_word *av) C_noret;
C_noret_decl(f_12193)
static C_word f_12193(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_12219)
static void C_ccall f_12219(C_word c,C_word *av) C_noret;
C_noret_decl(f_12232)
static C_word f_12232(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_12258)
static void C_ccall f_12258(C_word c,C_word *av) C_noret;
C_noret_decl(f_12271)
static C_word f_12271(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_12297)
static void C_ccall f_12297(C_word c,C_word *av) C_noret;
C_noret_decl(f_12310)
static C_word f_12310(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_12336)
static void C_ccall f_12336(C_word c,C_word *av) C_noret;
C_noret_decl(f_12349)
static C_word f_12349(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_12375)
static void C_ccall f_12375(C_word c,C_word *av) C_noret;
C_noret_decl(f_12381)
static void C_ccall f_12381(C_word c,C_word *av) C_noret;
C_noret_decl(f_12392)
static void C_ccall f_12392(C_word c,C_word *av) C_noret;
C_noret_decl(f_12398)
static void C_ccall f_12398(C_word c,C_word *av) C_noret;
C_noret_decl(f_12404)
static void C_ccall f_12404(C_word c,C_word *av) C_noret;
C_noret_decl(f_12410)
static void C_ccall f_12410(C_word c,C_word *av) C_noret;
C_noret_decl(f_12416)
static void C_ccall f_12416(C_word c,C_word *av) C_noret;
C_noret_decl(f_12422)
static void C_ccall f_12422(C_word c,C_word *av) C_noret;
C_noret_decl(f_12438)
static void C_ccall f_12438(C_word c,C_word *av) C_noret;
C_noret_decl(f_12446)
static void C_ccall f_12446(C_word c,C_word *av) C_noret;
C_noret_decl(f_12452)
static void C_ccall f_12452(C_word c,C_word *av) C_noret;
C_noret_decl(f_12458)
static void C_ccall f_12458(C_word c,C_word *av) C_noret;
C_noret_decl(f_12465)
static void C_ccall f_12465(C_word c,C_word *av) C_noret;
C_noret_decl(f_12474)
static void C_ccall f_12474(C_word c,C_word *av) C_noret;
C_noret_decl(f_12481)
static void C_ccall f_12481(C_word c,C_word *av) C_noret;
C_noret_decl(f_12490)
static void C_ccall f_12490(C_word c,C_word *av) C_noret;
C_noret_decl(f_12496)
static void C_ccall f_12496(C_word c,C_word *av) C_noret;
C_noret_decl(f_12501)
static void C_ccall f_12501(C_word c,C_word *av) C_noret;
C_noret_decl(f_12516)
static void C_ccall f_12516(C_word c,C_word *av) C_noret;
C_noret_decl(f_12527)
static void C_ccall f_12527(C_word c,C_word *av) C_noret;
C_noret_decl(f_12533)
static void C_ccall f_12533(C_word c,C_word *av) C_noret;
C_noret_decl(f_12539)
static void C_ccall f_12539(C_word c,C_word *av) C_noret;
C_noret_decl(f_12545)
static void C_ccall f_12545(C_word c,C_word *av) C_noret;
C_noret_decl(f_12551)
static void C_ccall f_12551(C_word c,C_word *av) C_noret;
C_noret_decl(f_12561)
static void C_ccall f_12561(C_word c,C_word *av) C_noret;
C_noret_decl(f_12563)
static void C_ccall f_12563(C_word c,C_word *av) C_noret;
C_noret_decl(f_12566)
static void C_ccall f_12566(C_word c,C_word *av) C_noret;
C_noret_decl(f_12569)
static void C_ccall f_12569(C_word c,C_word *av) C_noret;
C_noret_decl(f_12572)
static void C_ccall f_12572(C_word c,C_word *av) C_noret;
C_noret_decl(f_12575)
static void C_ccall f_12575(C_word c,C_word *av) C_noret;
C_noret_decl(f_12578)
static void C_ccall f_12578(C_word c,C_word *av) C_noret;
C_noret_decl(f_12583)
static void C_ccall f_12583(C_word c,C_word *av) C_noret;
C_noret_decl(f_12589)
static void C_ccall f_12589(C_word c,C_word *av) C_noret;
C_noret_decl(f_12595)
static void C_ccall f_12595(C_word c,C_word *av) C_noret;
C_noret_decl(f_12630)
static void C_ccall f_12630(C_word c,C_word *av) C_noret;
C_noret_decl(f_12633)
static void C_ccall f_12633(C_word c,C_word *av) C_noret;
C_noret_decl(f_12636)
static void C_ccall f_12636(C_word c,C_word *av) C_noret;
C_noret_decl(f_12644)
static void C_ccall f_12644(C_word c,C_word *av) C_noret;
C_noret_decl(f_12650)
static void C_ccall f_12650(C_word c,C_word *av) C_noret;
C_noret_decl(f_12657)
static void C_ccall f_12657(C_word c,C_word *av) C_noret;
C_noret_decl(f_12672)
static void C_ccall f_12672(C_word c,C_word *av) C_noret;
C_noret_decl(f_12686)
static void C_ccall f_12686(C_word c,C_word *av) C_noret;
C_noret_decl(f_12692)
static void C_ccall f_12692(C_word c,C_word *av) C_noret;
C_noret_decl(f_12698)
static void C_ccall f_12698(C_word c,C_word *av) C_noret;
C_noret_decl(f_12705)
static void C_ccall f_12705(C_word c,C_word *av) C_noret;
C_noret_decl(f_12710)
static void C_ccall f_12710(C_word c,C_word *av) C_noret;
C_noret_decl(f_12713)
static void C_ccall f_12713(C_word c,C_word *av) C_noret;
C_noret_decl(f_12722)
static void f_12722(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_12740)
static void C_ccall f_12740(C_word c,C_word *av) C_noret;
C_noret_decl(f_12750)
static void C_ccall f_12750(C_word c,C_word *av) C_noret;
C_noret_decl(f_12759)
static void f_12759(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_12777)
static void C_ccall f_12777(C_word c,C_word *av) C_noret;
C_noret_decl(f_12790)
static void C_ccall f_12790(C_word c,C_word *av) C_noret;
C_noret_decl(f_12797)
static void C_ccall f_12797(C_word c,C_word *av) C_noret;
C_noret_decl(f_12804)
static void C_ccall f_12804(C_word c,C_word *av) C_noret;
C_noret_decl(f_12815)
static void C_ccall f_12815(C_word c,C_word *av) C_noret;
C_noret_decl(f_12834)
static void C_ccall f_12834(C_word c,C_word *av) C_noret;
C_noret_decl(f_12837)
static void C_ccall f_12837(C_word c,C_word *av) C_noret;
C_noret_decl(f_12839)
static void C_ccall f_12839(C_word c,C_word *av) C_noret;
C_noret_decl(f_12845)
static void f_12845(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_12861)
static void C_ccall f_12861(C_word c,C_word *av) C_noret;
C_noret_decl(f_12870)
static void C_ccall f_12870(C_word c,C_word *av) C_noret;
C_noret_decl(f_12872)
static void C_ccall f_12872(C_word c,C_word *av) C_noret;
C_noret_decl(f_12878)
static void f_12878(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_12891)
static void C_ccall f_12891(C_word c,C_word *av) C_noret;
C_noret_decl(f_12907)
static void C_ccall f_12907(C_word c,C_word *av) C_noret;
C_noret_decl(f_12918)
static void C_ccall f_12918(C_word c,C_word *av) C_noret;
C_noret_decl(f_12920)
static void C_ccall f_12920(C_word c,C_word *av) C_noret;
C_noret_decl(f_12928)
static void C_ccall f_12928(C_word c,C_word *av) C_noret;
C_noret_decl(f_12930)
static void C_ccall f_12930(C_word c,C_word *av) C_noret;
C_noret_decl(f_12936)
static void C_ccall f_12936(C_word c,C_word *av) C_noret;
C_noret_decl(f_12938)
static void C_ccall f_12938(C_word c,C_word *av) C_noret;
C_noret_decl(f_12946)
static void C_ccall f_12946(C_word c,C_word *av) C_noret;
C_noret_decl(f_12948)
static void C_ccall f_12948(C_word c,C_word *av) C_noret;
C_noret_decl(f_12951)
static void C_ccall f_12951(C_word c,C_word *av) C_noret;
C_noret_decl(f_12959)
static void C_ccall f_12959(C_word c,C_word *av) C_noret;
C_noret_decl(f_12965)
static void C_ccall f_12965(C_word c,C_word *av) C_noret;
C_noret_decl(f_12973)
static void C_ccall f_12973(C_word c,C_word *av) C_noret;
C_noret_decl(f_12984)
static void C_ccall f_12984(C_word c,C_word *av) C_noret;
C_noret_decl(f_12996)
static void f_12996(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13010)
static void C_ccall f_13010(C_word c,C_word *av) C_noret;
C_noret_decl(f_13018)
static void C_ccall f_13018(C_word c,C_word *av) C_noret;
C_noret_decl(f_13021)
static void C_ccall f_13021(C_word c,C_word *av) C_noret;
C_noret_decl(f_13023)
static void C_ccall f_13023(C_word c,C_word *av) C_noret;
C_noret_decl(f_13025)
static void C_ccall f_13025(C_word c,C_word *av) C_noret;
C_noret_decl(f_13031)
static void f_13031(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13050)
static void C_ccall f_13050(C_word c,C_word *av) C_noret;
C_noret_decl(f_13067)
static void C_ccall f_13067(C_word c,C_word *av) C_noret;
C_noret_decl(f_13075)
static void C_ccall f_13075(C_word c,C_word *av) C_noret;
C_noret_decl(f_13089)
static void C_ccall f_13089(C_word c,C_word *av) C_noret;
C_noret_decl(f_13095)
static void f_13095(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13114)
static void C_ccall f_13114(C_word c,C_word *av) C_noret;
C_noret_decl(f_13123)
static void C_ccall f_13123(C_word c,C_word *av) C_noret;
C_noret_decl(f_13126)
static void C_ccall f_13126(C_word c,C_word *av) C_noret;
C_noret_decl(f_13129)
static void C_ccall f_13129(C_word c,C_word *av) C_noret;
C_noret_decl(f_13132)
static void C_ccall f_13132(C_word c,C_word *av) C_noret;
C_noret_decl(f_13135)
static void C_ccall f_13135(C_word c,C_word *av) C_noret;
C_noret_decl(f_13144)
static C_word f_13144(C_word t0,C_word t1);
C_noret_decl(f_13163)
static void C_ccall f_13163(C_word c,C_word *av) C_noret;
C_noret_decl(f_13169)
static void f_13169(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13194)
static void C_ccall f_13194(C_word c,C_word *av) C_noret;
C_noret_decl(f_13196)
static void C_ccall f_13196(C_word c,C_word *av) C_noret;
C_noret_decl(f_13205)
static void f_13205(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13226)
static void C_ccall f_13226(C_word c,C_word *av) C_noret;
C_noret_decl(f_13228)
static void C_ccall f_13228(C_word c,C_word *av) C_noret;
C_noret_decl(f_13234)
static void f_13234(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_13260)
static void C_ccall f_13260(C_word c,C_word *av) C_noret;
C_noret_decl(f_13267)
static void C_ccall f_13267(C_word c,C_word *av) C_noret;
C_noret_decl(f_13269)
static void C_ccall f_13269(C_word c,C_word *av) C_noret;
C_noret_decl(f_13281)
static void f_13281(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13316)
static void C_ccall f_13316(C_word c,C_word *av) C_noret;
C_noret_decl(f_13326)
static void C_ccall f_13326(C_word c,C_word *av) C_noret;
C_noret_decl(f_13335)
static void f_13335(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_13377)
static void C_ccall f_13377(C_word c,C_word *av) C_noret;
C_noret_decl(f_13406)
static void C_ccall f_13406(C_word c,C_word *av) C_noret;
C_noret_decl(f_13412)
static void C_ccall f_13412(C_word c,C_word *av) C_noret;
C_noret_decl(f_13426)
static void C_ccall f_13426(C_word c,C_word *av) C_noret;
C_noret_decl(f_13432)
static void C_ccall f_13432(C_word c,C_word *av) C_noret;
C_noret_decl(f_13439)
static void f_13439(C_word t0,C_word t1) C_noret;
C_noret_decl(f_13442)
static void C_ccall f_13442(C_word c,C_word *av) C_noret;
C_noret_decl(f_13471)
static void C_ccall f_13471(C_word c,C_word *av) C_noret;
C_noret_decl(f_13477)
static void f_13477(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13493)
static void C_ccall f_13493(C_word c,C_word *av) C_noret;
C_noret_decl(f_13518)
static void C_ccall f_13518(C_word c,C_word *av) C_noret;
C_noret_decl(f_13527)
static void f_13527(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13568)
static void C_ccall f_13568(C_word c,C_word *av) C_noret;
C_noret_decl(f_13590)
static void C_ccall f_13590(C_word c,C_word *av) C_noret;
C_noret_decl(f_13622)
static void C_ccall f_13622(C_word c,C_word *av) C_noret;
C_noret_decl(f_13638)
static void f_13638(C_word t0,C_word t1) C_noret;
C_noret_decl(f_13641)
static void C_ccall f_13641(C_word c,C_word *av) C_noret;
C_noret_decl(f_13663)
static void C_ccall f_13663(C_word c,C_word *av) C_noret;
C_noret_decl(f_13669)
static void f_13669(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13694)
static void C_ccall f_13694(C_word c,C_word *av) C_noret;
C_noret_decl(f_13734)
static void C_ccall f_13734(C_word c,C_word *av) C_noret;
C_noret_decl(f_13746)
static void f_13746(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_13765)
static void C_ccall f_13765(C_word c,C_word *av) C_noret;
C_noret_decl(f_13782)
static void C_ccall f_13782(C_word c,C_word *av) C_noret;
C_noret_decl(f_13789)
static void C_ccall f_13789(C_word c,C_word *av) C_noret;
C_noret_decl(f_13799)
static void C_ccall f_13799(C_word c,C_word *av) C_noret;
C_noret_decl(f_13810)
static void C_ccall f_13810(C_word c,C_word *av) C_noret;
C_noret_decl(f_13814)
static void C_ccall f_13814(C_word c,C_word *av) C_noret;
C_noret_decl(f_13827)
static void C_ccall f_13827(C_word c,C_word *av) C_noret;
C_noret_decl(f_13829)
static void C_ccall f_13829(C_word c,C_word *av) C_noret;
C_noret_decl(f_13863)
static void C_ccall f_13863(C_word c,C_word *av) C_noret;
C_noret_decl(f_13867)
static void C_ccall f_13867(C_word c,C_word *av) C_noret;
C_noret_decl(f_13885)
static void C_ccall f_13885(C_word c,C_word *av) C_noret;
C_noret_decl(f_13898)
static void C_ccall f_13898(C_word c,C_word *av) C_noret;
C_noret_decl(f_13910)
static void C_ccall f_13910(C_word c,C_word *av) C_noret;
C_noret_decl(f_13916)
static void C_ccall f_13916(C_word c,C_word *av) C_noret;
C_noret_decl(f_13926)
static void C_ccall f_13926(C_word c,C_word *av) C_noret;
C_noret_decl(f_13930)
static void C_ccall f_13930(C_word c,C_word *av) C_noret;
C_noret_decl(f_13934)
static void C_ccall f_13934(C_word c,C_word *av) C_noret;
C_noret_decl(f_13938)
static void C_ccall f_13938(C_word c,C_word *av) C_noret;
C_noret_decl(f_13941)
static void C_ccall f_13941(C_word c,C_word *av) C_noret;
C_noret_decl(f_13943)
static void f_13943(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_13947)
static void f_13947(C_word t0,C_word t1) C_noret;
C_noret_decl(f_13951)
static void C_ccall f_13951(C_word c,C_word *av) C_noret;
C_noret_decl(f_13955)
static void C_ccall f_13955(C_word c,C_word *av) C_noret;
C_noret_decl(f_13959)
static void C_ccall f_13959(C_word c,C_word *av) C_noret;
C_noret_decl(f_13974)
static void C_ccall f_13974(C_word c,C_word *av) C_noret;
C_noret_decl(f_13991)
static void C_ccall f_13991(C_word c,C_word *av) C_noret;
C_noret_decl(f_13997)
static void C_ccall f_13997(C_word c,C_word *av) C_noret;
C_noret_decl(f_14003)
static void C_ccall f_14003(C_word c,C_word *av) C_noret;
C_noret_decl(f_14006)
static void f_14006(C_word t0,C_word t1) C_noret;
C_noret_decl(f_14013)
static void C_ccall f_14013(C_word c,C_word *av) C_noret;
C_noret_decl(f_14050)
static void C_ccall f_14050(C_word c,C_word *av) C_noret;
C_noret_decl(f_14053)
static void C_ccall f_14053(C_word c,C_word *av) C_noret;
C_noret_decl(f_14056)
static void C_ccall f_14056(C_word c,C_word *av) C_noret;
C_noret_decl(f_14059)
static void C_ccall f_14059(C_word c,C_word *av) C_noret;
C_noret_decl(f_14065)
static void C_ccall f_14065(C_word c,C_word *av) C_noret;
C_noret_decl(f_14068)
static void C_ccall f_14068(C_word c,C_word *av) C_noret;
C_noret_decl(f_14071)
static void C_ccall f_14071(C_word c,C_word *av) C_noret;
C_noret_decl(f_14074)
static void C_ccall f_14074(C_word c,C_word *av) C_noret;
C_noret_decl(f_14077)
static void C_ccall f_14077(C_word c,C_word *av) C_noret;
C_noret_decl(f_14080)
static void C_ccall f_14080(C_word c,C_word *av) C_noret;
C_noret_decl(f_14083)
static void C_ccall f_14083(C_word c,C_word *av) C_noret;
C_noret_decl(f_14086)
static void C_ccall f_14086(C_word c,C_word *av) C_noret;
C_noret_decl(f_14089)
static void C_ccall f_14089(C_word c,C_word *av) C_noret;
C_noret_decl(f_14092)
static void C_ccall f_14092(C_word c,C_word *av) C_noret;
C_noret_decl(f_14095)
static void C_ccall f_14095(C_word c,C_word *av) C_noret;
C_noret_decl(f_14098)
static void C_ccall f_14098(C_word c,C_word *av) C_noret;
C_noret_decl(f_14101)
static void C_ccall f_14101(C_word c,C_word *av) C_noret;
C_noret_decl(f_14104)
static void C_ccall f_14104(C_word c,C_word *av) C_noret;
C_noret_decl(f_14107)
static void C_ccall f_14107(C_word c,C_word *av) C_noret;
C_noret_decl(f_14110)
static void C_ccall f_14110(C_word c,C_word *av) C_noret;
C_noret_decl(f_14113)
static void C_ccall f_14113(C_word c,C_word *av) C_noret;
C_noret_decl(f_14116)
static void C_ccall f_14116(C_word c,C_word *av) C_noret;
C_noret_decl(f_14119)
static void C_ccall f_14119(C_word c,C_word *av) C_noret;
C_noret_decl(f_14122)
static void C_ccall f_14122(C_word c,C_word *av) C_noret;
C_noret_decl(f_14125)
static void C_ccall f_14125(C_word c,C_word *av) C_noret;
C_noret_decl(f_14128)
static void C_ccall f_14128(C_word c,C_word *av) C_noret;
C_noret_decl(f_14131)
static void C_ccall f_14131(C_word c,C_word *av) C_noret;
C_noret_decl(f_14134)
static void C_ccall f_14134(C_word c,C_word *av) C_noret;
C_noret_decl(f_14137)
static void C_ccall f_14137(C_word c,C_word *av) C_noret;
C_noret_decl(f_14142)
static void C_ccall f_14142(C_word c,C_word *av) C_noret;
C_noret_decl(f_14151)
static void C_ccall f_14151(C_word c,C_word *av) C_noret;
C_noret_decl(f_14163)
static void C_ccall f_14163(C_word c,C_word *av) C_noret;
C_noret_decl(f_14177)
static void C_ccall f_14177(C_word c,C_word *av) C_noret;
C_noret_decl(f_14193)
static void C_ccall f_14193(C_word c,C_word *av) C_noret;
C_noret_decl(f_14196)
static void C_ccall f_14196(C_word c,C_word *av) C_noret;
C_noret_decl(f_14205)
static void C_ccall f_14205(C_word c,C_word *av) C_noret;
C_noret_decl(f_14209)
static void C_ccall f_14209(C_word c,C_word *av) C_noret;
C_noret_decl(f_14211)
static void C_ccall f_14211(C_word c,C_word *av) C_noret;
C_noret_decl(f_14215)
static void C_ccall f_14215(C_word c,C_word *av) C_noret;
C_noret_decl(f_14218)
static void C_ccall f_14218(C_word c,C_word *av) C_noret;
C_noret_decl(f_14229)
static void C_ccall f_14229(C_word c,C_word *av) C_noret;
C_noret_decl(f_14231)
static void C_ccall f_14231(C_word c,C_word *av) C_noret;
C_noret_decl(f_14238)
static void C_ccall f_14238(C_word c,C_word *av) C_noret;
C_noret_decl(f_14241)
static void C_ccall f_14241(C_word c,C_word *av) C_noret;
C_noret_decl(f_14246)
static void C_ccall f_14246(C_word c,C_word *av) C_noret;
C_noret_decl(f_14250)
static void C_ccall f_14250(C_word c,C_word *av) C_noret;
C_noret_decl(f_14255)
static void C_ccall f_14255(C_word c,C_word *av) C_noret;
C_noret_decl(f_14259)
static void C_ccall f_14259(C_word c,C_word *av) C_noret;
C_noret_decl(f_14290)
static void C_ccall f_14290(C_word c,C_word *av) C_noret;
C_noret_decl(f_14293)
static void C_ccall f_14293(C_word c,C_word *av) C_noret;
C_noret_decl(f_14296)
static void C_ccall f_14296(C_word c,C_word *av) C_noret;
C_noret_decl(f_14313)
static void C_ccall f_14313(C_word c,C_word *av) C_noret;
C_noret_decl(f_14324)
static void C_ccall f_14324(C_word c,C_word *av) C_noret;
C_noret_decl(f_14335)
static void C_ccall f_14335(C_word c,C_word *av) C_noret;
C_noret_decl(f_14346)
static void C_ccall f_14346(C_word c,C_word *av) C_noret;
C_noret_decl(f_14357)
static void C_ccall f_14357(C_word c,C_word *av) C_noret;
C_noret_decl(f_14368)
static void C_ccall f_14368(C_word c,C_word *av) C_noret;
C_noret_decl(f_14379)
static void C_ccall f_14379(C_word c,C_word *av) C_noret;
C_noret_decl(f_14390)
static void C_ccall f_14390(C_word c,C_word *av) C_noret;
C_noret_decl(f_14401)
static void C_ccall f_14401(C_word c,C_word *av) C_noret;
C_noret_decl(f_14412)
static void C_ccall f_14412(C_word c,C_word *av) C_noret;
C_noret_decl(f_14423)
static void C_ccall f_14423(C_word c,C_word *av) C_noret;
C_noret_decl(f_14434)
static void C_ccall f_14434(C_word c,C_word *av) C_noret;
C_noret_decl(f_14445)
static void C_ccall f_14445(C_word c,C_word *av) C_noret;
C_noret_decl(f_14456)
static void C_ccall f_14456(C_word c,C_word *av) C_noret;
C_noret_decl(f_14467)
static void C_ccall f_14467(C_word c,C_word *av) C_noret;
C_noret_decl(f_14478)
static void C_ccall f_14478(C_word c,C_word *av) C_noret;
C_noret_decl(f_14489)
static void C_ccall f_14489(C_word c,C_word *av) C_noret;
C_noret_decl(f_14506)
static void C_ccall f_14506(C_word c,C_word *av) C_noret;
C_noret_decl(f_14523)
static void C_ccall f_14523(C_word c,C_word *av) C_noret;
C_noret_decl(f_14547)
static void C_ccall f_14547(C_word c,C_word *av) C_noret;
C_noret_decl(f_14564)
static void C_ccall f_14564(C_word c,C_word *av) C_noret;
C_noret_decl(f_14575)
static void C_ccall f_14575(C_word c,C_word *av) C_noret;
C_noret_decl(f_14586)
static void C_ccall f_14586(C_word c,C_word *av) C_noret;
C_noret_decl(f_14606)
static void C_ccall f_14606(C_word c,C_word *av) C_noret;
C_noret_decl(f_14617)
static void C_ccall f_14617(C_word c,C_word *av) C_noret;
C_noret_decl(f_14629)
static void f_14629(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_14663)
static void C_ccall f_14663(C_word c,C_word *av) C_noret;
C_noret_decl(f_14678)
static void f_14678(C_word t0,C_word t1) C_noret;
C_noret_decl(f_14745)
static void C_ccall f_14745(C_word c,C_word *av) C_noret;
C_noret_decl(f_14761)
static void C_ccall f_14761(C_word c,C_word *av) C_noret;
C_noret_decl(f_14777)
static void C_ccall f_14777(C_word c,C_word *av) C_noret;
C_noret_decl(f_14793)
static void C_ccall f_14793(C_word c,C_word *av) C_noret;
C_noret_decl(f_14809)
static void C_ccall f_14809(C_word c,C_word *av) C_noret;
C_noret_decl(f_14825)
static void C_ccall f_14825(C_word c,C_word *av) C_noret;
C_noret_decl(f_14841)
static void C_ccall f_14841(C_word c,C_word *av) C_noret;
C_noret_decl(f_14857)
static void C_ccall f_14857(C_word c,C_word *av) C_noret;
C_noret_decl(f_14873)
static void C_ccall f_14873(C_word c,C_word *av) C_noret;
C_noret_decl(f_14885)
static void f_14885(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_14904)
static void f_14904(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_14935)
static void C_ccall f_14935(C_word c,C_word *av) C_noret;
C_noret_decl(f_14952)
static void C_ccall f_14952(C_word c,C_word *av) C_noret;
C_noret_decl(f_14958)
static void f_14958(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_14982)
static void C_ccall f_14982(C_word c,C_word *av) C_noret;
C_noret_decl(f_14997)
static void C_ccall f_14997(C_word c,C_word *av) C_noret;
C_noret_decl(f_15007)
static void C_ccall f_15007(C_word c,C_word *av) C_noret;
C_noret_decl(f_15019)
static void C_ccall f_15019(C_word c,C_word *av) C_noret;
C_noret_decl(f_15023)
static void C_ccall f_15023(C_word c,C_word *av) C_noret;
C_noret_decl(f_15030)
static void C_ccall f_15030(C_word c,C_word *av) C_noret;
C_noret_decl(f_15036)
static void C_ccall f_15036(C_word c,C_word *av) C_noret;
C_noret_decl(f_15042)
static void C_ccall f_15042(C_word c,C_word *av) C_noret;
C_noret_decl(f_15066)
static void C_ccall f_15066(C_word c,C_word *av) C_noret;
C_noret_decl(f_15070)
static void C_ccall f_15070(C_word c,C_word *av) C_noret;
C_noret_decl(f_15079)
static void C_ccall f_15079(C_word c,C_word *av) C_noret;
C_noret_decl(f_15083)
static void C_ccall f_15083(C_word c,C_word *av) C_noret;
C_noret_decl(f_15092)
static void C_ccall f_15092(C_word c,C_word *av) C_noret;
C_noret_decl(f_15095)
static void C_ccall f_15095(C_word c,C_word *av) C_noret;
C_noret_decl(f_15101)
static void C_ccall f_15101(C_word c,C_word *av) C_noret;
C_noret_decl(f_15107)
static void C_ccall f_15107(C_word c,C_word *av) C_noret;
C_noret_decl(f_15110)
static void C_ccall f_15110(C_word c,C_word *av) C_noret;
C_noret_decl(f_15149)
static void C_ccall f_15149(C_word c,C_word *av) C_noret;
C_noret_decl(f_15152)
static void C_ccall f_15152(C_word c,C_word *av) C_noret;
C_noret_decl(f_15162)
static void f_15162(C_word t0,C_word t1) C_noret;
C_noret_decl(f_15179)
static void C_ccall f_15179(C_word c,C_word *av) C_noret;
C_noret_decl(f_15185)
static void C_ccall f_15185(C_word c,C_word *av) C_noret;
C_noret_decl(f_15191)
static void C_ccall f_15191(C_word c,C_word *av) C_noret;
C_noret_decl(f_15197)
static void C_ccall f_15197(C_word c,C_word *av) C_noret;
C_noret_decl(f_15203)
static void C_ccall f_15203(C_word c,C_word *av) C_noret;
C_noret_decl(f_15209)
static void C_ccall f_15209(C_word c,C_word *av) C_noret;
C_noret_decl(f_15215)
static void C_ccall f_15215(C_word c,C_word *av) C_noret;
C_noret_decl(f_15221)
static void C_ccall f_15221(C_word c,C_word *av) C_noret;
C_noret_decl(f_15225)
static void C_ccall f_15225(C_word c,C_word *av) C_noret;
C_noret_decl(f_15230)
static void C_ccall f_15230(C_word c,C_word *av) C_noret;
C_noret_decl(f_15233)
static void C_ccall f_15233(C_word c,C_word *av) C_noret;
C_noret_decl(f_15243)
static void C_ccall f_15243(C_word c,C_word *av) C_noret;
C_noret_decl(f_15246)
static void C_ccall f_15246(C_word c,C_word *av) C_noret;
C_noret_decl(f_15252)
static void C_ccall f_15252(C_word c,C_word *av) C_noret;
C_noret_decl(f_15256)
static void C_ccall f_15256(C_word c,C_word *av) C_noret;
C_noret_decl(f_15264)
static void f_15264(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_15268)
static void C_ccall f_15268(C_word c,C_word *av) C_noret;
C_noret_decl(f_15286)
static void C_ccall f_15286(C_word c,C_word *av) C_noret;
C_noret_decl(f_15310)
static void C_ccall f_15310(C_word c,C_word *av) C_noret;
C_noret_decl(f_15317)
static void C_ccall f_15317(C_word c,C_word *av) C_noret;
C_noret_decl(f_15341)
static void C_ccall f_15341(C_word c,C_word *av) C_noret;
C_noret_decl(f_15363)
static void C_ccall f_15363(C_word c,C_word *av) C_noret;
C_noret_decl(f_15366)
static void C_ccall f_15366(C_word c,C_word *av) C_noret;
C_noret_decl(f_15375)
static void f_15375(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_15432)
static void C_ccall f_15432(C_word c,C_word *av) C_noret;
C_noret_decl(f_15445)
static void C_ccall f_15445(C_word c,C_word *av) C_noret;
C_noret_decl(f_15450)
static void f_15450(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_15494)
static void C_ccall f_15494(C_word c,C_word *av) C_noret;
C_noret_decl(f_15498)
static void C_ccall f_15498(C_word c,C_word *av) C_noret;
C_noret_decl(f_15503)
static void f_15503(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_15545)
static void C_ccall f_15545(C_word c,C_word *av) C_noret;
C_noret_decl(f_15568)
static void f_15568(C_word t0,C_word t1) C_noret;
C_noret_decl(f_15591)
static C_word f_15591(C_word t0,C_word t1);
C_noret_decl(f_15664)
static void C_ccall f_15664(C_word c,C_word *av) C_noret;
C_noret_decl(f_15684)
static void f_15684(C_word t0,C_word t1) C_noret;
C_noret_decl(f_15687)
static void C_ccall f_15687(C_word c,C_word *av) C_noret;
C_noret_decl(f_15690)
static void C_ccall f_15690(C_word c,C_word *av) C_noret;
C_noret_decl(f_15699)
static void C_ccall f_15699(C_word c,C_word *av) C_noret;
C_noret_decl(f_15712)
static void C_ccall f_15712(C_word c,C_word *av) C_noret;
C_noret_decl(f_15739)
static void C_ccall f_15739(C_word c,C_word *av) C_noret;
C_noret_decl(f_15769)
static void C_ccall f_15769(C_word c,C_word *av) C_noret;
C_noret_decl(f_15788)
static C_word f_15788(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_15822)
static C_word f_15822(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_15856)
static void C_ccall f_15856(C_word c,C_word *av) C_noret;
C_noret_decl(f_15890)
static void C_ccall f_15890(C_word c,C_word *av) C_noret;
C_noret_decl(f_15894)
static void C_ccall f_15894(C_word c,C_word *av) C_noret;
C_noret_decl(f_15904)
static void C_ccall f_15904(C_word c,C_word *av) C_noret;
C_noret_decl(f_15914)
static void f_15914(C_word t0,C_word t1) C_noret;
C_noret_decl(f_15921)
static void f_15921(C_word t0,C_word t1) C_noret;
C_noret_decl(f_15949)
static void f_15949(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_15969)
static void C_ccall f_15969(C_word c,C_word *av) C_noret;
C_noret_decl(f_15971)
static void f_15971(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_15999)
static void C_ccall f_15999(C_word c,C_word *av) C_noret;
C_noret_decl(f_16018)
static void C_ccall f_16018(C_word c,C_word *av) C_noret;
C_noret_decl(f_16024)
static void C_ccall f_16024(C_word c,C_word *av) C_noret;
C_noret_decl(f_16042)
static void C_ccall f_16042(C_word c,C_word *av) C_noret;
C_noret_decl(f_16048)
static void C_ccall f_16048(C_word c,C_word *av) C_noret;
C_noret_decl(f_16066)
static void C_ccall f_16066(C_word c,C_word *av) C_noret;
C_noret_decl(f_16072)
static void C_ccall f_16072(C_word c,C_word *av) C_noret;
C_noret_decl(f_16087)
static void C_ccall f_16087(C_word c,C_word *av) C_noret;
C_noret_decl(f_16093)
static void C_ccall f_16093(C_word c,C_word *av) C_noret;
C_noret_decl(f_16107)
static void f_16107(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_16127)
static void C_ccall f_16127(C_word c,C_word *av) C_noret;
C_noret_decl(f_16129)
static void f_16129(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_16157)
static void C_ccall f_16157(C_word c,C_word *av) C_noret;
C_noret_decl(f_16168)
static void C_ccall f_16168(C_word c,C_word *av) C_noret;
C_noret_decl(f_16174)
static void C_ccall f_16174(C_word c,C_word *av) C_noret;
C_noret_decl(f_16192)
static void C_ccall f_16192(C_word c,C_word *av) C_noret;
C_noret_decl(f_16198)
static void C_ccall f_16198(C_word c,C_word *av) C_noret;
C_noret_decl(f_16216)
static void C_ccall f_16216(C_word c,C_word *av) C_noret;
C_noret_decl(f_16222)
static void C_ccall f_16222(C_word c,C_word *av) C_noret;
C_noret_decl(f_16237)
static void C_ccall f_16237(C_word c,C_word *av) C_noret;
C_noret_decl(f_16243)
static void C_ccall f_16243(C_word c,C_word *av) C_noret;
C_noret_decl(f_16258)
static void C_ccall f_16258(C_word c,C_word *av) C_noret;
C_noret_decl(f_16274)
static void C_ccall f_16274(C_word c,C_word *av) C_noret;
C_noret_decl(f_16304)
static void C_ccall f_16304(C_word c,C_word *av) C_noret;
C_noret_decl(f_16308)
static void C_ccall f_16308(C_word c,C_word *av) C_noret;
C_noret_decl(f_16310)
static void f_16310(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_16321)
static void C_ccall f_16321(C_word c,C_word *av) C_noret;
C_noret_decl(f_16344)
static void C_ccall f_16344(C_word c,C_word *av) C_noret;
C_noret_decl(f_16362)
static void C_ccall f_16362(C_word c,C_word *av) C_noret;
C_noret_decl(f_16368)
static void C_ccall f_16368(C_word c,C_word *av) C_noret;
C_noret_decl(f_16374)
static void C_ccall f_16374(C_word c,C_word *av) C_noret;
C_noret_decl(f_16381)
static void C_ccall f_16381(C_word c,C_word *av) C_noret;
C_noret_decl(f_16389)
static void f_16389(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_16410)
static void f_16410(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_16424)
static void C_ccall f_16424(C_word c,C_word *av) C_noret;
C_noret_decl(f_16428)
static void C_ccall f_16428(C_word c,C_word *av) C_noret;
C_noret_decl(f_16469)
static void C_ccall f_16469(C_word c,C_word *av) C_noret;
C_noret_decl(f_16491)
static void C_ccall f_16491(C_word c,C_word *av) C_noret;
C_noret_decl(f_16493)
static void C_ccall f_16493(C_word c,C_word *av) C_noret;
C_noret_decl(f_16515)
static void C_ccall f_16515(C_word c,C_word *av) C_noret;
C_noret_decl(f_16517)
static void C_ccall f_16517(C_word c,C_word *av) C_noret;
C_noret_decl(f_16539)
static void C_ccall f_16539(C_word c,C_word *av) C_noret;
C_noret_decl(f_16541)
static void C_ccall f_16541(C_word c,C_word *av) C_noret;
C_noret_decl(f_16563)
static void C_ccall f_16563(C_word c,C_word *av) C_noret;
C_noret_decl(f_16565)
static void C_ccall f_16565(C_word c,C_word *av) C_noret;
C_noret_decl(f_16569)
static void C_ccall f_16569(C_word c,C_word *av) C_noret;
C_noret_decl(f_16572)
static void f_16572(C_word t0,C_word t1) C_noret;
C_noret_decl(f_16590)
static void C_ccall f_16590(C_word c,C_word *av) C_noret;
C_noret_decl(f_16612)
static void C_ccall f_16612(C_word c,C_word *av) C_noret;
C_noret_decl(f_16614)
static void C_ccall f_16614(C_word c,C_word *av) C_noret;
C_noret_decl(f_16636)
static void C_ccall f_16636(C_word c,C_word *av) C_noret;
C_noret_decl(f_16638)
static void C_ccall f_16638(C_word c,C_word *av) C_noret;
C_noret_decl(f_16660)
static void C_ccall f_16660(C_word c,C_word *av) C_noret;
C_noret_decl(f_16662)
static void C_ccall f_16662(C_word c,C_word *av) C_noret;
C_noret_decl(f_16684)
static void C_ccall f_16684(C_word c,C_word *av) C_noret;
C_noret_decl(f_16686)
static void C_ccall f_16686(C_word c,C_word *av) C_noret;
C_noret_decl(f_16708)
static void C_ccall f_16708(C_word c,C_word *av) C_noret;
C_noret_decl(f_16710)
static void C_ccall f_16710(C_word c,C_word *av) C_noret;
C_noret_decl(f_16732)
static void C_ccall f_16732(C_word c,C_word *av) C_noret;
C_noret_decl(f_16734)
static void C_ccall f_16734(C_word c,C_word *av) C_noret;
C_noret_decl(f_16756)
static void C_ccall f_16756(C_word c,C_word *av) C_noret;
C_noret_decl(f_16758)
static void C_ccall f_16758(C_word c,C_word *av) C_noret;
C_noret_decl(f_16774)
static void C_ccall f_16774(C_word c,C_word *av) C_noret;
C_noret_decl(f_16776)
static void C_ccall f_16776(C_word c,C_word *av) C_noret;
C_noret_decl(f_16798)
static void C_ccall f_16798(C_word c,C_word *av) C_noret;
C_noret_decl(f_16800)
static void C_ccall f_16800(C_word c,C_word *av) C_noret;
C_noret_decl(f_16822)
static void C_ccall f_16822(C_word c,C_word *av) C_noret;
C_noret_decl(f_16824)
static void C_ccall f_16824(C_word c,C_word *av) C_noret;
C_noret_decl(f_16840)
static void C_ccall f_16840(C_word c,C_word *av) C_noret;
C_noret_decl(f_16842)
static void C_ccall f_16842(C_word c,C_word *av) C_noret;
C_noret_decl(f_16858)
static void C_ccall f_16858(C_word c,C_word *av) C_noret;
C_noret_decl(f_16860)
static void C_ccall f_16860(C_word c,C_word *av) C_noret;
C_noret_decl(f_16876)
static void C_ccall f_16876(C_word c,C_word *av) C_noret;
C_noret_decl(f_16878)
static void C_ccall f_16878(C_word c,C_word *av) C_noret;
C_noret_decl(f_16894)
static void C_ccall f_16894(C_word c,C_word *av) C_noret;
C_noret_decl(f_16896)
static void C_ccall f_16896(C_word c,C_word *av) C_noret;
C_noret_decl(f_16912)
static void C_ccall f_16912(C_word c,C_word *av) C_noret;
C_noret_decl(f_16914)
static void C_ccall f_16914(C_word c,C_word *av) C_noret;
C_noret_decl(f_16930)
static void C_ccall f_16930(C_word c,C_word *av) C_noret;
C_noret_decl(f_16932)
static void C_ccall f_16932(C_word c,C_word *av) C_noret;
C_noret_decl(f_16948)
static void C_ccall f_16948(C_word c,C_word *av) C_noret;
C_noret_decl(f_16950)
static void C_ccall f_16950(C_word c,C_word *av) C_noret;
C_noret_decl(f_16966)
static void C_ccall f_16966(C_word c,C_word *av) C_noret;
C_noret_decl(f_16968)
static void C_ccall f_16968(C_word c,C_word *av) C_noret;
C_noret_decl(f_16984)
static void C_ccall f_16984(C_word c,C_word *av) C_noret;
C_noret_decl(f_16986)
static void C_ccall f_16986(C_word c,C_word *av) C_noret;
C_noret_decl(f_17002)
static void C_ccall f_17002(C_word c,C_word *av) C_noret;
C_noret_decl(f_17004)
static void C_ccall f_17004(C_word c,C_word *av) C_noret;
C_noret_decl(f_17026)
static void C_ccall f_17026(C_word c,C_word *av) C_noret;
C_noret_decl(f_17028)
static void C_ccall f_17028(C_word c,C_word *av) C_noret;
C_noret_decl(f_17044)
static void C_ccall f_17044(C_word c,C_word *av) C_noret;
C_noret_decl(f_17046)
static void C_ccall f_17046(C_word c,C_word *av) C_noret;
C_noret_decl(f_17062)
static void C_ccall f_17062(C_word c,C_word *av) C_noret;
C_noret_decl(f_17064)
static void C_ccall f_17064(C_word c,C_word *av) C_noret;
C_noret_decl(f_17080)
static void C_ccall f_17080(C_word c,C_word *av) C_noret;
C_noret_decl(f_17082)
static void C_ccall f_17082(C_word c,C_word *av) C_noret;
C_noret_decl(f_17098)
static void C_ccall f_17098(C_word c,C_word *av) C_noret;
C_noret_decl(f_17100)
static void C_ccall f_17100(C_word c,C_word *av) C_noret;
C_noret_decl(f_17116)
static void C_ccall f_17116(C_word c,C_word *av) C_noret;
C_noret_decl(f_17118)
static void C_ccall f_17118(C_word c,C_word *av) C_noret;
C_noret_decl(f_17134)
static void C_ccall f_17134(C_word c,C_word *av) C_noret;
C_noret_decl(f_17136)
static void C_ccall f_17136(C_word c,C_word *av) C_noret;
C_noret_decl(f_17152)
static void C_ccall f_17152(C_word c,C_word *av) C_noret;
C_noret_decl(f_17154)
static void C_ccall f_17154(C_word c,C_word *av) C_noret;
C_noret_decl(f_17176)
static void C_ccall f_17176(C_word c,C_word *av) C_noret;
C_noret_decl(f_17178)
static void C_ccall f_17178(C_word c,C_word *av) C_noret;
C_noret_decl(f_17194)
static void C_ccall f_17194(C_word c,C_word *av) C_noret;
C_noret_decl(f_17196)
static void C_ccall f_17196(C_word c,C_word *av) C_noret;
C_noret_decl(f_17212)
static void C_ccall f_17212(C_word c,C_word *av) C_noret;
C_noret_decl(f_17214)
static void C_ccall f_17214(C_word c,C_word *av) C_noret;
C_noret_decl(f_17230)
static void C_ccall f_17230(C_word c,C_word *av) C_noret;
C_noret_decl(f_17232)
static void C_ccall f_17232(C_word c,C_word *av) C_noret;
C_noret_decl(f_17248)
static void C_ccall f_17248(C_word c,C_word *av) C_noret;
C_noret_decl(f_17250)
static void C_ccall f_17250(C_word c,C_word *av) C_noret;
C_noret_decl(f_17268)
static void f_17268(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_17278)
static void C_ccall f_17278(C_word c,C_word *av) C_noret;
C_noret_decl(f_17282)
static void C_ccall f_17282(C_word c,C_word *av) C_noret;
C_noret_decl(f_17304)
static void C_ccall f_17304(C_word c,C_word *av) C_noret;
C_noret_decl(f_17308)
static void C_ccall f_17308(C_word c,C_word *av) C_noret;
C_noret_decl(f_17311)
static void C_ccall f_17311(C_word c,C_word *av) C_noret;
C_noret_decl(f_17316)
static void C_ccall f_17316(C_word c,C_word *av) C_noret;
C_noret_decl(f_17320)
static void C_ccall f_17320(C_word c,C_word *av) C_noret;
C_noret_decl(f_17323)
static void C_ccall f_17323(C_word c,C_word *av) C_noret;
C_noret_decl(f_17326)
static void C_ccall f_17326(C_word c,C_word *av) C_noret;
C_noret_decl(f_17339)
static void C_ccall f_17339(C_word c,C_word *av) C_noret;
C_noret_decl(f_17362)
static void C_ccall f_17362(C_word c,C_word *av) C_noret;
C_noret_decl(f_17388)
static void C_ccall f_17388(C_word c,C_word *av) C_noret;
C_noret_decl(f_17397)
static void C_ccall f_17397(C_word c,C_word *av) C_noret;
C_noret_decl(f_17402)
static void C_ccall f_17402(C_word c,C_word *av) C_noret;
C_noret_decl(f_17404)
static void C_ccall f_17404(C_word c,C_word *av) C_noret;
C_noret_decl(f_17448)
static C_word f_17448(C_word *a,C_word t0,C_word t1);
C_noret_decl(f_17494)
static void C_ccall f_17494(C_word c,C_word *av) C_noret;
C_noret_decl(f_17518)
static void C_ccall f_17518(C_word c,C_word *av) C_noret;
C_noret_decl(f_17522)
static void C_ccall f_17522(C_word c,C_word *av) C_noret;
C_noret_decl(f_17540)
static void C_ccall f_17540(C_word c,C_word *av) C_noret;
C_noret_decl(f_17564)
static void C_ccall f_17564(C_word c,C_word *av) C_noret;
C_noret_decl(f_17568)
static void C_ccall f_17568(C_word c,C_word *av) C_noret;
C_noret_decl(f_17586)
static void C_ccall f_17586(C_word c,C_word *av) C_noret;
C_noret_decl(f_17627)
static void f_17627(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_17638)
static void C_ccall f_17638(C_word c,C_word *av) C_noret;
C_noret_decl(f_17644)
static void f_17644(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_17648)
static void C_ccall f_17648(C_word c,C_word *av) C_noret;
C_noret_decl(f_17662)
static void C_ccall f_17662(C_word c,C_word *av) C_noret;
C_noret_decl(f_17675)
static void C_ccall f_17675(C_word c,C_word *av) C_noret;
C_noret_decl(f_17679)
static void C_ccall f_17679(C_word c,C_word *av) C_noret;
C_noret_decl(f_17696)
static void C_ccall f_17696(C_word c,C_word *av) C_noret;
C_noret_decl(f_17700)
static void C_ccall f_17700(C_word c,C_word *av) C_noret;
C_noret_decl(f_17706)
static void C_ccall f_17706(C_word c,C_word *av) C_noret;
C_noret_decl(f_17710)
static void C_ccall f_17710(C_word c,C_word *av) C_noret;
C_noret_decl(f_17750)
static void C_ccall f_17750(C_word c,C_word *av) C_noret;
C_noret_decl(f_17754)
static void C_ccall f_17754(C_word c,C_word *av) C_noret;
C_noret_decl(f_17774)
static void C_ccall f_17774(C_word c,C_word *av) C_noret;
C_noret_decl(f_17777)
static void C_ccall f_17777(C_word c,C_word *av) C_noret;
C_noret_decl(f_17780)
static void C_ccall f_17780(C_word c,C_word *av) C_noret;
C_noret_decl(f_17783)
static void C_ccall f_17783(C_word c,C_word *av) C_noret;
C_noret_decl(f_17786)
static void C_ccall f_17786(C_word c,C_word *av) C_noret;
C_noret_decl(f_17807)
static void C_ccall f_17807(C_word c,C_word *av) C_noret;
C_noret_decl(f_17809)
static void f_17809(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_17827)
static void C_ccall f_17827(C_word c,C_word *av) C_noret;
C_noret_decl(f_17837)
static void C_ccall f_17837(C_word c,C_word *av) C_noret;
C_noret_decl(f_17841)
static void C_ccall f_17841(C_word c,C_word *av) C_noret;
C_noret_decl(f_17879)
static void C_ccall f_17879(C_word c,C_word *av) C_noret;
C_noret_decl(f_17882)
static void C_ccall f_17882(C_word c,C_word *av) C_noret;
C_noret_decl(f_17885)
static void C_ccall f_17885(C_word c,C_word *av) C_noret;
C_noret_decl(f_17888)
static void C_ccall f_17888(C_word c,C_word *av) C_noret;
C_noret_decl(f_17894)
static void C_ccall f_17894(C_word c,C_word *av) C_noret;
C_noret_decl(f_17897)
static void C_ccall f_17897(C_word c,C_word *av) C_noret;
C_noret_decl(f_17945)
static void C_ccall f_17945(C_word c,C_word *av) C_noret;
C_noret_decl(f_17949)
static void C_ccall f_17949(C_word c,C_word *av) C_noret;
C_noret_decl(f_18026)
static void C_ccall f_18026(C_word c,C_word *av) C_noret;
C_noret_decl(f_18065)
static void C_ccall f_18065(C_word c,C_word *av) C_noret;
C_noret_decl(f_18120)
static void C_ccall f_18120(C_word c,C_word *av) C_noret;
C_noret_decl(f_18165)
static void C_ccall f_18165(C_word c,C_word *av) C_noret;
C_noret_decl(f_18210)
static void C_ccall f_18210(C_word c,C_word *av) C_noret;
C_noret_decl(f_18247)
static void C_ccall f_18247(C_word c,C_word *av) C_noret;
C_noret_decl(f_18267)
static void C_ccall f_18267(C_word c,C_word *av) C_noret;
C_noret_decl(f_18291)
static void f_18291(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_18294)
static void f_18294(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_18298)
static void C_ccall f_18298(C_word c,C_word *av) C_noret;
C_noret_decl(f_18301)
static void C_ccall f_18301(C_word c,C_word *av) C_noret;
C_noret_decl(f_18319)
static void C_ccall f_18319(C_word c,C_word *av) C_noret;
C_noret_decl(f_18342)
static void C_ccall f_18342(C_word c,C_word *av) C_noret;
C_noret_decl(f_18346)
static void C_ccall f_18346(C_word c,C_word *av) C_noret;
C_noret_decl(f_18369)
static void C_ccall f_18369(C_word c,C_word *av) C_noret;
C_noret_decl(f_18373)
static void C_ccall f_18373(C_word c,C_word *av) C_noret;
C_noret_decl(f_18405)
static void C_ccall f_18405(C_word c,C_word *av) C_noret;
C_noret_decl(f_18441)
static void C_ccall f_18441(C_word c,C_word *av) C_noret;
C_noret_decl(f_18445)
static void C_ccall f_18445(C_word c,C_word *av) C_noret;
C_noret_decl(f_18464)
static void C_ccall f_18464(C_word c,C_word *av) C_noret;
C_noret_decl(f_18466)
static void C_ccall f_18466(C_word c,C_word *av) C_noret;
C_noret_decl(f_18473)
static void f_18473(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_18510)
static void C_ccall f_18510(C_word c,C_word *av) C_noret;
C_noret_decl(f_18517)
static void f_18517(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_18554)
static void C_ccall f_18554(C_word c,C_word *av) C_noret;
C_noret_decl(f_18572)
static void C_ccall f_18572(C_word c,C_word *av) C_noret;
C_noret_decl(f_18581)
static void C_ccall f_18581(C_word c,C_word *av) C_noret;
C_noret_decl(f_18586)
static void C_ccall f_18586(C_word c,C_word *av) C_noret;
C_noret_decl(f_18599)
static void C_ccall f_18599(C_word c,C_word *av) C_noret;
C_noret_decl(f_18625)
static void C_ccall f_18625(C_word c,C_word *av) C_noret;
C_noret_decl(f_18633)
static void C_ccall f_18633(C_word c,C_word *av) C_noret;
C_noret_decl(f_18637)
static void C_ccall f_18637(C_word c,C_word *av) C_noret;
C_noret_decl(f_18641)
static void C_ccall f_18641(C_word c,C_word *av) C_noret;
C_noret_decl(f_18645)
static void C_ccall f_18645(C_word c,C_word *av) C_noret;
C_noret_decl(f_18648)
static void C_ccall f_18648(C_word c,C_word *av) C_noret;
C_noret_decl(f_18662)
static void C_ccall f_18662(C_word c,C_word *av) C_noret;
C_noret_decl(f_18666)
static void C_ccall f_18666(C_word c,C_word *av) C_noret;
C_noret_decl(f_18677)
static void C_ccall f_18677(C_word c,C_word *av) C_noret;
C_noret_decl(f_18701)
static void C_ccall f_18701(C_word c,C_word *av) C_noret;
C_noret_decl(f_18705)
static void C_ccall f_18705(C_word c,C_word *av) C_noret;
C_noret_decl(f_18711)
static void C_ccall f_18711(C_word c,C_word *av) C_noret;
C_noret_decl(f_18735)
static void C_ccall f_18735(C_word c,C_word *av) C_noret;
C_noret_decl(f_18739)
static void C_ccall f_18739(C_word c,C_word *av) C_noret;
C_noret_decl(f_18745)
static void C_ccall f_18745(C_word c,C_word *av) C_noret;
C_noret_decl(f_18762)
static void C_ccall f_18762(C_word c,C_word *av) C_noret;
C_noret_decl(f_18766)
static void C_ccall f_18766(C_word c,C_word *av) C_noret;
C_noret_decl(f_18770)
static void C_ccall f_18770(C_word c,C_word *av) C_noret;
C_noret_decl(f_18780)
static void f_18780(C_word t0,C_word t1) C_noret;
C_noret_decl(f_18786)
static void f_18786(C_word t0,C_word t1) C_noret;
C_noret_decl(f_18793)
static void C_ccall f_18793(C_word c,C_word *av) C_noret;
C_noret_decl(f_18805)
static void C_ccall f_18805(C_word c,C_word *av) C_noret;
C_noret_decl(f_18828)
static void C_ccall f_18828(C_word c,C_word *av) C_noret;
C_noret_decl(f_18832)
static void C_ccall f_18832(C_word c,C_word *av) C_noret;
C_noret_decl(f_18842)
static void f_18842(C_word t0,C_word t1) C_noret;
C_noret_decl(f_18848)
static void f_18848(C_word t0,C_word t1) C_noret;
C_noret_decl(f_18855)
static void C_ccall f_18855(C_word c,C_word *av) C_noret;
C_noret_decl(f_18870)
static void C_ccall f_18870(C_word c,C_word *av) C_noret;
C_noret_decl(f_18874)
static void C_ccall f_18874(C_word c,C_word *av) C_noret;
C_noret_decl(f_18907)
static void C_ccall f_18907(C_word c,C_word *av) C_noret;
C_noret_decl(f_18911)
static void C_ccall f_18911(C_word c,C_word *av) C_noret;
C_noret_decl(f_18928)
static void C_ccall f_18928(C_word c,C_word *av) C_noret;
C_noret_decl(f_18938)
static void C_ccall f_18938(C_word c,C_word *av) C_noret;
C_noret_decl(f_19011)
static void C_ccall f_19011(C_word c,C_word *av) C_noret;
C_noret_decl(f_19025)
static void C_ccall f_19025(C_word c,C_word *av) C_noret;
C_noret_decl(f_19042)
static void C_ccall f_19042(C_word c,C_word *av) C_noret;
C_noret_decl(f_19058)
static void C_ccall f_19058(C_word c,C_word *av) C_noret;
C_noret_decl(f_19129)
static void C_ccall f_19129(C_word c,C_word *av) C_noret;
C_noret_decl(f_19133)
static void C_ccall f_19133(C_word c,C_word *av) C_noret;
C_noret_decl(f_19138)
static void C_ccall f_19138(C_word c,C_word *av) C_noret;
C_noret_decl(f_19148)
static void C_ccall f_19148(C_word c,C_word *av) C_noret;
C_noret_decl(f_19152)
static void C_ccall f_19152(C_word c,C_word *av) C_noret;
C_noret_decl(f_19167)
static void C_ccall f_19167(C_word c,C_word *av) C_noret;
C_noret_decl(f_19171)
static void C_ccall f_19171(C_word c,C_word *av) C_noret;
C_noret_decl(f_19188)
static void C_ccall f_19188(C_word c,C_word *av) C_noret;
C_noret_decl(f_19199)
static void C_ccall f_19199(C_word c,C_word *av) C_noret;
C_noret_decl(f_19205)
static void C_ccall f_19205(C_word c,C_word *av) C_noret;
C_noret_decl(f_19216)
static void C_ccall f_19216(C_word c,C_word *av) C_noret;
C_noret_decl(f_19227)
static void C_ccall f_19227(C_word c,C_word *av) C_noret;
C_noret_decl(f_19239)
static void C_ccall f_19239(C_word c,C_word *av) C_noret;
C_noret_decl(f_19251)
static void C_ccall f_19251(C_word c,C_word *av) C_noret;
C_noret_decl(f_19263)
static void C_ccall f_19263(C_word c,C_word *av) C_noret;
C_noret_decl(f_19280)
static void C_ccall f_19280(C_word c,C_word *av) C_noret;
C_noret_decl(f_19287)
static void C_ccall f_19287(C_word c,C_word *av) C_noret;
C_noret_decl(f_19291)
static void C_ccall f_19291(C_word c,C_word *av) C_noret;
C_noret_decl(f_19293)
static void C_ccall f_19293(C_word c,C_word *av) C_noret;
C_noret_decl(f_19300)
static void C_ccall f_19300(C_word c,C_word *av) C_noret;
C_noret_decl(f_19306)
static void C_ccall f_19306(C_word c,C_word *av) C_noret;
C_noret_decl(f_19312)
static void C_ccall f_19312(C_word c,C_word *av) C_noret;
C_noret_decl(f_19355)
static void C_ccall f_19355(C_word c,C_word *av) C_noret;
C_noret_decl(f_19361)
static void C_ccall f_19361(C_word c,C_word *av) C_noret;
C_noret_decl(f_19367)
static void C_ccall f_19367(C_word c,C_word *av) C_noret;
C_noret_decl(f_19370)
static void C_ccall f_19370(C_word c,C_word *av) C_noret;
C_noret_decl(f_19376)
static void C_ccall f_19376(C_word c,C_word *av) C_noret;
C_noret_decl(f_19382)
static void C_ccall f_19382(C_word c,C_word *av) C_noret;
C_noret_decl(f_19385)
static void C_ccall f_19385(C_word c,C_word *av) C_noret;
C_noret_decl(f_19391)
static void C_ccall f_19391(C_word c,C_word *av) C_noret;
C_noret_decl(f_19395)
static void C_ccall f_19395(C_word c,C_word *av) C_noret;
C_noret_decl(f_19398)
static void C_ccall f_19398(C_word c,C_word *av) C_noret;
C_noret_decl(f_19403)
static void C_ccall f_19403(C_word c,C_word *av) C_noret;
C_noret_decl(f_19413)
static void f_19413(C_word t0,C_word t1) C_noret;
C_noret_decl(f_19433)
static void C_ccall f_19433(C_word c,C_word *av) C_noret;
C_noret_decl(f_19448)
static void f_19448(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_19478)
static void C_ccall f_19478(C_word c,C_word *av) C_noret;
C_noret_decl(f_19489)
static void C_ccall f_19489(C_word c,C_word *av) C_noret;
C_noret_decl(f_19505)
static void C_ccall f_19505(C_word c,C_word *av) C_noret;
C_noret_decl(f_19509)
static void C_ccall f_19509(C_word c,C_word *av) C_noret;
C_noret_decl(f_19513)
static void C_ccall f_19513(C_word c,C_word *av) C_noret;
C_noret_decl(f_19529)
static void C_ccall f_19529(C_word c,C_word *av) C_noret;
C_noret_decl(f_19547)
static void C_ccall f_19547(C_word c,C_word *av) C_noret;
C_noret_decl(f_19558)
static void f_19558(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_19580)
static void C_ccall f_19580(C_word c,C_word *av) C_noret;
C_noret_decl(f_19597)
static void C_ccall f_19597(C_word c,C_word *av) C_noret;
C_noret_decl(f_19600)
static void f_19600(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_19612)
static void C_ccall f_19612(C_word c,C_word *av) C_noret;
C_noret_decl(f_19614)
static void f_19614(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_19635)
static void C_ccall f_19635(C_word c,C_word *av) C_noret;
C_noret_decl(f_19666)
static void C_ccall f_19666(C_word c,C_word *av) C_noret;
C_noret_decl(f_19670)
static void C_ccall f_19670(C_word c,C_word *av) C_noret;
C_noret_decl(f_19705)
static void C_ccall f_19705(C_word c,C_word *av) C_noret;
C_noret_decl(f_19712)
static void C_ccall f_19712(C_word c,C_word *av) C_noret;
C_noret_decl(f_19724)
static void C_ccall f_19724(C_word c,C_word *av) C_noret;
C_noret_decl(f_19744)
static void C_ccall f_19744(C_word c,C_word *av) C_noret;
C_noret_decl(f_19748)
static void C_ccall f_19748(C_word c,C_word *av) C_noret;
C_noret_decl(f_19768)
static void f_19768(C_word t0,C_word t1) C_noret;
C_noret_decl(f_19788)
static void C_ccall f_19788(C_word c,C_word *av) C_noret;
C_noret_decl(f_19792)
static void C_ccall f_19792(C_word c,C_word *av) C_noret;
C_noret_decl(f_19796)
static void C_ccall f_19796(C_word c,C_word *av) C_noret;
C_noret_decl(f_19803)
static void C_ccall f_19803(C_word c,C_word *av) C_noret;
C_noret_decl(f_19819)
static void C_ccall f_19819(C_word c,C_word *av) C_noret;
C_noret_decl(f_19823)
static void C_ccall f_19823(C_word c,C_word *av) C_noret;
C_noret_decl(f_19864)
static void f_19864(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_19897)
static void C_ccall f_19897(C_word c,C_word *av) C_noret;
C_noret_decl(f_19926)
static void C_ccall f_19926(C_word c,C_word *av) C_noret;
C_noret_decl(f_19934)
static void C_ccall f_19934(C_word c,C_word *av) C_noret;
C_noret_decl(f_19940)
static void C_ccall f_19940(C_word c,C_word *av) C_noret;
C_noret_decl(f_19960)
static void f_19960(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_19985)
static void C_ccall f_19985(C_word c,C_word *av) C_noret;
C_noret_decl(f_19991)
static void C_ccall f_19991(C_word c,C_word *av) C_noret;
C_noret_decl(f_19995)
static void C_ccall f_19995(C_word c,C_word *av) C_noret;
C_noret_decl(f_20005)
static void C_ccall f_20005(C_word c,C_word *av) C_noret;
C_noret_decl(f_20025)
static void f_20025(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_20046)
static void C_ccall f_20046(C_word c,C_word *av) C_noret;
C_noret_decl(f_20063)
static void C_ccall f_20063(C_word c,C_word *av) C_noret;
C_noret_decl(f_20070)
static void C_ccall f_20070(C_word c,C_word *av) C_noret;
C_noret_decl(f_20075)
static void C_ccall f_20075(C_word c,C_word *av) C_noret;
C_noret_decl(f_20081)
static void C_ccall f_20081(C_word c,C_word *av) C_noret;
C_noret_decl(f_20085)
static void C_ccall f_20085(C_word c,C_word *av) C_noret;
C_noret_decl(f_20088)
static void C_ccall f_20088(C_word c,C_word *av) C_noret;
C_noret_decl(f_20095)
static void C_ccall f_20095(C_word c,C_word *av) C_noret;
C_noret_decl(f_20113)
static void C_ccall f_20113(C_word c,C_word *av) C_noret;
C_noret_decl(f_20127)
static void C_ccall f_20127(C_word c,C_word *av) C_noret;
C_noret_decl(f_20131)
static void C_ccall f_20131(C_word c,C_word *av) C_noret;
C_noret_decl(f_20168)
static void C_ccall f_20168(C_word c,C_word *av) C_noret;
C_noret_decl(f_20176)
static void C_ccall f_20176(C_word c,C_word *av) C_noret;
C_noret_decl(f_20205)
static void C_ccall f_20205(C_word c,C_word *av) C_noret;
C_noret_decl(f_20208)
static void C_ccall f_20208(C_word c,C_word *av) C_noret;
C_noret_decl(f_20223)
static void C_ccall f_20223(C_word c,C_word *av) C_noret;
C_noret_decl(f_20226)
static void f_20226(C_word t0,C_word t1) C_noret;
C_noret_decl(f_20233)
static void C_ccall f_20233(C_word c,C_word *av) C_noret;
C_noret_decl(f_20244)
static void C_ccall f_20244(C_word c,C_word *av) C_noret;
C_noret_decl(f_20262)
static void C_ccall f_20262(C_word c,C_word *av) C_noret;
C_noret_decl(f_20287)
static void f_20287(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_20302)
static void C_ccall f_20302(C_word c,C_word *av) C_noret;
C_noret_decl(f_20330)
static void f_20330(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_20334)
static C_word f_20334(C_word t0,C_word t1);
C_noret_decl(f_20348)
static void f_20348(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_20408)
static void C_ccall f_20408(C_word c,C_word *av) C_noret;
C_noret_decl(f_20428)
static void f_20428(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_20434)
static void f_20434(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_20494)
static void f_20494(C_word t0,C_word t1) C_noret;
C_noret_decl(f_20532)
static void f_20532(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_20538)
static void f_20538(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_20580)
static void f_20580(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_20584)
static void C_ccall f_20584(C_word c,C_word *av) C_noret;
C_noret_decl(f_20587)
static void C_ccall f_20587(C_word c,C_word *av) C_noret;
C_noret_decl(f_20636)
static void f_20636(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_20649)
static void f_20649(C_word t0,C_word t1) C_noret;
C_noret_decl(f_20655)
static void C_ccall f_20655(C_word c,C_word *av) C_noret;
C_noret_decl(f_20689)
static void f_20689(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_20699)
static void C_ccall f_20699(C_word c,C_word *av) C_noret;
C_noret_decl(f_20708)
static void f_20708(C_word t0,C_word t1) C_noret;
C_noret_decl(f_20720)
static void f_20720(C_word t0,C_word t1) C_noret;
C_noret_decl(f_20729)
static void C_ccall f_20729(C_word c,C_word *av) C_noret;
C_noret_decl(f_20741)
static void C_ccall f_20741(C_word c,C_word *av) C_noret;
C_noret_decl(f_20747)
static void f_20747(C_word t0,C_word t1) C_noret;
C_noret_decl(f_20753)
static void C_ccall f_20753(C_word c,C_word *av) C_noret;
C_noret_decl(f_20795)
static void C_ccall f_20795(C_word c,C_word *av) C_noret;
C_noret_decl(f_20901)
static void f_20901(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_20908)
static void f_20908(C_word t0,C_word t1) C_noret;
C_noret_decl(f_20921)
static void C_ccall f_20921(C_word c,C_word *av) C_noret;
C_noret_decl(f_20979)
static void f_20979(C_word t0,C_word t1) C_noret;
C_noret_decl(f_20997)
static void C_ccall f_20997(C_word c,C_word *av) C_noret;
C_noret_decl(f_21007)
static void C_ccall f_21007(C_word c,C_word *av) C_noret;
C_noret_decl(f_21043)
static void C_ccall f_21043(C_word c,C_word *av) C_noret;
C_noret_decl(f_21069)
static void C_ccall f_21069(C_word c,C_word *av) C_noret;
C_noret_decl(f_21080)
static void C_ccall f_21080(C_word c,C_word *av) C_noret;
C_noret_decl(f_21243)
static void f_21243(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_21256)
static void f_21256(C_word t0,C_word t1) C_noret;
C_noret_decl(f_21311)
static void f_21311(C_word t0,C_word t1) C_noret;
C_noret_decl(f_21349)
static void C_ccall f_21349(C_word c,C_word *av) C_noret;
C_noret_decl(f_21397)
static void C_ccall f_21397(C_word c,C_word *av) C_noret;
C_noret_decl(f_21474)
static void C_ccall f_21474(C_word c,C_word *av) C_noret;
C_noret_decl(f_21477)
static void C_ccall f_21477(C_word c,C_word *av) C_noret;
C_noret_decl(f_21489)
static void C_ccall f_21489(C_word c,C_word *av) C_noret;
C_noret_decl(f_21571)
static void C_ccall f_21571(C_word c,C_word *av) C_noret;
C_noret_decl(f_21635)
static void C_ccall f_21635(C_word c,C_word *av) C_noret;
C_noret_decl(f_21713)
static void C_ccall f_21713(C_word c,C_word *av) C_noret;
C_noret_decl(f_21723)
static void C_ccall f_21723(C_word c,C_word *av) C_noret;
C_noret_decl(f_21730)
static void f_21730(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_21962)
static void C_ccall f_21962(C_word c,C_word *av) C_noret;
C_noret_decl(f_22008)
static void C_ccall f_22008(C_word c,C_word *av) C_noret;
C_noret_decl(f_22011)
static void f_22011(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_22038)
static void f_22038(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_22062)
static void C_ccall f_22062(C_word c,C_word *av) C_noret;
C_noret_decl(f_22079)
static void f_22079(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_22195)
static void C_ccall f_22195(C_word c,C_word *av) C_noret;
C_noret_decl(f_22198)
static void C_ccall f_22198(C_word c,C_word *av) C_noret;
C_noret_decl(f_22208)
static void C_ccall f_22208(C_word c,C_word *av) C_noret;
C_noret_decl(f_22210)
static void C_ccall f_22210(C_word c,C_word *av) C_noret;
C_noret_decl(f_22216)
static void C_ccall f_22216(C_word c,C_word *av) C_noret;
C_noret_decl(f_22226)
static void C_ccall f_22226(C_word c,C_word *av) C_noret;
C_noret_decl(f_22229)
static void C_ccall f_22229(C_word c,C_word *av) C_noret;
C_noret_decl(f_22237)
static void C_ccall f_22237(C_word c,C_word *av) C_noret;
C_noret_decl(f_22239)
static void C_ccall f_22239(C_word c,C_word *av) C_noret;
C_noret_decl(f_22248)
static void C_ccall f_22248(C_word c,C_word *av) C_noret;
C_noret_decl(f_22257)
static void C_ccall f_22257(C_word c,C_word *av) C_noret;
C_noret_decl(f_22268)
static void C_ccall f_22268(C_word c,C_word *av) C_noret;
C_noret_decl(f_22270)
static void C_ccall f_22270(C_word c,C_word *av) C_noret;
C_noret_decl(f_22287)
static void C_ccall f_22287(C_word c,C_word *av) C_noret;
C_noret_decl(f_22291)
static void C_ccall f_22291(C_word c,C_word *av) C_noret;
C_noret_decl(f_22295)
static void C_ccall f_22295(C_word c,C_word *av) C_noret;
C_noret_decl(f_22299)
static void C_ccall f_22299(C_word c,C_word *av) C_noret;
C_noret_decl(f_22308)
static void C_ccall f_22308(C_word c,C_word *av) C_noret;
C_noret_decl(f_22328)
static void C_ccall f_22328(C_word c,C_word *av) C_noret;
C_noret_decl(f_22336)
static void C_ccall f_22336(C_word c,C_word *av) C_noret;
C_noret_decl(f_22351)
static void C_ccall f_22351(C_word c,C_word *av) C_noret;
C_noret_decl(f_22353)
static void f_22353(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_22378)
static void C_ccall f_22378(C_word c,C_word *av) C_noret;
C_noret_decl(f_22387)
static void C_ccall f_22387(C_word c,C_word *av) C_noret;
C_noret_decl(f_22390)
static void C_ccall f_22390(C_word c,C_word *av) C_noret;
C_noret_decl(f_22401)
static void C_ccall f_22401(C_word c,C_word *av) C_noret;
C_noret_decl(f_22403)
static void C_ccall f_22403(C_word c,C_word *av) C_noret;
C_noret_decl(f_22410)
static void C_ccall f_22410(C_word c,C_word *av) C_noret;
C_noret_decl(f_22421)
static void C_ccall f_22421(C_word c,C_word *av) C_noret;
C_noret_decl(f_22428)
static void C_ccall f_22428(C_word c,C_word *av) C_noret;
C_noret_decl(f_22452)
static void C_ccall f_22452(C_word c,C_word *av) C_noret;
C_noret_decl(f_22465)
static void f_22465(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_22486)
static void C_ccall f_22486(C_word c,C_word *av) C_noret;
C_noret_decl(f_22493)
static void C_ccall f_22493(C_word c,C_word *av) C_noret;
C_noret_decl(f_22498)
static void f_22498(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_22511)
static void C_ccall f_22511(C_word c,C_word *av) C_noret;
C_noret_decl(f_22525)
static void C_ccall f_22525(C_word c,C_word *av) C_noret;
C_noret_decl(f_22549)
static void C_ccall f_22549(C_word c,C_word *av) C_noret;
C_noret_decl(f_22555)
static void C_ccall f_22555(C_word c,C_word *av) C_noret;
C_noret_decl(f_22564)
static void C_ccall f_22564(C_word c,C_word *av) C_noret;
C_noret_decl(f_22567)
static void C_ccall f_22567(C_word c,C_word *av) C_noret;
C_noret_decl(f_22570)
static void C_ccall f_22570(C_word c,C_word *av) C_noret;
C_noret_decl(f_22584)
static void C_ccall f_22584(C_word c,C_word *av) C_noret;
C_noret_decl(f_22586)
static void C_ccall f_22586(C_word c,C_word *av) C_noret;
C_noret_decl(f_22596)
static void C_ccall f_22596(C_word c,C_word *av) C_noret;
C_noret_decl(f_22626)
static void C_ccall f_22626(C_word c,C_word *av) C_noret;
C_noret_decl(f_22643)
static void C_ccall f_22643(C_word c,C_word *av) C_noret;
C_noret_decl(f_22645)
static void C_ccall f_22645(C_word c,C_word *av) C_noret;
C_noret_decl(f_22655)
static void C_ccall f_22655(C_word c,C_word *av) C_noret;
C_noret_decl(f_22661)
static void C_ccall f_22661(C_word c,C_word *av) C_noret;
C_noret_decl(f_22683)
static void C_ccall f_22683(C_word c,C_word *av) C_noret;
C_noret_decl(f_22688)
static void C_ccall f_22688(C_word c,C_word *av) C_noret;
C_noret_decl(f_22693)
static C_word f_22693(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_22714)
static void C_ccall f_22714(C_word c,C_word *av) C_noret;
C_noret_decl(f_22739)
static void C_ccall f_22739(C_word c,C_word *av) C_noret;
C_noret_decl(f_22745)
static void f_22745(C_word t0,C_word t1) C_noret;
C_noret_decl(f_22751)
static void C_ccall f_22751(C_word c,C_word *av) C_noret;
C_noret_decl(f_22754)
static void C_ccall f_22754(C_word c,C_word *av) C_noret;
C_noret_decl(f_22795)
static void C_ccall f_22795(C_word c,C_word *av) C_noret;
C_noret_decl(f_22829)
static void f_22829(C_word t0,C_word t1) C_noret;
C_noret_decl(f_22832)
static void C_ccall f_22832(C_word c,C_word *av) C_noret;
C_noret_decl(f_22835)
static void C_ccall f_22835(C_word c,C_word *av) C_noret;
C_noret_decl(f_22838)
static void C_ccall f_22838(C_word c,C_word *av) C_noret;
C_noret_decl(f_22877)
static void C_ccall f_22877(C_word c,C_word *av) C_noret;
C_noret_decl(f_22883)
static void f_22883(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_22893)
static void C_ccall f_22893(C_word c,C_word *av) C_noret;
C_noret_decl(f_22898)
static C_word f_22898(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_22935)
static void C_ccall f_22935(C_word c,C_word *av) C_noret;
C_noret_decl(f_22942)
static void C_ccall f_22942(C_word c,C_word *av) C_noret;
C_noret_decl(f_22964)
static void C_ccall f_22964(C_word c,C_word *av) C_noret;
C_noret_decl(f_22980)
static void C_ccall f_22980(C_word c,C_word *av) C_noret;
C_noret_decl(f_22985)
static C_word f_22985(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_23016)
static void C_ccall f_23016(C_word c,C_word *av) C_noret;
C_noret_decl(f_23038)
static void C_ccall f_23038(C_word c,C_word *av) C_noret;
C_noret_decl(f_23041)
static void C_ccall f_23041(C_word c,C_word *av) C_noret;
C_noret_decl(f_23046)
static void f_23046(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_23064)
static void C_ccall f_23064(C_word c,C_word *av) C_noret;
C_noret_decl(f_23102)
static void C_ccall f_23102(C_word c,C_word *av) C_noret;
C_noret_decl(f_23108)
static void C_ccall f_23108(C_word c,C_word *av) C_noret;
C_noret_decl(f_23130)
static void C_ccall f_23130(C_word c,C_word *av) C_noret;
C_noret_decl(f_23133)
static void C_ccall f_23133(C_word c,C_word *av) C_noret;
C_noret_decl(f_23138)
static C_word f_23138(C_word t0,C_word t1);
C_noret_decl(f_23189)
static void C_ccall f_23189(C_word c,C_word *av) C_noret;
C_noret_decl(f_23206)
static void f_23206(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_23213)
static void C_ccall f_23213(C_word c,C_word *av) C_noret;
C_noret_decl(f_23216)
static void C_ccall f_23216(C_word c,C_word *av) C_noret;
C_noret_decl(f_23219)
static void C_ccall f_23219(C_word c,C_word *av) C_noret;
C_noret_decl(f_23224)
static C_word f_23224(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_23296)
static void C_ccall f_23296(C_word c,C_word *av) C_noret;
C_noret_decl(f_23316)
static void f_23316(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_23329)
static void C_ccall f_23329(C_word c,C_word *av) C_noret;
C_noret_decl(f_23332)
static void C_ccall f_23332(C_word c,C_word *av) C_noret;
C_noret_decl(f_23335)
static void C_ccall f_23335(C_word c,C_word *av) C_noret;
C_noret_decl(f_23338)
static void C_ccall f_23338(C_word c,C_word *av) C_noret;
C_noret_decl(f_23357)
static C_word f_23357(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_23391)
static C_word f_23391(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_23469)
static void C_ccall f_23469(C_word c,C_word *av) C_noret;
C_noret_decl(f_23484)
static void C_ccall f_23484(C_word c,C_word *av) C_noret;
C_noret_decl(f_23487)
static void C_ccall f_23487(C_word c,C_word *av) C_noret;
C_noret_decl(f_23492)
static void f_23492(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_23502)
static void C_ccall f_23502(C_word c,C_word *av) C_noret;
C_noret_decl(f_23532)
static C_word f_23532(C_word t0,C_word t1);
C_noret_decl(f_23556)
static void f_23556(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_23590)
static C_word f_23590(C_word t0);
C_noret_decl(f_23613)
static void C_ccall f_23613(C_word c,C_word *av) C_noret;
C_noret_decl(f_23632)
static void C_ccall f_23632(C_word c,C_word *av) C_noret;
C_noret_decl(f_23635)
static void C_ccall f_23635(C_word c,C_word *av) C_noret;
C_noret_decl(f_23638)
static void C_ccall f_23638(C_word c,C_word *av) C_noret;
C_noret_decl(f_23643)
static C_word f_23643(C_word t0,C_word t1);
C_noret_decl(f_23676)
static void C_ccall f_23676(C_word c,C_word *av) C_noret;
C_noret_decl(f_23697)
static void f_23697(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_23701)
static void C_ccall f_23701(C_word c,C_word *av) C_noret;
C_noret_decl(f_23704)
static void C_ccall f_23704(C_word c,C_word *av) C_noret;
C_noret_decl(f_23709)
static C_word f_23709(C_word t0,C_word t1);
C_noret_decl(f_23736)
static void C_ccall f_23736(C_word c,C_word *av) C_noret;
C_noret_decl(f_23752)
static void f_23752(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_23768)
static void C_ccall f_23768(C_word c,C_word *av) C_noret;
C_noret_decl(f_23785)
static void C_ccall f_23785(C_word c,C_word *av) C_noret;
C_noret_decl(f_23799)
static void f_23799(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_23815)
static void C_ccall f_23815(C_word c,C_word *av) C_noret;
C_noret_decl(f_23828)
static void C_ccall f_23828(C_word c,C_word *av) C_noret;
C_noret_decl(f_23842)
static void f_23842(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_23858)
static void C_ccall f_23858(C_word c,C_word *av) C_noret;
C_noret_decl(f_23871)
static void C_ccall f_23871(C_word c,C_word *av) C_noret;
C_noret_decl(f_23885)
static void f_23885(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_23901)
static void C_ccall f_23901(C_word c,C_word *av) C_noret;
C_noret_decl(f_23914)
static void C_ccall f_23914(C_word c,C_word *av) C_noret;
C_noret_decl(f_23928)
static void f_23928(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_23944)
static void C_ccall f_23944(C_word c,C_word *av) C_noret;
C_noret_decl(f_23959)
static void C_ccall f_23959(C_word c,C_word *av) C_noret;
C_noret_decl(f_23961)
static void f_23961(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_23974)
static C_word f_23974(C_word t0,C_word t1);
C_noret_decl(f_24002)
static void C_ccall f_24002(C_word c,C_word *av) C_noret;
C_noret_decl(f_24015)
static void C_ccall f_24015(C_word c,C_word *av) C_noret;
C_noret_decl(f_24033)
static void C_ccall f_24033(C_word c,C_word *av) C_noret;
C_noret_decl(f_24036)
static void C_ccall f_24036(C_word c,C_word *av) C_noret;
C_noret_decl(f_24119)
static void C_ccall f_24119(C_word c,C_word *av) C_noret;
C_noret_decl(f_24122)
static void C_ccall f_24122(C_word c,C_word *av) C_noret;
C_noret_decl(f_24125)
static void C_ccall f_24125(C_word c,C_word *av) C_noret;
C_noret_decl(f_24128)
static void C_ccall f_24128(C_word c,C_word *av) C_noret;
C_noret_decl(f_24131)
static void C_ccall f_24131(C_word c,C_word *av) C_noret;
C_noret_decl(f_24134)
static void C_ccall f_24134(C_word c,C_word *av) C_noret;
C_noret_decl(f_24137)
static void C_ccall f_24137(C_word c,C_word *av) C_noret;
C_noret_decl(f_24140)
static void C_ccall f_24140(C_word c,C_word *av) C_noret;
C_noret_decl(f_24143)
static void C_ccall f_24143(C_word c,C_word *av) C_noret;
C_noret_decl(f_24146)
static void C_ccall f_24146(C_word c,C_word *av) C_noret;
C_noret_decl(f_24149)
static void C_ccall f_24149(C_word c,C_word *av) C_noret;
C_noret_decl(f_24152)
static void C_ccall f_24152(C_word c,C_word *av) C_noret;
C_noret_decl(f_24155)
static void C_ccall f_24155(C_word c,C_word *av) C_noret;
C_noret_decl(f_24158)
static void C_ccall f_24158(C_word c,C_word *av) C_noret;
C_noret_decl(f_24163)
static void C_ccall f_24163(C_word c,C_word *av) C_noret;
C_noret_decl(f_24169)
static void f_24169(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_24185)
static void C_ccall f_24185(C_word c,C_word *av) C_noret;
C_noret_decl(f_24201)
static void C_ccall f_24201(C_word c,C_word *av) C_noret;
C_noret_decl(f_24207)
static void f_24207(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_24227)
static void C_ccall f_24227(C_word c,C_word *av) C_noret;
C_noret_decl(f_24231)
static void C_ccall f_24231(C_word c,C_word *av) C_noret;
C_noret_decl(f_24243)
static void C_ccall f_24243(C_word c,C_word *av) C_noret;
C_noret_decl(f_24249)
static void C_ccall f_24249(C_word c,C_word *av) C_noret;
C_noret_decl(f_24255)
static void f_24255(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_24287)
static void C_ccall f_24287(C_word c,C_word *av) C_noret;
C_noret_decl(f_24291)
static void C_ccall f_24291(C_word c,C_word *av) C_noret;
C_noret_decl(f_24301)
static void C_ccall f_24301(C_word c,C_word *av) C_noret;
C_noret_decl(f_24316)
static void f_24316(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_24326)
static void C_ccall f_24326(C_word c,C_word *av) C_noret;
C_noret_decl(f_24346)
static void f_24346(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_24353)
static void C_ccall f_24353(C_word c,C_word *av) C_noret;
C_noret_decl(f_24362)
static void C_ccall f_24362(C_word c,C_word *av) C_noret;
C_noret_decl(f_24369)
static void C_ccall f_24369(C_word c,C_word *av) C_noret;
C_noret_decl(f_24371)
static void C_ccall f_24371(C_word c,C_word *av) C_noret;
C_noret_decl(f_24377)
static void C_ccall f_24377(C_word c,C_word *av) C_noret;
C_noret_decl(f_24383)
static void C_ccall f_24383(C_word c,C_word *av) C_noret;
C_noret_decl(f_24401)
static void f_24401(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_24426)
static void C_ccall f_24426(C_word c,C_word *av) C_noret;
C_noret_decl(f_24442)
static void f_24442(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_24449)
static void C_ccall f_24449(C_word c,C_word *av) C_noret;
C_noret_decl(f_24462)
static void C_ccall f_24462(C_word c,C_word *av) C_noret;
C_noret_decl(f_24466)
static void C_ccall f_24466(C_word c,C_word *av) C_noret;
C_noret_decl(f_24470)
static void C_ccall f_24470(C_word c,C_word *av) C_noret;
C_noret_decl(f_24472)
static void C_ccall f_24472(C_word c,C_word *av) C_noret;
C_noret_decl(f_24478)
static void C_ccall f_24478(C_word c,C_word *av) C_noret;
C_noret_decl(f_24485)
static void C_ccall f_24485(C_word c,C_word *av) C_noret;
C_noret_decl(f_24489)
static void C_ccall f_24489(C_word c,C_word *av) C_noret;
C_noret_decl(f_24498)
static void C_ccall f_24498(C_word c,C_word *av) C_noret;
C_noret_decl(f_24506)
static void C_ccall f_24506(C_word c,C_word *av) C_noret;
C_noret_decl(f_24516)
static void C_ccall f_24516(C_word c,C_word *av) C_noret;
C_noret_decl(f_24522)
static void C_ccall f_24522(C_word c,C_word *av) C_noret;
C_noret_decl(f_24525)
static void C_ccall f_24525(C_word c,C_word *av) C_noret;
C_noret_decl(f_24529)
static void C_ccall f_24529(C_word c,C_word *av) C_noret;
C_noret_decl(f_24556)
static void f_24556(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_24572)
static void C_ccall f_24572(C_word c,C_word *av) C_noret;
C_noret_decl(f_24578)
static void C_ccall f_24578(C_word c,C_word *av) C_noret;
C_noret_decl(f_24601)
static void C_ccall f_24601(C_word c,C_word *av) C_noret;
C_noret_decl(f_24614)
static void C_ccall f_24614(C_word c,C_word *av) C_noret;
C_noret_decl(f_24618)
static void C_ccall f_24618(C_word c,C_word *av) C_noret;
C_noret_decl(f_24627)
static void C_ccall f_24627(C_word c,C_word *av) C_noret;
C_noret_decl(f_24673)
static void C_ccall f_24673(C_word c,C_word *av) C_noret;
C_noret_decl(f_24677)
static void C_ccall f_24677(C_word c,C_word *av) C_noret;
C_noret_decl(f_24681)
static void C_ccall f_24681(C_word c,C_word *av) C_noret;
C_noret_decl(f_24684)
static void C_ccall f_24684(C_word c,C_word *av) C_noret;
C_noret_decl(f_24687)
static void C_ccall f_24687(C_word c,C_word *av) C_noret;
C_noret_decl(f_24690)
static void C_ccall f_24690(C_word c,C_word *av) C_noret;
C_noret_decl(f_24692)
static void C_ccall f_24692(C_word c,C_word *av) C_noret;
C_noret_decl(f_24703)
static void C_ccall f_24703(C_word c,C_word *av) C_noret;
C_noret_decl(f_24714)
static void C_ccall f_24714(C_word c,C_word *av) C_noret;
C_noret_decl(f_24725)
static void C_ccall f_24725(C_word c,C_word *av) C_noret;
C_noret_decl(f_24736)
static void C_ccall f_24736(C_word c,C_word *av) C_noret;
C_noret_decl(f_24749)
static void C_ccall f_24749(C_word c,C_word *av) C_noret;
C_noret_decl(f_24751)
static C_word f_24751(C_word t0,C_word t1);
C_noret_decl(f_24757)
static C_word f_24757(C_word t0);
C_noret_decl(f_24762)
static C_word f_24762(C_word t0);
C_noret_decl(f_24797)
static void C_ccall f_24797(C_word c,C_word *av) C_noret;
C_noret_decl(f_24810)
static void C_ccall f_24810(C_word c,C_word *av) C_noret;
C_noret_decl(f_24812)
static C_word f_24812(C_word t0,C_word t1);
C_noret_decl(f_24818)
static C_word f_24818(C_word t0);
C_noret_decl(f_24823)
static C_word f_24823(C_word t0);
C_noret_decl(f_24858)
static void C_ccall f_24858(C_word c,C_word *av) C_noret;
C_noret_decl(f_24871)
static void C_ccall f_24871(C_word c,C_word *av) C_noret;
C_noret_decl(f_24873)
static C_word f_24873(C_word t0,C_word t1);
C_noret_decl(f_24879)
static C_word f_24879(C_word t0);
C_noret_decl(f_24884)
static C_word f_24884(C_word t0);
C_noret_decl(f_24919)
static void C_ccall f_24919(C_word c,C_word *av) C_noret;
C_noret_decl(f_24931)
static void C_ccall f_24931(C_word c,C_word *av) C_noret;
C_noret_decl(f_24933)
static void C_ccall f_24933(C_word c,C_word *av) C_noret;
C_noret_decl(f_24939)
static void C_ccall f_24939(C_word c,C_word *av) C_noret;
C_noret_decl(f_24946)
static void f_24946(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_24956)
static void C_ccall f_24956(C_word c,C_word *av) C_noret;
C_noret_decl(f_24959)
static void C_ccall f_24959(C_word c,C_word *av) C_noret;
C_noret_decl(f_24962)
static void C_ccall f_24962(C_word c,C_word *av) C_noret;
C_noret_decl(f_24968)
static void C_ccall f_24968(C_word c,C_word *av) C_noret;
C_noret_decl(f_24971)
static void C_ccall f_24971(C_word c,C_word *av) C_noret;
C_noret_decl(f_24978)
static void C_ccall f_24978(C_word c,C_word *av) C_noret;
C_noret_decl(f_24982)
static void C_ccall f_24982(C_word c,C_word *av) C_noret;
C_noret_decl(f_24986)
static void C_ccall f_24986(C_word c,C_word *av) C_noret;
C_noret_decl(f_24990)
static void C_ccall f_24990(C_word c,C_word *av) C_noret;
C_noret_decl(f_24996)
static void f_24996(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_25009)
static void C_ccall f_25009(C_word c,C_word *av) C_noret;
C_noret_decl(f_25053)
static void f_25053(C_word t0,C_word t1) C_noret;
C_noret_decl(f_25063)
static void f_25063(C_word t0,C_word t1) C_noret;
C_noret_decl(f_25176)
static void f_25176(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_25180)
static void C_ccall f_25180(C_word c,C_word *av) C_noret;
C_noret_decl(f_25213)
static void C_ccall f_25213(C_word c,C_word *av) C_noret;
C_noret_decl(f_25219)
static void C_ccall f_25219(C_word c,C_word *av) C_noret;
C_noret_decl(f_25225)
static void C_ccall f_25225(C_word c,C_word *av) C_noret;
C_noret_decl(f_25231)
static void C_ccall f_25231(C_word c,C_word *av) C_noret;
C_noret_decl(f_25237)
static void C_ccall f_25237(C_word c,C_word *av) C_noret;
C_noret_decl(f_25241)
static void C_ccall f_25241(C_word c,C_word *av) C_noret;
C_noret_decl(f_25246)
static void C_ccall f_25246(C_word c,C_word *av) C_noret;
C_noret_decl(f_25252)
static void C_ccall f_25252(C_word c,C_word *av) C_noret;
C_noret_decl(f_25256)
static void C_ccall f_25256(C_word c,C_word *av) C_noret;
C_noret_decl(f_25261)
static void C_ccall f_25261(C_word c,C_word *av) C_noret;
C_noret_decl(f_25265)
static void C_ccall f_25265(C_word c,C_word *av) C_noret;
C_noret_decl(f_25270)
static void C_ccall f_25270(C_word c,C_word *av) C_noret;
C_noret_decl(f_25276)
static void C_ccall f_25276(C_word c,C_word *av) C_noret;
C_noret_decl(f_25280)
static void C_ccall f_25280(C_word c,C_word *av) C_noret;
C_noret_decl(f_25285)
static void C_ccall f_25285(C_word c,C_word *av) C_noret;
C_noret_decl(f_25289)
static void C_ccall f_25289(C_word c,C_word *av) C_noret;
C_noret_decl(f_25294)
static void C_ccall f_25294(C_word c,C_word *av) C_noret;
C_noret_decl(f_25299)
static void C_ccall f_25299(C_word c,C_word *av) C_noret;
C_noret_decl(f_25305)
static void C_ccall f_25305(C_word c,C_word *av) C_noret;
C_noret_decl(f_25309)
static void C_ccall f_25309(C_word c,C_word *av) C_noret;
C_noret_decl(f_25314)
static void C_ccall f_25314(C_word c,C_word *av) C_noret;
C_noret_decl(f_25319)
static void C_ccall f_25319(C_word c,C_word *av) C_noret;
C_noret_decl(f_25323)
static void C_ccall f_25323(C_word c,C_word *av) C_noret;
C_noret_decl(f_25328)
static void C_ccall f_25328(C_word c,C_word *av) C_noret;
C_noret_decl(f_25333)
static void C_ccall f_25333(C_word c,C_word *av) C_noret;
C_noret_decl(f_25339)
static void C_ccall f_25339(C_word c,C_word *av) C_noret;
C_noret_decl(f_25343)
static void C_ccall f_25343(C_word c,C_word *av) C_noret;
C_noret_decl(f_25348)
static void C_ccall f_25348(C_word c,C_word *av) C_noret;
C_noret_decl(f_25353)
static void C_ccall f_25353(C_word c,C_word *av) C_noret;
C_noret_decl(f_25358)
static void C_ccall f_25358(C_word c,C_word *av) C_noret;
C_noret_decl(f_25379)
static void C_ccall f_25379(C_word c,C_word *av) C_noret;
C_noret_decl(f_25386)
static void C_ccall f_25386(C_word c,C_word *av) C_noret;
C_noret_decl(f_25392)
static void C_ccall f_25392(C_word c,C_word *av) C_noret;
C_noret_decl(f_25410)
static void C_ccall f_25410(C_word c,C_word *av) C_noret;
C_noret_decl(f_25419)
static void C_ccall f_25419(C_word c,C_word *av) C_noret;
C_noret_decl(f_25432)
static void f_25432(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_25440)
static void C_ccall f_25440(C_word c,C_word *av) C_noret;
C_noret_decl(f_25445)
static void f_25445(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_25482)
static void C_ccall f_25482(C_word c,C_word *av) C_noret;
C_noret_decl(f_25494)
static void C_ccall f_25494(C_word c,C_word *av) C_noret;
C_noret_decl(f_25504)
static void f_25504(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_25520)
static void C_ccall f_25520(C_word c,C_word *av) C_noret;
C_noret_decl(f_25533)
static void C_ccall f_25533(C_word c,C_word *av) C_noret;
C_noret_decl(f_25543)
static void C_ccall f_25543(C_word c,C_word *av) C_noret;
C_noret_decl(f_25549)
static void C_ccall f_25549(C_word c,C_word *av) C_noret;
C_noret_decl(f_25562)
static void C_ccall f_25562(C_word c,C_word *av) C_noret;
C_noret_decl(f_25568)
static void C_ccall f_25568(C_word c,C_word *av) C_noret;
C_noret_decl(f_25575)
static void C_ccall f_25575(C_word c,C_word *av) C_noret;
C_noret_decl(f_25582)
static void C_ccall f_25582(C_word c,C_word *av) C_noret;
C_noret_decl(f_25586)
static void C_ccall f_25586(C_word c,C_word *av) C_noret;
C_noret_decl(f_25589)
static void C_ccall f_25589(C_word c,C_word *av) C_noret;
C_noret_decl(f_25599)
static void C_ccall f_25599(C_word c,C_word *av) C_noret;
C_noret_decl(f_25603)
static void C_ccall f_25603(C_word c,C_word *av) C_noret;
C_noret_decl(f_25611)
static void C_ccall f_25611(C_word c,C_word *av) C_noret;
C_noret_decl(f_25614)
static void C_ccall f_25614(C_word c,C_word *av) C_noret;
C_noret_decl(f_25621)
static void C_ccall f_25621(C_word c,C_word *av) C_noret;
C_noret_decl(f_25624)
static void C_ccall f_25624(C_word c,C_word *av) C_noret;
C_noret_decl(f_25627)
static void C_ccall f_25627(C_word c,C_word *av) C_noret;
C_noret_decl(f_25630)
static void C_ccall f_25630(C_word c,C_word *av) C_noret;
C_noret_decl(f_25638)
static void C_ccall f_25638(C_word c,C_word *av) C_noret;
C_noret_decl(f_25646)
static void C_ccall f_25646(C_word c,C_word *av) C_noret;
C_noret_decl(f_25648)
static void C_ccall f_25648(C_word c,C_word *av) C_noret;
C_noret_decl(f_25664)
static void C_ccall f_25664(C_word c,C_word *av) C_noret;
C_noret_decl(f_25691)
static void C_ccall f_25691(C_word c,C_word *av) C_noret;
C_noret_decl(f_25695)
static void C_ccall f_25695(C_word c,C_word *av) C_noret;
C_noret_decl(f_25699)
static void C_ccall f_25699(C_word c,C_word *av) C_noret;
C_noret_decl(f_25703)
static void C_ccall f_25703(C_word c,C_word *av) C_noret;
C_noret_decl(f_25707)
static void C_ccall f_25707(C_word c,C_word *av) C_noret;
C_noret_decl(f_25711)
static void C_ccall f_25711(C_word c,C_word *av) C_noret;
C_noret_decl(f_25715)
static void C_ccall f_25715(C_word c,C_word *av) C_noret;
C_noret_decl(f_25719)
static void C_ccall f_25719(C_word c,C_word *av) C_noret;
C_noret_decl(f_25723)
static void C_ccall f_25723(C_word c,C_word *av) C_noret;
C_noret_decl(f_25727)
static void C_ccall f_25727(C_word c,C_word *av) C_noret;
C_noret_decl(f_25731)
static void C_ccall f_25731(C_word c,C_word *av) C_noret;
C_noret_decl(f_25735)
static void C_ccall f_25735(C_word c,C_word *av) C_noret;
C_noret_decl(f_25739)
static void C_ccall f_25739(C_word c,C_word *av) C_noret;
C_noret_decl(f_25743)
static void C_ccall f_25743(C_word c,C_word *av) C_noret;
C_noret_decl(f_25747)
static void C_ccall f_25747(C_word c,C_word *av) C_noret;
C_noret_decl(f_25751)
static void C_ccall f_25751(C_word c,C_word *av) C_noret;
C_noret_decl(f_25755)
static void C_ccall f_25755(C_word c,C_word *av) C_noret;
C_noret_decl(f_25759)
static void C_ccall f_25759(C_word c,C_word *av) C_noret;
C_noret_decl(f_25766)
static void C_ccall f_25766(C_word c,C_word *av) C_noret;
C_noret_decl(f_25773)
static void C_ccall f_25773(C_word c,C_word *av) C_noret;
C_noret_decl(f_25774)
static void f_25774(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_25778)
static void f_25778(C_word t0,C_word t1) C_noret;
C_noret_decl(f_25781)
static void C_ccall f_25781(C_word c,C_word *av) C_noret;
C_noret_decl(f_25797)
static void C_ccall f_25797(C_word c,C_word *av) C_noret;
C_noret_decl(f_25808)
static void f_25808(C_word t0,C_word t1) C_noret;
C_noret_decl(f_25816)
static void C_ccall f_25816(C_word c,C_word *av) C_noret;
C_noret_decl(f_25828)
static void f_25828(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_25837)
static void f_25837(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_25842)
static void f_25842(C_word t0,C_word t1) C_noret;
C_noret_decl(f_25898)
static void C_ccall f_25898(C_word c,C_word *av) C_noret;
C_noret_decl(f_25912)
static void C_ccall f_25912(C_word c,C_word *av) C_noret;
C_noret_decl(f_25924)
static void C_ccall f_25924(C_word c,C_word *av) C_noret;
C_noret_decl(f_25930)
static void C_ccall f_25930(C_word c,C_word *av) C_noret;
C_noret_decl(f_25955)
static void C_ccall f_25955(C_word c,C_word *av) C_noret;
C_noret_decl(f_25973)
static void C_ccall f_25973(C_word c,C_word *av) C_noret;
C_noret_decl(f_25977)
static void C_ccall f_25977(C_word c,C_word *av) C_noret;
C_noret_decl(f_26033)
static void C_ccall f_26033(C_word c,C_word *av) C_noret;
C_noret_decl(f_26042)
static void C_ccall f_26042(C_word c,C_word *av) C_noret;
C_noret_decl(f_26055)
static void C_ccall f_26055(C_word c,C_word *av) C_noret;
C_noret_decl(f_26067)
static void C_ccall f_26067(C_word c,C_word *av) C_noret;
C_noret_decl(f_26085)
static void C_ccall f_26085(C_word c,C_word *av) C_noret;
C_noret_decl(f_26105)
static void C_ccall f_26105(C_word c,C_word *av) C_noret;
C_noret_decl(f_26108)
static void C_ccall f_26108(C_word c,C_word *av) C_noret;
C_noret_decl(f_26113)
static void C_ccall f_26113(C_word c,C_word *av) C_noret;
C_noret_decl(f_26115)
static void C_ccall f_26115(C_word c,C_word *av) C_noret;
C_noret_decl(f_26123)
static void C_ccall f_26123(C_word c,C_word *av) C_noret;
C_noret_decl(f_26127)
static void C_ccall f_26127(C_word c,C_word *av) C_noret;
C_noret_decl(f_26131)
static void C_ccall f_26131(C_word c,C_word *av) C_noret;
C_noret_decl(f_26135)
static void C_ccall f_26135(C_word c,C_word *av) C_noret;
C_noret_decl(f_26139)
static void C_ccall f_26139(C_word c,C_word *av) C_noret;
C_noret_decl(f_26141)
static void C_ccall f_26141(C_word c,C_word *av) C_noret;
C_noret_decl(f_26149)
static void C_ccall f_26149(C_word c,C_word *av) C_noret;
C_noret_decl(f_26152)
static void C_ccall f_26152(C_word c,C_word *av) C_noret;
C_noret_decl(f_26162)
static void C_ccall f_26162(C_word c,C_word *av) C_noret;
C_noret_decl(f_26164)
static void C_ccall f_26164(C_word c,C_word *av) C_noret;
C_noret_decl(f_26172)
static void C_ccall f_26172(C_word c,C_word *av) C_noret;
C_noret_decl(f_26175)
static void C_ccall f_26175(C_word c,C_word *av) C_noret;
C_noret_decl(f_26185)
static void C_ccall f_26185(C_word c,C_word *av) C_noret;
C_noret_decl(f_26187)
static void C_ccall f_26187(C_word c,C_word *av) C_noret;
C_noret_decl(f_26194)
static void C_ccall f_26194(C_word c,C_word *av) C_noret;
C_noret_decl(f_26197)
static void C_ccall f_26197(C_word c,C_word *av) C_noret;
C_noret_decl(f_26200)
static void C_ccall f_26200(C_word c,C_word *av) C_noret;
C_noret_decl(f_26203)
static void C_ccall f_26203(C_word c,C_word *av) C_noret;
C_noret_decl(f_26205)
static void C_ccall f_26205(C_word c,C_word *av) C_noret;
C_noret_decl(f_26211)
static void f_26211(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_26220)
static void f_26220(C_word t0,C_word t1) C_noret;
C_noret_decl(f_26228)
static void C_ccall f_26228(C_word c,C_word *av) C_noret;
C_noret_decl(f_26230)
static void f_26230(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26244)
static void C_ccall f_26244(C_word c,C_word *av) C_noret;
C_noret_decl(f_26257)
static void f_26257(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26261)
static void C_ccall f_26261(C_word c,C_word *av) C_noret;
C_noret_decl(f_26266)
static void f_26266(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26270)
static void C_ccall f_26270(C_word c,C_word *av) C_noret;
C_noret_decl(f_26281)
static C_word f_26281(C_word *a,C_word t0,C_word t1,C_word t2);
C_noret_decl(f_26292)
static void f_26292(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_26296)
static void C_ccall f_26296(C_word c,C_word *av) C_noret;
C_noret_decl(f_26320)
static void f_26320(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_26326)
static void f_26326(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26336)
static void C_ccall f_26336(C_word c,C_word *av) C_noret;
C_noret_decl(f_26355)
static void C_ccall f_26355(C_word c,C_word *av) C_noret;
C_noret_decl(f_26379)
static void C_ccall f_26379(C_word c,C_word *av) C_noret;
C_noret_decl(f_26401)
static void f_26401(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26414)
static void C_ccall f_26414(C_word c,C_word *av) C_noret;
C_noret_decl(f_26434)
static void C_ccall f_26434(C_word c,C_word *av) C_noret;
C_noret_decl(f_26440)
static void f_26440(C_word t0,C_word t1) C_noret;
C_noret_decl(f_26443)
static void f_26443(C_word t0,C_word t1) C_noret;
C_noret_decl(f_26451)
static void C_ccall f_26451(C_word c,C_word *av) C_noret;
C_noret_decl(f_26453)
static void f_26453(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26466)
static void C_ccall f_26466(C_word c,C_word *av) C_noret;
C_noret_decl(f_26473)
static void C_ccall f_26473(C_word c,C_word *av) C_noret;
C_noret_decl(f_26482)
static void C_ccall f_26482(C_word c,C_word *av) C_noret;
C_noret_decl(f_26489)
static void C_ccall f_26489(C_word c,C_word *av) C_noret;
C_noret_decl(f_26491)
static void f_26491(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_26497)
static void f_26497(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_26507)
static void C_ccall f_26507(C_word c,C_word *av) C_noret;
C_noret_decl(f_26510)
static void C_ccall f_26510(C_word c,C_word *av) C_noret;
C_noret_decl(f_26520)
static void C_ccall f_26520(C_word c,C_word *av) C_noret;
C_noret_decl(f_26523)
static void C_ccall f_26523(C_word c,C_word *av) C_noret;
C_noret_decl(f_26551)
static void f_26551(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26554)
static void f_26554(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26558)
static void C_ccall f_26558(C_word c,C_word *av) C_noret;
C_noret_decl(f_26561)
static void C_ccall f_26561(C_word c,C_word *av) C_noret;
C_noret_decl(f_26571)
static void C_ccall f_26571(C_word c,C_word *av) C_noret;
C_noret_decl(f_26573)
static C_word f_26573(C_word t0);
C_noret_decl(f_26577)
static void f_26577(C_word t0,C_word t1) C_noret;
C_noret_decl(f_26586)
static void f_26586(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26590)
static void C_ccall f_26590(C_word c,C_word *av) C_noret;
C_noret_decl(f_26608)
static void C_ccall f_26608(C_word c,C_word *av) C_noret;
C_noret_decl(f_26629)
static void C_ccall f_26629(C_word c,C_word *av) C_noret;
C_noret_decl(f_26641)
static void f_26641(C_word t0,C_word t1) C_noret;
C_noret_decl(f_26652)
static void C_ccall f_26652(C_word c,C_word *av) C_noret;
C_noret_decl(f_26655)
static void C_ccall f_26655(C_word c,C_word *av) C_noret;
C_noret_decl(f_26691)
static void f_26691(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_26699)
static void C_ccall f_26699(C_word c,C_word *av) C_noret;
C_noret_decl(f_26701)
static void f_26701(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_26718)
static void C_ccall f_26718(C_word c,C_word *av) C_noret;
C_noret_decl(f_26731)
static void C_ccall f_26731(C_word c,C_word *av) C_noret;
C_noret_decl(f_26748)
static void C_ccall f_26748(C_word c,C_word *av) C_noret;
C_noret_decl(f_26765)
static void C_ccall f_26765(C_word c,C_word *av) C_noret;
C_noret_decl(f_26782)
static void C_ccall f_26782(C_word c,C_word *av) C_noret;
C_noret_decl(f_26799)
static void C_ccall f_26799(C_word c,C_word *av) C_noret;
C_noret_decl(f_26816)
static void C_ccall f_26816(C_word c,C_word *av) C_noret;
C_noret_decl(f_26833)
static void C_ccall f_26833(C_word c,C_word *av) C_noret;
C_noret_decl(f_26853)
static void C_ccall f_26853(C_word c,C_word *av) C_noret;
C_noret_decl(f_26861)
static void C_ccall f_26861(C_word c,C_word *av) C_noret;
C_noret_decl(f_26870)
static void C_ccall f_26870(C_word c,C_word *av) C_noret;
C_noret_decl(f_26877)
static void C_ccall f_26877(C_word c,C_word *av) C_noret;
C_noret_decl(f_26894)
static void C_ccall f_26894(C_word c,C_word *av) C_noret;
C_noret_decl(f_26901)
static void C_ccall f_26901(C_word c,C_word *av) C_noret;
C_noret_decl(f_26918)
static void f_26918(C_word t0,C_word t1) C_noret;
C_noret_decl(f_26925)
static void C_ccall f_26925(C_word c,C_word *av) C_noret;
C_noret_decl(f_26938)
static void f_26938(C_word t0,C_word t1) C_noret;
C_noret_decl(f_26943)
static void f_26943(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_26960)
static void C_ccall f_26960(C_word c,C_word *av) C_noret;
C_noret_decl(f_26975)
static void C_ccall f_26975(C_word c,C_word *av) C_noret;
C_noret_decl(f_26988)
static void C_ccall f_26988(C_word c,C_word *av) C_noret;
C_noret_decl(f_27010)
static void C_ccall f_27010(C_word c,C_word *av) C_noret;
C_noret_decl(f_27013)
static void C_ccall f_27013(C_word c,C_word *av) C_noret;
C_noret_decl(f_27042)
static void f_27042(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27052)
static void C_ccall f_27052(C_word c,C_word *av) C_noret;
C_noret_decl(f_27068)
static void C_ccall f_27068(C_word c,C_word *av) C_noret;
C_noret_decl(f_27079)
static void C_ccall f_27079(C_word c,C_word *av) C_noret;
C_noret_decl(f_27086)
static void C_ccall f_27086(C_word c,C_word *av) C_noret;
C_noret_decl(f_27184)
static void C_ccall f_27184(C_word c,C_word *av) C_noret;
C_noret_decl(f_27190)
static void f_27190(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_27199)
static void f_27199(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_27213)
static void C_ccall f_27213(C_word c,C_word *av) C_noret;
C_noret_decl(f_27216)
static void C_ccall f_27216(C_word c,C_word *av) C_noret;
C_noret_decl(f_27227)
static void C_ccall f_27227(C_word c,C_word *av) C_noret;
C_noret_decl(f_27229)
static void C_ccall f_27229(C_word c,C_word *av) C_noret;
C_noret_decl(f_27232)
static void C_ccall f_27232(C_word c,C_word *av) C_noret;
C_noret_decl(f_27249)
static void C_ccall f_27249(C_word c,C_word *av) C_noret;
C_noret_decl(f_27254)
static void f_27254(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_27258)
static void C_ccall f_27258(C_word c,C_word *av) C_noret;
C_noret_decl(f_27261)
static void f_27261(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27264)
static void C_ccall f_27264(C_word c,C_word *av) C_noret;
C_noret_decl(f_27274)
static void C_ccall f_27274(C_word c,C_word *av) C_noret;
C_noret_decl(f_27292)
static void C_ccall f_27292(C_word c,C_word *av) C_noret;
C_noret_decl(f_27295)
static void C_ccall f_27295(C_word c,C_word *av) C_noret;
C_noret_decl(f_27304)
static void f_27304(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27307)
static void C_ccall f_27307(C_word c,C_word *av) C_noret;
C_noret_decl(f_27310)
static void C_ccall f_27310(C_word c,C_word *av) C_noret;
C_noret_decl(f_27316)
static void C_ccall f_27316(C_word c,C_word *av) C_noret;
C_noret_decl(f_27329)
static void C_ccall f_27329(C_word c,C_word *av) C_noret;
C_noret_decl(f_27333)
static void C_ccall f_27333(C_word c,C_word *av) C_noret;
C_noret_decl(f_27337)
static void C_ccall f_27337(C_word c,C_word *av) C_noret;
C_noret_decl(f_27348)
static void C_ccall f_27348(C_word c,C_word *av) C_noret;
C_noret_decl(f_27352)
static void C_ccall f_27352(C_word c,C_word *av) C_noret;
C_noret_decl(f_27355)
static void C_ccall f_27355(C_word c,C_word *av) C_noret;
C_noret_decl(f_27383)
static void C_ccall f_27383(C_word c,C_word *av) C_noret;
C_noret_decl(f_27438)
static void C_ccall f_27438(C_word c,C_word *av) C_noret;
C_noret_decl(f_27442)
static void C_ccall f_27442(C_word c,C_word *av) C_noret;
C_noret_decl(f_27449)
static void C_ccall f_27449(C_word c,C_word *av) C_noret;
C_noret_decl(f_27451)
static void f_27451(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27455)
static void C_ccall f_27455(C_word c,C_word *av) C_noret;
C_noret_decl(f_27469)
static void f_27469(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_27475)
static void C_ccall f_27475(C_word c,C_word *av) C_noret;
C_noret_decl(f_27482)
static void C_ccall f_27482(C_word c,C_word *av) C_noret;
C_noret_decl(f_27489)
static void C_ccall f_27489(C_word c,C_word *av) C_noret;
C_noret_decl(f_27509)
static void C_ccall f_27509(C_word c,C_word *av) C_noret;
C_noret_decl(f_27538)
static void f_27538(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_27548)
static void C_ccall f_27548(C_word c,C_word *av) C_noret;
C_noret_decl(f_27551)
static void C_ccall f_27551(C_word c,C_word *av) C_noret;
C_noret_decl(f_27587)
static void C_ccall f_27587(C_word c,C_word *av) C_noret;
C_noret_decl(f_27589)
static void f_27589(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_27599)
static void C_ccall f_27599(C_word c,C_word *av) C_noret;
C_noret_decl(f_27602)
static void C_ccall f_27602(C_word c,C_word *av) C_noret;
C_noret_decl(f_27654)
static void C_ccall f_27654(C_word c,C_word *av) C_noret;
C_noret_decl(f_27656)
static void f_27656(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27664)
static void C_ccall f_27664(C_word c,C_word *av) C_noret;
C_noret_decl(f_27666)
static void f_27666(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_27676)
static void f_27676(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27691)
static void C_ccall f_27691(C_word c,C_word *av) C_noret;
C_noret_decl(f_27698)
static void C_ccall f_27698(C_word c,C_word *av) C_noret;
C_noret_decl(f_27718)
static void f_27718(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27726)
static void C_ccall f_27726(C_word c,C_word *av) C_noret;
C_noret_decl(f_27728)
static void f_27728(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_27744)
static void C_ccall f_27744(C_word c,C_word *av) C_noret;
C_noret_decl(f_27751)
static void C_ccall f_27751(C_word c,C_word *av) C_noret;
C_noret_decl(f_27764)
static void f_27764(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27770)
static void C_ccall f_27770(C_word c,C_word *av) C_noret;
C_noret_decl(f_27774)
static void C_ccall f_27774(C_word c,C_word *av) C_noret;
C_noret_decl(f_27781)
static void C_ccall f_27781(C_word c,C_word *av) C_noret;
C_noret_decl(f_27789)
static void f_27789(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_27794)
static void f_27794(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27799)
static void f_27799(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_27803)
static void C_ccall f_27803(C_word c,C_word *av) C_noret;
C_noret_decl(f_27812)
static void f_27812(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27818)
static void f_27818(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27825)
static void C_ccall f_27825(C_word c,C_word *av) C_noret;
C_noret_decl(f_27842)
static void C_ccall f_27842(C_word c,C_word *av) C_noret;
C_noret_decl(f_27848)
static void f_27848(C_word t0,C_word t1) C_noret;
C_noret_decl(f_27858)
static void C_ccall f_27858(C_word c,C_word *av) C_noret;
C_noret_decl(f_27909)
static void C_ccall f_27909(C_word c,C_word *av) C_noret;
C_noret_decl(f_27918)
static void C_ccall f_27918(C_word c,C_word *av) C_noret;
C_noret_decl(f_27925)
static void C_ccall f_27925(C_word c,C_word *av) C_noret;
C_noret_decl(f_27929)
static void C_ccall f_27929(C_word c,C_word *av) C_noret;
C_noret_decl(f_27933)
static void C_ccall f_27933(C_word c,C_word *av) C_noret;
C_noret_decl(f_27942)
static void C_ccall f_27942(C_word c,C_word *av) C_noret;
C_noret_decl(f_27953)
static void C_ccall f_27953(C_word c,C_word *av) C_noret;
C_noret_decl(f_27975)
static void C_ccall f_27975(C_word c,C_word *av) C_noret;
C_noret_decl(f_28002)
static void C_ccall f_28002(C_word c,C_word *av) C_noret;
C_noret_decl(f_28034)
static void C_ccall f_28034(C_word c,C_word *av) C_noret;
C_noret_decl(f_28038)
static void C_ccall f_28038(C_word c,C_word *av) C_noret;
C_noret_decl(f_28040)
static void f_28040(C_word t0,C_word t1) C_noret;
C_noret_decl(f_28044)
static void C_ccall f_28044(C_word c,C_word *av) C_noret;
C_noret_decl(f_28047)
static void C_ccall f_28047(C_word c,C_word *av) C_noret;
C_noret_decl(f_28059)
static void C_ccall f_28059(C_word c,C_word *av) C_noret;
C_noret_decl(f_28079)
static void f_28079(C_word t0,C_word t1) C_noret;
C_noret_decl(f_28085)
static void C_ccall f_28085(C_word c,C_word *av) C_noret;
C_noret_decl(f_28095)
static void C_ccall f_28095(C_word c,C_word *av) C_noret;
C_noret_decl(f_28232)
static void f_28232(C_word t0,C_word t1) C_noret;
C_noret_decl(f_28239)
static void C_ccall f_28239(C_word c,C_word *av) C_noret;
C_noret_decl(f_28257)
static void f_28257(C_word t0,C_word t1) C_noret;
C_noret_decl(f_28263)
static void f_28263(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_28267)
static void C_ccall f_28267(C_word c,C_word *av) C_noret;
C_noret_decl(f_28303)
static void C_ccall f_28303(C_word c,C_word *av) C_noret;
C_noret_decl(f_28326)
static void C_ccall f_28326(C_word c,C_word *av) C_noret;
C_noret_decl(f_28344)
static void f_28344(C_word t0,C_word t1) C_noret;
C_noret_decl(f_28348)
static void C_ccall f_28348(C_word c,C_word *av) C_noret;
C_noret_decl(f_28355)
static void C_ccall f_28355(C_word c,C_word *av) C_noret;
C_noret_decl(f_28357)
static void f_28357(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_28361)
static void C_ccall f_28361(C_word c,C_word *av) C_noret;
C_noret_decl(f_28372)
static void C_ccall f_28372(C_word c,C_word *av) C_noret;
C_noret_decl(f_28392)
static void C_ccall f_28392(C_word c,C_word *av) C_noret;
C_noret_decl(f_28395)
static void C_ccall f_28395(C_word c,C_word *av) C_noret;
C_noret_decl(f_28398)
static void C_ccall f_28398(C_word c,C_word *av) C_noret;
C_noret_decl(f_28412)
static void C_ccall f_28412(C_word c,C_word *av) C_noret;
C_noret_decl(f_28418)
static void C_ccall f_28418(C_word c,C_word *av) C_noret;
C_noret_decl(f_28440)
static void C_ccall f_28440(C_word c,C_word *av) C_noret;
C_noret_decl(f_28452)
static void C_ccall f_28452(C_word c,C_word *av) C_noret;
C_noret_decl(f_28464)
static void C_ccall f_28464(C_word c,C_word *av) C_noret;
C_noret_decl(f_28473)
static void C_ccall f_28473(C_word c,C_word *av) C_noret;
C_noret_decl(f_28483)
static void C_ccall f_28483(C_word c,C_word *av) C_noret;
C_noret_decl(f_28492)
static void C_ccall f_28492(C_word c,C_word *av) C_noret;
C_noret_decl(f_28495)
static void C_ccall f_28495(C_word c,C_word *av) C_noret;
C_noret_decl(f_28513)
static void C_ccall f_28513(C_word c,C_word *av) C_noret;
C_noret_decl(f_28516)
static void C_ccall f_28516(C_word c,C_word *av) C_noret;
C_noret_decl(f_28537)
static void C_ccall f_28537(C_word c,C_word *av) C_noret;
C_noret_decl(f_28543)
static void C_ccall f_28543(C_word c,C_word *av) C_noret;
C_noret_decl(f_28546)
static void C_ccall f_28546(C_word c,C_word *av) C_noret;
C_noret_decl(f_28556)
static void C_ccall f_28556(C_word c,C_word *av) C_noret;
C_noret_decl(f_28575)
static void f_28575(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_28583)
static void C_ccall f_28583(C_word c,C_word *av) C_noret;
C_noret_decl(f_28585)
static void C_ccall f_28585(C_word c,C_word *av) C_noret;
C_noret_decl(f_28591)
static void C_ccall f_28591(C_word c,C_word *av) C_noret;
C_noret_decl(f_28622)
static void C_ccall f_28622(C_word c,C_word *av) C_noret;
C_noret_decl(f_28645)
static void C_ccall f_28645(C_word c,C_word *av) C_noret;
C_noret_decl(f_28659)
static void C_ccall f_28659(C_word c,C_word *av) C_noret;
C_noret_decl(f_28665)
static void C_ccall f_28665(C_word c,C_word *av) C_noret;
C_noret_decl(f_28690)
static void C_ccall f_28690(C_word c,C_word *av) C_noret;
C_noret_decl(f_28702)
static void C_ccall f_28702(C_word c,C_word *av) C_noret;
C_noret_decl(f_28714)
static void C_ccall f_28714(C_word c,C_word *av) C_noret;
C_noret_decl(f_28726)
static void C_ccall f_28726(C_word c,C_word *av) C_noret;
C_noret_decl(f_28738)
static void C_ccall f_28738(C_word c,C_word *av) C_noret;
C_noret_decl(f_28750)
static void C_ccall f_28750(C_word c,C_word *av) C_noret;
C_noret_decl(f_28771)
static void C_ccall f_28771(C_word c,C_word *av) C_noret;
C_noret_decl(f_28783)
static void C_ccall f_28783(C_word c,C_word *av) C_noret;
C_noret_decl(f_28786)
static void C_ccall f_28786(C_word c,C_word *av) C_noret;
C_noret_decl(f_28798)
static void C_ccall f_28798(C_word c,C_word *av) C_noret;
C_noret_decl(f_28810)
static void C_ccall f_28810(C_word c,C_word *av) C_noret;
C_noret_decl(f_28813)
static void C_ccall f_28813(C_word c,C_word *av) C_noret;
C_noret_decl(f_28825)
static void C_ccall f_28825(C_word c,C_word *av) C_noret;
C_noret_decl(f_28837)
static void C_ccall f_28837(C_word c,C_word *av) C_noret;
C_noret_decl(f_28849)
static void C_ccall f_28849(C_word c,C_word *av) C_noret;
C_noret_decl(f_28852)
static void C_ccall f_28852(C_word c,C_word *av) C_noret;
C_noret_decl(f_28857)
static void C_ccall f_28857(C_word c,C_word *av) C_noret;
C_noret_decl(f_28862)
static void C_ccall f_28862(C_word c,C_word *av) C_noret;
C_noret_decl(f_28868)
static void C_ccall f_28868(C_word c,C_word *av) C_noret;
C_noret_decl(f_28897)
static void C_ccall f_28897(C_word c,C_word *av) C_noret;
C_noret_decl(f_28909)
static void C_ccall f_28909(C_word c,C_word *av) C_noret;
C_noret_decl(f_28912)
static void C_ccall f_28912(C_word c,C_word *av) C_noret;
C_noret_decl(f_28915)
static void C_ccall f_28915(C_word c,C_word *av) C_noret;
C_noret_decl(f_28930)
static void C_ccall f_28930(C_word c,C_word *av) C_noret;
C_noret_decl(f_28939)
static void C_ccall f_28939(C_word c,C_word *av) C_noret;
C_noret_decl(f_28942)
static void C_ccall f_28942(C_word c,C_word *av) C_noret;
C_noret_decl(f_28948)
static void f_28948(C_word t0,C_word t1) C_noret;
C_noret_decl(f_28951)
static void C_ccall f_28951(C_word c,C_word *av) C_noret;
C_noret_decl(f_28957)
static void C_ccall f_28957(C_word c,C_word *av) C_noret;
C_noret_decl(f_29004)
static void C_ccall f_29004(C_word c,C_word *av) C_noret;
C_noret_decl(f_29023)
static void C_ccall f_29023(C_word c,C_word *av) C_noret;
C_noret_decl(f_29039)
static void C_ccall f_29039(C_word c,C_word *av) C_noret;
C_noret_decl(f_29045)
static void C_ccall f_29045(C_word c,C_word *av) C_noret;
C_noret_decl(f_29115)
static void C_ccall f_29115(C_word c,C_word *av) C_noret;
C_noret_decl(f_29127)
static void C_ccall f_29127(C_word c,C_word *av) C_noret;
C_noret_decl(f_29205)
static void C_ccall f_29205(C_word c,C_word *av) C_noret;
C_noret_decl(f_29279)
static void C_ccall f_29279(C_word c,C_word *av) C_noret;
C_noret_decl(f_29282)
static void C_ccall f_29282(C_word c,C_word *av) C_noret;
C_noret_decl(f_29285)
static void C_ccall f_29285(C_word c,C_word *av) C_noret;
C_noret_decl(f_29293)
static void C_ccall f_29293(C_word c,C_word *av) C_noret;
C_noret_decl(f_29303)
static void C_ccall f_29303(C_word c,C_word *av) C_noret;
C_noret_decl(f_29308)
static void C_ccall f_29308(C_word c,C_word *av) C_noret;
C_noret_decl(f_29311)
static void f_29311(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_29324)
static void f_29324(C_word t0,C_word t1) C_noret;
C_noret_decl(f_29327)
static void C_ccall f_29327(C_word c,C_word *av) C_noret;
C_noret_decl(f_29363)
static void C_ccall f_29363(C_word c,C_word *av) C_noret;
C_noret_decl(f_29379)
static void C_ccall f_29379(C_word c,C_word *av) C_noret;
C_noret_decl(f_29429)
static void C_ccall f_29429(C_word c,C_word *av) C_noret;
C_noret_decl(f_29433)
static void C_ccall f_29433(C_word c,C_word *av) C_noret;
C_noret_decl(f_29460)
static void C_ccall f_29460(C_word c,C_word *av) C_noret;
C_noret_decl(f_29466)
static void f_29466(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_29482)
static void f_29482(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_29522)
static void C_ccall f_29522(C_word c,C_word *av) C_noret;
C_noret_decl(f_29524)
static void f_29524(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_29531)
static void f_29531(C_word t0,C_word t1) C_noret;
C_noret_decl(f_29588)
static void C_ccall f_29588(C_word c,C_word *av) C_noret;
C_noret_decl(f_29595)
static void C_ccall f_29595(C_word c,C_word *av) C_noret;
C_noret_decl(f_29604)
static void C_ccall f_29604(C_word c,C_word *av) C_noret;
C_noret_decl(f_29616)
static void C_ccall f_29616(C_word c,C_word *av) C_noret;
C_noret_decl(f_29637)
static void C_ccall f_29637(C_word c,C_word *av) C_noret;
C_noret_decl(f_29652)
static void C_ccall f_29652(C_word c,C_word *av) C_noret;
C_noret_decl(f_29670)
static void C_ccall f_29670(C_word c,C_word *av) C_noret;
C_noret_decl(f_29688)
static void C_ccall f_29688(C_word c,C_word *av) C_noret;
C_noret_decl(f_29707)
static void f_29707(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_29717)
static void C_ccall f_29717(C_word c,C_word *av) C_noret;
C_noret_decl(f_29731)
static void C_ccall f_29731(C_word c,C_word *av) C_noret;
C_noret_decl(f_29734)
static void C_ccall f_29734(C_word c,C_word *av) C_noret;
C_noret_decl(f_29739)
static void C_ccall f_29739(C_word c,C_word *av) C_noret;
C_noret_decl(f_29758)
static void f_29758(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_29768)
static void C_ccall f_29768(C_word c,C_word *av) C_noret;
C_noret_decl(f_29782)
static void C_ccall f_29782(C_word c,C_word *av) C_noret;
C_noret_decl(f_29785)
static void C_ccall f_29785(C_word c,C_word *av) C_noret;
C_noret_decl(f_29792)
static void C_ccall f_29792(C_word c,C_word *av) C_noret;
C_noret_decl(f_29796)
static void C_ccall f_29796(C_word c,C_word *av) C_noret;
C_noret_decl(f_29800)
static void C_ccall f_29800(C_word c,C_word *av) C_noret;
C_noret_decl(f_29802)
static void C_ccall f_29802(C_word c,C_word *av) C_noret;
C_noret_decl(f_29809)
static void C_ccall f_29809(C_word c,C_word *av) C_noret;
C_noret_decl(f_29812)
static void C_ccall f_29812(C_word c,C_word *av) C_noret;
C_noret_decl(f_29815)
static void C_ccall f_29815(C_word c,C_word *av) C_noret;
C_noret_decl(f_29818)
static void C_ccall f_29818(C_word c,C_word *av) C_noret;
C_noret_decl(f_29820)
static void f_29820(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_29830)
static void C_ccall f_29830(C_word c,C_word *av) C_noret;
C_noret_decl(f_29836)
static void C_ccall f_29836(C_word c,C_word *av) C_noret;
C_noret_decl(f_29848)
static void C_ccall f_29848(C_word c,C_word *av) C_noret;
C_noret_decl(f_29851)
static void C_ccall f_29851(C_word c,C_word *av) C_noret;
C_noret_decl(f_29854)
static void C_ccall f_29854(C_word c,C_word *av) C_noret;
C_noret_decl(f_29871)
static void C_ccall f_29871(C_word c,C_word *av) C_noret;
C_noret_decl(f_29879)
static void f_29879(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_29903)
static void f_29903(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_29907)
static void C_ccall f_29907(C_word c,C_word *av) C_noret;
C_noret_decl(f_29920)
static void C_ccall f_29920(C_word c,C_word *av) C_noret;
C_noret_decl(f_29923)
static void C_ccall f_29923(C_word c,C_word *av) C_noret;
C_noret_decl(f_29932)
static void C_ccall f_29932(C_word c,C_word *av) C_noret;
C_noret_decl(f_29935)
static void C_ccall f_29935(C_word c,C_word *av) C_noret;
C_noret_decl(f_29963)
static void f_29963(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_29967)
static void C_ccall f_29967(C_word c,C_word *av) C_noret;
C_noret_decl(f_29976)
static void C_ccall f_29976(C_word c,C_word *av) C_noret;
C_noret_decl(f_29993)
static void f_29993(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_30000)
static void C_ccall f_30000(C_word c,C_word *av) C_noret;
C_noret_decl(f_30005)
static void f_30005(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_30029)
static void C_ccall f_30029(C_word c,C_word *av) C_noret;
C_noret_decl(f_30035)
static void C_ccall f_30035(C_word c,C_word *av) C_noret;
C_noret_decl(f_30038)
static void C_ccall f_30038(C_word c,C_word *av) C_noret;
C_noret_decl(f_30049)
static void C_ccall f_30049(C_word c,C_word *av) C_noret;
C_noret_decl(f_30052)
static void C_ccall f_30052(C_word c,C_word *av) C_noret;
C_noret_decl(f_30055)
static void C_ccall f_30055(C_word c,C_word *av) C_noret;
C_noret_decl(f_30078)
static void f_30078(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_30129)
static void f_30129(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_30204)
static void f_30204(C_word t0,C_word t1) C_noret;
C_noret_decl(f_30304)
static void C_ccall f_30304(C_word c,C_word *av) C_noret;
C_noret_decl(f_30309)
static void f_30309(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_30364)
static void C_ccall f_30364(C_word c,C_word *av) C_noret;
C_noret_decl(f_30370)
static void C_ccall f_30370(C_word c,C_word *av) C_noret;
C_noret_decl(f_30374)
static void f_30374(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_30382)
static void C_ccall f_30382(C_word c,C_word *av) C_noret;
C_noret_decl(f_30397)
static void C_ccall f_30397(C_word c,C_word *av) C_noret;
C_noret_decl(f_30404)
static void C_ccall f_30404(C_word c,C_word *av) C_noret;
C_noret_decl(f_30423)
static void C_ccall f_30423(C_word c,C_word *av) C_noret;
C_noret_decl(f_30459)
static void C_ccall f_30459(C_word c,C_word *av) C_noret;
C_noret_decl(f_30471)
static void C_ccall f_30471(C_word c,C_word *av) C_noret;
C_noret_decl(f_30477)
static void C_ccall f_30477(C_word c,C_word *av) C_noret;
C_noret_decl(f_30506)
static void C_ccall f_30506(C_word c,C_word *av) C_noret;
C_noret_decl(f_30516)
static void C_ccall f_30516(C_word c,C_word *av) C_noret;
C_noret_decl(f_30525)
static void C_ccall f_30525(C_word c,C_word *av) C_noret;
C_noret_decl(f_30534)
static void f_30534(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_30550)
static void C_ccall f_30550(C_word c,C_word *av) C_noret;
C_noret_decl(f_30588)
static void C_ccall f_30588(C_word c,C_word *av) C_noret;
C_noret_decl(f_30654)
static void C_ccall f_30654(C_word c,C_word *av) C_noret;
C_noret_decl(f_30657)
static void C_ccall f_30657(C_word c,C_word *av) C_noret;
C_noret_decl(f_30660)
static void C_ccall f_30660(C_word c,C_word *av) C_noret;
C_noret_decl(f_30667)
static void C_ccall f_30667(C_word c,C_word *av) C_noret;
C_noret_decl(f_30711)
static void C_ccall f_30711(C_word c,C_word *av) C_noret;
C_noret_decl(f_30714)
static void C_ccall f_30714(C_word c,C_word *av) C_noret;
C_noret_decl(f_30723)
static void f_30723(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_30736)
static void C_ccall f_30736(C_word c,C_word *av) C_noret;
C_noret_decl(f_30745)
static void C_ccall f_30745(C_word c,C_word *av) C_noret;
C_noret_decl(f_30755)
static void C_ccall f_30755(C_word c,C_word *av) C_noret;
C_noret_decl(f_30758)
static void C_ccall f_30758(C_word c,C_word *av) C_noret;
C_noret_decl(f_30784)
static void C_ccall f_30784(C_word c,C_word *av) C_noret;
C_noret_decl(f_30791)
static void C_ccall f_30791(C_word c,C_word *av) C_noret;
C_noret_decl(f_30807)
static void C_ccall f_30807(C_word c,C_word *av) C_noret;
C_noret_decl(f_30819)
static void C_ccall f_30819(C_word c,C_word *av) C_noret;
C_noret_decl(f_30822)
static void C_ccall f_30822(C_word c,C_word *av) C_noret;
C_noret_decl(f_30829)
static void C_ccall f_30829(C_word c,C_word *av) C_noret;
C_noret_decl(f_30838)
static void C_ccall f_30838(C_word c,C_word *av) C_noret;
C_noret_decl(f_30841)
static void C_ccall f_30841(C_word c,C_word *av) C_noret;
C_noret_decl(f_30888)
static void C_ccall f_30888(C_word c,C_word *av) C_noret;
C_noret_decl(f_30891)
static void C_ccall f_30891(C_word c,C_word *av) C_noret;
C_noret_decl(f_30900)
static void f_30900(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_30913)
static void C_ccall f_30913(C_word c,C_word *av) C_noret;
C_noret_decl(f_30916)
static void C_ccall f_30916(C_word c,C_word *av) C_noret;
C_noret_decl(f_30941)
static void C_ccall f_30941(C_word c,C_word *av) C_noret;
C_noret_decl(f_30945)
static void C_ccall f_30945(C_word c,C_word *av) C_noret;
C_noret_decl(f_30955)
static void C_ccall f_30955(C_word c,C_word *av) C_noret;
C_noret_decl(f_30958)
static void C_ccall f_30958(C_word c,C_word *av) C_noret;
C_noret_decl(f_30970)
static void C_ccall f_30970(C_word c,C_word *av) C_noret;
C_noret_decl(f_30974)
static void C_ccall f_30974(C_word c,C_word *av) C_noret;
C_noret_decl(f_30996)
static void C_ccall f_30996(C_word c,C_word *av) C_noret;
C_noret_decl(f_30998)
static void C_ccall f_30998(C_word c,C_word *av) C_noret;
C_noret_decl(f_31014)
static void C_ccall f_31014(C_word c,C_word *av) C_noret;
C_noret_decl(f_31019)
static void C_ccall f_31019(C_word c,C_word *av) C_noret;
C_noret_decl(f_31025)
static void C_ccall f_31025(C_word c,C_word *av) C_noret;
C_noret_decl(f_31031)
static void C_ccall f_31031(C_word c,C_word *av) C_noret;
C_noret_decl(f_31035)
static void C_ccall f_31035(C_word c,C_word *av) C_noret;
C_noret_decl(f_31038)
static void C_ccall f_31038(C_word c,C_word *av) C_noret;
C_noret_decl(f_31053)
static void C_ccall f_31053(C_word c,C_word *av) C_noret;
C_noret_decl(f_31056)
static void C_ccall f_31056(C_word c,C_word *av) C_noret;
C_noret_decl(f_31072)
static void C_ccall f_31072(C_word c,C_word *av) C_noret;
C_noret_decl(f_31078)
static void C_ccall f_31078(C_word c,C_word *av) C_noret;
C_noret_decl(f_31087)
static void C_ccall f_31087(C_word c,C_word *av) C_noret;
C_noret_decl(f_31093)
static void C_ccall f_31093(C_word c,C_word *av) C_noret;
C_noret_decl(f_31100)
static void C_ccall f_31100(C_word c,C_word *av) C_noret;
C_noret_decl(f_31103)
static void C_ccall f_31103(C_word c,C_word *av) C_noret;
C_noret_decl(f_31106)
static void C_ccall f_31106(C_word c,C_word *av) C_noret;
C_noret_decl(f_31115)
static void C_ccall f_31115(C_word c,C_word *av) C_noret;
C_noret_decl(f_31131)
static void C_ccall f_31131(C_word c,C_word *av) C_noret;
C_noret_decl(f_31150)
static void C_ccall f_31150(C_word c,C_word *av) C_noret;
C_noret_decl(f_31156)
static void C_ccall f_31156(C_word c,C_word *av) C_noret;
C_noret_decl(f_31162)
static void C_ccall f_31162(C_word c,C_word *av) C_noret;
C_noret_decl(f_31166)
static void C_ccall f_31166(C_word c,C_word *av) C_noret;
C_noret_decl(f_31169)
static void C_ccall f_31169(C_word c,C_word *av) C_noret;
C_noret_decl(f_31172)
static void C_ccall f_31172(C_word c,C_word *av) C_noret;
C_noret_decl(f_31176)
static void C_ccall f_31176(C_word c,C_word *av) C_noret;
C_noret_decl(f_31180)
static void C_ccall f_31180(C_word c,C_word *av) C_noret;
C_noret_decl(f_31184)
static void C_ccall f_31184(C_word c,C_word *av) C_noret;
C_noret_decl(f_31187)
static void C_ccall f_31187(C_word c,C_word *av) C_noret;
C_noret_decl(f_31190)
static void C_ccall f_31190(C_word c,C_word *av) C_noret;
C_noret_decl(f_31193)
static void C_ccall f_31193(C_word c,C_word *av) C_noret;
C_noret_decl(f_31205)
static void C_ccall f_31205(C_word c,C_word *av) C_noret;
C_noret_decl(f_31211)
static void C_ccall f_31211(C_word c,C_word *av) C_noret;
C_noret_decl(f_31215)
static void C_ccall f_31215(C_word c,C_word *av) C_noret;
C_noret_decl(f_31218)
static void C_ccall f_31218(C_word c,C_word *av) C_noret;
C_noret_decl(f_31221)
static void C_ccall f_31221(C_word c,C_word *av) C_noret;
C_noret_decl(f_31224)
static void C_ccall f_31224(C_word c,C_word *av) C_noret;
C_noret_decl(f_31227)
static void C_ccall f_31227(C_word c,C_word *av) C_noret;
C_noret_decl(f_31230)
static void C_ccall f_31230(C_word c,C_word *av) C_noret;
C_noret_decl(f_31235)
static void C_ccall f_31235(C_word c,C_word *av) C_noret;
C_noret_decl(f_31257)
static void C_ccall f_31257(C_word c,C_word *av) C_noret;
C_noret_decl(f_31263)
static void C_ccall f_31263(C_word c,C_word *av) C_noret;
C_noret_decl(f_31288)
static void C_ccall f_31288(C_word c,C_word *av) C_noret;
C_noret_decl(f_31295)
static void C_ccall f_31295(C_word c,C_word *av) C_noret;
C_noret_decl(f_31297)
static void f_31297(C_word t0,C_word t1) C_noret;
C_noret_decl(f_31304)
static void C_ccall f_31304(C_word c,C_word *av) C_noret;
C_noret_decl(f_31308)
static void f_31308(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_31315)
static void C_ccall f_31315(C_word c,C_word *av) C_noret;
C_noret_decl(f_31331)
static void f_31331(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_31335)
static void C_ccall f_31335(C_word c,C_word *av) C_noret;
C_noret_decl(f_31351)
static void f_31351(C_word t0,C_word t1) C_noret;
C_noret_decl(f_31366)
static void f_31366(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_31376)
static void C_ccall f_31376(C_word c,C_word *av) C_noret;
C_noret_decl(f_31381)
static void C_ccall f_31381(C_word c,C_word *av) C_noret;
C_noret_decl(f_31387)
static void C_ccall f_31387(C_word c,C_word *av) C_noret;
C_noret_decl(f_31401)
static void C_ccall f_31401(C_word c,C_word *av) C_noret;
C_noret_decl(f_31410)
static void C_ccall f_31410(C_word c,C_word *av) C_noret;
C_noret_decl(f_31421)
static void C_ccall f_31421(C_word c,C_word *av) C_noret;
C_noret_decl(f_31427)
static void f_31427(C_word t0,C_word t1) C_noret;
C_noret_decl(f_31430)
static void C_ccall f_31430(C_word c,C_word *av) C_noret;
C_noret_decl(f_31441)
static void C_ccall f_31441(C_word c,C_word *av) C_noret;
C_noret_decl(f_31450)
static void C_ccall f_31450(C_word c,C_word *av) C_noret;
C_noret_decl(f_31455)
static void C_ccall f_31455(C_word c,C_word *av) C_noret;
C_noret_decl(f_31461)
static void C_ccall f_31461(C_word c,C_word *av) C_noret;
C_noret_decl(f_31482)
static void C_ccall f_31482(C_word c,C_word *av) C_noret;
C_noret_decl(f_31485)
static void C_ccall f_31485(C_word c,C_word *av) C_noret;
C_noret_decl(f_31492)
static void C_ccall f_31492(C_word c,C_word *av) C_noret;
C_noret_decl(f_31499)
static void C_ccall f_31499(C_word c,C_word *av) C_noret;
C_noret_decl(f_31508)
static void C_ccall f_31508(C_word c,C_word *av) C_noret;
C_noret_decl(f_31519)
static void C_ccall f_31519(C_word c,C_word *av) C_noret;
C_noret_decl(f_31565)
static void C_ccall f_31565(C_word c,C_word *av) C_noret;
C_noret_decl(f_31569)
static void C_ccall f_31569(C_word c,C_word *av) C_noret;
C_noret_decl(f_31570)
static void f_31570(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_31580)
static void C_ccall f_31580(C_word c,C_word *av) C_noret;
C_noret_decl(f_31585)
static void f_31585(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_31595)
static void C_ccall f_31595(C_word c,C_word *av) C_noret;
C_noret_decl(f_31608)
static void C_ccall f_31608(C_word c,C_word *av) C_noret;
C_noret_decl(f_31619)
static void C_ccall f_31619(C_word c,C_word *av) C_noret;
C_noret_decl(f_31623)
static void C_ccall f_31623(C_word c,C_word *av) C_noret;
C_noret_decl(f_31627)
static void C_ccall f_31627(C_word c,C_word *av) C_noret;
C_noret_decl(f_31649)
static void C_ccall f_31649(C_word c,C_word *av) C_noret;
C_noret_decl(f_31653)
static void C_ccall f_31653(C_word c,C_word *av) C_noret;
C_noret_decl(f_31661)
static void C_ccall f_31661(C_word c,C_word *av) C_noret;
C_noret_decl(f_31677)
static void C_ccall f_31677(C_word c,C_word *av) C_noret;
C_noret_decl(f_31688)
static void f_31688(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_31707)
static void f_31707(C_word t0,C_word t1) C_noret;
C_noret_decl(f_31718)
static void C_ccall f_31718(C_word c,C_word *av) C_noret;
C_noret_decl(f_31729)
static void C_ccall f_31729(C_word c,C_word *av) C_noret;
C_noret_decl(f_31815)
static void C_ccall f_31815(C_word c,C_word *av) C_noret;
C_noret_decl(f_31825)
static void C_ccall f_31825(C_word c,C_word *av) C_noret;
C_noret_decl(f_31826)
static void f_31826(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_31839)
static void C_ccall f_31839(C_word c,C_word *av) C_noret;
C_noret_decl(f_31842)
static void C_ccall f_31842(C_word c,C_word *av) C_noret;
C_noret_decl(f_31845)
static void C_ccall f_31845(C_word c,C_word *av) C_noret;
C_noret_decl(f_31848)
static void C_ccall f_31848(C_word c,C_word *av) C_noret;
C_noret_decl(f_31856)
static void C_ccall f_31856(C_word c,C_word *av) C_noret;
C_noret_decl(f_31863)
static void f_31863(C_word t0,C_word t1) C_noret;
C_noret_decl(f_31866)
static void C_ccall f_31866(C_word c,C_word *av) C_noret;
C_noret_decl(f_31869)
static void C_ccall f_31869(C_word c,C_word *av) C_noret;
C_noret_decl(f_31892)
static void C_ccall f_31892(C_word c,C_word *av) C_noret;
C_noret_decl(f_31897)
static void f_31897(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_31907)
static void C_ccall f_31907(C_word c,C_word *av) C_noret;
C_noret_decl(f_31920)
static void C_ccall f_31920(C_word c,C_word *av) C_noret;
C_noret_decl(f_31961)
static void C_ccall f_31961(C_word c,C_word *av) C_noret;
C_noret_decl(f_32011)
static void C_ccall f_32011(C_word c,C_word *av) C_noret;
C_noret_decl(f_32014)
static void C_ccall f_32014(C_word c,C_word *av) C_noret;
C_noret_decl(f_32033)
static void f_32033(C_word t0) C_noret;
C_noret_decl(f_32038)
static void C_ccall f_32038(C_word c,C_word *av) C_noret;
C_noret_decl(f_32044)
static void C_ccall f_32044(C_word c,C_word *av) C_noret;
C_noret_decl(f_32047)
static void C_ccall f_32047(C_word c,C_word *av) C_noret;
C_noret_decl(f_32056)
static void C_ccall f_32056(C_word c,C_word *av) C_noret;
C_noret_decl(f_32062)
static void C_ccall f_32062(C_word c,C_word *av) C_noret;
C_noret_decl(f_32081)
static void f_32081(C_word t0,C_word t1) C_noret;
C_noret_decl(f_32100)
static void C_ccall f_32100(C_word c,C_word *av) C_noret;
C_noret_decl(f_32105)
static void f_32105(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_32115)
static void C_ccall f_32115(C_word c,C_word *av) C_noret;
C_noret_decl(f_32129)
static void C_ccall f_32129(C_word c,C_word *av) C_noret;
C_noret_decl(f_32136)
static void C_ccall f_32136(C_word c,C_word *av) C_noret;
C_noret_decl(f_32140)
static void C_ccall f_32140(C_word c,C_word *av) C_noret;
C_noret_decl(f_32144)
static void C_ccall f_32144(C_word c,C_word *av) C_noret;
C_noret_decl(f_32146)
static void C_ccall f_32146(C_word c,C_word *av) C_noret;
C_noret_decl(f_32149)
static void C_ccall f_32149(C_word c,C_word *av) C_noret;
C_noret_decl(f_32175)
static void C_ccall f_32175(C_word c,C_word *av) C_noret;
C_noret_decl(f_32178)
static void C_ccall f_32178(C_word c,C_word *av) C_noret;
C_noret_decl(f_32181)
static void C_ccall f_32181(C_word c,C_word *av) C_noret;
C_noret_decl(f_32188)
static void C_ccall f_32188(C_word c,C_word *av) C_noret;
C_noret_decl(f_32192)
static void C_ccall f_32192(C_word c,C_word *av) C_noret;
C_noret_decl(f_32198)
static void C_ccall f_32198(C_word c,C_word *av) C_noret;
C_noret_decl(f_32203)
static void f_32203(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_32213)
static void C_ccall f_32213(C_word c,C_word *av) C_noret;
C_noret_decl(f_32251)
static void f_32251(C_word t0,C_word t1) C_noret;
C_noret_decl(f_32254)
static void f_32254(C_word t0,C_word t1) C_noret;
C_noret_decl(f_32274)
static void f_32274(C_word t0,C_word t1) C_noret;
C_noret_decl(f_32292)
static void C_ccall f_32292(C_word c,C_word *av) C_noret;
C_noret_decl(f_32426)
static void C_ccall f_32426(C_word c,C_word *av) C_noret;
C_noret_decl(f_32443)
static void C_ccall f_32443(C_word c,C_word *av) C_noret;
C_noret_decl(f_32458)
static void C_ccall f_32458(C_word c,C_word *av) C_noret;
C_noret_decl(f_32462)
static void C_ccall f_32462(C_word c,C_word *av) C_noret;
C_noret_decl(f_32475)
static void C_ccall f_32475(C_word c,C_word *av) C_noret;
C_noret_decl(f_32483)
static void C_ccall f_32483(C_word c,C_word *av) C_noret;
C_noret_decl(f_32486)
static void C_ccall f_32486(C_word c,C_word *av) C_noret;
C_noret_decl(f_32490)
static void C_ccall f_32490(C_word c,C_word *av) C_noret;
C_noret_decl(f_32529)
static void C_ccall f_32529(C_word c,C_word *av) C_noret;
C_noret_decl(f_32532)
static void C_ccall f_32532(C_word c,C_word *av) C_noret;
C_noret_decl(f_32539)
static void C_ccall f_32539(C_word c,C_word *av) C_noret;
C_noret_decl(f_32543)
static void C_ccall f_32543(C_word c,C_word *av) C_noret;
C_noret_decl(f_32569)
static void C_ccall f_32569(C_word c,C_word *av) C_noret;
C_noret_decl(f_32600)
static void C_ccall f_32600(C_word c,C_word *av) C_noret;
C_noret_decl(f_32603)
static void C_ccall f_32603(C_word c,C_word *av) C_noret;
C_noret_decl(f_32615)
static void C_ccall f_32615(C_word c,C_word *av) C_noret;
C_noret_decl(f_32618)
static void C_ccall f_32618(C_word c,C_word *av) C_noret;
C_noret_decl(f_32621)
static void C_ccall f_32621(C_word c,C_word *av) C_noret;
C_noret_decl(f_32646)
static void C_ccall f_32646(C_word c,C_word *av) C_noret;
C_noret_decl(f_32652)
static void C_ccall f_32652(C_word c,C_word *av) C_noret;
C_noret_decl(f_32656)
static void C_ccall f_32656(C_word c,C_word *av) C_noret;
C_noret_decl(f_32660)
static void C_ccall f_32660(C_word c,C_word *av) C_noret;
C_noret_decl(f_32673)
static void C_ccall f_32673(C_word c,C_word *av) C_noret;
C_noret_decl(f_32675)
static C_word f_32675(C_word t0,C_word t1);
C_noret_decl(f_32681)
static C_word f_32681(C_word t0);
C_noret_decl(f_32686)
static C_word f_32686(C_word t0);
C_noret_decl(f_32721)
static void f_32721(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_32727)
static void f_32727(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_32743)
static void f_32743(C_word t0,C_word t1) C_noret;
C_noret_decl(f_32765)
static void C_ccall f_32765(C_word c,C_word *av) C_noret;
C_noret_decl(f_32789)
static void C_ccall f_32789(C_word c,C_word *av) C_noret;
C_noret_decl(f_32801)
static void C_ccall f_32801(C_word c,C_word *av) C_noret;
C_noret_decl(f_32803)
static void C_ccall f_32803(C_word c,C_word *av) C_noret;
C_noret_decl(f_32822)
static void C_ccall f_32822(C_word c,C_word *av) C_noret;
C_noret_decl(f_32826)
static void C_ccall f_32826(C_word c,C_word *av) C_noret;
C_noret_decl(f_32838)
static void C_ccall f_32838(C_word c,C_word *av) C_noret;
C_noret_decl(f_32840)
static void f_32840(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_32884)
static void C_ccall f_32884(C_word c,C_word *av) C_noret;
C_noret_decl(f_32886)
static void f_32886(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_32920)
static C_word f_32920(C_word t0);
C_noret_decl(f_32943)
static void C_ccall f_32943(C_word c,C_word *av) C_noret;
C_noret_decl(f_32950)
static void C_ccall f_32950(C_word c,C_word *av) C_noret;
C_noret_decl(f_32960)
static void C_ccall f_32960(C_word c,C_word *av) C_noret;
C_noret_decl(f_32962)
static void f_32962(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33012)
static void C_ccall f_33012(C_word c,C_word *av) C_noret;
C_noret_decl(f_33014)
static void f_33014(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33039)
static void C_ccall f_33039(C_word c,C_word *av) C_noret;
C_noret_decl(f_33048)
static void C_ccall f_33048(C_word c,C_word *av) C_noret;
C_noret_decl(f_33054)
static void C_ccall f_33054(C_word c,C_word *av) C_noret;
C_noret_decl(f_33058)
static void C_ccall f_33058(C_word c,C_word *av) C_noret;
C_noret_decl(f_33062)
static void f_33062(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33070)
static void C_ccall f_33070(C_word c,C_word *av) C_noret;
C_noret_decl(f_33076)
static void f_33076(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33107)
static void C_ccall f_33107(C_word c,C_word *av) C_noret;
C_noret_decl(f_33132)
static void f_33132(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33157)
static void C_ccall f_33157(C_word c,C_word *av) C_noret;
C_noret_decl(f_33167)
static void C_ccall f_33167(C_word c,C_word *av) C_noret;
C_noret_decl(f_33172)
static void C_ccall f_33172(C_word c,C_word *av) C_noret;
C_noret_decl(f_33174)
static void C_ccall f_33174(C_word c,C_word *av) C_noret;
C_noret_decl(f_33181)
static void C_ccall f_33181(C_word c,C_word *av) C_noret;
C_noret_decl(f_33193)
static void C_ccall f_33193(C_word c,C_word *av) C_noret;
C_noret_decl(f_33201)
static void C_ccall f_33201(C_word c,C_word *av) C_noret;
C_noret_decl(f_33239)
static void C_ccall f_33239(C_word c,C_word *av) C_noret;
C_noret_decl(f_33243)
static void C_ccall f_33243(C_word c,C_word *av) C_noret;
C_noret_decl(f_33250)
static void C_ccall f_33250(C_word c,C_word *av) C_noret;
C_noret_decl(f_33253)
static void C_ccall f_33253(C_word c,C_word *av) C_noret;
C_noret_decl(f_33256)
static void C_ccall f_33256(C_word c,C_word *av) C_noret;
C_noret_decl(f_33257)
static void f_33257(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33259)
static void f_33259(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33263)
static void C_ccall f_33263(C_word c,C_word *av) C_noret;
C_noret_decl(f_33268)
static void C_ccall f_33268(C_word c,C_word *av) C_noret;
C_noret_decl(f_33280)
static void f_33280(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33290)
static void C_ccall f_33290(C_word c,C_word *av) C_noret;
C_noret_decl(f_33302)
static void C_ccall f_33302(C_word c,C_word *av) C_noret;
C_noret_decl(f_33304)
static void f_33304(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_33311)
static void C_ccall f_33311(C_word c,C_word *av) C_noret;
C_noret_decl(f_33314)
static void C_ccall f_33314(C_word c,C_word *av) C_noret;
C_noret_decl(f_33323)
static void C_ccall f_33323(C_word c,C_word *av) C_noret;
C_noret_decl(f_33326)
static void C_ccall f_33326(C_word c,C_word *av) C_noret;
C_noret_decl(f_33329)
static void C_ccall f_33329(C_word c,C_word *av) C_noret;
C_noret_decl(f_33344)
static void C_ccall f_33344(C_word c,C_word *av) C_noret;
C_noret_decl(f_33350)
static void C_ccall f_33350(C_word c,C_word *av) C_noret;
C_noret_decl(f_33358)
static void f_33358(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33362)
static void C_ccall f_33362(C_word c,C_word *av) C_noret;
C_noret_decl(f_33365)
static void C_ccall f_33365(C_word c,C_word *av) C_noret;
C_noret_decl(f_33368)
static void C_ccall f_33368(C_word c,C_word *av) C_noret;
C_noret_decl(f_33381)
static void C_ccall f_33381(C_word c,C_word *av) C_noret;
C_noret_decl(f_33385)
static void C_ccall f_33385(C_word c,C_word *av) C_noret;
C_noret_decl(f_33406)
static void C_ccall f_33406(C_word c,C_word *av) C_noret;
C_noret_decl(f_33422)
static void C_ccall f_33422(C_word c,C_word *av) C_noret;
C_noret_decl(f_33425)
static void C_ccall f_33425(C_word c,C_word *av) C_noret;
C_noret_decl(f_33431)
static void C_ccall f_33431(C_word c,C_word *av) C_noret;
C_noret_decl(f_33453)
static void f_33453(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_33458)
static void f_33458(C_word t0,C_word t1) C_noret;
C_noret_decl(f_33493)
static void C_ccall f_33493(C_word c,C_word *av) C_noret;
C_noret_decl(f_33503)
static void C_ccall f_33503(C_word c,C_word *av) C_noret;
C_noret_decl(f_33506)
static void C_ccall f_33506(C_word c,C_word *av) C_noret;
C_noret_decl(f_33509)
static void C_ccall f_33509(C_word c,C_word *av) C_noret;
C_noret_decl(f_33512)
static void C_ccall f_33512(C_word c,C_word *av) C_noret;
C_noret_decl(f_33515)
static void C_ccall f_33515(C_word c,C_word *av) C_noret;
C_noret_decl(f_33518)
static void C_ccall f_33518(C_word c,C_word *av) C_noret;
C_noret_decl(f_33525)
static void C_ccall f_33525(C_word c,C_word *av) C_noret;
C_noret_decl(f_33528)
static void C_ccall f_33528(C_word c,C_word *av) C_noret;
C_noret_decl(f_33531)
static void C_ccall f_33531(C_word c,C_word *av) C_noret;
C_noret_decl(f_33542)
static void C_ccall f_33542(C_word c,C_word *av) C_noret;
C_noret_decl(f_33565)
static void C_ccall f_33565(C_word c,C_word *av) C_noret;
C_noret_decl(f_33576)
static void C_ccall f_33576(C_word c,C_word *av) C_noret;
C_noret_decl(f_33580)
static void C_ccall f_33580(C_word c,C_word *av) C_noret;
C_noret_decl(f_33602)
static void C_ccall f_33602(C_word c,C_word *av) C_noret;
C_noret_decl(f_33613)
static void C_ccall f_33613(C_word c,C_word *av) C_noret;
C_noret_decl(f_33617)
static void C_ccall f_33617(C_word c,C_word *av) C_noret;
C_noret_decl(f_34116)
static void C_ccall f_34116(C_word c,C_word *av) C_noret;
C_noret_decl(f_34127)
static void C_ccall f_34127(C_word c,C_word *av) C_noret;
C_noret_decl(f_34131)
static void C_ccall f_34131(C_word c,C_word *av) C_noret;
C_noret_decl(f_34272)
static void C_ccall f_34272(C_word c,C_word *av) C_noret;
C_noret_decl(f_34274)
static void C_ccall f_34274(C_word c,C_word *av) C_noret;
C_noret_decl(f_34280)
static void C_ccall f_34280(C_word c,C_word *av) C_noret;
C_noret_decl(f_34284)
static void C_ccall f_34284(C_word c,C_word *av) C_noret;
C_noret_decl(f_34287)
static void C_ccall f_34287(C_word c,C_word *av) C_noret;
C_noret_decl(f_34296)
static void C_ccall f_34296(C_word c,C_word *av) C_noret;
C_noret_decl(f_34310)
static void C_ccall f_34310(C_word c,C_word *av) C_noret;
C_noret_decl(f_34318)
static void C_ccall f_34318(C_word c,C_word *av) C_noret;
C_noret_decl(f_34320)
static void C_ccall f_34320(C_word c,C_word *av) C_noret;
C_noret_decl(f_34324)
static void C_ccall f_34324(C_word c,C_word *av) C_noret;
C_noret_decl(f_34332)
static void C_ccall f_34332(C_word c,C_word *av) C_noret;
C_noret_decl(f_34340)
static void C_ccall f_34340(C_word c,C_word *av) C_noret;
C_noret_decl(f_34342)
static void C_ccall f_34342(C_word c,C_word *av) C_noret;
C_noret_decl(f_34352)
static void C_ccall f_34352(C_word c,C_word *av) C_noret;
C_noret_decl(f_34359)
static void C_ccall f_34359(C_word c,C_word *av) C_noret;
C_noret_decl(f_34369)
static void C_ccall f_34369(C_word c,C_word *av) C_noret;
C_noret_decl(f_34373)
static void C_ccall f_34373(C_word c,C_word *av) C_noret;
C_noret_decl(f_34377)
static void C_ccall f_34377(C_word c,C_word *av) C_noret;
C_noret_decl(f_34381)
static void C_ccall f_34381(C_word c,C_word *av) C_noret;
C_noret_decl(f_34383)
static void C_ccall f_34383(C_word c,C_word *av) C_noret;
C_noret_decl(f_34393)
static void C_ccall f_34393(C_word c,C_word *av) C_noret;
C_noret_decl(f_34404)
static void C_ccall f_34404(C_word c,C_word *av) C_noret;
C_noret_decl(f_34408)
static void C_ccall f_34408(C_word c,C_word *av) C_noret;
C_noret_decl(f_34413)
static void C_ccall f_34413(C_word c,C_word *av) C_noret;
C_noret_decl(f_34417)
static void C_ccall f_34417(C_word c,C_word *av) C_noret;
C_noret_decl(f_34422)
static void C_ccall f_34422(C_word c,C_word *av) C_noret;
C_noret_decl(f_34425)
static void C_ccall f_34425(C_word c,C_word *av) C_noret;
C_noret_decl(f_34428)
static void C_ccall f_34428(C_word c,C_word *av) C_noret;
C_noret_decl(f_34431)
static void C_ccall f_34431(C_word c,C_word *av) C_noret;
C_noret_decl(f_34433)
static void C_ccall f_34433(C_word c,C_word *av) C_noret;
C_noret_decl(f_34440)
static void C_ccall f_34440(C_word c,C_word *av) C_noret;
C_noret_decl(f_34443)
static void C_ccall f_34443(C_word c,C_word *av) C_noret;
C_noret_decl(f_34451)
static void C_ccall f_34451(C_word c,C_word *av) C_noret;
C_noret_decl(f_34458)
static void C_ccall f_34458(C_word c,C_word *av) C_noret;
C_noret_decl(f_34463)
static void C_ccall f_34463(C_word c,C_word *av) C_noret;
C_noret_decl(f_34466)
static void C_ccall f_34466(C_word c,C_word *av) C_noret;
C_noret_decl(f_34469)
static void C_ccall f_34469(C_word c,C_word *av) C_noret;
C_noret_decl(f_34472)
static void C_ccall f_34472(C_word c,C_word *av) C_noret;
C_noret_decl(f_34477)
static void C_ccall f_34477(C_word c,C_word *av) C_noret;
C_noret_decl(f_34480)
static void C_ccall f_34480(C_word c,C_word *av) C_noret;
C_noret_decl(f_34483)
static void C_ccall f_34483(C_word c,C_word *av) C_noret;
C_noret_decl(f_34486)
static void C_ccall f_34486(C_word c,C_word *av) C_noret;
C_noret_decl(f_34489)
static void C_ccall f_34489(C_word c,C_word *av) C_noret;
C_noret_decl(f_34492)
static void C_ccall f_34492(C_word c,C_word *av) C_noret;
C_noret_decl(f_34495)
static void C_ccall f_34495(C_word c,C_word *av) C_noret;
C_noret_decl(f_34498)
static void C_ccall f_34498(C_word c,C_word *av) C_noret;
C_noret_decl(f_34522)
static void C_ccall f_34522(C_word c,C_word *av) C_noret;
C_noret_decl(f_34526)
static void C_ccall f_34526(C_word c,C_word *av) C_noret;
C_noret_decl(f_34528)
static void C_ccall f_34528(C_word c,C_word *av) C_noret;
C_noret_decl(f_34536)
static void C_ccall f_34536(C_word c,C_word *av) C_noret;
C_noret_decl(f_34538)
static void C_ccall f_34538(C_word c,C_word *av) C_noret;
C_noret_decl(f_34542)
static void C_ccall f_34542(C_word c,C_word *av) C_noret;
C_noret_decl(f_34544)
static void C_ccall f_34544(C_word c,C_word *av) C_noret;
C_noret_decl(f_34551)
static void C_ccall f_34551(C_word c,C_word *av) C_noret;
C_noret_decl(f_34587)
static void C_ccall f_34587(C_word c,C_word *av) C_noret;
C_noret_decl(f_34590)
static void C_ccall f_34590(C_word c,C_word *av) C_noret;
C_noret_decl(f_34593)
static void C_ccall f_34593(C_word c,C_word *av) C_noret;
C_noret_decl(f_34596)
static void C_ccall f_34596(C_word c,C_word *av) C_noret;
C_noret_decl(f_34599)
static void C_ccall f_34599(C_word c,C_word *av) C_noret;
C_noret_decl(f_34615)
static void C_ccall f_34615(C_word c,C_word *av) C_noret;
C_noret_decl(f_34619)
static void C_ccall f_34619(C_word c,C_word *av) C_noret;
C_noret_decl(f_34628)
static void C_ccall f_34628(C_word c,C_word *av) C_noret;
C_noret_decl(f_34632)
static void C_ccall f_34632(C_word c,C_word *av) C_noret;
C_noret_decl(f_34634)
static void C_ccall f_34634(C_word c,C_word *av) C_noret;
C_noret_decl(f_34638)
static void C_ccall f_34638(C_word c,C_word *av) C_noret;
C_noret_decl(f_34640)
static void C_ccall f_34640(C_word c,C_word *av) C_noret;
C_noret_decl(f_34645)
static void C_ccall f_34645(C_word c,C_word *av) C_noret;
C_noret_decl(f_34647)
static void C_ccall f_34647(C_word c,C_word *av) C_noret;
C_noret_decl(f_34650)
static void C_ccall f_34650(C_word c,C_word *av) C_noret;
C_noret_decl(f_34670)
static void C_ccall f_34670(C_word c,C_word *av) C_noret;
C_noret_decl(f_34676)
static void f_34676(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_34686)
static void C_ccall f_34686(C_word c,C_word *av) C_noret;
C_noret_decl(f_34696)
static void C_ccall f_34696(C_word c,C_word *av) C_noret;
C_noret_decl(f_34731)
static void C_ccall f_34731(C_word c,C_word *av) C_noret;
C_noret_decl(f_34735)
static void C_ccall f_34735(C_word c,C_word *av) C_noret;
C_noret_decl(f_34740)
static void f_34740(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_34750)
static void C_ccall f_34750(C_word c,C_word *av) C_noret;
C_noret_decl(f_34760)
static void C_ccall f_34760(C_word c,C_word *av) C_noret;
C_noret_decl(f_34769)
static void C_ccall f_34769(C_word c,C_word *av) C_noret;
C_noret_decl(f_34772)
static void C_ccall f_34772(C_word c,C_word *av) C_noret;
C_noret_decl(f_34775)
static void C_ccall f_34775(C_word c,C_word *av) C_noret;
C_noret_decl(f_34779)
static void C_ccall f_34779(C_word c,C_word *av) C_noret;
C_noret_decl(f_34781)
static void C_ccall f_34781(C_word c,C_word *av) C_noret;
C_noret_decl(f_34784)
static void C_ccall f_34784(C_word c,C_word *av) C_noret;
C_noret_decl(f_34787)
static void C_ccall f_34787(C_word c,C_word *av) C_noret;
C_noret_decl(f_34790)
static void C_ccall f_34790(C_word c,C_word *av) C_noret;
C_noret_decl(f_34793)
static void C_ccall f_34793(C_word c,C_word *av) C_noret;
C_noret_decl(f_34802)
static void C_ccall f_34802(C_word c,C_word *av) C_noret;
C_noret_decl(f_34805)
static void C_ccall f_34805(C_word c,C_word *av) C_noret;
C_noret_decl(f_34808)
static void C_ccall f_34808(C_word c,C_word *av) C_noret;
C_noret_decl(f_34811)
static void C_ccall f_34811(C_word c,C_word *av) C_noret;
C_noret_decl(f_34814)
static void C_ccall f_34814(C_word c,C_word *av) C_noret;
C_noret_decl(f_34817)
static void C_ccall f_34817(C_word c,C_word *av) C_noret;
C_noret_decl(f_34820)
static void C_ccall f_34820(C_word c,C_word *av) C_noret;
C_noret_decl(f_34823)
static void C_ccall f_34823(C_word c,C_word *av) C_noret;
C_noret_decl(f_34830)
static void C_ccall f_34830(C_word c,C_word *av) C_noret;
C_noret_decl(f_34833)
static void C_ccall f_34833(C_word c,C_word *av) C_noret;
C_noret_decl(f_34849)
static void C_ccall f_34849(C_word c,C_word *av) C_noret;
C_noret_decl(f_34857)
static void C_ccall f_34857(C_word c,C_word *av) C_noret;
C_noret_decl(f_34860)
static void C_ccall f_34860(C_word c,C_word *av) C_noret;
C_noret_decl(f_34866)
static void C_ccall f_34866(C_word c,C_word *av) C_noret;
C_noret_decl(f_34875)
static void C_ccall f_34875(C_word c,C_word *av) C_noret;
C_noret_decl(f_34881)
static void C_ccall f_34881(C_word c,C_word *av) C_noret;
C_noret_decl(f_34890)
static void C_ccall f_34890(C_word c,C_word *av) C_noret;
C_noret_decl(f_34896)
static void C_ccall f_34896(C_word c,C_word *av) C_noret;
C_noret_decl(f_34902)
static void C_ccall f_34902(C_word c,C_word *av) C_noret;
C_noret_decl(f_34905)
static void C_ccall f_34905(C_word c,C_word *av) C_noret;
C_noret_decl(f_34911)
static void C_ccall f_34911(C_word c,C_word *av) C_noret;
C_noret_decl(f_34917)
static void C_ccall f_34917(C_word c,C_word *av) C_noret;
C_noret_decl(f_34920)
static void C_ccall f_34920(C_word c,C_word *av) C_noret;
C_noret_decl(f_34926)
static void C_ccall f_34926(C_word c,C_word *av) C_noret;
C_noret_decl(f_34965)
static void C_ccall f_34965(C_word c,C_word *av) C_noret;
C_noret_decl(f_35008)
static void C_ccall f_35008(C_word c,C_word *av) C_noret;
C_noret_decl(f_35015)
static void C_ccall f_35015(C_word c,C_word *av) C_noret;
C_noret_decl(f_35020)
static void f_35020(C_word t0,C_word t1) C_noret;
C_noret_decl(f_35036)
static void C_ccall f_35036(C_word c,C_word *av) C_noret;
C_noret_decl(f_35062)
static void C_ccall f_35062(C_word c,C_word *av) C_noret;
C_noret_decl(f_35065)
static void C_ccall f_35065(C_word c,C_word *av) C_noret;
C_noret_decl(f_35072)
static void C_ccall f_35072(C_word c,C_word *av) C_noret;
C_noret_decl(f_35077)
static void C_ccall f_35077(C_word c,C_word *av) C_noret;
C_noret_decl(f_35079)
static void C_ccall f_35079(C_word c,C_word *av) C_noret;
C_noret_decl(f_35083)
static void C_ccall f_35083(C_word c,C_word *av) C_noret;
C_noret_decl(f_35110)
static void f_35110(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_35120)
static void C_ccall f_35120(C_word c,C_word *av) C_noret;
C_noret_decl(f_35129)
static void C_ccall f_35129(C_word c,C_word *av) C_noret;
C_noret_decl(f_35136)
static void C_ccall f_35136(C_word c,C_word *av) C_noret;
C_noret_decl(f_35140)
static void C_ccall f_35140(C_word c,C_word *av) C_noret;
C_noret_decl(f_35154)
static void f_35154(C_word t0,C_word t1) C_noret;
C_noret_decl(f_35158)
static void C_ccall f_35158(C_word c,C_word *av) C_noret;
C_noret_decl(f_35165)
static void C_ccall f_35165(C_word c,C_word *av) C_noret;
C_noret_decl(f_35167)
static void f_35167(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_35189)
static void C_ccall f_35189(C_word c,C_word *av) C_noret;
C_noret_decl(f_35196)
static void C_ccall f_35196(C_word c,C_word *av) C_noret;
C_noret_decl(f_35201)
static void f_35201(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_35205)
static void C_ccall f_35205(C_word c,C_word *av) C_noret;
C_noret_decl(f_35208)
static void C_ccall f_35208(C_word c,C_word *av) C_noret;
C_noret_decl(f_35211)
static void C_ccall f_35211(C_word c,C_word *av) C_noret;
C_noret_decl(f_35216)
static void f_35216(C_word t0,C_word t1) C_noret;
C_noret_decl(f_35220)
static void C_ccall f_35220(C_word c,C_word *av) C_noret;
C_noret_decl(f_35246)
static void C_ccall f_35246(C_word c,C_word *av) C_noret;
C_noret_decl(f_35259)
static void C_ccall f_35259(C_word c,C_word *av) C_noret;
C_noret_decl(f_35262)
static void C_ccall f_35262(C_word c,C_word *av) C_noret;
C_noret_decl(f_35271)
static void C_ccall f_35271(C_word c,C_word *av) C_noret;
C_noret_decl(f_35274)
static void C_ccall f_35274(C_word c,C_word *av) C_noret;
C_noret_decl(f_35277)
static void C_ccall f_35277(C_word c,C_word *av) C_noret;
C_noret_decl(f_35283)
static void C_ccall f_35283(C_word c,C_word *av) C_noret;
C_noret_decl(f_35290)
static void C_ccall f_35290(C_word c,C_word *av) C_noret;
C_noret_decl(f_35292)
static void f_35292(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_35305)
static void C_ccall f_35305(C_word c,C_word *av) C_noret;
C_noret_decl(f_35318)
static void C_ccall f_35318(C_word c,C_word *av) C_noret;
C_noret_decl(f_35321)
static void C_ccall f_35321(C_word c,C_word *av) C_noret;
C_noret_decl(f_35324)
static void C_ccall f_35324(C_word c,C_word *av) C_noret;
C_noret_decl(f_35331)
static void C_ccall f_35331(C_word c,C_word *av) C_noret;
C_noret_decl(f_35383)
static void C_ccall f_35383(C_word c,C_word *av) C_noret;
C_noret_decl(f_35386)
static void C_ccall f_35386(C_word c,C_word *av) C_noret;
C_noret_decl(f_35389)
static void C_ccall f_35389(C_word c,C_word *av) C_noret;
C_noret_decl(f_35391)
static void f_35391(C_word t0,C_word t1) C_noret;
C_noret_decl(f_35395)
static void C_ccall f_35395(C_word c,C_word *av) C_noret;
C_noret_decl(f_35399)
static void C_ccall f_35399(C_word c,C_word *av) C_noret;
C_noret_decl(f_35405)
static void C_ccall f_35405(C_word c,C_word *av) C_noret;
C_noret_decl(f_35410)
static void f_35410(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_35414)
static void C_ccall f_35414(C_word c,C_word *av) C_noret;
C_noret_decl(f_35426)
static void C_ccall f_35426(C_word c,C_word *av) C_noret;
C_noret_decl(f_35438)
static void C_ccall f_35438(C_word c,C_word *av) C_noret;
C_noret_decl(f_35445)
static void C_ccall f_35445(C_word c,C_word *av) C_noret;
C_noret_decl(f_35451)
static void f_35451(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_35465)
static void C_ccall f_35465(C_word c,C_word *av) C_noret;
C_noret_decl(f_35504)
static void C_ccall f_35504(C_word c,C_word *av) C_noret;
C_noret_decl(f_35523)
static void C_ccall f_35523(C_word c,C_word *av) C_noret;
C_noret_decl(f_35545)
static void C_ccall f_35545(C_word c,C_word *av) C_noret;
C_noret_decl(f_35554)
static void C_ccall f_35554(C_word c,C_word *av) C_noret;
C_noret_decl(f_35561)
static void C_ccall f_35561(C_word c,C_word *av) C_noret;
C_noret_decl(f_35578)
static void C_ccall f_35578(C_word c,C_word *av) C_noret;
C_noret_decl(f_35586)
static void C_ccall f_35586(C_word c,C_word *av) C_noret;
C_noret_decl(f_35597)
static void C_ccall f_35597(C_word c,C_word *av) C_noret;
C_noret_decl(f_35605)
static void C_ccall f_35605(C_word c,C_word *av) C_noret;
C_noret_decl(f_35612)
static void C_ccall f_35612(C_word c,C_word *av) C_noret;
C_noret_decl(f_35674)
static void C_ccall f_35674(C_word c,C_word *av) C_noret;
C_noret_decl(f_35681)
static void C_ccall f_35681(C_word c,C_word *av) C_noret;
C_noret_decl(f_35684)
static void C_ccall f_35684(C_word c,C_word *av) C_noret;
C_noret_decl(f_35694)
static void C_ccall f_35694(C_word c,C_word *av) C_noret;
C_noret_decl(f_35698)
static void C_ccall f_35698(C_word c,C_word *av) C_noret;
C_noret_decl(f_35702)
static void C_ccall f_35702(C_word c,C_word *av) C_noret;
C_noret_decl(f_35705)
static void C_ccall f_35705(C_word c,C_word *av) C_noret;
C_noret_decl(f_35713)
static void C_ccall f_35713(C_word c,C_word *av) C_noret;
C_noret_decl(f_35722)
static void C_ccall f_35722(C_word c,C_word *av) C_noret;
C_noret_decl(f_35730)
static void C_ccall f_35730(C_word c,C_word *av) C_noret;
C_noret_decl(f_35743)
static void C_ccall f_35743(C_word c,C_word *av) C_noret;
C_noret_decl(f_35751)
static void C_ccall f_35751(C_word c,C_word *av) C_noret;
C_noret_decl(f_35755)
static void C_ccall f_35755(C_word c,C_word *av) C_noret;
C_noret_decl(f_35763)
static void C_ccall f_35763(C_word c,C_word *av) C_noret;
C_noret_decl(f_35771)
static void C_ccall f_35771(C_word c,C_word *av) C_noret;
C_noret_decl(f_35773)
static void C_ccall f_35773(C_word c,C_word *av) C_noret;
C_noret_decl(f_35779)
static void f_35779(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_35783)
static void C_ccall f_35783(C_word c,C_word *av) C_noret;
C_noret_decl(f_35791)
static void f_35791(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_35811)
static void C_ccall f_35811(C_word c,C_word *av) C_noret;
C_noret_decl(f_35819)
static void C_ccall f_35819(C_word c,C_word *av) C_noret;
C_noret_decl(f_35823)
static void C_ccall f_35823(C_word c,C_word *av) C_noret;
C_noret_decl(f_35838)
static void C_ccall f_35838(C_word c,C_word *av) C_noret;
C_noret_decl(f_35845)
static void C_ccall f_35845(C_word c,C_word *av) C_noret;
C_noret_decl(f_35857)
static void C_ccall f_35857(C_word c,C_word *av) C_noret;
C_noret_decl(f_35865)
static void C_ccall f_35865(C_word c,C_word *av) C_noret;
C_noret_decl(f_35871)
static void f_35871(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_35893)
static void C_ccall f_35893(C_word c,C_word *av) C_noret;
C_noret_decl(f_35897)
static void C_ccall f_35897(C_word c,C_word *av) C_noret;
C_noret_decl(f_35901)
static void C_ccall f_35901(C_word c,C_word *av) C_noret;
C_noret_decl(f_35903)
static void C_ccall f_35903(C_word c,C_word *av) C_noret;
C_noret_decl(f_35906)
static void C_ccall f_35906(C_word c,C_word *av) C_noret;
C_noret_decl(f_35909)
static void C_ccall f_35909(C_word c,C_word *av) C_noret;
C_noret_decl(f_35913)
static void C_ccall f_35913(C_word c,C_word *av) C_noret;
C_noret_decl(f_35916)
static void C_ccall f_35916(C_word c,C_word *av) C_noret;
C_noret_decl(f_35938)
static void C_ccall f_35938(C_word c,C_word *av) C_noret;
C_noret_decl(f_35944)
static void C_ccall f_35944(C_word c,C_word *av) C_noret;
C_noret_decl(f_35948)
static void C_ccall f_35948(C_word c,C_word *av) C_noret;
C_noret_decl(f_35965)
static void C_ccall f_35965(C_word c,C_word *av) C_noret;
C_noret_decl(f_35975)
static void C_ccall f_35975(C_word c,C_word *av) C_noret;
C_noret_decl(f_35979)
static void C_ccall f_35979(C_word c,C_word *av) C_noret;
C_noret_decl(f_35983)
static void C_ccall f_35983(C_word c,C_word *av) C_noret;
C_noret_decl(f_35995)
static void C_ccall f_35995(C_word c,C_word *av) C_noret;
C_noret_decl(f_36005)
static void C_ccall f_36005(C_word c,C_word *av) C_noret;
C_noret_decl(f_36014)
static void C_ccall f_36014(C_word c,C_word *av) C_noret;
C_noret_decl(f_36030)
static void C_ccall f_36030(C_word c,C_word *av) C_noret;
C_noret_decl(f_36034)
static void C_ccall f_36034(C_word c,C_word *av) C_noret;
C_noret_decl(f_36036)
static void C_ccall f_36036(C_word c,C_word *av) C_noret;
C_noret_decl(f_36042)
static void C_ccall f_36042(C_word c,C_word *av) C_noret;
C_noret_decl(f_36049)
static void C_ccall f_36049(C_word c,C_word *av) C_noret;
C_noret_decl(f_36054)
static void C_ccall f_36054(C_word c,C_word *av) C_noret;
C_noret_decl(f_36075)
static void C_ccall f_36075(C_word c,C_word *av) C_noret;
C_noret_decl(f_36085)
static void f_36085(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_36095)
static void C_ccall f_36095(C_word c,C_word *av) C_noret;
C_noret_decl(f_36108)
static void C_ccall f_36108(C_word c,C_word *av) C_noret;
C_noret_decl(f_36112)
static void C_ccall f_36112(C_word c,C_word *av) C_noret;
C_noret_decl(f_36115)
static void C_ccall f_36115(C_word c,C_word *av) C_noret;
C_noret_decl(f_36123)
static void f_36123(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_36133)
static void C_ccall f_36133(C_word c,C_word *av) C_noret;
C_noret_decl(f_36155)
static void C_ccall f_36155(C_word c,C_word *av) C_noret;
C_noret_decl(f_36159)
static void C_ccall f_36159(C_word c,C_word *av) C_noret;
C_noret_decl(f_36190)
static void C_ccall f_36190(C_word c,C_word *av) C_noret;
C_noret_decl(f_36193)
static void C_ccall f_36193(C_word c,C_word *av) C_noret;
C_noret_decl(f_36196)
static void C_ccall f_36196(C_word c,C_word *av) C_noret;
C_noret_decl(f_36202)
static void f_36202(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_36215)
static void C_ccall f_36215(C_word c,C_word *av) C_noret;
C_noret_decl(f_36218)
static void C_ccall f_36218(C_word c,C_word *av) C_noret;
C_noret_decl(f_36227)
static void C_ccall f_36227(C_word c,C_word *av) C_noret;
C_noret_decl(f_36233)
static void C_ccall f_36233(C_word c,C_word *av) C_noret;
C_noret_decl(f_36239)
static void C_ccall f_36239(C_word c,C_word *av) C_noret;
C_noret_decl(f_36245)
static void C_ccall f_36245(C_word c,C_word *av) C_noret;
C_noret_decl(f_36251)
static void C_ccall f_36251(C_word c,C_word *av) C_noret;
C_noret_decl(f_36268)
static void C_ccall f_36268(C_word c,C_word *av) C_noret;
C_noret_decl(f_36274)
static void C_ccall f_36274(C_word c,C_word *av) C_noret;
C_noret_decl(f_36289)
static void C_ccall f_36289(C_word c,C_word *av) C_noret;
C_noret_decl(f_36293)
static void C_ccall f_36293(C_word c,C_word *av) C_noret;
C_noret_decl(f_36297)
static void C_ccall f_36297(C_word c,C_word *av) C_noret;
C_noret_decl(f_36301)
static void C_ccall f_36301(C_word c,C_word *av) C_noret;
C_noret_decl(f_36322)
static void C_ccall f_36322(C_word c,C_word *av) C_noret;
C_noret_decl(f_36324)
static void C_ccall f_36324(C_word c,C_word *av) C_noret;
C_noret_decl(f_36330)
static void f_36330(C_word t0,C_word t1) C_noret;
C_noret_decl(f_36334)
static void C_ccall f_36334(C_word c,C_word *av) C_noret;
C_noret_decl(f_36343)
static void C_ccall f_36343(C_word c,C_word *av) C_noret;
C_noret_decl(f_36352)
static void C_ccall f_36352(C_word c,C_word *av) C_noret;
C_noret_decl(f_36395)
static void C_ccall f_36395(C_word c,C_word *av) C_noret;
C_noret_decl(f_36662)
static void C_ccall f_36662(C_word c,C_word *av) C_noret;
C_noret_decl(f_36668)
static void C_ccall f_36668(C_word c,C_word *av) C_noret;
C_noret_decl(f_36687)
static void C_ccall f_36687(C_word c,C_word *av) C_noret;
C_noret_decl(f_36689)
static void C_ccall f_36689(C_word c,C_word *av) C_noret;
C_noret_decl(f_36712)
static C_word f_36712(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_36758)
static void C_ccall f_36758(C_word c,C_word *av) C_noret;
C_noret_decl(f_36760)
static void C_ccall f_36760(C_word c,C_word *av) C_noret;
C_noret_decl(f_36767)
static void f_36767(C_word t0,C_word t1) C_noret;
C_noret_decl(f_36779)
static void f_36779(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_36823)
static void C_ccall f_36823(C_word c,C_word *av) C_noret;
C_noret_decl(f_36838)
static void f_36838(C_word t0,C_word t1) C_noret;
C_noret_decl(f_36846)
static void C_ccall f_36846(C_word c,C_word *av) C_noret;
C_noret_decl(f_36852)
static void f_36852(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_36860)
static void C_ccall f_36860(C_word c,C_word *av) C_noret;
C_noret_decl(f_36864)
static void C_ccall f_36864(C_word c,C_word *av) C_noret;
C_noret_decl(f_36872)
static void C_ccall f_36872(C_word c,C_word *av) C_noret;
C_noret_decl(f_36874)
static void f_36874(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_36884)
static void C_ccall f_36884(C_word c,C_word *av) C_noret;
C_noret_decl(f_36891)
static void C_ccall f_36891(C_word c,C_word *av) C_noret;
C_noret_decl(f_36895)
static void C_ccall f_36895(C_word c,C_word *av) C_noret;
C_noret_decl(f_36906)
static void C_ccall f_36906(C_word c,C_word *av) C_noret;
C_noret_decl(f_36913)
static void C_ccall f_36913(C_word c,C_word *av) C_noret;
C_noret_decl(f_36917)
static void C_ccall f_36917(C_word c,C_word *av) C_noret;
C_noret_decl(f_36928)
static void C_ccall f_36928(C_word c,C_word *av) C_noret;
C_noret_decl(f_36935)
static void C_ccall f_36935(C_word c,C_word *av) C_noret;
C_noret_decl(f_36939)
static void C_ccall f_36939(C_word c,C_word *av) C_noret;
C_noret_decl(f_36944)
static void C_ccall f_36944(C_word c,C_word *av) C_noret;
C_noret_decl(f_36950)
static void C_ccall f_36950(C_word c,C_word *av) C_noret;
C_noret_decl(f_36953)
static void C_ccall f_36953(C_word c,C_word *av) C_noret;
C_noret_decl(f_36956)
static void C_ccall f_36956(C_word c,C_word *av) C_noret;
C_noret_decl(f_36962)
static void C_ccall f_36962(C_word c,C_word *av) C_noret;
C_noret_decl(f_36971)
static void C_ccall f_36971(C_word c,C_word *av) C_noret;
C_noret_decl(f_36980)
static void C_ccall f_36980(C_word c,C_word *av) C_noret;
C_noret_decl(f_36986)
static void C_ccall f_36986(C_word c,C_word *av) C_noret;
C_noret_decl(f_36989)
static void C_ccall f_36989(C_word c,C_word *av) C_noret;
C_noret_decl(f_36992)
static void C_ccall f_36992(C_word c,C_word *av) C_noret;
C_noret_decl(f_37004)
static void C_ccall f_37004(C_word c,C_word *av) C_noret;
C_noret_decl(f_37007)
static void C_ccall f_37007(C_word c,C_word *av) C_noret;
C_noret_decl(f_37010)
static void C_ccall f_37010(C_word c,C_word *av) C_noret;
C_noret_decl(f_37013)
static void C_ccall f_37013(C_word c,C_word *av) C_noret;
C_noret_decl(f_37025)
static void C_ccall f_37025(C_word c,C_word *av) C_noret;
C_noret_decl(f_37028)
static void C_ccall f_37028(C_word c,C_word *av) C_noret;
C_noret_decl(f_37031)
static void C_ccall f_37031(C_word c,C_word *av) C_noret;
C_noret_decl(f_37034)
static void C_ccall f_37034(C_word c,C_word *av) C_noret;
C_noret_decl(f_37043)
static void C_ccall f_37043(C_word c,C_word *av) C_noret;
C_noret_decl(f_37046)
static void C_ccall f_37046(C_word c,C_word *av) C_noret;
C_noret_decl(f_37059)
static void C_ccall f_37059(C_word c,C_word *av) C_noret;
C_noret_decl(f_37060)
static void C_ccall f_37060(C_word c,C_word *av) C_noret;
C_noret_decl(f_37065)
static void C_ccall f_37065(C_word c,C_word *av) C_noret;
C_noret_decl(f_37066)
static void C_ccall f_37066(C_word c,C_word *av) C_noret;
C_noret_decl(f_37071)
static void C_ccall f_37071(C_word c,C_word *av) C_noret;
C_noret_decl(f_37072)
static void C_ccall f_37072(C_word c,C_word *av) C_noret;
C_noret_decl(f_37077)
static void C_ccall f_37077(C_word c,C_word *av) C_noret;
C_noret_decl(f_37078)
static void C_ccall f_37078(C_word c,C_word *av) C_noret;
C_noret_decl(f_37083)
static void C_ccall f_37083(C_word c,C_word *av) C_noret;
C_noret_decl(f_37084)
static void C_ccall f_37084(C_word c,C_word *av) C_noret;
C_noret_decl(f_37089)
static void f_37089(C_word t0,C_word t1) C_noret;
C_noret_decl(f_37091)
static void C_ccall f_37091(C_word c,C_word *av) C_noret;
C_noret_decl(f_37101)
static void C_ccall f_37101(C_word c,C_word *av) C_noret;
C_noret_decl(f_37104)
static void C_ccall f_37104(C_word c,C_word *av) C_noret;
C_noret_decl(f_37107)
static void C_ccall f_37107(C_word c,C_word *av) C_noret;
C_noret_decl(f_37110)
static void C_ccall f_37110(C_word c,C_word *av) C_noret;
C_noret_decl(f_37112)
static void f_37112(C_word t0,C_word t1) C_noret;
C_noret_decl(f_37126)
static void C_ccall f_37126(C_word c,C_word *av) C_noret;
C_noret_decl(f_37134)
static void C_ccall f_37134(C_word c,C_word *av) C_noret;
C_noret_decl(f_37138)
static void C_ccall f_37138(C_word c,C_word *av) C_noret;
C_noret_decl(f_37142)
static void C_ccall f_37142(C_word c,C_word *av) C_noret;
C_noret_decl(f_37146)
static void C_ccall f_37146(C_word c,C_word *av) C_noret;
C_noret_decl(f_37152)
static void C_ccall f_37152(C_word c,C_word *av) C_noret;
C_noret_decl(f_37159)
static void C_ccall f_37159(C_word c,C_word *av) C_noret;
C_noret_decl(f_37163)
static void C_ccall f_37163(C_word c,C_word *av) C_noret;
C_noret_decl(f_37167)
static void C_ccall f_37167(C_word c,C_word *av) C_noret;
C_noret_decl(f_37171)
static void C_ccall f_37171(C_word c,C_word *av) C_noret;
C_noret_decl(f_37189)
static void C_ccall f_37189(C_word c,C_word *av) C_noret;
C_noret_decl(f_37208)
static void C_ccall f_37208(C_word c,C_word *av) C_noret;
C_noret_decl(f_37211)
static void C_ccall f_37211(C_word c,C_word *av) C_noret;
C_noret_decl(f_37214)
static void C_ccall f_37214(C_word c,C_word *av) C_noret;
C_noret_decl(f_37217)
static void C_ccall f_37217(C_word c,C_word *av) C_noret;
C_noret_decl(f_37226)
static void C_ccall f_37226(C_word c,C_word *av) C_noret;
C_noret_decl(f_37232)
static void C_ccall f_37232(C_word c,C_word *av) C_noret;
C_noret_decl(f_37255)
static void C_ccall f_37255(C_word c,C_word *av) C_noret;
C_noret_decl(f_37277)
static void C_ccall f_37277(C_word c,C_word *av) C_noret;
C_noret_decl(f_37283)
static void f_37283(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_37303)
static void C_ccall f_37303(C_word c,C_word *av) C_noret;
C_noret_decl(f_37318)
static void C_ccall f_37318(C_word c,C_word *av) C_noret;
C_noret_decl(f_37322)
static void C_ccall f_37322(C_word c,C_word *av) C_noret;
C_noret_decl(f_37345)
static void C_ccall f_37345(C_word c,C_word *av) C_noret;
C_noret_decl(f_37349)
static void C_ccall f_37349(C_word c,C_word *av) C_noret;
C_noret_decl(f_37351)
static void C_ccall f_37351(C_word c,C_word *av) C_noret;
C_noret_decl(f_37381)
static void C_ccall f_37381(C_word c,C_word *av) C_noret;
C_noret_decl(f_37384)
static void C_ccall f_37384(C_word c,C_word *av) C_noret;
C_noret_decl(f_37386)
static void C_ccall f_37386(C_word c,C_word *av) C_noret;
C_noret_decl(f_37404)
static void C_ccall f_37404(C_word c,C_word *av) C_noret;
C_noret_decl(f_37411)
static void C_ccall f_37411(C_word c,C_word *av) C_noret;
C_noret_decl(f_37433)
static void C_ccall f_37433(C_word c,C_word *av) C_noret;
C_noret_decl(f_37442)
static void f_37442(C_word t0,C_word t1) C_noret;
C_noret_decl(f_37457)
static void C_ccall f_37457(C_word c,C_word *av) C_noret;
C_noret_decl(f_37460)
static void C_ccall f_37460(C_word c,C_word *av) C_noret;
C_noret_decl(f_37463)
static void C_ccall f_37463(C_word c,C_word *av) C_noret;
C_noret_decl(f_37466)
static void C_ccall f_37466(C_word c,C_word *av) C_noret;
C_noret_decl(f_37469)
static void C_ccall f_37469(C_word c,C_word *av) C_noret;
C_noret_decl(f_37472)
static void C_ccall f_37472(C_word c,C_word *av) C_noret;
C_noret_decl(f_37475)
static void f_37475(C_word t0,C_word t1) C_noret;
C_noret_decl(f_37478)
static void f_37478(C_word t0,C_word t1) C_noret;
C_noret_decl(f_37481)
static void f_37481(C_word t0,C_word t1) C_noret;
C_noret_decl(f_37484)
static void f_37484(C_word t0,C_word t1) C_noret;
C_noret_decl(f_37492)
static void C_ccall f_37492(C_word c,C_word *av) C_noret;
C_noret_decl(f_37495)
static void C_ccall f_37495(C_word c,C_word *av) C_noret;
C_noret_decl(f_37500)
static void C_ccall f_37500(C_word c,C_word *av) C_noret;
C_noret_decl(f_37506)
static void C_ccall f_37506(C_word c,C_word *av) C_noret;
C_noret_decl(f_37519)
static void C_ccall f_37519(C_word c,C_word *av) C_noret;
C_noret_decl(f_37521)
static void f_37521(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_37544)
static void C_ccall f_37544(C_word c,C_word *av) C_noret;
C_noret_decl(f_37551)
static void C_ccall f_37551(C_word c,C_word *av) C_noret;
C_noret_decl(f_37555)
static void C_ccall f_37555(C_word c,C_word *av) C_noret;
C_noret_decl(f_37557)
static void f_37557(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_37586)
static void C_ccall f_37586(C_word c,C_word *av) C_noret;
C_noret_decl(f_37588)
static void f_37588(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_37613)
static void C_ccall f_37613(C_word c,C_word *av) C_noret;
C_noret_decl(f_37622)
static void C_ccall f_37622(C_word c,C_word *av) C_noret;
C_noret_decl(f_37628)
static void f_37628(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_37652)
static void C_ccall f_37652(C_word c,C_word *av) C_noret;
C_noret_decl(f_37659)
static void C_ccall f_37659(C_word c,C_word *av) C_noret;
C_noret_decl(f_37663)
static void C_ccall f_37663(C_word c,C_word *av) C_noret;
C_noret_decl(f_37675)
static void C_ccall f_37675(C_word c,C_word *av) C_noret;
C_noret_decl(f_37683)
static void C_ccall f_37683(C_word c,C_word *av) C_noret;
C_noret_decl(f_37687)
static void C_ccall f_37687(C_word c,C_word *av) C_noret;
C_noret_decl(f_37696)
static void C_ccall f_37696(C_word c,C_word *av) C_noret;
C_noret_decl(f_37705)
static void C_ccall f_37705(C_word c,C_word *av) C_noret;
C_noret_decl(f_37713)
static void C_ccall f_37713(C_word c,C_word *av) C_noret;
C_noret_decl(f_37726)
static void C_ccall f_37726(C_word c,C_word *av) C_noret;
C_noret_decl(f_37734)
static void f_37734(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_37759)
static void C_ccall f_37759(C_word c,C_word *av) C_noret;
C_noret_decl(f_37768)
static void C_ccall f_37768(C_word c,C_word *av) C_noret;
C_noret_decl(f_37775)
static void C_ccall f_37775(C_word c,C_word *av) C_noret;
C_noret_decl(f_37778)
static void C_ccall f_37778(C_word c,C_word *av) C_noret;
C_noret_decl(f_37783)
static void f_37783(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_37815)
static void C_ccall f_37815(C_word c,C_word *av) C_noret;
C_noret_decl(f_37819)
static void C_ccall f_37819(C_word c,C_word *av) C_noret;
C_noret_decl(f_37822)
static void C_ccall f_37822(C_word c,C_word *av) C_noret;
C_noret_decl(f_37827)
static void f_37827(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_37840)
static void C_ccall f_37840(C_word c,C_word *av) C_noret;
C_noret_decl(f_37865)
static void C_ccall f_37865(C_word c,C_word *av) C_noret;
C_noret_decl(f_37877)
static void f_37877(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_37902)
static void C_ccall f_37902(C_word c,C_word *av) C_noret;
C_noret_decl(f_37904)
static void C_ccall f_37904(C_word c,C_word *av) C_noret;
C_noret_decl(f_37918)
static void f_37918(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_37928)
static void C_ccall f_37928(C_word c,C_word *av) C_noret;
C_noret_decl(f_37931)
static void C_ccall f_37931(C_word c,C_word *av) C_noret;
C_noret_decl(f_37934)
static void C_ccall f_37934(C_word c,C_word *av) C_noret;
C_noret_decl(f_37939)
static C_word f_37939(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_38008)
static void C_ccall f_38008(C_word c,C_word *av) C_noret;
C_noret_decl(f_38022)
static void f_38022(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_38032)
static void C_ccall f_38032(C_word c,C_word *av) C_noret;
C_noret_decl(f_38035)
static void C_ccall f_38035(C_word c,C_word *av) C_noret;
C_noret_decl(f_38038)
static void C_ccall f_38038(C_word c,C_word *av) C_noret;
C_noret_decl(f_38043)
static void f_38043(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_38122)
static void C_ccall f_38122(C_word c,C_word *av) C_noret;
C_noret_decl(f_38132)
static void C_ccall f_38132(C_word c,C_word *av) C_noret;
C_noret_decl(f_38137)
static void f_38137(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_38150)
static void C_ccall f_38150(C_word c,C_word *av) C_noret;
C_noret_decl(f_38184)
static void C_ccall f_38184(C_word c,C_word *av) C_noret;
C_noret_decl(f_38198)
static void C_ccall f_38198(C_word c,C_word *av) C_noret;
C_noret_decl(f_38207)
static void C_ccall f_38207(C_word c,C_word *av) C_noret;
C_noret_decl(f_38212)
static void f_38212(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38233)
static void C_ccall f_38233(C_word c,C_word *av) C_noret;
C_noret_decl(f_38238)
static C_word f_38238(C_word t0,C_word t1);
C_noret_decl(f_38245)
static void C_ccall f_38245(C_word c,C_word *av) C_noret;
C_noret_decl(f_38247)
static void f_38247(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38281)
static C_word f_38281(C_word t0,C_word t1);
C_noret_decl(f_38305)
static void f_38305(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38339)
static C_word f_38339(C_word t0);
C_noret_decl(f_38362)
static void C_ccall f_38362(C_word c,C_word *av) C_noret;
C_noret_decl(f_38374)
static void f_38374(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38384)
static void C_ccall f_38384(C_word c,C_word *av) C_noret;
C_noret_decl(f_38410)
static void C_ccall f_38410(C_word c,C_word *av) C_noret;
C_noret_decl(f_38424)
static void C_ccall f_38424(C_word c,C_word *av) C_noret;
C_noret_decl(f_38433)
static void C_ccall f_38433(C_word c,C_word *av) C_noret;
C_noret_decl(f_38438)
static void f_38438(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38448)
static void C_ccall f_38448(C_word c,C_word *av) C_noret;
C_noret_decl(f_38460)
static C_word f_38460(C_word t0,C_word t1);
C_noret_decl(f_38467)
static void C_ccall f_38467(C_word c,C_word *av) C_noret;
C_noret_decl(f_38469)
static void f_38469(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38503)
static C_word f_38503(C_word t0,C_word t1);
C_noret_decl(f_38527)
static void f_38527(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38561)
static C_word f_38561(C_word t0);
C_noret_decl(f_38584)
static void C_ccall f_38584(C_word c,C_word *av) C_noret;
C_noret_decl(f_38594)
static void C_ccall f_38594(C_word c,C_word *av) C_noret;
C_noret_decl(f_38603)
static void C_ccall f_38603(C_word c,C_word *av) C_noret;
C_noret_decl(f_38608)
static void f_38608(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38629)
static void C_ccall f_38629(C_word c,C_word *av) C_noret;
C_noret_decl(f_38639)
static void C_ccall f_38639(C_word c,C_word *av) C_noret;
C_noret_decl(f_38653)
static void C_ccall f_38653(C_word c,C_word *av) C_noret;
C_noret_decl(f_38662)
static void C_ccall f_38662(C_word c,C_word *av) C_noret;
C_noret_decl(f_38667)
static void f_38667(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38688)
static void C_ccall f_38688(C_word c,C_word *av) C_noret;
C_noret_decl(f_38693)
static C_word f_38693(C_word t0,C_word t1);
C_noret_decl(f_38700)
static void C_ccall f_38700(C_word c,C_word *av) C_noret;
C_noret_decl(f_38702)
static void f_38702(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38736)
static C_word f_38736(C_word t0,C_word t1);
C_noret_decl(f_38760)
static void f_38760(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38794)
static C_word f_38794(C_word t0);
C_noret_decl(f_38817)
static void C_ccall f_38817(C_word c,C_word *av) C_noret;
C_noret_decl(f_38827)
static void C_ccall f_38827(C_word c,C_word *av) C_noret;
C_noret_decl(f_38838)
static void f_38838(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38848)
static void C_ccall f_38848(C_word c,C_word *av) C_noret;
C_noret_decl(f_38865)
static void C_ccall f_38865(C_word c,C_word *av) C_noret;
C_noret_decl(f_38879)
static void C_ccall f_38879(C_word c,C_word *av) C_noret;
C_noret_decl(f_38888)
static void C_ccall f_38888(C_word c,C_word *av) C_noret;
C_noret_decl(f_38893)
static void f_38893(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38903)
static void C_ccall f_38903(C_word c,C_word *av) C_noret;
C_noret_decl(f_38915)
static C_word f_38915(C_word t0,C_word t1);
C_noret_decl(f_38922)
static void C_ccall f_38922(C_word c,C_word *av) C_noret;
C_noret_decl(f_38924)
static void f_38924(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_38958)
static C_word f_38958(C_word t0,C_word t1);
C_noret_decl(f_38982)
static void f_38982(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_39016)
static C_word f_39016(C_word t0);
C_noret_decl(f_39039)
static void C_ccall f_39039(C_word c,C_word *av) C_noret;
C_noret_decl(f_39043)
static void C_ccall f_39043(C_word c,C_word *av) C_noret;
C_noret_decl(f_39046)
static void C_ccall f_39046(C_word c,C_word *av) C_noret;
C_noret_decl(f_39049)
static void C_ccall f_39049(C_word c,C_word *av) C_noret;
C_noret_decl(f_39074)
static void C_ccall f_39074(C_word c,C_word *av) C_noret;
C_noret_decl(f_39080)
static void C_ccall f_39080(C_word c,C_word *av) C_noret;
C_noret_decl(f_39086)
static void C_ccall f_39086(C_word c,C_word *av) C_noret;
C_noret_decl(f_39090)
static void C_ccall f_39090(C_word c,C_word *av) C_noret;
C_noret_decl(f_39095)
static void C_ccall f_39095(C_word c,C_word *av) C_noret;
C_noret_decl(f_39098)
static void C_ccall f_39098(C_word c,C_word *av) C_noret;
C_noret_decl(f_39109)
static void C_ccall f_39109(C_word c,C_word *av) C_noret;
C_noret_decl(f_39134)
static void C_ccall f_39134(C_word c,C_word *av) C_noret;
C_noret_decl(f_39148)
static void C_ccall f_39148(C_word c,C_word *av) C_noret;
C_noret_decl(f_39176)
static void f_39176(C_word t0,C_word t1) C_noret;
C_noret_decl(f_39179)
static void f_39179(C_word t0,C_word t1) C_noret;
C_noret_decl(f_39182)
static void C_ccall f_39182(C_word c,C_word *av) C_noret;
C_noret_decl(f_39252)
static void C_ccall f_39252(C_word c,C_word *av) C_noret;
C_noret_decl(f_39281)
static void C_ccall f_39281(C_word c,C_word *av) C_noret;
C_noret_decl(f_39283)
static void f_39283(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_39303)
static void C_ccall f_39303(C_word c,C_word *av) C_noret;
C_noret_decl(f_39355)
static void C_ccall f_39355(C_word c,C_word *av) C_noret;
C_noret_decl(f_39365)
static void f_39365(C_word t0,C_word t1) C_noret;
C_noret_decl(f_39375)
static void f_39375(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_39388)
static void C_ccall f_39388(C_word c,C_word *av) C_noret;
C_noret_decl(f_39393)
static void f_39393(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_39406)
static void C_ccall f_39406(C_word c,C_word *av) C_noret;
C_noret_decl(f_39439)
static void C_ccall f_39439(C_word c,C_word *av) C_noret;
C_noret_decl(f_39448)
static void C_ccall f_39448(C_word c,C_word *av) C_noret;
C_noret_decl(f_39474)
static void C_ccall f_39474(C_word c,C_word *av) C_noret;
C_noret_decl(f_39482)
static void C_ccall f_39482(C_word c,C_word *av) C_noret;
C_noret_decl(f_39511)
static void C_ccall f_39511(C_word c,C_word *av) C_noret;
C_noret_decl(f_39539)
static void f_39539(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_39552)
static void C_ccall f_39552(C_word c,C_word *av) C_noret;
C_noret_decl(f_39601)
static void C_ccall f_39601(C_word c,C_word *av) C_noret;
C_noret_decl(f_39620)
static void C_ccall f_39620(C_word c,C_word *av) C_noret;
C_noret_decl(f_39640)
static void C_ccall f_39640(C_word c,C_word *av) C_noret;
C_noret_decl(f_39655)
static void f_39655(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_39659)
static void C_ccall f_39659(C_word c,C_word *av) C_noret;
C_noret_decl(f_39715)
static void C_ccall f_39715(C_word c,C_word *av) C_noret;
C_noret_decl(f_39719)
static void C_ccall f_39719(C_word c,C_word *av) C_noret;
C_noret_decl(f_39727)
static void C_ccall f_39727(C_word c,C_word *av) C_noret;
C_noret_decl(f_39730)
static void f_39730(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_39734)
static void C_ccall f_39734(C_word c,C_word *av) C_noret;
C_noret_decl(f_39745)
static void C_ccall f_39745(C_word c,C_word *av) C_noret;
C_noret_decl(f_39748)
static C_word f_39748(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_39754)
static void f_39754(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_39758)
static void C_ccall f_39758(C_word c,C_word *av) C_noret;
C_noret_decl(f_39778)
static void f_39778(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_39803)
static void C_ccall f_39803(C_word c,C_word *av) C_noret;
C_noret_decl(f_39873)
static void C_ccall f_39873(C_word c,C_word *av) C_noret;
C_noret_decl(f_39948)
static void C_ccall f_39948(C_word c,C_word *av) C_noret;
C_noret_decl(f_40033)
static void C_ccall f_40033(C_word c,C_word *av) C_noret;
C_noret_decl(f_40052)
static void C_ccall f_40052(C_word c,C_word *av) C_noret;
C_noret_decl(f_40055)
static void C_ccall f_40055(C_word c,C_word *av) C_noret;
C_noret_decl(f_40069)
static void C_ccall f_40069(C_word c,C_word *av) C_noret;
C_noret_decl(f_40081)
static void C_ccall f_40081(C_word c,C_word *av) C_noret;
C_noret_decl(f_40083)
static void C_ccall f_40083(C_word c,C_word *av) C_noret;
C_noret_decl(f_40091)
static void C_ccall f_40091(C_word c,C_word *av) C_noret;
C_noret_decl(f_40093)
static void f_40093(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_40100)
static void C_ccall f_40100(C_word c,C_word *av) C_noret;
C_noret_decl(f_40112)
static void C_ccall f_40112(C_word c,C_word *av) C_noret;
C_noret_decl(f_40132)
static void C_ccall f_40132(C_word c,C_word *av) C_noret;
C_noret_decl(f_40136)
static void C_ccall f_40136(C_word c,C_word *av) C_noret;
C_noret_decl(f_40139)
static void C_ccall f_40139(C_word c,C_word *av) C_noret;
C_noret_decl(f_40148)
static void C_ccall f_40148(C_word c,C_word *av) C_noret;
C_noret_decl(f_40150)
static void C_ccall f_40150(C_word c,C_word *av) C_noret;
C_noret_decl(f_40201)
static void C_ccall f_40201(C_word c,C_word *av) C_noret;
C_noret_decl(f_40226)
static void C_ccall f_40226(C_word c,C_word *av) C_noret;
C_noret_decl(f_40241)
static void C_ccall f_40241(C_word c,C_word *av) C_noret;
C_noret_decl(f_40251)
static void C_ccall f_40251(C_word c,C_word *av) C_noret;
C_noret_decl(f_40281)
static void C_ccall f_40281(C_word c,C_word *av) C_noret;
C_noret_decl(f_40309)
static void C_ccall f_40309(C_word c,C_word *av) C_noret;
C_noret_decl(f_40319)
static void C_ccall f_40319(C_word c,C_word *av) C_noret;
C_noret_decl(f_40324)
static void f_40324(C_word t0,C_word t1) C_noret;
C_noret_decl(f_40328)
static void C_ccall f_40328(C_word c,C_word *av) C_noret;
C_noret_decl(f_40334)
static void C_ccall f_40334(C_word c,C_word *av) C_noret;
C_noret_decl(f_40337)
static void C_ccall f_40337(C_word c,C_word *av) C_noret;
C_noret_decl(f_40344)
static void C_ccall f_40344(C_word c,C_word *av) C_noret;
C_noret_decl(f_40365)
static void C_ccall f_40365(C_word c,C_word *av) C_noret;
C_noret_decl(f_40375)
static void C_ccall f_40375(C_word c,C_word *av) C_noret;
C_noret_decl(f_40378)
static void C_ccall f_40378(C_word c,C_word *av) C_noret;
C_noret_decl(f_40392)
static void C_ccall f_40392(C_word c,C_word *av) C_noret;
C_noret_decl(f_40405)
static void C_ccall f_40405(C_word c,C_word *av) C_noret;
C_noret_decl(f_40423)
static void C_ccall f_40423(C_word c,C_word *av) C_noret;
C_noret_decl(f_40457)
static void C_ccall f_40457(C_word c,C_word *av) C_noret;
C_noret_decl(f_40460)
static void C_ccall f_40460(C_word c,C_word *av) C_noret;
C_noret_decl(f_40519)
static void C_ccall f_40519(C_word c,C_word *av) C_noret;
C_noret_decl(f_40527)
static void C_ccall f_40527(C_word c,C_word *av) C_noret;
C_noret_decl(f_40531)
static void C_ccall f_40531(C_word c,C_word *av) C_noret;
C_noret_decl(f_40535)
static void C_ccall f_40535(C_word c,C_word *av) C_noret;
C_noret_decl(f_40541)
static void C_ccall f_40541(C_word c,C_word *av) C_noret;
C_noret_decl(f_40545)
static void C_ccall f_40545(C_word c,C_word *av) C_noret;
C_noret_decl(f_40549)
static void C_ccall f_40549(C_word c,C_word *av) C_noret;
C_noret_decl(f_40571)
static void C_ccall f_40571(C_word c,C_word *av) C_noret;
C_noret_decl(f_40575)
static void C_ccall f_40575(C_word c,C_word *av) C_noret;
C_noret_decl(f_40579)
static void C_ccall f_40579(C_word c,C_word *av) C_noret;
C_noret_decl(f_40583)
static void C_ccall f_40583(C_word c,C_word *av) C_noret;
C_noret_decl(f_40587)
static void C_ccall f_40587(C_word c,C_word *av) C_noret;
C_noret_decl(f_40607)
static void C_ccall f_40607(C_word c,C_word *av) C_noret;
C_noret_decl(f_40615)
static void f_40615(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_40640)
static void C_ccall f_40640(C_word c,C_word *av) C_noret;
C_noret_decl(f_40657)
static void C_ccall f_40657(C_word c,C_word *av) C_noret;
C_noret_decl(f_40661)
static void C_ccall f_40661(C_word c,C_word *av) C_noret;
C_noret_decl(f_40664)
static void C_ccall f_40664(C_word c,C_word *av) C_noret;
C_noret_decl(f_40667)
static void C_ccall f_40667(C_word c,C_word *av) C_noret;
C_noret_decl(f_40677)
static void C_ccall f_40677(C_word c,C_word *av) C_noret;
C_noret_decl(f_40680)
static void C_ccall f_40680(C_word c,C_word *av) C_noret;
C_noret_decl(f_40682)
static void C_ccall f_40682(C_word c,C_word *av) C_noret;
C_noret_decl(f_40699)
static C_word f_40699(C_word t0);
C_noret_decl(f_40726)
static void C_ccall f_40726(C_word c,C_word *av) C_noret;
C_noret_decl(f_40735)
static void C_ccall f_40735(C_word c,C_word *av) C_noret;
C_noret_decl(f_40755)
static void C_ccall f_40755(C_word c,C_word *av) C_noret;
C_noret_decl(f_40759)
static void C_ccall f_40759(C_word c,C_word *av) C_noret;
C_noret_decl(f_40763)
static void C_ccall f_40763(C_word c,C_word *av) C_noret;
C_noret_decl(f_40767)
static void C_ccall f_40767(C_word c,C_word *av) C_noret;
C_noret_decl(f_40771)
static void C_ccall f_40771(C_word c,C_word *av) C_noret;
C_noret_decl(f_40775)
static void C_ccall f_40775(C_word c,C_word *av) C_noret;
C_noret_decl(f_40779)
static void C_ccall f_40779(C_word c,C_word *av) C_noret;
C_noret_decl(f_40781)
static void C_ccall f_40781(C_word c,C_word *av) C_noret;
C_noret_decl(f_40790)
static void C_ccall f_40790(C_word c,C_word *av) C_noret;
C_noret_decl(f_40800)
static void C_ccall f_40800(C_word c,C_word *av) C_noret;
C_noret_decl(f_40825)
static void C_ccall f_40825(C_word c,C_word *av) C_noret;
C_noret_decl(f_40828)
static void C_ccall f_40828(C_word c,C_word *av) C_noret;
C_noret_decl(f_40830)
static void C_ccall f_40830(C_word c,C_word *av) C_noret;
C_noret_decl(f_40846)
static void f_40846(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_40881)
static void C_ccall f_40881(C_word c,C_word *av) C_noret;
C_noret_decl(f_40905)
static void C_ccall f_40905(C_word c,C_word *av) C_noret;
C_noret_decl(f_40909)
static void C_ccall f_40909(C_word c,C_word *av) C_noret;
C_noret_decl(f_40911)
static void C_ccall f_40911(C_word c,C_word *av) C_noret;
C_noret_decl(f_40915)
static void C_ccall f_40915(C_word c,C_word *av) C_noret;
C_noret_decl(f_40918)
static void C_ccall f_40918(C_word c,C_word *av) C_noret;
C_noret_decl(f_40931)
static void C_ccall f_40931(C_word c,C_word *av) C_noret;
C_noret_decl(f_40936)
static void C_ccall f_40936(C_word c,C_word *av) C_noret;
C_noret_decl(f_40951)
static void C_ccall f_40951(C_word c,C_word *av) C_noret;
C_noret_decl(f_40955)
static void C_ccall f_40955(C_word c,C_word *av) C_noret;
C_noret_decl(f_40964)
static void C_ccall f_40964(C_word c,C_word *av) C_noret;
C_noret_decl(f_40967)
static void C_ccall f_40967(C_word c,C_word *av) C_noret;
C_noret_decl(f_40970)
static void C_ccall f_40970(C_word c,C_word *av) C_noret;
C_noret_decl(f_40973)
static void C_ccall f_40973(C_word c,C_word *av) C_noret;
C_noret_decl(f_40976)
static void C_ccall f_40976(C_word c,C_word *av) C_noret;
C_noret_decl(f_40978)
static void C_ccall f_40978(C_word c,C_word *av) C_noret;
C_noret_decl(f_40988)
static void C_ccall f_40988(C_word c,C_word *av) C_noret;
C_noret_decl(f_41000)
static void C_ccall f_41000(C_word c,C_word *av) C_noret;
C_noret_decl(f_41008)
static void f_41008(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_41018)
static void C_ccall f_41018(C_word c,C_word *av) C_noret;
C_noret_decl(f_41034)
static void C_ccall f_41034(C_word c,C_word *av) C_noret;
C_noret_decl(f_41040)
static void C_ccall f_41040(C_word c,C_word *av) C_noret;
C_noret_decl(f_41043)
static void C_ccall f_41043(C_word c,C_word *av) C_noret;
C_noret_decl(f_41046)
static void C_ccall f_41046(C_word c,C_word *av) C_noret;
C_noret_decl(f_41047)
static void f_41047(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_41051)
static void C_ccall f_41051(C_word c,C_word *av) C_noret;
C_noret_decl(f_41057)
static void C_ccall f_41057(C_word c,C_word *av) C_noret;
C_noret_decl(f_41061)
static void C_ccall f_41061(C_word c,C_word *av) C_noret;
C_noret_decl(f_41063)
static void f_41063(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_41073)
static void C_ccall f_41073(C_word c,C_word *av) C_noret;
C_noret_decl(f_41090)
static void C_ccall f_41090(C_word c,C_word *av) C_noret;
C_noret_decl(f_41093)
static void C_ccall f_41093(C_word c,C_word *av) C_noret;
C_noret_decl(f_41097)
static void C_ccall f_41097(C_word c,C_word *av) C_noret;
C_noret_decl(f_41102)
static void C_ccall f_41102(C_word c,C_word *av) C_noret;
C_noret_decl(f_41108)
static void C_ccall f_41108(C_word c,C_word *av) C_noret;
C_noret_decl(f_41124)
static void C_ccall f_41124(C_word c,C_word *av) C_noret;
C_noret_decl(f_41132)
static void C_ccall f_41132(C_word c,C_word *av) C_noret;
C_noret_decl(f_41154)
static void C_ccall f_41154(C_word c,C_word *av) C_noret;
C_noret_decl(f_41172)
static void C_ccall f_41172(C_word c,C_word *av) C_noret;
C_noret_decl(f_41176)
static void C_ccall f_41176(C_word c,C_word *av) C_noret;
C_noret_decl(f_41188)
static void C_ccall f_41188(C_word c,C_word *av) C_noret;
C_noret_decl(f_41195)
static void C_ccall f_41195(C_word c,C_word *av) C_noret;
C_noret_decl(f_41210)
static void C_ccall f_41210(C_word c,C_word *av) C_noret;
C_noret_decl(f_41213)
static void C_ccall f_41213(C_word c,C_word *av) C_noret;
C_noret_decl(f_41216)
static void C_ccall f_41216(C_word c,C_word *av) C_noret;
C_noret_decl(f_41229)
static void f_41229(C_word t0,C_word t1) C_noret;
C_noret_decl(f_41252)
static void C_ccall f_41252(C_word c,C_word *av) C_noret;
C_noret_decl(f_41276)
static void C_ccall f_41276(C_word c,C_word *av) C_noret;
C_noret_decl(f_41286)
static void C_ccall f_41286(C_word c,C_word *av) C_noret;
C_noret_decl(f_41295)
static void C_ccall f_41295(C_word c,C_word *av) C_noret;
C_noret_decl(f_41336)
static void C_ccall f_41336(C_word c,C_word *av) C_noret;
C_noret_decl(f_41358)
static void C_ccall f_41358(C_word c,C_word *av) C_noret;
C_noret_decl(f_41367)
static void C_ccall f_41367(C_word c,C_word *av) C_noret;
C_noret_decl(f_41371)
static void C_ccall f_41371(C_word c,C_word *av) C_noret;
C_noret_decl(f_41376)
static void C_ccall f_41376(C_word c,C_word *av) C_noret;
C_noret_decl(f_41386)
static void C_ccall f_41386(C_word c,C_word *av) C_noret;
C_noret_decl(f_41396)
static void C_ccall f_41396(C_word c,C_word *av) C_noret;
C_noret_decl(f_41406)
static void C_ccall f_41406(C_word c,C_word *av) C_noret;
C_noret_decl(f_41416)
static void C_ccall f_41416(C_word c,C_word *av) C_noret;
C_noret_decl(f_41426)
static void C_ccall f_41426(C_word c,C_word *av) C_noret;
C_noret_decl(f_41436)
static void C_ccall f_41436(C_word c,C_word *av) C_noret;
C_noret_decl(f_41446)
static void C_ccall f_41446(C_word c,C_word *av) C_noret;
C_noret_decl(f_41456)
static void C_ccall f_41456(C_word c,C_word *av) C_noret;
C_noret_decl(f_41466)
static void C_ccall f_41466(C_word c,C_word *av) C_noret;
C_noret_decl(f_41476)
static void C_ccall f_41476(C_word c,C_word *av) C_noret;
C_noret_decl(f_41486)
static void C_ccall f_41486(C_word c,C_word *av) C_noret;
C_noret_decl(f_41496)
static void C_ccall f_41496(C_word c,C_word *av) C_noret;
C_noret_decl(f_41506)
static void C_ccall f_41506(C_word c,C_word *av) C_noret;
C_noret_decl(f_41522)
static void C_ccall f_41522(C_word c,C_word *av) C_noret;
C_noret_decl(f_41530)
static void C_ccall f_41530(C_word c,C_word *av) C_noret;
C_noret_decl(f_41546)
static void C_ccall f_41546(C_word c,C_word *av) C_noret;
C_noret_decl(f_41562)
static void C_ccall f_41562(C_word c,C_word *av) C_noret;
C_noret_decl(f_41572)
static void C_ccall f_41572(C_word c,C_word *av) C_noret;
C_noret_decl(f_41582)
static void C_ccall f_41582(C_word c,C_word *av) C_noret;
C_noret_decl(f_41601)
static void C_ccall f_41601(C_word c,C_word *av) C_noret;
C_noret_decl(f_41617)
static void C_ccall f_41617(C_word c,C_word *av) C_noret;
C_noret_decl(f_41630)
static void C_ccall f_41630(C_word c,C_word *av) C_noret;
C_noret_decl(f_41636)
static void C_ccall f_41636(C_word c,C_word *av) C_noret;
C_noret_decl(f_41668)
static void C_ccall f_41668(C_word c,C_word *av) C_noret;
C_noret_decl(f_41684)
static void C_ccall f_41684(C_word c,C_word *av) C_noret;
C_noret_decl(f_41688)
static void C_ccall f_41688(C_word c,C_word *av) C_noret;
C_noret_decl(f_41698)
static void C_ccall f_41698(C_word c,C_word *av) C_noret;
C_noret_decl(f_41704)
static void C_ccall f_41704(C_word c,C_word *av) C_noret;
C_noret_decl(f_41711)
static void C_ccall f_41711(C_word c,C_word *av) C_noret;
C_noret_decl(f_41729)
static void C_ccall f_41729(C_word c,C_word *av) C_noret;
C_noret_decl(f_41733)
static void C_ccall f_41733(C_word c,C_word *av) C_noret;
C_noret_decl(f_41741)
static void C_ccall f_41741(C_word c,C_word *av) C_noret;
C_noret_decl(f_41744)
static void C_ccall f_41744(C_word c,C_word *av) C_noret;
C_noret_decl(f_41757)
static void C_ccall f_41757(C_word c,C_word *av) C_noret;
C_noret_decl(f_41760)
static void C_ccall f_41760(C_word c,C_word *av) C_noret;
C_noret_decl(f_41772)
static void C_ccall f_41772(C_word c,C_word *av) C_noret;
C_noret_decl(f_41786)
static void C_ccall f_41786(C_word c,C_word *av) C_noret;
C_noret_decl(f_41789)
static void C_ccall f_41789(C_word c,C_word *av) C_noret;
C_noret_decl(f_41795)
static void C_ccall f_41795(C_word c,C_word *av) C_noret;
C_noret_decl(f_41798)
static void C_ccall f_41798(C_word c,C_word *av) C_noret;
C_noret_decl(f_41801)
static void C_ccall f_41801(C_word c,C_word *av) C_noret;
C_noret_decl(f_41808)
static void f_41808(C_word t0,C_word t1) C_noret;
C_noret_decl(f_41817)
static void f_41817(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_41833)
static void C_ccall f_41833(C_word c,C_word *av) C_noret;
C_noret_decl(f_41844)
static void C_ccall f_41844(C_word c,C_word *av) C_noret;
C_noret_decl(f_41855)
static void C_ccall f_41855(C_word c,C_word *av) C_noret;
C_noret_decl(f_41859)
static void C_ccall f_41859(C_word c,C_word *av) C_noret;
C_noret_decl(f_41908)
static void C_ccall f_41908(C_word c,C_word *av) C_noret;
C_noret_decl(f_41915)
static void f_41915(C_word t0,C_word t1) C_noret;
C_noret_decl(f_41928)
static void f_41928(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6) C_noret;
C_noret_decl(f_41950)
static void C_ccall f_41950(C_word c,C_word *av) C_noret;
C_noret_decl(f_41974)
static void C_ccall f_41974(C_word c,C_word *av) C_noret;
C_noret_decl(f_41978)
static void C_ccall f_41978(C_word c,C_word *av) C_noret;
C_noret_decl(f_41995)
static void C_ccall f_41995(C_word c,C_word *av) C_noret;
C_noret_decl(f_42009)
static void C_ccall f_42009(C_word c,C_word *av) C_noret;
C_noret_decl(f_42017)
static void C_ccall f_42017(C_word c,C_word *av) C_noret;
C_noret_decl(f_42021)
static void C_ccall f_42021(C_word c,C_word *av) C_noret;
C_noret_decl(f_42036)
static void C_ccall f_42036(C_word c,C_word *av) C_noret;
C_noret_decl(f_42040)
static void C_ccall f_42040(C_word c,C_word *av) C_noret;
C_noret_decl(f_42054)
static void C_ccall f_42054(C_word c,C_word *av) C_noret;
C_noret_decl(f_42094)
static void C_ccall f_42094(C_word c,C_word *av) C_noret;
C_noret_decl(C_library_toplevel)
C_extern void C_ccall C_library_toplevel(C_word c,C_word *av) C_noret;

C_noret_decl(trf_11848)
static void C_ccall trf_11848(C_word c,C_word *av) C_noret;
static void C_ccall trf_11848(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_11848(t0,t1,t2,t3);}

C_noret_decl(trf_11899)
static void C_ccall trf_11899(C_word c,C_word *av) C_noret;
static void C_ccall trf_11899(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_11899(t0,t1,t2);}

C_noret_decl(trf_11949)
static void C_ccall trf_11949(C_word c,C_word *av) C_noret;
static void C_ccall trf_11949(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_11949(t0,t1,t2);}

C_noret_decl(trf_12722)
static void C_ccall trf_12722(C_word c,C_word *av) C_noret;
static void C_ccall trf_12722(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_12722(t0,t1,t2,t3);}

C_noret_decl(trf_12759)
static void C_ccall trf_12759(C_word c,C_word *av) C_noret;
static void C_ccall trf_12759(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_12759(t0,t1,t2);}

C_noret_decl(trf_12845)
static void C_ccall trf_12845(C_word c,C_word *av) C_noret;
static void C_ccall trf_12845(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_12845(t0,t1,t2);}

C_noret_decl(trf_12878)
static void C_ccall trf_12878(C_word c,C_word *av) C_noret;
static void C_ccall trf_12878(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_12878(t0,t1,t2);}

C_noret_decl(trf_12996)
static void C_ccall trf_12996(C_word c,C_word *av) C_noret;
static void C_ccall trf_12996(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_12996(t0,t1,t2);}

C_noret_decl(trf_13031)
static void C_ccall trf_13031(C_word c,C_word *av) C_noret;
static void C_ccall trf_13031(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_13031(t0,t1,t2);}

C_noret_decl(trf_13095)
static void C_ccall trf_13095(C_word c,C_word *av) C_noret;
static void C_ccall trf_13095(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_13095(t0,t1,t2);}

C_noret_decl(trf_13169)
static void C_ccall trf_13169(C_word c,C_word *av) C_noret;
static void C_ccall trf_13169(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_13169(t0,t1,t2);}

C_noret_decl(trf_13205)
static void C_ccall trf_13205(C_word c,C_word *av) C_noret;
static void C_ccall trf_13205(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_13205(t0,t1,t2);}

C_noret_decl(trf_13234)
static void C_ccall trf_13234(C_word c,C_word *av) C_noret;
static void C_ccall trf_13234(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_13234(t0,t1,t2,t3);}

C_noret_decl(trf_13281)
static void C_ccall trf_13281(C_word c,C_word *av) C_noret;
static void C_ccall trf_13281(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_13281(t0,t1,t2);}

C_noret_decl(trf_13335)
static void C_ccall trf_13335(C_word c,C_word *av) C_noret;
static void C_ccall trf_13335(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_13335(t0,t1,t2,t3);}

C_noret_decl(trf_13439)
static void C_ccall trf_13439(C_word c,C_word *av) C_noret;
static void C_ccall trf_13439(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_13439(t0,t1);}

C_noret_decl(trf_13477)
static void C_ccall trf_13477(C_word c,C_word *av) C_noret;
static void C_ccall trf_13477(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_13477(t0,t1,t2);}

C_noret_decl(trf_13527)
static void C_ccall trf_13527(C_word c,C_word *av) C_noret;
static void C_ccall trf_13527(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_13527(t0,t1,t2);}

C_noret_decl(trf_13638)
static void C_ccall trf_13638(C_word c,C_word *av) C_noret;
static void C_ccall trf_13638(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_13638(t0,t1);}

C_noret_decl(trf_13669)
static void C_ccall trf_13669(C_word c,C_word *av) C_noret;
static void C_ccall trf_13669(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_13669(t0,t1,t2);}

C_noret_decl(trf_13746)
static void C_ccall trf_13746(C_word c,C_word *av) C_noret;
static void C_ccall trf_13746(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_13746(t0,t1,t2);}

C_noret_decl(trf_13943)
static void C_ccall trf_13943(C_word c,C_word *av) C_noret;
static void C_ccall trf_13943(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_13943(t0,t1,t2,t3,t4);}

C_noret_decl(trf_13947)
static void C_ccall trf_13947(C_word c,C_word *av) C_noret;
static void C_ccall trf_13947(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_13947(t0,t1);}

C_noret_decl(trf_14006)
static void C_ccall trf_14006(C_word c,C_word *av) C_noret;
static void C_ccall trf_14006(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_14006(t0,t1);}

C_noret_decl(trf_14629)
static void C_ccall trf_14629(C_word c,C_word *av) C_noret;
static void C_ccall trf_14629(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_14629(t0,t1,t2,t3);}

C_noret_decl(trf_14678)
static void C_ccall trf_14678(C_word c,C_word *av) C_noret;
static void C_ccall trf_14678(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_14678(t0,t1);}

C_noret_decl(trf_14885)
static void C_ccall trf_14885(C_word c,C_word *av) C_noret;
static void C_ccall trf_14885(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_14885(t0,t1,t2);}

C_noret_decl(trf_14904)
static void C_ccall trf_14904(C_word c,C_word *av) C_noret;
static void C_ccall trf_14904(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_14904(t0,t1,t2);}

C_noret_decl(trf_14958)
static void C_ccall trf_14958(C_word c,C_word *av) C_noret;
static void C_ccall trf_14958(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_14958(t0,t1,t2,t3);}

C_noret_decl(trf_15162)
static void C_ccall trf_15162(C_word c,C_word *av) C_noret;
static void C_ccall trf_15162(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_15162(t0,t1);}

C_noret_decl(trf_15264)
static void C_ccall trf_15264(C_word c,C_word *av) C_noret;
static void C_ccall trf_15264(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_15264(t0,t1,t2,t3);}

C_noret_decl(trf_15375)
static void C_ccall trf_15375(C_word c,C_word *av) C_noret;
static void C_ccall trf_15375(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_15375(t0,t1,t2,t3);}

C_noret_decl(trf_15450)
static void C_ccall trf_15450(C_word c,C_word *av) C_noret;
static void C_ccall trf_15450(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_15450(t0,t1,t2,t3,t4);}

C_noret_decl(trf_15503)
static void C_ccall trf_15503(C_word c,C_word *av) C_noret;
static void C_ccall trf_15503(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_15503(t0,t1,t2,t3,t4);}

C_noret_decl(trf_15568)
static void C_ccall trf_15568(C_word c,C_word *av) C_noret;
static void C_ccall trf_15568(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_15568(t0,t1);}

C_noret_decl(trf_15684)
static void C_ccall trf_15684(C_word c,C_word *av) C_noret;
static void C_ccall trf_15684(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_15684(t0,t1);}

C_noret_decl(trf_15914)
static void C_ccall trf_15914(C_word c,C_word *av) C_noret;
static void C_ccall trf_15914(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_15914(t0,t1);}

C_noret_decl(trf_15921)
static void C_ccall trf_15921(C_word c,C_word *av) C_noret;
static void C_ccall trf_15921(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_15921(t0,t1);}

C_noret_decl(trf_15949)
static void C_ccall trf_15949(C_word c,C_word *av) C_noret;
static void C_ccall trf_15949(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_15949(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_15971)
static void C_ccall trf_15971(C_word c,C_word *av) C_noret;
static void C_ccall trf_15971(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_15971(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_16107)
static void C_ccall trf_16107(C_word c,C_word *av) C_noret;
static void C_ccall trf_16107(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_16107(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_16129)
static void C_ccall trf_16129(C_word c,C_word *av) C_noret;
static void C_ccall trf_16129(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_16129(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_16310)
static void C_ccall trf_16310(C_word c,C_word *av) C_noret;
static void C_ccall trf_16310(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_16310(t0,t1,t2,t3,t4);}

C_noret_decl(trf_16389)
static void C_ccall trf_16389(C_word c,C_word *av) C_noret;
static void C_ccall trf_16389(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_16389(t0,t1,t2,t3);}

C_noret_decl(trf_16410)
static void C_ccall trf_16410(C_word c,C_word *av) C_noret;
static void C_ccall trf_16410(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_16410(t0,t1,t2,t3,t4);}

C_noret_decl(trf_16572)
static void C_ccall trf_16572(C_word c,C_word *av) C_noret;
static void C_ccall trf_16572(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_16572(t0,t1);}

C_noret_decl(trf_17268)
static void C_ccall trf_17268(C_word c,C_word *av) C_noret;
static void C_ccall trf_17268(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_17268(t0,t1,t2);}

C_noret_decl(trf_17627)
static void C_ccall trf_17627(C_word c,C_word *av) C_noret;
static void C_ccall trf_17627(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_17627(t0,t1,t2,t3);}

C_noret_decl(trf_17644)
static void C_ccall trf_17644(C_word c,C_word *av) C_noret;
static void C_ccall trf_17644(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_17644(t0,t1,t2,t3);}

C_noret_decl(trf_17809)
static void C_ccall trf_17809(C_word c,C_word *av) C_noret;
static void C_ccall trf_17809(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_17809(t0,t1,t2,t3);}

C_noret_decl(trf_18291)
static void C_ccall trf_18291(C_word c,C_word *av) C_noret;
static void C_ccall trf_18291(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_18291(t0,t1,t2);}

C_noret_decl(trf_18294)
static void C_ccall trf_18294(C_word c,C_word *av) C_noret;
static void C_ccall trf_18294(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_18294(t0,t1,t2,t3);}

C_noret_decl(trf_18473)
static void C_ccall trf_18473(C_word c,C_word *av) C_noret;
static void C_ccall trf_18473(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_18473(t0,t1,t2,t3,t4);}

C_noret_decl(trf_18517)
static void C_ccall trf_18517(C_word c,C_word *av) C_noret;
static void C_ccall trf_18517(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_18517(t0,t1,t2,t3,t4);}

C_noret_decl(trf_18780)
static void C_ccall trf_18780(C_word c,C_word *av) C_noret;
static void C_ccall trf_18780(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_18780(t0,t1);}

C_noret_decl(trf_18786)
static void C_ccall trf_18786(C_word c,C_word *av) C_noret;
static void C_ccall trf_18786(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_18786(t0,t1);}

C_noret_decl(trf_18842)
static void C_ccall trf_18842(C_word c,C_word *av) C_noret;
static void C_ccall trf_18842(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_18842(t0,t1);}

C_noret_decl(trf_18848)
static void C_ccall trf_18848(C_word c,C_word *av) C_noret;
static void C_ccall trf_18848(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_18848(t0,t1);}

C_noret_decl(trf_19413)
static void C_ccall trf_19413(C_word c,C_word *av) C_noret;
static void C_ccall trf_19413(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_19413(t0,t1);}

C_noret_decl(trf_19448)
static void C_ccall trf_19448(C_word c,C_word *av) C_noret;
static void C_ccall trf_19448(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_19448(t0,t1,t2,t3);}

C_noret_decl(trf_19558)
static void C_ccall trf_19558(C_word c,C_word *av) C_noret;
static void C_ccall trf_19558(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_19558(t0,t1,t2,t3);}

C_noret_decl(trf_19600)
static void C_ccall trf_19600(C_word c,C_word *av) C_noret;
static void C_ccall trf_19600(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_19600(t0,t1,t2);}

C_noret_decl(trf_19614)
static void C_ccall trf_19614(C_word c,C_word *av) C_noret;
static void C_ccall trf_19614(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_19614(t0,t1,t2);}

C_noret_decl(trf_19768)
static void C_ccall trf_19768(C_word c,C_word *av) C_noret;
static void C_ccall trf_19768(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_19768(t0,t1);}

C_noret_decl(trf_19864)
static void C_ccall trf_19864(C_word c,C_word *av) C_noret;
static void C_ccall trf_19864(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_19864(t0,t1,t2,t3);}

C_noret_decl(trf_19960)
static void C_ccall trf_19960(C_word c,C_word *av) C_noret;
static void C_ccall trf_19960(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_19960(t0,t1,t2,t3);}

C_noret_decl(trf_20025)
static void C_ccall trf_20025(C_word c,C_word *av) C_noret;
static void C_ccall trf_20025(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_20025(t0,t1,t2,t3);}

C_noret_decl(trf_20226)
static void C_ccall trf_20226(C_word c,C_word *av) C_noret;
static void C_ccall trf_20226(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_20226(t0,t1);}

C_noret_decl(trf_20287)
static void C_ccall trf_20287(C_word c,C_word *av) C_noret;
static void C_ccall trf_20287(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_20287(t0,t1,t2);}

C_noret_decl(trf_20330)
static void C_ccall trf_20330(C_word c,C_word *av) C_noret;
static void C_ccall trf_20330(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_20330(t0,t1,t2,t3,t4);}

C_noret_decl(trf_20348)
static void C_ccall trf_20348(C_word c,C_word *av) C_noret;
static void C_ccall trf_20348(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_20348(t0,t1,t2,t3);}

C_noret_decl(trf_20428)
static void C_ccall trf_20428(C_word c,C_word *av) C_noret;
static void C_ccall trf_20428(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_20428(t0,t1,t2);}

C_noret_decl(trf_20434)
static void C_ccall trf_20434(C_word c,C_word *av) C_noret;
static void C_ccall trf_20434(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_20434(t0,t1,t2);}

C_noret_decl(trf_20494)
static void C_ccall trf_20494(C_word c,C_word *av) C_noret;
static void C_ccall trf_20494(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_20494(t0,t1);}

C_noret_decl(trf_20532)
static void C_ccall trf_20532(C_word c,C_word *av) C_noret;
static void C_ccall trf_20532(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_20532(t0,t1,t2);}

C_noret_decl(trf_20538)
static void C_ccall trf_20538(C_word c,C_word *av) C_noret;
static void C_ccall trf_20538(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_20538(t0,t1,t2);}

C_noret_decl(trf_20580)
static void C_ccall trf_20580(C_word c,C_word *av) C_noret;
static void C_ccall trf_20580(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_20580(t0,t1,t2,t3,t4);}

C_noret_decl(trf_20636)
static void C_ccall trf_20636(C_word c,C_word *av) C_noret;
static void C_ccall trf_20636(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_20636(t0,t1,t2);}

C_noret_decl(trf_20649)
static void C_ccall trf_20649(C_word c,C_word *av) C_noret;
static void C_ccall trf_20649(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_20649(t0,t1);}

C_noret_decl(trf_20689)
static void C_ccall trf_20689(C_word c,C_word *av) C_noret;
static void C_ccall trf_20689(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_20689(t0,t1,t2,t3,t4);}

C_noret_decl(trf_20708)
static void C_ccall trf_20708(C_word c,C_word *av) C_noret;
static void C_ccall trf_20708(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_20708(t0,t1);}

C_noret_decl(trf_20720)
static void C_ccall trf_20720(C_word c,C_word *av) C_noret;
static void C_ccall trf_20720(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_20720(t0,t1);}

C_noret_decl(trf_20747)
static void C_ccall trf_20747(C_word c,C_word *av) C_noret;
static void C_ccall trf_20747(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_20747(t0,t1);}

C_noret_decl(trf_20901)
static void C_ccall trf_20901(C_word c,C_word *av) C_noret;
static void C_ccall trf_20901(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_20901(t0,t1,t2,t3);}

C_noret_decl(trf_20908)
static void C_ccall trf_20908(C_word c,C_word *av) C_noret;
static void C_ccall trf_20908(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_20908(t0,t1);}

C_noret_decl(trf_20979)
static void C_ccall trf_20979(C_word c,C_word *av) C_noret;
static void C_ccall trf_20979(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_20979(t0,t1);}

C_noret_decl(trf_21243)
static void C_ccall trf_21243(C_word c,C_word *av) C_noret;
static void C_ccall trf_21243(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_21243(t0,t1,t2);}

C_noret_decl(trf_21256)
static void C_ccall trf_21256(C_word c,C_word *av) C_noret;
static void C_ccall trf_21256(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_21256(t0,t1);}

C_noret_decl(trf_21311)
static void C_ccall trf_21311(C_word c,C_word *av) C_noret;
static void C_ccall trf_21311(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_21311(t0,t1);}

C_noret_decl(trf_21730)
static void C_ccall trf_21730(C_word c,C_word *av) C_noret;
static void C_ccall trf_21730(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_21730(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_22011)
static void C_ccall trf_22011(C_word c,C_word *av) C_noret;
static void C_ccall trf_22011(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_22011(t0,t1,t2,t3,t4);}

C_noret_decl(trf_22038)
static void C_ccall trf_22038(C_word c,C_word *av) C_noret;
static void C_ccall trf_22038(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_22038(t0,t1,t2);}

C_noret_decl(trf_22079)
static void C_ccall trf_22079(C_word c,C_word *av) C_noret;
static void C_ccall trf_22079(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_22079(t0,t1,t2,t3);}

C_noret_decl(trf_22353)
static void C_ccall trf_22353(C_word c,C_word *av) C_noret;
static void C_ccall trf_22353(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_22353(t0,t1,t2);}

C_noret_decl(trf_22465)
static void C_ccall trf_22465(C_word c,C_word *av) C_noret;
static void C_ccall trf_22465(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_22465(t0,t1,t2,t3);}

C_noret_decl(trf_22498)
static void C_ccall trf_22498(C_word c,C_word *av) C_noret;
static void C_ccall trf_22498(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_22498(t0,t1,t2,t3);}

C_noret_decl(trf_22745)
static void C_ccall trf_22745(C_word c,C_word *av) C_noret;
static void C_ccall trf_22745(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_22745(t0,t1);}

C_noret_decl(trf_22829)
static void C_ccall trf_22829(C_word c,C_word *av) C_noret;
static void C_ccall trf_22829(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_22829(t0,t1);}

C_noret_decl(trf_22883)
static void C_ccall trf_22883(C_word c,C_word *av) C_noret;
static void C_ccall trf_22883(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_22883(t0,t1,t2,t3);}

C_noret_decl(trf_23046)
static void C_ccall trf_23046(C_word c,C_word *av) C_noret;
static void C_ccall trf_23046(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_23046(t0,t1,t2);}

C_noret_decl(trf_23206)
static void C_ccall trf_23206(C_word c,C_word *av) C_noret;
static void C_ccall trf_23206(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_23206(t0,t1,t2,t3);}

C_noret_decl(trf_23316)
static void C_ccall trf_23316(C_word c,C_word *av) C_noret;
static void C_ccall trf_23316(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_23316(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_23492)
static void C_ccall trf_23492(C_word c,C_word *av) C_noret;
static void C_ccall trf_23492(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_23492(t0,t1,t2,t3,t4);}

C_noret_decl(trf_23556)
static void C_ccall trf_23556(C_word c,C_word *av) C_noret;
static void C_ccall trf_23556(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_23556(t0,t1,t2);}

C_noret_decl(trf_23697)
static void C_ccall trf_23697(C_word c,C_word *av) C_noret;
static void C_ccall trf_23697(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_23697(t0,t1,t2,t3);}

C_noret_decl(trf_23752)
static void C_ccall trf_23752(C_word c,C_word *av) C_noret;
static void C_ccall trf_23752(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_23752(t0,t1,t2,t3,t4);}

C_noret_decl(trf_23799)
static void C_ccall trf_23799(C_word c,C_word *av) C_noret;
static void C_ccall trf_23799(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_23799(t0,t1,t2,t3,t4);}

C_noret_decl(trf_23842)
static void C_ccall trf_23842(C_word c,C_word *av) C_noret;
static void C_ccall trf_23842(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_23842(t0,t1,t2,t3,t4);}

C_noret_decl(trf_23885)
static void C_ccall trf_23885(C_word c,C_word *av) C_noret;
static void C_ccall trf_23885(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_23885(t0,t1,t2,t3,t4);}

C_noret_decl(trf_23928)
static void C_ccall trf_23928(C_word c,C_word *av) C_noret;
static void C_ccall trf_23928(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_23928(t0,t1,t2,t3,t4);}

C_noret_decl(trf_23961)
static void C_ccall trf_23961(C_word c,C_word *av) C_noret;
static void C_ccall trf_23961(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_23961(t0,t1,t2);}

C_noret_decl(trf_24169)
static void C_ccall trf_24169(C_word c,C_word *av) C_noret;
static void C_ccall trf_24169(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_24169(t0,t1,t2);}

C_noret_decl(trf_24207)
static void C_ccall trf_24207(C_word c,C_word *av) C_noret;
static void C_ccall trf_24207(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_24207(t0,t1,t2);}

C_noret_decl(trf_24255)
static void C_ccall trf_24255(C_word c,C_word *av) C_noret;
static void C_ccall trf_24255(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_24255(t0,t1,t2);}

C_noret_decl(trf_24316)
static void C_ccall trf_24316(C_word c,C_word *av) C_noret;
static void C_ccall trf_24316(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_24316(t0,t1,t2);}

C_noret_decl(trf_24346)
static void C_ccall trf_24346(C_word c,C_word *av) C_noret;
static void C_ccall trf_24346(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_24346(t0,t1,t2);}

C_noret_decl(trf_24401)
static void C_ccall trf_24401(C_word c,C_word *av) C_noret;
static void C_ccall trf_24401(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_24401(t0,t1,t2);}

C_noret_decl(trf_24442)
static void C_ccall trf_24442(C_word c,C_word *av) C_noret;
static void C_ccall trf_24442(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_24442(t0,t1,t2);}

C_noret_decl(trf_24556)
static void C_ccall trf_24556(C_word c,C_word *av) C_noret;
static void C_ccall trf_24556(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_24556(t0,t1,t2);}

C_noret_decl(trf_24946)
static void C_ccall trf_24946(C_word c,C_word *av) C_noret;
static void C_ccall trf_24946(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_24946(t0,t1,t2,t3,t4);}

C_noret_decl(trf_24996)
static void C_ccall trf_24996(C_word c,C_word *av) C_noret;
static void C_ccall trf_24996(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_24996(t0,t1,t2);}

C_noret_decl(trf_25053)
static void C_ccall trf_25053(C_word c,C_word *av) C_noret;
static void C_ccall trf_25053(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_25053(t0,t1);}

C_noret_decl(trf_25063)
static void C_ccall trf_25063(C_word c,C_word *av) C_noret;
static void C_ccall trf_25063(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_25063(t0,t1);}

C_noret_decl(trf_25176)
static void C_ccall trf_25176(C_word c,C_word *av) C_noret;
static void C_ccall trf_25176(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_25176(t0,t1,t2,t3);}

C_noret_decl(trf_25432)
static void C_ccall trf_25432(C_word c,C_word *av) C_noret;
static void C_ccall trf_25432(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_25432(t0,t1,t2);}

C_noret_decl(trf_25445)
static void C_ccall trf_25445(C_word c,C_word *av) C_noret;
static void C_ccall trf_25445(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_25445(t0,t1,t2);}

C_noret_decl(trf_25504)
static void C_ccall trf_25504(C_word c,C_word *av) C_noret;
static void C_ccall trf_25504(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_25504(t0,t1,t2);}

C_noret_decl(trf_25774)
static void C_ccall trf_25774(C_word c,C_word *av) C_noret;
static void C_ccall trf_25774(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_25774(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_25778)
static void C_ccall trf_25778(C_word c,C_word *av) C_noret;
static void C_ccall trf_25778(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_25778(t0,t1);}

C_noret_decl(trf_25808)
static void C_ccall trf_25808(C_word c,C_word *av) C_noret;
static void C_ccall trf_25808(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_25808(t0,t1);}

C_noret_decl(trf_25828)
static void C_ccall trf_25828(C_word c,C_word *av) C_noret;
static void C_ccall trf_25828(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_25828(t0,t1,t2,t3);}

C_noret_decl(trf_25837)
static void C_ccall trf_25837(C_word c,C_word *av) C_noret;
static void C_ccall trf_25837(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_25837(t0,t1,t2);}

C_noret_decl(trf_25842)
static void C_ccall trf_25842(C_word c,C_word *av) C_noret;
static void C_ccall trf_25842(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_25842(t0,t1);}

C_noret_decl(trf_26211)
static void C_ccall trf_26211(C_word c,C_word *av) C_noret;
static void C_ccall trf_26211(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_26211(t0,t1,t2,t3,t4);}

C_noret_decl(trf_26220)
static void C_ccall trf_26220(C_word c,C_word *av) C_noret;
static void C_ccall trf_26220(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_26220(t0,t1);}

C_noret_decl(trf_26230)
static void C_ccall trf_26230(C_word c,C_word *av) C_noret;
static void C_ccall trf_26230(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26230(t0,t1,t2);}

C_noret_decl(trf_26257)
static void C_ccall trf_26257(C_word c,C_word *av) C_noret;
static void C_ccall trf_26257(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26257(t0,t1,t2);}

C_noret_decl(trf_26266)
static void C_ccall trf_26266(C_word c,C_word *av) C_noret;
static void C_ccall trf_26266(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26266(t0,t1,t2);}

C_noret_decl(trf_26292)
static void C_ccall trf_26292(C_word c,C_word *av) C_noret;
static void C_ccall trf_26292(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_26292(t0,t1,t2,t3);}

C_noret_decl(trf_26320)
static void C_ccall trf_26320(C_word c,C_word *av) C_noret;
static void C_ccall trf_26320(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_26320(t0,t1,t2,t3);}

C_noret_decl(trf_26326)
static void C_ccall trf_26326(C_word c,C_word *av) C_noret;
static void C_ccall trf_26326(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26326(t0,t1,t2);}

C_noret_decl(trf_26401)
static void C_ccall trf_26401(C_word c,C_word *av) C_noret;
static void C_ccall trf_26401(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26401(t0,t1,t2);}

C_noret_decl(trf_26440)
static void C_ccall trf_26440(C_word c,C_word *av) C_noret;
static void C_ccall trf_26440(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_26440(t0,t1);}

C_noret_decl(trf_26443)
static void C_ccall trf_26443(C_word c,C_word *av) C_noret;
static void C_ccall trf_26443(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_26443(t0,t1);}

C_noret_decl(trf_26453)
static void C_ccall trf_26453(C_word c,C_word *av) C_noret;
static void C_ccall trf_26453(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26453(t0,t1,t2);}

C_noret_decl(trf_26491)
static void C_ccall trf_26491(C_word c,C_word *av) C_noret;
static void C_ccall trf_26491(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_26491(t0,t1,t2,t3,t4);}

C_noret_decl(trf_26497)
static void C_ccall trf_26497(C_word c,C_word *av) C_noret;
static void C_ccall trf_26497(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_26497(t0,t1,t2,t3);}

C_noret_decl(trf_26551)
static void C_ccall trf_26551(C_word c,C_word *av) C_noret;
static void C_ccall trf_26551(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26551(t0,t1,t2);}

C_noret_decl(trf_26554)
static void C_ccall trf_26554(C_word c,C_word *av) C_noret;
static void C_ccall trf_26554(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26554(t0,t1,t2);}

C_noret_decl(trf_26577)
static void C_ccall trf_26577(C_word c,C_word *av) C_noret;
static void C_ccall trf_26577(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_26577(t0,t1);}

C_noret_decl(trf_26586)
static void C_ccall trf_26586(C_word c,C_word *av) C_noret;
static void C_ccall trf_26586(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26586(t0,t1,t2);}

C_noret_decl(trf_26641)
static void C_ccall trf_26641(C_word c,C_word *av) C_noret;
static void C_ccall trf_26641(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_26641(t0,t1);}

C_noret_decl(trf_26691)
static void C_ccall trf_26691(C_word c,C_word *av) C_noret;
static void C_ccall trf_26691(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_26691(t0,t1,t2);}

C_noret_decl(trf_26701)
static void C_ccall trf_26701(C_word c,C_word *av) C_noret;
static void C_ccall trf_26701(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_26701(t0,t1,t2,t3);}

C_noret_decl(trf_26918)
static void C_ccall trf_26918(C_word c,C_word *av) C_noret;
static void C_ccall trf_26918(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_26918(t0,t1);}

C_noret_decl(trf_26938)
static void C_ccall trf_26938(C_word c,C_word *av) C_noret;
static void C_ccall trf_26938(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_26938(t0,t1);}

C_noret_decl(trf_26943)
static void C_ccall trf_26943(C_word c,C_word *av) C_noret;
static void C_ccall trf_26943(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_26943(t0,t1,t2,t3);}

C_noret_decl(trf_27042)
static void C_ccall trf_27042(C_word c,C_word *av) C_noret;
static void C_ccall trf_27042(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27042(t0,t1);}

C_noret_decl(trf_27190)
static void C_ccall trf_27190(C_word c,C_word *av) C_noret;
static void C_ccall trf_27190(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_27190(t0,t1,t2,t3);}

C_noret_decl(trf_27199)
static void C_ccall trf_27199(C_word c,C_word *av) C_noret;
static void C_ccall trf_27199(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_27199(t0,t1,t2);}

C_noret_decl(trf_27254)
static void C_ccall trf_27254(C_word c,C_word *av) C_noret;
static void C_ccall trf_27254(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_27254(t0,t1,t2);}

C_noret_decl(trf_27261)
static void C_ccall trf_27261(C_word c,C_word *av) C_noret;
static void C_ccall trf_27261(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27261(t0,t1);}

C_noret_decl(trf_27304)
static void C_ccall trf_27304(C_word c,C_word *av) C_noret;
static void C_ccall trf_27304(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27304(t0,t1);}

C_noret_decl(trf_27451)
static void C_ccall trf_27451(C_word c,C_word *av) C_noret;
static void C_ccall trf_27451(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27451(t0,t1);}

C_noret_decl(trf_27469)
static void C_ccall trf_27469(C_word c,C_word *av) C_noret;
static void C_ccall trf_27469(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_27469(t0,t1,t2,t3);}

C_noret_decl(trf_27538)
static void C_ccall trf_27538(C_word c,C_word *av) C_noret;
static void C_ccall trf_27538(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_27538(t0,t1,t2);}

C_noret_decl(trf_27589)
static void C_ccall trf_27589(C_word c,C_word *av) C_noret;
static void C_ccall trf_27589(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_27589(t0,t1,t2);}

C_noret_decl(trf_27656)
static void C_ccall trf_27656(C_word c,C_word *av) C_noret;
static void C_ccall trf_27656(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27656(t0,t1);}

C_noret_decl(trf_27666)
static void C_ccall trf_27666(C_word c,C_word *av) C_noret;
static void C_ccall trf_27666(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_27666(t0,t1,t2,t3);}

C_noret_decl(trf_27676)
static void C_ccall trf_27676(C_word c,C_word *av) C_noret;
static void C_ccall trf_27676(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27676(t0,t1);}

C_noret_decl(trf_27718)
static void C_ccall trf_27718(C_word c,C_word *av) C_noret;
static void C_ccall trf_27718(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27718(t0,t1);}

C_noret_decl(trf_27728)
static void C_ccall trf_27728(C_word c,C_word *av) C_noret;
static void C_ccall trf_27728(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_27728(t0,t1,t2,t3);}

C_noret_decl(trf_27764)
static void C_ccall trf_27764(C_word c,C_word *av) C_noret;
static void C_ccall trf_27764(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27764(t0,t1);}

C_noret_decl(trf_27789)
static void C_ccall trf_27789(C_word c,C_word *av) C_noret;
static void C_ccall trf_27789(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_27789(t0,t1,t2);}

C_noret_decl(trf_27794)
static void C_ccall trf_27794(C_word c,C_word *av) C_noret;
static void C_ccall trf_27794(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27794(t0,t1);}

C_noret_decl(trf_27799)
static void C_ccall trf_27799(C_word c,C_word *av) C_noret;
static void C_ccall trf_27799(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_27799(t0,t1,t2,t3,t4);}

C_noret_decl(trf_27812)
static void C_ccall trf_27812(C_word c,C_word *av) C_noret;
static void C_ccall trf_27812(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27812(t0,t1);}

C_noret_decl(trf_27818)
static void C_ccall trf_27818(C_word c,C_word *av) C_noret;
static void C_ccall trf_27818(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27818(t0,t1);}

C_noret_decl(trf_27848)
static void C_ccall trf_27848(C_word c,C_word *av) C_noret;
static void C_ccall trf_27848(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_27848(t0,t1);}

C_noret_decl(trf_28040)
static void C_ccall trf_28040(C_word c,C_word *av) C_noret;
static void C_ccall trf_28040(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_28040(t0,t1);}

C_noret_decl(trf_28079)
static void C_ccall trf_28079(C_word c,C_word *av) C_noret;
static void C_ccall trf_28079(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_28079(t0,t1);}

C_noret_decl(trf_28232)
static void C_ccall trf_28232(C_word c,C_word *av) C_noret;
static void C_ccall trf_28232(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_28232(t0,t1);}

C_noret_decl(trf_28257)
static void C_ccall trf_28257(C_word c,C_word *av) C_noret;
static void C_ccall trf_28257(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_28257(t0,t1);}

C_noret_decl(trf_28263)
static void C_ccall trf_28263(C_word c,C_word *av) C_noret;
static void C_ccall trf_28263(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_28263(t0,t1,t2);}

C_noret_decl(trf_28344)
static void C_ccall trf_28344(C_word c,C_word *av) C_noret;
static void C_ccall trf_28344(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_28344(t0,t1);}

C_noret_decl(trf_28357)
static void C_ccall trf_28357(C_word c,C_word *av) C_noret;
static void C_ccall trf_28357(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_28357(t0,t1,t2);}

C_noret_decl(trf_28575)
static void C_ccall trf_28575(C_word c,C_word *av) C_noret;
static void C_ccall trf_28575(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_28575(t0,t1,t2);}

C_noret_decl(trf_28948)
static void C_ccall trf_28948(C_word c,C_word *av) C_noret;
static void C_ccall trf_28948(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_28948(t0,t1);}

C_noret_decl(trf_29311)
static void C_ccall trf_29311(C_word c,C_word *av) C_noret;
static void C_ccall trf_29311(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_29311(t0,t1,t2);}

C_noret_decl(trf_29324)
static void C_ccall trf_29324(C_word c,C_word *av) C_noret;
static void C_ccall trf_29324(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_29324(t0,t1);}

C_noret_decl(trf_29466)
static void C_ccall trf_29466(C_word c,C_word *av) C_noret;
static void C_ccall trf_29466(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_29466(t0,t1,t2,t3);}

C_noret_decl(trf_29482)
static void C_ccall trf_29482(C_word c,C_word *av) C_noret;
static void C_ccall trf_29482(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_29482(t0,t1,t2);}

C_noret_decl(trf_29524)
static void C_ccall trf_29524(C_word c,C_word *av) C_noret;
static void C_ccall trf_29524(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_29524(t0,t1,t2,t3);}

C_noret_decl(trf_29531)
static void C_ccall trf_29531(C_word c,C_word *av) C_noret;
static void C_ccall trf_29531(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_29531(t0,t1);}

C_noret_decl(trf_29707)
static void C_ccall trf_29707(C_word c,C_word *av) C_noret;
static void C_ccall trf_29707(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_29707(t0,t1,t2);}

C_noret_decl(trf_29758)
static void C_ccall trf_29758(C_word c,C_word *av) C_noret;
static void C_ccall trf_29758(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_29758(t0,t1,t2);}

C_noret_decl(trf_29820)
static void C_ccall trf_29820(C_word c,C_word *av) C_noret;
static void C_ccall trf_29820(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_29820(t0,t1,t2,t3);}

C_noret_decl(trf_29879)
static void C_ccall trf_29879(C_word c,C_word *av) C_noret;
static void C_ccall trf_29879(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_29879(t0,t1,t2);}

C_noret_decl(trf_29903)
static void C_ccall trf_29903(C_word c,C_word *av) C_noret;
static void C_ccall trf_29903(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_29903(t0,t1,t2,t3);}

C_noret_decl(trf_29963)
static void C_ccall trf_29963(C_word c,C_word *av) C_noret;
static void C_ccall trf_29963(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_29963(t0,t1,t2,t3);}

C_noret_decl(trf_29993)
static void C_ccall trf_29993(C_word c,C_word *av) C_noret;
static void C_ccall trf_29993(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_29993(t0,t1,t2,t3);}

C_noret_decl(trf_30005)
static void C_ccall trf_30005(C_word c,C_word *av) C_noret;
static void C_ccall trf_30005(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_30005(t0,t1,t2);}

C_noret_decl(trf_30078)
static void C_ccall trf_30078(C_word c,C_word *av) C_noret;
static void C_ccall trf_30078(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_30078(t0,t1,t2);}

C_noret_decl(trf_30129)
static void C_ccall trf_30129(C_word c,C_word *av) C_noret;
static void C_ccall trf_30129(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_30129(t0,t1,t2);}

C_noret_decl(trf_30204)
static void C_ccall trf_30204(C_word c,C_word *av) C_noret;
static void C_ccall trf_30204(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_30204(t0,t1);}

C_noret_decl(trf_30309)
static void C_ccall trf_30309(C_word c,C_word *av) C_noret;
static void C_ccall trf_30309(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_30309(t0,t1,t2);}

C_noret_decl(trf_30374)
static void C_ccall trf_30374(C_word c,C_word *av) C_noret;
static void C_ccall trf_30374(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_30374(t0,t1,t2);}

C_noret_decl(trf_30534)
static void C_ccall trf_30534(C_word c,C_word *av) C_noret;
static void C_ccall trf_30534(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_30534(t0,t1,t2,t3);}

C_noret_decl(trf_30723)
static void C_ccall trf_30723(C_word c,C_word *av) C_noret;
static void C_ccall trf_30723(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_30723(t0,t1,t2);}

C_noret_decl(trf_30900)
static void C_ccall trf_30900(C_word c,C_word *av) C_noret;
static void C_ccall trf_30900(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_30900(t0,t1,t2,t3);}

C_noret_decl(trf_31297)
static void C_ccall trf_31297(C_word c,C_word *av) C_noret;
static void C_ccall trf_31297(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_31297(t0,t1);}

C_noret_decl(trf_31308)
static void C_ccall trf_31308(C_word c,C_word *av) C_noret;
static void C_ccall trf_31308(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_31308(t0,t1,t2,t3,t4);}

C_noret_decl(trf_31331)
static void C_ccall trf_31331(C_word c,C_word *av) C_noret;
static void C_ccall trf_31331(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_31331(t0,t1,t2);}

C_noret_decl(trf_31351)
static void C_ccall trf_31351(C_word c,C_word *av) C_noret;
static void C_ccall trf_31351(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_31351(t0,t1);}

C_noret_decl(trf_31366)
static void C_ccall trf_31366(C_word c,C_word *av) C_noret;
static void C_ccall trf_31366(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_31366(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_31427)
static void C_ccall trf_31427(C_word c,C_word *av) C_noret;
static void C_ccall trf_31427(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_31427(t0,t1);}

C_noret_decl(trf_31570)
static void C_ccall trf_31570(C_word c,C_word *av) C_noret;
static void C_ccall trf_31570(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_31570(t0,t1,t2);}

C_noret_decl(trf_31585)
static void C_ccall trf_31585(C_word c,C_word *av) C_noret;
static void C_ccall trf_31585(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_31585(t0,t1,t2);}

C_noret_decl(trf_31688)
static void C_ccall trf_31688(C_word c,C_word *av) C_noret;
static void C_ccall trf_31688(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_31688(t0,t1,t2);}

C_noret_decl(trf_31707)
static void C_ccall trf_31707(C_word c,C_word *av) C_noret;
static void C_ccall trf_31707(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_31707(t0,t1);}

C_noret_decl(trf_31826)
static void C_ccall trf_31826(C_word c,C_word *av) C_noret;
static void C_ccall trf_31826(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_31826(t0,t1,t2);}

C_noret_decl(trf_31863)
static void C_ccall trf_31863(C_word c,C_word *av) C_noret;
static void C_ccall trf_31863(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_31863(t0,t1);}

C_noret_decl(trf_31897)
static void C_ccall trf_31897(C_word c,C_word *av) C_noret;
static void C_ccall trf_31897(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_31897(t0,t1,t2);}

C_noret_decl(trf_32033)
static void C_ccall trf_32033(C_word c,C_word *av) C_noret;
static void C_ccall trf_32033(C_word c,C_word *av){
C_word t0=av[0];
f_32033(t0);}

C_noret_decl(trf_32081)
static void C_ccall trf_32081(C_word c,C_word *av) C_noret;
static void C_ccall trf_32081(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_32081(t0,t1);}

C_noret_decl(trf_32105)
static void C_ccall trf_32105(C_word c,C_word *av) C_noret;
static void C_ccall trf_32105(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_32105(t0,t1,t2);}

C_noret_decl(trf_32203)
static void C_ccall trf_32203(C_word c,C_word *av) C_noret;
static void C_ccall trf_32203(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_32203(t0,t1,t2);}

C_noret_decl(trf_32251)
static void C_ccall trf_32251(C_word c,C_word *av) C_noret;
static void C_ccall trf_32251(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_32251(t0,t1);}

C_noret_decl(trf_32254)
static void C_ccall trf_32254(C_word c,C_word *av) C_noret;
static void C_ccall trf_32254(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_32254(t0,t1);}

C_noret_decl(trf_32274)
static void C_ccall trf_32274(C_word c,C_word *av) C_noret;
static void C_ccall trf_32274(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_32274(t0,t1);}

C_noret_decl(trf_32721)
static void C_ccall trf_32721(C_word c,C_word *av) C_noret;
static void C_ccall trf_32721(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_32721(t0,t1,t2,t3);}

C_noret_decl(trf_32727)
static void C_ccall trf_32727(C_word c,C_word *av) C_noret;
static void C_ccall trf_32727(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_32727(t0,t1,t2);}

C_noret_decl(trf_32743)
static void C_ccall trf_32743(C_word c,C_word *av) C_noret;
static void C_ccall trf_32743(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_32743(t0,t1);}

C_noret_decl(trf_32840)
static void C_ccall trf_32840(C_word c,C_word *av) C_noret;
static void C_ccall trf_32840(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_32840(t0,t1,t2);}

C_noret_decl(trf_32886)
static void C_ccall trf_32886(C_word c,C_word *av) C_noret;
static void C_ccall trf_32886(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_32886(t0,t1,t2);}

C_noret_decl(trf_32962)
static void C_ccall trf_32962(C_word c,C_word *av) C_noret;
static void C_ccall trf_32962(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_32962(t0,t1,t2);}

C_noret_decl(trf_33014)
static void C_ccall trf_33014(C_word c,C_word *av) C_noret;
static void C_ccall trf_33014(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_33014(t0,t1,t2);}

C_noret_decl(trf_33062)
static void C_ccall trf_33062(C_word c,C_word *av) C_noret;
static void C_ccall trf_33062(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_33062(t0,t1,t2);}

C_noret_decl(trf_33076)
static void C_ccall trf_33076(C_word c,C_word *av) C_noret;
static void C_ccall trf_33076(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_33076(t0,t1,t2);}

C_noret_decl(trf_33132)
static void C_ccall trf_33132(C_word c,C_word *av) C_noret;
static void C_ccall trf_33132(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_33132(t0,t1,t2);}

C_noret_decl(trf_33257)
static void C_ccall trf_33257(C_word c,C_word *av) C_noret;
static void C_ccall trf_33257(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_33257(t0,t1,t2);}

C_noret_decl(trf_33259)
static void C_ccall trf_33259(C_word c,C_word *av) C_noret;
static void C_ccall trf_33259(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_33259(t0,t1,t2);}

C_noret_decl(trf_33280)
static void C_ccall trf_33280(C_word c,C_word *av) C_noret;
static void C_ccall trf_33280(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_33280(t0,t1,t2);}

C_noret_decl(trf_33304)
static void C_ccall trf_33304(C_word c,C_word *av) C_noret;
static void C_ccall trf_33304(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_33304(t0,t1,t2,t3);}

C_noret_decl(trf_33358)
static void C_ccall trf_33358(C_word c,C_word *av) C_noret;
static void C_ccall trf_33358(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_33358(t0,t1,t2);}

C_noret_decl(trf_33453)
static void C_ccall trf_33453(C_word c,C_word *av) C_noret;
static void C_ccall trf_33453(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_33453(t0,t1,t2);}

C_noret_decl(trf_33458)
static void C_ccall trf_33458(C_word c,C_word *av) C_noret;
static void C_ccall trf_33458(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_33458(t0,t1);}

C_noret_decl(trf_34676)
static void C_ccall trf_34676(C_word c,C_word *av) C_noret;
static void C_ccall trf_34676(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_34676(t0,t1,t2);}

C_noret_decl(trf_34740)
static void C_ccall trf_34740(C_word c,C_word *av) C_noret;
static void C_ccall trf_34740(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_34740(t0,t1,t2);}

C_noret_decl(trf_35020)
static void C_ccall trf_35020(C_word c,C_word *av) C_noret;
static void C_ccall trf_35020(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_35020(t0,t1);}

C_noret_decl(trf_35110)
static void C_ccall trf_35110(C_word c,C_word *av) C_noret;
static void C_ccall trf_35110(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_35110(t0,t1,t2);}

C_noret_decl(trf_35154)
static void C_ccall trf_35154(C_word c,C_word *av) C_noret;
static void C_ccall trf_35154(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_35154(t0,t1);}

C_noret_decl(trf_35167)
static void C_ccall trf_35167(C_word c,C_word *av) C_noret;
static void C_ccall trf_35167(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_35167(t0,t1,t2);}

C_noret_decl(trf_35201)
static void C_ccall trf_35201(C_word c,C_word *av) C_noret;
static void C_ccall trf_35201(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_35201(t0,t1,t2);}

C_noret_decl(trf_35216)
static void C_ccall trf_35216(C_word c,C_word *av) C_noret;
static void C_ccall trf_35216(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_35216(t0,t1);}

C_noret_decl(trf_35292)
static void C_ccall trf_35292(C_word c,C_word *av) C_noret;
static void C_ccall trf_35292(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_35292(t0,t1,t2);}

C_noret_decl(trf_35391)
static void C_ccall trf_35391(C_word c,C_word *av) C_noret;
static void C_ccall trf_35391(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_35391(t0,t1);}

C_noret_decl(trf_35410)
static void C_ccall trf_35410(C_word c,C_word *av) C_noret;
static void C_ccall trf_35410(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_35410(t0,t1,t2);}

C_noret_decl(trf_35451)
static void C_ccall trf_35451(C_word c,C_word *av) C_noret;
static void C_ccall trf_35451(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_35451(t0,t1,t2,t3,t4);}

C_noret_decl(trf_35779)
static void C_ccall trf_35779(C_word c,C_word *av) C_noret;
static void C_ccall trf_35779(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_35779(t0,t1,t2);}

C_noret_decl(trf_35791)
static void C_ccall trf_35791(C_word c,C_word *av) C_noret;
static void C_ccall trf_35791(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_35791(t0,t1,t2);}

C_noret_decl(trf_35871)
static void C_ccall trf_35871(C_word c,C_word *av) C_noret;
static void C_ccall trf_35871(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_35871(t0,t1,t2,t3);}

C_noret_decl(trf_36085)
static void C_ccall trf_36085(C_word c,C_word *av) C_noret;
static void C_ccall trf_36085(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_36085(t0,t1,t2);}

C_noret_decl(trf_36123)
static void C_ccall trf_36123(C_word c,C_word *av) C_noret;
static void C_ccall trf_36123(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_36123(t0,t1,t2);}

C_noret_decl(trf_36202)
static void C_ccall trf_36202(C_word c,C_word *av) C_noret;
static void C_ccall trf_36202(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_36202(t0,t1,t2);}

C_noret_decl(trf_36330)
static void C_ccall trf_36330(C_word c,C_word *av) C_noret;
static void C_ccall trf_36330(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_36330(t0,t1);}

C_noret_decl(trf_36767)
static void C_ccall trf_36767(C_word c,C_word *av) C_noret;
static void C_ccall trf_36767(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_36767(t0,t1);}

C_noret_decl(trf_36779)
static void C_ccall trf_36779(C_word c,C_word *av) C_noret;
static void C_ccall trf_36779(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_36779(t0,t1,t2);}

C_noret_decl(trf_36838)
static void C_ccall trf_36838(C_word c,C_word *av) C_noret;
static void C_ccall trf_36838(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_36838(t0,t1);}

C_noret_decl(trf_36852)
static void C_ccall trf_36852(C_word c,C_word *av) C_noret;
static void C_ccall trf_36852(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_36852(t0,t1,t2);}

C_noret_decl(trf_36874)
static void C_ccall trf_36874(C_word c,C_word *av) C_noret;
static void C_ccall trf_36874(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_36874(t0,t1,t2);}

C_noret_decl(trf_37089)
static void C_ccall trf_37089(C_word c,C_word *av) C_noret;
static void C_ccall trf_37089(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_37089(t0,t1);}

C_noret_decl(trf_37112)
static void C_ccall trf_37112(C_word c,C_word *av) C_noret;
static void C_ccall trf_37112(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_37112(t0,t1);}

C_noret_decl(trf_37283)
static void C_ccall trf_37283(C_word c,C_word *av) C_noret;
static void C_ccall trf_37283(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_37283(t0,t1,t2,t3);}

C_noret_decl(trf_37442)
static void C_ccall trf_37442(C_word c,C_word *av) C_noret;
static void C_ccall trf_37442(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_37442(t0,t1);}

C_noret_decl(trf_37475)
static void C_ccall trf_37475(C_word c,C_word *av) C_noret;
static void C_ccall trf_37475(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_37475(t0,t1);}

C_noret_decl(trf_37478)
static void C_ccall trf_37478(C_word c,C_word *av) C_noret;
static void C_ccall trf_37478(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_37478(t0,t1);}

C_noret_decl(trf_37481)
static void C_ccall trf_37481(C_word c,C_word *av) C_noret;
static void C_ccall trf_37481(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_37481(t0,t1);}

C_noret_decl(trf_37484)
static void C_ccall trf_37484(C_word c,C_word *av) C_noret;
static void C_ccall trf_37484(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_37484(t0,t1);}

C_noret_decl(trf_37521)
static void C_ccall trf_37521(C_word c,C_word *av) C_noret;
static void C_ccall trf_37521(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_37521(t0,t1,t2);}

C_noret_decl(trf_37557)
static void C_ccall trf_37557(C_word c,C_word *av) C_noret;
static void C_ccall trf_37557(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_37557(t0,t1,t2);}

C_noret_decl(trf_37588)
static void C_ccall trf_37588(C_word c,C_word *av) C_noret;
static void C_ccall trf_37588(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_37588(t0,t1,t2);}

C_noret_decl(trf_37628)
static void C_ccall trf_37628(C_word c,C_word *av) C_noret;
static void C_ccall trf_37628(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_37628(t0,t1,t2);}

C_noret_decl(trf_37734)
static void C_ccall trf_37734(C_word c,C_word *av) C_noret;
static void C_ccall trf_37734(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_37734(t0,t1,t2);}

C_noret_decl(trf_37783)
static void C_ccall trf_37783(C_word c,C_word *av) C_noret;
static void C_ccall trf_37783(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_37783(t0,t1,t2,t3);}

C_noret_decl(trf_37827)
static void C_ccall trf_37827(C_word c,C_word *av) C_noret;
static void C_ccall trf_37827(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_37827(t0,t1,t2,t3);}

C_noret_decl(trf_37877)
static void C_ccall trf_37877(C_word c,C_word *av) C_noret;
static void C_ccall trf_37877(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_37877(t0,t1,t2,t3);}

C_noret_decl(trf_37918)
static void C_ccall trf_37918(C_word c,C_word *av) C_noret;
static void C_ccall trf_37918(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_37918(t0,t1,t2,t3);}

C_noret_decl(trf_38022)
static void C_ccall trf_38022(C_word c,C_word *av) C_noret;
static void C_ccall trf_38022(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_38022(t0,t1,t2,t3);}

C_noret_decl(trf_38043)
static void C_ccall trf_38043(C_word c,C_word *av) C_noret;
static void C_ccall trf_38043(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_38043(t0,t1,t2,t3);}

C_noret_decl(trf_38137)
static void C_ccall trf_38137(C_word c,C_word *av) C_noret;
static void C_ccall trf_38137(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_38137(t0,t1,t2,t3);}

C_noret_decl(trf_38212)
static void C_ccall trf_38212(C_word c,C_word *av) C_noret;
static void C_ccall trf_38212(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38212(t0,t1,t2);}

C_noret_decl(trf_38247)
static void C_ccall trf_38247(C_word c,C_word *av) C_noret;
static void C_ccall trf_38247(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38247(t0,t1,t2);}

C_noret_decl(trf_38305)
static void C_ccall trf_38305(C_word c,C_word *av) C_noret;
static void C_ccall trf_38305(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38305(t0,t1,t2);}

C_noret_decl(trf_38374)
static void C_ccall trf_38374(C_word c,C_word *av) C_noret;
static void C_ccall trf_38374(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38374(t0,t1,t2);}

C_noret_decl(trf_38438)
static void C_ccall trf_38438(C_word c,C_word *av) C_noret;
static void C_ccall trf_38438(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38438(t0,t1,t2);}

C_noret_decl(trf_38469)
static void C_ccall trf_38469(C_word c,C_word *av) C_noret;
static void C_ccall trf_38469(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38469(t0,t1,t2);}

C_noret_decl(trf_38527)
static void C_ccall trf_38527(C_word c,C_word *av) C_noret;
static void C_ccall trf_38527(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38527(t0,t1,t2);}

C_noret_decl(trf_38608)
static void C_ccall trf_38608(C_word c,C_word *av) C_noret;
static void C_ccall trf_38608(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38608(t0,t1,t2);}

C_noret_decl(trf_38667)
static void C_ccall trf_38667(C_word c,C_word *av) C_noret;
static void C_ccall trf_38667(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38667(t0,t1,t2);}

C_noret_decl(trf_38702)
static void C_ccall trf_38702(C_word c,C_word *av) C_noret;
static void C_ccall trf_38702(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38702(t0,t1,t2);}

C_noret_decl(trf_38760)
static void C_ccall trf_38760(C_word c,C_word *av) C_noret;
static void C_ccall trf_38760(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38760(t0,t1,t2);}

C_noret_decl(trf_38838)
static void C_ccall trf_38838(C_word c,C_word *av) C_noret;
static void C_ccall trf_38838(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38838(t0,t1,t2);}

C_noret_decl(trf_38893)
static void C_ccall trf_38893(C_word c,C_word *av) C_noret;
static void C_ccall trf_38893(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38893(t0,t1,t2);}

C_noret_decl(trf_38924)
static void C_ccall trf_38924(C_word c,C_word *av) C_noret;
static void C_ccall trf_38924(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38924(t0,t1,t2);}

C_noret_decl(trf_38982)
static void C_ccall trf_38982(C_word c,C_word *av) C_noret;
static void C_ccall trf_38982(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_38982(t0,t1,t2);}

C_noret_decl(trf_39176)
static void C_ccall trf_39176(C_word c,C_word *av) C_noret;
static void C_ccall trf_39176(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_39176(t0,t1);}

C_noret_decl(trf_39179)
static void C_ccall trf_39179(C_word c,C_word *av) C_noret;
static void C_ccall trf_39179(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_39179(t0,t1);}

C_noret_decl(trf_39283)
static void C_ccall trf_39283(C_word c,C_word *av) C_noret;
static void C_ccall trf_39283(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_39283(t0,t1,t2,t3,t4);}

C_noret_decl(trf_39365)
static void C_ccall trf_39365(C_word c,C_word *av) C_noret;
static void C_ccall trf_39365(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_39365(t0,t1);}

C_noret_decl(trf_39375)
static void C_ccall trf_39375(C_word c,C_word *av) C_noret;
static void C_ccall trf_39375(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_39375(t0,t1,t2);}

C_noret_decl(trf_39393)
static void C_ccall trf_39393(C_word c,C_word *av) C_noret;
static void C_ccall trf_39393(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_39393(t0,t1,t2);}

C_noret_decl(trf_39539)
static void C_ccall trf_39539(C_word c,C_word *av) C_noret;
static void C_ccall trf_39539(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_39539(t0,t1,t2,t3);}

C_noret_decl(trf_39655)
static void C_ccall trf_39655(C_word c,C_word *av) C_noret;
static void C_ccall trf_39655(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_39655(t0,t1,t2,t3,t4);}

C_noret_decl(trf_39730)
static void C_ccall trf_39730(C_word c,C_word *av) C_noret;
static void C_ccall trf_39730(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_39730(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_39754)
static void C_ccall trf_39754(C_word c,C_word *av) C_noret;
static void C_ccall trf_39754(C_word c,C_word *av){
C_word t0=av[5];
C_word t1=av[4];
C_word t2=av[3];
C_word t3=av[2];
C_word t4=av[1];
C_word t5=av[0];
f_39754(t0,t1,t2,t3,t4,t5);}

C_noret_decl(trf_39778)
static void C_ccall trf_39778(C_word c,C_word *av) C_noret;
static void C_ccall trf_39778(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_39778(t0,t1,t2);}

C_noret_decl(trf_40093)
static void C_ccall trf_40093(C_word c,C_word *av) C_noret;
static void C_ccall trf_40093(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_40093(t0,t1,t2,t3,t4);}

C_noret_decl(trf_40324)
static void C_ccall trf_40324(C_word c,C_word *av) C_noret;
static void C_ccall trf_40324(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_40324(t0,t1);}

C_noret_decl(trf_40615)
static void C_ccall trf_40615(C_word c,C_word *av) C_noret;
static void C_ccall trf_40615(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_40615(t0,t1,t2);}

C_noret_decl(trf_40846)
static void C_ccall trf_40846(C_word c,C_word *av) C_noret;
static void C_ccall trf_40846(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_40846(t0,t1,t2);}

C_noret_decl(trf_41008)
static void C_ccall trf_41008(C_word c,C_word *av) C_noret;
static void C_ccall trf_41008(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_41008(t0,t1,t2);}

C_noret_decl(trf_41047)
static void C_ccall trf_41047(C_word c,C_word *av) C_noret;
static void C_ccall trf_41047(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_41047(t0,t1,t2);}

C_noret_decl(trf_41063)
static void C_ccall trf_41063(C_word c,C_word *av) C_noret;
static void C_ccall trf_41063(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_41063(t0,t1,t2);}

C_noret_decl(trf_41229)
static void C_ccall trf_41229(C_word c,C_word *av) C_noret;
static void C_ccall trf_41229(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_41229(t0,t1);}

C_noret_decl(trf_41808)
static void C_ccall trf_41808(C_word c,C_word *av) C_noret;
static void C_ccall trf_41808(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_41808(t0,t1);}

C_noret_decl(trf_41817)
static void C_ccall trf_41817(C_word c,C_word *av) C_noret;
static void C_ccall trf_41817(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_41817(t0,t1,t2,t3,t4);}

C_noret_decl(trf_41915)
static void C_ccall trf_41915(C_word c,C_word *av) C_noret;
static void C_ccall trf_41915(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_41915(t0,t1);}

C_noret_decl(trf_41928)
static void C_ccall trf_41928(C_word c,C_word *av) C_noret;
static void C_ccall trf_41928(C_word c,C_word *av){
C_word t0=av[6];
C_word t1=av[5];
C_word t2=av[4];
C_word t3=av[3];
C_word t4=av[2];
C_word t5=av[1];
C_word t6=av[0];
f_41928(t0,t1,t2,t3,t4,t5,t6);}

/* f45112 in chicken.base#exit in k12559 in k11436 */
static void C_ccall f45112(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f45112,c,av);}
/* library.scm:907: g887 */
t2=t1;{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_fix(0);
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* f45311 in chicken.base#gensym in k12559 in k11436 */
static void C_ccall f45311(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f45311,c,av);}
/* library.scm:3322: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[747];
av2[3]=t1;
tp(4,av2);}}

/* f45315 in k22306 in chicken.base#gensym in k12559 in k11436 */
static void C_ccall f45315(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f45315,c,av);}
/* library.scm:3322: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* f45445 in k27350 in a27347 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in ... */
static void C_ccall f45445(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f45445,c,av);}
/* library.scm:5045: ##sys#intern-keyword */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[733]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[733]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* f45450 in k27350 in a27347 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in ... */
static void C_ccall f45450(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f45450,c,av);}
/* library.scm:5045: ##sys#intern-keyword */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[733]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[733]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* f45457 in a27474 in r-number in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f45457(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f45457,c,av);}
/* library.scm:5045: ##sys#intern-keyword */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[733]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[733]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* f45466 in a27769 in r-symbol in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f45466(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f45466,c,av);}
/* library.scm:5045: ##sys#intern-keyword */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[733]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[733]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* f45475 in a28867 in a28861 in k28850 in k28847 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void C_ccall f45475(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f45475,c,av);}
/* library.scm:5045: ##sys#intern-keyword */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[733]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[733]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* f49039 in k40823 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f49039(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f49039,c,av);}
t3=C_i_check_list_2(t2,lf[1591]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* f49045 in k40907 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f49045(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f49045,c,av);}
t3=C_i_check_string_2(t2,lf[1594]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* f49051 in k40903 in k40907 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f49051(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f49051,c,av);}
t3=C_i_check_string_2(t2,lf[1594]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k11436 */
static void C_ccall f_11438(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word t51;
C_word t52;
C_word t53;
C_word t54;
C_word t55;
C_word t56;
C_word t57;
C_word t58;
C_word t59;
C_word t60;
C_word t61;
C_word t62;
C_word t63;
C_word t64;
C_word t65;
C_word t66;
C_word t67;
C_word t68;
C_word t69;
C_word t70;
C_word t71;
C_word t72;
C_word t73;
C_word t74;
C_word t75;
C_word t76;
C_word t77;
C_word t78;
C_word t79;
C_word t80;
C_word t81;
C_word t82;
C_word t83;
C_word t84;
C_word t85;
C_word t86;
C_word t87;
C_word t88;
C_word t89;
C_word t90;
C_word t91;
C_word t92;
C_word t93;
C_word t94;
C_word t95;
C_word t96;
C_word t97;
C_word t98;
C_word t99;
C_word t100;
C_word t101;
C_word t102;
C_word t103;
C_word t104;
C_word t105;
C_word t106;
C_word t107;
C_word t108;
C_word t109;
C_word t110;
C_word t111;
C_word t112;
C_word t113;
C_word t114;
C_word t115;
C_word t116;
C_word t117;
C_word t118;
C_word t119;
C_word t120;
C_word t121;
C_word t122;
C_word t123;
C_word t124;
C_word t125;
C_word t126;
C_word t127;
C_word t128;
C_word t129;
C_word t130;
C_word t131;
C_word t132;
C_word t133;
C_word t134;
C_word t135;
C_word t136;
C_word t137;
C_word t138;
C_word t139;
C_word t140;
C_word t141;
C_word t142;
C_word t143;
C_word t144;
C_word t145;
C_word t146;
C_word t147;
C_word t148;
C_word t149;
C_word t150;
C_word t151;
C_word t152;
C_word t153;
C_word t154;
C_word t155;
C_word t156;
C_word t157;
C_word t158;
C_word t159;
C_word t160;
C_word t161;
C_word t162;
C_word t163;
C_word t164;
C_word t165;
C_word t166;
C_word t167;
C_word t168;
C_word t169;
C_word t170;
C_word t171;
C_word t172;
C_word t173;
C_word t174;
C_word t175;
C_word t176;
C_word t177;
C_word t178;
C_word t179;
C_word t180;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(388,c,5)))){
C_save_and_reclaim((void *)f_11438,c,av);}
a=C_alloc(388);
t2=C_a_i_provide(&a,1,lf[0]);
t3=C_a_i_provide(&a,1,lf[1]);
t4=C_mutate((C_word*)lf[2]+1 /* (set! scheme#not ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11440,a[2]=((C_word)li0),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[3]+1 /* (set! scheme#boolean? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11443,a[2]=((C_word)li1),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[4]+1 /* (set! scheme#eq? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11446,a[2]=((C_word)li2),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[5]+1 /* (set! scheme#eqv? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11449,a[2]=((C_word)li3),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[6]+1 /* (set! scheme#equal? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11452,a[2]=((C_word)li4),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate((C_word*)lf[7]+1 /* (set! scheme#boolean=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11455,a[2]=((C_word)li6),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate((C_word*)lf[9]+1 /* (set! scheme#symbol=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11500,a[2]=((C_word)li8),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[11]+1 /* (set! scheme#pair? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11545,a[2]=((C_word)li9),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate((C_word*)lf[12]+1 /* (set! scheme#cons ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11548,a[2]=((C_word)li10),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate((C_word*)lf[13]+1 /* (set! scheme#car ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11551,a[2]=((C_word)li11),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate((C_word*)lf[14]+1 /* (set! scheme#cdr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11554,a[2]=((C_word)li12),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate((C_word*)lf[15]+1 /* (set! scheme#set-car! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11557,a[2]=((C_word)li13),tmp=(C_word)a,a+=3,tmp));
t16=C_mutate((C_word*)lf[16]+1 /* (set! scheme#set-cdr! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11560,a[2]=((C_word)li14),tmp=(C_word)a,a+=3,tmp));
t17=C_mutate((C_word*)lf[17]+1 /* (set! scheme#cadr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11563,a[2]=((C_word)li15),tmp=(C_word)a,a+=3,tmp));
t18=C_mutate((C_word*)lf[18]+1 /* (set! scheme#caddr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11566,a[2]=((C_word)li16),tmp=(C_word)a,a+=3,tmp));
t19=C_mutate((C_word*)lf[19]+1 /* (set! scheme#cadddr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11569,a[2]=((C_word)li17),tmp=(C_word)a,a+=3,tmp));
t20=C_mutate((C_word*)lf[20]+1 /* (set! scheme#cddddr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11572,a[2]=((C_word)li18),tmp=(C_word)a,a+=3,tmp));
t21=C_mutate((C_word*)lf[21]+1 /* (set! scheme#caar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11575,a[2]=((C_word)li19),tmp=(C_word)a,a+=3,tmp));
t22=C_mutate((C_word*)lf[22]+1 /* (set! scheme#cdar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11578,a[2]=((C_word)li20),tmp=(C_word)a,a+=3,tmp));
t23=C_mutate((C_word*)lf[23]+1 /* (set! scheme#cddr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11581,a[2]=((C_word)li21),tmp=(C_word)a,a+=3,tmp));
t24=C_mutate((C_word*)lf[24]+1 /* (set! scheme#caaar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11584,a[2]=((C_word)li22),tmp=(C_word)a,a+=3,tmp));
t25=C_mutate((C_word*)lf[25]+1 /* (set! scheme#caadr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11598,a[2]=((C_word)li23),tmp=(C_word)a,a+=3,tmp));
t26=C_mutate((C_word*)lf[26]+1 /* (set! scheme#cadar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11605,a[2]=((C_word)li24),tmp=(C_word)a,a+=3,tmp));
t27=C_mutate((C_word*)lf[27]+1 /* (set! scheme#cdaar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11612,a[2]=((C_word)li25),tmp=(C_word)a,a+=3,tmp));
t28=C_mutate((C_word*)lf[28]+1 /* (set! scheme#cdadr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11626,a[2]=((C_word)li26),tmp=(C_word)a,a+=3,tmp));
t29=C_mutate((C_word*)lf[29]+1 /* (set! scheme#cddar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11633,a[2]=((C_word)li27),tmp=(C_word)a,a+=3,tmp));
t30=C_mutate((C_word*)lf[30]+1 /* (set! scheme#cdddr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11647,a[2]=((C_word)li28),tmp=(C_word)a,a+=3,tmp));
t31=C_mutate((C_word*)lf[31]+1 /* (set! scheme#caaaar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11661,a[2]=((C_word)li29),tmp=(C_word)a,a+=3,tmp));
t32=C_mutate((C_word*)lf[32]+1 /* (set! scheme#caaadr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11679,a[2]=((C_word)li30),tmp=(C_word)a,a+=3,tmp));
t33=C_mutate((C_word*)lf[33]+1 /* (set! scheme#caadar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11690,a[2]=((C_word)li31),tmp=(C_word)a,a+=3,tmp));
t34=C_mutate((C_word*)lf[34]+1 /* (set! scheme#caaddr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11701,a[2]=((C_word)li32),tmp=(C_word)a,a+=3,tmp));
t35=C_mutate((C_word*)lf[35]+1 /* (set! scheme#cadaar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11708,a[2]=((C_word)li33),tmp=(C_word)a,a+=3,tmp));
t36=C_mutate((C_word*)lf[36]+1 /* (set! scheme#cadadr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11719,a[2]=((C_word)li34),tmp=(C_word)a,a+=3,tmp));
t37=C_mutate((C_word*)lf[37]+1 /* (set! scheme#caddar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11723,a[2]=((C_word)li35),tmp=(C_word)a,a+=3,tmp));
t38=C_mutate((C_word*)lf[38]+1 /* (set! scheme#cdaaar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11730,a[2]=((C_word)li36),tmp=(C_word)a,a+=3,tmp));
t39=C_mutate((C_word*)lf[39]+1 /* (set! scheme#cdaadr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11748,a[2]=((C_word)li37),tmp=(C_word)a,a+=3,tmp));
t40=C_mutate((C_word*)lf[40]+1 /* (set! scheme#cdadar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11759,a[2]=((C_word)li38),tmp=(C_word)a,a+=3,tmp));
t41=C_mutate((C_word*)lf[41]+1 /* (set! scheme#cdaddr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11770,a[2]=((C_word)li39),tmp=(C_word)a,a+=3,tmp));
t42=C_mutate((C_word*)lf[42]+1 /* (set! scheme#cddaar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11777,a[2]=((C_word)li40),tmp=(C_word)a,a+=3,tmp));
t43=C_mutate((C_word*)lf[43]+1 /* (set! scheme#cddadr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11795,a[2]=((C_word)li41),tmp=(C_word)a,a+=3,tmp));
t44=C_mutate((C_word*)lf[44]+1 /* (set! scheme#cdddar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11806,a[2]=((C_word)li42),tmp=(C_word)a,a+=3,tmp));
t45=C_mutate((C_word*)lf[45]+1 /* (set! scheme#null? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11824,a[2]=((C_word)li43),tmp=(C_word)a,a+=3,tmp));
t46=C_mutate((C_word*)lf[46]+1 /* (set! scheme#list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11830,a[2]=((C_word)li44),tmp=(C_word)a,a+=3,tmp));
t47=C_mutate((C_word*)lf[47]+1 /* (set! scheme#length ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11833,a[2]=((C_word)li45),tmp=(C_word)a,a+=3,tmp));
t48=C_mutate((C_word*)lf[48]+1 /* (set! scheme#list-tail ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11836,a[2]=((C_word)li46),tmp=(C_word)a,a+=3,tmp));
t49=C_mutate((C_word*)lf[49]+1 /* (set! scheme#list-ref ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11839,a[2]=((C_word)li47),tmp=(C_word)a,a+=3,tmp));
t50=C_mutate((C_word*)lf[50]+1 /* (set! scheme#reverse ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11842,a[2]=((C_word)li49),tmp=(C_word)a,a+=3,tmp));
t51=C_mutate((C_word*)lf[53]+1 /* (set! scheme#memq ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11881,a[2]=((C_word)li50),tmp=(C_word)a,a+=3,tmp));
t52=C_mutate((C_word*)lf[54]+1 /* (set! scheme#memv ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11884,a[2]=((C_word)li51),tmp=(C_word)a,a+=3,tmp));
t53=C_mutate((C_word*)lf[55]+1 /* (set! scheme#member ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11887,a[2]=((C_word)li53),tmp=(C_word)a,a+=3,tmp));
t54=C_mutate((C_word*)lf[56]+1 /* (set! scheme#assq ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11931,a[2]=((C_word)li54),tmp=(C_word)a,a+=3,tmp));
t55=C_mutate((C_word*)lf[57]+1 /* (set! scheme#assv ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11934,a[2]=((C_word)li55),tmp=(C_word)a,a+=3,tmp));
t56=C_mutate((C_word*)lf[58]+1 /* (set! scheme#assoc ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11937,a[2]=((C_word)li57),tmp=(C_word)a,a+=3,tmp));
t57=C_mutate((C_word*)lf[59]+1 /* (set! scheme#list? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11986,a[2]=((C_word)li58),tmp=(C_word)a,a+=3,tmp));
t58=C_mutate((C_word*)lf[60]+1 /* (set! scheme#string? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11989,a[2]=((C_word)li59),tmp=(C_word)a,a+=3,tmp));
t59=C_mutate((C_word*)lf[61]+1 /* (set! scheme#string-length ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11992,a[2]=((C_word)li60),tmp=(C_word)a,a+=3,tmp));
t60=C_mutate((C_word*)lf[62]+1 /* (set! scheme#string-ref ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11995,a[2]=((C_word)li61),tmp=(C_word)a,a+=3,tmp));
t61=C_mutate((C_word*)lf[63]+1 /* (set! scheme#string-set! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11998,a[2]=((C_word)li62),tmp=(C_word)a,a+=3,tmp));
t62=C_mutate((C_word*)lf[64]+1 /* (set! scheme#string=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12001,a[2]=((C_word)li64),tmp=(C_word)a,a+=3,tmp));
t63=C_mutate((C_word*)lf[66]+1 /* (set! scheme#string-ci=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12034,a[2]=((C_word)li66),tmp=(C_word)a,a+=3,tmp));
t64=C_set_block_item(lf[68] /* scheme#features */,0,C_SCHEME_UNDEFINED);
t65=C_set_block_item(lf[69] /* scheme#call-with-port */,0,C_SCHEME_UNDEFINED);
t66=C_set_block_item(lf[70] /* scheme#close-port */,0,C_SCHEME_UNDEFINED);
t67=C_set_block_item(lf[71] /* scheme#peek-u8 */,0,C_SCHEME_UNDEFINED);
t68=C_set_block_item(lf[72] /* scheme#string-map */,0,C_SCHEME_UNDEFINED);
t69=C_set_block_item(lf[73] /* scheme#vector-map */,0,C_SCHEME_UNDEFINED);
t70=C_set_block_item(lf[74] /* scheme#string-for-each */,0,C_SCHEME_UNDEFINED);
t71=C_set_block_item(lf[75] /* scheme#vector-for-each */,0,C_SCHEME_UNDEFINED);
t72=C_set_block_item(lf[76] /* scheme#make-list */,0,C_SCHEME_UNDEFINED);
t73=C_set_block_item(lf[77] /* scheme#list-set! */,0,C_SCHEME_UNDEFINED);
t74=C_set_block_item(lf[78] /* scheme#write-string */,0,C_SCHEME_UNDEFINED);
t75=C_set_block_item(lf[79] /* scheme#eof-object */,0,C_SCHEME_UNDEFINED);
t76=C_set_block_item(lf[80] /* scheme#list-copy */,0,C_SCHEME_UNDEFINED);
t77=C_set_block_item(lf[81] /* scheme#string->vector */,0,C_SCHEME_UNDEFINED);
t78=C_set_block_item(lf[82] /* scheme#vector->string */,0,C_SCHEME_UNDEFINED);
t79=C_set_block_item(lf[83] /* scheme#exact */,0,C_SCHEME_UNDEFINED);
t80=C_set_block_item(lf[84] /* scheme#inexact */,0,C_SCHEME_UNDEFINED);
t81=C_set_block_item(lf[85] /* scheme#make-parameter */,0,C_SCHEME_UNDEFINED);
t82=C_mutate((C_word*)lf[86]+1 /* (set! scheme#exact->inexact ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12085,a[2]=((C_word)li67),tmp=(C_word)a,a+=3,tmp));
t83=C_mutate((C_word*)lf[87]+1 /* (set! scheme#abs ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12088,a[2]=((C_word)li68),tmp=(C_word)a,a+=3,tmp));
t84=C_mutate((C_word*)lf[88]+1 /* (set! scheme#+ ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_plus,a[2]=((C_word)li69),tmp=(C_word)a,a+=3,tmp));
t85=C_mutate((C_word*)lf[89]+1 /* (set! scheme#- ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_minus,a[2]=((C_word)li70),tmp=(C_word)a,a+=3,tmp));
t86=C_mutate((C_word*)lf[90]+1 /* (set! scheme#* ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_times,a[2]=((C_word)li71),tmp=(C_word)a,a+=3,tmp));
t87=C_mutate((C_word*)lf[91]+1 /* (set! scheme#quotient ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12094,a[2]=((C_word)li72),tmp=(C_word)a,a+=3,tmp));
t88=C_mutate((C_word*)lf[92]+1 /* (set! scheme#remainder ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12097,a[2]=((C_word)li73),tmp=(C_word)a,a+=3,tmp));
t89=C_mutate((C_word*)lf[93]+1 /* (set! scheme#modulo ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12100,a[2]=((C_word)li74),tmp=(C_word)a,a+=3,tmp));
t90=C_mutate((C_word*)lf[94]+1 /* (set! scheme#even? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12103,a[2]=((C_word)li75),tmp=(C_word)a,a+=3,tmp));
t91=C_mutate((C_word*)lf[95]+1 /* (set! scheme#odd? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12106,a[2]=((C_word)li76),tmp=(C_word)a,a+=3,tmp));
t92=C_mutate((C_word*)lf[96]+1 /* (set! scheme#= ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_nequalp,a[2]=((C_word)li77),tmp=(C_word)a,a+=3,tmp));
t93=C_mutate((C_word*)lf[97]+1 /* (set! scheme#> ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_greaterp,a[2]=((C_word)li78),tmp=(C_word)a,a+=3,tmp));
t94=C_mutate((C_word*)lf[98]+1 /* (set! scheme#< ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_lessp,a[2]=((C_word)li79),tmp=(C_word)a,a+=3,tmp));
t95=C_mutate((C_word*)lf[99]+1 /* (set! scheme#>= ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_greater_or_equal_p,a[2]=((C_word)li80),tmp=(C_word)a,a+=3,tmp));
t96=C_mutate((C_word*)lf[100]+1 /* (set! scheme#<= ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_less_or_equal_p,a[2]=((C_word)li81),tmp=(C_word)a,a+=3,tmp));
t97=C_mutate((C_word*)lf[101]+1 /* (set! scheme#number? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12114,a[2]=((C_word)li82),tmp=(C_word)a,a+=3,tmp));
t98=C_mutate((C_word*)lf[102]+1 /* (set! scheme#complex? ...) */,*((C_word*)lf[101]+1));
t99=C_mutate((C_word*)lf[103]+1 /* (set! scheme#real? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12118,a[2]=((C_word)li83),tmp=(C_word)a,a+=3,tmp));
t100=C_mutate((C_word*)lf[104]+1 /* (set! scheme#rational? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12121,a[2]=((C_word)li84),tmp=(C_word)a,a+=3,tmp));
t101=C_mutate((C_word*)lf[105]+1 /* (set! scheme#integer? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12124,a[2]=((C_word)li85),tmp=(C_word)a,a+=3,tmp));
t102=C_mutate((C_word*)lf[106]+1 /* (set! scheme#exact? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12127,a[2]=((C_word)li86),tmp=(C_word)a,a+=3,tmp));
t103=C_mutate((C_word*)lf[107]+1 /* (set! scheme#inexact? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12130,a[2]=((C_word)li87),tmp=(C_word)a,a+=3,tmp));
t104=C_mutate((C_word*)lf[108]+1 /* (set! scheme#zero? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12133,a[2]=((C_word)li88),tmp=(C_word)a,a+=3,tmp));
t105=C_mutate((C_word*)lf[109]+1 /* (set! scheme#positive? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12136,a[2]=((C_word)li89),tmp=(C_word)a,a+=3,tmp));
t106=C_mutate((C_word*)lf[110]+1 /* (set! scheme#negative? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12139,a[2]=((C_word)li90),tmp=(C_word)a,a+=3,tmp));
t107=C_mutate((C_word*)lf[111]+1 /* (set! scheme#number->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_number_to_string,a[2]=((C_word)li91),tmp=(C_word)a,a+=3,tmp));
t108=C_mutate((C_word*)lf[112]+1 /* (set! scheme#symbol? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12143,a[2]=((C_word)li92),tmp=(C_word)a,a+=3,tmp));
t109=C_mutate((C_word*)lf[113]+1 /* (set! scheme#vector? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12146,a[2]=((C_word)li93),tmp=(C_word)a,a+=3,tmp));
t110=C_mutate((C_word*)lf[114]+1 /* (set! scheme#vector-length ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12149,a[2]=((C_word)li94),tmp=(C_word)a,a+=3,tmp));
t111=C_mutate((C_word*)lf[115]+1 /* (set! scheme#vector-ref ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12152,a[2]=((C_word)li95),tmp=(C_word)a,a+=3,tmp));
t112=C_mutate((C_word*)lf[116]+1 /* (set! scheme#vector-set! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12155,a[2]=((C_word)li96),tmp=(C_word)a,a+=3,tmp));
t113=C_set_block_item(lf[117] /* scheme#make-vector */,0,C_SCHEME_UNDEFINED);
t114=C_set_block_item(lf[118] /* scheme#list->vector */,0,C_SCHEME_UNDEFINED);
t115=C_set_block_item(lf[119] /* scheme#vector->list */,0,C_SCHEME_UNDEFINED);
t116=C_set_block_item(lf[120] /* scheme#vector */,0,C_SCHEME_UNDEFINED);
t117=C_set_block_item(lf[121] /* scheme#vector-fill! */,0,C_SCHEME_UNDEFINED);
t118=C_mutate((C_word*)lf[122]+1 /* (set! scheme#char? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12163,a[2]=((C_word)li97),tmp=(C_word)a,a+=3,tmp));
t119=C_mutate((C_word*)lf[123]+1 /* (set! scheme#char->integer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12166,a[2]=((C_word)li98),tmp=(C_word)a,a+=3,tmp));
t120=C_mutate((C_word*)lf[125]+1 /* (set! scheme#integer->char ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12173,a[2]=((C_word)li99),tmp=(C_word)a,a+=3,tmp));
t121=C_mutate((C_word*)lf[127]+1 /* (set! scheme#char=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12180,a[2]=((C_word)li101),tmp=(C_word)a,a+=3,tmp));
t122=C_mutate((C_word*)lf[129]+1 /* (set! scheme#char>? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12219,a[2]=((C_word)li103),tmp=(C_word)a,a+=3,tmp));
t123=C_mutate((C_word*)lf[131]+1 /* (set! scheme#char<? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12258,a[2]=((C_word)li105),tmp=(C_word)a,a+=3,tmp));
t124=C_mutate((C_word*)lf[133]+1 /* (set! scheme#char>=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12297,a[2]=((C_word)li107),tmp=(C_word)a,a+=3,tmp));
t125=C_mutate((C_word*)lf[135]+1 /* (set! scheme#char<=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12336,a[2]=((C_word)li109),tmp=(C_word)a,a+=3,tmp));
t126=C_mutate((C_word*)lf[137]+1 /* (set! scheme#char-upcase ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12375,a[2]=((C_word)li110),tmp=(C_word)a,a+=3,tmp));
t127=C_mutate((C_word*)lf[139]+1 /* (set! scheme#char-downcase ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12381,a[2]=((C_word)li111),tmp=(C_word)a,a+=3,tmp));
t128=C_set_block_item(lf[141] /* scheme#char-ci=? */,0,C_SCHEME_UNDEFINED);
t129=C_set_block_item(lf[142] /* scheme#char-ci>? */,0,C_SCHEME_UNDEFINED);
t130=C_set_block_item(lf[143] /* scheme#char-ci<? */,0,C_SCHEME_UNDEFINED);
t131=C_set_block_item(lf[144] /* scheme#char-ci>=? */,0,C_SCHEME_UNDEFINED);
t132=C_set_block_item(lf[145] /* scheme#char-ci<=? */,0,C_SCHEME_UNDEFINED);
t133=C_mutate((C_word*)lf[146]+1 /* (set! scheme#char-upper-case? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12392,a[2]=((C_word)li112),tmp=(C_word)a,a+=3,tmp));
t134=C_mutate((C_word*)lf[148]+1 /* (set! scheme#char-lower-case? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12398,a[2]=((C_word)li113),tmp=(C_word)a,a+=3,tmp));
t135=C_mutate((C_word*)lf[150]+1 /* (set! scheme#char-numeric? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12404,a[2]=((C_word)li114),tmp=(C_word)a,a+=3,tmp));
t136=C_mutate((C_word*)lf[152]+1 /* (set! scheme#char-whitespace? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12410,a[2]=((C_word)li115),tmp=(C_word)a,a+=3,tmp));
t137=C_mutate((C_word*)lf[154]+1 /* (set! scheme#char-alphabetic? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12416,a[2]=((C_word)li116),tmp=(C_word)a,a+=3,tmp));
t138=C_mutate((C_word*)lf[156]+1 /* (set! scheme.char#digit-value ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12422,a[2]=((C_word)li117),tmp=(C_word)a,a+=3,tmp));
t139=C_mutate((C_word*)lf[158]+1 /* (set! scheme#procedure? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12438,a[2]=((C_word)li118),tmp=(C_word)a,a+=3,tmp));
t140=C_mutate((C_word*)lf[159]+1 /* (set! scheme#apply ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_apply,a[2]=((C_word)li119),tmp=(C_word)a,a+=3,tmp));
t141=C_mutate((C_word*)lf[160]+1 /* (set! scheme#values ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_values,a[2]=((C_word)li120),tmp=(C_word)a,a+=3,tmp));
t142=C_mutate((C_word*)lf[161]+1 /* (set! scheme#call-with-values ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_call_with_values,a[2]=((C_word)li121),tmp=(C_word)a,a+=3,tmp));
t143=C_set_block_item(lf[162] /* scheme#call-with-current-continuation */,0,C_SCHEME_UNDEFINED);
t144=C_set_block_item(lf[163] /* scheme#call/cc */,0,C_SCHEME_UNDEFINED);
t145=C_mutate((C_word*)lf[164]+1 /* (set! scheme#input-port? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12446,a[2]=((C_word)li122),tmp=(C_word)a,a+=3,tmp));
t146=C_mutate((C_word*)lf[165]+1 /* (set! scheme#output-port? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12452,a[2]=((C_word)li123),tmp=(C_word)a,a+=3,tmp));
t147=C_mutate((C_word*)lf[166]+1 /* (set! scheme#binary-port? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12458,a[2]=((C_word)li124),tmp=(C_word)a,a+=3,tmp));
t148=C_mutate((C_word*)lf[169]+1 /* (set! scheme#textual-port? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12474,a[2]=((C_word)li125),tmp=(C_word)a,a+=3,tmp));
t149=C_mutate((C_word*)lf[168]+1 /* (set! scheme#port? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12490,a[2]=((C_word)li126),tmp=(C_word)a,a+=3,tmp));
t150=C_mutate((C_word*)lf[171]+1 /* (set! scheme#input-port-open? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12496,a[2]=((C_word)li127),tmp=(C_word)a,a+=3,tmp));
t151=C_mutate((C_word*)lf[173]+1 /* (set! scheme#output-port-open? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12501,a[2]=((C_word)li128),tmp=(C_word)a,a+=3,tmp));
t152=C_set_block_item(lf[175] /* scheme#current-input-port */,0,C_SCHEME_UNDEFINED);
t153=C_set_block_item(lf[176] /* scheme#current-output-port */,0,C_SCHEME_UNDEFINED);
t154=C_set_block_item(lf[177] /* scheme#open-input-file */,0,C_SCHEME_UNDEFINED);
t155=C_set_block_item(lf[178] /* scheme#open-output-file */,0,C_SCHEME_UNDEFINED);
t156=C_set_block_item(lf[179] /* scheme#close-input-port */,0,C_SCHEME_UNDEFINED);
t157=C_set_block_item(lf[180] /* scheme#close-output-port */,0,C_SCHEME_UNDEFINED);
t158=C_set_block_item(lf[181] /* scheme#call-with-input-file */,0,C_SCHEME_UNDEFINED);
t159=C_set_block_item(lf[182] /* scheme#call-with-output-file */,0,C_SCHEME_UNDEFINED);
t160=C_set_block_item(lf[183] /* scheme#with-input-from-file */,0,C_SCHEME_UNDEFINED);
t161=C_set_block_item(lf[184] /* scheme#with-output-to-file */,0,C_SCHEME_UNDEFINED);
t162=C_mutate((C_word*)lf[185]+1 /* (set! scheme#eof-object? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12516,a[2]=((C_word)li129),tmp=(C_word)a,a+=3,tmp));
t163=C_set_block_item(lf[186] /* scheme#char-ready? */,0,C_SCHEME_UNDEFINED);
t164=C_set_block_item(lf[187] /* scheme#read-char */,0,C_SCHEME_UNDEFINED);
t165=C_set_block_item(lf[188] /* scheme#peek-char */,0,C_SCHEME_UNDEFINED);
t166=C_set_block_item(lf[189] /* scheme#read */,0,C_SCHEME_UNDEFINED);
t167=C_set_block_item(lf[190] /* scheme#write-char */,0,C_SCHEME_UNDEFINED);
t168=C_set_block_item(lf[191] /* scheme#newline */,0,C_SCHEME_UNDEFINED);
t169=C_set_block_item(lf[192] /* scheme#write */,0,C_SCHEME_UNDEFINED);
t170=C_set_block_item(lf[193] /* scheme#display */,0,C_SCHEME_UNDEFINED);
t171=C_mutate((C_word*)lf[194]+1 /* (set! scheme#eval ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12527,a[2]=((C_word)li130),tmp=(C_word)a,a+=3,tmp));
t172=C_mutate((C_word*)lf[198]+1 /* (set! scheme#interaction-environment ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12533,a[2]=((C_word)li131),tmp=(C_word)a,a+=3,tmp));
t173=C_mutate((C_word*)lf[201]+1 /* (set! scheme#scheme-report-environment ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12539,a[2]=((C_word)li132),tmp=(C_word)a,a+=3,tmp));
t174=C_mutate((C_word*)lf[204]+1 /* (set! scheme#null-environment ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12545,a[2]=((C_word)li133),tmp=(C_word)a,a+=3,tmp));
t175=C_mutate((C_word*)lf[207]+1 /* (set! scheme#load ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12551,a[2]=((C_word)li134),tmp=(C_word)a,a+=3,tmp));
t176=C_set_block_item(lf[210] /* scheme#for-each */,0,C_SCHEME_UNDEFINED);
t177=C_set_block_item(lf[211] /* scheme#map */,0,C_SCHEME_UNDEFINED);
t178=C_set_block_item(lf[212] /* scheme#dynamic-wind */,0,C_SCHEME_UNDEFINED);
t179=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12561,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);{
C_word *av2=av;
av2[0]=C_SCHEME_UNDEFINED;
av2[1]=t179;
C_library_toplevel(2,av2);}}

/* scheme#not in k11436 */
static void C_ccall f_11440(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11440,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_not(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#boolean? in k11436 */
static void C_ccall f_11443(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11443,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_booleanp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#eq? in k11436 */
static void C_ccall f_11446(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11446,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_eqp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#eqv? in k11436 */
static void C_ccall f_11449(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11449,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_eqvp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#equal? in k11436 */
static void C_ccall f_11452(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11452,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_equalp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#boolean=? in k11436 */
static void C_ccall f_11455(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +4,c,3)))){
C_save_and_reclaim((void*)f_11455,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+4);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
t5=C_i_check_boolean_2(t2,lf[8]);
t6=C_i_check_boolean_2(t3,lf[8]);
t7=C_eqp(t2,t3);
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_11471,a[2]=t3,a[3]=((C_word)li5),tmp=(C_word)a,a+=4,tmp);
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=(
  f_11471(t8,t4,t7)
);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}

/* loop in scheme#boolean=? in k11436 */
static C_word f_11471(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t1))){
return(t2);}
else{
t3=C_slot(t1,C_fix(0));
t4=C_i_check_boolean_2(t3,lf[8]);
t5=C_slot(t1,C_fix(1));
if(C_truep(t2)){
t7=t5;
t8=C_eqp(t3,((C_word*)t0)[2]);
t1=t7;
t2=t8;
goto loop;}
else{
t7=t5;
t8=C_SCHEME_FALSE;
t1=t7;
t2=t8;
goto loop;}}}

/* scheme#symbol=? in k11436 */
static void C_ccall f_11500(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +4,c,3)))){
C_save_and_reclaim((void*)f_11500,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+4);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
t5=C_i_check_symbol_2(t2,lf[10]);
t6=C_i_check_symbol_2(t3,lf[10]);
t7=C_eqp(t2,t3);
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_11516,a[2]=t3,a[3]=((C_word)li7),tmp=(C_word)a,a+=4,tmp);
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=(
  f_11516(t8,t4,t7)
);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}

/* loop in scheme#symbol=? in k11436 */
static C_word f_11516(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t1))){
return(t2);}
else{
t3=C_slot(t1,C_fix(0));
t4=C_i_check_symbol_2(t3,lf[10]);
t5=C_slot(t1,C_fix(1));
if(C_truep(t2)){
t7=t5;
t8=C_eqp(t3,((C_word*)t0)[2]);
t1=t7;
t2=t8;
goto loop;}
else{
t7=t5;
t8=C_SCHEME_FALSE;
t1=t7;
t2=t8;
goto loop;}}}

/* scheme#pair? in k11436 */
static void C_ccall f_11545(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11545,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_pairp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cons in k11436 */
static void C_ccall f_11548(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_11548,c,av);}
a=C_alloc(3);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_cons(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#car in k11436 */
static void C_ccall f_11551(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11551,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_car(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cdr in k11436 */
static void C_ccall f_11554(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11554,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cdr(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#set-car! in k11436 */
static void C_ccall f_11557(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11557,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_car(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#set-cdr! in k11436 */
static void C_ccall f_11560(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11560,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_cdr(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#cadr in k11436 */
static void C_ccall f_11563(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11563,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cadr(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#caddr in k11436 */
static void C_ccall f_11566(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11566,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_caddr(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cadddr in k11436 */
static void C_ccall f_11569(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11569,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cadddr(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cddddr in k11436 */
static void C_ccall f_11572(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11572,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cddddr(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#caar in k11436 */
static void C_ccall f_11575(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11575,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_caar(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cdar in k11436 */
static void C_ccall f_11578(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11578,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cdar(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cddr in k11436 */
static void C_ccall f_11581(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11581,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cddr(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#caaar in k11436 */
static void C_ccall f_11584(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11584,c,av);}
t3=C_i_car(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_car(C_i_car(t3));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#caadr in k11436 */
static void C_ccall f_11598(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11598,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_car(C_i_cadr(t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cadar in k11436 */
static void C_ccall f_11605(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11605,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cadr(C_i_car(t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cdaar in k11436 */
static void C_ccall f_11612(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11612,c,av);}
t3=C_i_car(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_cdr(C_i_car(t3));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#cdadr in k11436 */
static void C_ccall f_11626(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11626,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cdr(C_i_cadr(t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cddar in k11436 */
static void C_ccall f_11633(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11633,c,av);}
t3=C_i_car(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_cdr(C_i_cdr(t3));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#cdddr in k11436 */
static void C_ccall f_11647(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11647,c,av);}
t3=C_i_cdr(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_cdr(C_i_cdr(t3));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#caaaar in k11436 */
static void C_ccall f_11661(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11661,c,av);}
t3=C_i_car(t2);
t4=C_i_car(t3);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_car(C_i_car(t4));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#caaadr in k11436 */
static void C_ccall f_11679(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11679,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_car(C_i_car(C_i_cadr(t2)));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#caadar in k11436 */
static void C_ccall f_11690(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11690,c,av);}
t3=C_i_car(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_car(C_i_cadr(t3));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#caaddr in k11436 */
static void C_ccall f_11701(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11701,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_car(C_i_caddr(t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cadaar in k11436 */
static void C_ccall f_11708(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11708,c,av);}
t3=C_i_car(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_cadr(C_i_car(t3));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#cadadr in k11436 */
static void C_ccall f_11719(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11719,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cadr(C_i_cadr(t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#caddar in k11436 */
static void C_ccall f_11723(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11723,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_caddr(C_i_car(t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cdaaar in k11436 */
static void C_ccall f_11730(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11730,c,av);}
t3=C_i_car(t2);
t4=C_i_car(t3);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_cdr(C_i_car(t4));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#cdaadr in k11436 */
static void C_ccall f_11748(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11748,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cdr(C_i_car(C_i_cadr(t2)));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cdadar in k11436 */
static void C_ccall f_11759(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11759,c,av);}
t3=C_i_car(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_cdr(C_i_cadr(t3));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#cdaddr in k11436 */
static void C_ccall f_11770(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11770,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cdr(C_i_caddr(t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cddaar in k11436 */
static void C_ccall f_11777(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11777,c,av);}
t3=C_i_car(t2);
t4=C_i_car(t3);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_cdr(C_i_cdr(t4));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#cddadr in k11436 */
static void C_ccall f_11795(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11795,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cdr(C_i_cdr(C_i_cadr(t2)));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#cdddar in k11436 */
static void C_ccall f_11806(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11806,c,av);}
t3=C_i_car(t2);
t4=C_i_cdr(t3);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_cdr(C_i_cdr(t4));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#null? in k11436 */
static void C_ccall f_11824(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11824,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_eqp(t2,C_SCHEME_END_OF_LIST);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#list in k11436 */
static void C_ccall f_11830(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_11830,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+0);
t2=C_build_rest(&a,c,2,av);
C_word t3;
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#length in k11436 */
static void C_ccall f_11833(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11833,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_length(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#list-tail in k11436 */
static void C_ccall f_11836(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11836,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_list_tail(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#list-ref in k11436 */
static void C_ccall f_11839(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11839,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_list_ref(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#reverse in k11436 */
static void C_ccall f_11842(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_11842,c,av);}
a=C_alloc(7);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_11848,a[2]=t4,a[3]=t2,a[4]=((C_word)li48),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_11848(t6,t1,t2,C_SCHEME_END_OF_LIST);}

/* loop in scheme#reverse in k11436 */
static void f_11848(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,3)))){
C_save_and_reclaim_args((void *)trf_11848,4,t0,t1,t2,t3);}
a=C_alloc(3);
t4=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(t4)){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_i_pairp(t2))){
t5=C_slot(t2,C_fix(1));
t6=C_slot(t2,C_fix(0));
t7=C_a_i_cons(&a,2,t6,t3);
/* library.scm:353: loop */
t9=t1;
t10=t5;
t11=t7;
t1=t9;
t2=t10;
t3=t11;
goto loop;}
else{
/* library.scm:354: ##sys#error-not-a-proper-list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[52];
tp(4,av2);}}}}

/* scheme#memq in k11436 */
static void C_ccall f_11881(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11881,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_memq(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#memv in k11436 */
static void C_ccall f_11884(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11884,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_memv(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#member in k11436 */
static void C_ccall f_11887(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_11887,c,av);}
a=C_alloc(8);
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,4,t0));
if(C_truep(t5)){
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_11899,a[2]=t7,a[3]=t5,a[4]=t2,a[5]=((C_word)li52),tmp=(C_word)a,a+=6,tmp));
t9=((C_word*)t7)[1];
f_11899(t9,t1,t3);}
else{
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_i_member(t2,t3);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* loop in scheme#member in k11436 */
static void f_11899(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_11899,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_11912,a[2]=t1,a[3]=t2,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* library.scm:363: eq */
t4=((C_word*)t0)[3];{
C_word av2[4];
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
av2[3]=C_slot(t2,C_fix(0));
((C_proc)C_fast_retrieve_proc(t4))(4,av2);}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k11910 in loop in scheme#member in k11436 */
static void C_ccall f_11912(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_11912,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:365: loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_11899(t2,((C_word*)t0)[2],C_slot(((C_word*)t0)[3],C_fix(1)));}}

/* scheme#assq in k11436 */
static void C_ccall f_11931(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11931,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_assq(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#assv in k11436 */
static void C_ccall f_11934(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11934,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_assv(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#assoc in k11436 */
static void C_ccall f_11937(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_11937,c,av);}
a=C_alloc(8);
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,4,t0));
if(C_truep(t5)){
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_11949,a[2]=t7,a[3]=t5,a[4]=t2,a[5]=((C_word)li56),tmp=(C_word)a,a+=6,tmp));
t9=((C_word*)t7)[1];
f_11949(t9,t1,t3);}
else{
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_i_assoc(t2,t3);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* loop in scheme#assoc in k11436 */
static void f_11949(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_11949,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_11962,a[2]=t1,a[3]=t2,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
t4=C_slot(t2,C_fix(0));
/* library.scm:375: eq */
t5=((C_word*)t0)[3];{
C_word av2[4];
av2[0]=t5;
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
av2[3]=C_i_car(t4);
((C_proc)C_fast_retrieve_proc(t5))(4,av2);}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k11960 in loop in scheme#assoc in k11436 */
static void C_ccall f_11962(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_11962,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_u_i_car(((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:377: loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_11949(t2,((C_word*)t0)[2],C_slot(((C_word*)t0)[3],C_fix(1)));}}

/* scheme#list? in k11436 */
static void C_ccall f_11986(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11986,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_listp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#string? in k11436 */
static void C_ccall f_11989(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11989,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_stringp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#string-length in k11436 */
static void C_ccall f_11992(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11992,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_string_length(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#string-ref in k11436 */
static void C_ccall f_11995(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11995,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_string_ref(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#string-set! in k11436 */
static void C_ccall f_11998(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_11998,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_string_set(t2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#string=? in k11436 */
static void C_ccall f_12001(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,4)))){
C_save_and_reclaim((void*)f_12001,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
t5=C_i_string_equal_p(t2,t3);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12008,a[2]=((C_word)li63),tmp=(C_word)a,a+=3,tmp);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(
  f_12008(t3,t4,t5)
);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* loop in scheme#string=? in k11436 */
static C_word f_12008(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t2))){
return(t3);}
else{
t4=C_slot(t2,C_fix(0));
t5=C_i_check_string_2(t4,lf[65]);
t6=C_slot(t2,C_fix(1));
if(C_truep(t3)){
t8=t4;
t9=t6;
t10=C_i_string_equal_p(t1,t4);
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t8=t4;
t9=t6;
t10=C_SCHEME_FALSE;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* scheme#string-ci=? in k11436 */
static void C_ccall f_12034(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,4)))){
C_save_and_reclaim((void*)f_12034,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
t5=C_i_string_ci_equal_p(t2,t3);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12041,a[2]=((C_word)li65),tmp=(C_word)a,a+=3,tmp);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(
  f_12041(t3,t4,t5)
);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* loop in scheme#string-ci=? in k11436 */
static C_word f_12041(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t2))){
return(t3);}
else{
t4=C_slot(t2,C_fix(0));
t5=C_i_check_string_2(t4,lf[67]);
t6=C_slot(t2,C_fix(1));
if(C_truep(t3)){
t8=t4;
t9=t6;
t10=C_i_string_ci_equal_p(t1,t4);
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t8=t4;
t9=t6;
t10=C_SCHEME_FALSE;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* scheme#exact->inexact in k11436 */
static void C_ccall f_12085(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(12,c,1)))){
C_save_and_reclaim((void *)f_12085,c,av);}
a=C_alloc(12);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_exact_to_inexact(&a,1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#abs in k11436 */
static void C_ccall f_12088(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,1)))){
C_save_and_reclaim((void *)f_12088,c,av);}
a=C_alloc(7);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_s_a_i_abs(&a,1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#quotient in k11436 */
static void C_ccall f_12094(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_12094,c,av);}
a=C_alloc(5);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_s_a_i_quotient(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#remainder in k11436 */
static void C_ccall f_12097(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_12097,c,av);}
a=C_alloc(5);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_s_a_i_remainder(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#modulo in k11436 */
static void C_ccall f_12100(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_12100,c,av);}
a=C_alloc(5);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_s_a_i_modulo(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#even? in k11436 */
static void C_ccall f_12103(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12103,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_evenp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#odd? in k11436 */
static void C_ccall f_12106(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12106,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_oddp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#number? in k11436 */
static void C_ccall f_12114(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12114,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_numberp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#real? in k11436 */
static void C_ccall f_12118(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12118,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_realp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#rational? in k11436 */
static void C_ccall f_12121(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12121,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_rationalp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#integer? in k11436 */
static void C_ccall f_12124(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12124,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_integerp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#exact? in k11436 */
static void C_ccall f_12127(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12127,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_exactp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#inexact? in k11436 */
static void C_ccall f_12130(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12130,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_inexactp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#zero? in k11436 */
static void C_ccall f_12133(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12133,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_zerop(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#positive? in k11436 */
static void C_ccall f_12136(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12136,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_positivep(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#negative? in k11436 */
static void C_ccall f_12139(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12139,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_negativep(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#symbol? in k11436 */
static void C_ccall f_12143(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12143,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_symbolp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#vector? in k11436 */
static void C_ccall f_12146(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12146,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_vectorp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#vector-length in k11436 */
static void C_ccall f_12149(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12149,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_vector_length(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#vector-ref in k11436 */
static void C_ccall f_12152(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12152,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_vector_ref(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#vector-set! in k11436 */
static void C_ccall f_12155(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12155,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_vector_set(t2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#char? in k11436 */
static void C_ccall f_12163(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12163,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_charp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#char->integer in k11436 */
static void C_ccall f_12166(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12166,c,av);}
t3=C_i_check_char_2(t2,lf[124]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fix(C_character_code(t2));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#integer->char in k11436 */
static void C_ccall f_12173(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12173,c,av);}
t3=C_i_check_fixnum_2(t2,lf[126]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_make_character(C_unfix(t2));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#char=? in k11436 */
static void C_ccall f_12180(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,4)))){
C_save_and_reclaim((void*)f_12180,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
t5=C_i_check_char_2(t2,lf[128]);
t6=C_i_check_char_2(t3,lf[128]);
t7=C_u_i_char_equalp(t2,t3);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12193,a[2]=((C_word)li100),tmp=(C_word)a,a+=3,tmp);
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=(
  f_12193(t3,t4,t7)
);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}

/* loop in scheme#char=? in k11436 */
static C_word f_12193(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t2))){
return(t3);}
else{
t4=C_slot(t2,C_fix(0));
t5=C_i_check_char_2(t4,lf[128]);
t6=C_slot(t2,C_fix(1));
if(C_truep(t3)){
t8=t4;
t9=t6;
t10=C_u_i_char_equalp(t1,t4);
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t8=t4;
t9=t6;
t10=C_SCHEME_FALSE;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* scheme#char>? in k11436 */
static void C_ccall f_12219(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,4)))){
C_save_and_reclaim((void*)f_12219,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
t5=C_i_check_char_2(t2,lf[130]);
t6=C_i_check_char_2(t3,lf[130]);
t7=C_u_i_char_greaterp(t2,t3);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12232,a[2]=((C_word)li102),tmp=(C_word)a,a+=3,tmp);
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=(
  f_12232(t3,t4,t7)
);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}

/* loop in scheme#char>? in k11436 */
static C_word f_12232(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t2))){
return(t3);}
else{
t4=C_slot(t2,C_fix(0));
t5=C_i_check_char_2(t4,lf[130]);
t6=C_slot(t2,C_fix(1));
if(C_truep(t3)){
t8=t4;
t9=t6;
t10=C_u_i_char_greaterp(t1,t4);
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t8=t4;
t9=t6;
t10=C_SCHEME_FALSE;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* scheme#char<? in k11436 */
static void C_ccall f_12258(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,4)))){
C_save_and_reclaim((void*)f_12258,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
t5=C_i_check_char_2(t2,lf[132]);
t6=C_i_check_char_2(t3,lf[132]);
t7=C_u_i_char_lessp(t2,t3);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12271,a[2]=((C_word)li104),tmp=(C_word)a,a+=3,tmp);
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=(
  f_12271(t3,t4,t7)
);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}

/* loop in scheme#char<? in k11436 */
static C_word f_12271(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t2))){
return(t3);}
else{
t4=C_slot(t2,C_fix(0));
t5=C_i_check_char_2(t4,lf[132]);
t6=C_slot(t2,C_fix(1));
if(C_truep(t3)){
t8=t4;
t9=t6;
t10=C_u_i_char_lessp(t1,t4);
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t8=t4;
t9=t6;
t10=C_SCHEME_FALSE;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* scheme#char>=? in k11436 */
static void C_ccall f_12297(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,4)))){
C_save_and_reclaim((void*)f_12297,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
t5=C_i_check_char_2(t2,lf[134]);
t6=C_i_check_char_2(t3,lf[134]);
t7=C_u_i_char_greater_or_equal_p(t2,t3);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12310,a[2]=((C_word)li106),tmp=(C_word)a,a+=3,tmp);
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=(
  f_12310(t3,t4,t7)
);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}

/* loop in scheme#char>=? in k11436 */
static C_word f_12310(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t2))){
return(t3);}
else{
t4=C_slot(t2,C_fix(0));
t5=C_i_check_char_2(t4,lf[134]);
t6=C_slot(t2,C_fix(1));
if(C_truep(t3)){
t8=t4;
t9=t6;
t10=C_u_i_char_greater_or_equal_p(t1,t4);
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t8=t4;
t9=t6;
t10=C_SCHEME_FALSE;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* scheme#char<=? in k11436 */
static void C_ccall f_12336(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,4)))){
C_save_and_reclaim((void*)f_12336,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
t5=C_i_check_char_2(t2,lf[136]);
t6=C_i_check_char_2(t3,lf[136]);
t7=C_u_i_char_less_or_equal_p(t2,t3);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12349,a[2]=((C_word)li108),tmp=(C_word)a,a+=3,tmp);
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=(
  f_12349(t3,t4,t7)
);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}

/* loop in scheme#char<=? in k11436 */
static C_word f_12349(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t2))){
return(t3);}
else{
t4=C_slot(t2,C_fix(0));
t5=C_i_check_char_2(t4,lf[136]);
t6=C_slot(t2,C_fix(1));
if(C_truep(t3)){
t8=t4;
t9=t6;
t10=C_u_i_char_less_or_equal_p(t1,t4);
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t8=t4;
t9=t6;
t10=C_SCHEME_FALSE;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* scheme#char-upcase in k11436 */
static void C_ccall f_12375(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12375,c,av);}
t3=C_i_check_char_2(t2,lf[138]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_u_i_char_upcase(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#char-downcase in k11436 */
static void C_ccall f_12381(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12381,c,av);}
t3=C_i_check_char_2(t2,lf[140]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_u_i_char_downcase(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#char-upper-case? in k11436 */
static void C_ccall f_12392(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12392,c,av);}
t3=C_i_check_char_2(t2,lf[147]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_u_i_char_upper_casep(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#char-lower-case? in k11436 */
static void C_ccall f_12398(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12398,c,av);}
t3=C_i_check_char_2(t2,lf[149]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_u_i_char_lower_casep(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#char-numeric? in k11436 */
static void C_ccall f_12404(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12404,c,av);}
t3=C_i_check_char_2(t2,lf[151]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_u_i_char_numericp(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#char-whitespace? in k11436 */
static void C_ccall f_12410(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12410,c,av);}
t3=C_i_check_char_2(t2,lf[153]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_u_i_char_whitespacep(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#char-alphabetic? in k11436 */
static void C_ccall f_12416(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12416,c,av);}
t3=C_i_check_char_2(t2,lf[155]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_u_i_char_alphabeticp(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme.char#digit-value in k11436 */
static void C_ccall f_12422(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12422,c,av);}
t3=C_i_check_char_2(t2,lf[157]);
t4=C_u_i_digit_value(t2);
t5=C_eqp(t4,C_fix(0));
t6=C_i_not(t5);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(C_truep(t6)?C_fixnum_difference(t4,C_fix(1)):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* scheme#procedure? in k11436 */
static void C_ccall f_12438(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12438,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_closurep(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#input-port? in k11436 */
static void C_ccall f_12446(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12446,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(C_blockp(t2))?C_input_portp(t2):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#output-port? in k11436 */
static void C_ccall f_12452(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12452,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(C_blockp(t2))?C_output_portp(t2):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#binary-port? in k11436 */
static void C_ccall f_12458(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_12458,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12465,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:682: port? */
t4=*((C_word*)lf[168]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k12463 in scheme#binary-port? in k11436 */
static void C_ccall f_12465(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12465,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=(C_truep(t1)?C_eqp(lf[167],C_slot(((C_word*)t0)[3],C_fix(14))):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scheme#textual-port? in k11436 */
static void C_ccall f_12474(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_12474,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12481,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:686: port? */
t4=*((C_word*)lf[168]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k12479 in scheme#textual-port? in k11436 */
static void C_ccall f_12481(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12481,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=(C_truep(t1)?C_eqp(lf[170],C_slot(((C_word*)t0)[3],C_fix(14))):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scheme#port? in k11436 */
static void C_ccall f_12490(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12490,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(C_blockp(t2))?C_portp(t2):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#input-port-open? in k11436 */
static void C_ccall f_12496(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12496,c,av);}
t3=C_i_check_port(t2,C_fix(1),lf[172]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_input_port_openp(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#output-port-open? in k11436 */
static void C_ccall f_12501(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12501,c,av);}
t3=C_i_check_port(t2,C_fix(2),lf[174]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_output_port_openp(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#eof-object? in k11436 */
static void C_ccall f_12516(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12516,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_eofp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#eval in k11436 */
static void C_ccall f_12527(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12527,c,av);}
/* library.scm:736: ##sys#error */
t3=*((C_word*)lf[195]+1);{
C_word av2[4];
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[196];
av2[3]=lf[197];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* scheme#interaction-environment in k11436 */
static void C_ccall f_12533(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12533,c,av);}
/* library.scm:739: ##sys#error */
t2=*((C_word*)lf[195]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=lf[199];
av2[3]=lf[200];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* scheme#scheme-report-environment in k11436 */
static void C_ccall f_12539(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12539,c,av);}
/* library.scm:742: ##sys#error */
t3=*((C_word*)lf[195]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[202];
av2[3]=lf[203];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* scheme#null-environment in k11436 */
static void C_ccall f_12545(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12545,c,av);}
/* library.scm:745: ##sys#error */
t2=*((C_word*)lf[195]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=lf[205];
av2[3]=lf[206];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* scheme#load in k11436 */
static void C_ccall f_12551(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12551,c,av);}
/* library.scm:748: ##sys#error */
t3=*((C_word*)lf[195]+1);{
C_word av2[4];
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[208];
av2[3]=lf[209];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k12559 in k11436 */
static void C_ccall f_12561(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word t51;
C_word t52;
C_word t53;
C_word t54;
C_word t55;
C_word t56;
C_word t57;
C_word t58;
C_word t59;
C_word t60;
C_word t61;
C_word t62;
C_word t63;
C_word t64;
C_word t65;
C_word t66;
C_word t67;
C_word t68;
C_word t69;
C_word t70;
C_word t71;
C_word t72;
C_word t73;
C_word t74;
C_word t75;
C_word t76;
C_word t77;
C_word t78;
C_word t79;
C_word t80;
C_word t81;
C_word t82;
C_word t83;
C_word t84;
C_word t85;
C_word t86;
C_word t87;
C_word t88;
C_word t89;
C_word t90;
C_word t91;
C_word t92;
C_word t93;
C_word t94;
C_word t95;
C_word t96;
C_word t97;
C_word t98;
C_word t99;
C_word t100;
C_word t101;
C_word t102;
C_word t103;
C_word t104;
C_word t105;
C_word t106;
C_word t107;
C_word t108;
C_word t109;
C_word t110;
C_word t111;
C_word t112;
C_word t113;
C_word t114;
C_word t115;
C_word t116;
C_word t117;
C_word t118;
C_word t119;
C_word t120;
C_word t121;
C_word t122;
C_word t123;
C_word t124;
C_word t125;
C_word t126;
C_word t127;
C_word t128;
C_word t129;
C_word t130;
C_word t131;
C_word t132;
C_word t133;
C_word t134;
C_word t135;
C_word t136;
C_word t137;
C_word t138;
C_word t139;
C_word t140;
C_word t141;
C_word t142;
C_word t143;
C_word t144;
C_word t145;
C_word t146;
C_word t147;
C_word t148;
C_word t149;
C_word t150;
C_word t151;
C_word t152;
C_word t153;
C_word t154;
C_word t155;
C_word t156;
C_word t157;
C_word t158;
C_word t159;
C_word t160;
C_word t161;
C_word t162;
C_word t163;
C_word t164;
C_word t165;
C_word t166;
C_word t167;
C_word t168;
C_word t169;
C_word t170;
C_word t171;
C_word t172;
C_word t173;
C_word t174;
C_word t175;
C_word t176;
C_word t177;
C_word t178;
C_word t179;
C_word t180;
C_word t181;
C_word t182;
C_word t183;
C_word t184;
C_word t185;
C_word t186;
C_word t187;
C_word t188;
C_word t189;
C_word t190;
C_word t191;
C_word t192;
C_word t193;
C_word t194;
C_word t195;
C_word t196;
C_word t197;
C_word t198;
C_word t199;
C_word t200;
C_word t201;
C_word t202;
C_word t203;
C_word t204;
C_word t205;
C_word t206;
C_word t207;
C_word t208;
C_word t209;
C_word t210;
C_word t211;
C_word t212;
C_word t213;
C_word t214;
C_word t215;
C_word t216;
C_word t217;
C_word t218;
C_word t219;
C_word t220;
C_word t221;
C_word t222;
C_word t223;
C_word t224;
C_word t225;
C_word t226;
C_word t227;
C_word t228;
C_word t229;
C_word t230;
C_word t231;
C_word t232;
C_word t233;
C_word t234;
C_word t235;
C_word t236;
C_word t237;
C_word t238;
C_word t239;
C_word t240;
C_word t241;
C_word t242;
C_word t243;
C_word t244;
C_word t245;
C_word t246;
C_word t247;
C_word t248;
C_word t249;
C_word t250;
C_word t251;
C_word t252;
C_word t253;
C_word t254;
C_word t255;
C_word t256;
C_word t257;
C_word t258;
C_word t259;
C_word t260;
C_word t261;
C_word t262;
C_word t263;
C_word t264;
C_word t265;
C_word t266;
C_word t267;
C_word t268;
C_word t269;
C_word t270;
C_word t271;
C_word t272;
C_word t273;
C_word t274;
C_word t275;
C_word t276;
C_word t277;
C_word t278;
C_word t279;
C_word t280;
C_word t281;
C_word t282;
C_word t283;
C_word t284;
C_word t285;
C_word t286;
C_word t287;
C_word t288;
C_word t289;
C_word t290;
C_word t291;
C_word t292;
C_word t293;
C_word t294;
C_word t295;
C_word t296;
C_word t297;
C_word t298;
C_word t299;
C_word t300;
C_word t301;
C_word t302;
C_word t303;
C_word t304;
C_word t305;
C_word t306;
C_word t307;
C_word t308;
C_word t309;
C_word t310;
C_word t311;
C_word t312;
C_word t313;
C_word t314;
C_word t315;
C_word t316;
C_word t317;
C_word t318;
C_word t319;
C_word t320;
C_word t321;
C_word t322;
C_word t323;
C_word t324;
C_word t325;
C_word t326;
C_word t327;
C_word t328;
C_word t329;
C_word t330;
C_word t331;
C_word t332;
C_word t333;
C_word t334;
C_word t335;
C_word t336;
C_word t337;
C_word t338;
C_word t339;
C_word t340;
C_word t341;
C_word t342;
C_word t343;
C_word t344;
C_word t345;
C_word t346;
C_word t347;
C_word t348;
C_word t349;
C_word t350;
C_word t351;
C_word t352;
C_word t353;
C_word t354;
C_word t355;
C_word t356;
C_word t357;
C_word t358;
C_word t359;
C_word t360;
C_word t361;
C_word t362;
C_word t363;
C_word t364;
C_word t365;
C_word t366;
C_word t367;
C_word t368;
C_word t369;
C_word t370;
C_word t371;
C_word t372;
C_word t373;
C_word t374;
C_word t375;
C_word t376;
C_word t377;
C_word t378;
C_word t379;
C_word t380;
C_word t381;
C_word t382;
C_word t383;
C_word t384;
C_word t385;
C_word t386;
C_word t387;
C_word t388;
C_word t389;
C_word t390;
C_word t391;
C_word t392;
C_word t393;
C_word t394;
C_word t395;
C_word t396;
C_word t397;
C_word t398;
C_word t399;
C_word t400;
C_word t401;
C_word t402;
C_word t403;
C_word t404;
C_word t405;
C_word t406;
C_word t407;
C_word t408;
C_word t409;
C_word t410;
C_word t411;
C_word t412;
C_word t413;
C_word t414;
C_word t415;
C_word t416;
C_word t417;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(1142,c,7)))){
C_save_and_reclaim((void *)f_12561,c,av);}
a=C_alloc(1142);
t2=C_a_i_provide(&a,1,lf[213]);
t3=C_mutate((C_word*)lf[214]+1 /* (set! chicken.base#fixnum? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12563,a[2]=((C_word)li135),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[215]+1 /* (set! chicken.base#flonum? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12566,a[2]=((C_word)li136),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[216]+1 /* (set! chicken.base#bignum? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12569,a[2]=((C_word)li137),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[217]+1 /* (set! chicken.base#ratnum? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12572,a[2]=((C_word)li138),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[218]+1 /* (set! chicken.base#cplxnum? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12575,a[2]=((C_word)li139),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[219]+1 /* (set! chicken.base#exact-integer? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12578,a[2]=((C_word)li140),tmp=(C_word)a,a+=3,tmp));
t9=C_set_block_item(lf[220] /* chicken.base#exact-integer-sqrt */,0,C_SCHEME_UNDEFINED);
t10=C_mutate((C_word*)lf[221]+1 /* (set! chicken.base#quotient&remainder ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_quotient_and_remainder,a[2]=((C_word)li141),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[222]+1 /* (set! chicken.base#quotient&modulo ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12583,a[2]=((C_word)li144),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate((C_word*)lf[223]+1 /* (set! chicken.base#finite? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12630,a[2]=((C_word)li145),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate((C_word*)lf[224]+1 /* (set! chicken.base#infinite? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12633,a[2]=((C_word)li146),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate((C_word*)lf[225]+1 /* (set! chicken.base#nan? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12636,a[2]=((C_word)li147),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate((C_word*)lf[226]+1 /* (set! chicken.base#signum ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_signum,a[2]=((C_word)li148),tmp=(C_word)a,a+=3,tmp));
t16=C_set_block_item(lf[227] /* chicken.base#get-call-chain */,0,C_SCHEME_UNDEFINED);
t17=C_set_block_item(lf[228] /* chicken.base#print-call-chain */,0,C_SCHEME_UNDEFINED);
t18=C_set_block_item(lf[229] /* chicken.base#print */,0,C_SCHEME_UNDEFINED);
t19=C_set_block_item(lf[230] /* chicken.base#print* */,0,C_SCHEME_UNDEFINED);
t20=C_mutate((C_word*)lf[231]+1 /* (set! chicken.base#add1 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12644,a[2]=((C_word)li149),tmp=(C_word)a,a+=3,tmp));
t21=C_mutate((C_word*)lf[232]+1 /* (set! chicken.base#sub1 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12650,a[2]=((C_word)li150),tmp=(C_word)a,a+=3,tmp));
t22=C_set_block_item(lf[233] /* chicken.base#current-error-port */,0,C_SCHEME_UNDEFINED);
t23=C_mutate((C_word*)lf[234]+1 /* (set! chicken.base#error ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12657,a[2]=((C_word)li151),tmp=(C_word)a,a+=3,tmp));
t24=C_mutate((C_word*)lf[237]+1 /* (set! chicken.base#void ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12672,a[2]=((C_word)li152),tmp=(C_word)a,a+=3,tmp));
t25=C_set_block_item(lf[238] /* chicken.base#sleep */,0,C_SCHEME_UNDEFINED);
t26=C_set_block_item(lf[239] /* chicken.base#char-name */,0,C_SCHEME_UNDEFINED);
t27=C_set_block_item(lf[240] /* chicken.base#getter-with-setter */,0,C_SCHEME_UNDEFINED);
t28=C_set_block_item(lf[241] /* chicken.base#procedure-information */,0,C_SCHEME_UNDEFINED);
t29=C_set_block_item(lf[242] /* chicken.base#setter */,0,C_SCHEME_UNDEFINED);
t30=C_set_block_item(lf[243] /* chicken.base#record-printer */,0,C_SCHEME_UNDEFINED);
t31=C_set_block_item(lf[244] /* chicken.base#set-record-printer! */,0,C_SCHEME_UNDEFINED);
t32=C_set_block_item(lf[245] /* chicken.base#subvector */,0,C_SCHEME_UNDEFINED);
t33=C_set_block_item(lf[246] /* chicken.base#vector-resize */,0,C_SCHEME_UNDEFINED);
t34=C_set_block_item(lf[247] /* chicken.base#port-closed? */,0,C_SCHEME_UNDEFINED);
t35=C_set_block_item(lf[248] /* chicken.base#flush-output */,0,C_SCHEME_UNDEFINED);
t36=C_mutate((C_word*)lf[249]+1 /* (set! chicken.base#promise? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12686,a[2]=((C_word)li153),tmp=(C_word)a,a+=3,tmp));
t37=C_mutate((C_word*)lf[251]+1 /* (set! ##sys#make-promise ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12692,a[2]=((C_word)li154),tmp=(C_word)a,a+=3,tmp));
t38=C_mutate((C_word*)lf[252]+1 /* (set! chicken.base#make-promise ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12698,a[2]=((C_word)li156),tmp=(C_word)a,a+=3,tmp));
t39=C_mutate((C_word*)lf[253]+1 /* (set! chicken.base#foldl ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12713,a[2]=((C_word)li158),tmp=(C_word)a,a+=3,tmp));
t40=C_mutate((C_word*)lf[255]+1 /* (set! chicken.base#foldr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12750,a[2]=((C_word)li160),tmp=(C_word)a,a+=3,tmp));
t41=C_set_block_item(lf[257] /* chicken.base#implicit-exit-handler */,0,C_SCHEME_UNDEFINED);
t42=C_set_block_item(lf[258] /* chicken.base#exit-handler */,0,C_SCHEME_UNDEFINED);
t43=C_set_block_item(lf[259] /* chicken.base#cleanup-tasks */,0,C_SCHEME_END_OF_LIST);
t44=C_mutate((C_word*)lf[260]+1 /* (set! chicken.base#on-exit ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12790,a[2]=((C_word)li161),tmp=(C_word)a,a+=3,tmp));
t45=C_mutate((C_word*)lf[261]+1 /* (set! chicken.base#exit ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12797,a[2]=((C_word)li162),tmp=(C_word)a,a+=3,tmp));
t46=C_mutate((C_word*)lf[262]+1 /* (set! chicken.base#emergency-exit ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12815,a[2]=((C_word)li163),tmp=(C_word)a,a+=3,tmp));
t47=C_set_block_item(lf[264] /* chicken.base#case-sensitive */,0,C_SCHEME_UNDEFINED);
t48=C_set_block_item(lf[265] /* chicken.base#keyword-style */,0,C_SCHEME_UNDEFINED);
t49=C_set_block_item(lf[266] /* chicken.base#parentheses-synonyms */,0,C_SCHEME_UNDEFINED);
t50=C_set_block_item(lf[267] /* chicken.base#symbol-escape */,0,C_SCHEME_UNDEFINED);
t51=C_mutate((C_word*)lf[268]+1 /* (set! chicken.base#identity ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12834,a[2]=((C_word)li164),tmp=(C_word)a,a+=3,tmp));
t52=C_mutate((C_word*)lf[269]+1 /* (set! chicken.base#conjoin ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12837,a[2]=((C_word)li167),tmp=(C_word)a,a+=3,tmp));
t53=C_mutate((C_word*)lf[270]+1 /* (set! chicken.base#disjoin ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12870,a[2]=((C_word)li170),tmp=(C_word)a,a+=3,tmp));
t54=C_mutate((C_word*)lf[271]+1 /* (set! chicken.base#constantly ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12907,a[2]=((C_word)li173),tmp=(C_word)a,a+=3,tmp));
t55=C_mutate((C_word*)lf[272]+1 /* (set! chicken.base#flip ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12928,a[2]=((C_word)li175),tmp=(C_word)a,a+=3,tmp));
t56=C_mutate((C_word*)lf[273]+1 /* (set! chicken.base#complement ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12936,a[2]=((C_word)li177),tmp=(C_word)a,a+=3,tmp));
t57=C_mutate((C_word*)lf[274]+1 /* (set! chicken.base#compose ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12948,a[2]=((C_word)li181),tmp=(C_word)a,a+=3,tmp));
t58=C_mutate((C_word*)lf[275]+1 /* (set! chicken.base#o ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12984,a[2]=((C_word)li184),tmp=(C_word)a,a+=3,tmp));
t59=C_mutate((C_word*)lf[276]+1 /* (set! chicken.base#list-of? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13023,a[2]=((C_word)li187),tmp=(C_word)a,a+=3,tmp));
t60=C_mutate((C_word*)lf[277]+1 /* (set! chicken.base#each ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13067,a[2]=((C_word)li191),tmp=(C_word)a,a+=3,tmp));
t61=C_mutate((C_word*)lf[279]+1 /* (set! chicken.base#bwp-object? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13123,a[2]=((C_word)li192),tmp=(C_word)a,a+=3,tmp));
t62=C_mutate((C_word*)lf[280]+1 /* (set! chicken.base#weak-cons ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13126,a[2]=((C_word)li193),tmp=(C_word)a,a+=3,tmp));
t63=C_mutate((C_word*)lf[281]+1 /* (set! chicken.base#weak-pair? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13129,a[2]=((C_word)li194),tmp=(C_word)a,a+=3,tmp));
t64=C_mutate((C_word*)lf[282]+1 /* (set! chicken.base#atom? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13132,a[2]=((C_word)li195),tmp=(C_word)a,a+=3,tmp));
t65=C_mutate((C_word*)lf[283]+1 /* (set! chicken.base#tail? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13135,a[2]=((C_word)li197),tmp=(C_word)a,a+=3,tmp));
t66=C_mutate((C_word*)lf[285]+1 /* (set! chicken.base#intersperse ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13163,a[2]=((C_word)li199),tmp=(C_word)a,a+=3,tmp));
t67=C_mutate((C_word*)lf[286]+1 /* (set! chicken.base#butlast ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13196,a[2]=((C_word)li201),tmp=(C_word)a,a+=3,tmp));
t68=C_mutate((C_word*)lf[288]+1 /* (set! chicken.base#flatten ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13228,a[2]=((C_word)li203),tmp=(C_word)a,a+=3,tmp));
t69=C_mutate((C_word*)lf[289]+1 /* (set! chicken.base#join ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13269,a[2]=((C_word)li205),tmp=(C_word)a,a+=3,tmp));
t70=C_mutate((C_word*)lf[292]+1 /* (set! chicken.base#compress ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13326,a[2]=((C_word)li207),tmp=(C_word)a,a+=3,tmp));
t71=C_mutate((C_word*)lf[296]+1 /* (set! chicken.base#char-foldcase ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13406,a[2]=((C_word)li208),tmp=(C_word)a,a+=3,tmp));
t72=C_mutate((C_word*)lf[298]+1 /* (set! chicken.base#string-foldcase ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13412,a[2]=((C_word)li209),tmp=(C_word)a,a+=3,tmp));
t73=C_mutate((C_word*)lf[302]+1 /* (set! chicken.base#alist-update! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13432,a[2]=((C_word)li212),tmp=(C_word)a,a+=3,tmp));
t74=C_mutate((C_word*)lf[303]+1 /* (set! chicken.base#alist-update ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13518,a[2]=((C_word)li214),tmp=(C_word)a,a+=3,tmp));
t75=C_mutate((C_word*)lf[307]+1 /* (set! chicken.base#alist-ref ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13622,a[2]=((C_word)li217),tmp=(C_word)a,a+=3,tmp));
t76=C_mutate((C_word*)lf[310]+1 /* (set! chicken.base#rassoc ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13734,a[2]=((C_word)li219),tmp=(C_word)a,a+=3,tmp));
t77=C_mutate((C_word*)lf[312]+1 /* (set! scheme#open-input-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13782,a[2]=((C_word)li220),tmp=(C_word)a,a+=3,tmp));
t78=C_mutate((C_word*)lf[318]+1 /* (set! scheme#open-output-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13810,a[2]=((C_word)li221),tmp=(C_word)a,a+=3,tmp));
t79=C_mutate((C_word*)lf[320]+1 /* (set! scheme#get-output-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13829,a[2]=((C_word)li222),tmp=(C_word)a,a+=3,tmp));
t80=C_mutate((C_word*)lf[323]+1 /* (set! scheme#open-input-bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13863,a[2]=((C_word)li228),tmp=(C_word)a,a+=3,tmp));
t81=C_mutate((C_word*)lf[328]+1 /* (set! scheme#open-output-bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13934,a[2]=((C_word)li234),tmp=(C_word)a,a+=3,tmp));
t82=C_mutate((C_word*)lf[330]+1 /* (set! scheme#get-output-bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14003,a[2]=((C_word)li236),tmp=(C_word)a,a+=3,tmp));
t83=C_unsigned_long_to_num(&a,C_HEADER_SIZE_MASK);
t84=C_mutate(&lf[334] /* (set! maximal-string-length ...) */,C_s_a_u_i_integer_minus(&a,2,t83,C_fix(1)));
t85=C_a_i_provide(&a,1,lf[335]);
t86=C_set_block_item(lf[336] /* chicken.fixnum#most-positive-fixnum */,0,C_fix((C_word)C_MOST_POSITIVE_FIXNUM));
t87=C_set_block_item(lf[337] /* chicken.fixnum#most-negative-fixnum */,0,C_fix((C_word)C_MOST_NEGATIVE_FIXNUM));
t88=C_set_block_item(lf[338] /* chicken.fixnum#fixnum-bits */,0,C_fix((C_word)(C_WORD_SIZE - 1)));
t89=C_set_block_item(lf[339] /* chicken.fixnum#fixnum-precision */,0,C_fix((C_word)(C_WORD_SIZE - (1 + 1))));
t90=C_mutate((C_word*)lf[340]+1 /* (set! chicken.fixnum#fx+ ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14050,a[2]=((C_word)li237),tmp=(C_word)a,a+=3,tmp));
t91=C_mutate((C_word*)lf[341]+1 /* (set! chicken.fixnum#fx- ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14053,a[2]=((C_word)li238),tmp=(C_word)a,a+=3,tmp));
t92=C_mutate((C_word*)lf[342]+1 /* (set! chicken.fixnum#fx* ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14056,a[2]=((C_word)li239),tmp=(C_word)a,a+=3,tmp));
t93=C_mutate((C_word*)lf[343]+1 /* (set! chicken.fixnum#fx= ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14059,a[2]=((C_word)li240),tmp=(C_word)a,a+=3,tmp));
t94=C_mutate((C_word*)lf[344]+1 /* (set! chicken.fixnum#fx> ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14065,a[2]=((C_word)li241),tmp=(C_word)a,a+=3,tmp));
t95=C_mutate((C_word*)lf[345]+1 /* (set! chicken.fixnum#fx< ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14068,a[2]=((C_word)li242),tmp=(C_word)a,a+=3,tmp));
t96=C_mutate((C_word*)lf[346]+1 /* (set! chicken.fixnum#fx>= ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14071,a[2]=((C_word)li243),tmp=(C_word)a,a+=3,tmp));
t97=C_mutate((C_word*)lf[347]+1 /* (set! chicken.fixnum#fx<= ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14074,a[2]=((C_word)li244),tmp=(C_word)a,a+=3,tmp));
t98=C_mutate((C_word*)lf[348]+1 /* (set! chicken.fixnum#fxmin ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14077,a[2]=((C_word)li245),tmp=(C_word)a,a+=3,tmp));
t99=C_mutate((C_word*)lf[349]+1 /* (set! chicken.fixnum#fxmax ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14080,a[2]=((C_word)li246),tmp=(C_word)a,a+=3,tmp));
t100=C_mutate((C_word*)lf[350]+1 /* (set! chicken.fixnum#fxneg ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14083,a[2]=((C_word)li247),tmp=(C_word)a,a+=3,tmp));
t101=C_mutate((C_word*)lf[351]+1 /* (set! chicken.fixnum#fxand ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14086,a[2]=((C_word)li248),tmp=(C_word)a,a+=3,tmp));
t102=C_mutate((C_word*)lf[352]+1 /* (set! chicken.fixnum#fxior ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14089,a[2]=((C_word)li249),tmp=(C_word)a,a+=3,tmp));
t103=C_mutate((C_word*)lf[353]+1 /* (set! chicken.fixnum#fxxor ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14092,a[2]=((C_word)li250),tmp=(C_word)a,a+=3,tmp));
t104=C_mutate((C_word*)lf[354]+1 /* (set! chicken.fixnum#fxnot ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14095,a[2]=((C_word)li251),tmp=(C_word)a,a+=3,tmp));
t105=C_mutate((C_word*)lf[355]+1 /* (set! chicken.fixnum#fxshl ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14098,a[2]=((C_word)li252),tmp=(C_word)a,a+=3,tmp));
t106=C_mutate((C_word*)lf[356]+1 /* (set! chicken.fixnum#fxshr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14101,a[2]=((C_word)li253),tmp=(C_word)a,a+=3,tmp));
t107=C_mutate((C_word*)lf[357]+1 /* (set! chicken.fixnum#fxodd? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14104,a[2]=((C_word)li254),tmp=(C_word)a,a+=3,tmp));
t108=C_mutate((C_word*)lf[358]+1 /* (set! chicken.fixnum#fxeven? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14107,a[2]=((C_word)li255),tmp=(C_word)a,a+=3,tmp));
t109=C_mutate((C_word*)lf[359]+1 /* (set! chicken.fixnum#fxlen ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14110,a[2]=((C_word)li256),tmp=(C_word)a,a+=3,tmp));
t110=C_mutate((C_word*)lf[360]+1 /* (set! chicken.fixnum#fx/ ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14113,a[2]=((C_word)li257),tmp=(C_word)a,a+=3,tmp));
t111=C_mutate((C_word*)lf[361]+1 /* (set! chicken.fixnum#fxgcd ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14116,a[2]=((C_word)li258),tmp=(C_word)a,a+=3,tmp));
t112=C_mutate((C_word*)lf[362]+1 /* (set! chicken.fixnum#fxmod ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14119,a[2]=((C_word)li259),tmp=(C_word)a,a+=3,tmp));
t113=C_mutate((C_word*)lf[363]+1 /* (set! chicken.fixnum#fxrem ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14122,a[2]=((C_word)li260),tmp=(C_word)a,a+=3,tmp));
t114=C_mutate((C_word*)lf[364]+1 /* (set! chicken.fixnum#fx+? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14125,a[2]=((C_word)li261),tmp=(C_word)a,a+=3,tmp));
t115=C_mutate((C_word*)lf[365]+1 /* (set! chicken.fixnum#fx-? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14128,a[2]=((C_word)li262),tmp=(C_word)a,a+=3,tmp));
t116=C_mutate((C_word*)lf[366]+1 /* (set! chicken.fixnum#fx*? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14131,a[2]=((C_word)li263),tmp=(C_word)a,a+=3,tmp));
t117=C_mutate((C_word*)lf[367]+1 /* (set! chicken.fixnum#fx/? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14134,a[2]=((C_word)li264),tmp=(C_word)a,a+=3,tmp));
t118=C_mutate((C_word*)lf[368]+1 /* (set! ##sys#debug-mode? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14137,a[2]=((C_word)li265),tmp=(C_word)a,a+=3,tmp));
t119=C_set_block_item(lf[369] /* ##sys#warnings-enabled */,0,C_SCHEME_TRUE);
t120=C_set_block_item(lf[370] /* ##sys#notices-enabled */,0,C_i_debug_modep());
t121=C_mutate((C_word*)lf[371]+1 /* (set! chicken.base#warning ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14142,a[2]=((C_word)li266),tmp=(C_word)a,a+=3,tmp));
t122=C_mutate((C_word*)lf[373]+1 /* (set! chicken.base#notice ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14151,a[2]=((C_word)li267),tmp=(C_word)a,a+=3,tmp));
t123=C_mutate((C_word*)lf[375]+1 /* (set! chicken.base#enable-warnings ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14163,a[2]=((C_word)li268),tmp=(C_word)a,a+=3,tmp));
t124=C_mutate((C_word*)lf[195]+1 /* (set! ##sys#error ...) */,*((C_word*)lf[234]+1));
t125=C_mutate((C_word*)lf[376]+1 /* (set! ##sys#warn ...) */,*((C_word*)lf[371]+1));
t126=C_mutate((C_word*)lf[377]+1 /* (set! ##sys#notice ...) */,*((C_word*)lf[373]+1));
t127=C_mutate((C_word*)lf[378]+1 /* (set! ##sys#error/errno ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14177,a[2]=((C_word)li269),tmp=(C_word)a,a+=3,tmp));
t128=C_mutate((C_word*)lf[380]+1 /* (set! ##sys#gc ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_gc,a[2]=((C_word)li270),tmp=(C_word)a,a+=3,tmp));
t129=C_mutate((C_word*)lf[381]+1 /* (set! ##sys#setslot ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14193,a[2]=((C_word)li271),tmp=(C_word)a,a+=3,tmp));
t130=C_mutate((C_word*)lf[382]+1 /* (set! ##sys#setislot ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14196,a[2]=((C_word)li272),tmp=(C_word)a,a+=3,tmp));
t131=C_mutate((C_word*)lf[383]+1 /* (set! ##sys#allocate-vector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_allocate_vector,a[2]=((C_word)li273),tmp=(C_word)a,a+=3,tmp));
t132=C_mutate((C_word*)lf[384]+1 /* (set! ##sys#allocate-bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_allocate_bytevector,a[2]=((C_word)li274),tmp=(C_word)a,a+=3,tmp));
t133=C_mutate((C_word*)lf[385]+1 /* (set! ##sys#make-structure ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_make_structure,a[2]=((C_word)li275),tmp=(C_word)a,a+=3,tmp));
t134=C_mutate((C_word*)lf[386]+1 /* (set! ##sys#ensure-heap-reserve ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_ensure_heap_reserve,a[2]=((C_word)li276),tmp=(C_word)a,a+=3,tmp));
t135=C_mutate((C_word*)lf[387]+1 /* (set! ##sys#symbol-table-info ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_get_symbol_table_info,a[2]=((C_word)li277),tmp=(C_word)a,a+=3,tmp));
t136=C_mutate((C_word*)lf[388]+1 /* (set! ##sys#memory-info ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_get_memory_info,a[2]=((C_word)li278),tmp=(C_word)a,a+=3,tmp));
t137=C_mutate((C_word*)lf[389]+1 /* (set! ##sys#start-timer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14205,a[2]=((C_word)li279),tmp=(C_word)a,a+=3,tmp));
t138=C_mutate((C_word*)lf[390]+1 /* (set! ##sys#stop-timer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14211,a[2]=((C_word)li282),tmp=(C_word)a,a+=3,tmp));
t139=C_mutate((C_word*)lf[391]+1 /* (set! ##sys#immediate? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14231,a[2]=((C_word)li283),tmp=(C_word)a,a+=3,tmp));
t140=C_mutate((C_word*)lf[392]+1 /* (set! ##sys#message ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14238,a[2]=((C_word)li284),tmp=(C_word)a,a+=3,tmp));
t141=C_mutate((C_word*)lf[393]+1 /* (set! ##sys#byte ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14241,a[2]=((C_word)li285),tmp=(C_word)a,a+=3,tmp));
t142=C_mutate((C_word*)lf[394]+1 /* (set! ##sys#void ...) */,*((C_word*)lf[237]+1));
t143=C_set_block_item(lf[278] /* ##sys#undefined-value */,0,C_SCHEME_UNDEFINED);
t144=C_mutate((C_word*)lf[395]+1 /* (set! ##sys#halt ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14246,a[2]=((C_word)li286),tmp=(C_word)a,a+=3,tmp));
t145=C_mutate((C_word*)lf[396]+1 /* (set! ##sys#become! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_become,a[2]=((C_word)li287),tmp=(C_word)a,a+=3,tmp));
t146=C_mutate((C_word*)lf[397]+1 /* (set! ##sys#block-ref ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14250,a[2]=((C_word)li288),tmp=(C_word)a,a+=3,tmp));
t147=C_mutate((C_word*)lf[398]+1 /* (set! ##sys#apply-values ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_apply_values,a[2]=((C_word)li289),tmp=(C_word)a,a+=3,tmp));
t148=C_mutate((C_word*)lf[399]+1 /* (set! ##sys#copy-closure ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_copy_closure,a[2]=((C_word)li290),tmp=(C_word)a,a+=3,tmp));
t149=C_mutate((C_word*)lf[400]+1 /* (set! ##sys#block-set! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14255,a[2]=((C_word)li291),tmp=(C_word)a,a+=3,tmp));
t150=C_a_i_provide(&a,1,lf[402]);
t151=C_mutate((C_word*)lf[403]+1 /* (set! chicken.time#current-process-milliseconds ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14290,a[2]=((C_word)li292),tmp=(C_word)a,a+=3,tmp));
t152=C_mutate((C_word*)lf[404]+1 /* (set! chicken.time#current-seconds ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14293,a[2]=((C_word)li293),tmp=(C_word)a,a+=3,tmp));
t153=C_mutate((C_word*)lf[405]+1 /* (set! chicken.time#cpu-time ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14296,a[2]=((C_word)li294),tmp=(C_word)a,a+=3,tmp));
t154=C_mutate((C_word*)lf[406]+1 /* (set! ##sys#check-structure ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14313,a[2]=((C_word)li295),tmp=(C_word)a,a+=3,tmp));
t155=C_mutate((C_word*)lf[407]+1 /* (set! ##sys#check-blob ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14324,a[2]=((C_word)li296),tmp=(C_word)a,a+=3,tmp));
t156=C_mutate((C_word*)lf[408]+1 /* (set! ##sys#check-pair ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14335,a[2]=((C_word)li297),tmp=(C_word)a,a+=3,tmp));
t157=C_mutate((C_word*)lf[409]+1 /* (set! ##sys#check-list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14346,a[2]=((C_word)li298),tmp=(C_word)a,a+=3,tmp));
t158=C_mutate((C_word*)lf[410]+1 /* (set! ##sys#check-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14357,a[2]=((C_word)li299),tmp=(C_word)a,a+=3,tmp));
t159=C_mutate((C_word*)lf[411]+1 /* (set! ##sys#check-number ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14368,a[2]=((C_word)li300),tmp=(C_word)a,a+=3,tmp));
t160=C_mutate((C_word*)lf[412]+1 /* (set! ##sys#check-fixnum ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14379,a[2]=((C_word)li301),tmp=(C_word)a,a+=3,tmp));
t161=C_mutate((C_word*)lf[413]+1 /* (set! ##sys#check-bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14390,a[2]=((C_word)li302),tmp=(C_word)a,a+=3,tmp));
t162=C_mutate((C_word*)lf[414]+1 /* (set! ##sys#check-exact ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14401,a[2]=((C_word)li303),tmp=(C_word)a,a+=3,tmp));
t163=C_mutate((C_word*)lf[415]+1 /* (set! ##sys#check-inexact ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14412,a[2]=((C_word)li304),tmp=(C_word)a,a+=3,tmp));
t164=C_mutate((C_word*)lf[416]+1 /* (set! ##sys#check-symbol ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14423,a[2]=((C_word)li305),tmp=(C_word)a,a+=3,tmp));
t165=C_mutate((C_word*)lf[417]+1 /* (set! ##sys#check-keyword ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14434,a[2]=((C_word)li306),tmp=(C_word)a,a+=3,tmp));
t166=C_mutate((C_word*)lf[418]+1 /* (set! ##sys#check-vector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14445,a[2]=((C_word)li307),tmp=(C_word)a,a+=3,tmp));
t167=C_mutate((C_word*)lf[419]+1 /* (set! ##sys#check-char ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14456,a[2]=((C_word)li308),tmp=(C_word)a,a+=3,tmp));
t168=C_mutate((C_word*)lf[420]+1 /* (set! ##sys#check-boolean ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14467,a[2]=((C_word)li309),tmp=(C_word)a,a+=3,tmp));
t169=C_mutate((C_word*)lf[421]+1 /* (set! ##sys#check-locative ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14478,a[2]=((C_word)li310),tmp=(C_word)a,a+=3,tmp));
t170=C_mutate((C_word*)lf[422]+1 /* (set! ##sys#check-integer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14489,a[2]=((C_word)li311),tmp=(C_word)a,a+=3,tmp));
t171=C_mutate((C_word*)lf[424]+1 /* (set! ##sys#check-exact-integer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14506,a[2]=((C_word)li312),tmp=(C_word)a,a+=3,tmp));
t172=C_mutate((C_word*)lf[426]+1 /* (set! ##sys#check-exact-uinteger ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14523,a[2]=((C_word)li313),tmp=(C_word)a,a+=3,tmp));
t173=C_mutate((C_word*)lf[428]+1 /* (set! ##sys#check-real ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14547,a[2]=((C_word)li314),tmp=(C_word)a,a+=3,tmp));
t174=C_mutate((C_word*)lf[430]+1 /* (set! ##sys#check-range ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14564,a[2]=((C_word)li315),tmp=(C_word)a,a+=3,tmp));
t175=C_mutate((C_word*)lf[431]+1 /* (set! ##sys#check-range/including ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14575,a[2]=((C_word)li316),tmp=(C_word)a,a+=3,tmp));
t176=C_mutate((C_word*)lf[432]+1 /* (set! ##sys#check-special ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14586,a[2]=((C_word)li317),tmp=(C_word)a,a+=3,tmp));
t177=C_mutate((C_word*)lf[434]+1 /* (set! ##sys#check-closure ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14606,a[2]=((C_word)li318),tmp=(C_word)a,a+=3,tmp));
t178=C_mutate((C_word*)lf[435]+1 /* (set! scheme#force ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14617,a[2]=((C_word)li320),tmp=(C_word)a,a+=3,tmp));
t179=C_mutate((C_word*)lf[437]+1 /* (set! ##sys#dload ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_dload,a[2]=((C_word)li321),tmp=(C_word)a,a+=3,tmp));
t180=C_mutate((C_word*)lf[438]+1 /* (set! ##sys#set-dlopen-flags! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_set_dlopen_flags,a[2]=((C_word)li322),tmp=(C_word)a,a+=3,tmp));
t181=C_mutate((C_word*)lf[51]+1 /* (set! ##sys#error-not-a-proper-list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14745,a[2]=((C_word)li323),tmp=(C_word)a,a+=3,tmp));
t182=C_mutate((C_word*)lf[440]+1 /* (set! ##sys#error-bad-number ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14761,a[2]=((C_word)li324),tmp=(C_word)a,a+=3,tmp));
t183=C_mutate((C_word*)lf[423]+1 /* (set! ##sys#error-bad-integer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14777,a[2]=((C_word)li325),tmp=(C_word)a,a+=3,tmp));
t184=C_mutate((C_word*)lf[425]+1 /* (set! ##sys#error-bad-exact-integer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14793,a[2]=((C_word)li326),tmp=(C_word)a,a+=3,tmp));
t185=C_mutate((C_word*)lf[427]+1 /* (set! ##sys#error-bad-exact-uinteger ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14809,a[2]=((C_word)li327),tmp=(C_word)a,a+=3,tmp));
t186=C_mutate((C_word*)lf[441]+1 /* (set! ##sys#error-bad-inexact ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14825,a[2]=((C_word)li328),tmp=(C_word)a,a+=3,tmp));
t187=C_mutate((C_word*)lf[429]+1 /* (set! ##sys#error-bad-real ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14841,a[2]=((C_word)li329),tmp=(C_word)a,a+=3,tmp));
t188=C_mutate((C_word*)lf[442]+1 /* (set! ##sys#error-bad-base ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14857,a[2]=((C_word)li330),tmp=(C_word)a,a+=3,tmp));
t189=C_mutate((C_word*)lf[443]+1 /* (set! scheme#append ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14873,a[2]=((C_word)li333),tmp=(C_word)a,a+=3,tmp));
t190=C_mutate((C_word*)lf[445]+1 /* (set! ##sys#fast-reverse ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14952,a[2]=((C_word)li335),tmp=(C_word)a,a+=3,tmp));
t191=C_mutate((C_word*)lf[301]+1 /* (set! ##sys#make-bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14982,a[2]=((C_word)li336),tmp=(C_word)a,a+=3,tmp));
t192=C_mutate((C_word*)lf[446]+1 /* (set! ##sys#make-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14997,a[2]=((C_word)li337),tmp=(C_word)a,a+=3,tmp));
t193=C_mutate((C_word*)lf[300]+1 /* (set! ##sys#buffer->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15019,a[2]=((C_word)li338),tmp=(C_word)a,a+=3,tmp));
t194=C_mutate((C_word*)lf[447]+1 /* (set! ##sys#utf-decoder ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15030,a[2]=((C_word)li339),tmp=(C_word)a,a+=3,tmp));
t195=C_mutate((C_word*)lf[448]+1 /* (set! ##sys#utf-encoder ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15036,a[2]=((C_word)li340),tmp=(C_word)a,a+=3,tmp));
t196=C_mutate((C_word*)lf[449]+1 /* (set! ##sys#utf-scanner ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15042,a[2]=((C_word)li341),tmp=(C_word)a,a+=3,tmp));
t197=C_mutate((C_word*)lf[450]+1 /* (set! ##sys#latin-decoder ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15066,a[2]=((C_word)li342),tmp=(C_word)a,a+=3,tmp));
t198=C_mutate((C_word*)lf[451]+1 /* (set! ##sys#latin-encoder ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15079,a[2]=((C_word)li343),tmp=(C_word)a,a+=3,tmp));
t199=C_mutate((C_word*)lf[452]+1 /* (set! ##sys#latin-scanner ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15092,a[2]=((C_word)li344),tmp=(C_word)a,a+=3,tmp));
t200=C_mutate((C_word*)lf[453]+1 /* (set! ##sys#binary-decoder ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15095,a[2]=((C_word)li345),tmp=(C_word)a,a+=3,tmp));
t201=C_mutate((C_word*)lf[454]+1 /* (set! ##sys#binary-encoder ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15101,a[2]=((C_word)li346),tmp=(C_word)a,a+=3,tmp));
t202=C_mutate((C_word*)lf[455]+1 /* (set! ##sys#binary-scanner ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15107,a[2]=((C_word)li347),tmp=(C_word)a,a+=3,tmp));
t203=C_mutate((C_word*)lf[456]+1 /* (set! ##sys#encoding-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15110,a[2]=((C_word)li348),tmp=(C_word)a,a+=3,tmp));
t204=C_mutate((C_word*)lf[460]+1 /* (set! ##sys#register-encoding ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15149,a[2]=((C_word)li350),tmp=(C_word)a,a+=3,tmp));
t205=C_mutate((C_word*)lf[461]+1 /* (set! ##sys#buffer->string/encoding ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15179,a[2]=((C_word)li352),tmp=(C_word)a,a+=3,tmp));
t206=C_mutate((C_word*)lf[462]+1 /* (set! ##sys#encode-buffer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15191,a[2]=((C_word)li354),tmp=(C_word)a,a+=3,tmp));
t207=C_mutate((C_word*)lf[463]+1 /* (set! ##sys#decode-buffer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15203,a[2]=((C_word)li356),tmp=(C_word)a,a+=3,tmp));
t208=C_mutate((C_word*)lf[464]+1 /* (set! ##sys#encode-char ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15215,a[2]=((C_word)li359),tmp=(C_word)a,a+=3,tmp));
t209=C_mutate((C_word*)lf[465]+1 /* (set! ##sys#decode-char ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15233,a[2]=((C_word)li361),tmp=(C_word)a,a+=3,tmp));
t210=C_mutate((C_word*)lf[466]+1 /* (set! ##sys#read-char/encoding ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15246,a[2]=((C_word)li364),tmp=(C_word)a,a+=3,tmp));
t211=C_mutate((C_word*)lf[470]+1 /* (set! scheme#make-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15310,a[2]=((C_word)li365),tmp=(C_word)a,a+=3,tmp));
t212=C_mutate((C_word*)lf[474]+1 /* (set! scheme#string->list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15341,a[2]=((C_word)li367),tmp=(C_word)a,a+=3,tmp));
t213=C_mutate((C_word*)lf[476]+1 /* (set! ##sys#string->list ...) */,*((C_word*)lf[474]+1));
t214=C_mutate((C_word*)lf[477]+1 /* (set! scheme#list->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15432,a[2]=((C_word)li369),tmp=(C_word)a,a+=3,tmp));
t215=C_mutate((C_word*)lf[479]+1 /* (set! ##sys#list->string ...) */,*((C_word*)lf[477]+1));
t216=C_mutate((C_word*)lf[480]+1 /* (set! ##sys#reverse-list->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15494,a[2]=((C_word)li371),tmp=(C_word)a,a+=3,tmp));
t217=C_mutate((C_word*)lf[482]+1 /* (set! scheme#string-fill! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15545,a[2]=((C_word)li373),tmp=(C_word)a,a+=3,tmp));
t218=C_mutate((C_word*)lf[484]+1 /* (set! scheme#string-copy ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15664,a[2]=((C_word)li374),tmp=(C_word)a,a+=3,tmp));
t219=C_mutate((C_word*)lf[487]+1 /* (set! scheme#string-copy! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15739,a[2]=((C_word)li377),tmp=(C_word)a,a+=3,tmp));
t220=C_mutate((C_word*)lf[486]+1 /* (set! ##sys#substring ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15890,a[2]=((C_word)li378),tmp=(C_word)a,a+=3,tmp));
t221=C_mutate((C_word*)lf[489]+1 /* (set! scheme#substring ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15904,a[2]=((C_word)li379),tmp=(C_word)a,a+=3,tmp));
t222=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15949,a[2]=((C_word)li381),tmp=(C_word)a,a+=3,tmp);
t223=C_mutate((C_word*)lf[491]+1 /* (set! scheme#string<? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16018,a[2]=t222,a[3]=((C_word)li383),tmp=(C_word)a,a+=4,tmp));
t224=C_mutate((C_word*)lf[493]+1 /* (set! scheme#string>? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16042,a[2]=t222,a[3]=((C_word)li385),tmp=(C_word)a,a+=4,tmp));
t225=C_mutate((C_word*)lf[495]+1 /* (set! scheme#string<=? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16066,a[2]=t222,a[3]=((C_word)li387),tmp=(C_word)a,a+=4,tmp));
t226=C_mutate((C_word*)lf[497]+1 /* (set! scheme#string>=? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16087,a[2]=t222,a[3]=((C_word)li389),tmp=(C_word)a,a+=4,tmp));
t227=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16107,a[2]=((C_word)li391),tmp=(C_word)a,a+=3,tmp);
t228=C_mutate((C_word*)lf[499]+1 /* (set! scheme#string-ci<? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16168,a[2]=t227,a[3]=((C_word)li393),tmp=(C_word)a,a+=4,tmp));
t229=C_mutate((C_word*)lf[501]+1 /* (set! scheme#string-ci>? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16192,a[2]=t227,a[3]=((C_word)li395),tmp=(C_word)a,a+=4,tmp));
t230=C_mutate((C_word*)lf[503]+1 /* (set! scheme#string-ci<=? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16216,a[2]=t227,a[3]=((C_word)li397),tmp=(C_word)a,a+=4,tmp));
t231=C_mutate((C_word*)lf[505]+1 /* (set! scheme#string-ci>=? ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16237,a[2]=t227,a[3]=((C_word)li399),tmp=(C_word)a,a+=4,tmp));
t232=C_mutate((C_word*)lf[507]+1 /* (set! ##sys#string-append ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16258,a[2]=((C_word)li400),tmp=(C_word)a,a+=3,tmp));
t233=C_mutate((C_word*)lf[508]+1 /* (set! scheme#string-append ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16304,a[2]=((C_word)li402),tmp=(C_word)a,a+=3,tmp));
t234=C_mutate((C_word*)lf[510]+1 /* (set! scheme#string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16362,a[2]=((C_word)li403),tmp=(C_word)a,a+=3,tmp));
t235=C_mutate((C_word*)lf[511]+1 /* (set! ##sys#char->utf8-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16368,a[2]=((C_word)li404),tmp=(C_word)a,a+=3,tmp));
t236=C_mutate((C_word*)lf[512]+1 /* (set! chicken.base#chop ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16374,a[2]=((C_word)li407),tmp=(C_word)a,a+=3,tmp));
t237=C_a_i_provide(&a,1,lf[515]);
t238=C_mutate((C_word*)lf[516]+1 /* (set! chicken.flonum#maximum-flonum ...) */,C_flonum(&a,DBL_MAX));
t239=C_mutate((C_word*)lf[517]+1 /* (set! chicken.flonum#minimum-flonum ...) */,C_flonum(&a,DBL_MIN));
t240=C_set_block_item(lf[518] /* chicken.flonum#flonum-radix */,0,C_fix((C_word)FLT_RADIX));
t241=C_mutate((C_word*)lf[519]+1 /* (set! chicken.flonum#flonum-epsilon ...) */,C_flonum(&a,DBL_EPSILON));
t242=C_set_block_item(lf[520] /* chicken.flonum#flonum-precision */,0,C_fix((C_word)DBL_MANT_DIG));
t243=C_set_block_item(lf[521] /* chicken.flonum#flonum-decimal-precision */,0,C_fix((C_word)DBL_DIG));
t244=C_set_block_item(lf[522] /* chicken.flonum#flonum-maximum-exponent */,0,C_fix((C_word)DBL_MAX_EXP));
t245=C_set_block_item(lf[523] /* chicken.flonum#flonum-minimum-exponent */,0,C_fix((C_word)DBL_MIN_EXP));
t246=C_set_block_item(lf[524] /* chicken.flonum#flonum-maximum-decimal-exponent */,0,C_fix((C_word)DBL_MAX_10_EXP));
t247=C_set_block_item(lf[525] /* chicken.flonum#flonum-minimum-decimal-exponent */,0,C_fix((C_word)DBL_MIN_10_EXP));
t248=C_mutate((C_word*)lf[526]+1 /* (set! chicken.flonum#fp+ ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16469,a[2]=((C_word)li408),tmp=(C_word)a,a+=3,tmp));
t249=C_mutate((C_word*)lf[528]+1 /* (set! chicken.flonum#fp- ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16493,a[2]=((C_word)li409),tmp=(C_word)a,a+=3,tmp));
t250=C_mutate((C_word*)lf[530]+1 /* (set! chicken.flonum#fp* ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16517,a[2]=((C_word)li410),tmp=(C_word)a,a+=3,tmp));
t251=C_mutate((C_word*)lf[532]+1 /* (set! chicken.flonum#fp/ ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16541,a[2]=((C_word)li411),tmp=(C_word)a,a+=3,tmp));
t252=C_mutate((C_word*)lf[534]+1 /* (set! chicken.flonum#fp*+ ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16565,a[2]=((C_word)li412),tmp=(C_word)a,a+=3,tmp));
t253=C_mutate((C_word*)lf[536]+1 /* (set! chicken.flonum#fpgcd ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16590,a[2]=((C_word)li413),tmp=(C_word)a,a+=3,tmp));
t254=C_mutate((C_word*)lf[538]+1 /* (set! chicken.flonum#fp/? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16614,a[2]=((C_word)li414),tmp=(C_word)a,a+=3,tmp));
t255=C_mutate((C_word*)lf[540]+1 /* (set! chicken.flonum#fp= ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16638,a[2]=((C_word)li415),tmp=(C_word)a,a+=3,tmp));
t256=C_mutate((C_word*)lf[542]+1 /* (set! chicken.flonum#fp> ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16662,a[2]=((C_word)li416),tmp=(C_word)a,a+=3,tmp));
t257=C_mutate((C_word*)lf[544]+1 /* (set! chicken.flonum#fp< ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16686,a[2]=((C_word)li417),tmp=(C_word)a,a+=3,tmp));
t258=C_mutate((C_word*)lf[546]+1 /* (set! chicken.flonum#fp>= ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16710,a[2]=((C_word)li418),tmp=(C_word)a,a+=3,tmp));
t259=C_mutate((C_word*)lf[548]+1 /* (set! chicken.flonum#fp<= ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16734,a[2]=((C_word)li419),tmp=(C_word)a,a+=3,tmp));
t260=C_mutate((C_word*)lf[550]+1 /* (set! chicken.flonum#fpneg ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16758,a[2]=((C_word)li420),tmp=(C_word)a,a+=3,tmp));
t261=C_mutate((C_word*)lf[552]+1 /* (set! chicken.flonum#fpmax ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16776,a[2]=((C_word)li421),tmp=(C_word)a,a+=3,tmp));
t262=C_mutate((C_word*)lf[554]+1 /* (set! chicken.flonum#fpmin ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16800,a[2]=((C_word)li422),tmp=(C_word)a,a+=3,tmp));
t263=C_mutate((C_word*)lf[556]+1 /* (set! chicken.flonum#fpfloor ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16824,a[2]=((C_word)li423),tmp=(C_word)a,a+=3,tmp));
t264=C_mutate((C_word*)lf[558]+1 /* (set! chicken.flonum#fptruncate ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16842,a[2]=((C_word)li424),tmp=(C_word)a,a+=3,tmp));
t265=C_mutate((C_word*)lf[560]+1 /* (set! chicken.flonum#fpround ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16860,a[2]=((C_word)li425),tmp=(C_word)a,a+=3,tmp));
t266=C_mutate((C_word*)lf[562]+1 /* (set! chicken.flonum#fpceiling ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16878,a[2]=((C_word)li426),tmp=(C_word)a,a+=3,tmp));
t267=C_mutate((C_word*)lf[564]+1 /* (set! chicken.flonum#fpsin ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16896,a[2]=((C_word)li427),tmp=(C_word)a,a+=3,tmp));
t268=C_mutate((C_word*)lf[566]+1 /* (set! chicken.flonum#fpcos ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16914,a[2]=((C_word)li428),tmp=(C_word)a,a+=3,tmp));
t269=C_mutate((C_word*)lf[568]+1 /* (set! chicken.flonum#fptan ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16932,a[2]=((C_word)li429),tmp=(C_word)a,a+=3,tmp));
t270=C_mutate((C_word*)lf[570]+1 /* (set! chicken.flonum#fpasin ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16950,a[2]=((C_word)li430),tmp=(C_word)a,a+=3,tmp));
t271=C_mutate((C_word*)lf[572]+1 /* (set! chicken.flonum#fpacos ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16968,a[2]=((C_word)li431),tmp=(C_word)a,a+=3,tmp));
t272=C_mutate((C_word*)lf[574]+1 /* (set! chicken.flonum#fpatan ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16986,a[2]=((C_word)li432),tmp=(C_word)a,a+=3,tmp));
t273=C_mutate((C_word*)lf[576]+1 /* (set! chicken.flonum#fpatan2 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17004,a[2]=((C_word)li433),tmp=(C_word)a,a+=3,tmp));
t274=C_mutate((C_word*)lf[578]+1 /* (set! chicken.flonum#fpsinh ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17028,a[2]=((C_word)li434),tmp=(C_word)a,a+=3,tmp));
t275=C_mutate((C_word*)lf[580]+1 /* (set! chicken.flonum#fpcosh ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17046,a[2]=((C_word)li435),tmp=(C_word)a,a+=3,tmp));
t276=C_mutate((C_word*)lf[582]+1 /* (set! chicken.flonum#fptanh ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17064,a[2]=((C_word)li436),tmp=(C_word)a,a+=3,tmp));
t277=C_mutate((C_word*)lf[584]+1 /* (set! chicken.flonum#fpasinh ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17082,a[2]=((C_word)li437),tmp=(C_word)a,a+=3,tmp));
t278=C_mutate((C_word*)lf[586]+1 /* (set! chicken.flonum#fpacosh ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17100,a[2]=((C_word)li438),tmp=(C_word)a,a+=3,tmp));
t279=C_mutate((C_word*)lf[588]+1 /* (set! chicken.flonum#fpatanh ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17118,a[2]=((C_word)li439),tmp=(C_word)a,a+=3,tmp));
t280=C_mutate((C_word*)lf[590]+1 /* (set! chicken.flonum#fpexp ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17136,a[2]=((C_word)li440),tmp=(C_word)a,a+=3,tmp));
t281=C_mutate((C_word*)lf[592]+1 /* (set! chicken.flonum#fpexpt ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17154,a[2]=((C_word)li441),tmp=(C_word)a,a+=3,tmp));
t282=C_mutate((C_word*)lf[594]+1 /* (set! chicken.flonum#fplog ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17178,a[2]=((C_word)li442),tmp=(C_word)a,a+=3,tmp));
t283=C_mutate((C_word*)lf[596]+1 /* (set! chicken.flonum#fpsqrt ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17196,a[2]=((C_word)li443),tmp=(C_word)a,a+=3,tmp));
t284=C_mutate((C_word*)lf[598]+1 /* (set! chicken.flonum#fpabs ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17214,a[2]=((C_word)li444),tmp=(C_word)a,a+=3,tmp));
t285=C_mutate((C_word*)lf[600]+1 /* (set! chicken.flonum#fpinteger? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17232,a[2]=((C_word)li445),tmp=(C_word)a,a+=3,tmp));
t286=C_mutate((C_word*)lf[602]+1 /* (set! chicken.flonum#flonum-print-precision ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17250,a[2]=((C_word)li446),tmp=(C_word)a,a+=3,tmp));
t287=C_mutate(&lf[604] /* (set! make-complex ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17268,a[2]=((C_word)li447),tmp=(C_word)a,a+=3,tmp));
t288=C_mutate((C_word*)lf[606]+1 /* (set! scheme#make-rectangular ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17304,a[2]=((C_word)li448),tmp=(C_word)a,a+=3,tmp));
t289=C_mutate((C_word*)lf[608]+1 /* (set! scheme#make-polar ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17316,a[2]=((C_word)li449),tmp=(C_word)a,a+=3,tmp));
t290=C_mutate((C_word*)lf[610]+1 /* (set! scheme#real-part ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17339,a[2]=((C_word)li450),tmp=(C_word)a,a+=3,tmp));
t291=C_mutate((C_word*)lf[612]+1 /* (set! scheme#imag-part ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17362,a[2]=((C_word)li451),tmp=(C_word)a,a+=3,tmp));
t292=C_mutate((C_word*)lf[614]+1 /* (set! scheme#angle ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17388,a[2]=((C_word)li452),tmp=(C_word)a,a+=3,tmp));
t293=C_mutate((C_word*)lf[616]+1 /* (set! scheme#magnitude ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17404,a[2]=((C_word)li453),tmp=(C_word)a,a+=3,tmp));
t294=C_mutate(&lf[619] /* (set! ratnum ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17448,a[2]=((C_word)li454),tmp=(C_word)a,a+=3,tmp));
t295=C_mutate((C_word*)lf[620]+1 /* (set! scheme#numerator ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17494,a[2]=((C_word)li455),tmp=(C_word)a,a+=3,tmp));
t296=C_mutate((C_word*)lf[624]+1 /* (set! scheme#denominator ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17540,a[2]=((C_word)li456),tmp=(C_word)a,a+=3,tmp));
t297=C_mutate((C_word*)lf[628]+1 /* (set! ##sys#extended-signum ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17586,a[2]=((C_word)li457),tmp=(C_word)a,a+=3,tmp));
t298=C_mutate((C_word*)lf[622]+1 /* (set! scheme#inexact->exact ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17710,a[2]=((C_word)li460),tmp=(C_word)a,a+=3,tmp));
t299=C_a_i_provide(&a,1,lf[635]);
t300=C_mutate((C_word*)lf[636]+1 /* (set! chicken.bitwise#bitwise-and ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_bitwise_and,a[2]=((C_word)li461),tmp=(C_word)a,a+=3,tmp));
t301=C_mutate((C_word*)lf[637]+1 /* (set! chicken.bitwise#bitwise-ior ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_bitwise_ior,a[2]=((C_word)li462),tmp=(C_word)a,a+=3,tmp));
t302=C_mutate((C_word*)lf[638]+1 /* (set! chicken.bitwise#bitwise-xor ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_bitwise_xor,a[2]=((C_word)li463),tmp=(C_word)a,a+=3,tmp));
t303=C_mutate((C_word*)lf[639]+1 /* (set! chicken.bitwise#bitwise-not ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17774,a[2]=((C_word)li464),tmp=(C_word)a,a+=3,tmp));
t304=C_mutate((C_word*)lf[640]+1 /* (set! chicken.bitwise#bit->boolean ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17777,a[2]=((C_word)li465),tmp=(C_word)a,a+=3,tmp));
t305=C_mutate((C_word*)lf[641]+1 /* (set! chicken.bitwise#integer-length ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17780,a[2]=((C_word)li466),tmp=(C_word)a,a+=3,tmp));
t306=C_mutate((C_word*)lf[642]+1 /* (set! chicken.bitwise#arithmetic-shift ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17783,a[2]=((C_word)li467),tmp=(C_word)a,a+=3,tmp));
t307=C_mutate((C_word*)lf[643]+1 /* (set! scheme#/ ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17786,a[2]=((C_word)li469),tmp=(C_word)a,a+=3,tmp));
t308=C_mutate((C_word*)lf[630]+1 /* (set! ##sys#/-2 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17837,a[2]=((C_word)li470),tmp=(C_word)a,a+=3,tmp));
t309=C_mutate((C_word*)lf[646]+1 /* (set! scheme#floor ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18120,a[2]=((C_word)li471),tmp=(C_word)a,a+=3,tmp));
t310=C_mutate((C_word*)lf[648]+1 /* (set! scheme#ceiling ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18165,a[2]=((C_word)li472),tmp=(C_word)a,a+=3,tmp));
t311=C_mutate((C_word*)lf[650]+1 /* (set! scheme#truncate ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18210,a[2]=((C_word)li473),tmp=(C_word)a,a+=3,tmp));
t312=C_mutate((C_word*)lf[652]+1 /* (set! scheme#round ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18247,a[2]=((C_word)li474),tmp=(C_word)a,a+=3,tmp));
t313=C_mutate(&lf[654] /* (set! find-ratio-between ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18291,a[2]=((C_word)li476),tmp=(C_word)a,a+=3,tmp));
t314=C_mutate((C_word*)lf[656]+1 /* (set! scheme#rationalize ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18441,a[2]=((C_word)li477),tmp=(C_word)a,a+=3,tmp));
t315=C_mutate((C_word*)lf[657]+1 /* (set! scheme#max ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18466,a[2]=((C_word)li479),tmp=(C_word)a,a+=3,tmp));
t316=C_mutate((C_word*)lf[325]+1 /* (set! scheme#min ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18510,a[2]=((C_word)li481),tmp=(C_word)a,a+=3,tmp));
t317=C_mutate((C_word*)lf[660]+1 /* (set! scheme#exp ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18554,a[2]=((C_word)li482),tmp=(C_word)a,a+=3,tmp));
t318=C_mutate((C_word*)lf[662]+1 /* (set! ##sys#log-1 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18599,a[2]=((C_word)li483),tmp=(C_word)a,a+=3,tmp));
t319=C_mutate((C_word*)lf[666]+1 /* (set! scheme#log ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18648,a[2]=((C_word)li484),tmp=(C_word)a,a+=3,tmp));
t320=C_mutate((C_word*)lf[667]+1 /* (set! scheme#sin ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18677,a[2]=((C_word)li485),tmp=(C_word)a,a+=3,tmp));
t321=C_mutate((C_word*)lf[671]+1 /* (set! scheme#cos ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18711,a[2]=((C_word)li486),tmp=(C_word)a,a+=3,tmp));
t322=C_mutate((C_word*)lf[673]+1 /* (set! scheme#tan ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18745,a[2]=((C_word)li487),tmp=(C_word)a,a+=3,tmp));
t323=C_mutate((C_word*)lf[675]+1 /* (set! scheme#asin ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18770,a[2]=((C_word)li488),tmp=(C_word)a,a+=3,tmp));
t324=C_a_i_asin(&a,1,C_fix(1));
t325=C_mutate((C_word*)lf[680]+1 /* (set! scheme#acos ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18832,a[2]=t324,a[3]=((C_word)li489),tmp=(C_word)a,a+=4,tmp));
t326=C_mutate((C_word*)lf[682]+1 /* (set! scheme#atan ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18874,a[2]=((C_word)li490),tmp=(C_word)a,a+=3,tmp));
t327=C_mutate((C_word*)lf[684]+1 /* (set! ##sys#exact-integer-sqrt ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18938,a[2]=((C_word)li496),tmp=(C_word)a,a+=3,tmp));
t328=C_mutate((C_word*)lf[686]+1 /* (set! scheme#exact-integer-sqrt ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19129,a[2]=((C_word)li497),tmp=(C_word)a,a+=3,tmp));
t329=C_mutate((C_word*)lf[678]+1 /* (set! ##sys#sqrt/loc ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19138,a[2]=((C_word)li504),tmp=(C_word)a,a+=3,tmp));
t330=C_mutate((C_word*)lf[617]+1 /* (set! scheme#sqrt ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19293,a[2]=((C_word)li505),tmp=(C_word)a,a+=3,tmp));
t331=C_mutate((C_word*)lf[689]+1 /* (set! scheme#truncate/ ...) */,*((C_word*)lf[221]+1));
t332=C_mutate((C_word*)lf[690]+1 /* (set! scheme#floor/ ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19300,a[2]=((C_word)li508),tmp=(C_word)a,a+=3,tmp));
t333=C_mutate((C_word*)lf[691]+1 /* (set! scheme#floor-remainder ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19355,a[2]=((C_word)li511),tmp=(C_word)a,a+=3,tmp));
t334=C_mutate((C_word*)lf[692]+1 /* (set! scheme#floor-quotient ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19370,a[2]=((C_word)li514),tmp=(C_word)a,a+=3,tmp));
t335=C_mutate((C_word*)lf[693]+1 /* (set! scheme#square ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19385,a[2]=((C_word)li515),tmp=(C_word)a,a+=3,tmp));
t336=C_mutate((C_word*)lf[694]+1 /* (set! chicken.base#exact-integer-nth-root ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19391,a[2]=((C_word)li516),tmp=(C_word)a,a+=3,tmp));
t337=C_mutate((C_word*)lf[695]+1 /* (set! ##sys#exact-integer-nth-root/loc ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19403,a[2]=((C_word)li518),tmp=(C_word)a,a+=3,tmp));
t338=C_mutate((C_word*)lf[632]+1 /* (set! ##sys#integer-power ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19529,a[2]=((C_word)li520),tmp=(C_word)a,a+=3,tmp));
t339=C_mutate((C_word*)lf[634]+1 /* (set! scheme#expt ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19597,a[2]=((C_word)li525),tmp=(C_word)a,a+=3,tmp));
t340=C_mutate(&lf[644] /* (set! ##sys#internal-gcd ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19864,a[2]=((C_word)li526),tmp=(C_word)a,a+=3,tmp));
t341=C_mutate((C_word*)lf[699]+1 /* (set! ##sys#gcd ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19934,a[2]=((C_word)li527),tmp=(C_word)a,a+=3,tmp));
t342=C_mutate((C_word*)lf[701]+1 /* (set! scheme#gcd ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19940,a[2]=((C_word)li529),tmp=(C_word)a,a+=3,tmp));
t343=C_mutate((C_word*)lf[702]+1 /* (set! ##sys#lcm ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19991,a[2]=((C_word)li530),tmp=(C_word)a,a+=3,tmp));
t344=C_mutate((C_word*)lf[704]+1 /* (set! scheme#lcm ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_20005,a[2]=((C_word)li532),tmp=(C_word)a,a+=3,tmp));
t345=C_mutate((C_word*)lf[705]+1 /* (set! ##sys#integer->string/recursive ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_20063,a[2]=((C_word)li536),tmp=(C_word)a,a+=3,tmp));
t346=C_mutate((C_word*)lf[707]+1 /* (set! ##sys#extended-number->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_20113,a[2]=((C_word)li537),tmp=(C_word)a,a+=3,tmp));
t347=C_mutate(&lf[713] /* (set! round-quotient ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_20287,a[2]=((C_word)li538),tmp=(C_word)a,a+=3,tmp));
t348=C_mutate(&lf[714] /* (set! ##sys#string->compnum ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_20330,a[2]=((C_word)li550),tmp=(C_word)a,a+=3,tmp));
t349=C_mutate((C_word*)lf[723]+1 /* (set! scheme#string->number ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_21713,a[2]=((C_word)li552),tmp=(C_word)a,a+=3,tmp));
t350=C_mutate((C_word*)lf[725]+1 /* (set! ##sys#string->number ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_21962,a[2]=((C_word)li553),tmp=(C_word)a,a+=3,tmp));
t351=C_mutate((C_word*)lf[726]+1 /* (set! ##sys#fixnum->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_fixnum_to_string,a[2]=((C_word)li554),tmp=(C_word)a,a+=3,tmp));
t352=C_mutate((C_word*)lf[727]+1 /* (set! ##sys#flonum->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_flonum_to_string,a[2]=((C_word)li555),tmp=(C_word)a,a+=3,tmp));
t353=C_mutate((C_word*)lf[728]+1 /* (set! ##sys#integer->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_integer_to_string,a[2]=((C_word)li556),tmp=(C_word)a,a+=3,tmp));
t354=C_mutate((C_word*)lf[706]+1 /* (set! ##sys#number->string ...) */,*((C_word*)lf[111]+1));
t355=C_mutate((C_word*)lf[729]+1 /* (set! chicken.base#equal=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22008,a[2]=((C_word)li560),tmp=(C_word)a,a+=3,tmp));
t356=C_mutate((C_word*)lf[730]+1 /* (set! ##sys#snafu ...) */,lf[731]);
t357=C_mutate((C_word*)lf[732]+1 /* (set! ##sys#intern-symbol ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_string_to_symbol,a[2]=((C_word)li561),tmp=(C_word)a,a+=3,tmp));
t358=C_mutate((C_word*)lf[733]+1 /* (set! ##sys#intern-keyword ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_string_to_keyword,a[2]=((C_word)li562),tmp=(C_word)a,a+=3,tmp));
t359=C_mutate((C_word*)lf[734]+1 /* (set! ##sys#make-symbol ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_make_symbol,a[2]=((C_word)li563),tmp=(C_word)a,a+=3,tmp));
t360=C_mutate((C_word*)lf[735]+1 /* (set! ##sys#interned-symbol? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22195,a[2]=((C_word)li564),tmp=(C_word)a,a+=3,tmp));
t361=C_mutate((C_word*)lf[736]+1 /* (set! ##sys#string->symbol-name ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22198,a[2]=((C_word)li565),tmp=(C_word)a,a+=3,tmp));
t362=C_mutate((C_word*)lf[737]+1 /* (set! ##sys#symbol->string/shared ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22210,a[2]=((C_word)li566),tmp=(C_word)a,a+=3,tmp));
t363=C_mutate((C_word*)lf[738]+1 /* (set! ##sys#symbol->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22216,a[2]=((C_word)li567),tmp=(C_word)a,a+=3,tmp));
t364=C_mutate((C_word*)lf[739]+1 /* (set! ##sys#string->symbol ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22229,a[2]=((C_word)li568),tmp=(C_word)a,a+=3,tmp));
t365=C_mutate((C_word*)lf[740]+1 /* (set! scheme#symbol->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22239,a[2]=((C_word)li569),tmp=(C_word)a,a+=3,tmp));
t366=C_mutate((C_word*)lf[742]+1 /* (set! scheme#string->symbol ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22248,a[2]=((C_word)li570),tmp=(C_word)a,a+=3,tmp));
t367=*((C_word*)lf[484]+1);
t368=C_mutate((C_word*)lf[744]+1 /* (set! chicken.base#string->uninterned-symbol ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22257,a[2]=((C_word)li571),tmp=(C_word)a,a+=3,tmp));
t369=C_fix(-1);
t370=(*a=C_VECTOR_TYPE|1,a[1]=t369,tmp=(C_word)a,a+=2,tmp);
t371=C_mutate((C_word*)lf[746]+1 /* (set! chicken.base#gensym ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22270,a[2]=t370,a[3]=((C_word)li572),tmp=(C_word)a,a+=4,tmp));
t372=*((C_word*)lf[508]+1);
t373=C_mutate((C_word*)lf[750]+1 /* (set! chicken.base#symbol-append ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22328,a[2]=t372,a[3]=((C_word)li574),tmp=(C_word)a,a+=4,tmp));
t374=C_a_i_provide(&a,1,lf[752]);
t375=C_mutate((C_word*)lf[753]+1 /* (set! chicken.keyword#keyword? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22387,a[2]=((C_word)li575),tmp=(C_word)a,a+=3,tmp));
t376=C_mutate((C_word*)lf[754]+1 /* (set! chicken.keyword#string->keyword ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22390,a[2]=((C_word)li576),tmp=(C_word)a,a+=3,tmp));
t377=*((C_word*)lf[753]+1);
t378=C_mutate((C_word*)lf[756]+1 /* (set! chicken.keyword#keyword->string ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22403,a[2]=t377,a[3]=((C_word)li577),tmp=(C_word)a,a+=4,tmp));
t379=C_a_i_list1(&a,1,lf[759]);
t380=C_mutate((C_word*)lf[760]+1 /* (set! chicken.keyword#get-keyword ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22421,a[2]=t379,a[3]=((C_word)li578),tmp=(C_word)a,a+=4,tmp));
t381=C_mutate((C_word*)lf[762]+1 /* (set! ##sys#get-keyword ...) */,*((C_word*)lf[760]+1));
t382=C_mutate((C_word*)lf[763]+1 /* (set! ##sys#bytevector->list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22452,a[2]=((C_word)li580),tmp=(C_word)a,a+=3,tmp));
t383=C_mutate((C_word*)lf[764]+1 /* (set! ##sys#list->bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22486,a[2]=((C_word)li582),tmp=(C_word)a,a+=3,tmp));
t384=C_a_i_provide(&a,1,lf[766]);
t385=C_mutate((C_word*)lf[767]+1 /* (set! chicken.bytevector#make-bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22525,a[2]=((C_word)li583),tmp=(C_word)a,a+=3,tmp));
t386=C_mutate((C_word*)lf[769]+1 /* (set! chicken.bytevector#bytevector? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22549,a[2]=((C_word)li584),tmp=(C_word)a,a+=3,tmp));
t387=C_mutate((C_word*)lf[770]+1 /* (set! chicken.bytevector#bytevector-length ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22555,a[2]=((C_word)li585),tmp=(C_word)a,a+=3,tmp));
t388=C_mutate((C_word*)lf[772]+1 /* (set! chicken.bytevector#bytevector-u8-ref ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22564,a[2]=((C_word)li586),tmp=(C_word)a,a+=3,tmp));
t389=C_mutate((C_word*)lf[773]+1 /* (set! chicken.bytevector#bytevector-u8-set! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22567,a[2]=((C_word)li587),tmp=(C_word)a,a+=3,tmp));
t390=C_mutate((C_word*)lf[774]+1 /* (set! chicken.bytevector#string->utf8 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22570,a[2]=((C_word)li588),tmp=(C_word)a,a+=3,tmp));
t391=C_mutate((C_word*)lf[776]+1 /* (set! chicken.bytevector#utf8->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22586,a[2]=((C_word)li589),tmp=(C_word)a,a+=3,tmp));
t392=C_mutate((C_word*)lf[778]+1 /* (set! chicken.bytevector#string->latin1 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22626,a[2]=((C_word)li590),tmp=(C_word)a,a+=3,tmp));
t393=C_mutate((C_word*)lf[780]+1 /* (set! chicken.bytevector#latin1->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22645,a[2]=((C_word)li591),tmp=(C_word)a,a+=3,tmp));
t394=C_mutate((C_word*)lf[782]+1 /* (set! chicken.bytevector#bytevector=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22661,a[2]=((C_word)li592),tmp=(C_word)a,a+=3,tmp));
t395=C_mutate((C_word*)lf[784]+1 /* (set! chicken.bytevector#bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22683,a[2]=((C_word)li594),tmp=(C_word)a,a+=3,tmp));
t396=C_mutate((C_word*)lf[786]+1 /* (set! chicken.bytevector#bytevector-copy ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22714,a[2]=((C_word)li595),tmp=(C_word)a,a+=3,tmp));
t397=C_mutate((C_word*)lf[789]+1 /* (set! chicken.bytevector#bytevector-copy! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22795,a[2]=((C_word)li596),tmp=(C_word)a,a+=3,tmp));
t398=C_mutate((C_word*)lf[792]+1 /* (set! chicken.bytevector#bytevector-append ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22877,a[2]=((C_word)li599),tmp=(C_word)a,a+=3,tmp));
t399=C_mutate((C_word*)lf[117]+1 /* (set! scheme#make-vector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22935,a[2]=((C_word)li600),tmp=(C_word)a,a+=3,tmp));
t400=C_mutate((C_word*)lf[796]+1 /* (set! ##sys#make-vector ...) */,*((C_word*)lf[117]+1));
t401=C_mutate((C_word*)lf[118]+1 /* (set! scheme#list->vector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22964,a[2]=((C_word)li602),tmp=(C_word)a,a+=3,tmp));
t402=C_mutate((C_word*)lf[119]+1 /* (set! scheme#vector->list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23016,a[2]=((C_word)li604),tmp=(C_word)a,a+=3,tmp));
t403=C_mutate((C_word*)lf[120]+1 /* (set! scheme#vector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23102,a[2]=((C_word)li605),tmp=(C_word)a,a+=3,tmp));
t404=C_mutate((C_word*)lf[121]+1 /* (set! scheme#vector-fill! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23108,a[2]=((C_word)li607),tmp=(C_word)a,a+=3,tmp));
t405=C_mutate((C_word*)lf[800]+1 /* (set! scheme#vector-copy ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23189,a[2]=((C_word)li610),tmp=(C_word)a,a+=3,tmp));
t406=C_mutate((C_word*)lf[802]+1 /* (set! scheme#vector-copy! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23296,a[2]=((C_word)li614),tmp=(C_word)a,a+=3,tmp));
t407=C_mutate((C_word*)lf[804]+1 /* (set! scheme#vector-append ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23469,a[2]=((C_word)li619),tmp=(C_word)a,a+=3,tmp));
t408=C_mutate((C_word*)lf[245]+1 /* (set! chicken.base#subvector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23613,a[2]=((C_word)li621),tmp=(C_word)a,a+=3,tmp));
t409=C_mutate((C_word*)lf[246]+1 /* (set! chicken.base#vector-resize ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23676,a[2]=((C_word)li622),tmp=(C_word)a,a+=3,tmp));
t410=C_mutate(&lf[808] /* (set! ##sys#vector-resize ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23697,a[2]=((C_word)li624),tmp=(C_word)a,a+=3,tmp));
t411=C_mutate((C_word*)lf[141]+1 /* (set! scheme#char-ci=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23736,a[2]=((C_word)li626),tmp=(C_word)a,a+=3,tmp));
t412=C_mutate((C_word*)lf[142]+1 /* (set! scheme#char-ci>? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23785,a[2]=((C_word)li628),tmp=(C_word)a,a+=3,tmp));
t413=C_mutate((C_word*)lf[143]+1 /* (set! scheme#char-ci<? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23828,a[2]=((C_word)li630),tmp=(C_word)a,a+=3,tmp));
t414=C_mutate((C_word*)lf[144]+1 /* (set! scheme#char-ci>=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23871,a[2]=((C_word)li632),tmp=(C_word)a,a+=3,tmp));
t415=C_mutate((C_word*)lf[145]+1 /* (set! scheme#char-ci<=? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23914,a[2]=((C_word)li634),tmp=(C_word)a,a+=3,tmp));
t416=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23959,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3749: scheme#make-vector */
t417=*((C_word*)lf[117]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t417;
av2[1]=t416;
av2[2]=C_fix(37);
av2[3]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t417+1)))(4,av2);}}

/* chicken.base#fixnum? in k12559 in k11436 */
static void C_ccall f_12563(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12563,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_fixnump(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#flonum? in k12559 in k11436 */
static void C_ccall f_12566(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12566,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_flonump(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#bignum? in k12559 in k11436 */
static void C_ccall f_12569(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12569,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_bignump(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#ratnum? in k12559 in k11436 */
static void C_ccall f_12572(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12572,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_ratnump(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#cplxnum? in k12559 in k11436 */
static void C_ccall f_12575(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12575,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cplxnump(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#exact-integer? in k12559 in k11436 */
static void C_ccall f_12578(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12578,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_exact_integerp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#quotient&modulo in k12559 in k11436 */
static void C_ccall f_12583(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_12583,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_12589,a[2]=t2,a[3]=t3,a[4]=((C_word)li142),tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12595,a[2]=t3,a[3]=((C_word)li143),tmp=(C_word)a,a+=4,tmp);
/* library.scm:812: scheme#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
C_call_with_values(4,av2);}}

/* a12588 in chicken.base#quotient&modulo in k12559 in k11436 */
static void C_ccall f_12589(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12589,c,av);}
/* library.scm:812: chicken.base#quotient&remainder */
t2=*((C_word*)lf[221]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* a12594 in chicken.base#quotient&modulo in k12559 in k11436 */
static void C_ccall f_12595(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(29,c,3)))){
C_save_and_reclaim((void *)f_12595,c,av);}
a=C_alloc(29);
if(C_truep(C_i_positivep(((C_word*)t0)[2]))){
if(C_truep(C_i_negativep(t3))){
t4=C_s_a_i_plus(&a,2,t3,((C_word*)t0)[2]);
/* library.scm:816: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
av2[3]=t4;
C_values(4,av2);}}
else{
/* library.scm:817: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
C_values(4,av2);}}}
else{
if(C_truep(C_i_positivep(t3))){
t4=C_s_a_i_plus(&a,2,t3,((C_word*)t0)[2]);
/* library.scm:819: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
av2[3]=t4;
C_values(4,av2);}}
else{
/* library.scm:820: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
C_values(4,av2);}}}}

/* chicken.base#finite? in k12559 in k11436 */
static void C_ccall f_12630(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12630,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_finitep(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#infinite? in k12559 in k11436 */
static void C_ccall f_12633(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12633,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_infinitep(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#nan? in k12559 in k11436 */
static void C_ccall f_12636(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12636,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_nanp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#add1 in k12559 in k11436 */
static void C_ccall f_12644(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(29,c,1)))){
C_save_and_reclaim((void *)f_12644,c,av);}
a=C_alloc(29);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_s_a_i_plus(&a,2,t2,C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#sub1 in k12559 in k11436 */
static void C_ccall f_12650(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(29,c,1)))){
C_save_and_reclaim((void *)f_12650,c,av);}
a=C_alloc(29);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_s_a_i_minus(&a,2,t2,C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#error in k12559 in k11436 */
static void C_ccall f_12657(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +0,c,4)))){
C_save_and_reclaim((void*)f_12657,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+0);
t2=C_build_rest(&a,c,2,av);
C_word t3;
if(C_truep(C_i_pairp(t2))){{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[236];
av2[4]=t2;
C_apply(5,av2);}}
else{
/* library.scm:841: ##sys#signal-hook */
t3=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[236];
av2[3]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}}

/* chicken.base#void in k12559 in k11436 */
static void C_ccall f_12672(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12672,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#promise? in k12559 in k11436 */
static void C_ccall f_12686(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12686,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_structurep(t2,lf[250]);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#make-promise in k12559 in k11436 */
static void C_ccall f_12692(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_12692,c,av);}
a=C_alloc(3);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_record2(&a,2,lf[250],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#make-promise in k12559 in k11436 */
static void C_ccall f_12698(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_12698,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12705,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:878: promise? */
t4=*((C_word*)lf[249]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k12703 in chicken.base#make-promise in k12559 in k11436 */
static void C_ccall f_12705(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_12705,c,av);}
a=C_alloc(4);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12710,a[2]=((C_word*)t0)[3],a[3]=((C_word)li155),tmp=(C_word)a,a+=4,tmp);
/* library.scm:879: ##sys#make-promise */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[251]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[251]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t2;
tp(3,av2);}}}

/* a12709 in k12703 in chicken.base#make-promise in k12559 in k11436 */
static void C_ccall f_12710(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12710,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#foldl in k12559 in k11436 */
static void C_ccall f_12713(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_12713,c,av);}
a=C_alloc(7);
t5=C_i_check_list_2(t4,lf[254]);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_12722,a[2]=t7,a[3]=t2,a[4]=((C_word)li157),tmp=(C_word)a,a+=5,tmp));
t9=((C_word*)t7)[1];
f_12722(t9,t1,t4,t3);}

/* loop in chicken.base#foldl in k12559 in k11436 */
static void f_12722(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_12722,4,t0,t1,t2,t3);}
a=C_alloc(5);
t4=C_i_pairp(t2);
if(C_truep(C_i_not(t4))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_slot(t2,C_fix(1));
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_12740,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t5,tmp=(C_word)a,a+=5,tmp);
/* library.scm:888: f */
t7=((C_word*)t0)[3];{
C_word av2[4];
av2[0]=t7;
av2[1]=t6;
av2[2]=t3;
av2[3]=C_slot(t2,C_fix(0));
((C_proc)C_fast_retrieve_proc(t7))(4,av2);}}}

/* k12738 in loop in chicken.base#foldl in k12559 in k11436 */
static void C_ccall f_12740(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12740,c,av);}
/* library.scm:888: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_12722(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* chicken.base#foldr in k12559 in k11436 */
static void C_ccall f_12750(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_12750,c,av);}
a=C_alloc(8);
t5=C_i_check_list_2(t4,lf[256]);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_12759,a[2]=t3,a[3]=t2,a[4]=t7,a[5]=((C_word)li159),tmp=(C_word)a,a+=6,tmp));
t9=((C_word*)t7)[1];
f_12759(t9,t1,t4);}

/* loop in chicken.base#foldr in k12559 in k11436 */
static void f_12759(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_12759,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_i_pairp(t2);
if(C_truep(C_i_not(t3))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_slot(t2,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_12777,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
/* library.scm:895: loop */
t7=t5;
t8=C_slot(t2,C_fix(1));
t1=t7;
t2=t8;
goto loop;}}

/* k12775 in loop in chicken.base#foldr in k12559 in k11436 */
static void C_ccall f_12777(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12777,c,av);}
/* library.scm:895: f */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=t1;
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}

/* chicken.base#on-exit in k12559 in k11436 */
static void C_ccall f_12790(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_12790,c,av);}
a=C_alloc(3);
t3=C_a_i_cons(&a,2,t2,*((C_word*)lf[259]+1));
t4=C_mutate((C_word*)lf[259]+1 /* (set! chicken.base#cleanup-tasks ...) */,t3);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* chicken.base#exit in k12559 in k11436 */
static void C_ccall f_12797(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_12797,c,av);}
a=C_alloc(4);
if(C_truep(C_rest_nullp(c,2))){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f45112,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:908: chicken.base#exit-handler */
t3=*((C_word*)lf[258]+1);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=C_get_rest_arg(c,2,av,2,t0);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12804,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:908: chicken.base#exit-handler */
t4=*((C_word*)lf[258]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k12802 in chicken.base#exit in k12559 in k11436 */
static void C_ccall f_12804(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_12804,c,av);}
/* library.scm:907: g887 */
t2=t1;{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* chicken.base#emergency-exit in k12559 in k11436 */
static void C_ccall f_12815(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12815,c,av);}
if(C_truep(C_rest_nullp(c,2))){
t2=C_i_check_fixnum_2(C_fix(0),lf[263]);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_exit_runtime(C_fix(0));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=C_get_rest_arg(c,2,av,2,t0);
t3=C_i_check_fixnum_2(t2,lf[263]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_exit_runtime(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* chicken.base#identity in k12559 in k11436 */
static void C_ccall f_12834(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12834,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#conjoin in k12559 in k11436 */
static void C_ccall f_12837(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,3)))){
C_save_and_reclaim((void*)f_12837,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12839,a[2]=t2,a[3]=((C_word)li166),tmp=(C_word)a,a+=4,tmp);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* f_12839 in chicken.base#conjoin in k12559 in k11436 */
static void C_ccall f_12839(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_12839,c,av);}
a=C_alloc(7);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_12845,a[2]=t4,a[3]=t2,a[4]=((C_word)li165),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_12845(t6,t1,((C_word*)t0)[2]);}

/* loop */
static void f_12845(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_12845,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_i_nullp(t2);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_slot(t2,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_12861,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:929: g916 */
t6=t4;{
C_word av2[3];
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t6))(3,av2);}}}

/* k12859 in loop */
static void C_ccall f_12861(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_12861,c,av);}
if(C_truep(t1)){
/* library.scm:930: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_12845(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* chicken.base#disjoin in k12559 in k11436 */
static void C_ccall f_12870(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,3)))){
C_save_and_reclaim((void*)f_12870,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12872,a[2]=t2,a[3]=((C_word)li169),tmp=(C_word)a,a+=4,tmp);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* f_12872 in chicken.base#disjoin in k12559 in k11436 */
static void C_ccall f_12872(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_12872,c,av);}
a=C_alloc(7);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_12878,a[2]=t4,a[3]=t2,a[4]=((C_word)li168),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_12878(t6,t1,((C_word*)t0)[2]);}

/* loop */
static void f_12878(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_12878,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_i_nullp(t2);
if(C_truep(C_i_not(t3))){
t4=C_slot(t2,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_12891,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:936: g928 */
t6=t4;{
C_word av2[3];
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t6))(3,av2);}}
else{
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k12889 in loop */
static void C_ccall f_12891(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_12891,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:937: loop */
t2=((C_word*)((C_word*)t0)[3])[1];
f_12878(t2,((C_word*)t0)[2],C_slot(((C_word*)t0)[4],C_fix(1)));}}

/* chicken.base#constantly in k12559 in k11436 */
static void C_ccall f_12907(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_12907,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
t3=C_eqp(C_fix(1),C_u_i_length(t2));
if(C_truep(t3)){
t4=C_i_car(t2);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12918,a[2]=t4,a[3]=((C_word)li171),tmp=(C_word)a,a+=4,tmp);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12920,a[2]=t2,a[3]=((C_word)li172),tmp=(C_word)a,a+=4,tmp);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* f_12918 in chicken.base#constantly in k12559 in k11436 */
static void C_ccall f_12918(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12918,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* f_12920 in chicken.base#constantly in k12559 in k11436 */
static void C_ccall f_12920(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12920,c,av);}{
C_word av2[4];
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[160]+1);
av2[3]=((C_word*)t0)[2];
C_apply(4,av2);}}

/* chicken.base#flip in k12559 in k11436 */
static void C_ccall f_12928(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_12928,c,av);}
a=C_alloc(4);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12930,a[2]=t2,a[3]=((C_word)li174),tmp=(C_word)a,a+=4,tmp);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* f_12930 in chicken.base#flip in k12559 in k11436 */
static void C_ccall f_12930(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12930,c,av);}
/* library.scm:945: proc */
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
av2[2]=t3;
av2[3]=t2;
((C_proc)C_fast_retrieve_proc(t4))(4,av2);}}

/* chicken.base#complement in k12559 in k11436 */
static void C_ccall f_12936(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_12936,c,av);}
a=C_alloc(4);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12938,a[2]=t2,a[3]=((C_word)li176),tmp=(C_word)a,a+=4,tmp);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* f_12938 in chicken.base#complement in k12559 in k11436 */
static void C_ccall f_12938(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +3,c,3)))){
C_save_and_reclaim((void*)f_12938,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+3);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_12946,a[2]=t1,tmp=(C_word)a,a+=3,tmp);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
av2[3]=t2;
C_apply(4,av2);}}

/* k12944 */
static void C_ccall f_12946(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_12946,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_not(t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#compose in k12559 in k11436 */
static void C_ccall f_12948(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +6,c,3)))){
C_save_and_reclaim((void*)f_12948,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+6);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12951,a[2]=t4,a[3]=((C_word)li180),tmp=(C_word)a,a+=4,tmp));
if(C_truep(C_rest_nullp(c,2))){
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=*((C_word*)lf[160]+1);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=((C_word*)t4)[1];
av2[3]=t2;
C_apply(4,av2);}}}

/* rec in chicken.base#compose in k12559 in k11436 */
static void C_ccall f_12951(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +6,c,2)))){
C_save_and_reclaim((void*)f_12951,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+6);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
if(C_truep(C_i_nullp(t3))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_12959,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=t2,a[5]=((C_word)li179),tmp=(C_word)a,a+=6,tmp);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* f_12959 in rec in chicken.base#compose in k12559 in k11436 */
static void C_ccall f_12959(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +6,c,3)))){
C_save_and_reclaim((void*)f_12959,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+6);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_12965,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word)li178),tmp=(C_word)a,a+=6,tmp);
/* library.scm:956: scheme#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=t3;
av2[3]=((C_word*)t0)[4];
C_call_with_values(4,av2);}}

/* a12964 */
static void C_ccall f_12965(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_12965,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12973,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=((C_word*)t0)[4];
C_apply(4,av2);}}

/* k12971 in a12964 */
static void C_ccall f_12973(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_12973,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=((C_word*)t0)[3];
C_apply(4,av2);}}

/* chicken.base#o in k12559 in k11436 */
static void C_ccall f_12984(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +6,c,3)))){
C_save_and_reclaim((void*)f_12984,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+6);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
if(C_truep(C_rest_nullp(c,2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=*((C_word*)lf[268]+1);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_12996,a[2]=t4,a[3]=((C_word)li183),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_12996(t6,t1,t2);}}

/* loop in chicken.base#o in k12559 in k11436 */
static void f_12996(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_12996,3,t0,t1,t2);}
a=C_alloc(6);
t3=C_slot(t2,C_fix(0));
t4=C_slot(t2,C_fix(1));
if(C_truep(C_i_nullp(t4))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13010,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=t4,a[5]=((C_word)li182),tmp=(C_word)a,a+=6,tmp);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* f_13010 in loop in chicken.base#o in k12559 in k11436 */
static void C_ccall f_13010(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_13010,c,av);}
a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13018,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:971: loop */
t4=((C_word*)((C_word*)t0)[3])[1];
f_12996(t4,t3,((C_word*)t0)[4]);}

/* k13016 */
static void C_ccall f_13018(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_13018,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13021,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:971: g957 */
t3=t1;{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
((C_proc)C_fast_retrieve_proc(t3))(3,av2);}}

/* k13019 in k13016 */
static void C_ccall f_13021(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_13021,c,av);}
/* library.scm:971: h */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* chicken.base#list-of? in k12559 in k11436 */
static void C_ccall f_13023(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_13023,c,av);}
a=C_alloc(4);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13025,a[2]=t2,a[3]=((C_word)li186),tmp=(C_word)a,a+=4,tmp);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* f_13025 in chicken.base#list-of? in k12559 in k11436 */
static void C_ccall f_13025(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_13025,c,av);}
a=C_alloc(7);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13031,a[2]=t4,a[3]=((C_word*)t0)[2],a[4]=((C_word)li185),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_13031(t6,t1,t2);}

/* loop */
static void f_13031(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_13031,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_i_pairp(t2);
if(C_truep(C_i_not(t3))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13050,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:978: pred */
t5=((C_word*)t0)[3];{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=C_slot(t2,C_fix(0));
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}}}

/* k13048 in loop */
static void C_ccall f_13050(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_13050,c,av);}
if(C_truep(t1)){
/* library.scm:978: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_13031(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* chicken.base#each in k12559 in k11436 */
static void C_ccall f_13067(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_13067,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
if(C_truep(C_i_nullp(t2))){
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13075,a[2]=((C_word)li188),tmp=(C_word)a,a+=3,tmp);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_slot(t2,C_fix(1));
t4=C_i_nullp(t3);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=(C_truep(t4)?C_slot(t2,C_fix(0)):(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13089,a[2]=t2,a[3]=((C_word)li190),tmp=(C_word)a,a+=4,tmp));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* f_13075 in chicken.base#each in k12559 in k11436 */
static void C_ccall f_13075(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13075,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=*((C_word*)lf[278]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* f_13089 in chicken.base#each in k12559 in k11436 */
static void C_ccall f_13089(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +7,c,3)))){
C_save_and_reclaim((void*)f_13089,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+7);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13095,a[2]=t2,a[3]=t4,a[4]=((C_word)li189),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_13095(t6,t1,((C_word*)t0)[2]);}

/* loop */
static void f_13095(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_13095,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_slot(t2,C_fix(0));
t4=C_slot(t2,C_fix(1));
if(C_truep(C_i_nullp(t4))){{
C_word av2[4];
av2[0]=0;
av2[1]=t1;
av2[2]=t3;
av2[3]=((C_word*)t0)[2];
C_apply(4,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13114,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t4,tmp=(C_word)a,a+=5,tmp);{
C_word av2[4];
av2[0]=0;
av2[1]=t5;
av2[2]=t3;
av2[3]=((C_word*)t0)[2];
C_apply(4,av2);}}}

/* k13112 in loop */
static void C_ccall f_13114(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_13114,c,av);}
/* library.scm:993: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_13095(t2,((C_word*)t0)[3],((C_word*)t0)[4]);}

/* chicken.base#bwp-object? in k12559 in k11436 */
static void C_ccall f_13123(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13123,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_bwpp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#weak-cons in k12559 in k11436 */
static void C_ccall f_13126(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_13126,c,av);}
a=C_alloc(3);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_weak_cons(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.base#weak-pair? in k12559 in k11436 */
static void C_ccall f_13129(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13129,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_weak_pairp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#atom? in k12559 in k11436 */
static void C_ccall f_13132(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13132,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_not_pair_p(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#tail? in k12559 in k11436 */
static void C_ccall f_13135(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_13135,c,av);}
a=C_alloc(4);
t4=C_i_check_list_2(t3,lf[284]);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13144,a[2]=t2,a[3]=((C_word)li196),tmp=(C_word)a,a+=4,tmp);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=(
  f_13144(t5,t3)
);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* loop in chicken.base#tail? in k12559 in k11436 */
static C_word f_13144(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_stack_overflow_check;
loop:{}
if(C_truep(C_eqp(((C_word*)t0)[2],t1))){
return(C_SCHEME_TRUE);}
else{
t2=(C_truep(C_blockp(t1))?C_pairp(t1):C_SCHEME_FALSE);
if(C_truep(t2)){
t4=C_slot(t1,C_fix(1));
t1=t4;
goto loop;}
else{
return(C_SCHEME_FALSE);}}}

/* chicken.base#intersperse in k12559 in k11436 */
static void C_ccall f_13163(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_13163,c,av);}
a=C_alloc(7);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13169,a[2]=t3,a[3]=t5,a[4]=((C_word)li198),tmp=(C_word)a,a+=5,tmp));
t7=((C_word*)t5)[1];
f_13169(t7,t1,t2);}

/* loop in chicken.base#intersperse in k12559 in k11436 */
static void f_13169(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_13169,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_eqp(t2,C_SCHEME_END_OF_LIST))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_i_cdr(t2);
if(C_truep(C_eqp(t3,C_SCHEME_END_OF_LIST))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_slot(t2,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13194,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
/* library.scm:1022: loop */
t7=t5;
t8=t3;
t1=t7;
t2=t8;
goto loop;}}}

/* k13192 in loop in chicken.base#intersperse in k12559 in k11436 */
static void C_ccall f_13194(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,1)))){
C_save_and_reclaim((void *)f_13194,c,av);}
a=C_alloc(6);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[4],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#butlast in k12559 in k11436 */
static void C_ccall f_13196(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_13196,c,av);}
a=C_alloc(6);
t3=C_i_check_pair_2(t2,lf[287]);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13205,a[2]=t5,a[3]=((C_word)li200),tmp=(C_word)a,a+=4,tmp));
t7=((C_word*)t5)[1];
f_13205(t7,t1,t2);}

/* loop in chicken.base#butlast in k12559 in k11436 */
static void f_13205(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_13205,3,t0,t1,t2);}
a=C_alloc(4);
t3=C_slot(t2,C_fix(1));
t4=(C_truep(C_blockp(t3))?C_pairp(t3):C_SCHEME_FALSE);
if(C_truep(t4)){
t5=C_slot(t2,C_fix(0));
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13226,a[2]=t1,a[3]=t5,tmp=(C_word)a,a+=4,tmp);
/* library.scm:1029: loop */
t8=t6;
t9=t3;
t1=t8;
t2=t9;
goto loop;}
else{
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* k13224 in loop in chicken.base#butlast in k12559 in k11436 */
static void C_ccall f_13226(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_13226,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#flatten in k12559 in k11436 */
static void C_ccall f_13228(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +6,c,4)))){
C_save_and_reclaim((void*)f_13228,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+6);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13234,a[2]=t4,a[3]=((C_word)li202),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_13234(t6,t1,t2,C_SCHEME_END_OF_LIST);}

/* loop in chicken.base#flatten in k12559 in k11436 */
static void f_13234(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_13234,4,t0,t1,t2,t3);}
a=C_alloc(5);
if(C_truep(C_i_nullp(t2))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_slot(t2,C_fix(0));
t5=C_slot(t2,C_fix(1));
if(C_truep(C_i_listp(t4))){
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13260,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
/* library.scm:1039: loop */
t8=t6;
t9=t5;
t10=t3;
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13267,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:1040: loop */
t8=t6;
t9=t5;
t10=t3;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* k13258 in loop in chicken.base#flatten in k12559 in k11436 */
static void C_ccall f_13260(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_13260,c,av);}
/* library.scm:1039: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_13234(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k13265 in loop in chicken.base#flatten in k12559 in k11436 */
static void C_ccall f_13267(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_13267,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#join in k12559 in k11436 */
static void C_ccall f_13269(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +7,c,3)))){
C_save_and_reclaim((void*)f_13269,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+7);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
t4=C_i_pairp(t3);
t5=(C_truep(t4)?C_get_rest_arg(c,3,av,3,t0):C_SCHEME_END_OF_LIST);
t6=C_i_check_list_2(t5,lf[290]);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13281,a[2]=t5,a[3]=t8,a[4]=((C_word)li204),tmp=(C_word)a,a+=5,tmp));
t10=((C_word*)t8)[1];
f_13281(t10,t1,t2);}

/* loop in chicken.base#join in k12559 in k11436 */
static void f_13281(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_13281,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_i_pairp(t2);
if(C_truep(C_i_not(t3))){
/* library.scm:1050: ##sys#error-not-a-proper-list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}
else{
t4=C_slot(t2,C_fix(0));
t5=C_slot(t2,C_fix(1));
if(C_truep(C_i_nullp(t5))){
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13316,a[2]=t1,a[3]=t4,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* library.scm:1056: loop */
t8=t6;
t9=t5;
t1=t8;
t2=t9;
goto loop;}}}}

/* k13314 in loop in chicken.base#join in k12559 in k11436 */
static void C_ccall f_13316(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_13316,c,av);}
/* library.scm:1056: ##sys#append */
t2=*((C_word*)lf[291]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
av2[4]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* chicken.base#compress in k12559 in k11436 */
static void C_ccall f_13326(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_13326,c,av);}
a=C_alloc(7);
t4=lf[293];
t5=C_i_check_list_2(t3,lf[294]);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13335,a[2]=t4,a[3]=t7,a[4]=((C_word)li206),tmp=(C_word)a,a+=5,tmp));
t9=((C_word*)t7)[1];
f_13335(t9,t1,t2,t3);}

/* loop in chicken.base#compress in k12559 in k11436 */
static void f_13335(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(4,0,5)))){
C_save_and_reclaim_args((void *)trf_13335,4,t0,t1,t2,t3);}
a=C_alloc(4);
if(C_truep(C_i_nullp(t2))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_i_pairp(t2);
if(C_truep(C_i_not(t4))){
/* library.scm:1065: ##sys#signal-hook */
t5=*((C_word*)lf[235]+1);{
C_word av2[6];
av2[0]=t5;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=lf[294];
av2[4]=((C_word*)t0)[2];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(6,av2);}}
else{
t5=C_i_pairp(t3);
if(C_truep(C_i_not(t5))){
/* library.scm:1067: ##sys#signal-hook */
t6=*((C_word*)lf[235]+1);{
C_word av2[6];
av2[0]=t6;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=lf[294];
av2[4]=((C_word*)t0)[2];
av2[5]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(6,av2);}}
else{
if(C_truep(C_slot(t2,C_fix(0)))){
t6=C_slot(t3,C_fix(0));
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13377,a[2]=t1,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
/* library.scm:1069: loop */
t9=t7;
t10=C_slot(t2,C_fix(1));
t11=C_slot(t3,C_fix(1));
t1=t9;
t2=t10;
t3=t11;
goto loop;}
else{
/* library.scm:1070: loop */
t9=t1;
t10=C_slot(t2,C_fix(1));
t11=C_slot(t3,C_fix(1));
t1=t9;
t2=t10;
t3=t11;
goto loop;}}}}}

/* k13375 in loop in chicken.base#compress in k12559 in k11436 */
static void C_ccall f_13377(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_13377,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#char-foldcase in k12559 in k11436 */
static void C_ccall f_13406(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13406,c,av);}
t3=C_i_check_char_2(t2,lf[297]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_utf_char_foldcase(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.base#string-foldcase in k12559 in k11436 */
static void C_ccall f_13412(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_13412,c,av);}
a=C_alloc(5);
t3=C_i_check_string_2(t2,lf[299]);
t4=C_slot(t2,C_fix(0));
t5=C_block_size(t4);
t6=C_fixnum_difference(t5,C_fix(1));
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13426,a[2]=t1,a[3]=t4,a[4]=t6,tmp=(C_word)a,a+=5,tmp);
/* library.scm:1083: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t7;
av2[2]=C_fixnum_times(t6,C_fix(2));
tp(3,av2);}}

/* k13424 in chicken.base#string-foldcase in k12559 in k11436 */
static void C_ccall f_13426(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_13426,c,av);}
/* library.scm:1085: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[300]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_fix(0);
av2[4]=C_utf_string_foldcase(((C_word*)t0)[3],t1,((C_word*)t0)[4]);
tp(5,av2);}}

/* chicken.base#alist-update! in k12559 in k11436 */
static void C_ccall f_13432(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c<5) C_bad_min_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_13432,c,av);}
a=C_alloc(10);
t5=C_rest_nullp(c,5);
t6=(C_truep(t5)?*((C_word*)lf[5]+1):C_get_rest_arg(c,5,av,5,t0));
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13439,a[2]=t3,a[3]=t1,a[4]=t4,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
t8=C_eqp(*((C_word*)lf[4]+1),t6);
if(C_truep(t8)){
t9=t7;
f_13439(t9,*((C_word*)lf[56]+1));}
else{
t9=C_eqp(*((C_word*)lf[5]+1),t6);
if(C_truep(t9)){
t10=t7;
f_13439(t10,*((C_word*)lf[57]+1));}
else{
t10=C_eqp(*((C_word*)lf[6]+1),t6);
t11=t7;
f_13439(t11,(C_truep(t10)?*((C_word*)lf[58]+1):(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13471,a[2]=t6,a[3]=((C_word)li211),tmp=(C_word)a,a+=4,tmp)));}}}

/* k13437 in chicken.base#alist-update! in k12559 in k11436 */
static void f_13439(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_13439,2,t0,t1);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13442,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:1102: aq */
t3=t1;{
C_word av2[4];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k13440 in k13437 in chicken.base#alist-update! in k12559 in k11436 */
static void C_ccall f_13442(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,1)))){
C_save_and_reclaim((void *)f_13442,c,av);}
a=C_alloc(6);
if(C_truep(t1)){
t2=C_i_setslot(t1,C_fix(1),((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=C_a_i_cons(&a,2,((C_word*)t0)[5],((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,t2,((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* f_13471 in chicken.base#alist-update! in k12559 in k11436 */
static void C_ccall f_13471(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_13471,c,av);}
a=C_alloc(8);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13477,a[2]=t5,a[3]=((C_word*)t0)[2],a[4]=t2,a[5]=((C_word)li210),tmp=(C_word)a,a+=6,tmp));
t7=((C_word*)t5)[1];
f_13477(t7,t1,t3);}

/* loop */
static void f_13477(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_13477,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13493,a[2]=t1,a[3]=t3,a[4]=((C_word*)t0)[2],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_i_pairp(t3))){
/* library.scm:1099: cmp */
t5=((C_word*)t0)[3];{
C_word av2[4];
av2[0]=t5;
av2[1]=t4;
av2[2]=((C_word*)t0)[4];
av2[3]=C_slot(t3,C_fix(0));
((C_proc)C_fast_retrieve_proc(t5))(4,av2);}}
else{
/* library.scm:1101: loop */
t6=t1;
t7=C_slot(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k13491 in loop */
static void C_ccall f_13493(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_13493,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:1101: loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_13477(t2,((C_word*)t0)[2],C_slot(((C_word*)t0)[5],C_fix(1)));}}

/* chicken.base#alist-update in k12559 in k11436 */
static void C_ccall f_13518(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c<5) C_bad_min_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_13518,c,av);}
a=C_alloc(9);
t5=C_rest_nullp(c,5);
t6=(C_truep(t5)?*((C_word*)lf[5]+1):C_get_rest_arg(c,5,av,5,t0));
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_13527,a[2]=t2,a[3]=t3,a[4]=t8,a[5]=t6,a[6]=((C_word)li213),tmp=(C_word)a,a+=7,tmp));
t10=((C_word*)t8)[1];
f_13527(t10,t1,t4);}

/* loop in chicken.base#alist-update in k12559 in k11436 */
static void f_13527(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,4)))){
C_save_and_reclaim_args((void *)trf_13527,3,t0,t1,t2);}
a=C_alloc(8);
if(C_truep(C_i_nullp(t2))){
t3=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_a_i_list1(&a,1,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_i_pairp(t2);
if(C_truep(C_i_not(t3))){
/* library.scm:1114: chicken.base#error */
t4=*((C_word*)lf[234]+1);{
C_word av2[5];
av2[0]=t4;
av2[1]=t1;
av2[2]=lf[304];
av2[3]=lf[305];
av2[4]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}
else{
t4=C_slot(t2,C_fix(0));
t5=C_i_pairp(t4);
if(C_truep(C_i_not(t5))){
/* library.scm:1118: chicken.base#error */
t6=*((C_word*)lf[234]+1);{
C_word av2[5];
av2[0]=t6;
av2[1]=t1;
av2[2]=lf[304];
av2[3]=lf[306];
av2[4]=t4;
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}
else{
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_13568,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=t1,a[6]=t4,a[7]=((C_word*)t0)[4],tmp=(C_word)a,a+=8,tmp);
/* library.scm:1119: cmp */
t7=((C_word*)t0)[5];{
C_word av2[4];
av2[0]=t7;
av2[1]=t6;
av2[2]=((C_word*)t0)[2];
av2[3]=C_slot(t4,C_fix(0));
((C_proc)C_fast_retrieve_proc(t7))(4,av2);}}}}}

/* k13566 in loop in chicken.base#alist-update in k12559 in k11436 */
static void C_ccall f_13568(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_13568,c,av);}
a=C_alloc(7);
if(C_truep(t1)){
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=C_slot(((C_word*)t0)[4],C_fix(1));
t4=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_cons(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t2=C_slot(((C_word*)t0)[6],C_fix(0));
t3=C_slot(((C_word*)t0)[6],C_fix(1));
t4=C_a_i_cons(&a,2,t2,t3);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13590,a[2]=((C_word*)t0)[5],a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:1123: loop */
t6=((C_word*)((C_word*)t0)[7])[1];
f_13527(t6,t5,C_slot(((C_word*)t0)[4],C_fix(1)));}}

/* k13588 in k13566 in loop in chicken.base#alist-update in k12559 in k11436 */
static void C_ccall f_13590(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_13590,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#alist-ref in k12559 in k11436 */
static void C_ccall f_13622(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_13622,c,av);}
a=C_alloc(10);
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?*((C_word*)lf[5]+1):C_get_rest_arg(c,4,av,4,t0));
t6=C_rest_nullp(c,4);
t7=C_rest_nullp(c,5);
t8=(C_truep(t7)?C_SCHEME_FALSE:C_get_rest_arg(c,5,av,4,t0));
t9=C_rest_nullp(c,5);
t10=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13638,a[2]=t1,a[3]=t8,a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
t11=C_eqp(*((C_word*)lf[4]+1),t5);
if(C_truep(t11)){
t12=t10;
f_13638(t12,*((C_word*)lf[56]+1));}
else{
t12=C_eqp(*((C_word*)lf[5]+1),t5);
if(C_truep(t12)){
t13=t10;
f_13638(t13,*((C_word*)lf[57]+1));}
else{
t13=C_eqp(*((C_word*)lf[6]+1),t5);
t14=t10;
f_13638(t14,(C_truep(t13)?*((C_word*)lf[58]+1):(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13663,a[2]=t5,a[3]=((C_word)li216),tmp=(C_word)a,a+=4,tmp)));}}}

/* k13636 in chicken.base#alist-ref in k12559 in k11436 */
static void f_13638(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,3)))){
C_save_and_reclaim_args((void *)trf_13638,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13641,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:1141: aq */
t3=t1;{
C_word av2[4];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k13639 in k13636 in chicken.base#alist-ref in k12559 in k11436 */
static void C_ccall f_13641(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13641,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=(C_truep(t1)?C_slot(t1,C_fix(1)):((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* f_13663 in chicken.base#alist-ref in k12559 in k11436 */
static void C_ccall f_13663(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_13663,c,av);}
a=C_alloc(8);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13669,a[2]=t5,a[3]=((C_word*)t0)[2],a[4]=t2,a[5]=((C_word)li215),tmp=(C_word)a,a+=6,tmp));
t7=((C_word*)t5)[1];
f_13669(t7,t1,t3);}

/* loop */
static void f_13669(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,4)))){
C_save_and_reclaim_args((void *)trf_13669,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_i_check_pair_2(t3,lf[308]);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13694,a[2]=t1,a[3]=t3,a[4]=((C_word*)t0)[2],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:1137: cmp */
t6=((C_word*)t0)[3];{
C_word av2[4];
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[4];
av2[3]=C_slot(t3,C_fix(0));
((C_proc)C_fast_retrieve_proc(t6))(4,av2);}}
else{
/* library.scm:1140: chicken.base#error */
t3=*((C_word*)lf[234]+1);{
C_word av2[5];
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[308];
av2[3]=lf[309];
av2[4]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}}}

/* k13692 in loop */
static void C_ccall f_13694(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_13694,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:1139: loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_13669(t2,((C_word*)t0)[2],C_slot(((C_word*)t0)[5],C_fix(1)));}}

/* chicken.base#rassoc in k12559 in k11436 */
static void C_ccall f_13734(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +8,c,3)))){
C_save_and_reclaim((void*)f_13734,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+8);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
t5=C_i_check_list_2(t3,lf[311]);
t6=C_i_pairp(t4);
t7=(C_truep(t6)?C_get_rest_arg(c,4,av,4,t0):*((C_word*)lf[5]+1));
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13746,a[2]=t9,a[3]=t7,a[4]=t2,a[5]=((C_word)li218),tmp=(C_word)a,a+=6,tmp));
t11=((C_word*)t9)[1];
f_13746(t11,t1,t3);}

/* loop in chicken.base#rassoc in k12559 in k11436 */
static void f_13746(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_13746,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_i_check_pair_2(t3,lf[311]);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13765,a[2]=t1,a[3]=t3,a[4]=((C_word*)t0)[2],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:1154: tst */
t6=((C_word*)t0)[3];{
C_word av2[4];
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[4];
av2[3]=C_slot(t3,C_fix(1));
((C_proc)C_fast_retrieve_proc(t6))(4,av2);}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k13763 in loop in chicken.base#rassoc in k12559 in k11436 */
static void C_ccall f_13765(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_13765,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:1156: loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_13746(t2,((C_word*)t0)[2],C_slot(((C_word*)t0)[5],C_fix(1)));}}

/* scheme#open-input-string in k12559 in k11436 */
static void C_ccall f_13782(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,5)))){
C_save_and_reclaim((void *)f_13782,c,av);}
a=C_alloc(4);
t3=C_i_check_string_2(t2,lf[313]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13789,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:1167: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[314]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[314]+1);
av2[1]=t4;
av2[2]=C_fix(1);
av2[3]=C_fast_retrieve(lf[315]);
av2[4]=lf[316];
av2[5]=lf[317];
tp(6,av2);}}

/* k13787 in scheme#open-input-string in k12559 in k11436 */
static void C_ccall f_13789(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_13789,c,av);}
a=C_alloc(6);
t2=C_slot(((C_word*)t0)[2],C_fix(0));
t3=C_block_size(t2);
t4=C_fixnum_difference(t3,C_fix(1));
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13799,a[2]=t2,a[3]=t4,a[4]=t1,a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
/* library.scm:1170: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}

/* k13797 in k13787 in scheme#open-input-string in k12559 in k11436 */
static void C_ccall f_13799(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13799,c,av);}
t2=C_copy_memory(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=C_i_set_i_slot(((C_word*)t0)[4],C_fix(10),C_fix(0));
t4=C_i_set_i_slot(((C_word*)t0)[4],C_fix(11),((C_word*)t0)[3]);
t5=C_i_setslot(((C_word*)t0)[4],C_fix(12),t1);
t6=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t6;
av2[1]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* scheme#open-output-string in k12559 in k11436 */
static void C_ccall f_13810(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_13810,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13814,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:1179: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[314]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[314]+1);
av2[1]=t2;
av2[2]=C_fix(2);
av2[3]=C_fast_retrieve(lf[315]);
av2[4]=lf[319];
av2[5]=lf[317];
tp(6,av2);}}

/* k13812 in scheme#open-output-string in k12559 in k11436 */
static void C_ccall f_13814(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_13814,c,av);}
a=C_alloc(4);
t2=C_i_set_i_slot(t1,C_fix(10),C_fix(0));
t3=C_i_set_i_slot(t1,C_fix(11),C_fix(256));
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13827,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:1182: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=C_fix(256);
tp(3,av2);}}

/* k13825 in k13812 in scheme#open-output-string in k12559 in k11436 */
static void C_ccall f_13827(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13827,c,av);}
t2=C_i_setslot(((C_word*)t0)[2],C_fix(12),t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#get-output-string in k12559 in k11436 */
static void C_ccall f_13829(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_13829,c,av);}
t3=C_i_check_port_2(t2,C_fix(2),C_SCHEME_FALSE,lf[321]);
t4=C_slot(t2,C_fix(7));
t5=C_eqp(lf[317],t4);
if(C_truep(C_i_not(t5))){
/* library.scm:1189: ##sys#signal-hook */
t6=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t6;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=lf[321];
av2[4]=lf[322];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(6,av2);}}
else{
/* library.scm:1191: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[300]+1);
av2[1]=t1;
av2[2]=C_slot(t2,C_fix(12));
av2[3]=C_fix(0);
av2[4]=C_slot(t2,C_fix(10));
tp(5,av2);}}}

/* scheme#open-input-bytevector in k12559 in k11436 */
static void C_ccall f_13863(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,5)))){
C_save_and_reclaim((void *)f_13863,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13867,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:1195: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[314]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[314]+1);
av2[1]=t3;
av2[2]=C_fix(1);
av2[3]=C_SCHEME_FALSE;
av2[4]=lf[326];
av2[5]=lf[327];
tp(6,av2);}}

/* k13865 in scheme#open-input-bytevector in k12559 in k11436 */
static void C_ccall f_13867(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(40,c,6)))){
C_save_and_reclaim((void *)f_13867,c,av);}
a=C_alloc(40);
t2=C_i_check_bytevector_2(((C_word*)t0)[2],lf[324]);
t3=C_i_setslot(t1,C_fix(14),lf[167]);
t4=C_fix(0);
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_block_size(((C_word*)t0)[2]);
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13885,a[2]=t5,a[3]=t6,a[4]=((C_word*)t0)[2],a[5]=((C_word)li223),tmp=(C_word)a,a+=6,tmp);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13898,a[2]=t5,a[3]=t6,a[4]=((C_word*)t0)[2],a[5]=((C_word)li224),tmp=(C_word)a,a+=6,tmp);
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13910,a[2]=t1,a[3]=((C_word)li225),tmp=(C_word)a,a+=4,tmp);
t10=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13916,a[2]=t5,a[3]=t6,a[4]=((C_word)li226),tmp=(C_word)a,a+=5,tmp);
t11=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13926,a[2]=((C_word*)t0)[2],a[3]=t5,a[4]=t6,a[5]=((C_word)li227),tmp=(C_word)a,a+=6,tmp);
t12=C_a_i_vector(&a,10,t7,t8,C_SCHEME_FALSE,C_SCHEME_FALSE,t9,C_SCHEME_FALSE,t10,t11,C_SCHEME_FALSE,C_SCHEME_FALSE);
t13=C_i_setslot(t1,C_fix(2),t12);
t14=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t14;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t14+1)))(2,av2);}}

/* a13884 in k13865 in scheme#open-input-bytevector in k12559 in k11436 */
static void C_ccall f_13885(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13885,c,av);}
t3=C_eqp(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3]);
if(C_truep(t3)){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_i_bytevector_ref(((C_word*)t0)[4],((C_word*)((C_word*)t0)[2])[1]);
t5=C_mutate(((C_word *)((C_word*)t0)[2])+1,C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],C_fix(1)));
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_make_character(C_unfix(t4));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* a13897 in k13865 in scheme#open-input-bytevector in k12559 in k11436 */
static void C_ccall f_13898(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13898,c,av);}
t3=C_eqp(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3]);
if(C_truep(t3)){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
/* library.scm:1210: g1284 */
t4=C_i_bytevector_ref(((C_word*)t0)[4],((C_word*)((C_word*)t0)[2])[1]);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
((C_proc)C_fast_retrieve_proc(t4))(2,av2);}}}

/* a13909 in k13865 in scheme#open-input-bytevector in k12559 in k11436 */
static void C_ccall f_13910(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13910,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_i_slot(((C_word*)t0)[2],C_fix(8),C_SCHEME_TRUE);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a13915 in k13865 in scheme#open-input-bytevector in k12559 in k11436 */
static void C_ccall f_13916(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13916,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_not(C_eqp(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3]));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a13925 in k13865 in scheme#open-input-bytevector in k12559 in k11436 */
static void C_ccall f_13926(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_13926,c,av);}
a=C_alloc(7);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_13930,a[2]=t4,a[3]=((C_word*)t0)[2],a[4]=t5,a[5]=((C_word*)t0)[3],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:1221: scheme#min */
t7=*((C_word*)lf[325]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t3;
av2[3]=C_fixnum_difference(((C_word*)t0)[4],((C_word*)((C_word*)t0)[3])[1]);
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}

/* k13928 in a13925 in k13865 in scheme#open-input-bytevector in k12559 in k11436 */
static void C_ccall f_13930(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13930,c,av);}
t2=C_copy_memory_with_offset(((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)((C_word*)t0)[5])[1],t1);
t3=C_mutate(((C_word *)((C_word*)t0)[5])+1,C_fixnum_plus(((C_word*)((C_word*)t0)[5])[1],t1));
t4=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#open-output-bytevector in k12559 in k11436 */
static void C_ccall f_13934(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_13934,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_13938,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:1231: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[314]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[314]+1);
av2[1]=t2;
av2[2]=C_fix(2);
av2[3]=C_SCHEME_FALSE;
av2[4]=lf[329];
av2[5]=lf[327];
tp(6,av2);}}

/* k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void C_ccall f_13938(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_13938,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13941,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:1232: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t2;
av2[2]=C_fix(256);
tp(3,av2);}}

/* k13939 in k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void C_ccall f_13941(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(42,c,6)))){
C_save_and_reclaim((void *)f_13941,c,av);}
a=C_alloc(42);
t2=t1;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_fix(0);
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_fix(256);
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_SCHEME_UNDEFINED;
t11=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_13943,a[2]=t5,a[3]=t3,a[4]=t7,a[5]=((C_word)li229),tmp=(C_word)a,a+=6,tmp));
t12=t10=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13955,a[2]=t3,a[3]=t5,a[4]=((C_word)li230),tmp=(C_word)a,a+=5,tmp);
t13=C_i_setslot(((C_word*)t0)[2],C_fix(9),t10);
t14=C_i_setslot(((C_word*)t0)[2],C_fix(14),lf[167]);
t15=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13974,a[2]=t9,a[3]=((C_word)li231),tmp=(C_word)a,a+=4,tmp);
t16=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13991,a[2]=t9,a[3]=((C_word)li232),tmp=(C_word)a,a+=4,tmp);
t17=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_13997,a[2]=((C_word*)t0)[2],a[3]=((C_word)li233),tmp=(C_word)a,a+=4,tmp);
t18=C_a_i_vector(&a,10,C_SCHEME_FALSE,C_SCHEME_FALSE,t15,t16,t17,C_SCHEME_FALSE,C_SCHEME_FALSE,C_SCHEME_FALSE,C_SCHEME_FALSE,C_SCHEME_FALSE);
t19=C_i_setslot(((C_word*)t0)[2],C_fix(2),t18);
t20=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t20;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t20+1)))(2,av2);}}

/* add in k13939 in k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void f_13943(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(16,0,2)))){
C_save_and_reclaim_args((void *)trf_13943,5,t0,t1,t2,t3,t4);}
a=C_alloc(16);
t5=C_fixnum_difference(t4,t3);
t6=C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],t5);
t7=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_13947,a[2]=((C_word*)t0)[3],a[3]=t2,a[4]=((C_word*)t0)[2],a[5]=t3,a[6]=t5,a[7]=t6,a[8]=t1,tmp=(C_word)a,a+=9,tmp);
if(C_truep(C_fixnum_greaterp(t6,((C_word*)((C_word*)t0)[4])[1]))){
t8=C_fixnum_times(((C_word*)((C_word*)t0)[4])[1],C_fix(2));
t9=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_13951,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],a[5]=t8,a[6]=t7,tmp=(C_word)a,a+=7,tmp);
/* library.scm:1240: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t9;
av2[2]=t8;
tp(3,av2);}}
else{
t8=t7;
f_13947(t8,C_SCHEME_UNDEFINED);}}

/* k13945 in add in k13939 in k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void f_13947(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,1)))){
C_save_and_reclaim_args((void *)trf_13947,2,t0,t1);}
t2=C_copy_memory_with_offset(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3],((C_word*)((C_word*)t0)[4])[1],((C_word*)t0)[5],((C_word*)t0)[6]);
t3=C_mutate(((C_word *)((C_word*)t0)[4])+1,((C_word*)t0)[7]);
t4=((C_word*)t0)[8];{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k13949 in add in k13939 in k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void C_ccall f_13951(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13951,c,av);}
t2=C_copy_memory_with_offset(t1,((C_word*)((C_word*)t0)[2])[1],C_fix(0),C_fix(0),((C_word*)((C_word*)t0)[3])[1]);
t3=C_mutate(((C_word *)((C_word*)t0)[4])+1,((C_word*)t0)[5]);
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t5=((C_word*)t0)[6];
f_13947(t5,t4);}

/* getter in k13939 in k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void C_ccall f_13955(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_13955,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_13959,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:1247: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[3])[1];
tp(3,av2);}}

/* k13957 in getter in k13939 in k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void C_ccall f_13959(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13959,c,av);}
t2=C_copy_memory_with_offset(t1,((C_word*)((C_word*)t0)[2])[1],C_fix(0),C_fix(0),((C_word*)((C_word*)t0)[3])[1]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a13973 in k13939 in k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void C_ccall f_13974(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_13974,c,av);}
a=C_alloc(8);
t4=C_a_i_string(&a,1,t3);
t5=C_slot(t4,C_fix(0));
t6=C_block_size(t5);
/* library.scm:1260: add */
t7=((C_word*)((C_word*)t0)[2])[1];
f_13943(t7,t1,t5,C_fix(0),C_fixnum_difference(t6,C_fix(1)));}

/* a13990 in k13939 in k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void C_ccall f_13991(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_13991,c,av);}
/* library.scm:1262: add */
t6=((C_word*)((C_word*)t0)[2])[1];
f_13943(t6,t1,t3,t4,t5);}

/* a13996 in k13939 in k13936 in scheme#open-output-bytevector in k12559 in k11436 */
static void C_ccall f_13997(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_13997,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_i_slot(((C_word*)t0)[2],C_fix(8),C_SCHEME_TRUE);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#get-output-bytevector in k12559 in k11436 */
static void C_ccall f_14003(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_14003,c,av);}
a=C_alloc(9);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_14006,a[2]=t2,a[3]=((C_word)li235),tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_14013,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:1275: ##sys#check-port */
t5=*((C_word*)lf[333]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
av2[3]=lf[331];
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* fail in scheme#get-output-bytevector in k12559 in k11436 */
static void f_14006(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,4)))){
C_save_and_reclaim_args((void *)trf_14006,2,t0,t1);}
/* library.scm:1274: chicken.base#error */
t2=*((C_word*)lf[234]+1);{
C_word av2[5];
av2[0]=t2;
av2[1]=t1;
av2[2]=lf[331];
av2[3]=lf[332];
av2[4]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k14011 in scheme#get-output-bytevector in k12559 in k11436 */
static void C_ccall f_14013(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14013,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(7));
t3=C_eqp(t2,lf[327]);
if(C_truep(t3)){
t4=C_slot(((C_word*)t0)[2],C_fix(9));
if(C_truep(C_i_closurep(t4))){
/* library.scm:1279: getter */
t5=t4;{
C_word *av2=av;
av2[0]=t5;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
/* library.scm:1280: fail */
t5=((C_word*)t0)[4];
f_14006(t5,((C_word*)t0)[3]);}}
else{
/* library.scm:1281: fail */
t4=((C_word*)t0)[4];
f_14006(t4,((C_word*)t0)[3]);}}

/* chicken.fixnum#fx+ in k12559 in k11436 */
static void C_ccall f_14050(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14050,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_plus(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx- in k12559 in k11436 */
static void C_ccall f_14053(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14053,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_difference(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx* in k12559 in k11436 */
static void C_ccall f_14056(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14056,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_times(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx= in k12559 in k11436 */
static void C_ccall f_14059(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14059,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_eqp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx> in k12559 in k11436 */
static void C_ccall f_14065(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14065,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_greaterp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx< in k12559 in k11436 */
static void C_ccall f_14068(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14068,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_lessp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx>= in k12559 in k11436 */
static void C_ccall f_14071(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14071,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_greater_or_equal_p(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx<= in k12559 in k11436 */
static void C_ccall f_14074(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14074,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_less_or_equal_p(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxmin in k12559 in k11436 */
static void C_ccall f_14077(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14077,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_fixnum_min(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxmax in k12559 in k11436 */
static void C_ccall f_14080(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14080,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_fixnum_max(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxneg in k12559 in k11436 */
static void C_ccall f_14083(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14083,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_fixnum_negate(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.fixnum#fxand in k12559 in k11436 */
static void C_ccall f_14086(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14086,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_and(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxior in k12559 in k11436 */
static void C_ccall f_14089(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14089,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_or(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxxor in k12559 in k11436 */
static void C_ccall f_14092(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14092,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_xor(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxnot in k12559 in k11436 */
static void C_ccall f_14095(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14095,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_fixnum_not(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.fixnum#fxshl in k12559 in k11436 */
static void C_ccall f_14098(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14098,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_shift_left(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxshr in k12559 in k11436 */
static void C_ccall f_14101(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14101,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_shift_right(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxodd? in k12559 in k11436 */
static void C_ccall f_14104(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14104,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_fixnumoddp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.fixnum#fxeven? in k12559 in k11436 */
static void C_ccall f_14107(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14107,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_fixnumevenp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.fixnum#fxlen in k12559 in k11436 */
static void C_ccall f_14110(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14110,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_fixnum_length(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.fixnum#fx/ in k12559 in k11436 */
static void C_ccall f_14113(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14113,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_divide(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxgcd in k12559 in k11436 */
static void C_ccall f_14116(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14116,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_fixnum_gcd(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxmod in k12559 in k11436 */
static void C_ccall f_14119(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14119,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fixnum_modulo(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fxrem in k12559 in k11436 */
static void C_ccall f_14122(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14122,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_fixnum_remainder_checked(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx+? in k12559 in k11436 */
static void C_ccall f_14125(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14125,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_o_fixnum_plus(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx-? in k12559 in k11436 */
static void C_ccall f_14128(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14128,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_o_fixnum_difference(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx*? in k12559 in k11436 */
static void C_ccall f_14131(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14131,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_o_fixnum_times(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.fixnum#fx/? in k12559 in k11436 */
static void C_ccall f_14134(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14134,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_o_fixnum_quotient(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#debug-mode? in k12559 in k11436 */
static void C_ccall f_14137(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14137,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_debug_modep();
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#warning in k12559 in k11436 */
static void C_ccall f_14142(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,5)))){
C_save_and_reclaim((void*)f_14142,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
if(C_truep(*((C_word*)lf[369]+1))){{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[372];
av2[4]=t2;
av2[5]=t3;
C_apply(6,av2);}}
else{
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* chicken.base#notice in k12559 in k11436 */
static void C_ccall f_14151(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,5)))){
C_save_and_reclaim((void*)f_14151,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
t4=(C_truep(*((C_word*)lf[370]+1))?*((C_word*)lf[369]+1):C_SCHEME_FALSE);
if(C_truep(t4)){{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[374];
av2[4]=t2;
av2[5]=t3;
C_apply(6,av2);}}
else{
t5=C_SCHEME_UNDEFINED;
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* chicken.base#enable-warnings in k12559 in k11436 */
static void C_ccall f_14163(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14163,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+0);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
if(C_truep(C_i_pairp(t2))){
t3=C_mutate((C_word*)lf[369]+1 /* (set! ##sys#warnings-enabled ...) */,C_get_rest_arg(c,2,av,2,t0));
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=*((C_word*)lf[369]+1);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=*((C_word*)lf[369]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* ##sys#error/errno in k12559 in k11436 */
static void C_ccall f_14177(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,6)))){
C_save_and_reclaim((void*)f_14177,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
if(C_truep(C_i_pairp(t3))){{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_fast_retrieve(lf[379]);
av2[3]=lf[236];
av2[4]=t2;
av2[5]=C_SCHEME_FALSE;
av2[6]=t3;
C_apply(7,av2);}}
else{
/* library.scm:1366: ##sys#signal-hook/errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[379]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[379]+1);
av2[1]=t1;
av2[2]=lf[236];
av2[3]=t2;
av2[4]=C_SCHEME_FALSE;
tp(5,av2);}}}

/* ##sys#setslot in k12559 in k11436 */
static void C_ccall f_14193(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14193,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_setslot(t2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#setislot in k12559 in k11436 */
static void C_ccall f_14196(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14196,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_set_i_slot(t2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#start-timer in k12559 in k11436 */
static void C_ccall f_14205(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_14205,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14209,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:1381: ##sys#gc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[380]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[380]+1);
av2[1]=t2;
av2[2]=C_SCHEME_TRUE;
tp(3,av2);}}

/* k14207 in ##sys#start-timer in k12559 in k11436 */
static void C_ccall f_14209(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14209,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_start_timer();
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#stop-timer in k12559 in k11436 */
static void C_ccall f_14211(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_14211,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_stop_timer,a[2]=((C_word)li280),tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_14215,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:1385: g1515 */
t4=t2;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)C_fast_retrieve_proc(t4))(2,av2);}}

/* k14213 in ##sys#stop-timer in k12559 in k11436 */
static void C_ccall f_14215(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_14215,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_14218,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:1388: ##sys#gc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[380]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[380]+1);
av2[1]=t2;
av2[2]=C_SCHEME_TRUE;
tp(3,av2);}}

/* k14216 in k14213 in ##sys#stop-timer in k12559 in k11436 */
static void C_ccall f_14218(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_14218,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_stop_timer,a[2]=((C_word)li281),tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_14229,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:1389: g1517 */
t4=t2;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)C_fast_retrieve_proc(t4))(2,av2);}}

/* k14227 in k14216 in k14213 in ##sys#stop-timer in k12559 in k11436 */
static void C_ccall f_14229(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14229,c,av);}
t2=C_slot(t1,C_fix(6));
t3=C_i_setslot(((C_word*)t0)[2],C_fix(6),t2);
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#immediate? in k12559 in k11436 */
static void C_ccall f_14231(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14231,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_not(C_blockp(t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#message in k12559 in k11436 */
static void C_ccall f_14238(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14238,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_message(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#byte in k12559 in k11436 */
static void C_ccall f_14241(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14241,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_subbyte(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#halt in k12559 in k11436 */
static void C_ccall f_14246(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14246,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_halt(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#block-ref in k12559 in k11436 */
static void C_ccall f_14250(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14250,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_block_ref(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#block-set! in k12559 in k11436 */
static void C_ccall f_14255(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_14255,c,av);}
a=C_alloc(6);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_14259,a[2]=t2,a[3]=t3,a[4]=t1,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
t6=C_i_not(C_blockp(t2));
if(C_truep(t6)){
if(C_truep(t6)){
/* library.scm:1407: ##sys#signal-hook */
t7=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t7;
av2[1]=t5;
av2[2]=lf[295];
av2[3]=lf[400];
av2[4]=lf[401];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t7+1)))(6,av2);}}
else{
t7=t5;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_SCHEME_UNDEFINED;
f_14259(2,av2);}}}
else{
t7=(C_truep(C_specialp(t2))?C_eqp(t3,C_fix(0)):C_SCHEME_FALSE);
if(C_truep(t7)){
if(C_truep(t7)){
/* library.scm:1407: ##sys#signal-hook */
t8=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t8;
av2[1]=t5;
av2[2]=lf[295];
av2[3]=lf[400];
av2[4]=lf[401];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t8+1)))(6,av2);}}
else{
t8=t5;{
C_word *av2=av;
av2[0]=t8;
av2[1]=C_SCHEME_UNDEFINED;
f_14259(2,av2);}}}
else{
if(C_truep(C_byteblockp(t2))){
/* library.scm:1407: ##sys#signal-hook */
t8=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t8;
av2[1]=t5;
av2[2]=lf[295];
av2[3]=lf[400];
av2[4]=lf[401];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t8+1)))(6,av2);}}
else{
t8=t5;{
C_word *av2=av;
av2[0]=t8;
av2[1]=C_SCHEME_UNDEFINED;
f_14259(2,av2);}}}}}

/* k14257 in ##sys#block-set! in k12559 in k11436 */
static void C_ccall f_14259(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_14259,c,av);}
t2=C_block_size(((C_word*)t0)[2]);
t3=C_i_check_range_2(((C_word*)t0)[3],C_fix(0),t2,lf[400]);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_setslot(((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[5]);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.time#current-process-milliseconds in k12559 in k11436 */
static void C_ccall f_14290(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,1)))){
C_save_and_reclaim((void *)f_14290,c,av);}
a=C_alloc(7);
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_current_process_milliseconds(&a,1,C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.time#current-seconds in k12559 in k11436 */
static void C_ccall f_14293(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,1)))){
C_save_and_reclaim((void *)f_14293,c,av);}
a=C_alloc(7);
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_get_current_seconds(&a,1,C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.time#cpu-time in k12559 in k11436 */
static void C_ccall f_14296(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_14296,c,av);}
a=C_alloc(11);
t2=C_a_i_vector2(&a,2,C_SCHEME_FALSE,C_SCHEME_FALSE);
t3=C_a_i_cpu_time(&a,1,t2);
/* library.scm:1436: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_slot(t2,C_fix(0));
av2[3]=C_slot(t2,C_fix(1));
C_values(4,av2);}}

/* ##sys#check-structure in k12559 in k11436 */
static void C_ccall f_14313(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14313,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+0);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=C_i_pairp(t4);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=(C_truep(t5)?C_i_check_structure_2(t2,t3,C_get_rest_arg(c,4,av,4,t0)):C_i_check_structure(t2,t3));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* ##sys#check-blob in k12559 in k11436 */
static void C_ccall f_14324(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14324,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_bytevector_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_bytevector(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-pair in k12559 in k11436 */
static void C_ccall f_14335(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14335,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_pair_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_pair(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-list in k12559 in k11436 */
static void C_ccall f_14346(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14346,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_list_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_list(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-string in k12559 in k11436 */
static void C_ccall f_14357(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14357,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_string_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_string(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-number in k12559 in k11436 */
static void C_ccall f_14368(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14368,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_number_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_number(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-fixnum in k12559 in k11436 */
static void C_ccall f_14379(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14379,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_fixnum_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_fixnum(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-bytevector in k12559 in k11436 */
static void C_ccall f_14390(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14390,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_bytevector_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_bytevector(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-exact in k12559 in k11436 */
static void C_ccall f_14401(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14401,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_exact_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_exact(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-inexact in k12559 in k11436 */
static void C_ccall f_14412(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14412,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_inexact_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_inexact(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-symbol in k12559 in k11436 */
static void C_ccall f_14423(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14423,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_symbol_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_symbol(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-keyword in k12559 in k11436 */
static void C_ccall f_14434(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14434,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_keyword_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_keyword(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-vector in k12559 in k11436 */
static void C_ccall f_14445(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14445,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_vector_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_vector(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-char in k12559 in k11436 */
static void C_ccall f_14456(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14456,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_char_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_char(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-boolean in k12559 in k11436 */
static void C_ccall f_14467(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14467,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_boolean_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_boolean(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-locative in k12559 in k11436 */
static void C_ccall f_14478(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14478,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_locative_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_locative(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-integer in k12559 in k11436 */
static void C_ccall f_14489(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,3)))){
C_save_and_reclaim((void*)f_14489,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
if(C_truep(C_i_integerp(t2))){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_i_pairp(t3))){
/* library.scm:1525: ##sys#error-bad-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[423]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[423]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_get_rest_arg(c,3,av,3,t0);
tp(4,av2);}}
else{
/* library.scm:1525: ##sys#error-bad-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[423]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[423]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_FALSE;
tp(4,av2);}}}}

/* ##sys#check-exact-integer in k12559 in k11436 */
static void C_ccall f_14506(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,3)))){
C_save_and_reclaim((void*)f_14506,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
if(C_truep(C_i_exact_integerp(t2))){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_i_pairp(t3))){
/* library.scm:1529: ##sys#error-bad-exact-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[425]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[425]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_get_rest_arg(c,3,av,3,t0);
tp(4,av2);}}
else{
/* library.scm:1529: ##sys#error-bad-exact-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[425]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[425]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_FALSE;
tp(4,av2);}}}}

/* ##sys#check-exact-uinteger in k12559 in k11436 */
static void C_ccall f_14523(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,3)))){
C_save_and_reclaim((void*)f_14523,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
C_word t7;
t4=C_i_not(C_i_exact_integerp(t2));
t5=(C_truep(t4)?t4:C_i_integer_negativep(t2));
if(C_truep(t5)){
if(C_truep(C_i_pairp(t3))){
/* library.scm:1534: ##sys#error-bad-exact-uinteger */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[427]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[427]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_get_rest_arg(c,3,av,3,t0);
tp(4,av2);}}
else{
/* library.scm:1534: ##sys#error-bad-exact-uinteger */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[427]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[427]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_FALSE;
tp(4,av2);}}}
else{
t6=C_SCHEME_UNDEFINED;
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}

/* ##sys#check-real in k12559 in k11436 */
static void C_ccall f_14547(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,3)))){
C_save_and_reclaim((void*)f_14547,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
if(C_truep(C_i_realp(t2))){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_i_pairp(t3))){
/* library.scm:1538: ##sys#error-bad-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[429]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[429]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_get_rest_arg(c,3,av,3,t0);
tp(4,av2);}}
else{
/* library.scm:1538: ##sys#error-bad-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[429]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[429]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_FALSE;
tp(4,av2);}}}}

/* ##sys#check-range in k12559 in k11436 */
static void C_ccall f_14564(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c<5) C_bad_min_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-5)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14564,c,av);}
a=C_alloc((c-5)*C_SIZEOF_PAIR+0);
t5=C_build_rest(&a,c,5,av);
C_word t6;
C_word t7;
t6=C_i_pairp(t5);
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=(C_truep(t6)?C_i_check_range_2(t2,t3,t4,C_get_rest_arg(c,5,av,5,t0)):C_i_check_range(t2,t3,t4));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* ##sys#check-range/including in k12559 in k11436 */
static void C_ccall f_14575(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c<5) C_bad_min_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-5)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14575,c,av);}
a=C_alloc((c-5)*C_SIZEOF_PAIR+0);
t5=C_build_rest(&a,c,5,av);
C_word t6;
C_word t7;
t6=C_i_pairp(t5);
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=(C_truep(t6)?C_i_check_range_including_2(t2,t3,t4,C_get_rest_arg(c,5,av,5,t0)):C_i_check_range_including(t2,t3,t4));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* ##sys#check-special in k12559 in k11436 */
static void C_ccall f_14586(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,5)))){
C_save_and_reclaim((void*)f_14586,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
t4=(C_truep(C_blockp(t2))?C_specialp(t2):C_SCHEME_FALSE);
if(C_truep(t4)){
t5=C_SCHEME_UNDEFINED;
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
if(C_truep(C_i_pairp(t3))){
/* library.scm:1552: ##sys#signal-hook */
t5=*((C_word*)lf[235]+1);{
C_word av2[6];
av2[0]=t5;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=C_get_rest_arg(c,3,av,3,t0);
av2[4]=lf[433];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(6,av2);}}
else{
/* library.scm:1552: ##sys#signal-hook */
t5=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t5;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=C_SCHEME_FALSE;
av2[4]=lf[433];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(6,av2);}}}}

/* ##sys#check-closure in k12559 in k11436 */
static void C_ccall f_14606(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_14606,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_closure_2(t2,C_get_rest_arg(c,3,av,3,t0)):C_i_check_closure(t2));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#force in k12559 in k11436 */
static void C_ccall f_14617(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_14617,c,av);}
a=C_alloc(6);
if(C_truep(C_i_structurep(t2,lf[250]))){
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_14629,a[2]=t4,a[3]=((C_word)li319),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_14629(t6,t1,t2,C_SCHEME_FALSE);}
else{
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* lp in scheme#force in k12559 in k11436 */
static void f_14629(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_14629,4,t0,t1,t2,t3);}
a=C_alloc(6);
t4=C_slot(t2,C_fix(1));
if(C_truep(C_i_nullp(t4))){
/* library.scm:1565: ##sys#values */{
C_word av2[2];
av2[0]=0;
av2[1]=t1;
C_values(2,av2);}}
else{
if(C_truep(C_i_pairp(t4))){{
C_word av2[3];
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
C_apply_values(3,av2);}}
else{
if(C_truep(C_i_closurep(t4))){
t5=(C_truep(t3)?C_i_setslot(t3,C_fix(1),t2):C_SCHEME_UNDEFINED);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_14663,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* library.scm:1569: ##sys#call-with-values */{
C_word av2[4];
av2[0]=0;
av2[1]=t6;
av2[2]=t4;
av2[3]=*((C_word*)lf[436]+1);
C_call_with_values(4,av2);}}
else{
if(C_truep(C_i_structurep(t4,lf[250]))){
/* library.scm:1581: lp */
t8=t1;
t9=t4;
t10=t3;
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}}}}

/* k14661 in lp in scheme#force in k12559 in k11436 */
static void C_ccall f_14663(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_14663,c,av);}
a=C_alloc(6);
t2=C_slot(((C_word*)t0)[2],C_fix(1));
t3=C_i_closurep(t2);
if(C_truep(C_i_not(t3))){
/* library.scm:1571: lp */
t4=((C_word*)((C_word*)t0)[3])[1];
f_14629(t4,((C_word*)t0)[4],((C_word*)t0)[2],((C_word*)t0)[5]);}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_14678,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t5=C_i_nullp(t1);
if(C_truep(C_i_not(t5))){
t6=C_i_cdr(t1);
t7=C_i_nullp(t6);
t8=t4;
f_14678(t8,(C_truep(t7)?C_i_structurep(C_slot(t1,C_fix(0)),lf[250]):C_SCHEME_FALSE));}
else{
t6=t4;
f_14678(t6,C_SCHEME_FALSE);}}}

/* k14676 in k14661 in lp in scheme#force in k12559 in k11436 */
static void f_14678(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,3)))){
C_save_and_reclaim_args((void *)trf_14678,2,t0,t1);}
if(C_truep(t1)){
t2=C_slot(((C_word*)t0)[2],C_fix(0));
t3=C_slot(t2,C_fix(1));
t4=C_i_setslot(((C_word*)t0)[3],C_fix(1),t3);
/* library.scm:1576: lp */
t5=((C_word*)((C_word*)t0)[4])[1];
f_14629(t5,((C_word*)t0)[5],((C_word*)t0)[3],t2);}
else{
t2=C_i_setslot(((C_word*)t0)[3],C_fix(1),((C_word*)t0)[2]);{
C_word av2[3];
av2[0]=0;
av2[1]=((C_word*)t0)[5];
av2[2]=((C_word*)t0)[2];
C_apply_values(3,av2);}}}

/* ##sys#error-not-a-proper-list in k12559 in k11436 */
static void C_ccall f_14745(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_14745,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=C_fix((C_word)C_NOT_A_PROPER_LIST_ERROR);
/* library.scm:1591: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=C_SCHEME_FALSE;
av2[4]=t2;
tp(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_fix((C_word)C_NOT_A_PROPER_LIST_ERROR);
/* library.scm:1591: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t3;
av2[4]=t2;
tp(5,av2);}}}

/* ##sys#error-bad-number in k12559 in k11436 */
static void C_ccall f_14761(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_14761,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_NUMBER_ERROR);
/* library.scm:1595: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=C_SCHEME_FALSE;
av2[4]=t2;
tp(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_NUMBER_ERROR);
/* library.scm:1595: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t3;
av2[4]=t2;
tp(5,av2);}}}

/* ##sys#error-bad-integer in k12559 in k11436 */
static void C_ccall f_14777(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_14777,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_INTEGER_ERROR);
/* library.scm:1599: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=C_SCHEME_FALSE;
av2[4]=t2;
tp(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_INTEGER_ERROR);
/* library.scm:1599: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t3;
av2[4]=t2;
tp(5,av2);}}}

/* ##sys#error-bad-exact-integer in k12559 in k11436 */
static void C_ccall f_14793(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_14793,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_INTEGER_ERROR);
/* library.scm:1603: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=C_SCHEME_FALSE;
av2[4]=t2;
tp(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_INTEGER_ERROR);
/* library.scm:1603: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t3;
av2[4]=t2;
tp(5,av2);}}}

/* ##sys#error-bad-exact-uinteger in k12559 in k11436 */
static void C_ccall f_14809(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_14809,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_UINTEGER_ERROR);
/* library.scm:1607: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=C_SCHEME_FALSE;
av2[4]=t2;
tp(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_UINTEGER_ERROR);
/* library.scm:1607: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t3;
av2[4]=t2;
tp(5,av2);}}}

/* ##sys#error-bad-inexact in k12559 in k11436 */
static void C_ccall f_14825(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_14825,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=C_fix((C_word)C_CANT_REPRESENT_INEXACT_ERROR);
/* library.scm:1611: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=C_SCHEME_FALSE;
av2[4]=t2;
tp(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_fix((C_word)C_CANT_REPRESENT_INEXACT_ERROR);
/* library.scm:1611: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t3;
av2[4]=t2;
tp(5,av2);}}}

/* ##sys#error-bad-real in k12559 in k11436 */
static void C_ccall f_14841(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_14841,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_REAL_ERROR);
/* library.scm:1615: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=C_SCHEME_FALSE;
av2[4]=t2;
tp(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_REAL_ERROR);
/* library.scm:1615: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t3;
av2[4]=t2;
tp(5,av2);}}}

/* ##sys#error-bad-base in k12559 in k11436 */
static void C_ccall f_14857(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_14857,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=C_fix((C_word)C_BAD_ARGUMENT_TYPE_BAD_BASE_ERROR);
/* library.scm:1619: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=C_SCHEME_FALSE;
av2[4]=t2;
tp(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_BAD_BASE_ERROR);
/* library.scm:1619: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t3;
av2[4]=t2;
tp(5,av2);}}}

/* scheme#append in k12559 in k11436 */
static void C_ccall f_14873(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +6,c,3)))){
C_save_and_reclaim((void*)f_14873,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+6);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
t3=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(t3)){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_14885,a[2]=t5,a[3]=((C_word)li332),tmp=(C_word)a,a+=4,tmp));
t7=((C_word*)t5)[1];
f_14885(t7,t1,t2);}}

/* loop in scheme#append in k12559 in k11436 */
static void f_14885(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_14885,3,t0,t1,t2);}
a=C_alloc(8);
t3=C_slot(t2,C_fix(1));
t4=C_eqp(t3,C_SCHEME_END_OF_LIST);
if(C_truep(t4)){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_slot(t2,C_fix(0));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_slot(t2,C_fix(0));
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_14904,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=t7,a[5]=((C_word)li331),tmp=(C_word)a,a+=6,tmp));
t9=((C_word*)t7)[1];
f_14904(t9,t1,t5);}}

/* copy in loop in scheme#append in k12559 in k11436 */
static void f_14904(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(4,0,3)))){
C_save_and_reclaim_args((void *)trf_14904,3,t0,t1,t2);}
a=C_alloc(4);
t3=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(t3)){
/* library.scm:1630: loop */
t4=((C_word*)((C_word*)t0)[2])[1];
f_14885(t4,t1,C_slot(((C_word*)t0)[3],C_fix(1)));}
else{
if(C_truep(C_i_pairp(t2))){
t4=C_slot(t2,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_14935,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:1632: copy */
t7=t5;
t8=C_slot(t2,C_fix(1));
t1=t7;
t2=t8;
goto loop;}
else{
/* library.scm:1634: ##sys#error-not-a-proper-list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t1;
av2[2]=C_slot(((C_word*)t0)[3],C_fix(0));
av2[3]=lf[444];
tp(4,av2);}}}}

/* k14933 in copy in loop in scheme#append in k12559 in k11436 */
static void C_ccall f_14935(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_14935,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#fast-reverse in k12559 in k11436 */
static void C_ccall f_14952(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_14952,c,av);}
a=C_alloc(6);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_14958,a[2]=t4,a[3]=((C_word)li334),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_14958(t6,t1,t2,C_SCHEME_END_OF_LIST);}

/* loop in ##sys#fast-reverse in k12559 in k11436 */
static void f_14958(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,3)))){
C_save_and_reclaim_args((void *)trf_14958,4,t0,t1,t2,t3);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t4=C_slot(t2,C_fix(1));
t5=C_slot(t2,C_fix(0));
t6=C_a_i_cons(&a,2,t5,t3);
/* library.scm:1640: loop */
t8=t1;
t9=t4;
t10=t6;
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* ##sys#make-bytevector in k12559 in k11436 */
static void C_ccall f_14982(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_14982,c,av);}
if(C_truep(C_rest_nullp(c,3))){
/* library.scm:1647: ##sys#allocate-bytevector */
t3=*((C_word*)lf[384]+1);{
C_word av2[4];
av2[0]=t3;
av2[1]=t1;
av2[2]=t2;
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}
else{
/* library.scm:1647: ##sys#allocate-bytevector */
t3=*((C_word*)lf[384]+1);{
C_word av2[4];
av2[0]=t3;
av2[1]=t1;
av2[2]=t2;
av2[3]=C_get_rest_arg(c,3,av,3,t0);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}}

/* ##sys#make-string in k12559 in k11436 */
static void C_ccall f_14997(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_14997,c,av);}
a=C_alloc(5);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_make_character(32):C_get_rest_arg(c,3,av,3,t0));
t5=C_utf_bytes(t4);
t6=C_fixnum_times(t5,t2);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15007,a[2]=t4,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:1652: ##sys#allocate-bytevector */
t8=*((C_word*)lf[384]+1);{
C_word av2[4];
av2[0]=t8;
av2[1]=t7;
av2[2]=C_fixnum_plus(t6,C_fix(1));
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t8+1)))(4,av2);}}

/* k15005 in ##sys#make-string in k12559 in k11436 */
static void C_ccall f_15007(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_15007,c,av);}
a=C_alloc(5);
t2=C_utf_fill(t1,((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_ustring(&a,2,t1,((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#buffer->string in k12559 in k11436 */
static void C_ccall f_15019(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_15019,c,av);}
a=C_alloc(6);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15023,a[2]=t2,a[3]=t3,a[4]=t4,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:1657: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=C_fixnum_plus(t4,C_fix(1));
tp(3,av2);}}

/* k15021 in ##sys#buffer->string in k12559 in k11436 */
static void C_ccall f_15023(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_15023,c,av);}
a=C_alloc(5);
t2=C_copy_memory_with_offset(t1,((C_word*)t0)[2],C_fix(0),((C_word*)t0)[3],((C_word*)t0)[4]);
t3=C_utf_range_length(t1,C_fix(0),((C_word*)t0)[4]);
t4=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_ustring(&a,2,t1,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#utf-decoder in k12559 in k11436 */
static void C_ccall f_15030(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_15030,c,av);}
/* library.scm:1663: k */
t6=t5;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
av2[4]=t4;
((C_proc)C_fast_retrieve_proc(t6))(5,av2);}}

/* ##sys#utf-encoder in k12559 in k11436 */
static void C_ccall f_15036(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_15036,c,av);}
/* library.scm:1666: k */
t6=t5;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
av2[4]=t4;
((C_proc)C_fast_retrieve_proc(t6))(5,av2);}}

/* ##sys#utf-scanner in k12559 in k11436 */
static void C_ccall f_15042(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_15042,c,av);}
if(C_truep(t2)){
t4=C_fixnum_greaterp(t2,C_fix(1));
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=(C_truep(t4)?C_fixnum_difference(t2,C_fix(1)):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t4=C_utf_bytes_needed(t3);
t5=C_eqp(t4,C_fix(1));
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=(C_truep(t5)?C_SCHEME_FALSE:C_fixnum_difference(t4,C_fix(1)));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* ##sys#latin-decoder in k12559 in k11436 */
static void C_ccall f_15066(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_15066,c,av);}
a=C_alloc(7);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15070,a[2]=t5,a[3]=t1,a[4]=t2,a[5]=t3,a[6]=t4,tmp=(C_word)a,a+=7,tmp);
/* library.scm:1679: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=C_fixnum_times(t4,C_fix(2));
tp(3,av2);}}

/* k15068 in ##sys#latin-decoder in k12559 in k11436 */
static void C_ccall f_15070(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_15070,c,av);}
/* library.scm:1681: k */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
av2[3]=C_fix(0);
av2[4]=C_latin_to_utf(((C_word*)t0)[4],t1,((C_word*)t0)[5],((C_word*)t0)[6]);
((C_proc)C_fast_retrieve_proc(t2))(5,av2);}}

/* ##sys#latin-encoder in k12559 in k11436 */
static void C_ccall f_15079(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_15079,c,av);}
a=C_alloc(7);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15083,a[2]=t5,a[3]=t1,a[4]=t2,a[5]=t3,a[6]=t4,tmp=(C_word)a,a+=7,tmp);
/* library.scm:1684: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=C_fixnum_plus(t4,C_fix(1));
tp(3,av2);}}

/* k15081 in ##sys#latin-encoder in k12559 in k11436 */
static void C_ccall f_15083(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_15083,c,av);}
/* library.scm:1686: k */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
av2[3]=C_fix(0);
av2[4]=C_utf_to_latin(((C_word*)t0)[4],t1,((C_word*)t0)[5],((C_word*)t0)[6]);
((C_proc)C_fast_retrieve_proc(t2))(5,av2);}}

/* ##sys#latin-scanner in k12559 in k11436 */
static void C_ccall f_15092(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_15092,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#binary-decoder in k12559 in k11436 */
static void C_ccall f_15095(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_15095,c,av);}
/* library.scm:1691: k */
t6=t5;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
av2[4]=t4;
((C_proc)C_fast_retrieve_proc(t6))(5,av2);}}

/* ##sys#binary-encoder in k12559 in k11436 */
static void C_ccall f_15101(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_15101,c,av);}
/* library.scm:1694: k */
t6=t5;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
av2[4]=t4;
((C_proc)C_fast_retrieve_proc(t6))(5,av2);}}

/* ##sys#binary-scanner in k12559 in k11436 */
static void C_ccall f_15107(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_15107,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#encoding-hook in k12559 in k11436 */
static void C_ccall f_15110(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_15110,c,av);}
t4=C_eqp(t2,lf[167]);
if(C_truep(t4)){
/* library.scm:1701: k */
t5=t3;{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t5;
av2[1]=t1;
av2[2]=*((C_word*)lf[453]+1);
av2[3]=*((C_word*)lf[454]+1);
av2[4]=*((C_word*)lf[455]+1);
((C_proc)C_fast_retrieve_proc(t5))(5,av2);}}
else{
t5=C_eqp(t2,lf[457]);
if(C_truep(t5)){
/* library.scm:1702: k */
t6=t3;{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t6;
av2[1]=t1;
av2[2]=*((C_word*)lf[447]+1);
av2[3]=*((C_word*)lf[448]+1);
av2[4]=*((C_word*)lf[449]+1);
((C_proc)C_fast_retrieve_proc(t6))(5,av2);}}
else{
t6=C_eqp(t2,lf[458]);
if(C_truep(t6)){
/* library.scm:1703: k */
t7=t3;{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t7;
av2[1]=t1;
av2[2]=*((C_word*)lf[450]+1);
av2[3]=*((C_word*)lf[451]+1);
av2[4]=*((C_word*)lf[452]+1);
((C_proc)C_fast_retrieve_proc(t7))(5,av2);}}
else{
/* library.scm:1704: ##sys#signal-hook */
t7=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t7;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=C_SCHEME_FALSE;
av2[4]=lf[459];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t7+1)))(6,av2);}}}}}

/* ##sys#register-encoding in k12559 in k11436 */
static void C_ccall f_15149(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_15149,c,av);}
a=C_alloc(7);
t6=*((C_word*)lf[456]+1);
t7=C_mutate((C_word*)lf[456]+1 /* (set! ##sys#encoding-hook ...) */,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15152,a[2]=t2,a[3]=t3,a[4]=t5,a[5]=t6,a[6]=((C_word)li349),tmp=(C_word)a,a+=7,tmp));
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}

/* ##sys#encoding-hook in ##sys#register-encoding in k12559 in k11436 */
static void C_ccall f_15152(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_15152,c,av);}
a=C_alloc(8);
t4=C_eqp(t2,((C_word*)t0)[2]);
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_15162,a[2]=t3,a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
if(C_truep(t4)){
t6=t5;
f_15162(t6,t4);}
else{
t6=C_i_pairp(((C_word*)t0)[2]);
t7=t5;
f_15162(t7,(C_truep(t6)?C_i_memq(t2,((C_word*)t0)[2]):C_SCHEME_FALSE));}}

/* k15160 in ##sys#encoding-hook in ##sys#register-encoding in k12559 in k11436 */
static void f_15162(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,4)))){
C_save_and_reclaim_args((void *)trf_15162,2,t0,t1);}
if(C_truep(t1)){
/* library.scm:1712: k */
t2=((C_word*)t0)[2];{
C_word av2[5];
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[5];
av2[4]=((C_word*)t0)[6];
((C_proc)C_fast_retrieve_proc(t2))(5,av2);}}
else{
/* library.scm:1713: old */
t2=((C_word*)t0)[7];{
C_word av2[4];
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[5];
av2[3]=((C_word*)t0)[2];
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}}

/* ##sys#buffer->string/encoding in k12559 in k11436 */
static void C_ccall f_15179(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_15179,c,av);}
a=C_alloc(6);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15185,a[2]=t2,a[3]=t3,a[4]=t4,a[5]=((C_word)li351),tmp=(C_word)a,a+=6,tmp);
/* library.scm:1717: ##sys#encoding-hook */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[456]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[456]+1);
av2[1]=t1;
av2[2]=t5;
av2[3]=t6;
tp(4,av2);}}

/* a15184 in ##sys#buffer->string/encoding in k12559 in k11436 */
static void C_ccall f_15185(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_15185,c,av);}
/* library.scm:1719: decoder */
t5=t2;{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t5;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
av2[4]=((C_word*)t0)[4];
av2[5]=*((C_word*)lf[300]+1);
((C_proc)C_fast_retrieve_proc(t5))(6,av2);}}

/* ##sys#encode-buffer in k12559 in k11436 */
static void C_ccall f_15191(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6=av[6];
C_word t7;
C_word t8;
C_word *a;
if(c!=7) C_bad_argc_2(c,7,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_15191,c,av);}
a=C_alloc(7);
t7=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15197,a[2]=t2,a[3]=t3,a[4]=t4,a[5]=t6,a[6]=((C_word)li353),tmp=(C_word)a,a+=7,tmp);
/* library.scm:1723: ##sys#encoding-hook */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[456]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[456]+1);
av2[1]=t1;
av2[2]=t5;
av2[3]=t7;
tp(4,av2);}}

/* a15196 in ##sys#encode-buffer in k12559 in k11436 */
static void C_ccall f_15197(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_15197,c,av);}
/* library.scm:1725: encoder */
t5=t3;{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t5;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
av2[4]=((C_word*)t0)[4];
av2[5]=((C_word*)t0)[5];
((C_proc)C_fast_retrieve_proc(t5))(6,av2);}}

/* ##sys#decode-buffer in k12559 in k11436 */
static void C_ccall f_15203(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6=av[6];
C_word t7;
C_word t8;
C_word *a;
if(c!=7) C_bad_argc_2(c,7,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_15203,c,av);}
a=C_alloc(7);
t7=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15209,a[2]=t2,a[3]=t3,a[4]=t4,a[5]=t6,a[6]=((C_word)li355),tmp=(C_word)a,a+=7,tmp);
/* library.scm:1729: ##sys#encoding-hook */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[456]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[456]+1);
av2[1]=t1;
av2[2]=t5;
av2[3]=t7;
tp(4,av2);}}

/* a15208 in ##sys#decode-buffer in k12559 in k11436 */
static void C_ccall f_15209(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_15209,c,av);}
/* library.scm:1731: decoder */
t5=t2;{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t5;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
av2[4]=((C_word*)t0)[4];
av2[5]=((C_word*)t0)[5];
((C_proc)C_fast_retrieve_proc(t5))(6,av2);}}

/* ##sys#encode-char in k12559 in k11436 */
static void C_ccall f_15215(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_15215,c,av);}
a=C_alloc(5);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15221,a[2]=t2,a[3]=t3,a[4]=((C_word)li358),tmp=(C_word)a,a+=5,tmp);
/* library.scm:1735: ##sys#encoding-hook */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[456]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[456]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
tp(4,av2);}}

/* a15220 in ##sys#encode-char in k12559 in k11436 */
static void C_ccall f_15221(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_15221,c,av);}
a=C_alloc(6);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15225,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:1738: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=C_fix(4);
tp(3,av2);}}

/* k15223 in a15220 in ##sys#encode-char in k12559 in k11436 */
static void C_ccall f_15225(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,5)))){
C_save_and_reclaim((void *)f_15225,c,av);}
a=C_alloc(4);
t2=C_utf_insert(t1,C_fix(0),((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_15230,a[2]=((C_word*)t0)[3],a[3]=((C_word)li357),tmp=(C_word)a,a+=4,tmp);
/* library.scm:1740: encoder */
t4=((C_word*)t0)[4];{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[5];
av2[2]=t1;
av2[3]=C_fix(0);
av2[4]=t2;
av2[5]=t3;
((C_proc)C_fast_retrieve_proc(t4))(6,av2);}}

/* a15229 in k15223 in a15220 in ##sys#encode-char in k12559 in k11436 */
static void C_ccall f_15230(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_15230,c,av);}
t5=C_copy_memory_with_offset(((C_word*)t0)[2],t2,C_fix(0),t3,t4);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* ##sys#decode-char in k12559 in k11436 */
static void C_ccall f_15233(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,6)))){
C_save_and_reclaim((void *)f_15233,c,av);}
a=C_alloc(3);
t5=C_block_size(t2);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_15243,a[2]=((C_word)li360),tmp=(C_word)a,a+=3,tmp);
/* library.scm:1746: ##sys#decode-buffer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[463]+1));
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[463]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=t4;
av2[4]=t5;
av2[5]=t3;
av2[6]=t6;
tp(7,av2);}}

/* a15242 in ##sys#decode-char in k12559 in k11436 */
static void C_ccall f_15243(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_15243,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_utf_decode(t2,t3);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#read-char/encoding in k12559 in k11436 */
static void C_ccall f_15246(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_15246,c,av);}
a=C_alloc(5);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15252,a[2]=t2,a[3]=t4,a[4]=((C_word)li363),tmp=(C_word)a,a+=5,tmp);
/* library.scm:1753: ##sys#encoding-hook */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[456]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[456]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=t5;
tp(4,av2);}}

/* a15251 in ##sys#read-char/encoding in k12559 in k11436 */
static void C_ccall f_15252(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_15252,c,av);}
a=C_alloc(7);
t5=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15256,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=t4,a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:1756: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=C_fix(4);
tp(3,av2);}}

/* k15254 in a15251 in ##sys#read-char/encoding in k12559 in k11436 */
static void C_ccall f_15256(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,4)))){
C_save_and_reclaim((void *)f_15256,c,av);}
a=C_alloc(12);
t2=C_slot(((C_word*)t0)[2],C_fix(2));
t3=C_slot(t2,C_fix(7));
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_15264,a[2]=t1,a[3]=t5,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=t3,a[8]=((C_word*)t0)[2],a[9]=((C_word)li362),tmp=(C_word)a,a+=10,tmp));
t7=((C_word*)t5)[1];
f_15264(t7,((C_word*)t0)[6],C_SCHEME_FALSE,C_fix(0));}

/* loop in k15254 in a15251 in ##sys#read-char/encoding in k12559 in k11436 */
static void f_15264(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,5)))){
C_save_and_reclaim_args((void *)trf_15264,4,t0,t1,t2,t3);}
a=C_alloc(10);
t4=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_15268,a[2]=t3,a[3]=t1,a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],a[9]=t2,tmp=(C_word)a,a+=10,tmp);
/* library.scm:1759: rbv! */
t5=((C_word*)t0)[7];{
C_word av2[6];
av2[0]=t5;
av2[1]=t4;
av2[2]=((C_word*)t0)[8];
av2[3]=C_fix(1);
av2[4]=((C_word*)t0)[2];
av2[5]=t3;
((C_proc)C_fast_retrieve_proc(t5))(6,av2);}}

/* k15266 in loop in k15254 in a15251 in ##sys#read-char/encoding in k12559 in k11436 */
static void C_ccall f_15268(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,6)))){
C_save_and_reclaim((void *)f_15268,c,av);}
a=C_alloc(8);
t2=C_eqp(C_fix(0),t1);
if(C_truep(t2)){
t3=C_eqp(((C_word*)t0)[2],C_fix(0));
if(C_truep(t3)){
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
/* library.scm:1763: ##sys#signal-hook */
t4=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
av2[2]=lf[467];
av2[3]=lf[468];
av2[4]=lf[469];
av2[5]=((C_word*)t0)[4];
av2[6]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(7,av2);}}}
else{
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_15286,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* library.scm:1764: scan */
t4=((C_word*)t0)[8];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[9];
av2[3]=C_subbyte(((C_word*)t0)[4],((C_word*)t0)[2]);
((C_proc)C_fast_retrieve_proc(t4))(4,av2);}}}

/* k15284 in k15266 in loop in k15254 in a15251 in ##sys#read-char/encoding in k12559 in k11436 */
static void C_ccall f_15286(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_15286,c,av);}
if(C_truep(t1)){
/* library.scm:1766: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_15264(t2,((C_word*)t0)[3],t1,C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}
else{
/* library.scm:1767: k */
t2=((C_word*)t0)[5];{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[6];
av2[3]=C_fix(0);
av2[4]=C_fixnum_plus(((C_word*)t0)[4],C_fix(1));
av2[5]=((C_word*)t0)[7];
((C_proc)C_fast_retrieve_proc(t2))(6,av2);}}}

/* scheme#make-string in k12559 in k11436 */
static void C_ccall f_15310(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +5,c,5)))){
C_save_and_reclaim((void*)f_15310,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+5);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
t4=C_i_check_fixnum_2(t2,lf[471]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15317,a[2]=t3,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fixnum_lessp(t2,C_fix(0)))){
/* library.scm:1773: ##sys#signal-hook */
t6=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[472];
av2[3]=lf[471];
av2[4]=lf[473];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(6,av2);}}
else{
t6=t5;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_UNDEFINED;
f_15317(2,av2);}}}

/* k15315 in scheme#make-string in k12559 in k11436 */
static void C_ccall f_15317(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_15317,c,av);}
if(C_truep(C_i_nullp(((C_word*)t0)[2]))){
/* library.scm:1774: ##sys#make-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[446]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[446]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=C_make_character(32);
tp(4,av2);}}
else{
t2=C_i_car(((C_word*)t0)[2]);
t3=C_i_check_char_2(t2,lf[471]);
/* library.scm:1774: ##sys#make-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[446]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[446]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=t2;
tp(4,av2);}}}

/* scheme#string->list in k12559 in k11436 */
static void C_ccall f_15341(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,5)))){
C_save_and_reclaim((void *)f_15341,c,av);}
a=C_alloc(11);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=t4;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_rest_nullp(c,3);
t8=C_rest_nullp(c,4);
t9=(C_truep(t8)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
t10=t9;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_rest_nullp(c,4);
t13=C_i_check_string_2(t2,lf[475]);
t14=C_slot(t2,C_fix(1));
t15=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15363,a[2]=t11,a[3]=t6,a[4]=t2,a[5]=t1,a[6]=t14,tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t6)[1])){
/* library.scm:1787: ##sys#check-range/including */
t16=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t16;
av2[1]=t15;
av2[2]=((C_word*)t6)[1];
av2[3]=C_fix(0);
av2[4]=t14;
av2[5]=lf[475];
((C_proc)(void*)(*((C_word*)t16+1)))(6,av2);}}
else{
t16=C_set_block_item(t6,0,C_fix(0));
t17=t15;{
C_word *av2=av;
av2[0]=t17;
av2[1]=t16;
f_15363(2,av2);}}}

/* k15361 in scheme#string->list in k12559 in k11436 */
static void C_ccall f_15363(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_15363,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15366,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
/* library.scm:1790: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[2])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[6];
av2[5]=lf[475];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}
else{
t3=C_mutate(((C_word *)((C_word*)t0)[2])+1,((C_word*)t0)[6]);
t4=t2;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
f_15366(2,av2);}}}

/* k15364 in k15361 in scheme#string->list in k12559 in k11436 */
static void C_ccall f_15366(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_15366,c,av);}
a=C_alloc(8);
t2=C_fixnum_difference(((C_word*)((C_word*)t0)[2])[1],C_fix(1));
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15375,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=t4,a[5]=((C_word)li366),tmp=(C_word)a,a+=6,tmp));
t6=((C_word*)t4)[1];
f_15375(t6,((C_word*)t0)[5],t2,C_SCHEME_END_OF_LIST);}

/* loop in k15364 in k15361 in scheme#string->list in k12559 in k11436 */
static void f_15375(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,3)))){
C_save_and_reclaim_args((void *)trf_15375,4,t0,t1,t2,t3);}
a=C_alloc(3);
if(C_truep(C_fixnum_lessp(t2,((C_word*)((C_word*)t0)[2])[1]))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fixnum_difference(t2,C_fix(1));
t5=C_i_string_ref(((C_word*)t0)[3],t2);
t6=C_a_i_cons(&a,2,t5,t3);
/* library.scm:1795: loop */
t8=t1;
t9=t4;
t10=t6;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}

/* scheme#list->string in k12559 in k11436 */
static void C_ccall f_15432(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_15432,c,av);}
a=C_alloc(4);
t3=C_i_listp(t2);
if(C_truep(C_i_not(t3))){
/* library.scm:1803: ##sys#error-not-a-proper-list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[478];
tp(4,av2);}}
else{
t4=C_utf_list_size(t2);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_15445,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:1805: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=C_fixnum_plus(C_fix(1),t4);
tp(3,av2);}}}

/* k15443 in scheme#list->string in k12559 in k11436 */
static void C_ccall f_15445(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_15445,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15450,a[2]=t1,a[3]=t3,a[4]=((C_word)li368),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_15450(t5,((C_word*)t0)[2],C_fix(0),C_fix(0),((C_word*)t0)[3]);}

/* loop in k15443 in scheme#list->string in k12559 in k11436 */
static void f_15450(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,4)))){
C_save_and_reclaim_args((void *)trf_15450,5,t0,t1,t2,t3,t4);}
a=C_alloc(5);
t5=C_i_pairp(t4);
if(C_truep(C_i_not(t5))){
t6=C_a_ustring(&a,2,((C_word*)t0)[2],t2);
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t6=C_slot(t4,C_fix(0));
t7=C_i_check_char_2(t6,lf[478]);
t8=C_utf_insert(((C_word*)t0)[2],t3,t6);
/* library.scm:1814: loop */
t10=t1;
t11=C_fixnum_plus(t2,C_fix(1));
t12=C_fixnum_plus(t3,C_utf_bytes(t6));
t13=C_slot(t4,C_fix(1));
t1=t10;
t2=t11;
t3=t12;
t4=t13;
goto loop;}}

/* ##sys#reverse-list->string in k12559 in k11436 */
static void C_ccall f_15494(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_15494,c,av);}
a=C_alloc(5);
t3=C_utf_list_size(t2);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15498,a[2]=t1,a[3]=t3,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:1822: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=C_fixnum_plus(t3,C_fix(1));
tp(3,av2);}}

/* k15496 in ##sys#reverse-list->string in k12559 in k11436 */
static void C_ccall f_15498(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_15498,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15503,a[2]=t1,a[3]=t3,a[4]=((C_word)li370),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_15503(t5,((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[4],C_fix(0));}

/* loop in k15496 in ##sys#reverse-list->string in k12559 in k11436 */
static void f_15503(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,4)))){
C_save_and_reclaim_args((void *)trf_15503,5,t0,t1,t2,t3,t4);}
a=C_alloc(5);
if(C_truep(C_i_nullp(t3))){
t5=C_a_ustring(&a,2,((C_word*)t0)[2],t4);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
if(C_truep(C_i_pairp(t3))){
t5=C_slot(t3,C_fix(0));
t6=C_i_check_char_2(t5,lf[481]);
t7=C_utf_bytes(t5);
t8=C_fixnum_difference(t2,t7);
t9=C_utf_insert(((C_word*)t0)[2],t8,t5);
/* library.scm:1832: loop */
t11=t1;
t12=t8;
t13=C_slot(t3,C_fix(1));
t14=C_fixnum_plus(t4,C_fix(1));
t1=t11;
t2=t12;
t3=t13;
t4=t14;
goto loop;}
else{
/* library.scm:1833: ##sys#error-not-a-proper-list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=lf[481];
tp(4,av2);}}}}

/* scheme#string-fill! in k12559 in k11436 */
static void C_ccall f_15545(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_15545,c,av);}
a=C_alloc(11);
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,4,t0));
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_rest_nullp(c,4);
t9=C_rest_nullp(c,5);
t10=(C_truep(t9)?C_SCHEME_FALSE:C_get_rest_arg(c,5,av,4,t0));
t11=t10;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_rest_nullp(c,5);
t14=C_i_check_string_2(t2,lf[483]);
t15=C_i_check_char_2(t3,lf[483]);
t16=C_u_i_string_length(t2);
t17=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15568,a[2]=t2,a[3]=t12,a[4]=t7,a[5]=t3,a[6]=t1,tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t7)[1])){
t18=C_i_check_range_2(((C_word*)t7)[1],C_fix(0),t16,lf[483]);
if(C_truep(((C_word*)t12)[1])){
t19=t17;
f_15568(t19,C_i_check_range_2(((C_word*)t12)[1],C_fix(0),t16,lf[483]));}
else{
t19=C_set_block_item(t12,0,t16);
t20=t17;
f_15568(t20,t19);}}
else{
t18=C_set_block_item(t7,0,C_fix(0));
t19=C_set_block_item(t12,0,t16);
t20=t17;
f_15568(t20,t19);}}

/* k15566 in scheme#string-fill! in k12559 in k11436 */
static void f_15568(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_15568,2,t0,t1);}
a=C_alloc(6);
t2=C_slot(((C_word*)t0)[2],C_fix(0));
t3=C_block_size(t2);
t4=C_fixnum_difference(((C_word*)((C_word*)t0)[3])[1],((C_word*)((C_word*)t0)[4])[1]);
t5=C_i_fixnum_max(C_fix(0),t4);
t6=C_fix(C_character_code(((C_word*)t0)[5]));
t7=C_fixnum_difference(t3,C_fix(1));
t8=C_slot(((C_word*)t0)[2],C_fix(1));
t9=C_eqp(t7,t8);
t10=(C_truep(t9)?C_fixnum_lessp(t6,C_fix(128)):C_SCHEME_FALSE);
if(C_truep(t10)){
t11=((C_word*)t0)[6];{
C_word av2[2];
av2[0]=t11;
av2[1]=C_fill_bytevector(t2,t6,((C_word*)((C_word*)t0)[4])[1],t5);
((C_proc)(void*)(*((C_word*)t11+1)))(2,av2);}}
else{
t11=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15591,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[5],a[5]=((C_word)li372),tmp=(C_word)a,a+=6,tmp);
t12=((C_word*)t0)[6];{
C_word av2[2];
av2[0]=t12;
av2[1]=(
  f_15591(t11,((C_word*)((C_word*)t0)[4])[1])
);
((C_proc)(void*)(*((C_word*)t12+1)))(2,av2);}}}

/* doloop2048 in k15566 in scheme#string-fill! in k12559 in k11436 */
static C_word f_15591(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_stack_overflow_check;
loop:{}
if(C_truep(C_fixnum_greater_or_equal_p(t1,((C_word*)((C_word*)t0)[2])[1]))){
t2=C_SCHEME_UNDEFINED;
return(t2);}
else{
t2=C_i_string_set(((C_word*)t0)[3],t1,((C_word*)t0)[4]);
t4=C_fixnum_plus(t1,C_fix(1));
t1=t4;
goto loop;}}

/* scheme#string-copy in k12559 in k11436 */
static void C_ccall f_15664(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(17,c,5)))){
C_save_and_reclaim((void *)f_15664,c,av);}
a=C_alloc(17);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
t8=t7;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_rest_nullp(c,4);
t11=C_i_check_string_2(t2,lf[485]);
t12=C_u_i_string_length(t2);
t13=C_fix(0);
t14=(*a=C_VECTOR_TYPE|1,a[1]=t13,tmp=(C_word)a,a+=2,tmp);
t15=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_15684,a[2]=t9,a[3]=t14,a[4]=t1,a[5]=t4,a[6]=t2,a[7]=t12,tmp=(C_word)a,a+=8,tmp);
if(C_truep(t4)){
t16=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15712,a[2]=t14,a[3]=t4,a[4]=t15,tmp=(C_word)a,a+=5,tmp);
/* library.scm:1864: ##sys#check-range/including */
t17=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t17;
av2[1]=t16;
av2[2]=t4;
av2[3]=C_fix(0);
av2[4]=t12;
av2[5]=lf[485];
((C_proc)(void*)(*((C_word*)t17+1)))(6,av2);}}
else{
t16=t15;
f_15684(t16,C_SCHEME_UNDEFINED);}}

/* k15682 in scheme#string-copy in k12559 in k11436 */
static void f_15684(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,5)))){
C_save_and_reclaim_args((void *)trf_15684,2,t0,t1);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15687,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
/* library.scm:1867: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[2])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[7];
av2[5]=lf[485];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}
else{
t3=C_set_block_item(((C_word*)t0)[2],0,((C_word*)t0)[7]);
t4=t2;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
f_15687(2,av2);}}}

/* k15685 in k15682 in scheme#string-copy in k12559 in k11436 */
static void C_ccall f_15687(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_15687,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15690,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(((C_word*)t0)[5])){
/* library.scm:1870: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[486]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=((C_word*)((C_word*)t0)[3])[1];
av2[4]=((C_word*)((C_word*)t0)[2])[1];
tp(5,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[6],C_fix(0));
f_15690(2,av2);}}}

/* k15688 in k15685 in k15682 in scheme#string-copy in k12559 in k11436 */
static void C_ccall f_15690(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_15690,c,av);}
a=C_alloc(6);
t2=C_block_size(t1);
t3=C_fixnum_difference(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15699,a[2]=t1,a[3]=t2,a[4]=((C_word*)t0)[4],a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* library.scm:1874: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}

/* k15697 in k15688 in k15685 in k15682 in scheme#string-copy in k12559 in k11436 */
static void C_ccall f_15699(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_15699,c,av);}
a=C_alloc(5);
t2=C_copy_memory(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_ustring(&a,2,t1,((C_word*)t0)[5]);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k15710 in scheme#string-copy in k12559 in k11436 */
static void C_ccall f_15712(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_15712,c,av);}
t2=C_set_block_item(((C_word*)t0)[2],0,((C_word*)t0)[3]);
t3=((C_word*)t0)[4];
f_15684(t3,t2);}

/* scheme#string-copy! in k12559 in k11436 */
static void C_ccall f_15739(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word *a;
if(c<5) C_bad_min_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(18,c,5)))){
C_save_and_reclaim((void *)f_15739,c,av);}
a=C_alloc(18);
t5=C_rest_nullp(c,5);
t6=(C_truep(t5)?C_SCHEME_FALSE:C_get_rest_arg(c,5,av,5,t0));
t7=t6;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_rest_nullp(c,5);
t10=C_rest_nullp(c,6);
t11=(C_truep(t10)?C_SCHEME_FALSE:C_get_rest_arg(c,6,av,5,t0));
t12=t11;
t13=(*a=C_VECTOR_TYPE|1,a[1]=t12,tmp=(C_word)a,a+=2,tmp);
t14=C_rest_nullp(c,6);
t15=C_i_check_string_2(t2,lf[488]);
t16=C_i_check_string_2(t4,lf[488]);
t17=C_u_i_string_length(t2);
t18=C_u_i_string_length(t4);
t19=C_fixnum_difference(((C_word*)t13)[1],((C_word*)t8)[1]);
t20=C_i_check_range_2(t3,C_fix(0),t17,lf[488]);
t21=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_15769,a[2]=t2,a[3]=t4,a[4]=t8,a[5]=t3,a[6]=t19,a[7]=t13,a[8]=t1,tmp=(C_word)a,a+=9,tmp);
if(C_truep(((C_word*)t8)[1])){
t22=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15856,a[2]=t13,a[3]=t21,a[4]=t18,tmp=(C_word)a,a+=5,tmp);
/* library.scm:1888: ##sys#check-range/including */
t23=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t23;
av2[1]=t22;
av2[2]=((C_word*)t8)[1];
av2[3]=C_fix(0);
av2[4]=t18;
av2[5]=lf[488];
((C_proc)(void*)(*((C_word*)t23+1)))(6,av2);}}
else{
t22=C_set_block_item(t8,0,C_fix(0));
t23=t21;{
C_word *av2=av;
av2[0]=t23;
av2[1]=t22;
f_15769(2,av2);}}}

/* k15767 in scheme#string-copy! in k12559 in k11436 */
static void C_ccall f_15769(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_15769,c,av);}
a=C_alloc(6);
t2=C_eqp(((C_word*)t0)[2],((C_word*)t0)[3]);
t3=(C_truep(t2)?C_fixnum_lessp(((C_word*)((C_word*)t0)[4])[1],((C_word*)t0)[5]):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=C_fixnum_plus(((C_word*)t0)[5],((C_word*)t0)[6]);
t5=C_fixnum_difference(t4,C_fix(1));
t6=C_fixnum_difference(((C_word*)((C_word*)t0)[7])[1],C_fix(1));
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15788,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word)li375),tmp=(C_word)a,a+=6,tmp);
t8=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t8;
av2[1]=(
  f_15788(t7,t5,t6)
);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15822,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word)li376),tmp=(C_word)a,a+=6,tmp);
t5=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t5;
av2[1]=(
  f_15822(t4,((C_word*)t0)[5],((C_word*)((C_word*)t0)[4])[1])
);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* doloop2106 in k15767 in scheme#string-copy! in k12559 in k11436 */
static C_word f_15788(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_fixnum_lessp(t2,((C_word*)((C_word*)t0)[2])[1]))){
t3=C_SCHEME_UNDEFINED;
return(t3);}
else{
t3=C_i_string_ref(((C_word*)t0)[3],t2);
t4=C_i_string_set(((C_word*)t0)[4],t1,t3);
t6=C_fixnum_difference(t1,C_fix(1));
t7=C_fixnum_difference(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}

/* doloop2112 in k15767 in scheme#string-copy! in k12559 in k11436 */
static C_word f_15822(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_fixnum_greater_or_equal_p(t2,((C_word*)((C_word*)t0)[2])[1]))){
t3=C_SCHEME_UNDEFINED;
return(t3);}
else{
t3=C_i_string_ref(((C_word*)t0)[3],t2);
t4=C_i_string_set(((C_word*)t0)[4],t1,t3);
t6=C_fixnum_plus(t1,C_fix(1));
t7=C_fixnum_plus(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}

/* k15854 in scheme#string-copy! in k12559 in k11436 */
static void C_ccall f_15856(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_15856,c,av);}
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
/* library.scm:1890: ##sys#check-range/including */
t2=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)((C_word*)t0)[2])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[4];
av2[5]=lf[488];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}
else{
t2=C_set_block_item(((C_word*)t0)[2],0,((C_word*)t0)[4]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
f_15769(2,av2);}}}

/* ##sys#substring in k12559 in k11436 */
static void C_ccall f_15890(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_15890,c,av);}
a=C_alloc(6);
t5=C_utf_range(t2,t3,t4);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15894,a[2]=t4,a[3]=t3,a[4]=t2,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:1905: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=C_fixnum_plus(t5,C_fix(1));
tp(3,av2);}}

/* k15892 in ##sys#substring in k12559 in k11436 */
static void C_ccall f_15894(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_15894,c,av);}
a=C_alloc(5);
t2=C_fixnum_difference(((C_word*)t0)[2],((C_word*)t0)[3]);
t3=C_a_ustring(&a,2,t1,t2);
t4=C_utf_copy(((C_word*)t0)[4],t3,((C_word*)t0)[3],((C_word*)t0)[2],C_fix(0));
t5=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#substring in k12559 in k11436 */
static void C_ccall f_15904(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +5,c,2)))){
C_save_and_reclaim((void*)f_15904,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+5);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
t5=C_i_check_string_2(t2,lf[490]);
t6=C_i_check_fixnum_2(t3,lf[490]);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_15914,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_pairp(t4))){
t8=C_get_rest_arg(c,4,av,4,t0);
t9=C_i_check_fixnum_2(t8,lf[490]);
t10=t7;
f_15914(t10,t8);}
else{
t8=t7;
f_15914(t8,C_u_i_string_length(t2));}}

/* k15912 in scheme#substring in k12559 in k11436 */
static void f_15914(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_15914,2,t0,t1);}
a=C_alloc(6);
t2=C_u_i_string_length(((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15921,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_fixnum_less_or_equal_p(((C_word*)t0)[4],t1))){
t4=C_fixnum_greater_or_equal_p(((C_word*)t0)[4],C_fix(0));
t5=t3;
f_15921(t5,(C_truep(t4)?C_fixnum_less_or_equal_p(t1,t2):C_SCHEME_FALSE));}
else{
t4=t3;
f_15921(t4,C_SCHEME_FALSE);}}

/* k15919 in k15912 in scheme#substring in k12559 in k11436 */
static void f_15921(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,5)))){
C_save_and_reclaim_args((void *)trf_15921,2,t0,t1);}
if(C_truep(t1)){
/* library.scm:1923: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[486]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
av2[4]=((C_word*)t0)[5];
tp(5,av2);}}
else{
t2=C_fix((C_word)C_OUT_OF_BOUNDS_ERROR);
/* library.scm:1924: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[6];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t2;
av2[3]=lf[490];
av2[4]=((C_word*)t0)[3];
av2[5]=((C_word*)t0)[4];
tp(6,av2);}}}

/* compare in k12559 in k11436 */
static void f_15949(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6){
C_word tmp;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_15949,6,t1,t2,t3,t4,t5,t6);}
a=C_alloc(7);
t7=C_i_check_string_2(t2,t5);
t8=C_i_check_string_2(t3,t5);
t9=C_u_i_string_length(t2);
t10=C_u_i_string_length(t3);
t11=C_fixnum_lessp(t9,t10);
t12=(C_truep(t11)?t9:t10);
t13=C_utf_compare(t2,t3,C_fix(0),C_fix(0),t12);
t14=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15969,a[2]=t4,a[3]=t6,a[4]=t1,a[5]=t3,a[6]=t10,tmp=(C_word)a,a+=7,tmp);
t15=C_fixnum_lessp(t9,t10);
t16=(C_truep(t15)?t9:t10);
/* library.scm:1938: cmp */
t17=t6;{
C_word av2[5];
av2[0]=t17;
av2[1]=t14;
av2[2]=C_utf_compare(t2,t3,C_fix(0),C_fix(0),t16);
av2[3]=t9;
av2[4]=t10;
((C_proc)C_fast_retrieve_proc(t17))(5,av2);}}

/* k15967 in compare in k12559 in k11436 */
static void C_ccall f_15969(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,6)))){
C_save_and_reclaim((void *)f_15969,c,av);}
a=C_alloc(8);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_15971,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=((C_word)li380),tmp=(C_word)a,a+=6,tmp));
t5=((C_word*)t3)[1];
f_15971(t5,((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6],((C_word*)t0)[2],t1);}

/* loop in k15967 in compare in k12559 in k11436 */
static void f_15971(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(7,0,5)))){
C_save_and_reclaim_args((void *)trf_15971,6,t0,t1,t2,t3,t4,t5);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t4))){
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_slot(((C_word*)t0)[2],C_fix(0));
t7=C_i_string_length(t6);
t8=C_fixnum_lessp(t3,t7);
t9=(C_truep(t8)?t3:t7);
t10=C_utf_compare_ci(t2,t6,C_fix(0),C_fix(0),t9);
t11=C_slot(((C_word*)t0)[2],C_fix(1));
t12=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_15999,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t6,a[5]=t7,a[6]=t11,tmp=(C_word)a,a+=7,tmp);
if(C_truep(t5)){
/* library.scm:1950: cmp */
t13=((C_word*)t0)[4];{
C_word av2[5];
av2[0]=t13;
av2[1]=t12;
av2[2]=t10;
av2[3]=t3;
av2[4]=t7;
((C_proc)C_fast_retrieve_proc(t13))(5,av2);}}
else{
/* library.scm:1949: loop */
t14=t1;
t15=t6;
t16=t7;
t17=t11;
t18=C_SCHEME_FALSE;
t1=t14;
t2=t15;
t3=t16;
t4=t17;
t5=t18;
goto loop;}}}

/* k15997 in loop in k15967 in compare in k12559 in k11436 */
static void C_ccall f_15999(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_15999,c,av);}
/* library.scm:1949: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_15971(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6],t1);}

/* scheme#string<? in k12559 in k11436 */
static void C_ccall f_16018(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,6)))){
C_save_and_reclaim((void*)f_16018,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16024,a[2]=((C_word)li382),tmp=(C_word)a,a+=3,tmp);
/* library.scm:1952: compare */
f_15949(t1,t2,t3,t4,lf[492],t5);}

/* a16023 in scheme#string<? in k12559 in k11436 */
static void C_ccall f_16024(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16024,c,av);}
t5=C_fixnum_lessp(t2,C_fix(0));
if(C_truep(t5)){
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_fixnum_lessp(t3,t4);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(C_truep(t6)?C_eqp(t2,C_fix(0)):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}

/* scheme#string>? in k12559 in k11436 */
static void C_ccall f_16042(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,6)))){
C_save_and_reclaim((void*)f_16042,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16048,a[2]=((C_word)li384),tmp=(C_word)a,a+=3,tmp);
/* library.scm:1959: compare */
f_15949(t1,t2,t3,t4,lf[494],t5);}

/* a16047 in scheme#string>? in k12559 in k11436 */
static void C_ccall f_16048(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16048,c,av);}
t5=C_fixnum_greaterp(t2,C_fix(0));
if(C_truep(t5)){
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_fixnum_lessp(t4,t3);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(C_truep(t6)?C_eqp(t2,C_fix(0)):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}

/* scheme#string<=? in k12559 in k11436 */
static void C_ccall f_16066(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,6)))){
C_save_and_reclaim((void*)f_16066,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16072,a[2]=((C_word)li386),tmp=(C_word)a,a+=3,tmp);
/* library.scm:1966: compare */
f_15949(t1,t2,t3,t4,lf[496],t5);}

/* a16071 in scheme#string<=? in k12559 in k11436 */
static void C_ccall f_16072(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16072,c,av);}
t5=C_eqp(t2,C_fix(0));
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=(C_truep(t5)?C_fixnum_less_or_equal_p(t3,t4):C_fixnum_lessp(t2,C_fix(0)));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* scheme#string>=? in k12559 in k11436 */
static void C_ccall f_16087(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,6)))){
C_save_and_reclaim((void*)f_16087,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16093,a[2]=((C_word)li388),tmp=(C_word)a,a+=3,tmp);
/* library.scm:1973: compare */
f_15949(t1,t2,t3,t4,lf[498],t5);}

/* a16092 in scheme#string>=? in k12559 in k11436 */
static void C_ccall f_16093(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16093,c,av);}
t5=C_eqp(t2,C_fix(0));
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=(C_truep(t5)?C_fixnum_greater_or_equal_p(t3,t4):C_fixnum_greaterp(t2,C_fix(0)));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* compare in k12559 in k11436 */
static void f_16107(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6){
C_word tmp;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_16107,6,t1,t2,t3,t4,t5,t6);}
a=C_alloc(7);
t7=C_i_check_string_2(t2,t5);
t8=C_i_check_string_2(t3,t5);
t9=C_u_i_string_length(t2);
t10=C_u_i_string_length(t3);
t11=C_fixnum_lessp(t9,t10);
t12=(C_truep(t11)?t9:t10);
t13=C_utf_compare_ci(t2,t3,C_fix(0),C_fix(0),t12);
t14=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_16127,a[2]=t6,a[3]=t1,a[4]=t3,a[5]=t10,a[6]=t4,tmp=(C_word)a,a+=7,tmp);
/* library.scm:1990: cmp */
t15=t6;{
C_word av2[5];
av2[0]=t15;
av2[1]=t14;
av2[2]=t13;
av2[3]=t9;
av2[4]=t10;
((C_proc)C_fast_retrieve_proc(t15))(5,av2);}}

/* k16125 in compare in k12559 in k11436 */
static void C_ccall f_16127(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,6)))){
C_save_and_reclaim((void *)f_16127,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16129,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word)li390),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_16129(t5,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6],t1);}

/* loop in k16125 in compare in k12559 in k11436 */
static void f_16129(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(7,0,5)))){
C_save_and_reclaim_args((void *)trf_16129,6,t0,t1,t2,t3,t4,t5);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t4))){
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_slot(t4,C_fix(0));
t7=C_i_string_length(t6);
t8=C_fixnum_lessp(t3,t7);
t9=(C_truep(t8)?t3:t7);
t10=C_utf_compare_ci(t2,t6,C_fix(0),C_fix(0),t9);
t11=C_slot(t4,C_fix(1));
t12=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_16157,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t6,a[5]=t7,a[6]=t11,tmp=(C_word)a,a+=7,tmp);
if(C_truep(t5)){
/* library.scm:1999: cmp */
t13=((C_word*)t0)[3];{
C_word av2[5];
av2[0]=t13;
av2[1]=t12;
av2[2]=t10;
av2[3]=t3;
av2[4]=t7;
((C_proc)C_fast_retrieve_proc(t13))(5,av2);}}
else{
/* library.scm:1998: loop */
t14=t1;
t15=t6;
t16=t7;
t17=t11;
t18=C_SCHEME_FALSE;
t1=t14;
t2=t15;
t3=t16;
t4=t17;
t5=t18;
goto loop;}}}

/* k16155 in loop in k16125 in compare in k12559 in k11436 */
static void C_ccall f_16157(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_16157,c,av);}
/* library.scm:1998: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_16129(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6],t1);}

/* scheme#string-ci<? in k12559 in k11436 */
static void C_ccall f_16168(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,6)))){
C_save_and_reclaim((void*)f_16168,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16174,a[2]=((C_word)li392),tmp=(C_word)a,a+=3,tmp);
/* library.scm:2001: compare */
f_16107(t1,t2,t3,t4,lf[500],t5);}

/* a16173 in scheme#string-ci<? in k12559 in k11436 */
static void C_ccall f_16174(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16174,c,av);}
t5=C_fixnum_lessp(t2,C_fix(0));
if(C_truep(t5)){
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_fixnum_lessp(t3,t4);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(C_truep(t6)?C_eqp(t2,C_fix(0)):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}

/* scheme#string-ci>? in k12559 in k11436 */
static void C_ccall f_16192(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,6)))){
C_save_and_reclaim((void*)f_16192,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16198,a[2]=((C_word)li394),tmp=(C_word)a,a+=3,tmp);
/* library.scm:2008: compare */
f_16107(t1,t2,t3,t4,lf[502],t5);}

/* a16197 in scheme#string-ci>? in k12559 in k11436 */
static void C_ccall f_16198(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16198,c,av);}
t5=C_fixnum_greaterp(t2,C_fix(0));
if(C_truep(t5)){
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_fixnum_lessp(t4,t3);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(C_truep(t6)?C_eqp(t2,C_fix(0)):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}

/* scheme#string-ci<=? in k12559 in k11436 */
static void C_ccall f_16216(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,6)))){
C_save_and_reclaim((void*)f_16216,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16222,a[2]=((C_word)li396),tmp=(C_word)a,a+=3,tmp);
/* library.scm:2015: compare */
f_16107(t1,t2,t3,t4,lf[504],t5);}

/* a16221 in scheme#string-ci<=? in k12559 in k11436 */
static void C_ccall f_16222(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16222,c,av);}
t5=C_eqp(t2,C_fix(0));
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=(C_truep(t5)?C_fixnum_less_or_equal_p(t3,t4):C_fixnum_lessp(t2,C_fix(0)));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* scheme#string-ci>=? in k12559 in k11436 */
static void C_ccall f_16237(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +3,c,6)))){
C_save_and_reclaim((void*)f_16237,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+3);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_16243,a[2]=((C_word)li398),tmp=(C_word)a,a+=3,tmp);
/* library.scm:2022: compare */
f_16107(t1,t2,t3,t4,lf[506],t5);}

/* a16242 in scheme#string-ci>=? in k12559 in k11436 */
static void C_ccall f_16243(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16243,c,av);}
t5=C_eqp(t2,C_fix(0));
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=(C_truep(t5)?C_fixnum_greater_or_equal_p(t3,t4):C_fixnum_greaterp(t2,C_fix(0)));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* ##sys#string-append in k12559 in k11436 */
static void C_ccall f_16258(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_16258,c,av);}
a=C_alloc(9);
t4=C_slot(t2,C_fix(0));
t5=C_slot(t3,C_fix(0));
t6=C_block_size(t4);
t7=C_fixnum_difference(t6,C_fix(1));
t8=C_block_size(t5);
t9=C_fixnum_difference(t8,C_fix(1));
t10=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_16274,a[2]=t4,a[3]=t7,a[4]=t5,a[5]=t9,a[6]=t2,a[7]=t3,a[8]=t1,tmp=(C_word)a,a+=9,tmp);
t11=C_fixnum_plus(t9,C_fix(1));
/* library.scm:2034: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t10;
av2[2]=C_fixnum_plus(t7,t11);
av2[3]=C_fix(0);
tp(4,av2);}}

/* k16272 in ##sys#string-append in k12559 in k11436 */
static void C_ccall f_16274(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_16274,c,av);}
a=C_alloc(5);
t2=C_copy_memory_with_offset(t1,((C_word*)t0)[2],C_fix(0),C_fix(0),((C_word*)t0)[3]);
t3=C_copy_memory_with_offset(t1,((C_word*)t0)[4],((C_word*)t0)[3],C_fix(0),((C_word*)t0)[5]);
t4=C_slot(((C_word*)t0)[6],C_fix(1));
t5=C_slot(((C_word*)t0)[7],C_fix(1));
t6=C_fixnum_plus(t4,t5);
t7=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_a_ustring(&a,2,t1,t6);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* scheme#string-append in k12559 in k11436 */
static void C_ccall f_16304(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +17,c,5)))){
C_save_and_reclaim((void*)f_16304,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+17);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
t3=C_SCHEME_FALSE;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_fix(0);
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16308,a[2]=t1,a[3]=t4,a[4]=t6,tmp=(C_word)a,a+=5,tmp);
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_16310,a[2]=t4,a[3]=t6,a[4]=t9,a[5]=((C_word)li401),tmp=(C_word)a,a+=6,tmp));
t11=((C_word*)t9)[1];
f_16310(t11,t7,t2,C_fix(0),C_fix(0));}

/* k16306 in scheme#string-append in k12559 in k11436 */
static void C_ccall f_16308(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_16308,c,av);}
a=C_alloc(5);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_ustring(&a,2,((C_word*)((C_word*)t0)[3])[1],((C_word*)((C_word*)t0)[4])[1]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* loop in scheme#string-append in k12559 in k11436 */
static void f_16310(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_16310,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
t5=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_16321,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t4,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:2046: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=C_fixnum_plus(t3,C_fix(1));
av2[3]=C_fix(0);
tp(4,av2);}}
else{
t6=C_slot(t2,C_fix(0));
t7=C_i_check_string_2(t6,lf[509]);
t8=C_slot(t6,C_fix(0));
t9=C_block_size(t8);
t10=C_fixnum_difference(t9,C_fix(1));
t11=C_slot(t6,C_fix(1));
t12=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_16344,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t8,a[5]=t3,a[6]=t10,tmp=(C_word)a,a+=7,tmp);
/* library.scm:2054: loop */
t14=t12;
t15=C_slot(t2,C_fix(1));
t16=C_fixnum_plus(t3,t10);
t17=C_fixnum_plus(t4,t11);
t1=t14;
t2=t15;
t3=t16;
t4=t17;
goto loop;}}

/* k16319 in loop in scheme#string-append in k12559 in k11436 */
static void C_ccall f_16321(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16321,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=C_mutate(((C_word *)((C_word*)t0)[3])+1,((C_word*)t0)[4]);
t4=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k16342 in loop in scheme#string-append in k12559 in k11436 */
static void C_ccall f_16344(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16344,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_copy_memory_with_offset(((C_word*)((C_word*)t0)[3])[1],((C_word*)t0)[4],((C_word*)t0)[5],C_fix(0),((C_word*)t0)[6]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scheme#string in k12559 in k11436 */
static void C_ccall f_16362(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +0,c,2)))){
C_save_and_reclaim((void*)f_16362,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+0);
t2=C_build_rest(&a,c,2,av);
C_word t3;
/* ##sys#list->string */
t3=*((C_word*)lf[479]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* ##sys#char->utf8-string in k12559 in k11436 */
static void C_ccall f_16368(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,1)))){
C_save_and_reclaim((void *)f_16368,c,av);}
a=C_alloc(8);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_string(&a,1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#chop in k12559 in k11436 */
static void C_ccall f_16374(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_16374,c,av);}
a=C_alloc(5);
t4=C_i_check_fixnum_2(t3,lf[513]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16381,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fixnum_less_or_equal_p(t3,C_fix(0)))){
/* library.scm:2069: ##sys#error */
t6=*((C_word*)lf[195]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[513];
av2[3]=lf[514];
av2[4]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}
else{
t6=t5;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_UNDEFINED;
f_16381(2,av2);}}}

/* k16379 in chicken.base#chop in k12559 in k11436 */
static void C_ccall f_16381(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_16381,c,av);}
a=C_alloc(7);
t2=C_i_length(((C_word*)t0)[2]);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16389,a[2]=((C_word*)t0)[3],a[3]=t4,a[4]=((C_word)li406),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_16389(t6,((C_word*)t0)[4],((C_word*)t0)[2],t2);}

/* loop in k16379 in chicken.base#chop in k12559 in k11436 */
static void f_16389(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,5)))){
C_save_and_reclaim_args((void *)trf_16389,4,t0,t1,t2,t3);}
a=C_alloc(9);
if(C_truep(C_i_nullp(t2))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
if(C_truep(C_fixnum_lessp(t3,((C_word*)t0)[2]))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_a_i_list1(&a,1,t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_16410,a[2]=((C_word*)t0)[3],a[3]=t3,a[4]=((C_word*)t0)[2],a[5]=t5,a[6]=((C_word)li405),tmp=(C_word)a,a+=7,tmp));
t7=((C_word*)t5)[1];
f_16410(t7,t1,C_SCHEME_END_OF_LIST,t2,((C_word*)t0)[2]);}}}

/* doloop2298 in loop in k16379 in chicken.base#chop in k12559 in k11436 */
static void f_16410(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_16410,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
t5=C_eqp(t4,C_fix(0));
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_16424,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t3,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],tmp=(C_word)a,a+=7,tmp);
/* library.scm:2079: scheme#reverse */
t7=*((C_word*)lf[50]+1);{
C_word av2[3];
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}
else{
t6=C_slot(t3,C_fix(0));
t7=C_a_i_cons(&a,2,t6,t2);
t9=t1;
t10=t7;
t11=C_slot(t3,C_fix(1));
t12=C_fixnum_difference(t4,C_fix(1));
t1=t9;
t2=t10;
t3=t11;
t4=t12;
goto loop;}}

/* k16422 in doloop2298 in loop in k16379 in chicken.base#chop in k12559 in k11436 */
static void C_ccall f_16424(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_16424,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16428,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2079: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_16389(t3,t2,((C_word*)t0)[4],C_fixnum_difference(((C_word*)t0)[5],((C_word*)t0)[6]));}

/* k16426 in k16422 in doloop2298 in loop in k16379 in chicken.base#chop in k12559 in k11436 */
static void C_ccall f_16428(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_16428,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp+ in k12559 in k11436 */
static void C_ccall f_16469(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_16469,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16491,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_flonum(&a,C_ub_i_flonum_plus(C_flonum_magnitude(t2),C_flonum_magnitude(t3)));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[527];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16489 in chicken.flonum#fp+ in k12559 in k11436 */
static void C_ccall f_16491(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16491,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_ub_i_flonum_plus(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp- in k12559 in k11436 */
static void C_ccall f_16493(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_16493,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16515,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_flonum(&a,C_ub_i_flonum_difference(C_flonum_magnitude(t2),C_flonum_magnitude(t3)));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[529];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16513 in chicken.flonum#fp- in k12559 in k11436 */
static void C_ccall f_16515(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16515,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_ub_i_flonum_difference(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp* in k12559 in k11436 */
static void C_ccall f_16517(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_16517,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16539,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_flonum(&a,C_ub_i_flonum_times(C_flonum_magnitude(t2),C_flonum_magnitude(t3)));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[531];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16537 in chicken.flonum#fp* in k12559 in k11436 */
static void C_ccall f_16539(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16539,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_ub_i_flonum_times(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp/ in k12559 in k11436 */
static void C_ccall f_16541(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_16541,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16563,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_flonum(&a,C_ub_i_flonum_quotient(C_flonum_magnitude(t2),C_flonum_magnitude(t3)));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[533];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16561 in chicken.flonum#fp/ in k12559 in k11436 */
static void C_ccall f_16563(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16563,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_ub_i_flonum_quotient(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp*+ in k12559 in k11436 */
static void C_ccall f_16565(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(13,c,2)))){
C_save_and_reclaim((void *)f_16565,c,av);}
a=C_alloc(13);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_16569,a[2]=t1,a[3]=t2,a[4]=t3,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_16572,a[2]=t1,a[3]=t2,a[4]=t3,a[5]=t4,a[6]=t5,tmp=(C_word)a,a+=7,tmp);
if(C_truep(C_i_flonump(t2))){
t7=C_i_flonump(t3);
t8=t6;
f_16572(t8,(C_truep(t7)?C_i_flonump(t4):C_SCHEME_FALSE));}
else{
t7=t6;
f_16572(t7,C_SCHEME_FALSE);}}

/* k16567 in chicken.flonum#fp*+ in k12559 in k11436 */
static void C_ccall f_16569(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16569,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_ub_i_flonum_multiply_add(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4]),C_flonum_magnitude(((C_word*)t0)[5])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k16570 in chicken.flonum#fp*+ in k12559 in k11436 */
static void f_16572(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,6)))){
C_save_and_reclaim_args((void *)trf_16572,2,t0,t1);}
a=C_alloc(4);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_flonum(&a,C_ub_i_flonum_multiply_add(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4]),C_flonum_magnitude(((C_word*)t0)[5])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2130: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[7];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=((C_word*)t0)[6];
av2[2]=t2;
av2[3]=lf[535];
av2[4]=((C_word*)t0)[3];
av2[5]=((C_word*)t0)[4];
av2[6]=((C_word*)t0)[5];
tp(7,av2);}}}

/* chicken.flonum#fpgcd in k12559 in k11436 */
static void C_ccall f_16590(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_16590,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16612,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_a_i_flonum_gcd(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[537];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16610 in chicken.flonum#fpgcd in k12559 in k11436 */
static void C_ccall f_16612(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16612,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_flonum_gcd(&a,2,((C_word*)t0)[3],((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp/? in k12559 in k11436 */
static void C_ccall f_16614(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_16614,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16636,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_a_i_flonum_quotient_checked(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[539];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16634 in chicken.flonum#fp/? in k12559 in k11436 */
static void C_ccall f_16636(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16636,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_flonum_quotient_checked(&a,2,((C_word*)t0)[3],((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp= in k12559 in k11436 */
static void C_ccall f_16638(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_16638,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16660,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_ub_i_flonum_equalp(C_flonum_magnitude(t2),C_flonum_magnitude(t3));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[541];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16658 in chicken.flonum#fp= in k12559 in k11436 */
static void C_ccall f_16660(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16660,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_ub_i_flonum_equalp(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4]));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp> in k12559 in k11436 */
static void C_ccall f_16662(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_16662,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16684,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_ub_i_flonum_greaterp(C_flonum_magnitude(t2),C_flonum_magnitude(t3));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[543];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16682 in chicken.flonum#fp> in k12559 in k11436 */
static void C_ccall f_16684(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16684,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_ub_i_flonum_greaterp(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4]));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp< in k12559 in k11436 */
static void C_ccall f_16686(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_16686,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16708,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_ub_i_flonum_lessp(C_flonum_magnitude(t2),C_flonum_magnitude(t3));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[545];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16706 in chicken.flonum#fp< in k12559 in k11436 */
static void C_ccall f_16708(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16708,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_ub_i_flonum_lessp(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4]));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp>= in k12559 in k11436 */
static void C_ccall f_16710(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_16710,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16732,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_ub_i_flonum_greater_or_equal_p(C_flonum_magnitude(t2),C_flonum_magnitude(t3));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[547];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16730 in chicken.flonum#fp>= in k12559 in k11436 */
static void C_ccall f_16732(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16732,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_ub_i_flonum_greater_or_equal_p(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4]));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fp<= in k12559 in k11436 */
static void C_ccall f_16734(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_16734,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16756,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_ub_i_flonum_less_or_equal_p(C_flonum_magnitude(t2),C_flonum_magnitude(t3));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[549];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16754 in chicken.flonum#fp<= in k12559 in k11436 */
static void C_ccall f_16756(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16756,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_ub_i_flonum_less_or_equal_p(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4]));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpneg in k12559 in k11436 */
static void C_ccall f_16758(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16758,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16774,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_flonum_negate(&a,1,t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[551];
av2[4]=t2;
tp(5,av2);}}}

/* k16772 in chicken.flonum#fpneg in k12559 in k11436 */
static void C_ccall f_16774(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16774,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_flonum_negate(&a,1,((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpmax in k12559 in k11436 */
static void C_ccall f_16776(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_16776,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16798,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_i_flonum_max(t2,t3);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[553];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16796 in chicken.flonum#fpmax in k12559 in k11436 */
static void C_ccall f_16798(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16798,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_flonum_max(((C_word*)t0)[3],((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpmin in k12559 in k11436 */
static void C_ccall f_16800(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_16800,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_16822,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_i_flonum_min(t2,t3);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[555];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k16820 in chicken.flonum#fpmin in k12559 in k11436 */
static void C_ccall f_16822(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_16822,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_flonum_min(((C_word*)t0)[3],((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpfloor in k12559 in k11436 */
static void C_ccall f_16824(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16824,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16840,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_floor(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[557];
av2[4]=t2;
tp(5,av2);}}}

/* k16838 in chicken.flonum#fpfloor in k12559 in k11436 */
static void C_ccall f_16840(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16840,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_floor(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fptruncate in k12559 in k11436 */
static void C_ccall f_16842(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16842,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16858,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_trunc(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[559];
av2[4]=t2;
tp(5,av2);}}}

/* k16856 in chicken.flonum#fptruncate in k12559 in k11436 */
static void C_ccall f_16858(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16858,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_trunc(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpround in k12559 in k11436 */
static void C_ccall f_16860(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16860,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16876,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_round(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[561];
av2[4]=t2;
tp(5,av2);}}}

/* k16874 in chicken.flonum#fpround in k12559 in k11436 */
static void C_ccall f_16876(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16876,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_round(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpceiling in k12559 in k11436 */
static void C_ccall f_16878(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16878,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16894,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_ceil(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[563];
av2[4]=t2;
tp(5,av2);}}}

/* k16892 in chicken.flonum#fpceiling in k12559 in k11436 */
static void C_ccall f_16894(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16894,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_ceil(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpsin in k12559 in k11436 */
static void C_ccall f_16896(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16896,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16912,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_sin(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[565];
av2[4]=t2;
tp(5,av2);}}}

/* k16910 in chicken.flonum#fpsin in k12559 in k11436 */
static void C_ccall f_16912(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16912,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_sin(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpcos in k12559 in k11436 */
static void C_ccall f_16914(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16914,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16930,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_cos(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[567];
av2[4]=t2;
tp(5,av2);}}}

/* k16928 in chicken.flonum#fpcos in k12559 in k11436 */
static void C_ccall f_16930(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16930,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_cos(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fptan in k12559 in k11436 */
static void C_ccall f_16932(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16932,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16948,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_tan(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[569];
av2[4]=t2;
tp(5,av2);}}}

/* k16946 in chicken.flonum#fptan in k12559 in k11436 */
static void C_ccall f_16948(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16948,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_tan(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpasin in k12559 in k11436 */
static void C_ccall f_16950(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16950,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16966,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_asin(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[571];
av2[4]=t2;
tp(5,av2);}}}

/* k16964 in chicken.flonum#fpasin in k12559 in k11436 */
static void C_ccall f_16966(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16966,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_asin(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpacos in k12559 in k11436 */
static void C_ccall f_16968(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16968,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_16984,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_acos(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[573];
av2[4]=t2;
tp(5,av2);}}}

/* k16982 in chicken.flonum#fpacos in k12559 in k11436 */
static void C_ccall f_16984(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_16984,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_acos(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpatan in k12559 in k11436 */
static void C_ccall f_16986(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_16986,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17002,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_atan(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[575];
av2[4]=t2;
tp(5,av2);}}}

/* k17000 in chicken.flonum#fpatan in k12559 in k11436 */
static void C_ccall f_17002(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17002,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_atan(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpatan2 in k12559 in k11436 */
static void C_ccall f_17004(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_17004,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17026,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_flonum(&a,C_atan2(C_flonum_magnitude(t2),C_flonum_magnitude(t3)));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[577];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k17024 in chicken.flonum#fpatan2 in k12559 in k11436 */
static void C_ccall f_17026(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17026,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_atan2(C_flonum_magnitude(((C_word*)t0)[3]),C_flonum_magnitude(((C_word*)t0)[4])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpsinh in k12559 in k11436 */
static void C_ccall f_17028(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17028,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17044,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_sinh(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[579];
av2[4]=t2;
tp(5,av2);}}}

/* k17042 in chicken.flonum#fpsinh in k12559 in k11436 */
static void C_ccall f_17044(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17044,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_sinh(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpcosh in k12559 in k11436 */
static void C_ccall f_17046(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17046,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17062,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_cosh(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[581];
av2[4]=t2;
tp(5,av2);}}}

/* k17060 in chicken.flonum#fpcosh in k12559 in k11436 */
static void C_ccall f_17062(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17062,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_cosh(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fptanh in k12559 in k11436 */
static void C_ccall f_17064(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17064,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17080,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_tanh(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[583];
av2[4]=t2;
tp(5,av2);}}}

/* k17078 in chicken.flonum#fptanh in k12559 in k11436 */
static void C_ccall f_17080(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17080,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_tanh(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpasinh in k12559 in k11436 */
static void C_ccall f_17082(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17082,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17098,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_asinh(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[585];
av2[4]=t2;
tp(5,av2);}}}

/* k17096 in chicken.flonum#fpasinh in k12559 in k11436 */
static void C_ccall f_17098(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17098,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_asinh(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpacosh in k12559 in k11436 */
static void C_ccall f_17100(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17100,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17116,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_acosh(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[587];
av2[4]=t2;
tp(5,av2);}}}

/* k17114 in chicken.flonum#fpacosh in k12559 in k11436 */
static void C_ccall f_17116(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17116,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_acosh(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpatanh in k12559 in k11436 */
static void C_ccall f_17118(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17118,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17134,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_atanh(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[589];
av2[4]=t2;
tp(5,av2);}}}

/* k17132 in chicken.flonum#fpatanh in k12559 in k11436 */
static void C_ccall f_17134(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17134,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_atanh(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpexp in k12559 in k11436 */
static void C_ccall f_17136(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17136,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17152,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_exp(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[591];
av2[4]=t2;
tp(5,av2);}}}

/* k17150 in chicken.flonum#fpexp in k12559 in k11436 */
static void C_ccall f_17152(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17152,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_exp(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpexpt in k12559 in k11436 */
static void C_ccall f_17154(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_17154,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17176,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_i_flonump(t2);
t6=(C_truep(t5)?C_i_flonump(t3):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_a_i_flonum_expt(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2110: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t7;
av2[3]=lf[593];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}}

/* k17174 in chicken.flonum#fpexpt in k12559 in k11436 */
static void C_ccall f_17176(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17176,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_flonum_expt(&a,2,((C_word*)t0)[3],((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fplog in k12559 in k11436 */
static void C_ccall f_17178(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17178,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17194,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_log(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[595];
av2[4]=t2;
tp(5,av2);}}}

/* k17192 in chicken.flonum#fplog in k12559 in k11436 */
static void C_ccall f_17194(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17194,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_log(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpsqrt in k12559 in k11436 */
static void C_ccall f_17196(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17196,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17212,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_sqrt(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[597];
av2[4]=t2;
tp(5,av2);}}}

/* k17210 in chicken.flonum#fpsqrt in k12559 in k11436 */
static void C_ccall f_17212(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17212,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_sqrt(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpabs in k12559 in k11436 */
static void C_ccall f_17214(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_17214,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17230,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_flonum(&a,C_fabs(C_flonum_magnitude(t2)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[599];
av2[4]=t2;
tp(5,av2);}}}

/* k17228 in chicken.flonum#fpabs in k12559 in k11436 */
static void C_ccall f_17230(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_17230,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_flonum(&a,C_fabs(C_flonum_magnitude(((C_word*)t0)[3])));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#fpinteger? in k12559 in k11436 */
static void C_ccall f_17232(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_17232,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17248,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_u_i_fpintegerp(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fix((C_word)C_BAD_ARGUMENT_TYPE_NO_FLONUM_ERROR);
/* library.scm:2106: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=lf[601];
av2[4]=t2;
tp(5,av2);}}}

/* k17246 in chicken.flonum#fpinteger? in k12559 in k11436 */
static void C_ccall f_17248(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_17248,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_u_i_fpintegerp(((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.flonum#flonum-print-precision in k12559 in k11436 */
static void C_ccall f_17250(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_17250,c,av);}
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?C_SCHEME_FALSE:C_get_rest_arg(c,2,av,2,t0));
t4=C_get_print_precision();
if(C_truep(t3)){
t5=C_i_check_fixnum_2(t3,lf[603]);
t6=C_set_print_precision(t3);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* make-complex in k12559 in k11436 */
static void f_17268(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_17268,3,t1,t2,t3);}
a=C_alloc(5);
t4=C_eqp(t3,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17278,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
if(C_truep(t4)){
t6=t5;{
C_word av2[2];
av2[0]=t6;
av2[1]=t4;
f_17278(2,av2);}}
else{
if(C_truep(C_i_flonump(t3))){
/* library.scm:2284: chicken.flonum#fp= */
t6=*((C_word*)lf[540]+1);{
C_word av2[4];
av2[0]=t6;
av2[1]=t5;
av2[2]=t3;
av2[3]=lf[605];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t6=t5;{
C_word av2[2];
av2[0]=t6;
av2[1]=C_SCHEME_FALSE;
f_17278(2,av2);}}}}

/* k17276 in make-complex in k12559 in k11436 */
static void C_ccall f_17278(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_17278,c,av);}
a=C_alloc(5);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17282,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_inexactp(((C_word*)t0)[4]))){
/* library.scm:2287: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
f_17282(2,av2);}}}}

/* k17280 in k17276 in make-complex in k12559 in k11436 */
static void C_ccall f_17282(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,1)))){
C_save_and_reclaim((void *)f_17282,c,av);}
a=C_alloc(14);
if(C_truep(C_i_inexactp(((C_word*)t0)[2]))){
t2=C_a_i_exact_to_inexact(&a,1,((C_word*)t0)[3]);
t3=C_a_i_cplxnum(&a,2,t1,t2);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t2=C_a_i_cplxnum(&a,2,t1,((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* scheme#make-rectangular in k12559 in k11436 */
static void C_ccall f_17304(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_17304,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17308,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2292: ##sys#check-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[428]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[428]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=lf[607];
tp(4,av2);}}

/* k17306 in scheme#make-rectangular in k12559 in k11436 */
static void C_ccall f_17308(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_17308,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17311,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2293: ##sys#check-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[428]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[428]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=lf[607];
tp(4,av2);}}

/* k17309 in k17306 in scheme#make-rectangular in k12559 in k11436 */
static void C_ccall f_17311(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17311,c,av);}
/* library.scm:2294: make-complex */
f_17268(((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[4]);}

/* scheme#make-polar in k12559 in k11436 */
static void C_ccall f_17316(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_17316,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17320,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2298: ##sys#check-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[428]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[428]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=lf[609];
tp(4,av2);}}

/* k17318 in scheme#make-polar in k12559 in k11436 */
static void C_ccall f_17320(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_17320,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17323,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2299: ##sys#check-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[428]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[428]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=lf[609];
tp(4,av2);}}

/* k17321 in k17318 in scheme#make-polar in k12559 in k11436 */
static void C_ccall f_17323(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_17323,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17326,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2300: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k17324 in k17321 in k17318 in scheme#make-polar in k12559 in k11436 */
static void C_ccall f_17326(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(74,c,3)))){
C_save_and_reclaim((void *)f_17326,c,av);}
a=C_alloc(74);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],C_a_i_cos(&a,1,t1));
t3=C_s_a_i_times(&a,2,((C_word*)t0)[2],C_a_i_sin(&a,1,t1));
/* library.scm:2301: make-complex */
f_17268(((C_word*)t0)[3],t2,t3);}

/* scheme#real-part in k12559 in k11436 */
static void C_ccall f_17339(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17339,c,av);}
if(C_truep(C_i_cplxnump(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_u_i_cplxnum_real(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_numberp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:2309: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[440]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[611];
tp(4,av2);}}}}

/* scheme#imag-part in k12559 in k11436 */
static void C_ccall f_17362(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17362,c,av);}
if(C_truep(C_i_cplxnump(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_u_i_cplxnum_imag(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_flonump(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=lf[605];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_numberp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_fix(0);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:2316: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[440]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[613];
tp(4,av2);}}}}}

/* scheme#angle in k12559 in k11436 */
static void C_ccall f_17388(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_17388,c,av);}
a=C_alloc(4);
t3=C_i_check_number_2(t2,lf[615]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17397,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2322: scheme#imag-part */
t5=*((C_word*)lf[612]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* k17395 in scheme#angle in k12559 in k11436 */
static void C_ccall f_17397(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,2)))){
C_save_and_reclaim((void *)f_17397,c,av);}
a=C_alloc(15);
t2=C_a_i_exact_to_inexact(&a,1,t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17402,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2323: scheme#real-part */
t4=*((C_word*)lf[610]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k17400 in k17395 in scheme#angle in k12559 in k11436 */
static void C_ccall f_17402(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,1)))){
C_save_and_reclaim((void *)f_17402,c,av);}
a=C_alloc(15);
t2=C_a_i_exact_to_inexact(&a,1,t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_atan2(&a,2,((C_word*)t0)[3],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#magnitude in k12559 in k11436 */
static void C_ccall f_17404(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(95,c,3)))){
C_save_and_reclaim((void *)f_17404,c,av);}
a=C_alloc(95);
if(C_truep(C_i_cplxnump(t2))){
t3=C_u_i_cplxnum_real(t2);
t4=C_u_i_cplxnum_imag(t2);
t5=C_s_a_i_times(&a,2,t3,t3);
t6=C_s_a_i_times(&a,2,t4,t4);
t7=C_s_a_i_plus(&a,2,t5,t6);
/* library.scm:2330: scheme#sqrt */
t8=*((C_word*)lf[617]+1);{
C_word *av2=av;
av2[0]=t8;
av2[1]=t1;
av2[2]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(3,av2);}}
else{
if(C_truep(C_i_numberp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_s_a_i_abs(&a,1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:2332: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[440]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[618];
tp(4,av2);}}}}

/* ratnum in k12559 in k11436 */
static C_word f_17448(C_word *a,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_stack_overflow_check;{}
switch(t2){
case C_fix(1):
return(t1);
case C_fix(-1):
return(C_s_a_u_i_integer_negate(&a,1,t1));
default:
if(C_truep(C_i_negativep(t2))){
t3=C_s_a_u_i_integer_negate(&a,1,t1);
t4=C_s_a_u_i_integer_negate(&a,1,t2);
return(C_a_i_ratnum(&a,2,t3,t4));}
else{
return(C_a_i_ratnum(&a,2,t1,t2));}}}

/* scheme#numerator in k12559 in k11436 */
static void C_ccall f_17494(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_17494,c,av);}
a=C_alloc(6);
if(C_truep(C_i_exact_integerp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_flonump(t2))){
if(C_truep(C_i_not(C_i_finitep(t2)))){
/* library.scm:2352: ##sys#error-bad-inexact */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[441]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[441]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[621];
tp(4,av2);}}
else{
if(C_truep(C_u_i_fpintegerp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17518,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17522,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:2354: scheme#inexact->exact */
t5=*((C_word*)lf[622]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}}}
else{
if(C_truep(C_i_ratnump(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_u_i_ratnum_num(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:2356: ##sys#signal-hook */
t3=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=lf[621];
av2[4]=lf[623];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}}}}

/* k17516 in scheme#numerator in k12559 in k11436 */
static void C_ccall f_17518(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,1)))){
C_save_and_reclaim((void *)f_17518,c,av);}
a=C_alloc(11);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_exact_to_inexact(&a,1,t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k17520 in scheme#numerator in k12559 in k11436 */
static void C_ccall f_17522(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_17522,c,av);}
/* library.scm:2354: scheme#numerator */
t2=*((C_word*)lf[620]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* scheme#denominator in k12559 in k11436 */
static void C_ccall f_17540(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_17540,c,av);}
a=C_alloc(6);
if(C_truep(C_i_exact_integerp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_fix(1);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_flonump(t2))){
if(C_truep(C_i_not(C_i_finitep(t2)))){
/* library.scm:2364: ##sys#error-bad-inexact */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[441]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[441]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[625];
tp(4,av2);}}
else{
if(C_truep(C_u_i_fpintegerp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=lf[626];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17564,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17568,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:2366: scheme#inexact->exact */
t5=*((C_word*)lf[622]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}}}
else{
if(C_truep(C_i_ratnump(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_u_i_ratnum_denom(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:2368: ##sys#signal-hook */
t3=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=lf[621];
av2[4]=lf[627];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}}}}

/* k17562 in scheme#denominator in k12559 in k11436 */
static void C_ccall f_17564(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,1)))){
C_save_and_reclaim((void *)f_17564,c,av);}
a=C_alloc(11);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_exact_to_inexact(&a,1,t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k17566 in scheme#denominator in k12559 in k11436 */
static void C_ccall f_17568(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_17568,c,av);}
/* library.scm:2366: scheme#denominator */
t2=*((C_word*)lf[624]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* ##sys#extended-signum in k12559 in k11436 */
static void C_ccall f_17586(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(26,c,3)))){
C_save_and_reclaim((void *)f_17586,c,av);}
a=C_alloc(26);
if(C_truep(C_i_ratnump(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_u_i_integer_signum(C_u_i_ratnum_num(t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_cplxnump(t2))){
t3=C_u_i_cplxnum_imag(t2);
t4=C_a_i_exact_to_inexact(&a,1,t3);
t5=C_u_i_cplxnum_real(t2);
t6=C_a_i_exact_to_inexact(&a,1,t5);
t7=C_flonum(&a,C_atan2(C_flonum_magnitude(t4),C_flonum_magnitude(t6)));
/* library.scm:2375: scheme#make-polar */
t8=*((C_word*)lf[608]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t8;
av2[1]=t1;
av2[2]=C_fix(1);
av2[3]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(4,av2);}}
else{
/* library.scm:2376: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[440]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[629];
tp(4,av2);}}}}

/* doloop2869 in deliver in scheme#inexact->exact in k12559 in k11436 */
static void f_17627(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_17627,4,t0,t1,t2,t3);}
a=C_alloc(5);
if(C_truep(C_u_i_fpintegerp(t2))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17638,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2384: chicken.flonum#fp* */
t5=*((C_word*)lf[530]+1);{
C_word av2[4];
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
av2[3]=lf[633];
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}}

/* k17636 in doloop2869 in deliver in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17638(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17638,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_17627(t2,((C_word*)t0)[3],t1,C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* deliver in scheme#inexact->exact in k12559 in k11436 */
static void f_17644(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,0,4)))){
C_save_and_reclaim_args((void *)trf_17644,4,t0,t1,t2,t3);}
a=C_alloc(15);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_17648,a[2]=t2,a[3]=t1,a[4]=t3,a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_17679,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17627,a[2]=t7,a[3]=((C_word)li458),tmp=(C_word)a,a+=4,tmp));
t9=((C_word*)t7)[1];
f_17627(t9,t5,t2,C_fix(0));}

/* k17646 in deliver in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17648(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_17648,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_17675,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* library.scm:2390: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k17660 in k17673 in k17646 in deliver in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17662(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17662,c,av);}
/* library.scm:2392: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}

/* k17673 in k17646 in deliver in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17675(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(42,c,3)))){
C_save_and_reclaim((void *)f_17675,c,av);}
a=C_alloc(42);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],t1);
if(C_truep(C_i_finitep(t2))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17662,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t4=C_s_a_u_i_flo_to_int(&a,1,t2);
/* library.scm:2392: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=((C_word*)t0)[5];
tp(4,av2);}}
else{
/* library.scm:2393: ##sys#error-bad-inexact */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[441]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[441]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[6];
av2[3]=lf[631];
tp(4,av2);}}}

/* k17677 in deliver in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17679(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17679,c,av);}
/* library.scm:2389: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[632]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=C_fix(2);
av2[3]=t1;
tp(4,av2);}}

/* k17694 in k17698 in k17704 in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17696(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17696,c,av);}
/* library.scm:2397: deliver */
t2=((C_word*)t0)[2];
f_17644(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k17698 in k17704 in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17700(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(38,c,3)))){
C_save_and_reclaim((void *)f_17700,c,av);}
a=C_alloc(38);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],t1);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17696,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2400: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t3;
av2[2]=C_fix(2);
av2[3]=*((C_word*)lf[520]+1);
tp(4,av2);}}

/* k17704 in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17706(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_17706,c,av);}
a=C_alloc(5);
t2=(C_truep(t1)?C_ub_i_flonum_greaterp(C_flonum_magnitude(((C_word*)t0)[2]),(double)-1.0):C_SCHEME_FALSE);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17700,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2397: scheme#expt */
t4=*((C_word*)lf[634]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[633];
av2[3]=*((C_word*)lf[520]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}
else{
/* library.scm:2401: deliver */
t3=((C_word*)t0)[3];
f_17644(t3,((C_word*)t0)[4],((C_word*)t0)[2],C_fix(1));}}

/* scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17710(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_17710,c,av);}
a=C_alloc(9);
if(C_truep(C_i_exactp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_flonump(t2))){
if(C_truep(C_u_i_fpintegerp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_s_a_u_i_flo_to_int(&a,1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_u_i_flonum_finitep(t2))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17644,a[2]=t2,a[3]=((C_word)li459),tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17706,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2395: chicken.flonum#fp< */
t5=*((C_word*)lf[544]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
av2[3]=lf[626];
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}
else{
/* library.scm:2409: ##sys#error-bad-inexact */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[441]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[441]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[631];
tp(4,av2);}}}}
else{
if(C_truep(C_i_cplxnump(t2))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17750,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2411: scheme#inexact->exact */
t4=*((C_word*)lf[622]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
av2[2]=C_u_i_cplxnum_real(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}
else{
/* library.scm:2413: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[440]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[631];
tp(4,av2);}}}}}

/* k17748 in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17750(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_17750,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17754,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2412: scheme#inexact->exact */
t3=*((C_word*)lf[622]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_u_i_cplxnum_imag(((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k17752 in k17748 in scheme#inexact->exact in k12559 in k11436 */
static void C_ccall f_17754(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17754,c,av);}
/* library.scm:2411: make-complex */
f_17268(((C_word*)t0)[2],((C_word*)t0)[3],t1);}

/* chicken.bitwise#bitwise-not in k12559 in k11436 */
static void C_ccall f_17774(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_17774,c,av);}
a=C_alloc(5);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_s_a_i_bitwise_not(&a,1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.bitwise#bit->boolean in k12559 in k11436 */
static void C_ccall f_17777(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_17777,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_bit_to_bool(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.bitwise#integer-length in k12559 in k11436 */
static void C_ccall f_17780(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_17780,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_integer_length(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.bitwise#arithmetic-shift in k12559 in k11436 */
static void C_ccall f_17783(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_17783,c,av);}
a=C_alloc(5);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_s_a_i_arithmetic_shift(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#/ in k12559 in k11436 */
static void C_ccall f_17786(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +4,c,3)))){
C_save_and_reclaim((void*)f_17786,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+4);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
if(C_truep(C_rest_nullp(c,3))){
/* library.scm:2445: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t1;
av2[2]=C_fix(1);
av2[3]=t2;
tp(4,av2);}}
else{
t4=C_slot(t3,C_fix(1));
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17807,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2447: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t5;
av2[2]=t2;
av2[3]=C_slot(t3,C_fix(0));
tp(4,av2);}}}

/* k17805 in scheme#/ in k12559 in k11436 */
static void C_ccall f_17807(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_17807,c,av);}
a=C_alloc(6);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17809,a[2]=t3,a[3]=((C_word)li468),tmp=(C_word)a,a+=4,tmp));
t5=((C_word*)t3)[1];
f_17809(t5,((C_word*)t0)[2],((C_word*)t0)[3],t1);}

/* loop in k17805 in scheme#/ in k12559 in k11436 */
static void f_17809(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_17809,4,t0,t1,t2,t3);}
a=C_alloc(5);
if(C_truep(C_i_nullp(t2))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_slot(t2,C_fix(1));
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17827,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2451: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t5;
av2[2]=t3;
av2[3]=C_slot(t2,C_fix(0));
tp(4,av2);}}}

/* k17825 in loop in k17805 in scheme#/ in k12559 in k11436 */
static void C_ccall f_17827(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17827,c,av);}
/* library.scm:2450: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_17809(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17837(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_17837,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17841,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t5=C_eqp(t3,C_fix(0));
if(C_truep(t5)){
t6=C_fix((C_word)C_DIVISION_BY_ZERO_ERROR);
/* library.scm:2458: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t4;
av2[2]=t6;
av2[3]=lf[645];
av2[4]=t2;
av2[5]=t3;
tp(6,av2);}}
else{
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_UNDEFINED;
f_17841(2,av2);}}}

/* k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17841(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(117,c,4)))){
C_save_and_reclaim((void *)f_17841,c,av);}
a=C_alloc(117);
t2=(C_truep(C_i_exact_integerp(((C_word*)t0)[2]))?C_i_exact_integerp(((C_word*)t0)[3]):C_SCHEME_FALSE);
if(C_truep(t2)){
t3=C_s_a_u_i_integer_gcd(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t4=C_s_a_u_i_integer_quotient(&a,2,((C_word*)t0)[2],t3);
t5=C_s_a_u_i_integer_quotient(&a,2,((C_word*)t0)[3],t3);
/* library.scm:2461: ratnum */
t6=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t6;
av2[1]=(
/* library.scm:2461: ratnum */
  f_17448(C_a_i(&a,21),t4,t5)
);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t3=C_i_cplxnump(((C_word*)t0)[2]);
t4=(C_truep(t3)?t3:C_i_cplxnump(((C_word*)t0)[3]));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17879,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2464: scheme#real-part */
t6=*((C_word*)lf[610]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}
else{
t5=C_i_flonump(((C_word*)t0)[2]);
t6=(C_truep(t5)?t5:C_i_flonump(((C_word*)t0)[3]));
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17945,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2472: scheme#exact->inexact */
t8=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t8;
av2[1]=t7;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t8+1)))(3,av2);}}
else{
if(C_truep(C_i_ratnump(((C_word*)t0)[2]))){
if(C_truep(C_i_ratnump(((C_word*)t0)[3]))){
t7=C_u_i_ratnum_num(((C_word*)t0)[2]);
t8=C_u_i_ratnum_denom(((C_word*)t0)[2]);
t9=C_u_i_ratnum_num(((C_word*)t0)[3]);
t10=C_u_i_ratnum_denom(((C_word*)t0)[3]);
t11=C_s_a_u_i_integer_gcd(&a,2,t7,t9);
t12=C_s_a_u_i_integer_gcd(&a,2,t8,t10);
t13=C_s_a_i_quotient(&a,2,t7,t11);
t14=C_s_a_i_quotient(&a,2,t10,t12);
t15=C_s_a_i_times(&a,2,t13,t14);
t16=C_s_a_i_quotient(&a,2,t8,t12);
t17=C_s_a_i_quotient(&a,2,t9,t11);
t18=C_s_a_i_times(&a,2,t16,t17);
/* library.scm:2482: ratnum */
t19=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t19;
av2[1]=(
/* library.scm:2482: ratnum */
  f_17448(C_a_i(&a,21),t15,t18)
);
((C_proc)(void*)(*((C_word*)t19+1)))(2,av2);}}
else{
t7=C_u_i_ratnum_num(((C_word*)t0)[2]);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_18026,a[2]=t7,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:2488: ##sys#internal-gcd */
f_19864(t8,lf[645],t7,((C_word*)t0)[3]);}}
else{
if(C_truep(C_i_ratnump(((C_word*)t0)[3]))){
t7=C_u_i_ratnum_num(((C_word*)t0)[3]);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_18065,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t7,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:2499: ##sys#internal-gcd */
f_19864(t8,lf[645],((C_word*)t0)[2],t7);}
else{
t7=C_i_numberp(((C_word*)t0)[2]);
if(C_truep(C_i_not(t7))){
/* library.scm:2505: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[440]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[2];
av2[3]=lf[645];
tp(4,av2);}}
else{
/* library.scm:2506: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[440]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[645];
tp(4,av2);}}}}}}}}

/* k17877 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17879(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_17879,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_17882,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2464: scheme#imag-part */
t3=*((C_word*)lf[612]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k17880 in k17877 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17882(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_17882,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_17885,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:2465: scheme#real-part */
t3=*((C_word*)lf[610]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k17883 in k17880 in k17877 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17885(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_17885,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_17888,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:2465: scheme#imag-part */
t3=*((C_word*)lf[612]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k17886 in k17883 in k17880 in k17877 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17888(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(198,c,3)))){
C_save_and_reclaim((void *)f_17888,c,av);}
a=C_alloc(198);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],((C_word*)t0)[2]);
t3=C_s_a_i_times(&a,2,t1,t1);
t4=C_s_a_i_plus(&a,2,t2,t3);
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_17894,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[5],a[6]=t1,a[7]=t4,tmp=(C_word)a,a+=8,tmp);
t6=C_s_a_i_times(&a,2,((C_word*)t0)[5],((C_word*)t0)[2]);
t7=C_s_a_i_times(&a,2,((C_word*)t0)[4],t1);
t8=C_s_a_i_plus(&a,2,t6,t7);
/* library.scm:2467: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t5;
av2[2]=t8;
av2[3]=t4;
tp(4,av2);}}

/* k17892 in k17886 in k17883 in k17880 in k17877 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17894(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(99,c,3)))){
C_save_and_reclaim((void *)f_17894,c,av);}
a=C_alloc(99);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17897,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_s_a_i_times(&a,2,((C_word*)t0)[3],((C_word*)t0)[4]);
t4=C_s_a_i_times(&a,2,((C_word*)t0)[5],((C_word*)t0)[6]);
t5=C_s_a_i_minus(&a,2,t3,t4);
/* library.scm:2468: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t2;
av2[2]=t5;
av2[3]=((C_word*)t0)[7];
tp(4,av2);}}

/* k17895 in k17892 in k17886 in k17883 in k17880 in k17877 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17897(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17897,c,av);}
/* library.scm:2469: make-complex */
f_17268(((C_word*)t0)[2],((C_word*)t0)[3],t1);}

/* k17943 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17945(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_17945,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_17949,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2472: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k17947 in k17943 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_17949(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_17949,c,av);}
/* library.scm:2472: chicken.flonum#fp/ */
t2=*((C_word*)lf[532]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k18024 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_18026(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(64,c,3)))){
C_save_and_reclaim((void *)f_18026,c,av);}
a=C_alloc(64);
t2=C_s_a_i_quotient(&a,2,((C_word*)t0)[2],t1);
t3=C_u_i_ratnum_denom(((C_word*)t0)[3]);
t4=C_s_a_i_quotient(&a,2,((C_word*)t0)[4],t1);
t5=C_s_a_i_times(&a,2,t3,t4);
if(C_truep(C_i_flonump(t5))){
/* library.scm:2492: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[5];
av2[2]=t2;
av2[3]=t5;
tp(4,av2);}}
else{
/* library.scm:2493: ratnum */
t6=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t6;
av2[1]=(
/* library.scm:2493: ratnum */
  f_17448(C_a_i(&a,21),t2,t5)
);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* k18063 in k17839 in ##sys#/-2 in k12559 in k11436 */
static void C_ccall f_18065(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(64,c,3)))){
C_save_and_reclaim((void *)f_18065,c,av);}
a=C_alloc(64);
t2=C_s_a_i_quotient(&a,2,((C_word*)t0)[2],t1);
t3=C_u_i_ratnum_denom(((C_word*)t0)[3]);
t4=C_s_a_i_times(&a,2,t2,t3);
t5=C_s_a_i_quotient(&a,2,((C_word*)t0)[4],t1);
if(C_truep(C_i_flonump(t5))){
/* library.scm:2503: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[5];
av2[2]=t4;
av2[3]=t5;
tp(4,av2);}}
else{
/* library.scm:2504: ratnum */
t6=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t6;
av2[1]=(
/* library.scm:2504: ratnum */
  f_17448(C_a_i(&a,21),t4,t5)
);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* scheme#floor in k12559 in k11436 */
static void C_ccall f_18120(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(34,c,3)))){
C_save_and_reclaim((void *)f_18120,c,av);}
a=C_alloc(34);
if(C_truep(C_i_exact_integerp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_flonump(t2))){
/* library.scm:2511: chicken.flonum#fpfloor */
t3=*((C_word*)lf[556]+1);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
if(C_truep(C_i_ratnump(t2))){
t3=C_u_i_ratnum_num(t2);
t4=C_u_i_ratnum_denom(t2);
t5=C_s_a_i_quotient(&a,2,t3,t4);
t6=C_i_greater_or_equalp(t3,C_fix(0));
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(C_truep(t6)?t5:C_s_a_i_minus(&a,2,t5,C_fix(1)));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
/* library.scm:2516: ##sys#error-bad-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[429]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[429]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[647];
tp(4,av2);}}}}}

/* scheme#ceiling in k12559 in k11436 */
static void C_ccall f_18165(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(34,c,3)))){
C_save_and_reclaim((void *)f_18165,c,av);}
a=C_alloc(34);
if(C_truep(C_i_exact_integerp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_flonump(t2))){
/* library.scm:2521: chicken.flonum#fpceiling */
t3=*((C_word*)lf[562]+1);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
if(C_truep(C_i_ratnump(t2))){
t3=C_u_i_ratnum_num(t2);
t4=C_u_i_ratnum_denom(t2);
t5=C_s_a_i_quotient(&a,2,t3,t4);
t6=C_i_greater_or_equalp(t3,C_fix(0));
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(C_truep(t6)?C_s_a_i_plus(&a,2,t5,C_fix(1)):t5);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
/* library.scm:2526: ##sys#error-bad-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[429]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[429]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[649];
tp(4,av2);}}}}}

/* scheme#truncate in k12559 in k11436 */
static void C_ccall f_18210(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_18210,c,av);}
a=C_alloc(5);
if(C_truep(C_i_exact_integerp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_flonump(t2))){
/* library.scm:2531: chicken.flonum#fptruncate */
t3=*((C_word*)lf[558]+1);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
if(C_truep(C_i_ratnump(t2))){
t3=C_u_i_ratnum_num(t2);
t4=C_u_i_ratnum_denom(t2);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_s_a_i_quotient(&a,2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
/* library.scm:2535: ##sys#error-bad-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[429]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[429]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[651];
tp(4,av2);}}}}}

/* scheme#round in k12559 in k11436 */
static void C_ccall f_18247(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(36,c,3)))){
C_save_and_reclaim((void *)f_18247,c,av);}
a=C_alloc(36);
if(C_truep(C_i_exact_integerp(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_flonump(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_flonum_round_proper(&a,1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_ratnump(t2))){
t3=C_a_i_ratnum(&a,2,C_fix(1),C_fix(2));
t4=C_s_a_i_plus(&a,2,t2,t3);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18267,a[2]=t4,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2544: scheme#floor */
t6=*((C_word*)lf[646]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}
else{
/* library.scm:2546: ##sys#error-bad-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[429]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[429]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[653];
tp(4,av2);}}}}}

/* k18265 in scheme#round in k12559 in k11436 */
static void C_ccall f_18267(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,1)))){
C_save_and_reclaim((void *)f_18267,c,av);}
a=C_alloc(29);
t2=C_i_nequalp(t1,((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(t2)?(C_truep(C_i_oddp(t1))?C_s_a_i_minus(&a,2,t1,C_fix(1)):t1):t1);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* find-ratio-between in k12559 in k11436 */
static void f_18291(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(67,0,4)))){
C_save_and_reclaim_args((void *)trf_18291,3,t1,t2,t3);}
a=C_alloc(67);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18294,a[2]=t5,a[3]=((C_word)li475),tmp=(C_word)a,a+=4,tmp));
if(C_truep(C_i_lessp(t3,t2))){
/* library.scm:2559: find-ratio-between */
t12=t1;
t13=t3;
t14=t2;
t1=t12;
t2=t13;
t3=t14;
goto loop;}
else{
t7=C_i_lessp(t2,t3);
if(C_truep(C_i_not(t7))){
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=C_a_i_list2(&a,2,t2,C_fix(1));
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
if(C_truep(C_i_positivep(t2))){
/* library.scm:2561: sr */
t8=((C_word*)t5)[1];
f_18294(t8,t1,t2,t3);}
else{
if(C_truep(C_i_negativep(t3))){
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18405,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t9=C_s_a_i_negate(&a,1,t3);
t10=C_s_a_i_negate(&a,1,t2);
/* library.scm:2562: sr */
t11=((C_word*)t5)[1];
f_18294(t11,t8,t9,t10);}
else{
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=lf[655];
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}}}}

/* sr in find-ratio-between in k12559 in k11436 */
static void f_18294(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,2)))){
C_save_and_reclaim_args((void *)trf_18294,4,t0,t1,t2,t3);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_18298,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[2],a[5]=t3,tmp=(C_word)a,a+=6,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18373,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* library.scm:2550: scheme#floor */
t6=*((C_word*)lf[646]+1);{
C_word av2[3];
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}

/* k18296 in sr in find-ratio-between in k12559 in k11436 */
static void C_ccall f_18298(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_18298,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_18301,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18369,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:2551: scheme#floor */
t4=*((C_word*)lf[646]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k18299 in k18296 in sr in find-ratio-between in k12559 in k11436 */
static void C_ccall f_18301(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(39,c,3)))){
C_save_and_reclaim((void *)f_18301,c,av);}
a=C_alloc(39);
t2=C_i_lessp(((C_word*)t0)[2],((C_word*)t0)[3]);
if(C_truep(C_i_not(t2))){
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_list2(&a,2,((C_word*)t0)[2],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_nequalp(((C_word*)t0)[2],t1))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18319,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_18342,a[2]=((C_word*)t0)[5],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
t5=C_s_a_i_minus(&a,2,((C_word*)t0)[6],t1);
/* library.scm:2554: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t4;
av2[2]=C_fix(1);
av2[3]=t5;
tp(4,av2);}}
else{
t3=C_s_a_i_plus(&a,2,C_fix(1),((C_word*)t0)[2]);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_list2(&a,2,t3,C_fix(1));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}}

/* k18317 in k18299 in k18296 in sr in find-ratio-between in k12559 in k11436 */
static void C_ccall f_18319(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(68,c,1)))){
C_save_and_reclaim((void *)f_18319,c,av);}
a=C_alloc(68);
t2=C_i_cadr(t1);
t3=C_u_i_car(t1);
t4=C_s_a_i_times(&a,2,((C_word*)t0)[2],t3);
t5=C_s_a_i_plus(&a,2,t2,t4);
t6=C_u_i_car(t1);
t7=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_a_i_list2(&a,2,t5,t6);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* k18340 in k18299 in k18296 in sr in find-ratio-between in k12559 in k11436 */
static void C_ccall f_18342(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(34,c,3)))){
C_save_and_reclaim((void *)f_18342,c,av);}
a=C_alloc(34);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_18346,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t3=C_s_a_i_minus(&a,2,((C_word*)t0)[4],((C_word*)t0)[5]);
/* library.scm:2555: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t2;
av2[2]=C_fix(1);
av2[3]=t3;
tp(4,av2);}}

/* k18344 in k18340 in k18299 in k18296 in sr in find-ratio-between in k12559 in k11436 */
static void C_ccall f_18346(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_18346,c,av);}
/* library.scm:2554: sr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_18294(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k18367 in k18296 in sr in find-ratio-between in k12559 in k11436 */
static void C_ccall f_18369(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_18369,c,av);}
/* library.scm:2551: scheme#inexact->exact */
t2=*((C_word*)lf[622]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k18371 in sr in find-ratio-between in k12559 in k11436 */
static void C_ccall f_18373(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_18373,c,av);}
/* library.scm:2550: scheme#inexact->exact */
t2=*((C_word*)lf[622]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k18403 in find-ratio-between in k12559 in k11436 */
static void C_ccall f_18405(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(35,c,1)))){
C_save_and_reclaim((void *)f_18405,c,av);}
a=C_alloc(35);
t2=C_i_car(t1);
t3=C_s_a_i_negate(&a,1,t2);
t4=C_i_cadr(t1);
t5=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_a_i_list2(&a,2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#rationalize in k12559 in k11436 */
static void C_ccall f_18441(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(66,c,3)))){
C_save_and_reclaim((void *)f_18441,c,av);}
a=C_alloc(66);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_18445,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18464,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
t6=C_s_a_i_minus(&a,2,t2,t3);
t7=C_s_a_i_plus(&a,2,t2,t3);
/* library.scm:2566: find-ratio-between */
f_18291(t5,t6,t7);}

/* k18443 in scheme#rationalize in k12559 in k11436 */
static void C_ccall f_18445(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_18445,c,av);}
t2=C_i_inexactp(((C_word*)t0)[2]);
if(C_truep(t2)){
if(C_truep(t2)){
/* library.scm:2572: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}
else{
if(C_truep(C_i_inexactp(((C_word*)t0)[4]))){
/* library.scm:2572: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}}

/* k18462 in scheme#rationalize in k12559 in k11436 */
static void C_ccall f_18464(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_18464,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[630]+1);
av2[3]=t1;
C_apply(4,av2);}}

/* scheme#max in k12559 in k11436 */
static void C_ccall f_18466(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +6,c,5)))){
C_save_and_reclaim((void*)f_18466,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+6);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
t4=C_i_flonump(t2);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18473,a[2]=t6,a[3]=((C_word)li478),tmp=(C_word)a,a+=4,tmp));
t8=((C_word*)t6)[1];
f_18473(t8,t1,t4,t2,t3);}

/* loop in scheme#max in k12559 in k11436 */
static void f_18473(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(11,0,4)))){
C_save_and_reclaim_args((void *)trf_18473,5,t0,t1,t2,t3,t4);}
a=C_alloc(11);
t5=C_i_check_number_2(t3,lf[658]);
if(C_truep(C_i_nullp(t4))){
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=(C_truep(t2)?C_a_i_exact_to_inexact(&a,1,t3):t3);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_slot(t4,C_fix(0));
t7=(C_truep(t2)?t2:C_i_flonump(t6));
t8=C_i_greaterp(t6,t3);
t9=(C_truep(t8)?t6:t3);
/* library.scm:2582: loop */
t11=t1;
t12=t7;
t13=t9;
t14=C_slot(t4,C_fix(1));
t1=t11;
t2=t12;
t3=t13;
t4=t14;
goto loop;}}

/* scheme#min in k12559 in k11436 */
static void C_ccall f_18510(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +6,c,5)))){
C_save_and_reclaim((void*)f_18510,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+6);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
t4=C_i_flonump(t2);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18517,a[2]=t6,a[3]=((C_word)li480),tmp=(C_word)a,a+=4,tmp));
t8=((C_word*)t6)[1];
f_18517(t8,t1,t4,t2,t3);}

/* loop in scheme#min in k12559 in k11436 */
static void f_18517(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(11,0,4)))){
C_save_and_reclaim_args((void *)trf_18517,5,t0,t1,t2,t3,t4);}
a=C_alloc(11);
t5=C_i_check_number_2(t3,lf[659]);
if(C_truep(C_i_nullp(t4))){
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=(C_truep(t2)?C_a_i_exact_to_inexact(&a,1,t3):t3);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_slot(t4,C_fix(0));
t7=(C_truep(t2)?t2:C_i_flonump(t6));
t8=C_i_lessp(t6,t3);
t9=(C_truep(t8)?t6:t3);
/* library.scm:2593: loop */
t11=t1;
t12=t7;
t13=t9;
t14=C_slot(t4,C_fix(1));
t1=t11;
t2=t12;
t3=t13;
t4=t14;
goto loop;}}

/* scheme#exp in k12559 in k11436 */
static void C_ccall f_18554(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(15,c,2)))){
C_save_and_reclaim((void *)f_18554,c,av);}
a=C_alloc(15);
t3=C_i_check_number_2(t2,lf[661]);
if(C_truep(C_i_cplxnump(t2))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18572,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2602: scheme#exact->inexact */
t5=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=C_u_i_cplxnum_real(t2);
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}
else{
t4=C_a_i_exact_to_inexact(&a,1,t2);
t5=C_flonum(&a,C_exp(C_flonum_magnitude(t4)));
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* k18570 in scheme#exp in k12559 in k11436 */
static void C_ccall f_18572(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,2)))){
C_save_and_reclaim((void *)f_18572,c,av);}
a=C_alloc(12);
t2=C_a_i_exp(&a,1,t1);
t3=C_u_i_cplxnum_imag(((C_word*)t0)[2]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18581,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18586,a[2]=t3,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2605: scheme#exact->inexact */
t6=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}

/* k18579 in k18570 in scheme#exp in k12559 in k11436 */
static void C_ccall f_18581(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,1)))){
C_save_and_reclaim((void *)f_18581,c,av);}
a=C_alloc(33);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_s_a_i_times(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k18584 in k18570 in scheme#exp in k12559 in k11436 */
static void C_ccall f_18586(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(19,c,3)))){
C_save_and_reclaim((void *)f_18586,c,av);}
a=C_alloc(19);
t2=C_a_i_cos(&a,1,t1);
t3=C_a_i_exact_to_inexact(&a,1,((C_word*)t0)[2]);
t4=C_a_i_sin(&a,1,t3);
/* library.scm:2604: make-complex */
f_17268(((C_word*)t0)[3],t2,t4);}

/* ##sys#log-1 in k12559 in k11436 */
static void C_ccall f_18599(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_18599,c,av);}
a=C_alloc(7);
t3=C_eqp(t2,C_fix(0));
if(C_truep(t3)){
/* library.scm:2612: ##sys#signal-hook */
t4=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t4;
av2[1]=t1;
av2[2]=lf[663];
av2[3]=lf[664];
av2[4]=lf[665];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(6,av2);}}
else{
t4=C_i_cplxnump(t2);
t5=(C_truep(t4)?t4:C_i_negativep(t2));
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18625,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18641,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* library.scm:2615: scheme#magnitude */
t8=*((C_word*)lf[616]+1);{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t8+1)))(3,av2);}}
else{
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18645,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:2618: scheme#exact->inexact */
t7=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}}}

/* k18623 in ##sys#log-1 in k12559 in k11436 */
static void C_ccall f_18625(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_18625,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_18633,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2616: make-complex */
f_17268(t2,C_fix(0),C_fix(1));}

/* k18631 in k18623 in ##sys#log-1 in k12559 in k11436 */
static void C_ccall f_18633(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_18633,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_18637,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2616: scheme#angle */
t3=*((C_word*)lf[614]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k18635 in k18631 in k18623 in ##sys#log-1 in k12559 in k11436 */
static void C_ccall f_18637(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(62,c,1)))){
C_save_and_reclaim((void *)f_18637,c,av);}
a=C_alloc(62);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_s_a_i_plus(&a,2,((C_word*)t0)[4],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k18639 in ##sys#log-1 in k12559 in k11436 */
static void C_ccall f_18641(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_18641,c,av);}
/* library.scm:2615: ##sys#log-1 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[662]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[662]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* k18643 in ##sys#log-1 in k12559 in k11436 */
static void C_ccall f_18645(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_18645,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_log(&a,1,t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scheme#log in k12559 in k11436 */
static void C_ccall f_18648(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_18648,c,av);}
a=C_alloc(4);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18662,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2622: ##sys#log-1 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[662]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[662]+1);
av2[1]=t5;
av2[2]=t2;
tp(3,av2);}}
else{
/* library.scm:2622: ##sys#log-1 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[662]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[662]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}}

/* k18660 in scheme#log in k12559 in k11436 */
static void C_ccall f_18662(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_18662,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18666,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2622: ##sys#log-1 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[662]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[662]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k18664 in k18660 in scheme#log in k12559 in k11436 */
static void C_ccall f_18666(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_18666,c,av);}
/* library.scm:2622: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* scheme#sin in k12559 in k11436 */
static void C_ccall f_18677(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(37,c,2)))){
C_save_and_reclaim((void *)f_18677,c,av);}
a=C_alloc(37);
t3=C_i_check_number_2(t2,lf[668]);
if(C_truep(C_i_cplxnump(t2))){
t4=C_s_a_i_times(&a,2,lf[669],t2);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18701,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2629: scheme#exp */
t6=*((C_word*)lf[660]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}
else{
t4=C_a_i_exact_to_inexact(&a,1,t2);
t5=C_a_i_sin(&a,1,t4);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* k18699 in scheme#sin in k12559 in k11436 */
static void C_ccall f_18701(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,2)))){
C_save_and_reclaim((void *)f_18701,c,av);}
a=C_alloc(33);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18705,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t3=C_s_a_i_negate(&a,1,((C_word*)t0)[3]);
/* library.scm:2629: scheme#exp */
t4=*((C_word*)lf[660]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t2;
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k18703 in k18699 in scheme#sin in k12559 in k11436 */
static void C_ccall f_18705(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,3)))){
C_save_and_reclaim((void *)f_18705,c,av);}
a=C_alloc(29);
t2=C_s_a_i_minus(&a,2,((C_word*)t0)[2],t1);
/* library.scm:2629: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
av2[3]=lf[670];
tp(4,av2);}}

/* scheme#cos in k12559 in k11436 */
static void C_ccall f_18711(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(37,c,2)))){
C_save_and_reclaim((void *)f_18711,c,av);}
a=C_alloc(37);
t3=C_i_check_number_2(t2,lf[672]);
if(C_truep(C_i_cplxnump(t2))){
t4=C_s_a_i_times(&a,2,lf[669],t2);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18735,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2637: scheme#exp */
t6=*((C_word*)lf[660]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}
else{
t4=C_a_i_exact_to_inexact(&a,1,t2);
t5=C_a_i_cos(&a,1,t4);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* k18733 in scheme#cos in k12559 in k11436 */
static void C_ccall f_18735(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,2)))){
C_save_and_reclaim((void *)f_18735,c,av);}
a=C_alloc(33);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18739,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t3=C_s_a_i_negate(&a,1,((C_word*)t0)[3]);
/* library.scm:2637: scheme#exp */
t4=*((C_word*)lf[660]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t2;
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k18737 in k18733 in scheme#cos in k12559 in k11436 */
static void C_ccall f_18739(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,3)))){
C_save_and_reclaim((void *)f_18739,c,av);}
a=C_alloc(29);
t2=C_s_a_i_plus(&a,2,((C_word*)t0)[2],t1);
/* library.scm:2637: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
av2[3]=C_fix(2);
tp(4,av2);}}

/* scheme#tan in k12559 in k11436 */
static void C_ccall f_18745(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(15,c,2)))){
C_save_and_reclaim((void *)f_18745,c,av);}
a=C_alloc(15);
t3=C_i_check_number_2(t2,lf[674]);
if(C_truep(C_i_cplxnump(t2))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18762,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2644: scheme#sin */
t5=*((C_word*)lf[667]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}
else{
t4=C_a_i_exact_to_inexact(&a,1,t2);
t5=C_a_i_tan(&a,1,t4);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* k18760 in scheme#tan in k12559 in k11436 */
static void C_ccall f_18762(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_18762,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18766,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2644: scheme#cos */
t3=*((C_word*)lf[671]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k18764 in k18760 in scheme#tan in k12559 in k11436 */
static void C_ccall f_18766(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_18766,c,av);}
/* library.scm:2644: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* scheme#asin in k12559 in k11436 */
static void C_ccall f_18770(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_18770,c,av);}
a=C_alloc(8);
t3=C_i_check_number_2(t2,lf[676]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18780,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_flonump(t2))){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18828,a[2]=t4,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2651: chicken.flonum#fp>= */
t6=*((C_word*)lf[546]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
av2[3]=lf[679];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t5=t4;
f_18780(t5,C_SCHEME_FALSE);}}

/* k18778 in scheme#asin in k12559 in k11436 */
static void f_18780(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_18780,2,t0,t1);}
a=C_alloc(4);
if(C_truep(t1)){
t2=C_a_i_asin(&a,1,((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word av2[2];
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18786,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_fixnump(((C_word*)t0)[2]))){
t3=C_fixnum_greater_or_equal_p(((C_word*)t0)[2],C_fix(-1));
t4=t2;
f_18786(t4,(C_truep(t3)?C_fixnum_less_or_equal_p(((C_word*)t0)[2],C_fix(1)):C_SCHEME_FALSE));}
else{
t3=t2;
f_18786(t3,C_SCHEME_FALSE);}}}

/* k18784 in k18778 in scheme#asin in k12559 in k11436 */
static void f_18786(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(102,0,3)))){
C_save_and_reclaim_args((void *)trf_18786,2,t0,t1);}
a=C_alloc(102);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_a_i_asin(&a,1,C_a_i_fix_to_flo(&a,1,((C_word*)t0)[3]));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_18793,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=C_s_a_i_times(&a,2,lf[669],((C_word*)t0)[3]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18805,a[2]=t3,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t5=C_s_a_i_times(&a,2,((C_word*)t0)[3],((C_word*)t0)[3]);
t6=C_s_a_i_minus(&a,2,C_fix(1),t5);
/* library.scm:2660: ##sys#sqrt/loc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[678]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[678]+1);
av2[1]=t4;
av2[2]=lf[676];
av2[3]=t6;
tp(4,av2);}}}

/* k18791 in k18784 in k18778 in scheme#asin in k12559 in k11436 */
static void C_ccall f_18793(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,1)))){
C_save_and_reclaim((void *)f_18793,c,av);}
a=C_alloc(33);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_s_a_i_times(&a,2,lf[677],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k18803 in k18784 in k18778 in scheme#asin in k12559 in k11436 */
static void C_ccall f_18805(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,2)))){
C_save_and_reclaim((void *)f_18805,c,av);}
a=C_alloc(29);
t2=C_s_a_i_plus(&a,2,((C_word*)t0)[2],t1);
/* library.scm:2658: ##sys#log-1 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[662]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[662]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
tp(3,av2);}}

/* k18826 in scheme#asin in k12559 in k11436 */
static void C_ccall f_18828(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_18828,c,av);}
t2=((C_word*)t0)[2];
f_18780(t2,(C_truep(t1)?C_ub_i_flonum_less_or_equal_p(C_flonum_magnitude(((C_word*)t0)[3]),(double)1.0):C_SCHEME_FALSE));}

/* scheme#acos in k12559 in k11436 */
static void C_ccall f_18832(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_18832,c,av);}
a=C_alloc(9);
t3=C_i_check_number_2(t2,lf[681]);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_18842,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_flonump(t2))){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18870,a[2]=t4,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2668: chicken.flonum#fp>= */
t6=*((C_word*)lf[546]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
av2[3]=lf[679];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t5=t4;
f_18842(t5,C_SCHEME_FALSE);}}

/* k18840 in scheme#acos in k12559 in k11436 */
static void f_18842(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_18842,2,t0,t1);}
a=C_alloc(5);
if(C_truep(t1)){
t2=C_a_i_acos(&a,1,((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word av2[2];
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_18848,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fixnump(((C_word*)t0)[2]))){
t3=C_fixnum_greater_or_equal_p(((C_word*)t0)[2],C_fix(-1));
t4=t2;
f_18848(t4,(C_truep(t3)?C_fixnum_less_or_equal_p(((C_word*)t0)[2],C_fix(1)):C_SCHEME_FALSE));}
else{
t3=t2;
f_18848(t3,C_SCHEME_FALSE);}}}

/* k18846 in k18840 in scheme#acos in k12559 in k11436 */
static void f_18848(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,2)))){
C_save_and_reclaim_args((void *)trf_18848,2,t0,t1);}
a=C_alloc(8);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_a_i_acos(&a,1,C_a_i_fix_to_flo(&a,1,((C_word*)t0)[3]));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18855,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2675: scheme#asin */
t3=*((C_word*)lf[675]+1);{
C_word av2[3];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}}

/* k18853 in k18846 in k18840 in scheme#acos in k12559 in k11436 */
static void C_ccall f_18855(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,1)))){
C_save_and_reclaim((void *)f_18855,c,av);}
a=C_alloc(29);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_s_a_i_minus(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k18868 in scheme#acos in k12559 in k11436 */
static void C_ccall f_18870(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_18870,c,av);}
t2=((C_word*)t0)[2];
f_18842(t2,(C_truep(t1)?C_ub_i_flonum_less_or_equal_p(C_flonum_magnitude(((C_word*)t0)[3]),(double)1.0):C_SCHEME_FALSE));}

/* scheme#atan in k12559 in k11436 */
static void C_ccall f_18874(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(66,c,3)))){
C_save_and_reclaim((void *)f_18874,c,av);}
a=C_alloc(66);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=C_i_check_number_2(t2,lf[683]);
if(C_truep(C_i_cplxnump(t2))){
if(C_truep(t4)){
/* library.scm:2682: ##sys#error-bad-real */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[429]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[429]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[683];
tp(4,av2);}}
else{
t6=C_s_a_i_times(&a,2,lf[669],t2);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18907,a[2]=t1,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
t8=C_s_a_i_plus(&a,2,C_fix(1),t6);
/* library.scm:2684: ##sys#log-1 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[662]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[662]+1);
av2[1]=t7;
av2[2]=t8;
tp(3,av2);}}}
else{
if(C_truep(t4)){
t6=C_a_i_exact_to_inexact(&a,1,t2);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18928,a[2]=t1,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2688: scheme#exact->inexact */
t8=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t8+1)))(3,av2);}}
else{
t6=C_a_i_exact_to_inexact(&a,1,t2);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_a_i_atan(&a,1,t6);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}}

/* k18905 in scheme#atan in k12559 in k11436 */
static void C_ccall f_18907(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,2)))){
C_save_and_reclaim((void *)f_18907,c,av);}
a=C_alloc(33);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_18911,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t3=C_s_a_i_minus(&a,2,C_fix(1),((C_word*)t0)[3]);
/* library.scm:2685: ##sys#log-1 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[662]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[662]+1);
av2[1]=t2;
av2[2]=t3;
tp(3,av2);}}

/* k18909 in k18905 in scheme#atan in k12559 in k11436 */
static void C_ccall f_18911(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,3)))){
C_save_and_reclaim((void *)f_18911,c,av);}
a=C_alloc(29);
t2=C_s_a_i_minus(&a,2,((C_word*)t0)[2],t1);
/* library.scm:2684: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
av2[3]=lf[670];
tp(4,av2);}}

/* k18926 in scheme#atan in k12559 in k11436 */
static void C_ccall f_18928(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_18928,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_atan2(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#exact-integer-sqrt in k12559 in k11436 */
static void C_ccall f_18938(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_18938,c,av);}
a=C_alloc(10);
t3=C_fixnump(t2);
t4=(C_truep(t3)?C_fixnum_less_or_equal_p(t2,C_fix(4)):C_SCHEME_FALSE);
if(C_truep(t4)){
t5=C_eqp(t2,C_fix(0));
t6=(C_truep(t5)?t5:C_eqp(t2,C_fix(1)));
if(C_truep(t6)){
/* library.scm:2700: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
av2[3]=C_fix(0);
C_values(4,av2);}}
else{
switch(t2){
case C_fix(2):
/* library.scm:2701: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_fix(1);
av2[3]=C_fix(1);
C_values(4,av2);}
case C_fix(3):
/* library.scm:2702: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_fix(1);
av2[3]=C_fix(2);
C_values(4,av2);}
case C_fix(4):
/* library.scm:2703: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_fix(2);
av2[3]=C_fix(0);
C_values(4,av2);}
default:
/* library.scm:2704: chicken.base#error */
t7=*((C_word*)lf[234]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t1;
av2[2]=lf[685];
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}}}
else{
t5=C_fixnum_plus(C_i_integer_length(t2),C_fix(1));
t6=C_fixnum_shift_right(t5,C_fix(2));
t7=C_fixnum_shift_left(t6,C_fix(1));
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19011,a[2]=t7,a[3]=t2,a[4]=((C_word)li491),tmp=(C_word)a,a+=5,tmp);
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19025,a[2]=t6,a[3]=t2,a[4]=((C_word)li495),tmp=(C_word)a,a+=5,tmp);
/* library.scm:2705: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=t8;
av2[3]=t9;
C_call_with_values(4,av2);}}}

/* a19010 in ##sys#exact-integer-sqrt in k12559 in k11436 */
static void C_ccall f_19011(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_19011,c,av);}
a=C_alloc(5);
t2=C_fixnum_negate(((C_word*)t0)[2]);
t3=C_s_a_i_arithmetic_shift(&a,2,((C_word*)t0)[3],t2);
/* library.scm:2708: ##sys#exact-integer-sqrt */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[684]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[684]+1);
av2[1]=t1;
av2[2]=t3;
tp(3,av2);}}

/* a19024 in ##sys#exact-integer-sqrt in k12559 in k11436 */
static void C_ccall f_19025(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(38,c,4)))){
C_save_and_reclaim((void *)f_19025,c,av);}
a=C_alloc(38);
t4=C_s_a_i_arithmetic_shift(&a,2,C_fix(1),((C_word*)t0)[2]);
t5=C_s_a_u_i_integer_minus(&a,2,t4,C_fix(1));
t6=C_s_a_i_bitwise_and(&a,2,((C_word*)t0)[3],t5);
t7=C_fixnum_negate(((C_word*)t0)[2]);
t8=C_s_a_i_arithmetic_shift(&a,2,((C_word*)t0)[3],t7);
t9=C_s_a_i_bitwise_and(&a,2,t8,t5);
t10=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_19042,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=t9,a[5]=t2,a[6]=((C_word)li493),tmp=(C_word)a,a+=7,tmp);
t11=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_19058,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t6,a[5]=((C_word)li494),tmp=(C_word)a,a+=6,tmp);
/* library.scm:2705: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t10;
av2[3]=t11;
C_call_with_values(4,av2);}}

/* a19041 in a19024 in ##sys#exact-integer-sqrt in k12559 in k11436 */
static void C_ccall f_19042(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(18,c,3)))){
C_save_and_reclaim((void *)f_19042,c,av);}
a=C_alloc(18);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_u_integer_quotient_and_remainder,a[2]=((C_word)li492),tmp=(C_word)a,a+=3,tmp);
t3=C_s_a_i_arithmetic_shift(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t4=C_s_a_u_i_integer_plus(&a,2,t3,((C_word*)t0)[4]);
t5=C_s_a_i_arithmetic_shift(&a,2,((C_word*)t0)[5],C_fix(1));
/* library.scm:2705: g3240 */
t6=t2;{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
((C_proc)C_fast_retrieve_proc(t6))(4,av2);}}

/* a19057 in a19024 in ##sys#exact-integer-sqrt in k12559 in k11436 */
static void C_ccall f_19058(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(222,c,3)))){
C_save_and_reclaim((void *)f_19058,c,av);}
a=C_alloc(222);
t4=C_s_a_i_arithmetic_shift(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t5=C_s_a_i_plus(&a,2,t4,t2);
t6=C_s_a_i_arithmetic_shift(&a,2,t3,((C_word*)t0)[3]);
t7=C_s_a_i_times(&a,2,t2,t2);
t8=C_s_a_i_minus(&a,2,((C_word*)t0)[4],t7);
t9=C_s_a_i_plus(&a,2,t6,t8);
if(C_truep(C_i_negativep(t9))){
t10=C_s_a_i_minus(&a,2,t5,C_fix(1));
t11=C_s_a_i_arithmetic_shift(&a,2,t5,C_fix(1));
t12=C_s_a_i_plus(&a,2,t9,t11);
t13=C_s_a_i_minus(&a,2,t12,C_fix(1));
/* library.scm:2719: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t10;
av2[3]=t13;
C_values(4,av2);}}
else{
/* library.scm:2721: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t5;
av2[3]=t9;
C_values(4,av2);}}}

/* scheme#exact-integer-sqrt in k12559 in k11436 */
static void C_ccall f_19129(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_19129,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19133,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2725: ##sys#check-exact-uinteger */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[426]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[426]+1);
av2[1]=t3;
av2[2]=t2;
av2[3]=lf[687];
tp(4,av2);}}

/* k19131 in scheme#exact-integer-sqrt in k12559 in k11436 */
static void C_ccall f_19133(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_19133,c,av);}
/* library.scm:2726: ##sys#exact-integer-sqrt */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[684]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[684]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19138(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(32,c,4)))){
C_save_and_reclaim((void *)f_19138,c,av);}
a=C_alloc(32);
if(C_truep(C_i_cplxnump(t3))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19148,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
t5=C_u_i_cplxnum_imag(t3);
t6=C_a_i_exact_to_inexact(&a,1,t5);
t7=C_u_i_cplxnum_real(t3);
t8=C_a_i_exact_to_inexact(&a,1,t7);
t9=C_flonum(&a,C_atan2(C_flonum_magnitude(t6),C_flonum_magnitude(t8)));
/* library.scm:2732: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t4;
av2[2]=t9;
av2[3]=C_fix(2);
tp(4,av2);}}
else{
if(C_truep(C_i_negativep(t3))){
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19188,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t5=C_s_a_i_negate(&a,1,t3);
/* library.scm:2737: scheme#exact->inexact */
t6=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t4;
av2[2]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}
else{
if(C_truep(C_i_exact_integerp(t3))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19199,a[2]=t3,a[3]=((C_word)li498),tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19205,a[2]=t3,a[3]=((C_word)li499),tmp=(C_word)a,a+=4,tmp);
/* library.scm:2739: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
C_call_with_values(4,av2);}}
else{
if(C_truep(C_i_ratnump(t3))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19227,a[2]=t3,a[3]=((C_word)li500),tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19239,a[2]=t3,a[3]=t2,a[4]=((C_word)li503),tmp=(C_word)a,a+=5,tmp);
/* library.scm:2744: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
C_call_with_values(4,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19291,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:2752: scheme#exact->inexact */
t5=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}}}}}

/* k19146 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19148(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_19148,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19152,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2733: scheme#magnitude */
t3=*((C_word*)lf[616]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k19150 in k19146 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19152(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_19152,c,av);}
a=C_alloc(9);
t2=C_a_i_sqrt(&a,1,t1);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19171,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2734: scheme#cos */
t4=*((C_word*)lf[671]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k19165 in k19169 in k19150 in k19146 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19167(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,3)))){
C_save_and_reclaim((void *)f_19167,c,av);}
a=C_alloc(33);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],t1);
/* library.scm:2734: make-complex */
f_17268(((C_word*)t0)[3],((C_word*)t0)[4],t2);}

/* k19169 in k19150 in k19146 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19171(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(38,c,2)))){
C_save_and_reclaim((void *)f_19171,c,av);}
a=C_alloc(38);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],t1);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19167,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2734: scheme#sin */
t4=*((C_word*)lf[667]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k19186 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19188(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_19188,c,av);}
a=C_alloc(4);
t2=C_a_i_sqrt(&a,1,t1);
/* library.scm:2736: make-complex */
f_17268(((C_word*)t0)[2],lf[605],t2);}

/* a19198 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19199(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_19199,c,av);}
/* library.scm:2739: ##sys#exact-integer-sqrt */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[684]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[684]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* a19204 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19205(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_19205,c,av);}
a=C_alloc(3);
t4=C_eqp(C_fix(0),t3);
if(C_truep(t4)){
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19216,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:2742: scheme#exact->inexact */
t6=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}}

/* k19214 in a19204 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19216(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_19216,c,av);}
a=C_alloc(4);
t2=C_a_i_sqrt(&a,1,t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a19226 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19227(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_19227,c,av);}
/* library.scm:2744: ##sys#exact-integer-sqrt */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[684]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[684]+1);
av2[1]=t1;
av2[2]=C_u_i_ratnum_num(((C_word*)t0)[2]);
tp(3,av2);}}

/* a19238 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19239(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_19239,c,av);}
a=C_alloc(10);
t4=C_eqp(t3,C_fix(0));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19251,a[2]=((C_word*)t0)[2],a[3]=((C_word)li501),tmp=(C_word)a,a+=4,tmp);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_19263,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word)li502),tmp=(C_word)a,a+=6,tmp);
/* library.scm:2746: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t5;
av2[3]=t6;
C_call_with_values(4,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19287,a[2]=t1,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2751: scheme#exact->inexact */
t6=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}}

/* a19250 in a19238 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19251(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_19251,c,av);}
/* library.scm:2747: ##sys#exact-integer-sqrt */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[684]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[684]+1);
av2[1]=t1;
av2[2]=C_u_i_ratnum_denom(((C_word*)t0)[2]);
tp(3,av2);}}

/* a19262 in a19238 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19263(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_19263,c,av);}
a=C_alloc(4);
t4=C_eqp(t3,C_fix(0));
if(C_truep(t4)){
/* library.scm:2749: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=t2;
tp(4,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19280,a[2]=t1,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2750: scheme#exact->inexact */
t6=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}}

/* k19278 in a19262 in a19238 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19280(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19280,c,av);}
/* library.scm:2750: ##sys#sqrt/loc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[678]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[678]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k19285 in a19238 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19287(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19287,c,av);}
/* library.scm:2751: ##sys#sqrt/loc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[678]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[678]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k19289 in ##sys#sqrt/loc in k12559 in k11436 */
static void C_ccall f_19291(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_19291,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_sqrt(&a,1,t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scheme#sqrt in k12559 in k11436 */
static void C_ccall f_19293(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19293,c,av);}
/* library.scm:2754: ##sys#sqrt/loc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[678]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[678]+1);
av2[1]=t1;
av2[2]=lf[688];
av2[3]=t2;
tp(4,av2);}}

/* scheme#floor/ in k12559 in k11436 */
static void C_ccall f_19300(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_19300,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19306,a[2]=t2,a[3]=t3,a[4]=((C_word)li506),tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19312,a[2]=t3,a[3]=((C_word)li507),tmp=(C_word)a,a+=4,tmp);
/* library.scm:2762: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
C_call_with_values(4,av2);}}

/* a19305 in scheme#floor/ in k12559 in k11436 */
static void C_ccall f_19306(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19306,c,av);}
/* library.scm:2762: chicken.base#quotient&remainder */
t2=*((C_word*)lf[221]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* a19311 in scheme#floor/ in k12559 in k11436 */
static void C_ccall f_19312(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(58,c,3)))){
C_save_and_reclaim((void *)f_19312,c,av);}
a=C_alloc(58);
if(C_truep(C_i_positivep(((C_word*)t0)[2]))){
if(C_truep(C_i_negativep(t3))){
t4=C_s_a_i_minus(&a,2,t2,C_fix(1));
t5=C_s_a_i_plus(&a,2,t3,((C_word*)t0)[2]);
/* library.scm:2765: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
C_values(4,av2);}}
else{
/* library.scm:2766: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
C_values(4,av2);}}}
else{
if(C_truep(C_i_positivep(t3))){
t4=C_s_a_i_minus(&a,2,t2,C_fix(1));
t5=C_s_a_i_plus(&a,2,t3,((C_word*)t0)[2]);
/* library.scm:2768: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
C_values(4,av2);}}
else{
/* library.scm:2769: scheme#values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
C_values(4,av2);}}}}

/* scheme#floor-remainder in k12559 in k11436 */
static void C_ccall f_19355(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_19355,c,av);}
a=C_alloc(8);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19361,a[2]=t2,a[3]=t3,a[4]=((C_word)li509),tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19367,a[2]=((C_word)li510),tmp=(C_word)a,a+=3,tmp);
/* library.scm:2772: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
C_call_with_values(4,av2);}}

/* a19360 in scheme#floor-remainder in k12559 in k11436 */
static void C_ccall f_19361(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19361,c,av);}
/* library.scm:2772: scheme#floor/ */
t2=*((C_word*)lf[690]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* a19366 in scheme#floor-remainder in k12559 in k11436 */
static void C_ccall f_19367(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_19367,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#floor-quotient in k12559 in k11436 */
static void C_ccall f_19370(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_19370,c,av);}
a=C_alloc(8);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19376,a[2]=t2,a[3]=t3,a[4]=((C_word)li512),tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19382,a[2]=((C_word)li513),tmp=(C_word)a,a+=3,tmp);
/* library.scm:2775: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
C_call_with_values(4,av2);}}

/* a19375 in scheme#floor-quotient in k12559 in k11436 */
static void C_ccall f_19376(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19376,c,av);}
/* library.scm:2775: scheme#floor/ */
t2=*((C_word*)lf[690]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* a19381 in scheme#floor-quotient in k12559 in k11436 */
static void C_ccall f_19382(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_19382,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#square in k12559 in k11436 */
static void C_ccall f_19385(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(33,c,1)))){
C_save_and_reclaim((void *)f_19385,c,av);}
a=C_alloc(33);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_s_a_i_times(&a,2,t2,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#exact-integer-nth-root in k12559 in k11436 */
static void C_ccall f_19391(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_19391,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19395,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2781: ##sys#check-exact-uinteger */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[426]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[426]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=lf[696];
tp(4,av2);}}

/* k19393 in chicken.base#exact-integer-nth-root in k12559 in k11436 */
static void C_ccall f_19395(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_19395,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19398,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2782: ##sys#check-exact-uinteger */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[426]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[426]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=lf[696];
tp(4,av2);}}

/* k19396 in k19393 in chicken.base#exact-integer-nth-root in k12559 in k11436 */
static void C_ccall f_19398(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_19398,c,av);}
/* library.scm:2783: ##sys#exact-integer-nth-root/loc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[695]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[695]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[696];
av2[3]=((C_word*)t0)[3];
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}

/* ##sys#exact-integer-nth-root/loc in k12559 in k11436 */
static void C_ccall f_19403(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_19403,c,av);}
a=C_alloc(5);
t5=C_eqp(C_fix(0),t3);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19413,a[2]=t1,a[3]=t3,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
if(C_truep(t5)){
t7=t6;
f_19413(t7,t5);}
else{
t7=C_eqp(C_fix(1),t3);
t8=t6;
f_19413(t8,(C_truep(t7)?t7:C_eqp(C_fix(1),t4)));}}

/* k19411 in ##sys#exact-integer-nth-root/loc in k12559 in k11436 */
static void f_19413(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,0,3)))){
C_save_and_reclaim_args((void *)trf_19413,2,t0,t1);}
a=C_alloc(29);
if(C_truep(t1)){
/* library.scm:2789: scheme#values */{
C_word av2[4];
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=C_fix(0);
C_values(4,av2);}}
else{
t2=C_i_integer_length(((C_word*)t0)[3]);
if(C_truep(C_i_lessp(t2,((C_word*)t0)[4]))){
t3=C_s_a_i_minus(&a,2,((C_word*)t0)[3],C_fix(1));
/* library.scm:2792: scheme#values */{
C_word av2[4];
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=C_fix(1);
av2[3]=t3;
C_values(4,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19433,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19509,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19513,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t5;
av2[2]=C_fixnum_plus(t2,C_fix(1));
av2[3]=((C_word*)t0)[4];
tp(4,av2);}}}}

/* k19431 in k19411 in ##sys#exact-integer-nth-root/loc in k12559 in k11436 */
static void C_ccall f_19433(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(75,c,3)))){
C_save_and_reclaim((void *)f_19433,c,av);}
a=C_alloc(75);
t2=C_s_a_i_arithmetic_shift(&a,2,C_fix(1),t1);
t3=C_s_a_i_minus(&a,2,((C_word*)t0)[2],C_fix(1));
t4=C_s_a_i_times(&a,2,t3,t2);
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_19505,a[2]=((C_word*)t0)[3],a[3]=t4,a[4]=((C_word*)t0)[2],a[5]=t3,a[6]=((C_word*)t0)[4],a[7]=t2,tmp=(C_word)a,a+=8,tmp);
/* library.scm:2800: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t5;
av2[2]=t2;
av2[3]=t3;
tp(4,av2);}}

/* lp in k19503 in k19431 in k19411 in ##sys#exact-integer-nth-root/loc in k12559 in k11436 */
static void f_19448(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(41,0,3)))){
C_save_and_reclaim_args((void *)trf_19448,4,t0,t1,t2,t3);}
a=C_alloc(41);
if(C_truep(C_i_lessp(t3,t2))){
t4=C_s_a_i_times(&a,2,((C_word*)t0)[2],t3);
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_19478,a[2]=((C_word*)t0)[3],a[3]=t4,a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,a[7]=t3,tmp=(C_word)a,a+=8,tmp);
/* library.scm:2805: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t5;
av2[2]=t3;
av2[3]=((C_word*)t0)[2];
tp(4,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19489,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2807: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=((C_word*)t0)[4];
tp(4,av2);}}}

/* k19476 in lp in k19503 in k19431 in k19411 in ##sys#exact-integer-nth-root/loc in k12559 in k11436 */
static void C_ccall f_19478(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(39,c,3)))){
C_save_and_reclaim((void *)f_19478,c,av);}
a=C_alloc(39);
t2=C_s_a_i_quotient(&a,2,((C_word*)t0)[2],t1);
t3=C_s_a_i_plus(&a,2,((C_word*)t0)[3],t2);
t4=C_s_a_i_quotient(&a,2,t3,((C_word*)t0)[4]);
/* library.scm:2803: lp */
t5=((C_word*)((C_word*)t0)[5])[1];
f_19448(t5,((C_word*)t0)[6],((C_word*)t0)[7],t4);}

/* k19487 in lp in k19503 in k19431 in k19411 in ##sys#exact-integer-nth-root/loc in k12559 in k11436 */
static void C_ccall f_19489(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,3)))){
C_save_and_reclaim((void *)f_19489,c,av);}
a=C_alloc(29);
t2=C_s_a_i_minus(&a,2,((C_word*)t0)[2],t1);
/* library.scm:2807: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=t2;
C_values(4,av2);}}

/* k19503 in k19431 in k19411 in ##sys#exact-integer-nth-root/loc in k12559 in k11436 */
static void C_ccall f_19505(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(48,c,4)))){
C_save_and_reclaim((void *)f_19505,c,av);}
a=C_alloc(48);
t2=C_s_a_i_quotient(&a,2,((C_word*)t0)[2],t1);
t3=C_s_a_i_plus(&a,2,((C_word*)t0)[3],t2);
t4=C_s_a_i_quotient(&a,2,t3,((C_word*)t0)[4]);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_19448,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],a[5]=t6,a[6]=((C_word)li517),tmp=(C_word)a,a+=7,tmp));
t8=((C_word*)t6)[1];
f_19448(t8,((C_word*)t0)[6],((C_word*)t0)[7],t4);}

/* k19507 in k19411 in ##sys#exact-integer-nth-root/loc in k12559 in k11436 */
static void C_ccall f_19509(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_19509,c,av);}
/* library.scm:2794: scheme#inexact->exact */
t2=*((C_word*)lf[622]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k19511 in k19411 in ##sys#exact-integer-nth-root/loc in k12559 in k11436 */
static void C_ccall f_19513(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_19513,c,av);}
/* library.scm:2794: scheme#ceiling */
t2=*((C_word*)lf[648]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* ##sys#integer-power in k12559 in k11436 */
static void C_ccall f_19529(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_19529,c,av);}
a=C_alloc(8);
if(C_truep(C_i_negativep(t3))){
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19547,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t5=C_s_a_u_i_integer_negate(&a,1,t3);
/* library.scm:2812: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=t5;
tp(4,av2);}}
else{
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19558,a[2]=t5,a[3]=t2,a[4]=((C_word)li519),tmp=(C_word)a,a+=5,tmp));
t7=((C_word*)t5)[1];
f_19558(t7,t1,C_fix(1),t3);}}

/* k19545 in ##sys#integer-power in k12559 in k11436 */
static void C_ccall f_19547(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19547,c,av);}
/* library.scm:2812: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=C_fix(1);
av2[3]=t1;
tp(4,av2);}}

/* lp in ##sys#integer-power in k12559 in k11436 */
static void f_19558(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(62,0,3)))){
C_save_and_reclaim_args((void *)trf_19558,4,t0,t1,t2,t3);}
a=C_alloc(62);
t4=C_eqp(t3,C_fix(0));
if(C_truep(t4)){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_i_evenp(t3))){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19580,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t6=C_s_a_i_arithmetic_shift(&a,2,t3,C_fix(-1));
/* library.scm:2817: lp */
t8=t5;
t9=C_fix(1);
t10=t6;
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
t5=C_s_a_i_times(&a,2,t2,((C_word*)t0)[3]);
t6=C_s_a_i_minus(&a,2,t3,C_fix(1));
/* library.scm:2819: lp */
t8=t1;
t9=t5;
t10=t6;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* k19578 in lp in ##sys#integer-power in k12559 in k11436 */
static void C_ccall f_19580(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(66,c,1)))){
C_save_and_reclaim((void *)f_19580,c,av);}
a=C_alloc(66);
t2=C_s_a_i_times(&a,2,t1,t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_s_a_i_times(&a,2,((C_word*)t0)[3],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#expt in k12559 in k11436 */
static void C_ccall f_19597(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(21,c,4)))){
C_save_and_reclaim((void *)f_19597,c,av);}
a=C_alloc(21);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19600,a[2]=((C_word)li521),tmp=(C_word)a,a+=3,tmp));
t9=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19614,a[2]=((C_word)li522),tmp=(C_word)a,a+=3,tmp));
t10=C_i_numberp(t2);
if(C_truep(C_i_not(t10))){
/* library.scm:2831: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[440]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[697];
tp(4,av2);}}
else{
t11=C_i_numberp(t3);
if(C_truep(C_i_not(t11))){
/* library.scm:2832: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[440]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=lf[697];
tp(4,av2);}}
else{
t12=C_i_ratnump(t2);
t13=(C_truep(t12)?C_i_not(C_i_inexactp(t3)):C_SCHEME_FALSE);
if(C_truep(t13)){
t14=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19666,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2836: scheme#expt */
t15=*((C_word*)lf[634]+1);{
C_word *av2=av;
av2[0]=t15;
av2[1]=t14;
av2[2]=C_u_i_ratnum_num(t2);
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t15+1)))(4,av2);}}
else{
if(C_truep(C_i_ratnump(t3))){
if(C_truep(C_i_exact_integerp(t2))){
if(C_truep(C_i_negativep(t2))){
t14=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19705,a[2]=t3,a[3]=t5,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2843: scheme#exact->inexact */
t15=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t15;
av2[1]=t14;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t15+1)))(3,av2);}}
else{
t14=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19712,a[2]=t2,a[3]=t3,a[4]=((C_word)li523),tmp=(C_word)a,a+=5,tmp);
t15=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19724,a[2]=t3,a[3]=t2,a[4]=((C_word)li524),tmp=(C_word)a,a+=5,tmp);
/* library.scm:2844: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t14;
av2[3]=t15;
C_call_with_values(4,av2);}}}
else{
if(C_truep(C_i_flonump(t2))){
t14=C_a_i_exact_to_inexact(&a,1,t3);
/* library.scm:2853: log-expt */
f_19600(t1,t2,t14);}
else{
/* library.scm:2854: slow-expt */
f_19614(t1,t2,t3);}}}
else{
t14=C_i_cplxnump(t3);
t15=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_19768,a[2]=t7,a[3]=t1,a[4]=t2,a[5]=t3,a[6]=t5,tmp=(C_word)a,a+=7,tmp);
if(C_truep(t14)){
t16=t15;
f_19768(t16,t14);}
else{
t16=C_i_cplxnump(t2);
t17=t15;
f_19768(t17,(C_truep(t16)?C_i_not(C_i_integerp(t3)):C_SCHEME_FALSE));}}}}}}

/* log-expt in scheme#expt in k12559 in k11436 */
static void f_19600(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_19600,3,t1,t2,t3);}
a=C_alloc(4);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19612,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2824: ##sys#log-1 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[662]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[662]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}

/* k19610 in log-expt in scheme#expt in k12559 in k11436 */
static void C_ccall f_19612(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,2)))){
C_save_and_reclaim((void *)f_19612,c,av);}
a=C_alloc(33);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],t1);
/* library.scm:2824: scheme#exp */
t3=*((C_word*)lf[660]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* slow-expt in scheme#expt in k12559 in k11436 */
static void f_19614(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,6)))){
C_save_and_reclaim_args((void *)trf_19614,3,t1,t2,t3);}
a=C_alloc(4);
t4=C_eqp(C_fix(0),t2);
if(C_truep(t4)){
/* library.scm:2827: ##sys#signal-hook */
t5=*((C_word*)lf[235]+1);{
C_word av2[7];
av2[0]=t5;
av2[1]=t1;
av2[2]=lf[663];
av2[3]=lf[697];
av2[4]=lf[698];
av2[5]=t2;
av2[6]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(7,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19635,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2830: ##sys#log-1 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[662]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[662]+1);
av2[1]=t5;
av2[2]=t2;
tp(3,av2);}}}

/* k19633 in slow-expt in scheme#expt in k12559 in k11436 */
static void C_ccall f_19635(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,2)))){
C_save_and_reclaim((void *)f_19635,c,av);}
a=C_alloc(33);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],t1);
/* library.scm:2830: scheme#exp */
t3=*((C_word*)lf[660]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k19664 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19666(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,3)))){
C_save_and_reclaim((void *)f_19666,c,av);}
a=C_alloc(33);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19670,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_u_i_ratnum_denom(((C_word*)t0)[3]);
t4=C_s_a_i_negate(&a,1,((C_word*)t0)[4]);
/* library.scm:2837: scheme#expt */
t5=*((C_word*)lf[634]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=t3;
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k19668 in k19664 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19670(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,1)))){
C_save_and_reclaim((void *)f_19670,c,av);}
a=C_alloc(33);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_s_a_i_times(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k19703 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19705(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_19705,c,av);}
a=C_alloc(11);
t2=C_a_i_exact_to_inexact(&a,1,((C_word*)t0)[2]);
/* library.scm:2843: log-expt */
f_19600(((C_word*)t0)[4],t1,t2);}

/* a19711 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19712(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_19712,c,av);}
/* library.scm:2845: ##sys#exact-integer-nth-root/loc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[695]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[695]+1);
av2[1]=t1;
av2[2]=lf[697];
av2[3]=((C_word*)t0)[2];
av2[4]=C_u_i_ratnum_denom(((C_word*)t0)[3]);
tp(5,av2);}}

/* a19723 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19724(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_19724,c,av);}
a=C_alloc(4);
t4=C_eqp(t3,C_fix(0));
if(C_truep(t4)){
/* library.scm:2848: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_u_i_ratnum_num(((C_word*)t0)[2]);
tp(4,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19744,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2850: scheme#exact->inexact */
t6=*((C_word*)lf[86]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}}

/* k19742 in a19723 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19744(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_19744,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19748,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2851: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k19746 in k19742 in a19723 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19748(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_19748,c,av);}
a=C_alloc(4);
t2=C_a_i_flonum_expt(&a,2,((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k19766 in scheme#expt in k12559 in k11436 */
static void f_19768(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_19768,2,t0,t1);}
a=C_alloc(7);
if(C_truep(t1)){
/* library.scm:2856: slow-expt */
f_19614(((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}
else{
t2=(C_truep(C_i_flonump(((C_word*)t0)[5]))?C_i_not(C_u_i_fpintegerp(((C_word*)t0)[5])):C_SCHEME_FALSE);
if(C_truep(t2)){
if(C_truep(C_i_negativep(((C_word*)t0)[4]))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19788,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:2860: scheme#exact->inexact */
t4=*((C_word*)lf[86]+1);{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19796,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2862: scheme#exact->inexact */
t4=*((C_word*)lf[86]+1);{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}}
else{
if(C_truep(C_i_flonump(((C_word*)t0)[4]))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19803,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2864: scheme#exact->inexact */
t4=*((C_word*)lf[86]+1);{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}
else{
t3=C_i_inexactp(((C_word*)t0)[4]);
t4=(C_truep(t3)?t3:C_i_inexactp(((C_word*)t0)[5]));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_19819,a[2]=((C_word*)t0)[3],tmp=(C_word)a,a+=3,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19823,a[2]=t5,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2868: scheme#inexact->exact */
t7=*((C_word*)lf[622]+1);{
C_word av2[3];
av2[0]=t7;
av2[1]=t6;
av2[2]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}
else{
/* library.scm:2869: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[632]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[5];
tp(4,av2);}}}}}}

/* k19786 in k19766 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19788(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_19788,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19792,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2860: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k19790 in k19786 in k19766 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19792(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19792,c,av);}
/* library.scm:2860: log-expt */
f_19600(((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k19794 in k19766 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19796(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_19796,c,av);}
a=C_alloc(4);
t2=C_a_i_flonum_expt(&a,2,t1,((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k19801 in k19766 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19803(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_19803,c,av);}
a=C_alloc(4);
t2=C_a_i_flonum_expt(&a,2,((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k19817 in k19766 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19819(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_19819,c,av);}
/* library.scm:2868: scheme#exact->inexact */
t2=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k19821 in k19766 in scheme#expt in k12559 in k11436 */
static void C_ccall f_19823(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19823,c,av);}
/* library.scm:2868: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[632]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* ##sys#internal-gcd in k12559 in k11436 */
static void f_19864(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_19864,4,t1,t2,t3,t4);}
a=C_alloc(5);
if(C_truep(C_i_exact_integerp(t3))){
if(C_truep(C_i_exact_integerp(t4))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_s_a_u_i_integer_gcd(&a,2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=(C_truep(C_i_flonump(t4))?C_u_i_fpintegerp(t4):C_SCHEME_FALSE);
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19897,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2877: scheme#inexact->exact */
t7=*((C_word*)lf[622]+1);{
C_word av2[3];
av2[0]=t7;
av2[1]=t6;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}
else{
/* library.scm:2878: ##sys#error-bad-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[423]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[423]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t2;
tp(4,av2);}}}}
else{
t5=(C_truep(C_i_flonump(t3))?C_u_i_fpintegerp(t3):C_SCHEME_FALSE);
if(C_truep(t5)){
if(C_truep(C_i_flonump(t4))){
t6=C_a_i_flonum_gcd(&a,2,t3,t4);
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
if(C_truep(C_i_exact_integerp(t4))){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19926,a[2]=t4,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2884: scheme#inexact->exact */
t7=*((C_word*)lf[622]+1);{
C_word av2[3];
av2[0]=t7;
av2[1]=t6;
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}
else{
/* library.scm:2885: ##sys#error-bad-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[423]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[423]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=t2;
tp(4,av2);}}}}
else{
/* library.scm:2886: ##sys#error-bad-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[423]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[423]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=t2;
tp(4,av2);}}}}

/* k19895 in ##sys#internal-gcd in k12559 in k11436 */
static void C_ccall f_19897(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_19897,c,av);}
a=C_alloc(5);
t2=C_s_a_u_i_integer_gcd(&a,2,((C_word*)t0)[2],t1);
/* library.scm:2877: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k19924 in ##sys#internal-gcd in k12559 in k11436 */
static void C_ccall f_19926(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_19926,c,av);}
a=C_alloc(5);
t2=C_s_a_u_i_integer_gcd(&a,2,t1,((C_word*)t0)[2]);
/* library.scm:2884: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* ##sys#gcd in k12559 in k11436 */
static void C_ccall f_19934(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_19934,c,av);}
/* library.scm:2888: ##sys#internal-gcd */
f_19864(t1,lf[700],t2,t3);}

/* scheme#gcd in k12559 in k11436 */
static void C_ccall f_19940(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +6,c,4)))){
C_save_and_reclaim((void*)f_19940,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+6);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
t3=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(t3)){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fix(0);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_slot(t2,C_fix(0));
t5=C_slot(t2,C_fix(1));
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_19960,a[2]=t7,a[3]=((C_word)li528),tmp=(C_word)a,a+=4,tmp));
t9=((C_word*)t7)[1];
f_19960(t9,t1,t4,t5);}}

/* loop in scheme#gcd in k12559 in k11436 */
static void f_19960(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_19960,4,t0,t1,t2,t3);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t3))){
if(C_truep(C_i_integerp(t2))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_s_a_i_abs(&a,1,t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
/* library.scm:2897: ##sys#error-bad-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[423]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[423]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[700];
tp(4,av2);}}}
else{
t4=C_slot(t3,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19985,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2899: ##sys#internal-gcd */
f_19864(t5,lf[700],t2,t4);}}

/* k19983 in loop in scheme#gcd in k12559 in k11436 */
static void C_ccall f_19985(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_19985,c,av);}
/* library.scm:2899: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_19960(t2,((C_word*)t0)[3],t1,C_slot(((C_word*)t0)[4],C_fix(1)));}

/* ##sys#lcm in k12559 in k11436 */
static void C_ccall f_19991(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_19991,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_19995,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:2903: ##sys#internal-gcd */
f_19864(t4,lf[703],t2,t3);}

/* k19993 in ##sys#lcm in k12559 in k11436 */
static void C_ccall f_19995(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(45,c,1)))){
C_save_and_reclaim((void *)f_19995,c,av);}
a=C_alloc(45);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=C_s_a_i_quotient(&a,2,t2,t1);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_s_a_i_abs(&a,1,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#lcm in k12559 in k11436 */
static void C_ccall f_20005(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +6,c,4)))){
C_save_and_reclaim((void*)f_20005,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+6);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
if(C_truep(C_rest_nullp(c,2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_fix(1);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_slot(t2,C_fix(0));
t4=C_slot(t2,C_fix(1));
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_20025,a[2]=t6,a[3]=((C_word)li531),tmp=(C_word)a,a+=4,tmp));
t8=((C_word*)t6)[1];
f_20025(t8,t1,t3,t4);}}

/* loop in scheme#lcm in k12559 in k11436 */
static void f_20025(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_20025,4,t0,t1,t2,t3);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t3))){
if(C_truep(C_i_integerp(t2))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_s_a_i_abs(&a,1,t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
/* library.scm:2913: ##sys#error-bad-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[423]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[423]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[703];
tp(4,av2);}}}
else{
t4=C_slot(t3,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_20046,a[2]=t2,a[3]=t4,a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=t3,tmp=(C_word)a,a+=7,tmp);
/* library.scm:2915: ##sys#internal-gcd */
f_19864(t5,lf[703],t2,t4);}}

/* k20044 in loop in scheme#lcm in k12559 in k11436 */
static void C_ccall f_20046(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(38,c,3)))){
C_save_and_reclaim((void *)f_20046,c,av);}
a=C_alloc(38);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=C_s_a_i_quotient(&a,2,t2,t1);
/* library.scm:2916: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_20025(t4,((C_word*)t0)[5],t3,C_slot(((C_word*)t0)[6],C_fix(1)));}

/* ##sys#integer->string/recursive in k12559 in k11436 */
static void C_ccall f_20063(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_20063,c,av);}
a=C_alloc(6);
t5=C_fixnum_plus(t4,C_fix(1));
t6=C_fixnum_shift_right(t5,C_fix(1));
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_20070,a[2]=t2,a[3]=t6,a[4]=t3,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:2923: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t7;
av2[2]=t3;
av2[3]=t6;
tp(4,av2);}}

/* k20068 in ##sys#integer->string/recursive in k12559 in k11436 */
static void C_ccall f_20070(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_20070,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20075,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word)li534),tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20081,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word)li535),tmp=(C_word)a,a+=5,tmp);
/* library.scm:2922: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[5];
av2[2]=t2;
av2[3]=t3;
C_call_with_values(4,av2);}}

/* a20074 in k20068 in ##sys#integer->string/recursive in k12559 in k11436 */
static void C_ccall f_20075(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_20075,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_u_integer_quotient_and_remainder,a[2]=((C_word)li533),tmp=(C_word)a,a+=3,tmp);
/* library.scm:2922: g3443 */
t3=t2;{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t3))(4,av2);}}

/* a20080 in k20068 in ##sys#integer->string/recursive in k12559 in k11436 */
static void C_ccall f_20081(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_20081,c,av);}
a=C_alloc(6);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_20085,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t3,a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
/* ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}

/* k20083 in a20080 in k20068 in ##sys#integer->string/recursive in k12559 in k11436 */
static void C_ccall f_20085(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_20085,c,av);}
a=C_alloc(12);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20088,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t3=C_s_a_i_abs(&a,1,((C_word*)t0)[4]);
/* ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=t3;
av2[3]=((C_word*)t0)[5];
tp(4,av2);}}

/* k20086 in k20083 in a20080 in k20068 in ##sys#integer->string/recursive in k12559 in k11436 */
static void C_ccall f_20088(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_20088,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20095,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* ##sys#make-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[446]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[446]+1);
av2[1]=t2;
av2[2]=C_fixnum_difference(((C_word*)t0)[4],C_u_i_string_length(t1));
av2[3]=C_make_character(48);
tp(4,av2);}}

/* k20093 in k20086 in k20083 in a20080 in k20068 in ##sys#integer->string/recursive in k12559 in k11436 */
static void C_ccall f_20095(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_20095,c,av);}
/* library.scm:2928: scheme#string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* ##sys#extended-number->string in k12559 in k11436 */
static void C_ccall f_20113(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_20113,c,av);}
a=C_alloc(5);
if(C_truep(C_i_ratnump(t2))){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20127,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t4;
av2[2]=C_u_i_ratnum_num(t2);
av2[3]=t3;
tp(4,av2);}}
else{
if(C_truep(C_i_cplxnump(t2))){
t4=C_u_i_cplxnum_real(t2);
t5=C_u_i_cplxnum_imag(t2);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20168,a[2]=t5,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t6;
av2[2]=t4;
av2[3]=t3;
tp(4,av2);}}
else{
/* library.scm:2950: ##sys#error-bad-number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[440]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[440]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[712];
tp(4,av2);}}}}

/* k20125 in ##sys#extended-number->string in k12559 in k11436 */
static void C_ccall f_20127(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_20127,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_20131,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=C_u_i_ratnum_denom(((C_word*)t0)[3]);
av2[3]=((C_word*)t0)[4];
tp(4,av2);}}

/* k20129 in k20125 in ##sys#extended-number->string in k12559 in k11436 */
static void C_ccall f_20131(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_20131,c,av);}
/* library.scm:2938: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[708];
av2[4]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k20166 in ##sys#extended-number->string in k12559 in k11436 */
static void C_ccall f_20168(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_20168,c,av);}
a=C_alloc(5);
t2=(C_truep(C_i_finitep(((C_word*)t0)[2]))?(C_truep(C_i_positivep(((C_word*)t0)[2]))?lf[709]:lf[710]):lf[710]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20176,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[4];
tp(4,av2);}}

/* k20174 in k20166 in ##sys#extended-number->string in k12559 in k11436 */
static void C_ccall f_20176(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_20176,c,av);}
/* library.scm:2945: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
av2[4]=t1;
av2[5]=lf[711];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k20203 in safe-exponent in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20205(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(44,c,1)))){
C_save_and_reclaim((void *)f_20205,c,av);}
a=C_alloc(44);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],t1);
t3=C_a_i_exact_to_inexact(&a,1,t2);
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k20206 in safe-exponent in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20208(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,3)))){
C_save_and_reclaim((void *)f_20208,c,av);}
a=C_alloc(13);
t2=C_fixnum_difference(C_i_integer_length(((C_word*)t0)[2]),C_i_integer_length(t1));
t3=C_fixnum_difference(t2,*((C_word*)lf[520]+1));
t4=t3;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
if(C_truep(C_fixnum_lessp(((C_word*)t5)[1],C_fix(0)))){
t6=C_fixnum_negate(((C_word*)t5)[1]);
t7=C_s_a_i_arithmetic_shift(&a,2,((C_word*)t0)[2],t6);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_20223,a[2]=t5,a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t7,tmp=(C_word)a,a+=6,tmp);
/* library.scm:2969: round-quotient */
f_20287(t8,t7,t1);}
else{
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_20262,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2976: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t6;
av2[2]=C_fix(10);
av2[3]=((C_word*)t0)[4];
tp(4,av2);}}}

/* k20221 in k20206 in safe-exponent in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20223(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(44,c,3)))){
C_save_and_reclaim((void *)f_20223,c,av);}
a=C_alloc(44);
t2=t1;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20226,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=((C_word*)t3)[1];
t6=C_i_integer_length(t5);
t7=*((C_word*)lf[520]+1);
if(C_truep(C_fixnum_greaterp(t6,*((C_word*)lf[520]+1)))){
t8=C_fixnum_plus(C_fix(1),((C_word*)((C_word*)t0)[2])[1]);
t9=C_set_block_item(((C_word*)t0)[2],0,t8);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_20244,a[2]=t3,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
t11=C_s_a_i_times(&a,2,((C_word*)t0)[4],C_fix(2));
/* library.scm:2973: round-quotient */
f_20287(t10,((C_word*)t0)[5],t11);}
else{
t8=t4;
f_20226(t8,C_SCHEME_UNDEFINED);}}

/* k20224 in k20221 in k20206 in safe-exponent in ##sys#string->compnum in k12559 in k11436 */
static void f_20226(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_20226,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_20233,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:2974: scheme#exact->inexact */
t3=*((C_word*)lf[86]+1);{
C_word av2[3];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[4])[1];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k20231 in k20224 in k20221 in k20206 in safe-exponent in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20233(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,1)))){
C_save_and_reclaim((void *)f_20233,c,av);}
a=C_alloc(6);
t2=((C_word*)((C_word*)t0)[2])[1];
t3=C_a_i_bytevector(&a,1,C_fix(4));
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=stub3497(t3,C_i_foreign_flonum_argumentp(t1),C_i_foreign_fixnum_argumentp(t2));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k20242 in k20221 in k20206 in safe-exponent in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20244(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_20244,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=((C_word*)t0)[3];
f_20226(t3,t2);}

/* k20260 in k20206 in safe-exponent in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20262(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,1)))){
C_save_and_reclaim((void *)f_20262,c,av);}
a=C_alloc(33);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_s_a_i_times(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* round-quotient in k12559 in k11436 */
static void f_20287(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(63,0,3)))){
C_save_and_reclaim_args((void *)trf_20287,3,t1,t2,t3);}
a=C_alloc(63);
t4=C_s_a_u_i_integer_quotient(&a,2,t2,t3);
t5=(C_truep(C_i_evenp(t4))?*((C_word*)lf[97]+1):*((C_word*)lf[99]+1));
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_20302,a[2]=t2,a[3]=t3,a[4]=t1,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
t7=C_s_a_i_remainder(&a,2,t2,t3);
t8=C_s_a_i_abs(&a,1,t7);
t9=C_s_a_i_times(&a,2,t8,C_fix(2));
t10=C_s_a_i_abs(&a,1,t3);
/* library.scm:2983: g3510 */
t11=t5;{
C_word av2[4];
av2[0]=t11;
av2[1]=t6;
av2[2]=t9;
av2[3]=t10;
((C_proc)(void*)(*((C_word*)t11+1)))(4,av2);}}

/* k20300 in round-quotient in k12559 in k11436 */
static void C_ccall f_20302(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,1)))){
C_save_and_reclaim((void *)f_20302,c,av);}
a=C_alloc(29);
if(C_truep(t1)){
t2=C_eqp(C_i_negativep(((C_word*)t0)[2]),C_i_negativep(((C_word*)t0)[3]));
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(t2)?C_s_a_i_plus(&a,2,((C_word*)t0)[5],C_fix(1)):C_s_a_i_plus(&a,2,((C_word*)t0)[5],C_fix(-1)));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* ##sys#string->compnum in k12559 in k11436 */
static void f_20330(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(87,0,5)))){
C_save_and_reclaim_args((void *)trf_20330,5,t1,t2,t3,t4,t5);}
a=C_alloc(87);
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_SCHEME_UNDEFINED;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_set_block_item(t8,0,C_SCHEME_FALSE);
t14=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20334,a[2]=t6,a[3]=t8,a[4]=((C_word)li539),tmp=(C_word)a,a+=5,tmp));
t15=C_set_block_item(t12,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_20348,a[2]=t6,a[3]=((C_word)li540),tmp=(C_word)a,a+=4,tmp));
t16=C_i_string_length(t3);
t17=C_fixnum_difference(t2,C_fix(1));
t18=C_fixnum_plus(C_fix(48),t17);
t19=C_make_character(C_unfix(t18));
t20=C_fixnum_difference(t2,C_fix(11));
t21=C_fixnum_plus(C_fix(97),t20);
t22=C_make_character(C_unfix(t21));
t23=C_fixnum_difference(t2,C_fix(11));
t24=C_fixnum_plus(C_fix(65),t23);
t25=C_make_character(C_unfix(t24));
t26=C_SCHEME_FALSE;
t27=(*a=C_VECTOR_TYPE|1,a[1]=t26,tmp=(C_word)a,a+=2,tmp);
t28=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_20428,a[2]=t16,a[3]=t3,a[4]=t2,a[5]=t19,a[6]=t22,a[7]=t25,a[8]=((C_word)li542),tmp=(C_word)a,a+=9,tmp);
t29=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20532,a[2]=t16,a[3]=t3,a[4]=((C_word)li544),tmp=(C_word)a,a+=5,tmp);
t30=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_20580,a[2]=t3,a[3]=t2,a[4]=t27,a[5]=t10,a[6]=t29,a[7]=t28,a[8]=((C_word)li545),tmp=(C_word)a,a+=9,tmp);
t31=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_20636,a[2]=t16,a[3]=t3,a[4]=t2,a[5]=t28,a[6]=((C_word)li546),tmp=(C_word)a,a+=7,tmp);
t32=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_20689,a[2]=t16,a[3]=t3,a[4]=t12,a[5]=t31,a[6]=t30,a[7]=((C_word)li547),tmp=(C_word)a,a+=8,tmp);
t33=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_20901,a[2]=t10,a[3]=t32,a[4]=t3,a[5]=t2,a[6]=t16,a[7]=t12,a[8]=t31,a[9]=t27,a[10]=t6,a[11]=t30,a[12]=((C_word)li548),tmp=(C_word)a,a+=13,tmp);
t34=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_21243,a[2]=t16,a[3]=t3,a[4]=t33,a[5]=t10,a[6]=((C_word)li549),tmp=(C_word)a,a+=7,tmp);
t35=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_21474,a[2]=t6,a[3]=t8,a[4]=t1,a[5]=t3,a[6]=t16,a[7]=t4,a[8]=t27,a[9]=t34,tmp=(C_word)a,a+=10,tmp);
/* library.scm:3167: scan-real */
t36=t34;
f_21243(t36,t35,t4);}

/* go-inexact! in ##sys#string->compnum in k12559 in k11436 */
static C_word f_20334(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_stack_overflow_check;{}
t2=C_eqp(((C_word*)((C_word*)t0)[2])[1],lf[715]);
if(C_truep(t2)){
t3=C_SCHEME_UNDEFINED;
return(t3);}
else{
t3=C_mutate(((C_word *)((C_word*)t0)[2])+1,lf[716]);
t4=((C_word*)((C_word*)t0)[3])[1];
if(C_truep(t4)){
t5=C_mutate(((C_word *)((C_word*)t0)[3])+1,t4);
return(t5);}
else{
t5=C_mutate(((C_word *)((C_word*)t0)[3])+1,t1);
return(t5);}}}

/* safe-exponent in ##sys#string->compnum in k12559 in k11436 */
static void f_20348(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,0,3)))){
C_save_and_reclaim_args((void *)trf_20348,4,t0,t1,t2,t3);}
a=C_alloc(12);
if(C_truep(t3)){
if(C_truep(C_i_not(t2))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_fix(0);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
if(C_truep(C_i_greaterp(t3,C_fix(10000)))){
t4=C_eqp(((C_word*)((C_word*)t0)[2])[1],lf[716]);
if(C_truep(t4)){
if(C_truep(C_i_zerop(t2))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=lf[605];
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_i_greaterp(t2,lf[605]);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=(C_truep(t5)?lf[717]:lf[718]);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}
else{
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}
else{
t4=C_fixnum_negate(C_fix(10000));
if(C_truep(C_i_lessp(t3,t4))){
t5=C_eqp(((C_word*)((C_word*)t0)[2])[1],lf[716]);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=(C_truep(t5)?lf[605]:C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t5=C_eqp(((C_word*)((C_word*)t0)[2])[1],lf[716]);
if(C_truep(t5)){
if(C_truep(C_i_not(C_i_negativep(t3)))){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_20205,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:2962: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t6;
av2[2]=C_fix(10);
av2[3]=t3;
tp(4,av2);}}
else{
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20208,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t7=C_s_a_i_abs(&a,1,t3);
/* library.scm:2963: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t6;
av2[2]=C_fix(10);
av2[3]=t7;
tp(4,av2);}}}
else{
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_20408,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3006: ##sys#integer-power */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[632]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[632]+1);
av2[1]=t6;
av2[2]=C_fix(10);
av2[3]=t3;
tp(4,av2);}}}}}}
else{
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k20406 in safe-exponent in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20408(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,1)))){
C_save_and_reclaim((void *)f_20408,c,av);}
a=C_alloc(33);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_s_a_i_times(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scan-digits in ##sys#string->compnum in k12559 in k11436 */
static void f_20428(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,0,3)))){
C_save_and_reclaim_args((void *)trf_20428,3,t0,t1,t2);}
a=C_alloc(13);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_20434,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=t4,a[8]=((C_word*)t0)[6],a[9]=((C_word*)t0)[7],a[10]=((C_word)li541),tmp=(C_word)a,a+=11,tmp));
t6=((C_word*)t4)[1];
f_20434(t6,t1,t2);}

/* lp in scan-digits in ##sys#string->compnum in k12559 in k11436 */
static void f_20434(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_20434,3,t0,t1,t2);}
a=C_alloc(6);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=C_fixnum_greaterp(t2,((C_word*)t0)[3]);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_a_i_cons(&a,2,t2,C_SCHEME_FALSE):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t4=C_i_string_ref(((C_word*)t0)[4],t2);
if(C_truep(C_fixnum_less_or_equal_p(((C_word*)t0)[5],C_fix(10)))){
t5=(C_truep(C_u_i_char_greater_or_equal_p(t4,C_make_character(48)))?C_u_i_char_less_or_equal_p(t4,((C_word*)t0)[6]):C_SCHEME_FALSE);
if(C_truep(t5)){
/* library.scm:3030: lp */
t9=t1;
t10=C_fixnum_plus(t2,C_fix(1));
t1=t9;
t2=t10;
goto loop;}
else{
t6=C_fixnum_greaterp(t2,((C_word*)t0)[3]);
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=(C_truep(t6)?C_a_i_cons(&a,2,t2,t2):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}
else{
t5=(C_truep(C_u_i_char_greater_or_equal_p(t4,C_make_character(48)))?C_u_i_char_less_or_equal_p(t4,C_make_character(57)):C_SCHEME_FALSE);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_20494,a[2]=((C_word*)t0)[7],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
if(C_truep(t5)){
t7=t6;
f_20494(t7,t5);}
else{
t7=(C_truep(C_u_i_char_greater_or_equal_p(t4,C_make_character(97)))?C_u_i_char_less_or_equal_p(t4,((C_word*)t0)[8]):C_SCHEME_FALSE);
t8=t6;
f_20494(t8,(C_truep(t7)?t7:(C_truep(C_u_i_char_greater_or_equal_p(t4,C_make_character(65)))?C_u_i_char_less_or_equal_p(t4,((C_word*)t0)[9]):C_SCHEME_FALSE)));}}}}

/* k20492 in lp in scan-digits in ##sys#string->compnum in k12559 in k11436 */
static void f_20494(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_20494,2,t0,t1);}
a=C_alloc(3);
if(C_truep(t1)){
/* library.scm:3035: lp */
t2=((C_word*)((C_word*)t0)[2])[1];
f_20434(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}
else{
t2=C_fixnum_greaterp(((C_word*)t0)[4],((C_word*)t0)[5]);
t3=((C_word*)t0)[3];{
C_word av2[2];
av2[0]=t3;
av2[1]=(C_truep(t2)?C_a_i_cons(&a,2,((C_word*)t0)[4],((C_word*)t0)[4]):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* scan-hashes in ##sys#string->compnum in k12559 in k11436 */
static void f_20532(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,3)))){
C_save_and_reclaim_args((void *)trf_20532,3,t0,t1,t2);}
a=C_alloc(9);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_20538,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word*)t0)[3],a[5]=t4,a[6]=((C_word)li543),tmp=(C_word)a,a+=7,tmp));
t6=((C_word*)t4)[1];
f_20538(t6,t1,t2);}

/* lp in scan-hashes in ##sys#string->compnum in k12559 in k11436 */
static void f_20538(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_20538,3,t0,t1,t2);}
a=C_alloc(3);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=C_fixnum_greaterp(t2,((C_word*)t0)[3]);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_a_i_cons(&a,2,t2,C_SCHEME_FALSE):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t4=C_i_string_ref(((C_word*)t0)[4],t2);
t5=C_eqp(t4,C_make_character(35));
if(C_truep(t5)){
/* library.scm:3044: lp */
t8=t1;
t9=C_fixnum_plus(t2,C_fix(1));
t1=t8;
t2=t9;
goto loop;}
else{
t6=C_fixnum_greaterp(t2,((C_word*)t0)[3]);
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=(C_truep(t6)?C_a_i_cons(&a,2,t2,t2):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}}

/* scan-digits+hashes in ##sys#string->compnum in k12559 in k11436 */
static void f_20580(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,2)))){
C_save_and_reclaim_args((void *)trf_20580,5,t0,t1,t2,t3,t4);}
a=C_alloc(11);
t5=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_20584,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word*)t0)[3],a[5]=t3,a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=t1,a[9]=((C_word*)t0)[6],a[10]=t4,tmp=(C_word)a,a+=11,tmp);
if(C_truep(C_i_not(((C_word*)((C_word*)t0)[4])[1]))){
/* library.scm:3048: scan-digits */
t6=((C_word*)t0)[7];
f_20428(t6,t5,t2);}
else{
t6=t5;{
C_word av2[2];
av2[0]=t6;
av2[1]=C_SCHEME_FALSE;
f_20584(2,av2);}}}

/* k20582 in scan-digits+hashes in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20584(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_20584,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_20587,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],tmp=(C_word)a,a+=10,tmp);
if(C_truep(t1)){
if(C_truep(C_i_cdr(t1))){
/* library.scm:3050: scan-hashes */
t3=((C_word*)t0)[9];
f_20532(t3,t2,C_u_i_cdr(t1));}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
f_20587(2,av2);}}}
else{
if(C_truep(((C_word*)t0)[10])){
/* library.scm:3051: scan-hashes */
t3=((C_word*)t0)[9];
f_20532(t3,t2,((C_word*)t0)[3]);}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
f_20587(2,av2);}}}}

/* k20585 in k20582 in scan-digits+hashes in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20587(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,1)))){
C_save_and_reclaim((void *)f_20587,c,av);}
a=C_alloc(9);
t2=(C_truep(t1)?t1:((C_word*)t0)[2]);
if(C_truep(t2)){
t3=C_i_car(t2);
t4=C_s_a_i_digits_to_integer(&a,5,((C_word*)t0)[3],((C_word*)t0)[4],t3,((C_word*)t0)[5],((C_word*)t0)[6]);
if(C_truep(t4)){
if(C_truep(t1)){
t5=C_set_block_item(((C_word*)t0)[7],0,C_SCHEME_TRUE);
t6=(
/* library.scm:3059: go-inexact! */
  f_20334(((C_word*)((C_word*)t0)[8])[1],((C_word*)t0)[6])
);
t7=C_u_i_cdr(t2);
t8=((C_word*)t0)[9];{
C_word *av2=av;
av2[0]=t8;
av2[1]=C_a_i_cons(&a,2,t4,t7);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t5=C_u_i_cdr(t2);
t6=((C_word*)t0)[9];{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_a_i_cons(&a,2,t4,t5);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}
else{
t5=((C_word*)t0)[9];{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}
else{
t3=((C_word*)t0)[9];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* scan-exponent in ##sys#string->compnum in k12559 in k11436 */
static void f_20636(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_20636,3,t0,t1,t2);}
a=C_alloc(7);
if(C_truep(C_fixnum_lessp(t2,((C_word*)t0)[2]))){
t3=C_i_string_ref(((C_word*)t0)[3],t2);
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_20649,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
t5=C_eqp(t3,C_make_character(43));
if(C_truep(t5)){
t6=t4;
f_20649(t6,lf[720]);}
else{
t6=C_eqp(t3,C_make_character(45));
t7=t4;
f_20649(t7,(C_truep(t6)?lf[719]:C_SCHEME_FALSE));}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k20647 in scan-exponent in ##sys#string->compnum in k12559 in k11436 */
static void f_20649(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_20649,2,t0,t1);}
a=C_alloc(7);
t2=(C_truep(t1)?C_fixnum_plus(((C_word*)t0)[2],C_fix(1)):((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_20655,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* library.scm:3067: scan-digits */
t4=((C_word*)t0)[6];
f_20428(t4,t3,t2);}

/* k20653 in k20647 in scan-exponent in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20655(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,1)))){
C_save_and_reclaim((void *)f_20655,c,av);}
a=C_alloc(9);
if(C_truep(t1)){
t2=C_i_car(t1);
t3=C_eqp(((C_word*)t0)[2],lf[719]);
t4=C_s_a_i_digits_to_integer(&a,5,((C_word*)t0)[3],((C_word*)t0)[4],t2,((C_word*)t0)[5],t3);
t5=C_u_i_cdr(t1);
t6=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_a_i_cons(&a,2,t4,t5);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t2=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* scan-decimal-tail in ##sys#string->compnum in k12559 in k11436 */
static void f_20689(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,4)))){
C_save_and_reclaim_args((void *)trf_20689,5,t0,t1,t2,t3,t4);}
a=C_alloc(9);
if(C_truep(C_fixnum_lessp(t2,((C_word*)t0)[2]))){
t5=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_20699,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=((C_word*)t0)[4],a[7]=t4,a[8]=((C_word*)t0)[5],tmp=(C_word)a,a+=9,tmp);
/* library.scm:3075: scan-digits+hashes */
t6=((C_word*)t0)[6];
f_20580(t6,t5,t2,t3,t4);}
else{
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* k20697 in scan-decimal-tail in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20699(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_20699,c,av);}
a=C_alloc(11);
t2=(C_truep(t1)?C_i_cdr(t1):((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_20708,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[2],a[9]=((C_word*)t0)[7],a[10]=((C_word*)t0)[8],tmp=(C_word)a,a+=11,tmp);
if(C_truep(((C_word*)t0)[7])){
t4=t3;
f_20708(t4,((C_word*)t0)[7]);}
else{
t4=C_i_not(t2);
t5=t3;
f_20708(t5,(C_truep(t4)?t4:C_fixnum_greaterp(t2,((C_word*)t0)[2])));}}

/* k20706 in k20697 in scan-decimal-tail in ##sys#string->compnum in k12559 in k11436 */
static void f_20708(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,2)))){
C_save_and_reclaim_args((void *)trf_20708,2,t0,t1);}
a=C_alloc(10);
if(C_truep(t1)){
t2=(C_truep(((C_word*)t0)[2])?C_i_string_ref(((C_word*)t0)[3],((C_word*)t0)[2]):C_SCHEME_FALSE);
t3=C_eqp(t2,C_make_character(101));
t4=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_20720,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],a[9]=((C_word*)t0)[10],tmp=(C_word)a,a+=10,tmp);
if(C_truep(t3)){
t5=t4;
f_20720(t5,t3);}
else{
t5=C_eqp(t2,C_make_character(115));
if(C_truep(t5)){
t6=t4;
f_20720(t6,t5);}
else{
t6=C_eqp(t2,C_make_character(102));
if(C_truep(t6)){
t7=t4;
f_20720(t7,t6);}
else{
t7=C_eqp(t2,C_make_character(100));
if(C_truep(t7)){
t8=t4;
f_20720(t8,t7);}
else{
t8=C_eqp(t2,C_make_character(108));
if(C_truep(t8)){
t9=t4;
f_20720(t9,t8);}
else{
t9=C_eqp(t2,C_make_character(69));
if(C_truep(t9)){
t10=t4;
f_20720(t10,t9);}
else{
t10=C_eqp(t2,C_make_character(83));
if(C_truep(t10)){
t11=t4;
f_20720(t11,t10);}
else{
t11=C_eqp(t2,C_make_character(70));
if(C_truep(t11)){
t12=t4;
f_20720(t12,t11);}
else{
t12=C_eqp(t2,C_make_character(68));
t13=t4;
f_20720(t13,(C_truep(t12)?t12:C_eqp(t2,C_make_character(76))));}}}}}}}}}
else{
t2=((C_word*)t0)[6];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k20718 in k20706 in k20697 in scan-decimal-tail in ##sys#string->compnum in k12559 in k11436 */
static void f_20720(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_20720,2,t0,t1);}
a=C_alloc(7);
if(C_truep(t1)){
if(C_truep(C_fixnum_greaterp(((C_word*)t0)[2],((C_word*)t0)[3]))){
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_20729,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[7],a[6]=((C_word*)t0)[8],tmp=(C_word)a,a+=7,tmp);
/* library.scm:3083: scan-exponent */
t3=((C_word*)t0)[9];
f_20636(t3,t2,C_fixnum_plus(((C_word*)t0)[3],C_fix(1)));}
else{
t2=((C_word*)t0)[5];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}
else{
t2=(C_truep(((C_word*)t0)[3])?((C_word*)t0)[3]:((C_word*)t0)[2]);
t3=(C_truep(((C_word*)t0)[4])?C_fixnum_difference(((C_word*)t0)[7],t2):C_SCHEME_FALSE);
t4=(C_truep(((C_word*)t0)[4])?C_i_car(((C_word*)t0)[4]):C_SCHEME_FALSE);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20795,a[2]=((C_word*)t0)[8],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:3093: safe-exponent */
t6=((C_word*)((C_word*)t0)[6])[1];
f_20348(t6,t5,t4,t3);}}

/* k20727 in k20718 in k20706 in k20697 in scan-decimal-tail in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20729(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_20729,c,av);}
a=C_alloc(8);
if(C_truep(t1)){
t2=C_i_car(t1);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_20741,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=t2,a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
/* library.scm:3085: safe-exponent */
t4=((C_word*)((C_word*)t0)[4])[1];
f_20348(t4,t3,((C_word*)t0)[6],t2);}
else{
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k20739 in k20727 in k20718 in k20706 in k20697 in scan-decimal-tail in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20741(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_20741,c,av);}
a=C_alloc(7);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_20747,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t0)[2])){
t3=C_i_cdr(((C_word*)t0)[2]);
t4=t2;
f_20747(t4,C_fixnum_difference(((C_word*)t0)[6],C_fixnum_difference(t3,((C_word*)t0)[7])));}
else{
t3=t2;
f_20747(t3,C_SCHEME_FALSE);}}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k20745 in k20739 in k20727 in k20718 in k20706 in k20697 in scan-decimal-tail in ##sys#string->compnum in k12559 in k11436 */
static void f_20747(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_20747,2,t0,t1);}
a=C_alloc(5);
t2=(C_truep(((C_word*)t0)[2])?C_i_car(((C_word*)t0)[2]):C_SCHEME_FALSE);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20753,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:3088: safe-exponent */
t4=((C_word*)((C_word*)t0)[6])[1];
f_20348(t4,t3,t2,t1);}

/* k20751 in k20745 in k20739 in k20727 in k20718 in k20706 in k20697 in scan-decimal-tail in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20753(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(32,c,1)))){
C_save_and_reclaim((void *)f_20753,c,av);}
a=C_alloc(32);
if(C_truep(t1)){
t2=C_s_a_i_plus(&a,2,((C_word*)t0)[2],t1);
t3=C_u_i_cdr(((C_word*)t0)[3]);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_cons(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t2=C_u_i_cdr(((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[2],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k20793 in k20718 in k20706 in k20697 in scan-decimal-tail in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20795(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(32,c,1)))){
C_save_and_reclaim((void *)f_20795,c,av);}
a=C_alloc(32);
t2=(C_truep(((C_word*)t0)[2])?((C_word*)t0)[2]:C_fix(0));
if(C_truep(t1)){
t3=C_s_a_i_plus(&a,2,t2,t1);
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_cons(&a,2,t3,((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,t2,((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* scan-ureal in ##sys#string->compnum in k12559 in k11436 */
static void f_20901(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,0,2)))){
C_save_and_reclaim_args((void *)trf_20901,4,t0,t1,t2,t3);}
a=C_alloc(15);
t4=(*a=C_CLOSURE_TYPE|14,a[1]=(C_word)f_20908,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=t1,a[6]=t2,a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[5],a[9]=((C_word*)t0)[6],a[10]=((C_word*)t0)[7],a[11]=((C_word*)t0)[8],a[12]=((C_word*)t0)[9],a[13]=((C_word*)t0)[10],a[14]=((C_word*)t0)[11],tmp=(C_word)a,a+=15,tmp);
t5=C_fixnum_plus(t2,C_fix(1));
if(C_truep(C_fixnum_greaterp(((C_word*)t0)[6],t5))){
t6=C_eqp(((C_word*)t0)[5],C_fix(10));
t7=t4;
f_20908(t7,(C_truep(t6)?C_eqp(C_i_string_ref(((C_word*)t0)[4],t2),C_make_character(46)):C_SCHEME_FALSE));}
else{
t6=t4;
f_20908(t6,C_SCHEME_FALSE);}}

/* k20906 in scan-ureal in ##sys#string->compnum in k12559 in k11436 */
static void f_20908(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,0,4)))){
C_save_and_reclaim_args((void *)trf_20908,2,t0,t1);}
a=C_alloc(14);
if(C_truep(t1)){
t2=(
/* library.scm:3101: go-inexact! */
  f_20334(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3])
);
/* library.scm:3102: scan-decimal-tail */
t3=((C_word*)t0)[4];
f_20689(t3,((C_word*)t0)[5],C_fixnum_plus(((C_word*)t0)[6],C_fix(1)),((C_word*)t0)[3],C_SCHEME_FALSE);}
else{
t2=(*a=C_CLOSURE_TYPE|13,a[1]=(C_word)f_20921,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[9],a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[5],a[9]=((C_word*)t0)[10],a[10]=((C_word*)t0)[11],a[11]=((C_word*)t0)[12],a[12]=((C_word*)t0)[13],a[13]=((C_word*)t0)[14],tmp=(C_word)a,a+=14,tmp);
/* library.scm:3103: scan-digits+hashes */
t3=((C_word*)t0)[14];
f_20580(t3,t2,((C_word*)t0)[6],((C_word*)t0)[3],C_SCHEME_FALSE);}}

/* k20919 in k20906 in scan-ureal in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20921(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,4)))){
C_save_and_reclaim((void *)f_20921,c,av);}
a=C_alloc(14);
if(C_truep(t1)){
t2=C_i_cdr(t1);
t3=(C_truep(t2)?C_i_string_ref(((C_word*)t0)[2],C_u_i_cdr(t1)):C_SCHEME_FALSE);
t4=C_eqp(t3,C_make_character(46));
if(C_truep(t4)){
t5=(
/* library.scm:3106: go-inexact! */
  f_20334(((C_word*)((C_word*)t0)[3])[1],((C_word*)t0)[4])
);
t6=C_eqp(((C_word*)t0)[5],C_fix(10));
if(C_truep(t6)){
t7=C_fixnum_plus(C_u_i_cdr(t1),C_fix(1));
if(C_truep(C_fixnum_greaterp(((C_word*)t0)[6],t7))){
/* library.scm:3109: scan-decimal-tail */
t8=((C_word*)t0)[7];
f_20689(t8,((C_word*)t0)[8],C_fixnum_plus(C_u_i_cdr(t1),C_fix(1)),((C_word*)t0)[4],C_u_i_car(t1));}
else{
t8=C_u_i_car(t1);
t9=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t9;
av2[1]=C_a_i_cons(&a,2,t8,C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}}
else{
t7=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}
else{
t5=C_eqp(t3,C_make_character(101));
t6=(*a=C_CLOSURE_TYPE|13,a[1]=(C_word)f_20979,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=t1,a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],a[9]=((C_word*)t0)[10],a[10]=t3,a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],a[13]=((C_word*)t0)[13],tmp=(C_word)a,a+=14,tmp);
if(C_truep(t5)){
t7=t6;
f_20979(t7,t5);}
else{
t7=C_eqp(t3,C_make_character(115));
if(C_truep(t7)){
t8=t6;
f_20979(t8,t7);}
else{
t8=C_eqp(t3,C_make_character(102));
if(C_truep(t8)){
t9=t6;
f_20979(t9,t8);}
else{
t9=C_eqp(t3,C_make_character(100));
if(C_truep(t9)){
t10=t6;
f_20979(t10,t9);}
else{
t10=C_eqp(t3,C_make_character(108));
if(C_truep(t10)){
t11=t6;
f_20979(t11,t10);}
else{
t11=C_eqp(t3,C_make_character(69));
if(C_truep(t11)){
t12=t6;
f_20979(t12,t11);}
else{
t12=C_eqp(t3,C_make_character(83));
if(C_truep(t12)){
t13=t6;
f_20979(t13,t12);}
else{
t13=C_eqp(t3,C_make_character(70));
if(C_truep(t13)){
t14=t6;
f_20979(t14,t13);}
else{
t14=C_eqp(t3,C_make_character(68));
t15=t6;
f_20979(t15,(C_truep(t14)?t14:C_eqp(t3,C_make_character(76))));}}}}}}}}}}
else{
t2=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k20977 in k20919 in k20906 in scan-ureal in ##sys#string->compnum in k12559 in k11436 */
static void f_20979(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,4)))){
C_save_and_reclaim_args((void *)trf_20979,2,t0,t1);}
a=C_alloc(5);
if(C_truep(t1)){
t2=(
/* library.scm:3113: go-inexact! */
  f_20334(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3])
);
t3=C_eqp(((C_word*)t0)[4],C_fix(10));
if(C_truep(t3)){
if(C_truep(C_fixnum_greaterp(((C_word*)t0)[5],C_u_i_cdr(((C_word*)t0)[6])))){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_20997,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[7],a[4]=((C_word*)t0)[8],tmp=(C_word)a,a+=5,tmp);
/* library.scm:3116: scan-exponent */
t5=((C_word*)t0)[9];
f_20636(t5,t4,C_fixnum_plus(C_u_i_cdr(((C_word*)t0)[6]),C_fix(1)));}
else{
t4=((C_word*)t0)[7];{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}
else{
t4=((C_word*)t0)[7];{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}
else{
t2=C_eqp(((C_word*)t0)[10],C_make_character(47));
if(C_truep(t2)){
t3=C_set_block_item(((C_word*)t0)[11],0,C_SCHEME_FALSE);
if(C_truep(C_fixnum_greaterp(((C_word*)t0)[5],C_u_i_cdr(((C_word*)t0)[6])))){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_21043,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[7],a[4]=((C_word*)t0)[12],tmp=(C_word)a,a+=5,tmp);
/* library.scm:3123: scan-digits+hashes */
t5=((C_word*)t0)[13];
f_20580(t5,t4,C_fixnum_plus(C_u_i_cdr(((C_word*)t0)[6]),C_fix(1)),C_SCHEME_FALSE,C_SCHEME_FALSE);}
else{
t4=((C_word*)t0)[7];{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}
else{
t3=((C_word*)t0)[7];{
C_word av2[2];
av2[0]=t3;
av2[1]=((C_word*)t0)[6];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}}

/* k20995 in k20977 in k20919 in k20906 in scan-ureal in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_20997(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_20997,c,av);}
a=C_alloc(4);
if(C_truep(t1)){
t2=C_u_i_car(((C_word*)t0)[2]);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_21007,a[2]=t1,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:3118: safe-exponent */
t4=((C_word*)((C_word*)t0)[4])[1];
f_20348(t4,t3,t2,C_i_car(t1));}
else{
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k21005 in k20995 in k20977 in k20919 in k20906 in scan-ureal in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21007(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_21007,c,av);}
a=C_alloc(3);
if(C_truep(t1)){
t2=C_u_i_cdr(((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,t1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k21041 in k20977 in k20919 in k20906 in scan-ureal in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21043(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_21043,c,av);}
a=C_alloc(4);
if(C_truep(t1)){
t2=C_u_i_car(((C_word*)t0)[2]);
if(C_truep(t2)){
t3=C_i_car(t1);
if(C_truep(t3)){
t4=C_eqp(t3,C_fix(0));
if(C_truep(C_i_not(t4))){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_21069,a[2]=t1,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:3127: ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t5;
av2[2]=t2;
av2[3]=t3;
tp(4,av2);}}
else{
t5=C_eqp(((C_word*)((C_word*)t0)[4])[1],lf[715]);
if(C_truep(C_i_not(t5))){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_21080,a[2]=t1,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:3131: chicken.base#signum */
t7=*((C_word*)lf[226]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}
else{
t6=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}}
else{
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}
else{
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k21067 in k21041 in k20977 in k20919 in k20906 in scan-ureal in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21069(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_21069,c,av);}
a=C_alloc(3);
t2=C_u_i_cdr(((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,t1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k21078 in k21041 in k20977 in k20919 in k20906 in scan-ureal in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21080(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,1)))){
C_save_and_reclaim((void *)f_21080,c,av);}
a=C_alloc(7);
switch(t1){
case C_fix(-1):
t2=C_u_i_cdr(((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,lf[718],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}
case C_fix(0):
t2=C_flonum(&a,C_ub_i_flonum_quotient((double)0.0,(double)0.0));
t3=C_u_i_cdr(((C_word*)t0)[2]);
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_cons(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}
case C_fix(1):
t2=C_u_i_cdr(((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,lf[717],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}
default:
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* scan-real in ##sys#string->compnum in k12559 in k11436 */
static void f_21243(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,2)))){
C_save_and_reclaim_args((void *)trf_21243,3,t0,t1,t2);}
a=C_alloc(8);
if(C_truep(C_fixnum_lessp(t2,((C_word*)t0)[2]))){
t3=C_i_string_ref(((C_word*)t0)[3],t2);
t4=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_21256,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t1,a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
t5=C_eqp(t3,C_make_character(43));
if(C_truep(t5)){
t6=t4;
f_21256(t6,lf[720]);}
else{
t6=C_eqp(t3,C_make_character(45));
t7=t4;
f_21256(t7,(C_truep(t6)?lf[719]:C_SCHEME_FALSE));}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k21254 in scan-real in ##sys#string->compnum in k12559 in k11436 */
static void f_21256(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,4)))){
C_save_and_reclaim_args((void *)trf_21256,2,t0,t1);}
a=C_alloc(11);
t2=(C_truep(t1)?C_fixnum_plus(((C_word*)t0)[2],C_fix(1)):((C_word*)t0)[2]);
if(C_truep(C_fixnum_lessp(t2,((C_word*)t0)[3]))){
t3=C_i_string_ref(((C_word*)t0)[4],t2);
t4=C_eqp(t3,C_make_character(105));
t5=(C_truep(t4)?t4:C_eqp(t3,C_make_character(73)));
if(C_truep(t5)){
if(C_truep(t1)){
t6=C_fixnum_plus(t2,C_fix(1));
t7=C_eqp(t6,((C_word*)t0)[3]);
if(C_truep(t7)){
t8=C_eqp(t1,lf[719]);
t9=(C_truep(t8)?C_a_i_cons(&a,2,C_fix(-1),t2):C_a_i_cons(&a,2,C_fix(1),t2));
if(C_truep(t9)){
t10=((C_word*)t0)[5];{
C_word av2[2];
av2[0]=t10;
av2[1]=t9;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
/* library.scm:3156: scan-ureal */
t10=((C_word*)t0)[6];
f_20901(t10,((C_word*)t0)[5],t2,C_eqp(t1,lf[719]));}}
else{
t8=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_21311,a[2]=((C_word*)t0)[7],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
t9=C_fixnum_plus(t2,C_fix(5));
if(C_truep(C_fixnum_less_or_equal_p(t9,((C_word*)t0)[3]))){
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_21349,a[2]=t8,tmp=(C_word)a,a+=3,tmp);
/* library.scm:3150: scheme#substring */
t11=*((C_word*)lf[489]+1);{
C_word av2[5];
av2[0]=t11;
av2[1]=t10;
av2[2]=((C_word*)t0)[4];
av2[3]=t2;
av2[4]=C_fixnum_plus(t2,C_fix(5));
((C_proc)(void*)(*((C_word*)t11+1)))(5,av2);}}
else{
t10=t8;
f_21311(t10,C_SCHEME_FALSE);}}}
else{
/* library.scm:3156: scan-ureal */
t6=((C_word*)t0)[6];
f_20901(t6,((C_word*)t0)[5],t2,C_eqp(t1,lf[719]));}}
else{
t6=C_eqp(t3,C_make_character(110));
t7=(C_truep(t6)?t6:C_eqp(t3,C_make_character(78)));
if(C_truep(t7)){
if(C_truep(t1)){
t8=C_fixnum_plus(t2,C_fix(5));
if(C_truep(C_fixnum_less_or_equal_p(t8,((C_word*)t0)[3]))){
t9=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_21397,a[2]=((C_word*)t0)[7],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
/* library.scm:3160: scheme#substring */
t10=*((C_word*)lf[489]+1);{
C_word av2[5];
av2[0]=t10;
av2[1]=t9;
av2[2]=((C_word*)t0)[4];
av2[3]=t2;
av2[4]=C_fixnum_plus(t2,C_fix(5));
((C_proc)(void*)(*((C_word*)t10+1)))(5,av2);}}
else{
/* library.scm:3165: scan-ureal */
t9=((C_word*)t0)[6];
f_20901(t9,((C_word*)t0)[5],t2,C_eqp(t1,lf[719]));}}
else{
/* library.scm:3165: scan-ureal */
t8=((C_word*)t0)[6];
f_20901(t8,((C_word*)t0)[5],t2,C_eqp(t1,lf[719]));}}
else{
/* library.scm:3166: scan-ureal */
t8=((C_word*)t0)[6];
f_20901(t8,((C_word*)t0)[5],t2,C_eqp(t1,lf[719]));}}}
else{
t3=((C_word*)t0)[5];{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k21309 in k21254 in scan-real in ##sys#string->compnum in k12559 in k11436 */
static void f_21311(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,0,3)))){
C_save_and_reclaim_args((void *)trf_21311,2,t0,t1);}
a=C_alloc(3);
if(C_truep(t1)){
t2=(
/* library.scm:3151: go-inexact! */
  f_20334(((C_word*)((C_word*)t0)[2])[1],C_eqp(((C_word*)t0)[3],lf[719]))
);
t3=C_eqp(((C_word*)t0)[3],lf[719]);
t4=(C_truep(t3)?lf[718]:lf[717]);
t5=C_fixnum_plus(((C_word*)t0)[4],C_fix(5));
if(C_truep(C_fixnum_lessp(t5,((C_word*)t0)[5]))){
t6=C_fixnum_plus(((C_word*)t0)[4],C_fix(5));
t7=C_a_i_cons(&a,2,t4,t6);
if(C_truep(t7)){
t8=((C_word*)t0)[6];{
C_word av2[2];
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
/* library.scm:3156: scan-ureal */
t8=((C_word*)t0)[7];
f_20901(t8,((C_word*)t0)[6],((C_word*)t0)[4],C_eqp(((C_word*)t0)[3],lf[719]));}}
else{
t6=C_a_i_cons(&a,2,t4,C_SCHEME_FALSE);
if(C_truep(t6)){
t7=((C_word*)t0)[6];{
C_word av2[2];
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
/* library.scm:3156: scan-ureal */
t7=((C_word*)t0)[7];
f_20901(t7,((C_word*)t0)[6],((C_word*)t0)[4],C_eqp(((C_word*)t0)[3],lf[719]));}}}
else{
/* library.scm:3156: scan-ureal */
t2=((C_word*)t0)[7];
f_20901(t2,((C_word*)t0)[6],((C_word*)t0)[4],C_eqp(((C_word*)t0)[3],lf[719]));}}

/* k21347 in k21254 in scan-real in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21349(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_21349,c,av);}
t2=((C_word*)t0)[2];
f_21311(t2,C_i_string_ci_equal_p(t1,lf[721]));}

/* k21395 in k21254 in scan-real in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21397(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_21397,c,av);}
a=C_alloc(7);
if(C_truep(C_i_string_ci_equal_p(t1,lf[722]))){
t2=(
/* library.scm:3161: go-inexact! */
  f_20334(((C_word*)((C_word*)t0)[2])[1],C_eqp(((C_word*)t0)[3],lf[719]))
);
t3=C_flonum(&a,C_ub_i_flonum_quotient((double)0.0,(double)0.0));
t4=C_fixnum_plus(((C_word*)t0)[4],C_fix(5));
if(C_truep(C_fixnum_lessp(t4,((C_word*)t0)[5]))){
t5=C_fixnum_plus(((C_word*)t0)[4],C_fix(5));
t6=C_a_i_cons(&a,2,t3,t5);
if(C_truep(t6)){
t7=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
/* library.scm:3165: scan-ureal */
t7=((C_word*)t0)[7];
f_20901(t7,((C_word*)t0)[6],((C_word*)t0)[4],C_eqp(((C_word*)t0)[3],lf[719]));}}
else{
t5=C_a_i_cons(&a,2,t3,C_SCHEME_FALSE);
if(C_truep(t5)){
t6=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
/* library.scm:3165: scan-ureal */
t6=((C_word*)t0)[7];
f_20901(t6,((C_word*)t0)[6],((C_word*)t0)[4],C_eqp(((C_word*)t0)[3],lf[719]));}}}
else{
/* library.scm:3165: scan-ureal */
t2=((C_word*)t0)[7];
f_20901(t2,((C_word*)t0)[6],((C_word*)t0)[4],C_eqp(((C_word*)t0)[3],lf[719]));}}

/* k21472 in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21474(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_21474,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_21477,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(t1)){
t3=C_i_cdr(t1);
t4=(C_truep(t3)?C_i_string_ref(((C_word*)t0)[5],C_u_i_cdr(t1)):C_SCHEME_FALSE);
t5=C_eqp(t4,C_SCHEME_FALSE);
if(C_truep(t5)){
t6=t2;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_u_i_car(t1);
f_21477(2,av2);}}
else{
t6=C_eqp(t4,C_make_character(105));
t7=(C_truep(t6)?t6:C_eqp(t4,C_make_character(73)));
if(C_truep(t7)){
t8=C_fixnum_plus(C_u_i_cdr(t1),C_fix(1));
t9=C_eqp(((C_word*)t0)[6],t8);
if(C_truep(t9)){
t10=C_i_string_ref(((C_word*)t0)[5],((C_word*)t0)[7]);
t11=C_eqp(t10,C_make_character(43));
if(C_truep(t11)){
if(C_truep(t11)){
/* library.scm:3173: scheme#make-rectangular */
t12=*((C_word*)lf[606]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t12;
av2[1]=t2;
av2[2]=C_fix(0);
av2[3]=C_u_i_car(t1);
((C_proc)(void*)(*((C_word*)t12+1)))(4,av2);}}
else{
t12=t2;{
C_word *av2=av;
av2[0]=t12;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}
else{
t12=C_eqp(C_i_string_ref(((C_word*)t0)[5],((C_word*)t0)[7]),C_make_character(45));
if(C_truep(t12)){
/* library.scm:3173: scheme#make-rectangular */
t13=*((C_word*)lf[606]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t13;
av2[1]=t2;
av2[2]=C_fix(0);
av2[3]=C_u_i_car(t1);
((C_proc)(void*)(*((C_word*)t13+1)))(4,av2);}}
else{
t13=t2;{
C_word *av2=av;
av2[0]=t13;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}}
else{
t10=t2;{
C_word *av2=av;
av2[0]=t10;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}
else{
t8=C_eqp(t4,C_make_character(43));
t9=(C_truep(t8)?t8:C_eqp(t4,C_make_character(45)));
if(C_truep(t9)){
t10=C_set_block_item(((C_word*)t0)[8],0,C_SCHEME_FALSE);
t11=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_21571,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[5],a[4]=t2,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:3176: scan-real */
t12=((C_word*)t0)[9];
f_21243(t12,t11,C_u_i_cdr(t1));}
else{
t10=C_eqp(t4,C_make_character(64));
if(C_truep(t10)){
t11=C_set_block_item(((C_word*)t0)[8],0,C_SCHEME_FALSE);
t12=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_21635,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3184: scan-real */
t13=((C_word*)t0)[9];
f_21243(t13,t12,C_fixnum_plus(C_u_i_cdr(t1),C_fix(1)));}
else{
t11=t2;{
C_word *av2=av;
av2[0]=t11;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}}}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}

/* k21475 in k21472 in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21477(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_21477,c,av);}
a=C_alloc(4);
if(C_truep(t1)){
t2=C_eqp(((C_word*)((C_word*)t0)[2])[1],lf[716]);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_21489,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* library.scm:3189: scheme#exact->inexact */
t4=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}
else{
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(C_i_finitep(t1))?t1:C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k21487 in k21475 in k21472 in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21489(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_21489,c,av);}
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
if(C_truep(C_u_i_zerop2(t1))){
/* library.scm:3192: chicken.flonum#fpneg */
t2=*((C_word*)lf[550]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k21569 in k21472 in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21571(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_21571,c,av);}
if(C_truep(t1)){
if(C_truep(C_i_cdr(t1))){
t2=C_fixnum_plus(C_u_i_cdr(t1),C_fix(1));
t3=C_eqp(((C_word*)t0)[2],t2);
if(C_truep(t3)){
t4=C_i_string_ref(((C_word*)t0)[3],C_u_i_cdr(t1));
t5=C_eqp(t4,C_make_character(105));
if(C_truep(t5)){
if(C_truep(t5)){
/* library.scm:3181: scheme#make-rectangular */
t6=*((C_word*)lf[606]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=((C_word*)t0)[4];
av2[2]=C_u_i_car(((C_word*)t0)[5]);
av2[3]=C_u_i_car(t1);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t6=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}
else{
t6=C_i_string_ref(((C_word*)t0)[3],C_u_i_cdr(t1));
t7=C_eqp(t6,C_make_character(73));
if(C_truep(t7)){
/* library.scm:3181: scheme#make-rectangular */
t8=*((C_word*)lf[606]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t8;
av2[1]=((C_word*)t0)[4];
av2[2]=C_u_i_car(((C_word*)t0)[5]);
av2[3]=C_u_i_car(t1);
((C_proc)(void*)(*((C_word*)t8+1)))(4,av2);}}
else{
t8=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t8;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}}
else{
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}

/* k21633 in k21472 in ##sys#string->compnum in k12559 in k11436 */
static void C_ccall f_21635(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_21635,c,av);}
if(C_truep(t1)){
t2=C_i_cdr(t1);
if(C_truep(C_i_not(t2))){
/* library.scm:3186: scheme#make-polar */
t3=*((C_word*)lf[608]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=C_u_i_car(((C_word*)t0)[3]);
av2[3]=C_u_i_car(t1);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}
else{
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}
else{
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
f_21477(2,av2);}}}

/* scheme#string->number in k12559 in k11436 */
static void C_ccall f_21713(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_21713,c,av);}
a=C_alloc(5);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_fix(10):C_get_rest_arg(c,3,av,3,t0));
t5=C_i_check_string_2(t2,lf[724]);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_21723,a[2]=t2,a[3]=t4,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fixnump(t4))){
if(C_truep(C_fixnum_lessp(C_fix(1),t4))){
if(C_truep(C_fixnum_lessp(t4,C_fix(37)))){
t7=t6;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_SCHEME_UNDEFINED;
f_21723(2,av2);}}
else{
/* library.scm:3201: ##sys#error-bad-base */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[442]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[442]+1);
av2[1]=t6;
av2[2]=t4;
av2[3]=lf[724];
tp(4,av2);}}}
else{
/* library.scm:3201: ##sys#error-bad-base */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[442]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[442]+1);
av2[1]=t6;
av2[2]=t4;
av2[3]=lf[724];
tp(4,av2);}}}
else{
/* library.scm:3201: ##sys#error-bad-base */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[442]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[442]+1);
av2[1]=t6;
av2[2]=t4;
av2[3]=lf[724];
tp(4,av2);}}}

/* k21721 in scheme#string->number in k12559 in k11436 */
static void C_ccall f_21723(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,6)))){
C_save_and_reclaim((void *)f_21723,c,av);}
a=C_alloc(8);
t2=C_u_i_string_length(((C_word*)t0)[2]);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_21730,a[2]=((C_word*)t0)[2],a[3]=t4,a[4]=((C_word*)t0)[3],a[5]=((C_word)li551),tmp=(C_word)a,a+=6,tmp));
t6=((C_word*)t4)[1];
f_21730(t6,((C_word*)t0)[4],C_fix(0),C_SCHEME_FALSE,C_SCHEME_FALSE,t2);}

/* scan-prefix in k21721 in scheme#string->number in k12559 in k11436 */
static void f_21730(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(0,0,5)))){
C_save_and_reclaim_args((void *)trf_21730,6,t0,t1,t2,t3,t4,t5);}
t6=C_fixnum_plus(t2,C_fix(2));
t7=C_fixnum_lessp(t6,t5);
t8=(C_truep(t7)?C_eqp(C_i_string_ref(((C_word*)t0)[2],t2),C_make_character(35)):C_SCHEME_FALSE);
if(C_truep(t8)){
t9=C_fixnum_plus(t2,C_fix(1));
t10=C_i_string_ref(((C_word*)t0)[2],t9);
t11=C_eqp(t10,C_make_character(105));
t12=(C_truep(t11)?t11:C_eqp(t10,C_make_character(73)));
if(C_truep(t12)){
if(C_truep(C_i_not(t3))){
/* library.scm:3208: scan-prefix */
t24=t1;
t25=C_fixnum_plus(t2,C_fix(2));
t26=lf[716];
t27=t4;
t28=t5;
t1=t24;
t2=t25;
t3=t26;
t4=t27;
t5=t28;
goto loop;}
else{
t13=t1;{
C_word av2[2];
av2[0]=t13;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t13+1)))(2,av2);}}}
else{
t13=C_eqp(t10,C_make_character(101));
t14=(C_truep(t13)?t13:C_eqp(t10,C_make_character(69)));
if(C_truep(t14)){
if(C_truep(C_i_not(t3))){
/* library.scm:3209: scan-prefix */
t24=t1;
t25=C_fixnum_plus(t2,C_fix(2));
t26=lf[715];
t27=t4;
t28=t5;
t1=t24;
t2=t25;
t3=t26;
t4=t27;
t5=t28;
goto loop;}
else{
t15=t1;{
C_word av2[2];
av2[0]=t15;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t15+1)))(2,av2);}}}
else{
t15=C_eqp(t10,C_make_character(98));
t16=(C_truep(t15)?t15:C_eqp(t10,C_make_character(66)));
if(C_truep(t16)){
if(C_truep(C_i_not(t4))){
/* library.scm:3210: scan-prefix */
t24=t1;
t25=C_fixnum_plus(t2,C_fix(2));
t26=t3;
t27=C_fix(2);
t28=t5;
t1=t24;
t2=t25;
t3=t26;
t4=t27;
t5=t28;
goto loop;}
else{
t17=t1;{
C_word av2[2];
av2[0]=t17;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t17+1)))(2,av2);}}}
else{
t17=C_eqp(t10,C_make_character(111));
t18=(C_truep(t17)?t17:C_eqp(t10,C_make_character(79)));
if(C_truep(t18)){
if(C_truep(C_i_not(t4))){
/* library.scm:3211: scan-prefix */
t24=t1;
t25=C_fixnum_plus(t2,C_fix(2));
t26=t3;
t27=C_fix(8);
t28=t5;
t1=t24;
t2=t25;
t3=t26;
t4=t27;
t5=t28;
goto loop;}
else{
t19=t1;{
C_word av2[2];
av2[0]=t19;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t19+1)))(2,av2);}}}
else{
t19=C_eqp(t10,C_make_character(100));
t20=(C_truep(t19)?t19:C_eqp(t10,C_make_character(68)));
if(C_truep(t20)){
if(C_truep(C_i_not(t4))){
/* library.scm:3212: scan-prefix */
t24=t1;
t25=C_fixnum_plus(t2,C_fix(2));
t26=t3;
t27=C_fix(10);
t28=t5;
t1=t24;
t2=t25;
t3=t26;
t4=t27;
t5=t28;
goto loop;}
else{
t21=t1;{
C_word av2[2];
av2[0]=t21;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t21+1)))(2,av2);}}}
else{
t21=C_eqp(t10,C_make_character(120));
t22=(C_truep(t21)?t21:C_eqp(t10,C_make_character(88)));
if(C_truep(t22)){
if(C_truep(C_i_not(t4))){
/* library.scm:3213: scan-prefix */
t24=t1;
t25=C_fixnum_plus(t2,C_fix(2));
t26=t3;
t27=C_fix(16);
t28=t5;
t1=t24;
t2=t25;
t3=t26;
t4=t27;
t5=t28;
goto loop;}
else{
t23=t1;{
C_word av2[2];
av2[0]=t23;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t23+1)))(2,av2);}}}
else{
t23=t1;{
C_word av2[2];
av2[0]=t23;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t23+1)))(2,av2);}}}}}}}}
else{
if(C_truep(t4)){
/* library.scm:3215: ##sys#string->compnum */
f_20330(t1,t4,((C_word*)t0)[2],t2,t3);}
else{
/* library.scm:3215: ##sys#string->compnum */
f_20330(t1,((C_word*)t0)[4],((C_word*)t0)[2],t2,t3);}}}

/* ##sys#string->number in k12559 in k11436 */
static void C_ccall f_21962(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_21962,c,av);}
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_fix(10):C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
if(C_truep(C_rest_nullp(c,4))){
/* library.scm:3218: ##sys#string->compnum */
f_20330(t1,t4,t2,C_fix(0),t7);}
else{
/* library.scm:3218: ##sys#string->compnum */
f_20330(t1,t4,t2,C_fix(0),t7);}}

/* chicken.base#equal=? in k12559 in k11436 */
static void C_ccall f_22008(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(13,c,5)))){
C_save_and_reclaim((void *)f_22008,c,av);}
a=C_alloc(13);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22011,a[2]=t7,a[3]=((C_word)li558),tmp=(C_word)a,a+=4,tmp));
t9=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22079,a[2]=t5,a[3]=t7,a[4]=((C_word)li559),tmp=(C_word)a,a+=5,tmp));
/* library.scm:3263: walk */
t10=((C_word*)t7)[1];
f_22079(t10,t1,t2,t3);}

/* compare-slots in chicken.base#equal=? in k12559 in k11436 */
static void f_22011(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,3)))){
C_save_and_reclaim_args((void *)trf_22011,5,t0,t1,t2,t3,t4);}
a=C_alloc(10);
t5=C_block_size(t2);
t6=C_block_size(t3);
t7=C_eqp(t5,t6);
if(C_truep(t7)){
t8=C_fixnum_less_or_equal_p(t5,t4);
if(C_truep(t8)){
t9=t1;{
C_word av2[2];
av2[0]=t9;
av2[1]=t8;
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}
else{
t9=C_fixnum_difference(t5,C_fix(1));
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_22038,a[2]=t9,a[3]=((C_word*)t0)[2],a[4]=t2,a[5]=t3,a[6]=t11,a[7]=((C_word)li557),tmp=(C_word)a,a+=8,tmp));
t13=((C_word*)t11)[1];
f_22038(t13,t1,t4);}}
else{
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}

/* loop in compare-slots in chicken.base#equal=? in k12559 in k11436 */
static void f_22038(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_22038,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
/* library.scm:3235: walk */
t4=((C_word*)((C_word*)t0)[3])[1];
f_22079(t4,t1,C_slot(((C_word*)t0)[4],t2),C_slot(((C_word*)t0)[5],t2));}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22062,a[2]=((C_word*)t0)[6],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3236: walk */
t5=((C_word*)((C_word*)t0)[3])[1];
f_22079(t5,t4,C_slot(((C_word*)t0)[4],t2),C_slot(((C_word*)t0)[5],t2));}}

/* k22060 in loop in compare-slots in chicken.base#equal=? in k12559 in k11436 */
static void C_ccall f_22062(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_22062,c,av);}
if(C_truep(t1)){
/* library.scm:3237: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_22038(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* walk in chicken.base#equal=? in k12559 in k11436 */
static void f_22079(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(0,0,4)))){
C_save_and_reclaim_args((void *)trf_22079,4,t0,t1,t2,t3);}
t4=C_eqp(t2,t3);
if(C_truep(t4)){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_i_numberp(t2))){
t5=C_i_numberp(t3);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=(C_truep(t5)?C_i_nequalp(t2,t3):C_eqp(t2,t3));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
if(C_truep(C_i_not(C_blockp(t2)))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_i_not(C_blockp(t3)))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_i_not(C_sametypep(t2,t3)))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_specialp(t2))){
if(C_truep(C_specialp(t3))){
if(C_truep(C_closurep(t2))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=shallow_equal(t2,t3);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
/* library.scm:3251: compare-slots */
t5=((C_word*)((C_word*)t0)[2])[1];
f_22011(t5,t1,t2,t3,C_fix(1));}}
else{
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}
else{
if(C_truep(C_stringp(t2))){
/* library.scm:3253: walk */
t9=t1;
t10=C_slot(t2,C_fix(0));
t11=C_slot(t3,C_fix(0));
t1=t9;
t2=t10;
t3=t11;
goto loop;}
else{
if(C_truep(C_byteblockp(t2))){
if(C_truep(C_byteblockp(t3))){
t5=C_block_size(t2);
t6=C_block_size(t3);
t7=C_eqp(t5,t6);
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=(C_truep(t7)?C_bv_compare(t2,t3,t5):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}
else{
t5=C_block_size(t2);
t6=C_block_size(t3);
t7=C_eqp(t5,t6);
if(C_truep(t7)){
/* library.scm:3262: compare-slots */
t8=((C_word*)((C_word*)t0)[2])[1];
f_22011(t8,t1,t2,t3,C_fix(0));}
else{
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}}}}}}}}}

/* ##sys#interned-symbol? in k12559 in k11436 */
static void C_ccall f_22195(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22195,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_lookup_symbol(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#string->symbol-name in k12559 in k11436 */
static void C_ccall f_22198(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_22198,c,av);}
a=C_alloc(5);
t3=C_slot(t2,C_fix(0));
t4=C_block_size(t3);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22208,a[2]=t1,a[3]=t3,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3277: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}

/* k22206 in ##sys#string->symbol-name in k12559 in k11436 */
static void C_ccall f_22208(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22208,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_copy_bytevector(((C_word*)t0)[3],t1,((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#symbol->string/shared in k12559 in k11436 */
static void C_ccall f_22210(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_22210,c,av);}
a=C_alloc(5);
t3=C_slot(t2,C_fix(1));
t4=C_utf_length(t3);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_a_ustring(&a,2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#symbol->string in k12559 in k11436 */
static void C_ccall f_22216(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_22216,c,av);}
a=C_alloc(5);
t3=C_slot(t2,C_fix(1));
t4=C_block_size(t3);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22226,a[2]=t3,a[3]=t4,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3290: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}

/* k22224 in ##sys#symbol->string in k12559 in k11436 */
static void C_ccall f_22226(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_22226,c,av);}
a=C_alloc(5);
t2=C_utf_length(((C_word*)t0)[2]);
t3=C_copy_bytevector(((C_word*)t0)[2],t1,((C_word*)t0)[3]);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_ustring(&a,2,t3,t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#string->symbol in k12559 in k11436 */
static void C_ccall f_22229(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_22229,c,av);}
a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22237,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:3297: ##sys#string->symbol-name */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[736]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[736]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k22235 in ##sys#string->symbol in k12559 in k11436 */
static void C_ccall f_22237(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_22237,c,av);}
/* library.scm:3297: ##sys#intern-symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[732]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[732]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* scheme#symbol->string in k12559 in k11436 */
static void C_ccall f_22239(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_22239,c,av);}
t3=C_i_check_symbol_2(t2,lf[741]);
/* library.scm:3302: ##sys#symbol->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[738]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[738]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}

/* scheme#string->symbol in k12559 in k11436 */
static void C_ccall f_22248(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_22248,c,av);}
t3=C_i_check_string_2(t2,lf[743]);
/* library.scm:3307: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[739]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}

/* chicken.base#string->uninterned-symbol in k12559 in k11436 */
static void C_ccall f_22257(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_22257,c,av);}
a=C_alloc(3);
t3=C_i_check_string_2(t2,lf[745]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22268,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:3313: ##sys#string->symbol-name */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[736]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[736]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}

/* k22266 in chicken.base#string->uninterned-symbol in k12559 in k11436 */
static void C_ccall f_22268(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_22268,c,av);}
/* library.scm:3313: ##sys#make-symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[734]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[734]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* chicken.base#gensym in k12559 in k11436 */
static void C_ccall f_22270(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +16,c,5)))){
C_save_and_reclaim((void*)f_22270,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+16);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
t3=C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],C_fix(1));
t4=C_set_block_item(((C_word*)t0)[2],0,t3);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22287,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22291,a[2]=t5,tmp=(C_word)a,a+=3,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22295,a[2]=t6,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t8=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(t8)){
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f45311,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* library.scm:3331: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t9;
av2[2]=((C_word*)((C_word*)t0)[2])[1];
tp(3,av2);}}
else{
t9=C_get_rest_arg(c,2,av,2,t0);
t10=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_22308,a[2]=t6,a[3]=((C_word*)t0)[2],a[4]=t7,a[5]=t9,tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_blockp(t9))){
if(C_truep(C_stringp(t9))){
t11=t10;{
C_word *av2=av;
av2[0]=t11;
av2[1]=t9;
f_22308(2,av2);}}
else{
if(C_truep(C_symbolp(t9))){
/* library.scm:3328: ##sys#symbol->string/shared */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[737]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[737]+1);
av2[1]=t10;
av2[2]=t9;
tp(3,av2);}}
else{
/* library.scm:3318: ##sys#signal-hook */
t11=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t11;
av2[1]=t10;
av2[2]=lf[295];
av2[3]=lf[748];
av2[4]=lf[749];
av2[5]=t9;
((C_proc)(void*)(*((C_word*)t11+1)))(6,av2);}}}}
else{
t11=t10;{
C_word *av2=av;
av2[0]=t11;
av2[1]=C_SCHEME_FALSE;
f_22308(2,av2);}}}}

/* k22285 in chicken.base#gensym in k12559 in k11436 */
static void C_ccall f_22287(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_22287,c,av);}
/* library.scm:3320: ##sys#make-symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[734]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[734]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* k22289 in chicken.base#gensym in k12559 in k11436 */
static void C_ccall f_22291(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_22291,c,av);}
/* library.scm:3321: ##sys#string->symbol-name */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[736]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[736]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* k22293 in chicken.base#gensym in k12559 in k11436 */
static void C_ccall f_22295(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_22295,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22299,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3331: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[3])[1];
tp(3,av2);}}

/* k22297 in k22293 in chicken.base#gensym in k12559 in k11436 */
static void C_ccall f_22299(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_22299,c,av);}
/* library.scm:3322: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k22306 in chicken.base#gensym in k12559 in k11436 */
static void C_ccall f_22308(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,5)))){
C_save_and_reclaim((void *)f_22308,c,av);}
a=C_alloc(4);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f45315,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3331: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[3])[1];
tp(3,av2);}}
else{
/* library.scm:3318: ##sys#signal-hook */
t2=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[4];
av2[2]=lf[295];
av2[3]=lf[748];
av2[4]=lf[749];
av2[5]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}}

/* chicken.base#symbol-append in k12559 in k11436 */
static void C_ccall f_22328(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +20,c,3)))){
C_save_and_reclaim((void*)f_22328,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+20);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22336,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t4=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t5=t4;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=((C_word*)t6)[1];
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22351,a[2]=t3,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_22353,a[2]=t6,a[3]=t10,a[4]=t7,a[5]=((C_word)li573),tmp=(C_word)a,a+=6,tmp));
t12=((C_word*)t10)[1];
f_22353(t12,t8,t2);}

/* k22334 in chicken.base#symbol-append in k12559 in k11436 */
static void C_ccall f_22336(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_22336,c,av);}
/* library.scm:3336: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[739]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* k22349 in chicken.base#symbol-append in k12559 in k11436 */
static void C_ccall f_22351(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_22351,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
C_apply(4,av2);}}

/* map-loop3999 in chicken.base#symbol-append in k12559 in k11436 */
static void f_22353(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_22353,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_22378,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
t4=C_slot(t2,C_fix(0));
t5=C_i_check_symbol_2(t4,lf[751]);
/* library.scm:3341: ##sys#symbol->string/shared */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[737]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[737]+1);
av2[1]=t3;
av2[2]=t4;
tp(3,av2);}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k22376 in map-loop3999 in chicken.base#symbol-append in k12559 in k11436 */
static void C_ccall f_22378(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_22378,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_SCHEME_END_OF_LIST);
t3=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t2);
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
t5=((C_word*)((C_word*)t0)[3])[1];
f_22353(t5,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}

/* chicken.keyword#keyword? in k12559 in k11436 */
static void C_ccall f_22387(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22387,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_keywordp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.keyword#string->keyword in k12559 in k11436 */
static void C_ccall f_22390(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_22390,c,av);}
a=C_alloc(3);
t3=C_i_check_string_2(t2,lf[755]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_22401,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:3358: ##sys#string->symbol-name */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[736]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[736]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}

/* k22399 in chicken.keyword#string->keyword in k12559 in k11436 */
static void C_ccall f_22401(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_22401,c,av);}
/* library.scm:3358: ##sys#intern-keyword */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[733]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[733]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* chicken.keyword#keyword->string in k12559 in k11436 */
static void C_ccall f_22403(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_22403,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22410,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3363: keyword? */
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k22408 in chicken.keyword#keyword->string in k12559 in k11436 */
static void C_ccall f_22410(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_22410,c,av);}
if(C_truep(t1)){
/* library.scm:3364: ##sys#symbol->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[738]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[738]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
/* library.scm:3365: ##sys#signal-hook */
t2=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[295];
av2[3]=lf[757];
av2[4]=lf[758];
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}}

/* chicken.keyword#get-keyword in k12559 in k11436 */
static void C_ccall f_22421(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_22421,c,av);}
a=C_alloc(7);
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,4,t0));
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_22428,a[2]=t3,a[3]=t2,a[4]=((C_word*)t0)[2],a[5]=t5,a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:3370: ##sys#check-keyword */
t7=*((C_word*)lf[417]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
av2[3]=lf[761];
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}

/* k22426 in chicken.keyword#get-keyword in k12559 in k11436 */
static void C_ccall f_22428(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22428,c,av);}
t2=C_i_check_list_2(((C_word*)t0)[2],lf[761]);
t3=C_i_get_keyword(((C_word*)t0)[3],((C_word*)t0)[2],((C_word*)t0)[4]);
t4=C_eqp(t3,((C_word*)t0)[4]);
if(C_truep(t4)){
if(C_truep(((C_word*)t0)[5])){
/* library.scm:3374: thunk */
t5=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t5;
av2[1]=((C_word*)t0)[6];
((C_proc)C_fast_retrieve_proc(t5))(2,av2);}}
else{
t5=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}
else{
t5=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* ##sys#bytevector->list in k12559 in k11436 */
static void C_ccall f_22452(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_22452,c,av);}
a=C_alloc(7);
t3=C_block_size(t2);
t4=C_fixnum_difference(t3,C_fix(1));
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22465,a[2]=t2,a[3]=t6,a[4]=((C_word)li579),tmp=(C_word)a,a+=5,tmp));
t8=((C_word*)t6)[1];
f_22465(t8,t1,t4,C_SCHEME_END_OF_LIST);}

/* loop in ##sys#bytevector->list in k12559 in k11436 */
static void f_22465(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,3)))){
C_save_and_reclaim_args((void *)trf_22465,4,t0,t1,t2,t3);}
a=C_alloc(3);
if(C_truep(C_fixnum_lessp(t2,C_fix(0)))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fixnum_difference(t2,C_fix(1));
t5=C_subbyte(((C_word*)t0)[2],t2);
t6=C_a_i_cons(&a,2,t5,t3);
/* library.scm:3389: loop */
t8=t1;
t9=t4;
t10=t6;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}

/* ##sys#list->bytevector in k12559 in k11436 */
static void C_ccall f_22486(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_22486,c,av);}
a=C_alloc(4);
t3=C_i_length(t2);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22493,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3394: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=t3;
tp(3,av2);}}

/* k22491 in ##sys#list->bytevector in k12559 in k11436 */
static void C_ccall f_22493(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_22493,c,av);}
a=C_alloc(8);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_22498,a[2]=t1,a[3]=t3,a[4]=((C_word*)t0)[2],a[5]=((C_word)li581),tmp=(C_word)a,a+=6,tmp));
t5=((C_word*)t3)[1];
f_22498(t5,((C_word*)t0)[3],((C_word*)t0)[2],C_fix(0));}

/* loop in k22491 in ##sys#list->bytevector in k12559 in k11436 */
static void f_22498(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(6,0,4)))){
C_save_and_reclaim_args((void *)trf_22498,4,t0,t1,t2,t3);}
a=C_alloc(6);
if(C_truep(C_i_nullp(t2))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_i_car(t2);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_22511,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_fixnump(t4))){
t6=C_setsubbyte(((C_word*)t0)[2],t3,t4);
/* library.scm:3402: loop */
t8=t1;
t9=C_u_i_cdr(t2);
t10=C_fixnum_plus(t3,C_fix(1));
t1=t8;
t2=t9;
t3=t10;
goto loop;}
else{
/* library.scm:3401: ##sys#signal-hook */
t6=*((C_word*)lf[235]+1);{
C_word av2[5];
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[295];
av2[3]=lf[765];
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}}}

/* k22509 in loop in k22491 in ##sys#list->bytevector in k12559 in k11436 */
static void C_ccall f_22511(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_22511,c,av);}
/* library.scm:3402: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_22498(t2,((C_word*)t0)[3],C_u_i_cdr(((C_word*)t0)[4]),C_fixnum_plus(((C_word*)t0)[5],C_fix(1)));}

/* chicken.bytevector#make-bytevector in k12559 in k11436 */
static void C_ccall f_22525(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_22525,c,av);}
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=C_i_check_fixnum_2(t2,lf[768]);
if(C_truep(t4)){
t6=C_i_check_fixnum_2(t4,lf[768]);
/* library.scm:3416: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=t4;
tp(4,av2);}}
else{
/* library.scm:3416: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=t4;
tp(4,av2);}}}

/* chicken.bytevector#bytevector? in k12559 in k11436 */
static void C_ccall f_22549(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22549,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(C_blockp(t2))?C_bytevectorp(t2):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.bytevector#bytevector-length in k12559 in k11436 */
static void C_ccall f_22555(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22555,c,av);}
t3=C_i_check_bytevector_2(t2,lf[771]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_block_size(t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.bytevector#bytevector-u8-ref in k12559 in k11436 */
static void C_ccall f_22564(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22564,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_bytevector_ref(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.bytevector#bytevector-u8-set! in k12559 in k11436 */
static void C_ccall f_22567(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22567,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_bytevector_set(t2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* chicken.bytevector#string->utf8 in k12559 in k11436 */
static void C_ccall f_22570(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_22570,c,av);}
a=C_alloc(5);
t3=C_i_check_string_2(t2,lf[775]);
t4=C_slot(t2,C_fix(0));
t5=C_block_size(t4);
t6=C_fixnum_difference(t5,C_fix(1));
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22584,a[2]=t4,a[3]=t6,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3436: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t7;
av2[2]=t6;
tp(3,av2);}}

/* k22582 in chicken.bytevector#string->utf8 in k12559 in k11436 */
static void C_ccall f_22584(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22584,c,av);}
t2=C_copy_memory(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.bytevector#utf8->string in k12559 in k11436 */
static void C_ccall f_22586(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_22586,c,av);}
a=C_alloc(4);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_TRUE:C_get_rest_arg(c,3,av,3,t0));
t5=C_i_check_bytevector_2(t2,lf[777]);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22596,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(t4)){
t7=C_block_size(t2);
if(C_truep(C_i_not(C_utf_validate(t2,t7)))){
t8=C_fix((C_word)C_DECODING_ERROR);
/* library.scm:3443: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t6;
av2[2]=t8;
av2[3]=lf[777];
av2[4]=t2;
tp(5,av2);}}
else{
/* library.scm:3445: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[300]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_fix(0);
av2[4]=C_block_size(t2);
tp(5,av2);}}}
else{
/* library.scm:3445: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[300]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_fix(0);
av2[4]=C_block_size(t2);
tp(5,av2);}}}

/* k22594 in chicken.bytevector#utf8->string in k12559 in k11436 */
static void C_ccall f_22596(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_22596,c,av);}
/* library.scm:3445: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[300]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=C_fix(0);
av2[4]=C_block_size(((C_word*)t0)[3]);
tp(5,av2);}}

/* chicken.bytevector#string->latin1 in k12559 in k11436 */
static void C_ccall f_22626(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_22626,c,av);}
a=C_alloc(5);
t3=C_i_check_string_2(t2,lf[779]);
t4=C_slot(t2,C_fix(0));
t5=C_slot(t2,C_fix(1));
t6=C_block_size(t4);
t7=C_fixnum_difference(t6,C_fix(1));
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22643,a[2]=t4,a[3]=t7,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3452: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t8;
av2[2]=t5;
tp(3,av2);}}

/* k22641 in chicken.bytevector#string->latin1 in k12559 in k11436 */
static void C_ccall f_22643(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22643,c,av);}
t2=C_utf_to_latin(((C_word*)t0)[2],t1,C_fix(0),((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.bytevector#latin1->string in k12559 in k11436 */
static void C_ccall f_22645(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_22645,c,av);}
a=C_alloc(5);
t3=C_i_check_bytevector_2(t2,lf[781]);
t4=C_block_size(t2);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22655,a[2]=t1,a[3]=t2,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3459: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=C_fixnum_times(t4,C_fix(2));
tp(3,av2);}}

/* k22653 in chicken.bytevector#latin1->string in k12559 in k11436 */
static void C_ccall f_22655(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_22655,c,av);}
/* library.scm:3461: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[300]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_fix(0);
av2[4]=C_latin_to_utf(((C_word*)t0)[3],t1,C_fix(0),((C_word*)t0)[4]);
tp(5,av2);}}

/* chicken.bytevector#bytevector=? in k12559 in k11436 */
static void C_ccall f_22661(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22661,c,av);}
t4=C_i_check_bytevector_2(t2,lf[783]);
t5=C_i_check_bytevector_2(t3,lf[783]);
t6=C_block_size(t2);
t7=C_block_size(t3);
t8=C_eqp(t7,t6);
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=(C_truep(t8)?C_bv_compare(t2,t3,t6):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}

/* chicken.bytevector#bytevector in k12559 in k11436 */
static void C_ccall f_22683(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_22683,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
t3=C_u_i_length(t2);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22688,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3472: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=t3;
tp(3,av2);}}

/* k22686 in chicken.bytevector#bytevector in k12559 in k11436 */
static void C_ccall f_22688(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_22688,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22693,a[2]=t1,a[3]=((C_word)li593),tmp=(C_word)a,a+=4,tmp);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(
  f_22693(t2,((C_word*)t0)[3],C_fix(0))
);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* loop in k22686 in chicken.bytevector#bytevector in k12559 in k11436 */
static C_word f_22693(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t1))){
return(((C_word*)t0)[2]);}
else{
t3=C_i_car(t1);
t4=C_i_check_fixnum_2(t3,lf[785]);
t5=C_setsubbyte(((C_word*)t0)[2],t2,t3);
t7=C_u_i_cdr(t1);
t8=C_fixnum_plus(t2,C_fix(1));
t1=t7;
t2=t8;
goto loop;}}

/* chicken.bytevector#bytevector-copy in k12559 in k11436 */
static void C_ccall f_22714(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_22714,c,av);}
a=C_alloc(7);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_fix(0):C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
t8=C_rest_nullp(c,4);
t9=C_i_check_bytevector_2(t2,lf[787]);
t10=C_block_size(t2);
t11=(C_truep(t7)?t7:t10);
t12=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_22739,a[2]=t1,a[3]=t11,a[4]=t4,a[5]=t2,a[6]=t10,tmp=(C_word)a,a+=7,tmp);
if(C_truep(t7)){
/* library.scm:3486: ##sys#check-range/including */
t13=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t13;
av2[1]=t12;
av2[2]=t7;
av2[3]=C_fix(0);
av2[4]=t10;
av2[5]=lf[788];
((C_proc)(void*)(*((C_word*)t13+1)))(6,av2);}}
else{
t13=t12;{
C_word *av2=av;
av2[0]=t13;
av2[1]=C_SCHEME_UNDEFINED;
f_22739(2,av2);}}}

/* k22737 in chicken.bytevector#bytevector-copy in k12559 in k11436 */
static void C_ccall f_22739(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_22739,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_22745,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
t3=C_eqp(((C_word*)t0)[6],C_fix(0));
if(C_truep(t3)){
t4=C_eqp(((C_word*)t0)[4],C_fix(0));
t5=t2;
f_22745(t5,(C_truep(t4)?C_eqp(C_fix(0),((C_word*)t0)[3]):C_SCHEME_FALSE));}
else{
t4=t2;
f_22745(t4,C_SCHEME_FALSE);}}

/* k22743 in k22737 in chicken.bytevector#bytevector-copy in k12559 in k11436 */
static void f_22745(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,5)))){
C_save_and_reclaim_args((void *)trf_22745,2,t0,t1);}
a=C_alloc(6);
if(C_truep(t1)){
/* library.scm:3488: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[301]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=C_fix(0);
tp(3,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_22751,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
/* library.scm:3490: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[6];
av2[5]=lf[788];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}}

/* k22749 in k22743 in k22737 in chicken.bytevector#bytevector-copy in k12559 in k11436 */
static void C_ccall f_22751(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_22751,c,av);}
a=C_alloc(6);
t2=C_fixnum_difference(((C_word*)t0)[2],((C_word*)t0)[3]);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_22754,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:3492: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k22752 in k22749 in k22743 in k22737 in chicken.bytevector#bytevector-copy in k12559 in k11436 */
static void C_ccall f_22754(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22754,c,av);}
t2=C_copy_memory_with_offset(t1,((C_word*)t0)[2],C_fix(0),((C_word*)t0)[3],((C_word*)t0)[4]);
t3=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.bytevector#bytevector-copy! in k12559 in k11436 */
static void C_ccall f_22795(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word *a;
if(c<5) C_bad_min_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_22795,c,av);}
a=C_alloc(10);
t5=C_rest_nullp(c,5);
t6=(C_truep(t5)?C_fix(0):C_get_rest_arg(c,5,av,5,t0));
t7=C_rest_nullp(c,5);
t8=C_rest_nullp(c,6);
t9=(C_truep(t8)?C_SCHEME_FALSE:C_get_rest_arg(c,6,av,5,t0));
t10=C_rest_nullp(c,6);
t11=C_i_check_bytevector_2(t2,lf[790]);
t12=C_i_check_bytevector_2(t4,lf[790]);
t13=C_block_size(t2);
t14=C_block_size(t4);
t15=(C_truep(t9)?t9:t14);
t16=C_fixnum_difference(t15,t6);
t17=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_22829,a[2]=t1,a[3]=t2,a[4]=t4,a[5]=t3,a[6]=t6,a[7]=t16,a[8]=t13,a[9]=t14,tmp=(C_word)a,a+=10,tmp);
t18=C_eqp(t14,C_fix(0));
if(C_truep(t18)){
t19=C_eqp(t16,C_fix(0));
t20=t17;
f_22829(t20,(C_truep(t19)?C_eqp(t6,C_fix(0)):C_SCHEME_FALSE));}
else{
t19=t17;
f_22829(t19,C_SCHEME_FALSE);}}

/* k22827 in chicken.bytevector#bytevector-copy! in k12559 in k11436 */
static void f_22829(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,5)))){
C_save_and_reclaim_args((void *)trf_22829,2,t0,t1);}
a=C_alloc(9);
if(C_truep(t1)){
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_22832,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* library.scm:3505: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[9];
av2[5]=lf[791];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}}

/* k22830 in k22827 in chicken.bytevector#bytevector-copy! in k12559 in k11436 */
static void C_ccall f_22832(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_22832,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_22835,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* library.scm:3506: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[8];
av2[5]=lf[791];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}

/* k22833 in k22830 in k22827 in chicken.bytevector#bytevector-copy! in k12559 in k11436 */
static void C_ccall f_22835(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,5)))){
C_save_and_reclaim((void *)f_22835,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_22838,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* library.scm:3507: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_fixnum_plus(((C_word*)t0)[5],((C_word*)t0)[7]);
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[8];
av2[5]=lf[791];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}

/* k22836 in k22833 in k22830 in k22827 in chicken.bytevector#bytevector-copy! in k12559 in k11436 */
static void C_ccall f_22838(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_22838,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_copy_memory_with_offset(((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6],((C_word*)t0)[7]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.bytevector#bytevector-append in k12559 in k11436 */
static void C_ccall f_22877(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +7,c,4)))){
C_save_and_reclaim((void*)f_22877,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+7);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22883,a[2]=t2,a[3]=t4,a[4]=((C_word)li598),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_22883(t6,t1,t2,C_fix(0));}

/* loop in chicken.bytevector#bytevector-append in k12559 in k11436 */
static void f_22883(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(4,0,3)))){
C_save_and_reclaim_args((void *)trf_22883,4,t0,t1,t2,t3);}
a=C_alloc(4);
if(C_truep(C_i_nullp(t2))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22893,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:3514: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=t3;
tp(3,av2);}}
else{
t4=C_i_car(t2);
t5=C_i_check_bytevector_2(t4,lf[793]);
t6=C_u_i_cdr(t2);
t7=C_block_size(t4);
/* library.scm:3524: loop */
t9=t1;
t10=t6;
t11=C_fixnum_plus(t3,t7);
t1=t9;
t2=t10;
t3=t11;
goto loop;}}

/* k22891 in loop in chicken.bytevector#bytevector-append in k12559 in k11436 */
static void C_ccall f_22893(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_22893,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22898,a[2]=t1,a[3]=((C_word)li597),tmp=(C_word)a,a+=4,tmp);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(
  f_22898(t2,((C_word*)t0)[3],C_fix(0))
);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* loop in k22891 in loop in chicken.bytevector#bytevector-append in k12559 in k11436 */
static C_word f_22898(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t1))){
return(((C_word*)t0)[2]);}
else{
t3=C_i_car(t1);
t4=C_block_size(t3);
t5=C_copy_memory_with_offset(((C_word*)t0)[2],t3,t2,C_fix(0),t4);
t7=C_u_i_cdr(t1);
t8=C_fixnum_plus(t2,t4);
t1=t7;
t2=t8;
goto loop;}}

/* scheme#make-vector in k12559 in k11436 */
static void C_ccall f_22935(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +5,c,4)))){
C_save_and_reclaim((void*)f_22935,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+5);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
t4=C_i_check_fixnum_2(t2,lf[794]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_22942,a[2]=t3,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fixnum_lessp(t2,C_fix(0)))){
/* library.scm:3533: ##sys#error */
t6=*((C_word*)lf[195]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[794];
av2[3]=lf[795];
av2[4]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}
else{
t6=t5;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_UNDEFINED;
f_22942(2,av2);}}}

/* k22940 in scheme#make-vector in k12559 in k11436 */
static void C_ccall f_22942(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_22942,c,av);}
if(C_truep(C_i_nullp(((C_word*)t0)[2]))){
t2=C_SCHEME_UNDEFINED;
/* library.scm:3534: ##sys#allocate-vector */
t3=*((C_word*)lf[383]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}
else{
/* library.scm:3534: ##sys#allocate-vector */
t2=*((C_word*)lf[383]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=C_i_car(((C_word*)t0)[2]);
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}}

/* scheme#list->vector in k12559 in k11436 */
static void C_ccall f_22964(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_22964,c,av);}
a=C_alloc(4);
t3=C_i_listp(t2);
if(C_truep(C_i_not(t3))){
/* library.scm:3545: ##sys#error-not-a-proper-list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[797];
tp(4,av2);}}
else{
t4=C_i_length(t2);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22980,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3547: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}}

/* k22978 in scheme#list->vector in k12559 in k11436 */
static void C_ccall f_22980(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_22980,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_22985,a[2]=t1,a[3]=((C_word)li601),tmp=(C_word)a,a+=4,tmp);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(
  f_22985(t2,((C_word*)t0)[3],C_fix(0))
);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* loop in k22978 in scheme#list->vector in k12559 in k11436 */
static C_word f_22985(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_nullp(t1))){
return(((C_word*)t0)[2]);}
else{
t3=C_slot(t1,C_fix(0));
t4=C_i_setslot(((C_word*)t0)[2],t2,t3);
t6=C_slot(t1,C_fix(1));
t7=C_fixnum_plus(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}

/* scheme#vector->list in k12559 in k11436 */
static void C_ccall f_23016(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,5)))){
C_save_and_reclaim((void *)f_23016,c,av);}
a=C_alloc(11);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=t4;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_rest_nullp(c,3);
t8=C_rest_nullp(c,4);
t9=(C_truep(t8)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
t10=t9;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_rest_nullp(c,4);
t13=C_i_check_vector_2(t2,lf[798]);
t14=C_block_size(t2);
t15=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23038,a[2]=t11,a[3]=t2,a[4]=t1,a[5]=t6,a[6]=t14,tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t6)[1])){
/* library.scm:3561: ##sys#check-range/including */
t16=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t16;
av2[1]=t15;
av2[2]=((C_word*)t6)[1];
av2[3]=C_fix(0);
av2[4]=t14;
av2[5]=lf[798];
((C_proc)(void*)(*((C_word*)t16+1)))(6,av2);}}
else{
t16=C_set_block_item(t6,0,C_fix(0));
t17=t15;{
C_word *av2=av;
av2[0]=t17;
av2[1]=t16;
f_23038(2,av2);}}}

/* k23036 in scheme#vector->list in k12559 in k11436 */
static void C_ccall f_23038(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_23038,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23041,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
/* library.scm:3564: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[2])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[6];
av2[5]=lf[798];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}
else{
t3=C_set_block_item(((C_word*)t0)[2],0,((C_word*)t0)[6]);
t4=t2;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
f_23041(2,av2);}}}

/* k23039 in k23036 in scheme#vector->list in k12559 in k11436 */
static void C_ccall f_23041(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_23041,c,av);}
a=C_alloc(8);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23046,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=((C_word)li603),tmp=(C_word)a,a+=6,tmp));
t5=((C_word*)t3)[1];
f_23046(t5,((C_word*)t0)[4],((C_word*)((C_word*)t0)[5])[1]);}

/* loop in k23039 in k23036 in scheme#vector->list in k12559 in k11436 */
static void f_23046(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_23046,3,t0,t1,t2);}
a=C_alloc(4);
if(C_truep(C_fixnum_greater_or_equal_p(t2,((C_word*)((C_word*)t0)[2])[1]))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_slot(((C_word*)t0)[3],t2);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_23064,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3570: loop */
t6=t4;
t7=C_fixnum_plus(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}

/* k23062 in loop in k23039 in k23036 in scheme#vector->list in k12559 in k11436 */
static void C_ccall f_23064(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_23064,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scheme#vector in k12559 in k11436 */
static void C_ccall f_23102(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +0,c,2)))){
C_save_and_reclaim((void*)f_23102,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+0);
t2=C_build_rest(&a,c,2,av);
C_word t3;
/* library.scm:3572: scheme#list->vector */
t3=*((C_word*)lf[118]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* scheme#vector-fill! in k12559 in k11436 */
static void C_ccall f_23108(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(12,c,5)))){
C_save_and_reclaim((void *)f_23108,c,av);}
a=C_alloc(12);
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,4,t0));
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_rest_nullp(c,4);
t9=C_rest_nullp(c,5);
t10=(C_truep(t9)?C_SCHEME_FALSE:C_get_rest_arg(c,5,av,4,t0));
t11=t10;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_rest_nullp(c,5);
t14=C_i_check_vector_2(t2,lf[799]);
t15=C_block_size(t2);
t16=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_23130,a[2]=t12,a[3]=t2,a[4]=t3,a[5]=t1,a[6]=t7,a[7]=t15,tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)t7)[1])){
/* library.scm:3579: ##sys#check-range/including */
t17=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t17;
av2[1]=t16;
av2[2]=((C_word*)t7)[1];
av2[3]=C_fix(0);
av2[4]=t15;
av2[5]=lf[799];
((C_proc)(void*)(*((C_word*)t17+1)))(6,av2);}}
else{
t17=C_set_block_item(t7,0,C_fix(0));
t18=t16;{
C_word *av2=av;
av2[0]=t18;
av2[1]=t17;
f_23130(2,av2);}}}

/* k23128 in scheme#vector-fill! in k12559 in k11436 */
static void C_ccall f_23130(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_23130,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23133,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
/* library.scm:3582: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[2])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[7];
av2[5]=lf[799];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}
else{
t3=C_set_block_item(((C_word*)t0)[2],0,((C_word*)t0)[7]);
t4=t2;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
f_23133(2,av2);}}}

/* k23131 in k23128 in scheme#vector-fill! in k12559 in k11436 */
static void C_ccall f_23133(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_23133,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23138,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word)li606),tmp=(C_word)a,a+=6,tmp);
t3=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(
  f_23138(t2,((C_word*)((C_word*)t0)[6])[1])
);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* doloop4337 in k23131 in k23128 in scheme#vector-fill! in k12559 in k11436 */
static C_word f_23138(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_stack_overflow_check;
loop:{}
if(C_truep(C_fixnum_greater_or_equal_p(t1,((C_word*)((C_word*)t0)[2])[1]))){
t2=C_SCHEME_UNDEFINED;
return(t2);}
else{
t2=C_i_setslot(((C_word*)t0)[3],t1,((C_word*)t0)[4]);
t4=C_fixnum_plus(t1,C_fix(1));
t1=t4;
goto loop;}}

/* scheme#vector-copy in k12559 in k11436 */
static void C_ccall f_23189(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_23189,c,av);}
a=C_alloc(3);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
t8=C_rest_nullp(c,4);
t9=C_i_check_vector_2(t2,lf[801]);
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23206,a[2]=((C_word)li609),tmp=(C_word)a,a+=3,tmp);
if(C_truep(t7)){
/* library.scm:3600: copy */
f_23206(t1,t2,t4,t7);}
else{
t11=(C_truep(t4)?t4:C_fix(0));
/* library.scm:3601: copy */
f_23206(t1,t2,t11,C_block_size(t2));}}

/* copy in scheme#vector-copy in k12559 in k11436 */
static void f_23206(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,5)))){
C_save_and_reclaim_args((void *)trf_23206,4,t1,t2,t3,t4);}
a=C_alloc(7);
t5=C_block_size(t2);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23213,a[2]=t4,a[3]=t2,a[4]=t1,a[5]=t3,a[6]=t5,tmp=(C_word)a,a+=7,tmp);
/* library.scm:3592: ##sys#check-range/including */
t7=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t7;
av2[1]=t6;
av2[2]=t3;
av2[3]=C_fix(0);
av2[4]=t4;
av2[5]=lf[801];
((C_proc)(void*)(*((C_word*)t7+1)))(6,av2);}}

/* k23211 in copy in scheme#vector-copy in k12559 in k11436 */
static void C_ccall f_23213(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_23213,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23216,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:3593: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[5];
av2[4]=((C_word*)t0)[6];
av2[5]=lf[801];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}

/* k23214 in k23211 in copy in scheme#vector-copy in k12559 in k11436 */
static void C_ccall f_23216(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_23216,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23219,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:3594: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t2;
av2[2]=C_fixnum_difference(((C_word*)t0)[2],((C_word*)t0)[5]);
tp(3,av2);}}

/* k23217 in k23214 in k23211 in copy in scheme#vector-copy in k12559 in k11436 */
static void C_ccall f_23219(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_23219,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23224,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word)li608),tmp=(C_word)a,a+=6,tmp);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(
  f_23224(t2,C_fix(0),((C_word*)t0)[5])
);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* doloop4368 in k23217 in k23214 in k23211 in copy in scheme#vector-copy in k12559 in k11436 */
static C_word f_23224(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_fixnum_greater_or_equal_p(t2,((C_word*)t0)[2]))){
return(((C_word*)t0)[3]);}
else{
t3=C_slot(((C_word*)t0)[4],t2);
t4=C_i_setslot(((C_word*)t0)[3],t1,t3);
t6=C_fixnum_plus(t1,C_fix(1));
t7=C_fixnum_plus(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}

/* scheme#vector-copy! in k12559 in k11436 */
static void C_ccall f_23296(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a;
if(c<5) C_bad_min_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,7)))){
C_save_and_reclaim((void *)f_23296,c,av);}
a=C_alloc(3);
t5=C_rest_nullp(c,5);
t6=(C_truep(t5)?C_SCHEME_FALSE:C_get_rest_arg(c,5,av,5,t0));
t7=C_rest_nullp(c,5);
t8=C_rest_nullp(c,6);
t9=(C_truep(t8)?C_SCHEME_FALSE:C_get_rest_arg(c,6,av,5,t0));
t10=C_rest_nullp(c,6);
t11=C_i_check_vector_2(t2,lf[803]);
t12=C_i_check_vector_2(t4,lf[803]);
t13=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23316,a[2]=((C_word)li613),tmp=(C_word)a,a+=3,tmp);
if(C_truep(t9)){
/* library.scm:3624: copy! */
f_23316(t1,t2,t3,t4,t6,t9);}
else{
t14=(C_truep(t6)?t6:C_fix(0));
/* library.scm:3625: copy! */
f_23316(t1,t2,t3,t4,t14,C_block_size(t4));}}

/* copy! in scheme#vector-copy! in k12559 in k11436 */
static void f_23316(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6){
C_word tmp;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,5)))){
C_save_and_reclaim_args((void *)trf_23316,6,t1,t2,t3,t4,t5,t6);}
a=C_alloc(11);
t7=C_block_size(t2);
t8=C_block_size(t4);
t9=C_fixnum_difference(t6,t5);
t10=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_23329,a[2]=t2,a[3]=t4,a[4]=t5,a[5]=t3,a[6]=t6,a[7]=t9,a[8]=t1,a[9]=t7,a[10]=t8,tmp=(C_word)a,a+=11,tmp);
/* library.scm:3610: ##sys#check-range/including */
t11=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t11;
av2[1]=t10;
av2[2]=t3;
av2[3]=C_fix(0);
av2[4]=t7;
av2[5]=lf[803];
((C_proc)(void*)(*((C_word*)t11+1)))(6,av2);}}

/* k23327 in copy! in scheme#vector-copy! in k12559 in k11436 */
static void C_ccall f_23329(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,5)))){
C_save_and_reclaim((void *)f_23329,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_23332,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],tmp=(C_word)a,a+=11,tmp);
/* library.scm:3611: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[6];
av2[5]=lf[803];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}

/* k23330 in k23327 in copy! in scheme#vector-copy! in k12559 in k11436 */
static void C_ccall f_23332(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,5)))){
C_save_and_reclaim((void *)f_23332,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_23335,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],tmp=(C_word)a,a+=10,tmp);
/* library.scm:3612: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=((C_word*)t0)[4];
av2[4]=((C_word*)t0)[10];
av2[5]=lf[803];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}

/* k23333 in k23330 in k23327 in copy! in scheme#vector-copy! in k12559 in k11436 */
static void C_ccall f_23335(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_23335,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_23338,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* library.scm:3613: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[7];
av2[3]=C_fix(0);
av2[4]=C_fixnum_difference(((C_word*)t0)[9],((C_word*)t0)[5]);
av2[5]=lf[803];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}

/* k23336 in k23333 in k23330 in k23327 in copy! in scheme#vector-copy! in k12559 in k11436 */
static void C_ccall f_23338(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_23338,c,av);}
a=C_alloc(6);
t2=C_eqp(((C_word*)t0)[2],((C_word*)t0)[3]);
t3=(C_truep(t2)?C_fixnum_lessp(((C_word*)t0)[4],((C_word*)t0)[5]):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=C_fixnum_difference(((C_word*)t0)[6],C_fix(1));
t5=C_fixnum_plus(((C_word*)t0)[5],((C_word*)t0)[7]);
t6=C_fixnum_difference(t5,C_fix(1));
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23357,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word)li611),tmp=(C_word)a,a+=6,tmp);
t8=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t8;
av2[1]=(
  f_23357(t7,t4,t6)
);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23391,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word)li612),tmp=(C_word)a,a+=6,tmp);
t5=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t5;
av2[1]=(
  f_23391(t4,((C_word*)t0)[4],((C_word*)t0)[5])
);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* doloop4409 in k23336 in k23333 in k23330 in k23327 in copy! in scheme#vector-copy! in k12559 in k11436 */
static C_word f_23357(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_fixnum_lessp(t1,((C_word*)t0)[2]))){
t3=C_SCHEME_UNDEFINED;
return(t3);}
else{
t3=C_slot(((C_word*)t0)[3],t1);
t4=C_i_setslot(((C_word*)t0)[4],t2,t3);
t6=C_fixnum_difference(t1,C_fix(1));
t7=C_fixnum_difference(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}

/* doloop4415 in k23336 in k23333 in k23330 in k23327 in copy! in scheme#vector-copy! in k12559 in k11436 */
static C_word f_23391(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_stack_overflow_check;
loop:{}
t3=C_eqp(t1,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
return(t4);}
else{
t4=C_slot(((C_word*)t0)[3],t1);
t5=C_i_setslot(((C_word*)t0)[4],t2,t4);
t7=C_fixnum_plus(t1,C_fix(1));
t8=C_fixnum_plus(t2,C_fix(1));
t1=t7;
t2=t8;
goto loop;}}

/* scheme#vector-append in k12559 in k11436 */
static void C_ccall f_23469(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +20,c,3)))){
C_save_and_reclaim((void*)f_23469,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+20);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23590,a[2]=((C_word)li615),tmp=(C_word)a,a+=3,tmp);
t4=(
  f_23590(t2)
);
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_23484,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23556,a[2]=t7,a[3]=t11,a[4]=t8,a[5]=((C_word)li618),tmp=(C_word)a,a+=6,tmp));
t13=((C_word*)t11)[1];
f_23556(t13,t9,t2);}

/* k23482 in scheme#vector-append in k12559 in k11436 */
static void C_ccall f_23484(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_23484,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_23487,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t3=C_i_check_list_2(t1,lf[254]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_23532,a[2]=((C_word)li617),tmp=(C_word)a,a+=3,tmp);
t5=(
  f_23532(t1,C_fix(0))
);
/* library.scm:3630: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t2;
av2[2]=t5;
tp(3,av2);}}

/* k23485 in k23482 in scheme#vector-append in k12559 in k11436 */
static void C_ccall f_23487(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_23487,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_23492,a[2]=t1,a[3]=t3,a[4]=((C_word)li616),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_23492(t5,((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[4],C_fix(0));}

/* doloop4501 in k23485 in k23482 in scheme#vector-append in k12559 in k11436 */
static void f_23492(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,6)))){
C_save_and_reclaim_args((void *)trf_23492,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t2))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23502,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,a[5]=t3,a[6]=t4,tmp=(C_word)a,a+=7,tmp);
/* library.scm:3635: scheme#vector-copy! */
t6=*((C_word*)lf[802]+1);{
C_word av2[7];
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
av2[3]=t4;
av2[4]=C_i_car(t2);
av2[5]=C_fix(0);
av2[6]=C_i_car(t3);
((C_proc)(void*)(*((C_word*)t6+1)))(7,av2);}}}

/* k23500 in doloop4501 in k23485 in k23482 in scheme#vector-append in k12559 in k11436 */
static void C_ccall f_23502(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_23502,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_23492(t2,((C_word*)t0)[3],C_u_i_cdr(((C_word*)t0)[4]),C_u_i_cdr(((C_word*)t0)[5]),C_fixnum_plus(((C_word*)t0)[6],C_u_i_car(((C_word*)t0)[5])));}

/* foldl4491 in k23482 in scheme#vector-append in k12559 in k11436 */
static C_word f_23532(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t3=C_slot(t1,C_fix(1));
t4=C_slot(t1,C_fix(0));
t6=t3;
t7=C_fixnum_plus(t2,t4);
t1=t6;
t2=t7;
goto loop;}
else{
return(t2);}}

/* map-loop4460 in scheme#vector-append in k12559 in k11436 */
static void f_23556(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_23556,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_block_size(t3);
t5=C_a_i_cons(&a,2,t4,C_SCHEME_END_OF_LIST);
t6=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t5);
t7=C_mutate(((C_word *)((C_word*)t0)[2])+1,t5);
t9=t1;
t10=C_slot(t2,C_fix(1));
t1=t9;
t2=t10;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* for-each-loop4434 in scheme#vector-append in k12559 in k11436 */
static C_word f_23590(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=C_slot(t1,C_fix(0));
t3=C_i_check_vector_2(t2,lf[805]);
t5=C_slot(t1,C_fix(1));
t1=t5;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* chicken.base#subvector in k12559 in k11436 */
static void C_ccall f_23613(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,5)))){
C_save_and_reclaim((void *)f_23613,c,av);}
a=C_alloc(8);
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,4,t0));
t6=C_i_check_vector_2(t2,lf[806]);
t7=C_block_size(t2);
t8=(C_truep(t5)?t5:t7);
t9=C_fixnum_difference(t8,t3);
t10=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_23632,a[2]=t9,a[3]=t3,a[4]=t2,a[5]=t1,a[6]=t8,a[7]=t7,tmp=(C_word)a,a+=8,tmp);
/* library.scm:3643: ##sys#check-range/including */
t11=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t11;
av2[1]=t10;
av2[2]=t3;
av2[3]=C_fix(0);
av2[4]=t7;
av2[5]=lf[806];
((C_proc)(void*)(*((C_word*)t11+1)))(6,av2);}}

/* k23630 in chicken.base#subvector in k12559 in k11436 */
static void C_ccall f_23632(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_23632,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23635,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:3644: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[7];
av2[5]=lf[806];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}

/* k23633 in k23630 in chicken.base#subvector in k12559 in k11436 */
static void C_ccall f_23635(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_23635,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23638,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:3645: scheme#make-vector */
t3=*((C_word*)lf[117]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k23636 in k23633 in k23630 in chicken.base#subvector in k12559 in k11436 */
static void C_ccall f_23638(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_23638,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23643,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word)li620),tmp=(C_word)a,a+=7,tmp);
t3=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(
  f_23643(t2,C_fix(0))
);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* doloop4528 in k23636 in k23633 in k23630 in chicken.base#subvector in k12559 in k11436 */
static C_word f_23643(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_stack_overflow_check;
loop:{}
if(C_truep(C_fixnum_greater_or_equal_p(t1,((C_word*)t0)[2]))){
return(((C_word*)t0)[3]);}
else{
t2=C_fixnum_plus(t1,((C_word*)t0)[4]);
t3=C_slot(((C_word*)t0)[5],t2);
t4=C_i_setslot(((C_word*)t0)[3],t1,t3);
t6=C_fixnum_plus(t1,C_fix(1));
t1=t6;
goto loop;}}

/* chicken.base#vector-resize in k12559 in k11436 */
static void C_ccall f_23676(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_23676,c,av);}
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,4,t0));
t6=C_i_check_vector_2(t2,lf[807]);
t7=C_i_check_fixnum_2(t3,lf[807]);
/* library.scm:3654: ##sys#vector-resize */
f_23697(t1,t2,t3,t5);}

/* ##sys#vector-resize in k12559 in k11436 */
static void f_23697(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_23697,4,t1,t2,t3,t4);}
a=C_alloc(5);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_23701,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3657: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t5;
av2[2]=t3;
av2[3]=t4;
tp(4,av2);}}

/* k23699 in ##sys#vector-resize in k12559 in k11436 */
static void C_ccall f_23701(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_23701,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_23704,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:3658: scheme#min */
t3=*((C_word*)lf[325]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_block_size(((C_word*)t0)[2]);
av2[3]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k23702 in k23699 in ##sys#vector-resize in k12559 in k11436 */
static void C_ccall f_23704(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_23704,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_23709,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word)li623),tmp=(C_word)a,a+=6,tmp);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(
  f_23709(t2,C_fix(0))
);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* doloop4556 in k23702 in k23699 in ##sys#vector-resize in k12559 in k11436 */
static C_word f_23709(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_stack_overflow_check;
loop:{}
if(C_truep(C_fixnum_greater_or_equal_p(t1,((C_word*)t0)[2]))){
return(((C_word*)t0)[3]);}
else{
t2=C_slot(((C_word*)t0)[4],t1);
t3=C_i_setslot(((C_word*)t0)[3],t1,t2);
t5=C_fixnum_plus(t1,C_fix(1));
t1=t5;
goto loop;}}

/* scheme#char-ci=? in k12559 in k11436 */
static void C_ccall f_23736(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +6,c,5)))){
C_save_and_reclaim((void*)f_23736,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+6);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
t5=C_i_check_char_2(t2,lf[809]);
t6=C_i_check_char_2(t3,lf[809]);
t7=C_utf_char_foldcase(t3);
t8=C_eqp(C_utf_char_foldcase(t2),t7);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_23752,a[2]=t10,a[3]=((C_word)li625),tmp=(C_word)a,a+=4,tmp));
t12=((C_word*)t10)[1];
f_23752(t12,t1,t7,t4,t8);}

/* loop in scheme#char-ci=? in k12559 in k11436 */
static void f_23752(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_23752,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t3))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_slot(t3,C_fix(0));
t6=C_i_check_char_2(t5,lf[809]);
t7=C_utf_char_foldcase(t5);
t8=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23768,a[2]=t3,a[3]=t4,a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=t2,tmp=(C_word)a,a+=7,tmp);
/* library.scm:3676: g4571 */
t9=t7;{
C_word av2[2];
av2[0]=t9;
av2[1]=t8;
((C_proc)C_fast_retrieve_proc(t9))(2,av2);}}}

/* k23766 in loop in scheme#char-ci=? in k12559 in k11436 */
static void C_ccall f_23768(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_23768,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(1));
if(C_truep(((C_word*)t0)[3])){
/* library.scm:3677: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23752(t3,((C_word*)t0)[5],t1,t2,C_eqp(((C_word*)t0)[6],t1));}
else{
/* library.scm:3677: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23752(t3,((C_word*)t0)[5],t1,t2,C_SCHEME_FALSE);}}

/* scheme#char-ci>? in k12559 in k11436 */
static void C_ccall f_23785(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +6,c,5)))){
C_save_and_reclaim((void*)f_23785,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+6);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
t5=C_i_check_char_2(t2,lf[810]);
t6=C_i_check_char_2(t3,lf[810]);
t7=C_utf_char_foldcase(t3);
t8=C_utf_char_foldcase(t2);
t9=C_u_i_char_greaterp(t8,t7);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_23799,a[2]=t11,a[3]=((C_word)li627),tmp=(C_word)a,a+=4,tmp));
t13=((C_word*)t11)[1];
f_23799(t13,t1,t7,t4,t9);}

/* loop in scheme#char-ci>? in k12559 in k11436 */
static void f_23799(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_23799,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t3))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_slot(t3,C_fix(0));
t6=C_i_check_char_2(t5,lf[810]);
t7=C_utf_char_foldcase(t5);
t8=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23815,a[2]=t3,a[3]=t4,a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=t2,tmp=(C_word)a,a+=7,tmp);
/* library.scm:3693: g4588 */
t9=t7;{
C_word av2[2];
av2[0]=t9;
av2[1]=t8;
((C_proc)C_fast_retrieve_proc(t9))(2,av2);}}}

/* k23813 in loop in scheme#char-ci>? in k12559 in k11436 */
static void C_ccall f_23815(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_23815,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(1));
if(C_truep(((C_word*)t0)[3])){
/* library.scm:3694: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23799(t3,((C_word*)t0)[5],t1,t2,C_u_i_char_greaterp(((C_word*)t0)[6],t1));}
else{
/* library.scm:3694: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23799(t3,((C_word*)t0)[5],t1,t2,C_SCHEME_FALSE);}}

/* scheme#char-ci<? in k12559 in k11436 */
static void C_ccall f_23828(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +6,c,5)))){
C_save_and_reclaim((void*)f_23828,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+6);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
t5=C_i_check_char_2(t2,lf[811]);
t6=C_i_check_char_2(t3,lf[811]);
t7=C_utf_char_foldcase(t3);
t8=C_utf_char_foldcase(t2);
t9=C_u_i_char_lessp(t8,t7);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_23842,a[2]=t11,a[3]=((C_word)li629),tmp=(C_word)a,a+=4,tmp));
t13=((C_word*)t11)[1];
f_23842(t13,t1,t7,t4,t9);}

/* loop in scheme#char-ci<? in k12559 in k11436 */
static void f_23842(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_23842,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t3))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_slot(t3,C_fix(0));
t6=C_i_check_char_2(t5,lf[811]);
t7=C_utf_char_foldcase(t5);
t8=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23858,a[2]=t3,a[3]=t4,a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=t2,tmp=(C_word)a,a+=7,tmp);
/* library.scm:3710: g4605 */
t9=t7;{
C_word av2[2];
av2[0]=t9;
av2[1]=t8;
((C_proc)C_fast_retrieve_proc(t9))(2,av2);}}}

/* k23856 in loop in scheme#char-ci<? in k12559 in k11436 */
static void C_ccall f_23858(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_23858,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(1));
if(C_truep(((C_word*)t0)[3])){
/* library.scm:3711: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23842(t3,((C_word*)t0)[5],t1,t2,C_u_i_char_lessp(((C_word*)t0)[6],t1));}
else{
/* library.scm:3711: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23842(t3,((C_word*)t0)[5],t1,t2,C_SCHEME_FALSE);}}

/* scheme#char-ci>=? in k12559 in k11436 */
static void C_ccall f_23871(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +6,c,5)))){
C_save_and_reclaim((void*)f_23871,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+6);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
t5=C_i_check_char_2(t2,lf[812]);
t6=C_i_check_char_2(t3,lf[812]);
t7=C_utf_char_foldcase(t3);
t8=C_utf_char_foldcase(t2);
t9=C_u_i_char_greater_or_equal_p(t8,t7);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_23885,a[2]=t11,a[3]=((C_word)li631),tmp=(C_word)a,a+=4,tmp));
t13=((C_word*)t11)[1];
f_23885(t13,t1,t7,t4,t9);}

/* loop in scheme#char-ci>=? in k12559 in k11436 */
static void f_23885(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_23885,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t3))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_slot(t3,C_fix(0));
t6=C_i_check_char_2(t5,lf[812]);
t7=C_utf_char_foldcase(t5);
t8=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23901,a[2]=t3,a[3]=t4,a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=t2,tmp=(C_word)a,a+=7,tmp);
/* library.scm:3727: g4622 */
t9=t7;{
C_word av2[2];
av2[0]=t9;
av2[1]=t8;
((C_proc)C_fast_retrieve_proc(t9))(2,av2);}}}

/* k23899 in loop in scheme#char-ci>=? in k12559 in k11436 */
static void C_ccall f_23901(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_23901,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(1));
if(C_truep(((C_word*)t0)[3])){
/* library.scm:3728: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23885(t3,((C_word*)t0)[5],t1,t2,C_u_i_char_greater_or_equal_p(((C_word*)t0)[6],t1));}
else{
/* library.scm:3728: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23885(t3,((C_word*)t0)[5],t1,t2,C_SCHEME_FALSE);}}

/* scheme#char-ci<=? in k12559 in k11436 */
static void C_ccall f_23914(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +6,c,5)))){
C_save_and_reclaim((void*)f_23914,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+6);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
t5=C_i_check_char_2(t2,lf[813]);
t6=C_i_check_char_2(t3,lf[813]);
t7=C_utf_char_foldcase(t3);
t8=C_utf_char_foldcase(t2);
t9=C_u_i_char_less_or_equal_p(t8,t7);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_23928,a[2]=t11,a[3]=((C_word)li633),tmp=(C_word)a,a+=4,tmp));
t13=((C_word*)t11)[1];
f_23928(t13,t1,t7,t4,t9);}

/* loop in scheme#char-ci<=? in k12559 in k11436 */
static void f_23928(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_23928,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t3))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_slot(t3,C_fix(0));
t6=C_i_check_char_2(t5,lf[813]);
t7=C_utf_char_foldcase(t5);
t8=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_23944,a[2]=t3,a[3]=t4,a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=t2,tmp=(C_word)a,a+=7,tmp);
/* library.scm:3744: g4639 */
t9=t7;{
C_word av2[2];
av2[0]=t9;
av2[1]=t8;
((C_proc)C_fast_retrieve_proc(t9))(2,av2);}}}

/* k23942 in loop in scheme#char-ci<=? in k12559 in k11436 */
static void C_ccall f_23944(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_23944,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(1));
if(C_truep(((C_word*)t0)[3])){
/* library.scm:3745: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23928(t3,((C_word*)t0)[5],t1,t2,C_u_i_char_less_or_equal_p(((C_word*)t0)[6],t1));}
else{
/* library.scm:3745: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_23928(t3,((C_word*)t0)[5],t1,t2,C_SCHEME_FALSE);}}

/* k23957 in k12559 in k11436 */
static void C_ccall f_23959(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,3)))){
C_save_and_reclaim((void *)f_23959,c,av);}
a=C_alloc(15);
t2=C_SCHEME_END_OF_LIST;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_23961,a[2]=t1,a[3]=((C_word)li636),tmp=(C_word)a,a+=4,tmp);
t5=C_mutate((C_word*)lf[239]+1 /* (set! chicken.base#char-name ...) */,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24002,a[2]=t4,a[3]=t3,a[4]=t1,a[5]=((C_word)li637),tmp=(C_word)a,a+=6,tmp));
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24119,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3789: chicken.base#char-name */
t7=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t7;
av2[1]=t6;
av2[2]=lf[1630];
av2[3]=C_make_character(32);
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}

/* lookup-char in k23957 in k12559 in k11436 */
static void f_23961(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_23961,3,t0,t1,t2);}
a=C_alloc(4);
t3=C_fix(C_character_code(t2));
t4=C_fixnum_modulo(t3,C_fix(37));
t5=C_slot(((C_word*)t0)[2],t4);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_23974,a[2]=t2,a[3]=((C_word)li635),tmp=(C_word)a,a+=4,tmp);
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=(
  f_23974(t6,t5)
);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* loop in lookup-char in k23957 in k12559 in k11436 */
static C_word f_23974(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=C_slot(t1,C_fix(0));
t3=C_slot(t2,C_fix(0));
t4=C_eqp(t3,((C_word*)t0)[2]);
if(C_truep(t4)){
return(t2);}
else{
t6=C_slot(t1,C_fix(1));
t1=t6;
goto loop;}}
else{
return(C_SCHEME_FALSE);}}

/* chicken.base#char-name in k23957 in k12559 in k11436 */
static void C_ccall f_24002(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +8,c,5)))){
C_save_and_reclaim((void*)f_24002,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+8);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
t4=C_i_pairp(t3);
t5=(C_truep(t4)?C_get_rest_arg(c,3,av,3,t0):C_SCHEME_FALSE);
if(C_truep(C_charp(t2))){
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24015,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:3763: lookup-char */
t7=((C_word*)t0)[2];
f_23961(t7,t6,t2);}
else{
if(C_truep(t5)){
t6=C_i_check_symbol_2(t2,lf[814]);
t7=C_i_check_char_2(t5,lf[814]);
t8=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_24033,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t5,a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[2],tmp=(C_word)a,a+=8,tmp);
t9=C_slot(t2,C_fix(1));
t10=C_block_size(t9);
if(C_truep(C_fixnum_lessp(t10,C_fix(2)))){
/* library.scm:3769: ##sys#signal-hook */
t11=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t11;
av2[1]=t8;
av2[2]=lf[295];
av2[3]=lf[814];
av2[4]=lf[815];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t11+1)))(6,av2);}}
else{
t11=t8;{
C_word *av2=av;
av2[0]=t11;
av2[1]=C_SCHEME_UNDEFINED;
f_24033(2,av2);}}}
else{
t6=C_i_check_symbol_2(t2,lf[814]);
t7=C_i_assq(t2,((C_word*)((C_word*)t0)[3])[1]);
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=(C_truep(t7)?C_slot(t7,C_fix(1)):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}}

/* k24013 in chicken.base#char-name in k23957 in k12559 in k11436 */
static void C_ccall f_24015(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24015,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=(C_truep(t1)?C_slot(t1,C_fix(1)):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k24031 in chicken.base#char-name in k23957 in k12559 in k11436 */
static void C_ccall f_24033(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_24033,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_24036,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
/* library.scm:3770: lookup-char */
t3=((C_word*)t0)[7];
f_23961(t3,t2,((C_word*)t0)[5]);}

/* k24034 in k24031 in chicken.base#char-name in k23957 in k12559 in k11436 */
static void C_ccall f_24036(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,1)))){
C_save_and_reclaim((void *)f_24036,c,av);}
a=C_alloc(12);
if(C_truep(t1)){
t2=C_i_assq(((C_word*)t0)[2],((C_word*)((C_word*)t0)[3])[1]);
t3=C_i_setslot(t1,C_fix(1),((C_word*)t0)[2]);
if(C_truep(t2)){
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_i_slot(t2,C_fix(1),((C_word*)t0)[5]);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[5]);
t5=C_a_i_cons(&a,2,t4,((C_word*)((C_word*)t0)[3])[1]);
t6=C_mutate(((C_word *)((C_word*)t0)[3])+1,t5);
t7=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}
else{
t2=C_fix(C_character_code(((C_word*)t0)[5]));
t3=C_fixnum_modulo(t2,C_fix(37));
t4=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[5]);
t5=C_a_i_cons(&a,2,t4,((C_word*)((C_word*)t0)[3])[1]);
t6=C_mutate(((C_word *)((C_word*)t0)[3])+1,t5);
t7=C_a_i_cons(&a,2,((C_word*)t0)[5],((C_word*)t0)[2]);
t8=C_slot(((C_word*)t0)[6],t3);
t9=C_a_i_cons(&a,2,t7,t8);
t10=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t10;
av2[1]=C_i_setslot(((C_word*)t0)[6],t3,t9);
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}}

/* k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24119(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24119,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24122,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3790: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1629];
av2[3]=C_make_character(9);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24122(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24122,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24125,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3791: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1628];
av2[3]=C_make_character(10);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24125(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24125,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24128,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3792: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1627];
av2[3]=C_make_character(10);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24128(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24128,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24131,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3793: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1626];
av2[3]=C_make_character(11);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24131(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24131,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24134,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3794: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1625];
av2[3]=C_make_character(127);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24134(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24134,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24137,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3795: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1624];
av2[3]=C_make_character(27);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24137(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24137,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24140,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3796: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1623];
av2[3]=C_make_character(27);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24140(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24140,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24143,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3797: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1622];
av2[3]=C_make_character(7);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24143(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24143,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24146,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3798: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1621];
av2[3]=C_make_character(0);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24146(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24146,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24149,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3799: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1620];
av2[3]=C_make_character(0);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24149(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24149,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24152,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3800: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1619];
av2[3]=C_make_character(13);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24152(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24152,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24155,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3801: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1618];
av2[3]=C_make_character(12);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24155(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_24155,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24158,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:3802: chicken.base#char-name */
t3=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1617];
av2[3]=C_make_character(8);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24158(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(84,c,6)))){
C_save_and_reclaim((void *)f_24158,c,av);}
a=C_alloc(84);
t2=C_mutate((C_word*)lf[816]+1 /* (set! ##sys#call-with-current-continuation ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_call_cc,a[2]=((C_word)li638),tmp=(C_word)a,a+=3,tmp));
t3=C_mutate((C_word*)lf[817]+1 /* (set! ##sys#call-with-cthulhu ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_call_with_cthulhu,a[2]=((C_word)li639),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[818]+1 /* (set! ##sys#call-with-values ...) */,*((C_word*)lf[161]+1));
t5=C_mutate((C_word*)lf[819]+1 /* (set! ##sys#for-each ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24163,a[2]=((C_word)li641),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[821]+1 /* (set! ##sys#map ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24201,a[2]=((C_word)li643),tmp=(C_word)a,a+=3,tmp));
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24243,a[2]=((C_word)li646),tmp=(C_word)a,a+=3,tmp);
t10=C_set_block_item(t8,0,t9);
t11=C_mutate((C_word*)lf[210]+1 /* (set! scheme#for-each ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24301,a[2]=t8,a[3]=((C_word)li651),tmp=(C_word)a,a+=4,tmp));
t12=C_mutate((C_word*)lf[211]+1 /* (set! scheme#map ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24383,a[2]=t8,a[3]=((C_word)li656),tmp=(C_word)a,a+=4,tmp));
t13=C_set_block_item(lf[823] /* ##sys#dynamic-winds */,0,C_SCHEME_END_OF_LIST);
t14=C_mutate((C_word*)lf[212]+1 /* (set! scheme#dynamic-wind ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24485,a[2]=((C_word)li658),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate((C_word*)lf[824]+1 /* (set! ##sys#dynamic-wind ...) */,*((C_word*)lf[212]+1));
t16=C_mutate((C_word*)lf[162]+1 /* (set! scheme#call-with-current-continuation ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24516,a[2]=((C_word)li661),tmp=(C_word)a,a+=3,tmp));
t17=C_mutate((C_word*)lf[163]+1 /* (set! scheme#call/cc ...) */,*((C_word*)lf[162]+1));
t18=C_mutate(&lf[825] /* (set! ##sys#dynamic-unwind ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24556,a[2]=((C_word)li662),tmp=(C_word)a,a+=3,tmp));
t19=C_mutate((C_word*)lf[247]+1 /* (set! chicken.base#port-closed? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24614,a[2]=((C_word)li663),tmp=(C_word)a,a+=3,tmp));
t20=C_mutate((C_word*)lf[314]+1 /* (set! ##sys#make-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24627,a[2]=((C_word)li664),tmp=(C_word)a,a+=3,tmp));
t21=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41630,a[2]=((C_word)li668),tmp=(C_word)a,a+=3,tmp);
t22=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41711,a[2]=((C_word)li671),tmp=(C_word)a,a+=3,tmp);
t23=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41744,a[2]=((C_word)li672),tmp=(C_word)a,a+=3,tmp);
t24=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41772,a[2]=((C_word)li674),tmp=(C_word)a,a+=3,tmp);
t25=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41789,a[2]=((C_word)li675),tmp=(C_word)a,a+=3,tmp);
t26=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41795,a[2]=((C_word)li676),tmp=(C_word)a,a+=3,tmp);
t27=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41798,a[2]=((C_word)li677),tmp=(C_word)a,a+=3,tmp);
t28=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41801,a[2]=((C_word)li680),tmp=(C_word)a,a+=3,tmp);
t29=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41908,a[2]=((C_word)li683),tmp=(C_word)a,a+=3,tmp);
t30=C_a_i_vector(&a,10,t21,t22,t23,t24,t25,t26,t27,t28,t29,C_SCHEME_FALSE);
t31=C_mutate((C_word*)lf[836]+1 /* (set! ##sys#stream-port-class ...) */,t30);
t32=C_mutate((C_word*)lf[837]+1 /* (set! ##sys#open-file-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_open_file_port,a[2]=((C_word)li684),tmp=(C_word)a,a+=3,tmp));
t33=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24673,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4111: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[314]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[314]+1);
av2[1]=t33;
av2[2]=C_fix(1);
av2[3]=C_fast_retrieve(lf[836]);
av2[4]=lf[1616];
av2[5]=lf[856];
tp(6,av2);}}

/* ##sys#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24163(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_24163,c,av);}
a=C_alloc(8);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24169,a[2]=t5,a[3]=t2,a[4]=t3,a[5]=((C_word)li640),tmp=(C_word)a,a+=6,tmp));
t7=((C_word*)t5)[1];
f_24169(t7,t1,t3);}

/* loop in ##sys#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_24169(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_24169,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_i_pairp(t2))){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24185,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3815: p */
t5=((C_word*)t0)[3];{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=C_slot(t2,C_fix(0));
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}
else{
/* library.scm:3817: ##sys#error-not-a-proper-list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[4];
av2[3]=lf[820];
tp(4,av2);}}}}

/* k24183 in loop in ##sys#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24185(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_24185,c,av);}
/* library.scm:3816: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_24169(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* ##sys#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24201(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_24201,c,av);}
a=C_alloc(8);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24207,a[2]=t5,a[3]=t2,a[4]=t3,a[5]=((C_word)li642),tmp=(C_word)a,a+=6,tmp));
t7=((C_word*)t5)[1];
f_24207(t7,t1,t3);}

/* loop in ##sys#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_24207(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_24207,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
if(C_truep(C_i_pairp(t2))){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24227,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3823: p */
t5=((C_word*)t0)[3];{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=C_slot(t2,C_fix(0));
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}
else{
/* library.scm:3824: ##sys#error-not-a-proper-list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[4];
av2[3]=lf[822];
tp(4,av2);}}}}

/* k24225 in loop in ##sys#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24227(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_24227,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24231,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3823: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_24207(t3,t2,C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k24229 in k24225 in loop in ##sys#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24231(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_24231,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* mapsafe4702 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24243(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_24243,c,av);}
a=C_alloc(6);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24249,a[2]=t2,a[3]=t4,a[4]=t3,a[5]=((C_word)li645),tmp=(C_word)a,a+=6,tmp);
/* library.scm:3828: scheme#call-with-current-continuation */
t6=*((C_word*)lf[162]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
av2[2]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}

/* a24248 in mapsafe4702 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24249(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_24249,c,av);}
a=C_alloc(9);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_24255,a[2]=t2,a[3]=t4,a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=((C_word)li644),tmp=(C_word)a,a+=7,tmp));
t6=((C_word*)t4)[1];
f_24255(t6,t1,((C_word*)t0)[4]);}

/* lp in a24248 in mapsafe4702 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_24255(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_24255,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_slot(t2,C_fix(0));
t5=C_eqp(t4,C_SCHEME_END_OF_LIST);
if(C_truep(t5)){
/* library.scm:3834: empty */
t6=((C_word*)t0)[2];{
C_word av2[3];
av2[0]=t6;
av2[1]=t1;
av2[2]=C_SCHEME_END_OF_LIST;
((C_proc)C_fast_retrieve_proc(t6))(3,av2);}}
else{
if(C_truep(C_i_pairp(t4))){
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24287,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3836: p */
t7=((C_word*)t0)[4];{
C_word av2[3];
av2[0]=t7;
av2[1]=t6;
av2[2]=t4;
((C_proc)C_fast_retrieve_proc(t7))(3,av2);}}
else{
/* library.scm:3837: ##sys#error-not-a-proper-list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=((C_word*)t0)[5];
tp(4,av2);}}}}}

/* k24285 in lp in a24248 in mapsafe4702 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24287(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_24287,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24291,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3836: lp */
t3=((C_word*)((C_word*)t0)[3])[1];
f_24255(t3,t2,C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k24289 in k24285 in lp in a24248 in mapsafe4702 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_24291(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_24291,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scheme#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24301(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +11,c,3)))){
C_save_and_reclaim((void*)f_24301,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+11);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
if(C_truep(C_rest_nullp(c,4))){
t5=C_i_check_list_2(t3,lf[820]);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24316,a[2]=t7,a[3]=t2,a[4]=((C_word)li647),tmp=(C_word)a,a+=5,tmp));
t9=((C_word*)t7)[1];
f_24316(t9,t1,t3);}
else{
t5=C_a_i_cons(&a,2,t3,t4);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24346,a[2]=t7,a[3]=((C_word*)t0)[2],a[4]=t2,a[5]=((C_word)li650),tmp=(C_word)a,a+=6,tmp));
t9=((C_word*)t7)[1];
f_24346(t9,t1,t5);}}

/* for-each-loop4722 in scheme#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_24316(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_24316,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24326,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3842: g4723 */
t4=((C_word*)t0)[3];{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=C_slot(t2,C_fix(0));
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k24324 in for-each-loop4722 in scheme#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24326(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_24326,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_24316(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* loop in scheme#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_24346(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,4)))){
C_save_and_reclaim_args((void *)trf_24346,3,t0,t1,t2);}
a=C_alloc(10);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_24353,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=((C_word*)t0)[4],tmp=(C_word)a,a+=7,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24377,a[2]=((C_word)li649),tmp=(C_word)a,a+=3,tmp);
/* library.scm:3845: mapsafe */
t5=((C_word*)((C_word*)t0)[3])[1];{
C_word av2[5];
av2[0]=t5;
av2[1]=t3;
av2[2]=t4;
av2[3]=t2;
av2[4]=lf[820];
((C_proc)C_fast_retrieve_proc(t5))(5,av2);}}

/* k24351 in loop in scheme#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24353(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_24353,c,av);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t1))){
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24362,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=t1;
C_apply(4,av2);}}
else{
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k24360 in k24351 in loop in scheme#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24362(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_24362,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24369,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24371,a[2]=((C_word)li648),tmp=(C_word)a,a+=3,tmp);
/* library.scm:3848: mapsafe */
t4=((C_word*)((C_word*)t0)[4])[1];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t2;
av2[2]=t3;
av2[3]=((C_word*)t0)[5];
av2[4]=lf[820];
((C_proc)C_fast_retrieve_proc(t4))(5,av2);}}

/* k24367 in k24360 in k24351 in loop in scheme#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_24369(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_24369,c,av);}
/* library.scm:3848: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_24346(t2,((C_word*)t0)[3],t1);}

/* a24370 in k24360 in k24351 in loop in scheme#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_24371(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24371,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cdr(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a24376 in loop in scheme#for-each in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24377(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24377,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_car(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24383(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +14,c,3)))){
C_save_and_reclaim((void*)f_24383,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+14);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
if(C_truep(C_rest_nullp(c,4))){
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=C_i_check_list_2(t3,lf[822]);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_24401,a[2]=t7,a[3]=t11,a[4]=t2,a[5]=t8,a[6]=((C_word)li652),tmp=(C_word)a,a+=7,tmp));
t13=((C_word*)t11)[1];
f_24401(t13,t1,t3);}
else{
t5=C_a_i_cons(&a,2,t3,t4);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24442,a[2]=t7,a[3]=((C_word*)t0)[2],a[4]=t2,a[5]=((C_word)li655),tmp=(C_word)a,a+=6,tmp));
t9=((C_word*)t7)[1];
f_24442(t9,t1,t5);}}

/* map-loop4750 in scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_24401(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_24401,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24426,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:3853: g4756 */
t4=((C_word*)t0)[4];{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=C_slot(t2,C_fix(0));
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[5],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k24424 in map-loop4750 in scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24426(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_24426,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_SCHEME_END_OF_LIST);
t3=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t2);
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
t5=((C_word*)((C_word*)t0)[3])[1];
f_24401(t5,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}

/* loop in scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_24442(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,4)))){
C_save_and_reclaim_args((void *)trf_24442,3,t0,t1,t2);}
a=C_alloc(10);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_24449,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=((C_word*)t0)[4],tmp=(C_word)a,a+=7,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24478,a[2]=((C_word)li654),tmp=(C_word)a,a+=3,tmp);
/* library.scm:3856: mapsafe */
t5=((C_word*)((C_word*)t0)[3])[1];{
C_word av2[5];
av2[0]=t5;
av2[1]=t3;
av2[2]=t4;
av2[3]=t2;
av2[4]=lf[822];
((C_proc)C_fast_retrieve_proc(t5))(5,av2);}}

/* k24447 in loop in scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24449(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_24449,c,av);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t1))){
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24462,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=t1;
C_apply(4,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k24460 in k24447 in loop in scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24462(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,4)))){
C_save_and_reclaim((void *)f_24462,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24466,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24470,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24472,a[2]=((C_word)li653),tmp=(C_word)a,a+=3,tmp);
/* library.scm:3859: mapsafe */
t5=((C_word*)((C_word*)t0)[4])[1];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=t4;
av2[3]=((C_word*)t0)[5];
av2[4]=lf[822];
((C_proc)C_fast_retrieve_proc(t5))(5,av2);}}

/* k24464 in k24460 in k24447 in loop in scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_24466(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_24466,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k24468 in k24460 in k24447 in loop in scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_24470(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_24470,c,av);}
/* library.scm:3859: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_24442(t2,((C_word*)t0)[3],t1);}

/* a24471 in k24460 in k24447 in loop in scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_24472(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24472,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cdr(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a24477 in loop in scheme#map in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24478(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24478,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_car(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#dynamic-wind in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24485(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_24485,c,av);}
a=C_alloc(6);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24489,a[2]=t2,a[3]=t4,a[4]=t1,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* library.scm:3879: before */
t6=t2;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)C_fast_retrieve_proc(t6))(2,av2);}}

/* k24487 in scheme#dynamic-wind in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24489(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_24489,c,av);}
a=C_alloc(10);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=C_a_i_cons(&a,2,t2,C_fast_retrieve(lf[823]));
t4=C_mutate((C_word*)lf[823]+1 /* (set! ##sys#dynamic-winds ...) */,t3);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24498,a[2]=((C_word*)t0)[3],a[3]=((C_word)li657),tmp=(C_word)a,a+=4,tmp);
/* library.scm:3881: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[5];
av2[3]=t5;
C_call_with_values(4,av2);}}

/* a24497 in k24487 in scheme#dynamic-wind in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24498(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_24498,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
t3=C_slot(C_fast_retrieve(lf[823]),C_fix(1));
t4=C_mutate((C_word*)lf[823]+1 /* (set! ##sys#dynamic-winds ...) */,t3);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24506,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3885: after */
t6=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)C_fast_retrieve_proc(t6))(2,av2);}}

/* k24504 in a24497 in k24487 in scheme#dynamic-wind in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24506(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_24506,c,av);}{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
C_apply_values(3,av2);}}

/* scheme#call-with-current-continuation in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24516(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_24516,c,av);}
a=C_alloc(5);
t3=C_fast_retrieve(lf[823]);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24522,a[2]=t3,a[3]=t2,a[4]=((C_word)li660),tmp=(C_word)a,a+=5,tmp);
/* library.scm:3893: ##sys#call-with-current-continuation */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
C_call_cc(3,av2);}}

/* a24521 in scheme#call-with-current-continuation in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24522(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_24522,c,av);}
a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24525,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word)li659),tmp=(C_word)a,a+=5,tmp);
/* library.scm:3899: proc */
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}

/* continuation in a24521 in scheme#call-with-current-continuation in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24525(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +5,c,3)))){
C_save_and_reclaim((void*)f_24525,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+5);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24529,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t4=C_eqp(C_fast_retrieve(lf[823]),((C_word*)t0)[3]);
if(C_truep(t4)){{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=t2;
C_apply(4,av2);}}
else{
t5=C_i_length(C_fast_retrieve(lf[823]));
t6=C_i_length(((C_word*)t0)[3]);
/* library.scm:3897: ##sys#dynamic-unwind */
f_24556(t3,((C_word*)t0)[3],C_fixnum_difference(t5,t6));}}

/* k24527 in continuation in a24521 in scheme#call-with-current-continuation in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24529(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_24529,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
C_apply(4,av2);}}

/* ##sys#dynamic-unwind in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_24556(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_24556,3,t1,t2,t3);}
a=C_alloc(5);
t4=C_eqp(C_fast_retrieve(lf[823]),t2);
if(C_truep(t4)){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
if(C_truep(C_fixnum_lessp(t3,C_fix(0)))){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24572,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3906: ##sys#dynamic-unwind */
t11=t5;
t12=C_slot(t2,C_fix(1));
t13=C_fixnum_plus(t3,C_fix(1));
t1=t11;
t2=t12;
t3=t13;
goto loop;}
else{
t5=C_slot(C_fast_retrieve(lf[823]),C_fix(0));
t6=C_slot(t5,C_fix(1));
t7=C_slot(C_fast_retrieve(lf[823]),C_fix(1));
t8=C_mutate((C_word*)lf[823]+1 /* (set! ##sys#dynamic-winds ...) */,t7);
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24601,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:3912: after */
t10=t6;{
C_word av2[2];
av2[0]=t10;
av2[1]=t9;
((C_proc)C_fast_retrieve_proc(t10))(2,av2);}}}}

/* k24570 in ##sys#dynamic-unwind in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24572(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_24572,c,av);}
a=C_alloc(4);
t2=C_slot(((C_word*)t0)[2],C_fix(0));
t3=C_slot(t2,C_fix(0));
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24578,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:3904: g4810 */
t5=t3;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)C_fast_retrieve_proc(t5))(2,av2);}}

/* k24576 in k24570 in ##sys#dynamic-unwind in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24578(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24578,c,av);}
t2=C_mutate((C_word*)lf[823]+1 /* (set! ##sys#dynamic-winds ...) */,((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k24599 in ##sys#dynamic-unwind in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24601(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_24601,c,av);}
/* library.scm:3913: ##sys#dynamic-unwind */
f_24556(((C_word*)t0)[2],((C_word*)t0)[3],C_fixnum_difference(((C_word*)t0)[4],C_fix(1)));}

/* chicken.base#port-closed? in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24614(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_24614,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24618,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:3920: ##sys#check-port */
t4=*((C_word*)lf[333]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
av2[3]=lf[826];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k24616 in chicken.base#port-closed? in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24618(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24618,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_eqp(C_slot(((C_word*)t0)[3],C_fix(8)),C_fix(0));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#make-port in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24627(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(17,c,1)))){
C_save_and_reclaim((void *)f_24627,c,av);}
a=C_alloc(17);
t6=C_a_i_port(&a,0);
t7=C_i_set_i_slot(t6,C_fix(1),t2);
t8=C_i_setslot(t6,C_fix(2),t3);
t9=C_i_setslot(t6,C_fix(3),t4);
t10=C_i_set_i_slot(t6,C_fix(4),C_fix(1));
t11=C_i_set_i_slot(t6,C_fix(5),C_fix(0));
t12=C_i_set_i_slot(t6,C_fix(6),C_SCHEME_FALSE);
t13=C_i_setslot(t6,C_fix(7),t5);
t14=C_i_setslot(t6,C_fix(8),t2);
t15=C_i_set_i_slot(t6,C_fix(10),C_SCHEME_FALSE);
t16=C_i_set_i_slot(t6,C_fix(13),C_SCHEME_TRUE);
t17=C_i_set_i_slot(t6,C_fix(14),lf[170]);
t18=C_i_setslot(t6,C_fix(15),lf[457]);
t19=t1;{
C_word *av2=av;
av2[0]=t19;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t19+1)))(2,av2);}}

/* k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24673(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_24673,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[838]+1 /* (set! ##sys#standard-input ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24677,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4112: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[314]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[314]+1);
av2[1]=t3;
av2[2]=C_fix(2);
av2[3]=C_fast_retrieve(lf[836]);
av2[4]=lf[1615];
av2[5]=lf[856];
tp(6,av2);}}

/* k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24677(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_24677,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[839]+1 /* (set! ##sys#standard-output ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24681,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4113: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[314]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[314]+1);
av2[1]=t3;
av2[2]=C_fix(2);
av2[3]=C_fast_retrieve(lf[836]);
av2[4]=lf[1614];
av2[5]=lf[856];
tp(6,av2);}}

/* k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24681(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_24681,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[840]+1 /* (set! ##sys#standard-error ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24684,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4115: ##sys#open-file-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[837]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[837]+1);
av2[1]=t3;
av2[2]=*((C_word*)lf[838]+1);
av2[3]=C_fix(0);
av2[4]=C_SCHEME_FALSE;
tp(5,av2);}}

/* k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_24684(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_24684,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24687,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4116: ##sys#open-file-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[837]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[837]+1);
av2[1]=t2;
av2[2]=*((C_word*)lf[839]+1);
av2[3]=C_fix(1);
av2[4]=C_SCHEME_FALSE;
tp(5,av2);}}

/* k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_24687(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_24687,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24690,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4117: ##sys#open-file-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[837]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[837]+1);
av2[1]=t2;
av2[2]=*((C_word*)lf[840]+1);
av2[3]=C_fix(2);
av2[4]=C_SCHEME_FALSE;
tp(5,av2);}}

/* k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in ... */
static void C_ccall f_24690(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(119,c,6)))){
C_save_and_reclaim((void *)f_24690,c,av);}
a=C_alloc(119);
t2=C_mutate((C_word*)lf[841]+1 /* (set! ##sys#check-input-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24692,a[2]=((C_word)li685),tmp=(C_word)a,a+=3,tmp));
t3=C_mutate((C_word*)lf[842]+1 /* (set! ##sys#check-output-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24703,a[2]=((C_word)li686),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[333]+1 /* (set! ##sys#check-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24714,a[2]=((C_word)li687),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[843]+1 /* (set! ##sys#check-open-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24725,a[2]=((C_word)li688),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[175]+1 /* (set! scheme#current-input-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24736,a[2]=((C_word)li690),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[176]+1 /* (set! scheme#current-output-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24797,a[2]=((C_word)li692),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[233]+1 /* (set! chicken.base#current-error-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24858,a[2]=((C_word)li694),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate((C_word*)lf[847]+1 /* (set! ##sys#tty-port? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24919,a[2]=((C_word)li695),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate((C_word*)lf[849]+1 /* (set! ##sys#port-data ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24933,a[2]=((C_word)li696),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[850]+1 /* (set! ##sys#set-port-data! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24939,a[2]=((C_word)li697),tmp=(C_word)a,a+=3,tmp));
t12=C_set_block_item(lf[851] /* ##sys#default-file-encoding */,0,C_SCHEME_UNDEFINED);
t13=C_SCHEME_UNDEFINED;
t14=(*a=C_VECTOR_TYPE|1,a[1]=t13,tmp=(C_word)a,a+=2,tmp);
t15=C_SCHEME_UNDEFINED;
t16=(*a=C_VECTOR_TYPE|1,a[1]=t15,tmp=(C_word)a,a+=2,tmp);
t17=C_set_block_item(t14,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24946,a[2]=((C_word)li699),tmp=(C_word)a,a+=3,tmp));
t18=C_set_block_item(t16,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25176,a[2]=((C_word)li700),tmp=(C_word)a,a+=3,tmp));
t19=C_mutate((C_word*)lf[177]+1 /* (set! scheme#open-input-file ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25213,a[2]=t14,a[3]=((C_word)li701),tmp=(C_word)a,a+=4,tmp));
t20=C_mutate((C_word*)lf[178]+1 /* (set! scheme#open-output-file ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25219,a[2]=t14,a[3]=((C_word)li702),tmp=(C_word)a,a+=4,tmp));
t21=C_mutate((C_word*)lf[179]+1 /* (set! scheme#close-input-port ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25225,a[2]=t16,a[3]=((C_word)li703),tmp=(C_word)a,a+=4,tmp));
t22=C_mutate((C_word*)lf[180]+1 /* (set! scheme#close-output-port ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25231,a[2]=t16,a[3]=((C_word)li704),tmp=(C_word)a,a+=4,tmp));
t23=*((C_word*)lf[177]+1);
t24=C_mutate((C_word*)lf[181]+1 /* (set! scheme#call-with-input-file ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25237,a[2]=t23,a[3]=((C_word)li707),tmp=(C_word)a,a+=4,tmp));
t25=*((C_word*)lf[178]+1);
t26=C_mutate((C_word*)lf[182]+1 /* (set! scheme#call-with-output-file ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25261,a[2]=t25,a[3]=((C_word)li710),tmp=(C_word)a,a+=4,tmp));
t27=*((C_word*)lf[177]+1);
t28=C_mutate((C_word*)lf[183]+1 /* (set! scheme#with-input-from-file ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25285,a[2]=t27,a[3]=((C_word)li715),tmp=(C_word)a,a+=4,tmp));
t29=*((C_word*)lf[178]+1);
t30=C_mutate((C_word*)lf[184]+1 /* (set! scheme#with-output-to-file ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25319,a[2]=t29,a[3]=((C_word)li720),tmp=(C_word)a,a+=4,tmp));
t31=C_mutate((C_word*)lf[882]+1 /* (set! ##sys#file-exists? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25353,a[2]=((C_word)li721),tmp=(C_word)a,a+=3,tmp));
t32=C_mutate((C_word*)lf[885]+1 /* (set! ##sys#flush-output ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25379,a[2]=((C_word)li722),tmp=(C_word)a,a+=3,tmp));
t33=C_mutate((C_word*)lf[248]+1 /* (set! chicken.base#flush-output ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25392,a[2]=((C_word)li723),tmp=(C_word)a,a+=3,tmp));
t34=C_mutate((C_word*)lf[887]+1 /* (set! ##sys#port-line ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25410,a[2]=((C_word)li724),tmp=(C_word)a,a+=3,tmp));
t35=C_mutate((C_word*)lf[888]+1 /* (set! ##sys#decorate-lambda ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25419,a[2]=((C_word)li727),tmp=(C_word)a,a+=3,tmp));
t36=C_mutate((C_word*)lf[889]+1 /* (set! ##sys#lambda-decoration ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25494,a[2]=((C_word)li729),tmp=(C_word)a,a+=3,tmp));
t37=C_mutate((C_word*)lf[890]+1 /* (set! ##sys#make-lambda-info ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25533,a[2]=((C_word)li730),tmp=(C_word)a,a+=3,tmp));
t38=C_mutate((C_word*)lf[891]+1 /* (set! ##sys#lambda-info? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25549,a[2]=((C_word)li731),tmp=(C_word)a,a+=3,tmp));
t39=C_mutate((C_word*)lf[892]+1 /* (set! ##sys#lambda-info ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25562,a[2]=((C_word)li732),tmp=(C_word)a,a+=3,tmp));
t40=C_mutate((C_word*)lf[893]+1 /* (set! ##sys#lambda-info->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25568,a[2]=((C_word)li733),tmp=(C_word)a,a+=3,tmp));
t41=C_mutate((C_word*)lf[241]+1 /* (set! chicken.base#procedure-information ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25582,a[2]=((C_word)li734),tmp=(C_word)a,a+=3,tmp));
t42=C_a_i_vector1(&a,1,lf[896]);
t43=C_mutate(&lf[897] /* (set! setter-tag ...) */,t42);
t44=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25611,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t45=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41506,a[2]=((C_word)li1250),tmp=(C_word)a,a+=3,tmp);
t46=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41546,a[2]=((C_word)li1251),tmp=(C_word)a,a+=3,tmp);
t47=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41562,a[2]=((C_word)li1255),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4363: ##sys#decorate-lambda */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[888]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[888]+1);
av2[1]=t44;
av2[2]=t45;
av2[3]=t46;
av2[4]=t47;
tp(5,av2);}}

/* ##sys#check-input-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24692(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_24692,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+0);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=C_i_pairp(t4);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=(C_truep(t5)?C_i_check_port_2(t2,C_fix(1),t3,C_get_rest_arg(c,4,av,4,t0)):C_i_check_port(t2,C_fix(1),t3));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* ##sys#check-output-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24703(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_24703,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+0);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=C_i_pairp(t4);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=(C_truep(t5)?C_i_check_port_2(t2,C_fix(2),t3,C_get_rest_arg(c,4,av,4,t0)):C_i_check_port(t2,C_fix(2),t3));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* ##sys#check-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24714(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_24714,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_port_2(t2,C_fix(0),C_SCHEME_FALSE,C_get_rest_arg(c,3,av,3,t0)):C_i_check_port(t2,C_fix(0),C_SCHEME_FALSE));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#check-open-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24725(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,1)))){
C_save_and_reclaim((void*)f_24725,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=C_i_pairp(t3);
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_i_check_port_2(t2,C_fix(0),C_SCHEME_TRUE,C_get_rest_arg(c,3,av,3,t0)):C_i_check_port(t2,C_fix(0),C_SCHEME_TRUE));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* scheme#current-input-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24736(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +5,c,3)))){
C_save_and_reclaim((void*)f_24736,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+5);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
if(C_truep(C_i_nullp(t2))){
t3=*((C_word*)lf[838]+1);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=*((C_word*)lf[838]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_i_car(t2);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24749,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4144: ##sys#check-port */
t5=*((C_word*)lf[333]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=t3;
av2[3]=lf[844];
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}}

/* k24747 in scheme#current-input-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_24749(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_24749,c,av);}
a=C_alloc(10);
t2=C_u_i_cdr(((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24751,a[2]=((C_word*)t0)[3],a[3]=((C_word)li689),tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24757,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24762,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_nullp(t2))){
t6=(
/* library.scm:4145: def-convert?4966 */
  f_24762(t5)
);
t7=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t7;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t6=C_i_car(t2);
t7=C_u_i_cdr(t2);
if(C_truep(C_i_nullp(t7))){
t8=(
/* library.scm:4145: def-set?4967 */
  f_24757(t4)
);
t9=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t9;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}
else{
t8=C_i_car(t7);
t9=C_u_i_cdr(t7);
t10=(
/* library.scm:4145: body4964 */
  f_24751(t3,t8)
);
t11=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t11;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t11+1)))(2,av2);}}}}

/* body4964 in k24747 in scheme#current-input-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static C_word f_24751(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_stack_overflow_check;{}
if(C_truep(t1)){
t2=C_mutate((C_word*)lf[838]+1 /* (set! ##sys#standard-input ...) */,((C_word*)t0)[2]);
return(t2);}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* def-set?4967 in k24747 in scheme#current-input-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static C_word f_24757(C_word t0){
C_word tmp;
C_word t1;
C_stack_overflow_check;{}
return((
/* library.scm:4145: body4964 */
  f_24751(((C_word*)t0)[2],C_SCHEME_TRUE)
));}

/* def-convert?4966 in k24747 in scheme#current-input-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static C_word f_24762(C_word t0){
C_word tmp;
C_word t1;
C_stack_overflow_check;{}
return((
/* library.scm:4145: def-set?4967 */
  f_24757(((C_word*)t0)[2])
));}

/* scheme#current-output-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24797(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +5,c,3)))){
C_save_and_reclaim((void*)f_24797,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+5);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
if(C_truep(C_i_nullp(t2))){
t3=*((C_word*)lf[839]+1);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=*((C_word*)lf[839]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_i_car(t2);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24810,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4154: ##sys#check-port */
t5=*((C_word*)lf[333]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=t3;
av2[3]=lf[845];
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}}

/* k24808 in scheme#current-output-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_24810(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_24810,c,av);}
a=C_alloc(10);
t2=C_u_i_cdr(((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24812,a[2]=((C_word*)t0)[3],a[3]=((C_word)li691),tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24818,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24823,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_nullp(t2))){
t6=(
/* library.scm:4155: def-convert?4991 */
  f_24823(t5)
);
t7=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t7;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t6=C_i_car(t2);
t7=C_u_i_cdr(t2);
if(C_truep(C_i_nullp(t7))){
t8=(
/* library.scm:4155: def-set?4992 */
  f_24818(t4)
);
t9=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t9;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}
else{
t8=C_i_car(t7);
t9=C_u_i_cdr(t7);
t10=(
/* library.scm:4155: body4989 */
  f_24812(t3,t8)
);
t11=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t11;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t11+1)))(2,av2);}}}}

/* body4989 in k24808 in scheme#current-output-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static C_word f_24812(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_stack_overflow_check;{}
if(C_truep(t1)){
t2=C_mutate((C_word*)lf[839]+1 /* (set! ##sys#standard-output ...) */,((C_word*)t0)[2]);
return(t2);}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* def-set?4992 in k24808 in scheme#current-output-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static C_word f_24818(C_word t0){
C_word tmp;
C_word t1;
C_stack_overflow_check;{}
return((
/* library.scm:4155: body4989 */
  f_24812(((C_word*)t0)[2],C_SCHEME_TRUE)
));}

/* def-convert?4991 in k24808 in scheme#current-output-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static C_word f_24823(C_word t0){
C_word tmp;
C_word t1;
C_stack_overflow_check;{}
return((
/* library.scm:4155: def-set?4992 */
  f_24818(((C_word*)t0)[2])
));}

/* chicken.base#current-error-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24858(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +5,c,3)))){
C_save_and_reclaim((void*)f_24858,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+5);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
if(C_truep(C_i_nullp(t2))){
t3=*((C_word*)lf[840]+1);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_i_car(t2);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24871,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4164: ##sys#check-port */
t5=*((C_word*)lf[333]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=t3;
av2[3]=lf[846];
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}}

/* k24869 in chicken.base#current-error-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_24871(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_24871,c,av);}
a=C_alloc(10);
t2=C_u_i_cdr(((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24873,a[2]=((C_word*)t0)[3],a[3]=((C_word)li693),tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24879,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24884,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_nullp(t2))){
t6=(
/* library.scm:4165: def-convert?5016 */
  f_24884(t5)
);
t7=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t7;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t6=C_i_car(t2);
t7=C_u_i_cdr(t2);
if(C_truep(C_i_nullp(t7))){
t8=(
/* library.scm:4165: def-set?5017 */
  f_24879(t4)
);
t9=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t9;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}
else{
t8=C_i_car(t7);
t9=C_u_i_cdr(t7);
t10=(
/* library.scm:4165: body5014 */
  f_24873(t3,t8)
);
t11=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t11;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t11+1)))(2,av2);}}}}

/* body5014 in k24869 in chicken.base#current-error-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static C_word f_24873(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_stack_overflow_check;{}
if(C_truep(t1)){
t2=C_mutate((C_word*)lf[840]+1 /* (set! ##sys#standard-error ...) */,((C_word*)t0)[2]);
return(t2);}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* def-set?5017 in k24869 in chicken.base#current-error-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static C_word f_24879(C_word t0){
C_word tmp;
C_word t1;
C_stack_overflow_check;{}
return((
/* library.scm:4165: body5014 */
  f_24873(((C_word*)t0)[2],C_SCHEME_TRUE)
));}

/* def-convert?5016 in k24869 in chicken.base#current-error-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static C_word f_24884(C_word t0){
C_word tmp;
C_word t1;
C_stack_overflow_check;{}
return((
/* library.scm:4165: def-set?5017 */
  f_24879(((C_word*)t0)[2])
));}

/* ##sys#tty-port? in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24919(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_24919,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24931,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4170: ##sys#peek-unsigned-integer */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[848]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[848]+1);
av2[1]=t3;
av2[2]=t2;
av2[3]=C_fix(0);
tp(4,av2);}}

/* k24929 in ##sys#tty-port? in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_24931(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24931,c,av);}
t2=C_i_not(C_i_zerop(t1));
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(t2)?C_tty_portp(((C_word*)t0)[3]):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#port-data in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24933(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24933,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_slot(t2,C_fix(9));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#set-port-data! in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_24939(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24939,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_setslot(t2,C_fix(9),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void f_24946(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,0,2)))){
C_save_and_reclaim_args((void *)trf_24946,5,t1,t2,t3,t4,t5);}
a=C_alloc(13);
t6=C_i_check_string_2(t2,t5);
t7=(C_truep(t3)?lf[852]:lf[853]);
t8=t7;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=lf[854];
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_24956,a[2]=t1,a[3]=t5,a[4]=t2,a[5]=t9,a[6]=t11,a[7]=t3,a[8]=t4,tmp=(C_word)a,a+=9,tmp);
/* library.scm:4183: ##sys#default-file-encoding */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[851]);
C_word av2[2];
av2[0]=*((C_word*)lf[851]+1);
av2[1]=t12;
tp(2,av2);}}

/* k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_24956(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(22,c,3)))){
C_save_and_reclaim((void *)f_24956,c,av);}
a=C_alloc(22);
t2=t1;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_24959,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_24996,a[2]=t6,a[3]=((C_word*)t0)[6],a[4]=t3,a[5]=((C_word*)t0)[7],a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[5],a[8]=((C_word)li698),tmp=(C_word)a,a+=9,tmp));
t8=((C_word*)t6)[1];
f_24996(t8,t4,((C_word*)t0)[8]);}

/* k24957 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_24959(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,5)))){
C_save_and_reclaim((void *)f_24959,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_24962,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)t0)[8])){
/* library.scm:4205: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[314]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[314]+1);
av2[1]=t2;
av2[2]=C_fix(1);
av2[3]=C_fast_retrieve(lf[836]);
av2[4]=((C_word*)t0)[5];
av2[5]=lf[856];
tp(6,av2);}}
else{
/* library.scm:4205: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[314]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[314]+1);
av2[1]=t2;
av2[2]=C_fix(2);
av2[3]=C_fast_retrieve(lf[836]);
av2[4]=((C_word*)t0)[5];
av2[5]=lf[856];
tp(6,av2);}}}

/* k24960 in k24957 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_24962(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(16,c,3)))){
C_save_and_reclaim((void *)f_24962,c,av);}
a=C_alloc(16);
t2=C_i_setslot(t1,C_fix(15),((C_word*)((C_word*)t0)[2])[1]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_24968,a[2]=((C_word*)t0)[3],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_24971,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t3,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24990,a[2]=t4,a[3]=t1,a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4207: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=t5;
av2[2]=((C_word*)((C_word*)t0)[6])[1];
av2[3]=((C_word*)((C_word*)t0)[7])[1];
tp(4,av2);}}

/* k24966 in k24960 in k24957 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in ... */
static void C_ccall f_24968(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_24968,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k24969 in k24960 in k24957 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in ... */
static void C_ccall f_24971(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_24971,c,av);}
a=C_alloc(5);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_24978,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4208: ##sys#update-errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[830]);
C_word *av2=av;
av2[0]=*((C_word*)lf[830]+1);
av2[1]=t2;
tp(2,av2);}}}

/* k24976 in k24969 in k24960 in k24957 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in ... */
static void C_ccall f_24978(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_24978,c,av);}
a=C_alloc(12);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_24982,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_24986,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t4=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=C_mpointer(&a,(void*)strerror(errno));
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k24980 in k24976 in k24969 in k24960 in k24957 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in ... */
static void C_ccall f_24982(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_24982,c,av);}
/* library.scm:4208: ##sys#signal-hook/errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[379]);
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[379]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[467];
av2[3]=((C_word*)t0)[3];
av2[4]=((C_word*)t0)[4];
av2[5]=t1;
av2[6]=((C_word*)t0)[5];
tp(7,av2);}}

/* k24984 in k24976 in k24969 in k24960 in k24957 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in ... */
static void C_ccall f_24986(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_24986,c,av);}
/* library.scm:4209: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[855];
av2[3]=t1;
tp(4,av2);}}

/* k24988 in k24960 in k24957 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in ... */
static void C_ccall f_24990(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_24990,c,av);}
/* library.scm:4207: ##sys#open-file-port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[837]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[837]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
av2[4]=t1;
tp(5,av2);}}

/* doloop5053 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void f_24996(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(17,0,2)))){
C_save_and_reclaim_args((void *)trf_24996,3,t0,t1,t2);}
a=C_alloc(17);
if(C_truep(C_i_nullp(t2))){
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_slot(t2,C_fix(0));
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25009,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t5=C_eqp(t3,lf[857]);
t6=(C_truep(t5)?t5:C_eqp(t3,lf[167]));
if(C_truep(t6)){
t7=C_mutate(((C_word *)((C_word*)t0)[3])+1,lf[858]);
t8=C_mutate(((C_word *)((C_word*)t0)[4])+1,lf[167]);
t16=t1;
t17=C_slot(t2,C_fix(1));
t1=t16;
t2=t17;
goto loop;}
else{
t7=C_eqp(t3,lf[859]);
t8=(C_truep(t7)?t7:C_eqp(t3,lf[860]));
if(C_truep(t8)){
t9=C_mutate(((C_word *)((C_word*)t0)[3])+1,lf[861]);
t16=t1;
t17=C_slot(t2,C_fix(1));
t1=t16;
t2=t17;
goto loop;}
else{
t9=C_eqp(t3,lf[862]);
t10=(C_truep(t9)?t9:C_eqp(t3,lf[457]));
if(C_truep(t10)){
t11=C_mutate(((C_word *)((C_word*)t0)[4])+1,lf[457]);
t16=t1;
t17=C_slot(t2,C_fix(1));
t1=t16;
t2=t17;
goto loop;}
else{
t11=C_eqp(t3,lf[863]);
t12=(*a=C_CLOSURE_TYPE|11,a[1]=(C_word)f_25053,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=t2,a[6]=t3,a[7]=((C_word*)t0)[3],a[8]=((C_word*)t0)[5],a[9]=t4,a[10]=((C_word*)t0)[6],a[11]=((C_word*)t0)[7],tmp=(C_word)a,a+=12,tmp);
if(C_truep(t11)){
t13=t12;
f_25053(t13,t11);}
else{
t13=C_eqp(t3,lf[458]);
if(C_truep(t13)){
t14=t12;
f_25053(t14,t13);}
else{
t14=C_eqp(t3,lf[876]);
t15=t12;
f_25053(t15,(C_truep(t14)?t14:C_eqp(t3,lf[877])));}}}}}}}

/* k25007 in doloop5053 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_25009(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25009,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_24996(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k25051 in doloop5053 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void f_25053(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,2)))){
C_save_and_reclaim_args((void *)trf_25053,2,t0,t1);}
a=C_alloc(11);
if(C_truep(t1)){
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,lf[458]);
t3=((C_word*)((C_word*)t0)[3])[1];
f_24996(t3,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}
else{
t2=C_eqp(((C_word*)t0)[6],lf[864]);
t3=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_25063,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],a[9]=((C_word*)t0)[10],a[10]=((C_word*)t0)[11],tmp=(C_word)a,a+=11,tmp);
if(C_truep(t2)){
t4=t3;
f_25063(t4,t2);}
else{
t4=C_eqp(((C_word*)t0)[6],lf[873]);
if(C_truep(t4)){
t5=t3;
f_25063(t5,t4);}
else{
t5=C_eqp(((C_word*)t0)[6],lf[874]);
t6=t3;
f_25063(t6,(C_truep(t5)?t5:C_eqp(((C_word*)t0)[6],lf[875])));}}}}

/* k25061 in k25051 in doloop5053 in k24954 in open in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in ... */
static void f_25063(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,4)))){
C_save_and_reclaim_args((void *)trf_25063,2,t0,t1);}
if(C_truep(t1)){
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,lf[865]);
t3=((C_word*)((C_word*)t0)[3])[1];
f_24996(t3,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}
else{
t2=C_eqp(((C_word*)t0)[6],lf[866]);
t3=(C_truep(t2)?t2:C_eqp(((C_word*)t0)[6],lf[867]));
if(C_truep(t3)){
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,lf[868]);
t5=((C_word*)((C_word*)t0)[3])[1];
f_24996(t5,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}
else{
t4=C_eqp(((C_word*)t0)[6],lf[869]);
t5=(C_truep(t4)?t4:C_eqp(((C_word*)t0)[6],lf[444]));
if(C_truep(t5)){
if(C_truep(((C_word*)t0)[7])){
/* library.scm:4202: ##sys#error */
t6=*((C_word*)lf[195]+1);{
C_word av2[4];
av2[0]=t6;
av2[1]=((C_word*)t0)[8];
av2[2]=((C_word*)t0)[9];
av2[3]=lf[870];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t6=C_mutate(((C_word *)((C_word*)t0)[10])+1,lf[871]);
t7=((C_word*)((C_word*)t0)[3])[1];
f_24996(t7,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}}
else{
/* library.scm:4204: ##sys#error */
t6=*((C_word*)lf[195]+1);{
C_word av2[5];
av2[0]=t6;
av2[1]=((C_word*)t0)[8];
av2[2]=((C_word*)t0)[9];
av2[3]=lf[872];
av2[4]=((C_word*)t0)[6];
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}}}}

/* close in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void f_25176(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_25176,4,t1,t2,t3,t4);}
a=C_alloc(5);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25180,a[2]=t3,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4214: ##sys#check-port */
t6=*((C_word*)lf[333]+1);{
C_word av2[4];
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k25178 in close in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25180(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_25180,c,av);}
t2=(C_truep(((C_word*)t0)[2])?C_fix(1):C_fix(2));
if(C_truep(C_port_openp(((C_word*)t0)[3],t2))){
t3=C_slot(((C_word*)t0)[3],C_fix(8));
t4=C_fixnum_not(t2);
t5=C_fixnum_and(t3,t4);
t6=C_i_set_i_slot(((C_word*)t0)[3],C_fix(8),t5);
t7=C_slot(((C_word*)t0)[3],C_fix(2));
/* library.scm:4217: g5108 */
t8=C_slot(t7,C_fix(4));{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t8;
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[3];
av2[3]=t2;
((C_proc)C_fast_retrieve_proc(t8))(4,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* scheme#open-input-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25213(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,5)))){
C_save_and_reclaim((void*)f_25213,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
/* library.scm:4221: open */
f_24946(t1,t2,C_SCHEME_TRUE,t3,lf[878]);}

/* scheme#open-output-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25219(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +0,c,5)))){
C_save_and_reclaim((void*)f_25219,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+0);
t3=C_build_rest(&a,c,3,av);
C_word t4;
/* library.scm:4222: open */
f_24946(t1,t2,C_SCHEME_FALSE,t3,lf[879]);}

/* scheme#close-input-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25225(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_25225,c,av);}
/* library.scm:4223: close */
f_25176(t1,t2,C_SCHEME_TRUE,lf[880]);}

/* scheme#close-output-port in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25231(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_25231,c,av);}
/* library.scm:4224: close */
f_25176(t1,t2,C_SCHEME_FALSE,lf[881]);}

/* scheme#call-with-input-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25237(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +4,c,4)))){
C_save_and_reclaim((void*)f_25237,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+4);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25241,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
av2[3]=t2;
av2[4]=t4;
C_apply(5,av2);}}

/* k25239 in scheme#call-with-input-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25241(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_25241,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25246,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word)li705),tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25252,a[2]=t1,a[3]=((C_word)li706),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4231: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
av2[3]=t3;
C_call_with_values(4,av2);}}

/* a25245 in k25239 in scheme#call-with-input-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25246(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25246,c,av);}
/* library.scm:4232: p */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* a25251 in k25239 in scheme#call-with-input-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25252(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_25252,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25256,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4234: close-input-port */
t4=*((C_word*)lf[179]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k25254 in a25251 in k25239 in scheme#call-with-input-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_25256(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25256,c,av);}{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
C_apply_values(3,av2);}}

/* scheme#call-with-output-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25261(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +4,c,4)))){
C_save_and_reclaim((void*)f_25261,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+4);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25265,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
av2[3]=t2;
av2[4]=t4;
C_apply(5,av2);}}

/* k25263 in scheme#call-with-output-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25265(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_25265,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25270,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word)li708),tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25276,a[2]=t1,a[3]=((C_word)li709),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4242: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
av2[3]=t3;
C_call_with_values(4,av2);}}

/* a25269 in k25263 in scheme#call-with-output-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25270(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25270,c,av);}
/* library.scm:4243: p */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* a25275 in k25263 in scheme#call-with-output-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25276(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_25276,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25280,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4245: close-output-port */
t4=*((C_word*)lf[180]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k25278 in a25275 in k25263 in scheme#call-with-output-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_25280(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25280,c,av);}{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
C_apply_values(3,av2);}}

/* scheme#with-input-from-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25285(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +4,c,4)))){
C_save_and_reclaim((void*)f_25285,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+4);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25289,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
av2[3]=t2;
av2[4]=t4;
C_apply(5,av2);}}

/* k25287 in scheme#with-input-from-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25289(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(19,c,4)))){
C_save_and_reclaim((void *)f_25289,c,av);}
a=C_alloc(19);
t2=t1;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_FALSE;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25294,a[2]=t5,a[3]=t3,a[4]=((C_word)li711),tmp=(C_word)a,a+=5,tmp);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25299,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word)li713),tmp=(C_word)a,a+=5,tmp);
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25314,a[2]=t3,a[3]=t5,a[4]=((C_word)li714),tmp=(C_word)a,a+=5,tmp);
/* library.scm:4253: ##sys#dynamic-wind */
t9=*((C_word*)lf[824]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t9;
av2[1]=((C_word*)t0)[3];
av2[2]=t6;
av2[3]=t7;
av2[4]=t8;
((C_proc)(void*)(*((C_word*)t9+1)))(5,av2);}}

/* a25293 in k25287 in scheme#with-input-from-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25294(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25294,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,*((C_word*)lf[838]+1));
t3=C_mutate((C_word*)lf[838]+1 /* (set! ##sys#standard-input ...) */,((C_word*)((C_word*)t0)[3])[1]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a25298 in k25287 in scheme#with-input-from-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25299(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_25299,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25305,a[2]=((C_word*)t0)[2],a[3]=((C_word)li712),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4254: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=t2;
C_call_with_values(4,av2);}}

/* a25304 in a25298 in k25287 in scheme#with-input-from-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_25305(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_25305,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25309,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4256: close-input-port */
t4=*((C_word*)lf[179]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k25307 in a25304 in a25298 in k25287 in scheme#with-input-from-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in ... */
static void C_ccall f_25309(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25309,c,av);}{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
C_apply_values(3,av2);}}

/* a25313 in k25287 in scheme#with-input-from-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25314(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25314,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,*((C_word*)lf[838]+1));
t3=C_mutate((C_word*)lf[838]+1 /* (set! ##sys#standard-input ...) */,((C_word*)((C_word*)t0)[3])[1]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* scheme#with-output-to-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25319(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +4,c,4)))){
C_save_and_reclaim((void*)f_25319,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+4);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25323,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
av2[3]=t2;
av2[4]=t4;
C_apply(5,av2);}}

/* k25321 in scheme#with-output-to-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25323(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(19,c,4)))){
C_save_and_reclaim((void *)f_25323,c,av);}
a=C_alloc(19);
t2=t1;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_FALSE;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25328,a[2]=t5,a[3]=t3,a[4]=((C_word)li716),tmp=(C_word)a,a+=5,tmp);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25333,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word)li718),tmp=(C_word)a,a+=5,tmp);
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25348,a[2]=t3,a[3]=t5,a[4]=((C_word)li719),tmp=(C_word)a,a+=5,tmp);
/* library.scm:4264: ##sys#dynamic-wind */
t9=*((C_word*)lf[824]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t9;
av2[1]=((C_word*)t0)[3];
av2[2]=t6;
av2[3]=t7;
av2[4]=t8;
((C_proc)(void*)(*((C_word*)t9+1)))(5,av2);}}

/* a25327 in k25321 in scheme#with-output-to-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25328(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25328,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,*((C_word*)lf[839]+1));
t3=C_mutate((C_word*)lf[839]+1 /* (set! ##sys#standard-output ...) */,((C_word*)((C_word*)t0)[3])[1]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a25332 in k25321 in scheme#with-output-to-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25333(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_25333,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25339,a[2]=((C_word*)t0)[2],a[3]=((C_word)li717),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4265: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=t2;
C_call_with_values(4,av2);}}

/* a25338 in a25332 in k25321 in scheme#with-output-to-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_25339(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_25339,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25343,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4267: close-output-port */
t4=*((C_word*)lf[180]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k25341 in a25338 in a25332 in k25321 in scheme#with-output-to-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in ... */
static void C_ccall f_25343(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25343,c,av);}{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
C_apply_values(3,av2);}}

/* a25347 in k25321 in scheme#with-output-to-file in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25348(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25348,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,*((C_word*)lf[839]+1));
t3=C_mutate((C_word*)lf[839]+1 /* (set! ##sys#standard-output ...) */,((C_word*)((C_word*)t0)[3])[1]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#file-exists? in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25353(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_25353,c,av);}
a=C_alloc(7);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_25358,a[2]=t3,a[3]=t4,a[4]=t1,a[5]=t5,a[6]=t2,tmp=(C_word)a,a+=7,tmp);
/* library.scm:4271: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[884]);
C_word *av2=av;
av2[0]=*((C_word*)lf[884]+1);
av2[1]=t6;
av2[2]=t2;
av2[3]=t5;
tp(4,av2);}}

/* k25356 in ##sys#file-exists? in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25358(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_25358,c,av);}
t2=C_i_file_exists_p(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
switch(t2){
case C_SCHEME_FALSE:
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}
case C_SCHEME_TRUE:
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}
default:
/* library.scm:4275: ##sys#signal-hook */
t3=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[4];
av2[2]=lf[467];
av2[3]=((C_word*)t0)[5];
av2[4]=lf[883];
av2[5]=((C_word*)t0)[6];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}}

/* ##sys#flush-output in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25379(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_25379,c,av);}
a=C_alloc(3);
t3=C_slot(t2,C_fix(2));
t4=C_slot(t3,C_fix(5));
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25386,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:4279: g5188 */
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
((C_proc)C_fast_retrieve_proc(t6))(3,av2);}}

/* k25384 in ##sys#flush-output in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25386(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25386,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#flush-output in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25392(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25392,c,av);}
if(C_truep(C_rest_nullp(c,2))){
t2=*((C_word*)lf[839]+1);
t3=C_i_check_port_2(*((C_word*)lf[839]+1),C_fix(2),C_SCHEME_TRUE,lf[886]);
/* library.scm:4286: ##sys#flush-output */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[885]);
C_word av2[3];
av2[0]=*((C_word*)lf[885]+1);
av2[1]=t1;
av2[2]=*((C_word*)lf[839]+1);
tp(3,av2);}}
else{
t2=C_get_rest_arg(c,2,av,2,t0);
t3=C_i_check_port_2(t2,C_fix(2),C_SCHEME_TRUE,lf[886]);
/* library.scm:4286: ##sys#flush-output */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[885]);
C_word av2[3];
av2[0]=*((C_word*)lf[885]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}}

/* ##sys#port-line in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25410(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25410,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(C_input_portp(t2))?C_slot(t2,C_fix(4)):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#decorate-lambda in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25419(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_25419,c,av);}
a=C_alloc(10);
t5=C_block_size(t2);
t6=C_fixnum_difference(t5,C_fix(1));
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_25432,a[2]=t5,a[3]=t2,a[4]=t4,a[5]=t8,a[6]=t3,a[7]=((C_word)li726),tmp=(C_word)a,a+=8,tmp));
t10=((C_word*)t8)[1];
f_25432(t10,t1,t6);}

/* loop in ##sys#decorate-lambda in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void f_25432(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_25432,3,t0,t1,t2);}
a=C_alloc(7);
if(C_truep(C_i_zerop(t2))){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_25440,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:4300: scheme#make-vector */
t4=*((C_word*)lf[117]+1);{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=C_fixnum_plus(((C_word*)t0)[2],C_fix(1));
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}
else{
t3=C_slot(((C_word*)t0)[3],t2);
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_25482,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* library.scm:4309: pred */
t5=((C_word*)t0)[6];{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}}

/* k25438 in loop in ##sys#decorate-lambda in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25440(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_25440,c,av);}
a=C_alloc(10);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_25445,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=t3,a[7]=((C_word)li725),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_25445(t5,((C_word*)t0)[5],C_fix(1));}

/* doloop5217 in k25438 in loop in ##sys#decorate-lambda in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void f_25445(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(0,0,3)))){
C_save_and_reclaim_args((void *)trf_25445,3,t0,t1,t2);}
if(C_truep(C_fixnum_greater_or_equal_p(t2,((C_word*)t0)[2]))){
t3=C_vector_to_closure(((C_word*)t0)[3]);
t4=C_copy_pointer(((C_word*)t0)[4],((C_word*)t0)[3]);
/* library.scm:4305: decorator */
t5=((C_word*)t0)[5];{
C_word av2[4];
av2[0]=t5;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=t2;
((C_proc)C_fast_retrieve_proc(t5))(4,av2);}}
else{
t3=C_slot(((C_word*)t0)[4],t2);
t4=C_i_setslot(((C_word*)t0)[3],t2,t3);
t6=t1;
t7=C_fixnum_plus(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}

/* k25480 in loop in ##sys#decorate-lambda in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25482(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_25482,c,av);}
if(C_truep(t1)){
/* library.scm:4310: decorator */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[5];
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}
else{
/* library.scm:4311: loop */
t2=((C_word*)((C_word*)t0)[6])[1];
f_25432(t2,((C_word*)t0)[3],C_fixnum_difference(((C_word*)t0)[5],C_fix(1)));}}

/* ##sys#lambda-decoration in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25494(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_25494,c,av);}
a=C_alloc(8);
t4=C_block_size(t2);
t5=C_fixnum_difference(t4,C_fix(1));
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_25504,a[2]=t2,a[3]=t7,a[4]=t3,a[5]=((C_word)li728),tmp=(C_word)a,a+=6,tmp));
t9=((C_word*)t7)[1];
f_25504(t9,t1,t5);}

/* loop in ##sys#lambda-decoration in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void f_25504(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_25504,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_fixnum_greaterp(t2,C_fix(0)))){
t3=C_slot(((C_word*)t0)[2],t2);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_25520,a[2]=t1,a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:4317: pred */
t5=((C_word*)t0)[4];{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k25518 in loop in ##sys#lambda-decoration in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25520(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25520,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:4319: loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_25504(t2,((C_word*)t0)[2],C_fixnum_difference(((C_word*)t0)[5],C_fix(1)));}}

/* ##sys#make-lambda-info in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25533(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_25533,c,av);}
a=C_alloc(5);
t3=C_slot(t2,C_fix(0));
t4=C_block_size(t3);
t5=C_fixnum_difference(t4,C_fix(1));
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25543,a[2]=t3,a[3]=t5,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4327: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=t5;
tp(3,av2);}}

/* k25541 in ##sys#make-lambda-info in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25543(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25543,c,av);}
t2=C_copy_memory(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=C_bytevector_to_lambdainfo(t1);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#lambda-info? in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25549(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25549,c,av);}
t3=C_immp(t2);
t4=C_i_not(t3);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=(C_truep(t4)?C_lambdainfop(t2):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#lambda-info in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25562(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_25562,c,av);}
/* library.scm:4339: ##sys#lambda-decoration */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[889]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[889]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_fast_retrieve(lf[891]);
tp(4,av2);}}

/* ##sys#lambda-info->string in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25568(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_25568,c,av);}
a=C_alloc(5);
t3=C_block_size(t2);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25575,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4343: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=C_fixnum_plus(t3,C_fix(1));
tp(3,av2);}}

/* k25573 in ##sys#lambda-info->string in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25575(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_25575,c,av);}
a=C_alloc(5);
t2=C_copy_memory(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=C_utf_length(t1);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_ustring(&a,2,t1,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.base#procedure-information in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25582(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_25582,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25586,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4350: ##sys#check-closure */
t4=*((C_word*)lf[434]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
av2[3]=lf[895];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k25584 in chicken.base#procedure-information in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25586(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_25586,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25589,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4351: ##sys#lambda-info */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[892]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[892]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k25587 in k25584 in chicken.base#procedure-information in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25589(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_25589,c,av);}
a=C_alloc(6);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25599,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25603,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:4352: ##sys#lambda-info->string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[893]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[893]+1);
av2[1]=t3;
av2[2]=t1;
tp(3,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k25597 in k25587 in k25584 in chicken.base#procedure-information in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_25599(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_25599,c,av);}
/* library.scm:4352: ##sys#read */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[894]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[894]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_SCHEME_FALSE;
tp(4,av2);}}

/* k25601 in k25587 in k25584 in chicken.base#procedure-information in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_25603(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25603,c,av);}
/* library.scm:4352: scheme#open-input-string */
t2=*((C_word*)lf[312]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_25611(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25611,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[242]+1 /* (set! chicken.base#setter ...) */,t1);
t3=C_mutate((C_word*)lf[898]+1 /* (set! ##sys#setter ...) */,*((C_word*)lf[242]+1));
t4=C_mutate((C_word*)lf[240]+1 /* (set! chicken.base#getter-with-setter ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25614,a[2]=((C_word)li738),tmp=(C_word)a,a+=3,tmp));
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25691,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4412: chicken.base#getter-with-setter */
t6=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=*((C_word*)lf[13]+1);
av2[3]=*((C_word*)lf[15]+1);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* chicken.base#getter-with-setter in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25614(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_25614,c,av);}
a=C_alloc(6);
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,4,t0));
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_25621,a[2]=t1,a[3]=t3,a[4]=t2,a[5]=t5,tmp=(C_word)a,a+=6,tmp);
/* library.scm:4391: ##sys#check-closure */
t7=*((C_word*)lf[434]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
av2[3]=lf[899];
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}

/* k25619 in chicken.base#getter-with-setter in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25621(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_25621,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_25624,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4392: ##sys#check-closure */
t3=*((C_word*)lf[434]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[899];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k25622 in k25619 in chicken.base#getter-with-setter in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_25624(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_25624,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25627,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(((C_word*)t0)[5])){
t3=C_i_check_string_2(((C_word*)t0)[5],lf[899]);
/* library.scm:4395: ##sys#make-lambda-info */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[890]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[890]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}
else{
/* library.scm:4396: ##sys#lambda-info */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[892]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[892]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}}

/* k25625 in k25622 in k25619 in chicken.base#getter-with-setter in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in ... */
static void C_ccall f_25627(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_25627,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25630,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25646,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4398: ##sys#copy-closure */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[399]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[399]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k25628 in k25625 in k25622 in k25619 in chicken.base#getter-with-setter in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in ... */
static void C_ccall f_25630(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_25630,c,av);}
a=C_alloc(4);
if(C_truep(((C_word*)t0)[2])){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25638,a[2]=((C_word*)t0)[2],a[3]=((C_word)li735),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4404: ##sys#decorate-lambda */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[888]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[888]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
av2[3]=C_fast_retrieve(lf[891]);
av2[4]=t2;
tp(5,av2);}}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* a25637 in k25628 in k25625 in k25622 in k25619 in chicken.base#getter-with-setter in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in ... */
static void C_ccall f_25638(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25638,c,av);}
t4=C_i_setslot(t2,t3,((C_word*)t0)[2]);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* k25644 in k25625 in k25622 in k25619 in chicken.base#getter-with-setter in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in ... */
static void C_ccall f_25646(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_25646,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25648,a[2]=((C_word)li736),tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25664,a[2]=((C_word*)t0)[2],a[3]=((C_word)li737),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4397: ##sys#decorate-lambda */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[888]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[888]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
av2[3]=t2;
av2[4]=t3;
tp(5,av2);}}

/* a25647 in k25644 in k25625 in k25622 in k25619 in chicken.base#getter-with-setter in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in ... */
static void C_ccall f_25648(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25648,c,av);}
t3=C_i_pairp(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=(C_truep(t3)?C_eqp(C_retrieve2(lf[897],C_text("setter-tag")),C_slot(t2,C_fix(0))):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a25663 in k25644 in k25625 in k25622 in k25619 in chicken.base#getter-with-setter in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in ... */
static void C_ccall f_25664(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_25664,c,av);}
a=C_alloc(3);
t4=C_a_i_cons(&a,2,C_retrieve2(lf[897],C_text("setter-tag")),((C_word*)t0)[2]);
t5=C_i_setslot(t2,t3,t4);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_25691(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_25691,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[13]+1 /* (set! scheme#car ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25695,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4413: chicken.base#getter-with-setter */
t4=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=*((C_word*)lf[14]+1);
av2[3]=*((C_word*)lf[16]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_25695(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25695,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[14]+1 /* (set! scheme#cdr ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25699,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41496,a[2]=((C_word)li1248),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4414: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[21]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_25699(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25699,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[21]+1 /* (set! scheme#caar ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25703,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41486,a[2]=((C_word)li1247),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4415: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[17]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in ... */
static void C_ccall f_25703(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25703,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[17]+1 /* (set! scheme#cadr ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25707,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41476,a[2]=((C_word)li1246),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4416: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[22]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in ... */
static void C_ccall f_25707(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25707,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[22]+1 /* (set! scheme#cdar ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25711,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41466,a[2]=((C_word)li1245),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4417: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[23]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in ... */
static void C_ccall f_25711(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25711,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[23]+1 /* (set! scheme#cddr ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25715,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41456,a[2]=((C_word)li1244),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4418: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[24]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in ... */
static void C_ccall f_25715(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25715,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[24]+1 /* (set! scheme#caaar ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25719,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41446,a[2]=((C_word)li1243),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4419: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[25]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in ... */
static void C_ccall f_25719(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25719,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[25]+1 /* (set! scheme#caadr ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25723,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41436,a[2]=((C_word)li1242),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4420: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[26]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in ... */
static void C_ccall f_25723(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25723,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[26]+1 /* (set! scheme#cadar ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25727,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41426,a[2]=((C_word)li1241),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4421: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[18]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in ... */
static void C_ccall f_25727(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25727,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[18]+1 /* (set! scheme#caddr ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25731,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41416,a[2]=((C_word)li1240),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4422: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[27]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in ... */
static void C_ccall f_25731(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25731,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[27]+1 /* (set! scheme#cdaar ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25735,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41406,a[2]=((C_word)li1239),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4423: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[28]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in ... */
static void C_ccall f_25735(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25735,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[28]+1 /* (set! scheme#cdadr ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25739,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41396,a[2]=((C_word)li1238),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4424: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[29]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in ... */
static void C_ccall f_25739(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_25739,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[29]+1 /* (set! scheme#cddar ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25743,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41386,a[2]=((C_word)li1237),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4425: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[30]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in ... */
static void C_ccall f_25743(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_25743,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[30]+1 /* (set! scheme#cdddr ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25747,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4426: chicken.base#getter-with-setter */
t4=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=*((C_word*)lf[62]+1);
av2[3]=*((C_word*)lf[63]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in ... */
static void C_ccall f_25747(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_25747,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[62]+1 /* (set! scheme#string-ref ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25751,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4427: chicken.base#getter-with-setter */
t4=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=*((C_word*)lf[115]+1);
av2[3]=*((C_word*)lf[116]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in ... */
static void C_ccall f_25751(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_25751,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[115]+1 /* (set! scheme#vector-ref ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25755,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41376,a[2]=((C_word)li1236),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4430: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=*((C_word*)lf[49]+1);
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in ... */
static void C_ccall f_25755(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_25755,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[49]+1 /* (set! scheme#list-ref ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25759,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4435: chicken.base#getter-with-setter */
t4=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=C_fast_retrieve(lf[772]);
av2[3]=C_fast_retrieve(lf[773]);
av2[4]=lf[1611];
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}

/* k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in ... */
static void C_ccall f_25759(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(53,c,3)))){
C_save_and_reclaim((void *)f_25759,c,av);}
a=C_alloc(53);
t2=C_mutate((C_word*)lf[772]+1 /* (set! chicken.bytevector#bytevector-u8-ref ...) */,t1);
t3=C_SCHEME_UNDEFINED;
t4=C_a_i_vector(&a,16,t3,t3,t3,t3,t3,t3,t3,t3,t3,t3,t3,t3,t3,t3,t3,t3);
t5=C_mutate(&lf[900] /* (set! ##sys#default-parameter-vector ...) */,t4);
t6=C_mutate((C_word*)lf[901]+1 /* (set! ##sys#current-parameter-vector ...) */,lf[902]);
t7=C_fix(0);
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_mutate((C_word*)lf[85]+1 /* (set! scheme#make-parameter ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25766,a[2]=t8,a[3]=((C_word)li746),tmp=(C_word)a,a+=4,tmp));
t10=C_mutate((C_word*)lf[186]+1 /* (set! scheme#char-ready? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25930,a[2]=((C_word)li747),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[187]+1 /* (set! scheme#read-char ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25955,a[2]=((C_word)li748),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate((C_word*)lf[904]+1 /* (set! ##sys#read-char-0 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25973,a[2]=((C_word)li749),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate((C_word*)lf[905]+1 /* (set! ##sys#read-char/port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26033,a[2]=((C_word)li750),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate((C_word*)lf[906]+1 /* (set! ##sys#peek-char-0 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26042,a[2]=((C_word)li751),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate((C_word*)lf[188]+1 /* (set! scheme#peek-char ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26067,a[2]=((C_word)li752),tmp=(C_word)a,a+=3,tmp));
t16=C_mutate((C_word*)lf[189]+1 /* (set! scheme#read ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26085,a[2]=((C_word)li753),tmp=(C_word)a,a+=3,tmp));
t17=C_set_block_item(lf[909] /* ##sys#default-read-info-hook */,0,C_SCHEME_FALSE);
t18=C_set_block_item(lf[910] /* ##sys#read-error-with-line-number */,0,C_SCHEME_FALSE);
t19=C_mutate((C_word*)lf[911]+1 /* (set! ##sys#read-prompt-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26105,a[2]=((C_word)li754),tmp=(C_word)a,a+=3,tmp));
t20=C_mutate((C_word*)lf[912]+1 /* (set! ##sys#infix-list-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26108,a[2]=((C_word)li755),tmp=(C_word)a,a+=3,tmp));
t21=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26113,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4541: scheme#make-parameter */
t22=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t22;
av2[1]=t21;
av2[2]=lf[457];
((C_proc)(void*)(*((C_word*)t22+1)))(3,av2);}}

/* scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_25766(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_25766,c,av);}
a=C_alloc(8);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25924,a[2]=((C_word)li739),tmp=(C_word)a,a+=3,tmp):C_get_rest_arg(c,3,av,3,t0));
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25773,a[2]=((C_word*)t0)[2],a[3]=t4,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4448: guard */
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
((C_proc)C_fast_retrieve_proc(t6))(3,av2);}}

/* k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in ... */
static void C_ccall f_25773(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,6)))){
C_save_and_reclaim((void *)f_25773,c,av);}
a=C_alloc(14);
t2=((C_word*)((C_word*)t0)[2])[1];
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25774,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=((C_word)li740),tmp=(C_word)a,a+=5,tmp);
t4=C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],C_fix(1));
t5=C_set_block_item(((C_word*)t0)[2],0,t4);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_25808,a[2]=t2,a[3]=t1,a[4]=t3,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t7=C_block_size(C_retrieve2(lf[900],C_text("##sys#default-parameter-vector")));
if(C_truep(C_fixnum_greater_or_equal_p(t2,t7))){
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25912,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* library.scm:4465: ##sys#vector-resize */
f_23697(t8,C_retrieve2(lf[900],C_text("##sys#default-parameter-vector")),C_fixnum_plus(t2,C_fix(1)),C_SCHEME_UNDEFINED);}
else{
t8=t6;
f_25808(t8,C_SCHEME_UNDEFINED);}}

/* assign in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in ... */
static void f_25774(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,4)))){
C_save_and_reclaim_args((void *)trf_25774,6,t0,t1,t2,t3,t4,t5);}
a=C_alloc(11);
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_25778,a[2]=t5,a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=t4,a[6]=((C_word*)t0)[3],a[7]=t2,tmp=(C_word)a,a+=8,tmp);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)t0)[2],t3))){
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_25797,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* library.scm:4453: ##sys#vector-resize */
f_23697(t7,C_fast_retrieve(lf[901]),C_fixnum_plus(((C_word*)t0)[2],C_fix(1)),*((C_word*)lf[730]+1));}
else{
t7=t6;
f_25778(t7,C_SCHEME_UNDEFINED);}}

/* k25776 in assign in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in ... */
static void f_25778(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_25778,2,t0,t1);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25781,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(((C_word*)t0)[5])){
/* library.scm:4457: guard */
t3=((C_word*)t0)[6];{
C_word av2[3];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[7];
((C_proc)C_fast_retrieve_proc(t3))(3,av2);}}
else{
t3=t2;{
C_word av2[2];
av2[0]=t3;
av2[1]=((C_word*)t0)[7];
f_25781(2,av2);}}}

/* k25779 in k25776 in assign in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in ... */
static void C_ccall f_25781(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25781,c,av);}
if(C_truep(((C_word*)t0)[2])){
t2=C_i_setslot(C_fast_retrieve(lf[901]),((C_word*)t0)[3],t1);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k25795 in assign in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in ... */
static void C_ccall f_25797(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25797,c,av);}
t2=C_mutate((C_word*)lf[901]+1 /* (set! ##sys#current-parameter-vector ...) */,t1);
t3=((C_word*)t0)[2];
f_25778(t3,t2);}

/* k25806 in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in ... */
static void f_25808(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,3)))){
C_save_and_reclaim_args((void *)trf_25808,2,t0,t1);}
a=C_alloc(9);
t2=C_i_setslot(C_retrieve2(lf[900],C_text("##sys#default-parameter-vector")),((C_word*)t0)[2],((C_word*)t0)[3]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_25816,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=((C_word)li744),tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25898,a[2]=((C_word*)t0)[4],a[3]=((C_word)li745),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4470: chicken.base#getter-with-setter */
t5=*((C_word*)lf[240]+1);{
C_word av2[4];
av2[0]=t5;
av2[1]=((C_word*)t0)[5];
av2[2]=t3;
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* a25815 in k25806 in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in ... */
static void C_ccall f_25816(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +14,c,4)))){
C_save_and_reclaim((void*)f_25816,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+14);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
t3=C_block_size(C_fast_retrieve(lf[901]));
if(C_truep(C_i_pairp(t2))){
t4=C_u_i_cdr(t2);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_25828,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=t3,a[5]=((C_word)li741),tmp=(C_word)a,a+=6,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25837,a[2]=t5,a[3]=((C_word)li742),tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25842,a[2]=t6,a[3]=((C_word)li743),tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_nullp(t4))){
/* library.scm:4474: def-convert?5371 */
t8=t7;
f_25842(t8,t1);}
else{
t8=C_i_car(t4);
t9=C_u_i_cdr(t4);
if(C_truep(C_i_nullp(t9))){
/* library.scm:4474: def-set?5372 */
t10=t6;
f_25837(t10,t1,t8);}
else{
t10=C_i_car(t9);
t11=C_u_i_cdr(t9);
/* library.scm:4474: body5369 */
t12=t5;
f_25828(t12,t1,t8,t10);}}}
else{
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)t0)[3],t3))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_slot(C_retrieve2(lf[900],C_text("##sys#default-parameter-vector")),((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_slot(C_fast_retrieve(lf[901]),((C_word*)t0)[3]);
t5=C_eqp(t4,*((C_word*)lf[730]+1));
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=(C_truep(t5)?C_slot(C_retrieve2(lf[900],C_text("##sys#default-parameter-vector")),((C_word*)t0)[3]):t4);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}}

/* body5369 in a25815 in k25806 in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in ... */
static void f_25828(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,5)))){
C_save_and_reclaim_args((void *)trf_25828,4,t0,t1,t2,t3);}
/* library.scm:4476: assign */
t4=((C_word*)t0)[2];
f_25774(t4,t1,C_i_car(((C_word*)t0)[3]),((C_word*)t0)[4],t2,t3);}

/* def-set?5372 in a25815 in k25806 in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in ... */
static void f_25837(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,3)))){
C_save_and_reclaim_args((void *)trf_25837,3,t0,t1,t2);}
/* library.scm:4474: body5369 */
t3=((C_word*)t0)[2];
f_25828(t3,t1,t2,C_SCHEME_TRUE);}

/* def-convert?5371 in a25815 in k25806 in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in ... */
static void f_25842(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,2)))){
C_save_and_reclaim_args((void *)trf_25842,2,t0,t1);}
/* library.scm:4474: def-set?5372 */
t2=((C_word*)t0)[2];
f_25837(t2,t1,C_SCHEME_TRUE);}

/* a25897 in k25806 in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in ... */
static void C_ccall f_25898(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_25898,c,av);}
/* library.scm:4486: assign */
t3=((C_word*)t0)[2];
f_25774(t3,t1,t2,C_block_size(C_fast_retrieve(lf[901])),C_SCHEME_FALSE,C_SCHEME_TRUE);}

/* k25910 in k25771 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in ... */
static void C_ccall f_25912(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25912,c,av);}
t2=C_mutate(&lf[900] /* (set! ##sys#default-parameter-vector ...) */,t1);
t3=((C_word*)t0)[2];
f_25808(t3,t2);}

/* f_25924 in scheme#make-parameter in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in ... */
static void C_ccall f_25924(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25924,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#char-ready? in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_25930(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25930,c,av);}
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?*((C_word*)lf[838]+1):C_get_rest_arg(c,2,av,2,t0));
t4=C_i_check_port_2(t3,C_fix(1),C_SCHEME_TRUE,lf[903]);
t5=C_slot(t3,C_fix(2));
/* library.scm:4492: g5404 */
t6=C_slot(t5,C_fix(6));{
C_word av2[3];
av2[0]=t6;
av2[1]=t1;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t6))(3,av2);}}

/* scheme#read-char in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_25955(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_25955,c,av);}
if(C_truep(C_rest_nullp(c,2))){
t2=*((C_word*)lf[838]+1);
t3=C_i_check_port_2(*((C_word*)lf[838]+1),C_fix(1),C_SCHEME_TRUE,lf[468]);
/* library.scm:4499: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t1;
av2[2]=*((C_word*)lf[838]+1);
tp(3,av2);}}
else{
t2=C_get_rest_arg(c,2,av,2,t0);
t3=C_i_check_port_2(t2,C_fix(1),C_SCHEME_TRUE,lf[468]);
/* library.scm:4499: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}}

/* ##sys#read-char-0 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_25973(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_25973,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_25977,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_slot(t2,C_fix(6)))){
t4=C_i_set_i_slot(t2,C_fix(6),C_SCHEME_FALSE);
t5=t3;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_END_OF_FILE;
f_25977(2,av2);}}
else{
t4=C_slot(t2,C_fix(2));
/* library.scm:4502: g5422 */
t5=C_slot(t4,C_fix(0));{
C_word *av2=av;
av2[0]=t5;
av2[1]=t3;
av2[2]=t2;
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}}

/* k25975 in ##sys#read-char-0 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in ... */
static void C_ccall f_25977(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_25977,c,av);}
t2=C_eqp(t1,C_make_character(10));
if(C_truep(t2)){
t3=C_slot(((C_word*)t0)[2],C_fix(4));
t4=C_fixnum_plus(t3,C_fix(1));
t5=C_i_set_i_slot(((C_word*)t0)[2],C_fix(4),t4);
t6=C_i_set_i_slot(((C_word*)t0)[2],C_fix(5),C_fix(0));
t7=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t7;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
if(C_truep(C_i_not(C_eofp(t1)))){
t3=C_slot(((C_word*)t0)[2],C_fix(5));
t4=C_fixnum_plus(t3,C_fix(1));
t5=C_i_set_i_slot(((C_word*)t0)[2],C_fix(5),t4);
t6=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}}

/* ##sys#read-char/port in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_26033(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_26033,c,av);}
t3=C_i_check_port_2(t2,C_fix(1),C_SCHEME_TRUE,lf[468]);
/* library.scm:4516: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2=av;
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}

/* ##sys#peek-char-0 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_26042(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_26042,c,av);}
a=C_alloc(4);
if(C_truep(C_slot(t2,C_fix(6)))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_slot(t2,C_fix(2));
t4=C_slot(t3,C_fix(1));
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26055,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4521: g5436 */
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
((C_proc)C_fast_retrieve_proc(t6))(3,av2);}}}

/* k26053 in ##sys#peek-char-0 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in ... */
static void C_ccall f_26055(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_26055,c,av);}
if(C_truep(C_eofp(t1))){
t2=C_i_set_i_slot(((C_word*)t0)[2],C_fix(6),C_SCHEME_TRUE);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* scheme#peek-char in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_26067(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_26067,c,av);}
if(C_truep(C_rest_nullp(c,2))){
t2=*((C_word*)lf[838]+1);
t3=C_i_check_port_2(*((C_word*)lf[838]+1),C_fix(1),C_SCHEME_TRUE,lf[907]);
/* library.scm:4529: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t1;
av2[2]=*((C_word*)lf[838]+1);
tp(3,av2);}}
else{
t2=C_get_rest_arg(c,2,av,2,t0);
t3=C_i_check_port_2(t2,C_fix(1),C_SCHEME_TRUE,lf[907]);
/* library.scm:4529: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}}

/* scheme#read in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_26085(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_26085,c,av);}
if(C_truep(C_rest_nullp(c,2))){
t2=*((C_word*)lf[838]+1);
t3=C_i_check_port_2(*((C_word*)lf[838]+1),C_fix(1),C_SCHEME_TRUE,lf[908]);
/* library.scm:4534: ##sys#read */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[894]);
C_word av2[4];
av2[0]=*((C_word*)lf[894]+1);
av2[1]=t1;
av2[2]=*((C_word*)lf[838]+1);
av2[3]=C_fast_retrieve(lf[909]);
tp(4,av2);}}
else{
t2=C_get_rest_arg(c,2,av,2,t0);
t3=C_i_check_port_2(t2,C_fix(1),C_SCHEME_TRUE,lf[908]);
/* library.scm:4534: ##sys#read */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[894]);
C_word av2[4];
av2[0]=*((C_word*)lf[894]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_fast_retrieve(lf[909]);
tp(4,av2);}}}

/* ##sys#read-prompt-hook in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_26105(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_26105,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#infix-list-hook in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_26108(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_26108,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in ... */
static void C_ccall f_26113(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_26113,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[851]+1 /* (set! ##sys#default-file-encoding ...) */,t1);
t3=C_mutate((C_word*)lf[913]+1 /* (set! ##sys#sharp-number-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26115,a[2]=((C_word)li756),tmp=(C_word)a,a+=3,tmp));
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26123,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4546: scheme#make-parameter */
t5=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* ##sys#sharp-number-hook in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in ... */
static void C_ccall f_26115(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_26115,c,av);}
/* library.scm:4544: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=lf[915];
av2[4]=t3;
tp(5,av2);}}

/* k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in ... */
static void C_ccall f_26123(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_26123,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[264]+1 /* (set! chicken.base#case-sensitive ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26127,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4547: scheme#make-parameter */
t4=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in ... */
static void C_ccall f_26127(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_26127,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[266]+1 /* (set! chicken.base#parentheses-synonyms ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26131,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4548: scheme#make-parameter */
t4=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in ... */
static void C_ccall f_26131(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_26131,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[267]+1 /* (set! chicken.base#symbol-escape ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26135,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41367,a[2]=((C_word)li1235),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4551: scheme#make-parameter */
t5=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=lf[948];
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in ... */
static void C_ccall f_26135(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_26135,c,av);}
a=C_alloc(8);
t2=C_mutate((C_word*)lf[265]+1 /* (set! chicken.base#keyword-style ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26139,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=C_a_i_record4(&a,4,lf[1609],C_SCHEME_FALSE,C_SCHEME_FALSE,C_SCHEME_FALSE);
/* library.scm:4553: scheme#make-parameter */
t5=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in ... */
static void C_ccall f_26139(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(50,c,4)))){
C_save_and_reclaim((void *)f_26139,c,av);}
a=C_alloc(50);
t2=C_mutate((C_word*)lf[916]+1 /* (set! ##sys#current-read-table ...) */,t1);
t3=C_mutate((C_word*)lf[917]+1 /* (set! ##sys#read-warning ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26141,a[2]=((C_word)li757),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[914]+1 /* (set! ##sys#read-error ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26164,a[2]=((C_word)li758),tmp=(C_word)a,a+=3,tmp));
t5=*((C_word*)lf[265]+1);
t6=*((C_word*)lf[266]+1);
t7=*((C_word*)lf[264]+1);
t8=*((C_word*)lf[267]+1);
t9=C_fast_retrieve(lf[916]);
t10=C_mutate((C_word*)lf[894]+1 /* (set! ##sys#read ...) */,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_26187,a[2]=t9,a[3]=t8,a[4]=t6,a[5]=t5,a[6]=t7,a[7]=((C_word)li821),tmp=(C_word)a,a+=8,tmp));
t11=C_mutate((C_word*)lf[994]+1 /* (set! ##sys#user-read-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29308,a[2]=((C_word)li823),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate((C_word*)lf[1005]+1 /* (set! ##sys#read-numvector-data ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29429,a[2]=((C_word)li824),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate((C_word*)lf[1004]+1 /* (set! ##sys#canonicalize-number-list! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29460,a[2]=((C_word)li828),tmp=(C_word)a,a+=3,tmp));
t14=C_set_block_item(lf[992] /* ##sys#read-marks */,0,C_SCHEME_END_OF_LIST);
t15=C_mutate((C_word*)lf[1007]+1 /* (set! ##sys#write-char-0 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29588,a[2]=((C_word)li829),tmp=(C_word)a,a+=3,tmp));
t16=C_mutate((C_word*)lf[1008]+1 /* (set! ##sys#write-char/port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29604,a[2]=((C_word)li830),tmp=(C_word)a,a+=3,tmp));
t17=C_mutate((C_word*)lf[190]+1 /* (set! scheme#write-char ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29616,a[2]=((C_word)li831),tmp=(C_word)a,a+=3,tmp));
t18=C_mutate((C_word*)lf[191]+1 /* (set! scheme#newline ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29637,a[2]=((C_word)li832),tmp=(C_word)a,a+=3,tmp));
t19=C_mutate((C_word*)lf[192]+1 /* (set! scheme#write ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29652,a[2]=((C_word)li833),tmp=(C_word)a,a+=3,tmp));
t20=C_mutate((C_word*)lf[193]+1 /* (set! scheme#display ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29670,a[2]=((C_word)li834),tmp=(C_word)a,a+=3,tmp));
t21=C_mutate((C_word*)lf[229]+1 /* (set! chicken.base#print ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29688,a[2]=((C_word)li836),tmp=(C_word)a,a+=3,tmp));
t22=C_mutate((C_word*)lf[230]+1 /* (set! chicken.base#print* ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29739,a[2]=((C_word)li838),tmp=(C_word)a,a+=3,tmp));
t23=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29792,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5342: scheme#make-parameter */
t24=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t24;
av2[1]=t23;
av2[2]=C_fix(0);
((C_proc)(void*)(*((C_word*)t24+1)))(3,av2);}}

/* ##sys#read-warning in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_26141(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +5,c,2)))){
C_save_and_reclaim((void*)f_26141,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+5);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26149,a[2]=t1,a[3]=t4,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4560: ##sys#port-line */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[887]);
C_word *av2=av;
av2[0]=*((C_word*)lf[887]+1);
av2[1]=t5;
av2[2]=t2;
tp(3,av2);}}

/* k26147 in ##sys#read-warning in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void C_ccall f_26149(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_26149,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26152,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(C_truep(C_fast_retrieve(lf[910]))?t1:C_SCHEME_FALSE);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26162,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4562: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t4;
av2[2]=t1;
tp(3,av2);}}
else{{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[376]+1);
av2[3]=((C_word*)t0)[4];
av2[4]=((C_word*)t0)[3];
C_apply(5,av2);}}}

/* k26150 in k26147 in ##sys#read-warning in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_26152(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_26152,c,av);}{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[376]+1);
av2[3]=t1;
av2[4]=((C_word*)t0)[3];
C_apply(5,av2);}}

/* k26160 in k26147 in ##sys#read-warning in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_26162(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_26162,c,av);}
/* library.scm:4562: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[918];
av2[3]=t1;
av2[4]=lf[919];
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* ##sys#read-error in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_26164(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +5,c,2)))){
C_save_and_reclaim((void*)f_26164,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+5);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26172,a[2]=t1,a[3]=t4,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4572: ##sys#port-line */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[887]);
C_word *av2=av;
av2[0]=*((C_word*)lf[887]+1);
av2[1]=t5;
av2[2]=t2;
tp(3,av2);}}

/* k26170 in ##sys#read-error in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void C_ccall f_26172(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,5)))){
C_save_and_reclaim((void *)f_26172,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26175,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(C_truep(C_fast_retrieve(lf[910]))?t1:C_SCHEME_FALSE);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26185,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4574: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t4;
av2[2]=t1;
tp(3,av2);}}
else{{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[920];
av2[4]=((C_word*)t0)[4];
av2[5]=((C_word*)t0)[3];
C_apply(6,av2);}}}

/* k26173 in k26170 in ##sys#read-error in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_26175(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_26175,c,av);}{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[920];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
C_apply(6,av2);}}

/* k26183 in k26170 in ##sys#read-error in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_26185(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_26185,c,av);}
/* library.scm:4574: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[921];
av2[3]=t1;
av2[4]=lf[922];
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_26187(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_26187,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_29303,a[2]=t2,a[3]=t3,a[4]=t1,a[5]=((C_word*)t0)[2],a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[5],tmp=(C_word)a,a+=9,tmp);
/* library.scm:4586: case-sensitive */
t5=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_26194(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_26194,c,av);}
a=C_alloc(11);
t2=t1;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_26197,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* library.scm:4588: parentheses-synonyms */
t5=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in ... */
static void C_ccall f_26197(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_26197,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_26200,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* library.scm:4589: symbol-escape */
t3=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_26200(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_26200,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_26203,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t1,a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* library.scm:4590: current-read-table */
t3=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)C_fast_retrieve_proc(t3))(2,av2);}}

/* k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_26203(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(84,c,5)))){
C_save_and_reclaim((void *)f_26203,c,av);}
a=C_alloc(84);
t2=C_SCHEME_FALSE;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_END_OF_LIST;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=lf[923];
t7=C_SCHEME_FALSE;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_SCHEME_UNDEFINED;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_SCHEME_UNDEFINED;
t14=(*a=C_VECTOR_TYPE|1,a[1]=t13,tmp=(C_word)a,a+=2,tmp);
t15=C_SCHEME_UNDEFINED;
t16=(*a=C_VECTOR_TYPE|1,a[1]=t15,tmp=(C_word)a,a+=2,tmp);
t17=C_SCHEME_UNDEFINED;
t18=(*a=C_VECTOR_TYPE|1,a[1]=t17,tmp=(C_word)a,a+=2,tmp);
t19=C_SCHEME_UNDEFINED;
t20=(*a=C_VECTOR_TYPE|1,a[1]=t19,tmp=(C_word)a,a+=2,tmp);
t21=C_SCHEME_UNDEFINED;
t22=(*a=C_VECTOR_TYPE|1,a[1]=t21,tmp=(C_word)a,a+=2,tmp);
t23=C_SCHEME_UNDEFINED;
t24=(*a=C_VECTOR_TYPE|1,a[1]=t23,tmp=(C_word)a,a+=2,tmp);
t25=C_SCHEME_UNDEFINED;
t26=(*a=C_VECTOR_TYPE|1,a[1]=t25,tmp=(C_word)a,a+=2,tmp);
t27=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26205,a[2]=((C_word*)t0)[2],a[3]=((C_word)li759),tmp=(C_word)a,a+=4,tmp));
t28=C_set_block_item(t12,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26211,a[2]=((C_word*)t0)[3],a[3]=((C_word)li760),tmp=(C_word)a,a+=4,tmp));
t29=C_set_block_item(t14,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26220,a[2]=((C_word*)t0)[2],a[3]=((C_word)li762),tmp=(C_word)a,a+=4,tmp));
t30=C_set_block_item(t16,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26257,a[2]=((C_word*)t0)[2],a[3]=((C_word)li763),tmp=(C_word)a,a+=4,tmp));
t31=C_set_block_item(t18,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26266,a[2]=t8,a[3]=t16,a[4]=((C_word)li764),tmp=(C_word)a,a+=5,tmp));
t32=C_set_block_item(t20,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26281,a[2]=t5,a[3]=((C_word)li765),tmp=(C_word)a,a+=4,tmp));
t33=C_set_block_item(t22,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26292,a[2]=t22,a[3]=((C_word)li766),tmp=(C_word)a,a+=4,tmp));
t34=C_set_block_item(t24,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26320,a[2]=t22,a[3]=((C_word)li769),tmp=(C_word)a,a+=4,tmp));
t35=C_set_block_item(t26,0,(*a=C_CLOSURE_TYPE|19,a[1]=(C_word)f_26440,a[2]=((C_word*)t0)[2],a[3]=t14,a[4]=t3,a[5]=t10,a[6]=t12,a[7]=t26,a[8]=((C_word*)t0)[4],a[9]=((C_word*)t0)[5],a[10]=t18,a[11]=t6,a[12]=t8,a[13]=t16,a[14]=t1,a[15]=t20,a[16]=t5,a[17]=((C_word*)t0)[6],a[18]=((C_word*)t0)[7],a[19]=((C_word)li819),tmp=(C_word)a,a+=20,tmp));
t36=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_29279,a[2]=((C_word*)t0)[8],a[3]=t5,a[4]=t24,a[5]=t3,a[6]=((C_word*)t0)[2],tmp=(C_word)a,a+=7,tmp);
/* library.scm:5216: readrec */
t37=((C_word*)t26)[1];
f_26440(t37,t36);}

/* f_26205 in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_26205(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_26205,c,av);}
/* library.scm:4598: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=lf[924];
av2[4]=t2;
tp(5,av2);}}

/* info in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_26211(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,4)))){
C_save_and_reclaim_args((void *)trf_26211,5,t0,t1,t2,t3,t4);}
if(C_truep(((C_word*)t0)[2])){
/* library.scm:4602: infohandler */
t5=((C_word*)t0)[2];{
C_word av2[5];
av2[0]=t5;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
av2[4]=t4;
((C_proc)C_fast_retrieve_proc(t5))(5,av2);}}
else{
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* skip-to-eol in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_26220(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_26220,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26228,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4606: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k26226 in skip-to-eol in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_26228(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_26228,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26230,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word)li761),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_26230(t5,((C_word*)t0)[3],t1);}

/* skip in k26226 in skip-to-eol in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_26230(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_26230,3,t0,t1,t2);}
a=C_alloc(4);
t3=C_i_not(C_eofp(t2));
t4=(C_truep(t3)?C_i_not(C_eqp(C_make_character(10),t2)):C_SCHEME_FALSE);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26244,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4608: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
t5=C_SCHEME_UNDEFINED;
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* k26242 in skip in k26226 in skip-to-eol in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_26244(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_26244,c,av);}
/* library.scm:4608: skip */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26230(t2,((C_word*)t0)[3],t1);}

/* reserved-character in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_26257(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_26257,3,t0,t1,t2);}
a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26261,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4611: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k26259 in reserved-character in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_26261(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_26261,c,av);}
/* library.scm:4612: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[925];
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}

/* read-unreserved-char-0 in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_26266(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_26266,3,t0,t1,t2);}
a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26270,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4615: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k26268 in read-unreserved-char-0 in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_26270(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_26270,c,av);}
if(C_truep(C_i_memq(t1,((C_word*)((C_word*)t0)[2])[1]))){
/* library.scm:4617: reserved-character */
t2=((C_word*)((C_word*)t0)[3])[1];
f_26257(t2,((C_word*)t0)[4],t1);}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* register-shared! in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static C_word f_26281(C_word *a,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_stack_overflow_check;{}
t3=C_a_i_cons(&a,2,t1,t2);
t4=C_a_i_cons(&a,2,t3,((C_word*)((C_word*)t0)[2])[1]);
t5=C_mutate(((C_word *)((C_word*)t0)[2])+1,t4);
return(t5);}

/* unthunk in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_26292(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_26292,4,t0,t1,t2,t3);}
a=C_alloc(6);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26296,a[2]=t1,a[3]=t2,a[4]=t3,a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4624: o */
t5=t2;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)C_fast_retrieve_proc(t5))(2,av2);}}

/* k26294 in unthunk in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_26296(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_26296,c,av);}
t2=C_i_closurep(t1);
if(C_truep(C_i_not(t2))){
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_eqp(t1,((C_word*)t0)[3]);
if(C_truep(t3)){
/* library.scm:4627: fail */
t4=((C_word*)t0)[4];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[926];
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}
else{
/* library.scm:4629: unthunk */
t4=((C_word*)((C_word*)t0)[5])[1];
f_26292(t4,((C_word*)t0)[2],t1,((C_word*)t0)[4]);}}}

/* unthunkify! in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_26320(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_26320,4,t0,t1,t2,t3);}
a=C_alloc(8);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26326,a[2]=t5,a[3]=((C_word*)t0)[2],a[4]=t3,a[5]=((C_word)li768),tmp=(C_word)a,a+=6,tmp));
t7=((C_word*)t5)[1];
f_26326(t7,t1,t2);}

/* loop! in unthunkify! in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_26326(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(11,0,3)))){
C_save_and_reclaim_args((void *)trf_26326,3,t0,t1,t2);}
a=C_alloc(11);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_26336,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],tmp=(C_word)a,a+=7,tmp);
t4=C_i_closurep(C_u_i_car(t2));
if(C_truep(C_i_not(t4))){
/* library.scm:4636: loop! */
t8=t3;
t9=C_u_i_car(t2);
t1=t8;
t2=t9;
goto loop;}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26379,a[2]=t3,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4637: unthunk */
t6=((C_word*)((C_word*)t0)[3])[1];
f_26292(t6,t5,C_u_i_car(t2),((C_word*)t0)[4]);}}
else{
if(C_truep(C_i_vectorp(t2))){
t3=C_block_size(t2);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_26401,a[2]=t3,a[3]=t2,a[4]=t5,a[5]=((C_word*)t0)[2],a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[4],a[8]=((C_word)li767),tmp=(C_word)a,a+=9,tmp));
t7=((C_word*)t5)[1];
f_26401(t7,t1,C_fix(0));}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}}

/* k26334 in loop! in unthunkify! in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_26336(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_26336,c,av);}
a=C_alloc(4);
t2=C_i_closurep(C_u_i_cdr(((C_word*)t0)[2]));
if(C_truep(C_i_not(t2))){
/* library.scm:4639: loop! */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26326(t3,((C_word*)t0)[4],C_u_i_cdr(((C_word*)t0)[2]));}
else{
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26355,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4640: unthunk */
t4=((C_word*)((C_word*)t0)[5])[1];
f_26292(t4,t3,C_u_i_cdr(((C_word*)t0)[2]),((C_word*)t0)[6]);}}

/* k26353 in k26334 in loop! in unthunkify! in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_26355(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_26355,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_setslot(((C_word*)t0)[3],C_fix(1),t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k26377 in loop! in unthunkify! in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_26379(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_26379,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_setslot(((C_word*)t0)[3],C_fix(0),t1);
f_26336(2,av2);}}

/* doloop5545 in loop! in unthunkify! in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_26401(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,3)))){
C_save_and_reclaim_args((void *)trf_26401,3,t0,t1,t2);}
a=C_alloc(11);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t4=C_slot(((C_word*)t0)[3],t2);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26414,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t6=C_i_closurep(t4);
if(C_truep(C_i_not(t6))){
/* library.scm:4647: loop! */
t7=((C_word*)((C_word*)t0)[5])[1];
f_26326(t7,t5,t4);}
else{
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26434,a[2]=((C_word*)t0)[3],a[3]=t2,a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:4648: unthunk */
t8=((C_word*)((C_word*)t0)[6])[1];
f_26292(t8,t7,t4,((C_word*)t0)[7]);}}}

/* k26412 in doloop5545 in loop! in unthunkify! in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_26414(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_26414,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_26401(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* k26432 in doloop5545 in loop! in unthunkify! in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_26434(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_26434,c,av);}
t2=C_i_setslot(((C_word*)t0)[2],((C_word*)t0)[3],t1);
t3=((C_word*)((C_word*)t0)[4])[1];
f_26401(t3,((C_word*)t0)[5],C_fixnum_plus(((C_word*)t0)[3],C_fix(1)));}

/* readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_26440(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word t51;
C_word t52;
C_word t53;
C_word t54;
C_word t55;
C_word t56;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(162,0,5)))){
C_save_and_reclaim_args((void *)trf_26440,2,t0,t1);}
a=C_alloc(162);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_SCHEME_UNDEFINED;
t13=(*a=C_VECTOR_TYPE|1,a[1]=t12,tmp=(C_word)a,a+=2,tmp);
t14=C_SCHEME_UNDEFINED;
t15=(*a=C_VECTOR_TYPE|1,a[1]=t14,tmp=(C_word)a,a+=2,tmp);
t16=C_SCHEME_UNDEFINED;
t17=(*a=C_VECTOR_TYPE|1,a[1]=t16,tmp=(C_word)a,a+=2,tmp);
t18=C_SCHEME_UNDEFINED;
t19=(*a=C_VECTOR_TYPE|1,a[1]=t18,tmp=(C_word)a,a+=2,tmp);
t20=C_SCHEME_UNDEFINED;
t21=(*a=C_VECTOR_TYPE|1,a[1]=t20,tmp=(C_word)a,a+=2,tmp);
t22=C_SCHEME_UNDEFINED;
t23=(*a=C_VECTOR_TYPE|1,a[1]=t22,tmp=(C_word)a,a+=2,tmp);
t24=C_SCHEME_UNDEFINED;
t25=(*a=C_VECTOR_TYPE|1,a[1]=t24,tmp=(C_word)a,a+=2,tmp);
t26=C_SCHEME_UNDEFINED;
t27=(*a=C_VECTOR_TYPE|1,a[1]=t26,tmp=(C_word)a,a+=2,tmp);
t28=C_SCHEME_UNDEFINED;
t29=(*a=C_VECTOR_TYPE|1,a[1]=t28,tmp=(C_word)a,a+=2,tmp);
t30=C_SCHEME_UNDEFINED;
t31=(*a=C_VECTOR_TYPE|1,a[1]=t30,tmp=(C_word)a,a+=2,tmp);
t32=C_SCHEME_UNDEFINED;
t33=(*a=C_VECTOR_TYPE|1,a[1]=t32,tmp=(C_word)a,a+=2,tmp);
t34=C_SCHEME_UNDEFINED;
t35=(*a=C_VECTOR_TYPE|1,a[1]=t34,tmp=(C_word)a,a+=2,tmp);
t36=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26443,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word)li771),tmp=(C_word)a,a+=5,tmp));
t37=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26491,a[2]=((C_word*)t0)[2],a[3]=((C_word)li773),tmp=(C_word)a,a+=4,tmp));
t38=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26551,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[4],a[4]=((C_word)li777),tmp=(C_word)a,a+=5,tmp));
t39=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26691,a[2]=((C_word*)t0)[2],a[3]=t7,a[4]=t5,a[5]=((C_word)li780),tmp=(C_word)a,a+=6,tmp));
t40=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_27190,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[2],a[5]=t3,a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=t27,a[9]=((C_word)li786),tmp=(C_word)a,a+=10,tmp));
t41=C_set_block_item(t13,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27451,a[2]=((C_word*)t0)[2],a[3]=t11,a[4]=((C_word)li787),tmp=(C_word)a,a+=5,tmp));
t42=C_set_block_item(t15,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27469,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[2],a[4]=t27,a[5]=((C_word)li789),tmp=(C_word)a,a+=6,tmp));
t43=C_set_block_item(t17,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27538,a[2]=((C_word*)t0)[2],a[3]=t15,a[4]=((C_word)li790),tmp=(C_word)a,a+=5,tmp));
t44=C_set_block_item(t19,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27589,a[2]=((C_word*)t0)[2],a[3]=t15,a[4]=((C_word)li791),tmp=(C_word)a,a+=5,tmp));
t45=C_set_block_item(t21,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27656,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[9],a[4]=((C_word*)t0)[10],a[5]=((C_word*)t0)[11],a[6]=((C_word)li793),tmp=(C_word)a,a+=7,tmp));
t46=C_set_block_item(t23,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27718,a[2]=((C_word*)t0)[2],a[3]=((C_word)li795),tmp=(C_word)a,a+=4,tmp));
t47=C_set_block_item(t25,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27764,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[2],a[4]=t27,a[5]=((C_word)li797),tmp=(C_word)a,a+=6,tmp));
t48=C_set_block_item(t27,0,(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_27789,a[2]=((C_word*)t0)[8],a[3]=((C_word*)t0)[12],a[4]=((C_word*)t0)[13],a[5]=t9,a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[9],a[8]=((C_word*)t0)[11],a[9]=((C_word)li799),tmp=(C_word)a,a+=10,tmp));
t49=C_set_block_item(t29,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28040,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[11],a[4]=t21,a[5]=((C_word)li800),tmp=(C_word)a,a+=6,tmp));
t50=C_set_block_item(t31,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28257,a[2]=((C_word*)t0)[2],a[3]=((C_word)li802),tmp=(C_word)a,a+=4,tmp));
t51=C_set_block_item(t33,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28344,a[2]=t21,a[3]=((C_word)li803),tmp=(C_word)a,a+=4,tmp));
t52=C_set_block_item(t35,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28357,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[7],a[4]=((C_word*)t0)[2],a[5]=((C_word)li804),tmp=(C_word)a,a+=6,tmp));
t53=(*a=C_CLOSURE_TYPE|29,a[1]=(C_word)f_28392,a[2]=((C_word*)t0)[12],a[3]=((C_word*)t0)[14],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[7],a[6]=t1,a[7]=t35,a[8]=((C_word*)t0)[15],a[9]=((C_word*)t0)[16],a[10]=t23,a[11]=t17,a[12]=t19,a[13]=t13,a[14]=t29,a[15]=t31,a[16]=t33,a[17]=((C_word*)t0)[8],a[18]=t27,a[19]=((C_word*)t0)[6],a[20]=((C_word*)t0)[3],a[21]=((C_word*)t0)[9],a[22]=t21,a[23]=t11,a[24]=((C_word*)t0)[5],a[25]=t9,a[26]=t15,a[27]=((C_word*)t0)[13],a[28]=t25,a[29]=t3,tmp=(C_word)a,a+=30,tmp);
t54=C_i_not(((C_word*)t0)[17]);
t55=(C_truep(t54)?lf[995]:C_SCHEME_END_OF_LIST);
if(C_truep(C_i_not(((C_word*)t0)[18]))){
/* library.scm:5049: scheme#append */
t56=*((C_word*)lf[443]+1);{
C_word av2[4];
av2[0]=t56;
av2[1]=t53;
av2[2]=t55;
av2[3]=lf[996];
((C_proc)(void*)(*((C_word*)t56+1)))(4,av2);}}
else{
/* library.scm:5049: scheme#append */
t56=*((C_word*)lf[443]+1);{
C_word av2[4];
av2[0]=t56;
av2[1]=t53;
av2[2]=t55;
av2[3]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t56+1)))(4,av2);}}}

/* r-spaces in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_26443(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_26443,2,t0,t1);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26451,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4653: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k26449 in r-spaces in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_26451(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_26451,c,av);}
a=C_alloc(8);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26453,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word)li770),tmp=(C_word)a,a+=6,tmp));
t5=((C_word*)t3)[1];
f_26453(t5,((C_word*)t0)[4],t1);}

/* loop in k26449 in r-spaces in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_26453(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_26453,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_eofp(t2);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_eqp(C_make_character(59),t2);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26466,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4656: skip-to-eol */
t6=((C_word*)((C_word*)t0)[4])[1];
f_26220(t6,t5);}
else{
if(C_truep(C_u_i_char_whitespacep(t2))){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26482,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4659: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
t5=C_SCHEME_UNDEFINED;
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}}}

/* k26464 in loop in k26449 in r-spaces in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_26466(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_26466,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26473,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4657: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k26471 in k26464 in loop in k26449 in r-spaces in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26473(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_26473,c,av);}
/* library.scm:4657: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26453(t2,((C_word*)t0)[3],t1);}

/* k26480 in loop in k26449 in r-spaces in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_26482(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_26482,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26489,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4660: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k26487 in k26480 in loop in k26449 in r-spaces in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26489(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_26489,c,av);}
/* library.scm:4660: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26453(t2,((C_word*)t0)[3],t1);}

/* r-usequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_26491(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,4)))){
C_save_and_reclaim_args((void *)trf_26491,5,t0,t1,t2,t3,t4);}
a=C_alloc(9);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_26497,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=t4,a[5]=t6,a[6]=((C_word)li772),tmp=(C_word)a,a+=7,tmp));
t8=((C_word*)t6)[1];
f_26497(t8,t1,C_SCHEME_END_OF_LIST,t3);}

/* loop in r-usequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_26497(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_26497,4,t0,t1,t2,t3);}
a=C_alloc(7);
t4=C_eqp(t3,C_fix(0));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26507,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4665: ##sys#reverse-list->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[480]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[480]+1);
av2[1]=t5;
av2[2]=t2;
tp(3,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_26523,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t2,a[5]=((C_word*)t0)[5],a[6]=t3,tmp=(C_word)a,a+=7,tmp);
/* library.scm:4672: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}}

/* k26505 in loop in r-usequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_26507(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_26507,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26510,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:4666: scheme#string->number */
t3=*((C_word*)lf[723]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=t1;
av2[3]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k26508 in k26505 in loop in r-usequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_26510(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,5)))){
C_save_and_reclaim((void *)f_26510,c,av);}
a=C_alloc(4);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26520,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4670: string-append */
t3=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[927];
av2[3]=((C_word*)t0)[4];
av2[4]=((C_word*)t0)[5];
av2[5]=lf[928];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}}

/* k26518 in k26508 in k26505 in loop in r-usequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26520(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_26520,c,av);}
/* library.scm:4668: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k26521 in loop in r-usequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_26523(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26523,c,av);}
a=C_alloc(3);
t2=C_eofp(t1);
t3=(C_truep(t2)?t2:C_i_char_equalp(C_make_character(34),t1));
if(C_truep(t3)){
/* library.scm:4674: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[929];
tp(4,av2);}}
else{
t4=C_a_i_cons(&a,2,t1,((C_word*)t0)[4]);
/* library.scm:4675: loop */
t5=((C_word*)((C_word*)t0)[5])[1];
f_26497(t5,((C_word*)t0)[2],t4,C_fixnum_difference(((C_word*)t0)[6],C_fix(1)));}}

/* r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_26551(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(28,0,3)))){
C_save_and_reclaim_args((void *)trf_26551,3,t0,t1,t2);}
a=C_alloc(28);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26554,a[2]=((C_word*)t0)[2],a[3]=((C_word)li774),tmp=(C_word)a,a+=4,tmp));
t10=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_26573,a[2]=((C_word*)t0)[3],tmp=(C_word)a,a+=3,tmp));
t11=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26577,a[2]=((C_word*)t0)[2],a[3]=((C_word)li775),tmp=(C_word)a,a+=4,tmp));
t12=C_SCHEME_UNDEFINED;
t13=(*a=C_VECTOR_TYPE|1,a[1]=t12,tmp=(C_word)a,a+=2,tmp);
t14=C_set_block_item(t13,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_26586,a[2]=t8,a[3]=t2,a[4]=t6,a[5]=t4,a[6]=((C_word*)t0)[2],a[7]=t13,a[8]=((C_word)li776),tmp=(C_word)a,a+=9,tmp));
t15=((C_word*)t13)[1];
f_26586(t15,t1,C_SCHEME_END_OF_LIST);}

/* parse in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_26554(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_26554,3,t0,t1,t2);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26558,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4679: ##sys#reverse-list->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[480]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[480]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k26556 in parse in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_26558(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_26558,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26561,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4680: scheme#string->number */
t3=*((C_word*)lf[723]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=t1;
av2[3]=C_fix(16);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k26559 in k26556 in parse in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_26561(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_26561,c,av);}
a=C_alloc(4);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26571,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4683: string-append */
t3=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[930];
av2[3]=((C_word*)t0)[4];
av2[4]=lf[931];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}}

/* k26569 in k26559 in k26556 in parse in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26571(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_26571,c,av);}
/* library.scm:4682: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* complain in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static C_word f_26573(C_word t0){
C_word tmp;
C_word t1;
C_word t2;
C_stack_overflow_check;{}
t1=C_mutate(((C_word *)((C_word*)t0)[2])+1,lf[932]);
return(t1);}

/* abort in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_26577(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,3)))){
C_save_and_reclaim_args((void *)trf_26577,2,t0,t1);}
/* library.scm:4688: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word av2[4];
av2[0]=*((C_word*)lf[914]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=lf[933];
tp(4,av2);}}

/* loop in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_26586(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,2)))){
C_save_and_reclaim_args((void *)trf_26586,3,t0,t1,t2);}
a=C_alloc(10);
t3=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_26590,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=t2,a[8]=((C_word*)t0)[6],a[9]=((C_word*)t0)[7],tmp=(C_word)a,a+=10,tmp);
/* library.scm:4690: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}}

/* k26588 in loop in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_26590(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_26590,c,av);}
a=C_alloc(9);
if(C_truep(C_eofp(t1))){
/* library.scm:4691: abort */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26577(t2,((C_word*)t0)[3]);}
else{
t2=C_eqp(((C_word*)t0)[4],t1);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26608,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4693: parse */
t4=((C_word*)((C_word*)t0)[6])[1];
f_26554(t4,t3,((C_word*)t0)[7]);}
else{
t3=C_eqp(C_make_character(59),t1);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26629,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[7],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4698: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[8];
tp(3,av2);}}
else{
t4=C_i_char_greater_or_equal_p(t1,C_make_character(48));
t5=(C_truep(t4)?C_u_i_char_less_or_equal_p(t1,C_make_character(57)):C_SCHEME_FALSE);
t6=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_26641,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[9],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],tmp=(C_word)a,a+=9,tmp);
if(C_truep(t5)){
t7=t6;
f_26641(t7,t5);}
else{
t7=(C_truep(C_u_i_char_greater_or_equal_p(t1,C_make_character(97)))?C_u_i_char_less_or_equal_p(t1,C_make_character(102)):C_SCHEME_FALSE);
t8=t6;
f_26641(t8,(C_truep(t7)?t7:(C_truep(C_u_i_char_greater_or_equal_p(t1,C_make_character(65)))?C_u_i_char_less_or_equal_p(t1,C_make_character(70)):C_SCHEME_FALSE)));}}}}}

/* k26606 in k26588 in loop in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_26608(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_26608,c,av);}
if(C_truep(C_fixnum_greaterp(t1,C_fix(131071)))){
/* library.scm:4695: abort */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26577(t2,((C_word*)t0)[3]);}
else{
t2=(
/* library.scm:4696: complain */
  f_26573(((C_word*)((C_word*)t0)[4])[1])
);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k26627 in k26588 in loop in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_26629(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_26629,c,av);}
/* library.scm:4699: parse */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26554(t2,((C_word*)t0)[3],((C_word*)t0)[4]);}

/* k26639 in k26588 in loop in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_26641(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_26641,2,t0,t1);}
a=C_alloc(5);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26652,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4703: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26655,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[7],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4705: parse */
t3=((C_word*)((C_word*)t0)[8])[1];
f_26554(t3,t2,((C_word*)t0)[2]);}}

/* k26650 in k26639 in k26588 in loop in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26652(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_26652,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,((C_word*)t0)[2]);
/* library.scm:4703: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26586(t3,((C_word*)t0)[4],t2);}

/* k26653 in k26639 in k26588 in loop in r-xsequence in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26655(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_26655,c,av);}
if(C_truep(C_fixnum_greaterp(t1,C_fix(131071)))){
/* library.scm:4707: abort */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26577(t2,((C_word*)t0)[3]);}
else{
t2=(
/* library.scm:4708: complain */
  f_26573(((C_word*)((C_word*)t0)[4])[1])
);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_26691(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_26691,3,t0,t1,t2);}
a=C_alloc(7);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_26699,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word*)t0)[4],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:4711: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_26699(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_26699,c,av);}
a=C_alloc(10);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_26701,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word)li779),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_26701(t5,((C_word*)t0)[6],t1,C_SCHEME_END_OF_LIST);}

/* loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_26701(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,0,3)))){
C_save_and_reclaim_args((void *)trf_26701,4,t0,t1,t2,t3);}
a=C_alloc(12);
t4=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
if(C_truep(C_eofp(((C_word*)t4)[1]))){
/* library.scm:4713: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word av2[4];
av2[0]=*((C_word*)lf[914]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=lf[934];
tp(4,av2);}}
else{
t5=C_eqp(C_make_character(92),((C_word*)t4)[1]);
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_26718,a[2]=t4,a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=t1,a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[5],a[9]=((C_word*)t0)[6],tmp=(C_word)a,a+=10,tmp);
/* library.scm:4715: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}
else{
t6=C_eqp(((C_word*)t0)[5],((C_word*)t4)[1]);
if(C_truep(t6)){
/* library.scm:4776: ##sys#reverse-list->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[480]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[480]+1);
av2[1]=t1;
av2[2]=t3;
tp(3,av2);}}
else{
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27184,a[2]=t4,a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:4777: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t7;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}}}}

/* k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_26718(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_26718,c,av);}
a=C_alloc(9);
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=((C_word*)((C_word*)t0)[2])[1];
switch(t3){
case C_make_character(116):
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26731,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4717: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}
case C_make_character(114):
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26748,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4718: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}
case C_make_character(98):
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26765,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4719: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}
case C_make_character(110):
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26782,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4720: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}
case C_make_character(97):
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26799,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4721: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}
case C_make_character(118):
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26816,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4722: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}
case C_make_character(102):
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26833,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4723: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}
case C_make_character(120):
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26861,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4725: r-xsequence */
t5=((C_word*)((C_word*)t0)[7])[1];
f_26551(t5,t4,((C_word*)t0)[8]);
case C_make_character(117):
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26870,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4728: r-usequence */
t5=((C_word*)((C_word*)t0)[9])[1];
f_26491(t5,t4,lf[935],C_fix(4),C_fix(16));
case C_make_character(85):
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26894,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4732: r-usequence */
t5=((C_word*)((C_word*)t0)[9])[1];
f_26491(t5,t4,lf[936],C_fix(8),C_fix(16));
default:
t4=C_eqp(t3,C_make_character(92));
t5=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_26918,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t3,a[8]=((C_word*)t0)[9],tmp=(C_word)a,a+=9,tmp);
if(C_truep(t4)){
t6=t5;
f_26918(t6,t4);}
else{
t6=C_eqp(t3,C_make_character(39));
if(C_truep(t6)){
t7=t5;
f_26918(t7,t6);}
else{
t7=C_eqp(t3,C_make_character(34));
t8=t5;
f_26918(t8,(C_truep(t7)?t7:C_eqp(t3,C_make_character(124))));}}}}

/* k26729 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26731(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26731,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,C_make_character(9),((C_word*)t0)[2]);
/* library.scm:4717: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26701(t3,((C_word*)t0)[4],t1,t2);}

/* k26746 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26748(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26748,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,C_make_character(13),((C_word*)t0)[2]);
/* library.scm:4718: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26701(t3,((C_word*)t0)[4],t1,t2);}

/* k26763 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26765(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26765,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,C_make_character(8),((C_word*)t0)[2]);
/* library.scm:4719: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26701(t3,((C_word*)t0)[4],t1,t2);}

/* k26780 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26782(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26782,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,C_make_character(10),((C_word*)t0)[2]);
/* library.scm:4720: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26701(t3,((C_word*)t0)[4],t1,t2);}

/* k26797 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26799(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26799,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,C_make_character(7),((C_word*)t0)[2]);
/* library.scm:4721: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26701(t3,((C_word*)t0)[4],t1,t2);}

/* k26814 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26816(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26816,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,C_make_character(11),((C_word*)t0)[2]);
/* library.scm:4722: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26701(t3,((C_word*)t0)[4],t1,t2);}

/* k26831 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26833(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26833,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,C_make_character(12),((C_word*)t0)[2]);
/* library.scm:4723: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26701(t3,((C_word*)t0)[4],t1,t2);}

/* k26851 in k26859 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_26853(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26853,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
/* library.scm:4726: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_26701(t3,((C_word*)t0)[5],t1,t2);}

/* k26859 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26861(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_26861,c,av);}
a=C_alloc(6);
t2=C_make_character(C_unfix(t1));
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26853,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4726: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}

/* k26868 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26870(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_26870,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26877,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4729: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}

/* k26875 in k26868 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_26877(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26877,c,av);}
a=C_alloc(3);
t2=C_make_character(C_unfix(((C_word*)t0)[2]));
t3=C_a_i_cons(&a,2,t2,((C_word*)t0)[3]);
/* library.scm:4729: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_26701(t4,((C_word*)t0)[5],t1,t3);}

/* k26892 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_26894(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_26894,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26901,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4733: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}

/* k26899 in k26892 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_26901(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26901,c,av);}
a=C_alloc(3);
t2=C_make_character(C_unfix(((C_word*)t0)[2]));
t3=C_a_i_cons(&a,2,t2,((C_word*)t0)[3]);
/* library.scm:4733: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_26701(t4,((C_word*)t0)[5],t1,t3);}

/* k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void f_26918(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,2)))){
C_save_and_reclaim_args((void *)trf_26918,2,t0,t1);}
a=C_alloc(8);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_26925,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4736: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}}
else{
t2=C_eqp(((C_word*)t0)[7],C_make_character(10));
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_26938,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[8],tmp=(C_word)a,a+=8,tmp);
if(C_truep(t2)){
t4=t3;
f_26938(t4,t2);}
else{
t4=C_eqp(((C_word*)t0)[7],C_make_character(13));
if(C_truep(t4)){
t5=t3;
f_26938(t5,t4);}
else{
t5=C_eqp(((C_word*)t0)[7],C_make_character(32));
t6=t3;
f_26938(t6,(C_truep(t5)?t5:C_eqp(((C_word*)t0)[7],C_make_character(9))));}}}}

/* k26923 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_26925(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_26925,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3]);
/* library.scm:4736: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_26701(t3,((C_word*)t0)[5],t1,t2);}

/* k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_26938(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,4)))){
C_save_and_reclaim_args((void *)trf_26938,2,t0,t1);}
a=C_alloc(9);
if(C_truep(t1)){
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_26943,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word)li778),tmp=(C_word)a,a+=7,tmp));
t5=((C_word*)t3)[1];
f_26943(t5,((C_word*)t0)[5],((C_word*)((C_word*)t0)[6])[1],C_SCHEME_FALSE);}
else{
if(C_truep(C_eofp(((C_word*)((C_word*)t0)[6])[1]))){
/* library.scm:4762: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word av2[4];
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[5];
av2[2]=((C_word*)t0)[2];
av2[3]=lf[938];
tp(4,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_27042,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
if(C_truep(C_u_i_char_numericp(((C_word*)((C_word*)t0)[6])[1]))){
t3=C_i_char_greater_or_equal_p(((C_word*)((C_word*)t0)[6])[1],C_make_character(48));
t4=t2;
f_27042(t4,(C_truep(t3)?C_i_char_less_or_equal_p(((C_word*)((C_word*)t0)[6])[1],C_make_character(55)):C_SCHEME_FALSE));}
else{
t3=t2;
f_27042(t3,C_SCHEME_FALSE);}}}}

/* eat-ws in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void f_26943(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_26943,4,t0,t1,t2,t3);}
a=C_alloc(6);
t4=C_eqp(t2,C_make_character(32));
t5=(C_truep(t4)?t4:C_eqp(t2,C_make_character(9)));
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26960,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4742: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
switch(t2){
case C_make_character(13):
if(C_truep(t3)){
/* library.scm:4745: loop */
t6=((C_word*)((C_word*)t0)[4])[1];
f_26701(t6,t1,t2,((C_word*)t0)[5]);}
else{
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_26975,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4746: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
case C_make_character(10):
if(C_truep(t3)){
/* library.scm:4752: loop */
t6=((C_word*)((C_word*)t0)[4])[1];
f_26701(t6,t1,t2,((C_word*)t0)[5]);}
else{
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27010,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4753: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
default:
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27013,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
if(C_truep(t3)){
/* library.scm:4759: loop */
t7=((C_word*)((C_word*)t0)[4])[1];
f_26701(t7,t1,t2,((C_word*)t0)[5]);}
else{
/* library.scm:4756: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word av2[4];
av2[0]=*((C_word*)lf[917]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[937];
tp(4,av2);}}}}}

/* k26958 in eat-ws in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_26960(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_26960,c,av);}
/* library.scm:4742: eat-ws */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26943(t2,((C_word*)t0)[3],t1,((C_word*)t0)[4]);}

/* k26973 in eat-ws in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_26975(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_26975,c,av);}
a=C_alloc(4);
t2=C_eqp(t1,C_make_character(10));
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_26988,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4748: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}
else{
/* library.scm:4749: eat-ws */
t3=((C_word*)((C_word*)t0)[2])[1];
f_26943(t3,((C_word*)t0)[3],t1,C_SCHEME_TRUE);}}

/* k26986 in k26973 in eat-ws in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_26988(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_26988,c,av);}
/* library.scm:4748: eat-ws */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26943(t2,((C_word*)t0)[3],t1,C_SCHEME_TRUE);}

/* k27008 in eat-ws in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27010(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_27010,c,av);}
/* library.scm:4753: eat-ws */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26943(t2,((C_word*)t0)[3],t1,C_SCHEME_TRUE);}

/* k27011 in eat-ws in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27013(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_27013,c,av);}
/* library.scm:4759: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26701(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}

/* k27040 in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void f_27042(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_27042,2,t0,t1);}
a=C_alloc(7);
if(C_truep(t1)){
t2=C_fix(C_character_code(((C_word*)((C_word*)t0)[2])[1]));
t3=C_fixnum_difference(t2,C_fix(48));
t4=C_fixnum_times(t3,C_fix(64));
t5=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27068,a[2]=t4,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
/* library.scm:4768: r-usequence */
t6=((C_word*)((C_word*)t0)[7])[1];
f_26491(t6,t5,lf[939],C_fix(2),C_fix(8));}
else{
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27079,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
/* library.scm:4771: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word av2[5];
av2[0]=*((C_word*)lf[917]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=lf[940];
av2[4]=((C_word*)((C_word*)t0)[2])[1];
tp(5,av2);}}}

/* k27050 in k27066 in k27040 in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_27052(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_27052,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
/* library.scm:4769: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_26701(t3,((C_word*)t0)[5],t1,t2);}

/* k27066 in k27040 in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27068(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_27068,c,av);}
a=C_alloc(6);
t2=C_fixnum_plus(((C_word*)t0)[2],t1);
t3=C_make_character(C_unfix(t2));
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27052,a[2]=t3,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4769: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}}

/* k27077 in k27040 in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27079(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_27079,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27086,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4775: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}}

/* k27084 in k27077 in k27040 in k26936 in k26916 in k26716 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_27086(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_27086,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3]);
/* library.scm:4775: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_26701(t3,((C_word*)t0)[5],t1,t2);}

/* k27182 in loop in k26697 in r-string in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27184(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_27184,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3]);
/* library.scm:4777: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_26701(t3,((C_word*)t0)[5],t1,t2);}

/* r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_27190(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,0,2)))){
C_save_and_reclaim_args((void *)trf_27190,4,t0,t1,t2,t3);}
a=C_alloc(12);
t4=(*a=C_CLOSURE_TYPE|11,a[1]=(C_word)f_27449,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t1,a[6]=t3,a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[5],a[9]=((C_word*)t0)[6],a[10]=((C_word*)t0)[7],a[11]=((C_word*)t0)[8],tmp=(C_word)a,a+=12,tmp);
/* library.scm:4780: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* starting-line in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_27199(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_27199,3,t0,t1,t2);}
a=C_alloc(4);
t3=(C_truep(((C_word*)((C_word*)t0)[2])[1])?C_fast_retrieve(lf[910]):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27213,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4788: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t4;
av2[2]=((C_word*)((C_word*)t0)[2])[1];
tp(3,av2);}}
else{
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k27211 in starting-line in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27213(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27213,c,av);}
/* library.scm:4786: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[941];
av2[4]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k27214 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_27216(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_27216,c,av);}
a=C_alloc(5);
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,((C_word*)t0)[3]);
if(C_truep(((C_word*)((C_word*)t0)[4])[1])){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27227,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4855: ##sys#infix-list-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[912]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[912]+1);
av2[1]=t3;
av2[2]=((C_word*)((C_word*)t0)[4])[1];
tp(3,av2);}}
else{
t3=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k27225 in k27214 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27227(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27227,c,av);}
/* library.scm:4855: info */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26211(t2,((C_word*)t0)[3],lf[942],t1,((C_word*)((C_word*)t0)[4])[1]);}

/* a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_27229(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(22,c,3)))){
C_save_and_reclaim((void *)f_27229,c,av);}
a=C_alloc(22);
t3=C_mutate(((C_word *)((C_word*)t0)[2])+1,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27232,a[2]=((C_word*)t0)[3],a[3]=t2,a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word)li782),tmp=(C_word)a,a+=7,tmp));
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_27254,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=t5,a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word)li784),tmp=(C_word)a,a+=13,tmp));
t7=((C_word*)t5)[1];
f_27254(t7,t1,C_SCHEME_END_OF_LIST);}

/* f_27232 in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27232(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_27232,c,av);}
a=C_alloc(6);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
/* library.scm:4795: return */
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
av2[2]=C_SCHEME_FALSE;
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27249,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=t2,a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4798: starting-line */
t5=((C_word*)t0)[5];
f_27199(t5,t4,lf[943]);}}

/* k27247 */
static void C_ccall f_27249(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_27249,c,av);}
/* library.scm:4796: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=((C_word*)t0)[4];
av2[5]=((C_word*)t0)[5];
tp(6,av2);}}

/* loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_27254(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,0,2)))){
C_save_and_reclaim_args((void *)trf_27254,3,t0,t1,t2);}
a=C_alloc(14);
t3=(*a=C_CLOSURE_TYPE|13,a[1]=(C_word)f_27258,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=t2,a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],a[9]=((C_word*)t0)[7],a[10]=((C_word*)t0)[8],a[11]=((C_word*)t0)[9],a[12]=((C_word*)t0)[10],a[13]=((C_word*)t0)[11],tmp=(C_word)a,a+=14,tmp);
/* library.scm:4801: r-spaces */
t4=((C_word*)((C_word*)t0)[5])[1];
f_26443(t4,t3);}

/* k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_27258(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(17,c,2)))){
C_save_and_reclaim((void *)f_27258,c,av);}
a=C_alloc(17);
t2=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_27261,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],tmp=(C_word)a,a+=13,tmp);
if(C_truep(((C_word*)((C_word*)t0)[9])[1])){
t3=t2;
f_27261(t3,C_SCHEME_UNDEFINED);}
else{
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27442,a[2]=((C_word*)t0)[13],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4802: ##sys#port-line */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[887]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[887]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}}

/* k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_27261(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,0,2)))){
C_save_and_reclaim_args((void *)trf_27261,2,t0,t1);}
a=C_alloc(13);
t2=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_27264,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],tmp=(C_word)a,a+=13,tmp);
/* library.scm:4803: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_27264(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,2)))){
C_save_and_reclaim((void *)f_27264,c,av);}
a=C_alloc(13);
if(C_truep(C_eofp(t1))){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27274,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4807: starting-line */
t3=((C_word*)t0)[4];
f_27199(t3,t2,lf[944]);}
else{
t2=C_eqp(t1,((C_word*)t0)[5]);
if(C_truep(t2)){
/* library.scm:4809: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
t3=C_eqp(t1,C_make_character(46));
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_27292,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],tmp=(C_word)a,a+=13,tmp);
/* library.scm:4811: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27438,a[2]=((C_word*)t0)[9],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[10],a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4848: readrec */
t5=((C_word*)((C_word*)t0)[8])[1];
f_26440(t5,t4);}}}}

/* k27272 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27274(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_27274,c,av);}
/* library.scm:4805: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27292(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,2)))){
C_save_and_reclaim((void *)f_27292,c,av);}
a=C_alloc(13);
t2=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_27295,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],tmp=(C_word)a,a+=13,tmp);
/* library.scm:4812: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}

/* k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_27295(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,2)))){
C_save_and_reclaim((void *)f_27295,c,av);}
a=C_alloc(14);
t2=C_u_i_char_whitespacep(t1);
t3=(*a=C_CLOSURE_TYPE|13,a[1]=(C_word)f_27304,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=t1,a[13]=((C_word*)t0)[12],tmp=(C_word)a,a+=14,tmp);
if(C_truep(t2)){
t4=t3;
f_27304(t4,t2);}
else{
t4=C_eqp(t1,C_make_character(40));
if(C_truep(t4)){
t5=t3;
f_27304(t5,t4);}
else{
t5=C_eqp(t1,C_make_character(41));
if(C_truep(t5)){
t6=t3;
f_27304(t6,t5);}
else{
t6=C_eqp(t1,C_make_character(34));
t7=t3;
f_27304(t7,(C_truep(t6)?t6:C_eqp(t1,C_make_character(59))));}}}}

/* k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void f_27304(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,4)))){
C_save_and_reclaim_args((void *)trf_27304,2,t0,t1);}
a=C_alloc(9);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_27307,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
if(C_truep(C_i_pairp(((C_word*)t0)[2]))){
t3=t2;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_27307(2,av2);}}
else{
/* library.scm:4819: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word av2[4];
av2[0]=*((C_word*)lf[914]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=lf[946];
tp(4,av2);}}}
else{
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_27348,a[2]=((C_word*)t0)[9],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[10],a[5]=((C_word*)t0)[11],a[6]=((C_word*)t0)[12],a[7]=((C_word)li783),tmp=(C_word)a,a+=8,tmp);
/* library.scm:4829: r-xtoken */
t3=((C_word*)((C_word*)t0)[13])[1];
f_27789(t3,((C_word*)t0)[4],t2);}}

/* k27305 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in ... */
static void C_ccall f_27307(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_27307,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_27310,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* library.scm:4820: r-spaces */
t3=((C_word*)((C_word*)t0)[7])[1];
f_26443(t3,t2);}

/* k27308 in k27305 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in ... */
static void C_ccall f_27310(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_27310,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_27337,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* library.scm:4821: readrec */
t3=((C_word*)((C_word*)t0)[8])[1];
f_26440(t3,t2);}

/* k27314 in k27335 in k27308 in k27305 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in ... */
static void C_ccall f_27316(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_27316,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27333,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4823: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k27327 in k27331 in k27314 in k27335 in k27308 in k27305 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ... */
static void C_ccall f_27329(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27329,c,av);}
/* library.scm:4824: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}

/* k27331 in k27314 in k27335 in k27308 in k27305 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in ... */
static void C_ccall f_27333(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_27333,c,av);}
a=C_alloc(5);
t2=C_eqp(t1,((C_word*)t0)[2]);
if(C_truep(t2)){
t3=C_SCHEME_UNDEFINED;
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27329,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4826: starting-line */
t4=((C_word*)t0)[5];
f_27199(t4,t3,lf[945]);}}

/* k27335 in k27308 in k27305 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in ... */
static void C_ccall f_27337(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_27337,c,av);}
a=C_alloc(6);
t2=C_i_setslot(((C_word*)t0)[2],C_fix(1),t1);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27316,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4822: r-spaces */
t4=((C_word*)((C_word*)t0)[7])[1];
f_26443(t4,t3);}

/* a27347 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in ... */
static void C_ccall f_27348(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_27348,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_27352,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,a[6]=((C_word*)t0)[5],a[7]=t3,a[8]=((C_word*)t0)[6],tmp=(C_word)a,a+=9,tmp);
/* library.scm:4831: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[507]+1);
av2[1]=t4;
av2[2]=lf[950];
av2[3]=t2;
tp(4,av2);}}

/* k27350 in a27347 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in ... */
static void C_ccall f_27352(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_27352,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27355,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
t3=(C_truep(C_i_string_equal_p(t1,lf[947]))?C_eqp(((C_word*)((C_word*)t0)[6])[1],lf[948]):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f45445,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5045: ##sys#string->symbol-name */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[736]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[736]+1);
av2[1]=t4;
av2[2]=lf[949];
tp(3,av2);}}
else{
if(C_truep(((C_word*)t0)[7])){
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f45450,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5045: ##sys#string->symbol-name */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[736]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[736]+1);
av2[1]=t4;
av2[2]=t1;
tp(3,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27383,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_u_i_char_numericp(((C_word*)t0)[8]))){
/* library.scm:4840: ##sys#string->number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[725]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[725]+1);
av2[1]=t4;
av2[2]=t1;
tp(3,av2);}}
else{
/* library.scm:5042: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[739]+1);
av2[1]=t2;
av2[2]=t1;
tp(3,av2);}}}}}

/* k27353 in k27350 in a27347 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in ... */
static void C_ccall f_27355(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_27355,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_SCHEME_END_OF_LIST);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
t3=C_i_setslot(((C_word*)t0)[3],C_fix(1),t2);
/* library.scm:4846: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_27254(t4,((C_word*)t0)[5],t2);}
else{
t3=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
/* library.scm:4846: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_27254(t4,((C_word*)t0)[5],t2);}}

/* k27381 in k27350 in a27347 in k27302 in k27293 in k27290 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in ... */
static void C_ccall f_27383(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_27383,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
f_27355(2,av2);}}
else{
/* library.scm:5042: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[739]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}}

/* k27436 in k27262 in k27259 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27438(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_27438,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_SCHEME_END_OF_LIST);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
t3=C_i_setslot(((C_word*)t0)[3],C_fix(1),t2);
/* library.scm:4852: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_27254(t4,((C_word*)t0)[5],t2);}
else{
t3=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
/* library.scm:4852: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_27254(t4,((C_word*)t0)[5],t2);}}

/* k27440 in k27256 in loop in a27228 in k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_27442(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_27442,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=((C_word*)t0)[3];
f_27261(t3,t2);}

/* k27447 in r-list in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_27449(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,4)))){
C_save_and_reclaim((void *)f_27449,c,av);}
a=C_alloc(29);
t2=C_eqp(t1,((C_word*)t0)[2]);
if(C_truep(t2)){
t3=C_SCHEME_FALSE;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_SCHEME_FALSE;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=((C_word*)((C_word*)t0)[3])[1];
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27199,a[2]=t6,a[3]=((C_word)li781),tmp=(C_word)a,a+=4,tmp);
t9=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_27216,a[2]=((C_word*)t0)[3],a[3]=t7,a[4]=t4,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=t6,tmp=(C_word)a,a+=8,tmp);
t10=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_27229,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],a[5]=t8,a[6]=((C_word*)t0)[8],a[7]=((C_word*)t0)[9],a[8]=t4,a[9]=((C_word*)t0)[10],a[10]=((C_word*)t0)[11],a[11]=t6,a[12]=((C_word)li785),tmp=(C_word)a,a+=13,tmp);
/* library.scm:4790: ##sys#call-with-current-continuation */{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=t9;
av2[2]=t10;
C_call_cc(3,av2);}}
else{
/* library.scm:4857: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[5];
av2[2]=((C_word*)t0)[7];
av2[3]=lf[951];
av2[4]=((C_word*)t0)[2];
tp(5,av2);}}}

/* r-vector in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_27451(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,3)))){
C_save_and_reclaim_args((void *)trf_27451,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27455,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4860: r-list */
t3=((C_word*)((C_word*)t0)[3])[1];
f_27190(t3,t2,C_make_character(40),C_make_character(41));}

/* k27453 in r-vector in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_27455(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27455,c,av);}
if(C_truep(C_i_listp(t1))){
/* library.scm:4862: ##sys#list->vector */
t2=*((C_word*)lf[952]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}
else{
/* library.scm:4863: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[953];
av2[4]=t1;
tp(5,av2);}}}

/* r-number in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_27469(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_27469,4,t0,t1,t2,t3);}
a=C_alloc(7);
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27475,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=t3,a[6]=((C_word)li788),tmp=(C_word)a,a+=7,tmp);
/* library.scm:4866: r-xtoken */
t5=((C_word*)((C_word*)t0)[4])[1];
f_27789(t5,t1,t4);}

/* a27474 in r-number in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_27475(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_27475,c,av);}
a=C_alloc(8);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27482,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f45457,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5045: ##sys#string->symbol-name */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[736]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[736]+1);
av2[1]=t5;
av2[2]=t2;
tp(3,av2);}}
else{
if(C_truep(C_i_string_equal_p(t2,lf[955]))){
/* library.scm:4872: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2=av;
av2[0]=*((C_word*)lf[914]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[956];
tp(4,av2);}}
else{
t4=C_i_string_length(t2);
t5=C_fixnum_greaterp(t4,C_fix(0));
t6=(C_truep(t5)?C_u_i_char_equalp(C_i_string_ref(t2,C_fix(0)),C_make_character(35)):C_SCHEME_FALSE);
if(C_truep(t6)){
/* library.scm:4874: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[957];
av2[4]=t2;
tp(5,av2);}}
else{
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27509,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)t0)[4])){
/* library.scm:4875: ##sys#string->number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[725]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[725]+1);
av2[1]=t7;
av2[2]=t2;
av2[3]=((C_word*)t0)[4];
av2[4]=((C_word*)t0)[5];
tp(5,av2);}}
else{
/* library.scm:4875: ##sys#string->number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[725]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[725]+1);
av2[1]=t7;
av2[2]=t2;
av2[3]=C_fix(10);
av2[4]=((C_word*)t0)[5];
tp(5,av2);}}}}}}

/* k27480 in a27474 in r-number in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_27482(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_27482,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27489,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4870: ##sys#port-line */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[887]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[887]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k27487 in k27480 in a27474 in r-number in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27489(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27489,c,av);}
/* library.scm:4870: info */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26211(t2,((C_word*)t0)[3],lf[954],((C_word*)t0)[4],t1);}

/* k27507 in a27474 in r-number in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_27509(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27509,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
if(C_truep(((C_word*)t0)[3])){
/* library.scm:4876: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[4];
av2[3]=lf[958];
av2[4]=((C_word*)t0)[5];
tp(5,av2);}}
else{
/* library.scm:5042: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[739]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}}}

/* r-number-with-exactness in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_27538(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_27538,3,t0,t1,t2);}
a=C_alloc(6);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27587,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:4880: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k27546 in k27585 in r-number-with-exactness in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_27548(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_27548,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27551,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4882: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k27549 in k27546 in k27585 in r-number-with-exactness in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27551(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27551,c,av);}
if(C_truep(C_eofp(t1))){
/* library.scm:4884: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[959];
tp(4,av2);}}
else{
if(C_truep(C_i_char_equalp(t1,C_make_character(105)))){
/* library.scm:4885: r-number */
t2=((C_word*)((C_word*)t0)[4])[1];
f_27469(t2,((C_word*)t0)[2],((C_word*)t0)[5],lf[716]);}
else{
if(C_truep(C_u_i_char_equalp(t1,C_make_character(101)))){
/* library.scm:4886: r-number */
t2=((C_word*)((C_word*)t0)[4])[1];
f_27469(t2,((C_word*)t0)[2],((C_word*)t0)[5],lf[715]);}
else{
/* library.scm:4888: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[960];
av2[4]=t1;
tp(5,av2);}}}}}

/* k27585 in r-number-with-exactness in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_27587(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_27587,c,av);}
a=C_alloc(6);
t2=C_eqp(C_make_character(35),t1);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27548,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4881: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
/* library.scm:4891: r-number */
t3=((C_word*)((C_word*)t0)[4])[1];
f_27469(t3,((C_word*)t0)[2],((C_word*)t0)[5],C_SCHEME_FALSE);}}

/* r-number-with-radix in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_27589(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_27589,3,t0,t1,t2);}
a=C_alloc(6);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27654,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:4894: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k27597 in k27652 in r-number-with-radix in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_27599(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_27599,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27602,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4896: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k27600 in k27597 in k27652 in r-number-with-radix in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27602(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27602,c,av);}
if(C_truep(C_eofp(t1))){
/* library.scm:4897: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[961];
tp(4,av2);}}
else{
if(C_truep(C_i_char_equalp(t1,C_make_character(120)))){
/* library.scm:4898: r-number */
t2=((C_word*)((C_word*)t0)[4])[1];
f_27469(t2,((C_word*)t0)[2],C_fix(16),((C_word*)t0)[5]);}
else{
if(C_truep(C_u_i_char_equalp(t1,C_make_character(100)))){
/* library.scm:4899: r-number */
t2=((C_word*)((C_word*)t0)[4])[1];
f_27469(t2,((C_word*)t0)[2],C_fix(10),((C_word*)t0)[5]);}
else{
if(C_truep(C_u_i_char_equalp(t1,C_make_character(111)))){
/* library.scm:4900: r-number */
t2=((C_word*)((C_word*)t0)[4])[1];
f_27469(t2,((C_word*)t0)[2],C_fix(8),((C_word*)t0)[5]);}
else{
if(C_truep(C_u_i_char_equalp(t1,C_make_character(98)))){
/* library.scm:4901: r-number */
t2=((C_word*)((C_word*)t0)[4])[1];
f_27469(t2,((C_word*)t0)[2],C_fix(2),((C_word*)t0)[5]);}
else{
/* library.scm:4902: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[962];
av2[4]=t1;
tp(5,av2);}}}}}}}

/* k27652 in r-number-with-radix in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_27654(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_27654,c,av);}
a=C_alloc(6);
t2=C_eqp(C_make_character(35),t1);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27599,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4895: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
/* library.scm:4903: r-number */
t3=((C_word*)((C_word*)t0)[4])[1];
f_27469(t3,((C_word*)t0)[2],C_fix(10),((C_word*)t0)[5]);}}

/* r-token in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_27656(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_27656,2,t0,t1);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27664,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:4906: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k27662 in r-token in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_27664(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_27664,c,av);}
a=C_alloc(10);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_27666,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word)li792),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_27666(t5,((C_word*)t0)[6],t1,C_SCHEME_END_OF_LIST);}

/* loop in k27662 in r-token in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_27666(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,2)))){
C_save_and_reclaim_args((void *)trf_27666,4,t0,t1,t2,t3);}
a=C_alloc(9);
t4=C_eofp(t2);
t5=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_27676,a[2]=t1,a[3]=t3,a[4]=t2,a[5]=((C_word*)t0)[2],a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[5],tmp=(C_word)a,a+=9,tmp);
if(C_truep(t4)){
t6=t5;
f_27676(t6,t4);}
else{
t6=C_u_i_char_whitespacep(t2);
t7=t5;
f_27676(t7,(C_truep(t6)?t6:C_i_memq(t2,((C_word*)t0)[6])));}}

/* k27674 in loop in k27662 in r-token in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_27676(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_27676,2,t0,t1);}
a=C_alloc(8);
if(C_truep(t1)){
/* library.scm:4910: ##sys#reverse-list->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[480]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[480]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
if(C_truep(C_i_char_equalp(((C_word*)t0)[4],C_make_character(0)))){
/* library.scm:4912: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word av2[4];
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[5];
av2[3]=lf[963];
tp(4,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_27691,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[7],a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
/* library.scm:4914: read-unreserved-char-0 */
t3=((C_word*)((C_word*)t0)[8])[1];
f_26266(t3,t2,((C_word*)t0)[5]);}}}

/* k27689 in k27674 in loop in k27662 in r-token in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_27691(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_27691,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27698,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
/* library.scm:4915: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[7];
tp(3,av2);}}

/* k27696 in k27689 in k27674 in loop in k27662 in r-token in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_27698(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_27698,c,av);}
a=C_alloc(3);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
t2=C_a_i_cons(&a,2,((C_word*)t0)[3],((C_word*)t0)[4]);
/* library.scm:4915: loop */
t3=((C_word*)((C_word*)t0)[5])[1];
f_27666(t3,((C_word*)t0)[6],t1,t2);}
else{
t2=C_utf_char_foldcase(((C_word*)t0)[3]);
t3=C_a_i_cons(&a,2,t2,((C_word*)t0)[4]);
/* library.scm:4915: loop */
t4=((C_word*)((C_word*)t0)[5])[1];
f_27666(t4,((C_word*)t0)[6],t1,t3);}}

/* r-digits in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_27718(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_27718,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27726,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4919: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k27724 in r-digits in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_27726(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_27726,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27728,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word)li794),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_27728(t5,((C_word*)t0)[3],t1,C_SCHEME_END_OF_LIST);}

/* loop in k27724 in r-digits in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_27728(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_27728,4,t0,t1,t2,t3);}
a=C_alloc(7);
t4=C_eofp(t2);
t5=(C_truep(t4)?t4:C_i_not(C_u_i_char_numericp(t2)));
if(C_truep(t5)){
/* library.scm:4921: ##sys#reverse-list->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[480]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[480]+1);
av2[1]=t1;
av2[2]=t3;
tp(3,av2);}}
else{
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27744,a[2]=t2,a[3]=t3,a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=((C_word*)t0)[3],tmp=(C_word)a,a+=7,tmp);
/* library.scm:4923: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}}

/* k27742 in loop in k27724 in r-digits in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27744(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_27744,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27751,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4924: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}}

/* k27749 in k27742 in loop in k27724 in r-digits in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_27751(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_27751,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
/* library.scm:4924: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_27728(t3,((C_word*)t0)[5],t1,t2);}

/* r-symbol in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_27764(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,4)))){
C_save_and_reclaim_args((void *)trf_27764,2,t0,t1);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27770,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word)li796),tmp=(C_word)a,a+=5,tmp);
/* library.scm:4927: r-xtoken */
t3=((C_word*)((C_word*)t0)[4])[1];
f_27789(t3,t1,t2);}

/* a27769 in r-symbol in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_27770(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_27770,c,av);}
a=C_alloc(8);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27774,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
if(C_truep(t3)){
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f45466,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5045: ##sys#string->symbol-name */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[736]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[736]+1);
av2[1]=t5;
av2[2]=t2;
tp(3,av2);}}
else{
/* library.scm:5042: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[739]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}}

/* k27772 in a27769 in r-symbol in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_27774(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_27774,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27781,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4930: ##sys#port-line */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[887]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[887]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k27779 in k27772 in a27769 in r-symbol in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27781(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27781,c,av);}
/* library.scm:4930: info */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26211(t2,((C_word*)t0)[3],lf[954],((C_word*)t0)[4],t1);}

/* r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_27789(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(18,0,2)))){
C_save_and_reclaim_args((void *)trf_27789,3,t0,t1,t2);}
a=C_alloc(18);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=(*a=C_CLOSURE_TYPE|11,a[1]=(C_word)f_27794,a[2]=t4,a[3]=t2,a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],a[9]=((C_word*)t0)[7],a[10]=((C_word*)t0)[8],a[11]=t1,tmp=(C_word)a,a+=12,tmp);
t6=C_eqp(((C_word*)((C_word*)t0)[2])[1],lf[967]);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28038,a[2]=t5,a[3]=((C_word*)t0)[6],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4935: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t7;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}}
else{
t7=t5;
f_27794(t7,C_SCHEME_FALSE);}}

/* k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_27794(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,0,5)))){
C_save_and_reclaim_args((void *)trf_27794,2,t0,t1);}
a=C_alloc(15);
t2=C_set_block_item(((C_word*)t0)[2],0,t1);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_27799,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t4,a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],a[10]=((C_word*)t0)[9],a[11]=((C_word*)t0)[10],a[12]=((C_word)li798),tmp=(C_word)a,a+=13,tmp));
t6=((C_word*)t4)[1];
f_27799(t6,((C_word*)t0)[11],C_SCHEME_END_OF_LIST,C_SCHEME_FALSE,C_SCHEME_FALSE);}

/* loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_27799(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(16,0,2)))){
C_save_and_reclaim_args((void *)trf_27799,5,t0,t1,t2,t3,t4);}
a=C_alloc(16);
t5=(*a=C_CLOSURE_TYPE|15,a[1]=(C_word)f_27803,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[3],a[6]=t4,a[7]=t3,a[8]=((C_word*)t0)[4],a[9]=((C_word*)t0)[5],a[10]=((C_word*)t0)[6],a[11]=((C_word*)t0)[7],a[12]=((C_word*)t0)[8],a[13]=((C_word*)t0)[9],a[14]=((C_word*)t0)[10],a[15]=((C_word*)t0)[11],tmp=(C_word)a,a+=16,tmp);
/* library.scm:4938: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[9];
tp(3,av2);}}

/* k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_27803(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(16,c,2)))){
C_save_and_reclaim((void *)f_27803,c,av);}
a=C_alloc(16);
t2=C_eofp(t1);
t3=(*a=C_CLOSURE_TYPE|15,a[1]=(C_word)f_27812,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=t1,a[10]=((C_word*)t0)[9],a[11]=((C_word*)t0)[10],a[12]=((C_word*)t0)[11],a[13]=((C_word*)t0)[12],a[14]=((C_word*)t0)[13],a[15]=((C_word*)t0)[14],tmp=(C_word)a,a+=16,tmp);
if(C_truep(t2)){
t4=t3;
f_27812(t4,t2);}
else{
t4=C_u_i_char_whitespacep(t1);
t5=t3;
f_27812(t5,(C_truep(t4)?t4:C_i_memq(t1,((C_word*)t0)[15])));}}

/* k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void f_27812(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,2)))){
C_save_and_reclaim_args((void *)trf_27812,2,t0,t1);}
a=C_alloc(9);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27818,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t0)[7])){
t3=C_eqp(((C_word*)((C_word*)t0)[8])[1],lf[948]);
if(C_truep(t3)){
if(C_truep(((C_word*)t0)[6])){
t4=t2;
f_27818(t4,((C_word*)t0)[6]);}
else{
t4=C_i_cdr(((C_word*)t0)[4]);
t5=t2;
f_27818(t5,C_i_not(C_i_nullp(t4)));}}
else{
t4=t2;
f_27818(t4,C_SCHEME_FALSE);}}
else{
t3=t2;
f_27818(t3,C_SCHEME_FALSE);}}
else{
if(C_truep(C_i_memq(((C_word*)t0)[9],((C_word*)((C_word*)t0)[10])[1]))){
/* library.scm:4955: reserved-character */
t2=((C_word*)((C_word*)t0)[11])[1];
f_26257(t2,((C_word*)t0)[3],((C_word*)t0)[9]);}
else{
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_27909,a[2]=((C_word*)t0)[12],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[13],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[14],a[8]=((C_word*)t0)[15],tmp=(C_word)a,a+=9,tmp);
/* library.scm:4957: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[14];
tp(3,av2);}}}}

/* k27816 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_27818(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_27818,2,t0,t1);}
a=C_alloc(5);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27825,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4947: ##sys#reverse-list->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[480]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[480]+1);
av2[1]=t2;
av2[2]=C_i_cdr(((C_word*)t0)[4]);
tp(3,av2);}}
else{
t2=(C_truep(((C_word*)((C_word*)t0)[5])[1])?(C_truep(((C_word*)t0)[6])?((C_word*)t0)[6]:C_i_not(C_i_nullp(((C_word*)t0)[4]))):C_SCHEME_FALSE);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27842,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4949: ##sys#reverse-list->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[480]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[480]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27848,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(((C_word*)((C_word*)t0)[5])[1])){
t4=C_i_not(((C_word*)t0)[6]);
t5=t3;
f_27848(t5,(C_truep(t4)?C_i_nullp(((C_word*)t0)[4]):C_SCHEME_FALSE));}
else{
t4=t3;
f_27848(t4,C_SCHEME_FALSE);}}}}

/* k27823 in k27816 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_27825(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_27825,c,av);}
/* library.scm:4947: k */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
av2[3]=C_SCHEME_TRUE;
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}

/* k27840 in k27816 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_27842(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_27842,c,av);}
/* library.scm:4949: k */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
av2[3]=C_SCHEME_TRUE;
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}

/* k27846 in k27816 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void f_27848(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,3)))){
C_save_and_reclaim_args((void *)trf_27848,2,t0,t1);}
a=C_alloc(4);
if(C_truep(t1)){
/* library.scm:4951: k */
t2=((C_word*)t0)[2];{
C_word av2[4];
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=lf[964];
av2[3]=C_SCHEME_FALSE;
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27858,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4953: ##sys#reverse-list->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[480]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[480]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}}

/* k27856 in k27846 in k27816 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27858(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_27858,c,av);}
/* library.scm:4953: k */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
av2[3]=C_SCHEME_FALSE;
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}

/* k27907 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_27909(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_27909,c,av);}
a=C_alloc(10);
switch(t1){
case C_make_character(124):
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_27918,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:4960: r-string */
t3=((C_word*)((C_word*)t0)[5])[1];
f_26691(t3,t2,C_make_character(124));
case C_make_character(10):
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_27942,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27953,a[2]=t2,a[3]=((C_word*)t0)[7],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4966: ##sys#reverse-list->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[480]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[480]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}
case C_make_character(58):
t2=C_a_i_cons(&a,2,C_make_character(58),((C_word*)t0)[4]);
/* library.scm:4969: loop */
t3=((C_word*)((C_word*)t0)[2])[1];
f_27799(t3,((C_word*)t0)[3],t2,C_SCHEME_TRUE,((C_word*)t0)[6]);
case C_make_character(92):
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_27975,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[7],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[2],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
/* library.scm:4971: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[7];
tp(3,av2);}
default:
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28002,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)((C_word*)t0)[8])[1])){
t3=C_a_i_cons(&a,2,t1,((C_word*)t0)[4]);
/* library.scm:4978: loop */
t4=((C_word*)((C_word*)t0)[2])[1];
f_27799(t4,((C_word*)t0)[3],t3,C_SCHEME_FALSE,((C_word*)t0)[6]);}
else{
/* library.scm:4979: chicken.base#char-foldcase */
t3=*((C_word*)lf[296]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}}}

/* k27916 in k27907 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_27918(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_27918,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27925,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_27929,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_27933,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:4961: ##sys#string->list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[476]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[476]+1);
av2[1]=t4;
av2[2]=t1;
tp(3,av2);}}

/* k27923 in k27916 in k27907 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27925(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27925,c,av);}
/* library.scm:4961: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_27799(t2,((C_word*)t0)[3],t1,C_SCHEME_FALSE,C_SCHEME_TRUE);}

/* k27927 in k27916 in k27907 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27929(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_27929,c,av);}
/* library.scm:4961: scheme#append */
t2=*((C_word*)lf[443]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k27931 in k27916 in k27907 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_27933(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_27933,c,av);}
/* library.scm:4961: ##sys#fast-reverse */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[445]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[445]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* k27940 in k27907 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_27942(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_27942,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,C_make_character(10),((C_word*)t0)[2]);
/* library.scm:4967: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_27799(t3,((C_word*)t0)[4],t2,C_SCHEME_FALSE,((C_word*)t0)[5]);}

/* k27951 in k27907 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_27953(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_27953,c,av);}
/* library.scm:4964: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[965];
av2[4]=t1;
tp(5,av2);}}

/* k27973 in k27907 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_27975(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_27975,c,av);}
a=C_alloc(3);
if(C_truep(C_eofp(t1))){
/* library.scm:4973: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[966];
tp(4,av2);}}
else{
t2=C_a_i_cons(&a,2,t1,((C_word*)t0)[4]);
/* library.scm:4976: loop */
t3=((C_word*)((C_word*)t0)[5])[1];
f_27799(t3,((C_word*)t0)[2],t2,C_SCHEME_FALSE,((C_word*)t0)[6]);}}

/* k28000 in k27907 in k27810 in k27801 in loop in k27792 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_28002(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_28002,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,((C_word*)t0)[2]);
/* library.scm:4978: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_27799(t3,((C_word*)t0)[4],t2,C_SCHEME_FALSE,((C_word*)t0)[5]);}

/* k28032 in k28036 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_28034(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28034,c,av);}
t2=((C_word*)t0)[2];
f_27794(t2,C_SCHEME_TRUE);}

/* k28036 in r-xtoken in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_28038(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_28038,c,av);}
a=C_alloc(3);
t2=C_eqp(C_make_character(58),t1);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_28034,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4936: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
t3=((C_word*)t0)[2];
f_27794(t3,C_SCHEME_FALSE);}}

/* r-char in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_28040(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_28040,2,t0,t1);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28044,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4984: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k28042 in r-char in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_28044(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_28044,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28047,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:4985: r-token */
t3=((C_word*)((C_word*)t0)[5])[1];
f_27656(t3,t2);}

/* k28045 in k28042 in r-char in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_28047(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_28047,c,av);}
a=C_alloc(11);
t2=C_i_string_length(t1);
if(C_truep(C_fixnum_greaterp(t2,C_fix(1)))){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28059,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
t4=C_i_char_equalp(C_make_character(120),((C_word*)t0)[4]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28232,a[2]=t3,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
if(C_truep(t4)){
t6=t5;
f_28232(t6,t4);}
else{
t6=C_u_i_char_equalp(C_make_character(117),((C_word*)t0)[4]);
t7=t5;
f_28232(t7,(C_truep(t6)?t6:C_u_i_char_equalp(C_make_character(85),((C_word*)t0)[4])));}}
else{
if(C_truep(C_i_memq(((C_word*)t0)[4],((C_word*)t0)[5]))){
/* library.scm:5015: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}}

/* k28057 in k28045 in k28042 in r-char in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_28059(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_28059,c,av);}
a=C_alloc(5);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_make_character(C_unfix(t1));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=C_i_string_ref(((C_word*)t0)[3],C_fix(0));
t3=C_fix(C_character_code(t2));
t4=C_fixnum_less_or_equal_p(C_fix(192),t3);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28079,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
if(C_truep(t4)){
if(C_truep(C_fixnum_less_or_equal_p(t3,C_fix(247)))){
t6=C_fixnum_shift_right(t3,C_fix(4));
t7=C_fixnum_and(t6,C_fix(3));
t8=C_fixnum_shift_right(t7,C_fix(1));
t9=C_fixnum_or(t7,t8);
t10=C_fixnum_difference(t7,C_fix(1));
t11=C_fixnum_and(t9,t10);
t12=C_fixnum_plus(C_fix(2),t11);
t13=C_eqp(((C_word*)t0)[5],t12);
if(C_truep(t13)){
t14=C_fixnum_difference(C_fix(8),t12);
t15=C_fixnum_shift_left(C_fix(1),t14);
t16=C_fixnum_difference(t15,C_fix(1));
t17=C_fixnum_and(t3,t16);
t18=C_fixnum_shift_left(t17,C_fix(6));
t19=C_i_string_ref(((C_word*)t0)[3],C_fix(1));
t20=C_fix(C_character_code(t19));
t21=C_fixnum_and(t20,C_fix(63));
t22=C_fixnum_plus(t18,t21);
t23=t22;
if(C_truep(t23)){
if(C_truep(C_fixnum_greater_or_equal_p(t12,C_fix(3)))){
t24=C_fixnum_shift_left(t23,C_fix(6));
t25=C_i_string_ref(((C_word*)t0)[3],C_fix(2));
t26=C_fix(C_character_code(t25));
t27=C_fixnum_and(t26,C_fix(63));
t28=C_fixnum_plus(t24,t27);
t29=t23=t28;
t30=C_eqp(t12,C_fix(4));
if(C_truep(t30)){
t31=C_fixnum_shift_left(t23,C_fix(6));
t32=C_i_string_ref(((C_word*)t0)[3],C_fix(3));
t33=C_fix(C_character_code(t32));
t34=C_fixnum_and(t33,C_fix(63));
t35=C_fixnum_plus(t31,t34);
t36=t23=t35;
t37=t5;
f_28079(t37,C_make_character(C_unfix(t23)));}
else{
t31=t5;
f_28079(t31,C_make_character(C_unfix(t23)));}}
else{
t24=t5;
f_28079(t24,C_make_character(C_unfix(t23)));}}
else{
t24=t5;
f_28079(t24,C_SCHEME_FALSE);}}
else{
t14=t5;
f_28079(t14,C_SCHEME_FALSE);}}
else{
t6=t5;
f_28079(t6,C_SCHEME_FALSE);}}
else{
t6=t5;
f_28079(t6,C_SCHEME_FALSE);}}}

/* k28077 in k28057 in k28045 in k28042 in r-char in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void f_28079(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,2)))){
C_save_and_reclaim_args((void *)trf_28079,2,t0,t1);}
a=C_alloc(8);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28085,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_28095,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5013: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[739]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}}

/* k28083 in k28077 in k28057 in k28045 in k28042 in r-char in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28085(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_28085,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:5014: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[968];
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}}

/* k28093 in k28077 in k28057 in k28045 in k28042 in r-char in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28095(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28095,c,av);}
/* library.scm:5013: chicken.base#char-name */
t2=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k28230 in k28045 in k28042 in r-char in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_28232(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,0,4)))){
C_save_and_reclaim_args((void *)trf_28232,2,t0,t1);}
a=C_alloc(3);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_28239,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:4989: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[486]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
av2[3]=C_fix(1);
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
f_28059(2,av2);}}}

/* k28237 in k28230 in k28045 in k28042 in r-char in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_28239(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_28239,c,av);}
/* library.scm:4989: ##sys#string->number */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[725]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[725]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_fix(16);
tp(4,av2);}}

/* r-comment in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_28257(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_28257,2,t0,t1);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28263,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word)li801),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_28263(t5,t1,C_fix(0));}

/* loop in r-comment in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_28263(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_28263,3,t0,t1,t2);}
a=C_alloc(6);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28267,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5020: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k28265 in loop in r-comment in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_28267(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_28267,c,av);}
a=C_alloc(5);
switch(t1){
case C_make_character(124):
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28303,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5022: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}
case C_make_character(35):
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28326,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5026: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}
default:
if(C_truep(C_eofp(t1))){
/* library.scm:5030: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[5];
av2[3]=lf[969];
tp(4,av2);}}
else{
/* library.scm:5031: loop */
t2=((C_word*)((C_word*)t0)[3])[1];
f_28263(t2,((C_word*)t0)[4],((C_word*)t0)[2]);}}}

/* k28301 in k28265 in loop in r-comment in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_28303(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28303,c,av);}
t2=C_eqp(C_make_character(35),t1);
if(C_truep(t2)){
t3=C_eqp(((C_word*)t0)[2],C_fix(0));
if(C_truep(C_i_not(t3))){
/* library.scm:5024: loop */
t4=((C_word*)((C_word*)t0)[3])[1];
f_28263(t4,((C_word*)t0)[4],C_fixnum_difference(((C_word*)t0)[2],C_fix(1)));}
else{
t4=C_SCHEME_UNDEFINED;
t5=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}
else{
/* library.scm:5025: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_28263(t3,((C_word*)t0)[4],((C_word*)t0)[2]);}}

/* k28324 in k28265 in loop in r-comment in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_28326(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28326,c,av);}
t2=C_eqp(C_make_character(124),t1);
if(C_truep(t2)){
/* library.scm:5026: loop */
t3=((C_word*)((C_word*)t0)[2])[1];
f_28263(t3,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}
else{
/* library.scm:5026: loop */
t3=((C_word*)((C_word*)t0)[2])[1];
f_28263(t3,((C_word*)t0)[3],((C_word*)t0)[4]);}}

/* r-ext-symbol in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_28344(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_28344,2,t0,t1);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_28348,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5034: r-token */
t3=((C_word*)((C_word*)t0)[2])[1];
f_27656(t3,t2);}

/* k28346 in r-ext-symbol in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_28348(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_28348,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_28355,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5035: string-append */
t3=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[970];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k28353 in k28346 in r-ext-symbol in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_28355(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28355,c,av);}
/* library.scm:5042: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[739]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* r-quote in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_28357(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_28357,3,t0,t1,t2);}
a=C_alloc(6);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28361,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5038: ##sys#port-line */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[887]);
C_word av2[3];
av2[0]=*((C_word*)lf[887]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k28359 in r-quote in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_28361(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_28361,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28372,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:5039: readrec */
t3=((C_word*)((C_word*)t0)[5])[1];
f_26440(t3,t2);}

/* k28370 in k28359 in r-quote in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_28372(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_28372,c,av);}
a=C_alloc(6);
t2=C_a_i_list2(&a,2,((C_word*)t0)[2],t1);
/* library.scm:5039: info */
t3=((C_word*)((C_word*)t0)[3])[1];
f_26211(t3,((C_word*)t0)[4],lf[942],t2,((C_word*)t0)[5]);}

/* k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_28392(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,2)))){
C_save_and_reclaim((void *)f_28392,c,av);}
a=C_alloc(29);
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=(*a=C_CLOSURE_TYPE|28,a[1]=(C_word)f_28395,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],a[9]=((C_word*)t0)[10],a[10]=((C_word*)t0)[11],a[11]=((C_word*)t0)[12],a[12]=((C_word*)t0)[13],a[13]=((C_word*)t0)[14],a[14]=((C_word*)t0)[15],a[15]=((C_word*)t0)[16],a[16]=((C_word*)t0)[17],a[17]=((C_word*)t0)[18],a[18]=((C_word*)t0)[19],a[19]=((C_word*)t0)[20],a[20]=((C_word*)t0)[21],a[21]=((C_word*)t0)[22],a[22]=((C_word*)t0)[23],a[23]=((C_word*)t0)[24],a[24]=((C_word*)t0)[25],a[25]=((C_word*)t0)[26],a[26]=((C_word*)t0)[2],a[27]=((C_word*)t0)[27],a[28]=((C_word*)t0)[28],tmp=(C_word)a,a+=29,tmp);
/* library.scm:5051: r-spaces */
t4=((C_word*)((C_word*)t0)[29])[1];
f_26443(t4,t3);}

/* k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_28395(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,2)))){
C_save_and_reclaim((void *)f_28395,c,av);}
a=C_alloc(29);
t2=(*a=C_CLOSURE_TYPE|28,a[1]=(C_word)f_28398,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],a[13]=((C_word*)t0)[13],a[14]=((C_word*)t0)[14],a[15]=((C_word*)t0)[15],a[16]=((C_word*)t0)[16],a[17]=((C_word*)t0)[17],a[18]=((C_word*)t0)[18],a[19]=((C_word*)t0)[19],a[20]=((C_word*)t0)[20],a[21]=((C_word*)t0)[21],a[22]=((C_word*)t0)[22],a[23]=((C_word*)t0)[23],a[24]=((C_word*)t0)[24],a[25]=((C_word*)t0)[25],a[26]=((C_word*)t0)[26],a[27]=((C_word*)t0)[27],a[28]=((C_word*)t0)[28],tmp=(C_word)a,a+=29,tmp);
/* library.scm:5052: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_28398(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(23,c,3)))){
C_save_and_reclaim((void *)f_28398,c,av);}
a=C_alloc(23);
t2=C_slot(((C_word*)t0)[2],C_fix(1));
t3=C_eofp(t1);
t4=C_i_not(t3);
t5=(C_truep(t4)?(C_truep(t2)?C_slot(t2,C_fix(C_character_code(t1))):C_SCHEME_FALSE):C_SCHEME_FALSE);
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28412,a[2]=t5,a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word)li805),tmp=(C_word)a,a+=6,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28418,a[2]=((C_word*)t0)[4],a[3]=((C_word)li806),tmp=(C_word)a,a+=4,tmp);
/* library.scm:5058: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[5];
av2[2]=t6;
av2[3]=t7;
C_call_with_values(4,av2);}}
else{
switch(t1){
case C_make_character(39):
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28440,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5064: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(96):
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28452,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5067: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(44):
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28464,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5070: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(35):
t6=(*a=C_CLOSURE_TYPE|22,a[1]=(C_word)f_28492,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],a[13]=((C_word*)t0)[13],a[14]=((C_word*)t0)[14],a[15]=((C_word*)t0)[15],a[16]=((C_word*)t0)[6],a[17]=((C_word*)t0)[16],a[18]=((C_word*)t0)[17],a[19]=((C_word*)t0)[18],a[20]=((C_word*)t0)[19],a[21]=((C_word*)t0)[20],a[22]=((C_word*)t0)[21],tmp=(C_word)a,a+=23,tmp);
/* library.scm:5076: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(40):
/* library.scm:5199: r-list */
t6=((C_word*)((C_word*)t0)[22])[1];
f_27190(t6,((C_word*)t0)[5],C_make_character(40),C_make_character(41));
case C_make_character(41):
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29115,a[2]=((C_word*)t0)[23],a[3]=((C_word*)t0)[5],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5200: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(34):
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_29127,a[2]=((C_word*)t0)[24],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5201: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(46):
/* library.scm:5202: r-number */
t6=((C_word*)((C_word*)t0)[25])[1];
f_27469(t6,((C_word*)t0)[5],C_SCHEME_FALSE,C_SCHEME_FALSE);
default:
t6=C_eqp(t1,C_make_character(45));
t7=(C_truep(t6)?t6:C_eqp(t1,C_make_character(43)));
if(C_truep(t7)){
/* library.scm:5203: r-number */
t8=((C_word*)((C_word*)t0)[25])[1];
f_27469(t8,((C_word*)t0)[5],C_SCHEME_FALSE,C_SCHEME_FALSE);}
else{
if(C_truep(C_eofp(t1))){
t8=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t8;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
if(C_truep(C_u_i_char_numericp(t1))){
/* library.scm:5206: r-number */
t8=((C_word*)((C_word*)t0)[25])[1];
f_27469(t8,((C_word*)t0)[5],C_SCHEME_FALSE,C_SCHEME_FALSE);}
else{
if(C_truep(C_i_memq(t1,((C_word*)((C_word*)t0)[26])[1]))){
/* library.scm:5208: reserved-character */
t8=((C_word*)((C_word*)t0)[27])[1];
f_26257(t8,((C_word*)t0)[5],t1);}
else{
switch(t1){
case C_make_character(91):
/* library.scm:5211: r-list */
t8=((C_word*)((C_word*)t0)[22])[1];
f_27190(t8,((C_word*)t0)[5],C_make_character(91),C_make_character(93));
case C_make_character(123):
/* library.scm:5212: r-list */
t8=((C_word*)((C_word*)t0)[22])[1];
f_27190(t8,((C_word*)t0)[5],C_make_character(123),C_make_character(125));
default:
t8=C_eqp(t1,C_make_character(93));
t9=(C_truep(t8)?t8:C_eqp(t1,C_make_character(125)));
if(C_truep(t9)){
t10=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29205,a[2]=((C_word*)t0)[23],a[3]=((C_word*)t0)[5],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5213: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t10;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
/* library.scm:5214: r-symbol */
t10=((C_word*)((C_word*)t0)[28])[1];
f_27764(t10,((C_word*)t0)[5]);}}}}}}}}}

/* a28411 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_28412(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_28412,c,av);}
/* library.scm:5059: h */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}

/* a28417 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_28418(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28418,c,av);}
if(C_truep(C_rest_nullp(c,2))){
/* library.scm:5060: readrec */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26440(t2,t1);}
else{
t2=t1;{
C_word av2[2];
av2[0]=t2;
av2[1]=C_get_rest_arg(c,2,av,2,t0);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k28438 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_28440(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28440,c,av);}
/* library.scm:5065: r-quote */
t2=((C_word*)((C_word*)t0)[2])[1];
f_28357(t2,((C_word*)t0)[3],lf[971]);}

/* k28450 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_28452(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28452,c,av);}
/* library.scm:5068: r-quote */
t2=((C_word*)((C_word*)t0)[2])[1];
f_28357(t2,((C_word*)t0)[3],lf[972]);}

/* k28462 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_28464(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_28464,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28483,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5071: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k28471 in k28481 in k28462 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28473(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28473,c,av);}
/* library.scm:5073: r-quote */
t2=((C_word*)((C_word*)t0)[2])[1];
f_28357(t2,((C_word*)t0)[3],lf[973]);}

/* k28481 in k28462 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_28483(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_28483,c,av);}
a=C_alloc(4);
t2=C_eqp(t1,C_make_character(64));
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28473,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5072: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}
else{
/* library.scm:5074: r-quote */
t3=((C_word*)((C_word*)t0)[2])[1];
f_28357(t3,((C_word*)t0)[3],lf[974]);}}

/* k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_28492(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(23,c,2)))){
C_save_and_reclaim((void *)f_28492,c,av);}
a=C_alloc(23);
t2=(*a=C_CLOSURE_TYPE|22,a[1]=(C_word)f_28495,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],a[12]=((C_word*)t0)[12],a[13]=((C_word*)t0)[13],a[14]=((C_word*)t0)[14],a[15]=((C_word*)t0)[15],a[16]=((C_word*)t0)[16],a[17]=((C_word*)t0)[17],a[18]=((C_word*)t0)[18],a[19]=((C_word*)t0)[19],a[20]=((C_word*)t0)[20],a[21]=((C_word*)t0)[21],a[22]=((C_word*)t0)[22],tmp=(C_word)a,a+=23,tmp);
/* library.scm:5077: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_28495(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_28495,c,av);}
a=C_alloc(12);
if(C_truep(C_eofp(t1))){
/* library.scm:5080: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[975];
tp(4,av2);}}
else{
if(C_truep(C_u_i_char_numericp(t1))){
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_28513,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_28645,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5083: r-digits */
t4=((C_word*)((C_word*)t0)[9])[1];
f_27718(t4,t3);}
else{
t2=C_slot(((C_word*)t0)[4],C_fix(2));
t3=(C_truep(t2)?C_slot(t2,C_fix(C_character_code(t1))):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28659,a[2]=t3,a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word)li811),tmp=(C_word)a,a+=6,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28665,a[2]=((C_word*)t0)[7],a[3]=((C_word)li812),tmp=(C_word)a,a+=4,tmp);
/* library.scm:5122: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=t4;
av2[3]=t5;
C_call_with_values(4,av2);}}
else{
t4=C_u_i_char_downcase(t1);
switch(t4){
case C_make_character(120):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28690,a[2]=((C_word*)t0)[10],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5127: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(100):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28702,a[2]=((C_word*)t0)[10],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5128: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(111):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28714,a[2]=((C_word*)t0)[10],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5129: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(98):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28726,a[2]=((C_word*)t0)[10],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5130: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(105):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28738,a[2]=((C_word*)t0)[11],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5131: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(101):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28750,a[2]=((C_word*)t0)[11],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5132: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(40):
/* library.scm:5133: r-vector */
t5=((C_word*)((C_word*)t0)[12])[1];
f_27451(t5,((C_word*)t0)[2]);
case C_make_character(92):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28771,a[2]=((C_word*)t0)[13],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5134: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(124):
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28783,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[14],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5136: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(35):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28798,a[2]=((C_word*)t0)[15],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5139: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(59):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28810,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5142: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(96):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28825,a[2]=((C_word*)t0)[16],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5145: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(36):
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28837,a[2]=((C_word*)t0)[16],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5148: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(58):
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28849,a[2]=((C_word*)t0)[17],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[18],a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5152: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(43):
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28909,a[2]=((C_word*)t0)[19],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[7],a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5162: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
case C_make_character(33):
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_28939,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[20],a[5]=((C_word*)t0)[21],a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[22],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5169: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}
default:
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29039,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word)li817),tmp=(C_word)a,a+=5,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_29045,a[2]=((C_word*)t0)[7],a[3]=((C_word)li818),tmp=(C_word)a,a+=4,tmp);
/* library.scm:5197: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=t5;
av2[3]=t6;
C_call_with_values(4,av2);}}}}}}

/* k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28513(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_28513,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_28516,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],tmp=(C_word)a,a+=10,tmp);
/* library.scm:5084: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_28516(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_28516,c,av);}
a=C_alloc(7);
t2=C_slot(((C_word*)t0)[2],C_fix(3));
if(C_truep(C_eofp(t1))){
/* library.scm:5087: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=lf[976];
av2[4]=((C_word*)t0)[5];
av2[5]=((C_word*)t0)[6];
tp(6,av2);}}
else{
t3=C_eqp(C_make_character(61),t1);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28537,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[8],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5092: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}
else{
t4=C_eqp(C_make_character(35),t1);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28556,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[9],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5099: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}
else{
t5=C_charp(t1);
t6=(C_truep(t5)?(C_truep(t2)?C_slot(t2,C_fix(C_character_code(t1))):C_SCHEME_FALSE):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_28575,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[8],a[6]=((C_word)li810),tmp=(C_word)a,a+=7,tmp);
/* library.scm:5086: g5986 */
t8=t7;
f_28575(t8,((C_word*)t0)[3],t6);}
else{
t7=C_eqp(t1,C_make_character(41));
t8=(C_truep(t7)?t7:C_u_i_char_whitespacep(t1));
if(C_truep(t8)){
/* library.scm:5112: ##sys#sharp-number-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[913]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[913]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[6];
tp(4,av2);}}
else{
t9=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_28622,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:5113: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t9;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}}}}}}

/* k28535 in k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_28537(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(16,c,2)))){
C_save_and_reclaim((void *)f_28537,c,av);}
a=C_alloc(16);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28546,a[2]=t3,a[3]=((C_word)li807),tmp=(C_word)a,a+=4,tmp);
t5=(
/* library.scm:5094: register-shared! */
  f_26281(C_a_i(&a,6),((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3],t4)
);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28543,a[2]=t3,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5095: readrec */
t7=((C_word*)((C_word*)t0)[5])[1];
f_26440(t7,t6);}

/* k28541 in k28535 in k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_28543(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28543,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=((C_word*)((C_word*)t0)[2])[1];
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a28545 in k28535 in k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_28546(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28546,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)((C_word*)t0)[2])[1];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k28554 in k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_28556(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_28556,c,av);}
t2=C_i_assq(((C_word*)t0)[2],((C_word*)((C_word*)t0)[3])[1]);
if(C_truep(t2)){
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_cdr(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:5101: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[5];
av2[3]=lf[977];
av2[4]=((C_word*)t0)[2];
tp(5,av2);}}}

/* g5986 in k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void f_28575(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,0,3)))){
C_save_and_reclaim_args((void *)trf_28575,3,t0,t1,t2);}
a=C_alloc(15);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28583,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_28585,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word)li808),tmp=(C_word)a,a+=7,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28591,a[2]=((C_word*)t0)[5],a[3]=((C_word)li809),tmp=(C_word)a,a+=4,tmp);
/* library.scm:5107: ##sys#call-with-values */{
C_word av2[4];
av2[0]=0;
av2[1]=t3;
av2[2]=t4;
av2[3]=t5;
C_call_with_values(4,av2);}}

/* k28581 in g5986 in k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_28583(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28583,c,av);}
/* library.scm:5107: h */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* a28584 in g5986 in k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_28585(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_28585,c,av);}
/* library.scm:5108: h */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
av2[4]=((C_word*)t0)[5];
((C_proc)C_fast_retrieve_proc(t2))(5,av2);}}

/* a28590 in g5986 in k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_28591(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28591,c,av);}
if(C_truep(C_rest_nullp(c,2))){
/* library.scm:5109: readrec */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26440(t2,t1);}
else{
t2=t1;{
C_word av2[2];
av2[0]=t2;
av2[1]=C_get_rest_arg(c,2,av,2,t0);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k28620 in k28514 in k28511 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_28622(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_28622,c,av);}
/* library.scm:5114: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[978];
av2[4]=((C_word*)t0)[4];
av2[5]=((C_word*)t0)[5];
av2[6]=((C_word*)t0)[6];
tp(7,av2);}}

/* k28643 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28645(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28645,c,av);}
/* library.scm:5083: scheme#string->number */
t2=*((C_word*)lf[723]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* a28658 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28659(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_28659,c,av);}
/* library.scm:5123: h */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}

/* a28664 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28665(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28665,c,av);}
if(C_truep(C_rest_nullp(c,2))){
/* library.scm:5124: readrec */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26440(t2,t1);}
else{
t2=t1;{
C_word av2[2];
av2[0]=t2;
av2[1]=C_get_rest_arg(c,2,av,2,t0);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k28688 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28690(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28690,c,av);}
/* library.scm:5127: r-number-with-exactness */
t2=((C_word*)((C_word*)t0)[2])[1];
f_27538(t2,((C_word*)t0)[3],C_fix(16));}

/* k28700 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28702(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28702,c,av);}
/* library.scm:5128: r-number-with-exactness */
t2=((C_word*)((C_word*)t0)[2])[1];
f_27538(t2,((C_word*)t0)[3],C_fix(10));}

/* k28712 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28714(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28714,c,av);}
/* library.scm:5129: r-number-with-exactness */
t2=((C_word*)((C_word*)t0)[2])[1];
f_27538(t2,((C_word*)t0)[3],C_fix(8));}

/* k28724 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28726(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28726,c,av);}
/* library.scm:5130: r-number-with-exactness */
t2=((C_word*)((C_word*)t0)[2])[1];
f_27538(t2,((C_word*)t0)[3],C_fix(2));}

/* k28736 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28738(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28738,c,av);}
/* library.scm:5131: r-number-with-radix */
t2=((C_word*)((C_word*)t0)[2])[1];
f_27589(t2,((C_word*)t0)[3],lf[716]);}

/* k28748 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28750(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28750,c,av);}
/* library.scm:5132: r-number-with-radix */
t2=((C_word*)((C_word*)t0)[2])[1];
f_27589(t2,((C_word*)t0)[3],lf[715]);}

/* k28769 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28771(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28771,c,av);}
/* library.scm:5134: r-char */
t2=((C_word*)((C_word*)t0)[2])[1];
f_28040(t2,((C_word*)t0)[3]);}

/* k28781 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28783(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_28783,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28786,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5137: r-comment */
t3=((C_word*)((C_word*)t0)[4])[1];
f_28257(t3,t2);}

/* k28784 in k28781 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_28786(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28786,c,av);}
/* library.scm:5137: readrec */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26440(t2,((C_word*)t0)[3]);}

/* k28796 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28798(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28798,c,av);}
/* library.scm:5140: r-ext-symbol */
t2=((C_word*)((C_word*)t0)[2])[1];
f_28344(t2,((C_word*)t0)[3]);}

/* k28808 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28810(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_28810,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28813,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5143: readrec */
t3=((C_word*)((C_word*)t0)[2])[1];
f_26440(t3,t2);}

/* k28811 in k28808 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_28813(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28813,c,av);}
/* library.scm:5143: readrec */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26440(t2,((C_word*)t0)[3]);}

/* k28823 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28825(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28825,c,av);}
/* library.scm:5146: r-quote */
t2=((C_word*)((C_word*)t0)[2])[1];
f_28357(t2,((C_word*)t0)[3],lf[979]);}

/* k28835 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28837(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_28837,c,av);}
/* library.scm:5150: r-quote */
t2=((C_word*)((C_word*)t0)[2])[1];
f_28357(t2,((C_word*)t0)[3],lf[980]);}

/* k28847 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28849(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_28849,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28852,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5153: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k28850 in k28847 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_28852(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(22,c,4)))){
C_save_and_reclaim((void *)f_28852,c,av);}
a=C_alloc(22);
t2=C_SCHEME_FALSE;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_FALSE;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28857,a[2]=t5,a[3]=((C_word*)t0)[2],a[4]=t3,a[5]=((C_word)li813),tmp=(C_word)a,a+=6,tmp);
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28862,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word)li815),tmp=(C_word)a,a+=6,tmp);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28897,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=t5,a[5]=((C_word)li816),tmp=(C_word)a,a+=6,tmp);
/* library.scm:5154: ##sys#dynamic-wind */
t9=*((C_word*)lf[824]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t9;
av2[1]=((C_word*)t0)[5];
av2[2]=t6;
av2[3]=t7;
av2[4]=t8;
((C_proc)(void*)(*((C_word*)t9+1)))(5,av2);}}

/* a28856 in k28850 in k28847 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_28857(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28857,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,((C_word*)((C_word*)t0)[3])[1]);
t3=C_mutate(((C_word *)((C_word*)t0)[3])+1,((C_word*)((C_word*)t0)[4])[1]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a28861 in k28850 in k28847 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_28862(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_28862,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28868,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word)li814),tmp=(C_word)a,a+=5,tmp);
/* library.scm:5155: r-xtoken */
t3=((C_word*)((C_word*)t0)[4])[1];
f_27789(t3,t1,t2);}

/* a28867 in a28861 in k28850 in k28847 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_28868(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_28868,c,av);}
a=C_alloc(3);
t4=C_i_string_length(t2);
t5=C_eqp(C_fix(0),t4);
t6=(C_truep(t5)?C_i_not(C_i_char_equalp(((C_word*)t0)[2],C_make_character(124))):C_SCHEME_FALSE);
if(C_truep(t6)){
/* library.scm:5159: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2=av;
av2[0]=*((C_word*)lf[914]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[981];
tp(4,av2);}}
else{
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f45475,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5045: ##sys#string->symbol-name */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[736]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[736]+1);
av2[1]=t7;
av2[2]=t2;
tp(3,av2);}}}

/* a28896 in k28850 in k28847 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_28897(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28897,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,((C_word*)((C_word*)t0)[3])[1]);
t3=C_mutate(((C_word *)((C_word*)t0)[3])+1,((C_word*)((C_word*)t0)[4])[1]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k28907 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28909(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_28909,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_28912,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5163: ##sys#port-line */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[887]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[887]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}

/* k28910 in k28907 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_28912(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_28912,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28915,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5164: readrec */
t3=((C_word*)((C_word*)t0)[4])[1];
f_26440(t3,t2);}

/* k28913 in k28910 in k28907 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_28915(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_28915,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28930,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5166: readrec */
t3=((C_word*)((C_word*)t0)[5])[1];
f_26440(t3,t2);}

/* k28928 in k28913 in k28910 in k28907 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_28930(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,4)))){
C_save_and_reclaim((void *)f_28930,c,av);}
a=C_alloc(15);
t2=C_a_i_list2(&a,2,((C_word*)t0)[2],t1);
t3=C_a_i_list3(&a,3,lf[982],t2,lf[983]);
/* library.scm:5165: info */
t4=((C_word*)((C_word*)t0)[3])[1];
f_26211(t4,((C_word*)t0)[4],lf[942],t3,((C_word*)t0)[5]);}

/* k28937 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_28939(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_28939,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_28942,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5170: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}}

/* k28940 in k28937 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_28942(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_28942,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_28948,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
if(C_truep(C_charp(t1))){
t3=C_u_i_char_whitespacep(t1);
t4=t2;
f_28948(t4,(C_truep(t3)?t3:C_u_i_char_equalp(C_make_character(47),t1)));}
else{
t3=t2;
f_28948(t3,C_SCHEME_FALSE);}}

/* k28946 in k28940 in k28937 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void f_28948(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_28948,2,t0,t1);}
a=C_alloc(6);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_28951,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5173: skip-to-eol */
t3=((C_word*)((C_word*)t0)[4])[1];
f_26220(t3,t2);}
else{
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_28957,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5176: r-token */
t3=((C_word*)((C_word*)t0)[7])[1];
f_27656(t3,t2);}}

/* k28949 in k28946 in k28940 in k28937 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_28951(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_28951,c,av);}
/* library.scm:5174: readrec */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26440(t2,((C_word*)t0)[3]);}

/* k28955 in k28946 in k28940 in k28937 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_28957(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_28957,c,av);}
a=C_alloc(5);
if(C_truep(C_i_string_equal_p(lf[984],t1))){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
if(C_truep(C_i_string_equal_p(lf[985],t1))){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_BROKEN_WEAK_PTR;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
if(C_truep(C_i_string_equal_p(lf[986],t1))){
t2=C_set_block_item(((C_word*)t0)[3],0,C_SCHEME_FALSE);
t3=C_i_set_i_slot(((C_word*)t0)[4],C_fix(13),((C_word*)((C_word*)t0)[3])[1]);
/* library.scm:5182: readrec */
t4=((C_word*)((C_word*)t0)[5])[1];
f_26440(t4,((C_word*)t0)[2]);}
else{
if(C_truep(C_i_string_equal_p(lf[987],t1))){
t2=C_set_block_item(((C_word*)t0)[3],0,C_SCHEME_TRUE);
t3=C_i_set_i_slot(((C_word*)t0)[4],C_fix(13),((C_word*)((C_word*)t0)[3])[1]);
/* library.scm:5186: readrec */
t4=((C_word*)((C_word*)t0)[5])[1];
f_26440(t4,((C_word*)t0)[2]);}
else{
if(C_truep((C_truep(C_i_equalp(t1,lf[988]))?C_SCHEME_TRUE:(C_truep(C_i_equalp(t1,lf[989]))?C_SCHEME_TRUE:(C_truep(C_i_equalp(t1,lf[990]))?C_SCHEME_TRUE:C_SCHEME_FALSE))))){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29004,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5188: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=t2;
av2[2]=lf[991];
av2[3]=t1;
tp(4,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29023,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[4],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5190: scheme#string->symbol */
t3=*((C_word*)lf[742]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}}}}}}

/* k29002 in k28955 in k28946 in k28940 in k28937 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void C_ccall f_29004(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29004,c,av);}
/* library.scm:5042: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[739]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* k29021 in k28955 in k28946 in k28940 in k28937 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void C_ccall f_29023(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_29023,c,av);}
t2=C_i_assq(t1,C_fast_retrieve(lf[992]));
if(C_truep(t2)){
/* library.scm:5191: g6056 */
t3=C_slot(t2,C_fix(1));{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t3))(3,av2);}}
else{
/* library.scm:5193: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[993];
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}}

/* a29038 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_29039(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_29039,c,av);}
/* library.scm:5197: ##sys#user-read-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[994]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[994]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}

/* a29044 in k28493 in k28490 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_29045(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_29045,c,av);}
if(C_truep(C_rest_nullp(c,2))){
/* library.scm:5198: readrec */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26440(t2,t1);}
else{
t2=t1;{
C_word av2[2];
av2[0]=t2;
av2[1]=C_get_rest_arg(c,2,av,2,t0);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k29113 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_29115(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29115,c,av);}
/* library.scm:5200: container */
t2=((C_word*)((C_word*)t0)[2])[1];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* k29125 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_29127(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29127,c,av);}
/* library.scm:5201: r-string */
t2=((C_word*)((C_word*)t0)[2])[1];
f_26691(t2,((C_word*)t0)[3],C_make_character(34));}

/* k29203 in k28396 in k28393 in k28390 in readrec in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_29205(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29205,c,av);}
/* library.scm:5213: container */
t2=((C_word*)((C_word*)t0)[2])[1];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* k29277 in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_29279(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_29279,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_29282,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)((C_word*)t0)[5])[1])){
/* library.scm:5217: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=((C_word*)((C_word*)t0)[5])[1];
tp(4,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_29282(2,av2);}}}

/* k29280 in k29277 in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_29282(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_29282,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_29285,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_pairp(((C_word*)((C_word*)t0)[4])[1]))){
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29293,a[2]=((C_word)li820),tmp=(C_word)a,a+=3,tmp);
/* library.scm:5219: unthunkify! */
t4=((C_word*)((C_word*)t0)[5])[1];
f_26320(t4,t2,((C_word*)t0)[3],t3);}
else{
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k29283 in k29280 in k29277 in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_29285(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_29285,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* a29292 in k29280 in k29277 in k26201 in k26198 in k26195 in k26192 in k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_29293(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +0,c,4)))){
C_save_and_reclaim((void*)f_29293,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+0);
t2=C_build_rest(&a,c,2,av);
C_word t3;{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_fast_retrieve(lf[914]);
av2[3]=C_fast_retrieve(lf[997]);
av2[4]=t2;
C_apply(5,av2);}}

/* k29301 in ##sys#read in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void C_ccall f_29303(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_29303,c,av);}
a=C_alloc(11);
t2=(C_truep(t1)?C_slot(((C_word*)t0)[2],C_fix(13)):C_SCHEME_FALSE);
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_26194,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t4,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* library.scm:4587: keyword-style */
t6=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* ##sys#user-read-hook in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29308(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_29308,c,av);}
a=C_alloc(10);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_29311,a[2]=t3,a[3]=((C_word)li822),tmp=(C_word)a,a+=4,tmp);
t5=C_eqp(t2,C_make_character(102));
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_29324,a[2]=t4,a[3]=t1,a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
if(C_truep(t5)){
t7=t6;
f_29324(t7,t5);}
else{
t7=C_eqp(t2,C_make_character(116));
t8=t6;
f_29324(t8,(C_truep(t7)?t7:C_eqp(t2,C_make_character(117))));}}

/* fail in ##sys#user-read-hook in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void f_29311(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,4)))){
C_save_and_reclaim_args((void *)trf_29311,3,t0,t1,t2);}
/* library.scm:5229: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word av2[5];
av2[0]=*((C_word*)lf[914]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=lf[998];
av2[4]=t2;
tp(5,av2);}}

/* k29322 in ##sys#user-read-hook in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void f_29324(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_29324,2,t0,t1);}
a=C_alloc(6);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_29327,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5232: ##sys#read */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[894]);
C_word av2[4];
av2[0]=*((C_word*)lf[894]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=C_fast_retrieve(lf[909]);
tp(4,av2);}}
else{
/* library.scm:5247: fail */
t2=((C_word*)t0)[2];
f_29311(t2,((C_word*)t0)[3],((C_word*)t0)[4]);}}

/* k29325 in k29322 in ##sys#user-read-hook in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_29327(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_29327,c,av);}
a=C_alloc(3);
t2=C_i_symbolp(t1);
if(C_truep(C_i_not(t2))){
/* library.scm:5234: fail */
t3=((C_word*)t0)[2];
f_29311(t3,((C_word*)t0)[3],((C_word*)t0)[4]);}
else{
t3=C_eqp(t1,lf[999]);
t4=(C_truep(t3)?t3:C_eqp(t1,lf[1000]));
if(C_truep(t4)){
t5=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_eqp(t1,lf[1001]);
t6=(C_truep(t5)?t5:C_eqp(t1,lf[1002]));
if(C_truep(t6)){
t7=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_eqp(t1,lf[1003]);
if(C_truep(t7)){
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29363,a[2]=((C_word*)t0)[3],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5241: ##sys#read-numvector-data */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1005]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[1005]+1);
av2[1]=t8;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}
else{
/* library.scm:5246: fail */
t8=((C_word*)t0)[2];
f_29311(t8,((C_word*)t0)[3],t1);}}}}}

/* k29361 in k29325 in k29322 in ##sys#user-read-hook in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in ... */
static void C_ccall f_29363(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_29363,c,av);}
a=C_alloc(3);
t2=C_i_nullp(t1);
t3=(C_truep(t2)?t2:C_i_pairp(t1));
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29379,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5243: ##sys#canonicalize-number-list! */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1004]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[1004]+1);
av2[1]=t4;
av2[2]=t1;
tp(3,av2);}}
else{
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_chop_bv(C_slot(t1,C_fix(0)));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k29377 in k29361 in k29325 in k29322 in ##sys#user-read-hook in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_29379(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29379,c,av);}
/* library.scm:5243: ##sys#list->bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[764]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[764]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* ##sys#read-numvector-data in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29429(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_29429,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_29433,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:5250: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2=av;
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k29431 in ##sys#read-numvector-data in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void C_ccall f_29433(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_29433,c,av);}
switch(t1){
case C_make_character(40):
/* library.scm:5252: ##sys#read */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[894]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[894]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=C_fast_retrieve(lf[909]);
tp(4,av2);}
case C_make_character(34):
/* library.scm:5253: ##sys#read */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[894]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[894]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=C_fast_retrieve(lf[909]);
tp(4,av2);}
default:
/* library.scm:5254: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[1006];
av2[4]=t1;
tp(5,av2);}}}

/* ##sys#canonicalize-number-list! in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29460(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_29460,c,av);}
a=C_alloc(9);
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29466,a[2]=t5,a[3]=t3,a[4]=((C_word)li827),tmp=(C_word)a,a+=5,tmp));
t7=((C_word*)t5)[1];
f_29466(t7,t1,((C_word*)t3)[1],C_SCHEME_FALSE);}

/* loop in ##sys#canonicalize-number-list! in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void f_29466(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,3)))){
C_save_and_reclaim_args((void *)trf_29466,4,t0,t1,t2,t3);}
a=C_alloc(10);
t4=(C_truep(C_blockp(t2))?C_pairp(t2):C_SCHEME_FALSE);
if(C_truep(t4)){
t5=C_slot(t2,C_fix(0));
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_29482,a[2]=t7,a[3]=((C_word*)t0)[2],a[4]=t2,a[5]=t3,a[6]=((C_word*)t0)[3],a[7]=((C_word)li826),tmp=(C_word)a,a+=8,tmp));
t9=((C_word*)t7)[1];
f_29482(t9,t1,t5);}
else{
if(C_truep(t3)){
t5=C_i_set_i_slot(t3,C_fix(1),C_SCHEME_END_OF_LIST);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=((C_word*)((C_word*)t0)[3])[1];
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}}

/* retry in loop in ##sys#canonicalize-number-list! in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void f_29482(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_29482,3,t0,t1,t2);}
a=C_alloc(8);
if(C_truep(C_charp(t2))){
t3=C_a_i_string(&a,1,t2);
/* library.scm:5266: retry */
t6=t1;
t7=t3;
t1=t6;
t2=t7;
goto loop;}
else{
if(C_truep(C_i_stringp(t2))){
t3=C_eqp(C_u_i_string_length(t2),C_fix(0));
if(C_truep(t3)){
/* library.scm:5269: loop */
t4=((C_word*)((C_word*)t0)[3])[1];
f_29466(t4,t1,C_slot(((C_word*)t0)[4],C_fix(1)),((C_word*)t0)[5]);}
else{
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_29522,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[6],a[5]=t1,a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* ##sys#string->list */
t5=*((C_word*)lf[476]+1);{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}}
else{
/* library.scm:5280: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_29466(t3,t1,C_slot(((C_word*)t0)[4],C_fix(1)),((C_word*)t0)[4]);}}}

/* k29520 in retry in loop in ##sys#canonicalize-number-list! in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in ... */
static void C_ccall f_29522(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_29522,c,av);}
a=C_alloc(9);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_29524,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=((C_word*)t0)[4],a[6]=((C_word)li825),tmp=(C_word)a,a+=7,tmp));
t5=((C_word*)t3)[1];
f_29524(t5,((C_word*)t0)[5],t1,((C_word*)t0)[6]);}

/* loop2 in k29520 in retry in loop in ##sys#canonicalize-number-list! in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void f_29524(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,2)))){
C_save_and_reclaim_args((void *)trf_29524,4,t0,t1,t2,t3);}
a=C_alloc(11);
t4=C_slot(t2,C_fix(0));
t5=C_fix(C_character_code(t4));
t6=C_slot(((C_word*)t0)[2],C_fix(1));
t7=C_a_i_cons(&a,2,t5,t6);
t8=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_29531,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[2],a[6]=t7,a[7]=((C_word*)t0)[4],tmp=(C_word)a,a+=8,tmp);
if(C_truep(t3)){
t9=t8;
f_29531(t9,C_i_setslot(t3,C_fix(1),t7));}
else{
t9=C_mutate(((C_word *)((C_word*)t0)[5])+1,t7);
t10=t8;
f_29531(t10,t9);}}

/* k29529 in loop2 in k29520 in retry in loop in ##sys#canonicalize-number-list! in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void f_29531(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,3)))){
C_save_and_reclaim_args((void *)trf_29531,2,t0,t1);}
t2=C_slot(((C_word*)t0)[2],C_fix(1));
if(C_truep(C_i_nullp(t2))){
/* library.scm:5278: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_29466(t3,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)),((C_word*)t0)[6]);}
else{
/* library.scm:5279: loop2 */
t3=((C_word*)((C_word*)t0)[7])[1];
f_29524(t3,((C_word*)t0)[4],C_slot(((C_word*)t0)[2],C_fix(1)),((C_word*)t0)[6]);}}

/* ##sys#write-char-0 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29588(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_29588,c,av);}
a=C_alloc(3);
t4=C_slot(t3,C_fix(2));
t5=C_slot(t4,C_fix(2));
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29595,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5296: g6187 */
t7=t5;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t3;
av2[3]=t2;
((C_proc)C_fast_retrieve_proc(t7))(4,av2);}}

/* k29593 in ##sys#write-char-0 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void C_ccall f_29595(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_29595,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=*((C_word*)lf[278]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#write-char/port in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29604(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_29604,c,av);}
t4=C_i_check_port_2(t3,C_fix(2),C_SCHEME_TRUE,lf[1009]);
t5=C_i_check_char_2(t2,lf[1009]);
/* library.scm:5303: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
tp(4,av2);}}

/* scheme#write-char in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29616(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_29616,c,av);}
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?*((C_word*)lf[839]+1):C_get_rest_arg(c,3,av,3,t0));
t5=C_i_check_char_2(t2,lf[1009]);
t6=C_i_check_port_2(t4,C_fix(2),C_SCHEME_TRUE,lf[1009]);
/* library.scm:5309: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word av2[4];
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=t4;
tp(4,av2);}}

/* scheme#newline in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29637(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_29637,c,av);}
if(C_truep(C_rest_nullp(c,2))){
t2=*((C_word*)lf[839]+1);
t3=*((C_word*)lf[839]+1);
/* library.scm:5313: ##sys#write-char/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1008]);
C_word av2[4];
av2[0]=*((C_word*)lf[1008]+1);
av2[1]=t1;
av2[2]=C_make_character(10);
av2[3]=*((C_word*)lf[839]+1);
tp(4,av2);}}
else{
/* library.scm:5313: ##sys#write-char/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1008]);
C_word av2[4];
av2[0]=*((C_word*)lf[1008]+1);
av2[1]=t1;
av2[2]=C_make_character(10);
av2[3]=C_get_rest_arg(c,2,av,2,t0);
tp(4,av2);}}}

/* scheme#write in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29652(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_29652,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=*((C_word*)lf[839]+1);
t4=C_i_check_port_2(*((C_word*)lf[839]+1),C_fix(2),C_SCHEME_TRUE,lf[1010]);
/* library.scm:5318: ##sys#print */
t5=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t5;
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_TRUE;
av2[4]=*((C_word*)lf[839]+1);
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_i_check_port_2(t3,C_fix(2),C_SCHEME_TRUE,lf[1010]);
/* library.scm:5318: ##sys#print */
t5=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t5;
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_TRUE;
av2[4]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}}

/* scheme#display in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29670(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_29670,c,av);}
if(C_truep(C_rest_nullp(c,3))){
t3=*((C_word*)lf[839]+1);
t4=C_i_check_port_2(*((C_word*)lf[839]+1),C_fix(2),C_SCHEME_TRUE,lf[1012]);
/* library.scm:5323: ##sys#print */
t5=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t5;
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[839]+1);
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}
else{
t3=C_get_rest_arg(c,3,av,3,t0);
t4=C_i_check_port_2(t3,C_fix(2),C_SCHEME_TRUE,lf[1012]);
/* library.scm:5323: ##sys#print */
t5=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t5;
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_FALSE;
av2[4]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}}

/* chicken.base#print in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29688(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +9,c,3)))){
C_save_and_reclaim((void*)f_29688,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+9);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
t3=*((C_word*)lf[839]+1);
t4=C_i_check_port_2(*((C_word*)lf[839]+1),C_fix(2),C_SCHEME_TRUE,lf[1013]);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29731,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t6=C_i_check_list_2(t2,lf[820]);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_29707,a[2]=t8,a[3]=((C_word)li835),tmp=(C_word)a,a+=4,tmp));
t10=((C_word*)t8)[1];
f_29707(t10,t5,t2);}

/* for-each-loop6248 in chicken.base#print in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void f_29707(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,4)))){
C_save_and_reclaim_args((void *)trf_29707,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29717,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t4=C_slot(t2,C_fix(0));
t5=*((C_word*)lf[1011]+1);
/* library.scm:5326: g6264 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[1011]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[1011]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[839]+1);
tp(5,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k29715 in for-each-loop6248 in chicken.base#print in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_29717(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29717,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_29707(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k29729 in chicken.base#print in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void C_ccall f_29731(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_29731,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29734,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5332: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t2;
av2[2]=C_make_character(10);
av2[3]=*((C_word*)lf[839]+1);
tp(4,av2);}}

/* k29732 in k29729 in chicken.base#print in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_29734(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_29734,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=*((C_word*)lf[278]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.base#print* in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29739(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +9,c,3)))){
C_save_and_reclaim((void*)f_29739,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+9);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
t3=*((C_word*)lf[839]+1);
t4=C_i_check_port_2(*((C_word*)lf[839]+1),C_fix(2),C_SCHEME_TRUE,lf[1013]);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29782,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t6=C_i_check_list_2(t2,lf[820]);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_29758,a[2]=t8,a[3]=((C_word)li837),tmp=(C_word)a,a+=4,tmp));
t10=((C_word*)t8)[1];
f_29758(t10,t5,t2);}

/* for-each-loop6280 in chicken.base#print* in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void f_29758(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,4)))){
C_save_and_reclaim_args((void *)trf_29758,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29768,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t4=C_slot(t2,C_fix(0));
t5=*((C_word*)lf[1011]+1);
/* library.scm:5326: g6296 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[1011]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[1011]+1);
av2[1]=t3;
av2[2]=t4;
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[839]+1);
tp(5,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k29766 in for-each-loop6280 in chicken.base#print* in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_29768(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29768,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_29758(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k29780 in chicken.base#print* in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void C_ccall f_29782(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_29782,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29785,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5339: ##sys#flush-output */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[885]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[885]+1);
av2[1]=t2;
av2[2]=*((C_word*)lf[839]+1);
tp(3,av2);}}

/* k29783 in k29780 in chicken.base#print* in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_29785(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_29785,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=*((C_word*)lf[278]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in ... */
static void C_ccall f_29792(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_29792,c,av);}
a=C_alloc(3);
t2=C_mutate(&lf[1014] /* (set! current-print-length ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29796,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5343: scheme#make-parameter */
t4=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in ... */
static void C_ccall f_29796(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_29796,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[1015]+1 /* (set! ##sys#print-length-limit ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29800,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5344: scheme#make-parameter */
t4=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in ... */
static void C_ccall f_29800(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(18,c,5)))){
C_save_and_reclaim((void *)f_29800,c,av);}
a=C_alloc(18);
t2=C_mutate(&lf[1016] /* (set! ##sys#print-exit ...) */,t1);
t3=*((C_word*)lf[264]+1);
t4=*((C_word*)lf[267]+1);
t5=*((C_word*)lf[265]+1);
t6=C_mutate((C_word*)lf[1011]+1 /* (set! ##sys#print ...) */,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_29802,a[2]=t4,a[3]=t5,a[4]=t3,a[5]=((C_word)li852),tmp=(C_word)a,a+=6,tmp));
t7=C_mutate((C_word*)lf[1039]+1 /* (set! ##sys#procedure->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_30941,a[2]=((C_word)li853),tmp=(C_word)a,a+=3,tmp));
t8=C_set_block_item(lf[1052] /* ##sys#record-printers */,0,C_SCHEME_END_OF_LIST);
t9=C_mutate((C_word*)lf[243]+1 /* (set! chicken.base#record-printer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_30958,a[2]=((C_word)li854),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate((C_word*)lf[244]+1 /* (set! chicken.base#set-record-printer! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_30970,a[2]=((C_word)li855),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[1054]+1 /* (set! ##sys#register-record-printer ...) */,*((C_word*)lf[244]+1));
t12=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_30996,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5592: chicken.base#getter-with-setter */
t13=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t13;
av2[1]=t12;
av2[2]=*((C_word*)lf[243]+1);
av2[3]=*((C_word*)lf[244]+1);
((C_proc)(void*)(*((C_word*)t13+1)))(4,av2);}}

/* ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in ... */
static void C_ccall f_29802(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_29802,c,av);}
a=C_alloc(8);
t5=C_i_check_port_2(t4,C_fix(2),C_SCHEME_TRUE,C_SCHEME_FALSE);
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_29809,a[2]=t3,a[3]=t1,a[4]=t4,a[5]=t2,a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[3],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5352: case-sensitive */
t7=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_29809(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_29809,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_29812,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5353: keyword-style */
t3=((C_word*)t0)[7];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_29812(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_29812,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_29815,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5354: symbol-escape */
t3=((C_word*)t0)[7];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_29815(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_29815,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_29818,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5355: ##sys#print-length-limit */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1015]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1015]+1);
av2[1]=t2;
tp(2,av2);}}

/* k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_29818(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(57,c,4)))){
C_save_and_reclaim((void *)f_29818,c,av);}
a=C_alloc(57);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_SCHEME_UNDEFINED;
t13=(*a=C_VECTOR_TYPE|1,a[1]=t12,tmp=(C_word)a,a+=2,tmp);
t14=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29820,a[2]=t1,a[3]=t5,a[4]=((C_word)li839),tmp=(C_word)a,a+=5,tmp));
t15=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29879,a[2]=((C_word)li840),tmp=(C_word)a,a+=3,tmp));
t16=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29903,a[2]=t1,a[3]=t5,a[4]=((C_word)li841),tmp=(C_word)a,a+=5,tmp));
t17=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_29963,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=t11,a[5]=((C_word*)t0)[3],a[6]=t13,a[7]=((C_word)li842),tmp=(C_word)a,a+=8,tmp));
t18=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29993,a[2]=t7,a[3]=t3,a[4]=((C_word)li844),tmp=(C_word)a,a+=5,tmp));
t19=C_set_block_item(t13,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_30078,a[2]=((C_word*)t0)[4],a[3]=((C_word)li846),tmp=(C_word)a,a+=4,tmp));
t20=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_30304,a[2]=((C_word*)t0)[5],tmp=(C_word)a,a+=3,tmp);
t21=C_SCHEME_UNDEFINED;
t22=(*a=C_VECTOR_TYPE|1,a[1]=t21,tmp=(C_word)a,a+=2,tmp);
t23=C_set_block_item(t22,0,(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_30309,a[2]=t3,a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[3],a[5]=t7,a[6]=((C_word*)t0)[7],a[7]=t9,a[8]=t22,a[9]=((C_word)li851),tmp=(C_word)a,a+=10,tmp));
t24=((C_word*)t22)[1];
f_30309(t24,t20,((C_word*)t0)[8]);}

/* outstr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_29820(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_29820,4,t0,t1,t2,t3);}
a=C_alloc(8);
if(C_truep(((C_word*)t0)[2])){
t4=C_i_string_length(t3);
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_29830,a[2]=t4,a[3]=t1,a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=t2,a[7]=t3,tmp=(C_word)a,a+=8,tmp);
/* library.scm:5361: current-print-length */
t6=C_retrieve2(lf[1014],C_text("current-print-length"));{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
/* library.scm:5370: outstr0 */
f_29879(t1,t2,t3);}}

/* k29828 in outstr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_29830(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,4)))){
C_save_and_reclaim((void *)f_29830,c,av);}
a=C_alloc(14);
t2=C_fixnum_plus(t1,((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_29836,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_fixnum_greaterp(t2,((C_word*)t0)[4]))){
t4=C_fixnum_difference(((C_word*)t0)[4],t1);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29848,a[2]=t3,a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fixnum_greaterp(t4,C_fix(0)))){
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29871,a[2]=((C_word*)t0)[5],a[3]=t5,a[4]=((C_word*)t0)[6],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5365: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[486]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[7];
av2[3]=C_fix(0);
av2[4]=t4;
tp(5,av2);}}
else{
t6=t5;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_UNDEFINED;
f_29848(2,av2);}}}
else{
/* library.scm:5368: outstr0 */
f_29879(t3,((C_word*)t0)[6],((C_word*)t0)[7]);}}

/* k29834 in k29828 in outstr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_29836(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29836,c,av);}
/* library.scm:5369: current-print-length */
t2=C_retrieve2(lf[1014],C_text("current-print-length"));{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k29846 in k29828 in outstr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_29848(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_29848,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29851,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5366: outstr0 */
f_29879(t2,((C_word*)t0)[4],lf[1017]);}

/* k29849 in k29846 in k29828 in outstr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_29851(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_29851,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29854,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5367: ##sys#print-exit */
t3=C_retrieve2(lf[1016],C_text("##sys#print-exit"));{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k29852 in k29849 in k29846 in k29828 in outstr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_29854(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29854,c,av);}
t2=*((C_word*)lf[278]+1);
/* library.scm:5364: g6334 */
t3=t1;{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[278]+1);
((C_proc)C_fast_retrieve_proc(t3))(3,av2);}}

/* k29869 in k29828 in outstr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_29871(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_29871,c,av);}
/* library.scm:5365: outstr0 */
f_29879(((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* outstr0 in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_29879(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,5)))){
C_save_and_reclaim_args((void *)trf_29879,3,t1,t2,t3);}
t4=C_slot(t3,C_fix(0));
t5=C_slot(t2,C_fix(2));
t6=C_slot(t5,C_fix(3));
t7=C_block_size(t4);
/* library.scm:5373: g6342 */
t8=t6;{
C_word av2[6];
av2[0]=t8;
av2[1]=t1;
av2[2]=t2;
av2[3]=t4;
av2[4]=C_fix(0);
av2[5]=C_fixnum_difference(t7,C_fix(1));
((C_proc)C_fast_retrieve_proc(t8))(6,av2);}}

/* outchr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_29903(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,0,3)))){
C_save_and_reclaim_args((void *)trf_29903,4,t0,t1,t2,t3);}
a=C_alloc(13);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_29907,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
if(C_truep(((C_word*)t0)[2])){
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_29920,a[2]=((C_word*)t0)[2],a[3]=t4,a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=t1,a[7]=t3,tmp=(C_word)a,a+=8,tmp);
/* library.scm:5378: current-print-length */
t6=C_retrieve2(lf[1014],C_text("current-print-length"));{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t5=C_slot(t2,C_fix(2));
/* g63516352 */
t6=C_slot(t5,C_fix(2));{
C_word av2[4];
av2[0]=t6;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
((C_proc)C_fast_retrieve_proc(t6))(4,av2);}}}

/* k29905 in outchr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_29907(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_29907,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(2));
/* g63516352 */
t3=C_slot(t2,C_fix(2));{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[4];
((C_proc)C_fast_retrieve_proc(t3))(4,av2);}}

/* k29918 in outchr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_29920(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_29920,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_29923,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5379: current-print-length */
t3=C_retrieve2(lf[1014],C_text("current-print-length"));{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_fixnum_plus(t1,C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k29921 in k29918 in outchr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_29923(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_29923,c,av);}
a=C_alloc(3);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)t0)[2],((C_word*)t0)[3]))){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29932,a[2]=((C_word*)t0)[4],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5381: outstr0 */
f_29879(t2,((C_word*)t0)[6],lf[1018]);}
else{
t2=C_slot(((C_word*)t0)[6],C_fix(2));
/* g63516352 */
t3=C_slot(t2,C_fix(2));{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[7];
av2[2]=((C_word*)t0)[6];
av2[3]=((C_word*)t0)[8];
((C_proc)C_fast_retrieve_proc(t3))(4,av2);}}}

/* k29930 in k29921 in k29918 in outchr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_29932(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_29932,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_29935,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5382: ##sys#print-exit */
t3=C_retrieve2(lf[1016],C_text("##sys#print-exit"));{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k29933 in k29930 in k29921 in k29918 in outchr in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_29935(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_29935,c,av);}
t2=*((C_word*)lf[278]+1);
/* library.scm:5380: g6347 */
t3=t1;{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[278]+1);
((C_proc)C_fast_retrieve_proc(t3))(3,av2);}}

/* outsym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_29963(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,2)))){
C_save_and_reclaim_args((void *)trf_29963,4,t0,t1,t2,t3);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_29967,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t2,a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5391: ##sys#symbol->string/shared */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[737]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[737]+1);
av2[1]=t4;
av2[2]=t3;
tp(3,av2);}}

/* k29965 in outsym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_29967(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_29967,c,av);}
a=C_alloc(7);
t2=C_i_not(((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_29976,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t1,a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(t2)){
t4=t3;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
f_29976(2,av2);}}
else{
t4=C_i_not(((C_word*)t0)[7]);
if(C_truep(t4)){
t5=t3;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
f_29976(2,av2);}}
else{
/* library.scm:5392: sym-is-readable? */
t5=((C_word*)((C_word*)t0)[8])[1];
f_30078(t5,t3,t1);}}}

/* k29974 in k29965 in outsym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_29976(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_29976,c,av);}
if(C_truep(t1)){
/* library.scm:5393: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}
else{
/* library.scm:5394: outreadablesym */
t2=((C_word*)((C_word*)t0)[6])[1];
f_29993(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}}

/* outreadablesym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_29993(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_29993,4,t0,t1,t2,t3);}
a=C_alloc(8);
t4=C_i_string_length(t3);
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30000,a[2]=t4,a[3]=((C_word*)t0)[2],a[4]=t2,a[5]=t3,a[6]=((C_word*)t0)[3],a[7]=t1,tmp=(C_word)a,a+=8,tmp);
/* library.scm:5398: outchr */
t6=((C_word*)((C_word*)t0)[2])[1];
f_29903(t6,t5,t2,C_make_character(124));}

/* k29998 in outreadablesym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30000(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_30000,c,av);}
a=C_alloc(11);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_30005,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t3,a[7]=((C_word*)t0)[6],a[8]=((C_word)li843),tmp=(C_word)a,a+=9,tmp));
t5=((C_word*)t3)[1];
f_30005(t5,((C_word*)t0)[7],C_fix(0));}

/* loop in k29998 in outreadablesym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_30005(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,3)))){
C_save_and_reclaim_args((void *)trf_30005,3,t0,t1,t2);}
a=C_alloc(9);
if(C_truep(C_fixnum_greater_or_equal_p(t2,((C_word*)t0)[2]))){
/* library.scm:5401: outchr */
t3=((C_word*)((C_word*)t0)[3])[1];
f_29903(t3,t1,((C_word*)t0)[4],C_make_character(124));}
else{
t3=C_i_string_ref(((C_word*)t0)[5],t2);
t4=C_u_i_char_lessp(t3,C_make_character(32));
t5=(C_truep(t4)?t4:C_u_i_char_greaterp(t3,C_make_character(126)));
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_30029,a[2]=t3,a[3]=((C_word*)t0)[6],a[4]=t1,a[5]=t2,a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[4],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5404: outstr */
t7=((C_word*)((C_word*)t0)[7])[1];
f_29820(t7,t6,((C_word*)t0)[4],lf[1019]);}
else{
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30052,a[2]=((C_word*)t0)[6],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=t3,tmp=(C_word)a,a+=8,tmp);
t7=C_eqp(t3,C_make_character(124));
if(C_truep(t7)){
if(C_truep(t7)){
/* library.scm:5410: outchr */
t8=((C_word*)((C_word*)t0)[3])[1];
f_29903(t8,t6,((C_word*)t0)[4],C_make_character(92));}
else{
t8=t6;{
C_word av2[2];
av2[0]=t8;
av2[1]=C_SCHEME_UNDEFINED;
f_30052(2,av2);}}}
else{
t8=C_eqp(t3,C_make_character(92));
if(C_truep(t8)){
/* library.scm:5410: outchr */
t9=((C_word*)((C_word*)t0)[3])[1];
f_29903(t9,t6,((C_word*)t0)[4],C_make_character(92));}
else{
t9=t6;{
C_word av2[2];
av2[0]=t9;
av2[1]=C_SCHEME_UNDEFINED;
f_30052(2,av2);}}}}}}

/* k30027 in loop in k29998 in outreadablesym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_30029(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_30029,c,av);}
a=C_alloc(12);
t2=C_fix(C_character_code(((C_word*)t0)[2]));
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_30035,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],tmp=(C_word)a,a+=7,tmp);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30049,a[2]=((C_word*)t0)[8],a[3]=t3,a[4]=((C_word*)t0)[7],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5406: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=C_fix(16);
tp(4,av2);}}

/* k30033 in k30027 in loop in k29998 in outreadablesym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30035(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_30035,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30038,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5407: outchr */
t3=((C_word*)((C_word*)t0)[5])[1];
f_29903(t3,t2,((C_word*)t0)[6],C_make_character(59));}

/* k30036 in k30033 in k30027 in loop in k29998 in outreadablesym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_30038(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_30038,c,av);}
/* library.scm:5408: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_30005(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* k30047 in k30027 in loop in k29998 in outreadablesym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30049(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30049,c,av);}
/* library.scm:5406: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k30050 in loop in k29998 in outreadablesym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_30052(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_30052,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30055,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5411: outchr */
t3=((C_word*)((C_word*)t0)[5])[1];
f_29903(t3,t2,((C_word*)t0)[6],((C_word*)t0)[7]);}

/* k30053 in k30050 in loop in k29998 in outreadablesym in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30055(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_30055,c,av);}
/* library.scm:5412: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_30005(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* sym-is-readable? in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_30078(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,3)))){
C_save_and_reclaim_args((void *)trf_30078,3,t0,t1,t2);}
a=C_alloc(9);
t3=C_i_string_length(t2);
switch(t3){
case C_fix(0):
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}
case C_fix(1):
t4=C_i_string_ref(t2,C_fix(0));
t5=C_eqp(C_make_character(35),t4);
t6=(C_truep(t5)?t5:C_eqp(C_make_character(46),t4));
if(C_truep(t6)){
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_fix(C_character_code(t4));
t8=C_fixnum_less_or_equal_p(t7,C_fix(32));
t9=(C_truep(t8)?t8:C_i_memq(t4,lf[1020]));
if(C_truep(t9)){
t10=t1;{
C_word av2[2];
av2[0]=t10;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
t10=C_u_i_char_numericp(t4);
t11=t1;{
C_word av2[2];
av2[0]=t11;
av2[1]=(C_truep(t10)?C_SCHEME_FALSE:C_SCHEME_TRUE);
((C_proc)(void*)(*((C_word*)t11+1)))(2,av2);}}}
default:
t4=C_fixnum_difference(t3,C_fix(1));
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_30129,a[2]=t2,a[3]=t3,a[4]=((C_word*)t0)[2],a[5]=t6,a[6]=((C_word)li845),tmp=(C_word)a,a+=7,tmp));
t8=((C_word*)t6)[1];
f_30129(t8,t1,t4);}}

/* loop in sym-is-readable? in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_30129(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_30129,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_eqp(t2,C_fix(0));
if(C_truep(t3)){
t4=C_i_string_ref(((C_word*)t0)[2],C_fix(0));
if(C_truep(C_u_i_char_numericp(t4))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_eqp(t4,C_make_character(43));
t6=(C_truep(t5)?t5:C_eqp(t4,C_make_character(45)));
if(C_truep(t6)){
t7=C_eqp(((C_word*)t0)[3],C_fix(1));
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=(C_truep(t7)?t7:C_i_not(C_u_i_char_numericp(C_i_string_ref(((C_word*)t0)[2],C_fix(1)))));
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
switch(t4){
case C_make_character(46):
t7=C_fixnum_greaterp(((C_word*)t0)[3],C_fix(1));
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=(C_truep(t7)?C_i_not(C_u_i_char_numericp(C_i_string_ref(((C_word*)t0)[2],C_fix(1)))):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}
case C_make_character(58):
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}
default:
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30204,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t4,tmp=(C_word)a,a+=5,tmp);
t8=C_eqp(t4,C_make_character(35));
if(C_truep(t8)){
if(C_truep(C_fixnum_greaterp(((C_word*)t0)[3],C_fix(2)))){
t9=C_eqp(C_i_string_ref(((C_word*)t0)[2],C_fix(1)),C_make_character(35));
if(C_truep(t9)){
t10=C_eqp(C_i_string_ref(((C_word*)t0)[2],C_fix(2)),C_make_character(35));
t11=t7;
f_30204(t11,C_i_not(C_i_not(t10)));}
else{
t10=t7;
f_30204(t10,C_SCHEME_TRUE);}}
else{
t9=t7;
f_30204(t9,C_SCHEME_TRUE);}}
else{
t9=t7;
f_30204(t9,C_SCHEME_FALSE);}}}}}
else{
t4=C_i_string_ref(((C_word*)t0)[2],t2);
t5=(C_truep(((C_word*)t0)[4])?((C_word*)t0)[4]:C_i_not(C_u_i_char_upper_casep(t4)));
if(C_truep(t5)){
t6=C_fix(C_character_code(t4));
t7=C_fixnum_less_or_equal_p(t6,C_fix(32));
t8=(C_truep(t7)?t7:C_i_memq(t4,lf[1020]));
if(C_truep(C_i_not(t8))){
t9=C_eqp(t4,C_make_character(58));
t10=C_i_not(t9);
t11=(C_truep(t10)?t10:C_fixnum_lessp(t2,C_fixnum_difference(((C_word*)t0)[3],C_fix(1))));
if(C_truep(t11)){
/* library.scm:5449: loop */
t13=t1;
t14=C_fixnum_difference(t2,C_fix(1));
t1=t13;
t2=t14;
goto loop;}
else{
t12=t1;{
C_word av2[2];
av2[0]=t12;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t12+1)))(2,av2);}}}
else{
t9=t1;{
C_word av2[2];
av2[0]=t9;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}}
else{
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}}

/* k30202 in loop in sym-is-readable? in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_30204(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,1)))){
C_save_and_reclaim_args((void *)trf_30204,2,t0,t1);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_i_member(((C_word*)t0)[3],lf[1021]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=C_fix(C_character_code(((C_word*)t0)[4]));
t3=C_fixnum_less_or_equal_p(t2,C_fix(32));
t4=(C_truep(t3)?t3:C_i_memq(((C_word*)t0)[4],lf[1020]));
t5=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t5;
av2[1]=(C_truep(t4)?C_SCHEME_FALSE:C_SCHEME_TRUE);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* k30302 in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_30304(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_30304,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=*((C_word*)lf[278]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_30309(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,4)))){
C_save_and_reclaim_args((void *)trf_30309,3,t0,t1,t2);}
a=C_alloc(8);
switch(t2){
case C_SCHEME_END_OF_LIST:
/* library.scm:5452: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1022]);
case C_SCHEME_TRUE:
/* library.scm:5453: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1023]);
case C_SCHEME_FALSE:
/* library.scm:5454: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1024]);
default:
if(C_truep(C_eofp(t2))){
/* library.scm:5455: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1025]);}
else{
if(C_truep(C_undefinedp(t2))){
/* library.scm:5456: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1026]);}
else{
if(C_truep(C_bwpp(t2))){
/* library.scm:5457: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1027]);}
else{
if(C_truep(C_charp(t2))){
if(C_truep(((C_word*)t0)[4])){
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_30364,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t1,a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* library.scm:5460: outstr */
t4=((C_word*)((C_word*)t0)[2])[1];
f_29820(t4,t3,((C_word*)t0)[3],lf[1028]);}
else{
/* library.scm:5469: outchr */
t3=((C_word*)((C_word*)t0)[5])[1];
f_29903(t3,t1,((C_word*)t0)[3],t2);}}
else{
if(C_truep(C_fixnump(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30423,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5470: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}
else{
if(C_truep(C_unboundvaluep(t2))){
/* library.scm:5471: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1029]);}
else{
if(C_truep(C_i_not(C_blockp(t2)))){
/* library.scm:5472: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1030]);}
else{
if(C_truep(C_forwardedp(t2))){
/* library.scm:5473: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1031]);}
else{
if(C_truep(C_i_keywordp(t2))){
t3=C_i_not(((C_word*)t0)[4]);
t4=(C_truep(t3)?((C_word*)t0)[6]:C_SCHEME_FALSE);
t5=C_eqp(t4,lf[967]);
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_30459,a[2]=((C_word*)t0)[7],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:5478: outchr */
t7=((C_word*)((C_word*)t0)[5])[1];
f_29903(t7,t6,((C_word*)t0)[3],C_make_character(58));}
else{
t6=C_eqp(t4,lf[948]);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30471,a[2]=((C_word*)t0)[5],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5481: outsym */
t8=((C_word*)((C_word*)t0)[7])[1];
f_29963(t8,t7,((C_word*)t0)[3],t2);}
else{
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_30477,a[2]=((C_word*)t0)[7],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:5484: outstr */
t8=((C_word*)((C_word*)t0)[2])[1];
f_29820(t8,t7,((C_word*)t0)[3],lf[1032]);}}}
else{
if(C_truep(C_i_symbolp(t2))){
/* library.scm:5486: outsym */
t3=((C_word*)((C_word*)t0)[7])[1];
f_29963(t3,t1,((C_word*)t0)[3],t2);}
else{
if(C_truep(C_i_numberp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30506,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5487: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}
else{
if(C_truep(C_anypointerp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30516,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5488: ##sys#pointer->string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1033]);
C_word av2[3];
av2[0]=*((C_word*)lf[1033]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}
else{
if(C_truep(C_stringp(t2))){
if(C_truep(((C_word*)t0)[4])){
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_30525,a[2]=t2,a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[2],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:5491: outchr */
t4=((C_word*)((C_word*)t0)[5])[1];
f_29903(t4,t3,((C_word*)t0)[3],C_make_character(34));}
else{
/* library.scm:5518: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],t2);}}
else{
if(C_truep(C_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30711,a[2]=t2,a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[2],a[7]=t1,tmp=(C_word)a,a+=8,tmp);
/* library.scm:5520: outchr */
t4=((C_word*)((C_word*)t0)[5])[1];
f_29903(t4,t3,((C_word*)t0)[3],C_make_character(40));}
else{
if(C_truep(C_bytevectorp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30784,a[2]=((C_word*)t0)[8],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5532: outstr */
t4=((C_word*)((C_word*)t0)[2])[1];
f_29820(t4,t3,((C_word*)t0)[3],lf[1037]);}
else{
if(C_truep(C_structurep(t2))){
/* library.scm:5534: ##sys#user-print-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1038]);
C_word av2[5];
av2[0]=*((C_word*)lf[1038]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=((C_word*)t0)[4];
av2[4]=((C_word*)t0)[3];
tp(5,av2);}}
else{
if(C_truep(C_closurep(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30807,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5535: ##sys#procedure->string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1039]);
C_word av2[3];
av2[0]=*((C_word*)lf[1039]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}
else{
if(C_truep(C_locativep(t2))){
/* library.scm:5536: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t1,((C_word*)t0)[3],lf[1040]);}
else{
if(C_truep(C_lambdainfop(t2))){
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_30819,a[2]=((C_word*)t0)[5],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[2],a[6]=t2,tmp=(C_word)a,a+=7,tmp);
/* library.scm:5538: outstr */
t4=((C_word*)((C_word*)t0)[2])[1];
f_29820(t4,t3,((C_word*)t0)[3],lf[1041]);}
else{
if(C_truep(C_portp(t2))){
t3=C_slot(t2,C_fix(1));
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_30838,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
switch(t3){
case C_fix(1):
/* library.scm:5543: outstr */
t5=((C_word*)((C_word*)t0)[2])[1];
f_29820(t5,t4,((C_word*)t0)[3],lf[1043]);
case C_fix(2):
/* library.scm:5544: outstr */
t5=((C_word*)((C_word*)t0)[2])[1];
f_29820(t5,t4,((C_word*)t0)[3],lf[1044]);
default:
/* library.scm:5545: outstr */
t5=((C_word*)((C_word*)t0)[2])[1];
f_29820(t5,t4,((C_word*)t0)[3],lf[1045]);}}
else{
if(C_truep(C_vectorp(t2))){
t3=C_block_size(t2);
t4=C_eqp(C_fix(0),t3);
if(C_truep(t4)){
/* library.scm:5551: outstr */
t5=((C_word*)((C_word*)t0)[2])[1];
f_29820(t5,t1,((C_word*)t0)[3],lf[1046]);}
else{
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30888,a[2]=t3,a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[8],a[6]=t2,a[7]=t1,tmp=(C_word)a,a+=8,tmp);
/* library.scm:5553: outstr */
t6=((C_word*)((C_word*)t0)[2])[1];
f_29820(t6,t5,((C_word*)t0)[3],lf[1047]);}}
else{
/* library.scm:5561: ##sys#error */
t3=*((C_word*)lf[195]+1);{
C_word av2[3];
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[1048];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}}}}}}}}}}}}}}}}}}}}}}}

/* k30362 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30364(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_30364,c,av);}
a=C_alloc(8);
t2=C_fix(C_character_code(((C_word*)t0)[2]));
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30370,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t2,a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[2],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5462: chicken.base#char-name */
t4=*((C_word*)lf[239]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k30368 in k30362 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_30370(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_30370,c,av);}
a=C_alloc(6);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30374,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word)li847),tmp=(C_word)a,a+=5,tmp);
/* library.scm:5462: g6450 */
t3=t2;
f_30374(t3,((C_word*)t0)[4],t1);}
else{
t2=C_fixnum_lessp(((C_word*)t0)[5],C_fix(32));
t3=(C_truep(t2)?t2:C_fixnum_greaterp(((C_word*)t0)[5],C_fix(131071)));
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_30397,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5466: outchr */
t5=((C_word*)((C_word*)t0)[6])[1];
f_29903(t5,t4,((C_word*)t0)[3],C_make_character(120));}
else{
/* library.scm:5468: outchr */
t4=((C_word*)((C_word*)t0)[6])[1];
f_29903(t4,((C_word*)t0)[4],((C_word*)t0)[3],((C_word*)t0)[7]);}}}

/* g6450 in k30368 in k30362 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void f_30374(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_30374,3,t0,t1,t2);}
a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30382,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5464: ##sys#symbol->string/shared */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[737]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[737]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k30380 in g6450 in k30368 in k30362 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30382(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30382,c,av);}
/* library.scm:5464: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k30395 in k30368 in k30362 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_30397(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_30397,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30404,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5467: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=C_fix(16);
tp(4,av2);}}

/* k30402 in k30395 in k30368 in k30362 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30404(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30404,c,av);}
/* library.scm:5467: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k30421 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30423(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30423,c,av);}
/* library.scm:5470: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k30457 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30459(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30459,c,av);}
/* library.scm:5479: outsym */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29963(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}

/* k30469 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30471(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30471,c,av);}
/* library.scm:5482: outchr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29903(t2,((C_word*)t0)[3],((C_word*)t0)[4],C_make_character(58));}

/* k30475 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30477(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30477,c,av);}
/* library.scm:5485: outsym */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29963(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}

/* k30504 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30506(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30506,c,av);}
/* library.scm:5487: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k30514 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30516(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30516,c,av);}
/* library.scm:5488: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k30523 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30525(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_30525,c,av);}
a=C_alloc(10);
t2=C_i_string_length(((C_word*)t0)[2]);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30534,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],a[5]=t4,a[6]=((C_word*)t0)[5],a[7]=((C_word)li848),tmp=(C_word)a,a+=8,tmp));
t6=((C_word*)t4)[1];
f_30534(t6,((C_word*)t0)[6],C_fix(0),t2);}

/* doloop6471 in k30523 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_30534(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,0,3)))){
C_save_and_reclaim_args((void *)trf_30534,4,t0,t1,t2,t3);}
a=C_alloc(13);
t4=C_eqp(t3,C_fix(0));
if(C_truep(t4)){
/* library.scm:5495: outchr */
t5=((C_word*)((C_word*)t0)[2])[1];
f_29903(t5,t1,((C_word*)t0)[3],C_make_character(34));}
else{
t5=C_i_string_ref(((C_word*)t0)[4],t2);
t6=C_fix(C_character_code(t5));
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_30550,a[2]=((C_word*)t0)[5],a[3]=t1,a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
switch(t6){
case C_fix(34):
/* library.scm:5498: outstr */
t8=((C_word*)((C_word*)t0)[6])[1];
f_29820(t8,t7,((C_word*)t0)[3],lf[1034]);
case C_fix(92):
/* library.scm:5499: outstr */
t8=((C_word*)((C_word*)t0)[6])[1];
f_29820(t8,t7,((C_word*)t0)[3],lf[1035]);
default:
t8=C_fixnum_lessp(t6,C_fix(32));
t9=(C_truep(t8)?t8:C_eqp(t6,C_fix(131071)));
if(C_truep(t9)){
t10=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_30588,a[2]=t6,a[3]=((C_word*)t0)[2],a[4]=t7,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
/* library.scm:5503: outchr */
t11=((C_word*)((C_word*)t0)[2])[1];
f_29903(t11,t10,((C_word*)t0)[3],C_make_character(92));}
else{
/* library.scm:5517: outchr */
t10=((C_word*)((C_word*)t0)[2])[1];
f_29903(t10,t7,((C_word*)t0)[3],C_fix_to_char(t6));}}}}

/* k30548 in doloop6471 in k30523 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_30550(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30550,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_30534(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)),C_fixnum_difference(((C_word*)t0)[5],C_fix(1)));}

/* k30586 in doloop6471 in k30523 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_30588(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_30588,c,av);}
a=C_alloc(7);
switch(((C_word*)t0)[2]){
case C_fix(7):
/* library.scm:5505: outchr */
t2=((C_word*)((C_word*)t0)[3])[1];
f_29903(t2,((C_word*)t0)[4],((C_word*)t0)[5],C_make_character(97));
case C_fix(8):
/* library.scm:5506: outchr */
t2=((C_word*)((C_word*)t0)[3])[1];
f_29903(t2,((C_word*)t0)[4],((C_word*)t0)[5],C_make_character(98));
case C_fix(9):
/* library.scm:5507: outchr */
t2=((C_word*)((C_word*)t0)[3])[1];
f_29903(t2,((C_word*)t0)[4],((C_word*)t0)[5],C_make_character(116));
case C_fix(10):
/* library.scm:5508: outchr */
t2=((C_word*)((C_word*)t0)[3])[1];
f_29903(t2,((C_word*)t0)[4],((C_word*)t0)[5],C_make_character(110));
case C_fix(11):
/* library.scm:5509: outchr */
t2=((C_word*)((C_word*)t0)[3])[1];
f_29903(t2,((C_word*)t0)[4],((C_word*)t0)[5],C_make_character(118));
case C_fix(12):
/* library.scm:5510: outchr */
t2=((C_word*)((C_word*)t0)[3])[1];
f_29903(t2,((C_word*)t0)[4],((C_word*)t0)[5],C_make_character(102));
case C_fix(13):
/* library.scm:5511: outchr */
t2=((C_word*)((C_word*)t0)[3])[1];
f_29903(t2,((C_word*)t0)[4],((C_word*)t0)[5],C_make_character(114));
default:
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_30654,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[2],tmp=(C_word)a,a+=7,tmp);
/* library.scm:5513: outchr */
t3=((C_word*)((C_word*)t0)[3])[1];
f_29903(t3,t2,((C_word*)t0)[5],C_make_character(120));}}

/* k30652 in k30586 in doloop6471 in k30523 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30654(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_30654,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_30657,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(C_fixnum_lessp(((C_word*)t0)[6],C_fix(16)))){
/* library.scm:5514: outchr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29903(t3,t2,((C_word*)t0)[4],C_make_character(48));}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_30657(2,av2);}}}

/* k30655 in k30652 in k30586 in doloop6471 in k30523 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_30657(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_30657,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30660,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30667,a[2]=((C_word*)t0)[5],a[3]=t2,a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5515: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[6];
av2[3]=C_fix(16);
tp(4,av2);}}

/* k30658 in k30655 in k30652 in k30586 in doloop6471 in k30523 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_30660(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30660,c,av);}
/* library.scm:5516: outchr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29903(t2,((C_word*)t0)[3],((C_word*)t0)[4],C_make_character(59));}

/* k30665 in k30655 in k30652 in k30586 in doloop6471 in k30523 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_30667(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30667,c,av);}
/* library.scm:5515: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k30709 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30711(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_30711,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30714,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5521: out */
t3=((C_word*)((C_word*)t0)[5])[1];
f_30309(t3,t2,C_slot(((C_word*)t0)[2],C_fix(0)));}

/* k30712 in k30709 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_30714(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_30714,c,av);}
a=C_alloc(10);
t2=C_slot(((C_word*)t0)[2],C_fix(1));
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30723,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=t4,a[7]=((C_word)li849),tmp=(C_word)a,a+=8,tmp));
t6=((C_word*)t4)[1];
f_30723(t6,((C_word*)t0)[7],t2);}

/* doloop6502 in k30712 in k30709 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void f_30723(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,3)))){
C_save_and_reclaim_args((void *)trf_30723,3,t0,t1,t2);}
a=C_alloc(10);
t3=C_i_not(C_blockp(t2));
t4=(C_truep(t3)?t3:C_i_not(C_pairp(t2)));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30736,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t6=C_eqp(t2,C_SCHEME_END_OF_LIST);
if(C_truep(C_i_not(t6))){
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30745,a[2]=((C_word*)t0)[4],a[3]=t5,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5526: outstr */
t8=((C_word*)((C_word*)t0)[5])[1];
f_29820(t8,t7,((C_word*)t0)[3],lf[1036]);}
else{
/* library.scm:5528: outchr */
t7=((C_word*)((C_word*)t0)[2])[1];
f_29903(t7,t1,((C_word*)t0)[3],C_make_character(41));}}
else{
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_30755,a[2]=((C_word*)t0)[6],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5529: outchr */
t6=((C_word*)((C_word*)t0)[2])[1];
f_29903(t6,t5,((C_word*)t0)[3],C_make_character(32));}}

/* k30734 in doloop6502 in k30712 in k30709 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30736(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30736,c,av);}
/* library.scm:5528: outchr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29903(t2,((C_word*)t0)[3],((C_word*)t0)[4],C_make_character(41));}

/* k30743 in doloop6502 in k30712 in k30709 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30745(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_30745,c,av);}
/* library.scm:5527: out */
t2=((C_word*)((C_word*)t0)[2])[1];
f_30309(t2,((C_word*)t0)[3],((C_word*)t0)[4]);}

/* k30753 in doloop6502 in k30712 in k30709 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30755(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_30755,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30758,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5530: out */
t3=((C_word*)((C_word*)t0)[5])[1];
f_30309(t3,t2,C_slot(((C_word*)t0)[4],C_fix(0)));}

/* k30756 in k30753 in doloop6502 in k30712 in k30709 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_30758(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_30758,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_30723(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k30782 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30784(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_30784,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_30791,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5533: ##sys#bytevector->list */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[763]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[763]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k30789 in k30782 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_30791(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_30791,c,av);}
/* library.scm:5533: out */
t2=((C_word*)((C_word*)t0)[2])[1];
f_30309(t2,((C_word*)t0)[3],t1);}

/* k30805 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30807(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30807,c,av);}
/* library.scm:5535: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k30817 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30819(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_30819,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30822,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30829,a[2]=((C_word*)t0)[5],a[3]=t2,a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5539: ##sys#lambda-info->string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[893]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[893]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}}

/* k30820 in k30817 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_30822(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30822,c,av);}
/* library.scm:5540: outchr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29903(t2,((C_word*)t0)[3],((C_word*)t0)[4],C_make_character(62));}

/* k30827 in k30817 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_30829(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30829,c,av);}
/* library.scm:5539: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* k30836 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30838(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_30838,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30841,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5546: outstr */
t3=((C_word*)((C_word*)t0)[2])[1];
f_29820(t3,t2,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(3)));}

/* k30839 in k30836 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_30841(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30841,c,av);}
/* library.scm:5547: outstr */
t2=((C_word*)((C_word*)t0)[2])[1];
f_29820(t2,((C_word*)t0)[3],((C_word*)t0)[4],lf[1042]);}

/* k30886 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_30888(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_30888,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30891,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5554: out */
t3=((C_word*)((C_word*)t0)[5])[1];
f_30309(t3,t2,C_slot(((C_word*)t0)[6],C_fix(0)));}

/* k30889 in k30886 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_30891(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_30891,c,av);}
a=C_alloc(10);
t2=C_fixnum_difference(((C_word*)t0)[2],C_fix(1));
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30900,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=t4,a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word)li850),tmp=(C_word)a,a+=8,tmp));
t6=((C_word*)t4)[1];
f_30900(t6,((C_word*)t0)[7],C_fix(1),t2);}

/* doloop6531 in k30889 in k30886 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void f_30900(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_30900,4,t0,t1,t2,t3);}
a=C_alloc(8);
t4=C_eqp(t3,C_fix(0));
if(C_truep(t4)){
/* library.scm:5558: outchr */
t5=((C_word*)((C_word*)t0)[2])[1];
f_29903(t5,t1,((C_word*)t0)[3],C_make_character(41));}
else{
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_30913,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=t2,a[5]=t3,a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5559: outchr */
t6=((C_word*)((C_word*)t0)[2])[1];
f_29903(t6,t5,((C_word*)t0)[3],C_make_character(32));}}

/* k30911 in doloop6531 in k30889 in k30886 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_30913(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_30913,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_30916,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5560: out */
t3=((C_word*)((C_word*)t0)[6])[1];
f_30309(t3,t2,C_slot(((C_word*)t0)[7],((C_word*)t0)[4]));}

/* k30914 in k30911 in doloop6531 in k30889 in k30886 in out in k29816 in k29813 in k29810 in k29807 in ##sys#print in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_30916(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_30916,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_30900(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)),C_fixnum_difference(((C_word*)t0)[5],C_fix(1)));}

/* ##sys#procedure->string in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in ... */
static void C_ccall f_30941(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_30941,c,av);}
a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_30945,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5567: ##sys#lambda-info */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[892]);
C_word *av2=av;
av2[0]=*((C_word*)lf[892]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k30943 in ##sys#procedure->string in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_30945(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_30945,c,av);}
a=C_alloc(3);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_30955,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5569: ##sys#lambda-info->string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[893]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[893]+1);
av2[1]=t2;
av2[2]=t1;
tp(3,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=lf[1051];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k30953 in k30943 in ##sys#procedure->string in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_30955(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_30955,c,av);}
/* library.scm:5569: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1049];
av2[3]=t1;
av2[4]=lf[1050];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* chicken.base#record-printer in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in ... */
static void C_ccall f_30958(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_30958,c,av);}
t3=C_i_assq(t2,C_fast_retrieve(lf[1052]));
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=(C_truep(t3)?C_i_cdr(t3):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.base#set-record-printer! in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in ... */
static void C_ccall f_30970(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_30970,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_30974,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5581: ##sys#check-closure */
t5=*((C_word*)lf[434]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t3;
av2[3]=lf[1053];
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k30972 in chicken.base#set-record-printer! in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_30974(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,1)))){
C_save_and_reclaim((void *)f_30974,c,av);}
a=C_alloc(6);
t2=C_i_assq(((C_word*)t0)[2],C_fast_retrieve(lf[1052]));
if(C_truep(t2)){
t3=C_i_setslot(t2,C_fix(1),((C_word*)t0)[3]);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t4=C_a_i_cons(&a,2,t3,C_fast_retrieve(lf[1052]));
t5=C_mutate((C_word*)lf[1052]+1 /* (set! ##sys#record-printers ...) */,t4);
t6=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in ... */
static void C_ccall f_30996(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(84,c,6)))){
C_save_and_reclaim((void *)f_30996,c,av);}
a=C_alloc(84);
t2=C_mutate((C_word*)lf[243]+1 /* (set! chicken.base#record-printer ...) */,t1);
t3=C_mutate((C_word*)lf[1038]+1 /* (set! ##sys#user-print-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_30998,a[2]=((C_word)li863),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[1065]+1 /* (set! ##sys#with-print-length-limit ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31150,a[2]=((C_word)li868),tmp=(C_word)a,a+=3,tmp));
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31235,a[2]=t6,a[3]=((C_word)li869),tmp=(C_word)a,a+=4,tmp);
t8=C_set_block_item(t6,0,t7);
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41132,a[2]=((C_word)li870),tmp=(C_word)a,a+=3,tmp);
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41154,a[2]=((C_word)li871),tmp=(C_word)a,a+=3,tmp);
t11=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41172,a[2]=t6,a[3]=((C_word)li872),tmp=(C_word)a,a+=4,tmp);
t12=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41188,a[2]=t6,a[3]=((C_word)li873),tmp=(C_word)a,a+=4,tmp);
t13=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41210,a[2]=((C_word)li874),tmp=(C_word)a,a+=3,tmp);
t14=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41213,a[2]=((C_word)li875),tmp=(C_word)a,a+=3,tmp);
t15=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41216,a[2]=((C_word)li876),tmp=(C_word)a,a+=3,tmp);
t16=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41252,a[2]=((C_word)li880),tmp=(C_word)a,a+=3,tmp);
t17=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41336,a[2]=((C_word)li881),tmp=(C_word)a,a+=3,tmp);
t18=C_a_i_vector(&a,10,t9,t10,t11,t12,*((C_word*)lf[237]+1),t13,t14,t15,t16,t17);
t19=C_mutate((C_word*)lf[315]+1 /* (set! ##sys#string-port-class ...) */,t18);
t20=C_mutate((C_word*)lf[1067]+1 /* (set! ##sys#scan-buffer-line ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31288,a[2]=((C_word)li891),tmp=(C_word)a,a+=3,tmp));
t21=*((C_word*)lf[320]+1);
t22=*((C_word*)lf[318]+1);
t23=C_mutate((C_word*)lf[1070]+1 /* (set! ##sys#print-to-string ...) */,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31565,a[2]=t21,a[3]=t22,a[4]=((C_word)li894),tmp=(C_word)a,a+=5,tmp));
t24=C_mutate((C_word*)lf[1033]+1 /* (set! ##sys#pointer->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31608,a[2]=((C_word)li895),tmp=(C_word)a,a+=3,tmp));
t25=C_mutate((C_word*)lf[227]+1 /* (set! chicken.base#get-call-chain ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31661,a[2]=((C_word)li897),tmp=(C_word)a,a+=3,tmp));
t26=C_mutate((C_word*)lf[1079]+1 /* (set! ##sys#really-print-call-chain ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31815,a[2]=((C_word)li901),tmp=(C_word)a,a+=3,tmp));
t27=C_mutate((C_word*)lf[228]+1 /* (set! chicken.base#print-call-chain ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31920,a[2]=((C_word)li902),tmp=(C_word)a,a+=3,tmp));
t28=C_mutate((C_word*)lf[1087]+1 /* (set! ##sys#user-interrupt-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32011,a[2]=((C_word)li904),tmp=(C_word)a,a+=3,tmp));
t29=lf[1090] /* exit-in-progress */ =C_SCHEME_FALSE;;
t30=C_mutate(&lf[1091] /* (set! cleanup-before-exit ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32033,a[2]=((C_word)li907),tmp=(C_word)a,a+=3,tmp));
t31=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32136,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t32=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41108,a[2]=((C_word)li1234),tmp=(C_word)a,a+=3,tmp);
/* library.scm:5927: scheme#make-parameter */
t33=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t33;
av2[1]=t31;
av2[2]=t32;
((C_proc)(void*)(*((C_word*)t33+1)))(3,av2);}}

/* ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_30998(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_30998,c,av);}
a=C_alloc(10);
t5=C_slot(t2,C_fix(0));
t6=C_i_assq(t5,C_fast_retrieve(lf[1052]));
t7=C_i_vectorp(t5);
t8=(C_truep(t7)?C_slot(t5,C_fix(0)):t5);
if(C_truep(t6)){
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31014,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t10=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31019,a[2]=t4,a[3]=t8,a[4]=t6,a[5]=t2,a[6]=((C_word)li862),tmp=(C_word)a,a+=7,tmp);
/* library.scm:5598: scheme#call-with-current-continuation */
t11=*((C_word*)lf[162]+1);{
C_word *av2=av;
av2[0]=t11;
av2[1]=t9;
av2[2]=t10;
((C_proc)(void*)(*((C_word*)t11+1)))(3,av2);}}
else{
t9=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31100,a[2]=t1,a[3]=t4,a[4]=t5,a[5]=t2,a[6]=t8,tmp=(C_word)a,a+=7,tmp);
/* library.scm:5610: ##sys#print */
t10=*((C_word*)lf[1011]+1);{
C_word *av2=av;
av2[0]=t10;
av2[1]=t9;
av2[2]=lf[1064];
av2[3]=C_SCHEME_FALSE;
av2[4]=t4;
((C_proc)(void*)(*((C_word*)t10+1)))(5,av2);}}}

/* k31012 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31014(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_31014,c,av);}
/* library.scm:5598: g6576 */
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)C_fast_retrieve_proc(t2))(2,av2);}}

/* a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31019(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(13,c,3)))){
C_save_and_reclaim((void *)f_31019,c,av);}
a=C_alloc(13);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31025,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word)li857),tmp=(C_word)a,a+=6,tmp);
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31072,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[2],a[5]=t2,a[6]=((C_word)li861),tmp=(C_word)a,a+=7,tmp);
/* library.scm:5598: chicken.condition#with-exception-handler */
t5=C_fast_retrieve(lf[1060]);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t1;
av2[2]=t3;
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* a31024 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31025(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_31025,c,av);}
a=C_alloc(6);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31031,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word)li856),tmp=(C_word)a,a+=6,tmp);
/* library.scm:5598: k6573 */
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}

/* a31030 in a31024 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31031(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_31031,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31035,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5600: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1059];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31033 in a31030 in a31024 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31035(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_31035,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31038,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5601: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31036 in k31033 in a31030 in a31024 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31038(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_31038,c,av);}
a=C_alloc(5);
if(C_truep(C_i_structurep(((C_word*)t0)[2],lf[1055]))){
t2=C_slot(((C_word*)t0)[2],C_fix(2));
t3=C_i_member(lf[1056],t2);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31053,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5604: ##sys#print */
t5=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=lf[1057];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}
else{
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}
else{
/* library.scm:5607: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=lf[1058];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}}

/* k31051 in k31036 in k31033 in a31030 in a31024 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_31053(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_31053,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31056,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5605: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_i_cadr(((C_word*)t0)[4]);
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31054 in k31051 in k31036 in k31033 in a31030 in a31024 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_31056(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_31056,c,av);}
/* library.scm:5606: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=C_make_character(62);
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}

/* a31071 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31072(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_31072,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31078,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word)li858),tmp=(C_word)a,a+=6,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31087,a[2]=((C_word*)t0)[5],a[3]=((C_word)li860),tmp=(C_word)a,a+=4,tmp);
/* library.scm:5598: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
C_call_with_values(4,av2);}}

/* a31077 in a31071 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31078(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_31078,c,av);}
/* library.scm:5598: g6586 */
t2=C_slot(((C_word*)t0)[2],C_fix(1));{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
((C_proc)C_fast_retrieve_proc(t2))(4,av2);}}

/* a31086 in a31071 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31087(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_31087,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31093,a[2]=t2,a[3]=((C_word)li859),tmp=(C_word)a,a+=4,tmp);
/* library.scm:5598: k6573 */
t4=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t1;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}

/* a31092 in a31086 in a31071 in a31018 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31093(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_31093,c,av);}{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
C_apply_values(3,av2);}}

/* k31098 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31100(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_31100,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31103,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5611: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31101 in k31098 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31103(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_31103,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31106,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_eqp(((C_word*)t0)[4],lf[1055]);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31115,a[2]=t2,a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5614: ##sys#print */
t5=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=lf[1061];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}
else{
t4=C_eqp(((C_word*)t0)[4],lf[1062]);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31131,a[2]=t2,a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5617: ##sys#print */
t6=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[1063];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}
else{
/* library.scm:5619: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=C_make_character(62);
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}}}

/* k31104 in k31101 in k31098 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31106(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_31106,c,av);}
/* library.scm:5619: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=C_make_character(62);
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}

/* k31113 in k31101 in k31098 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31115(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31115,c,av);}
/* library.scm:5615: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_slot(((C_word*)t0)[3],C_fix(1));
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k31129 in k31101 in k31098 in ##sys#user-print-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31131(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31131,c,av);}
/* library.scm:5618: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_slot(((C_word*)t0)[3],C_fix(6));
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_31150(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_31150,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31156,a[2]=t2,a[3]=t3,a[4]=((C_word)li867),tmp=(C_word)a,a+=5,tmp);
/* library.scm:5624: call-with-current-continuation */
t5=*((C_word*)lf[162]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t1;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31156(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(27,c,4)))){
C_save_and_reclaim((void *)f_31156,c,av);}
a=C_alloc(27);
t3=C_fast_retrieve(lf[1015]);
t4=C_retrieve2(lf[1016],C_text("##sys#print-exit"));
t5=C_retrieve2(lf[1014],C_text("current-print-length"));
t6=((C_word*)t0)[2];
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=t2;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_fix(0);
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_SCHEME_TRUE;
t13=(*a=C_VECTOR_TYPE|1,a[1]=t12,tmp=(C_word)a,a+=2,tmp);
t14=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_31162,a[2]=t7,a[3]=t9,a[4]=t11,a[5]=t13,a[6]=t3,a[7]=((C_word)li864),tmp=(C_word)a,a+=8,tmp);
t15=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31205,a[2]=((C_word*)t0)[3],a[3]=((C_word)li865),tmp=(C_word)a,a+=4,tmp);
t16=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31211,a[2]=t7,a[3]=t9,a[4]=t11,a[5]=t3,a[6]=((C_word)li866),tmp=(C_word)a,a+=7,tmp);
/* library.scm:5626: ##sys#dynamic-wind */
t17=*((C_word*)lf[824]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t17;
av2[1]=t1;
av2[2]=t14;
av2[3]=t15;
av2[4]=t16;
((C_proc)(void*)(*((C_word*)t17+1)))(5,av2);}}

/* a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31162(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_31162,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_31166,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)((C_word*)t0)[5])[1])){
/* library.scm:5626: ##sys#print-length-limit6606 */
t3=((C_word*)t0)[6];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[2])[1];
av2[3]=C_SCHEME_TRUE;
av2[4]=C_SCHEME_FALSE;
((C_proc)C_fast_retrieve_proc(t3))(5,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)((C_word*)t0)[2])[1];
f_31166(2,av2);}}}

/* k31164 in a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31166(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_31166,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_31169,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=t1,tmp=(C_word)a,a+=9,tmp);
if(C_truep(((C_word*)((C_word*)t0)[5])[1])){
/* library.scm:5626: ##sys#print-exit6607 */
t3=C_retrieve2(lf[1016],C_text("##sys#print-exit"));{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=C_SCHEME_TRUE;
av2[4]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)((C_word*)t0)[3])[1];
f_31169(2,av2);}}}

/* k31167 in k31164 in a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31169(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_31169,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_31172,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t1,a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],tmp=(C_word)a,a+=10,tmp);
if(C_truep(((C_word*)((C_word*)t0)[5])[1])){
/* library.scm:5626: current-print-length66086609 */
t3=C_retrieve2(lf[1014],C_text("current-print-length"));{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[4])[1];
av2[3]=C_SCHEME_TRUE;
av2[4]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)((C_word*)t0)[4])[1];
f_31172(2,av2);}}}

/* k31170 in k31167 in k31164 in a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31172(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_31172,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_31176,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t1,a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],a[10]=((C_word*)t0)[9],tmp=(C_word)a,a+=11,tmp);
/* library.scm:5626: ##sys#print-length-limit6606 */
t3=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)C_fast_retrieve_proc(t3))(2,av2);}}

/* k31174 in k31170 in k31167 in k31164 in a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_31176(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_31176,c,av);}
a=C_alloc(10);
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_31180,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],a[9]=((C_word*)t0)[10],tmp=(C_word)a,a+=10,tmp);
/* library.scm:5626: ##sys#print-exit6607 */
t4=C_retrieve2(lf[1016],C_text("##sys#print-exit"));{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k31178 in k31174 in k31170 in k31167 in k31164 in a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_31180(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_31180,c,av);}
a=C_alloc(9);
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_31184,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5626: current-print-length66086609 */
t4=C_retrieve2(lf[1014],C_text("current-print-length"));{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k31182 in k31178 in k31174 in k31170 in k31167 in k31164 in a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_31184(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_31184,c,av);}
a=C_alloc(6);
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31187,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5626: ##sys#print-length-limit6606 */
t4=((C_word*)t0)[7];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[8];
av2[3]=C_SCHEME_FALSE;
av2[4]=C_SCHEME_TRUE;
((C_proc)C_fast_retrieve_proc(t4))(5,av2);}}

/* k31185 in k31182 in k31178 in k31174 in k31170 in k31167 in k31164 in a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_31187(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_31187,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31190,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5626: ##sys#print-exit6607 */
t3=C_retrieve2(lf[1016],C_text("##sys#print-exit"));{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=C_SCHEME_FALSE;
av2[4]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31188 in k31185 in k31182 in k31178 in k31174 in k31170 in k31167 in k31164 in a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_31190(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_31190,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31193,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5626: current-print-length66086609 */
t3=C_retrieve2(lf[1014],C_text("current-print-length"));{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=C_SCHEME_FALSE;
av2[4]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31191 in k31188 in k31185 in k31182 in k31178 in k31174 in k31170 in k31167 in k31164 in a31161 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_31193(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_31193,c,av);}
t2=C_set_block_item(((C_word*)t0)[2],0,C_SCHEME_FALSE);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a31204 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31205(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_31205,c,av);}
/* library.scm:5629: thunk */
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)C_fast_retrieve_proc(t2))(2,av2);}}

/* a31210 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31211(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_31211,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31215,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* library.scm:5626: ##sys#print-length-limit6606 */
t3=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)C_fast_retrieve_proc(t3))(2,av2);}}

/* k31213 in a31210 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31215(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_31215,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_31218,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5626: ##sys#print-exit6607 */
t3=C_retrieve2(lf[1016],C_text("##sys#print-exit"));{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k31216 in k31213 in a31210 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31218(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_31218,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_31221,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5626: current-print-length66086609 */
t3=C_retrieve2(lf[1014],C_text("current-print-length"));{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k31219 in k31216 in k31213 in a31210 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31221(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_31221,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_31224,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t1,a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5626: ##sys#print-length-limit6606 */
t3=((C_word*)t0)[8];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[2])[1];
av2[3]=C_SCHEME_FALSE;
av2[4]=C_SCHEME_TRUE;
((C_proc)C_fast_retrieve_proc(t3))(5,av2);}}

/* k31222 in k31219 in k31216 in k31213 in a31210 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_31224(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_31224,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_31227,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5626: ##sys#print-exit6607 */
t3=C_retrieve2(lf[1016],C_text("##sys#print-exit"));{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[4])[1];
av2[3]=C_SCHEME_FALSE;
av2[4]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31225 in k31222 in k31219 in k31216 in k31213 in a31210 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_31227(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_31227,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_31230,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5626: current-print-length66086609 */
t3=C_retrieve2(lf[1014],C_text("current-print-length"));{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[6])[1];
av2[3]=C_SCHEME_FALSE;
av2[4]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31228 in k31225 in k31222 in k31219 in k31216 in k31213 in a31210 in a31155 in ##sys#with-print-length-limit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_31230(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_31230,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,((C_word*)t0)[3]);
t3=C_mutate(((C_word *)((C_word*)t0)[4])+1,((C_word*)t0)[5]);
t4=C_mutate(((C_word *)((C_word*)t0)[6])+1,((C_word*)t0)[7]);
t5=((C_word*)t0)[8];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* check6650 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_31235(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_31235,c,av);}
a=C_alloc(9);
t4=C_slot(t2,C_fix(10));
t5=C_slot(t2,C_fix(11));
t6=C_slot(t2,C_fix(12));
t7=C_fixnum_plus(t4,t3);
if(C_truep(C_fixnum_greater_or_equal_p(t7,t5))){
t8=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_31257,a[2]=t5,a[3]=t6,a[4]=t4,a[5]=t2,a[6]=((C_word*)t0)[2],a[7]=t1,a[8]=t3,tmp=(C_word)a,a+=9,tmp);
if(C_truep(C_fixnum_greater_or_equal_p(t7,lf[334]))){
/* library.scm:5657: ##sys#error */
t9=*((C_word*)lf[195]+1);{
C_word *av2=av;
av2[0]=t9;
av2[1]=t8;
av2[2]=lf[1066];
av2[3]=t2;
((C_proc)(void*)(*((C_word*)t9+1)))(4,av2);}}
else{
t9=t8;{
C_word *av2=av;
av2[0]=t9;
av2[1]=C_SCHEME_UNDEFINED;
f_31257(2,av2);}}}
else{
t8=C_SCHEME_UNDEFINED;
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=t8;
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}}

/* k31255 in check6650 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31257(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_31257,c,av);}
a=C_alloc(9);
t2=C_fixnum_plus(((C_word*)t0)[2],((C_word*)t0)[2]);
t3=C_i_fixnum_min(lf[334],t2);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_31263,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t3,a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* library.scm:5659: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=t3;
tp(3,av2);}}

/* k31261 in k31255 in check6650 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31263(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_31263,c,av);}
t2=C_copy_memory_with_offset(t1,((C_word*)t0)[2],C_fix(0),C_fix(0),((C_word*)t0)[3]);
t3=C_i_setslot(((C_word*)t0)[4],C_fix(12),t1);
t4=C_i_set_i_slot(((C_word*)t0)[4],C_fix(11),((C_word*)t0)[5]);
/* library.scm:5663: check */
t5=((C_word*)((C_word*)t0)[6])[1];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=((C_word*)t0)[7];
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[8];
((C_proc)C_fast_retrieve_proc(t5))(4,av2);}}

/* ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_31288(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(c<6) C_bad_min_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(14,c,2)))){
C_save_and_reclaim((void *)f_31288,c,av);}
a=C_alloc(14);
t6=C_rest_nullp(c,6);
t7=(C_truep(t6)?C_SCHEME_FALSE:C_get_rest_arg(c,6,av,6,t0));
t8=C_fix(1024);
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_fix(0);
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_31295,a[2]=t9,a[3]=t11,a[4]=t7,a[5]=t5,a[6]=t1,a[7]=t2,a[8]=t4,a[9]=t3,tmp=(C_word)a,a+=10,tmp);
/* library.scm:5742: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t12;
av2[2]=((C_word*)t9)[1];
tp(3,av2);}}

/* k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31295(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(46,c,6)))){
C_save_and_reclaim((void *)f_31295,c,av);}
a=C_alloc(46);
t2=t1;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31297,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=((C_word)li882),tmp=(C_word)a,a+=6,tmp));
t13=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31308,a[2]=t3,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=t5,a[6]=((C_word)li883),tmp=(C_word)a,a+=7,tmp));
t14=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31331,a[2]=t3,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=t5,a[6]=((C_word)li884),tmp=(C_word)a,a+=7,tmp));
t15=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31351,a[2]=((C_word*)t0)[4],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=((C_word)li885),tmp=(C_word)a,a+=6,tmp));
t16=C_SCHEME_UNDEFINED;
t17=(*a=C_VECTOR_TYPE|1,a[1]=t16,tmp=(C_word)a,a+=2,tmp);
t18=C_set_block_item(t17,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_31366,a[2]=((C_word*)t0)[5],a[3]=t17,a[4]=t11,a[5]=t7,a[6]=t9,a[7]=((C_word)li890),tmp=(C_word)a,a+=8,tmp));
t19=((C_word*)t17)[1];
f_31366(t19,((C_word*)t0)[6],((C_word*)t0)[7],((C_word*)t0)[8],((C_word*)t0)[8],((C_word*)t0)[9]);}

/* grow in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31297(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_31297,2,t0,t1);}
a=C_alloc(7);
t2=C_fixnum_times(((C_word*)((C_word*)t0)[2])[1],C_fix(2));
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31304,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],a[5]=t2,a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:5745: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k31302 in grow in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31304(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_31304,c,av);}
t2=C_copy_memory(t1,((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]);
t3=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t4=C_set_block_item(((C_word*)t0)[4],0,((C_word*)t0)[5]);
t5=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* conc in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31308(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,2)))){
C_save_and_reclaim_args((void *)trf_31308,5,t0,t1,t2,t3,t4);}
a=C_alloc(8);
t5=C_fixnum_difference(t4,t3);
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_31315,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word*)t0)[3],a[5]=t3,a[6]=t5,a[7]=t1,tmp=(C_word)a,a+=8,tmp);
t7=C_fixnum_plus(((C_word*)((C_word*)t0)[3])[1],t5);
if(C_truep(C_fixnum_greater_or_equal_p(t7,((C_word*)((C_word*)t0)[4])[1]))){
/* library.scm:5751: grow */
t8=((C_word*)((C_word*)t0)[5])[1];
f_31297(t8,t6);}
else{
t8=t6;{
C_word av2[2];
av2[0]=t8;
av2[1]=C_SCHEME_UNDEFINED;
f_31315(2,av2);}}}

/* k31313 in conc in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31315(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_31315,c,av);}
t2=C_copy_memory_with_offset(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3],((C_word*)((C_word*)t0)[4])[1],((C_word*)t0)[5],((C_word*)t0)[6]);
t3=C_fixnum_plus(((C_word*)((C_word*)t0)[4])[1],((C_word*)t0)[6]);
t4=C_set_block_item(((C_word*)t0)[4],0,t3);
t5=((C_word*)t0)[7];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* conc1 in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31331(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_31331,3,t0,t1,t2);}
a=C_alloc(6);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31335,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
t4=C_fixnum_plus(((C_word*)((C_word*)t0)[3])[1],C_fix(1));
if(C_truep(C_fixnum_greater_or_equal_p(t4,((C_word*)((C_word*)t0)[4])[1]))){
/* library.scm:5755: grow */
t5=((C_word*)((C_word*)t0)[5])[1];
f_31297(t5,t3);}
else{
t5=t3;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_UNDEFINED;
f_31335(2,av2);}}}

/* k31333 in conc1 in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31335(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_31335,c,av);}
t2=C_setsubbyte(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1],((C_word*)t0)[4]);
t3=C_fixnum_plus(((C_word*)((C_word*)t0)[3])[1],C_fix(1));
t4=C_set_block_item(((C_word*)t0)[3],0,t3);
t5=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* getline in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31351(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,5)))){
C_save_and_reclaim_args((void *)trf_31351,2,t0,t1);}
if(C_truep(((C_word*)t0)[2])){
/* library.scm:5760: ##sys#buffer->string/encoding */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[461]+1));
C_word av2[6];
av2[0]=*((C_word*)lf[461]+1);
av2[1]=t1;
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)((C_word*)t0)[4])[1];
av2[5]=((C_word*)t0)[2];
tp(6,av2);}}
else{
/* library.scm:5761: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[300]+1);
av2[1]=t1;
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)((C_word*)t0)[4])[1];
tp(5,av2);}}}

/* loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31366(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,0,4)))){
C_save_and_reclaim_args((void *)trf_31366,6,t0,t1,t2,t3,t4,t5);}
a=C_alloc(13);
t6=C_eqp(t4,t5);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31376,a[2]=((C_word*)t0)[2],a[3]=t4,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:5767: conc */
t8=((C_word*)((C_word*)t0)[5])[1];
f_31308(t8,t7,t2,t3,t4);}
else{
t7=C_subbyte(t2,t4);
t8=C_eqp(t7,C_fix(10));
if(C_truep(t8)){
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31410,a[2]=t4,a[3]=t1,a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5775: conc */
t10=((C_word*)((C_word*)t0)[5])[1];
f_31308(t10,t9,t2,t3,t4);}
else{
t9=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_31427,a[2]=t4,a[3]=t1,a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t2,a[7]=t3,a[8]=t7,a[9]=t5,a[10]=((C_word*)t0)[2],a[11]=((C_word*)t0)[3],a[12]=((C_word*)t0)[6],tmp=(C_word)a,a+=13,tmp);
t10=C_eqp(t7,C_fix(13));
if(C_truep(t10)){
t11=C_fixnum_plus(t4,C_fix(1));
if(C_truep(C_fixnum_greaterp(t5,t11))){
t12=C_fixnum_plus(t4,C_fix(1));
t13=t9;
f_31427(t13,C_eqp(C_subbyte(t2,t12),C_fix(10)));}
else{
t12=t9;
f_31427(t12,C_SCHEME_FALSE);}}
else{
t11=t9;
f_31427(t11,C_SCHEME_FALSE);}}}}

/* k31374 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31376(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,5)))){
C_save_and_reclaim((void *)f_31376,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31381,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word)li886),tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31387,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word)li887),tmp=(C_word)a,a+=5,tmp);
/* library.scm:5768: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[6];
av2[2]=t2;
av2[3]=t3;
C_call_with_values(4,av2);}}

/* a31380 in k31374 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31381(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_31381,c,av);}
/* library.scm:5768: eos-handler */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* a31386 in k31374 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31387(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,5)))){
C_save_and_reclaim((void *)f_31387,c,av);}
a=C_alloc(4);
if(C_truep(t2)){
/* library.scm:5770: loop */
t5=((C_word*)((C_word*)t0)[2])[1];
f_31366(t5,t1,t2,t3,t3,t4);}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31401,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* library.scm:5771: getline */
t6=((C_word*)((C_word*)t0)[3])[1];
f_31351(t6,t5);}}

/* k31399 in a31386 in k31374 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31401(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31401,c,av);}
/* library.scm:5771: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=C_SCHEME_FALSE;
C_values(5,av2);}}

/* k31408 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31410(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_31410,c,av);}
a=C_alloc(4);
t2=C_fixnum_plus(((C_word*)t0)[2],C_fix(1));
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31421,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:5776: getline */
t4=((C_word*)((C_word*)t0)[4])[1];
f_31351(t4,t3);}

/* k31419 in k31408 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31421(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31421,c,av);}
/* library.scm:5776: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=C_SCHEME_TRUE;
C_values(5,av2);}}

/* k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_31427(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,5)))){
C_save_and_reclaim_args((void *)trf_31427,2,t0,t1);}
a=C_alloc(8);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31430,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5780: conc */
t3=((C_word*)((C_word*)t0)[5])[1];
f_31308(t3,t2,((C_word*)t0)[6],((C_word*)t0)[7],((C_word*)t0)[2]);}
else{
t2=C_eqp(((C_word*)t0)[8],C_fix(13));
t3=(C_truep(t2)?C_eqp(((C_word*)t0)[9],C_fixnum_plus(((C_word*)t0)[2],C_fix(1))):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_31450,a[2]=((C_word*)t0)[10],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[11],a[6]=((C_word*)t0)[12],a[7]=((C_word*)t0)[3],tmp=(C_word)a,a+=8,tmp);
/* library.scm:5784: conc */
t5=((C_word*)((C_word*)t0)[5])[1];
f_31308(t5,t4,((C_word*)t0)[6],((C_word*)t0)[7],((C_word*)t0)[2]);}
else{
t4=C_eqp(((C_word*)t0)[8],C_fix(13));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31508,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5798: conc */
t6=((C_word*)((C_word*)t0)[5])[1];
f_31308(t6,t5,((C_word*)t0)[6],((C_word*)t0)[7],((C_word*)t0)[2]);}
else{
/* library.scm:5800: loop */
t5=((C_word*)((C_word*)t0)[11])[1];
f_31366(t5,((C_word*)t0)[3],((C_word*)t0)[6],((C_word*)t0)[7],C_fixnum_plus(((C_word*)t0)[2],C_fix(1)),((C_word*)t0)[9]);}}}}

/* k31428 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31430(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_31430,c,av);}
a=C_alloc(4);
t2=C_fixnum_plus(((C_word*)t0)[2],C_fix(2));
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31441,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:5781: getline */
t4=((C_word*)((C_word*)t0)[4])[1];
f_31351(t4,t3);}

/* k31439 in k31428 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31441(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31441,c,av);}
/* library.scm:5781: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=C_SCHEME_TRUE;
C_values(5,av2);}}

/* k31448 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31450(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,5)))){
C_save_and_reclaim((void *)f_31450,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31455,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word)li888),tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31461,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=((C_word)li889),tmp=(C_word)a,a+=6,tmp);
/* library.scm:5785: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[7];
av2[2]=t2;
av2[3]=t3;
C_call_with_values(4,av2);}}

/* a31454 in k31448 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31455(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_31455,c,av);}
/* library.scm:5785: eos-handler */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* a31460 in k31448 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31461(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_31461,c,av);}
a=C_alloc(7);
if(C_truep(t2)){
t5=C_eqp(C_subbyte(t2,t3),C_fix(10));
if(C_truep(t5)){
t6=C_fixnum_plus(t3,C_fix(1));
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31482,a[2]=t1,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
/* library.scm:5788: getline */
t8=((C_word*)((C_word*)t0)[2])[1];
f_31351(t8,t7);}
else{
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31485,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,a[5]=t3,a[6]=t4,tmp=(C_word)a,a+=7,tmp);
/* library.scm:5791: conc1 */
t7=((C_word*)((C_word*)t0)[4])[1];
f_31331(t7,t6,C_fix(13));}}
else{
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31492,a[2]=t1,a[3]=t3,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* library.scm:5795: conc1 */
t6=((C_word*)((C_word*)t0)[4])[1];
f_31331(t6,t5,C_fix(13));}}

/* k31480 in a31460 in k31448 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_31482(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31482,c,av);}
/* library.scm:5788: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=C_SCHEME_TRUE;
C_values(5,av2);}}

/* k31483 in a31460 in k31448 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_31485(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_31485,c,av);}
/* library.scm:5792: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_31366(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[5],((C_word*)t0)[6]);}

/* k31490 in a31460 in k31448 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_31492(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_31492,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31499,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5796: getline */
t3=((C_word*)((C_word*)t0)[4])[1];
f_31351(t3,t2);}

/* k31497 in k31490 in a31460 in k31448 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_31499(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31499,c,av);}
/* library.scm:5796: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=C_SCHEME_TRUE;
C_values(5,av2);}}

/* k31506 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31508(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_31508,c,av);}
a=C_alloc(4);
t2=C_fixnum_plus(((C_word*)t0)[2],C_fix(1));
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31519,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:5799: getline */
t4=((C_word*)((C_word*)t0)[4])[1];
f_31351(t4,t3);}

/* k31517 in k31506 in k31425 in loop in k31293 in ##sys#scan-buffer-line in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31519(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31519,c,av);}
/* library.scm:5799: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=C_SCHEME_TRUE;
C_values(5,av2);}}

/* ##sys#print-to-string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_31565(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_31565,c,av);}
a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31569,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5806: open-output-string */
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k31567 in ##sys#print-to-string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31569(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(16,c,3)))){
C_save_and_reclaim((void *)f_31569,c,av);}
a=C_alloc(16);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31570,a[2]=t1,a[3]=((C_word)li892),tmp=(C_word)a,a+=4,tmp);
t3=C_i_check_list_2(((C_word*)t0)[2],lf[820]);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31580,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31585,a[2]=t6,a[3]=t2,a[4]=((C_word)li893),tmp=(C_word)a,a+=5,tmp));
t8=((C_word*)t6)[1];
f_31585(t8,t4,((C_word*)t0)[2]);}

/* g6803 in k31567 in ##sys#print-to-string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31570(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,4)))){
C_save_and_reclaim_args((void *)trf_31570,3,t0,t1,t2);}
/* library.scm:5807: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t3;
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31578 in k31567 in ##sys#print-to-string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31580(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_31580,c,av);}
/* library.scm:5808: get-output-string */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* for-each-loop6802 in k31567 in ##sys#print-to-string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31585(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_31585,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31595,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5807: g6803 */
t4=((C_word*)t0)[3];
f_31570(t4,t3,C_slot(t2,C_fix(0)));}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k31593 in for-each-loop6802 in k31567 in ##sys#print-to-string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31595(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_31595,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_31585(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* ##sys#pointer->string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_31608(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_31608,c,av);}
a=C_alloc(7);
if(C_truep(C_taggedpointerp(t2))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31619,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t4=C_slot(t2,C_fix(1));
if(C_truep(C_i_pairp(t4))){
t5=C_u_i_car(t4);
t6=C_a_i_list1(&a,1,t5);
/* library.scm:5816: ##sys#print-to-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1070]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1070]+1);
av2[1]=t3;
av2[2]=t6;
tp(3,av2);}}
else{
t5=C_a_i_list1(&a,1,t4);
/* library.scm:5816: ##sys#print-to-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1070]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1070]+1);
av2[1]=t3;
av2[2]=t5;
tp(3,av2);}}}
else{
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31649,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31653,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5822: ##sys#pointer->address */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1074]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1074]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}}

/* k31617 in ##sys#pointer->string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31619(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_31619,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31623,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_31627,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5820: ##sys#pointer->address */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1074]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[1074]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k31621 in k31617 in ##sys#pointer->string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31623(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_31623,c,av);}
/* library.scm:5814: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1071];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1072];
av2[5]=t1;
av2[6]=lf[1073];
((C_proc)(void*)(*((C_word*)t2+1)))(7,av2);}}

/* k31625 in k31617 in ##sys#pointer->string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31627(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_31627,c,av);}
/* library.scm:5820: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_fix(16);
tp(4,av2);}}

/* k31647 in ##sys#pointer->string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31649(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31649,c,av);}
/* library.scm:5822: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1075];
av2[3]=t1;
av2[4]=lf[1076];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k31651 in ##sys#pointer->string in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31653(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_31653,c,av);}
/* library.scm:5822: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_fix(16);
tp(4,av2);}}

/* chicken.base#get-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_31661(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_31661,c,av);}
a=C_alloc(6);
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?C_fix(0):C_get_rest_arg(c,2,av,2,t0));
t4=C_rest_nullp(c,2);
t5=C_rest_nullp(c,3);
t6=(C_truep(t5)?C_fast_retrieve(lf[1077]):C_get_rest_arg(c,3,av,2,t0));
t7=C_rest_nullp(c,3);
t8=C_fix((C_word)C_trace_buffer_size);
t9=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31677,a[2]=t3,a[3]=t8,a[4]=t6,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:5836: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t9;
av2[2]=C_fixnum_times(C_fix(5),t8);
av2[3]=C_SCHEME_FALSE;
tp(4,av2);}}

/* k31675 in chicken.base#get-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31677(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_31677,c,av);}
a=C_alloc(10);
t2=C_fetch_trace(((C_word*)t0)[2],t1);
t3=C_fixnump(t2);
t4=(C_truep(t3)?t2:C_fixnum_times(C_fix(5),((C_word*)t0)[3]));
t5=(C_truep(((C_word*)t0)[4])?C_slot(((C_word*)t0)[4],C_fix(14)):C_SCHEME_FALSE);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_31688,a[2]=t4,a[3]=t1,a[4]=t7,a[5]=((C_word*)t0)[4],a[6]=t5,a[7]=((C_word)li896),tmp=(C_word)a,a+=8,tmp));
t9=((C_word*)t7)[1];
f_31688(t9,((C_word*)t0)[5],C_fix(0));}

/* loop in k31675 in chicken.base#get-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31688(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_31688,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_fixnum_greater_or_equal_p(t2,((C_word*)t0)[2]))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_fixnum_plus(t2,C_fix(4));
t4=C_slot(((C_word*)t0)[3],t3);
t5=C_i_not(t4);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31707,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
if(C_truep(t5)){
t7=t6;
f_31707(t7,t5);}
else{
t7=C_i_not(((C_word*)t0)[5]);
t8=t6;
f_31707(t8,(C_truep(t7)?t7:C_eqp(((C_word*)t0)[6],t4)));}}}

/* k31705 in loop in k31675 in chicken.base#get-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_31707(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,3)))){
C_save_and_reclaim_args((void *)trf_31707,2,t0,t1);}
a=C_alloc(11);
if(C_truep(t1)){
t2=C_fixnum_plus(((C_word*)t0)[2],C_fix(1));
t3=C_slot(((C_word*)t0)[3],t2);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31729,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
if(C_truep(t3)){
t5=t4;{
C_word av2[2];
av2[0]=t5;
av2[1]=t3;
f_31729(2,av2);}}
else{
t5=C_slot(((C_word*)t0)[3],((C_word*)t0)[2]);
t6=C_a_i_bytevector(&a,1,C_fix(3));
/* library.scm:5831: ##sys#peek-nonnull-c-string */
t7=*((C_word*)lf[1078]+1);{
C_word av2[4];
av2[0]=t7;
av2[1]=t4;
av2[2]=stub6825(t6,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}}
else{
/* library.scm:5851: loop */
t2=((C_word*)((C_word*)t0)[5])[1];
f_31688(t2,((C_word*)t0)[4],C_fixnum_plus(((C_word*)t0)[2],C_fix(5)));}}

/* k31716 in k31727 in k31705 in loop in k31675 in chicken.base#get-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31718(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_31718,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k31727 in k31705 in loop in k31675 in chicken.base#get-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31729(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_31729,c,av);}
a=C_alloc(8);
t2=C_fixnum_plus(((C_word*)t0)[2],C_fix(2));
t3=C_slot(((C_word*)t0)[3],t2);
t4=C_fixnum_plus(((C_word*)t0)[2],C_fix(3));
t5=C_slot(((C_word*)t0)[3],t4);
t6=C_a_i_vector3(&a,3,t1,t3,t5);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31718,a[2]=((C_word*)t0)[4],a[3]=t6,tmp=(C_word)a,a+=4,tmp);
/* library.scm:5850: loop */
t8=((C_word*)((C_word*)t0)[5])[1];
f_31688(t8,t7,C_fixnum_plus(((C_word*)t0)[2],C_fix(5)));}

/* ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_31815(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_31815,c,av);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t3))){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31825,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5855: ##sys#print */
t6=*((C_word*)lf[1011]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t4;
av2[3]=C_SCHEME_FALSE;
av2[4]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}
else{
t5=C_SCHEME_UNDEFINED;
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31825(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,3)))){
C_save_and_reclaim((void *)f_31825,c,av);}
a=C_alloc(15);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31826,a[2]=((C_word*)t0)[2],a[3]=((C_word)li899),tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31892,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31897,a[2]=t5,a[3]=t2,a[4]=((C_word)li900),tmp=(C_word)a,a+=5,tmp));
t7=((C_word*)t5)[1];
f_31897(t7,t3,((C_word*)t0)[4]);}

/* g6872 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31826(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,4)))){
C_save_and_reclaim_args((void *)trf_31826,3,t0,t1,t2);}
a=C_alloc(8);
t3=C_slot(t2,C_fix(1));
t4=C_slot(t2,C_fix(2));
t5=C_i_structurep(t4,lf[1080]);
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_31839,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=t5,a[6]=t4,a[7]=t2,tmp=(C_word)a,a+=8,tmp);
/* library.scm:5861: ##sys#print */
t7=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t7;
av2[1]=t6;
av2[2]=lf[1083];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t7+1)))(5,av2);}}

/* k31837 in g6872 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31839(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_31839,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31842,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
/* library.scm:5862: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_slot(((C_word*)t0)[7],C_fix(0));
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31840 in k31837 in g6872 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_31842(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_31842,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_31845,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
/* library.scm:5863: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1082];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k31843 in k31840 in k31837 in g6872 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_31845(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_31845,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31848,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31863,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)t0)[6])){
if(C_truep(((C_word*)t0)[5])){
t4=t3;
f_31863(t4,C_slot(((C_word*)t0)[6],C_fix(1)));}
else{
t4=C_SCHEME_UNDEFINED;
t5=t3;
f_31863(t5,t4);}}
else{
t4=t3;
f_31863(t4,C_SCHEME_FALSE);}}

/* k31846 in k31843 in k31840 in k31837 in g6872 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_31848(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_31848,c,av);}
a=C_alloc(5);
if(C_truep(((C_word*)t0)[2])){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31856,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word)li898),tmp=(C_word)a,a+=5,tmp);
/* library.scm:5873: ##sys#with-print-length-limit */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1065]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1065]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=C_fix(100);
av2[3]=t2;
tp(4,av2);}}
else{
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* a31855 in k31846 in k31843 in k31840 in k31837 in g6872 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_31856(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31856,c,av);}
/* library.scm:5876: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=C_SCHEME_TRUE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k31861 in k31843 in k31840 in k31837 in g6872 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_31863(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_31863,2,t0,t1);}
a=C_alloc(6);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_31866,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:5865: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word av2[4];
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t2;
av2[2]=C_make_character(91);
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
f_31848(2,av2);}}}

/* k31864 in k31861 in k31843 in k31840 in k31837 in g6872 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_31866(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_31866,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_31869,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)t0)[4])){
/* library.scm:5866: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_slot(((C_word*)t0)[5],C_fix(1));
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}
else{
/* library.scm:5866: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}}

/* k31867 in k31864 in k31861 in k31843 in k31840 in k31837 in g6872 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_31869(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31869,c,av);}
/* library.scm:5871: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1081];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k31890 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_31892(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31892,c,av);}
/* library.scm:5878: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1084];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* for-each-loop6871 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_31897(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_31897,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31907,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5856: g6872 */
t4=((C_word*)t0)[3];
f_31826(t4,t3,C_slot(t2,C_fix(0)));}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k31905 in for-each-loop6871 in k31823 in ##sys#really-print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_31907(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_31907,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_31897(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* chicken.base#print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_31920(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_31920,c,av);}
a=C_alloc(5);
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?*((C_word*)lf[839]+1):C_get_rest_arg(c,2,av,2,t0));
t4=C_rest_nullp(c,2);
t5=C_rest_nullp(c,3);
t6=(C_truep(t5)?C_fix(0):C_get_rest_arg(c,3,av,2,t0));
t7=C_rest_nullp(c,3);
t8=C_rest_nullp(c,4);
t9=(C_truep(t8)?C_fast_retrieve(lf[1077]):C_get_rest_arg(c,4,av,2,t0));
t10=C_rest_nullp(c,4);
t11=C_rest_nullp(c,5);
t12=(C_truep(t11)?lf[1085]:C_get_rest_arg(c,5,av,2,t0));
t13=C_rest_nullp(c,5);
t14=C_i_check_port_2(t3,C_fix(2),C_SCHEME_TRUE,lf[1086]);
t15=C_i_check_fixnum_2(t6,lf[1086]);
t16=C_i_check_string_2(t12,lf[1086]);
t17=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_31961,a[2]=t1,a[3]=t3,a[4]=t12,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5887: chicken.base#get-call-chain */
t18=*((C_word*)lf[227]+1);{
C_word av2[4];
av2[0]=t18;
av2[1]=t17;
av2[2]=t6;
av2[3]=t9;
((C_proc)(void*)(*((C_word*)t18+1)))(4,av2);}}

/* k31959 in chicken.base#print-call-chain in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_31961(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_31961,c,av);}
/* library.scm:5887: ##sys#really-print-call-chain */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1079]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[1079]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}

/* ##sys#user-interrupt-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_32011(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_32011,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32014,a[2]=((C_word)li903),tmp=(C_word)a,a+=3,tmp);
t3=C_eqp(C_fast_retrieve(lf[1077]),C_fast_retrieve(lf[1089]));
if(C_truep(t3)){
/* library.scm:5893: ##sys#signal-hook */
t4=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t1;
av2[2]=lf[1088];
av2[3]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}
else{
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_setslot(C_fast_retrieve(lf[1089]),C_fix(1),t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* break in ##sys#user-interrupt-hook in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_32014(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_32014,c,av);}
/* library.scm:5893: ##sys#signal-hook */
t2=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=lf[1088];
av2[3]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void f_32033(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,4)))){
C_save_and_reclaim_args((void *)trf_32033,1,t1);}
a=C_alloc(6);
t2=lf[1090] /* exit-in-progress */ =C_SCHEME_TRUE;;
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32038,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_dump_heap_on_exitp())){
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32129,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5908: ##sys#print */
t5=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t5;
av2[1]=t4;
av2[2]=lf[1098];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}
else{
t4=t3;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
f_32038(2,av2);}}}

/* k32036 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_32038(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_32038,c,av);}
a=C_alloc(9);
t2=(C_truep(C_i_profilingp())?C_i_dump_statistical_profile():C_SCHEME_UNDEFINED);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32044,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32081,a[2]=t5,a[3]=((C_word)li906),tmp=(C_word)a,a+=4,tmp));
t7=((C_word*)t5)[1];
f_32081(t7,t3);}

/* k32042 in k32036 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_32044(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_32044,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32047,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=C_slot(C_fast_retrieve(lf[1095]),C_fix(0));
if(C_truep(C_fixnum_greaterp(t3,C_fix(0)))){
/* library.scm:5919: ##sys#run-pending-finalizers */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1096]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[1096]+1);
av2[1]=t2;
av2[2]=C_SCHEME_FALSE;
tp(3,av2);}}
else{
t4=t2;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
f_32047(2,av2);}}}

/* k32045 in k32042 in k32036 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_32047(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_32047,c,av);}
a=C_alloc(3);
if(C_truep(C_fixnum_greaterp(C_i_live_finalizer_count(),C_fix(0)))){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32056,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_debug_modep())){
/* library.scm:5922: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1094];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_32056(2,av2);}}}
else{
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k32054 in k32045 in k32042 in k32036 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32056(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_32056,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32062,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:5923: chicken.gc#force-finalizers */
t3=C_fast_retrieve(lf[1093]);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k32060 in k32054 in k32045 in k32042 in k32036 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32062(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32062,c,av);}
if(C_truep(t1)){
/* library.scm:5924: ##sys#force-finalizers */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1092]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1092]+1);
av2[1]=((C_word*)t0)[2];
tp(2,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* loop in k32036 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void f_32081(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,3)))){
C_save_and_reclaim_args((void *)trf_32081,2,t0,t1);}
a=C_alloc(10);
t2=*((C_word*)lf[259]+1);
t3=C_set_block_item(lf[259] /* chicken.base#cleanup-tasks */,0,C_SCHEME_END_OF_LIST);
if(C_truep(C_i_nullp(t2))){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t4=C_i_check_list_2(t2,lf[820]);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32100,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32105,a[2]=t7,a[3]=((C_word)li905),tmp=(C_word)a,a+=4,tmp));
t9=((C_word*)t7)[1];
f_32105(t9,t5,t2);}}

/* k32098 in loop in k32036 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_32100(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32100,c,av);}
/* library.scm:5917: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_32081(t2,((C_word*)t0)[3]);}

/* for-each-loop6931 in loop in k32036 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void f_32105(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_32105,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_32115,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5916: t */
t4=C_slot(t2,C_fix(0));{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)C_fast_retrieve_proc(t4))(2,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k32113 in for-each-loop6931 in loop in k32036 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32115(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_32115,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_32105(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k32127 in cleanup-before-exit in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_32129(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32129,c,av);}
/* library.scm:5909: ##sys#dump-heap-state */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1097]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1097]+1);
av2[1]=((C_word*)t0)[2];
tp(2,av2);}}

/* k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_32136(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_32136,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[258]+1 /* (set! chicken.base#exit-handler ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32140,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41102,a[2]=((C_word)li1233),tmp=(C_word)a,a+=3,tmp);
/* library.scm:5937: scheme#make-parameter */
t5=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_32140(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_32140,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[257]+1 /* (set! chicken.base#implicit-exit-handler ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32144,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41093,a[2]=((C_word)li1232),tmp=(C_word)a,a+=3,tmp);
/* library.scm:5942: scheme#make-parameter */
t5=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_32144(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,5)))){
C_save_and_reclaim((void *)f_32144,c,av);}
a=C_alloc(29);
t2=C_mutate((C_word*)lf[1099]+1 /* (set! ##sys#reset-handler ...) */,t1);
t3=C_mutate((C_word*)lf[1100]+1 /* (set! ##sys#dbg-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32146,a[2]=((C_word)li908),tmp=(C_word)a,a+=3,tmp));
t4=C_a_i_provide(&a,1,lf[1101]);
t5=C_mutate((C_word*)lf[379]+1 /* (set! ##sys#signal-hook/errno ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32149,a[2]=((C_word)li911),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[235]+1 /* (set! ##sys#signal-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32443,a[2]=((C_word)li912),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[1103]+1 /* (set! chicken.condition#abort ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32458,a[2]=((C_word)li913),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[1142]+1 /* (set! chicken.condition#signal ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32475,a[2]=((C_word)li914),tmp=(C_word)a,a+=3,tmp));
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32483,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40951,a[2]=((C_word)li1231),tmp=(C_word)a,a+=3,tmp);
/* library.scm:6051: scheme#make-parameter */
t11=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t11;
av2[1]=t9;
av2[2]=t10;
((C_proc)(void*)(*((C_word*)t11+1)))(3,av2);}}

/* ##sys#dbg-hook in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_32146(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32146,c,av);}
t2=C_dbg_hook(C_SCHEME_FALSE);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_32149(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c<5) C_bad_min_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-5)*C_SIZEOF_PAIR +13,c,4)))){
C_save_and_reclaim((void*)f_32149,c,av);}
a=C_alloc((c-5)*C_SIZEOF_PAIR+13);
t5=C_build_rest(&a,c,5,av);
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t7=C_dbg_hook(C_SCHEME_FALSE);
t8=signal_debug_event(t2,((C_word*)t6)[1],t5);
t9=C_eqp(t2,lf[1088]);
if(C_truep(t9)){
t10=C_a_i_record3(&a,3,lf[1055],lf[1102],C_SCHEME_END_OF_LIST);
/* library.scm:5975: abort */
t11=C_fast_retrieve(lf[1103]);{
C_word *av2=av;
av2[0]=t11;
av2[1]=t1;
av2[2]=t10;
((C_proc)(void*)(*((C_word*)t11+1)))(3,av2);}}
else{
t10=C_eqp(t2,lf[372]);
t11=(C_truep(t10)?t10:C_eqp(t2,lf[374]));
if(C_truep(t11)){
t12=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_32175,a[2]=t1,a[3]=t5,a[4]=t6,tmp=(C_word)a,a+=5,tmp);
t13=C_eqp(t2,lf[372]);
if(C_truep(t13)){
/* library.scm:5981: ##sys#print */
t14=*((C_word*)lf[1011]+1);{
C_word *av2=av;
av2[0]=t14;
av2[1]=t12;
av2[2]=lf[1105];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t14+1)))(5,av2);}}
else{
/* library.scm:5981: ##sys#print */
t14=*((C_word*)lf[1011]+1);{
C_word *av2=av;
av2[0]=t14;
av2[1]=t12;
av2[2]=lf[1106];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t14+1)))(5,av2);}}}
else{
t12=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_32251,a[2]=t6,a[3]=t5,a[4]=t3,a[5]=t1,a[6]=t2,tmp=(C_word)a,a+=7,tmp);
t13=C_i_symbolp(((C_word*)t6)[1]);
t14=(C_truep(t13)?C_i_nullp(t5):C_SCHEME_FALSE);
if(C_truep(t14)){
t15=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32426,a[2]=t6,a[3]=t12,tmp=(C_word)a,a+=4,tmp);
/* library.scm:5999: scheme#symbol->string */
t16=*((C_word*)lf[740]+1);{
C_word *av2=av;
av2[0]=t16;
av2[1]=t15;
av2[2]=((C_word*)t6)[1];
((C_proc)(void*)(*((C_word*)t16+1)))(3,av2);}}
else{
t15=t12;
f_32251(t15,C_SCHEME_UNDEFINED);}}}}

/* k32173 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32175(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_32175,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32178,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:5984: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[4])[1];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k32176 in k32173 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32178(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_32178,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32181,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_i_nullp(((C_word*)t0)[3]);
t4=(C_truep(t3)?t3:C_fixnum_greaterp(C_u_i_length(((C_word*)t0)[3]),C_fix(1)));
if(C_truep(t4)){
/* library.scm:5986: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t2;
av2[2]=C_make_character(10);
av2[3]=*((C_word*)lf[840]+1);
tp(4,av2);}}
else{
/* library.scm:5987: ##sys#print */
t5=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=lf[1104];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}}

/* k32179 in k32176 in k32173 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_32181(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_32181,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32198,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32203,a[2]=t4,a[3]=((C_word)li910),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_32203(t6,t2,((C_word*)t0)[3]);}

/* a32187 in for-each-loop7010 in k32179 in k32176 in k32173 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_32188(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_32188,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32192,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5993: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
av2[3]=C_SCHEME_TRUE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k32190 in a32187 in for-each-loop7010 in k32179 in k32176 in k32173 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_32192(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_32192,c,av);}
/* library.scm:5994: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=C_make_character(10);
av2[3]=*((C_word*)lf[840]+1);
tp(4,av2);}}

/* k32196 in k32179 in k32176 in k32173 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_32198(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_32198,c,av);}
/* library.scm:5996: ##sys#flush-output */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[885]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[885]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[840]+1);
tp(3,av2);}}

/* for-each-loop7010 in k32179 in k32176 in k32173 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void f_32203(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,3)))){
C_save_and_reclaim_args((void *)trf_32203,3,t0,t1,t2);}
a=C_alloc(9);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_32213,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t4=C_slot(t2,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32188,a[2]=t4,a[3]=((C_word)li909),tmp=(C_word)a,a+=4,tmp);
/* library.scm:5990: ##sys#with-print-length-limit */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1065]);
C_word av2[4];
av2[0]=*((C_word*)lf[1065]+1);
av2[1]=t3;
av2[2]=C_fix(400);
av2[3]=t5;
tp(4,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k32211 in for-each-loop7010 in k32179 in k32176 in k32173 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_32213(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_32213,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_32203(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k32249 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_32251(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_32251,2,t0,t1);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_32254,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
t3=C_i_not(((C_word*)((C_word*)t0)[2])[1]);
if(C_truep(t3)){
t4=t2;
f_32254(t4,(C_truep(t3)?C_i_pairp(((C_word*)t0)[3]):C_SCHEME_FALSE));}
else{
t4=C_i_symbolp(((C_word*)((C_word*)t0)[2])[1]);
t5=t2;
f_32254(t5,(C_truep(t4)?C_i_pairp(((C_word*)t0)[3]):C_SCHEME_FALSE));}}

/* k32252 in k32249 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_32254(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_32254,2,t0,t1);}
a=C_alloc(7);
t2=(C_truep(t1)?((C_word*)((C_word*)t0)[2])[1]:C_SCHEME_FALSE);
t3=(C_truep(t1)?C_slot(((C_word*)t0)[3],C_fix(0)):((C_word*)((C_word*)t0)[2])[1]);
t4=(C_truep(t1)?C_slot(((C_word*)t0)[3],C_fix(1)):((C_word*)t0)[3]);
t5=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_32274,a[2]=t3,a[3]=t4,a[4]=t2,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
t6=C_eqp(((C_word*)t0)[6],lf[295]);
if(C_truep(t6)){
t7=t5;
f_32274(t7,lf[1112]);}
else{
t7=C_eqp(((C_word*)t0)[6],lf[920]);
if(C_truep(t7)){
t8=t5;
f_32274(t8,lf[1113]);}
else{
t8=C_eqp(((C_word*)t0)[6],lf[472]);
if(C_truep(t8)){
t9=t5;
f_32274(t9,lf[1114]);}
else{
t9=C_eqp(((C_word*)t0)[6],lf[663]);
if(C_truep(t9)){
t10=t5;
f_32274(t10,lf[1115]);}
else{
t10=C_eqp(((C_word*)t0)[6],lf[467]);
if(C_truep(t10)){
t11=t5;
f_32274(t11,lf[1116]);}
else{
t11=C_eqp(((C_word*)t0)[6],lf[1117]);
if(C_truep(t11)){
t12=t5;
f_32274(t12,lf[1118]);}
else{
t12=C_eqp(((C_word*)t0)[6],lf[1119]);
if(C_truep(t12)){
t13=t5;
f_32274(t13,lf[1120]);}
else{
t13=C_eqp(((C_word*)t0)[6],lf[1121]);
if(C_truep(t13)){
t14=t5;
f_32274(t14,lf[1122]);}
else{
t14=C_eqp(((C_word*)t0)[6],lf[1123]);
if(C_truep(t14)){
t15=t5;
f_32274(t15,lf[1124]);}
else{
t15=C_eqp(((C_word*)t0)[6],lf[1125]);
if(C_truep(t15)){
t16=t5;
f_32274(t16,lf[1126]);}
else{
t16=C_eqp(((C_word*)t0)[6],lf[1127]);
if(C_truep(t16)){
t17=t5;
f_32274(t17,lf[1128]);}
else{
t17=C_eqp(((C_word*)t0)[6],lf[1129]);
if(C_truep(t17)){
t18=t5;
f_32274(t18,lf[1130]);}
else{
t18=C_eqp(((C_word*)t0)[6],lf[1131]);
if(C_truep(t18)){
t19=t5;
f_32274(t19,lf[1132]);}
else{
t19=C_eqp(((C_word*)t0)[6],lf[1133]);
t20=t5;
f_32274(t20,(C_truep(t19)?lf[1134]:lf[1135]));}}}}}}}}}}}}}}

/* k32272 in k32252 in k32249 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_32274(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,2)))){
C_save_and_reclaim_args((void *)trf_32274,2,t0,t1);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_32292,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
/* library.scm:6026: chicken.base#get-call-chain */
t3=*((C_word*)lf[227]+1);{
C_word av2[2];
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k32290 in k32272 in k32252 in k32249 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_32292(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(34,c,2)))){
C_save_and_reclaim((void *)f_32292,c,av);}
a=C_alloc(34);
t2=C_a_i_list8(&a,8,lf[1107],((C_word*)t0)[2],lf[1108],((C_word*)t0)[3],lf[1109],t1,lf[1110],((C_word*)t0)[4]);
if(C_truep(((C_word*)t0)[5])){
t3=C_a_i_cons(&a,2,((C_word*)t0)[5],t2);
t4=C_a_i_cons(&a,2,lf[1111],t3);
t5=C_a_i_record3(&a,3,lf[1055],((C_word*)t0)[6],t4);
/* library.scm:6004: abort */
t6=C_fast_retrieve(lf[1103]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t6;
av2[1]=((C_word*)t0)[7];
av2[2]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}
else{
t3=C_a_i_record3(&a,3,lf[1055],((C_word*)t0)[6],t2);
/* library.scm:6004: abort */
t4=C_fast_retrieve(lf[1103]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[7];
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}}

/* k32424 in ##sys#signal-hook/errno in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32426(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32426,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=((C_word*)t0)[3];
f_32251(t3,t2);}

/* ##sys#signal-hook in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_32443(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +0,c,6)))){
C_save_and_reclaim((void*)f_32443,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+0);
t4=C_build_rest(&a,c,4,av);
C_word t5;
if(C_truep(C_i_pairp(t4))){{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_fast_retrieve(lf[379]);
av2[3]=t2;
av2[4]=C_SCHEME_FALSE;
av2[5]=t3;
av2[6]=t4;
C_apply(7,av2);}}
else{
/* library.scm:6035: ##sys#signal-hook/errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[379]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[379]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_SCHEME_FALSE;
av2[4]=t3;
tp(5,av2);}}}

/* chicken.condition#abort in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_32458(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_32458,c,av);}
a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32462,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6038: ##sys#current-exception-handler */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1141]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1141]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k32460 in chicken.condition#abort in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32462(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(22,c,2)))){
C_save_and_reclaim((void *)f_32462,c,av);}
a=C_alloc(22);
t2=C_a_i_list6(&a,6,lf[1136],lf[1137],lf[1138],C_SCHEME_END_OF_LIST,lf[1139],C_SCHEME_FALSE);
t3=C_a_i_record3(&a,3,lf[1055],lf[1140],t2);
/* library.scm:6039: abort */
t4=C_fast_retrieve(lf[1103]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* chicken.condition#signal in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_32475(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_32475,c,av);}
/* library.scm:6048: ##sys#current-exception-handler */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1141]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1141]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}

/* k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_32483(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(39,c,5)))){
C_save_and_reclaim((void *)f_32483,c,av);}
a=C_alloc(39);
t2=C_mutate((C_word*)lf[1143]+1 /* (set! ##sys#error-handler ...) */,t1);
t3=C_set_block_item(lf[1144] /* ##sys#last-exception */,0,C_SCHEME_FALSE);
t4=C_mutate((C_word*)lf[1141]+1 /* (set! ##sys#current-exception-handler ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32486,a[2]=((C_word)li915),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[1060]+1 /* (set! chicken.condition#with-exception-handler ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32646,a[2]=((C_word)li918),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[1160]+1 /* (set! chicken.condition#current-exception-handler ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32660,a[2]=((C_word)li920),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate(&lf[1162] /* (set! chicken.condition#prop-list->kind-prefixed-prop-list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32721,a[2]=((C_word)li922),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[1164]+1 /* (set! chicken.condition#make-property-condition ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32789,a[2]=((C_word)li923),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate((C_word*)lf[1166]+1 /* (set! chicken.condition#make-composite-condition ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32803,a[2]=((C_word)li927),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate((C_word*)lf[1168]+1 /* (set! chicken.condition#condition ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32943,a[2]=((C_word)li930),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[1169]+1 /* (set! chicken.condition#condition? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33048,a[2]=((C_word)li931),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate((C_word*)lf[1170]+1 /* (set! chicken.condition#condition->list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33054,a[2]=((C_word)li935),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate((C_word*)lf[1173]+1 /* (set! chicken.condition#condition-predicate ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33172,a[2]=((C_word)li937),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate((C_word*)lf[1174]+1 /* (set! chicken.condition#condition-property-accessor ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33193,a[2]=((C_word)li939),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate((C_word*)lf[1177]+1 /* (set! chicken.condition#get-condition-property ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33239,a[2]=((C_word)li940),tmp=(C_word)a,a+=3,tmp));
t16=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33250,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6229: chicken.condition#condition-property-accessor */
t17=C_fast_retrieve(lf[1174]);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t17;
av2[1]=t16;
av2[2]=lf[1147];
av2[3]=lf[1259];
av2[4]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t17+1)))(5,av2);}}

/* ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32486(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(14,c,4)))){
C_save_and_reclaim((void *)f_32486,c,av);}
a=C_alloc(14);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32490,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_structurep(t2,lf[1055]))){
t4=C_mutate((C_word*)lf[1144]+1 /* (set! ##sys#last-exception ...) */,t2);
t5=C_slot(t2,C_fix(1));
if(C_truep(C_i_memq(lf[1147],t5))){
t6=C_slot(t2,C_fix(2));
t7=C_i_member(lf[1148],t6);
t8=C_i_member(lf[1149],t6);
t9=C_i_member(lf[1150],t6);
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32529,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
t11=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_32539,a[2]=t8,a[3]=t10,a[4]=t7,a[5]=t9,tmp=(C_word)a,a+=6,tmp);
/* library.scm:6098: ##sys#error-handler */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1143]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1143]+1);
av2[1]=t11;
tp(2,av2);}}
else{
t6=C_slot(t5,C_fix(0));
t7=C_eqp(lf[1155],t6);
if(C_truep(t7)){
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32600,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6116: ##sys#print */
t9=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t9;
av2[1]=t8;
av2[2]=lf[1156];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t9+1)))(5,av2);}}
else{
t8=C_slot(t5,C_fix(0));
t9=C_eqp(lf[1157],t8);
if(C_truep(t9)){
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32615,a[2]=t3,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6119: ##sys#error-handler */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1143]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1143]+1);
av2[1]=t10;
tp(2,av2);}}
else{
t10=C_a_i_list2(&a,2,lf[1145],t2);
t11=C_a_i_record3(&a,3,lf[1055],lf[1146],t10);
/* library.scm:6123: abort */
t12=C_fast_retrieve(lf[1103]);{
C_word *av2=av;
av2[0]=t12;
av2[1]=t1;
av2[2]=t11;
((C_proc)(void*)(*((C_word*)t12+1)))(3,av2);}}}}}
else{
t4=C_a_i_list2(&a,2,lf[1145],t2);
t5=C_a_i_record3(&a,3,lf[1055],lf[1146],t4);
/* library.scm:6123: abort */
t6=C_fast_retrieve(lf[1103]);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
av2[2]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}}

/* k32488 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32490(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_32490,c,av);}
a=C_alloc(10);
t2=C_a_i_list2(&a,2,lf[1145],((C_word*)t0)[2]);
t3=C_a_i_record3(&a,3,lf[1055],lf[1146],t2);
/* library.scm:6123: abort */
t4=C_fast_retrieve(lf[1103]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k32527 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32529(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_32529,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32532,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6114: ##sys#reset-handler */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1099]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1099]+1);
av2[1]=t2;
tp(2,av2);}}

/* k32530 in k32527 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_32532(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32532,c,av);}
/* library.scm:6093: g7145 */
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)C_fast_retrieve_proc(t2))(2,av2);}}

/* k32537 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32539(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_32539,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_32543,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
if(C_truep(((C_word*)t0)[4])){
t3=C_i_cadr(((C_word*)t0)[4]);
t4=(C_truep(((C_word*)t0)[5])?C_i_cadr(((C_word*)t0)[5]):C_SCHEME_FALSE);
t5=(C_truep(t4)?C_i_symbolp(t4):C_SCHEME_FALSE);
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32569,a[2]=t3,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6104: ##sys#symbol->string/shared */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[737]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[737]+1);
av2[1]=t6;
av2[2]=t4;
tp(3,av2);}}
else{
t6=t2;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t3;
f_32543(2,av2);}}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=lf[1154];
f_32543(2,av2);}}}

/* k32541 in k32537 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_32543(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_32543,c,av);}
if(C_truep(((C_word*)t0)[2])){{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=t1;
av2[4]=C_i_cadr(((C_word*)t0)[2]);
C_apply(5,av2);}}
else{
t2=((C_word*)t0)[4];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}}

/* k32567 in k32537 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_32569(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_32569,c,av);}
if(C_truep(C_i_symbolp(((C_word*)t0)[2]))){
/* library.scm:6103: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=lf[1151];
av2[3]=t1;
av2[4]=lf[1152];
av2[5]=C_slot(((C_word*)t0)[2],C_fix(1));
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}
else{
if(C_truep(C_i_stringp(((C_word*)t0)[2]))){
/* library.scm:6103: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=lf[1151];
av2[3]=t1;
av2[4]=lf[1152];
av2[5]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}
else{
/* library.scm:6103: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=lf[1151];
av2[3]=t1;
av2[4]=lf[1152];
av2[5]=lf[1153];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}}}

/* k32598 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32600(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_32600,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32603,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6117: ##sys#reset-handler */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1099]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1099]+1);
av2[1]=t2;
tp(2,av2);}}

/* k32601 in k32598 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_32603(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32603,c,av);}
/* library.scm:6092: g7148 */
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)C_fast_retrieve_proc(t2))(2,av2);}}

/* k32613 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32615(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_32615,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32618,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=C_slot(((C_word*)t0)[3],C_fix(2));
t4=C_i_member(lf[1158],t3);
/* library.scm:6092: g7151 */
t5=t1;{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=lf[1159];
av2[3]=C_i_cadr(t4);
((C_proc)C_fast_retrieve_proc(t5))(4,av2);}}

/* k32616 in k32613 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_32618(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_32618,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32621,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6122: ##sys#reset-handler */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1099]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1099]+1);
av2[1]=t2;
tp(2,av2);}}

/* k32619 in k32616 in k32613 in ##sys#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_32621(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32621,c,av);}
/* library.scm:6092: g7153 */
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)C_fast_retrieve_proc(t2))(2,av2);}}

/* chicken.condition#with-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32646(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_32646,c,av);}
a=C_alloc(8);
t4=C_fast_retrieve(lf[1141]);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32652,a[2]=t2,a[3]=((C_word)li916),tmp=(C_word)a,a+=4,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32656,a[2]=t4,a[3]=((C_word)li917),tmp=(C_word)a,a+=4,tmp);
/* library.scm:6131: ##sys#dynamic-wind */
t7=*((C_word*)lf[824]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t7;
av2[1]=t1;
av2[2]=t5;
av2[3]=t3;
av2[4]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(5,av2);}}

/* a32651 in chicken.condition#with-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32652(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32652,c,av);}
t2=C_mutate((C_word*)lf[1141]+1 /* (set! ##sys#current-exception-handler ...) */,((C_word*)t0)[2]);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a32655 in chicken.condition#with-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32656(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_32656,c,av);}
t2=C_mutate((C_word*)lf[1141]+1 /* (set! ##sys#current-exception-handler ...) */,((C_word*)t0)[2]);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.condition#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32660(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +5,c,3)))){
C_save_and_reclaim((void*)f_32660,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+5);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
if(C_truep(C_i_nullp(t2))){
t3=C_fast_retrieve(lf[1141]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fast_retrieve(lf[1141]);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_i_car(t2);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_32673,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:6141: ##sys#check-closure */
t5=*((C_word*)lf[434]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=t3;
av2[3]=lf[1161];
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}}

/* k32671 in chicken.condition#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32673(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_32673,c,av);}
a=C_alloc(10);
t2=C_u_i_cdr(((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32675,a[2]=((C_word*)t0)[3],a[3]=((C_word)li919),tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32681,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32686,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_nullp(t2))){
t6=(
/* library.scm:6142: def-convert?7169 */
  f_32686(t5)
);
t7=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t7;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t6=C_i_car(t2);
t7=C_u_i_cdr(t2);
if(C_truep(C_i_nullp(t7))){
t8=(
/* library.scm:6142: def-set?7170 */
  f_32681(t4)
);
t9=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t9;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}
else{
t8=C_i_car(t7);
t9=C_u_i_cdr(t7);
t10=(
/* library.scm:6142: body7167 */
  f_32675(t3,t8)
);
t11=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t11;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t11+1)))(2,av2);}}}}

/* body7167 in k32671 in chicken.condition#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static C_word f_32675(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_stack_overflow_check;{}
if(C_truep(t1)){
t2=C_mutate((C_word*)lf[1141]+1 /* (set! ##sys#current-exception-handler ...) */,((C_word*)t0)[2]);
return(t2);}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* def-set?7170 in k32671 in chicken.condition#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static C_word f_32681(C_word t0){
C_word tmp;
C_word t1;
C_stack_overflow_check;{}
return((
/* library.scm:6142: body7167 */
  f_32675(((C_word*)t0)[2],C_SCHEME_TRUE)
));}

/* def-convert?7169 in k32671 in chicken.condition#current-exception-handler in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static C_word f_32686(C_word t0){
C_word tmp;
C_word t1;
C_stack_overflow_check;{}
return((
/* library.scm:6142: def-set?7170 */
  f_32681(((C_word*)t0)[2])
));}

/* chicken.condition#prop-list->kind-prefixed-prop-list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void f_32721(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,3)))){
C_save_and_reclaim_args((void *)trf_32721,4,t1,t2,t3,t4);}
a=C_alloc(9);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_32727,a[2]=t2,a[3]=t4,a[4]=t3,a[5]=t6,a[6]=((C_word)li921),tmp=(C_word)a,a+=7,tmp));
t8=((C_word*)t6)[1];
f_32727(t8,t1,t4);}

/* loop in chicken.condition#prop-list->kind-prefixed-prop-list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_32727(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,2)))){
C_save_and_reclaim_args((void *)trf_32727,3,t0,t1,t2);}
a=C_alloc(8);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_i_pairp(t2);
t4=C_i_not(t3);
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_32743,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
if(C_truep(t4)){
t6=t5;
f_32743(t6,t4);}
else{
t6=C_i_cdr(t2);
t7=t5;
f_32743(t7,C_i_not(C_i_pairp(t6)));}}}

/* k32741 in loop in chicken.condition#prop-list->kind-prefixed-prop-list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_32743(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,5)))){
C_save_and_reclaim_args((void *)trf_32743,2,t0,t1);}
a=C_alloc(8);
if(C_truep(t1)){
/* library.scm:6152: ##sys#signal-hook */
t2=*((C_word*)lf[235]+1);{
C_word av2[6];
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[295];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1163];
av2[5]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}
else{
t2=C_i_car(((C_word*)t0)[5]);
t3=C_a_i_cons(&a,2,((C_word*)t0)[6],t2);
t4=C_i_cadr(((C_word*)t0)[5]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_32765,a[2]=t4,a[3]=((C_word*)t0)[2],a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t6=C_u_i_cdr(((C_word*)t0)[5]);
/* library.scm:6156: loop */
t7=((C_word*)((C_word*)t0)[7])[1];
f_32727(t7,t5,C_u_i_cdr(t6));}}

/* k32763 in k32741 in loop in chicken.condition#prop-list->kind-prefixed-prop-list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_32765(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,1)))){
C_save_and_reclaim((void *)f_32765,c,av);}
a=C_alloc(6);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[4],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.condition#make-property-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32789(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +7,c,4)))){
C_save_and_reclaim((void*)f_32789,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+7);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
t4=C_a_i_list1(&a,1,t2);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32801,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6161: prop-list->kind-prefixed-prop-list */
f_32721(t5,lf[1165],t2,t3);}

/* k32799 in chicken.condition#make-property-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32801(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_32801,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_record3(&a,3,lf[1055],((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.condition#make-composite-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32803(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +26,c,3)))){
C_save_and_reclaim((void*)f_32803,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+26);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
t4=C_a_i_cons(&a,2,t2,t3);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32920,a[2]=((C_word)li924),tmp=(C_word)a,a+=3,tmp);
t6=(
  f_32920(t4)
);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32822,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
t8=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t9=t8;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=((C_word*)t10)[1];
t12=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32884,a[2]=t7,tmp=(C_word)a,a+=3,tmp);
t13=C_SCHEME_UNDEFINED;
t14=(*a=C_VECTOR_TYPE|1,a[1]=t13,tmp=(C_word)a,a+=2,tmp);
t15=C_set_block_item(t14,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_32886,a[2]=t10,a[3]=t14,a[4]=t11,a[5]=((C_word)li926),tmp=(C_word)a,a+=6,tmp));
t16=((C_word*)t14)[1];
f_32886(t16,t12,t4);}

/* k32820 in chicken.condition#make-composite-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32822(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(20,c,3)))){
C_save_and_reclaim((void *)f_32822,c,av);}
a=C_alloc(20);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32826,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t4=t3;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=((C_word*)t5)[1];
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_32838,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_32840,a[2]=t5,a[3]=t9,a[4]=t6,a[5]=((C_word)li925),tmp=(C_word)a,a+=6,tmp));
t11=((C_word*)t9)[1];
f_32840(t11,t7,((C_word*)t0)[3]);}

/* k32824 in k32820 in chicken.condition#make-composite-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_32826(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_32826,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_record3(&a,3,lf[1055],((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k32836 in k32820 in chicken.condition#make-composite-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_32838(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_32838,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[291]+1);
av2[3]=t1;
C_apply(4,av2);}}

/* map-loop7256 in k32820 in chicken.condition#make-composite-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_32840(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_32840,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_slot(t3,C_fix(2));
t5=C_a_i_cons(&a,2,t4,C_SCHEME_END_OF_LIST);
t6=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t5);
t7=C_mutate(((C_word *)((C_word*)t0)[2])+1,t5);
t9=t1;
t10=C_slot(t2,C_fix(1));
t1=t9;
t2=t10;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k32882 in chicken.condition#make-composite-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32884(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_32884,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[291]+1);
av2[3]=t1;
C_apply(4,av2);}}

/* map-loop7229 in chicken.condition#make-composite-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_32886(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_32886,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_slot(t3,C_fix(1));
t5=C_a_i_cons(&a,2,t4,C_SCHEME_END_OF_LIST);
t6=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t5);
t7=C_mutate(((C_word *)((C_word*)t0)[2])+1,t5);
t9=t1;
t10=C_slot(t2,C_fix(1));
t1=t9;
t2=t10;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* for-each-loop7211 in chicken.condition#make-composite-condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static C_word f_32920(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=C_slot(t1,C_fix(0));
t3=C_i_check_structure_2(t2,lf[1055],lf[1167]);
t5=C_slot(t1,C_fix(1));
t1=t5;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* chicken.condition#condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_32943(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +23,c,3)))){
C_save_and_reclaim((void*)f_32943,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+23);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
t4=C_a_i_cons(&a,2,t2,t3);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32950,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
t6=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t7=t6;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=((C_word*)t8)[1];
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33012,a[2]=t5,tmp=(C_word)a,a+=3,tmp);
t11=C_SCHEME_UNDEFINED;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_set_block_item(t12,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_33014,a[2]=t8,a[3]=t12,a[4]=t9,a[5]=((C_word)li929),tmp=(C_word)a,a+=6,tmp));
t14=((C_word*)t12)[1];
f_33014(t14,t10,t4);}

/* k32948 in chicken.condition#condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_32950(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(17,c,3)))){
C_save_and_reclaim((void *)f_32950,c,av);}
a=C_alloc(17);
t2=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=((C_word*)t4)[1];
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_32960,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_32962,a[2]=t4,a[3]=t8,a[4]=t5,a[5]=((C_word)li928),tmp=(C_word)a,a+=6,tmp));
t10=((C_word*)t8)[1];
f_32962(t10,t6,((C_word*)t0)[3]);}

/* k32958 in k32948 in chicken.condition#condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_32960(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_32960,c,av);}
a=C_alloc(4);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_record3(&a,3,lf[1055],t1,((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* map-loop7316 in k32948 in chicken.condition#condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_32962(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_32962,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_i_car(t3);
t5=C_a_i_cons(&a,2,t4,C_SCHEME_END_OF_LIST);
t6=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t5);
t7=C_mutate(((C_word *)((C_word*)t0)[2])+1,t5);
t9=t1;
t10=C_slot(t2,C_fix(1));
t1=t9;
t2=t10;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k33010 in chicken.condition#condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_33012(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_33012,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[291]+1);
av2[3]=t1;
C_apply(4,av2);}}

/* map-loop7289 in chicken.condition#condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void f_33014(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,4)))){
C_save_and_reclaim_args((void *)trf_33014,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_33039,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
t4=C_slot(t2,C_fix(0));
/* library.scm:6176: prop-list->kind-prefixed-prop-list */
f_32721(t3,lf[1055],C_i_car(t4),C_u_i_cdr(t4));}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k33037 in map-loop7289 in chicken.condition#condition in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_33039(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_33039,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_SCHEME_END_OF_LIST);
t3=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t2);
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
t5=((C_word*)((C_word*)t0)[3])[1];
f_33014(t5,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}

/* chicken.condition#condition? in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_33048(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_33048,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_structurep(t2,lf[1055]);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.condition#condition->list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_33054(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_33054,c,av);}
a=C_alloc(8);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33058,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33167,a[2]=t3,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6184: condition? */
t5=C_fast_retrieve(lf[1169]);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* k33056 in chicken.condition#condition->list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_33058(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(18,c,3)))){
C_save_and_reclaim((void *)f_33058,c,av);}
a=C_alloc(18);
t2=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=((C_word*)t4)[1];
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33062,a[2]=((C_word*)t0)[2],a[3]=((C_word)li933),tmp=(C_word)a,a+=4,tmp);
t7=C_slot(((C_word*)t0)[2],C_fix(1));
t8=C_i_check_list_2(t7,lf[822]);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_33132,a[2]=t4,a[3]=t10,a[4]=t6,a[5]=t5,a[6]=((C_word)li934),tmp=(C_word)a,a+=7,tmp));
t12=((C_word*)t10)[1];
f_33132(t12,((C_word*)t0)[3],t7);}

/* g7352 in k33056 in chicken.condition#condition->list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_33062(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,3)))){
C_save_and_reclaim_args((void *)trf_33062,3,t0,t1,t2);}
a=C_alloc(11);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33070,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t4=C_slot(((C_word*)t0)[2],C_fix(2));
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33076,a[2]=t2,a[3]=t6,a[4]=((C_word)li932),tmp=(C_word)a,a+=5,tmp));
t8=((C_word*)t6)[1];
f_33076(t8,t3,t4);}

/* k33068 in g7352 in k33056 in chicken.condition#condition->list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_33070(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_33070,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* loop in g7352 in k33056 in chicken.condition#condition->list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void f_33076(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_33076,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_i_caar(t2);
t4=C_eqp(t3,((C_word*)t0)[2]);
if(C_truep(t4)){
t5=C_u_i_car(t2);
t6=C_u_i_cdr(t5);
t7=C_i_cadr(t2);
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33107,a[2]=t7,a[3]=t1,a[4]=t6,tmp=(C_word)a,a+=5,tmp);
t9=C_u_i_cdr(t2);
/* library.scm:6194: loop */
t11=t8;
t12=C_u_i_cdr(t9);
t1=t11;
t2=t12;
goto loop;}
else{
/* library.scm:6196: loop */
t11=t1;
t12=C_i_cddr(t2);
t1=t11;
t2=t12;
goto loop;}}}

/* k33105 in loop in g7352 in k33056 in chicken.condition#condition->list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_33107(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,1)))){
C_save_and_reclaim((void *)f_33107,c,av);}
a=C_alloc(6);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[4],t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* map-loop7346 in k33056 in chicken.condition#condition->list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void f_33132(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_33132,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_33157,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:6188: g7352 */
t4=((C_word*)t0)[4];
f_33062(t4,t3,C_slot(t2,C_fix(0)));}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[5],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k33155 in map-loop7346 in k33056 in chicken.condition#condition->list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_33157(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_33157,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_SCHEME_END_OF_LIST);
t3=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t2);
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
t5=((C_word*)((C_word*)t0)[3])[1];
f_33132(t5,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}

/* k33165 in chicken.condition#condition->list in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_33167(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_33167,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
f_33058(2,av2);}}
else{
/* library.scm:6185: ##sys#signal-hook */
t2=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[295];
av2[3]=lf[1171];
av2[4]=lf[1172];
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}}

/* chicken.condition#condition-predicate in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_33172(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_33172,c,av);}
a=C_alloc(4);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33174,a[2]=t2,a[3]=((C_word)li936),tmp=(C_word)a,a+=4,tmp);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* f_33174 in chicken.condition#condition-predicate in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_33174(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_33174,c,av);}
a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33181,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:6201: condition? */
t4=C_fast_retrieve(lf[1169]);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k33179 */
static void C_ccall f_33181(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_33181,c,av);}
if(C_truep(t1)){
t2=C_slot(((C_word*)t0)[2],C_fix(1));
t3=C_i_memv(((C_word*)t0)[3],t2);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=(C_truep(t3)?C_SCHEME_TRUE:C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* chicken.condition#condition-property-accessor in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_33193(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +11,c,3)))){
C_save_and_reclaim((void*)f_33193,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+11);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
t5=C_i_nullp(t4);
t6=C_a_i_cons(&a,2,t2,t3);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_33201,a[2]=t2,a[3]=t6,a[4]=t5,a[5]=t3,a[6]=t4,a[7]=((C_word)li938),tmp=(C_word)a,a+=8,tmp);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* f_33201 in chicken.condition#condition-property-accessor in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_33201(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_33201,c,av);}
t3=C_i_check_structure(t2,lf[1055]);
t4=C_slot(t2,C_fix(1));
if(C_truep(C_i_memv(((C_word*)t0)[2],t4))){
t5=C_slot(t2,C_fix(2));
t6=C_i_member(((C_word*)t0)[3],t5);
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_i_cadr(t6);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
if(C_truep(((C_word*)t0)[4])){
/* library.scm:6212: ##sys#signal-hook */
t7=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t7;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=lf[1175];
av2[4]=lf[1176];
av2[5]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t7+1)))(6,av2);}}
else{
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_i_car(((C_word*)t0)[6]);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}}
else{
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* chicken.condition#get-condition-property in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_33239(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c<5) C_bad_min_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-5)*C_SIZEOF_PAIR +4,c,5)))){
C_save_and_reclaim((void*)f_33239,c,av);}
a=C_alloc((c-5)*C_SIZEOF_PAIR+4);
t5=C_build_rest(&a,c,5,av);
C_word t6;
C_word t7;
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33243,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=0;
av2[1]=t6;
av2[2]=C_fast_retrieve(lf[1174]);
av2[3]=t3;
av2[4]=t4;
av2[5]=t5;
C_apply(6,av2);}}

/* k33241 in chicken.condition#get-condition-property in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_33243(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_33243,c,av);}
/* library.scm:6218: g7401 */
t2=t1;{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_33250(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_33250,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33253,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6230: chicken.condition#condition-property-accessor */
t3=C_fast_retrieve(lf[1174]);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1147];
av2[3]=lf[980];
av2[4]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_33253(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_33253,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33256,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6231: chicken.condition#condition-property-accessor */
t3=C_fast_retrieve(lf[1174]);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1147];
av2[3]=lf[1261];
av2[4]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_33256(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(26,c,4)))){
C_save_and_reclaim((void *)f_33256,c,av);}
a=C_alloc(26);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33257,a[2]=((C_word)li944),tmp=(C_word)a,a+=3,tmp);
t3=C_mutate((C_word*)lf[1178]+1 /* (set! chicken.condition#print-error-message ...) */,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_33302,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=((C_word)li949),tmp=(C_word)a,a+=7,tmp));
t4=C_fast_retrieve(lf[1178]);
t5=*((C_word*)lf[228]+1);
t6=*((C_word*)lf[318]+1);
t7=*((C_word*)lf[320]+1);
t8=C_mutate((C_word*)lf[1190]+1 /* (set! ##sys#show-exception-warning ...) */,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_33493,a[2]=t5,a[3]=t4,a[4]=t7,a[5]=t6,a[6]=((C_word)li950),tmp=(C_word)a,a+=7,tmp));
t9=C_mutate((C_word*)lf[439]+1 /* (set! ##sys#error-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33542,a[2]=((C_word)li951),tmp=(C_word)a,a+=3,tmp));
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34272,a[2]=((C_word*)t0)[4],tmp=(C_word)a,a+=3,tmp);
t11=C_a_i_list1(&a,1,C_fast_retrieve(lf[1141]));
t12=C_i_setslot(t11,C_fix(1),t11);
/* library.scm:6399: scheme#make-parameter */
t13=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t13;
av2[1]=t10;
av2[2]=t11;
((C_proc)(void*)(*((C_word*)t13+1)))(3,av2);}}

/* writeargs in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void f_33257(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,3)))){
C_save_and_reclaim_args((void *)trf_33257,3,t1,t2,t3);}
a=C_alloc(11);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33259,a[2]=t3,a[3]=((C_word)li942),tmp=(C_word)a,a+=4,tmp);
t5=C_i_check_list_2(t2,lf[820]);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33280,a[2]=t7,a[3]=t4,a[4]=((C_word)li943),tmp=(C_word)a,a+=5,tmp));
t9=((C_word*)t7)[1];
f_33280(t9,t1,t2);}

/* g7417 in writeargs in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_33259(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,3)))){
C_save_and_reclaim_args((void *)trf_33259,3,t0,t1,t2);}
a=C_alloc(9);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33263,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33268,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word)li941),tmp=(C_word)a,a+=5,tmp);
/* library.scm:6236: ##sys#with-print-length-limit */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1065]);
C_word av2[4];
av2[0]=*((C_word*)lf[1065]+1);
av2[1]=t3;
av2[2]=C_fix(80);
av2[3]=t4;
tp(4,av2);}}

/* k33261 in g7417 in writeargs in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_33263(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_33263,c,av);}
/* library.scm:6237: newline */
t2=*((C_word*)lf[191]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* a33267 in g7417 in writeargs in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_33268(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_33268,c,av);}
/* library.scm:6236: write */
t2=*((C_word*)lf[192]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* for-each-loop7416 in writeargs in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_33280(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_33280,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33290,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:6234: g7417 */
t4=((C_word*)t0)[3];
f_33259(t4,t3,C_slot(t2,C_fix(0)));}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k33288 in for-each-loop7416 in writeargs in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_33290(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_33290,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_33280(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_33302(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(16,c,4)))){
C_save_and_reclaim((void *)f_33302,c,av);}
a=C_alloc(16);
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_33304,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word)li946),tmp=(C_word)a,a+=8,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33453,a[2]=t3,a[3]=((C_word)li947),tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33458,a[2]=t4,a[3]=((C_word)li948),tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_rest_nullp(c,3))){
/* library.scm:6240: def-port7439 */
t6=t5;
f_33458(t6,t1);}
else{
t6=C_get_rest_arg(c,3,av,3,t0);
if(C_truep(C_rest_nullp(c,4))){
/* library.scm:6240: def-header7440 */
t7=t4;
f_33453(t7,t1,t6);}
else{
t7=C_get_rest_arg(c,4,av,3,t0);
/* library.scm:6240: body7437 */
t8=t3;
f_33304(t8,t1,t6,t7);}}}

/* body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_33304(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,2)))){
C_save_and_reclaim_args((void *)trf_33304,4,t0,t1,t2,t3);}
a=C_alloc(10);
t4=C_i_check_port_2(t2,C_fix(2),C_SCHEME_TRUE,lf[1179]);
t5=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_33311,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],a[9]=t3,tmp=(C_word)a,a+=10,tmp);
/* library.scm:6243: newline */
t6=*((C_word*)lf[191]+1);{
C_word av2[3];
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}

/* k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_33311(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_33311,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_33314,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* library.scm:6244: display */
t3=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[9];
av2[3]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_33314(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_33314,c,av);}
a=C_alloc(8);
t2=C_immp(((C_word*)t0)[2]);
t3=C_i_not(t2);
t4=(C_truep(t3)?C_eqp(lf[1055],C_slot(((C_word*)t0)[2],C_fix(0))):C_SCHEME_FALSE);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_33323,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* library.scm:6246: errmsg */
t6=((C_word*)t0)[8];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}
else{
if(C_truep(C_i_stringp(((C_word*)t0)[2]))){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33422,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6270: display */
t6=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[1187];
av2[3]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_33431,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6274: display */
t6=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[1188];
av2[3]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}}}

/* k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_33323(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,3)))){
C_save_and_reclaim((void *)f_33323,c,av);}
a=C_alloc(13);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_33326,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(t1)){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_33358,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[7],a[4]=((C_word*)t0)[6],a[5]=((C_word)li945),tmp=(C_word)a,a+=6,tmp);
/* library.scm:6246: g7460 */
t4=t3;
f_33358(t4,t2,t1);}
else{
t3=C_slot(((C_word*)t0)[6],C_fix(1));
if(C_truep(C_i_equalp(lf[1184],t3))){
/* library.scm:6256: display */
t4=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t2;
av2[2]=lf[1185];
av2[3]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33406,a[2]=t2,a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6258: display */
t5=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=lf[1186];
av2[3]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}}}

/* k33324 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void C_ccall f_33326(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_33326,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33329,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6260: errargs */
t3=((C_word*)t0)[5];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k33327 in k33324 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in ... */
static void C_ccall f_33329(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_33329,c,av);}
a=C_alloc(6);
t2=C_i_not(t1);
if(C_truep(t2)){
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_i_length(t1);
t4=C_eqp(C_fix(1),t3);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_33344,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6264: display */
t6=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[1180];
av2[3]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_33350,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6267: newline */
t6=*((C_word*)lf[191]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}}}

/* k33342 in k33327 in k33324 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_33344(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_33344,c,av);}
/* library.scm:6265: writeargs */
f_33257(((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}

/* k33348 in k33327 in k33324 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_33350(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_33350,c,av);}
/* library.scm:6268: writeargs */
f_33257(((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}

/* g7460 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void f_33358(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_33358,3,t0,t1,t2);}
a=C_alloc(7);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_33362,a[2]=t1,a[3]=t2,a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],tmp=(C_word)a,a+=7,tmp);
/* library.scm:6248: display */
t4=*((C_word*)lf[193]+1);{
C_word av2[4];
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1183];
av2[3]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k33360 in g7460 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in ... */
static void C_ccall f_33362(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_33362,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33365,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6249: errloc */
t3=((C_word*)t0)[5];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k33363 in k33360 in g7460 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_33365(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_33365,c,av);}
a=C_alloc(12);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33368,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=(C_truep(t1)?C_i_symbolp(t1):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33381,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_33385,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6251: ##sys#symbol->string/shared */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[737]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[737]+1);
av2[1]=t5;
av2[2]=t1;
tp(3,av2);}}
else{
/* library.scm:6252: display */
t4=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}}

/* k33366 in k33363 in k33360 in g7460 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_33368(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_33368,c,av);}
/* library.scm:6252: display */
t2=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k33379 in k33363 in k33360 in g7460 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_33381(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_33381,c,av);}
/* library.scm:6251: display */
t2=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k33383 in k33363 in k33360 in g7460 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_33385(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_33385,c,av);}
/* library.scm:6251: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1181];
av2[3]=t1;
av2[4]=lf[1182];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k33404 in k33321 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void C_ccall f_33406(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_33406,c,av);}
/* library.scm:6259: display */
t2=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_slot(((C_word*)t0)[3],C_fix(1));
av2[3]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k33420 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_33422(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_33422,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33425,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6271: display */
t3=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k33423 in k33420 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void C_ccall f_33425(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_33425,c,av);}
/* library.scm:6272: newline */
t2=*((C_word*)lf[191]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k33429 in k33312 in k33309 in body7437 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_33431(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_33431,c,av);}
a=C_alloc(3);
t2=C_a_i_list1(&a,1,((C_word*)t0)[2]);
/* library.scm:6275: writeargs */
f_33257(((C_word*)t0)[4],t2,((C_word*)t0)[5]);}

/* def-header7440 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_33453(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,3)))){
C_save_and_reclaim_args((void *)trf_33453,3,t0,t1,t2);}
/* library.scm:6240: body7437 */
t3=((C_word*)t0)[2];
f_33304(t3,t1,t2,lf[1189]);}

/* def-port7439 in chicken.condition#print-error-message in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_33458(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,2)))){
C_save_and_reclaim_args((void *)trf_33458,2,t0,t1);}
/* library.scm:6240: def-header7440 */
t2=((C_word*)t0)[2];
f_33453(t2,t1,*((C_word*)lf[839]+1));}

/* ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_33493(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_33493,c,av);}
a=C_alloc(9);
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_fast_retrieve(lf[1077]):C_get_rest_arg(c,4,av,4,t0));
if(C_truep(*((C_word*)lf[369]+1))){
t6=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_33503,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t5,a[5]=((C_word*)t0)[3],a[6]=t2,a[7]=((C_word*)t0)[4],a[8]=t3,tmp=(C_word)a,a+=9,tmp);
/* library.scm:6290: open-output-string */
t7=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t6=C_SCHEME_UNDEFINED;
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}

/* k33501 in ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_33503(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_33503,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_33506,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=t1,a[9]=((C_word*)t0)[8],tmp=(C_word)a,a+=10,tmp);
/* library.scm:6291: display */
t3=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1193];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k33504 in k33501 in ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_33506(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,3)))){
C_save_and_reclaim((void *)f_33506,c,av);}
a=C_alloc(15);
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_33509,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],tmp=(C_word)a,a+=10,tmp);
if(C_truep(((C_word*)t0)[4])){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33528,a[2]=t2,a[3]=((C_word*)t0)[8],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6293: display */
t4=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1192];
av2[3]=((C_word*)t0)[8];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_33509(2,av2);}}}

/* k33507 in k33504 in k33501 in ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_33509(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_33509,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_33512,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],tmp=(C_word)a,a+=10,tmp);
/* library.scm:6296: display */
t3=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1191];
av2[3]=((C_word*)t0)[8];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k33510 in k33507 in k33504 in k33501 in ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_33512(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_33512,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_33515,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* library.scm:6297: display */
t3=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[9];
av2[3]=((C_word*)t0)[8];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k33513 in k33510 in k33507 in k33504 in k33501 in ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void C_ccall f_33515(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_33515,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33518,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33525,a[2]=((C_word*)t0)[5],a[3]=t2,a[4]=((C_word*)t0)[6],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6298: get-output-string */
t4=((C_word*)t0)[7];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[8];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k33516 in k33513 in k33510 in k33507 in k33504 in k33501 in ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in ... */
static void C_ccall f_33518(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_33518,c,av);}
/* library.scm:6299: print-call-chain */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=*((C_word*)lf[840]+1);
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k33523 in k33513 in k33510 in k33507 in k33504 in k33501 in ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in ... */
static void C_ccall f_33525(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_33525,c,av);}
/* library.scm:6298: print-error-message */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=*((C_word*)lf[840]+1);
av2[4]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k33526 in k33504 in k33501 in ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_33528(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_33528,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33531,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6294: display */
t3=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k33529 in k33526 in k33504 in k33501 in ##sys#show-exception-warning in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_33531(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_33531,c,av);}
/* ##sys#write-char/port */
t2=C_fast_retrieve(lf[1008]);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_make_character(41);
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_33542(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +9,c,6)))){
C_save_and_reclaim((void*)f_33542,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+9);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
switch(t2){
case C_fix(1):
t5=C_get_rest_arg(c,4,av,4,t0);
t6=C_i_cadr(t4);
t7=C_i_caddr(t4);
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33565,a[2]=t7,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33576,a[2]=t8,a[3]=t5,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6314: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t9;
av2[2]=t6;
tp(3,av2);}
case C_fix(2):
t5=C_get_rest_arg(c,4,av,4,t0);
t6=C_i_cadr(t4);
t7=C_i_caddr(t4);
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_33602,a[2]=t7,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33613,a[2]=t8,a[3]=t5,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6323: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t9;
av2[2]=t6;
tp(3,av2);}
case C_fix(3):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1198];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(4):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1117];
av2[4]=t3;
av2[5]=lf[1199];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(5):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1200];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(6):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1125];
av2[4]=t3;
av2[5]=lf[1201];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(7):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[663];
av2[4]=t3;
av2[5]=lf[1202];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(8):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[472];
av2[4]=t3;
av2[5]=lf[1203];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(9):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1204];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(10):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1127];
av2[4]=t3;
av2[5]=lf[1205];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(11):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1206];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(12):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1125];
av2[4]=t3;
av2[5]=lf[1207];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(13):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1208];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(14):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1209];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(15):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1210];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(16):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1211];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(17):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1212];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(18):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1213];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(19):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1214];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(20):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1215];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(21):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1216];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(22):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1217];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(23):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1125];
av2[4]=t3;
av2[5]=lf[1218];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(24):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1219];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(25):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1220];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(26):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1221];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(27):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1222];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(28):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1223];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(29):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1224];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(30):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1225];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(31):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1226];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(32):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1227];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(33):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1228];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(34):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1229];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(35):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1230];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(36):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1125];
av2[4]=t3;
av2[5]=lf[1231];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(37):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1232];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(38):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1233];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(39):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1234];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(40):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1235];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(41):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1236];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(42):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1237];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(43):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[467];
av2[4]=t3;
av2[5]=lf[1238];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(44):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1239];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(45):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1133];
av2[4]=t3;
av2[5]=lf[1240];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(46):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[663];
av2[4]=t3;
av2[5]=lf[1241];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(47):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1117];
av2[4]=t3;
av2[5]=lf[1242];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(48):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1133];
av2[4]=t3;
av2[5]=lf[1243];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(49):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1244];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(50):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1245];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(51):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1246];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(52):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1247];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(53):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1248];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(54):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1249];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(55):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1250];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(56):
t5=C_get_rest_arg(c,4,av,4,t0);
t6=C_i_cadr(t4);
t7=C_i_caddr(t4);
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_34116,a[2]=t7,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34127,a[2]=t8,a[3]=t5,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6385: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t9;
av2[2]=t6;
tp(3,av2);}
case C_fix(57):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1253];
av2[6]=t4;
C_apply(7,av2);}
case C_fix(58):{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=t3;
av2[5]=lf[1254];
av2[6]=t4;
C_apply(7,av2);}
default:{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=t1;
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1117];
av2[4]=t3;
av2[5]=lf[1255];
av2[6]=t4;
C_apply(7,av2);}}}

/* k33563 in ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_33565(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,6)))){
C_save_and_reclaim((void *)f_33565,c,av);}
a=C_alloc(3);
if(C_truep(((C_word*)t0)[2])){
t2=C_a_i_list1(&a,1,((C_word*)t0)[2]);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=((C_word*)t0)[3];
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1127];
av2[4]=((C_word*)t0)[4];
av2[5]=t1;
av2[6]=t2;
C_apply(7,av2);}}
else{
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[235]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[235]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=lf[1127];
av2[3]=((C_word*)t0)[4];
av2[4]=t1;
tp(5,av2);}}}

/* k33574 in ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_33576(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_33576,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33580,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6315: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k33578 in k33574 in ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_33580(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_33580,c,av);}
/* library.scm:6314: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1194];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1195];
av2[5]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k33600 in ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_33602(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,6)))){
C_save_and_reclaim((void *)f_33602,c,av);}
a=C_alloc(3);
if(C_truep(((C_word*)t0)[2])){
t2=C_a_i_list1(&a,1,((C_word*)t0)[2]);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=((C_word*)t0)[3];
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[1127];
av2[4]=((C_word*)t0)[4];
av2[5]=t1;
av2[6]=t2;
C_apply(7,av2);}}
else{
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[235]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[235]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=lf[1127];
av2[3]=((C_word*)t0)[4];
av2[4]=t1;
tp(5,av2);}}}

/* k33611 in ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_33613(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_33613,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_33617,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6324: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k33615 in k33611 in ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_33617(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_33617,c,av);}
/* library.scm:6323: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1196];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1197];
av2[5]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k34114 in ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_34116(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,6)))){
C_save_and_reclaim((void *)f_34116,c,av);}
a=C_alloc(3);
if(C_truep(((C_word*)t0)[2])){
t2=C_a_i_list1(&a,1,((C_word*)t0)[2]);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=0;
av2[1]=((C_word*)t0)[3];
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[472];
av2[4]=((C_word*)t0)[4];
av2[5]=t1;
av2[6]=t2;
C_apply(7,av2);}}
else{
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[235]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[235]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=lf[472];
av2[3]=((C_word*)t0)[4];
av2[4]=t1;
tp(5,av2);}}}

/* k34125 in ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_34127(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34127,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34131,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6386: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k34129 in k34125 in ##sys#error-hook in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_34131(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_34131,c,av);}
/* library.scm:6385: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1251];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1252];
av2[5]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_34272(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,4)))){
C_save_and_reclaim((void *)f_34272,c,av);}
a=C_alloc(12);
t2=C_mutate(&lf[1256] /* (set! ##sys#r7rs-exn-handlers ...) */,t1);
t3=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));
t4=C_mutate((C_word*)lf[1257]+1 /* (set! scheme#with-exception-handler ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34274,a[2]=((C_word)li954),tmp=(C_word)a,a+=3,tmp));
t5=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));
t6=C_mutate((C_word*)lf[1258]+1 /* (set! scheme#raise ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34342,a[2]=((C_word)li956),tmp=(C_word)a,a+=3,tmp));
t7=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));
t8=C_mutate((C_word*)lf[1262]+1 /* (set! scheme#raise-continuable ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34383,a[2]=((C_word)li958),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate((C_word*)lf[1263]+1 /* (set! scheme#error-object? ...) */,C_fast_retrieve(lf[1169]));
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34413,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6443: chicken.condition#condition-property-accessor */
t11=C_fast_retrieve(lf[1174]);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t11;
av2[1]=t10;
av2[2]=lf[1147];
av2[3]=lf[1259];
((C_proc)(void*)(*((C_word*)t11+1)))(4,av2);}}

/* scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_34274(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_34274,c,av);}
a=C_alloc(7);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34280,a[2]=t2,a[3]=((C_word)li952),tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34320,a[2]=((C_word)li953),tmp=(C_word)a,a+=3,tmp);
/* library.scm:6407: scheme#dynamic-wind */
t6=*((C_word*)lf[212]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t6;
av2[1]=t1;
av2[2]=t4;
av2[3]=t3;
av2[4]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}

/* a34279 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_34280(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_34280,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34284,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34318,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6411: eh */
t4=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k34282 in a34279 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_34284(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_34284,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34287,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34296,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6413: eh */
t4=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k34285 in k34282 in a34279 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_34287(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34287,c,av);}
t2=C_mutate((C_word*)lf[1141]+1 /* (set! ##sys#current-exception-handler ...) */,((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k34294 in k34282 in a34279 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_34296(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34296,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],t1);
/* library.scm:6413: eh */
t3=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k34308 in k34316 in a34279 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_34310(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34310,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,C_fast_retrieve(lf[1141]),t1);
/* library.scm:6412: eh */
t3=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k34316 in a34279 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_34318(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34318,c,av);}
a=C_alloc(3);
t2=C_i_car(t1);
t3=C_eqp(t2,C_fast_retrieve(lf[1141]));
if(C_truep(t3)){
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
f_34284(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34310,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6412: eh */
t5=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* a34319 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_34320(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_34320,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34324,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34340,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6417: eh */
t4=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k34322 in a34319 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_34324(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34324,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34332,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6418: eh */
t3=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k34330 in k34322 in a34319 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_34332(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34332,c,av);}
t2=C_i_car(t1);
t3=C_mutate((C_word*)lf[1141]+1 /* (set! ##sys#current-exception-handler ...) */,t2);
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k34338 in a34319 in scheme#with-exception-handler in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_34340(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_34340,c,av);}
/* library.scm:6417: eh */
t2=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_i_cdr(t1);
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* scheme#raise in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_34342(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34342,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34381,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6424: eh */
t4=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a34351 in k34379 in scheme#raise in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_34352(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34352,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34377,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6426: eh */
t3=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k34357 in k34375 in a34351 in k34379 in scheme#raise in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void C_ccall f_34359(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34359,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34373,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6427: eh */
t3=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k34367 in k34371 in k34357 in k34375 in a34351 in k34379 in scheme#raise in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34369(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_34369,c,av);}
/* library.scm:6425: g7582 */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=t1;
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* k34371 in k34357 in k34375 in a34351 in k34379 in scheme#raise in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in ... */
static void C_ccall f_34373(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,8)))){
C_save_and_reclaim((void *)f_34373,c,av);}
a=C_alloc(4);
t2=C_i_car(t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34369,a[2]=t2,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6428: chicken.condition#make-property-condition */
t4=C_fast_retrieve(lf[1164]);{
C_word *av2;
if(c >= 9) {
  av2=av;
} else {
  av2=C_alloc(9);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1147];
av2[3]=lf[1259];
av2[4]=lf[1260];
av2[5]=lf[1261];
av2[6]=C_SCHEME_END_OF_LIST;
av2[7]=lf[980];
av2[8]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(9,av2);}}

/* k34375 in a34351 in k34379 in scheme#raise in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_34377(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34377,c,av);}
a=C_alloc(3);
t2=C_i_cadr(t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34359,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6425: g7580 */
t4=t2;{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}

/* k34379 in scheme#raise in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_34381(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_34381,c,av);}
a=C_alloc(4);
t2=C_i_cadr(t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34352,a[2]=((C_word*)t0)[2],a[3]=((C_word)li955),tmp=(C_word)a,a+=4,tmp);
/* library.scm:6423: scheme#with-exception-handler */
t4=C_fast_retrieve(lf[1257]);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* scheme#raise-continuable in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_34383(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34383,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34408,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6438: eh */
t4=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a34392 in k34406 in scheme#raise-continuable in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_34393(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34393,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34404,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6440: eh */
t3=C_retrieve2(lf[1256],C_text("##sys#r7rs-exn-handlers"));{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k34402 in a34392 in k34406 in scheme#raise-continuable in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_34404(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_34404,c,av);}
/* library.scm:6439: g7588 */
t2=C_i_cadr(t1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* k34406 in scheme#raise-continuable in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_34408(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_34408,c,av);}
a=C_alloc(4);
t2=C_i_cadr(t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34393,a[2]=((C_word*)t0)[2],a[3]=((C_word)li957),tmp=(C_word)a,a+=4,tmp);
/* library.scm:6437: scheme#with-exception-handler */
t4=C_fast_retrieve(lf[1257]);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_34413(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_34413,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[1264]+1 /* (set! scheme#error-object-message ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34417,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6444: chicken.condition#condition-property-accessor */
t4=C_fast_retrieve(lf[1174]);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1147];
av2[3]=lf[1261];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_34417(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34417,c,av);}
a=C_alloc(3);
t2=C_mutate((C_word*)lf[1265]+1 /* (set! scheme#error-object-irritants ...) */,t1);
t3=C_set_block_item(lf[1266] /* scheme#read-error? */,0,C_SCHEME_UNDEFINED);
t4=C_set_block_item(lf[1267] /* scheme#file-error? */,0,C_SCHEME_UNDEFINED);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34422,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6449: chicken.condition#condition-predicate */
t6=C_fast_retrieve(lf[1173]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[1147];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}

/* k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in ... */
static void C_ccall f_34422(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34422,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34425,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6450: chicken.condition#condition-predicate */
t3=C_fast_retrieve(lf[1173]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1603];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in ... */
static void C_ccall f_34425(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_34425,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_34428,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6451: chicken.condition#condition-predicate */
t3=C_fast_retrieve(lf[1173]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1602];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in ... */
static void C_ccall f_34428(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_34428,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_34431,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6452: chicken.condition#condition-predicate */
t3=C_fast_retrieve(lf[1173]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1601];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in ... */
static void C_ccall f_34431(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word t51;
C_word t52;
C_word t53;
C_word t54;
C_word t55;
C_word t56;
C_word t57;
C_word t58;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(170,c,6)))){
C_save_and_reclaim((void *)f_34431,c,av);}
a=C_alloc(170);
t2=C_mutate((C_word*)lf[1266]+1 /* (set! scheme#read-error? ...) */,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_34433,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word)li959),tmp=(C_word)a,a+=6,tmp));
t3=C_mutate((C_word*)lf[1267]+1 /* (set! scheme#file-error? ...) */,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_34451,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],a[4]=((C_word)li960),tmp=(C_word)a,a+=5,tmp));
t4=C_mutate((C_word*)lf[1268]+1 /* (set! ##sys#structure? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34463,a[2]=((C_word)li961),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[1269]+1 /* (set! ##sys#generic-structure? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34466,a[2]=((C_word)li962),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[1270]+1 /* (set! ##sys#slot ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34469,a[2]=((C_word)li963),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[1271]+1 /* (set! ##sys#size ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34472,a[2]=((C_word)li964),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[1272]+1 /* (set! ##sys#make-pointer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_make_pointer,a[2]=((C_word)li965),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate((C_word*)lf[1273]+1 /* (set! ##sys#make-tagged-pointer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_make_tagged_pointer,a[2]=((C_word)li966),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate((C_word*)lf[1274]+1 /* (set! ##sys#pointer? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34477,a[2]=((C_word)li967),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[1275]+1 /* (set! ##sys#set-pointer-address! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34480,a[2]=((C_word)li968),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate((C_word*)lf[1276]+1 /* (set! ##sys#bytevector? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34483,a[2]=((C_word)li969),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate((C_word*)lf[1277]+1 /* (set! ##sys#string->pbytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34486,a[2]=((C_word)li970),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate((C_word*)lf[1278]+1 /* (set! ##sys#permanent? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34489,a[2]=((C_word)li971),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate((C_word*)lf[1279]+1 /* (set! ##sys#block-address ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34492,a[2]=((C_word)li972),tmp=(C_word)a,a+=3,tmp));
t16=C_mutate((C_word*)lf[1280]+1 /* (set! ##sys#locative? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34495,a[2]=((C_word)li973),tmp=(C_word)a,a+=3,tmp));
t17=C_mutate((C_word*)lf[1281]+1 /* (set! ##sys#srfi-4-vector? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34498,a[2]=((C_word)li974),tmp=(C_word)a,a+=3,tmp));
t18=C_mutate((C_word*)lf[1284]+1 /* (set! ##sys#null-pointer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34522,a[2]=((C_word)li975),tmp=(C_word)a,a+=3,tmp));
t19=C_mutate((C_word*)lf[1285]+1 /* (set! ##sys#null-pointer? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34528,a[2]=((C_word)li976),tmp=(C_word)a,a+=3,tmp));
t20=C_mutate((C_word*)lf[1286]+1 /* (set! ##sys#address->pointer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34538,a[2]=((C_word)li977),tmp=(C_word)a,a+=3,tmp));
t21=C_mutate((C_word*)lf[1074]+1 /* (set! ##sys#pointer->address ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34544,a[2]=((C_word)li978),tmp=(C_word)a,a+=3,tmp));
t22=C_mutate((C_word*)lf[884]+1 /* (set! ##sys#make-c-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34551,a[2]=((C_word)li979),tmp=(C_word)a,a+=3,tmp));
t23=C_mutate((C_word*)lf[1287]+1 /* (set! ##sys#peek-signed-integer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_peek_signed_integer,a[2]=((C_word)li980),tmp=(C_word)a,a+=3,tmp));
t24=C_mutate((C_word*)lf[848]+1 /* (set! ##sys#peek-unsigned-integer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_peek_unsigned_integer,a[2]=((C_word)li981),tmp=(C_word)a,a+=3,tmp));
t25=C_mutate((C_word*)lf[1288]+1 /* (set! ##sys#peek-fixnum ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34587,a[2]=((C_word)li982),tmp=(C_word)a,a+=3,tmp));
t26=C_mutate((C_word*)lf[1289]+1 /* (set! ##sys#peek-byte ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34590,a[2]=((C_word)li983),tmp=(C_word)a,a+=3,tmp));
t27=C_mutate((C_word*)lf[1290]+1 /* (set! ##sys#vector->structure! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34593,a[2]=((C_word)li984),tmp=(C_word)a,a+=3,tmp));
t28=C_mutate((C_word*)lf[1291]+1 /* (set! ##sys#peek-double ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34596,a[2]=((C_word)li985),tmp=(C_word)a,a+=3,tmp));
t29=C_mutate((C_word*)lf[829]+1 /* (set! ##sys#peek-c-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34599,a[2]=((C_word)li986),tmp=(C_word)a,a+=3,tmp));
t30=C_mutate((C_word*)lf[1078]+1 /* (set! ##sys#peek-nonnull-c-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34615,a[2]=((C_word)li987),tmp=(C_word)a,a+=3,tmp));
t31=C_mutate((C_word*)lf[1292]+1 /* (set! ##sys#peek-and-free-c-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34628,a[2]=((C_word)li988),tmp=(C_word)a,a+=3,tmp));
t32=C_mutate((C_word*)lf[1293]+1 /* (set! ##sys#peek-and-free-nonnull-c-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34634,a[2]=((C_word)li989),tmp=(C_word)a,a+=3,tmp));
t33=C_mutate((C_word*)lf[1294]+1 /* (set! ##sys#poke-c-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34640,a[2]=((C_word)li990),tmp=(C_word)a,a+=3,tmp));
t34=C_mutate((C_word*)lf[1295]+1 /* (set! ##sys#poke-integer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34647,a[2]=((C_word)li991),tmp=(C_word)a,a+=3,tmp));
t35=C_mutate((C_word*)lf[1296]+1 /* (set! ##sys#poke-double ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34650,a[2]=((C_word)li992),tmp=(C_word)a,a+=3,tmp));
t36=C_mutate((C_word*)lf[1297]+1 /* (set! ##sys#peek-c-string-list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34670,a[2]=((C_word)li994),tmp=(C_word)a,a+=3,tmp));
t37=C_mutate((C_word*)lf[1298]+1 /* (set! ##sys#peek-and-free-c-string-list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34731,a[2]=((C_word)li996),tmp=(C_word)a,a+=3,tmp));
t38=C_mutate((C_word*)lf[1299]+1 /* (set! ##sys#vector->closure! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34769,a[2]=((C_word)li997),tmp=(C_word)a,a+=3,tmp));
t39=C_mutate((C_word*)lf[1300]+1 /* (set! ##sys#symbol-has-toplevel-binding? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34772,a[2]=((C_word)li998),tmp=(C_word)a,a+=3,tmp));
t40=C_mutate((C_word*)lf[1301]+1 /* (set! ##sys#block-pointer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34775,a[2]=((C_word)li999),tmp=(C_word)a,a+=3,tmp));
t41=C_mutate((C_word*)lf[1302]+1 /* (set! ##sys#foreign-char-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34781,a[2]=((C_word)li1000),tmp=(C_word)a,a+=3,tmp));
t42=C_mutate((C_word*)lf[1303]+1 /* (set! ##sys#foreign-fixnum-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34784,a[2]=((C_word)li1001),tmp=(C_word)a,a+=3,tmp));
t43=C_mutate((C_word*)lf[1304]+1 /* (set! ##sys#foreign-flonum-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34787,a[2]=((C_word)li1002),tmp=(C_word)a,a+=3,tmp));
t44=C_mutate((C_word*)lf[1305]+1 /* (set! ##sys#foreign-block-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34790,a[2]=((C_word)li1003),tmp=(C_word)a,a+=3,tmp));
t45=C_mutate((C_word*)lf[1306]+1 /* (set! ##sys#foreign-cplxnum-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34793,a[2]=((C_word)li1004),tmp=(C_word)a,a+=3,tmp));
t46=C_mutate((C_word*)lf[1308]+1 /* (set! ##sys#foreign-struct-wrapper-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34802,a[2]=((C_word)li1005),tmp=(C_word)a,a+=3,tmp));
t47=C_mutate((C_word*)lf[1309]+1 /* (set! ##sys#foreign-string-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34805,a[2]=((C_word)li1006),tmp=(C_word)a,a+=3,tmp));
t48=C_mutate((C_word*)lf[1310]+1 /* (set! ##sys#foreign-symbol-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34808,a[2]=((C_word)li1007),tmp=(C_word)a,a+=3,tmp));
t49=C_mutate((C_word*)lf[1311]+1 /* (set! ##sys#foreign-pointer-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34811,a[2]=((C_word)li1008),tmp=(C_word)a,a+=3,tmp));
t50=C_mutate((C_word*)lf[1312]+1 /* (set! ##sys#foreign-tagged-pointer-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34814,a[2]=((C_word)li1009),tmp=(C_word)a,a+=3,tmp));
t51=C_mutate((C_word*)lf[1313]+1 /* (set! ##sys#foreign-ranged-integer-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34817,a[2]=((C_word)li1010),tmp=(C_word)a,a+=3,tmp));
t52=C_mutate((C_word*)lf[1314]+1 /* (set! ##sys#foreign-unsigned-ranged-integer-argument ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34820,a[2]=((C_word)li1011),tmp=(C_word)a,a+=3,tmp));
t53=C_mutate((C_word*)lf[1315]+1 /* (set! ##sys#wrap-struct ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34823,a[2]=((C_word)li1012),tmp=(C_word)a,a+=3,tmp));
t54=C_set_block_item(lf[1316] /* ##sys#default-thread-quantum */,0,C_fix(10000));
t55=C_mutate((C_word*)lf[1317]+1 /* (set! ##sys#default-exception-handler ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34830,a[2]=((C_word)li1013),tmp=(C_word)a,a+=3,tmp));
t56=C_mutate((C_word*)lf[1319]+1 /* (set! ##sys#make-thread ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34833,a[2]=((C_word)li1014),tmp=(C_word)a,a+=3,tmp));
t57=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34857,a[2]=((C_word*)t0)[5],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6650: ##sys#make-thread */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1319]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[1319]+1);
av2[1]=t57;
av2[2]=C_SCHEME_FALSE;
av2[3]=lf[1599];
av2[4]=lf[1600];
av2[5]=C_fast_retrieve(lf[1316]);
tp(6,av2);}}

/* scheme#read-error? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34433(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_34433,c,av);}
a=C_alloc(6);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_34440,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t2,a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6455: exn? */
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k34438 in scheme#read-error? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34440(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_34440,c,av);}
a=C_alloc(5);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_34443,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6456: i/o? */
t3=((C_word*)t0)[5];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k34441 in k34438 in scheme#read-error? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_34443(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_34443,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:6457: syntax? */
t2=((C_word*)t0)[3];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}}

/* scheme#file-error? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34451(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_34451,c,av);}
a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_34458,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:6460: exn? */
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k34456 in scheme#file-error? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34458(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_34458,c,av);}
if(C_truep(t1)){
/* library.scm:6461: file? */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* ##sys#structure? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34463(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34463,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_structurep(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#generic-structure? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34466(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34466,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_structurep(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#slot in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34469(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34469,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_slot(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#size in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34472(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34472,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_block_size(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#pointer? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34477(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34477,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_anypointerp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#set-pointer-address! in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34480(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34480,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_update_pointer(t3,t2);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#bytevector? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34483(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34483,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_bytevectorp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#string->pbytevector in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34486(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34486,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_string_to_pbytevector(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#permanent? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34489(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34489,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_permanentp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#block-address in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34492(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,1)))){
C_save_and_reclaim((void *)f_34492,c,av);}
a=C_alloc(6);
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_block_address(&a,1,t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#locative? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34495(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34495,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_locativep(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#srfi-4-vector? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34498(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34498,c,av);}
t3=C_i_srfi_4_vectorp(t2);
if(C_truep(t3)){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
if(C_truep(C_blockp(t2))){
if(C_truep(C_structurep(t2))){
t4=C_slot(t2,C_fix(0));
t5=C_eqp(t4,lf[1282]);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=(C_truep(t5)?t5:C_eqp(t4,lf[1283]));
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}
else{
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}}

/* ##sys#null-pointer in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34522(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34522,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34526,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6488: ##sys#make-pointer */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1272]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1272]+1);
av2[1]=t2;
tp(2,av2);}}

/* k34524 in ##sys#null-pointer in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34526(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34526,c,av);}
t2=C_update_pointer(C_fix(0),t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#null-pointer? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34528(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34528,c,av);}
a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34536,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6493: ##sys#pointer->address */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1074]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1074]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k34534 in ##sys#null-pointer? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34536(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34536,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_eqp(C_fix(0),t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#address->pointer in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34538(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34538,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34542,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6496: ##sys#make-pointer */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1272]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1272]+1);
av2[1]=t3;
tp(2,av2);}}

/* k34540 in ##sys#address->pointer in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34542(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34542,c,av);}
t2=C_update_pointer(((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#pointer->address in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34544(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,1)))){
C_save_and_reclaim((void *)f_34544,c,av);}
a=C_alloc(6);
t3=C_slot(t2,C_fix(0));
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_unsigned_int_to_num(&a,1,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#make-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34551(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_34551,c,av);}
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=C_slot(t2,C_fix(0));
t6=C_asciiz_strlen(t5);
t7=C_block_size(t5);
t8=C_fixnum_difference(t7,C_fix(1));
t9=C_eqp(t6,t8);
if(C_truep(t9)){
t10=t1;{
C_word *av2=av;
av2[0]=t10;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
t10=C_fix((C_word)C_ASCIIZ_REPRESENTATION_ERROR);
/* library.scm:6508: ##sys#error-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[439]);
C_word av2[5];
av2[0]=*((C_word*)lf[439]+1);
av2[1]=t1;
av2[2]=t10;
av2[3]=t4;
av2[4]=t2;
tp(5,av2);}}}

/* ##sys#peek-fixnum in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34587(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34587,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_peek_fixnum(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#peek-byte in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34590(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34590,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_peek_byte(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#vector->structure! in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34593(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34593,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_vector_to_structure(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#peek-double in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34596(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_34596,c,av);}
a=C_alloc(4);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_f64peek(&a,2,t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#peek-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34599(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_34599,c,av);}
t4=C_null_pointerp(t2);
if(C_truep(C_i_not(t4))){
/* library.scm:6523: ##sys#peek-nonnull-c-string */
t5=*((C_word*)lf[1078]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}
else{
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* ##sys#peek-nonnull-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34615(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_34615,c,av);}
a=C_alloc(6);
t4=C_fetch_c_strlen(t2,t3);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_34619,a[2]=t2,a[3]=t3,a[4]=t4,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:6527: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=C_fixnum_plus(t4,C_fix(1));
av2[3]=C_fix(0);
tp(4,av2);}}

/* k34617 in ##sys#peek-nonnull-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34619(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_34619,c,av);}
t2=C_peek_c_string(((C_word*)t0)[2],((C_word*)t0)[3],t1,((C_word*)t0)[4]);
/* library.scm:6529: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[300]+1);
av2[1]=((C_word*)t0)[5];
av2[2]=t1;
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}

/* ##sys#peek-and-free-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34628(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_34628,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_34632,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:6532: ##sys#peek-c-string */
t5=*((C_word*)lf[829]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k34630 in ##sys#peek-and-free-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34632(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34632,c,av);}
t2=C_free_mptr(((C_word*)t0)[2],((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#peek-and-free-nonnull-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34634(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_34634,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_34638,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:6537: ##sys#peek-nonnull-c-string */
t5=*((C_word*)lf[1078]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k34636 in ##sys#peek-and-free-nonnull-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34638(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34638,c,av);}
t2=C_free_mptr(((C_word*)t0)[2],((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#poke-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34640(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_34640,c,av);}
a=C_alloc(6);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_34645,a[2]=t1,a[3]=t2,a[4]=t3,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
/* library.scm:6542: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[884]);
C_word *av2=av;
av2[0]=*((C_word*)lf[884]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}

/* k34643 in ##sys#poke-c-string in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34645(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34645,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_poke_c_string(((C_word*)t0)[3],((C_word*)t0)[4],t1,((C_word*)t0)[5]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#poke-integer in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34647(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34647,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_poke_integer(t2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#poke-double in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34650(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34650,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_poke_double(t2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#peek-c-string-list in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34670(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_34670,c,av);}
a=C_alloc(8);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_34676,a[2]=t3,a[3]=t5,a[4]=t2,a[5]=((C_word)li993),tmp=(C_word)a,a+=6,tmp));
t7=((C_word*)t5)[1];
f_34676(t7,t1,C_fix(0));}

/* loop in ##sys#peek-c-string-list in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void f_34676(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,3)))){
C_save_and_reclaim_args((void *)trf_34676,3,t0,t1,t2);}
a=C_alloc(10);
t3=(C_truep(((C_word*)t0)[2])?C_fixnum_greater_or_equal_p(t2,((C_word*)t0)[2]):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_34686,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t5=C_a_i_bytevector(&a,1,C_fix(3));
t6=(C_truep(((C_word*)t0)[4])?C_i_foreign_pointer_argumentp(((C_word*)t0)[4]):C_SCHEME_FALSE);
t7=C_i_foreign_fixnum_argumentp(t2);
/* library.scm:6548: ##sys#peek-c-string */
t8=*((C_word*)lf[829]+1);{
C_word av2[4];
av2[0]=t8;
av2[1]=t4;
av2[2]=stub7719(t5,t6,t7);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t8+1)))(4,av2);}}}

/* k34684 in loop in ##sys#peek-c-string-list in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_34686(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34686,c,av);}
a=C_alloc(4);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34696,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6555: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_34676(t3,t2,C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}
else{
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k34694 in k34684 in loop in ##sys#peek-c-string-list in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_34696(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_34696,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#peek-and-free-c-string-list in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34731(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_34731,c,av);}
a=C_alloc(12);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34735,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_34740,a[2]=t3,a[3]=t2,a[4]=t6,a[5]=((C_word)li995),tmp=(C_word)a,a+=6,tmp));
t8=((C_word*)t6)[1];
f_34740(t8,t4,C_fix(0));}

/* k34733 in ##sys#peek-and-free-c-string-list in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34735(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34735,c,av);}
if(C_truep(((C_word*)t0)[2])){
t2=C_i_foreign_pointer_argumentp(((C_word*)t0)[2]);
t3=stub7746(C_SCHEME_UNDEFINED,t2);
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t2=stub7746(C_SCHEME_UNDEFINED,C_SCHEME_FALSE);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* loop in ##sys#peek-and-free-c-string-list in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void f_34740(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,3)))){
C_save_and_reclaim_args((void *)trf_34740,3,t0,t1,t2);}
a=C_alloc(11);
t3=(C_truep(((C_word*)t0)[2])?C_fixnum_greater_or_equal_p(t2,((C_word*)t0)[2]):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_34750,a[2]=((C_word*)t0)[3],a[3]=t2,a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t5=C_a_i_bytevector(&a,1,C_fix(3));
t6=(C_truep(((C_word*)t0)[3])?C_i_foreign_pointer_argumentp(((C_word*)t0)[3]):C_SCHEME_FALSE);
t7=C_i_foreign_fixnum_argumentp(t2);
/* library.scm:6559: ##sys#peek-c-string */
t8=*((C_word*)lf[829]+1);{
C_word av2[4];
av2[0]=t8;
av2[1]=t4;
av2[2]=stub7738(t5,t6,t7);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t8+1)))(4,av2);}}}

/* k34748 in loop in ##sys#peek-and-free-c-string-list in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_34750(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34750,c,av);}
a=C_alloc(4);
if(C_truep(t1)){
t2=C_free_sptr(((C_word*)t0)[2],((C_word*)t0)[3]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34760,a[2]=((C_word*)t0)[4],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6568: loop */
t4=((C_word*)((C_word*)t0)[5])[1];
f_34740(t4,t3,C_fixnum_plus(((C_word*)t0)[3],C_fix(1)));}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k34758 in k34748 in loop in ##sys#peek-and-free-c-string-list in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_34760(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_34760,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#vector->closure! in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34769(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34769,c,av);}
t4=C_vector_to_closure(t2);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_update_pointer(t3,t2);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#symbol-has-toplevel-binding? in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34772(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34772,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_boundp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#block-pointer in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34775(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34775,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34779,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6581: ##sys#make-pointer */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1272]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1272]+1);
av2[1]=t3;
tp(2,av2);}}

/* k34777 in ##sys#block-pointer in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34779(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34779,c,av);}
t2=C_pointer_to_block(t1,((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#foreign-char-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34781(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34781,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_foreign_char_argumentp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#foreign-fixnum-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34784(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34784,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_foreign_fixnum_argumentp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#foreign-flonum-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34787(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34787,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_foreign_flonum_argumentp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#foreign-block-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34790(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34790,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_foreign_block_argumentp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#foreign-cplxnum-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34793(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(12,c,5)))){
C_save_and_reclaim((void *)f_34793,c,av);}
a=C_alloc(12);
if(C_truep(C_i_numberp(t2))){
t3=C_a_i_exact_to_inexact(&a,1,t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
/* library.scm:6596: ##sys#signal-hook */
t3=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=C_SCHEME_FALSE;
av2[4]=lf[1307];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}}

/* ##sys#foreign-struct-wrapper-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34802(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34802,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_foreign_struct_wrapper_argumentp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#foreign-string-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34805(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34805,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_foreign_string_argumentp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#foreign-symbol-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34808(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34808,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_foreign_symbol_argumentp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#foreign-pointer-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34811(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34811,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_foreign_pointer_argumentp(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#foreign-tagged-pointer-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34814(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34814,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_foreign_tagged_pointer_argumentp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#foreign-ranged-integer-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34817(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34817,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_foreign_ranged_integer_argumentp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#foreign-unsigned-ranged-integer-argument in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34820(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34820,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_foreign_unsigned_ranged_integer_argumentp(t2,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#wrap-struct in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34823(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34823,c,av);}
t4=C_i_setslot(t3,C_fix(0),t2);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* ##sys#default-exception-handler in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34830(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34830,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_halt(lf[1318]);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#make-thread in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34833(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_34833,c,av);}
a=C_alloc(7);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_34849,a[2]=t1,a[3]=t2,a[4]=t3,a[5]=t4,a[6]=t5,tmp=(C_word)a,a+=7,tmp);
/* library.scm:6637: ##sys#vector-resize */
f_23697(t6,C_fast_retrieve(lf[901]),C_block_size(C_fast_retrieve(lf[901])),C_SCHEME_FALSE);}

/* k34847 in ##sys#make-thread in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34849(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(26,c,1)))){
C_save_and_reclaim((void *)f_34849,c,av);}
a=C_alloc(26);
t2=C_a_i_vector6(&a,6,C_fast_retrieve(lf[823]),*((C_word*)lf[838]+1),*((C_word*)lf[839]+1),*((C_word*)lf[840]+1),C_fast_retrieve(lf[1317]),t1);
t3=C_a_i_cons(&a,2,C_SCHEME_FALSE,C_SCHEME_FALSE);
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_record(&a,15,lf[1062],((C_word*)t0)[3],C_SCHEME_FALSE,((C_word*)t0)[4],C_SCHEME_FALSE,t2,((C_word*)t0)[5],C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST,((C_word*)t0)[6],C_SCHEME_UNDEFINED,C_SCHEME_FALSE,C_SCHEME_END_OF_LIST,C_SCHEME_FALSE,t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in ... */
static void C_ccall f_34857(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(45,c,4)))){
C_save_and_reclaim((void *)f_34857,c,av);}
a=C_alloc(45);
t2=C_mutate((C_word*)lf[1089]+1 /* (set! ##sys#primordial-thread ...) */,t1);
t3=C_mutate((C_word*)lf[1077]+1 /* (set! ##sys#current-thread ...) */,C_fast_retrieve(lf[1089]));
t4=C_mutate((C_word*)lf[1320]+1 /* (set! ##sys#make-mutex ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34860,a[2]=((C_word)li1015),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[1322]+1 /* (set! ##sys#schedule ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34866,a[2]=((C_word)li1016),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[1323]+1 /* (set! ##sys#thread-yield! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34875,a[2]=((C_word)li1019),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[1324]+1 /* (set! ##sys#kill-other-threads ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34896,a[2]=((C_word)li1020),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[1325]+1 /* (set! ##sys#resume-thread-on-event ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34902,a[2]=((C_word)li1021),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate((C_word*)lf[1326]+1 /* (set! ##sys#suspend-thread-on-event ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34905,a[2]=((C_word)li1022),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate((C_word*)lf[1327]+1 /* (set! ##sys#sleep-until-interrupt ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34911,a[2]=((C_word)li1024),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[1328]+1 /* (set! ##sys#make-event-queue ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34920,a[2]=((C_word)li1025),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate((C_word*)lf[1330]+1 /* (set! ##sys#add-event-to-queue! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34926,a[2]=((C_word)li1026),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate((C_word*)lf[1331]+1 /* (set! ##sys#get-next-event ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34965,a[2]=((C_word)li1027),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate((C_word*)lf[1332]+1 /* (set! ##sys#wait-for-next-event ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35008,a[2]=((C_word)li1029),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate((C_word*)lf[1334]+1 /* (set! chicken.base#sleep-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35062,a[2]=((C_word)li1030),tmp=(C_word)a,a+=3,tmp));
t16=C_mutate((C_word*)lf[238]+1 /* (set! chicken.base#sleep ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35065,a[2]=((C_word)li1031),tmp=(C_word)a,a+=3,tmp));
t17=C_mutate((C_word*)lf[1336]+1 /* (set! ##sys#context-switch ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_context_switch,a[2]=((C_word)li1032),tmp=(C_word)a,a+=3,tmp));
t18=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35077,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6755: scheme#make-vector */
t19=*((C_word*)lf[117]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t19;
av2[1]=t18;
av2[2]=C_fix(256);
av2[3]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t19+1)))(4,av2);}}

/* ##sys#make-mutex in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34860(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,1)))){
C_save_and_reclaim((void *)f_34860,c,av);}
a=C_alloc(8);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_a_i_record7(&a,7,lf[1321],t2,t3,C_SCHEME_END_OF_LIST,C_SCHEME_FALSE,C_SCHEME_FALSE,C_SCHEME_UNDEFINED);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* ##sys#schedule in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34866(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34866,c,av);}
/* library.scm:6664: g7820 */
t2=C_slot(C_fast_retrieve(lf[1077]),C_fix(1));{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)C_fast_retrieve_proc(t2))(2,av2);}}

/* ##sys#thread-yield! in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34875(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_34875,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34881,a[2]=((C_word)li1018),tmp=(C_word)a,a+=3,tmp);
/* library.scm:6667: ##sys#call-with-current-continuation */{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
C_call_cc(3,av2);}}

/* a34880 in ##sys#thread-yield! in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_34881(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_34881,c,av);}
a=C_alloc(4);
t3=C_fast_retrieve(lf[1077]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_34890,a[2]=t2,a[3]=((C_word)li1017),tmp=(C_word)a,a+=4,tmp);
t5=C_i_setslot(C_fast_retrieve(lf[1077]),C_fix(1),t4);
/* library.scm:6671: ##sys#schedule */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1322]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1322]+1);
av2[1]=t1;
tp(2,av2);}}

/* a34889 in a34880 in ##sys#thread-yield! in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_34890(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_34890,c,av);}
/* library.scm:6670: return */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=C_SCHEME_UNDEFINED;
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* ##sys#kill-other-threads in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34896(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34896,c,av);}
/* library.scm:6674: thunk */
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)C_fast_retrieve_proc(t3))(2,av2);}}

/* ##sys#resume-thread-on-event in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34902(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34902,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#suspend-thread-on-event in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34905(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34905,c,av);}
/* library.scm:6682: ##sys#sleep-until-interrupt */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1327]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1327]+1);
av2[1]=t1;
tp(2,av2);}}

/* ##sys#sleep-until-interrupt in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34911(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34911,c,av);}
a=C_alloc(3);
t2=C_i_sleep_until_interrupt(C_fix(100));
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_34917,a[2]=((C_word)li1023),tmp=(C_word)a,a+=3,tmp);
/* library.scm:6686: ##sys#dispatch-interrupt */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[827]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[827]+1);
av2[1]=t1;
av2[2]=t3;
tp(3,av2);}}

/* a34916 in ##sys#sleep-until-interrupt in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_34917(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34917,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#make-event-queue in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34920(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_34920,c,av);}
a=C_alloc(5);
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_record4(&a,4,lf[1329],C_SCHEME_END_OF_LIST,C_SCHEME_END_OF_LIST,C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#add-event-to-queue! in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34926(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_34926,c,av);}
a=C_alloc(3);
t4=C_slot(t2,C_fix(1));
t5=C_slot(t2,C_fix(2));
t6=C_a_i_cons(&a,2,t3,C_SCHEME_END_OF_LIST);
t7=C_i_nullp(t4);
t8=(C_truep(t7)?C_i_setslot(t2,C_fix(1),t6):C_i_setslot(t5,C_fix(1),t6));
t9=C_i_setslot(t2,C_fix(2),t6);
t10=C_slot(t2,C_fix(3));
if(C_truep(t10)){
t11=C_i_set_i_slot(t2,C_fix(3),C_SCHEME_FALSE);
/* library.scm:6708: ##sys#resume-thread-on-event */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1325]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1325]+1);
av2[1]=t1;
av2[2]=t10;
tp(3,av2);}}
else{
t11=C_SCHEME_UNDEFINED;
t12=t1;{
C_word *av2=av;
av2[0]=t12;
av2[1]=t11;
((C_proc)(void*)(*((C_word*)t12+1)))(2,av2);}}}

/* ##sys#get-next-event in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_34965(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_34965,c,av);}
t3=C_slot(t2,C_fix(3));
if(C_truep(C_i_not(t3))){
t4=C_slot(t2,C_fix(1));
t5=C_i_nullp(t4);
if(C_truep(C_i_not(t5))){
t6=C_slot(t4,C_fix(0));
t7=C_slot(t4,C_fix(1));
t8=C_i_setslot(t2,C_fix(1),t7);
if(C_truep(C_i_nullp(t7))){
t9=C_i_set_i_slot(t2,C_fix(2),C_SCHEME_END_OF_LIST);
t10=t1;{
C_word *av2=av;
av2[0]=t10;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}}
else{
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}
else{
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* ##sys#wait-for-next-event in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_35008(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,5)))){
C_save_and_reclaim((void *)f_35008,c,av);}
a=C_alloc(4);
t3=C_slot(t2,C_fix(3));
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35015,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(t3)){
/* library.scm:6724: ##sys#signal-hook */
t5=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=lf[1117];
av2[3]=C_SCHEME_FALSE;
av2[4]=lf[1333];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(6,av2);}}
else{
t5=t4;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_UNDEFINED;
f_35015(2,av2);}}}

/* k35013 in ##sys#wait-for-next-event in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35015(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_35015,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35020,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word)li1028),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_35020(t5,((C_word*)t0)[3]);}

/* again in k35013 in ##sys#wait-for-next-event in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void f_35020(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_35020,2,t0,t1);}
a=C_alloc(4);
t2=C_slot(((C_word*)t0)[2],C_fix(1));
if(C_truep(C_i_nullp(t2))){
t3=C_i_setslot(((C_word*)t0)[2],C_fix(3),C_fast_retrieve(lf[1077]));
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35036,a[2]=((C_word*)t0)[3],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6729: ##sys#suspend-thread-on-event */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1326]);
C_word av2[3];
av2[0]=*((C_word*)lf[1326]+1);
av2[1]=t4;
av2[2]=C_fast_retrieve(lf[1077]);
tp(3,av2);}}
else{
t3=C_slot(t2,C_fix(0));
t4=C_slot(t2,C_fix(1));
t5=C_i_setslot(((C_word*)t0)[2],C_fix(1),t4);
if(C_truep(C_i_nullp(t4))){
t6=C_i_set_i_slot(((C_word*)t0)[2],C_fix(2),C_SCHEME_END_OF_LIST);
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}}

/* k35034 in again in k35013 in ##sys#wait-for-next-event in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35036(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35036,c,av);}
/* library.scm:6730: again */
t2=((C_word*)((C_word*)t0)[2])[1];
f_35020(t2,((C_word*)t0)[3]);}

/* chicken.base#sleep-hook in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_35062(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35062,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_process_sleep(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.base#sleep in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_35065(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_35065,c,av);}
a=C_alloc(3);
t3=C_i_check_fixnum_2(t2,lf[1335]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35072,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6747: chicken.base#sleep-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1334]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1334]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}

/* k35070 in chicken.base#sleep in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35072(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35072,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in ... */
static void C_ccall f_35077(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(55,c,4)))){
C_save_and_reclaim((void *)f_35077,c,av);}
a=C_alloc(55);
t2=C_mutate((C_word*)lf[1337]+1 /* (set! ##sys#signal-vector ...) */,t1);
t3=C_mutate((C_word*)lf[1338]+1 /* (set! ##sys#interrupt-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35079,a[2]=((C_word)li1034),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[827]+1 /* (set! ##sys#dispatch-interrupt ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35129,a[2]=((C_word)li1035),tmp=(C_word)a,a+=3,tmp));
t5=C_fix(0);
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_mutate((C_word*)lf[830]+1 /* (set! ##sys#update-errno ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35136,a[2]=t6,a[3]=((C_word)li1036),tmp=(C_word)a,a+=4,tmp));
t8=C_mutate((C_word*)lf[1339]+1 /* (set! ##sys#errno ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35140,a[2]=t6,a[3]=((C_word)li1037),tmp=(C_word)a,a+=4,tmp));
t9=C_fast_retrieve(lf[994]);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_SCHEME_UNDEFINED;
t13=(*a=C_VECTOR_TYPE|1,a[1]=t12,tmp=(C_word)a,a+=2,tmp);
t14=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35154,a[2]=((C_word)li1039),tmp=(C_word)a,a+=3,tmp));
t15=C_set_block_item(t13,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35201,a[2]=((C_word)li1041),tmp=(C_word)a,a+=3,tmp));
t16=C_mutate((C_word*)lf[994]+1 /* (set! ##sys#user-read-hook ...) */,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35246,a[2]=t9,a[3]=t11,a[4]=t13,a[5]=((C_word)li1046),tmp=(C_word)a,a+=6,tmp));
t17=C_a_i_provide(&a,1,lf[1350]);
t18=C_mutate((C_word*)lf[1351]+1 /* (set! chicken.process-context#change-directory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35674,a[2]=((C_word)li1047),tmp=(C_word)a,a+=3,tmp));
t19=C_mutate((C_word*)lf[1354]+1 /* (set! ##sys#change-directory-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35705,a[2]=((C_word)li1048),tmp=(C_word)a,a+=3,tmp));
t20=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35713,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t21=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40911,a[2]=((C_word)li1224),tmp=(C_word)a,a+=3,tmp);
t22=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40936,a[2]=((C_word)li1225),tmp=(C_word)a,a+=3,tmp);
/* library.scm:6938: chicken.base#getter-with-setter */
t23=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t23;
av2[1]=t20;
av2[2]=t21;
av2[3]=t22;
av2[4]=lf[1598];
((C_proc)(void*)(*((C_word*)t23+1)))(5,av2);}}

/* ##sys#interrupt-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35079(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_35079,c,av);}
a=C_alloc(10);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35083,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35110,a[2]=t6,a[3]=((C_word)li1033),tmp=(C_word)a,a+=4,tmp));
t8=((C_word*)t6)[1];
f_35110(t8,t4,t2);}

/* k35081 in ##sys#interrupt-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35083(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_35083,c,av);}
t2=C_slot(C_fast_retrieve(lf[1095]),C_fix(0));
if(C_truep(C_fixnum_greaterp(t2,C_fix(0)))){
/* library.scm:6765: ##sys#run-pending-finalizers */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1096]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[1096]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
if(C_truep(C_i_closurep(((C_word*)t0)[3]))){
/* library.scm:6766: state */
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:6767: ##sys#context-switch */{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
C_context_switch(3,av2);}}}}

/* loop in ##sys#interrupt-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void f_35110(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_35110,3,t0,t1,t2);}
a=C_alloc(4);
if(C_truep(t2)){
t3=C_slot(C_fast_retrieve(lf[1337]),t2);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35120,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(t3)){
/* library.scm:6762: handler */
t5=t3;{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}
else{
/* library.scm:6763: loop */
t6=t1;
t7=C_i_pending_interrupt(C_SCHEME_FALSE);
t1=t6;
t2=t7;
goto loop;}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k35118 in loop in ##sys#interrupt-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35120(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_35120,c,av);}
/* library.scm:6763: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_35110(t2,((C_word*)t0)[3],C_i_pending_interrupt(C_SCHEME_FALSE));}

/* ##sys#dispatch-interrupt in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35129(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_35129,c,av);}
/* library.scm:6770: ##sys#interrupt-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1338]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1338]+1);
av2[1]=t1;
av2[2]=C_i_pending_interrupt(C_SCHEME_FALSE);
av2[3]=t2;
tp(4,av2);}}

/* ##sys#update-errno in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35136(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35136,c,av);}
t2=C_set_block_item(((C_word*)t0)[2],0,C_fix((C_word)errno));
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)((C_word*)t0)[2])[1];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* ##sys#errno in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35140(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35140,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)((C_word*)t0)[2])[1];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* readln in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void f_35154(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_35154,2,t1,t2);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35158,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6799: scheme#open-output-string */
t4=*((C_word*)lf[318]+1);{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k35156 in readln in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35158(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_35158,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35165,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6800: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k35163 in k35156 in readln in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35165(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_35165,c,av);}
a=C_alloc(8);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35167,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=((C_word)li1038),tmp=(C_word)a,a+=6,tmp));
t5=((C_word*)t3)[1];
f_35167(t5,((C_word*)t0)[4],t1);}

/* doloop7912 in k35163 in k35156 in readln in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void f_35167(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_35167,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_eofp(t2);
t4=(C_truep(t3)?t3:C_i_char_equalp(C_make_character(10),t2));
if(C_truep(t4)){
if(C_truep(C_eofp(t2))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
/* library.scm:6802: scheme#get-output-string */
t5=*((C_word*)lf[320]+1);{
C_word av2[3];
av2[0]=t5;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}}
else{
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35189,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6803: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word av2[4];
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t5;
av2[2]=t2;
av2[3]=((C_word*)t0)[2];
tp(4,av2);}}}

/* k35187 in doloop7912 in k35163 in k35156 in readln in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_35189(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_35189,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35196,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6800: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k35194 in k35187 in doloop7912 in k35163 in k35156 in readln in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_35196(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_35196,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_35167(t2,((C_word*)t0)[3],t1);}

/* read-escaped-sexp in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void f_35201(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_35201,3,t1,t2,t3);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35205,a[2]=t1,a[3]=t3,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
if(C_truep(t3)){
/* library.scm:6805: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}
else{
t5=t4;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_UNDEFINED;
f_35205(2,av2);}}}

/* k35203 in read-escaped-sexp in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35205(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_35205,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35208,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6806: read */
t3=*((C_word*)lf[189]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k35206 in k35203 in read-escaped-sexp in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35208(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_35208,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35211,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)t0)[3])){
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35216,a[2]=((C_word*)t0)[4],a[3]=t4,a[4]=((C_word)li1040),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_35216(t6,t2);}
else{
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k35209 in k35206 in k35203 in read-escaped-sexp in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35211(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35211,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* loop in k35206 in k35203 in read-escaped-sexp in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void f_35216(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_35216,2,t0,t1);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35220,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6810: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k35218 in loop in k35206 in k35203 in read-escaped-sexp in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_35220(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_35220,c,av);}
if(C_truep(C_eofp(t1))){
/* library.scm:6812: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[1340];
tp(4,av2);}}
else{
t2=C_i_char_equalp(C_make_character(125),t1);
if(C_truep(C_i_not(t2))){
/* library.scm:6813: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_35216(t3,((C_word*)t0)[2]);}
else{
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}}

/* ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35246(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_35246,c,av);}
a=C_alloc(6);
t4=C_i_char_equalp(C_make_character(60),t2);
if(C_truep(C_i_not(t4))){
/* library.scm:6816: old */
t5=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
((C_proc)C_fast_retrieve_proc(t5))(4,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35259,a[2]=t3,a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* ##sys#read-char/port */
t6=C_fast_retrieve(lf[905]);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}}

/* k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35259(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_35259,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35262,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6819: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}

/* k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35262(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_35262,c,av);}
a=C_alloc(6);
switch(t1){
case C_make_character(60):
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35271,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6821: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}
case C_make_character(35):
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35383,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6846: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}
default:
/* library.scm:6900: ##sys#read-error */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[914]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[914]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[2];
av2[3]=lf[1349];
tp(4,av2);}}}

/* k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35271(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_35271,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35274,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6822: scheme#open-output-string */
t3=*((C_word*)lf[318]+1);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_35274(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_35274,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35277,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6823: readln */
f_35154(t2,((C_word*)t0)[2]);}

/* k35275 in k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_35277(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_35277,c,av);}
a=C_alloc(10);
t2=C_SCHEME_FALSE;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_eofp(t1);
t5=(C_truep(t4)?C_fix(0):C_i_string_length(t1));
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_35283,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=t3,a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
t7=C_eqp(t5,C_fix(0));
if(C_truep(t7)){
/* library.scm:6828: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[1343];
tp(4,av2);}}
else{
t8=C_fixnum_difference(t5,C_fix(1));
t9=C_i_string_ref(t1,t8);
t10=C_u_i_char_equalp(t9,C_make_character(32));
if(C_truep(t10)){
if(C_truep(t10)){
/* library.scm:6832: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[1344];
tp(4,av2);}}
else{
t11=C_SCHEME_UNDEFINED;
t12=t6;{
C_word *av2=av;
av2[0]=t12;
av2[1]=t11;
f_35283(2,av2);}}}
else{
t11=C_fixnum_difference(t5,C_fix(1));
t12=C_i_string_ref(t1,t11);
if(C_truep(C_u_i_char_equalp(t12,C_make_character(9)))){
/* library.scm:6832: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[1344];
tp(4,av2);}}
else{
t13=C_SCHEME_UNDEFINED;
t14=t6;{
C_word *av2=av;
av2[0]=t14;
av2[1]=t13;
f_35283(2,av2);}}}}}

/* k35281 in k35275 in k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_35283(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_35283,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_35290,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* library.scm:6835: readln */
f_35154(t2,((C_word*)t0)[4]);}

/* k35288 in k35281 in k35275 in k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_35290(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_35290,c,av);}
a=C_alloc(11);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_35292,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t3,a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word)li1042),tmp=(C_word)a,a+=9,tmp));
t5=((C_word*)t3)[1];
f_35292(t5,((C_word*)t0)[7],t1);}

/* doloop7947 in k35288 in k35281 in k35275 in k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void f_35292(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(17,0,3)))){
C_save_and_reclaim_args((void *)trf_35292,3,t0,t1,t2);}
a=C_alloc(17);
t3=C_eofp(t2);
t4=(C_truep(t3)?t3:C_i_string_equal_p(((C_word*)t0)[2],t2));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35305,a[2]=t1,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_eofp(t2))){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35318,a[2]=t5,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t7=C_a_i_list(&a,3,lf[1341],((C_word*)t0)[2],lf[1342]);
/* library.scm:6790: ##sys#print-to-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1070]);
C_word av2[3];
av2[0]=*((C_word*)lf[1070]+1);
av2[1]=t6;
av2[2]=t7;
tp(3,av2);}}
else{
/* library.scm:6840: scheme#get-output-string */
t6=*((C_word*)lf[320]+1);{
C_word av2[3];
av2[0]=t6;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}}
else{
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_35321,a[2]=((C_word*)t0)[5],a[3]=t1,a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[4],a[6]=t2,a[7]=((C_word*)t0)[3],tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)((C_word*)t0)[7])[1])){
/* library.scm:6842: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word av2[4];
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t5;
av2[2]=C_make_character(10);
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}
else{
t6=C_set_block_item(((C_word*)t0)[7],0,C_SCHEME_TRUE);
t7=t5;{
C_word av2[2];
av2[0]=t7;
av2[1]=t6;
f_35321(2,av2);}}}}

/* k35303 in doloop7947 in k35288 in k35281 in k35275 in k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_35305(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_35305,c,av);}
/* library.scm:6840: scheme#get-output-string */
t2=*((C_word*)lf[320]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k35316 in doloop7947 in k35288 in k35281 in k35275 in k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_35318(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_35318,c,av);}
/* library.scm:6838: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k35319 in doloop7947 in k35288 in k35281 in k35275 in k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_35321(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_35321,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35324,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6844: display */
t3=*((C_word*)lf[193]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=((C_word*)t0)[7];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k35322 in k35319 in doloop7947 in k35288 in k35281 in k35275 in k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_35324(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_35324,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35331,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6835: readln */
f_35154(t2,((C_word*)t0)[5]);}

/* k35329 in k35322 in k35319 in doloop7947 in k35288 in k35281 in k35275 in k35272 in k35269 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void C_ccall f_35331(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_35331,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_35292(t2,((C_word*)t0)[3],t1);}

/* k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35383(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_35383,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35386,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6847: readln */
f_35154(t2,((C_word*)t0)[2]);}

/* k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_35386(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_35386,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35389,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6848: scheme#open-output-string */
t3=*((C_word*)lf[318]+1);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_35389(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,3)))){
C_save_and_reclaim((void *)f_35389,c,av);}
a=C_alloc(14);
t2=t1;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35391,a[2]=t3,a[3]=((C_word)li1043),tmp=(C_word)a,a+=4,tmp);
t5=C_eofp(((C_word*)t0)[2]);
t6=(C_truep(t5)?C_fix(0):C_i_string_length(((C_word*)t0)[2]));
t7=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_35405,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t4,a[5]=t3,a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
t8=C_eqp(t6,C_fix(0));
if(C_truep(t8)){
/* library.scm:6857: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=t7;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[1347];
tp(4,av2);}}
else{
t9=C_fixnum_difference(t6,C_fix(1));
t10=C_i_string_ref(((C_word*)t0)[2],t9);
t11=C_u_i_char_equalp(t10,C_make_character(32));
if(C_truep(t11)){
if(C_truep(t11)){
/* library.scm:6861: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=t7;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[1348];
tp(4,av2);}}
else{
t12=C_SCHEME_UNDEFINED;
t13=t7;{
C_word *av2=av;
av2[0]=t13;
av2[1]=t12;
f_35405(2,av2);}}}
else{
t12=C_fixnum_difference(t6,C_fix(1));
t13=C_i_string_ref(((C_word*)t0)[2],t12);
if(C_truep(C_u_i_char_equalp(t13,C_make_character(9)))){
/* library.scm:6861: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=t7;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[1348];
tp(4,av2);}}
else{
t14=C_SCHEME_UNDEFINED;
t15=t7;{
C_word *av2=av;
av2[0]=t15;
av2[1]=t14;
f_35405(2,av2);}}}}}

/* get/clear-str in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void f_35391(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_35391,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35395,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6850: scheme#get-output-string */
t3=*((C_word*)lf[320]+1);{
C_word av2[3];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)((C_word*)t0)[2])[1];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k35393 in get/clear-str in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_35395(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_35395,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35399,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:6851: scheme#open-output-string */
t3=*((C_word*)lf[318]+1);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k35397 in k35393 in get/clear-str in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_35399(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35399,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_35405(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_35405,c,av);}
a=C_alloc(11);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_35410,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word)li1045),tmp=(C_word)a,a+=9,tmp));
t5=((C_word*)t3)[1];
f_35410(t5,((C_word*)t0)[7],C_SCHEME_END_OF_LIST);}

/* loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void f_35410(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,2)))){
C_save_and_reclaim_args((void *)trf_35410,3,t0,t1,t2);}
a=C_alloc(10);
t3=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_35414,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],a[9]=((C_word*)t0)[7],tmp=(C_word)a,a+=10,tmp);
/* library.scm:6866: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}

/* k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_35414(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_35414,c,av);}
a=C_alloc(9);
t2=C_eqp(t1,C_make_character(10));
t3=(C_truep(t2)?t2:C_eqp(t1,C_SCHEME_END_OF_FILE));
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_35426,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
/* library.scm:6869: get/clear-str */
t5=((C_word*)t0)[7];
f_35391(t5,t4);}
else{
t4=C_eqp(t1,C_make_character(35));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_35545,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[9],tmp=(C_word)a,a+=9,tmp);
/* library.scm:6888: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t5;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35612,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6898: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t5;
av2[2]=t1;
av2[3]=((C_word*)((C_word*)t0)[8])[1];
tp(4,av2);}}}}

/* k35424 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_35426(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(17,c,2)))){
C_save_and_reclaim((void *)f_35426,c,av);}
a=C_alloc(17);
t2=C_eofp(((C_word*)t0)[2]);
t3=(C_truep(t2)?t2:C_i_string_equal_p(((C_word*)t0)[3],t1));
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35438,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_eofp(((C_word*)t0)[2]))){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35523,a[2]=t4,a[3]=((C_word*)t0)[6],tmp=(C_word)a,a+=4,tmp);
t6=C_a_i_list(&a,3,lf[1341],((C_word*)t0)[3],lf[1342]);
/* library.scm:6790: ##sys#print-to-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1070]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[1070]+1);
av2[1]=t5;
av2[2]=t6;
tp(3,av2);}}
else{
t5=t4;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_UNDEFINED;
f_35438(2,av2);}}}
else{
t4=C_a_i_cons(&a,2,t1,((C_word*)t0)[5]);
t5=C_a_i_cons(&a,2,C_make_character(10),t4);
/* library.scm:6886: loop */
t6=((C_word*)((C_word*)t0)[7])[1];
f_35410(t6,((C_word*)t0)[4],t5);}}

/* k35436 in k35424 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_35438(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_35438,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35445,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=C_i_cdr(((C_word*)t0)[3]);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35451,a[2]=t5,a[3]=((C_word)li1044),tmp=(C_word)a,a+=4,tmp));
t7=((C_word*)t5)[1];
f_35451(t7,t2,t3,C_SCHEME_END_OF_LIST,lf[1346]);}

/* k35443 in k35436 in k35424 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void C_ccall f_35445(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,1)))){
C_save_and_reclaim((void *)f_35445,c,av);}
a=C_alloc(6);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_list(&a,2,lf[1070],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* loop2 in k35436 in k35424 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void f_35451(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_35451,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
if(C_truep(C_i_nullp(t2))){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35465,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6878: ##sys#print-to-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1070]);
C_word av2[3];
av2[0]=*((C_word*)lf[1070]+1);
av2[1]=t5;
av2[2]=t3;
tp(3,av2);}}
else{
t5=C_i_car(t2);
t6=C_i_stringp(t5);
t7=(C_truep(t6)?t6:C_charp(C_u_i_car(t2)));
if(C_truep(t7)){
t8=C_u_i_cdr(t2);
t9=C_u_i_car(t2);
t10=C_a_i_cons(&a,2,t9,t3);
/* library.scm:6880: loop2 */
t12=t1;
t13=t8;
t14=t10;
t15=t4;
t1=t12;
t2=t13;
t3=t14;
t4=t15;
goto loop;}
else{
t8=C_u_i_cdr(t2);
t9=C_u_i_car(t2);
t10=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_35504,a[2]=t4,a[3]=t9,a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=t8,tmp=(C_word)a,a+=7,tmp);
/* library.scm:6885: ##sys#print-to-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1070]);
C_word av2[3];
av2[0]=*((C_word*)lf[1070]+1);
av2[1]=t10;
av2[2]=t3;
tp(3,av2);}}}}

/* k35463 in loop2 in k35436 in k35424 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in ... */
static void C_ccall f_35465(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,1)))){
C_save_and_reclaim((void *)f_35465,c,av);}
a=C_alloc(9);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_list(&a,3,lf[1345],t1,((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k35502 in loop2 in k35436 in k35424 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in ... */
static void C_ccall f_35504(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(18,c,4)))){
C_save_and_reclaim((void *)f_35504,c,av);}
a=C_alloc(18);
t2=C_a_i_list(&a,3,lf[1345],t1,((C_word*)t0)[2]);
t3=C_a_i_list(&a,3,lf[1345],((C_word*)t0)[3],t2);
/* library.scm:6882: loop2 */
t4=((C_word*)((C_word*)t0)[4])[1];
f_35451(t4,((C_word*)t0)[5],((C_word*)t0)[6],C_SCHEME_END_OF_LIST,t3);}

/* k35521 in k35424 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_35523(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_35523,c,av);}
/* library.scm:6872: ##sys#read-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[917]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[917]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k35543 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_35545(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_35545,c,av);}
a=C_alloc(9);
switch(t1){
case C_make_character(35):
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35554,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35561,a[2]=t2,a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6891: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[6];
tp(3,av2);}
case C_make_character(123):
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35578,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[7],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6893: read-escaped-sexp */
f_35201(t2,((C_word*)t0)[6],C_SCHEME_TRUE);
default:
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35597,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[7],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6895: read-escaped-sexp */
f_35201(t2,((C_word*)t0)[6],C_SCHEME_FALSE);}}

/* k35552 in k35543 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_35554(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_35554,c,av);}
/* library.scm:6892: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_35410(t2,((C_word*)t0)[3],((C_word*)t0)[4]);}

/* k35559 in k35543 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_35561(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_35561,c,av);}
/* library.scm:6891: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=((C_word*)((C_word*)t0)[3])[1];
tp(4,av2);}}

/* k35576 in k35543 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_35578(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_35578,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35586,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6894: get/clear-str */
t3=((C_word*)t0)[5];
f_35391(t3,t2);}

/* k35584 in k35576 in k35543 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void C_ccall f_35586(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_35586,c,av);}
a=C_alloc(6);
t2=C_a_i_cons(&a,2,t1,((C_word*)t0)[2]);
t3=C_a_i_cons(&a,2,((C_word*)t0)[3],t2);
/* library.scm:6893: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_35410(t4,((C_word*)t0)[5],t3);}

/* k35595 in k35543 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_35597(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_35597,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35605,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6896: get/clear-str */
t3=((C_word*)t0)[5];
f_35391(t3,t2);}

/* k35603 in k35595 in k35543 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void C_ccall f_35605(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_35605,c,av);}
a=C_alloc(6);
t2=C_a_i_cons(&a,2,t1,((C_word*)t0)[2]);
t3=C_a_i_cons(&a,2,((C_word*)t0)[3],t2);
/* library.scm:6895: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_35410(t4,((C_word*)t0)[5],t3);}

/* k35610 in k35412 in loop in k35403 in k35387 in k35384 in k35381 in k35260 in k35257 in ##sys#user-read-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_35612(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_35612,c,av);}
/* library.scm:6899: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_35410(t2,((C_word*)t0)[3],((C_word*)t0)[4]);}

/* chicken.process-context#change-directory in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35674(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_35674,c,av);}
a=C_alloc(4);
t3=C_i_check_string_2(t2,lf[1352]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35681,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6928: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[884]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[884]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=lf[1352];
tp(4,av2);}}

/* k35679 in chicken.process-context#change-directory in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35681(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_35681,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35684,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_eqp(C_chdir(t1),C_fix(0));
if(C_truep(t3)){
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35694,a[2]=t2,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6930: ##sys#update-errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[830]);
C_word *av2=av;
av2[0]=*((C_word*)lf[830]+1);
av2[1]=t4;
tp(2,av2);}}}

/* k35682 in k35679 in chicken.process-context#change-directory in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35684(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35684,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k35692 in k35679 in chicken.process-context#change-directory in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35694(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_35694,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35698,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35702,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t4=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=C_mpointer(&a,(void*)strerror(errno));
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k35696 in k35692 in k35679 in chicken.process-context#change-directory in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35698(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_35698,c,av);}
/* library.scm:6930: ##sys#signal-hook/errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[379]);
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[379]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[467];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1352];
av2[5]=t1;
av2[6]=((C_word*)t0)[4];
tp(7,av2);}}

/* k35700 in k35692 in k35679 in chicken.process-context#change-directory in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35702(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_35702,c,av);}
/* library.scm:6931: scheme#string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1353];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* ##sys#change-directory-hook in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35705(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_35705,c,av);}
/* library.scm:6935: change-directory */
t3=C_fast_retrieve(lf[1351]);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_35713(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(30,c,4)))){
C_save_and_reclaim((void *)f_35713,c,av);}
a=C_alloc(30);
t2=C_mutate((C_word*)lf[1355]+1 /* (set! chicken.process-context#current-directory ...) */,t1);
t3=C_mutate((C_word*)lf[1356]+1 /* (set! chicken.process-context#get-environment-variable ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35722,a[2]=((C_word)li1049),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[1358]+1 /* (set! chicken.process-context#set-environment-variable! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35743,a[2]=((C_word)li1050),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[1360]+1 /* (set! chicken.process-context#unset-environment-variable! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35763,a[2]=((C_word)li1051),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[1362]+1 /* (set! chicken.process-context#get-environment-variables ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35773,a[2]=((C_word)li1054),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[1363]+1 /* (set! chicken.process-context#executable-pathname ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35838,a[2]=((C_word)li1055),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[1364]+1 /* (set! chicken.process-context#argc+argv ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35845,a[2]=((C_word)li1056),tmp=(C_word)a,a+=3,tmp));
t9=C_SCHEME_FALSE;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_mutate((C_word*)lf[1365]+1 /* (set! chicken.process-context#argv ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35857,a[2]=t10,a[3]=((C_word)li1058),tmp=(C_word)a,a+=4,tmp));
t12=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35897,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t13=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40909,a[2]=t12,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7022: argv */
t14=C_fast_retrieve(lf[1365]);{
C_word *av2=av;
av2[0]=t14;
av2[1]=t13;
((C_proc)(void*)(*((C_word*)t14+1)))(2,av2);}}

/* chicken.process-context#get-environment-variable in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35722(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_35722,c,av);}
a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35730,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6962: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[884]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[884]+1);
av2[1]=t3;
av2[2]=t2;
av2[3]=lf[1357];
tp(4,av2);}}

/* k35728 in chicken.process-context#get-environment-variable in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35730(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_35730,c,av);}
a=C_alloc(5);
t2=C_a_i_bytevector(&a,1,C_fix(3));
/* library.scm:6959: ##sys#peek-c-string */
t3=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=stub8071(t2,t1);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* chicken.process-context#set-environment-variable! in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35743(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_35743,c,av);}
a=C_alloc(4);
t4=C_i_check_string_2(t2,lf[1359]);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35751,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6970: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[884]);
C_word *av2=av;
av2[0]=*((C_word*)lf[884]+1);
av2[1]=t5;
av2[2]=t2;
av2[3]=lf[1359];
tp(4,av2);}}

/* k35749 in chicken.process-context#set-environment-variable! in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35751(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_35751,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35755,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)t0)[3])){
t3=C_i_check_string_2(((C_word*)t0)[3],lf[1359]);
/* library.scm:6974: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[884]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[884]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
av2[3]=lf[1359];
tp(4,av2);}}
else{
t3=C_i_setenv(t1,C_SCHEME_FALSE);
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k35753 in k35749 in chicken.process-context#set-environment-variable! in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35755(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35755,c,av);}
t2=C_i_setenv(((C_word*)t0)[2],t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.process-context#unset-environment-variable! in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35763(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_35763,c,av);}
a=C_alloc(3);
t3=C_i_check_string_2(t2,lf[1361]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35771,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:6980: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[884]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[884]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=lf[1361];
tp(4,av2);}}

/* k35769 in chicken.process-context#unset-environment-variable! in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35771(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35771,c,av);}
t2=C_i_setenv(t1,C_SCHEME_FALSE);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.process-context#get-environment-variables in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35773(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_35773,c,av);}
a=C_alloc(6);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35779,a[2]=t3,a[3]=((C_word)li1053),tmp=(C_word)a,a+=4,tmp));
t5=((C_word*)t3)[1];
f_35779(t5,t1,C_fix(0));}

/* loop in chicken.process-context#get-environment-variables in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void f_35779(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,0,3)))){
C_save_and_reclaim_args((void *)trf_35779,3,t0,t1,t2);}
a=C_alloc(10);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35783,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t2);
/* library.scm:6965: ##sys#peek-and-free-c-string */
t6=*((C_word*)lf[1292]+1);{
C_word av2[4];
av2[0]=t6;
av2[1]=t3;
av2[2]=stub8079(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k35781 in loop in chicken.process-context#get-environment-variables in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35783(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_35783,c,av);}
a=C_alloc(9);
if(C_truep(t1)){
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_35791,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t3,a[6]=((C_word)li1052),tmp=(C_word)a,a+=7,tmp));
t5=((C_word*)t3)[1];
f_35791(t5,((C_word*)t0)[4],C_fix(0));}
else{
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* scan in k35781 in loop in chicken.process-context#get-environment-variables in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void f_35791(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_35791,3,t0,t1,t2);}
a=C_alloc(7);
t3=C_i_string_ref(((C_word*)t0)[2],t2);
if(C_truep(C_u_i_char_equalp(C_make_character(61),t3))){
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_35819,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[2],a[6]=t2,tmp=(C_word)a,a+=7,tmp);
/* library.scm:6991: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[486]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[2];
av2[3]=C_fix(0);
av2[4]=t2;
tp(5,av2);}}
else{
/* library.scm:6994: scan */
t6=t1;
t7=C_fixnum_plus(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}

/* k35809 in k35821 in k35817 in scan in k35781 in loop in chicken.process-context#get-environment-variables in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_35811(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_35811,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k35817 in scan in k35781 in loop in chicken.process-context#get-environment-variables in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_35819(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_35819,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35823,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:6992: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[486]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=C_fixnum_plus(((C_word*)t0)[6],C_fix(1));
av2[4]=C_u_i_string_length(((C_word*)t0)[5]);
tp(5,av2);}}

/* k35821 in k35817 in scan in k35781 in loop in chicken.process-context#get-environment-variables in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_35823(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_35823,c,av);}
a=C_alloc(7);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35811,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6993: loop */
t4=((C_word*)((C_word*)t0)[4])[1];
f_35779(t4,t3,C_fixnum_plus(((C_word*)t0)[5],C_fix(1)));}

/* chicken.process-context#executable-pathname in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35838(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_35838,c,av);}
a=C_alloc(5);
t2=C_a_i_bytevector(&a,1,C_fix(3));
/* library.scm:7004: ##sys#peek-and-free-c-string */
t3=*((C_word*)lf[1292]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=stub8103(t2);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* chicken.process-context#argc+argv in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35845(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_35845,c,av);}
a=C_alloc(3);
/* library.scm:7007: ##sys#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_fix((C_word)C_main_argc);
av2[3]=C_mpointer_or_false(&a,(void*)C_main_argv);
C_values(4,av2);}}

/* chicken.process-context#argv in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35857(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_35857,c,av);}
a=C_alloc(10);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)((C_word*)t0)[2])[1];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35865,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_fixnum_difference(C_fix((C_word)C_main_argc),C_fix(1));
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35871,a[2]=t5,a[3]=((C_word)li1057),tmp=(C_word)a,a+=4,tmp));
t7=((C_word*)t5)[1];
f_35871(t7,t2,t3,C_SCHEME_END_OF_LIST);}}

/* k35863 in chicken.process-context#argv in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35865(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35865,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)((C_word*)t0)[2])[1];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* doloop8115 in chicken.process-context#argv in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void f_35871(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,3)))){
C_save_and_reclaim_args((void *)trf_35871,4,t0,t1,t2,t3);}
a=C_alloc(11);
if(C_truep(C_fixnum_lessp(t2,C_fix(0)))){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_fixnum_difference(t2,C_fix(1));
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35893,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
t6=C_a_i_bytevector(&a,1,C_fix(3));
/* library.scm:7011: ##sys#peek-c-string */
t7=*((C_word*)lf[829]+1);{
C_word av2[4];
av2[0]=t7;
av2[1]=t5;
av2[2]=stub8111(t6,t2);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}}

/* k35891 in doloop8115 in chicken.process-context#argv in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35893(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_35893,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,((C_word*)t0)[2]);
t3=((C_word*)((C_word*)t0)[3])[1];
f_35871(t3,((C_word*)t0)[4],((C_word*)t0)[5],t2);}

/* k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_35897(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_35897,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[1366]+1 /* (set! chicken.process-context#program-name ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35901,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40825,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7031: argv */
t5=C_fast_retrieve(lf[1365]);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_35901(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(20,c,3)))){
C_save_and_reclaim((void *)f_35901,c,av);}
a=C_alloc(20);
t2=C_mutate((C_word*)lf[1367]+1 /* (set! chicken.process-context#command-line-arguments ...) */,t1);
t3=C_a_i_provide(&a,1,lf[1368]);
t4=C_mutate((C_word*)lf[1369]+1 /* (set! chicken.gc#current-gc-milliseconds ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35903,a[2]=((C_word)li1059),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[1370]+1 /* (set! chicken.gc#set-gc-report! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35906,a[2]=((C_word)li1060),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[1371]+1 /* (set! chicken.gc#memory-statistics ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35909,a[2]=((C_word)li1061),tmp=(C_word)a,a+=3,tmp));
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35938,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t8=C_fixnum_times(C_fix(2),C_fix((C_word)C_max_pending_finalizers));
/* library.scm:7087: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t7;
av2[2]=C_fixnum_plus(t8,C_fix(1));
av2[3]=C_SCHEME_UNDEFINED;
tp(4,av2);}}

/* chicken.gc#current-gc-milliseconds in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35903(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35903,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_accumulated_gc_time();
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.gc#set-gc-report! in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35906(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35906,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_set_gc_report(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.gc#memory-statistics in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35909(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_35909,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35913,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7077: ##sys#gc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[380]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[380]+1);
av2[1]=t2;
av2[2]=C_SCHEME_TRUE;
tp(3,av2);}}

/* k35911 in chicken.gc#memory-statistics in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_35913(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_35913,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35916,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:7078: ##sys#memory-info */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[388]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[388]+1);
av2[1]=t2;
tp(2,av2);}}

/* k35914 in k35911 in chicken.gc#memory-statistics in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_35916(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,1)))){
C_save_and_reclaim((void *)f_35916,c,av);}
a=C_alloc(4);
t2=C_slot(t1,C_fix(0));
t3=C_fixnum_divide(t2,C_fix(2));
t4=C_fixnum_difference(t3,((C_word*)t0)[2]);
t5=C_slot(t1,C_fix(1));
t6=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_a_i_vector3(&a,3,t3,t4,t5);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_35938(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(26,c,4)))){
C_save_and_reclaim((void *)f_35938,c,av);}
a=C_alloc(26);
t2=C_mutate((C_word*)lf[1095]+1 /* (set! ##sys#pending-finalizers ...) */,t1);
t3=C_i_set_i_slot(C_fast_retrieve(lf[1095]),C_fix(0),C_fix(0));
t4=C_mutate((C_word*)lf[1372]+1 /* (set! ##sys#set-finalizer! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_register_finalizer,a[2]=((C_word)li1062),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[1373]+1 /* (set! ##sys#init-finalizer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35944,a[2]=((C_word)li1063),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[1379]+1 /* (set! chicken.gc#set-finalizer! ...) */,C_fast_retrieve(lf[1373]));
t7=C_a_i_vector1(&a,1,lf[1380]);
t8=C_mutate(&lf[1381] /* (set! chicken.gc#finalizer-tag ...) */,t7);
t9=C_mutate(&lf[1382] /* (set! chicken.gc#finalizer? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36014,a[2]=((C_word)li1064),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate((C_word*)lf[1383]+1 /* (set! chicken.gc#make-finalizer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36030,a[2]=((C_word)li1070),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[1384]+1 /* (set! chicken.gc#add-to-finalizer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36108,a[2]=((C_word)li1072),tmp=(C_word)a,a+=3,tmp));
t12=C_SCHEME_FALSE;
t13=(*a=C_VECTOR_TYPE|1,a[1]=t12,tmp=(C_word)a,a+=2,tmp);
t14=C_mutate((C_word*)lf[1096]+1 /* (set! ##sys#run-pending-finalizers ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36155,a[2]=t13,a[3]=((C_word)li1081),tmp=(C_word)a,a+=4,tmp));
t15=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36322,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7195: scheme#make-parameter */
t16=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t16;
av2[1]=t15;
av2[2]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t16+1)))(3,av2);}}

/* ##sys#init-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_35944(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,4)))){
C_save_and_reclaim((void *)f_35944,c,av);}
a=C_alloc(11);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_35948,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fixnum_greater_or_equal_p(C_i_live_finalizer_count(),C_fix((C_word)C_max_pending_finalizers)))){
t5=C_fixnum_times(C_fix(2),C_fix((C_word)C_max_pending_finalizers));
if(C_truep(C_resize_pending_finalizers(t5))){
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_35965,a[2]=t4,a[3]=t1,a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
t7=C_fixnum_times(C_fix(2),C_fix((C_word)C_max_pending_finalizers));
/* library.scm:7099: ##sys#vector-resize */
f_23697(t6,C_fast_retrieve(lf[1095]),C_fixnum_plus(t7,C_fix(1)),C_SCHEME_UNDEFINED);}
else{
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35995,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_debug_modep())){
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36005,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7115: string-append */
t8=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t8;
av2[1]=t7;
av2[2]=lf[1377];
av2[3]=C_i_live_finalizer_count();
av2[4]=lf[1378];
((C_proc)(void*)(*((C_word*)t8+1)))(5,av2);}}
else{
/* library.scm:7120: ##sys#force-finalizers */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1092]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1092]+1);
av2[1]=t4;
tp(2,av2);}}}}
else{
/* library.scm:7121: ##sys#set-finalizer! */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1372]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1372]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
tp(4,av2);}}}

/* k35946 in ##sys#init-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_35948(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_35948,c,av);}
/* library.scm:7121: ##sys#set-finalizer! */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1372]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1372]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
tp(4,av2);}}

/* k35963 in ##sys#init-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_35965(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_35965,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[1095]+1 /* (set! ##sys#pending-finalizers ...) */,t1);
if(C_truep(C_i_debug_modep())){
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35975,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_35979,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7106: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t4;
av2[2]=C_i_live_finalizer_count();
tp(3,av2);}}
else{
/* library.scm:7121: ##sys#set-finalizer! */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1372]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1372]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[5];
tp(4,av2);}}}

/* k35973 in k35963 in ##sys#init-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_35975(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_35975,c,av);}
/* library.scm:7103: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k35977 in k35963 in ##sys#init-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_35979(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_35979,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_35983,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7109: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=C_fix((C_word)C_max_pending_finalizers);
tp(3,av2);}}

/* k35981 in k35977 in k35963 in ##sys#init-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_35983(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_35983,c,av);}
/* library.scm:7104: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1374];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1375];
av2[5]=t1;
av2[6]=lf[1376];
((C_proc)(void*)(*((C_word*)t2+1)))(7,av2);}}

/* k35993 in ##sys#init-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_35995(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_35995,c,av);}
/* library.scm:7120: ##sys#force-finalizers */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1092]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1092]+1);
av2[1]=((C_word*)t0)[2];
tp(2,av2);}}

/* k36003 in ##sys#init-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36005(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_36005,c,av);}
/* library.scm:7114: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* chicken.gc#finalizer? in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_36014(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_36014,c,av);}
t3=C_i_pairp(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=(C_truep(t3)?C_eqp(C_retrieve2(lf[1381],C_text("chicken.gc#finalizer-tag")),C_slot(t2,C_fix(0))):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* chicken.gc#make-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_36030(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_36030,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36034,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7131: ##sys#make-event-queue */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1328]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1328]+1);
av2[1]=t3;
tp(2,av2);}}

/* k36032 in chicken.gc#make-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36034(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(24,c,3)))){
C_save_and_reclaim((void *)f_36034,c,av);}
a=C_alloc(24);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36036,a[2]=t1,a[3]=((C_word)li1065),tmp=(C_word)a,a+=4,tmp));
t7=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36042,a[2]=t3,a[3]=((C_word)li1066),tmp=(C_word)a,a+=4,tmp));
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36049,a[2]=t1,a[3]=t5,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36085,a[2]=t10,a[3]=t5,a[4]=((C_word)li1069),tmp=(C_word)a,a+=5,tmp));
t12=((C_word*)t10)[1];
f_36085(t12,t8,((C_word*)t0)[3]);}

/* handler in k36032 in chicken.gc#make-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_36036(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_36036,c,av);}
/* library.scm:7132: ##sys#add-event-to-queue! */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1330]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1330]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=t2;
tp(4,av2);}}

/* handle in k36032 in chicken.gc#make-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_36042(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_36042,c,av);}
/* library.scm:7133: ##sys#init-finalizer */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1373]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1373]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=((C_word*)((C_word*)t0)[2])[1];
tp(4,av2);}}

/* k36047 in k36032 in chicken.gc#make-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_36049(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_36049,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36054,a[2]=((C_word*)t0)[2],a[3]=((C_word)li1067),tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36075,a[2]=((C_word*)t0)[3],a[3]=((C_word)li1068),tmp=(C_word)a,a+=4,tmp);
/* library.scm:7135: ##sys#decorate-lambda */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[888]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[888]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=t2;
av2[3]=C_retrieve2(lf[1382],C_text("chicken.gc#finalizer?"));
av2[4]=t3;
tp(5,av2);}}

/* a36053 in k36047 in k36032 in chicken.gc#make-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36054(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36054,c,av);}
if(C_truep(C_rest_nullp(c,2))){
/* library.scm:7139: ##sys#get-next-event */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1331]);
C_word av2[3];
av2[0]=*((C_word*)lf[1331]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}
else{
if(C_truep(C_get_rest_arg(c,2,av,2,t0))){
/* library.scm:7138: ##sys#wait-for-next-event */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1332]);
C_word av2[3];
av2[0]=*((C_word*)lf[1332]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}
else{
/* library.scm:7139: ##sys#get-next-event */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1331]);
C_word av2[3];
av2[0]=*((C_word*)lf[1331]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
tp(3,av2);}}}}

/* a36074 in k36047 in k36032 in chicken.gc#make-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36075(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_36075,c,av);}
a=C_alloc(3);
t4=C_a_i_cons(&a,2,C_retrieve2(lf[1381],C_text("chicken.gc#finalizer-tag")),((C_word*)((C_word*)t0)[2])[1]);
t5=C_i_setslot(t2,t3,t4);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* for-each-loop8202 in k36032 in chicken.gc#make-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void f_36085(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_36085,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36095,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7134: g8203 */
t4=((C_word*)((C_word*)t0)[3])[1];{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=C_slot(t2,C_fix(0));
f_36042(3,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k36093 in for-each-loop8202 in k36032 in chicken.gc#make-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36095(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36095,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_36085(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* chicken.gc#add-to-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_36108(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +5,c,3)))){
C_save_and_reclaim((void*)f_36108,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+5);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36112,a[2]=t1,a[3]=t3,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_closurep(t2))){
/* library.scm:7147: ##sys#lambda-decoration */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[889]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[889]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=C_retrieve2(lf[1382],C_text("chicken.gc#finalizer?"));
tp(4,av2);}}
else{
t5=t4;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_FALSE;
f_36112(2,av2);}}}

/* k36110 in chicken.gc#add-to-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36112(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_36112,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36115,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
if(C_truep(t1)){
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_36115(2,av2);}}
else{
/* library.scm:7149: chicken.base#error */
t3=*((C_word*)lf[234]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1385];
av2[3]=lf[1386];
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}}

/* k36113 in k36110 in chicken.gc#add-to-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_36115(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_36115,c,av);}
a=C_alloc(7);
t2=C_i_cdr(((C_word*)t0)[2]);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36123,a[2]=t4,a[3]=t2,a[4]=((C_word)li1071),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_36123(t6,((C_word*)t0)[3],((C_word*)t0)[4]);}

/* for-each-loop8244 in k36113 in k36110 in chicken.gc#add-to-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void f_36123(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_36123,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36133,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7151: g8245 */
t4=((C_word*)t0)[3];{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=C_slot(t2,C_fix(0));
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k36131 in for-each-loop8244 in k36113 in k36110 in chicken.gc#add-to-finalizer in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_36133(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36133,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_36123(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_36155(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(15,c,4)))){
C_save_and_reclaim((void *)f_36155,c,av);}
a=C_alloc(15);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36159,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_not(((C_word*)((C_word*)t0)[2])[1]))){
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,C_fast_retrieve(lf[1077]));
t5=C_slot(C_fast_retrieve(lf[1095]),C_fix(0));
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36190,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=t5,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_debug_modep())){
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36289,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36293,a[2]=t7,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7164: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t8;
av2[2]=t5;
tp(3,av2);}}
else{
t7=t6;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_SCHEME_UNDEFINED;
f_36190(2,av2);}}}
else{
if(C_truep(t2)){
t4=t3;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
f_36159(2,av2);}}
else{
t4=C_eqp(((C_word*)((C_word*)t0)[2])[1],C_fast_retrieve(lf[1077]));
if(C_truep(t4)){
/* library.scm:7185: ##sys#signal-hook */
t5=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t5;
av2[1]=t3;
av2[2]=lf[236];
av2[3]=lf[1096];
av2[4]=lf[1392];
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}
else{
/* library.scm:7190: ##sys#thread-yield! */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1323]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1323]+1);
av2[1]=t3;
tp(2,av2);}}}}}

/* k36157 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36159(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36159,c,av);}
t2=C_i_not(((C_word*)t0)[2]);
if(C_truep(t2)){
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(C_i_closurep(((C_word*)t0)[2]))){
/* library.scm:7192: state */
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
if(C_truep(((C_word*)t0)[2])){
/* library.scm:7193: ##sys#context-switch */{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[2];
C_context_switch(3,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}}}

/* k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36190(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_36190,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36193,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36202,a[2]=((C_word*)t0)[4],a[3]=t4,a[4]=((C_word)li1080),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_36202(t6,t2,C_fix(0));}

/* k36191 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_36193(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_36193,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36196,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:7180: vector-fill! */
t3=*((C_word*)lf[121]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_fast_retrieve(lf[1095]);
av2[3]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k36194 in k36191 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36196(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_36196,c,av);}
t2=C_i_set_i_slot(C_fast_retrieve(lf[1095]),C_fix(0),C_fix(0));
t3=C_set_block_item(((C_word*)t0)[2],0,C_SCHEME_FALSE);
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
f_36159(2,av2);}}

/* doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void f_36202(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,3)))){
C_save_and_reclaim_args((void *)trf_36202,3,t0,t1,t2);}
a=C_alloc(9);
if(C_truep(C_fixnum_greater_or_equal_p(t2,((C_word*)t0)[2]))){
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_fixnum_times(t2,C_fix(2));
t4=C_fixnum_plus(C_fix(1),t3);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36215,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36227,a[2]=t4,a[3]=((C_word)li1079),tmp=(C_word)a,a+=4,tmp);
/* library.scm:7176: scheme#call-with-current-continuation */
t7=*((C_word*)lf[162]+1);{
C_word av2[3];
av2[0]=t7;
av2[1]=t5;
av2[2]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}}

/* k36213 in doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36215(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_36215,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36218,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:7175: g8283 */
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)C_fast_retrieve_proc(t3))(2,av2);}}

/* k36216 in k36213 in doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_36218(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36218,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_36202(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* a36226 in doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36227(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_36227,c,av);}
a=C_alloc(9);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36233,a[2]=t2,a[3]=((C_word)li1074),tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36245,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word)li1078),tmp=(C_word)a,a+=5,tmp);
/* library.scm:7176: chicken.condition#with-exception-handler */
t5=C_fast_retrieve(lf[1060]);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t1;
av2[2]=t3;
av2[3]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* a36232 in a36226 in doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_36233(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_36233,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36239,a[2]=t2,a[3]=((C_word)li1073),tmp=(C_word)a,a+=4,tmp);
/* library.scm:7176: k8280 */
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}

/* a36238 in a36232 in a36226 in doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36239(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_36239,c,av);}
/* library.scm:7177: ##sys#show-exception-warning */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1190]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[1190]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=lf[1387];
av2[4]=C_SCHEME_FALSE;
tp(5,av2);}}

/* a36244 in a36226 in doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_36245(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_36245,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36251,a[2]=((C_word*)t0)[2],a[3]=((C_word)li1075),tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36268,a[2]=((C_word*)t0)[3],a[3]=((C_word)li1077),tmp=(C_word)a,a+=4,tmp);
/* library.scm:7176: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
C_call_with_values(4,av2);}}

/* a36250 in a36244 in a36226 in doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36251(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36251,c,av);}
t2=C_fixnum_plus(((C_word*)t0)[2],C_fix(1));
/* library.scm:7176: g8287 */
t3=C_slot(C_fast_retrieve(lf[1095]),t2);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=C_slot(C_fast_retrieve(lf[1095]),((C_word*)t0)[2]);
((C_proc)C_fast_retrieve_proc(t3))(3,av2);}}

/* a36267 in a36244 in a36226 in doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36268(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_36268,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36274,a[2]=t2,a[3]=((C_word)li1076),tmp=(C_word)a,a+=4,tmp);
/* library.scm:7176: k8280 */
t4=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t1;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}

/* a36273 in a36267 in a36244 in a36226 in doloop8276 in k36188 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_36274(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36274,c,av);}{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=0;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
C_apply_values(3,av2);}}

/* k36287 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36289(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_36289,c,av);}
/* library.scm:7163: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k36291 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36293(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_36293,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36297,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7166: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=C_i_live_finalizer_count();
tp(3,av2);}}

/* k36295 in k36291 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_36297(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_36297,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36301,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7169: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=C_i_allocated_finalizer_count();
tp(3,av2);}}

/* k36299 in k36295 in k36291 in ##sys#run-pending-finalizers in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36301(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,8)))){
C_save_and_reclaim((void *)f_36301,c,av);}
/* library.scm:7164: string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 9) {
  av2=av;
} else {
  av2=C_alloc(9);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1388];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1389];
av2[5]=((C_word*)t0)[4];
av2[6]=lf[1390];
av2[7]=t1;
av2[8]=lf[1391];
((C_proc)(void*)(*((C_word*)t2+1)))(9,av2);}}

/* k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_36322(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(26,c,6)))){
C_save_and_reclaim((void *)f_36322,c,av);}
a=C_alloc(26);
t2=C_mutate((C_word*)lf[1093]+1 /* (set! chicken.gc#force-finalizers ...) */,t1);
t3=C_mutate((C_word*)lf[1092]+1 /* (set! ##sys#force-finalizers ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36324,a[2]=((C_word)li1083),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[1393]+1 /* (set! chicken.gc#gc ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36352,a[2]=((C_word)li1084),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[952]+1 /* (set! ##sys#list->vector ...) */,*((C_word*)lf[118]+1));
t6=C_mutate((C_word*)lf[436]+1 /* (set! ##sys#list ...) */,*((C_word*)lf[46]+1));
t7=C_mutate((C_word*)lf[1394]+1 /* (set! ##sys#length ...) */,*((C_word*)lf[47]+1));
t8=C_mutate((C_word*)lf[1395]+1 /* (set! ##sys#cons ...) */,*((C_word*)lf[12]+1));
t9=C_mutate((C_word*)lf[291]+1 /* (set! ##sys#append ...) */,*((C_word*)lf[443]+1));
t10=C_mutate((C_word*)lf[1396]+1 /* (set! ##sys#vector ...) */,*((C_word*)lf[120]+1));
t11=C_mutate((C_word*)lf[1397]+1 /* (set! ##sys#apply ...) */,*((C_word*)lf[159]+1));
t12=C_mutate((C_word*)lf[1398]+1 /* (set! ##sys#values ...) */,*((C_word*)lf[160]+1));
t13=C_mutate((C_word*)lf[1399]+1 /* (set! ##sys#equal? ...) */,*((C_word*)lf[6]+1));
t14=C_mutate((C_word*)lf[1400]+1 /* (set! ##sys#car ...) */,*((C_word*)lf[13]+1));
t15=C_mutate((C_word*)lf[1401]+1 /* (set! ##sys#cdr ...) */,*((C_word*)lf[14]+1));
t16=C_mutate((C_word*)lf[1402]+1 /* (set! ##sys#pair? ...) */,*((C_word*)lf[11]+1));
t17=C_mutate((C_word*)lf[1403]+1 /* (set! ##sys#vector? ...) */,*((C_word*)lf[113]+1));
t18=C_mutate((C_word*)lf[1404]+1 /* (set! ##sys#vector->list ...) */,*((C_word*)lf[119]+1));
t19=C_mutate((C_word*)lf[1405]+1 /* (set! ##sys#vector-length ...) */,*((C_word*)lf[114]+1));
t20=C_mutate((C_word*)lf[1406]+1 /* (set! ##sys#vector-ref ...) */,*((C_word*)lf[115]+1));
t21=C_mutate((C_word*)lf[1407]+1 /* (set! ##sys#>= ...) */,*((C_word*)lf[99]+1));
t22=C_mutate((C_word*)lf[1408]+1 /* (set! ##sys#= ...) */,*((C_word*)lf[96]+1));
t23=C_mutate((C_word*)lf[1409]+1 /* (set! ##sys#+ ...) */,*((C_word*)lf[88]+1));
t24=C_mutate((C_word*)lf[1410]+1 /* (set! ##sys#eq? ...) */,*((C_word*)lf[4]+1));
t25=C_mutate((C_word*)lf[1411]+1 /* (set! ##sys#eqv? ...) */,*((C_word*)lf[5]+1));
t26=C_mutate((C_word*)lf[1412]+1 /* (set! ##sys#list? ...) */,*((C_word*)lf[59]+1));
t27=C_mutate((C_word*)lf[1413]+1 /* (set! ##sys#null? ...) */,*((C_word*)lf[45]+1));
t28=C_mutate((C_word*)lf[1414]+1 /* (set! ##sys#map-n ...) */,*((C_word*)lf[211]+1));
t29=C_mutate((C_word*)lf[1415]+1 /* (set! ##sys#make-locative ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36395,a[2]=((C_word)li1085),tmp=(C_word)a,a+=3,tmp));
t30=C_a_i_provide(&a,1,lf[1428]);
t31=C_mutate((C_word*)lf[1429]+1 /* (set! chicken.plist#put! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36662,a[2]=((C_word)li1086),tmp=(C_word)a,a+=3,tmp));
t32=C_mutate((C_word*)lf[1431]+1 /* (set! chicken.plist#get ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36668,a[2]=((C_word)li1087),tmp=(C_word)a,a+=3,tmp));
t33=C_mutate((C_word*)lf[1433]+1 /* (set! ##sys#put! ...) */,C_fast_retrieve(lf[1429]));
t34=C_mutate((C_word*)lf[1434]+1 /* (set! ##sys#get ...) */,C_fast_retrieve(lf[1431]));
t35=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36687,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7328: chicken.base#getter-with-setter */
t36=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t36;
av2[1]=t35;
av2[2]=C_fast_retrieve(lf[1431]);
av2[3]=C_fast_retrieve(lf[1429]);
((C_proc)(void*)(*((C_word*)t36+1)))(4,av2);}}

/* ##sys#force-finalizers in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36324(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_36324,c,av);}
a=C_alloc(6);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36330,a[2]=t3,a[3]=((C_word)li1082),tmp=(C_word)a,a+=4,tmp));
t5=((C_word*)t3)[1];
f_36330(t5,t1);}

/* loop in ##sys#force-finalizers in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void f_36330(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_36330,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36334,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7199: ##sys#gc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[380]+1));
C_word av2[2];
av2[0]=*((C_word*)lf[380]+1);
av2[1]=t2;
tp(2,av2);}}

/* k36332 in loop in ##sys#force-finalizers in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36334(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_36334,c,av);}
a=C_alloc(4);
t2=C_slot(C_fast_retrieve(lf[1095]),C_fix(0));
if(C_truep(C_fixnum_greaterp(t2,C_fix(0)))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36343,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* library.scm:7201: ##sys#run-pending-finalizers */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1096]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[1096]+1);
av2[1]=t3;
av2[2]=C_SCHEME_FALSE;
tp(3,av2);}}
else{
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k36341 in k36332 in loop in ##sys#force-finalizers in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_36343(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_36343,c,av);}
/* library.scm:7202: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_36330(t2,((C_word*)t0)[3]);}

/* chicken.gc#gc in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36352(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +0,c,2)))){
C_save_and_reclaim((void*)f_36352,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+0);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
if(C_truep(C_i_pairp(t2))){
t3=C_get_rest_arg(c,2,av,2,t0);
if(C_truep(t3)){
/* library.scm:7208: ##sys#force-finalizers */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1092]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1092]+1);
av2[1]=t1;
tp(2,av2);}}
else{
/* library.scm:7209: ##sys#gc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[380]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[380]+1);
av2[1]=t1;
av2[2]=t3;
tp(3,av2);}}}
else{
/* library.scm:7209: ##sys#gc */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[380]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[380]+1);
av2[1]=t1;
av2[2]=C_SCHEME_FALSE;
tp(3,av2);}}}

/* ##sys#make-locative in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36395(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_36395,c,av);}
a=C_alloc(5);
if(C_truep(C_immp(t2))){
/* library.scm:7242: ##sys#signal-hook */
t6=*((C_word*)lf[235]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=t5;
av2[4]=lf[1416];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(6,av2);}}
else{
t6=C_i_vectorp(t2);
t7=(C_truep(t6)?t6:C_i_pairp(t2));
if(C_truep(t7)){
t8=C_block_size(t2);
t9=C_i_check_range_2(t3,C_fix(0),t8,t5);
t10=t1;{
C_word *av2=av;
av2[0]=t10;
av2[1]=C_a_i_make_locative(&a,4,C_fix(0),t2,t3,t4);
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
t8=(C_truep(C_blockp(t2))?C_bytevectorp(t2):C_SCHEME_FALSE);
if(C_truep(t8)){
t9=C_block_size(t2);
t10=C_i_check_range_2(t3,C_fix(0),t9,t5);
t11=C_a_i_make_locative(&a,4,C_fix(2),t2,t3,t4);
t12=t1;{
C_word *av2=av;
av2[0]=t12;
av2[1]=t11;
((C_proc)(void*)(*((C_word*)t12+1)))(2,av2);}}
else{
if(C_truep(C_structurep(t2))){
t9=C_slot(t2,C_fix(0));
t10=C_eqp(t9,lf[1417]);
if(C_truep(t10)){
t11=C_slot(t2,C_fix(1));
t12=C_block_size(t11);
t13=C_i_check_range_2(t3,C_fix(0),t12,t5);
t14=C_a_i_make_locative(&a,4,C_fix(2),t11,t3,t4);
t15=t1;{
C_word *av2=av;
av2[0]=t15;
av2[1]=t14;
((C_proc)(void*)(*((C_word*)t15+1)))(2,av2);}}
else{
t11=C_eqp(t9,lf[1418]);
if(C_truep(t11)){
t12=C_slot(t2,C_fix(1));
t13=C_block_size(t12);
t14=C_i_check_range_2(t3,C_fix(0),t13,t5);
t15=t1;{
C_word *av2=av;
av2[0]=t15;
av2[1]=C_a_i_make_locative(&a,4,C_fix(3),t12,t3,t4);
((C_proc)(void*)(*((C_word*)t15+1)))(2,av2);}}
else{
t12=C_eqp(t9,lf[1419]);
if(C_truep(t12)){
t13=C_slot(t2,C_fix(1));
t14=C_block_size(t13);
t15=C_i_check_range_2(t3,C_fix(0),t14,t5);
t16=C_a_i_make_locative(&a,4,C_fix(4),t13,t3,t4);
t17=t1;{
C_word *av2=av;
av2[0]=t17;
av2[1]=t16;
((C_proc)(void*)(*((C_word*)t17+1)))(2,av2);}}
else{
t13=C_eqp(t9,lf[1420]);
if(C_truep(t13)){
t14=C_slot(t2,C_fix(1));
t15=C_block_size(t14);
t16=C_i_check_range_2(t3,C_fix(0),t15,t5);
t17=t1;{
C_word *av2=av;
av2[0]=t17;
av2[1]=C_a_i_make_locative(&a,4,C_fix(5),t14,t3,t4);
((C_proc)(void*)(*((C_word*)t17+1)))(2,av2);}}
else{
t14=C_eqp(t9,lf[1421]);
if(C_truep(t14)){
t15=C_slot(t2,C_fix(1));
t16=C_block_size(t15);
t17=C_i_check_range_2(t3,C_fix(0),t16,t5);
t18=C_a_i_make_locative(&a,4,C_fix(6),t15,t3,t4);
t19=t1;{
C_word *av2=av;
av2[0]=t19;
av2[1]=t18;
((C_proc)(void*)(*((C_word*)t19+1)))(2,av2);}}
else{
t15=C_eqp(t9,lf[1422]);
if(C_truep(t15)){
t16=C_slot(t2,C_fix(1));
t17=C_block_size(t16);
t18=C_i_check_range_2(t3,C_fix(0),t17,t5);
t19=t1;{
C_word *av2=av;
av2[0]=t19;
av2[1]=C_a_i_make_locative(&a,4,C_fix(7),t16,t3,t4);
((C_proc)(void*)(*((C_word*)t19+1)))(2,av2);}}
else{
t16=C_eqp(t9,lf[1423]);
if(C_truep(t16)){
t17=C_slot(t2,C_fix(1));
t18=C_block_size(t17);
t19=C_i_check_range_2(t3,C_fix(0),t18,t5);
t20=C_a_i_make_locative(&a,4,C_fix(8),t17,t3,t4);
t21=t1;{
C_word *av2=av;
av2[0]=t21;
av2[1]=t20;
((C_proc)(void*)(*((C_word*)t21+1)))(2,av2);}}
else{
t17=C_eqp(t9,lf[1424]);
if(C_truep(t17)){
t18=C_slot(t2,C_fix(1));
t19=C_block_size(t18);
t20=C_i_check_range_2(t3,C_fix(0),t19,t5);
t21=t1;{
C_word *av2=av;
av2[0]=t21;
av2[1]=C_a_i_make_locative(&a,4,C_fix(9),t18,t3,t4);
((C_proc)(void*)(*((C_word*)t21+1)))(2,av2);}}
else{
t18=C_eqp(t9,lf[1425]);
if(C_truep(t18)){
t19=C_slot(t2,C_fix(1));
t20=C_block_size(t19);
t21=C_i_check_range_2(t3,C_fix(0),t20,t5);
t22=C_a_i_make_locative(&a,4,C_fix(10),t19,t3,t4);
t23=t1;{
C_word *av2=av;
av2[0]=t23;
av2[1]=t22;
((C_proc)(void*)(*((C_word*)t23+1)))(2,av2);}}
else{
t19=C_eqp(t9,lf[1426]);
if(C_truep(t19)){
t20=C_slot(t2,C_fix(1));
t21=C_block_size(t20);
t22=C_i_check_range_2(t3,C_fix(0),t21,t5);
t23=t1;{
C_word *av2=av;
av2[0]=t23;
av2[1]=C_a_i_make_locative(&a,4,C_fix(11),t20,t3,t4);
((C_proc)(void*)(*((C_word*)t23+1)))(2,av2);}}
else{
t20=C_block_size(t2);
t21=C_fixnum_difference(t20,C_fix(1));
t22=C_i_check_range_2(t3,C_fix(0),t21,t5);
t23=C_fixnum_plus(t3,C_fix(1));
t24=t1;{
C_word *av2=av;
av2[0]=t24;
av2[1]=C_a_i_make_locative(&a,4,C_fix(0),t2,t23,t4);
((C_proc)(void*)(*((C_word*)t24+1)))(2,av2);}}}}}}}}}}}}
else{
if(C_truep(C_i_stringp(t2))){
t9=C_slot(t2,C_fix(0));
t10=C_utf_position(t2,t3);
t11=C_slot(t2,C_fix(1));
t12=C_i_check_range_2(t3,C_fix(0),t11,t5);
t13=C_a_i_make_locative(&a,4,C_fix(1),t9,t10,t4);
t14=t1;{
C_word *av2=av;
av2[0]=t14;
av2[1]=t13;
((C_proc)(void*)(*((C_word*)t14+1)))(2,av2);}}
else{
/* library.scm:7302: ##sys#signal-hook */
t9=*((C_word*)lf[235]+1);{
C_word *av2=av;
av2[0]=t9;
av2[1]=t1;
av2[2]=lf[295];
av2[3]=t5;
av2[4]=lf[1427];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t9+1)))(6,av2);}}}}}}}

/* chicken.plist#put! in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36662(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,1)))){
C_save_and_reclaim((void *)f_36662,c,av);}
a=C_alloc(8);
t5=C_i_check_symbol_2(t2,lf[1430]);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_a_i_putprop(&a,3,t2,t3,t4);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* chicken.plist#get in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36668(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_36668,c,av);}
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,4,t0));
t6=C_i_check_symbol_2(t2,lf[1432]);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_i_getprop(t2,t3,t5);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in ... */
static void C_ccall f_36687(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,4)))){
C_save_and_reclaim((void *)f_36687,c,av);}
a=C_alloc(12);
t2=C_mutate((C_word*)lf[1431]+1 /* (set! chicken.plist#get ...) */,t1);
t3=C_mutate((C_word*)lf[1435]+1 /* (set! chicken.plist#remprop! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36689,a[2]=((C_word)li1089),tmp=(C_word)a,a+=3,tmp));
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36758,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40781,a[2]=((C_word)li1217),tmp=(C_word)a,a+=3,tmp);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40790,a[2]=((C_word)li1218),tmp=(C_word)a,a+=3,tmp);
/* library.scm:7348: chicken.base#getter-with-setter */
t7=*((C_word*)lf[240]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t7;
av2[1]=t4;
av2[2]=t5;
av2[3]=t6;
av2[4]=lf[1590];
((C_proc)(void*)(*((C_word*)t7+1)))(5,av2);}}

/* chicken.plist#remprop! in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_36689(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_36689,c,av);}
a=C_alloc(5);
t4=C_i_check_symbol_2(t2,lf[1436]);
t5=C_slot(t2,C_fix(2));
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36712,a[2]=t3,a[3]=t2,a[4]=((C_word)li1088),tmp=(C_word)a,a+=5,tmp);
t7=(
  f_36712(t6,t5,C_SCHEME_FALSE)
);
t8=C_slot(t2,C_fix(2));
if(C_truep(C_i_nullp(t8))){
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=C_i_unpersist_symbol(t2);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}
else{
t9=C_SCHEME_UNDEFINED;
t10=t1;{
C_word *av2=av;
av2[0]=t10;
av2[1]=t9;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}}

/* loop in chicken.plist#remprop! in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static C_word f_36712(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_stack_overflow_check;
loop:{}
t3=C_i_nullp(t1);
if(C_truep(C_i_not(t3))){
t4=C_slot(t1,C_fix(1));
t5=C_slot(t4,C_fix(1));
t6=C_slot(t1,C_fix(0));
t7=C_eqp(t6,((C_word*)t0)[2]);
if(C_truep(t7)){
t8=(C_truep(t2)?C_i_setslot(t2,C_fix(1),t5):C_i_setslot(((C_word*)t0)[3],C_fix(2),t5));
return(C_SCHEME_TRUE);}
else{
t10=t5;
t11=t4;
t1=t10;
t2=t11;
goto loop;}}
else{
return(C_SCHEME_FALSE);}}

/* k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_36758(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,4)))){
C_save_and_reclaim((void *)f_36758,c,av);}
a=C_alloc(29);
t2=C_mutate((C_word*)lf[1437]+1 /* (set! chicken.plist#symbol-plist ...) */,t1);
t3=C_mutate((C_word*)lf[1438]+1 /* (set! chicken.plist#get-properties ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36760,a[2]=((C_word)li1091),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[1440]+1 /* (set! ##sys#display-times ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36823,a[2]=((C_word)li1095),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[1097]+1 /* (set! ##sys#dump-heap-state ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_dump_heap_state,a[2]=((C_word)li1096),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[1456]+1 /* (set! ##sys#filter-heap-objects ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_filter_heap_objects,a[2]=((C_word)li1097),tmp=(C_word)a,a+=3,tmp));
t7=C_a_i_provide(&a,1,lf[1457]);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37059,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_software_type,a[2]=((C_word)li1216),tmp=(C_word)a,a+=3,tmp);
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40779,a[2]=t8,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7454: g8559 */
t11=t9;{
C_word *av2=av;
av2[0]=t11;
av2[1]=t10;
((C_proc)C_fast_retrieve_proc(t11))(2,av2);}}

/* chicken.plist#get-properties in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36760(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_36760,c,av);}
a=C_alloc(10);
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_i_check_symbol_2(t2,lf[1439]);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36767,a[2]=t4,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_symbolp(((C_word*)t4)[1]))){
t7=C_a_i_list1(&a,1,((C_word*)t4)[1]);
t8=C_set_block_item(t4,0,t7);
t9=t6;
f_36767(t9,t8);}
else{
t7=t6;
f_36767(t7,C_SCHEME_UNDEFINED);}}

/* k36765 in chicken.plist#get-properties in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void f_36767(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_36767,2,t0,t1);}
a=C_alloc(7);
t2=C_i_check_list_2(((C_word*)((C_word*)t0)[2])[1],lf[1439]);
t3=C_slot(((C_word*)t0)[3],C_fix(2));
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36779,a[2]=((C_word*)t0)[2],a[3]=t5,a[4]=((C_word)li1090),tmp=(C_word)a,a+=5,tmp));
t7=((C_word*)t5)[1];
f_36779(t7,((C_word*)t0)[4],t3);}

/* loop in k36765 in chicken.plist#get-properties in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void f_36779(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(0,0,4)))){
C_save_and_reclaim_args((void *)trf_36779,3,t0,t1,t2);}
if(C_truep(C_i_nullp(t2))){
/* library.scm:7372: scheme#values */{
C_word av2[5];
av2[0]=0;
av2[1]=t1;
av2[2]=C_SCHEME_FALSE;
av2[3]=C_SCHEME_FALSE;
av2[4]=C_SCHEME_FALSE;
C_values(5,av2);}}
else{
t3=C_slot(t2,C_fix(0));
t4=C_slot(t2,C_fix(1));
t5=C_slot(t4,C_fix(1));
if(C_truep(C_i_memq(t3,((C_word*)((C_word*)t0)[2])[1]))){
/* library.scm:7377: scheme#values */{
C_word av2[5];
av2[0]=0;
av2[1]=t1;
av2[2]=t3;
av2[3]=C_slot(t4,C_fix(0));
av2[4]=t5;
C_values(5,av2);}}
else{
/* library.scm:7378: loop */
t7=t1;
t8=t5;
t1=t7;
t2=t8;
goto loop;}}}

/* ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_36823(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(23,c,4)))){
C_save_and_reclaim((void *)f_36823,c,av);}
a=C_alloc(23);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36838,a[2]=((C_word)li1092),tmp=(C_word)a,a+=3,tmp));
t10=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36852,a[2]=((C_word)li1093),tmp=(C_word)a,a+=3,tmp));
t11=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36874,a[2]=t4,a[3]=t6,a[4]=((C_word)li1094),tmp=(C_word)a,a+=5,tmp));
t12=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_36950,a[2]=t2,a[3]=t1,a[4]=t8,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7400: ##sys#flush-output */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[885]);
C_word *av2=av;
av2[0]=*((C_word*)lf[885]+1);
av2[1]=t12;
av2[2]=*((C_word*)lf[839]+1);
tp(3,av2);}}

/* pnum in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void f_36838(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,0,4)))){
C_save_and_reclaim_args((void *)trf_36838,2,t1,t2);}
a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36846,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_zerop(t2))){
/* library.scm:7389: ##sys#print */
t4=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t4;
av2[1]=t1;
av2[2]=lf[1441];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}
else{
/* library.scm:7389: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}}

/* k36844 in pnum in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36846(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_36846,c,av);}
/* library.scm:7389: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* round-to in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void f_36852(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_36852,3,t1,t2,t3);}
a=C_alloc(8);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36860,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36872,a[2]=t2,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7391: scheme#expt */
t6=*((C_word*)lf[634]+1);{
C_word av2[4];
av2[0]=t6;
av2[1]=t5;
av2[2]=C_fix(10);
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k36858 in round-to in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36860(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_36860,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36864,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7391: scheme#expt */
t3=*((C_word*)lf[634]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1442];
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k36862 in k36858 in round-to in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_36864(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_36864,c,av);}
/* ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[630]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k36870 in round-to in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36872(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,2)))){
C_save_and_reclaim((void *)f_36872,c,av);}
a=C_alloc(33);
t2=C_s_a_i_times(&a,2,((C_word*)t0)[2],t1);
/* library.scm:7391: scheme#round */
t3=*((C_word*)lf[652]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void f_36874(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,3)))){
C_save_and_reclaim_args((void *)trf_36874,3,t0,t1,t2);}
a=C_alloc(11);
if(C_truep(C_i_greaterp(t2,lf[1443]))){
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36884,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36891,a[2]=((C_word*)t0)[2],a[3]=t3,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36895,a[2]=((C_word*)t0)[3],a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t5;
av2[2]=t2;
av2[3]=lf[1443];
tp(4,av2);}}
else{
if(C_truep(C_i_greaterp(t2,C_fix(1048576)))){
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36906,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36913,a[2]=((C_word*)t0)[2],a[3]=t3,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36917,a[2]=((C_word*)t0)[3],a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t5;
av2[2]=t2;
av2[3]=C_fix(1048576);
tp(4,av2);}}
else{
if(C_truep(C_i_greaterp(t2,C_fix(1024)))){
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36928,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36935,a[2]=((C_word*)t0)[2],a[3]=t3,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_36939,a[2]=((C_word*)t0)[3],a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* ##sys#/-2 */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[630]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[630]+1);
av2[1]=t5;
av2[2]=t2;
av2[3]=C_fix(1024);
tp(4,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36944,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7399: pnum */
f_36838(t3,t2);}}}}

/* k36882 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36884(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_36884,c,av);}
/* library.scm:7386: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1444];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k36889 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36891(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36891,c,av);}
/* library.scm:7394: pnum */
f_36838(((C_word*)t0)[3],t1);}

/* k36893 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36895(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_36895,c,av);}
/* library.scm:7394: round-to */
f_36852(((C_word*)t0)[3],t1,C_fix(2));}

/* k36904 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36906(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_36906,c,av);}
/* library.scm:7386: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1445];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k36911 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36913(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36913,c,av);}
/* library.scm:7396: pnum */
f_36838(((C_word*)t0)[3],t1);}

/* k36915 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36917(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_36917,c,av);}
/* library.scm:7396: round-to */
f_36852(((C_word*)t0)[3],t1,C_fix(2));}

/* k36926 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36928(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_36928,c,av);}
/* library.scm:7386: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1446];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k36933 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36935(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36935,c,av);}
/* library.scm:7398: pnum */
f_36838(((C_word*)t0)[3],t1);}

/* k36937 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36939(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_36939,c,av);}
/* library.scm:7398: round-to */
f_36852(((C_word*)t0)[3],t1,C_fix(2));}

/* k36942 in pmem in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36944(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_36944,c,av);}
/* library.scm:7386: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1447];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_36950(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_36950,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_36953,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7401: pnum */
f_36838(t2,C_slot(((C_word*)t0)[2],C_fix(0)));}

/* k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_36953(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_36953,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_36956,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7386: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1455];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_36956(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,4)))){
C_save_and_reclaim((void *)f_36956,c,av);}
a=C_alloc(11);
t2=C_slot(((C_word*)t0)[2],C_fix(1));
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_36962,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_i_greaterp(t2,C_fix(0)))){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37043,a[2]=t3,a[3]=((C_word*)t0)[5],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7386: ##sys#print */
t5=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=lf[1454];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}
else{
t4=t3;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
f_36962(2,av2);}}}

/* k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void C_ccall f_36962(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,4)))){
C_save_and_reclaim((void *)f_36962,c,av);}
a=C_alloc(12);
t2=C_slot(((C_word*)t0)[2],C_fix(2));
t3=C_slot(((C_word*)t0)[2],C_fix(3));
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_36971,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_fixnum_greaterp(t2,C_fix(0)))){
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37025,a[2]=t4,a[3]=((C_word*)t0)[5],a[4]=t3,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7386: ##sys#print */
t6=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[1452];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}
else{
t5=t4;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_UNDEFINED;
f_36971(2,av2);}}}

/* k36969 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in ... */
static void C_ccall f_36971(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,4)))){
C_save_and_reclaim((void *)f_36971,c,av);}
a=C_alloc(11);
t2=C_slot(((C_word*)t0)[2],C_fix(4));
t3=C_slot(((C_word*)t0)[2],C_fix(5));
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36980,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t5=C_fixnum_greaterp(t2,C_fix(0));
t6=(C_truep(t5)?t5:C_fixnum_greaterp(t3,C_fix(0)));
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37004,a[2]=t4,a[3]=((C_word*)t0)[5],a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7386: ##sys#print */
t8=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t8;
av2[1]=t7;
av2[2]=lf[1450];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t8+1)))(5,av2);}}
else{
t7=t4;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_SCHEME_UNDEFINED;
f_36980(2,av2);}}}

/* k36978 in k36969 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_36980(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_36980,c,av);}
a=C_alloc(5);
t2=C_slot(((C_word*)t0)[2],C_fix(6));
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_36986,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7386: ##sys#print */
t4=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1448];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}

/* k36984 in k36978 in k36969 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_36986(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_36986,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36989,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7426: pmem */
t3=((C_word*)((C_word*)t0)[3])[1];
f_36874(t3,t2,((C_word*)t0)[4]);}

/* k36987 in k36984 in k36978 in k36969 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_36989(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_36989,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_36992,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7427: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t2;
av2[2]=C_make_character(10);
av2[3]=*((C_word*)lf[840]+1);
tp(4,av2);}}

/* k36990 in k36987 in k36984 in k36978 in k36969 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in ... */
static void C_ccall f_36992(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_36992,c,av);}
/* library.scm:7428: ##sys#flush-output */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[885]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[885]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[840]+1);
tp(3,av2);}}

/* k37002 in k36969 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_37004(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_37004,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37007,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:7420: pnum */
f_36838(t2,((C_word*)t0)[5]);}

/* k37005 in k37002 in k36969 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_37007(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_37007,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37010,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:7387: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t2;
av2[2]=C_make_character(47);
av2[3]=*((C_word*)lf[840]+1);
tp(4,av2);}}

/* k37008 in k37005 in k37002 in k36969 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_37010(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37010,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37013,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7422: pnum */
f_36838(t2,((C_word*)t0)[4]);}

/* k37011 in k37008 in k37005 in k37002 in k36969 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in ... */
static void C_ccall f_37013(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_37013,c,av);}
/* library.scm:7386: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1449];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k37023 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in ... */
static void C_ccall f_37025(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_37025,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37028,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:7412: pnum */
f_36838(t2,((C_word*)t0)[5]);}

/* k37026 in k37023 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_37028(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_37028,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37031,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:7387: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=t2;
av2[2]=C_make_character(47);
av2[3]=*((C_word*)lf[840]+1);
tp(4,av2);}}

/* k37029 in k37026 in k37023 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_37031(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37031,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37034,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7414: pnum */
f_36838(t2,((C_word*)t0)[4]);}

/* k37032 in k37029 in k37026 in k37023 in k36960 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_37034(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_37034,c,av);}
/* library.scm:7386: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1451];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k37041 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void C_ccall f_37043(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37043,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37046,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7406: pnum */
f_36838(t2,((C_word*)t0)[4]);}

/* k37044 in k37041 in k36954 in k36951 in k36948 in ##sys#display-times in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in ... */
static void C_ccall f_37046(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_37046,c,av);}
/* library.scm:7386: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1453];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_37059(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,2)))){
C_save_and_reclaim((void *)f_37059,c,av);}
a=C_alloc(13);
t2=C_mutate((C_word*)lf[1458]+1 /* (set! chicken.platform#software-type ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37060,a[2]=t1,a[3]=((C_word)li1098),tmp=(C_word)a,a+=4,tmp));
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37065,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_machine_type,a[2]=((C_word)li1215),tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40775,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7458: g8563 */
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)C_fast_retrieve_proc(t6))(2,av2);}}

/* chicken.platform#software-type in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_37060(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_37060,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_37065(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,2)))){
C_save_and_reclaim((void *)f_37065,c,av);}
a=C_alloc(13);
t2=C_mutate((C_word*)lf[1459]+1 /* (set! chicken.platform#machine-type ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37066,a[2]=t1,a[3]=((C_word)li1099),tmp=(C_word)a,a+=4,tmp));
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37071,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_machine_byte_order,a[2]=((C_word)li1214),tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40771,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7462: g8567 */
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)C_fast_retrieve_proc(t6))(2,av2);}}

/* chicken.platform#machine-type in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_37066(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_37066,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_37071(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,2)))){
C_save_and_reclaim((void *)f_37071,c,av);}
a=C_alloc(13);
t2=C_mutate((C_word*)lf[1460]+1 /* (set! chicken.platform#machine-byte-order ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37072,a[2]=t1,a[3]=((C_word)li1100),tmp=(C_word)a,a+=4,tmp));
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37077,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_software_version,a[2]=((C_word)li1213),tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40767,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7466: g8571 */
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)C_fast_retrieve_proc(t6))(2,av2);}}

/* chicken.platform#machine-byte-order in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_37072(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_37072,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_37077(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,2)))){
C_save_and_reclaim((void *)f_37077,c,av);}
a=C_alloc(13);
t2=C_mutate((C_word*)lf[1461]+1 /* (set! chicken.platform#software-version ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37078,a[2]=t1,a[3]=((C_word)li1101),tmp=(C_word)a,a+=4,tmp));
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37083,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_build_platform,a[2]=((C_word)li1212),tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40763,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7470: g8575 */
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)C_fast_retrieve_proc(t6))(2,av2);}}

/* chicken.platform#software-version in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void C_ccall f_37078(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_37078,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void C_ccall f_37083(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_37083,c,av);}
a=C_alloc(10);
t2=C_mutate((C_word*)lf[1462]+1 /* (set! chicken.platform#build-platform ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37084,a[2]=t1,a[3]=((C_word)li1102),tmp=(C_word)a,a+=4,tmp));
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37089,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40759,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7474: software-type */
t5=C_fast_retrieve(lf[1458]);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* chicken.platform#build-platform in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in ... */
static void C_ccall f_37084(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_37084,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in ... */
static void f_37089(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(24,0,3)))){
C_save_and_reclaim_args((void *)trf_37089,2,t0,t1);}
a=C_alloc(24);
t2=C_set_block_item(lf[1463] /* ##sys#windows-platform */,0,t1);
t3=C_mutate((C_word*)lf[1464]+1 /* (set! chicken.platform#chicken-version ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37091,a[2]=((C_word)li1104),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[1497]+1 /* (set! chicken.platform#chicken-home ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37226,a[2]=((C_word)li1105),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[1498]+1 /* (set! chicken.platform#include-path ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37232,a[2]=((C_word)li1106),tmp=(C_word)a,a+=3,tmp));
t6=(C_truep(C_fast_retrieve(lf[1463]))?C_make_character(59):C_make_character(58));
t7=lf[1502] /* chicken.platform#path-list-separator */ =t6;;
t8=lf[1503];
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_mutate((C_word*)lf[1504]+1 /* (set! ##sys#split-path ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37255,a[2]=t9,a[3]=((C_word)li1108),tmp=(C_word)a,a+=4,tmp));
t11=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37345,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t12=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40677,a[2]=t11,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t13=*((C_word*)lf[829]+1);{
C_word av2[4];
av2[0]=t13;
av2[1]=t12;
av2[2]=C_mpointer(&a,(void*)C_private_repository_path());
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t13+1)))(4,av2);}}

/* chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_37091(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_37091,c,av);}
a=C_alloc(6);
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?C_SCHEME_FALSE:C_get_rest_arg(c,2,av,2,t0));
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37152,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37189,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
t6=C_fix((C_word)C_WORD_SIZE);
/* ##sys#fixnum->string */
t7=*((C_word*)lf[726]+1);{
C_word av2[4];
av2[0]=t7;
av2[1]=t5;
av2[2]=t6;
av2[3]=C_fix(10);
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}
else{
t4=C_fast_retrieve(lf[1466]);
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_fast_retrieve(lf[1466]);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in ... */
static void C_ccall f_37101(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_37101,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37104,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7481: software-type */
t3=C_fast_retrieve(lf[1458]);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k37102 in k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in ... */
static void C_ccall f_37104(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_37104,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37107,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7482: software-version */
t3=C_fast_retrieve(lf[1461]);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k37105 in k37102 in k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in ... */
static void C_ccall f_37107(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_37107,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37110,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7483: machine-type */
t3=C_fast_retrieve(lf[1459]);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k37108 in k37105 in k37102 in k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in ... */
static void C_ccall f_37110(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_37110,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37112,a[2]=((C_word)li1103),tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_37134,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],tmp=(C_word)a,a+=7,tmp);
/* library.scm:7488: str */
f_37112(t3,((C_word*)t0)[5]);}

/* str in k37108 in k37105 in k37102 in k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in ... */
static void f_37112(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_37112,2,t1,t2);}
a=C_alloc(3);
t3=C_eqp(lf[1471],t2);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=lf[1472];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37126,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7487: scheme#symbol->string */
t5=*((C_word*)lf[740]+1);{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}}

/* k37124 in str in k37108 in k37105 in k37102 in k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in ... */
static void C_ccall f_37126(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_37126,c,av);}
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=lf[1473];
tp(4,av2);}}

/* k37132 in k37108 in k37105 in k37102 in k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in ... */
static void C_ccall f_37134(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_37134,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_37138,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* library.scm:7488: str */
f_37112(t2,((C_word*)t0)[6]);}

/* k37136 in k37132 in k37108 in k37105 in k37102 in k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in ... */
static void C_ccall f_37138(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_37138,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37142,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7488: str */
f_37112(t2,((C_word*)t0)[6]);}

/* k37140 in k37136 in k37132 in k37108 in k37105 in k37102 in k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in ... */
static void C_ccall f_37142(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_37142,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37146,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7488: ##sys#symbol->string/shared */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[737]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[737]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}

/* k37144 in k37140 in k37136 in k37132 in k37108 in k37105 in k37102 in k37099 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in ... */
static void C_ccall f_37146(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_37146,c,av);}
/* library.scm:7488: scheme#string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
av2[4]=((C_word*)t0)[5];
av2[5]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_37152(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_37152,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37159,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_fast_retrieve(lf[1478]))){
/* library.scm:7498: scheme#string-append */
t3=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1479];
av2[3]=C_fast_retrieve(lf[1478]);
av2[4]=lf[1480];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=lf[1481];
f_37159(2,av2);}}}

/* k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_37159(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_37159,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37163,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fast_retrieve(lf[1474]))){
/* library.scm:7499: scheme#string-append */
t3=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1475];
av2[3]=C_fast_retrieve(lf[1474]);
av2[4]=lf[1476];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=lf[1477];
f_37163(2,av2);}}}

/* k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in ... */
static void C_ccall f_37163(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_37163,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37167,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37101,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7480: build-platform */
t4=C_fast_retrieve(lf[1462]);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k37165 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in ... */
static void C_ccall f_37167(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,8)))){
C_save_and_reclaim((void *)f_37167,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37171,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
t3=C_eqp(C_u_i_string_length(((C_word*)t0)[5]),C_fix(0));
if(C_truep(t3)){
/* library.scm:7496: scheme#string-append */
t4=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 9) {
  av2=av;
} else {
  av2=C_alloc(9);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1465];
av2[3]=C_fast_retrieve(lf[1466]);
av2[4]=((C_word*)t0)[3];
av2[5]=((C_word*)t0)[4];
av2[6]=lf[1467];
av2[7]=t1;
av2[8]=lf[1468];
((C_proc)(void*)(*((C_word*)t4+1)))(9,av2);}}
else{
/* library.scm:7504: scheme#string-append */
t4=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t2;
av2[2]=lf[1469];
av2[3]=((C_word*)t0)[5];
av2[4]=lf[1470];
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}}

/* k37169 in k37165 in k37161 in k37157 in k37150 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in ... */
static void C_ccall f_37171(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,8)))){
C_save_and_reclaim((void *)f_37171,c,av);}
/* library.scm:7496: scheme#string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 9) {
  av2=av;
} else {
  av2=C_alloc(9);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1465];
av2[3]=C_fast_retrieve(lf[1466]);
av2[4]=((C_word*)t0)[3];
av2[5]=((C_word*)t0)[4];
av2[6]=lf[1467];
av2[7]=((C_word*)t0)[5];
av2[8]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(9,av2);}}

/* k37187 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_37189(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_37189,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37217,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7492: feature? */
t3=C_fast_retrieve(lf[1492]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1496];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k37206 in k37209 in k37212 in k37215 in k37187 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in ... */
static void C_ccall f_37208(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,8)))){
C_save_and_reclaim((void *)f_37208,c,av);}
if(C_truep(t1)){
/* library.scm:7490: scheme#string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 9) {
  av2=av;
} else {
  av2=C_alloc(9);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1488];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1489];
av2[5]=((C_word*)t0)[4];
av2[6]=((C_word*)t0)[5];
av2[7]=((C_word*)t0)[6];
av2[8]=lf[1490];
((C_proc)(void*)(*((C_word*)t2+1)))(9,av2);}}
else{
/* library.scm:7490: scheme#string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 9) {
  av2=av;
} else {
  av2=C_alloc(9);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1488];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1489];
av2[5]=((C_word*)t0)[4];
av2[6]=((C_word*)t0)[5];
av2[7]=((C_word*)t0)[6];
av2[8]=lf[1491];
((C_proc)(void*)(*((C_word*)t2+1)))(9,av2);}}}

/* k37209 in k37212 in k37215 in k37187 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in ... */
static void C_ccall f_37211(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_37211,c,av);}
a=C_alloc(7);
t2=(C_truep(t1)?lf[1486]:lf[1487]);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_37208,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t2,tmp=(C_word)a,a+=7,tmp);
/* library.scm:7495: feature? */
t4=C_fast_retrieve(lf[1492]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1493];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k37212 in k37215 in k37187 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in ... */
static void C_ccall f_37214(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_37214,c,av);}
a=C_alloc(6);
t2=(C_truep(t1)?lf[1484]:lf[1485]);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37211,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7494: feature? */
t4=C_fast_retrieve(lf[1492]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1494];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k37215 in k37187 in chicken.platform#chicken-version in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_37217(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_37217,c,av);}
a=C_alloc(5);
t2=(C_truep(t1)?lf[1482]:lf[1483]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37214,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7493: feature? */
t4=C_fast_retrieve(lf[1492]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1495];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* chicken.platform#chicken-home in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_37226(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_37226,c,av);}
a=C_alloc(3);
/* ##sys#peek-c-string */
t2=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=C_mpointer(&a,(void*)C_INSTALL_SHARE_HOME);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* chicken.platform#include-path in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_37232(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_37232,c,av);}
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?C_SCHEME_FALSE:C_get_rest_arg(c,2,av,2,t0));
if(C_truep(t3)){
t4=C_i_check_list_2(t3,lf[1499]);
t5=C_mutate((C_word*)lf[1500]+1 /* (set! ##sys#include-pathnames ...) */,t3);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_fast_retrieve(lf[1501]);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_fast_retrieve(lf[1501]);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* ##sys#split-path in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_37255(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(13,c,4)))){
C_save_and_reclaim((void *)f_37255,c,av);}
a=C_alloc(13);
if(C_truep(C_i_not(t2))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_i_car(((C_word*)((C_word*)t0)[2])[1]);
if(C_truep(C_i_equalp(t2,t3))){
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_cdr(((C_word*)((C_word*)t0)[2])[1]);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=C_i_string_length(t2);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37277,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37283,a[2]=t4,a[3]=t2,a[4]=t7,a[5]=((C_word)li1107),tmp=(C_word)a,a+=6,tmp));
t9=((C_word*)t7)[1];
f_37283(t9,t5,C_fix(0),C_fix(0));}}}

/* k37275 in ##sys#split-path in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_37277(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_37277,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,((C_word*)t0)[2],t1);
t3=C_mutate(((C_word *)((C_word*)t0)[3])+1,t2);
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* loop in ##sys#split-path in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void f_37283(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,4)))){
C_save_and_reclaim_args((void *)trf_37283,4,t0,t1,t2,t3);}
a=C_alloc(5);
if(C_truep(C_fixnum_greater_or_equal_p(t3,((C_word*)t0)[2]))){
t4=C_eqp(t3,t2);
if(C_truep(t4)){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37303,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7537: scheme#substring */
t6=*((C_word*)lf[489]+1);{
C_word av2[5];
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
av2[3]=t2;
av2[4]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}}
else{
t4=C_i_string_ref(((C_word*)t0)[3],t3);
t5=C_retrieve2(lf[1502],C_text("chicken.platform#path-list-separator"));
if(C_truep(C_u_i_char_equalp(t4,C_retrieve2(lf[1502],C_text("chicken.platform#path-list-separator"))))){
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37318,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7540: scheme#substring */
t7=*((C_word*)lf[489]+1);{
C_word av2[5];
av2[0]=t7;
av2[1]=t6;
av2[2]=((C_word*)t0)[3];
av2[3]=t2;
av2[4]=t3;
((C_proc)(void*)(*((C_word*)t7+1)))(5,av2);}}
else{
/* library.scm:7544: loop */
t8=t1;
t9=t2;
t10=C_fixnum_plus(t3,C_fix(1));
t1=t8;
t2=t9;
t3=t10;
goto loop;}}}

/* k37301 in loop in ##sys#split-path in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_37303(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_37303,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_list1(&a,1,t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k37316 in loop in ##sys#split-path in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_37318(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_37318,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37322,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7541: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_37283(t3,t2,C_fixnum_plus(((C_word*)t0)[4],C_fix(1)),C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* k37320 in k37316 in loop in ##sys#split-path in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in ... */
static void C_ccall f_37322(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_37322,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_37345(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_37345,c,av);}
a=C_alloc(9);
t2=C_mutate((C_word*)lf[1505]+1 /* (set! chicken.platform#repository-path ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37349,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40661,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t5=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=C_mpointer(&a,(void*)C_private_repository_path());
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_37349(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_37349,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[1506]+1 /* (set! chicken.platform#installation-repository ...) */,t1);
t3=C_mutate(&lf[1507] /* (set! chicken.platform#chop-separator ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37351,a[2]=((C_word)li1109),tmp=(C_word)a,a+=3,tmp));
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37381,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7578: chicken.process-context#get-environment-variable */
t5=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=lf[1581];
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* chicken.platform#chop-separator in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_37351(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_37351,c,av);}
t3=C_i_string_length(t2);
t4=C_fixnum_difference(t3,C_fix(1));
if(C_truep(C_fixnum_greaterp(t4,C_fix(0)))){
t5=C_i_string_ref(t2,t4);
if(C_truep((C_truep(C_eqp(t5,C_make_character(92)))?C_SCHEME_TRUE:(C_truep(C_eqp(t5,C_make_character(47)))?C_SCHEME_TRUE:C_SCHEME_FALSE)))){
/* library.scm:7574: scheme#substring */
t6=*((C_word*)lf[489]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t6;
av2[1]=t1;
av2[2]=t2;
av2[3]=C_fix(0);
av2[4]=t4;
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}
else{
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}
else{
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_37381(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,3)))){
C_save_and_reclaim((void *)f_37381,c,av);}
a=C_alloc(13);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37384,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(t1)){
t3=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t4=t3;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=((C_word*)t5)[1];
t7=C_retrieve2(lf[1507],C_text("chicken.platform#chop-separator"));
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40607,a[2]=t5,a[3]=t6,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7580: ##sys#split-path */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1504]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[1504]+1);
av2[1]=t8;
av2[2]=t1;
tp(3,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40657,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t4=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=C_mpointer(&a,(void*)C_INSTALL_SHARE_HOME);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}}

/* k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in ... */
static void C_ccall f_37384(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,3)))){
C_save_and_reclaim((void *)f_37384,c,av);}
a=C_alloc(29);
t2=C_mutate((C_word*)lf[1500]+1 /* (set! ##sys#include-pathnames ...) */,t1);
t3=C_mutate((C_word*)lf[1498]+1 /* (set! chicken.platform#include-path ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37386,a[2]=((C_word)li1110),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate(&lf[1508] /* (set! chicken.platform#->feature-id ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37404,a[2]=((C_word)li1111),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,lf[1511]);
t6=C_a_i_cons(&a,2,lf[1512],C_fast_retrieve(lf[1510]));
t7=C_a_i_cons(&a,2,lf[1513],t6);
t8=C_a_i_cons(&a,2,lf[1514],t7);
t9=C_a_i_cons(&a,2,lf[1515],t8);
t10=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t9);
t11=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37442,a[2]=((C_word)li1112),tmp=(C_word)a,a+=3,tmp);
t12=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37460,a[2]=((C_word*)t0)[2],a[3]=t11,tmp=(C_word)a,a+=4,tmp);
t13=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40587,a[2]=t11,a[3]=t12,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7613: software-type */
t14=C_fast_retrieve(lf[1458]);{
C_word *av2=av;
av2[0]=t14;
av2[1]=t13;
((C_proc)(void*)(*((C_word*)t14+1)))(2,av2);}}

/* chicken.platform#include-path in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in ... */
static void C_ccall f_37386(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_37386,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_fast_retrieve(lf[1500]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.platform#->feature-id in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in ... */
static void C_ccall f_37404(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_37404,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37411,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7595: chicken.keyword#keyword? */
t4=*((C_word*)lf[753]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k37409 in chicken.platform#->feature-id in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in ... */
static void C_ccall f_37411(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_37411,c,av);}
a=C_alloc(3);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
if(C_truep(C_i_stringp(((C_word*)t0)[3]))){
/* library.scm:7596: chicken.keyword#string->keyword */
t2=*((C_word*)lf[754]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}
else{
if(C_truep(C_i_symbolp(((C_word*)t0)[3]))){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37433,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7597: ##sys#symbol->string/shared */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[737]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[737]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
t2=C_a_i_list(&a,1,((C_word*)t0)[3]);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[235]+1);
av2[3]=lf[295];
av2[4]=lf[1509];
av2[5]=t2;
C_apply(6,av2);}}}}}

/* k37431 in k37409 in chicken.platform#->feature-id in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in ... */
static void C_ccall f_37433(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_37433,c,av);}
/* library.scm:7597: chicken.keyword#string->keyword */
t2=*((C_word*)lf[754]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* check in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in ... */
static void f_37442(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_37442,2,t1,t2);}
a=C_alloc(3);
t3=C_eqp(lf[1471],t2);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37457,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7612: ->feature-id */
t5=C_retrieve2(lf[1508],C_text("chicken.platform#->feature-id"));{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
f_37404(3,av2);}}}

/* k37455 in check in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in ... */
static void C_ccall f_37457(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_37457,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_fast_retrieve(lf[1510]));
t3=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t2);
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in ... */
static void C_ccall f_37460(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_37460,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37463,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40583,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7614: software-version */
t4=C_fast_retrieve(lf[1461]);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in ... */
static void C_ccall f_37463(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_37463,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37466,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40579,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7615: build-platform */
t4=C_fast_retrieve(lf[1462]);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in ... */
static void C_ccall f_37466(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_37466,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37469,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40575,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7616: machine-type */
t4=C_fast_retrieve(lf[1459]);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in ... */
static void C_ccall f_37469(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_37469,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37472,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40571,a[2]=((C_word*)t0)[3],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7617: machine-byte-order */
t4=C_fast_retrieve(lf[1460]);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in ... */
static void C_ccall f_37472(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_37472,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37475,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_mk_bool(HAVE_DLOAD))){
t3=C_a_i_cons(&a,2,lf[1496],C_fast_retrieve(lf[1510]));
t4=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t3);
t5=t2;
f_37475(t5,t4);}
else{
t3=t2;
f_37475(t3,C_SCHEME_UNDEFINED);}}

/* k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in ... */
static void f_37475(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_37475,2,t0,t1);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37478,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_mk_bool(HAVE_PTABLES))){
t3=C_a_i_cons(&a,2,lf[1495],C_fast_retrieve(lf[1510]));
t4=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t3);
t5=t2;
f_37478(t5,t4);}
else{
t3=t2;
f_37478(t3,C_SCHEME_UNDEFINED);}}

/* k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in ... */
static void f_37478(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_37478,2,t0,t1);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37481,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_mk_bool(HAVE_GCHOOKS))){
t3=C_a_i_cons(&a,2,lf[1494],C_fast_retrieve(lf[1510]));
t4=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t3);
t5=t2;
f_37481(t5,t4);}
else{
t3=t2;
f_37481(t3,C_SCHEME_UNDEFINED);}}

/* k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in ... */
static void f_37481(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_37481,2,t0,t1);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37484,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_mk_bool(IS_CROSS_CHICKEN))){
t3=C_a_i_cons(&a,2,lf[1493],C_fast_retrieve(lf[1510]));
t4=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t3);
t5=t2;
f_37484(t5,t4);}
else{
t3=t2;
f_37484(t3,C_SCHEME_UNDEFINED);}}

/* k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in ... */
static void f_37484(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,3)))){
C_save_and_reclaim_args((void *)trf_37484,2,t0,t1);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40541,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40545,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40549,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
t5=C_fix((C_word)C_WORD_SIZE);
/* ##sys#fixnum->string */
t6=*((C_word*)lf[726]+1);{
C_word av2[4];
av2[0]=t6;
av2[1]=t4;
av2[2]=t5;
av2[3]=C_fix(10);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in ... */
static void C_ccall f_37492(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_37492,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37495,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_fix((C_word)C_MINOR_VERSION);
/* library.scm:7638: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t2;
av2[2]=t3;
tp(3,av2);}}

/* k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in ... */
static void C_ccall f_37495(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_37495,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40519,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40535,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7639: scheme#string-append */
t4=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1579];
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* chicken.platform#register-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37500(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +9,c,3)))){
C_save_and_reclaim((void*)f_37500,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+9);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37519,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37521,a[2]=t5,a[3]=((C_word)li1113),tmp=(C_word)a,a+=4,tmp));
t7=((C_word*)t5)[1];
f_37521(t7,t3,t2);}

/* k37504 in for-each-loop8750 in chicken.platform#register-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37506(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37506,c,av);}
a=C_alloc(3);
if(C_truep(C_i_memq(t1,C_fast_retrieve(lf[1510])))){
t2=((C_word*)((C_word*)t0)[2])[1];
f_37521(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}
else{
t2=C_a_i_cons(&a,2,t1,C_fast_retrieve(lf[1510]));
t3=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t2);
t4=((C_word*)((C_word*)t0)[2])[1];
f_37521(t4,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}}

/* k37517 in chicken.platform#register-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_37519(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_37519,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* for-each-loop8750 in chicken.platform#register-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_37521(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_37521,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37506,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7646: ->feature-id */
t5=C_retrieve2(lf[1508],C_text("chicken.platform#->feature-id"));{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=t3;
f_37404(3,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* chicken.platform#unregister-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37544(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +16,c,3)))){
C_save_and_reclaim((void*)f_37544,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+16);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
t3=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t4=t3;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=((C_word*)t5)[1];
t7=C_retrieve2(lf[1508],C_text("chicken.platform#->feature-id"));
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37551,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37588,a[2]=t5,a[3]=t10,a[4]=t6,a[5]=((C_word)li1116),tmp=(C_word)a,a+=6,tmp));
t12=((C_word*)t10)[1];
f_37588(t12,t8,t2);}

/* k37549 in chicken.platform#unregister-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_37551(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_37551,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37555,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37557,a[2]=t1,a[3]=t4,a[4]=((C_word)li1115),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];
f_37557(t6,t2,C_fast_retrieve(lf[1510]));}

/* k37553 in k37549 in chicken.platform#unregister-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37555(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_37555,c,av);}
t2=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* loop in k37549 in chicken.platform#unregister-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_37557(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_37557,3,t0,t1,t2);}
a=C_alloc(4);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_slot(t2,C_fix(0));
t4=C_slot(t2,C_fix(1));
if(C_truep(C_i_memq(t3,((C_word*)t0)[2]))){
/* library.scm:7660: loop */
t7=t1;
t8=t4;
t1=t7;
t2=t8;
goto loop;}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37586,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7661: loop */
t7=t5;
t8=t4;
t1=t7;
t2=t8;
goto loop;}}}

/* k37584 in loop in k37549 in chicken.platform#unregister-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_37586(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_37586,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* map-loop8773 in chicken.platform#unregister-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_37588(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_37588,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37613,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7652: g8779 */
t4=C_retrieve2(lf[1508],C_text("chicken.platform#->feature-id"));{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=C_slot(t2,C_fix(0));
f_37404(3,av2);}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k37611 in map-loop8773 in chicken.platform#unregister-feature! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37613(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37613,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_SCHEME_END_OF_LIST);
t3=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t2);
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
t5=((C_word*)((C_word*)t0)[3])[1];
f_37588(t5,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}

/* chicken.platform#feature? in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37622(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +6,c,3)))){
C_save_and_reclaim((void*)f_37622,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+6);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37628,a[2]=t4,a[3]=((C_word)li1118),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_37628(t6,t1,t2);}

/* loop in chicken.platform#feature? in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_37628(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_37628,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_i_nullp(t2);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37652,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7667: ->feature-id */
t5=C_retrieve2(lf[1508],C_text("chicken.platform#->feature-id"));{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=C_slot(t2,C_fix(0));
f_37404(3,av2);}}}

/* k37650 in loop in chicken.platform#feature? in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37652(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_37652,c,av);}
if(C_truep(C_i_memq(t1,C_fast_retrieve(lf[1510])))){
/* library.scm:7668: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_37628(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* chicken.platform#system-config-directory in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37659(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37659,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37663,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7674: chicken.process-context#get-environment-variable */
t3=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1523];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k37661 in chicken.platform#system-config-directory in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_37663(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37663,c,av);}
a=C_alloc(3);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
if(C_truep(C_fast_retrieve(lf[1463]))){
/* library.scm:7676: chicken.process-context#get-environment-variable */
t2=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1520];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37675,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7677: chicken.process-context#get-environment-variable */
t3=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1522];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}}}

/* k37673 in k37661 in chicken.platform#system-config-directory in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37675(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_37675,c,av);}
if(C_truep(t1)){
/* library.scm:7678: scheme#string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=lf[1521];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* chicken.platform#system-cache-directory in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37683(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37683,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37687,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7681: chicken.process-context#get-environment-variable */
t3=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1529];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k37685 in chicken.platform#system-cache-directory in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_37687(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37687,c,av);}
a=C_alloc(3);
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
if(C_truep(C_fast_retrieve(lf[1463]))){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37696,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7683: chicken.process-context#get-environment-variable */
t3=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1526];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37705,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7685: chicken.process-context#get-environment-variable */
t3=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1528];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}}}

/* k37694 in k37685 in chicken.platform#system-cache-directory in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37696(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_37696,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* library.scm:7684: chicken.process-context#get-environment-variable */
t2=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1525];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}}

/* k37703 in k37685 in chicken.platform#system-cache-directory in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37705(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_37705,c,av);}
if(C_truep(t1)){
/* library.scm:7686: scheme#string-append */
t2=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=lf[1527];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* scheme#features in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37713(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(13,c,3)))){
C_save_and_reclaim((void *)f_37713,c,av);}
a=C_alloc(13);
t2=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=((C_word*)t4)[1];
t6=C_fast_retrieve(lf[1510]);
t7=C_i_check_list_2(t6,lf[822]);
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37734,a[2]=t4,a[3]=t9,a[4]=t5,a[5]=((C_word)li1123),tmp=(C_word)a,a+=6,tmp));
t11=((C_word*)t9)[1];
f_37734(t11,t1,t6);}

/* k37724 in map-loop8865 in scheme#features in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37726(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_37726,c,av);}
/* library.scm:7693: ##sys#string->symbol */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[739]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[739]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}

/* map-loop8865 in scheme#features in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_37734(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,2)))){
C_save_and_reclaim_args((void *)trf_37734,3,t0,t1,t2);}
a=C_alloc(9);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37759,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
t4=C_slot(t2,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37726,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7693: ##sys#symbol->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[738]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[738]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k37757 in map-loop8865 in scheme#features in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37759(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_37759,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_SCHEME_END_OF_LIST);
t3=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t2);
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
t5=((C_word*)((C_word*)t0)[3])[1];
f_37734(t5,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}

/* scheme#make-list in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37768(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_37768,c,av);}
a=C_alloc(5);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37775,a[2]=t4,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7698: ##sys#check-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[422]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[422]+1);
av2[1]=t5;
av2[2]=t2;
av2[3]=lf[1530];
tp(4,av2);}}

/* k37773 in scheme#make-list in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_37775(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_37775,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37778,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)t0)[4],C_fix(0)))){
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_37778(2,av2);}}
else{
/* library.scm:7700: chicken.base#error */
t3=*((C_word*)lf[234]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1530];
av2[3]=lf[1531];
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}}

/* k37776 in k37773 in scheme#make-list in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37778(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_37778,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37783,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word)li1125),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_37783(t5,((C_word*)t0)[3],((C_word*)t0)[4],C_SCHEME_END_OF_LIST);}

/* doloop8901 in k37776 in k37773 in scheme#make-list in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void f_37783(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,3)))){
C_save_and_reclaim_args((void *)trf_37783,4,t0,t1,t2,t3);}
a=C_alloc(3);
t4=C_eqp(t2,C_fix(0));
if(C_truep(t4)){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_fixnum_difference(t2,C_fix(1));
t6=C_a_i_cons(&a,2,((C_word*)t0)[2],t3);
t8=t1;
t9=t5;
t10=t6;
t1=t8;
t2=t9;
t3=t10;
goto loop;}}

/* scheme#list-set! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37815(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_37815,c,av);}
a=C_alloc(6);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37819,a[2]=t4,a[3]=t1,a[4]=t3,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7707: ##sys#check-integer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[422]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[422]+1);
av2[1]=t5;
av2[2]=t3;
av2[3]=lf[1532];
tp(4,av2);}}

/* k37817 in scheme#list-set! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_37819(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_37819,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37822,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)t0)[4],C_fix(0)))){
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_37822(2,av2);}}
else{
/* library.scm:7709: chicken.base#error */
t3=*((C_word*)lf[234]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[1532];
av2[3]=lf[1534];
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}}

/* k37820 in k37817 in scheme#list-set! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37822(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_37822,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_37827,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word)li1127),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_37827(t5,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}

/* doloop8911 in k37820 in k37817 in scheme#list-set! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void f_37827(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_37827,4,t0,t1,t2,t3);}
a=C_alloc(6);
t4=C_eqp(t2,C_fix(0));
if(C_truep(t4)){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_i_set_car(t3,((C_word*)t0)[2]);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37840,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_i_nullp(t3))){
/* library.scm:7714: chicken.base#error */
t6=*((C_word*)lf[234]+1);{
C_word av2[4];
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[1532];
av2[3]=lf[1533];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t7=t1;
t8=C_fixnum_difference(t2,C_fix(1));
t9=C_i_cdr(t3);
t1=t7;
t2=t8;
t3=t9;
goto loop;}}}

/* k37838 in doloop8911 in k37820 in k37817 in scheme#list-set! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void C_ccall f_37840(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_37840,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_37827(t2,((C_word*)t0)[3],C_fixnum_difference(((C_word*)t0)[4],C_fix(1)),C_i_cdr(((C_word*)t0)[5]));}

/* scheme#list-copy in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37865(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_37865,c,av);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t2))){
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37877,a[2]=t4,a[3]=((C_word)li1129),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_37877(t6,t1,C_SCHEME_END_OF_LIST,t2);}
else{
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* lp in scheme#list-copy in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_37877(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(4,0,3)))){
C_save_and_reclaim_args((void *)trf_37877,4,t0,t1,t2,t3);}
a=C_alloc(4);
if(C_truep(C_i_pairp(t3))){
t4=C_u_i_car(t3);
t5=C_a_i_cons(&a,2,t4,t2);
/* library.scm:7724: lp */
t7=t1;
t8=t5;
t9=C_u_i_cdr(t3);
t1=t7;
t2=t8;
t3=t9;
goto loop;}
else{
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_37902,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7725: ##sys#fast-reverse */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[445]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[445]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}}

/* k37900 in lp in scheme#list-copy in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37902(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_37902,c,av);}
/* library.scm:7725: scheme#append */
t2=*((C_word*)lf[443]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* scheme#string->vector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_37904(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_37904,c,av);}
a=C_alloc(3);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
t8=C_rest_nullp(c,4);
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37918,a[2]=((C_word)li1132),tmp=(C_word)a,a+=3,tmp);
if(C_truep(t7)){
/* library.scm:7741: s->v */
f_37918(t1,t2,t4,t7);}
else{
t10=(C_truep(t4)?t4:C_fix(0));
/* library.scm:7742: s->v */
f_37918(t1,t2,t10,C_i_string_length(t2));}}

/* s->v in scheme#string->vector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_37918(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,5)))){
C_save_and_reclaim_args((void *)trf_37918,4,t1,t2,t3,t4);}
a=C_alloc(7);
t5=C_i_check_string_2(t2,lf[1535]);
t6=C_slot(t2,C_fix(1));
t7=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_37928,a[2]=t4,a[3]=t2,a[4]=t1,a[5]=t3,a[6]=t6,tmp=(C_word)a,a+=7,tmp);
/* library.scm:7733: ##sys#check-range/including */
t8=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t8;
av2[1]=t7;
av2[2]=t3;
av2[3]=C_fix(0);
av2[4]=t4;
av2[5]=lf[1535];
((C_proc)(void*)(*((C_word*)t8+1)))(6,av2);}}

/* k37926 in s->v in scheme#string->vector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_37928(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_37928,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37931,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7734: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[5];
av2[4]=((C_word*)t0)[6];
av2[5]=lf[1535];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}

/* k37929 in k37926 in s->v in scheme#string->vector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_37931(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_37931,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37934,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7735: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t2;
av2[2]=C_fixnum_difference(((C_word*)t0)[2],((C_word*)t0)[5]);
tp(3,av2);}}

/* k37932 in k37929 in k37926 in s->v in scheme#string->vector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void C_ccall f_37934(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_37934,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_37939,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word)li1131),tmp=(C_word)a,a+=6,tmp);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(
  f_37939(t2,C_fix(0),((C_word*)t0)[5])
);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* doloop8950 in k37932 in k37929 in k37926 in s->v in scheme#string->vector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static C_word f_37939(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
return(((C_word*)t0)[3]);}
else{
t4=C_i_setslot(((C_word*)t0)[3],t1,C_utf_subchar(((C_word*)t0)[4],t2));
t6=C_fixnum_plus(t1,C_fix(1));
t7=C_fixnum_plus(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}

/* scheme#vector->string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_38008(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_38008,c,av);}
a=C_alloc(3);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
t8=C_rest_nullp(c,4);
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38022,a[2]=((C_word)li1135),tmp=(C_word)a,a+=3,tmp);
if(C_truep(t7)){
/* library.scm:7761: v->s */
f_38022(t1,t2,t4,t7);}
else{
t10=(C_truep(t4)?t4:C_fix(0));
/* library.scm:7762: v->s */
f_38022(t1,t2,t10,C_block_size(t2));}}

/* v->s in scheme#vector->string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_38022(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,5)))){
C_save_and_reclaim_args((void *)trf_38022,4,t1,t2,t3,t4);}
a=C_alloc(7);
t5=C_i_check_vector_2(t2,lf[1536]);
t6=C_block_size(t2);
t7=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38032,a[2]=t4,a[3]=t2,a[4]=t1,a[5]=t3,a[6]=t6,tmp=(C_word)a,a+=7,tmp);
/* library.scm:7749: ##sys#check-range/including */
t8=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t8;
av2[1]=t7;
av2[2]=t3;
av2[3]=C_fix(0);
av2[4]=t4;
av2[5]=lf[1536];
((C_proc)(void*)(*((C_word*)t8+1)))(6,av2);}}

/* k38030 in v->s in scheme#vector->string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_38032(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_38032,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38035,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7750: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[5];
av2[4]=((C_word*)t0)[6];
av2[5]=lf[1536];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}

/* k38033 in k38030 in v->s in scheme#vector->string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_38035(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_38035,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38038,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
t3=C_fixnum_difference(((C_word*)t0)[2],((C_word*)t0)[5]);
/* library.scm:7751: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t2;
av2[2]=C_fixnum_times(C_fix(4),t3);
tp(3,av2);}}

/* k38036 in k38033 in k38030 in v->s in scheme#vector->string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void C_ccall f_38038(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_38038,c,av);}
a=C_alloc(9);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38043,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t3,a[6]=((C_word)li1134),tmp=(C_word)a,a+=7,tmp));
t5=((C_word*)t3)[1];
f_38043(t5,((C_word*)t0)[4],C_fix(0),((C_word*)t0)[5]);}

/* loop in k38036 in k38033 in k38030 in v->s in scheme#vector->string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void f_38043(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(0,0,4)))){
C_save_and_reclaim_args((void *)trf_38043,4,t0,t1,t2,t3);}
t4=C_eqp(t3,((C_word*)t0)[2]);
if(C_truep(t4)){
/* library.scm:7755: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[300]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=C_fix(0);
av2[4]=t2;
tp(5,av2);}}
else{
t5=C_slot(((C_word*)t0)[4],t3);
t6=C_i_check_char_2(t5,lf[1536]);
/* library.scm:7758: loop */
t8=t1;
t9=C_fixnum_plus(t2,C_utf_insert(((C_word*)t0)[3],t2,t5));
t10=C_fixnum_plus(t3,C_fix(1));
t1=t8;
t2=t9;
t3=t10;
goto loop;}}

/* scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_38122(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +8,c,3)))){
C_save_and_reclaim((void*)f_38122,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+8);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
if(C_truep(C_rest_nullp(c,4))){
t5=C_i_string_length(t3);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38132,a[2]=t5,a[3]=t2,a[4]=t3,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7768: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=C_fixnum_times(C_fix(4),t5);
tp(3,av2);}}
else{
t5=C_a_i_cons(&a,2,t3,t4);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38184,a[2]=t5,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7780: ##sys#check-closure */
t7=*((C_word*)lf[434]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
av2[3]=lf[1537];
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}}

/* k38130 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_38132(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_38132,c,av);}
a=C_alloc(10);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_38137,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word)li1137),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_38137(t5,((C_word*)t0)[5],C_fix(0),C_fix(0));}

/* loop in k38130 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_38137(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,4)))){
C_save_and_reclaim_args((void *)trf_38137,4,t0,t1,t2,t3);}
a=C_alloc(7);
if(C_truep(C_fixnum_greater_or_equal_p(t3,((C_word*)t0)[2]))){
/* library.scm:7772: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[300]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=C_fix(0);
av2[4]=t2;
tp(5,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38150,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=t3,tmp=(C_word)a,a+=7,tmp);
/* library.scm:7773: proc */
t5=((C_word*)t0)[5];{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=C_i_string_ref(((C_word*)t0)[6],t3);
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}}

/* k38148 in loop in k38130 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_38150(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_38150,c,av);}
t2=C_i_check_char_2(t1,lf[1537]);
/* library.scm:7775: loop */
t3=((C_word*)((C_word*)t0)[2])[1];
f_38137(t3,((C_word*)t0)[3],C_utf_insert(((C_word*)t0)[4],((C_word*)t0)[5],t1),C_fixnum_plus(((C_word*)t0)[6],C_fix(1)));}

/* k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_38184(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(22,c,3)))){
C_save_and_reclaim((void *)f_38184,c,av);}
a=C_alloc(22);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38339,a[2]=((C_word)li1138),tmp=(C_word)a,a+=3,tmp);
t3=(
  f_38339(((C_word*)t0)[2])
);
t4=*((C_word*)lf[336]+1);
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38198,a[2]=t4,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38305,a[2]=t7,a[3]=t11,a[4]=t8,a[5]=((C_word)li1143),tmp=(C_word)a,a+=6,tmp));
t13=((C_word*)t11)[1];
f_38305(t13,t9,((C_word*)t0)[2]);}

/* k38196 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_38198(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_38198,c,av);}
a=C_alloc(9);
t2=C_i_check_list_2(t1,lf[254]);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38281,a[2]=((C_word)li1139),tmp=(C_word)a,a+=3,tmp);
t4=(
  f_38281(t1,((C_word*)t0)[2])
);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38207,a[2]=t4,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7783: ##sys#make-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[446]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[446]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}

/* k38205 in k38196 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_38207(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_38207,c,av);}
a=C_alloc(10);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_38212,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word)li1142),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_38212(t5,((C_word*)t0)[5],C_fix(0));}

/* doloop9080 in k38205 in k38196 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void f_38212(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(28,0,3)))){
C_save_and_reclaim_args((void *)trf_38212,3,t0,t1,t2);}
a=C_alloc(28);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38233,a[2]=((C_word*)t0)[3],a[3]=t2,a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_38238,a[2]=t2,a[3]=((C_word)li1140),tmp=(C_word)a,a+=4,tmp);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_38245,a[2]=t4,a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
t11=C_SCHEME_UNDEFINED;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_set_block_item(t12,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38247,a[2]=t9,a[3]=t7,a[4]=t12,a[5]=t8,a[6]=((C_word)li1141),tmp=(C_word)a,a+=7,tmp));
t14=((C_word*)t12)[1];
f_38247(t14,t10,((C_word*)t0)[6]);}}

/* k38231 in doloop9080 in k38205 in k38196 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_38233(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_38233,c,av);}
t2=C_i_string_set(((C_word*)t0)[2],((C_word*)t0)[3],t1);
t3=((C_word*)((C_word*)t0)[4])[1];
f_38212(t3,((C_word*)t0)[5],C_fixnum_plus(((C_word*)t0)[3],C_fix(1)));}

/* g9091 in doloop9080 in k38205 in k38196 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static C_word f_38238(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_stack_overflow_check;{}
return(C_i_string_ref(t1,((C_word*)t0)[2]));}

/* k38243 in doloop9080 in k38205 in k38196 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_38245(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_38245,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
C_apply(4,av2);}}

/* map-loop9085 in doloop9080 in k38205 in k38196 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void f_38247(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_38247,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=(
/* library.scm:7786: g9091 */
  f_38238(((C_word*)t0)[2],C_slot(t2,C_fix(0)))
);
t4=C_a_i_cons(&a,2,t3,C_SCHEME_END_OF_LIST);
t5=C_i_setslot(((C_word*)((C_word*)t0)[3])[1],C_fix(1),t4);
t6=C_mutate(((C_word *)((C_word*)t0)[3])+1,t4);
t8=t1;
t9=C_slot(t2,C_fix(1));
t1=t8;
t2=t9;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[5],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* foldl9043 in k38196 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static C_word f_38281(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t3=C_slot(t1,C_fix(1));
t4=C_slot(t1,C_fix(0));
t6=t3;
t7=C_i_fixnum_min(t2,t4);
t1=t6;
t2=t7;
goto loop;}
else{
return(t2);}}

/* map-loop9050 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_38305(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_38305,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_i_string_length(t3);
t5=C_a_i_cons(&a,2,t4,C_SCHEME_END_OF_LIST);
t6=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t5);
t7=C_mutate(((C_word *)((C_word*)t0)[2])+1,t5);
t9=t1;
t10=C_slot(t2,C_fix(1));
t1=t9;
t2=t10;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* for-each-loop9013 in k38182 in scheme#string-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static C_word f_38339(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=C_slot(t1,C_fix(0));
t3=C_i_check_string_2(t2,lf[1537]);
t5=C_slot(t1,C_fix(1));
t1=t5;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_38362(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +9,c,3)))){
C_save_and_reclaim((void*)f_38362,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+9);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
if(C_truep(C_rest_nullp(c,4))){
t5=C_i_string_length(t3);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38374,a[2]=t5,a[3]=t7,a[4]=t2,a[5]=t3,a[6]=((C_word)li1145),tmp=(C_word)a,a+=7,tmp));
t9=((C_word*)t7)[1];
f_38374(t9,t1,C_fix(0));}
else{
t5=C_a_i_cons(&a,2,t3,t4);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38410,a[2]=t5,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7799: ##sys#check-closure */
t7=*((C_word*)lf[434]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
av2[3]=lf[1538];
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}}

/* lp in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_38374(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_38374,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_fixnum_lessp(t2,((C_word*)t0)[2]))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38384,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7794: proc */
t4=((C_word*)t0)[4];{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=C_i_string_ref(((C_word*)t0)[5],t2);
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k38382 in lp in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_38384(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_38384,c,av);}
/* library.scm:7795: lp */
t2=((C_word*)((C_word*)t0)[2])[1];
f_38374(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_38410(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(22,c,3)))){
C_save_and_reclaim((void *)f_38410,c,av);}
a=C_alloc(22);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38561,a[2]=((C_word)li1146),tmp=(C_word)a,a+=3,tmp);
t3=(
  f_38561(((C_word*)t0)[2])
);
t4=*((C_word*)lf[336]+1);
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38424,a[2]=t4,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38527,a[2]=t7,a[3]=t11,a[4]=t8,a[5]=((C_word)li1151),tmp=(C_word)a,a+=6,tmp));
t13=((C_word*)t11)[1];
f_38527(t13,t9,((C_word*)t0)[2]);}

/* k38422 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_38424(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_38424,c,av);}
a=C_alloc(9);
t2=C_i_check_list_2(t1,lf[254]);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38503,a[2]=((C_word)li1147),tmp=(C_word)a,a+=3,tmp);
t4=(
  f_38503(t1,((C_word*)t0)[2])
);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38433,a[2]=t4,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7802: ##sys#make-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[446]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[446]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}

/* k38431 in k38422 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_38433(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_38433,c,av);}
a=C_alloc(9);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38438,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word)li1150),tmp=(C_word)a,a+=7,tmp));
t5=((C_word*)t3)[1];
f_38438(t5,((C_word*)t0)[5],C_fix(0));}

/* doloop9203 in k38431 in k38422 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void f_38438(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(27,0,3)))){
C_save_and_reclaim_args((void *)trf_38438,3,t0,t1,t2);}
a=C_alloc(27);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38448,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_38460,a[2]=t2,a[3]=((C_word)li1148),tmp=(C_word)a,a+=4,tmp);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_38467,a[2]=t4,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t11=C_SCHEME_UNDEFINED;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_set_block_item(t12,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38469,a[2]=t9,a[3]=t7,a[4]=t12,a[5]=t8,a[6]=((C_word)li1149),tmp=(C_word)a,a+=7,tmp));
t14=((C_word*)t12)[1];
f_38469(t14,t10,((C_word*)t0)[5]);}}

/* k38446 in doloop9203 in k38431 in k38422 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_38448(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_38448,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_38438(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* g9214 in doloop9203 in k38431 in k38422 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static C_word f_38460(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_stack_overflow_check;{}
return(C_i_string_ref(t1,((C_word*)t0)[2]));}

/* k38465 in doloop9203 in k38431 in k38422 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_38467(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_38467,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
C_apply(4,av2);}}

/* map-loop9208 in doloop9203 in k38431 in k38422 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void f_38469(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_38469,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=(
/* library.scm:7805: g9214 */
  f_38460(((C_word*)t0)[2],C_slot(t2,C_fix(0)))
);
t4=C_a_i_cons(&a,2,t3,C_SCHEME_END_OF_LIST);
t5=C_i_setslot(((C_word*)((C_word*)t0)[3])[1],C_fix(1),t4);
t6=C_mutate(((C_word *)((C_word*)t0)[3])+1,t4);
t8=t1;
t9=C_slot(t2,C_fix(1));
t1=t8;
t2=t9;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[5],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* foldl9166 in k38422 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static C_word f_38503(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t3=C_slot(t1,C_fix(1));
t4=C_slot(t1,C_fix(0));
t6=t3;
t7=C_i_fixnum_min(t2,t4);
t1=t6;
t2=t7;
goto loop;}
else{
return(t2);}}

/* map-loop9173 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_38527(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_38527,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_i_string_length(t3);
t5=C_a_i_cons(&a,2,t4,C_SCHEME_END_OF_LIST);
t6=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t5);
t7=C_mutate(((C_word *)((C_word*)t0)[2])+1,t5);
t9=t1;
t10=C_slot(t2,C_fix(1));
t1=t9;
t2=t10;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* for-each-loop9136 in k38408 in scheme#string-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static C_word f_38561(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=C_slot(t1,C_fix(0));
t3=C_i_check_string_2(t2,lf[1538]);
t5=C_slot(t1,C_fix(1));
t1=t5;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_38584(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +8,c,3)))){
C_save_and_reclaim((void*)f_38584,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+8);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
if(C_truep(C_rest_nullp(c,4))){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38594,a[2]=t3,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7810: ##sys#check-closure */
t6=*((C_word*)lf[434]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
av2[3]=lf[1539];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t5=C_a_i_cons(&a,2,t3,t4);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38639,a[2]=t5,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7819: ##sys#check-closure */
t7=*((C_word*)lf[434]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
av2[3]=lf[1539];
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}}

/* k38592 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_38594(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_38594,c,av);}
a=C_alloc(6);
t2=C_i_check_vector_2(((C_word*)t0)[2],lf[1539]);
t3=C_block_size(((C_word*)t0)[2]);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38603,a[2]=t3,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7813: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t4;
av2[2]=t3;
tp(3,av2);}}

/* k38601 in k38592 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_38603(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_38603,c,av);}
a=C_alloc(10);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_38608,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word)li1153),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_38608(t5,((C_word*)t0)[5],C_fix(0));}

/* doloop9254 in k38601 in k38592 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void f_38608(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_38608,3,t0,t1,t2);}
a=C_alloc(6);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38629,a[2]=((C_word*)t0)[3],a[3]=t2,a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7816: proc */
t5=((C_word*)t0)[5];{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=C_slot(((C_word*)t0)[6],t2);
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}}

/* k38627 in doloop9254 in k38601 in k38592 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void C_ccall f_38629(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_38629,c,av);}
t2=C_i_setslot(((C_word*)t0)[2],((C_word*)t0)[3],t1);
t3=((C_word*)((C_word*)t0)[4])[1];
f_38608(t3,((C_word*)t0)[5],C_fixnum_plus(((C_word*)t0)[3],C_fix(1)));}

/* k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_38639(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(22,c,3)))){
C_save_and_reclaim((void *)f_38639,c,av);}
a=C_alloc(22);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38794,a[2]=((C_word)li1154),tmp=(C_word)a,a+=3,tmp);
t3=(
  f_38794(((C_word*)t0)[2])
);
t4=*((C_word*)lf[336]+1);
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38653,a[2]=t4,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38760,a[2]=t7,a[3]=t11,a[4]=t8,a[5]=((C_word)li1159),tmp=(C_word)a,a+=6,tmp));
t13=((C_word*)t11)[1];
f_38760(t13,t9,((C_word*)t0)[2]);}

/* k38651 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_38653(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_38653,c,av);}
a=C_alloc(9);
t2=C_i_check_list_2(t1,lf[254]);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38736,a[2]=((C_word)li1155),tmp=(C_word)a,a+=3,tmp);
t4=(
  f_38736(t1,((C_word*)t0)[2])
);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38662,a[2]=t4,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7822: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}

/* k38660 in k38651 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_38662(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_38662,c,av);}
a=C_alloc(10);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_38667,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word)li1158),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_38667(t5,((C_word*)t0)[5],C_fix(0));}

/* doloop9331 in k38660 in k38651 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void f_38667(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(28,0,3)))){
C_save_and_reclaim_args((void *)trf_38667,3,t0,t1,t2);}
a=C_alloc(28);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38688,a[2]=((C_word*)t0)[3],a[3]=t2,a[4]=((C_word*)t0)[4],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_38693,a[2]=t2,a[3]=((C_word)li1156),tmp=(C_word)a,a+=4,tmp);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_38700,a[2]=t4,a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
t11=C_SCHEME_UNDEFINED;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_set_block_item(t12,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38702,a[2]=t9,a[3]=t7,a[4]=t12,a[5]=t8,a[6]=((C_word)li1157),tmp=(C_word)a,a+=7,tmp));
t14=((C_word*)t12)[1];
f_38702(t14,t10,((C_word*)t0)[6]);}}

/* k38686 in doloop9331 in k38660 in k38651 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_38688(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_38688,c,av);}
t2=C_i_setslot(((C_word*)t0)[2],((C_word*)t0)[3],t1);
t3=((C_word*)((C_word*)t0)[4])[1];
f_38667(t3,((C_word*)t0)[5],C_fixnum_plus(((C_word*)t0)[3],C_fix(1)));}

/* g9342 in doloop9331 in k38660 in k38651 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static C_word f_38693(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_stack_overflow_check;{}
return(C_i_vector_ref(t1,((C_word*)t0)[2]));}

/* k38698 in doloop9331 in k38660 in k38651 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_38700(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_38700,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
C_apply(4,av2);}}

/* map-loop9336 in doloop9331 in k38660 in k38651 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void f_38702(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_38702,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=(
/* library.scm:7825: g9342 */
  f_38693(((C_word*)t0)[2],C_slot(t2,C_fix(0)))
);
t4=C_a_i_cons(&a,2,t3,C_SCHEME_END_OF_LIST);
t5=C_i_setslot(((C_word*)((C_word*)t0)[3])[1],C_fix(1),t4);
t6=C_mutate(((C_word *)((C_word*)t0)[3])+1,t4);
t8=t1;
t9=C_slot(t2,C_fix(1));
t1=t8;
t2=t9;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[5],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* foldl9294 in k38651 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static C_word f_38736(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t3=C_slot(t1,C_fix(1));
t4=C_slot(t1,C_fix(0));
t6=t3;
t7=C_i_fixnum_min(t2,t4);
t1=t6;
t2=t7;
goto loop;}
else{
return(t2);}}

/* map-loop9301 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_38760(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_38760,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_block_size(t3);
t5=C_a_i_cons(&a,2,t4,C_SCHEME_END_OF_LIST);
t6=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t5);
t7=C_mutate(((C_word *)((C_word*)t0)[2])+1,t5);
t9=t1;
t10=C_slot(t2,C_fix(1));
t1=t9;
t2=t10;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* for-each-loop9264 in k38637 in scheme#vector-map in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static C_word f_38794(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=C_slot(t1,C_fix(0));
t3=C_i_check_vector_2(t2,lf[1539]);
t5=C_slot(t1,C_fix(1));
t1=t5;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_38817(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-4)*C_SIZEOF_PAIR +8,c,3)))){
C_save_and_reclaim((void*)f_38817,c,av);}
a=C_alloc((c-4)*C_SIZEOF_PAIR+8);
t4=C_build_rest(&a,c,4,av);
C_word t5;
C_word t6;
C_word t7;
if(C_truep(C_rest_nullp(c,4))){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38827,a[2]=t3,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7830: ##sys#check-closure */
t6=*((C_word*)lf[434]+1);{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
av2[2]=t2;
av2[3]=lf[1540];
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}
else{
t5=C_a_i_cons(&a,2,t3,t4);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38865,a[2]=t5,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7838: ##sys#check-closure */
t7=*((C_word*)lf[434]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
av2[3]=lf[1540];
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}}

/* k38825 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_38827(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_38827,c,av);}
a=C_alloc(9);
t2=C_i_check_vector_2(((C_word*)t0)[2],lf[1540]);
t3=C_block_size(((C_word*)t0)[2]);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38838,a[2]=t3,a[3]=t5,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[2],a[6]=((C_word)li1161),tmp=(C_word)a,a+=7,tmp));
t7=((C_word*)t5)[1];
f_38838(t7,((C_word*)t0)[4],C_fix(0));}

/* doloop9380 in k38825 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_38838(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_38838,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38848,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:7835: proc */
t5=((C_word*)t0)[4];{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=C_slot(((C_word*)t0)[5],t2);
((C_proc)C_fast_retrieve_proc(t5))(3,av2);}}}

/* k38846 in doloop9380 in k38825 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_38848(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_38848,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_38838(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_38865(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(22,c,3)))){
C_save_and_reclaim((void *)f_38865,c,av);}
a=C_alloc(22);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39016,a[2]=((C_word)li1162),tmp=(C_word)a,a+=3,tmp);
t3=(
  f_39016(((C_word*)t0)[2])
);
t4=*((C_word*)lf[336]+1);
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38879,a[2]=t4,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t10=C_SCHEME_UNDEFINED;
t11=(*a=C_VECTOR_TYPE|1,a[1]=t10,tmp=(C_word)a,a+=2,tmp);
t12=C_set_block_item(t11,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38982,a[2]=t7,a[3]=t11,a[4]=t8,a[5]=((C_word)li1167),tmp=(C_word)a,a+=6,tmp));
t13=((C_word*)t11)[1];
f_38982(t13,t9,((C_word*)t0)[2]);}

/* k38877 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_38879(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_38879,c,av);}
a=C_alloc(9);
t2=C_i_check_list_2(t1,lf[254]);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38958,a[2]=((C_word)li1163),tmp=(C_word)a,a+=3,tmp);
t4=(
  f_38958(t1,((C_word*)t0)[2])
);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_38888,a[2]=t4,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7841: ##sys#make-vector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[796]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[796]+1);
av2[1]=t5;
av2[2]=t4;
tp(3,av2);}}

/* k38886 in k38877 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_38888(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_38888,c,av);}
a=C_alloc(10);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_38893,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word)li1166),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_38893(t5,((C_word*)t0)[5],C_fix(0));}

/* doloop9457 in k38886 in k38877 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void f_38893(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(27,0,3)))){
C_save_and_reclaim_args((void *)trf_38893,3,t0,t1,t2);}
a=C_alloc(27);
t3=C_eqp(t2,((C_word*)t0)[2]);
if(C_truep(t3)){
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_38903,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t5=C_a_i_cons(&a,2,C_SCHEME_UNDEFINED,C_SCHEME_END_OF_LIST);
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=((C_word*)t7)[1];
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_38915,a[2]=t2,a[3]=((C_word)li1164),tmp=(C_word)a,a+=4,tmp);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_38922,a[2]=t4,a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
t11=C_SCHEME_UNDEFINED;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_set_block_item(t12,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_38924,a[2]=t9,a[3]=t7,a[4]=t12,a[5]=t8,a[6]=((C_word)li1165),tmp=(C_word)a,a+=7,tmp));
t14=((C_word*)t12)[1];
f_38924(t14,t10,((C_word*)t0)[6]);}}

/* k38901 in doloop9457 in k38886 in k38877 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_38903(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_38903,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_38893(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* g9468 in doloop9457 in k38886 in k38877 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static C_word f_38915(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_stack_overflow_check;{}
return(C_i_vector_ref(t1,((C_word*)t0)[2]));}

/* k38920 in doloop9457 in k38886 in k38877 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_38922(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_38922,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
C_apply(4,av2);}}

/* map-loop9462 in doloop9457 in k38886 in k38877 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void f_38924(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_38924,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=(
/* library.scm:7844: g9468 */
  f_38915(((C_word*)t0)[2],C_slot(t2,C_fix(0)))
);
t4=C_a_i_cons(&a,2,t3,C_SCHEME_END_OF_LIST);
t5=C_i_setslot(((C_word*)((C_word*)t0)[3])[1],C_fix(1),t4);
t6=C_mutate(((C_word *)((C_word*)t0)[3])+1,t4);
t8=t1;
t9=C_slot(t2,C_fix(1));
t1=t8;
t2=t9;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[5],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* foldl9420 in k38877 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static C_word f_38958(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t3=C_slot(t1,C_fix(1));
t4=C_slot(t1,C_fix(0));
t6=t3;
t7=C_i_fixnum_min(t2,t4);
t1=t6;
t2=t7;
goto loop;}
else{
return(t2);}}

/* map-loop9427 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_38982(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(3,0,2)))){
C_save_and_reclaim_args((void *)trf_38982,3,t0,t1,t2);}
a=C_alloc(3);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_block_size(t3);
t5=C_a_i_cons(&a,2,t4,C_SCHEME_END_OF_LIST);
t6=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t5);
t7=C_mutate(((C_word *)((C_word*)t0)[2])+1,t5);
t9=t1;
t10=C_slot(t2,C_fix(1));
t1=t9;
t2=t10;
goto loop;}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* for-each-loop9390 in k38863 in scheme#vector-for-each in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static C_word f_39016(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=C_slot(t1,C_fix(0));
t3=C_i_check_vector_2(t2,lf[1540]);
t5=C_slot(t1,C_fix(1));
t1=t5;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* scheme#close-port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39039(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_39039,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39043,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7848: ##sys#check-port */
t4=*((C_word*)lf[333]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
av2[3]=lf[1541];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k39041 in scheme#close-port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_39043(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_39043,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39046,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_port_openp(((C_word*)t0)[3],C_fix(1)))){
t3=C_slot(((C_word*)t0)[3],C_fix(2));
/* library.scm:7849: g9499 */
t4=C_slot(t3,C_fix(4));{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
av2[3]=C_fix(1);
((C_proc)C_fast_retrieve_proc(t4))(4,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_39046(2,av2);}}}

/* k39044 in k39041 in scheme#close-port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_39046(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_39046,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39049,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_port_openp(((C_word*)t0)[3],C_fix(2)))){
t3=C_slot(((C_word*)t0)[3],C_fix(2));
/* library.scm:7851: g9501 */
t4=C_slot(t3,C_fix(4));{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
av2[3]=C_fix(2);
((C_proc)C_fast_retrieve_proc(t4))(4,av2);}}
else{
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_i_set_i_slot(((C_word*)t0)[3],C_fix(8),C_fix(0));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k39047 in k39044 in k39041 in scheme#close-port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_39049(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_39049,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_set_i_slot(((C_word*)t0)[3],C_fix(8),C_fix(0));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scheme#call-with-port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39074(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_39074,c,av);}
a=C_alloc(9);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_39080,a[2]=t3,a[3]=t2,a[4]=((C_word)li1170),tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39086,a[2]=t2,a[3]=((C_word)li1171),tmp=(C_word)a,a+=4,tmp);
/* library.scm:7857: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t4;
av2[3]=t5;
C_call_with_values(4,av2);}}

/* a39079 in scheme#call-with-port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_39080(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_39080,c,av);}
/* library.scm:7858: proc */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t2))(3,av2);}}

/* a39085 in scheme#call-with-port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_39086(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_39086,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39090,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7859: scheme#close-port */
t4=*((C_word*)lf[70]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}

/* k39088 in a39085 in scheme#call-with-port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_39090(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_39090,c,av);}{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=*((C_word*)lf[160]+1);
av2[3]=((C_word*)t0)[3];
C_apply(4,av2);}}

/* scheme#eof-object in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39095(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_39095,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* scheme#peek-u8 in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39098(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_39098,c,av);}
a=C_alloc(3);
t2=C_fix(c - 2);
switch(t2){
case C_fix(0):
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39109,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7867: scheme#peek-char */
t4=*((C_word*)lf[188]+1);{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=*((C_word*)lf[838]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}
case C_fix(1):
t3=C_get_rest_arg(c,2,av,2,t0);
t4=C_i_check_port_2(t3,C_fix(1),C_SCHEME_TRUE,lf[1542]);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39134,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7872: scheme#peek-char */
t6=*((C_word*)lf[188]+1);{
C_word av2[3];
av2[0]=t6;
av2[1]=t5;
av2[2]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}
default:
/* library.scm:7865: ##sys#error */
t3=*((C_word*)lf[195]+1);{
C_word av2[3];
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[1543];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}}

/* k39107 in scheme#peek-u8 in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_39109(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_39109,c,av);}
t2=C_eofp(t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(t2)?t1:C_fix(C_character_code(t1)));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k39132 in scheme#peek-u8 in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_39134(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_39134,c,av);}
t2=C_eofp(t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(t2)?t1:C_fix(C_character_code(t1)));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* scheme#write-string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39148(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_39148,c,av);}
a=C_alloc(11);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?*((C_word*)lf[839]+1):C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
t8=t7;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_rest_nullp(c,4);
t11=C_rest_nullp(c,5);
t12=(C_truep(t11)?C_SCHEME_FALSE:C_get_rest_arg(c,5,av,3,t0));
t13=t12;
t14=(*a=C_VECTOR_TYPE|1,a[1]=t13,tmp=(C_word)a,a+=2,tmp);
t15=C_rest_nullp(c,5);
t16=C_i_check_string_2(t2,lf[1544]);
t17=C_i_check_port_2(t4,C_fix(2),C_SCHEME_TRUE,lf[1544]);
t18=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_39176,a[2]=t4,a[3]=t1,a[4]=t9,a[5]=t2,a[6]=t14,tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t9)[1])){
t19=t18;
f_39176(t19,C_i_check_fixnum_2(((C_word*)t9)[1],lf[1544]));}
else{
t19=C_set_block_item(t9,0,C_fix(0));
t20=t18;
f_39176(t20,t19);}}

/* k39174 in scheme#write-string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_39176(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_39176,2,t0,t1);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_39179,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)((C_word*)t0)[6])[1])){
t3=t2;
f_39179(t3,C_i_check_fixnum_2(((C_word*)((C_word*)t0)[6])[1],lf[1544]));}
else{
t3=C_set_block_item(((C_word*)t0)[6],0,C_u_i_string_length(((C_word*)t0)[5]));
t4=t2;
f_39179(t4,t3);}}

/* k39177 in k39174 in scheme#write-string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_39179(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,4)))){
C_save_and_reclaim_args((void *)trf_39179,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39182,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)((C_word*)t0)[4])[1])){
/* library.scm:7886: scheme#substring */
t3=*((C_word*)lf[489]+1);{
C_word av2[5];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=((C_word*)((C_word*)t0)[4])[1];
av2[4]=((C_word*)((C_word*)t0)[6])[1];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}
else{
t3=t2;{
C_word av2[2];
av2[0]=t3;
av2[1]=((C_word*)t0)[5];
f_39182(2,av2);}}}

/* k39180 in k39177 in k39174 in scheme#write-string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_39182(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_39182,c,av);}
t2=C_slot(t1,C_fix(0));
t3=C_block_size(t2);
t4=C_fixnum_difference(t3,C_fix(1));
t5=C_slot(((C_word*)t0)[2],C_fix(2));
/* library.scm:7886: g9548 */
t6=C_slot(t5,C_fix(3));{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t6;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[2];
av2[3]=t2;
av2[4]=C_fix(0);
av2[5]=t4;
((C_proc)C_fast_retrieve_proc(t6))(6,av2);}}

/* chicken.io#read-list in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39252(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_39252,c,av);}
a=C_alloc(6);
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?*((C_word*)lf[838]+1):C_get_rest_arg(c,2,av,2,t0));
t4=C_rest_nullp(c,2);
t5=C_rest_nullp(c,3);
t6=(C_truep(t5)?((C_word*)t0)[2]:C_get_rest_arg(c,3,av,2,t0));
t7=C_rest_nullp(c,3);
t8=C_rest_nullp(c,4);
t9=(C_truep(t8)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,2,t0));
t10=C_rest_nullp(c,4);
t11=C_i_check_port_2(t3,C_fix(1),C_SCHEME_TRUE,lf[1547]);
t12=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_39281,a[2]=t9,a[3]=t6,a[4]=t3,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7912: reader */
t13=t6;{
C_word av2[3];
av2[0]=t13;
av2[1]=t12;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t13))(3,av2);}}

/* k39279 in chicken.io#read-list in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_39281(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_39281,c,av);}
a=C_alloc(9);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_39283,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word)li1176),tmp=(C_word)a,a+=7,tmp));
t5=((C_word*)t3)[1];
f_39283(t5,((C_word*)t0)[5],t1,C_fix(0),C_SCHEME_END_OF_LIST);}

/* doloop9586 in k39279 in chicken.io#read-list in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_39283(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_39283,5,t0,t1,t2,t3,t4);}
a=C_alloc(7);
t5=C_eofp(t2);
t6=(C_truep(t5)?t5:(C_truep(((C_word*)t0)[2])?C_fixnum_greater_or_equal_p(t3,((C_word*)t0)[2]):C_SCHEME_FALSE));
if(C_truep(t6)){
/* library.scm:7916: ##sys#fast-reverse */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[445]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[445]+1);
av2[1]=t1;
av2[2]=t4;
tp(3,av2);}}
else{
t7=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_39303,a[2]=t3,a[3]=t2,a[4]=t4,a[5]=((C_word*)t0)[3],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:7912: reader */
t8=((C_word*)t0)[4];{
C_word av2[3];
av2[0]=t8;
av2[1]=t7;
av2[2]=((C_word*)t0)[5];
((C_proc)C_fast_retrieve_proc(t8))(3,av2);}}}

/* k39301 in doloop9586 in k39279 in chicken.io#read-list in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_39303(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_39303,c,av);}
a=C_alloc(3);
t2=C_fixnum_plus(((C_word*)t0)[2],C_fix(1));
t3=C_a_i_cons(&a,2,((C_word*)t0)[3],((C_word*)t0)[4]);
t4=((C_word*)((C_word*)t0)[5])[1];
f_39283(t4,((C_word*)t0)[6],t1,t2,t3);}

/* chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39355(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand((c-2)*C_SIZEOF_PAIR +4,c,2)))){
C_save_and_reclaim((void*)f_39355,c,av);}
a=C_alloc((c-2)*C_SIZEOF_PAIR+4);
t2=C_build_rest(&a,c,2,av);
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
t3=C_i_pairp(t2);
t4=(C_truep(t3)?C_get_rest_arg(c,2,av,2,t0):*((C_word*)lf[838]+1));
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39365,a[2]=t4,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(t3)){
t6=C_i_cdr(t2);
t7=C_i_pairp(t6);
t8=t5;
f_39365(t8,(C_truep(t7)?C_i_cadr(t2):C_SCHEME_FALSE));}
else{
t6=t5;
f_39365(t6,C_SCHEME_FALSE);}}

/* k39363 in chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_39365(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_39365,2,t0,t1);}
a=C_alloc(8);
t2=C_i_check_port_2(((C_word*)t0)[2],C_fix(1),C_SCHEME_TRUE,lf[833]);
t3=C_slot(((C_word*)t0)[2],C_fix(2));
t4=C_slot(t3,C_fix(8));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_39375,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word)li1178),tmp=(C_word)a,a+=5,tmp);
/* library.scm:7928: g9610 */
t6=t5;
f_39375(t6,((C_word*)t0)[3],t4);}
else{
t5=(C_truep(t1)?t1:C_fix(256));
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_39388,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t7,a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7931: ##sys#make-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[446]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[446]+1);
av2[1]=t8;
av2[2]=((C_word*)t7)[1];
tp(3,av2);}}}

/* g9610 in k39363 in chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_39375(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,3)))){
C_save_and_reclaim_args((void *)trf_39375,3,t0,t1,t2);}
/* library.scm:7928: rl */
t3=t2;{
C_word av2[4];
av2[0]=t3;
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
((C_proc)C_fast_retrieve_proc(t3))(4,av2);}}

/* k39386 in k39363 in chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_39388(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_39388,c,av);}
a=C_alloc(12);
t2=t1;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_39393,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=t5,a[7]=((C_word)li1179),tmp=(C_word)a,a+=8,tmp));
t7=((C_word*)t5)[1];
f_39393(t7,((C_word*)t0)[5],C_fix(0));}

/* loop in k39386 in k39363 in chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void f_39393(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,4)))){
C_save_and_reclaim_args((void *)trf_39393,3,t0,t1,t2);}
a=C_alloc(8);
t3=(C_truep(((C_word*)t0)[2])?C_fixnum_greater_or_equal_p(t2,((C_word*)t0)[2]):C_SCHEME_FALSE);
if(C_truep(t3)){
/* library.scm:7934: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[486]+1);
av2[1]=t1;
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=C_fix(0);
av2[4]=t2;
tp(5,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_39406,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
/* library.scm:7935: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word av2[3];
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}}

/* k39404 in loop in k39386 in k39363 in chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void C_ccall f_39406(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,4)))){
C_save_and_reclaim((void *)f_39406,c,av);}
a=C_alloc(12);
if(C_truep(C_eofp(t1))){
t2=C_eqp(((C_word*)t0)[2],C_fix(0));
if(C_truep(t2)){
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:7939: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[486]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)((C_word*)t0)[4])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[2];
tp(5,av2);}}}
else{
switch(t1){
case C_make_character(10):
/* library.scm:7941: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[486]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)((C_word*)t0)[4])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[2];
tp(5,av2);}
case C_make_character(13):
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_39439,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* library.scm:7943: scheme#peek-char */
t3=*((C_word*)lf[188]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}
default:
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)t0)[2],((C_word*)((C_word*)t0)[6])[1]))){
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_39474,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[2],a[5]=t1,a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[3],tmp=(C_word)a,a+=8,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39482,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* library.scm:7951: scheme#make-string */
t4=*((C_word*)lf[470]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)((C_word*)t0)[6])[1];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}
else{
t2=C_i_string_set(((C_word*)((C_word*)t0)[4])[1],((C_word*)t0)[2],t1);
/* library.scm:7954: loop */
t3=((C_word*)((C_word*)t0)[7])[1];
f_39393(t3,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[2],C_fix(1)));}}}}

/* k39437 in k39404 in loop in k39386 in k39363 in chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_39439(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_39439,c,av);}
a=C_alloc(5);
if(C_truep(C_i_char_equalp(t1,C_make_character(10)))){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_39448,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:7945: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}
else{
/* library.scm:7947: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[486]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}}

/* k39446 in k39437 in k39404 in loop in k39386 in k39363 in chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in ... */
static void C_ccall f_39448(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_39448,c,av);}
/* library.scm:7946: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[486]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[4];
tp(5,av2);}}

/* k39472 in k39404 in loop in k39386 in k39363 in chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_39474(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_39474,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,t1);
t3=C_fixnum_plus(((C_word*)((C_word*)t0)[3])[1],((C_word*)((C_word*)t0)[3])[1]);
t4=C_set_block_item(((C_word*)t0)[3],0,t3);
t5=C_i_string_set(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[4],((C_word*)t0)[5]);
/* library.scm:7954: loop */
t6=((C_word*)((C_word*)t0)[6])[1];
f_39393(t6,((C_word*)t0)[7],C_fixnum_plus(((C_word*)t0)[4],C_fix(1)));}

/* k39480 in k39404 in loop in k39386 in k39363 in chicken.io#read-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_39482(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_39482,c,av);}
/* library.scm:7951: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=t1;
tp(4,av2);}}

/* chicken.io#read-lines in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39511(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_39511,c,av);}
a=C_alloc(7);
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?*((C_word*)lf[838]+1):C_get_rest_arg(c,2,av,2,t0));
t4=C_rest_nullp(c,2);
t5=C_rest_nullp(c,3);
t6=(C_truep(t5)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,2,t0));
t7=C_rest_nullp(c,3);
t8=C_i_check_port_2(t3,C_fix(1),C_SCHEME_TRUE,lf[1550]);
t9=(C_truep(t6)?C_i_check_fixnum_2(t6,lf[1550]):C_SCHEME_UNDEFINED);
t10=(C_truep(t6)?t6:*((C_word*)lf[336]+1));
t11=C_SCHEME_UNDEFINED;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_set_block_item(t12,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_39539,a[2]=t12,a[3]=t3,a[4]=((C_word)li1181),tmp=(C_word)a,a+=5,tmp));
t14=((C_word*)t12)[1];
f_39539(t14,t1,C_SCHEME_END_OF_LIST,t10);}

/* loop in chicken.io#read-lines in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_39539(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_39539,4,t0,t1,t2,t3);}
a=C_alloc(6);
t4=C_eqp(t3,C_fix(0));
if(C_truep(t4)){
/* library.scm:7963: ##sys#fast-reverse */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[445]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[445]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_39552,a[2]=t1,a[3]=t2,a[4]=((C_word*)t0)[2],a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7964: read-line */
t6=C_fast_retrieve(lf[1548]);{
C_word av2[3];
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}}

/* k39550 in loop in chicken.io#read-lines in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_39552(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_39552,c,av);}
a=C_alloc(3);
if(C_truep(C_eofp(t1))){
/* library.scm:7966: ##sys#fast-reverse */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[445]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[445]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
t2=C_a_i_cons(&a,2,t1,((C_word*)t0)[3]);
/* library.scm:7967: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_39539(t3,((C_word*)t0)[2],t2,C_fixnum_difference(((C_word*)t0)[5],C_fix(1)));}}

/* chicken.io#write-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39601(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +4,c,5)))){
C_save_and_reclaim((void*)f_39601,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+4);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
t4=(C_truep(C_eqp(t3,C_SCHEME_END_OF_LIST))?*((C_word*)lf[839]+1):C_slot(t3,C_fix(0)));
t5=C_i_check_port_2(t4,C_fix(2),C_SCHEME_TRUE,lf[1552]);
t6=C_i_check_string_2(t2,lf[1552]);
t7=C_slot(t2,C_fix(0));
t8=C_slot(t4,C_fix(2));
t9=C_slot(t8,C_fix(3));
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39620,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
t11=C_block_size(t7);
/* library.scm:7976: g9663 */
t12=t9;{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t12;
av2[1]=t10;
av2[2]=t4;
av2[3]=t7;
av2[4]=C_fix(0);
av2[5]=C_fixnum_difference(t11,C_fix(1));
((C_proc)C_fast_retrieve_proc(t12))(6,av2);}}

/* k39618 in chicken.io#write-line in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_39620(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_39620,c,av);}
/* library.scm:7982: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=C_make_character(10);
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}

/* chicken.io#read-bytevector!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39640(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_39640,c,av);}
a=C_alloc(9);
t6=C_eqp(t2,C_fix(0));
if(C_truep(t6)){
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_fix(0);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_slot(t4,C_fix(2));
t8=C_slot(t7,C_fix(7));
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_39655,a[2]=t4,a[3]=t10,a[4]=t8,a[5]=t3,a[6]=((C_word)li1184),tmp=(C_word)a,a+=7,tmp));
t12=((C_word*)t10)[1];
f_39655(t12,t1,t5,t2,C_fix(0));}}

/* loop in chicken.io#read-bytevector!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void f_39655(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,5)))){
C_save_and_reclaim_args((void *)trf_39655,5,t0,t1,t2,t3,t4);}
a=C_alloc(8);
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_39659,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t4,a[5]=t3,a[6]=t2,a[7]=((C_word*)t0)[3],tmp=(C_word)a,a+=8,tmp);
/* library.scm:7992: rdbvec */
t6=((C_word*)t0)[4];{
C_word av2[6];
av2[0]=t6;
av2[1]=t5;
av2[2]=((C_word*)t0)[2];
av2[3]=t3;
av2[4]=((C_word*)t0)[5];
av2[5]=t2;
((C_proc)C_fast_retrieve_proc(t6))(6,av2);}}

/* k39657 in loop in chicken.io#read-bytevector!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_39659(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_39659,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(5));
t3=C_fixnum_plus(t2,t1);
t4=C_i_set_i_slot(((C_word*)t0)[2],C_fix(5),t3);
t5=C_eqp(t1,C_fix(0));
if(C_truep(t5)){
t6=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t6;
av2[1]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_i_not(((C_word*)t0)[5]);
t7=(C_truep(t6)?t6:C_fixnum_lessp(t1,((C_word*)t0)[5]));
if(C_truep(t7)){
t8=C_fixnum_plus(((C_word*)t0)[6],t1);
t9=(C_truep(((C_word*)t0)[5])?C_fixnum_difference(((C_word*)t0)[5],t1):C_SCHEME_FALSE);
/* library.scm:7997: loop */
t10=((C_word*)((C_word*)t0)[7])[1];
f_39655(t10,((C_word*)t0)[3],t8,t9,C_fixnum_plus(((C_word*)t0)[4],t1));}
else{
t8=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t8;
av2[1]=C_fixnum_plus(t1,((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}}

/* chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39715(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_39715,c,av);}
a=C_alloc(7);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_39719,a[2]=t4,a[3]=t3,a[4]=t5,a[5]=t2,a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:8001: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=C_fixnum_times(t2,C_fix(4));
tp(3,av2);}}

/* k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_39719(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_39719,c,av);}
a=C_alloc(9);
t2=C_slot(((C_word*)t0)[2],C_fix(15));
t3=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_39727,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,a[6]=((C_word*)t0)[2],a[7]=((C_word*)t0)[5],a[8]=((C_word)li1191),tmp=(C_word)a,a+=9,tmp);
/* library.scm:8003: ##sys#encoding-hook */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[456]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[456]+1);
av2[1]=((C_word*)t0)[6];
av2[2]=t2;
av2[3]=t3;
tp(4,av2);}}

/* a39726 in k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_39727(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(26,c,6)))){
C_save_and_reclaim((void *)f_39727,c,av);}
a=C_alloc(26);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_39730,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word)li1187),tmp=(C_word)a,a+=5,tmp));
t10=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_39748,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word)li1188),tmp=(C_word)a,a+=6,tmp));
t11=C_SCHEME_UNDEFINED;
t12=(*a=C_VECTOR_TYPE|1,a[1]=t11,tmp=(C_word)a,a+=2,tmp);
t13=C_set_block_item(t12,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_39754,a[2]=t8,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[5],a[5]=t6,a[6]=((C_word*)t0)[6],a[7]=t12,a[8]=((C_word)li1190),tmp=(C_word)a,a+=9,tmp));
t14=((C_word*)t12)[1];
f_39754(t14,t1,C_fix(0),((C_word*)t0)[7],C_fix(0),C_fix(0));}

/* readb in a39726 in k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void f_39730(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,5)))){
C_save_and_reclaim_args((void *)trf_39730,6,t0,t1,t2,t3,t4,t5);}
a=C_alloc(7);
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_39734,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,a[5]=t5,a[6]=((C_word*)t0)[3],tmp=(C_word)a,a+=7,tmp);
/* library.scm:8007: read-bytevector!/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1553]);
C_word av2[6];
av2[0]=*((C_word*)lf[1553]+1);
av2[1]=t6;
av2[2]=t2;
av2[3]=t3;
av2[4]=t4;
av2[5]=t5;
tp(6,av2);}}

/* k39732 in readb in a39726 in k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void C_ccall f_39734(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_39734,c,av);}
a=C_alloc(5);
t2=C_eqp(((C_word*)t0)[2],lf[457]);
if(C_truep(t2)){
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_39745,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word)li1186),tmp=(C_word)a,a+=5,tmp);
/* library.scm:8010: decoder */
t4=((C_word*)t0)[6];{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[5];
av2[4]=t1;
av2[5]=t3;
((C_proc)C_fast_retrieve_proc(t4))(6,av2);}}}

/* a39744 in k39732 in readb in a39726 in k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_39745(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_39745,c,av);}
t5=C_copy_memory_with_offset(((C_word*)t0)[2],t2,((C_word*)t0)[3],t3,t4);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* finish in a39726 in k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static C_word f_39748(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_stack_overflow_check;{}
t3=C_utf_overwrite(((C_word*)t0)[2],((C_word*)t0)[3],t1,((C_word*)t0)[4],t2);
return(t1);}

/* loop in a39726 in k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void f_39754(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,0,5)))){
C_save_and_reclaim_args((void *)trf_39754,6,t0,t1,t2,t3,t4,t5);}
a=C_alloc(13);
t6=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_39758,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t4,a[5]=t5,a[6]=((C_word*)t0)[3],a[7]=((C_word*)t0)[4],a[8]=t2,a[9]=t3,a[10]=((C_word*)t0)[5],a[11]=((C_word*)t0)[6],a[12]=((C_word*)t0)[7],tmp=(C_word)a,a+=13,tmp);
/* library.scm:8018: readb */
t7=((C_word*)((C_word*)t0)[5])[1];
f_39730(t7,t6,t3,((C_word*)t0)[4],((C_word*)t0)[6],t2);}

/* k39756 in loop in a39726 in k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void C_ccall f_39758(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,5)))){
C_save_and_reclaim((void *)f_39758,c,av);}
a=C_alloc(15);
t2=C_eqp(t1,C_fix(0));
if(C_truep(t2)){
/* library.scm:8019: finish */
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(
/* library.scm:8019: finish */
  f_39748(((C_word*)((C_word*)t0)[3])[1],((C_word*)t0)[4],((C_word*)t0)[5])
);
((C_proc)C_fast_retrieve_proc(t3))(2,av2);}}
else{
t3=C_eqp(((C_word*)t0)[6],lf[457]);
if(C_truep(t3)){
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_39778,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[8],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[9],a[7]=((C_word*)t0)[3],a[8]=t5,a[9]=((C_word*)t0)[10],a[10]=((C_word*)t0)[11],a[11]=((C_word*)t0)[12],a[12]=((C_word)li1189),tmp=(C_word)a,a+=13,tmp));
t7=((C_word*)t5)[1];
f_39778(t7,((C_word*)t0)[2],t1);}
else{
if(C_truep(C_fixnum_greaterp(t1,((C_word*)t0)[9]))){
/* library.scm:8039: loop */
t4=((C_word*)((C_word*)t0)[12])[1];
f_39754(t4,((C_word*)t0)[2],C_fixnum_plus(((C_word*)t0)[8],t1),C_fixnum_difference(((C_word*)t0)[9],t1),C_fixnum_plus(((C_word*)t0)[4],t1),C_fixnum_plus(((C_word*)t0)[5],t1));}
else{
/* library.scm:8041: finish */
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=(
/* library.scm:8041: finish */
  f_39748(((C_word*)((C_word*)t0)[3])[1],((C_word*)t0)[4],((C_word*)t0)[5])
);
((C_proc)C_fast_retrieve_proc(t4))(2,av2);}}}}}

/* recount in k39756 in loop in a39726 in k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void f_39778(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,5)))){
C_save_and_reclaim_args((void *)trf_39778,3,t0,t1,t2);}
a=C_alloc(9);
t3=C_utf_fragment_counts(((C_word*)t0)[2],((C_word*)t0)[3],t2);
t4=C_fixnum_shift_right(t3,C_fix(4));
t5=C_fixnum_and(t3,C_fix(15));
t6=C_fixnum_plus(((C_word*)t0)[4],t4);
t7=C_fixnum_plus(((C_word*)t0)[5],t2);
t8=C_fixnum_difference(((C_word*)t0)[6],t4);
if(C_truep(C_fixnum_greaterp(t5,C_fix(0)))){
t9=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_39803,a[2]=t5,a[3]=t1,a[4]=((C_word*)t0)[7],a[5]=t6,a[6]=t7,a[7]=((C_word*)t0)[8],a[8]=t2,tmp=(C_word)a,a+=9,tmp);
/* library.scm:8031: readb */
t10=((C_word*)((C_word*)t0)[9])[1];
f_39730(t10,t9,t5,((C_word*)t0)[2],((C_word*)t0)[10],C_fixnum_plus(((C_word*)t0)[3],t2));}
else{
t9=C_eqp(t8,C_fix(0));
if(C_truep(t9)){
/* library.scm:8035: finish */
t10=t1;{
C_word av2[2];
av2[0]=t10;
av2[1]=(
/* library.scm:8035: finish */
  f_39748(((C_word*)((C_word*)t0)[7])[1],t6,t7)
);
((C_proc)C_fast_retrieve_proc(t10))(2,av2);}}
else{
/* library.scm:8036: loop */
t10=((C_word*)((C_word*)t0)[11])[1];
f_39754(t10,t1,C_fixnum_plus(((C_word*)t0)[3],t2),t8,t6,t7);}}}

/* k39801 in recount in k39756 in loop in a39726 in k39717 in chicken.io#read-string!/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in ... */
static void C_ccall f_39803(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_39803,c,av);}
if(C_truep(C_fixnum_lessp(t1,((C_word*)t0)[2]))){
/* library.scm:8033: finish */
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=(
/* library.scm:8033: finish */
  f_39748(((C_word*)((C_word*)t0)[4])[1],((C_word*)t0)[5],((C_word*)t0)[6])
);
((C_proc)C_fast_retrieve_proc(t2))(2,av2);}}
else{
/* library.scm:8034: recount */
t2=((C_word*)((C_word*)t0)[7])[1];
f_39778(t2,((C_word*)t0)[3],C_fixnum_plus(((C_word*)t0)[8],t1));}}

/* chicken.io#read-string! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39873(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word *a;
if(c<4) C_bad_min_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_39873,c,av);}
t4=C_rest_nullp(c,4);
t5=(C_truep(t4)?*((C_word*)lf[838]+1):C_get_rest_arg(c,4,av,4,t0));
t6=C_rest_nullp(c,4);
t7=C_rest_nullp(c,5);
t8=(C_truep(t7)?C_fix(0):C_get_rest_arg(c,5,av,4,t0));
t9=C_rest_nullp(c,5);
t10=C_i_check_port_2(t5,C_fix(1),C_SCHEME_TRUE,lf[1556]);
t11=C_i_check_string_2(t3,lf[1556]);
t12=(C_truep(t2)?C_i_check_fixnum_2(t2,lf[1556]):C_SCHEME_UNDEFINED);
t13=C_u_i_string_length(t3);
t14=(C_truep(t2)?C_fixnum_less_or_equal_p(C_fixnum_plus(t8,t2),t13):C_SCHEME_FALSE);
if(C_truep(t14)){
t15=C_i_check_fixnum_2(t8,lf[1556]);
/* library.scm:8051: read-string!/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1554]);
C_word av2[6];
av2[0]=*((C_word*)lf[1554]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
av2[4]=t5;
av2[5]=t8;
tp(6,av2);}}
else{
t15=C_fixnum_difference(t13,t8);
t16=t2=t15;
t17=C_i_check_fixnum_2(t8,lf[1556]);
/* library.scm:8051: read-string!/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1554]);
C_word av2[6];
av2[0]=*((C_word*)lf[1554]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
av2[4]=t5;
av2[5]=t8;
tp(6,av2);}}}

/* chicken.io#read-bytevector! in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_39948(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_39948,c,av);}
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?*((C_word*)lf[838]+1):C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_fix(0):C_get_rest_arg(c,4,av,3,t0));
t8=C_rest_nullp(c,4);
t9=C_rest_nullp(c,5);
t10=(C_truep(t9)?C_SCHEME_FALSE:C_get_rest_arg(c,5,av,3,t0));
t11=C_rest_nullp(c,5);
t12=C_i_check_port_2(t4,C_fix(1),C_SCHEME_TRUE,lf[831]);
t13=C_i_check_bytevector_2(t2,lf[831]);
t14=C_i_check_fixnum_2(t7,lf[831]);
t15=(C_truep(t10)?C_i_check_fixnum_2(t10,lf[831]):C_SCHEME_UNDEFINED);
t16=C_block_size(t2);
t17=(C_truep(t10)?C_fixnum_difference(t10,t7):C_fixnum_difference(t16,t7));
/* library.scm:8060: read-bytevector!/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1553]);
C_word av2[6];
av2[0]=*((C_word*)lf[1553]+1);
av2[1]=t1;
av2[2]=t17;
av2[3]=t2;
av2[4]=t4;
av2[5]=t7;
tp(6,av2);}}

/* chicken.io#read-string/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40033(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_40033,c,av);}
a=C_alloc(5);
t4=C_eqp(t2,C_fix(0));
if(C_truep(t4)){
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=lf[1559];
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40081,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:8065: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word *av2=av;
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t5;
av2[2]=t3;
tp(3,av2);}}}

/* k40050 in k40079 in chicken.io#read-string/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_40052(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_40052,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40055,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:8067: read-string!/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1554]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[1554]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
av2[3]=t1;
av2[4]=((C_word*)t0)[4];
av2[5]=C_fix(0);
tp(6,av2);}}

/* k40053 in k40050 in k40079 in chicken.io#read-string/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_40055(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_40055,c,av);}
t2=C_eqp(((C_word*)t0)[2],t1);
if(C_truep(t2)){
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:8070: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[486]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=C_fix(0);
av2[4]=t1;
tp(5,av2);}}}

/* a40068 in k40079 in chicken.io#read-string/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_40069(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_40069,c,av);}
/* library.scm:8075: ##sys#buffer->string/encoding */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[461]+1));
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[461]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_fix(0);
av2[4]=t3;
av2[5]=C_slot(((C_word*)t0)[2],C_fix(15));
tp(6,av2);}}

/* k40079 in chicken.io#read-string/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_40081(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_40081,c,av);}
a=C_alloc(5);
if(C_truep(C_eofp(t1))){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
if(C_truep(((C_word*)t0)[3])){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40052,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:8066: ##sys#make-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[446]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[446]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
tp(3,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40069,a[2]=((C_word*)t0)[4],a[3]=((C_word)li1195),tmp=(C_word)a,a+=4,tmp);
/* library.scm:8072: ##sys#read-remaining */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1560]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1560]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[4];
av2[3]=t2;
tp(4,av2);}}}}

/* ##sys#read-remaining in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40083(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_40083,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40091,a[2]=t3,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:8080: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=C_fix(1024);
tp(3,av2);}}

/* k40089 in ##sys#read-remaining in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_40091(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,5)))){
C_save_and_reclaim((void *)f_40091,c,av);}
a=C_alloc(8);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_40093,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word)li1197),tmp=(C_word)a,a+=6,tmp));
t5=((C_word*)t3)[1];
f_40093(t5,((C_word*)t0)[4],t1,C_fix(1024),C_fix(0));}

/* loop in k40089 in ##sys#read-remaining in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_40093(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,5)))){
C_save_and_reclaim_args((void *)trf_40093,5,t0,t1,t2,t3,t4);}
a=C_alloc(9);
t5=C_block_size(t2);
t6=C_fixnum_difference(t5,t4);
t7=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_40100,a[2]=t6,a[3]=t3,a[4]=t2,a[5]=((C_word*)t0)[2],a[6]=t1,a[7]=t4,a[8]=((C_word*)t0)[3],tmp=(C_word)a,a+=9,tmp);
/* library.scm:8084: read-bytevector!/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1553]);
C_word av2[6];
av2[0]=*((C_word*)lf[1553]+1);
av2[1]=t7;
av2[2]=t6;
av2[3]=t2;
av2[4]=((C_word*)t0)[4];
av2[5]=t4;
tp(6,av2);}}

/* k40098 in loop in k40089 in ##sys#read-remaining in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_40100(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_40100,c,av);}
a=C_alloc(9);
t2=C_eqp(t1,((C_word*)t0)[2]);
if(C_truep(t2)){
t3=C_fixnum_times(((C_word*)t0)[3],C_fix(2));
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_40112,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=t3,a[7]=((C_word*)t0)[7],a[8]=t1,tmp=(C_word)a,a+=9,tmp);
/* library.scm:8087: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=t3;
tp(3,av2);}}
else{
/* library.scm:8090: k */
t3=((C_word*)t0)[8];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[6];
av2[2]=((C_word*)t0)[4];
av2[3]=C_fixnum_plus(t1,((C_word*)t0)[7]);
((C_proc)C_fast_retrieve_proc(t3))(4,av2);}}}

/* k40110 in k40098 in loop in k40089 in ##sys#read-remaining in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void C_ccall f_40112(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_40112,c,av);}
t2=C_copy_memory(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
/* library.scm:8089: loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_40093(t3,((C_word*)t0)[5],t1,((C_word*)t0)[6],C_fixnum_plus(((C_word*)t0)[7],((C_word*)t0)[8]));}

/* chicken.io#read-bytevector/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40132(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_40132,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40136,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:8094: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}

/* k40134 in chicken.io#read-bytevector/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_40136(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_40136,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40139,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:8095: read-bytevector!/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1553]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[1553]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
av2[3]=t1;
av2[4]=((C_word*)t0)[4];
av2[5]=C_fix(0);
tp(6,av2);}}

/* k40137 in k40134 in chicken.io#read-bytevector/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_40139(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_40139,c,av);}
a=C_alloc(5);
t2=C_eqp(((C_word*)t0)[2],t1);
if(C_truep(t2)){
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40148,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* library.scm:8098: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t3;
av2[2]=t1;
tp(3,av2);}}}

/* k40146 in k40137 in k40134 in chicken.io#read-bytevector/port in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_40148(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40148,c,av);}
t2=C_copy_memory(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.io#read-string in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40150(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_40150,c,av);}
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?C_SCHEME_FALSE:C_get_rest_arg(c,2,av,2,t0));
t4=C_rest_nullp(c,2);
t5=C_rest_nullp(c,3);
t6=(C_truep(t5)?*((C_word*)lf[838]+1):C_get_rest_arg(c,3,av,2,t0));
t7=C_rest_nullp(c,3);
t8=C_i_check_port_2(t6,C_fix(1),C_SCHEME_TRUE,lf[1563]);
if(C_truep(t3)){
t9=C_i_check_fixnum_2(t3,lf[1563]);
/* library.scm:8105: read-string/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1558]);
C_word av2[4];
av2[0]=*((C_word*)lf[1558]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=t6;
tp(4,av2);}}
else{
/* library.scm:8105: read-string/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1558]);
C_word av2[4];
av2[0]=*((C_word*)lf[1558]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=t6;
tp(4,av2);}}}

/* chicken.io#read-bytevector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40201(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_40201,c,av);}
a=C_alloc(3);
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?C_SCHEME_FALSE:C_get_rest_arg(c,2,av,2,t0));
t4=C_rest_nullp(c,2);
t5=C_rest_nullp(c,3);
t6=(C_truep(t5)?*((C_word*)lf[838]+1):C_get_rest_arg(c,3,av,2,t0));
t7=C_rest_nullp(c,3);
t8=C_i_check_port_2(t6,C_fix(1),C_SCHEME_TRUE,lf[1565]);
if(C_truep(t3)){
t9=C_i_check_fixnum_2(t3,lf[1565]);
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40226,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:8110: read-bytevector/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1561]);
C_word av2[4];
av2[0]=*((C_word*)lf[1561]+1);
av2[1]=t10;
av2[2]=t3;
av2[3]=t6;
tp(4,av2);}}
else{
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40241,a[2]=((C_word)li1201),tmp=(C_word)a,a+=3,tmp);
/* library.scm:8115: ##sys#read-remaining */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1560]);
C_word av2[4];
av2[0]=*((C_word*)lf[1560]+1);
av2[1]=t1;
av2[2]=t6;
av2[3]=t9;
tp(4,av2);}}}

/* k40224 in chicken.io#read-bytevector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_40226(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40226,c,av);}
t2=C_block_size(t1);
t3=C_eqp(t2,C_fix(0));
t4=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t4;
av2[1]=(C_truep(t3)?C_SCHEME_END_OF_FILE:t1);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a40240 in chicken.io#read-bytevector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_40241(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_40241,c,av);}
a=C_alloc(5);
t4=C_eqp(t3,C_fix(0));
if(C_truep(t4)){
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40251,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:8120: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=t3;
tp(3,av2);}}}

/* k40249 in a40240 in chicken.io#read-bytevector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_40251(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40251,c,av);}
t2=C_copy_memory(t1,((C_word*)t0)[2],((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.io#read-buffered in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40281(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40281,c,av);}
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?*((C_word*)lf[838]+1):C_get_rest_arg(c,2,av,2,t0));
t4=C_i_check_port_2(t3,C_fix(1),C_SCHEME_TRUE,lf[1567]);
t5=C_slot(t3,C_fix(2));
t6=C_slot(t5,C_fix(9));
if(C_truep(t6)){
/* library.scm:8136: rb */
t7=t6;{
C_word av2[3];
av2[0]=t7;
av2[1]=t1;
av2[2]=t3;
((C_proc)C_fast_retrieve_proc(t7))(3,av2);}}
else{
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=lf[1568];
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}

/* chicken.io#read-token in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40309(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_40309,c,av);}
a=C_alloc(5);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?*((C_word*)lf[838]+1):C_get_rest_arg(c,3,av,3,t0));
t5=C_i_check_port_2(t4,C_fix(1),C_SCHEME_TRUE,lf[1570]);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40319,a[2]=t4,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:8146: scheme#open-output-string */
t7=*((C_word*)lf[318]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* k40317 in chicken.io#read-token in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_40319(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_40319,c,av);}
a=C_alloc(9);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_40324,a[2]=t3,a[3]=t1,a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=((C_word)li1204),tmp=(C_word)a,a+=7,tmp));
t5=((C_word*)t3)[1];
f_40324(t5,((C_word*)t0)[4]);}

/* loop in k40317 in chicken.io#read-token in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void f_40324(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_40324,2,t0,t1);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_40328,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* library.scm:8148: ##sys#peek-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[906]);
C_word av2[3];
av2[0]=*((C_word*)lf[906]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
tp(3,av2);}}

/* k40326 in loop in k40317 in chicken.io#read-token in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in ... */
static void C_ccall f_40328(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_40328,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_40334,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
t3=C_eofp(t1);
if(C_truep(C_i_not(t3))){
/* library.scm:8149: pred */
t4=((C_word*)t0)[6];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t2;
av2[2]=t1;
((C_proc)C_fast_retrieve_proc(t4))(3,av2);}}
else{
t4=t2;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
f_40334(2,av2);}}}

/* k40332 in k40326 in loop in k40317 in chicken.io#read-token in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in ... */
static void C_ccall f_40334(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_40334,c,av);}
a=C_alloc(8);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40337,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40344,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* library.scm:8151: ##sys#read-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[904]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[904]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[5];
tp(3,av2);}}
else{
/* library.scm:8153: scheme#get-output-string */
t2=*((C_word*)lf[320]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}}

/* k40335 in k40332 in k40326 in loop in k40317 in chicken.io#read-token in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_40337(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40337,c,av);}
/* library.scm:8152: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_40324(t2,((C_word*)t0)[3]);}

/* k40342 in k40332 in k40326 in loop in k40317 in chicken.io#read-token in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in ... */
static void C_ccall f_40344(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_40344,c,av);}
/* library.scm:8151: ##sys#write-char-0 */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1007]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1007]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=((C_word*)t0)[3];
tp(4,av2);}}

/* chicken.io#read-byte in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40365(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_40365,c,av);}
a=C_alloc(4);
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?*((C_word*)lf[838]+1):C_get_rest_arg(c,2,av,2,t0));
t4=C_i_check_port_2(t3,C_fix(1),C_SCHEME_TRUE,lf[1572]);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40375,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* library.scm:8160: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t5;
av2[2]=C_fix(1);
tp(3,av2);}}

/* k40373 in chicken.io#read-byte in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_40375(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,5)))){
C_save_and_reclaim((void *)f_40375,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40378,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:8161: read-bytevector!/port */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1553]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[1553]+1);
av2[1]=t2;
av2[2]=C_fix(1);
av2[3]=t1;
av2[4]=((C_word*)t0)[3];
av2[5]=C_fix(0);
tp(6,av2);}}

/* k40376 in k40373 in chicken.io#read-byte in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_40378(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40378,c,av);}
t2=C_fixnum_lessp(t1,C_fix(1));
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(t2)?C_SCHEME_END_OF_FILE:C_subbyte(((C_word*)t0)[3],C_fix(0)));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.io#write-byte in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40392(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_40392,c,av);}
a=C_alloc(4);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?*((C_word*)lf[839]+1):C_get_rest_arg(c,3,av,3,t0));
t5=C_i_check_fixnum_2(t2,lf[1574]);
t6=C_i_check_port_2(t4,C_fix(2),C_SCHEME_TRUE,lf[1574]);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40405,a[2]=t4,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:8169: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t7;
av2[2]=C_fix(1);
av2[3]=t2;
tp(4,av2);}}

/* k40403 in chicken.io#write-byte in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_40405(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_40405,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(2));
/* library.scm:8169: g9932 */
t3=C_slot(t2,C_fix(3));{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[2];
av2[3]=t1;
av2[4]=C_fix(0);
av2[5]=C_fix(1);
((C_proc)C_fast_retrieve_proc(t3))(6,av2);}}

/* chicken.io#write-bytevector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in ... */
static void C_ccall f_40423(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,5)))){
C_save_and_reclaim((void *)f_40423,c,av);}
a=C_alloc(8);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?*((C_word*)lf[839]+1):C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_fix(0):C_get_rest_arg(c,4,av,3,t0));
t8=C_rest_nullp(c,4);
t9=C_rest_nullp(c,5);
t10=(C_truep(t9)?C_SCHEME_FALSE:C_get_rest_arg(c,5,av,3,t0));
t11=C_rest_nullp(c,5);
t12=C_i_check_bytevector_2(t2,lf[1576]);
t13=C_i_check_port_2(t4,C_fix(2),C_SCHEME_TRUE,lf[1576]);
t14=C_i_check_fixnum_2(t7,lf[1576]);
t15=C_block_size(t2);
t16=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_40457,a[2]=t10,a[3]=t15,a[4]=t4,a[5]=t1,a[6]=t2,a[7]=t7,tmp=(C_word)a,a+=8,tmp);
/* library.scm:8179: ##sys#check-range/including */
t17=*((C_word*)lf[431]+1);{
C_word av2[6];
av2[0]=t17;
av2[1]=t16;
av2[2]=t7;
av2[3]=C_fix(0);
av2[4]=t15;
av2[5]=lf[1576];
((C_proc)(void*)(*((C_word*)t17+1)))(6,av2);}}

/* k40455 in chicken.io#write-bytevector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in ... */
static void C_ccall f_40457(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,5)))){
C_save_and_reclaim((void *)f_40457,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_40460,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)t0)[2])){
/* library.scm:8180: ##sys#check-range/including */
t3=*((C_word*)lf[431]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[3];
av2[5]=lf[1576];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_40460(2,av2);}}}

/* k40458 in k40455 in chicken.io#write-bytevector in k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in ... */
static void C_ccall f_40460(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_40460,c,av);}
t2=(C_truep(((C_word*)t0)[2])?C_i_fixnum_min(((C_word*)t0)[2],((C_word*)t0)[3]):((C_word*)t0)[3]);
t3=C_slot(((C_word*)t0)[4],C_fix(2));
/* library.scm:8181: g9957 */
t4=C_slot(t3,C_fix(3));{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[5];
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[6];
av2[4]=((C_word*)t0)[7];
av2[5]=t2;
((C_proc)C_fast_retrieve_proc(t4))(6,av2);}}

/* k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in ... */
static void C_ccall f_40519(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_40519,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40527,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40531,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7640: scheme#string-append */
t4=*((C_word*)lf[508]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1577];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[1578];
av2[5]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t4+1)))(6,av2);}}

/* k40525 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in ... */
static void C_ccall f_40527(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(132,c,6)))){
C_save_and_reclaim((void *)f_40527,c,av);}
a=C_alloc(132);
t2=C_a_i_cons(&a,2,t1,C_fast_retrieve(lf[1510]));
t3=C_a_i_cons(&a,2,((C_word*)t0)[2],t2);
t4=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t3);
t5=C_mutate((C_word*)lf[1516]+1 /* (set! chicken.platform#register-feature! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37500,a[2]=((C_word)li1114),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[1517]+1 /* (set! chicken.platform#unregister-feature! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37544,a[2]=((C_word)li1117),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[1492]+1 /* (set! chicken.platform#feature? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37622,a[2]=((C_word)li1119),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[1518]+1 /* (set! chicken.platform#return-to-host ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)C_return_to_host,a[2]=((C_word)li1120),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate((C_word*)lf[1519]+1 /* (set! chicken.platform#system-config-directory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37659,a[2]=((C_word)li1121),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate((C_word*)lf[1524]+1 /* (set! chicken.platform#system-cache-directory ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37683,a[2]=((C_word)li1122),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[68]+1 /* (set! scheme#features ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37713,a[2]=((C_word)li1124),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate((C_word*)lf[76]+1 /* (set! scheme#make-list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37768,a[2]=((C_word)li1126),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate((C_word*)lf[77]+1 /* (set! scheme#list-set! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37815,a[2]=((C_word)li1128),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate((C_word*)lf[80]+1 /* (set! scheme#list-copy ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37865,a[2]=((C_word)li1130),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate((C_word*)lf[81]+1 /* (set! scheme#string->vector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37904,a[2]=((C_word)li1133),tmp=(C_word)a,a+=3,tmp));
t16=C_mutate((C_word*)lf[82]+1 /* (set! scheme#vector->string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38008,a[2]=((C_word)li1136),tmp=(C_word)a,a+=3,tmp));
t17=C_mutate((C_word*)lf[72]+1 /* (set! scheme#string-map ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38122,a[2]=((C_word)li1144),tmp=(C_word)a,a+=3,tmp));
t18=C_mutate((C_word*)lf[74]+1 /* (set! scheme#string-for-each ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38362,a[2]=((C_word)li1152),tmp=(C_word)a,a+=3,tmp));
t19=C_mutate((C_word*)lf[73]+1 /* (set! scheme#vector-map ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38584,a[2]=((C_word)li1160),tmp=(C_word)a,a+=3,tmp));
t20=C_mutate((C_word*)lf[75]+1 /* (set! scheme#vector-for-each ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_38817,a[2]=((C_word)li1168),tmp=(C_word)a,a+=3,tmp));
t21=C_mutate((C_word*)lf[70]+1 /* (set! scheme#close-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39039,a[2]=((C_word)li1169),tmp=(C_word)a,a+=3,tmp));
t22=C_mutate((C_word*)lf[69]+1 /* (set! scheme#call-with-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39074,a[2]=((C_word)li1172),tmp=(C_word)a,a+=3,tmp));
t23=C_mutate((C_word*)lf[79]+1 /* (set! scheme#eof-object ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39095,a[2]=((C_word)li1173),tmp=(C_word)a,a+=3,tmp));
t24=C_mutate((C_word*)lf[71]+1 /* (set! scheme#peek-u8 ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39098,a[2]=((C_word)li1174),tmp=(C_word)a,a+=3,tmp));
t25=C_mutate((C_word*)lf[78]+1 /* (set! scheme#write-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39148,a[2]=((C_word)li1175),tmp=(C_word)a,a+=3,tmp));
t26=C_a_i_provide(&a,1,lf[1545]);
t27=*((C_word*)lf[189]+1);
t28=C_mutate((C_word*)lf[1546]+1 /* (set! chicken.io#read-list ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_39252,a[2]=t27,a[3]=((C_word)li1177),tmp=(C_word)a,a+=4,tmp));
t29=C_mutate((C_word*)lf[1548]+1 /* (set! chicken.io#read-line ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39355,a[2]=((C_word)li1180),tmp=(C_word)a,a+=3,tmp));
t30=C_mutate((C_word*)lf[1549]+1 /* (set! chicken.io#read-lines ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39511,a[2]=((C_word)li1182),tmp=(C_word)a,a+=3,tmp));
t31=C_mutate((C_word*)lf[1551]+1 /* (set! chicken.io#write-line ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39601,a[2]=((C_word)li1183),tmp=(C_word)a,a+=3,tmp));
t32=C_mutate((C_word*)lf[1553]+1 /* (set! chicken.io#read-bytevector!/port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39640,a[2]=((C_word)li1185),tmp=(C_word)a,a+=3,tmp));
t33=C_mutate((C_word*)lf[1554]+1 /* (set! chicken.io#read-string!/port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39715,a[2]=((C_word)li1192),tmp=(C_word)a,a+=3,tmp));
t34=C_mutate((C_word*)lf[1555]+1 /* (set! chicken.io#read-string! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39873,a[2]=((C_word)li1193),tmp=(C_word)a,a+=3,tmp));
t35=C_mutate((C_word*)lf[1557]+1 /* (set! chicken.io#read-bytevector! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_39948,a[2]=((C_word)li1194),tmp=(C_word)a,a+=3,tmp));
t36=C_mutate((C_word*)lf[1558]+1 /* (set! chicken.io#read-string/port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40033,a[2]=((C_word)li1196),tmp=(C_word)a,a+=3,tmp));
t37=C_mutate((C_word*)lf[1560]+1 /* (set! ##sys#read-remaining ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40083,a[2]=((C_word)li1198),tmp=(C_word)a,a+=3,tmp));
t38=C_mutate((C_word*)lf[1561]+1 /* (set! chicken.io#read-bytevector/port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40132,a[2]=((C_word)li1199),tmp=(C_word)a,a+=3,tmp));
t39=C_mutate((C_word*)lf[1562]+1 /* (set! chicken.io#read-string ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40150,a[2]=((C_word)li1200),tmp=(C_word)a,a+=3,tmp));
t40=C_mutate((C_word*)lf[1564]+1 /* (set! chicken.io#read-bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40201,a[2]=((C_word)li1202),tmp=(C_word)a,a+=3,tmp));
t41=C_mutate((C_word*)lf[1558]+1 /* (set! chicken.io#read-string/port ...) */,C_fast_retrieve(lf[1558]));
t42=C_mutate((C_word*)lf[1554]+1 /* (set! chicken.io#read-string!/port ...) */,C_fast_retrieve(lf[1554]));
t43=C_mutate((C_word*)lf[1561]+1 /* (set! chicken.io#read-bytevector/port ...) */,C_fast_retrieve(lf[1561]));
t44=C_mutate((C_word*)lf[1553]+1 /* (set! chicken.io#read-bytevector!/port ...) */,C_fast_retrieve(lf[1553]));
t45=C_mutate((C_word*)lf[1566]+1 /* (set! chicken.io#read-buffered ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40281,a[2]=((C_word)li1203),tmp=(C_word)a,a+=3,tmp));
t46=C_mutate((C_word*)lf[1569]+1 /* (set! chicken.io#read-token ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40309,a[2]=((C_word)li1205),tmp=(C_word)a,a+=3,tmp));
t47=C_mutate((C_word*)lf[1571]+1 /* (set! chicken.io#read-byte ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40365,a[2]=((C_word)li1206),tmp=(C_word)a,a+=3,tmp));
t48=C_mutate((C_word*)lf[1573]+1 /* (set! chicken.io#write-byte ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40392,a[2]=((C_word)li1207),tmp=(C_word)a,a+=3,tmp));
t49=C_mutate((C_word*)lf[1575]+1 /* (set! chicken.io#write-bytevector ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40423,a[2]=((C_word)li1208),tmp=(C_word)a,a+=3,tmp));
t50=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t50;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t50+1)))(2,av2);}}

/* k40529 in k40517 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in ... */
static void C_ccall f_40531(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40531,c,av);}
/* library.scm:7640: ->feature-id */
t2=C_retrieve2(lf[1508],C_text("chicken.platform#->feature-id"));{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
f_37404(3,av2);}}

/* k40533 in k37493 in k37490 in k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in ... */
static void C_ccall f_40535(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40535,c,av);}
/* library.scm:7639: ->feature-id */
t2=C_retrieve2(lf[1508],C_text("chicken.platform#->feature-id"));{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
f_37404(3,av2);}}

/* k40539 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in ... */
static void C_ccall f_40541(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_40541,c,av);}
a=C_alloc(6);
t2=C_a_i_cons(&a,2,t1,C_fast_retrieve(lf[1510]));
t3=C_mutate((C_word*)lf[1510]+1 /* (set! ##sys#features ...) */,t2);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_37492,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t5=C_fix((C_word)C_MAJOR_VERSION);
/* library.scm:7637: ##sys#number->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[706]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[706]+1);
av2[1]=t4;
av2[2]=t5;
tp(3,av2);}}

/* k40543 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in ... */
static void C_ccall f_40545(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40545,c,av);}
/* library.scm:7630: chicken.keyword#string->keyword */
t2=*((C_word*)lf[754]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k40547 in k37482 in k37479 in k37476 in k37473 in k37470 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in ... */
static void C_ccall f_40549(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_40549,c,av);}
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=lf[1580];
tp(4,av2);}}

/* k40569 in k37467 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in ... */
static void C_ccall f_40571(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40571,c,av);}
/* library.scm:7617: check */
f_37442(((C_word*)t0)[3],t1);}

/* k40573 in k37464 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in ... */
static void C_ccall f_40575(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40575,c,av);}
/* library.scm:7616: check */
f_37442(((C_word*)t0)[3],t1);}

/* k40577 in k37461 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in ... */
static void C_ccall f_40579(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40579,c,av);}
/* library.scm:7615: check */
f_37442(((C_word*)t0)[3],t1);}

/* k40581 in k37458 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in ... */
static void C_ccall f_40583(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40583,c,av);}
/* library.scm:7614: check */
f_37442(((C_word*)t0)[3],t1);}

/* k40585 in k37382 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in ... */
static void C_ccall f_40587(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40587,c,av);}
/* library.scm:7613: check */
f_37442(((C_word*)t0)[3],t1);}

/* k40605 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in ... */
static void C_ccall f_40607(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_40607,c,av);}
a=C_alloc(8);
t2=C_i_check_list_2(t1,lf[822]);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_40615,a[2]=((C_word*)t0)[2],a[3]=t4,a[4]=((C_word*)t0)[3],a[5]=((C_word)li1209),tmp=(C_word)a,a+=6,tmp));
t6=((C_word*)t4)[1];
f_40615(t6,((C_word*)t0)[4],t1);}

/* map-loop8690 in k40605 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in ... */
static void f_40615(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_40615,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_40640,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7580: g8696 */
t4=C_retrieve2(lf[1507],C_text("chicken.platform#chop-separator"));{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=C_slot(t2,C_fix(0));
f_37351(3,av2);}}
else{
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_slot(((C_word*)t0)[4],C_fix(1));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k40638 in map-loop8690 in k40605 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in ... */
static void C_ccall f_40640(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_40640,c,av);}
a=C_alloc(3);
t2=C_a_i_cons(&a,2,t1,C_SCHEME_END_OF_LIST);
t3=C_i_setslot(((C_word*)((C_word*)t0)[2])[1],C_fix(1),t2);
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
t5=((C_word*)((C_word*)t0)[3])[1];
f_40615(t5,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}

/* k40655 in k37379 in k37347 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in ... */
static void C_ccall f_40657(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_40657,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_list1(&a,1,t1);
f_37384(2,av2);}}

/* k40659 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_40661(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_40661,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40664,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(t1)){
/* library.scm:7565: scheme#make-parameter */
t3=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40667,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:7567: chicken.process-context#get-environment-variable */
t4=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1582];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}}

/* k40662 in k40659 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_40664(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40664,c,av);}
/* library.scm:7565: scheme#make-parameter */
t2=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k40665 in k40659 in k37343 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_40667(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_40667,c,av);}
a=C_alloc(3);
if(C_truep(t1)){
/* library.scm:7565: scheme#make-parameter */
t2=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}
else{
/* ##sys#peek-c-string */
t2=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=C_mpointer(&a,(void*)C_INSTALL_EGG_HOME);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}}

/* k40675 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_40677(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_40677,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40680,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(t1)){
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_a_i_list1(&a,1,t1);
f_40680(2,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40726,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* library.scm:7552: chicken.process-context#get-environment-variable */
t4=C_fast_retrieve(lf[1356]);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1584];
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}}

/* k40678 in k40675 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_40680(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_40680,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40682,a[2]=((C_word)li1211),tmp=(C_word)a,a+=3,tmp);
/* library.scm:7549: scheme#make-parameter */
t3=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* a40681 in k40678 in k40675 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_40682(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_40682,c,av);}
a=C_alloc(3);
if(C_truep(t2)){
t3=C_i_check_list_2(t2,lf[1583]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40699,a[2]=((C_word)li1210),tmp=(C_word)a,a+=3,tmp);
t5=(
  f_40699(t2)
);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* for-each-loop8648 in a40681 in k40678 in k40675 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in ... */
static C_word f_40699(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_stack_overflow_check;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=C_slot(t1,C_fix(0));
t3=C_i_check_string_2(t2,lf[1583]);
t5=C_slot(t1,C_fix(1));
t1=t5;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* k40724 in k40675 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in ... */
static void C_ccall f_40726(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_40726,c,av);}
a=C_alloc(6);
if(C_truep(t1)){
/* library.scm:7550: ##sys#split-path */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1504]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[1504]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
tp(3,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40735,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t3=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_mpointer(&a,(void*)C_INSTALL_EGG_HOME);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}}

/* k40733 in k40724 in k40675 in k37087 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in ... */
static void C_ccall f_40735(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_40735,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=(C_truep(t1)?C_a_i_list1(&a,1,t1):C_SCHEME_FALSE);
f_40680(2,av2);}}

/* k40753 in k40757 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in ... */
static void C_ccall f_40755(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40755,c,av);}
t2=((C_word*)t0)[2];
f_37089(t2,C_i_not(C_eqp(lf[1586],t1)));}

/* k40757 in k37081 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in ... */
static void C_ccall f_40759(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_40759,c,av);}
a=C_alloc(3);
t2=C_eqp(lf[1585],t1);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40755,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7476: software-version */
t4=C_fast_retrieve(lf[1461]);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=((C_word*)t0)[2];
f_37089(t3,C_SCHEME_FALSE);}}

/* k40761 in k37075 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in ... */
static void C_ccall f_40763(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40763,c,av);}
/* library.scm:7470: scheme#string->symbol */
t2=*((C_word*)lf[742]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k40765 in k37069 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in ... */
static void C_ccall f_40767(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40767,c,av);}
/* library.scm:7466: scheme#string->symbol */
t2=*((C_word*)lf[742]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k40769 in k37063 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in ... */
static void C_ccall f_40771(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40771,c,av);}
/* library.scm:7462: scheme#string->symbol */
t2=*((C_word*)lf[742]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k40773 in k37057 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in ... */
static void C_ccall f_40775(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40775,c,av);}
/* library.scm:7458: scheme#string->symbol */
t2=*((C_word*)lf[742]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* k40777 in k36756 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_40779(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40779,c,av);}
/* library.scm:7454: scheme#string->symbol */
t2=*((C_word*)lf[742]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* a40780 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_40781(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40781,c,av);}
t3=C_i_check_symbol_2(t2,lf[1587]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_slot(t2,C_fix(2));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a40789 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in ... */
static void C_ccall f_40790(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_40790,c,av);}
a=C_alloc(5);
t4=C_i_check_symbol_2(t2,lf[1587]);
t5=C_i_check_list_2(t3,lf[1588]);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40800,a[2]=t3,a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t7=C_i_length(t3);
if(C_truep(C_i_fixnumevenp(t7))){
t8=C_i_setslot(t2,C_fix(2),t3);
t9=C_i_nullp(t3);
t10=t1;{
C_word *av2=av;
av2[0]=t10;
av2[1]=(C_truep(t9)?C_i_unpersist_symbol(t2):C_i_persist_symbol(t2));
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
/* library.scm:7357: ##sys#signal-hook */
t8=*((C_word*)lf[235]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t8;
av2[1]=t6;
av2[2]=lf[295];
av2[3]=lf[1589];
av2[4]=t3;
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t8+1)))(6,av2);}}}

/* k40798 in a40789 in k36685 in k36320 in k35936 in k35899 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in ... */
static void C_ccall f_40800(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40800,c,av);}
t2=C_i_nullp(((C_word*)t0)[2]);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(t2)?C_i_unpersist_symbol(((C_word*)t0)[4]):C_i_persist_symbol(((C_word*)t0)[4]));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k40823 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_40825(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_40825,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40828,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(C_i_pairp(t1))){
t3=C_slot(t1,C_fix(1));
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40846,a[2]=t5,a[3]=((C_word)li1220),tmp=(C_word)a,a+=4,tmp));
t7=((C_word*)t5)[1];
f_40846(t7,t2,t3);}
else{
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f49039,a[2]=((C_word)li1221),tmp=(C_word)a,a+=3,tmp);
/* library.scm:7030: scheme#make-parameter */
t4=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}}

/* k40826 in k40823 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_40828(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_40828,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40830,a[2]=((C_word)li1219),tmp=(C_word)a,a+=3,tmp);
/* library.scm:7030: scheme#make-parameter */
t3=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
av2[3]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* a40829 in k40826 in k40823 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_40830(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40830,c,av);}
t3=C_i_check_list_2(t2,lf[1591]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* loop in k40823 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void f_40846(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,0,4)))){
C_save_and_reclaim_args((void *)trf_40846,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_slot(t2,C_fix(0));
t4=C_slot(t2,C_fix(1));
if(C_truep(C_i_string_equal_p(lf[1592],t3))){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_i_string_length(t3);
if(C_truep(C_fixnum_greater_or_equal_p(t5,C_fix(3)))){
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_40881,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t4,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* library.scm:7043: ##sys#substring */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[486]+1));
C_word av2[5];
av2[0]=*((C_word*)lf[486]+1);
av2[1]=t6;
av2[2]=t3;
av2[3]=C_fix(0);
av2[4]=C_fix(2);
tp(5,av2);}}
else{
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}}}

/* k40879 in loop in k40823 in k35895 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in ... */
static void C_ccall f_40881(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40881,c,av);}
if(C_truep(C_i_string_equal_p(lf[1593],t1))){
/* library.scm:7044: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_40846(t2,((C_word*)t0)[3],((C_word*)t0)[4]);}
else{
t2=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k40903 in k40907 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_40905(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_40905,c,av);}
a=C_alloc(3);
t2=C_i_car(t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f49051,a[2]=((C_word)li1223),tmp=(C_word)a,a+=3,tmp);
/* library.scm:7021: scheme#make-parameter */
t4=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
av2[2]=t2;
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k40907 in k35711 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_40909(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_40909,c,av);}
a=C_alloc(3);
if(C_truep(C_i_nullp(t1))){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f49045,a[2]=((C_word)li1222),tmp=(C_word)a,a+=3,tmp);
/* library.scm:7021: scheme#make-parameter */
t3=*((C_word*)lf[85]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[1595];
av2[3]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40905,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:7024: argv */
t3=C_fast_retrieve(lf[1365]);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* a40910 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_40911(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_40911,c,av);}
a=C_alloc(11);
t2=C_uint64_to_num(&a,C_MAX_PATH);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40915,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6941: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t3;
av2[2]=t2;
tp(3,av2);}}

/* k40913 in a40910 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in ... */
static void C_ccall f_40915(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_40915,c,av);}
a=C_alloc(5);
t2=C_curdir(t1,((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40918,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_fast_retrieve(lf[1463]))){
t4=t3;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
f_40918(2,av2);}}
else{
/* library.scm:6944: ##sys#update-errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[830]);
C_word *av2=av;
av2[0]=*((C_word*)lf[830]+1);
av2[1]=t3;
tp(2,av2);}}}

/* k40916 in k40913 in a40910 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in ... */
static void C_ccall f_40918(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_40918,c,av);}
a=C_alloc(3);
if(C_truep(((C_word*)t0)[2])){
/* library.scm:6946: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[300]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[2];
tp(5,av2);}}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40931,a[2]=((C_word*)t0)[3],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6949: ##sys#errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1339]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1339]+1);
av2[1]=t2;
tp(2,av2);}}}

/* k40929 in k40916 in k40913 in a40910 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in ... */
static void C_ccall f_40931(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_40931,c,av);}
/* library.scm:6947: ##sys#signal-hook/errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[379]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[379]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[467];
av2[3]=t1;
av2[4]=lf[1596];
av2[5]=lf[1597];
tp(6,av2);}}

/* a40935 in k35075 in k34855 in k34429 in k34426 in k34423 in k34420 in k34415 in k34411 in k34270 in k33254 in k33251 in k33248 in k32481 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in ... */
static void C_ccall f_40936(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_40936,c,av);}
/* library.scm:6952: ##sys#change-directory-hook */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1354]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1354]+1);
av2[1]=t1;
av2[2]=t2;
tp(3,av2);}}

/* a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_40951(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand((c-3)*C_SIZEOF_PAIR +8,c,2)))){
C_save_and_reclaim((void*)f_40951,c,av);}
a=C_alloc((c-3)*C_SIZEOF_PAIR+8);
t3=C_build_rest(&a,c,3,av);
C_word t4;
C_word t5;
C_word t6;
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40955,a[2]=t1,a[3]=t3,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41090,a[2]=((C_word)li1230),tmp=(C_word)a,a+=3,tmp);
/* library.scm:6054: ##sys#error-handler */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1143]);
C_word *av2=av;
av2[0]=*((C_word*)lf[1143]+1);
av2[1]=t4;
av2[2]=t5;
tp(3,av2);}}

/* k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_40955(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_40955,c,av);}
a=C_alloc(5);
t2=C_mk_bool(C_gui_mode);
if(C_truep(C_i_not(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_40964,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6056: ##sys#print */
t4=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1606];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41040,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6076: scheme#open-output-string */
t4=*((C_word*)lf[318]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_40964(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_40964,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40967,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)t0)[4])){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41034,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6058: ##sys#print */
t4=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1605];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_40967(2,av2);}}}

/* k40965 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_40967(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_40967,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40970,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40978,a[2]=((C_word*)t0)[3],a[3]=((C_word)li1227),tmp=(C_word)a,a+=4,tmp);
/* library.scm:6060: ##sys#with-print-length-limit */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1065]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[1065]+1);
av2[1]=t2;
av2[2]=C_fix(400);
av2[3]=t3;
tp(4,av2);}}

/* k40968 in k40965 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_40970(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_40970,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40973,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6072: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_make_character(10);
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k40971 in k40968 in k40965 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_40973(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_40973,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_40976,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6073: chicken.base#print-call-chain */
t3=*((C_word*)lf[228]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k40974 in k40971 in k40968 in k40965 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_40976(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_40976,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_halt(C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* a40977 in k40965 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_40978(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_40978,c,av);}
a=C_alloc(6);
t2=C_eqp(C_fix(1),C_u_i_length(((C_word*)t0)[2]));
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_40988,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6064: ##sys#print */
t4=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[1604];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41008,a[2]=t4,a[3]=((C_word)li1226),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_41008(t6,t1,((C_word*)t0)[2]);}}

/* k40986 in a40977 in k40965 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_40988(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_40988,c,av);}
/* library.scm:6065: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_slot(((C_word*)t0)[3],C_fix(0));
av2[3]=C_SCHEME_TRUE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k40998 in for-each-loop7078 in a40977 in k40965 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_41000(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_41000,c,av);}
/* library.scm:6070: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=C_SCHEME_TRUE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* for-each-loop7078 in a40977 in k40965 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_41008(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,4)))){
C_save_and_reclaim_args((void *)trf_41008,3,t0,t1,t2);}
a=C_alloc(9);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41018,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
t4=C_slot(t2,C_fix(0));
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41000,a[2]=t3,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
/* library.scm:6069: ##sys#print */
t6=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t6;
av2[1]=t5;
av2[2]=C_make_character(10);
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t6+1)))(5,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k41016 in for-each-loop7078 in a40977 in k40965 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_41018(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_41018,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_41008(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k41032 in k40962 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_41034(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_41034,c,av);}
/* library.scm:6059: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=C_SCHEME_FALSE;
av2[4]=*((C_word*)lf[840]+1);
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k41038 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in ... */
static void C_ccall f_41040(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_41040,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41043,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
if(C_truep(((C_word*)t0)[4])){
/* library.scm:6077: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=C_SCHEME_FALSE;
av2[4]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_41043(2,av2);}}}

/* k41041 in k41038 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in ... */
static void C_ccall f_41043(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_41043,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41046,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* library.scm:6078: ##sys#print */
t3=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_make_character(10);
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k41044 in k41041 in k41038 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in ... */
static void C_ccall f_41046(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,3)))){
C_save_and_reclaim((void *)f_41046,c,av);}
a=C_alloc(15);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41047,a[2]=((C_word*)t0)[2],a[3]=((C_word)li1228),tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41057,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41063,a[2]=t5,a[3]=t2,a[4]=((C_word)li1229),tmp=(C_word)a,a+=5,tmp));
t7=((C_word*)t5)[1];
f_41063(t7,t3,((C_word*)t0)[4]);}

/* g7104 in k41044 in k41041 in k41038 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_41047(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,4)))){
C_save_and_reclaim_args((void *)trf_41047,3,t0,t1,t2);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41051,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* library.scm:6079: ##sys#print */
t4=*((C_word*)lf[1011]+1);{
C_word av2[5];
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
av2[3]=C_SCHEME_TRUE;
av2[4]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}

/* k41049 in g7104 in k41044 in k41041 in k41038 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_41051(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_41051,c,av);}
/* library.scm:6079: ##sys#print */
t2=*((C_word*)lf[1011]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_make_character(10);
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k41055 in k41044 in k41041 in k41038 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void C_ccall f_41057(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_41057,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41061,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* library.scm:6080: scheme#get-output-string */
t3=*((C_word*)lf[320]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k41059 in k41055 in k41044 in k41041 in k41038 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_41061(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41061,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_halt(t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* for-each-loop7103 in k41044 in k41041 in k41038 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in ... */
static void f_41063(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_41063,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41073,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* library.scm:6079: g7104 */
t4=((C_word*)t0)[3];
f_41047(t4,t3,C_slot(t2,C_fix(0)));}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k41071 in for-each-loop7103 in k41044 in k41041 in k41038 in k40953 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in ... */
static void C_ccall f_41073(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_41073,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_41063(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* a41089 in a40950 in k32142 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in ... */
static void C_ccall f_41090(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41090,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_halt(lf[1607]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* a41092 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_41093(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_41093,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41097,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* library.scm:5944: chicken.base#exit-handler */
t3=*((C_word*)lf[258]+1);{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k41095 in a41092 in k32138 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in ... */
static void C_ccall f_41097(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_41097,c,av);}
/* library.scm:5943: g6972 */
t2=t1;{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_fix((C_word)EX_SOFTWARE);
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* a41101 in k32134 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_41102(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41102,c,av);}
/* library.scm:5939: cleanup-before-exit */
f_32033(t1);}

/* a41107 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41108(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_41108,c,av);}
a=C_alloc(4);
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?C_fix(0):C_get_rest_arg(c,2,av,2,t0));
t4=C_i_check_fixnum(t3);
if(C_truep(C_retrieve2(lf[1090],C_text("exit-in-progress")))){
/* library.scm:5931: ##sys#warn */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[376]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[376]+1);
av2[1]=t1;
av2[2]=lf[1608];
tp(3,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41124,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* library.scm:5933: cleanup-before-exit */
f_32033(t5);}}

/* k41122 in a41107 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_41124(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41124,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_exit_runtime(((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* a41131 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41132(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41132,c,av);}
t3=C_slot(t2,C_fix(10));
t4=C_slot(t2,C_fix(12));
t5=C_slot(t2,C_fix(11));
if(C_truep(C_fixnum_greater_or_equal_p(t3,t5))){
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=C_utf_decode(t4,t3);
t7=C_i_set_i_slot(t2,C_fix(10),C_utf_advance(t4,t3));
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}

/* a41153 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41154(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41154,c,av);}
t3=C_slot(t2,C_fix(10));
t4=C_slot(t2,C_fix(12));
t5=C_slot(t2,C_fix(11));
t6=C_fixnum_greater_or_equal_p(t3,t5);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=(C_truep(t6)?C_SCHEME_END_OF_FILE:C_utf_decode(t4,t3));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* a41171 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41172(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,3)))){
C_save_and_reclaim((void *)f_41172,c,av);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41176,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5683: check */
t5=((C_word*)((C_word*)t0)[2])[1];{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
av2[3]=C_fix(1);
((C_proc)C_fast_retrieve_proc(t5))(4,av2);}}

/* k41174 in a41171 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_41176(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41176,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(10));
t3=C_slot(((C_word*)t0)[2],C_fix(12));
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_i_slot(((C_word*)t0)[2],C_fix(10),C_utf_insert(t3,t2,((C_word*)t0)[4]));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41187 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41188(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_41188,c,av);}
a=C_alloc(7);
t6=C_fixnum_difference(t5,t4);
t7=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_41195,a[2]=t2,a[3]=t3,a[4]=t4,a[5]=t6,a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:5689: check */
t8=((C_word*)((C_word*)t0)[2])[1];{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
av2[2]=t2;
av2[3]=t6;
((C_proc)C_fast_retrieve_proc(t8))(4,av2);}}

/* k41193 in a41187 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_41195(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41195,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(10));
t3=C_slot(((C_word*)t0)[2],C_fix(12));
t4=C_copy_memory_with_offset(t3,((C_word*)t0)[3],t2,((C_word*)t0)[4],((C_word*)t0)[5]);
t5=((C_word*)t0)[6];{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_set_i_slot(((C_word*)t0)[2],C_fix(10),C_fixnum_plus(t2,((C_word*)t0)[5]));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* a41209 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41210(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41210,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a41212 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41213(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41213,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_TRUE;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a41215 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41216(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_41216,c,av);}
a=C_alloc(11);
t6=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t7=C_slot(t2,C_fix(10));
t8=C_slot(t2,C_fix(12));
t9=C_slot(t2,C_fix(11));
t10=C_fixnum_difference(t9,t7);
t11=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_41229,a[2]=t4,a[3]=t8,a[4]=t5,a[5]=t7,a[6]=t6,a[7]=t2,a[8]=t1,tmp=(C_word)a,a+=9,tmp);
t12=C_i_not(((C_word*)t6)[1]);
if(C_truep(t12)){
if(C_truep(t12)){
t13=C_set_block_item(t6,0,t10);
t14=t11;
f_41229(t14,t13);}
else{
t13=t11;
f_41229(t13,C_SCHEME_UNDEFINED);}}
else{
if(C_truep(C_fixnum_greaterp(((C_word*)t6)[1],t10))){
t13=C_set_block_item(t6,0,t10);
t14=t11;
f_41229(t14,t13);}
else{
t13=t11;
f_41229(t13,C_SCHEME_UNDEFINED);}}}

/* k41227 in a41215 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void f_41229(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,1)))){
C_save_and_reclaim_args((void *)trf_41229,2,t0,t1);}
t2=C_copy_memory_with_offset(((C_word*)t0)[2],((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)((C_word*)t0)[6])[1]);
t3=C_fixnum_plus(((C_word*)t0)[5],((C_word*)((C_word*)t0)[6])[1]);
t4=C_i_set_i_slot(((C_word*)t0)[7],C_fix(10),t3);
t5=((C_word*)t0)[8];{
C_word av2[2];
av2[0]=t5;
av2[1]=((C_word*)((C_word*)t0)[6])[1];
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* a41251 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41252(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,5)))){
C_save_and_reclaim((void *)f_41252,c,av);}
a=C_alloc(11);
t4=C_slot(t2,C_fix(10));
t5=C_slot(t2,C_fix(11));
t6=C_slot(t2,C_fix(12));
t7=(C_truep(t3)?C_fixnum_plus(t4,t3):t5);
if(C_truep(C_fixnum_greater_or_equal_p(t4,t5))){
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t8=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_41276,a[2]=t7,a[3]=t5,a[4]=t6,a[5]=t4,a[6]=((C_word)li878),tmp=(C_word)a,a+=7,tmp);
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41295,a[2]=t2,a[3]=((C_word)li879),tmp=(C_word)a,a+=4,tmp);
/* library.scm:5712: ##sys#call-with-values */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t8;
av2[3]=t9;
C_call_with_values(4,av2);}}}

/* a41275 in a41251 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_41276(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_41276,c,av);}
a=C_alloc(3);
t2=C_fixnum_greaterp(((C_word*)t0)[2],((C_word*)t0)[3]);
t3=(C_truep(t2)?((C_word*)t0)[3]:((C_word*)t0)[2]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41286,a[2]=((C_word)li877),tmp=(C_word)a,a+=3,tmp);
/* library.scm:5713: ##sys#scan-buffer-line */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[1067]);
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[1067]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[4];
av2[3]=t3;
av2[4]=((C_word*)t0)[5];
av2[5]=t4;
tp(6,av2);}}

/* a41285 in a41275 in a41251 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in ... */
static void C_ccall f_41286(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_41286,c,av);}
/* library.scm:5715: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_SCHEME_FALSE;
av2[3]=t2;
av2[4]=C_SCHEME_FALSE;
C_values(5,av2);}}

/* a41294 in a41251 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_41295(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41295,c,av);}
if(C_truep(t4)){
t5=C_slot(((C_word*)t0)[2],C_fix(4));
t6=C_fixnum_plus(t5,C_fix(1));
t7=C_i_set_i_slot(((C_word*)t0)[2],C_fix(4),t6);
t8=C_i_set_i_slot(((C_word*)t0)[2],C_fix(5),C_fix(0));
t9=C_i_set_i_slot(((C_word*)t0)[2],C_fix(10),t2);
t10=t1;{
C_word *av2=av;
av2[0]=t10;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
t5=C_slot(((C_word*)t0)[2],C_fix(5));
t6=C_i_string_length(t3);
t7=C_i_set_i_slot(((C_word*)t0)[2],C_fix(5),C_fixnum_plus(t5,t6));
t8=C_i_set_i_slot(((C_word*)t0)[2],C_fix(10),t2);
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}}

/* a41335 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in ... */
static void C_ccall f_41336(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_41336,c,av);}
a=C_alloc(5);
t3=C_slot(t2,C_fix(10));
t4=C_slot(t2,C_fix(11));
if(C_truep(C_fixnum_greater_or_equal_p(t3,t4))){
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=lf[1068];
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_fixnum_difference(t4,t3);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41358,a[2]=t2,a[3]=t4,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:5731: ##sys#buffer->string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[300]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[300]+1);
av2[1]=t6;
av2[2]=C_fast_retrieve(lf[1069]);
av2[3]=t3;
av2[4]=t5;
tp(5,av2);}}}

/* k41356 in a41335 in k30994 in k29798 in k29794 in k29790 in k26137 in k26133 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in ... */
static void C_ccall f_41358(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41358,c,av);}
t2=C_i_set_i_slot(((C_word*)t0)[2],C_fix(10),((C_word*)t0)[3]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a41366 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in ... */
static void C_ccall f_41367(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_41367,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41371,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep(t2)){
/* library.scm:4551: ##sys#check-keyword */
t4=*((C_word*)lf[417]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=t2;
av2[3]=lf[1610];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}
else{
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k41369 in a41366 in k26129 in k26125 in k26121 in k26111 in k25757 in k25753 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in ... */
static void C_ccall f_41371(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41371,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* a41375 in k25749 in k25745 in k25741 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in ... */
static void C_ccall f_41376(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41376,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_set_car(C_i_list_tail(t2,t3),t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* a41385 in k25737 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in ... */
static void C_ccall f_41386(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41386,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_cdr(C_i_cddr(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41395 in k25733 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in ... */
static void C_ccall f_41396(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41396,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_cdr(C_i_cdar(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41405 in k25729 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in ... */
static void C_ccall f_41406(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41406,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_cdr(C_i_cadr(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41415 in k25725 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in ... */
static void C_ccall f_41416(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41416,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_cdr(C_i_caar(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41425 in k25721 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in ... */
static void C_ccall f_41426(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41426,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_car(C_i_cddr(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41435 in k25717 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in ... */
static void C_ccall f_41436(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41436,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_car(C_i_cdar(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41445 in k25713 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in ... */
static void C_ccall f_41446(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41446,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_car(C_i_cadr(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41455 in k25709 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in ... */
static void C_ccall f_41456(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41456,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_car(C_i_caar(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41465 in k25705 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in ... */
static void C_ccall f_41466(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41466,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_cdr(C_i_cdr(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41475 in k25701 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in ... */
static void C_ccall f_41476(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41476,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_cdr(C_i_car(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41485 in k25697 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in ... */
static void C_ccall f_41486(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41486,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_car(C_i_cdr(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41495 in k25693 in k25689 in k25609 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in ... */
static void C_ccall f_41496(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41496,c,av);}
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_set_car(C_i_car(t2),t3);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41505 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_41506(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_41506,c,av);}
a=C_alloc(7);
if(C_truep(C_i_closurep(t2))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41522,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41530,a[2]=((C_word)li1249),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4366: ##sys#lambda-decoration */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[889]);
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[889]+1);
av2[1]=t3;
av2[2]=t2;
av2[3]=t4;
tp(4,av2);}}
else{
/* library.scm:4368: ##sys#error */
t3=*((C_word*)lf[195]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=lf[896];
av2[3]=lf[1612];
av2[4]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}}

/* k41520 in a41505 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_41522(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_41522,c,av);}
if(C_truep(t1)){
t2=C_slot(t1,C_fix(1));
if(C_truep(t2)){
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* library.scm:4368: ##sys#error */
t3=*((C_word*)lf[195]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[896];
av2[3]=lf[1612];
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}}
else{
/* library.scm:4368: ##sys#error */
t2=*((C_word*)lf[195]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[896];
av2[3]=lf[1612];
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}}

/* a41529 in a41505 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_41530(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41530,c,av);}
t3=C_i_pairp(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=(C_truep(t3)?C_eqp(C_retrieve2(lf[897],C_text("setter-tag")),C_slot(t2,C_fix(0))):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41545 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_41546(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41546,c,av);}
t3=C_i_pairp(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=(C_truep(t3)?C_eqp(C_retrieve2(lf[897],C_text("setter-tag")),C_slot(t2,C_fix(0))):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41561 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in ... */
static void C_ccall f_41562(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_41562,c,av);}
a=C_alloc(6);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41572,a[2]=((C_word)li1254),tmp=(C_word)a,a+=3,tmp);
t5=C_a_i_cons(&a,2,C_retrieve2(lf[897],C_text("setter-tag")),t4);
t6=C_i_setslot(t2,t3,t5);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* a41571 in a41561 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in ... */
static void C_ccall f_41572(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,4)))){
C_save_and_reclaim((void *)f_41572,c,av);}
a=C_alloc(11);
if(C_truep(C_i_closurep(t2))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41582,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41601,a[2]=((C_word)li1252),tmp=(C_word)a,a+=3,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41617,a[2]=t3,a[3]=((C_word)li1253),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4377: ##sys#decorate-lambda */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[888]);
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[888]+1);
av2[1]=t4;
av2[2]=t2;
av2[3]=t5;
av2[4]=t6;
tp(5,av2);}}
else{
/* library.scm:4384: chicken.base#error */
t4=*((C_word*)lf[234]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t1;
av2[2]=lf[1613];
av2[3]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}}

/* k41580 in a41571 in a41561 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_41582(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_41582,c,av);}
a=C_alloc(6);
t2=C_eqp(((C_word*)t0)[2],t1);
if(C_truep(t2)){
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_a_i_cons(&a,2,((C_word*)t0)[2],t1);
t4=C_a_i_list1(&a,1,t3);
/* library.scm:4383: ##sys#become! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[396]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[396]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=t4;
tp(3,av2);}}}

/* a41600 in a41571 in a41561 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_41601(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41601,c,av);}
t3=C_i_pairp(t2);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=(C_truep(t3)?C_eqp(C_retrieve2(lf[897],C_text("setter-tag")),C_slot(t2,C_fix(0))):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* a41616 in a41571 in a41561 in k24688 in k24685 in k24682 in k24679 in k24675 in k24671 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in ... */
static void C_ccall f_41617(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_41617,c,av);}
a=C_alloc(3);
t4=C_a_i_cons(&a,2,C_retrieve2(lf[897],C_text("setter-tag")),((C_word*)t0)[2]);
t5=C_i_setslot(t2,t3,t4);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* a41629 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41630(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_41630,c,av);}
a=C_alloc(7);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41636,a[2]=t2,a[3]=t4,a[4]=((C_word)li667),tmp=(C_word)a,a+=5,tmp));
t6=((C_word*)t4)[1];{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
f_41636(2,av2);}}

/* loop in a41629 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41636(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,6)))){
C_save_and_reclaim((void *)f_41636,c,av);}
a=C_alloc(5);
t2=C_slot(((C_word*)t0)[2],C_fix(10));
if(C_truep(t2)){
t3=C_i_set_i_slot(((C_word*)t0)[2],C_fix(10),C_SCHEME_FALSE);
/* library.scm:3982: ##sys#decode-char */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[465]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[465]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=C_slot(((C_word*)t0)[2],C_fix(15));
av2[4]=C_fix(0);
tp(5,av2);}}
else{
t3=C_slot(((C_word*)t0)[2],C_fix(15));
t4=C_eqp(lf[457],t3);
if(C_truep(t4)){
t5=C_read_char(((C_word*)t0)[2]);
t6=C_eqp(C_fix(-1),t5);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41668,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* library.scm:3986: ##sys#update-errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[830]);
C_word *av2=av;
av2[0]=*((C_word*)lf[830]+1);
av2[1]=t7;
tp(2,av2);}}
else{
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}
else{
t5=C_slot(((C_word*)t0)[2],C_fix(15));
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41698,a[2]=((C_word)li666),tmp=(C_word)a,a+=3,tmp);
/* library.scm:3994: ##sys#read-char/encoding */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[466]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[466]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[2];
av2[3]=t5;
av2[4]=t6;
tp(5,av2);}}}}

/* k41666 in loop in a41629 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41668(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_41668,c,av);}
a=C_alloc(11);
t2=C_fix((C_word)EINTR);
t3=C_eqp(t1,t2);
if(C_truep(t3)){
/* library.scm:3988: ##sys#dispatch-interrupt */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[827]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[827]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)((C_word*)t0)[3])[1];
tp(3,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41684,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41688,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t6=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=C_mpointer(&a,(void*)strerror(errno));
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}}

/* k41682 in k41666 in loop in a41629 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41684(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_41684,c,av);}
/* library.scm:3989: ##sys#signal-hook/errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[379]);
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[379]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[467];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[468];
av2[5]=t1;
av2[6]=((C_word*)t0)[4];
tp(7,av2);}}

/* k41686 in k41666 in loop in a41629 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41688(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_41688,c,av);}
/* library.scm:3991: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[828];
av2[3]=t1;
tp(4,av2);}}

/* a41697 in loop in a41629 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41698(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_41698,c,av);}
a=C_alloc(3);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41704,a[2]=((C_word)li665),tmp=(C_word)a,a+=3,tmp);
/* library.scm:3997: dec */
t7=t5;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
av2[4]=t4;
av2[5]=t6;
((C_proc)C_fast_retrieve_proc(t7))(6,av2);}}

/* a41703 in a41697 in loop in a41629 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41704(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41704,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_utf_decode(t2,t3);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* a41710 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41711(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,6)))){
C_save_and_reclaim((void *)f_41711,c,av);}
a=C_alloc(4);
t3=C_slot(t2,C_fix(10));
t4=C_slot(t2,C_fix(15));
if(C_truep(t3)){
/* library.scm:4004: ##sys#decode-char */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[465]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[465]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=t4;
av2[4]=C_fix(0);
tp(5,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41729,a[2]=t2,a[3]=((C_word)li670),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4005: ##sys#read-char/encoding */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[466]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[466]+1);
av2[1]=t1;
av2[2]=t2;
av2[3]=t4;
av2[4]=t5;
tp(5,av2);}}}

/* a41728 in a41710 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41729(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_41729,c,av);}
a=C_alloc(8);
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_41733,a[2]=t2,a[3]=t3,a[4]=t4,a[5]=((C_word*)t0)[2],a[6]=t5,a[7]=t1,tmp=(C_word)a,a+=8,tmp);
/* library.scm:4008: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=t4;
tp(3,av2);}}

/* k41731 in a41728 in a41710 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41733(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,5)))){
C_save_and_reclaim((void *)f_41733,c,av);}
a=C_alloc(3);
t2=C_copy_memory_with_offset(t1,((C_word*)t0)[2],C_fix(0),((C_word*)t0)[3],((C_word*)t0)[4]);
t3=C_i_setslot(((C_word*)t0)[5],C_fix(10),t1);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41741,a[2]=((C_word)li669),tmp=(C_word)a,a+=3,tmp);
/* library.scm:4011: dec */
t5=((C_word*)t0)[6];{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t5;
av2[1]=((C_word*)t0)[7];
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[3];
av2[4]=((C_word*)t0)[4];
av2[5]=t4;
((C_proc)C_fast_retrieve_proc(t5))(6,av2);}}

/* a41740 in k41731 in a41728 in a41710 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41741(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41741,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_utf_decode(t2,t3);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* a41743 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41744(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_41744,c,av);}
a=C_alloc(6);
t4=C_slot(t2,C_fix(15));
t5=C_eqp(t4,lf[457]);
if(C_truep(t5)){
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_display_char(t2,t3);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_41757,a[2]=t2,a[3]=t1,a[4]=t3,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
/* library.scm:4018: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=C_fix(4);
tp(3,av2);}}}

/* k41755 in a41743 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41757(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_41757,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41760,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* library.scm:4019: ##sys#encode-char */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[464]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[464]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=t1;
av2[4]=((C_word*)t0)[5];
tp(5,av2);}}

/* k41758 in k41755 in a41743 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41760(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_41760,c,av);}
t2=C_slot(((C_word*)t0)[2],C_fix(2));
/* library.scm:4018: g4875 */
t3=C_slot(t2,C_fix(3));{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[4];
av2[4]=C_fix(0);
av2[5]=t1;
((C_proc)C_fast_retrieve_proc(t3))(6,av2);}}

/* a41771 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41772(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,6)))){
C_save_and_reclaim((void *)f_41772,c,av);}
a=C_alloc(4);
t6=C_fixnum_difference(t5,t4);
t7=C_slot(t2,C_fix(15));
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_41786,a[2]=t2,a[3]=((C_word)li673),tmp=(C_word)a,a+=4,tmp);
/* library.scm:4022: ##sys#encode-buffer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[462]+1));
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[462]+1);
av2[1]=t1;
av2[2]=t3;
av2[3]=t4;
av2[4]=t6;
av2[5]=t7;
av2[6]=t8;
tp(7,av2);}}

/* a41785 in a41771 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41786(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41786,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_display_string(((C_word*)t0)[2],t2,t3,t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* a41788 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41789(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41789,c,av);}
t4=C_close_file(t2);
/* library.scm:4028: ##sys#update-errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[830]);
C_word *av2=av;
av2[0]=*((C_word*)lf[830]+1);
av2[1]=t1;
tp(2,av2);}}

/* a41794 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41795(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41795,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_flush_output(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a41797 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41798(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_41798,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_char_ready_p(t2);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a41800 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41801(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(14,c,2)))){
C_save_and_reclaim((void *)f_41801,c,av);}
a=C_alloc(14);
t6=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t7=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t8=C_slot(t2,C_fix(10));
t9=C_fix(0);
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_41808,a[2]=t6,a[3]=t4,a[4]=t7,a[5]=t2,a[6]=t1,a[7]=t10,tmp=(C_word)a,a+=8,tmp);
if(C_truep(t8)){
t12=C_block_size(t8);
t13=C_set_block_item(t10,0,t12);
t14=C_copy_memory_with_offset(t4,t8,((C_word*)t7)[1],C_fix(0),((C_word*)t10)[1]);
t15=C_fixnum_plus(((C_word*)t7)[1],((C_word*)t10)[1]);
t16=C_set_block_item(t7,0,t15);
t17=C_fixnum_difference(((C_word*)t6)[1],((C_word*)t10)[1]);
t18=C_set_block_item(t6,0,t17);
t19=t11;
f_41808(t19,C_i_set_i_slot(t2,C_fix(10),C_SCHEME_FALSE));}
else{
t12=t11;
f_41808(t12,C_SCHEME_UNDEFINED);}}

/* k41806 in a41800 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_41808(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,5)))){
C_save_and_reclaim_args((void *)trf_41808,2,t0,t1);}
a=C_alloc(9);
t2=((C_word*)((C_word*)t0)[2])[1];
t3=(C_truep(t2)?t2:C_fixnum_difference(C_block_size(((C_word*)t0)[3]),((C_word*)((C_word*)t0)[4])[1]));
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_41817,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[5],a[4]=t5,a[5]=((C_word*)t0)[2],a[6]=((C_word)li679),tmp=(C_word)a,a+=7,tmp));
t7=((C_word*)t5)[1];
f_41817(t7,((C_word*)t0)[6],t3,((C_word*)((C_word*)t0)[7])[1],((C_word*)((C_word*)t0)[4])[1]);}

/* loop in k41806 in a41800 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_41817(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(10,0,4)))){
C_save_and_reclaim_args((void *)trf_41817,5,t0,t1,t2,t3,t4);}
a=C_alloc(10);
t5=fast_read_string_from_file(((C_word*)t0)[2],((C_word*)t0)[3],t2,t4);
if(C_truep(C_eofp(t5))){
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
if(C_truep(C_fixnum_lessp(t5,C_fix(0)))){
t6=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_41833,a[2]=((C_word*)t0)[4],a[3]=t2,a[4]=t3,a[5]=t4,a[6]=t1,a[7]=((C_word*)t0)[3],a[8]=((C_word*)t0)[5],a[9]=((C_word*)t0)[2],tmp=(C_word)a,a+=10,tmp);
/* library.scm:4050: ##sys#update-errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[830]);
C_word av2[2];
av2[0]=*((C_word*)lf[830]+1);
av2[1]=t6;
tp(2,av2);}}
else{
if(C_truep(C_fixnum_lessp(t5,t2))){
/* library.scm:4059: loop */
t8=t1;
t9=C_fixnum_difference(t2,t5);
t10=C_fixnum_plus(t3,t5);
t11=C_fixnum_plus(t4,t5);
t1=t8;
t2=t9;
t3=t10;
t4=t11;
goto loop;}
else{
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=C_fixnum_plus(t3,t5);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}}}

/* k41831 in loop in k41806 in a41800 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41833(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,3)))){
C_save_and_reclaim((void *)f_41833,c,av);}
a=C_alloc(14);
t2=C_fix((C_word)EINTR);
t3=C_eqp(t1,t2);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_41844,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word)li678),tmp=(C_word)a,a+=7,tmp);
/* library.scm:4052: ##sys#dispatch-interrupt */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[827]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[827]+1);
av2[1]=((C_word*)t0)[6];
av2[2]=t4;
tp(3,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_41855,a[2]=((C_word*)t0)[6],a[3]=t1,a[4]=((C_word*)t0)[7],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[9],a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_41859,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t6=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=C_mpointer(&a,(void*)strerror(errno));
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}}

/* a41843 in k41831 in loop in k41806 in a41800 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_41844(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_41844,c,av);}
/* library.scm:4053: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_41817(t2,t1,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}

/* k41853 in k41831 in loop in k41806 in a41800 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_41855(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,9)))){
C_save_and_reclaim((void *)f_41855,c,av);}
/* library.scm:4054: ##sys#signal-hook/errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[379]);
C_word *av2;
if(c >= 10) {
  av2=av;
} else {
  av2=C_alloc(10);
}
av2[0]=*((C_word*)lf[379]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[467];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[831];
av2[5]=t1;
av2[6]=((C_word*)t0)[4];
av2[7]=((C_word*)((C_word*)t0)[5])[1];
av2[8]=((C_word*)t0)[6];
av2[9]=((C_word*)t0)[7];
tp(10,av2);}}

/* k41857 in k41831 in loop in k41806 in a41800 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_41859(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_41859,c,av);}
/* library.scm:4056: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[832];
av2[3]=t1;
tp(4,av2);}}

/* a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41908(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_41908,c,av);}
a=C_alloc(9);
t4=(C_truep(t3)?C_i_check_fixnum_2(t3,lf[833]):C_SCHEME_UNDEFINED);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_41915,a[2]=t3,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_slot(t2,C_fix(12)))){
t6=t5;
f_41915(t6,C_SCHEME_UNDEFINED);}
else{
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_42094,a[2]=t5,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4065: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t6;
av2[2]=C_fix(1024);
tp(3,av2);}}}

/* k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_41915(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,7)))){
C_save_and_reclaim_args((void *)trf_41915,2,t0,t1);}
a=C_alloc(8);
t2=(C_truep(((C_word*)t0)[2])?((C_word*)t0)[2]:lf[334]);
t3=C_slot(((C_word*)t0)[3],C_fix(12));
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_41928,a[2]=((C_word*)t0)[3],a[3]=t5,a[4]=((C_word*)t0)[2],a[5]=((C_word)li682),tmp=(C_word)a,a+=6,tmp));
t7=((C_word*)t5)[1];
f_41928(t7,((C_word*)t0)[4],C_fix(1024),t2,t3,lf[835],C_SCHEME_FALSE);}

/* loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void f_41928(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6){
C_word tmp;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,5)))){
C_save_and_reclaim_args((void *)trf_41928,7,t0,t1,t2,t3,t4,t5,t6);}
a=C_alloc(11);
t7=C_i_fixnum_min(t3,t2);
t8=fast_read_line_from_file(t4,((C_word*)t0)[2],t7);
if(C_truep(C_eofp(t8))){
t9=t1;{
C_word av2[2];
av2[0]=t9;
av2[1]=(C_truep(t6)?t5:C_SCHEME_END_OF_FILE);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}
else{
if(C_truep(C_i_not(t8))){
t9=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_41950,a[2]=t3,a[3]=t2,a[4]=t1,a[5]=t5,a[6]=((C_word*)t0)[3],tmp=(C_word)a,a+=7,tmp);
/* library.scm:4076: ##sys#buffer->string/encoding */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[461]+1));
C_word av2[6];
av2[0]=*((C_word*)lf[461]+1);
av2[1]=t9;
av2[2]=t4;
av2[3]=C_fix(0);
av2[4]=t7;
av2[5]=C_slot(((C_word*)t0)[2],C_fix(15));
tp(6,av2);}}
else{
if(C_truep(C_fixnum_lessp(t8,C_fix(0)))){
t9=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_41995,a[2]=t8,a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=t3,a[6]=t4,a[7]=t5,a[8]=((C_word*)t0)[2],a[9]=t1,a[10]=((C_word*)t0)[4],tmp=(C_word)a,a+=11,tmp);
/* library.scm:4086: ##sys#update-errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[830]);
C_word av2[2];
av2[0]=*((C_word*)lf[830]+1);
av2[1]=t9;
tp(2,av2);}}
else{
if(C_truep(t6)){
t9=C_slot(((C_word*)t0)[2],C_fix(4));
t10=C_fixnum_plus(t9,C_fix(1));
t11=C_i_set_i_slot(((C_word*)t0)[2],C_fix(4),t10);
t12=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_42054,a[2]=t1,a[3]=t5,tmp=(C_word)a,a+=4,tmp);
/* library.scm:4102: ##sys#buffer->string/encoding */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[461]+1));
C_word av2[6];
av2[0]=*((C_word*)lf[461]+1);
av2[1]=t12;
av2[2]=t4;
av2[3]=C_fix(0);
av2[4]=t8;
av2[5]=C_slot(((C_word*)t0)[2],C_fix(15));
tp(6,av2);}}
else{
t9=C_slot(((C_word*)t0)[2],C_fix(4));
t10=C_fixnum_plus(t9,C_fix(1));
t11=C_i_set_i_slot(((C_word*)t0)[2],C_fix(4),t10);
/* library.scm:4105: ##sys#buffer->string/encoding */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[461]+1));
C_word av2[6];
av2[0]=*((C_word*)lf[461]+1);
av2[1]=t1;
av2[2]=t4;
av2[3]=C_fix(0);
av2[4]=t8;
av2[5]=C_slot(((C_word*)t0)[2],C_fix(15));
tp(6,av2);}}}}}}

/* k41948 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41950(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_41950,c,av);}
a=C_alloc(8);
if(C_truep(C_fixnum_lessp(((C_word*)t0)[2],((C_word*)t0)[3]))){
/* library.scm:4079: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[5];
av2[3]=t1;
tp(4,av2);}}
else{
t2=C_fixnum_times(((C_word*)t0)[3],C_fix(2));
t3=C_fixnum_difference(((C_word*)t0)[2],((C_word*)t0)[3]);
t4=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_41974,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=t2,a[5]=t3,a[6]=((C_word*)t0)[5],a[7]=t1,tmp=(C_word)a,a+=8,tmp);
/* library.scm:4082: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[301]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[301]+1);
av2[1]=t4;
av2[2]=C_fixnum_times(((C_word*)t0)[3],C_fix(2));
tp(3,av2);}}}

/* k41972 in k41948 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_41974(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_41974,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_41978,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* library.scm:4083: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=((C_word*)t0)[7];
tp(4,av2);}}

/* k41976 in k41972 in k41948 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in ... */
static void C_ccall f_41978(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_41978,c,av);}
/* library.scm:4080: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_41928(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6],t1,C_SCHEME_TRUE);}

/* k41993 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_41995(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_41995,c,av);}
a=C_alloc(12);
t2=C_fix((C_word)EINTR);
t3=C_eqp(t1,t2);
if(C_truep(t3)){
t4=C_fixnum_negate(((C_word*)t0)[2]);
t5=C_fixnum_difference(t4,C_fix(1));
t6=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_42009,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=t5,a[8]=((C_word*)t0)[8],a[9]=((C_word)li681),tmp=(C_word)a,a+=10,tmp);
/* library.scm:4089: ##sys#dispatch-interrupt */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[827]);
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[827]+1);
av2[1]=((C_word*)t0)[9];
av2[2]=t6;
tp(3,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_42036,a[2]=((C_word*)t0)[9],a[3]=t1,a[4]=((C_word*)t0)[8],a[5]=((C_word*)t0)[10],tmp=(C_word)a,a+=6,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_42040,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t6=*((C_word*)lf[829]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t5;
av2[2]=C_mpointer(&a,(void*)strerror(errno));
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}}

/* a42008 in k41993 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_42009(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,5)))){
C_save_and_reclaim((void *)f_42009,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_42017,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_42021,a[2]=t2,a[3]=((C_word*)t0)[6],tmp=(C_word)a,a+=4,tmp);
/* library.scm:4094: ##sys#buffer->string/encoding */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[461]+1));
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[461]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[5];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[7];
av2[5]=C_slot(((C_word*)t0)[8],C_fix(15));
tp(6,av2);}}

/* k42015 in a42008 in k41993 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in ... */
static void C_ccall f_42017(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_42017,c,av);}
/* library.scm:4091: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_41928(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6],t1,C_SCHEME_TRUE);}

/* k42019 in a42008 in k41993 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in ... */
static void C_ccall f_42021(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_42021,c,av);}
/* library.scm:4092: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k42034 in k41993 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_42036(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,7)))){
C_save_and_reclaim((void *)f_42036,c,av);}
/* library.scm:4096: ##sys#signal-hook/errno */
{C_proc tp=(C_proc)C_fast_retrieve_symbol_proc(lf[379]);
C_word *av2;
if(c >= 8) {
  av2=av;
} else {
  av2=C_alloc(8);
}
av2[0]=*((C_word*)lf[379]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[467];
av2[3]=((C_word*)t0)[3];
av2[4]=lf[833];
av2[5]=t1;
av2[6]=((C_word*)t0)[4];
av2[7]=((C_word*)t0)[5];
tp(8,av2);}}

/* k42038 in k41993 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 in ... */
static void C_ccall f_42040(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_42040,c,av);}
/* library.scm:4098: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=lf[834];
av2[3]=t1;
tp(4,av2);}}

/* k42052 in loop in k41913 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_42054(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_42054,c,av);}
/* library.scm:4101: ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[507]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[507]+1);
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
tp(4,av2);}}

/* k42092 in a41907 in k24156 in k24153 in k24150 in k24147 in k24144 in k24141 in k24138 in k24135 in k24132 in k24129 in k24126 in k24123 in k24120 in k24117 in k23957 in k12559 in k11436 */
static void C_ccall f_42094(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_42094,c,av);}
t2=((C_word*)t0)[2];
f_41915(t2,C_i_setslot(((C_word*)t0)[3],C_fix(12),t1));}

/* toplevel */
static int toplevel_initialized=0;

void C_ccall C_library_toplevel(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(toplevel_initialized) {C_kontinue(t1,C_SCHEME_UNDEFINED);}
else C_toplevel_entry(C_text("library"));
C_check_nursery_minimum(C_calculate_demand(3,c,2));
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void*)C_library_toplevel,c,av);}
toplevel_initialized=1;
if(C_unlikely(!C_demand_2(9281))){
C_save(t1);
C_rereclaim2(9281*sizeof(C_word),1);
t1=C_restore;}
a=C_alloc(3);
C_initialize_lf(lf,1631);
lf[0]=C_h_intern(&lf[0],7, C_text("library"));
lf[1]=C_h_intern(&lf[1],7, C_text("scheme#"));
lf[2]=C_h_intern(&lf[2],10, C_text("scheme#not"));
lf[3]=C_h_intern(&lf[3],15, C_text("scheme#boolean?"));
lf[4]=C_h_intern(&lf[4],10, C_text("scheme#eq?"));
lf[5]=C_h_intern(&lf[5],11, C_text("scheme#eqv?"));
lf[6]=C_h_intern(&lf[6],13, C_text("scheme#equal?"));
lf[7]=C_h_intern(&lf[7],16, C_text("scheme#boolean=?"));
lf[8]=C_h_intern(&lf[8],9, C_text("boolean=?"));
lf[9]=C_h_intern(&lf[9],15, C_text("scheme#symbol=?"));
lf[10]=C_h_intern(&lf[10],8, C_text("symbol=?"));
lf[11]=C_h_intern(&lf[11],12, C_text("scheme#pair?"));
lf[12]=C_h_intern(&lf[12],11, C_text("scheme#cons"));
lf[13]=C_h_intern(&lf[13],10, C_text("scheme#car"));
lf[14]=C_h_intern(&lf[14],10, C_text("scheme#cdr"));
lf[15]=C_h_intern(&lf[15],15, C_text("scheme#set-car!"));
lf[16]=C_h_intern(&lf[16],15, C_text("scheme#set-cdr!"));
lf[17]=C_h_intern(&lf[17],11, C_text("scheme#cadr"));
lf[18]=C_h_intern(&lf[18],12, C_text("scheme#caddr"));
lf[19]=C_h_intern(&lf[19],13, C_text("scheme#cadddr"));
lf[20]=C_h_intern(&lf[20],13, C_text("scheme#cddddr"));
lf[21]=C_h_intern(&lf[21],11, C_text("scheme#caar"));
lf[22]=C_h_intern(&lf[22],11, C_text("scheme#cdar"));
lf[23]=C_h_intern(&lf[23],11, C_text("scheme#cddr"));
lf[24]=C_h_intern(&lf[24],12, C_text("scheme#caaar"));
lf[25]=C_h_intern(&lf[25],12, C_text("scheme#caadr"));
lf[26]=C_h_intern(&lf[26],12, C_text("scheme#cadar"));
lf[27]=C_h_intern(&lf[27],12, C_text("scheme#cdaar"));
lf[28]=C_h_intern(&lf[28],12, C_text("scheme#cdadr"));
lf[29]=C_h_intern(&lf[29],12, C_text("scheme#cddar"));
lf[30]=C_h_intern(&lf[30],12, C_text("scheme#cdddr"));
lf[31]=C_h_intern(&lf[31],13, C_text("scheme#caaaar"));
lf[32]=C_h_intern(&lf[32],13, C_text("scheme#caaadr"));
lf[33]=C_h_intern(&lf[33],13, C_text("scheme#caadar"));
lf[34]=C_h_intern(&lf[34],13, C_text("scheme#caaddr"));
lf[35]=C_h_intern(&lf[35],13, C_text("scheme#cadaar"));
lf[36]=C_h_intern(&lf[36],13, C_text("scheme#cadadr"));
lf[37]=C_h_intern(&lf[37],13, C_text("scheme#caddar"));
lf[38]=C_h_intern(&lf[38],13, C_text("scheme#cdaaar"));
lf[39]=C_h_intern(&lf[39],13, C_text("scheme#cdaadr"));
lf[40]=C_h_intern(&lf[40],13, C_text("scheme#cdadar"));
lf[41]=C_h_intern(&lf[41],13, C_text("scheme#cdaddr"));
lf[42]=C_h_intern(&lf[42],13, C_text("scheme#cddaar"));
lf[43]=C_h_intern(&lf[43],13, C_text("scheme#cddadr"));
lf[44]=C_h_intern(&lf[44],13, C_text("scheme#cdddar"));
lf[45]=C_h_intern(&lf[45],12, C_text("scheme#null?"));
lf[46]=C_h_intern(&lf[46],11, C_text("scheme#list"));
lf[47]=C_h_intern(&lf[47],13, C_text("scheme#length"));
lf[48]=C_h_intern(&lf[48],16, C_text("scheme#list-tail"));
lf[49]=C_h_intern(&lf[49],15, C_text("scheme#list-ref"));
lf[50]=C_h_intern(&lf[50],14, C_text("scheme#reverse"));
lf[51]=C_h_intern(&lf[51],29, C_text("##sys#error-not-a-proper-list"));
lf[52]=C_h_intern(&lf[52],7, C_text("reverse"));
lf[53]=C_h_intern(&lf[53],11, C_text("scheme#memq"));
lf[54]=C_h_intern(&lf[54],11, C_text("scheme#memv"));
lf[55]=C_h_intern(&lf[55],13, C_text("scheme#member"));
lf[56]=C_h_intern(&lf[56],11, C_text("scheme#assq"));
lf[57]=C_h_intern(&lf[57],11, C_text("scheme#assv"));
lf[58]=C_h_intern(&lf[58],12, C_text("scheme#assoc"));
lf[59]=C_h_intern(&lf[59],12, C_text("scheme#list?"));
lf[60]=C_h_intern(&lf[60],14, C_text("scheme#string?"));
lf[61]=C_h_intern(&lf[61],20, C_text("scheme#string-length"));
lf[62]=C_h_intern(&lf[62],17, C_text("scheme#string-ref"));
lf[63]=C_h_intern(&lf[63],18, C_text("scheme#string-set!"));
lf[64]=C_h_intern(&lf[64],15, C_text("scheme#string=?"));
lf[65]=C_h_intern(&lf[65],8, C_text("string=?"));
lf[66]=C_h_intern(&lf[66],18, C_text("scheme#string-ci=?"));
lf[67]=C_h_intern(&lf[67],11, C_text("string-ci=?"));
lf[68]=C_h_intern(&lf[68],15, C_text("scheme#features"));
lf[69]=C_h_intern(&lf[69],21, C_text("scheme#call-with-port"));
lf[70]=C_h_intern(&lf[70],17, C_text("scheme#close-port"));
lf[71]=C_h_intern(&lf[71],14, C_text("scheme#peek-u8"));
lf[72]=C_h_intern(&lf[72],17, C_text("scheme#string-map"));
lf[73]=C_h_intern(&lf[73],17, C_text("scheme#vector-map"));
lf[74]=C_h_intern(&lf[74],22, C_text("scheme#string-for-each"));
lf[75]=C_h_intern(&lf[75],22, C_text("scheme#vector-for-each"));
lf[76]=C_h_intern(&lf[76],16, C_text("scheme#make-list"));
lf[77]=C_h_intern(&lf[77],16, C_text("scheme#list-set!"));
lf[78]=C_h_intern(&lf[78],19, C_text("scheme#write-string"));
lf[79]=C_h_intern(&lf[79],17, C_text("scheme#eof-object"));
lf[80]=C_h_intern(&lf[80],16, C_text("scheme#list-copy"));
lf[81]=C_h_intern(&lf[81],21, C_text("scheme#string->vector"));
lf[82]=C_h_intern(&lf[82],21, C_text("scheme#vector->string"));
lf[83]=C_h_intern(&lf[83],12, C_text("scheme#exact"));
lf[84]=C_h_intern(&lf[84],14, C_text("scheme#inexact"));
lf[85]=C_h_intern(&lf[85],21, C_text("scheme#make-parameter"));
lf[86]=C_h_intern(&lf[86],21, C_text("scheme#exact->inexact"));
lf[87]=C_h_intern(&lf[87],10, C_text("scheme#abs"));
lf[88]=C_h_intern(&lf[88],8, C_text("scheme#+"));
lf[89]=C_h_intern(&lf[89],8, C_text("scheme#-"));
lf[90]=C_h_intern(&lf[90],8, C_text("scheme#*"));
lf[91]=C_h_intern(&lf[91],15, C_text("scheme#quotient"));
lf[92]=C_h_intern(&lf[92],16, C_text("scheme#remainder"));
lf[93]=C_h_intern(&lf[93],13, C_text("scheme#modulo"));
lf[94]=C_h_intern(&lf[94],12, C_text("scheme#even?"));
lf[95]=C_h_intern(&lf[95],11, C_text("scheme#odd?"));
lf[96]=C_h_intern(&lf[96],8, C_text("scheme#="));
lf[97]=C_h_intern(&lf[97],8, C_text("scheme#>"));
lf[98]=C_h_intern(&lf[98],8, C_text("scheme#<"));
lf[99]=C_h_intern(&lf[99],9, C_text("scheme#>="));
lf[100]=C_h_intern(&lf[100],9, C_text("scheme#<="));
lf[101]=C_h_intern(&lf[101],14, C_text("scheme#number?"));
lf[102]=C_h_intern(&lf[102],15, C_text("scheme#complex?"));
lf[103]=C_h_intern(&lf[103],12, C_text("scheme#real?"));
lf[104]=C_h_intern(&lf[104],16, C_text("scheme#rational?"));
lf[105]=C_h_intern(&lf[105],15, C_text("scheme#integer?"));
lf[106]=C_h_intern(&lf[106],13, C_text("scheme#exact?"));
lf[107]=C_h_intern(&lf[107],15, C_text("scheme#inexact?"));
lf[108]=C_h_intern(&lf[108],12, C_text("scheme#zero?"));
lf[109]=C_h_intern(&lf[109],16, C_text("scheme#positive?"));
lf[110]=C_h_intern(&lf[110],16, C_text("scheme#negative?"));
lf[111]=C_h_intern(&lf[111],21, C_text("scheme#number->string"));
lf[112]=C_h_intern(&lf[112],14, C_text("scheme#symbol?"));
lf[113]=C_h_intern(&lf[113],14, C_text("scheme#vector?"));
lf[114]=C_h_intern(&lf[114],20, C_text("scheme#vector-length"));
lf[115]=C_h_intern(&lf[115],17, C_text("scheme#vector-ref"));
lf[116]=C_h_intern(&lf[116],18, C_text("scheme#vector-set!"));
lf[117]=C_h_intern(&lf[117],18, C_text("scheme#make-vector"));
lf[118]=C_h_intern(&lf[118],19, C_text("scheme#list->vector"));
lf[119]=C_h_intern(&lf[119],19, C_text("scheme#vector->list"));
lf[120]=C_h_intern(&lf[120],13, C_text("scheme#vector"));
lf[121]=C_h_intern(&lf[121],19, C_text("scheme#vector-fill!"));
lf[122]=C_h_intern(&lf[122],12, C_text("scheme#char?"));
lf[123]=C_h_intern(&lf[123],20, C_text("scheme#char->integer"));
lf[124]=C_h_intern(&lf[124],13, C_text("char->integer"));
lf[125]=C_h_intern(&lf[125],20, C_text("scheme#integer->char"));
lf[126]=C_h_intern(&lf[126],13, C_text("integer->char"));
lf[127]=C_h_intern(&lf[127],13, C_text("scheme#char=?"));
lf[128]=C_h_intern(&lf[128],6, C_text("char=?"));
lf[129]=C_h_intern(&lf[129],13, C_text("scheme#char>?"));
lf[130]=C_h_intern(&lf[130],6, C_text("char>?"));
lf[131]=C_h_intern(&lf[131],13, C_text("scheme#char<?"));
lf[132]=C_h_intern(&lf[132],6, C_text("char<?"));
lf[133]=C_h_intern(&lf[133],14, C_text("scheme#char>=?"));
lf[134]=C_h_intern(&lf[134],7, C_text("char>=?"));
lf[135]=C_h_intern(&lf[135],14, C_text("scheme#char<=?"));
lf[136]=C_h_intern(&lf[136],7, C_text("char<=?"));
lf[137]=C_h_intern(&lf[137],18, C_text("scheme#char-upcase"));
lf[138]=C_h_intern(&lf[138],11, C_text("char-upcase"));
lf[139]=C_h_intern(&lf[139],20, C_text("scheme#char-downcase"));
lf[140]=C_h_intern(&lf[140],13, C_text("char-downcase"));
lf[141]=C_h_intern(&lf[141],16, C_text("scheme#char-ci=?"));
lf[142]=C_h_intern(&lf[142],16, C_text("scheme#char-ci>?"));
lf[143]=C_h_intern(&lf[143],16, C_text("scheme#char-ci<?"));
lf[144]=C_h_intern(&lf[144],17, C_text("scheme#char-ci>=?"));
lf[145]=C_h_intern(&lf[145],17, C_text("scheme#char-ci<=?"));
lf[146]=C_h_intern(&lf[146],23, C_text("scheme#char-upper-case?"));
lf[147]=C_h_intern(&lf[147],16, C_text("char-upper-case?"));
lf[148]=C_h_intern(&lf[148],23, C_text("scheme#char-lower-case?"));
lf[149]=C_h_intern(&lf[149],16, C_text("char-lower-case?"));
lf[150]=C_h_intern(&lf[150],20, C_text("scheme#char-numeric?"));
lf[151]=C_h_intern(&lf[151],13, C_text("char-numeric?"));
lf[152]=C_h_intern(&lf[152],23, C_text("scheme#char-whitespace?"));
lf[153]=C_h_intern(&lf[153],16, C_text("char-whitespace?"));
lf[154]=C_h_intern(&lf[154],23, C_text("scheme#char-alphabetic?"));
lf[155]=C_h_intern(&lf[155],16, C_text("char-alphabetic?"));
lf[156]=C_h_intern(&lf[156],23, C_text("scheme.char#digit-value"));
lf[157]=C_h_intern(&lf[157],11, C_text("digit-value"));
lf[158]=C_h_intern(&lf[158],17, C_text("scheme#procedure?"));
lf[159]=C_h_intern(&lf[159],12, C_text("scheme#apply"));
lf[160]=C_h_intern(&lf[160],13, C_text("scheme#values"));
lf[161]=C_h_intern(&lf[161],23, C_text("scheme#call-with-values"));
lf[162]=C_h_intern(&lf[162],37, C_text("scheme#call-with-current-continuation"));
lf[163]=C_h_intern(&lf[163],14, C_text("scheme#call/cc"));
lf[164]=C_h_intern(&lf[164],18, C_text("scheme#input-port?"));
lf[165]=C_h_intern(&lf[165],19, C_text("scheme#output-port?"));
lf[166]=C_h_intern(&lf[166],19, C_text("scheme#binary-port?"));
lf[167]=C_h_intern(&lf[167],6, C_text("binary"));
lf[168]=C_h_intern(&lf[168],12, C_text("scheme#port?"));
lf[169]=C_h_intern(&lf[169],20, C_text("scheme#textual-port?"));
lf[170]=C_h_intern(&lf[170],7, C_text("textual"));
lf[171]=C_h_intern(&lf[171],23, C_text("scheme#input-port-open?"));
lf[172]=C_h_intern(&lf[172],16, C_text("input-port-open?"));
lf[173]=C_h_intern(&lf[173],24, C_text("scheme#output-port-open?"));
lf[174]=C_h_intern(&lf[174],17, C_text("output-port-open?"));
lf[175]=C_h_intern(&lf[175],25, C_text("scheme#current-input-port"));
lf[176]=C_h_intern(&lf[176],26, C_text("scheme#current-output-port"));
lf[177]=C_h_intern(&lf[177],22, C_text("scheme#open-input-file"));
lf[178]=C_h_intern(&lf[178],23, C_text("scheme#open-output-file"));
lf[179]=C_h_intern(&lf[179],23, C_text("scheme#close-input-port"));
lf[180]=C_h_intern(&lf[180],24, C_text("scheme#close-output-port"));
lf[181]=C_h_intern(&lf[181],27, C_text("scheme#call-with-input-file"));
lf[182]=C_h_intern(&lf[182],28, C_text("scheme#call-with-output-file"));
lf[183]=C_h_intern(&lf[183],27, C_text("scheme#with-input-from-file"));
lf[184]=C_h_intern(&lf[184],26, C_text("scheme#with-output-to-file"));
lf[185]=C_h_intern(&lf[185],18, C_text("scheme#eof-object?"));
lf[186]=C_h_intern(&lf[186],18, C_text("scheme#char-ready?"));
lf[187]=C_h_intern(&lf[187],16, C_text("scheme#read-char"));
lf[188]=C_h_intern(&lf[188],16, C_text("scheme#peek-char"));
lf[189]=C_h_intern(&lf[189],11, C_text("scheme#read"));
lf[190]=C_h_intern(&lf[190],17, C_text("scheme#write-char"));
lf[191]=C_h_intern(&lf[191],14, C_text("scheme#newline"));
lf[192]=C_h_intern(&lf[192],12, C_text("scheme#write"));
lf[193]=C_h_intern(&lf[193],14, C_text("scheme#display"));
lf[194]=C_h_intern(&lf[194],11, C_text("scheme#eval"));
lf[195]=C_h_intern(&lf[195],11, C_text("##sys#error"));
lf[196]=C_h_intern(&lf[196],4, C_text("eval"));
lf[197]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\125\140\145\166\141\154\047\040\151\163\040\156\157\164\040\144\145\146\151\156\145\144\040\055\040\164\150\145\040\140\145\166\141\154\047\040\165\156\151\164\040\167\141\163\040\160\162\157\142\141\142\154\171\040\156\157\164\040\154\151\156\153\145\144\040\167\151\164\150\040\164\150\151\163\040\145\170\145\143\165\164\141\142\154\145\000"));
lf[198]=C_h_intern(&lf[198],30, C_text("scheme#interaction-environment"));
lf[199]=C_h_intern(&lf[199],23, C_text("interaction-environment"));
lf[200]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\150\140\151\156\164\145\162\141\143\164\151\157\156\055\145\156\166\151\162\157\156\155\145\156\164\047\040\151\163\040\156\157\164\040\144\145\146\151\156\145\144\040\055\040\164\150\145\040\140\145\166\141\154\047\040\165\156\151\164\040\167\141\163\040\160\162\157\142\141\142\154\171\040\156\157\164\040\154\151\156\153\145\144\040\167\151\164\150\040\164\150\151\163\040\145\170\145\143\165\164\141\142\154\145\000"));
lf[201]=C_h_intern(&lf[201],32, C_text("scheme#scheme-report-environment"));
lf[202]=C_h_intern(&lf[202],25, C_text("scheme-report-environment"));
lf[203]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\152\140\163\143\150\145\155\145\055\162\145\160\157\162\164\055\145\156\166\151\162\157\156\155\145\156\164\047\040\151\163\040\156\157\164\040\144\145\146\151\156\145\144\040\055\040\164\150\145\040\140\145\166\141\154\047\040\165\156\151\164\040\167\141\163\040\160\162\157\142\141\142\154\171\040\156\157\164\040\154\151\156\153\145\144\040\167\151\164\150\040\164\150\151\163\040\145\170\145\143\165\164\141\142\154\145\000"));
lf[204]=C_h_intern(&lf[204],23, C_text("scheme#null-environment"));
lf[205]=C_h_intern(&lf[205],16, C_text("null-environment"));
lf[206]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\141\140\156\165\154\154\055\145\156\166\151\162\157\156\155\145\156\164\047\040\151\163\040\156\157\164\040\144\145\146\151\156\145\144\040\055\040\164\150\145\040\140\145\166\141\154\047\040\165\156\151\164\040\167\141\163\040\160\162\157\142\141\142\154\171\040\156\157\164\040\154\151\156\153\145\144\040\167\151\164\150\040\164\150\151\163\040\145\170\145\143\165\164\141\142\154\145\000"));
lf[207]=C_h_intern(&lf[207],11, C_text("scheme#load"));
lf[208]=C_h_intern(&lf[208],4, C_text("load"));
lf[209]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\125\140\154\157\141\144\047\040\151\163\040\156\157\164\040\144\145\146\151\156\145\144\040\055\040\164\150\145\040\140\145\166\141\154\047\040\165\156\151\164\040\167\141\163\040\160\162\157\142\141\142\154\171\040\156\157\164\040\154\151\156\153\145\144\040\167\151\164\150\040\164\150\151\163\040\145\170\145\143\165\164\141\142\154\145\000"));
lf[210]=C_h_intern(&lf[210],15, C_text("scheme#for-each"));
lf[211]=C_h_intern(&lf[211],10, C_text("scheme#map"));
lf[212]=C_h_intern(&lf[212],19, C_text("scheme#dynamic-wind"));
lf[213]=C_h_intern(&lf[213],13, C_text("chicken.base#"));
lf[214]=C_h_intern(&lf[214],20, C_text("chicken.base#fixnum?"));
lf[215]=C_h_intern(&lf[215],20, C_text("chicken.base#flonum?"));
lf[216]=C_h_intern(&lf[216],20, C_text("chicken.base#bignum?"));
lf[217]=C_h_intern(&lf[217],20, C_text("chicken.base#ratnum?"));
lf[218]=C_h_intern(&lf[218],21, C_text("chicken.base#cplxnum?"));
lf[219]=C_h_intern(&lf[219],27, C_text("chicken.base#exact-integer?"));
lf[220]=C_h_intern(&lf[220],31, C_text("chicken.base#exact-integer-sqrt"));
lf[221]=C_h_intern(&lf[221],31, C_text("chicken.base#quotient&remainder"));
lf[222]=C_h_intern(&lf[222],28, C_text("chicken.base#quotient&modulo"));
lf[223]=C_h_intern(&lf[223],20, C_text("chicken.base#finite?"));
lf[224]=C_h_intern(&lf[224],22, C_text("chicken.base#infinite?"));
lf[225]=C_h_intern(&lf[225],17, C_text("chicken.base#nan?"));
lf[226]=C_h_intern(&lf[226],19, C_text("chicken.base#signum"));
lf[227]=C_h_intern(&lf[227],27, C_text("chicken.base#get-call-chain"));
lf[228]=C_h_intern(&lf[228],29, C_text("chicken.base#print-call-chain"));
lf[229]=C_h_intern(&lf[229],18, C_text("chicken.base#print"));
lf[230]=C_h_intern(&lf[230],19, C_text("chicken.base#print*"));
lf[231]=C_h_intern(&lf[231],17, C_text("chicken.base#add1"));
lf[232]=C_h_intern(&lf[232],17, C_text("chicken.base#sub1"));
lf[233]=C_h_intern(&lf[233],31, C_text("chicken.base#current-error-port"));
lf[234]=C_h_intern(&lf[234],18, C_text("chicken.base#error"));
lf[235]=C_h_intern(&lf[235],17, C_text("##sys#signal-hook"));
lf[236]=C_h_intern_kw(&lf[236],5, C_text("error"));
lf[237]=C_h_intern(&lf[237],17, C_text("chicken.base#void"));
lf[238]=C_h_intern(&lf[238],18, C_text("chicken.base#sleep"));
lf[239]=C_h_intern(&lf[239],22, C_text("chicken.base#char-name"));
lf[240]=C_h_intern(&lf[240],31, C_text("chicken.base#getter-with-setter"));
lf[241]=C_h_intern(&lf[241],34, C_text("chicken.base#procedure-information"));
lf[242]=C_h_intern(&lf[242],19, C_text("chicken.base#setter"));
lf[243]=C_h_intern(&lf[243],27, C_text("chicken.base#record-printer"));
lf[244]=C_h_intern(&lf[244],32, C_text("chicken.base#set-record-printer!"));
lf[245]=C_h_intern(&lf[245],22, C_text("chicken.base#subvector"));
lf[246]=C_h_intern(&lf[246],26, C_text("chicken.base#vector-resize"));
lf[247]=C_h_intern(&lf[247],25, C_text("chicken.base#port-closed?"));
lf[248]=C_h_intern(&lf[248],25, C_text("chicken.base#flush-output"));
lf[249]=C_h_intern(&lf[249],21, C_text("chicken.base#promise?"));
lf[250]=C_h_intern(&lf[250],7, C_text("promise"));
lf[251]=C_h_intern(&lf[251],18, C_text("##sys#make-promise"));
lf[252]=C_h_intern(&lf[252],25, C_text("chicken.base#make-promise"));
lf[253]=C_h_intern(&lf[253],18, C_text("chicken.base#foldl"));
lf[254]=C_h_intern(&lf[254],5, C_text("foldl"));
lf[255]=C_h_intern(&lf[255],18, C_text("chicken.base#foldr"));
lf[256]=C_h_intern(&lf[256],5, C_text("foldr"));
lf[257]=C_h_intern(&lf[257],34, C_text("chicken.base#implicit-exit-handler"));
lf[258]=C_h_intern(&lf[258],25, C_text("chicken.base#exit-handler"));
lf[259]=C_h_intern(&lf[259],26, C_text("chicken.base#cleanup-tasks"));
lf[260]=C_h_intern(&lf[260],20, C_text("chicken.base#on-exit"));
lf[261]=C_h_intern(&lf[261],17, C_text("chicken.base#exit"));
lf[262]=C_h_intern(&lf[262],27, C_text("chicken.base#emergency-exit"));
lf[263]=C_h_intern(&lf[263],14, C_text("emergency-exit"));
lf[264]=C_h_intern(&lf[264],27, C_text("chicken.base#case-sensitive"));
lf[265]=C_h_intern(&lf[265],26, C_text("chicken.base#keyword-style"));
lf[266]=C_h_intern(&lf[266],33, C_text("chicken.base#parentheses-synonyms"));
lf[267]=C_h_intern(&lf[267],26, C_text("chicken.base#symbol-escape"));
lf[268]=C_h_intern(&lf[268],21, C_text("chicken.base#identity"));
lf[269]=C_h_intern(&lf[269],20, C_text("chicken.base#conjoin"));
lf[270]=C_h_intern(&lf[270],20, C_text("chicken.base#disjoin"));
lf[271]=C_h_intern(&lf[271],23, C_text("chicken.base#constantly"));
lf[272]=C_h_intern(&lf[272],17, C_text("chicken.base#flip"));
lf[273]=C_h_intern(&lf[273],23, C_text("chicken.base#complement"));
lf[274]=C_h_intern(&lf[274],20, C_text("chicken.base#compose"));
lf[275]=C_h_intern(&lf[275],14, C_text("chicken.base#o"));
lf[276]=C_h_intern(&lf[276],21, C_text("chicken.base#list-of?"));
lf[277]=C_h_intern(&lf[277],17, C_text("chicken.base#each"));
lf[278]=C_h_intern(&lf[278],21, C_text("##sys#undefined-value"));
lf[279]=C_h_intern(&lf[279],24, C_text("chicken.base#bwp-object?"));
lf[280]=C_h_intern(&lf[280],22, C_text("chicken.base#weak-cons"));
lf[281]=C_h_intern(&lf[281],23, C_text("chicken.base#weak-pair?"));
lf[282]=C_h_intern(&lf[282],18, C_text("chicken.base#atom?"));
lf[283]=C_h_intern(&lf[283],18, C_text("chicken.base#tail?"));
lf[284]=C_h_intern(&lf[284],5, C_text("tail?"));
lf[285]=C_h_intern(&lf[285],24, C_text("chicken.base#intersperse"));
lf[286]=C_h_intern(&lf[286],20, C_text("chicken.base#butlast"));
lf[287]=C_h_intern(&lf[287],7, C_text("butlast"));
lf[288]=C_h_intern(&lf[288],20, C_text("chicken.base#flatten"));
lf[289]=C_h_intern(&lf[289],17, C_text("chicken.base#join"));
lf[290]=C_h_intern(&lf[290],4, C_text("join"));
lf[291]=C_h_intern(&lf[291],12, C_text("##sys#append"));
lf[292]=C_h_intern(&lf[292],21, C_text("chicken.base#compress"));
lf[293]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\046\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\160\162\157\160\145\162\040\154\151\163\164\000"));
lf[294]=C_h_intern(&lf[294],8, C_text("compress"));
lf[295]=C_h_intern_kw(&lf[295],10, C_text("type-error"));
lf[296]=C_h_intern(&lf[296],26, C_text("chicken.base#char-foldcase"));
lf[297]=C_h_intern(&lf[297],13, C_text("char-foldcase"));
lf[298]=C_h_intern(&lf[298],28, C_text("chicken.base#string-foldcase"));
lf[299]=C_h_intern(&lf[299],15, C_text("string-foldcase"));
lf[300]=C_h_intern(&lf[300],20, C_text("##sys#buffer->string"));
lf[301]=C_h_intern(&lf[301],21, C_text("##sys#make-bytevector"));
lf[302]=C_h_intern(&lf[302],26, C_text("chicken.base#alist-update!"));
lf[303]=C_h_intern(&lf[303],25, C_text("chicken.base#alist-update"));
lf[304]=C_h_intern(&lf[304],12, C_text("alist-update"));
lf[305]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\000"));
lf[306]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\000"));
lf[307]=C_h_intern(&lf[307],22, C_text("chicken.base#alist-ref"));
lf[308]=C_h_intern(&lf[308],9, C_text("alist-ref"));
lf[309]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\000"));
lf[310]=C_h_intern(&lf[310],19, C_text("chicken.base#rassoc"));
lf[311]=C_h_intern(&lf[311],6, C_text("rassoc"));
lf[312]=C_h_intern(&lf[312],24, C_text("scheme#open-input-string"));
lf[313]=C_h_intern(&lf[313],17, C_text("open-input-string"));
lf[314]=C_h_intern(&lf[314],15, C_text("##sys#make-port"));
lf[315]=C_h_intern(&lf[315],23, C_text("##sys#string-port-class"));
lf[316]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\050\163\164\162\151\156\147\051\000"));
lf[317]=C_h_intern(&lf[317],6, C_text("string"));
lf[318]=C_h_intern(&lf[318],25, C_text("scheme#open-output-string"));
lf[319]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\050\163\164\162\151\156\147\051\000"));
lf[320]=C_h_intern(&lf[320],24, C_text("scheme#get-output-string"));
lf[321]=C_h_intern(&lf[321],17, C_text("get-output-string"));
lf[322]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\045\141\162\147\165\155\145\156\164\040\151\163\040\156\157\164\040\141\040\163\164\162\151\156\147\055\157\165\164\160\165\164\055\160\157\162\164\000"));
lf[323]=C_h_intern(&lf[323],28, C_text("scheme#open-input-bytevector"));
lf[324]=C_h_intern(&lf[324],21, C_text("open-input-bytevector"));
lf[325]=C_h_intern(&lf[325],10, C_text("scheme#min"));
lf[326]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\050\142\171\164\145\166\145\143\164\157\162\051\000"));
lf[327]=C_h_intern(&lf[327],6, C_text("custom"));
lf[328]=C_h_intern(&lf[328],29, C_text("scheme#open-output-bytevector"));
lf[329]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\050\142\171\164\145\166\145\143\164\157\162\051\000"));
lf[330]=C_h_intern(&lf[330],28, C_text("scheme#get-output-bytevector"));
lf[331]=C_h_intern(&lf[331],21, C_text("get-output-bytevector"));
lf[332]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\156\157\164\040\141\156\040\157\165\164\160\165\164\055\142\171\164\145\166\145\143\164\157\162\000"));
lf[333]=C_h_intern(&lf[333],16, C_text("##sys#check-port"));
lf[335]=C_h_intern(&lf[335],15, C_text("chicken.fixnum#"));
lf[336]=C_h_intern(&lf[336],35, C_text("chicken.fixnum#most-positive-fixnum"));
lf[337]=C_h_intern(&lf[337],35, C_text("chicken.fixnum#most-negative-fixnum"));
lf[338]=C_h_intern(&lf[338],26, C_text("chicken.fixnum#fixnum-bits"));
lf[339]=C_h_intern(&lf[339],31, C_text("chicken.fixnum#fixnum-precision"));
lf[340]=C_h_intern(&lf[340],18, C_text("chicken.fixnum#fx+"));
lf[341]=C_h_intern(&lf[341],18, C_text("chicken.fixnum#fx-"));
lf[342]=C_h_intern(&lf[342],18, C_text("chicken.fixnum#fx*"));
lf[343]=C_h_intern(&lf[343],18, C_text("chicken.fixnum#fx="));
lf[344]=C_h_intern(&lf[344],18, C_text("chicken.fixnum#fx>"));
lf[345]=C_h_intern(&lf[345],18, C_text("chicken.fixnum#fx<"));
lf[346]=C_h_intern(&lf[346],19, C_text("chicken.fixnum#fx>="));
lf[347]=C_h_intern(&lf[347],19, C_text("chicken.fixnum#fx<="));
lf[348]=C_h_intern(&lf[348],20, C_text("chicken.fixnum#fxmin"));
lf[349]=C_h_intern(&lf[349],20, C_text("chicken.fixnum#fxmax"));
lf[350]=C_h_intern(&lf[350],20, C_text("chicken.fixnum#fxneg"));
lf[351]=C_h_intern(&lf[351],20, C_text("chicken.fixnum#fxand"));
lf[352]=C_h_intern(&lf[352],20, C_text("chicken.fixnum#fxior"));
lf[353]=C_h_intern(&lf[353],20, C_text("chicken.fixnum#fxxor"));
lf[354]=C_h_intern(&lf[354],20, C_text("chicken.fixnum#fxnot"));
lf[355]=C_h_intern(&lf[355],20, C_text("chicken.fixnum#fxshl"));
lf[356]=C_h_intern(&lf[356],20, C_text("chicken.fixnum#fxshr"));
lf[357]=C_h_intern(&lf[357],21, C_text("chicken.fixnum#fxodd?"));
lf[358]=C_h_intern(&lf[358],22, C_text("chicken.fixnum#fxeven?"));
lf[359]=C_h_intern(&lf[359],20, C_text("chicken.fixnum#fxlen"));
lf[360]=C_h_intern(&lf[360],18, C_text("chicken.fixnum#fx/"));
lf[361]=C_h_intern(&lf[361],20, C_text("chicken.fixnum#fxgcd"));
lf[362]=C_h_intern(&lf[362],20, C_text("chicken.fixnum#fxmod"));
lf[363]=C_h_intern(&lf[363],20, C_text("chicken.fixnum#fxrem"));
lf[364]=C_h_intern(&lf[364],19, C_text("chicken.fixnum#fx+?"));
lf[365]=C_h_intern(&lf[365],19, C_text("chicken.fixnum#fx-?"));
lf[366]=C_h_intern(&lf[366],19, C_text("chicken.fixnum#fx*?"));
lf[367]=C_h_intern(&lf[367],19, C_text("chicken.fixnum#fx/?"));
lf[368]=C_h_intern(&lf[368],17, C_text("##sys#debug-mode?"));
lf[369]=C_h_intern(&lf[369],22, C_text("##sys#warnings-enabled"));
lf[370]=C_h_intern(&lf[370],21, C_text("##sys#notices-enabled"));
lf[371]=C_h_intern(&lf[371],20, C_text("chicken.base#warning"));
lf[372]=C_h_intern_kw(&lf[372],7, C_text("warning"));
lf[373]=C_h_intern(&lf[373],19, C_text("chicken.base#notice"));
lf[374]=C_h_intern_kw(&lf[374],6, C_text("notice"));
lf[375]=C_h_intern(&lf[375],28, C_text("chicken.base#enable-warnings"));
lf[376]=C_h_intern(&lf[376],10, C_text("##sys#warn"));
lf[377]=C_h_intern(&lf[377],12, C_text("##sys#notice"));
lf[378]=C_h_intern(&lf[378],17, C_text("##sys#error/errno"));
lf[379]=C_h_intern(&lf[379],23, C_text("##sys#signal-hook/errno"));
lf[380]=C_h_intern(&lf[380],8, C_text("##sys#gc"));
lf[381]=C_h_intern(&lf[381],13, C_text("##sys#setslot"));
lf[382]=C_h_intern(&lf[382],14, C_text("##sys#setislot"));
lf[383]=C_h_intern(&lf[383],21, C_text("##sys#allocate-vector"));
lf[384]=C_h_intern(&lf[384],25, C_text("##sys#allocate-bytevector"));
lf[385]=C_h_intern(&lf[385],20, C_text("##sys#make-structure"));
lf[386]=C_h_intern(&lf[386],25, C_text("##sys#ensure-heap-reserve"));
lf[387]=C_h_intern(&lf[387],23, C_text("##sys#symbol-table-info"));
lf[388]=C_h_intern(&lf[388],17, C_text("##sys#memory-info"));
lf[389]=C_h_intern(&lf[389],17, C_text("##sys#start-timer"));
lf[390]=C_h_intern(&lf[390],16, C_text("##sys#stop-timer"));
lf[391]=C_h_intern(&lf[391],16, C_text("##sys#immediate?"));
lf[392]=C_h_intern(&lf[392],13, C_text("##sys#message"));
lf[393]=C_h_intern(&lf[393],10, C_text("##sys#byte"));
lf[394]=C_h_intern(&lf[394],10, C_text("##sys#void"));
lf[395]=C_h_intern(&lf[395],10, C_text("##sys#halt"));
lf[396]=C_h_intern(&lf[396],13, C_text("##sys#become!"));
lf[397]=C_h_intern(&lf[397],15, C_text("##sys#block-ref"));
lf[398]=C_h_intern(&lf[398],18, C_text("##sys#apply-values"));
lf[399]=C_h_intern(&lf[399],18, C_text("##sys#copy-closure"));
lf[400]=C_h_intern(&lf[400],16, C_text("##sys#block-set!"));
lf[401]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\163\154\157\164\040\156\157\164\040\141\143\143\145\163\163\151\142\154\145\000"));
lf[402]=C_h_intern(&lf[402],13, C_text("chicken.time#"));
lf[403]=C_h_intern(&lf[403],41, C_text("chicken.time#current-process-milliseconds"));
lf[404]=C_h_intern(&lf[404],28, C_text("chicken.time#current-seconds"));
lf[405]=C_h_intern(&lf[405],21, C_text("chicken.time#cpu-time"));
lf[406]=C_h_intern(&lf[406],21, C_text("##sys#check-structure"));
lf[407]=C_h_intern(&lf[407],16, C_text("##sys#check-blob"));
lf[408]=C_h_intern(&lf[408],16, C_text("##sys#check-pair"));
lf[409]=C_h_intern(&lf[409],16, C_text("##sys#check-list"));
lf[410]=C_h_intern(&lf[410],18, C_text("##sys#check-string"));
lf[411]=C_h_intern(&lf[411],18, C_text("##sys#check-number"));
lf[412]=C_h_intern(&lf[412],18, C_text("##sys#check-fixnum"));
lf[413]=C_h_intern(&lf[413],22, C_text("##sys#check-bytevector"));
lf[414]=C_h_intern(&lf[414],17, C_text("##sys#check-exact"));
lf[415]=C_h_intern(&lf[415],19, C_text("##sys#check-inexact"));
lf[416]=C_h_intern(&lf[416],18, C_text("##sys#check-symbol"));
lf[417]=C_h_intern(&lf[417],19, C_text("##sys#check-keyword"));
lf[418]=C_h_intern(&lf[418],18, C_text("##sys#check-vector"));
lf[419]=C_h_intern(&lf[419],16, C_text("##sys#check-char"));
lf[420]=C_h_intern(&lf[420],19, C_text("##sys#check-boolean"));
lf[421]=C_h_intern(&lf[421],20, C_text("##sys#check-locative"));
lf[422]=C_h_intern(&lf[422],19, C_text("##sys#check-integer"));
lf[423]=C_h_intern(&lf[423],23, C_text("##sys#error-bad-integer"));
lf[424]=C_h_intern(&lf[424],25, C_text("##sys#check-exact-integer"));
lf[425]=C_h_intern(&lf[425],29, C_text("##sys#error-bad-exact-integer"));
lf[426]=C_h_intern(&lf[426],26, C_text("##sys#check-exact-uinteger"));
lf[427]=C_h_intern(&lf[427],30, C_text("##sys#error-bad-exact-uinteger"));
lf[428]=C_h_intern(&lf[428],16, C_text("##sys#check-real"));
lf[429]=C_h_intern(&lf[429],20, C_text("##sys#error-bad-real"));
lf[430]=C_h_intern(&lf[430],17, C_text("##sys#check-range"));
lf[431]=C_h_intern(&lf[431],27, C_text("##sys#check-range/including"));
lf[432]=C_h_intern(&lf[432],19, C_text("##sys#check-special"));
lf[433]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\056\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\160\157\151\156\164\145\162\055\154\151\153\145\040\157\142\152\145\143\164\000"));
lf[434]=C_h_intern(&lf[434],19, C_text("##sys#check-closure"));
lf[435]=C_h_intern(&lf[435],12, C_text("scheme#force"));
lf[436]=C_h_intern(&lf[436],10, C_text("##sys#list"));
lf[437]=C_h_intern(&lf[437],11, C_text("##sys#dload"));
lf[438]=C_h_intern(&lf[438],23, C_text("##sys#set-dlopen-flags!"));
lf[439]=C_h_intern(&lf[439],16, C_text("##sys#error-hook"));
lf[440]=C_h_intern(&lf[440],22, C_text("##sys#error-bad-number"));
lf[441]=C_h_intern(&lf[441],23, C_text("##sys#error-bad-inexact"));
lf[442]=C_h_intern(&lf[442],20, C_text("##sys#error-bad-base"));
lf[443]=C_h_intern(&lf[443],13, C_text("scheme#append"));
lf[444]=C_h_intern(&lf[444],6, C_text("append"));
lf[445]=C_h_intern(&lf[445],18, C_text("##sys#fast-reverse"));
lf[446]=C_h_intern(&lf[446],17, C_text("##sys#make-string"));
lf[447]=C_h_intern(&lf[447],17, C_text("##sys#utf-decoder"));
lf[448]=C_h_intern(&lf[448],17, C_text("##sys#utf-encoder"));
lf[449]=C_h_intern(&lf[449],17, C_text("##sys#utf-scanner"));
lf[450]=C_h_intern(&lf[450],19, C_text("##sys#latin-decoder"));
lf[451]=C_h_intern(&lf[451],19, C_text("##sys#latin-encoder"));
lf[452]=C_h_intern(&lf[452],19, C_text("##sys#latin-scanner"));
lf[453]=C_h_intern(&lf[453],20, C_text("##sys#binary-decoder"));
lf[454]=C_h_intern(&lf[454],20, C_text("##sys#binary-encoder"));
lf[455]=C_h_intern(&lf[455],20, C_text("##sys#binary-scanner"));
lf[456]=C_h_intern(&lf[456],19, C_text("##sys#encoding-hook"));
lf[457]=C_h_intern(&lf[457],5, C_text("utf-8"));
lf[458]=C_h_intern(&lf[458],7, C_text("latin-1"));
lf[459]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\151\156\166\141\154\151\144\040\146\151\154\145\040\160\157\162\164\040\145\156\143\157\144\151\156\147\000"));
lf[460]=C_h_intern(&lf[460],23, C_text("##sys#register-encoding"));
lf[461]=C_h_intern(&lf[461],29, C_text("##sys#buffer->string/encoding"));
lf[462]=C_h_intern(&lf[462],19, C_text("##sys#encode-buffer"));
lf[463]=C_h_intern(&lf[463],19, C_text("##sys#decode-buffer"));
lf[464]=C_h_intern(&lf[464],17, C_text("##sys#encode-char"));
lf[465]=C_h_intern(&lf[465],17, C_text("##sys#decode-char"));
lf[466]=C_h_intern(&lf[466],24, C_text("##sys#read-char/encoding"));
lf[467]=C_h_intern_kw(&lf[467],10, C_text("file-error"));
lf[468]=C_h_intern(&lf[468],9, C_text("read-char"));
lf[469]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\055\151\156\143\157\155\160\154\145\164\145\040\143\150\141\162\141\143\164\145\162\040\163\145\161\165\145\156\143\145\040\167\150\151\154\145\040\144\145\143\157\144\151\156\147\000"));
lf[470]=C_h_intern(&lf[470],18, C_text("scheme#make-string"));
lf[471]=C_h_intern(&lf[471],11, C_text("make-string"));
lf[472]=C_h_intern_kw(&lf[472],12, C_text("bounds-error"));
lf[473]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\021\163\151\172\145\040\151\163\040\156\145\147\141\164\151\166\145\000"));
lf[474]=C_h_intern(&lf[474],19, C_text("scheme#string->list"));
lf[475]=C_h_intern(&lf[475],12, C_text("string->list"));
lf[476]=C_h_intern(&lf[476],18, C_text("##sys#string->list"));
lf[477]=C_h_intern(&lf[477],19, C_text("scheme#list->string"));
lf[478]=C_h_intern(&lf[478],12, C_text("list->string"));
lf[479]=C_h_intern(&lf[479],18, C_text("##sys#list->string"));
lf[480]=C_h_intern(&lf[480],26, C_text("##sys#reverse-list->string"));
lf[481]=C_h_intern(&lf[481],20, C_text("reverse-list->string"));
lf[482]=C_h_intern(&lf[482],19, C_text("scheme#string-fill!"));
lf[483]=C_h_intern(&lf[483],12, C_text("string-fill!"));
lf[484]=C_h_intern(&lf[484],18, C_text("scheme#string-copy"));
lf[485]=C_h_intern(&lf[485],11, C_text("string-copy"));
lf[486]=C_h_intern(&lf[486],15, C_text("##sys#substring"));
lf[487]=C_h_intern(&lf[487],19, C_text("scheme#string-copy!"));
lf[488]=C_h_intern(&lf[488],12, C_text("string-copy!"));
lf[489]=C_h_intern(&lf[489],16, C_text("scheme#substring"));
lf[490]=C_h_intern(&lf[490],9, C_text("substring"));
lf[491]=C_h_intern(&lf[491],15, C_text("scheme#string<?"));
lf[492]=C_h_intern(&lf[492],8, C_text("string<?"));
lf[493]=C_h_intern(&lf[493],15, C_text("scheme#string>?"));
lf[494]=C_h_intern(&lf[494],8, C_text("string>?"));
lf[495]=C_h_intern(&lf[495],16, C_text("scheme#string<=?"));
lf[496]=C_h_intern(&lf[496],9, C_text("string<=?"));
lf[497]=C_h_intern(&lf[497],16, C_text("scheme#string>=?"));
lf[498]=C_h_intern(&lf[498],9, C_text("string>=?"));
lf[499]=C_h_intern(&lf[499],18, C_text("scheme#string-ci<?"));
lf[500]=C_h_intern(&lf[500],11, C_text("string-ci<?"));
lf[501]=C_h_intern(&lf[501],18, C_text("scheme#string-ci>?"));
lf[502]=C_h_intern(&lf[502],11, C_text("string-ci>?"));
lf[503]=C_h_intern(&lf[503],19, C_text("scheme#string-ci<=?"));
lf[504]=C_h_intern(&lf[504],12, C_text("string-ci<=?"));
lf[505]=C_h_intern(&lf[505],19, C_text("scheme#string-ci>=?"));
lf[506]=C_h_intern(&lf[506],12, C_text("string-ci>=?"));
lf[507]=C_h_intern(&lf[507],19, C_text("##sys#string-append"));
lf[508]=C_h_intern(&lf[508],20, C_text("scheme#string-append"));
lf[509]=C_h_intern(&lf[509],13, C_text("string-append"));
lf[510]=C_h_intern(&lf[510],13, C_text("scheme#string"));
lf[511]=C_h_intern(&lf[511],23, C_text("##sys#char->utf8-string"));
lf[512]=C_h_intern(&lf[512],17, C_text("chicken.base#chop"));
lf[513]=C_h_intern(&lf[513],4, C_text("chop"));
lf[514]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\151\156\166\141\154\151\144\040\156\165\155\145\162\151\143\040\141\162\147\165\155\145\156\164\000"));
lf[515]=C_h_intern(&lf[515],15, C_text("chicken.flonum#"));
lf[516]=C_h_intern(&lf[516],29, C_text("chicken.flonum#maximum-flonum"));
lf[517]=C_h_intern(&lf[517],29, C_text("chicken.flonum#minimum-flonum"));
lf[518]=C_h_intern(&lf[518],27, C_text("chicken.flonum#flonum-radix"));
lf[519]=C_h_intern(&lf[519],29, C_text("chicken.flonum#flonum-epsilon"));
lf[520]=C_h_intern(&lf[520],31, C_text("chicken.flonum#flonum-precision"));
lf[521]=C_h_intern(&lf[521],39, C_text("chicken.flonum#flonum-decimal-precision"));
lf[522]=C_h_intern(&lf[522],38, C_text("chicken.flonum#flonum-maximum-exponent"));
lf[523]=C_h_intern(&lf[523],38, C_text("chicken.flonum#flonum-minimum-exponent"));
lf[524]=C_h_intern(&lf[524],46, C_text("chicken.flonum#flonum-maximum-decimal-exponent"));
lf[525]=C_h_intern(&lf[525],46, C_text("chicken.flonum#flonum-minimum-decimal-exponent"));
lf[526]=C_h_intern(&lf[526],18, C_text("chicken.flonum#fp+"));
lf[527]=C_h_intern(&lf[527],3, C_text("fp+"));
lf[528]=C_h_intern(&lf[528],18, C_text("chicken.flonum#fp-"));
lf[529]=C_h_intern(&lf[529],3, C_text("fp-"));
lf[530]=C_h_intern(&lf[530],18, C_text("chicken.flonum#fp*"));
lf[531]=C_h_intern(&lf[531],3, C_text("fp*"));
lf[532]=C_h_intern(&lf[532],18, C_text("chicken.flonum#fp/"));
lf[533]=C_h_intern(&lf[533],3, C_text("fp/"));
lf[534]=C_h_intern(&lf[534],19, C_text("chicken.flonum#fp*+"));
lf[535]=C_h_intern(&lf[535],4, C_text("fp*+"));
lf[536]=C_h_intern(&lf[536],20, C_text("chicken.flonum#fpgcd"));
lf[537]=C_h_intern(&lf[537],5, C_text("fpgcd"));
lf[538]=C_h_intern(&lf[538],19, C_text("chicken.flonum#fp/?"));
lf[539]=C_h_intern(&lf[539],4, C_text("fp/?"));
lf[540]=C_h_intern(&lf[540],18, C_text("chicken.flonum#fp="));
lf[541]=C_h_intern(&lf[541],3, C_text("fp="));
lf[542]=C_h_intern(&lf[542],18, C_text("chicken.flonum#fp>"));
lf[543]=C_h_intern(&lf[543],3, C_text("fp>"));
lf[544]=C_h_intern(&lf[544],18, C_text("chicken.flonum#fp<"));
lf[545]=C_h_intern(&lf[545],3, C_text("fp<"));
lf[546]=C_h_intern(&lf[546],19, C_text("chicken.flonum#fp>="));
lf[547]=C_h_intern(&lf[547],4, C_text("fp>="));
lf[548]=C_h_intern(&lf[548],19, C_text("chicken.flonum#fp<="));
lf[549]=C_h_intern(&lf[549],4, C_text("fp<="));
lf[550]=C_h_intern(&lf[550],20, C_text("chicken.flonum#fpneg"));
lf[551]=C_h_intern(&lf[551],5, C_text("fpneg"));
lf[552]=C_h_intern(&lf[552],20, C_text("chicken.flonum#fpmax"));
lf[553]=C_h_intern(&lf[553],5, C_text("fpmax"));
lf[554]=C_h_intern(&lf[554],20, C_text("chicken.flonum#fpmin"));
lf[555]=C_h_intern(&lf[555],5, C_text("fpmin"));
lf[556]=C_h_intern(&lf[556],22, C_text("chicken.flonum#fpfloor"));
lf[557]=C_h_intern(&lf[557],7, C_text("fpfloor"));
lf[558]=C_h_intern(&lf[558],25, C_text("chicken.flonum#fptruncate"));
lf[559]=C_h_intern(&lf[559],10, C_text("fptruncate"));
lf[560]=C_h_intern(&lf[560],22, C_text("chicken.flonum#fpround"));
lf[561]=C_h_intern(&lf[561],7, C_text("fpround"));
lf[562]=C_h_intern(&lf[562],24, C_text("chicken.flonum#fpceiling"));
lf[563]=C_h_intern(&lf[563],9, C_text("fpceiling"));
lf[564]=C_h_intern(&lf[564],20, C_text("chicken.flonum#fpsin"));
lf[565]=C_h_intern(&lf[565],5, C_text("fpsin"));
lf[566]=C_h_intern(&lf[566],20, C_text("chicken.flonum#fpcos"));
lf[567]=C_h_intern(&lf[567],5, C_text("fpcos"));
lf[568]=C_h_intern(&lf[568],20, C_text("chicken.flonum#fptan"));
lf[569]=C_h_intern(&lf[569],5, C_text("fptan"));
lf[570]=C_h_intern(&lf[570],21, C_text("chicken.flonum#fpasin"));
lf[571]=C_h_intern(&lf[571],6, C_text("fpasin"));
lf[572]=C_h_intern(&lf[572],21, C_text("chicken.flonum#fpacos"));
lf[573]=C_h_intern(&lf[573],6, C_text("fpacos"));
lf[574]=C_h_intern(&lf[574],21, C_text("chicken.flonum#fpatan"));
lf[575]=C_h_intern(&lf[575],6, C_text("fpatan"));
lf[576]=C_h_intern(&lf[576],22, C_text("chicken.flonum#fpatan2"));
lf[577]=C_h_intern(&lf[577],7, C_text("fpatan2"));
lf[578]=C_h_intern(&lf[578],21, C_text("chicken.flonum#fpsinh"));
lf[579]=C_h_intern(&lf[579],6, C_text("fpsinh"));
lf[580]=C_h_intern(&lf[580],21, C_text("chicken.flonum#fpcosh"));
lf[581]=C_h_intern(&lf[581],6, C_text("fpcosh"));
lf[582]=C_h_intern(&lf[582],21, C_text("chicken.flonum#fptanh"));
lf[583]=C_h_intern(&lf[583],6, C_text("fptanh"));
lf[584]=C_h_intern(&lf[584],22, C_text("chicken.flonum#fpasinh"));
lf[585]=C_h_intern(&lf[585],7, C_text("fpasinh"));
lf[586]=C_h_intern(&lf[586],22, C_text("chicken.flonum#fpacosh"));
lf[587]=C_h_intern(&lf[587],7, C_text("fpacosh"));
lf[588]=C_h_intern(&lf[588],22, C_text("chicken.flonum#fpatanh"));
lf[589]=C_h_intern(&lf[589],7, C_text("fpatanh"));
lf[590]=C_h_intern(&lf[590],20, C_text("chicken.flonum#fpexp"));
lf[591]=C_h_intern(&lf[591],5, C_text("fpexp"));
lf[592]=C_h_intern(&lf[592],21, C_text("chicken.flonum#fpexpt"));
lf[593]=C_h_intern(&lf[593],6, C_text("fpexpt"));
lf[594]=C_h_intern(&lf[594],20, C_text("chicken.flonum#fplog"));
lf[595]=C_h_intern(&lf[595],5, C_text("fplog"));
lf[596]=C_h_intern(&lf[596],21, C_text("chicken.flonum#fpsqrt"));
lf[597]=C_h_intern(&lf[597],6, C_text("fpsqrt"));
lf[598]=C_h_intern(&lf[598],20, C_text("chicken.flonum#fpabs"));
lf[599]=C_h_intern(&lf[599],5, C_text("fpabs"));
lf[600]=C_h_intern(&lf[600],25, C_text("chicken.flonum#fpinteger?"));
lf[601]=C_h_intern(&lf[601],10, C_text("fpinteger?"));
lf[602]=C_h_intern(&lf[602],37, C_text("chicken.flonum#flonum-print-precision"));
lf[603]=C_h_intern(&lf[603],22, C_text("flonum-print-precision"));
lf[605]=C_decode_literal(C_heaptop,C_text("\376\1250.0\000"));
lf[606]=C_h_intern(&lf[606],23, C_text("scheme#make-rectangular"));
lf[607]=C_h_intern(&lf[607],16, C_text("make-rectangular"));
lf[608]=C_h_intern(&lf[608],17, C_text("scheme#make-polar"));
lf[609]=C_h_intern(&lf[609],10, C_text("make-polar"));
lf[610]=C_h_intern(&lf[610],16, C_text("scheme#real-part"));
lf[611]=C_h_intern(&lf[611],9, C_text("real-part"));
lf[612]=C_h_intern(&lf[612],16, C_text("scheme#imag-part"));
lf[613]=C_h_intern(&lf[613],9, C_text("imag-part"));
lf[614]=C_h_intern(&lf[614],12, C_text("scheme#angle"));
lf[615]=C_h_intern(&lf[615],5, C_text("angle"));
lf[616]=C_h_intern(&lf[616],16, C_text("scheme#magnitude"));
lf[617]=C_h_intern(&lf[617],11, C_text("scheme#sqrt"));
lf[618]=C_h_intern(&lf[618],9, C_text("magnitude"));
lf[620]=C_h_intern(&lf[620],16, C_text("scheme#numerator"));
lf[621]=C_h_intern(&lf[621],9, C_text("numerator"));
lf[622]=C_h_intern(&lf[622],21, C_text("scheme#inexact->exact"));
lf[623]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\052\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\162\141\164\151\157\156\141\154\040\156\165\155\142\145\162\000"));
lf[624]=C_h_intern(&lf[624],18, C_text("scheme#denominator"));
lf[625]=C_h_intern(&lf[625],11, C_text("denominator"));
lf[626]=C_decode_literal(C_heaptop,C_text("\376\1251.0\000"));
lf[627]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\052\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\162\141\164\151\157\156\141\154\040\156\165\155\142\145\162\000"));
lf[628]=C_h_intern(&lf[628],21, C_text("##sys#extended-signum"));
lf[629]=C_h_intern(&lf[629],6, C_text("signum"));
lf[630]=C_h_intern(&lf[630],9, C_text("##sys#/-2"));
lf[631]=C_h_intern(&lf[631],14, C_text("inexact->exact"));
lf[632]=C_h_intern(&lf[632],19, C_text("##sys#integer-power"));
lf[633]=C_decode_literal(C_heaptop,C_text("\376\1252.0\000"));
lf[634]=C_h_intern(&lf[634],11, C_text("scheme#expt"));
lf[635]=C_h_intern(&lf[635],16, C_text("chicken.bitwise#"));
lf[636]=C_h_intern(&lf[636],27, C_text("chicken.bitwise#bitwise-and"));
lf[637]=C_h_intern(&lf[637],27, C_text("chicken.bitwise#bitwise-ior"));
lf[638]=C_h_intern(&lf[638],27, C_text("chicken.bitwise#bitwise-xor"));
lf[639]=C_h_intern(&lf[639],27, C_text("chicken.bitwise#bitwise-not"));
lf[640]=C_h_intern(&lf[640],28, C_text("chicken.bitwise#bit->boolean"));
lf[641]=C_h_intern(&lf[641],30, C_text("chicken.bitwise#integer-length"));
lf[642]=C_h_intern(&lf[642],32, C_text("chicken.bitwise#arithmetic-shift"));
lf[643]=C_h_intern(&lf[643],8, C_text("scheme#/"));
lf[645]=C_h_intern(&lf[645],1, C_text("/"));
lf[646]=C_h_intern(&lf[646],12, C_text("scheme#floor"));
lf[647]=C_h_intern(&lf[647],5, C_text("floor"));
lf[648]=C_h_intern(&lf[648],14, C_text("scheme#ceiling"));
lf[649]=C_h_intern(&lf[649],7, C_text("ceiling"));
lf[650]=C_h_intern(&lf[650],15, C_text("scheme#truncate"));
lf[651]=C_h_intern(&lf[651],8, C_text("truncate"));
lf[652]=C_h_intern(&lf[652],12, C_text("scheme#round"));
lf[653]=C_h_intern(&lf[653],5, C_text("round"));
lf[655]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\377\001\000\000\000\000\376\003\000\000\002\376\377\001\000\000\000\001\376\377\016"));
lf[656]=C_h_intern(&lf[656],18, C_text("scheme#rationalize"));
lf[657]=C_h_intern(&lf[657],10, C_text("scheme#max"));
lf[658]=C_h_intern(&lf[658],3, C_text("max"));
lf[659]=C_h_intern(&lf[659],3, C_text("min"));
lf[660]=C_h_intern(&lf[660],10, C_text("scheme#exp"));
lf[661]=C_h_intern(&lf[661],3, C_text("exp"));
lf[662]=C_h_intern(&lf[662],11, C_text("##sys#log-1"));
lf[663]=C_h_intern_kw(&lf[663],16, C_text("arithmetic-error"));
lf[664]=C_h_intern(&lf[664],3, C_text("log"));
lf[665]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\034\154\157\147\040\157\146\040\145\170\141\143\164\040\060\040\151\163\040\165\156\144\145\146\151\156\145\144\000"));
lf[666]=C_h_intern(&lf[666],10, C_text("scheme#log"));
lf[667]=C_h_intern(&lf[667],10, C_text("scheme#sin"));
lf[668]=C_h_intern(&lf[668],3, C_text("sin"));
lf[669]=C_decode_literal(C_heaptop,C_text("\376\016\000\000\002\376\377\001\000\000\000\000\376\377\001\000\000\000\001"));
lf[670]=C_decode_literal(C_heaptop,C_text("\376\016\000\000\002\376\377\001\000\000\000\000\376\377\001\000\000\000\002"));
lf[671]=C_h_intern(&lf[671],10, C_text("scheme#cos"));
lf[672]=C_h_intern(&lf[672],3, C_text("cos"));
lf[673]=C_h_intern(&lf[673],10, C_text("scheme#tan"));
lf[674]=C_h_intern(&lf[674],3, C_text("tan"));
lf[675]=C_h_intern(&lf[675],11, C_text("scheme#asin"));
lf[676]=C_h_intern(&lf[676],4, C_text("asin"));
lf[677]=C_decode_literal(C_heaptop,C_text("\376\016\000\000\002\376\377\001\000\000\000\000\376\377\001\377\377\377\377"));
lf[678]=C_h_intern(&lf[678],14, C_text("##sys#sqrt/loc"));
lf[679]=C_decode_literal(C_heaptop,C_text("\376\125-1.0\000"));
lf[680]=C_h_intern(&lf[680],11, C_text("scheme#acos"));
lf[681]=C_h_intern(&lf[681],4, C_text("acos"));
lf[682]=C_h_intern(&lf[682],11, C_text("scheme#atan"));
lf[683]=C_h_intern(&lf[683],4, C_text("atan"));
lf[684]=C_h_intern(&lf[684],24, C_text("##sys#exact-integer-sqrt"));
lf[685]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\164\150\151\163\040\163\150\157\165\154\144\040\156\145\166\145\162\040\150\141\160\160\145\156\000"));
lf[686]=C_h_intern(&lf[686],25, C_text("scheme#exact-integer-sqrt"));
lf[687]=C_h_intern(&lf[687],18, C_text("exact-integer-sqrt"));
lf[688]=C_h_intern(&lf[688],4, C_text("sqrt"));
lf[689]=C_h_intern(&lf[689],16, C_text("scheme#truncate/"));
lf[690]=C_h_intern(&lf[690],13, C_text("scheme#floor/"));
lf[691]=C_h_intern(&lf[691],22, C_text("scheme#floor-remainder"));
lf[692]=C_h_intern(&lf[692],21, C_text("scheme#floor-quotient"));
lf[693]=C_h_intern(&lf[693],13, C_text("scheme#square"));
lf[694]=C_h_intern(&lf[694],35, C_text("chicken.base#exact-integer-nth-root"));
lf[695]=C_h_intern(&lf[695],32, C_text("##sys#exact-integer-nth-root/loc"));
lf[696]=C_h_intern(&lf[696],22, C_text("exact-integer-nth-root"));
lf[697]=C_h_intern(&lf[697],4, C_text("expt"));
lf[698]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\067\145\170\160\157\156\145\156\164\040\157\146\040\145\170\141\143\164\040\060\040\167\151\164\150\040\143\157\155\160\154\145\170\040\141\162\147\165\155\145\156\164\040\151\163\040\165\156\144\145\146\151\156\145\144\000"));
lf[699]=C_h_intern(&lf[699],9, C_text("##sys#gcd"));
lf[700]=C_h_intern(&lf[700],3, C_text("gcd"));
lf[701]=C_h_intern(&lf[701],10, C_text("scheme#gcd"));
lf[702]=C_h_intern(&lf[702],9, C_text("##sys#lcm"));
lf[703]=C_h_intern(&lf[703],3, C_text("lcm"));
lf[704]=C_h_intern(&lf[704],10, C_text("scheme#lcm"));
lf[705]=C_h_intern(&lf[705],31, C_text("##sys#integer->string/recursive"));
lf[706]=C_h_intern(&lf[706],20, C_text("##sys#number->string"));
lf[707]=C_h_intern(&lf[707],29, C_text("##sys#extended-number->string"));
lf[708]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\057\000"));
lf[709]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\053\000"));
lf[710]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[711]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\151\000"));
lf[712]=C_h_intern(&lf[712],14, C_text("number->string"));
lf[715]=C_h_intern(&lf[715],1, C_text("e"));
lf[716]=C_h_intern(&lf[716],1, C_text("i"));
lf[717]=C_decode_literal(C_heaptop,C_text("\376\125+inf.0\000"));
lf[718]=C_decode_literal(C_heaptop,C_text("\376\125-inf.0\000"));
lf[719]=C_h_intern(&lf[719],3, C_text("neg"));
lf[720]=C_h_intern(&lf[720],3, C_text("pos"));
lf[721]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\006\151\156\146\056\060\000"));
lf[722]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\006\156\141\156\056\060\000"));
lf[723]=C_h_intern(&lf[723],21, C_text("scheme#string->number"));
lf[724]=C_h_intern(&lf[724],14, C_text("string->number"));
lf[725]=C_h_intern(&lf[725],20, C_text("##sys#string->number"));
lf[726]=C_h_intern(&lf[726],20, C_text("##sys#fixnum->string"));
lf[727]=C_h_intern(&lf[727],20, C_text("##sys#flonum->string"));
lf[728]=C_h_intern(&lf[728],21, C_text("##sys#integer->string"));
lf[729]=C_h_intern(&lf[729],20, C_text("chicken.base#equal=?"));
lf[730]=C_h_intern(&lf[730],11, C_text("##sys#snafu"));
lf[731]=C_h_intern(&lf[731],11, C_text("##sys#fnord"));
lf[732]=C_h_intern(&lf[732],19, C_text("##sys#intern-symbol"));
lf[733]=C_h_intern(&lf[733],20, C_text("##sys#intern-keyword"));
lf[734]=C_h_intern(&lf[734],17, C_text("##sys#make-symbol"));
lf[735]=C_h_intern(&lf[735],22, C_text("##sys#interned-symbol?"));
lf[736]=C_h_intern(&lf[736],25, C_text("##sys#string->symbol-name"));
lf[737]=C_h_intern(&lf[737],27, C_text("##sys#symbol->string/shared"));
lf[738]=C_h_intern(&lf[738],20, C_text("##sys#symbol->string"));
lf[739]=C_h_intern(&lf[739],20, C_text("##sys#string->symbol"));
lf[740]=C_h_intern(&lf[740],21, C_text("scheme#symbol->string"));
lf[741]=C_h_intern(&lf[741],14, C_text("symbol->string"));
lf[742]=C_h_intern(&lf[742],21, C_text("scheme#string->symbol"));
lf[743]=C_h_intern(&lf[743],14, C_text("string->symbol"));
lf[744]=C_h_intern(&lf[744],38, C_text("chicken.base#string->uninterned-symbol"));
lf[745]=C_h_intern(&lf[745],25, C_text("string->uninterned-symbol"));
lf[746]=C_h_intern(&lf[746],19, C_text("chicken.base#gensym"));
lf[747]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\147\000"));
lf[748]=C_h_intern(&lf[748],6, C_text("gensym"));
lf[749]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\043\141\162\147\165\155\145\156\164\040\151\163\040\156\157\164\040\141\040\163\164\162\151\156\147\040\157\162\040\163\171\155\142\157\154\000"));
lf[750]=C_h_intern(&lf[750],26, C_text("chicken.base#symbol-append"));
lf[751]=C_h_intern(&lf[751],13, C_text("symbol-append"));
lf[752]=C_h_intern(&lf[752],16, C_text("chicken.keyword#"));
lf[753]=C_h_intern(&lf[753],24, C_text("chicken.keyword#keyword?"));
lf[754]=C_h_intern(&lf[754],31, C_text("chicken.keyword#string->keyword"));
lf[755]=C_h_intern(&lf[755],15, C_text("string->keyword"));
lf[756]=C_h_intern(&lf[756],31, C_text("chicken.keyword#keyword->string"));
lf[757]=C_h_intern(&lf[757],15, C_text("keyword->string"));
lf[758]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\153\145\171\167\157\162\144\000"));
lf[759]=C_h_intern(&lf[759],3, C_text("tag"));
lf[760]=C_h_intern(&lf[760],27, C_text("chicken.keyword#get-keyword"));
lf[761]=C_h_intern(&lf[761],11, C_text("get-keyword"));
lf[762]=C_h_intern(&lf[762],17, C_text("##sys#get-keyword"));
lf[763]=C_h_intern(&lf[763],22, C_text("##sys#bytevector->list"));
lf[764]=C_h_intern(&lf[764],22, C_text("##sys#list->bytevector"));
lf[765]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\043\143\141\156\040\156\157\164\040\143\157\156\166\145\162\164\040\154\151\163\164\040\164\157\040\142\171\164\145\166\145\143\164\157\162\000"));
lf[766]=C_h_intern(&lf[766],19, C_text("chicken.bytevector#"));
lf[767]=C_h_intern(&lf[767],34, C_text("chicken.bytevector#make-bytevector"));
lf[768]=C_h_intern(&lf[768],15, C_text("make-bytevector"));
lf[769]=C_h_intern(&lf[769],30, C_text("chicken.bytevector#bytevector?"));
lf[770]=C_h_intern(&lf[770],36, C_text("chicken.bytevector#bytevector-length"));
lf[771]=C_h_intern(&lf[771],15, C_text("bytevector-size"));
lf[772]=C_h_intern(&lf[772],36, C_text("chicken.bytevector#bytevector-u8-ref"));
lf[773]=C_h_intern(&lf[773],37, C_text("chicken.bytevector#bytevector-u8-set!"));
lf[774]=C_h_intern(&lf[774],31, C_text("chicken.bytevector#string->utf8"));
lf[775]=C_h_intern(&lf[775],12, C_text("string->utf8"));
lf[776]=C_h_intern(&lf[776],31, C_text("chicken.bytevector#utf8->string"));
lf[777]=C_h_intern(&lf[777],12, C_text("utf8->string"));
lf[778]=C_h_intern(&lf[778],33, C_text("chicken.bytevector#string->latin1"));
lf[779]=C_h_intern(&lf[779],14, C_text("string->latin1"));
lf[780]=C_h_intern(&lf[780],33, C_text("chicken.bytevector#latin1->string"));
lf[781]=C_h_intern(&lf[781],14, C_text("latin1->string"));
lf[782]=C_h_intern(&lf[782],31, C_text("chicken.bytevector#bytevector=?"));
lf[783]=C_h_intern(&lf[783],12, C_text("bytevector=?"));
lf[784]=C_h_intern(&lf[784],29, C_text("chicken.bytevector#bytevector"));
lf[785]=C_h_intern(&lf[785],10, C_text("bytevector"));
lf[786]=C_h_intern(&lf[786],34, C_text("chicken.bytevector#bytevector-copy"));
lf[787]=C_h_intern(&lf[787],15, C_text("bytevector-copy"));
lf[788]=C_h_intern(&lf[788],16, C_text("bytevector->copy"));
lf[789]=C_h_intern(&lf[789],35, C_text("chicken.bytevector#bytevector-copy!"));
lf[790]=C_h_intern(&lf[790],16, C_text("bytevector-copy!"));
lf[791]=C_h_intern(&lf[791],17, C_text("bytevector->copy!"));
lf[792]=C_h_intern(&lf[792],36, C_text("chicken.bytevector#bytevector-append"));
lf[793]=C_h_intern(&lf[793],17, C_text("bytevector-append"));
lf[794]=C_h_intern(&lf[794],11, C_text("make-vector"));
lf[795]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\021\163\151\172\145\040\151\163\040\156\145\147\141\164\151\166\145\000"));
lf[796]=C_h_intern(&lf[796],17, C_text("##sys#make-vector"));
lf[797]=C_h_intern(&lf[797],12, C_text("list->vector"));
lf[798]=C_h_intern(&lf[798],12, C_text("vector->list"));
lf[799]=C_h_intern(&lf[799],12, C_text("vector-fill!"));
lf[800]=C_h_intern(&lf[800],18, C_text("scheme#vector-copy"));
lf[801]=C_h_intern(&lf[801],11, C_text("vector-copy"));
lf[802]=C_h_intern(&lf[802],19, C_text("scheme#vector-copy!"));
lf[803]=C_h_intern(&lf[803],12, C_text("vector-copy!"));
lf[804]=C_h_intern(&lf[804],20, C_text("scheme#vector-append"));
lf[805]=C_h_intern(&lf[805],13, C_text("vector-append"));
lf[806]=C_h_intern(&lf[806],9, C_text("subvector"));
lf[807]=C_h_intern(&lf[807],13, C_text("vector-resize"));
lf[809]=C_h_intern(&lf[809],9, C_text("char-ci=?"));
lf[810]=C_h_intern(&lf[810],9, C_text("char-ci>?"));
lf[811]=C_h_intern(&lf[811],9, C_text("char-ci<?"));
lf[812]=C_h_intern(&lf[812],10, C_text("char-ci>=?"));
lf[813]=C_h_intern(&lf[813],10, C_text("char-ci<=?"));
lf[814]=C_h_intern(&lf[814],9, C_text("char-name"));
lf[815]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\027\151\156\166\141\154\151\144\040\143\150\141\162\141\143\164\145\162\040\156\141\155\145\000"));
lf[816]=C_h_intern(&lf[816],36, C_text("##sys#call-with-current-continuation"));
lf[817]=C_h_intern(&lf[817],23, C_text("##sys#call-with-cthulhu"));
lf[818]=C_h_intern(&lf[818],22, C_text("##sys#call-with-values"));
lf[819]=C_h_intern(&lf[819],14, C_text("##sys#for-each"));
lf[820]=C_h_intern(&lf[820],8, C_text("for-each"));
lf[821]=C_h_intern(&lf[821],9, C_text("##sys#map"));
lf[822]=C_h_intern(&lf[822],3, C_text("map"));
lf[823]=C_h_intern(&lf[823],19, C_text("##sys#dynamic-winds"));
lf[824]=C_h_intern(&lf[824],18, C_text("##sys#dynamic-wind"));
lf[826]=C_h_intern(&lf[826],12, C_text("port-closed?"));
lf[827]=C_h_intern(&lf[827],24, C_text("##sys#dispatch-interrupt"));
lf[828]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\143\141\156\156\157\164\040\162\145\141\144\040\146\162\157\155\040\160\157\162\164\040\055\040\000"));
lf[829]=C_h_intern(&lf[829],19, C_text("##sys#peek-c-string"));
lf[830]=C_h_intern(&lf[830],18, C_text("##sys#update-errno"));
lf[831]=C_h_intern(&lf[831],16, C_text("read-bytevector!"));
lf[832]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\143\141\156\156\157\164\040\162\145\141\144\040\146\162\157\155\040\160\157\162\164\040\055\040\000"));
lf[833]=C_h_intern(&lf[833],9, C_text("read-line"));
lf[834]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\143\141\156\156\157\164\040\162\145\141\144\040\146\162\157\155\040\160\157\162\164\040\055\040\000"));
lf[835]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[836]=C_h_intern(&lf[836],23, C_text("##sys#stream-port-class"));
lf[837]=C_h_intern(&lf[837],20, C_text("##sys#open-file-port"));
lf[838]=C_h_intern(&lf[838],20, C_text("##sys#standard-input"));
lf[839]=C_h_intern(&lf[839],21, C_text("##sys#standard-output"));
lf[840]=C_h_intern(&lf[840],20, C_text("##sys#standard-error"));
lf[841]=C_h_intern(&lf[841],22, C_text("##sys#check-input-port"));
lf[842]=C_h_intern(&lf[842],23, C_text("##sys#check-output-port"));
lf[843]=C_h_intern(&lf[843],21, C_text("##sys#check-open-port"));
lf[844]=C_h_intern(&lf[844],18, C_text("current-input-port"));
lf[845]=C_h_intern(&lf[845],19, C_text("current-output-port"));
lf[846]=C_h_intern(&lf[846],18, C_text("current-error-port"));
lf[847]=C_h_intern(&lf[847],15, C_text("##sys#tty-port?"));
lf[848]=C_h_intern(&lf[848],27, C_text("##sys#peek-unsigned-integer"));
lf[849]=C_h_intern(&lf[849],15, C_text("##sys#port-data"));
lf[850]=C_h_intern(&lf[850],20, C_text("##sys#set-port-data!"));
lf[851]=C_h_intern(&lf[851],27, C_text("##sys#default-file-encoding"));
lf[852]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\162\000"));
lf[853]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\167\000"));
lf[854]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[855]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\143\141\156\156\157\164\040\157\160\145\156\040\146\151\154\145\040\055\040\000"));
lf[856]=C_h_intern(&lf[856],6, C_text("stream"));
lf[857]=C_h_intern_kw(&lf[857],6, C_text("binary"));
lf[858]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\142\000"));
lf[859]=C_h_intern_kw(&lf[859],4, C_text("text"));
lf[860]=C_h_intern(&lf[860],4, C_text("text"));
lf[861]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[862]=C_h_intern_kw(&lf[862],5, C_text("utf-8"));
lf[863]=C_h_intern_kw(&lf[863],7, C_text("latin-1"));
lf[864]=C_h_intern_kw(&lf[864],4, C_text("unix"));
lf[865]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\142\000"));
lf[866]=C_h_intern_kw(&lf[866],4, C_text("crnl"));
lf[867]=C_h_intern(&lf[867],4, C_text("crnl"));
lf[868]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[869]=C_h_intern_kw(&lf[869],6, C_text("append"));
lf[870]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\047\143\141\156\156\157\164\040\165\163\145\040\141\160\160\145\156\144\040\155\157\144\145\040\167\151\164\150\040\151\156\160\165\164\040\146\151\154\145\000"));
lf[871]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\141\000"));
lf[872]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\151\156\166\141\154\151\144\040\146\151\154\145\040\157\160\164\151\157\156\000"));
lf[873]=C_h_intern_kw(&lf[873],2, C_text("nl"));
lf[874]=C_h_intern(&lf[874],4, C_text("unix"));
lf[875]=C_h_intern(&lf[875],2, C_text("nl"));
lf[876]=C_h_intern_kw(&lf[876],10, C_text("iso-8859-1"));
lf[877]=C_h_intern(&lf[877],10, C_text("iso-8859-1"));
lf[878]=C_h_intern(&lf[878],15, C_text("open-input-file"));
lf[879]=C_h_intern(&lf[879],16, C_text("open-output-file"));
lf[880]=C_h_intern(&lf[880],16, C_text("close-input-port"));
lf[881]=C_h_intern(&lf[881],17, C_text("close-output-port"));
lf[882]=C_h_intern(&lf[882],18, C_text("##sys#file-exists?"));
lf[883]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\051\163\171\163\164\145\155\040\145\162\162\157\162\040\167\150\151\154\145\040\164\162\171\151\156\147\040\164\157\040\141\143\143\145\163\163\040\146\151\154\145\000"));
lf[884]=C_h_intern(&lf[884],19, C_text("##sys#make-c-string"));
lf[885]=C_h_intern(&lf[885],18, C_text("##sys#flush-output"));
lf[886]=C_h_intern(&lf[886],12, C_text("flush-output"));
lf[887]=C_h_intern(&lf[887],15, C_text("##sys#port-line"));
lf[888]=C_h_intern(&lf[888],21, C_text("##sys#decorate-lambda"));
lf[889]=C_h_intern(&lf[889],23, C_text("##sys#lambda-decoration"));
lf[890]=C_h_intern(&lf[890],22, C_text("##sys#make-lambda-info"));
lf[891]=C_h_intern(&lf[891],18, C_text("##sys#lambda-info?"));
lf[892]=C_h_intern(&lf[892],17, C_text("##sys#lambda-info"));
lf[893]=C_h_intern(&lf[893],25, C_text("##sys#lambda-info->string"));
lf[894]=C_h_intern(&lf[894],10, C_text("##sys#read"));
lf[895]=C_h_intern(&lf[895],21, C_text("procedure-information"));
lf[896]=C_h_intern(&lf[896],6, C_text("setter"));
lf[898]=C_h_intern(&lf[898],12, C_text("##sys#setter"));
lf[899]=C_h_intern(&lf[899],18, C_text("getter-with-setter"));
lf[901]=C_h_intern(&lf[901],30, C_text("##sys#current-parameter-vector"));
lf[902]=C_decode_literal(C_heaptop,C_text("\376\000\000\000\000"));
lf[903]=C_h_intern(&lf[903],11, C_text("char-ready?"));
lf[904]=C_h_intern(&lf[904],17, C_text("##sys#read-char-0"));
lf[905]=C_h_intern(&lf[905],20, C_text("##sys#read-char/port"));
lf[906]=C_h_intern(&lf[906],17, C_text("##sys#peek-char-0"));
lf[907]=C_h_intern(&lf[907],9, C_text("peek-char"));
lf[908]=C_h_intern(&lf[908],4, C_text("read"));
lf[909]=C_h_intern(&lf[909],28, C_text("##sys#default-read-info-hook"));
lf[910]=C_h_intern(&lf[910],33, C_text("##sys#read-error-with-line-number"));
lf[911]=C_h_intern(&lf[911],22, C_text("##sys#read-prompt-hook"));
lf[912]=C_h_intern(&lf[912],21, C_text("##sys#infix-list-hook"));
lf[913]=C_h_intern(&lf[913],23, C_text("##sys#sharp-number-hook"));
lf[914]=C_h_intern(&lf[914],16, C_text("##sys#read-error"));
lf[915]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\151\156\166\141\154\151\144\040\140\043\056\056\056\047\040\162\145\141\144\040\163\171\156\164\141\170\000"));
lf[916]=C_h_intern(&lf[916],24, C_text("##sys#current-read-table"));
lf[917]=C_h_intern(&lf[917],18, C_text("##sys#read-warning"));
lf[918]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\007\050\154\151\156\145\040\000"));
lf[919]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\051\040\000"));
lf[920]=C_h_intern_kw(&lf[920],12, C_text("syntax-error"));
lf[921]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\007\050\154\151\156\145\040\000"));
lf[922]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\051\040\000"));
lf[923]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\377\012\000\000\054\376\003\000\000\002\376\377\012\000\000\073\376\003\000\000\002\376\377\012\000\000\050\376\003\000\000\002\376\377\012\000\000\051\376\003\000\000\002\376\377\012\000\000\047\376\003\000\000\002\376\377\012\000\000\042\376\003\000\000\002\376\377\012\000\000\133\376\003\000\000\002\376\377\012\000\000\135\376\003\000\000\002\376\377\012\000\000\173\376\003\000\000\002\376\377\012\000\000\175\376\377\016"));
lf[924]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\165\156\145\170\160\145\143\164\145\144\040\154\151\163\164\040\164\145\162\155\151\156\141\164\157\162\000"));
lf[925]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\023\162\145\163\145\162\166\145\144\040\143\150\141\162\141\143\164\145\162\000"));
lf[926]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\027\163\145\154\146\055\162\145\146\145\162\145\156\164\151\141\154\040\144\141\164\165\155\000"));
lf[927]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\151\156\166\141\154\151\144\040\145\163\143\141\160\145\055\163\145\161\165\145\156\143\145\040\047\134\000"));
lf[928]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\047\000"));
lf[929]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\035\165\156\164\145\162\155\151\156\141\164\145\144\040\163\164\162\151\156\147\040\143\157\156\163\164\141\156\164\000"));
lf[930]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\034\151\156\166\141\154\151\144\040\145\163\143\141\160\145\055\163\145\161\165\145\156\143\145\040\047\134\170\000"));
lf[931]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\073\047\000"));
lf[932]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\051\165\156\164\145\162\155\151\156\141\164\145\144\040\150\145\170\141\144\145\143\151\155\141\154\040\145\163\143\141\160\145\040\163\145\161\165\145\156\143\145\000"));
lf[933]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\051\165\156\164\145\162\155\151\156\141\164\145\144\040\150\145\170\141\144\145\143\151\155\141\154\040\145\163\143\141\160\145\040\163\145\161\165\145\156\143\145\000"));
lf[934]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\165\156\164\145\162\155\151\156\141\164\145\144\040\163\164\162\151\156\147\000"));
lf[935]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\165\000"));
lf[936]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\125\000"));
lf[937]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\067\145\163\143\141\160\145\144\040\167\150\151\164\145\163\160\141\143\145\054\040\142\165\164\040\156\157\040\156\145\167\154\151\156\145\040\055\040\143\157\154\154\141\160\163\151\156\147\040\141\156\171\167\141\171\000"));
lf[938]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\165\156\164\145\162\155\151\156\141\164\145\144\040\163\164\162\151\156\147\000"));
lf[939]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[940]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\100\165\156\144\145\146\151\156\145\144\040\145\163\143\141\160\145\040\163\145\161\165\145\156\143\145\040\151\156\040\163\164\162\151\156\147\040\055\040\160\162\157\142\141\142\154\171\040\146\157\162\147\157\164\040\142\141\143\153\163\154\141\163\150\000"));
lf[941]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\054\040\163\164\141\162\164\151\156\147\040\151\156\040\154\151\156\145\040\000"));
lf[942]=C_h_intern(&lf[942],9, C_text("list-info"));
lf[943]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\154\151\163\164\055\164\145\162\155\151\156\141\164\157\162\040\155\151\163\155\141\164\143\150\000"));
lf[944]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\165\156\164\145\162\155\151\156\141\164\145\144\040\154\151\163\164\000"));
lf[945]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\030\155\151\163\163\151\156\147\040\154\151\163\164\040\164\145\162\155\151\156\141\164\157\162\000"));
lf[946]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\023\151\156\166\141\154\151\144\040\165\163\145\040\157\146\040\140\056\047\000"));
lf[947]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\056\072\000"));
lf[948]=C_h_intern_kw(&lf[948],6, C_text("suffix"));
lf[949]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\056\000"));
lf[950]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\056\000"));
lf[951]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\016\155\151\163\163\151\156\147\040\164\157\153\145\156\000"));
lf[952]=C_h_intern(&lf[952],18, C_text("##sys#list->vector"));
lf[953]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\026\151\156\166\141\154\151\144\040\166\145\143\164\157\162\040\163\171\156\164\141\170\000"));
lf[954]=C_h_intern(&lf[954],11, C_text("symbol-info"));
lf[955]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\056\000"));
lf[956]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\023\151\156\166\141\154\151\144\040\165\163\145\040\157\146\040\140\056\047\000"));
lf[957]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\043\165\156\145\170\160\145\143\164\145\144\040\160\162\145\146\151\170\040\151\156\040\156\165\155\142\145\162\040\163\171\156\164\141\170\000"));
lf[958]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\026\151\154\154\145\147\141\154\040\156\165\155\142\145\162\040\163\171\156\164\141\170\000"));
lf[959]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\165\156\145\170\160\145\143\164\145\144\040\145\156\144\040\157\146\040\156\165\155\145\162\151\143\040\154\151\164\145\162\141\154\000"));
lf[960]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\061\151\154\154\145\147\141\154\040\156\165\155\142\145\162\040\163\171\156\164\141\170\040\055\040\151\156\166\141\154\151\144\040\145\170\141\143\164\156\145\163\163\040\160\162\145\146\151\170\000"));
lf[961]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\165\156\145\170\160\145\143\164\145\144\040\145\156\144\040\157\146\040\156\165\155\145\162\151\143\040\154\151\164\145\162\141\154\000"));
lf[962]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\046\151\154\154\145\147\141\154\040\156\165\155\142\145\162\040\163\171\156\164\141\170\040\055\040\151\156\166\141\154\151\144\040\162\141\144\151\170\000"));
lf[963]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\106\141\164\164\145\155\160\164\040\164\157\040\162\145\141\144\040\145\170\160\162\145\163\163\151\157\156\040\146\162\157\155\040\163\157\155\145\164\150\151\156\147\040\164\150\141\164\040\154\157\157\153\163\040\154\151\153\145\040\142\151\156\141\162\171\040\144\141\164\141\000"));
lf[964]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\072\000"));
lf[965]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\053\145\163\143\141\160\145\144\040\163\171\155\142\157\154\040\163\171\156\164\141\170\040\163\160\141\156\163\040\155\165\154\164\151\160\154\145\040\154\151\156\145\163\000"));
lf[966]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\067\165\156\145\170\160\145\143\164\145\144\040\145\156\144\040\157\146\040\146\151\154\145\040\167\150\151\154\145\040\162\145\141\144\151\156\147\040\145\163\143\141\160\145\144\040\143\150\141\162\141\143\164\145\162\000"));
lf[967]=C_h_intern_kw(&lf[967],6, C_text("prefix"));
lf[968]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\030\165\156\153\156\157\167\156\040\156\141\155\145\144\040\143\150\141\162\141\143\164\145\162\000"));
lf[969]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\165\156\164\145\162\155\151\156\141\164\145\144\040\142\154\157\143\153\055\143\157\155\155\145\156\164\000"));
lf[970]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\043\043\000"));
lf[971]=C_h_intern(&lf[971],5, C_text("quote"));
lf[972]=C_h_intern(&lf[972],10, C_text("quasiquote"));
lf[973]=C_h_intern(&lf[973],16, C_text("unquote-splicing"));
lf[974]=C_h_intern(&lf[974],7, C_text("unquote"));
lf[975]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\055\165\156\145\170\160\145\143\164\145\144\040\145\156\144\040\157\146\040\151\156\160\165\164\040\141\146\164\145\162\040\162\145\141\144\151\156\147\040\043\055\163\151\147\156\000"));
lf[976]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\046\165\156\145\170\160\145\143\164\145\144\040\145\156\144\040\157\146\040\151\156\160\165\164\040\141\146\164\145\162\040\162\145\141\144\151\156\147\000"));
lf[977]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\020\165\156\144\145\146\151\156\145\144\040\144\141\164\165\155\000"));
lf[978]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\151\156\166\141\154\151\144\040\160\141\162\141\155\145\164\145\162\151\172\145\144\040\162\145\141\144\040\163\171\156\164\141\170\000"));
lf[979]=C_h_intern(&lf[979],11, C_text("quasisyntax"));
lf[980]=C_h_intern(&lf[980],8, C_text("location"));
lf[981]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\016\145\155\160\164\171\040\153\145\171\167\157\162\144\000"));
lf[982]=C_h_intern(&lf[982],11, C_text("cond-expand"));
lf[983]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\004\001\145\154\163\145\376\377\016"));
lf[984]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\145\157\146\000"));
lf[985]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\142\167\160\000"));
lf[986]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\012\146\157\154\144\055\143\141\163\145\000"));
lf[987]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\156\157\055\146\157\154\144\055\143\141\163\145\000"));
lf[988]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\157\160\164\151\157\156\141\154\000"));
lf[989]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\005\162\145\163\164\000"));
lf[990]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\153\145\171\000"));
lf[991]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\043\041\000"));
lf[992]=C_h_intern(&lf[992],16, C_text("##sys#read-marks"));
lf[993]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\023\151\156\166\141\154\151\144\040\140\043\041\047\040\164\157\153\145\156\000"));
lf[994]=C_h_intern(&lf[994],20, C_text("##sys#user-read-hook"));
lf[995]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\377\012\000\000\133\376\003\000\000\002\376\377\012\000\000\135\376\003\000\000\002\376\377\012\000\000\173\376\003\000\000\002\376\377\012\000\000\175\376\377\016"));
lf[996]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\377\012\000\000\174\376\377\016"));
lf[997]=C_h_intern(&lf[997],1, C_text("p"));
lf[998]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\151\156\166\141\154\151\144\040\163\150\141\162\160\055\163\151\147\156\040\162\145\141\144\040\163\171\156\164\141\170\000"));
lf[999]=C_h_intern(&lf[999],1, C_text("t"));
lf[1000]=C_h_intern(&lf[1000],4, C_text("true"));
lf[1001]=C_h_intern(&lf[1001],1, C_text("f"));
lf[1002]=C_h_intern(&lf[1002],5, C_text("false"));
lf[1003]=C_h_intern(&lf[1003],2, C_text("u8"));
lf[1004]=C_h_intern(&lf[1004],31, C_text("##sys#canonicalize-number-list!"));
lf[1005]=C_h_intern(&lf[1005],25, C_text("##sys#read-numvector-data"));
lf[1006]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\151\156\166\141\154\151\144\040\156\165\155\145\162\151\143\040\166\145\143\164\157\162\040\163\171\156\164\141\170\000"));
lf[1007]=C_h_intern(&lf[1007],18, C_text("##sys#write-char-0"));
lf[1008]=C_h_intern(&lf[1008],21, C_text("##sys#write-char/port"));
lf[1009]=C_h_intern(&lf[1009],10, C_text("write-char"));
lf[1010]=C_h_intern(&lf[1010],5, C_text("write"));
lf[1011]=C_h_intern(&lf[1011],11, C_text("##sys#print"));
lf[1012]=C_h_intern(&lf[1012],7, C_text("display"));
lf[1013]=C_h_intern(&lf[1013],5, C_text("print"));
lf[1015]=C_h_intern(&lf[1015],24, C_text("##sys#print-length-limit"));
lf[1017]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\056\056\056\000"));
lf[1018]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\056\056\056\000"));
lf[1019]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\134\170\000"));
lf[1020]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\377\012\000\000\050\376\003\000\000\002\376\377\012\000\000\051\376\003\000\000\002\376\377\012\000\000\054\376\003\000\000\002\376\377\012\000\000\133\376\003\000\000\002\376\377\012\000\000\135\376\003\000\000\002\376\377\012\000\000\173\376\003\000\000\002\376\377\012\000\000\175\376\003\000\000\002\376\377\012\000\000\047\376\003\000\000\002\376\377\012\000\000\042\376\003\000\000\002\376\377\012\000\000\073\376\003\000\000\002\376\377\012\000\000\040\376\003\000\000\002\376\377\012\000\000\140\376\003\000\000\002\376\377\012\000\000\174\376\003\000\000\002\376\377\012\000\000\134\376\377\016"));
lf[1021]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\002\000\000\007\043\041\162\145\163\164\000\376\003\000\000\002\376\002\000\000\006\043\041\153\145\171\000\376\003\000\000\002\376\002\000\000\013\043\041\157\160\164\151\157\156\141\154\000\376\003\000\000\002\376\002\000\000\014\043\041\146\157\154\144\055\143\141\163\145\000\376\003\000\000\002\376\002\000\000\017\043\041\156\157\055\146\157\154\144\055\143\141\163\145\000\376\377\016"));
lf[1022]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\050\051\000"));
lf[1023]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\043\164\000"));
lf[1024]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\043\146\000"));
lf[1025]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\006\043\041\145\157\146\000"));
lf[1026]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\043\074\165\156\163\160\145\143\151\146\151\145\144\076\000"));
lf[1027]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\006\043\041\142\167\160\000"));
lf[1028]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\043\134\000"));
lf[1029]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\021\043\074\165\156\142\157\165\156\144\040\166\141\154\165\145\076\000"));
lf[1030]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\034\043\074\151\156\166\141\154\151\144\040\151\155\155\145\144\151\141\164\145\040\157\142\152\145\143\164\076\000"));
lf[1031]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\034\043\074\151\156\166\141\154\151\144\040\146\157\162\167\141\162\144\145\144\040\157\142\152\145\143\164\076\000"));
lf[1032]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\043\072\000"));
lf[1033]=C_h_intern(&lf[1033],21, C_text("##sys#pointer->string"));
lf[1034]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\134\042\000"));
lf[1035]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\134\134\000"));
lf[1036]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\040\056\040\000"));
lf[1037]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\043\165\070\000"));
lf[1038]=C_h_intern(&lf[1038],21, C_text("##sys#user-print-hook"));
lf[1039]=C_h_intern(&lf[1039],23, C_text("##sys#procedure->string"));
lf[1040]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\014\043\074\154\157\143\141\164\151\166\145\076\000"));
lf[1041]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\043\074\154\141\155\142\144\141\040\151\156\146\157\040\000"));
lf[1042]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\042\076\000"));
lf[1043]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\043\074\151\156\160\165\164\040\160\157\162\164\040\042\000"));
lf[1044]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\020\043\074\157\165\164\160\165\164\040\160\157\162\164\040\042\000"));
lf[1045]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\043\074\160\157\162\164\040\042\000"));
lf[1046]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\043\050\051\000"));
lf[1047]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\043\050\000"));
lf[1048]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\045\165\156\160\162\151\156\164\141\142\154\145\040\142\154\157\143\153\040\157\142\152\145\143\164\040\145\156\143\157\165\156\164\145\162\145\144\000"));
lf[1049]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\043\074\160\162\157\143\145\144\165\162\145\040\000"));
lf[1050]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\076\000"));
lf[1051]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\043\074\160\162\157\143\145\144\165\162\145\076\000"));
lf[1052]=C_h_intern(&lf[1052],21, C_text("##sys#record-printers"));
lf[1053]=C_h_intern(&lf[1053],19, C_text("set-record-printer!"));
lf[1054]=C_h_intern(&lf[1054],29, C_text("##sys#register-record-printer"));
lf[1055]=C_h_intern(&lf[1055],9, C_text("condition"));
lf[1056]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\007\001\155\145\163\163\141\147\145"));
lf[1057]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\047\072\040\000"));
lf[1058]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\047\076\000"));
lf[1059]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\044\043\074\105\162\162\157\162\040\151\156\040\160\162\151\156\164\145\162\040\157\146\040\162\145\143\157\162\144\040\164\171\160\145\040\140\000"));
lf[1060]=C_h_intern(&lf[1060],40, C_text("chicken.condition#with-exception-handler"));
lf[1061]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\072\040\000"));
lf[1062]=C_h_intern(&lf[1062],6, C_text("thread"));
lf[1063]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\072\040\000"));
lf[1064]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\043\074\000"));
lf[1065]=C_h_intern(&lf[1065],29, C_text("##sys#with-print-length-limit"));
lf[1066]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\023\163\164\162\151\156\147\040\142\165\146\146\145\162\040\146\165\154\154\000"));
lf[1067]=C_h_intern(&lf[1067],22, C_text("##sys#scan-buffer-line"));
lf[1068]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1069]=C_h_intern(&lf[1069],8, C_text("buffered"));
lf[1070]=C_h_intern(&lf[1070],21, C_text("##sys#print-to-string"));
lf[1071]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\043\074\164\141\147\147\145\144\040\160\157\151\156\164\145\162\040\000"));
lf[1072]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\040\000"));
lf[1073]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\076\000"));
lf[1074]=C_h_intern(&lf[1074],22, C_text("##sys#pointer->address"));
lf[1075]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\043\074\160\157\151\156\164\145\162\040\060\170\000"));
lf[1076]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\076\000"));
lf[1077]=C_h_intern(&lf[1077],20, C_text("##sys#current-thread"));
lf[1078]=C_h_intern(&lf[1078],27, C_text("##sys#peek-nonnull-c-string"));
lf[1079]=C_h_intern(&lf[1079],29, C_text("##sys#really-print-call-chain"));
lf[1080]=C_h_intern(&lf[1080],9, C_text("frameinfo"));
lf[1081]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\135\040\000"));
lf[1082]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\011\040\040\000"));
lf[1083]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\012\011\000"));
lf[1084]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\006\011\074\055\055\012\000"));
lf[1085]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\021\012\011\103\141\154\154\040\150\151\163\164\157\162\171\072\012\000"));
lf[1086]=C_h_intern(&lf[1086],16, C_text("print-call-chain"));
lf[1087]=C_h_intern(&lf[1087],25, C_text("##sys#user-interrupt-hook"));
lf[1088]=C_h_intern_kw(&lf[1088],14, C_text("user-interrupt"));
lf[1089]=C_h_intern(&lf[1089],23, C_text("##sys#primordial-thread"));
lf[1092]=C_h_intern(&lf[1092],22, C_text("##sys#force-finalizers"));
lf[1093]=C_h_intern(&lf[1093],27, C_text("chicken.gc#force-finalizers"));
lf[1094]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\133\144\145\142\165\147\135\040\146\157\162\143\151\156\147\040\146\151\156\141\154\151\172\145\162\163\056\056\056\012\000"));
lf[1095]=C_h_intern(&lf[1095],24, C_text("##sys#pending-finalizers"));
lf[1096]=C_h_intern(&lf[1096],28, C_text("##sys#run-pending-finalizers"));
lf[1097]=C_h_intern(&lf[1097],21, C_text("##sys#dump-heap-state"));
lf[1098]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\012\000"));
lf[1099]=C_h_intern(&lf[1099],19, C_text("##sys#reset-handler"));
lf[1100]=C_h_intern(&lf[1100],14, C_text("##sys#dbg-hook"));
lf[1101]=C_h_intern(&lf[1101],18, C_text("chicken.condition#"));
lf[1102]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\016\001\165\163\145\162\055\151\156\164\145\162\162\165\160\164\376\377\016"));
lf[1103]=C_h_intern(&lf[1103],23, C_text("chicken.condition#abort"));
lf[1104]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\072\040\000"));
lf[1105]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\013\012\127\141\162\156\151\156\147\072\040\000"));
lf[1106]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\010\012\116\157\164\145\072\040\000"));
lf[1107]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\007\001\155\145\163\163\141\147\145"));
lf[1108]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\011\001\141\162\147\165\155\145\156\164\163"));
lf[1109]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\012\001\143\141\154\154\055\143\150\141\151\156"));
lf[1110]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\010\001\154\157\143\141\164\151\157\156"));
lf[1111]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\005\001\145\162\162\156\157"));
lf[1112]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\004\001\164\171\160\145\376\377\016"));
lf[1113]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\006\001\163\171\156\164\141\170\376\377\016"));
lf[1114]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\006\001\142\157\165\156\144\163\376\377\016"));
lf[1115]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\012\001\141\162\151\164\150\155\145\164\151\143\376\377\016"));
lf[1116]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\003\001\151\057\157\376\003\000\000\002\376\001\000\000\004\001\146\151\154\145\376\377\016"));
lf[1117]=C_h_intern_kw(&lf[1117],13, C_text("runtime-error"));
lf[1118]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\007\001\162\165\156\164\151\155\145\376\377\016"));
lf[1119]=C_h_intern_kw(&lf[1119],13, C_text("process-error"));
lf[1120]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\007\001\160\162\157\143\145\163\163\376\377\016"));
lf[1121]=C_h_intern_kw(&lf[1121],13, C_text("network-error"));
lf[1122]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\003\001\151\057\157\376\003\000\000\002\376\001\000\000\003\001\156\145\164\376\377\016"));
lf[1123]=C_h_intern_kw(&lf[1123],21, C_text("network-timeout-error"));
lf[1124]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\003\001\151\057\157\376\003\000\000\002\376\001\000\000\003\001\156\145\164\376\003\000\000\002\376\001\000\000\007\001\164\151\155\145\157\165\164\376\377\016"));
lf[1125]=C_h_intern_kw(&lf[1125],11, C_text("limit-error"));
lf[1126]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\007\001\162\165\156\164\151\155\145\376\003\000\000\002\376\001\000\000\005\001\154\151\155\151\164\376\377\016"));
lf[1127]=C_h_intern_kw(&lf[1127],11, C_text("arity-error"));
lf[1128]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\005\001\141\162\151\164\171\376\377\016"));
lf[1129]=C_h_intern_kw(&lf[1129],12, C_text("access-error"));
lf[1130]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\006\001\141\143\143\145\163\163\376\377\016"));
lf[1131]=C_h_intern_kw(&lf[1131],12, C_text("domain-error"));
lf[1132]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\006\001\144\157\155\141\151\156\376\377\016"));
lf[1133]=C_h_intern_kw(&lf[1133],12, C_text("memory-error"));
lf[1134]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\003\000\000\002\376\001\000\000\006\001\155\145\155\157\162\171\376\377\016"));
lf[1135]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\377\016"));
lf[1136]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\007\001\155\145\163\163\141\147\145"));
lf[1137]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\145\170\143\145\160\164\151\157\156\040\150\141\156\144\154\145\162\040\162\145\164\165\162\156\145\144\000"));
lf[1138]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\011\001\141\162\147\165\155\145\156\164\163"));
lf[1139]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\010\001\154\157\143\141\164\151\157\156"));
lf[1140]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\377\016"));
lf[1141]=C_h_intern(&lf[1141],31, C_text("##sys#current-exception-handler"));
lf[1142]=C_h_intern(&lf[1142],24, C_text("chicken.condition#signal"));
lf[1143]=C_h_intern(&lf[1143],19, C_text("##sys#error-handler"));
lf[1144]=C_h_intern(&lf[1144],20, C_text("##sys#last-exception"));
lf[1145]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\022\001\165\156\143\141\165\147\150\164\055\145\170\143\145\160\164\151\157\156\376\001\000\000\006\001\162\145\141\163\157\156"));
lf[1146]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\022\001\165\156\143\141\165\147\150\164\055\145\170\143\145\160\164\151\157\156\376\377\016"));
lf[1147]=C_h_intern(&lf[1147],3, C_text("exn"));
lf[1148]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\007\001\155\145\163\163\141\147\145"));
lf[1149]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\011\001\141\162\147\165\155\145\156\164\163"));
lf[1150]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\003\001\145\170\156\376\001\000\000\010\001\154\157\143\141\164\151\157\156"));
lf[1151]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\050\000"));
lf[1152]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\051\040\000"));
lf[1153]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1154]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\074\145\170\156\072\040\150\141\163\040\156\157\040\140\155\145\163\163\141\147\145\047\040\160\162\157\160\145\162\164\171\076\000"));
lf[1155]=C_h_intern(&lf[1155],14, C_text("user-interrupt"));
lf[1156]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\012\052\052\052\040\165\163\145\162\040\151\156\164\145\162\162\165\160\164\040\052\052\052\012\000"));
lf[1157]=C_h_intern(&lf[1157],18, C_text("uncaught-exception"));
lf[1158]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\022\001\165\156\143\141\165\147\150\164\055\145\170\143\145\160\164\151\157\156\376\001\000\000\006\001\162\145\141\163\157\156"));
lf[1159]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\023\165\156\143\141\165\147\150\164\040\145\170\143\145\160\164\151\157\156\000"));
lf[1160]=C_h_intern(&lf[1160],43, C_text("chicken.condition#current-exception-handler"));
lf[1161]=C_h_intern(&lf[1161],25, C_text("current-exception-handler"));
lf[1163]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\046\141\162\147\165\155\145\156\164\040\151\163\040\156\157\164\040\141\156\040\145\166\145\156\040\160\162\157\160\145\162\164\171\040\154\151\163\164\000"));
lf[1164]=C_h_intern(&lf[1164],41, C_text("chicken.condition#make-property-condition"));
lf[1165]=C_h_intern(&lf[1165],23, C_text("make-property-condition"));
lf[1166]=C_h_intern(&lf[1166],42, C_text("chicken.condition#make-composite-condition"));
lf[1167]=C_h_intern(&lf[1167],24, C_text("make-composite-condition"));
lf[1168]=C_h_intern(&lf[1168],27, C_text("chicken.condition#condition"));
lf[1169]=C_h_intern(&lf[1169],28, C_text("chicken.condition#condition?"));
lf[1170]=C_h_intern(&lf[1170],33, C_text("chicken.condition#condition->list"));
lf[1171]=C_h_intern(&lf[1171],15, C_text("condition->list"));
lf[1172]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\043\141\162\147\165\155\145\156\164\040\151\163\040\156\157\164\040\141\040\143\157\156\144\151\164\151\157\156\040\157\142\152\145\143\164\000"));
lf[1173]=C_h_intern(&lf[1173],37, C_text("chicken.condition#condition-predicate"));
lf[1174]=C_h_intern(&lf[1174],45, C_text("chicken.condition#condition-property-accessor"));
lf[1175]=C_h_intern(&lf[1175],27, C_text("condition-property-accessor"));
lf[1176]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\143\157\156\144\151\164\151\157\156\040\150\141\163\040\156\157\040\163\165\143\150\040\160\162\157\160\145\162\164\171\000"));
lf[1177]=C_h_intern(&lf[1177],40, C_text("chicken.condition#get-condition-property"));
lf[1178]=C_h_intern(&lf[1178],37, C_text("chicken.condition#print-error-message"));
lf[1179]=C_h_intern(&lf[1179],19, C_text("print-error-message"));
lf[1180]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\072\040\000"));
lf[1181]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\050\000"));
lf[1182]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\051\040\000"));
lf[1183]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\072\040\000"));
lf[1184]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\016\001\165\163\145\162\055\151\156\164\145\162\162\165\160\164\376\377\016"));
lf[1185]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\072\040\052\052\052\040\165\163\145\162\040\151\156\164\145\162\162\165\160\164\040\052\052\052\000"));
lf[1186]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\072\040\074\143\157\156\144\151\164\151\157\156\076\040\000"));
lf[1187]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\072\040\000"));
lf[1188]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\027\072\040\165\156\143\141\165\147\150\164\040\145\170\143\145\160\164\151\157\156\072\040\000"));
lf[1189]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\006\105\162\162\157\162\000"));
lf[1190]=C_h_intern(&lf[1190],28, C_text("##sys#show-exception-warning"));
lf[1191]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\072\040\000"));
lf[1192]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\040\050\000"));
lf[1193]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\010\127\141\162\156\151\156\147\000"));
lf[1194]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\142\141\144\040\141\162\147\165\155\145\156\164\040\143\157\165\156\164\040\055\040\162\145\143\145\151\166\145\144\040\000"));
lf[1195]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\040\142\165\164\040\145\170\160\145\143\164\145\144\040\000"));
lf[1196]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\164\157\157\040\146\145\167\040\141\162\147\165\155\145\156\164\163\040\055\040\162\145\143\145\151\166\145\144\040\000"));
lf[1197]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\040\142\165\164\040\145\170\160\145\143\164\145\144\040\000"));
lf[1198]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\000"));
lf[1199]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\021\165\156\142\157\165\156\144\040\166\141\162\151\141\142\154\145\000"));
lf[1200]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\153\145\171\167\157\162\144\000"));
lf[1201]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\016\157\165\164\040\157\146\040\155\145\155\157\162\171\000"));
lf[1202]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\021\144\151\166\151\163\151\157\156\040\142\171\040\172\145\162\157\000"));
lf[1203]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\157\165\164\040\157\146\040\162\141\156\147\145\000"));
lf[1204]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\026\143\141\154\154\040\157\146\040\156\157\156\055\160\162\157\143\145\144\165\162\145\000"));
lf[1205]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\054\143\157\156\164\151\156\165\141\164\151\157\156\040\143\141\156\156\157\164\040\162\145\143\145\151\166\145\040\155\165\154\164\151\160\154\145\040\166\141\154\165\145\163\000"));
lf[1206]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\052\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\156\157\156\055\143\171\143\154\151\143\040\154\151\163\164\000"));
lf[1207]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\023\162\145\143\165\162\163\151\157\156\040\164\157\157\040\144\145\145\160\000"));
lf[1208]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\070\151\156\145\170\141\143\164\040\156\165\155\142\145\162\040\143\141\156\156\157\164\040\142\145\040\162\145\160\162\145\163\145\156\164\145\144\040\141\163\040\141\156\040\145\170\141\143\164\040\156\165\155\142\145\162\000"));
lf[1209]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\046\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\160\162\157\160\145\162\040\154\151\163\164\000"));
lf[1210]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\146\151\170\156\165\155\000"));
lf[1211]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\156\165\155\142\145\162\000"));
lf[1212]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\163\164\162\151\156\147\000"));
lf[1213]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\160\141\151\162\000"));
lf[1214]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\154\151\163\164\000"));
lf[1215]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\044\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\143\150\141\162\141\143\164\145\162\000"));
lf[1216]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\166\145\143\164\157\162\000"));
lf[1217]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\163\171\155\142\157\154\000"));
lf[1218]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\163\164\141\143\153\040\157\166\145\162\146\154\157\167\000"));
lf[1219]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\071\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\163\164\162\165\143\164\165\162\145\040\157\146\040\164\150\145\040\162\145\161\165\151\162\145\144\040\164\171\160\145\000"));
lf[1220]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\045\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\142\171\164\145\166\145\143\164\157\162\000"));
lf[1221]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\044\154\157\143\141\164\151\166\145\040\162\145\146\145\162\163\040\164\157\040\162\145\143\154\141\151\155\145\144\040\157\142\152\145\143\164\000"));
lf[1222]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\047\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\142\154\157\143\153\040\157\142\152\145\143\164\000"));
lf[1223]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\050\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\156\165\155\142\145\162\040\166\145\143\164\157\162\000"));
lf[1224]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\043\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\156\040\151\156\164\145\147\145\162\000"));
lf[1225]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\054\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\156\040\165\156\163\151\147\156\145\144\040\151\156\164\145\147\145\162\000"));
lf[1226]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\160\157\151\156\164\145\162\000"));
lf[1227]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\051\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\164\141\147\147\145\144\040\160\157\151\156\164\145\162\000"));
lf[1228]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\146\154\157\156\165\155\000"));
lf[1229]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\044\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\160\162\157\143\145\144\165\162\145\000"));
lf[1230]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\151\156\166\141\154\151\144\040\142\141\163\145\000"));
lf[1231]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\060\162\145\143\165\162\163\151\157\156\040\164\157\157\040\144\145\145\160\040\157\162\040\143\151\162\143\165\154\141\162\040\144\141\164\141\040\145\156\143\157\165\156\164\145\162\145\144\000"));
lf[1232]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\142\157\157\154\145\141\156\000"));
lf[1233]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\043\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\154\157\143\141\164\151\166\145\000"));
lf[1234]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\160\157\162\164\000"));
lf[1235]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\063\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\160\157\162\164\040\157\146\040\164\150\145\040\143\157\162\162\145\143\164\040\164\171\160\145\000"));
lf[1236]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\046\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\156\040\151\156\160\165\164\055\160\157\162\164\000"));
lf[1237]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\047\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\156\040\157\165\164\160\165\164\055\160\157\162\164\000"));
lf[1238]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\160\157\162\164\040\141\154\162\145\141\144\171\040\143\154\157\163\145\144\000"));
lf[1239]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\063\143\141\156\156\157\164\040\162\145\160\162\145\163\145\156\164\040\163\164\162\151\156\147\040\167\151\164\150\040\116\125\114\040\142\171\164\145\163\040\141\163\040\103\040\163\164\162\151\156\147\000"));
lf[1240]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\027\163\145\147\155\145\156\164\141\164\151\157\156\040\166\151\157\154\141\164\151\157\156\000"));
lf[1241]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\146\154\157\141\164\151\156\147\055\160\157\151\156\164\040\145\170\143\145\160\164\151\157\156\000"));
lf[1242]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\151\154\154\145\147\141\154\040\151\156\163\164\162\165\143\164\151\157\156\000"));
lf[1243]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\012\142\165\163\040\145\162\162\157\162\000"));
lf[1244]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\050\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\156\040\145\170\141\143\164\040\156\165\155\142\145\162\000"));
lf[1245]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\052\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\156\040\151\156\145\170\141\143\164\040\156\165\155\142\145\162\000"));
lf[1246]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\162\145\141\154\000"));
lf[1247]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\063\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\143\157\155\160\154\145\170\040\156\165\155\142\145\162\040\150\141\163\040\156\157\040\157\162\144\145\162\151\156\147\000"));
lf[1248]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\051\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\156\040\145\170\141\143\164\040\151\156\164\145\147\145\162\000"));
lf[1249]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\044\156\165\155\142\145\162\040\144\157\145\163\040\156\157\164\040\146\151\164\040\151\156\040\146\157\162\145\151\147\156\040\164\171\160\145\000"));
lf[1250]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\060\143\141\156\156\157\164\040\143\157\155\160\165\164\145\040\141\142\163\157\154\165\164\145\040\166\141\154\165\145\040\157\146\040\143\157\155\160\154\145\170\040\156\165\155\142\145\162\000"));
lf[1251]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\051\141\164\164\145\155\160\164\145\144\040\162\145\163\164\040\141\162\147\165\155\145\156\164\040\141\143\143\145\163\163\040\141\164\040\151\156\144\145\170\040\000"));
lf[1252]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\032\040\142\165\164\040\162\145\163\164\040\154\151\163\164\040\154\145\156\147\164\150\040\151\163\040\000"));
lf[1253]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\047\163\164\162\151\156\147\040\143\157\156\164\141\151\156\163\040\151\156\166\141\154\151\144\040\125\124\106\055\070\040\163\145\161\165\145\156\143\145\000"));
lf[1254]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\060\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\165\155\145\162\151\143\040\166\141\154\165\145\040\145\170\143\145\145\144\163\040\162\141\156\147\145\000"));
lf[1255]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\027\165\156\153\156\157\167\156\040\151\156\164\145\162\156\141\154\040\145\162\162\157\162\000"));
lf[1257]=C_h_intern(&lf[1257],29, C_text("scheme#with-exception-handler"));
lf[1258]=C_h_intern(&lf[1258],12, C_text("scheme#raise"));
lf[1259]=C_h_intern(&lf[1259],7, C_text("message"));
lf[1260]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\145\170\143\145\160\164\151\157\156\040\150\141\156\144\154\145\162\040\162\145\164\165\162\156\145\144\000"));
lf[1261]=C_h_intern(&lf[1261],9, C_text("arguments"));
lf[1262]=C_h_intern(&lf[1262],24, C_text("scheme#raise-continuable"));
lf[1263]=C_h_intern(&lf[1263],20, C_text("scheme#error-object?"));
lf[1264]=C_h_intern(&lf[1264],27, C_text("scheme#error-object-message"));
lf[1265]=C_h_intern(&lf[1265],29, C_text("scheme#error-object-irritants"));
lf[1266]=C_h_intern(&lf[1266],18, C_text("scheme#read-error?"));
lf[1267]=C_h_intern(&lf[1267],18, C_text("scheme#file-error?"));
lf[1268]=C_h_intern(&lf[1268],16, C_text("##sys#structure?"));
lf[1269]=C_h_intern(&lf[1269],24, C_text("##sys#generic-structure?"));
lf[1270]=C_h_intern(&lf[1270],10, C_text("##sys#slot"));
lf[1271]=C_h_intern(&lf[1271],10, C_text("##sys#size"));
lf[1272]=C_h_intern(&lf[1272],18, C_text("##sys#make-pointer"));
lf[1273]=C_h_intern(&lf[1273],25, C_text("##sys#make-tagged-pointer"));
lf[1274]=C_h_intern(&lf[1274],14, C_text("##sys#pointer?"));
lf[1275]=C_h_intern(&lf[1275],26, C_text("##sys#set-pointer-address!"));
lf[1276]=C_h_intern(&lf[1276],17, C_text("##sys#bytevector?"));
lf[1277]=C_h_intern(&lf[1277],25, C_text("##sys#string->pbytevector"));
lf[1278]=C_h_intern(&lf[1278],16, C_text("##sys#permanent?"));
lf[1279]=C_h_intern(&lf[1279],19, C_text("##sys#block-address"));
lf[1280]=C_h_intern(&lf[1280],15, C_text("##sys#locative?"));
lf[1281]=C_h_intern(&lf[1281],20, C_text("##sys#srfi-4-vector?"));
lf[1282]=C_h_intern(&lf[1282],9, C_text("c64vector"));
lf[1283]=C_h_intern(&lf[1283],10, C_text("c128vector"));
lf[1284]=C_h_intern(&lf[1284],18, C_text("##sys#null-pointer"));
lf[1285]=C_h_intern(&lf[1285],19, C_text("##sys#null-pointer?"));
lf[1286]=C_h_intern(&lf[1286],22, C_text("##sys#address->pointer"));
lf[1287]=C_h_intern(&lf[1287],25, C_text("##sys#peek-signed-integer"));
lf[1288]=C_h_intern(&lf[1288],17, C_text("##sys#peek-fixnum"));
lf[1289]=C_h_intern(&lf[1289],15, C_text("##sys#peek-byte"));
lf[1290]=C_h_intern(&lf[1290],24, C_text("##sys#vector->structure!"));
lf[1291]=C_h_intern(&lf[1291],17, C_text("##sys#peek-double"));
lf[1292]=C_h_intern(&lf[1292],28, C_text("##sys#peek-and-free-c-string"));
lf[1293]=C_h_intern(&lf[1293],36, C_text("##sys#peek-and-free-nonnull-c-string"));
lf[1294]=C_h_intern(&lf[1294],19, C_text("##sys#poke-c-string"));
lf[1295]=C_h_intern(&lf[1295],18, C_text("##sys#poke-integer"));
lf[1296]=C_h_intern(&lf[1296],17, C_text("##sys#poke-double"));
lf[1297]=C_h_intern(&lf[1297],24, C_text("##sys#peek-c-string-list"));
lf[1298]=C_h_intern(&lf[1298],33, C_text("##sys#peek-and-free-c-string-list"));
lf[1299]=C_h_intern(&lf[1299],22, C_text("##sys#vector->closure!"));
lf[1300]=C_h_intern(&lf[1300],34, C_text("##sys#symbol-has-toplevel-binding?"));
lf[1301]=C_h_intern(&lf[1301],19, C_text("##sys#block-pointer"));
lf[1302]=C_h_intern(&lf[1302],27, C_text("##sys#foreign-char-argument"));
lf[1303]=C_h_intern(&lf[1303],29, C_text("##sys#foreign-fixnum-argument"));
lf[1304]=C_h_intern(&lf[1304],29, C_text("##sys#foreign-flonum-argument"));
lf[1305]=C_h_intern(&lf[1305],28, C_text("##sys#foreign-block-argument"));
lf[1306]=C_h_intern(&lf[1306],30, C_text("##sys#foreign-cplxnum-argument"));
lf[1307]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\051\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\143\157\155\160\154\145\170\040\156\165\155\142\145\162\000"));
lf[1308]=C_h_intern(&lf[1308],37, C_text("##sys#foreign-struct-wrapper-argument"));
lf[1309]=C_h_intern(&lf[1309],29, C_text("##sys#foreign-string-argument"));
lf[1310]=C_h_intern(&lf[1310],29, C_text("##sys#foreign-symbol-argument"));
lf[1311]=C_h_intern(&lf[1311],30, C_text("##sys#foreign-pointer-argument"));
lf[1312]=C_h_intern(&lf[1312],37, C_text("##sys#foreign-tagged-pointer-argument"));
lf[1313]=C_h_intern(&lf[1313],37, C_text("##sys#foreign-ranged-integer-argument"));
lf[1314]=C_h_intern(&lf[1314],46, C_text("##sys#foreign-unsigned-ranged-integer-argument"));
lf[1315]=C_h_intern(&lf[1315],17, C_text("##sys#wrap-struct"));
lf[1316]=C_h_intern(&lf[1316],28, C_text("##sys#default-thread-quantum"));
lf[1317]=C_h_intern(&lf[1317],31, C_text("##sys#default-exception-handler"));
lf[1318]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\077\151\156\164\145\162\156\141\154\040\145\162\162\157\162\072\040\144\145\146\141\165\154\164\040\145\170\143\145\160\164\151\157\156\040\150\141\156\144\154\145\162\040\163\150\157\165\154\144\156\047\164\040\142\145\040\143\141\154\154\145\144\041\000"));
lf[1319]=C_h_intern(&lf[1319],17, C_text("##sys#make-thread"));
lf[1320]=C_h_intern(&lf[1320],16, C_text("##sys#make-mutex"));
lf[1321]=C_h_intern(&lf[1321],5, C_text("mutex"));
lf[1322]=C_h_intern(&lf[1322],14, C_text("##sys#schedule"));
lf[1323]=C_h_intern(&lf[1323],19, C_text("##sys#thread-yield!"));
lf[1324]=C_h_intern(&lf[1324],24, C_text("##sys#kill-other-threads"));
lf[1325]=C_h_intern(&lf[1325],28, C_text("##sys#resume-thread-on-event"));
lf[1326]=C_h_intern(&lf[1326],29, C_text("##sys#suspend-thread-on-event"));
lf[1327]=C_h_intern(&lf[1327],27, C_text("##sys#sleep-until-interrupt"));
lf[1328]=C_h_intern(&lf[1328],22, C_text("##sys#make-event-queue"));
lf[1329]=C_h_intern(&lf[1329],11, C_text("event-queue"));
lf[1330]=C_h_intern(&lf[1330],25, C_text("##sys#add-event-to-queue!"));
lf[1331]=C_h_intern(&lf[1331],20, C_text("##sys#get-next-event"));
lf[1332]=C_h_intern(&lf[1332],25, C_text("##sys#wait-for-next-event"));
lf[1333]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\145\166\145\156\164\040\161\165\145\165\145\040\142\154\157\143\153\145\144\000"));
lf[1334]=C_h_intern(&lf[1334],23, C_text("chicken.base#sleep-hook"));
lf[1335]=C_h_intern(&lf[1335],5, C_text("sleep"));
lf[1336]=C_h_intern(&lf[1336],20, C_text("##sys#context-switch"));
lf[1337]=C_h_intern(&lf[1337],19, C_text("##sys#signal-vector"));
lf[1338]=C_h_intern(&lf[1338],20, C_text("##sys#interrupt-hook"));
lf[1339]=C_h_intern(&lf[1339],11, C_text("##sys#errno"));
lf[1340]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\115\165\156\145\170\160\145\143\164\145\144\040\145\156\144\040\157\146\040\146\151\154\145\040\055\040\165\156\164\145\162\155\151\156\141\164\145\144\040\140\043\173\056\056\056\175\047\040\151\164\145\155\040\151\156\040\140\150\145\162\145\047\040\163\164\162\151\156\147\040\154\151\164\145\162\141\154\000"));
lf[1341]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\047\165\156\164\145\162\155\151\156\141\164\145\144\040\150\145\162\145\055\144\157\143\040\163\164\162\151\156\147\040\154\151\164\145\162\141\154\040\140\000"));
lf[1342]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\047\000"));
lf[1343]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\045\115\151\163\163\151\156\147\040\164\141\147\040\141\146\164\145\162\040\043\074\074\040\150\145\162\145\055\144\157\143\040\164\157\153\145\156\000"));
lf[1344]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\127\150\151\164\145\163\160\141\143\145\040\141\146\164\145\162\040\043\074\074\040\150\145\162\145\055\144\157\143\040\164\141\147\000"));
lf[1345]=C_h_intern(&lf[1345],4, C_text("cons"));
lf[1346]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\005\001\161\165\157\164\145\376\003\000\000\002\376\377\016\376\377\016"));
lf[1347]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\045\115\151\163\163\151\156\147\040\164\141\147\040\141\146\164\145\162\040\043\074\043\040\150\145\162\145\055\144\157\143\040\164\157\153\145\156\000"));
lf[1348]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\127\150\151\164\145\163\160\141\143\145\040\141\146\164\145\162\040\043\074\043\040\150\145\162\145\055\144\157\143\040\164\141\147\000"));
lf[1349]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\165\156\162\145\141\144\141\142\154\145\040\157\142\152\145\143\164\000"));
lf[1350]=C_h_intern(&lf[1350],24, C_text("chicken.process-context#"));
lf[1351]=C_h_intern(&lf[1351],40, C_text("chicken.process-context#change-directory"));
lf[1352]=C_h_intern(&lf[1352],16, C_text("change-directory"));
lf[1353]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\043\143\141\156\156\157\164\040\143\150\141\156\147\145\040\143\165\162\162\145\156\164\040\144\151\162\145\143\164\157\162\171\040\055\040\000"));
lf[1354]=C_h_intern(&lf[1354],27, C_text("##sys#change-directory-hook"));
lf[1355]=C_h_intern(&lf[1355],41, C_text("chicken.process-context#current-directory"));
lf[1356]=C_h_intern(&lf[1356],48, C_text("chicken.process-context#get-environment-variable"));
lf[1357]=C_h_intern(&lf[1357],24, C_text("get-environment-variable"));
lf[1358]=C_h_intern(&lf[1358],49, C_text("chicken.process-context#set-environment-variable!"));
lf[1359]=C_h_intern(&lf[1359],25, C_text("set-environment-variable!"));
lf[1360]=C_h_intern(&lf[1360],51, C_text("chicken.process-context#unset-environment-variable!"));
lf[1361]=C_h_intern(&lf[1361],27, C_text("unset-environment-variable!"));
lf[1362]=C_h_intern(&lf[1362],49, C_text("chicken.process-context#get-environment-variables"));
lf[1363]=C_h_intern(&lf[1363],43, C_text("chicken.process-context#executable-pathname"));
lf[1364]=C_h_intern(&lf[1364],33, C_text("chicken.process-context#argc+argv"));
lf[1365]=C_h_intern(&lf[1365],28, C_text("chicken.process-context#argv"));
lf[1366]=C_h_intern(&lf[1366],36, C_text("chicken.process-context#program-name"));
lf[1367]=C_h_intern(&lf[1367],46, C_text("chicken.process-context#command-line-arguments"));
lf[1368]=C_h_intern(&lf[1368],11, C_text("chicken.gc#"));
lf[1369]=C_h_intern(&lf[1369],34, C_text("chicken.gc#current-gc-milliseconds"));
lf[1370]=C_h_intern(&lf[1370],25, C_text("chicken.gc#set-gc-report!"));
lf[1371]=C_h_intern(&lf[1371],28, C_text("chicken.gc#memory-statistics"));
lf[1372]=C_h_intern(&lf[1372],20, C_text("##sys#set-finalizer!"));
lf[1373]=C_h_intern(&lf[1373],20, C_text("##sys#init-finalizer"));
lf[1374]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\133\144\145\142\165\147\135\040\164\157\157\040\155\141\156\171\040\146\151\156\141\154\151\172\145\162\163\040\050\000"));
lf[1375]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\051\054\040\162\145\163\151\172\145\144\040\155\141\170\040\146\151\156\141\154\151\172\145\162\163\040\164\157\040\000"));
lf[1376]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\012\000"));
lf[1377]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\133\144\145\142\165\147\135\040\164\157\157\040\155\141\156\171\040\146\151\156\141\154\151\172\145\162\163\040\050\000"));
lf[1378]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\020\051\054\040\146\157\162\143\151\156\147\040\056\056\056\012\000"));
lf[1379]=C_h_intern(&lf[1379],25, C_text("chicken.gc#set-finalizer!"));
lf[1380]=C_h_intern(&lf[1380],9, C_text("finalizer"));
lf[1383]=C_h_intern(&lf[1383],25, C_text("chicken.gc#make-finalizer"));
lf[1384]=C_h_intern(&lf[1384],27, C_text("chicken.gc#add-to-finalizer"));
lf[1385]=C_h_intern(&lf[1385],16, C_text("add-to-finalizer"));
lf[1386]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\056\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\146\151\156\141\154\151\172\145\162\040\160\162\157\143\145\144\165\162\145\000"));
lf[1387]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\151\156\040\146\151\156\141\154\151\172\145\162\000"));
lf[1388]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\021\133\144\145\142\165\147\135\040\162\165\156\156\151\156\147\040\000"));
lf[1389]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\020\040\146\151\156\141\154\151\172\145\162\050\163\051\040\050\000"));
lf[1390]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\010\040\154\151\166\145\054\040\000"));
lf[1391]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\021\040\141\154\154\157\143\141\164\145\144\051\040\056\056\056\012\000"));
lf[1392]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\113\162\145\055\145\156\164\162\171\040\146\162\157\155\040\146\151\156\141\154\151\172\145\162\040\164\150\162\145\141\144\040\050\155\141\171\142\145\040\050\147\143\040\043\164\051\040\167\141\163\040\143\141\154\154\145\144\040\146\162\157\155\040\141\040\146\151\156\141\154\151\172\145\162\051\000"));
lf[1393]=C_h_intern(&lf[1393],13, C_text("chicken.gc#gc"));
lf[1394]=C_h_intern(&lf[1394],12, C_text("##sys#length"));
lf[1395]=C_h_intern(&lf[1395],10, C_text("##sys#cons"));
lf[1396]=C_h_intern(&lf[1396],12, C_text("##sys#vector"));
lf[1397]=C_h_intern(&lf[1397],11, C_text("##sys#apply"));
lf[1398]=C_h_intern(&lf[1398],12, C_text("##sys#values"));
lf[1399]=C_h_intern(&lf[1399],12, C_text("##sys#equal?"));
lf[1400]=C_h_intern(&lf[1400],9, C_text("##sys#car"));
lf[1401]=C_h_intern(&lf[1401],9, C_text("##sys#cdr"));
lf[1402]=C_h_intern(&lf[1402],11, C_text("##sys#pair?"));
lf[1403]=C_h_intern(&lf[1403],13, C_text("##sys#vector?"));
lf[1404]=C_h_intern(&lf[1404],18, C_text("##sys#vector->list"));
lf[1405]=C_h_intern(&lf[1405],19, C_text("##sys#vector-length"));
lf[1406]=C_h_intern(&lf[1406],16, C_text("##sys#vector-ref"));
lf[1407]=C_h_intern(&lf[1407],8, C_text("##sys#>="));
lf[1408]=C_h_intern(&lf[1408],7, C_text("##sys#="));
lf[1409]=C_h_intern(&lf[1409],7, C_text("##sys#+"));
lf[1410]=C_h_intern(&lf[1410],9, C_text("##sys#eq?"));
lf[1411]=C_h_intern(&lf[1411],10, C_text("##sys#eqv?"));
lf[1412]=C_h_intern(&lf[1412],11, C_text("##sys#list?"));
lf[1413]=C_h_intern(&lf[1413],11, C_text("##sys#null?"));
lf[1414]=C_h_intern(&lf[1414],11, C_text("##sys#map-n"));
lf[1415]=C_h_intern(&lf[1415],19, C_text("##sys#make-locative"));
lf[1416]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\052\154\157\143\141\164\151\166\145\040\143\141\156\156\157\164\040\162\145\146\145\162\040\164\157\040\151\155\155\145\144\151\141\164\145\040\157\142\152\145\143\164\000"));
lf[1417]=C_h_intern(&lf[1417],8, C_text("u8vector"));
lf[1418]=C_h_intern(&lf[1418],8, C_text("s8vector"));
lf[1419]=C_h_intern(&lf[1419],9, C_text("u16vector"));
lf[1420]=C_h_intern(&lf[1420],9, C_text("s16vector"));
lf[1421]=C_h_intern(&lf[1421],9, C_text("u32vector"));
lf[1422]=C_h_intern(&lf[1422],9, C_text("s32vector"));
lf[1423]=C_h_intern(&lf[1423],9, C_text("u64vector"));
lf[1424]=C_h_intern(&lf[1424],9, C_text("s64vector"));
lf[1425]=C_h_intern(&lf[1425],9, C_text("f32vector"));
lf[1426]=C_h_intern(&lf[1426],9, C_text("f64vector"));
lf[1427]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\102\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\154\157\143\141\164\151\166\145\040\143\141\156\156\157\164\040\162\145\146\145\162\040\164\157\040\157\142\152\145\143\164\163\040\157\146\040\164\150\151\163\040\164\171\160\145\000"));
lf[1428]=C_h_intern(&lf[1428],14, C_text("chicken.plist#"));
lf[1429]=C_h_intern(&lf[1429],18, C_text("chicken.plist#put!"));
lf[1430]=C_h_intern(&lf[1430],4, C_text("put!"));
lf[1431]=C_h_intern(&lf[1431],17, C_text("chicken.plist#get"));
lf[1432]=C_h_intern(&lf[1432],3, C_text("get"));
lf[1433]=C_h_intern(&lf[1433],10, C_text("##sys#put!"));
lf[1434]=C_h_intern(&lf[1434],9, C_text("##sys#get"));
lf[1435]=C_h_intern(&lf[1435],22, C_text("chicken.plist#remprop!"));
lf[1436]=C_h_intern(&lf[1436],8, C_text("remprop!"));
lf[1437]=C_h_intern(&lf[1437],26, C_text("chicken.plist#symbol-plist"));
lf[1438]=C_h_intern(&lf[1438],28, C_text("chicken.plist#get-properties"));
lf[1439]=C_h_intern(&lf[1439],14, C_text("get-properties"));
lf[1440]=C_h_intern(&lf[1440],19, C_text("##sys#display-times"));
lf[1441]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\060\000"));
lf[1442]=C_decode_literal(C_heaptop,C_text("\376\12510.0\000"));
lf[1443]=C_decode_literal(C_heaptop,C_text("\376\320\000\000\01040000000"));
lf[1444]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\005\040\107\151\102\000"));
lf[1445]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\005\040\115\151\102\000"));
lf[1446]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\005\040\113\151\102\000"));
lf[1447]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\007\040\142\171\164\145\163\000"));
lf[1448]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\026\054\040\155\141\170\151\155\165\155\040\154\151\166\145\040\150\145\141\160\072\040\000"));
lf[1449]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\023\040\107\103\163\040\050\155\141\152\157\162\057\155\151\156\157\162\051\000"));
lf[1450]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\054\040\000"));
lf[1451]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\040\155\165\164\141\164\151\157\156\163\040\050\164\157\164\141\154\057\164\162\141\143\153\145\144\051\000"));
lf[1452]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\054\040\000"));
lf[1453]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\163\040\107\103\040\164\151\155\145\040\050\155\141\152\157\162\051\000"));
lf[1454]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\054\040\000"));
lf[1455]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\013\163\040\103\120\125\040\164\151\155\145\000"));
lf[1456]=C_h_intern(&lf[1456],25, C_text("##sys#filter-heap-objects"));
lf[1457]=C_h_intern(&lf[1457],17, C_text("chicken.platform#"));
lf[1458]=C_h_intern(&lf[1458],30, C_text("chicken.platform#software-type"));
lf[1459]=C_h_intern(&lf[1459],29, C_text("chicken.platform#machine-type"));
lf[1460]=C_h_intern(&lf[1460],35, C_text("chicken.platform#machine-byte-order"));
lf[1461]=C_h_intern(&lf[1461],33, C_text("chicken.platform#software-version"));
lf[1462]=C_h_intern(&lf[1462],31, C_text("chicken.platform#build-platform"));
lf[1463]=C_h_intern(&lf[1463],22, C_text("##sys#windows-platform"));
lf[1464]=C_h_intern(&lf[1464],32, C_text("chicken.platform#chicken-version"));
lf[1465]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\126\145\162\163\151\157\156\040\000"));
lf[1466]=C_h_intern(&lf[1466],19, C_text("##sys#build-version"));
lf[1467]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\012\000"));
lf[1468]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1469]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\040\133\000"));
lf[1470]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\040\135\000"));
lf[1471]=C_h_intern(&lf[1471],7, C_text("unknown"));
lf[1472]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1473]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\055\000"));
lf[1474]=C_h_intern(&lf[1474],14, C_text("##sys#build-id"));
lf[1475]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\007\040\050\162\145\166\040\000"));
lf[1476]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\051\000"));
lf[1477]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1478]=C_h_intern(&lf[1478],18, C_text("##sys#build-branch"));
lf[1479]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\040\050\000"));
lf[1480]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\051\000"));
lf[1481]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1482]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\007\040\144\154\157\141\144\000"));
lf[1483]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1484]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\040\160\164\141\142\154\145\163\000"));
lf[1485]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1486]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\040\147\143\150\157\157\153\163\000"));
lf[1487]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1488]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\040\000"));
lf[1489]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\142\151\164\000"));
lf[1490]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\007\040\143\162\157\163\163\000"));
lf[1491]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1492]=C_h_intern(&lf[1492],25, C_text("chicken.platform#feature?"));
lf[1493]=C_h_intern_kw(&lf[1493],13, C_text("cross-chicken"));
lf[1494]=C_h_intern_kw(&lf[1494],7, C_text("gchooks"));
lf[1495]=C_h_intern_kw(&lf[1495],7, C_text("ptables"));
lf[1496]=C_h_intern_kw(&lf[1496],5, C_text("dload"));
lf[1497]=C_h_intern(&lf[1497],29, C_text("chicken.platform#chicken-home"));
lf[1498]=C_h_intern(&lf[1498],29, C_text("chicken.platform#include-path"));
lf[1499]=C_h_intern(&lf[1499],12, C_text("include-path"));
lf[1500]=C_h_intern(&lf[1500],23, C_text("##sys#include-pathnames"));
lf[1501]=C_h_intern(&lf[1501],19, C_text("##include-pathnames"));
lf[1503]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\377\006\000\376\377\016"));
lf[1504]=C_h_intern(&lf[1504],16, C_text("##sys#split-path"));
lf[1505]=C_h_intern(&lf[1505],32, C_text("chicken.platform#repository-path"));
lf[1506]=C_h_intern(&lf[1506],40, C_text("chicken.platform#installation-repository"));
lf[1509]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\062\142\141\144\040\141\162\147\165\155\145\156\164\040\164\171\160\145\040\055\040\156\157\164\040\141\040\166\141\154\151\144\040\146\145\141\164\165\162\145\040\151\144\145\156\164\151\146\145\162\000"));
lf[1510]=C_h_intern(&lf[1510],14, C_text("##sys#features"));
lf[1511]=C_decode_literal(C_heaptop,C_text("\376\003\000\000\002\376\001\000\000\007\002\143\150\151\143\153\145\156\376\003\000\000\002\376\001\000\000\006\002\163\162\146\151\055\066\376\003\000\000\002\376\001\000\000\007\002\163\162\146\151\055\061\062\376\003\000\000\002\376\001\000\000\007\002\163\162\146\151\055\061\067\376\003\000\000\002\376\001\000\000\007\002\163\162\146\151\055\062\063\376\003\000\000\002\376\001\000\000\007\002\163\162\146\151\055\063\060\376\003\000\000\002\376\001\000\000\015\002\145\170\141\143\164\055\143\157\155\160\154\145\170\376\003\000\000\002\376\001\000\000\007\002\163\162\146\151\055\063\071\376\003\000\000\002\376\001\000\000\007\002\163\162\146\151\055\066\062\376\003\000\000\002\376\001\000\000\007\002\163\162\146\151\055\070\070\376\003\000\000\002\376\001\000\000\022\002\146\165\154\154\055\156\165\155\145\162\151\143\055\164\157\167\145\162\376\003\000\000\002\376\001\000\000\014\002\146\165\154\154\055\165\156\151\143\157\144\145\376\377\016"));
lf[1512]=C_h_intern_kw(&lf[1512],6, C_text("ratios"));
lf[1513]=C_h_intern_kw(&lf[1513],10, C_text("ieee-float"));
lf[1514]=C_h_intern_kw(&lf[1514],4, C_text("r7rs"));
lf[1515]=C_h_intern_kw(&lf[1515],5, C_text("posix"));
lf[1516]=C_h_intern(&lf[1516],34, C_text("chicken.platform#register-feature!"));
lf[1517]=C_h_intern(&lf[1517],36, C_text("chicken.platform#unregister-feature!"));
lf[1518]=C_h_intern(&lf[1518],31, C_text("chicken.platform#return-to-host"));
lf[1519]=C_h_intern(&lf[1519],40, C_text("chicken.platform#system-config-directory"));
lf[1520]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\010\101\120\120\104\101\124\101\000"));
lf[1521]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\057\056\143\157\156\146\151\147\000"));
lf[1522]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\005\110\117\115\105\000"));
lf[1523]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\020\130\104\107\137\103\117\116\106\111\107\137\110\117\115\105\000"));
lf[1524]=C_h_intern(&lf[1524],39, C_text("chicken.platform#system-cache-directory"));
lf[1525]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\010\101\120\120\104\101\124\101\000"));
lf[1526]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\114\117\103\101\114\101\120\120\104\101\124\101\000"));
lf[1527]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\010\057\056\143\141\143\150\145\000"));
lf[1528]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\005\110\117\115\105\000"));
lf[1529]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\130\104\107\137\103\101\103\110\105\137\110\117\115\105\000"));
lf[1530]=C_h_intern(&lf[1530],9, C_text("make-list"));
lf[1531]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\027\156\157\164\040\141\040\160\157\163\151\164\151\166\145\040\151\156\164\145\147\145\162\000"));
lf[1532]=C_h_intern(&lf[1532],9, C_text("list-set!"));
lf[1533]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\015\157\165\164\040\157\146\040\162\141\156\147\145\000"));
lf[1534]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\027\156\157\164\040\141\040\160\157\163\151\164\151\166\145\040\151\156\164\145\147\145\162\000"));
lf[1535]=C_h_intern(&lf[1535],14, C_text("string->vector"));
lf[1536]=C_h_intern(&lf[1536],14, C_text("vector->string"));
lf[1537]=C_h_intern(&lf[1537],10, C_text("string-map"));
lf[1538]=C_h_intern(&lf[1538],15, C_text("string-for-each"));
lf[1539]=C_h_intern(&lf[1539],10, C_text("vector-map"));
lf[1540]=C_h_intern(&lf[1540],15, C_text("vector-for-each"));
lf[1541]=C_h_intern(&lf[1541],10, C_text("close-port"));
lf[1542]=C_h_intern(&lf[1542],7, C_text("peek-u8"));
lf[1543]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\061\156\157\040\155\141\164\143\150\151\156\147\040\143\154\141\165\163\145\040\151\156\040\143\141\154\154\040\164\157\040\047\143\141\163\145\055\154\141\155\142\144\141\047\040\146\157\162\155\000"));
lf[1544]=C_h_intern(&lf[1544],12, C_text("write-string"));
lf[1545]=C_h_intern(&lf[1545],11, C_text("chicken.io#"));
lf[1546]=C_h_intern(&lf[1546],20, C_text("chicken.io#read-list"));
lf[1547]=C_h_intern(&lf[1547],9, C_text("read-list"));
lf[1548]=C_h_intern(&lf[1548],20, C_text("chicken.io#read-line"));
lf[1549]=C_h_intern(&lf[1549],21, C_text("chicken.io#read-lines"));
lf[1550]=C_h_intern(&lf[1550],10, C_text("read-lines"));
lf[1551]=C_h_intern(&lf[1551],21, C_text("chicken.io#write-line"));
lf[1552]=C_h_intern(&lf[1552],10, C_text("write-line"));
lf[1553]=C_h_intern(&lf[1553],32, C_text("chicken.io#read-bytevector!/port"));
lf[1554]=C_h_intern(&lf[1554],28, C_text("chicken.io#read-string!/port"));
lf[1555]=C_h_intern(&lf[1555],23, C_text("chicken.io#read-string!"));
lf[1556]=C_h_intern(&lf[1556],12, C_text("read-string!"));
lf[1557]=C_h_intern(&lf[1557],27, C_text("chicken.io#read-bytevector!"));
lf[1558]=C_h_intern(&lf[1558],27, C_text("chicken.io#read-string/port"));
lf[1559]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1560]=C_h_intern(&lf[1560],20, C_text("##sys#read-remaining"));
lf[1561]=C_h_intern(&lf[1561],31, C_text("chicken.io#read-bytevector/port"));
lf[1562]=C_h_intern(&lf[1562],22, C_text("chicken.io#read-string"));
lf[1563]=C_h_intern(&lf[1563],11, C_text("read-string"));
lf[1564]=C_h_intern(&lf[1564],26, C_text("chicken.io#read-bytevector"));
lf[1565]=C_h_intern(&lf[1565],15, C_text("read-bytevector"));
lf[1566]=C_h_intern(&lf[1566],24, C_text("chicken.io#read-buffered"));
lf[1567]=C_h_intern(&lf[1567],13, C_text("read-buffered"));
lf[1568]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[1569]=C_h_intern(&lf[1569],21, C_text("chicken.io#read-token"));
lf[1570]=C_h_intern(&lf[1570],10, C_text("read-token"));
lf[1571]=C_h_intern(&lf[1571],20, C_text("chicken.io#read-byte"));
lf[1572]=C_h_intern(&lf[1572],9, C_text("read-byte"));
lf[1573]=C_h_intern(&lf[1573],21, C_text("chicken.io#write-byte"));
lf[1574]=C_h_intern(&lf[1574],10, C_text("write-byte"));
lf[1575]=C_h_intern(&lf[1575],27, C_text("chicken.io#write-bytevector"));
lf[1576]=C_h_intern(&lf[1576],16, C_text("write-bytevector"));
lf[1577]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\143\150\151\143\153\145\156\055\000"));
lf[1578]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\002\056\000"));
lf[1579]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\143\150\151\143\153\145\156\055\000"));
lf[1580]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\142\151\164\000"));
lf[1581]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\025\103\110\111\103\113\105\116\137\111\116\103\114\125\104\105\137\120\101\124\110\000"));
lf[1582]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\103\110\111\103\113\105\116\137\111\116\123\124\101\114\114\137\122\105\120\117\123\111\124\117\122\131\000"));
lf[1583]=C_h_intern(&lf[1583],15, C_text("repository-path"));
lf[1584]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\030\103\110\111\103\113\105\116\137\122\105\120\117\123\111\124\117\122\131\137\120\101\124\110\000"));
lf[1585]=C_h_intern(&lf[1585],7, C_text("windows"));
lf[1586]=C_h_intern(&lf[1586],6, C_text("cygwin"));
lf[1587]=C_h_intern(&lf[1587],12, C_text("symbol-plist"));
lf[1588]=C_h_intern(&lf[1588],19, C_text("symbol-plist/setter"));
lf[1589]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\045\160\162\157\160\145\162\164\171\055\154\151\163\164\040\155\165\163\164\040\142\145\040\157\146\040\145\166\145\156\040\154\145\156\147\164\150\000"));
lf[1590]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\050\143\150\151\143\153\145\156\056\160\154\151\163\164\043\163\171\155\142\157\154\055\160\154\151\163\164\040\163\171\155\051\000"));
lf[1591]=C_h_intern(&lf[1591],22, C_text("command-line-arguments"));
lf[1592]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\055\072\000"));
lf[1593]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\055\072\000"));
lf[1594]=C_h_intern(&lf[1594],12, C_text("program-name"));
lf[1595]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\012\074\165\156\153\156\157\167\156\076\000"));
lf[1596]=C_h_intern(&lf[1596],17, C_text("current-directory"));
lf[1597]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\042\143\141\156\156\157\164\040\162\145\164\162\151\145\166\145\040\143\165\162\162\145\156\164\040\144\151\162\145\143\164\157\162\171\000"));
lf[1598]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\054\050\143\150\151\143\153\145\156\056\160\162\157\143\145\163\163\055\143\157\156\164\145\170\164\043\143\165\162\162\145\156\164\055\144\151\162\145\143\164\157\162\171\051\000"));
lf[1599]=C_h_intern(&lf[1599],7, C_text("running"));
lf[1600]=C_h_intern(&lf[1600],10, C_text("primordial"));
lf[1601]=C_h_intern(&lf[1601],6, C_text("syntax"));
lf[1602]=C_h_intern(&lf[1602],4, C_text("file"));
lf[1603]=C_h_intern(&lf[1603],3, C_text("i/o"));
lf[1604]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\072\040\000"));
lf[1605]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\003\072\040\000"));
lf[1606]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\007\012\105\162\162\157\162\000"));
lf[1607]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\145\162\162\157\162\040\151\156\040\145\162\162\157\162\000"));
lf[1608]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\055\042\145\170\151\164\042\040\143\141\154\154\145\144\040\167\150\151\154\145\040\160\162\157\143\145\163\163\151\156\147\040\157\156\055\145\170\151\164\040\164\141\163\153\163\000"));
lf[1609]=C_h_intern(&lf[1609],10, C_text("read-table"));
lf[1610]=C_h_intern(&lf[1610],13, C_text("keyword-style"));
lf[1611]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\053\050\143\150\151\143\153\145\156\056\142\171\164\145\166\145\143\164\157\162\043\142\171\164\145\166\145\143\164\157\162\055\165\070\055\162\145\146\040\166\040\151\051\000"));
lf[1612]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\156\157\040\163\145\164\164\145\162\040\144\145\146\151\156\145\144\000"));
lf[1613]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\044\143\141\156\040\156\157\164\040\163\145\164\040\163\145\164\164\145\162\040\157\146\040\156\157\156\055\160\162\157\143\145\144\165\162\145\000"));
lf[1614]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\050\163\164\144\145\162\162\051\000"));
lf[1615]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\050\163\164\144\157\165\164\051\000"));
lf[1616]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\010\050\163\164\144\151\156\051\000"));
lf[1617]=C_h_intern(&lf[1617],9, C_text("backspace"));
lf[1618]=C_h_intern(&lf[1618],4, C_text("page"));
lf[1619]=C_h_intern(&lf[1619],6, C_text("return"));
lf[1620]=C_h_intern(&lf[1620],4, C_text("null"));
lf[1621]=C_h_intern(&lf[1621],3, C_text("nul"));
lf[1622]=C_h_intern(&lf[1622],5, C_text("alarm"));
lf[1623]=C_h_intern(&lf[1623],6, C_text("escape"));
lf[1624]=C_h_intern(&lf[1624],3, C_text("esc"));
lf[1625]=C_h_intern(&lf[1625],6, C_text("delete"));
lf[1626]=C_h_intern(&lf[1626],4, C_text("vtab"));
lf[1627]=C_h_intern(&lf[1627],7, C_text("newline"));
lf[1628]=C_h_intern(&lf[1628],8, C_text("linefeed"));
lf[1629]=C_h_intern(&lf[1629],3, C_text("tab"));
lf[1630]=C_h_intern(&lf[1630],5, C_text("space"));
C_register_lf2(lf,1631,create_ptable());{}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_11438,a[2]=t1,tmp=(C_word)a,a+=3,tmp);{
C_word *av2=av;
av2[0]=C_SCHEME_UNDEFINED;
av2[1]=t2;
C_build_2dversion_toplevel(2,av2);}}

#ifdef C_ENABLE_PTABLES
static C_PTABLE_ENTRY ptable[2530] = {
{C_text("f45112:library_2escm"),(void*)f45112},
{C_text("f45311:library_2escm"),(void*)f45311},
{C_text("f45315:library_2escm"),(void*)f45315},
{C_text("f45445:library_2escm"),(void*)f45445},
{C_text("f45450:library_2escm"),(void*)f45450},
{C_text("f45457:library_2escm"),(void*)f45457},
{C_text("f45466:library_2escm"),(void*)f45466},
{C_text("f45475:library_2escm"),(void*)f45475},
{C_text("f49039:library_2escm"),(void*)f49039},
{C_text("f49045:library_2escm"),(void*)f49045},
{C_text("f49051:library_2escm"),(void*)f49051},
{C_text("f_11438:library_2escm"),(void*)f_11438},
{C_text("f_11440:library_2escm"),(void*)f_11440},
{C_text("f_11443:library_2escm"),(void*)f_11443},
{C_text("f_11446:library_2escm"),(void*)f_11446},
{C_text("f_11449:library_2escm"),(void*)f_11449},
{C_text("f_11452:library_2escm"),(void*)f_11452},
{C_text("f_11455:library_2escm"),(void*)f_11455},
{C_text("f_11471:library_2escm"),(void*)f_11471},
{C_text("f_11500:library_2escm"),(void*)f_11500},
{C_text("f_11516:library_2escm"),(void*)f_11516},
{C_text("f_11545:library_2escm"),(void*)f_11545},
{C_text("f_11548:library_2escm"),(void*)f_11548},
{C_text("f_11551:library_2escm"),(void*)f_11551},
{C_text("f_11554:library_2escm"),(void*)f_11554},
{C_text("f_11557:library_2escm"),(void*)f_11557},
{C_text("f_11560:library_2escm"),(void*)f_11560},
{C_text("f_11563:library_2escm"),(void*)f_11563},
{C_text("f_11566:library_2escm"),(void*)f_11566},
{C_text("f_11569:library_2escm"),(void*)f_11569},
{C_text("f_11572:library_2escm"),(void*)f_11572},
{C_text("f_11575:library_2escm"),(void*)f_11575},
{C_text("f_11578:library_2escm"),(void*)f_11578},
{C_text("f_11581:library_2escm"),(void*)f_11581},
{C_text("f_11584:library_2escm"),(void*)f_11584},
{C_text("f_11598:library_2escm"),(void*)f_11598},
{C_text("f_11605:library_2escm"),(void*)f_11605},
{C_text("f_11612:library_2escm"),(void*)f_11612},
{C_text("f_11626:library_2escm"),(void*)f_11626},
{C_text("f_11633:library_2escm"),(void*)f_11633},
{C_text("f_11647:library_2escm"),(void*)f_11647},
{C_text("f_11661:library_2escm"),(void*)f_11661},
{C_text("f_11679:library_2escm"),(void*)f_11679},
{C_text("f_11690:library_2escm"),(void*)f_11690},
{C_text("f_11701:library_2escm"),(void*)f_11701},
{C_text("f_11708:library_2escm"),(void*)f_11708},
{C_text("f_11719:library_2escm"),(void*)f_11719},
{C_text("f_11723:library_2escm"),(void*)f_11723},
{C_text("f_11730:library_2escm"),(void*)f_11730},
{C_text("f_11748:library_2escm"),(void*)f_11748},
{C_text("f_11759:library_2escm"),(void*)f_11759},
{C_text("f_11770:library_2escm"),(void*)f_11770},
{C_text("f_11777:library_2escm"),(void*)f_11777},
{C_text("f_11795:library_2escm"),(void*)f_11795},
{C_text("f_11806:library_2escm"),(void*)f_11806},
{C_text("f_11824:library_2escm"),(void*)f_11824},
{C_text("f_11830:library_2escm"),(void*)f_11830},
{C_text("f_11833:library_2escm"),(void*)f_11833},
{C_text("f_11836:library_2escm"),(void*)f_11836},
{C_text("f_11839:library_2escm"),(void*)f_11839},
{C_text("f_11842:library_2escm"),(void*)f_11842},
{C_text("f_11848:library_2escm"),(void*)f_11848},
{C_text("f_11881:library_2escm"),(void*)f_11881},
{C_text("f_11884:library_2escm"),(void*)f_11884},
{C_text("f_11887:library_2escm"),(void*)f_11887},
{C_text("f_11899:library_2escm"),(void*)f_11899},
{C_text("f_11912:library_2escm"),(void*)f_11912},
{C_text("f_11931:library_2escm"),(void*)f_11931},
{C_text("f_11934:library_2escm"),(void*)f_11934},
{C_text("f_11937:library_2escm"),(void*)f_11937},
{C_text("f_11949:library_2escm"),(void*)f_11949},
{C_text("f_11962:library_2escm"),(void*)f_11962},
{C_text("f_11986:library_2escm"),(void*)f_11986},
{C_text("f_11989:library_2escm"),(void*)f_11989},
{C_text("f_11992:library_2escm"),(void*)f_11992},
{C_text("f_11995:library_2escm"),(void*)f_11995},
{C_text("f_11998:library_2escm"),(void*)f_11998},
{C_text("f_12001:library_2escm"),(void*)f_12001},
{C_text("f_12008:library_2escm"),(void*)f_12008},
{C_text("f_12034:library_2escm"),(void*)f_12034},
{C_text("f_12041:library_2escm"),(void*)f_12041},
{C_text("f_12085:library_2escm"),(void*)f_12085},
{C_text("f_12088:library_2escm"),(void*)f_12088},
{C_text("f_12094:library_2escm"),(void*)f_12094},
{C_text("f_12097:library_2escm"),(void*)f_12097},
{C_text("f_12100:library_2escm"),(void*)f_12100},
{C_text("f_12103:library_2escm"),(void*)f_12103},
{C_text("f_12106:library_2escm"),(void*)f_12106},
{C_text("f_12114:library_2escm"),(void*)f_12114},
{C_text("f_12118:library_2escm"),(void*)f_12118},
{C_text("f_12121:library_2escm"),(void*)f_12121},
{C_text("f_12124:library_2escm"),(void*)f_12124},
{C_text("f_12127:library_2escm"),(void*)f_12127},
{C_text("f_12130:library_2escm"),(void*)f_12130},
{C_text("f_12133:library_2escm"),(void*)f_12133},
{C_text("f_12136:library_2escm"),(void*)f_12136},
{C_text("f_12139:library_2escm"),(void*)f_12139},
{C_text("f_12143:library_2escm"),(void*)f_12143},
{C_text("f_12146:library_2escm"),(void*)f_12146},
{C_text("f_12149:library_2escm"),(void*)f_12149},
{C_text("f_12152:library_2escm"),(void*)f_12152},
{C_text("f_12155:library_2escm"),(void*)f_12155},
{C_text("f_12163:library_2escm"),(void*)f_12163},
{C_text("f_12166:library_2escm"),(void*)f_12166},
{C_text("f_12173:library_2escm"),(void*)f_12173},
{C_text("f_12180:library_2escm"),(void*)f_12180},
{C_text("f_12193:library_2escm"),(void*)f_12193},
{C_text("f_12219:library_2escm"),(void*)f_12219},
{C_text("f_12232:library_2escm"),(void*)f_12232},
{C_text("f_12258:library_2escm"),(void*)f_12258},
{C_text("f_12271:library_2escm"),(void*)f_12271},
{C_text("f_12297:library_2escm"),(void*)f_12297},
{C_text("f_12310:library_2escm"),(void*)f_12310},
{C_text("f_12336:library_2escm"),(void*)f_12336},
{C_text("f_12349:library_2escm"),(void*)f_12349},
{C_text("f_12375:library_2escm"),(void*)f_12375},
{C_text("f_12381:library_2escm"),(void*)f_12381},
{C_text("f_12392:library_2escm"),(void*)f_12392},
{C_text("f_12398:library_2escm"),(void*)f_12398},
{C_text("f_12404:library_2escm"),(void*)f_12404},
{C_text("f_12410:library_2escm"),(void*)f_12410},
{C_text("f_12416:library_2escm"),(void*)f_12416},
{C_text("f_12422:library_2escm"),(void*)f_12422},
{C_text("f_12438:library_2escm"),(void*)f_12438},
{C_text("f_12446:library_2escm"),(void*)f_12446},
{C_text("f_12452:library_2escm"),(void*)f_12452},
{C_text("f_12458:library_2escm"),(void*)f_12458},
{C_text("f_12465:library_2escm"),(void*)f_12465},
{C_text("f_12474:library_2escm"),(void*)f_12474},
{C_text("f_12481:library_2escm"),(void*)f_12481},
{C_text("f_12490:library_2escm"),(void*)f_12490},
{C_text("f_12496:library_2escm"),(void*)f_12496},
{C_text("f_12501:library_2escm"),(void*)f_12501},
{C_text("f_12516:library_2escm"),(void*)f_12516},
{C_text("f_12527:library_2escm"),(void*)f_12527},
{C_text("f_12533:library_2escm"),(void*)f_12533},
{C_text("f_12539:library_2escm"),(void*)f_12539},
{C_text("f_12545:library_2escm"),(void*)f_12545},
{C_text("f_12551:library_2escm"),(void*)f_12551},
{C_text("f_12561:library_2escm"),(void*)f_12561},
{C_text("f_12563:library_2escm"),(void*)f_12563},
{C_text("f_12566:library_2escm"),(void*)f_12566},
{C_text("f_12569:library_2escm"),(void*)f_12569},
{C_text("f_12572:library_2escm"),(void*)f_12572},
{C_text("f_12575:library_2escm"),(void*)f_12575},
{C_text("f_12578:library_2escm"),(void*)f_12578},
{C_text("f_12583:library_2escm"),(void*)f_12583},
{C_text("f_12589:library_2escm"),(void*)f_12589},
{C_text("f_12595:library_2escm"),(void*)f_12595},
{C_text("f_12630:library_2escm"),(void*)f_12630},
{C_text("f_12633:library_2escm"),(void*)f_12633},
{C_text("f_12636:library_2escm"),(void*)f_12636},
{C_text("f_12644:library_2escm"),(void*)f_12644},
{C_text("f_12650:library_2escm"),(void*)f_12650},
{C_text("f_12657:library_2escm"),(void*)f_12657},
{C_text("f_12672:library_2escm"),(void*)f_12672},
{C_text("f_12686:library_2escm"),(void*)f_12686},
{C_text("f_12692:library_2escm"),(void*)f_12692},
{C_text("f_12698:library_2escm"),(void*)f_12698},
{C_text("f_12705:library_2escm"),(void*)f_12705},
{C_text("f_12710:library_2escm"),(void*)f_12710},
{C_text("f_12713:library_2escm"),(void*)f_12713},
{C_text("f_12722:library_2escm"),(void*)f_12722},
{C_text("f_12740:library_2escm"),(void*)f_12740},
{C_text("f_12750:library_2escm"),(void*)f_12750},
{C_text("f_12759:library_2escm"),(void*)f_12759},
{C_text("f_12777:library_2escm"),(void*)f_12777},
{C_text("f_12790:library_2escm"),(void*)f_12790},
{C_text("f_12797:library_2escm"),(void*)f_12797},
{C_text("f_12804:library_2escm"),(void*)f_12804},
{C_text("f_12815:library_2escm"),(void*)f_12815},
{C_text("f_12834:library_2escm"),(void*)f_12834},
{C_text("f_12837:library_2escm"),(void*)f_12837},
{C_text("f_12839:library_2escm"),(void*)f_12839},
{C_text("f_12845:library_2escm"),(void*)f_12845},
{C_text("f_12861:library_2escm"),(void*)f_12861},
{C_text("f_12870:library_2escm"),(void*)f_12870},
{C_text("f_12872:library_2escm"),(void*)f_12872},
{C_text("f_12878:library_2escm"),(void*)f_12878},
{C_text("f_12891:library_2escm"),(void*)f_12891},
{C_text("f_12907:library_2escm"),(void*)f_12907},
{C_text("f_12918:library_2escm"),(void*)f_12918},
{C_text("f_12920:library_2escm"),(void*)f_12920},
{C_text("f_12928:library_2escm"),(void*)f_12928},
{C_text("f_12930:library_2escm"),(void*)f_12930},
{C_text("f_12936:library_2escm"),(void*)f_12936},
{C_text("f_12938:library_2escm"),(void*)f_12938},
{C_text("f_12946:library_2escm"),(void*)f_12946},
{C_text("f_12948:library_2escm"),(void*)f_12948},
{C_text("f_12951:library_2escm"),(void*)f_12951},
{C_text("f_12959:library_2escm"),(void*)f_12959},
{C_text("f_12965:library_2escm"),(void*)f_12965},
{C_text("f_12973:library_2escm"),(void*)f_12973},
{C_text("f_12984:library_2escm"),(void*)f_12984},
{C_text("f_12996:library_2escm"),(void*)f_12996},
{C_text("f_13010:library_2escm"),(void*)f_13010},
{C_text("f_13018:library_2escm"),(void*)f_13018},
{C_text("f_13021:library_2escm"),(void*)f_13021},
{C_text("f_13023:library_2escm"),(void*)f_13023},
{C_text("f_13025:library_2escm"),(void*)f_13025},
{C_text("f_13031:library_2escm"),(void*)f_13031},
{C_text("f_13050:library_2escm"),(void*)f_13050},
{C_text("f_13067:library_2escm"),(void*)f_13067},
{C_text("f_13075:library_2escm"),(void*)f_13075},
{C_text("f_13089:library_2escm"),(void*)f_13089},
{C_text("f_13095:library_2escm"),(void*)f_13095},
{C_text("f_13114:library_2escm"),(void*)f_13114},
{C_text("f_13123:library_2escm"),(void*)f_13123},
{C_text("f_13126:library_2escm"),(void*)f_13126},
{C_text("f_13129:library_2escm"),(void*)f_13129},
{C_text("f_13132:library_2escm"),(void*)f_13132},
{C_text("f_13135:library_2escm"),(void*)f_13135},
{C_text("f_13144:library_2escm"),(void*)f_13144},
{C_text("f_13163:library_2escm"),(void*)f_13163},
{C_text("f_13169:library_2escm"),(void*)f_13169},
{C_text("f_13194:library_2escm"),(void*)f_13194},
{C_text("f_13196:library_2escm"),(void*)f_13196},
{C_text("f_13205:library_2escm"),(void*)f_13205},
{C_text("f_13226:library_2escm"),(void*)f_13226},
{C_text("f_13228:library_2escm"),(void*)f_13228},
{C_text("f_13234:library_2escm"),(void*)f_13234},
{C_text("f_13260:library_2escm"),(void*)f_13260},
{C_text("f_13267:library_2escm"),(void*)f_13267},
{C_text("f_13269:library_2escm"),(void*)f_13269},
{C_text("f_13281:library_2escm"),(void*)f_13281},
{C_text("f_13316:library_2escm"),(void*)f_13316},
{C_text("f_13326:library_2escm"),(void*)f_13326},
{C_text("f_13335:library_2escm"),(void*)f_13335},
{C_text("f_13377:library_2escm"),(void*)f_13377},
{C_text("f_13406:library_2escm"),(void*)f_13406},
{C_text("f_13412:library_2escm"),(void*)f_13412},
{C_text("f_13426:library_2escm"),(void*)f_13426},
{C_text("f_13432:library_2escm"),(void*)f_13432},
{C_text("f_13439:library_2escm"),(void*)f_13439},
{C_text("f_13442:library_2escm"),(void*)f_13442},
{C_text("f_13471:library_2escm"),(void*)f_13471},
{C_text("f_13477:library_2escm"),(void*)f_13477},
{C_text("f_13493:library_2escm"),(void*)f_13493},
{C_text("f_13518:library_2escm"),(void*)f_13518},
{C_text("f_13527:library_2escm"),(void*)f_13527},
{C_text("f_13568:library_2escm"),(void*)f_13568},
{C_text("f_13590:library_2escm"),(void*)f_13590},
{C_text("f_13622:library_2escm"),(void*)f_13622},
{C_text("f_13638:library_2escm"),(void*)f_13638},
{C_text("f_13641:library_2escm"),(void*)f_13641},
{C_text("f_13663:library_2escm"),(void*)f_13663},
{C_text("f_13669:library_2escm"),(void*)f_13669},
{C_text("f_13694:library_2escm"),(void*)f_13694},
{C_text("f_13734:library_2escm"),(void*)f_13734},
{C_text("f_13746:library_2escm"),(void*)f_13746},
{C_text("f_13765:library_2escm"),(void*)f_13765},
{C_text("f_13782:library_2escm"),(void*)f_13782},
{C_text("f_13789:library_2escm"),(void*)f_13789},
{C_text("f_13799:library_2escm"),(void*)f_13799},
{C_text("f_13810:library_2escm"),(void*)f_13810},
{C_text("f_13814:library_2escm"),(void*)f_13814},
{C_text("f_13827:library_2escm"),(void*)f_13827},
{C_text("f_13829:library_2escm"),(void*)f_13829},
{C_text("f_13863:library_2escm"),(void*)f_13863},
{C_text("f_13867:library_2escm"),(void*)f_13867},
{C_text("f_13885:library_2escm"),(void*)f_13885},
{C_text("f_13898:library_2escm"),(void*)f_13898},
{C_text("f_13910:library_2escm"),(void*)f_13910},
{C_text("f_13916:library_2escm"),(void*)f_13916},
{C_text("f_13926:library_2escm"),(void*)f_13926},
{C_text("f_13930:library_2escm"),(void*)f_13930},
{C_text("f_13934:library_2escm"),(void*)f_13934},
{C_text("f_13938:library_2escm"),(void*)f_13938},
{C_text("f_13941:library_2escm"),(void*)f_13941},
{C_text("f_13943:library_2escm"),(void*)f_13943},
{C_text("f_13947:library_2escm"),(void*)f_13947},
{C_text("f_13951:library_2escm"),(void*)f_13951},
{C_text("f_13955:library_2escm"),(void*)f_13955},
{C_text("f_13959:library_2escm"),(void*)f_13959},
{C_text("f_13974:library_2escm"),(void*)f_13974},
{C_text("f_13991:library_2escm"),(void*)f_13991},
{C_text("f_13997:library_2escm"),(void*)f_13997},
{C_text("f_14003:library_2escm"),(void*)f_14003},
{C_text("f_14006:library_2escm"),(void*)f_14006},
{C_text("f_14013:library_2escm"),(void*)f_14013},
{C_text("f_14050:library_2escm"),(void*)f_14050},
{C_text("f_14053:library_2escm"),(void*)f_14053},
{C_text("f_14056:library_2escm"),(void*)f_14056},
{C_text("f_14059:library_2escm"),(void*)f_14059},
{C_text("f_14065:library_2escm"),(void*)f_14065},
{C_text("f_14068:library_2escm"),(void*)f_14068},
{C_text("f_14071:library_2escm"),(void*)f_14071},
{C_text("f_14074:library_2escm"),(void*)f_14074},
{C_text("f_14077:library_2escm"),(void*)f_14077},
{C_text("f_14080:library_2escm"),(void*)f_14080},
{C_text("f_14083:library_2escm"),(void*)f_14083},
{C_text("f_14086:library_2escm"),(void*)f_14086},
{C_text("f_14089:library_2escm"),(void*)f_14089},
{C_text("f_14092:library_2escm"),(void*)f_14092},
{C_text("f_14095:library_2escm"),(void*)f_14095},
{C_text("f_14098:library_2escm"),(void*)f_14098},
{C_text("f_14101:library_2escm"),(void*)f_14101},
{C_text("f_14104:library_2escm"),(void*)f_14104},
{C_text("f_14107:library_2escm"),(void*)f_14107},
{C_text("f_14110:library_2escm"),(void*)f_14110},
{C_text("f_14113:library_2escm"),(void*)f_14113},
{C_text("f_14116:library_2escm"),(void*)f_14116},
{C_text("f_14119:library_2escm"),(void*)f_14119},
{C_text("f_14122:library_2escm"),(void*)f_14122},
{C_text("f_14125:library_2escm"),(void*)f_14125},
{C_text("f_14128:library_2escm"),(void*)f_14128},
{C_text("f_14131:library_2escm"),(void*)f_14131},
{C_text("f_14134:library_2escm"),(void*)f_14134},
{C_text("f_14137:library_2escm"),(void*)f_14137},
{C_text("f_14142:library_2escm"),(void*)f_14142},
{C_text("f_14151:library_2escm"),(void*)f_14151},
{C_text("f_14163:library_2escm"),(void*)f_14163},
{C_text("f_14177:library_2escm"),(void*)f_14177},
{C_text("f_14193:library_2escm"),(void*)f_14193},
{C_text("f_14196:library_2escm"),(void*)f_14196},
{C_text("f_14205:library_2escm"),(void*)f_14205},
{C_text("f_14209:library_2escm"),(void*)f_14209},
{C_text("f_14211:library_2escm"),(void*)f_14211},
{C_text("f_14215:library_2escm"),(void*)f_14215},
{C_text("f_14218:library_2escm"),(void*)f_14218},
{C_text("f_14229:library_2escm"),(void*)f_14229},
{C_text("f_14231:library_2escm"),(void*)f_14231},
{C_text("f_14238:library_2escm"),(void*)f_14238},
{C_text("f_14241:library_2escm"),(void*)f_14241},
{C_text("f_14246:library_2escm"),(void*)f_14246},
{C_text("f_14250:library_2escm"),(void*)f_14250},
{C_text("f_14255:library_2escm"),(void*)f_14255},
{C_text("f_14259:library_2escm"),(void*)f_14259},
{C_text("f_14290:library_2escm"),(void*)f_14290},
{C_text("f_14293:library_2escm"),(void*)f_14293},
{C_text("f_14296:library_2escm"),(void*)f_14296},
{C_text("f_14313:library_2escm"),(void*)f_14313},
{C_text("f_14324:library_2escm"),(void*)f_14324},
{C_text("f_14335:library_2escm"),(void*)f_14335},
{C_text("f_14346:library_2escm"),(void*)f_14346},
{C_text("f_14357:library_2escm"),(void*)f_14357},
{C_text("f_14368:library_2escm"),(void*)f_14368},
{C_text("f_14379:library_2escm"),(void*)f_14379},
{C_text("f_14390:library_2escm"),(void*)f_14390},
{C_text("f_14401:library_2escm"),(void*)f_14401},
{C_text("f_14412:library_2escm"),(void*)f_14412},
{C_text("f_14423:library_2escm"),(void*)f_14423},
{C_text("f_14434:library_2escm"),(void*)f_14434},
{C_text("f_14445:library_2escm"),(void*)f_14445},
{C_text("f_14456:library_2escm"),(void*)f_14456},
{C_text("f_14467:library_2escm"),(void*)f_14467},
{C_text("f_14478:library_2escm"),(void*)f_14478},
{C_text("f_14489:library_2escm"),(void*)f_14489},
{C_text("f_14506:library_2escm"),(void*)f_14506},
{C_text("f_14523:library_2escm"),(void*)f_14523},
{C_text("f_14547:library_2escm"),(void*)f_14547},
{C_text("f_14564:library_2escm"),(void*)f_14564},
{C_text("f_14575:library_2escm"),(void*)f_14575},
{C_text("f_14586:library_2escm"),(void*)f_14586},
{C_text("f_14606:library_2escm"),(void*)f_14606},
{C_text("f_14617:library_2escm"),(void*)f_14617},
{C_text("f_14629:library_2escm"),(void*)f_14629},
{C_text("f_14663:library_2escm"),(void*)f_14663},
{C_text("f_14678:library_2escm"),(void*)f_14678},
{C_text("f_14745:library_2escm"),(void*)f_14745},
{C_text("f_14761:library_2escm"),(void*)f_14761},
{C_text("f_14777:library_2escm"),(void*)f_14777},
{C_text("f_14793:library_2escm"),(void*)f_14793},
{C_text("f_14809:library_2escm"),(void*)f_14809},
{C_text("f_14825:library_2escm"),(void*)f_14825},
{C_text("f_14841:library_2escm"),(void*)f_14841},
{C_text("f_14857:library_2escm"),(void*)f_14857},
{C_text("f_14873:library_2escm"),(void*)f_14873},
{C_text("f_14885:library_2escm"),(void*)f_14885},
{C_text("f_14904:library_2escm"),(void*)f_14904},
{C_text("f_14935:library_2escm"),(void*)f_14935},
{C_text("f_14952:library_2escm"),(void*)f_14952},
{C_text("f_14958:library_2escm"),(void*)f_14958},
{C_text("f_14982:library_2escm"),(void*)f_14982},
{C_text("f_14997:library_2escm"),(void*)f_14997},
{C_text("f_15007:library_2escm"),(void*)f_15007},
{C_text("f_15019:library_2escm"),(void*)f_15019},
{C_text("f_15023:library_2escm"),(void*)f_15023},
{C_text("f_15030:library_2escm"),(void*)f_15030},
{C_text("f_15036:library_2escm"),(void*)f_15036},
{C_text("f_15042:library_2escm"),(void*)f_15042},
{C_text("f_15066:library_2escm"),(void*)f_15066},
{C_text("f_15070:library_2escm"),(void*)f_15070},
{C_text("f_15079:library_2escm"),(void*)f_15079},
{C_text("f_15083:library_2escm"),(void*)f_15083},
{C_text("f_15092:library_2escm"),(void*)f_15092},
{C_text("f_15095:library_2escm"),(void*)f_15095},
{C_text("f_15101:library_2escm"),(void*)f_15101},
{C_text("f_15107:library_2escm"),(void*)f_15107},
{C_text("f_15110:library_2escm"),(void*)f_15110},
{C_text("f_15149:library_2escm"),(void*)f_15149},
{C_text("f_15152:library_2escm"),(void*)f_15152},
{C_text("f_15162:library_2escm"),(void*)f_15162},
{C_text("f_15179:library_2escm"),(void*)f_15179},
{C_text("f_15185:library_2escm"),(void*)f_15185},
{C_text("f_15191:library_2escm"),(void*)f_15191},
{C_text("f_15197:library_2escm"),(void*)f_15197},
{C_text("f_15203:library_2escm"),(void*)f_15203},
{C_text("f_15209:library_2escm"),(void*)f_15209},
{C_text("f_15215:library_2escm"),(void*)f_15215},
{C_text("f_15221:library_2escm"),(void*)f_15221},
{C_text("f_15225:library_2escm"),(void*)f_15225},
{C_text("f_15230:library_2escm"),(void*)f_15230},
{C_text("f_15233:library_2escm"),(void*)f_15233},
{C_text("f_15243:library_2escm"),(void*)f_15243},
{C_text("f_15246:library_2escm"),(void*)f_15246},
{C_text("f_15252:library_2escm"),(void*)f_15252},
{C_text("f_15256:library_2escm"),(void*)f_15256},
{C_text("f_15264:library_2escm"),(void*)f_15264},
{C_text("f_15268:library_2escm"),(void*)f_15268},
{C_text("f_15286:library_2escm"),(void*)f_15286},
{C_text("f_15310:library_2escm"),(void*)f_15310},
{C_text("f_15317:library_2escm"),(void*)f_15317},
{C_text("f_15341:library_2escm"),(void*)f_15341},
{C_text("f_15363:library_2escm"),(void*)f_15363},
{C_text("f_15366:library_2escm"),(void*)f_15366},
{C_text("f_15375:library_2escm"),(void*)f_15375},
{C_text("f_15432:library_2escm"),(void*)f_15432},
{C_text("f_15445:library_2escm"),(void*)f_15445},
{C_text("f_15450:library_2escm"),(void*)f_15450},
{C_text("f_15494:library_2escm"),(void*)f_15494},
{C_text("f_15498:library_2escm"),(void*)f_15498},
{C_text("f_15503:library_2escm"),(void*)f_15503},
{C_text("f_15545:library_2escm"),(void*)f_15545},
{C_text("f_15568:library_2escm"),(void*)f_15568},
{C_text("f_15591:library_2escm"),(void*)f_15591},
{C_text("f_15664:library_2escm"),(void*)f_15664},
{C_text("f_15684:library_2escm"),(void*)f_15684},
{C_text("f_15687:library_2escm"),(void*)f_15687},
{C_text("f_15690:library_2escm"),(void*)f_15690},
{C_text("f_15699:library_2escm"),(void*)f_15699},
{C_text("f_15712:library_2escm"),(void*)f_15712},
{C_text("f_15739:library_2escm"),(void*)f_15739},
{C_text("f_15769:library_2escm"),(void*)f_15769},
{C_text("f_15788:library_2escm"),(void*)f_15788},
{C_text("f_15822:library_2escm"),(void*)f_15822},
{C_text("f_15856:library_2escm"),(void*)f_15856},
{C_text("f_15890:library_2escm"),(void*)f_15890},
{C_text("f_15894:library_2escm"),(void*)f_15894},
{C_text("f_15904:library_2escm"),(void*)f_15904},
{C_text("f_15914:library_2escm"),(void*)f_15914},
{C_text("f_15921:library_2escm"),(void*)f_15921},
{C_text("f_15949:library_2escm"),(void*)f_15949},
{C_text("f_15969:library_2escm"),(void*)f_15969},
{C_text("f_15971:library_2escm"),(void*)f_15971},
{C_text("f_15999:library_2escm"),(void*)f_15999},
{C_text("f_16018:library_2escm"),(void*)f_16018},
{C_text("f_16024:library_2escm"),(void*)f_16024},
{C_text("f_16042:library_2escm"),(void*)f_16042},
{C_text("f_16048:library_2escm"),(void*)f_16048},
{C_text("f_16066:library_2escm"),(void*)f_16066},
{C_text("f_16072:library_2escm"),(void*)f_16072},
{C_text("f_16087:library_2escm"),(void*)f_16087},
{C_text("f_16093:library_2escm"),(void*)f_16093},
{C_text("f_16107:library_2escm"),(void*)f_16107},
{C_text("f_16127:library_2escm"),(void*)f_16127},
{C_text("f_16129:library_2escm"),(void*)f_16129},
{C_text("f_16157:library_2escm"),(void*)f_16157},
{C_text("f_16168:library_2escm"),(void*)f_16168},
{C_text("f_16174:library_2escm"),(void*)f_16174},
{C_text("f_16192:library_2escm"),(void*)f_16192},
{C_text("f_16198:library_2escm"),(void*)f_16198},
{C_text("f_16216:library_2escm"),(void*)f_16216},
{C_text("f_16222:library_2escm"),(void*)f_16222},
{C_text("f_16237:library_2escm"),(void*)f_16237},
{C_text("f_16243:library_2escm"),(void*)f_16243},
{C_text("f_16258:library_2escm"),(void*)f_16258},
{C_text("f_16274:library_2escm"),(void*)f_16274},
{C_text("f_16304:library_2escm"),(void*)f_16304},
{C_text("f_16308:library_2escm"),(void*)f_16308},
{C_text("f_16310:library_2escm"),(void*)f_16310},
{C_text("f_16321:library_2escm"),(void*)f_16321},
{C_text("f_16344:library_2escm"),(void*)f_16344},
{C_text("f_16362:library_2escm"),(void*)f_16362},
{C_text("f_16368:library_2escm"),(void*)f_16368},
{C_text("f_16374:library_2escm"),(void*)f_16374},
{C_text("f_16381:library_2escm"),(void*)f_16381},
{C_text("f_16389:library_2escm"),(void*)f_16389},
{C_text("f_16410:library_2escm"),(void*)f_16410},
{C_text("f_16424:library_2escm"),(void*)f_16424},
{C_text("f_16428:library_2escm"),(void*)f_16428},
{C_text("f_16469:library_2escm"),(void*)f_16469},
{C_text("f_16491:library_2escm"),(void*)f_16491},
{C_text("f_16493:library_2escm"),(void*)f_16493},
{C_text("f_16515:library_2escm"),(void*)f_16515},
{C_text("f_16517:library_2escm"),(void*)f_16517},
{C_text("f_16539:library_2escm"),(void*)f_16539},
{C_text("f_16541:library_2escm"),(void*)f_16541},
{C_text("f_16563:library_2escm"),(void*)f_16563},
{C_text("f_16565:library_2escm"),(void*)f_16565},
{C_text("f_16569:library_2escm"),(void*)f_16569},
{C_text("f_16572:library_2escm"),(void*)f_16572},
{C_text("f_16590:library_2escm"),(void*)f_16590},
{C_text("f_16612:library_2escm"),(void*)f_16612},
{C_text("f_16614:library_2escm"),(void*)f_16614},
{C_text("f_16636:library_2escm"),(void*)f_16636},
{C_text("f_16638:library_2escm"),(void*)f_16638},
{C_text("f_16660:library_2escm"),(void*)f_16660},
{C_text("f_16662:library_2escm"),(void*)f_16662},
{C_text("f_16684:library_2escm"),(void*)f_16684},
{C_text("f_16686:library_2escm"),(void*)f_16686},
{C_text("f_16708:library_2escm"),(void*)f_16708},
{C_text("f_16710:library_2escm"),(void*)f_16710},
{C_text("f_16732:library_2escm"),(void*)f_16732},
{C_text("f_16734:library_2escm"),(void*)f_16734},
{C_text("f_16756:library_2escm"),(void*)f_16756},
{C_text("f_16758:library_2escm"),(void*)f_16758},
{C_text("f_16774:library_2escm"),(void*)f_16774},
{C_text("f_16776:library_2escm"),(void*)f_16776},
{C_text("f_16798:library_2escm"),(void*)f_16798},
{C_text("f_16800:library_2escm"),(void*)f_16800},
{C_text("f_16822:library_2escm"),(void*)f_16822},
{C_text("f_16824:library_2escm"),(void*)f_16824},
{C_text("f_16840:library_2escm"),(void*)f_16840},
{C_text("f_16842:library_2escm"),(void*)f_16842},
{C_text("f_16858:library_2escm"),(void*)f_16858},
{C_text("f_16860:library_2escm"),(void*)f_16860},
{C_text("f_16876:library_2escm"),(void*)f_16876},
{C_text("f_16878:library_2escm"),(void*)f_16878},
{C_text("f_16894:library_2escm"),(void*)f_16894},
{C_text("f_16896:library_2escm"),(void*)f_16896},
{C_text("f_16912:library_2escm"),(void*)f_16912},
{C_text("f_16914:library_2escm"),(void*)f_16914},
{C_text("f_16930:library_2escm"),(void*)f_16930},
{C_text("f_16932:library_2escm"),(void*)f_16932},
{C_text("f_16948:library_2escm"),(void*)f_16948},
{C_text("f_16950:library_2escm"),(void*)f_16950},
{C_text("f_16966:library_2escm"),(void*)f_16966},
{C_text("f_16968:library_2escm"),(void*)f_16968},
{C_text("f_16984:library_2escm"),(void*)f_16984},
{C_text("f_16986:library_2escm"),(void*)f_16986},
{C_text("f_17002:library_2escm"),(void*)f_17002},
{C_text("f_17004:library_2escm"),(void*)f_17004},
{C_text("f_17026:library_2escm"),(void*)f_17026},
{C_text("f_17028:library_2escm"),(void*)f_17028},
{C_text("f_17044:library_2escm"),(void*)f_17044},
{C_text("f_17046:library_2escm"),(void*)f_17046},
{C_text("f_17062:library_2escm"),(void*)f_17062},
{C_text("f_17064:library_2escm"),(void*)f_17064},
{C_text("f_17080:library_2escm"),(void*)f_17080},
{C_text("f_17082:library_2escm"),(void*)f_17082},
{C_text("f_17098:library_2escm"),(void*)f_17098},
{C_text("f_17100:library_2escm"),(void*)f_17100},
{C_text("f_17116:library_2escm"),(void*)f_17116},
{C_text("f_17118:library_2escm"),(void*)f_17118},
{C_text("f_17134:library_2escm"),(void*)f_17134},
{C_text("f_17136:library_2escm"),(void*)f_17136},
{C_text("f_17152:library_2escm"),(void*)f_17152},
{C_text("f_17154:library_2escm"),(void*)f_17154},
{C_text("f_17176:library_2escm"),(void*)f_17176},
{C_text("f_17178:library_2escm"),(void*)f_17178},
{C_text("f_17194:library_2escm"),(void*)f_17194},
{C_text("f_17196:library_2escm"),(void*)f_17196},
{C_text("f_17212:library_2escm"),(void*)f_17212},
{C_text("f_17214:library_2escm"),(void*)f_17214},
{C_text("f_17230:library_2escm"),(void*)f_17230},
{C_text("f_17232:library_2escm"),(void*)f_17232},
{C_text("f_17248:library_2escm"),(void*)f_17248},
{C_text("f_17250:library_2escm"),(void*)f_17250},
{C_text("f_17268:library_2escm"),(void*)f_17268},
{C_text("f_17278:library_2escm"),(void*)f_17278},
{C_text("f_17282:library_2escm"),(void*)f_17282},
{C_text("f_17304:library_2escm"),(void*)f_17304},
{C_text("f_17308:library_2escm"),(void*)f_17308},
{C_text("f_17311:library_2escm"),(void*)f_17311},
{C_text("f_17316:library_2escm"),(void*)f_17316},
{C_text("f_17320:library_2escm"),(void*)f_17320},
{C_text("f_17323:library_2escm"),(void*)f_17323},
{C_text("f_17326:library_2escm"),(void*)f_17326},
{C_text("f_17339:library_2escm"),(void*)f_17339},
{C_text("f_17362:library_2escm"),(void*)f_17362},
{C_text("f_17388:library_2escm"),(void*)f_17388},
{C_text("f_17397:library_2escm"),(void*)f_17397},
{C_text("f_17402:library_2escm"),(void*)f_17402},
{C_text("f_17404:library_2escm"),(void*)f_17404},
{C_text("f_17448:library_2escm"),(void*)f_17448},
{C_text("f_17494:library_2escm"),(void*)f_17494},
{C_text("f_17518:library_2escm"),(void*)f_17518},
{C_text("f_17522:library_2escm"),(void*)f_17522},
{C_text("f_17540:library_2escm"),(void*)f_17540},
{C_text("f_17564:library_2escm"),(void*)f_17564},
{C_text("f_17568:library_2escm"),(void*)f_17568},
{C_text("f_17586:library_2escm"),(void*)f_17586},
{C_text("f_17627:library_2escm"),(void*)f_17627},
{C_text("f_17638:library_2escm"),(void*)f_17638},
{C_text("f_17644:library_2escm"),(void*)f_17644},
{C_text("f_17648:library_2escm"),(void*)f_17648},
{C_text("f_17662:library_2escm"),(void*)f_17662},
{C_text("f_17675:library_2escm"),(void*)f_17675},
{C_text("f_17679:library_2escm"),(void*)f_17679},
{C_text("f_17696:library_2escm"),(void*)f_17696},
{C_text("f_17700:library_2escm"),(void*)f_17700},
{C_text("f_17706:library_2escm"),(void*)f_17706},
{C_text("f_17710:library_2escm"),(void*)f_17710},
{C_text("f_17750:library_2escm"),(void*)f_17750},
{C_text("f_17754:library_2escm"),(void*)f_17754},
{C_text("f_17774:library_2escm"),(void*)f_17774},
{C_text("f_17777:library_2escm"),(void*)f_17777},
{C_text("f_17780:library_2escm"),(void*)f_17780},
{C_text("f_17783:library_2escm"),(void*)f_17783},
{C_text("f_17786:library_2escm"),(void*)f_17786},
{C_text("f_17807:library_2escm"),(void*)f_17807},
{C_text("f_17809:library_2escm"),(void*)f_17809},
{C_text("f_17827:library_2escm"),(void*)f_17827},
{C_text("f_17837:library_2escm"),(void*)f_17837},
{C_text("f_17841:library_2escm"),(void*)f_17841},
{C_text("f_17879:library_2escm"),(void*)f_17879},
{C_text("f_17882:library_2escm"),(void*)f_17882},
{C_text("f_17885:library_2escm"),(void*)f_17885},
{C_text("f_17888:library_2escm"),(void*)f_17888},
{C_text("f_17894:library_2escm"),(void*)f_17894},
{C_text("f_17897:library_2escm"),(void*)f_17897},
{C_text("f_17945:library_2escm"),(void*)f_17945},
{C_text("f_17949:library_2escm"),(void*)f_17949},
{C_text("f_18026:library_2escm"),(void*)f_18026},
{C_text("f_18065:library_2escm"),(void*)f_18065},
{C_text("f_18120:library_2escm"),(void*)f_18120},
{C_text("f_18165:library_2escm"),(void*)f_18165},
{C_text("f_18210:library_2escm"),(void*)f_18210},
{C_text("f_18247:library_2escm"),(void*)f_18247},
{C_text("f_18267:library_2escm"),(void*)f_18267},
{C_text("f_18291:library_2escm"),(void*)f_18291},
{C_text("f_18294:library_2escm"),(void*)f_18294},
{C_text("f_18298:library_2escm"),(void*)f_18298},
{C_text("f_18301:library_2escm"),(void*)f_18301},
{C_text("f_18319:library_2escm"),(void*)f_18319},
{C_text("f_18342:library_2escm"),(void*)f_18342},
{C_text("f_18346:library_2escm"),(void*)f_18346},
{C_text("f_18369:library_2escm"),(void*)f_18369},
{C_text("f_18373:library_2escm"),(void*)f_18373},
{C_text("f_18405:library_2escm"),(void*)f_18405},
{C_text("f_18441:library_2escm"),(void*)f_18441},
{C_text("f_18445:library_2escm"),(void*)f_18445},
{C_text("f_18464:library_2escm"),(void*)f_18464},
{C_text("f_18466:library_2escm"),(void*)f_18466},
{C_text("f_18473:library_2escm"),(void*)f_18473},
{C_text("f_18510:library_2escm"),(void*)f_18510},
{C_text("f_18517:library_2escm"),(void*)f_18517},
{C_text("f_18554:library_2escm"),(void*)f_18554},
{C_text("f_18572:library_2escm"),(void*)f_18572},
{C_text("f_18581:library_2escm"),(void*)f_18581},
{C_text("f_18586:library_2escm"),(void*)f_18586},
{C_text("f_18599:library_2escm"),(void*)f_18599},
{C_text("f_18625:library_2escm"),(void*)f_18625},
{C_text("f_18633:library_2escm"),(void*)f_18633},
{C_text("f_18637:library_2escm"),(void*)f_18637},
{C_text("f_18641:library_2escm"),(void*)f_18641},
{C_text("f_18645:library_2escm"),(void*)f_18645},
{C_text("f_18648:library_2escm"),(void*)f_18648},
{C_text("f_18662:library_2escm"),(void*)f_18662},
{C_text("f_18666:library_2escm"),(void*)f_18666},
{C_text("f_18677:library_2escm"),(void*)f_18677},
{C_text("f_18701:library_2escm"),(void*)f_18701},
{C_text("f_18705:library_2escm"),(void*)f_18705},
{C_text("f_18711:library_2escm"),(void*)f_18711},
{C_text("f_18735:library_2escm"),(void*)f_18735},
{C_text("f_18739:library_2escm"),(void*)f_18739},
{C_text("f_18745:library_2escm"),(void*)f_18745},
{C_text("f_18762:library_2escm"),(void*)f_18762},
{C_text("f_18766:library_2escm"),(void*)f_18766},
{C_text("f_18770:library_2escm"),(void*)f_18770},
{C_text("f_18780:library_2escm"),(void*)f_18780},
{C_text("f_18786:library_2escm"),(void*)f_18786},
{C_text("f_18793:library_2escm"),(void*)f_18793},
{C_text("f_18805:library_2escm"),(void*)f_18805},
{C_text("f_18828:library_2escm"),(void*)f_18828},
{C_text("f_18832:library_2escm"),(void*)f_18832},
{C_text("f_18842:library_2escm"),(void*)f_18842},
{C_text("f_18848:library_2escm"),(void*)f_18848},
{C_text("f_18855:library_2escm"),(void*)f_18855},
{C_text("f_18870:library_2escm"),(void*)f_18870},
{C_text("f_18874:library_2escm"),(void*)f_18874},
{C_text("f_18907:library_2escm"),(void*)f_18907},
{C_text("f_18911:library_2escm"),(void*)f_18911},
{C_text("f_18928:library_2escm"),(void*)f_18928},
{C_text("f_18938:library_2escm"),(void*)f_18938},
{C_text("f_19011:library_2escm"),(void*)f_19011},
{C_text("f_19025:library_2escm"),(void*)f_19025},
{C_text("f_19042:library_2escm"),(void*)f_19042},
{C_text("f_19058:library_2escm"),(void*)f_19058},
{C_text("f_19129:library_2escm"),(void*)f_19129},
{C_text("f_19133:library_2escm"),(void*)f_19133},
{C_text("f_19138:library_2escm"),(void*)f_19138},
{C_text("f_19148:library_2escm"),(void*)f_19148},
{C_text("f_19152:library_2escm"),(void*)f_19152},
{C_text("f_19167:library_2escm"),(void*)f_19167},
{C_text("f_19171:library_2escm"),(void*)f_19171},
{C_text("f_19188:library_2escm"),(void*)f_19188},
{C_text("f_19199:library_2escm"),(void*)f_19199},
{C_text("f_19205:library_2escm"),(void*)f_19205},
{C_text("f_19216:library_2escm"),(void*)f_19216},
{C_text("f_19227:library_2escm"),(void*)f_19227},
{C_text("f_19239:library_2escm"),(void*)f_19239},
{C_text("f_19251:library_2escm"),(void*)f_19251},
{C_text("f_19263:library_2escm"),(void*)f_19263},
{C_text("f_19280:library_2escm"),(void*)f_19280},
{C_text("f_19287:library_2escm"),(void*)f_19287},
{C_text("f_19291:library_2escm"),(void*)f_19291},
{C_text("f_19293:library_2escm"),(void*)f_19293},
{C_text("f_19300:library_2escm"),(void*)f_19300},
{C_text("f_19306:library_2escm"),(void*)f_19306},
{C_text("f_19312:library_2escm"),(void*)f_19312},
{C_text("f_19355:library_2escm"),(void*)f_19355},
{C_text("f_19361:library_2escm"),(void*)f_19361},
{C_text("f_19367:library_2escm"),(void*)f_19367},
{C_text("f_19370:library_2escm"),(void*)f_19370},
{C_text("f_19376:library_2escm"),(void*)f_19376},
{C_text("f_19382:library_2escm"),(void*)f_19382},
{C_text("f_19385:library_2escm"),(void*)f_19385},
{C_text("f_19391:library_2escm"),(void*)f_19391},
{C_text("f_19395:library_2escm"),(void*)f_19395},
{C_text("f_19398:library_2escm"),(void*)f_19398},
{C_text("f_19403:library_2escm"),(void*)f_19403},
{C_text("f_19413:library_2escm"),(void*)f_19413},
{C_text("f_19433:library_2escm"),(void*)f_19433},
{C_text("f_19448:library_2escm"),(void*)f_19448},
{C_text("f_19478:library_2escm"),(void*)f_19478},
{C_text("f_19489:library_2escm"),(void*)f_19489},
{C_text("f_19505:library_2escm"),(void*)f_19505},
{C_text("f_19509:library_2escm"),(void*)f_19509},
{C_text("f_19513:library_2escm"),(void*)f_19513},
{C_text("f_19529:library_2escm"),(void*)f_19529},
{C_text("f_19547:library_2escm"),(void*)f_19547},
{C_text("f_19558:library_2escm"),(void*)f_19558},
{C_text("f_19580:library_2escm"),(void*)f_19580},
{C_text("f_19597:library_2escm"),(void*)f_19597},
{C_text("f_19600:library_2escm"),(void*)f_19600},
{C_text("f_19612:library_2escm"),(void*)f_19612},
{C_text("f_19614:library_2escm"),(void*)f_19614},
{C_text("f_19635:library_2escm"),(void*)f_19635},
{C_text("f_19666:library_2escm"),(void*)f_19666},
{C_text("f_19670:library_2escm"),(void*)f_19670},
{C_text("f_19705:library_2escm"),(void*)f_19705},
{C_text("f_19712:library_2escm"),(void*)f_19712},
{C_text("f_19724:library_2escm"),(void*)f_19724},
{C_text("f_19744:library_2escm"),(void*)f_19744},
{C_text("f_19748:library_2escm"),(void*)f_19748},
{C_text("f_19768:library_2escm"),(void*)f_19768},
{C_text("f_19788:library_2escm"),(void*)f_19788},
{C_text("f_19792:library_2escm"),(void*)f_19792},
{C_text("f_19796:library_2escm"),(void*)f_19796},
{C_text("f_19803:library_2escm"),(void*)f_19803},
{C_text("f_19819:library_2escm"),(void*)f_19819},
{C_text("f_19823:library_2escm"),(void*)f_19823},
{C_text("f_19864:library_2escm"),(void*)f_19864},
{C_text("f_19897:library_2escm"),(void*)f_19897},
{C_text("f_19926:library_2escm"),(void*)f_19926},
{C_text("f_19934:library_2escm"),(void*)f_19934},
{C_text("f_19940:library_2escm"),(void*)f_19940},
{C_text("f_19960:library_2escm"),(void*)f_19960},
{C_text("f_19985:library_2escm"),(void*)f_19985},
{C_text("f_19991:library_2escm"),(void*)f_19991},
{C_text("f_19995:library_2escm"),(void*)f_19995},
{C_text("f_20005:library_2escm"),(void*)f_20005},
{C_text("f_20025:library_2escm"),(void*)f_20025},
{C_text("f_20046:library_2escm"),(void*)f_20046},
{C_text("f_20063:library_2escm"),(void*)f_20063},
{C_text("f_20070:library_2escm"),(void*)f_20070},
{C_text("f_20075:library_2escm"),(void*)f_20075},
{C_text("f_20081:library_2escm"),(void*)f_20081},
{C_text("f_20085:library_2escm"),(void*)f_20085},
{C_text("f_20088:library_2escm"),(void*)f_20088},
{C_text("f_20095:library_2escm"),(void*)f_20095},
{C_text("f_20113:library_2escm"),(void*)f_20113},
{C_text("f_20127:library_2escm"),(void*)f_20127},
{C_text("f_20131:library_2escm"),(void*)f_20131},
{C_text("f_20168:library_2escm"),(void*)f_20168},
{C_text("f_20176:library_2escm"),(void*)f_20176},
{C_text("f_20205:library_2escm"),(void*)f_20205},
{C_text("f_20208:library_2escm"),(void*)f_20208},
{C_text("f_20223:library_2escm"),(void*)f_20223},
{C_text("f_20226:library_2escm"),(void*)f_20226},
{C_text("f_20233:library_2escm"),(void*)f_20233},
{C_text("f_20244:library_2escm"),(void*)f_20244},
{C_text("f_20262:library_2escm"),(void*)f_20262},
{C_text("f_20287:library_2escm"),(void*)f_20287},
{C_text("f_20302:library_2escm"),(void*)f_20302},
{C_text("f_20330:library_2escm"),(void*)f_20330},
{C_text("f_20334:library_2escm"),(void*)f_20334},
{C_text("f_20348:library_2escm"),(void*)f_20348},
{C_text("f_20408:library_2escm"),(void*)f_20408},
{C_text("f_20428:library_2escm"),(void*)f_20428},
{C_text("f_20434:library_2escm"),(void*)f_20434},
{C_text("f_20494:library_2escm"),(void*)f_20494},
{C_text("f_20532:library_2escm"),(void*)f_20532},
{C_text("f_20538:library_2escm"),(void*)f_20538},
{C_text("f_20580:library_2escm"),(void*)f_20580},
{C_text("f_20584:library_2escm"),(void*)f_20584},
{C_text("f_20587:library_2escm"),(void*)f_20587},
{C_text("f_20636:library_2escm"),(void*)f_20636},
{C_text("f_20649:library_2escm"),(void*)f_20649},
{C_text("f_20655:library_2escm"),(void*)f_20655},
{C_text("f_20689:library_2escm"),(void*)f_20689},
{C_text("f_20699:library_2escm"),(void*)f_20699},
{C_text("f_20708:library_2escm"),(void*)f_20708},
{C_text("f_20720:library_2escm"),(void*)f_20720},
{C_text("f_20729:library_2escm"),(void*)f_20729},
{C_text("f_20741:library_2escm"),(void*)f_20741},
{C_text("f_20747:library_2escm"),(void*)f_20747},
{C_text("f_20753:library_2escm"),(void*)f_20753},
{C_text("f_20795:library_2escm"),(void*)f_20795},
{C_text("f_20901:library_2escm"),(void*)f_20901},
{C_text("f_20908:library_2escm"),(void*)f_20908},
{C_text("f_20921:library_2escm"),(void*)f_20921},
{C_text("f_20979:library_2escm"),(void*)f_20979},
{C_text("f_20997:library_2escm"),(void*)f_20997},
{C_text("f_21007:library_2escm"),(void*)f_21007},
{C_text("f_21043:library_2escm"),(void*)f_21043},
{C_text("f_21069:library_2escm"),(void*)f_21069},
{C_text("f_21080:library_2escm"),(void*)f_21080},
{C_text("f_21243:library_2escm"),(void*)f_21243},
{C_text("f_21256:library_2escm"),(void*)f_21256},
{C_text("f_21311:library_2escm"),(void*)f_21311},
{C_text("f_21349:library_2escm"),(void*)f_21349},
{C_text("f_21397:library_2escm"),(void*)f_21397},
{C_text("f_21474:library_2escm"),(void*)f_21474},
{C_text("f_21477:library_2escm"),(void*)f_21477},
{C_text("f_21489:library_2escm"),(void*)f_21489},
{C_text("f_21571:library_2escm"),(void*)f_21571},
{C_text("f_21635:library_2escm"),(void*)f_21635},
{C_text("f_21713:library_2escm"),(void*)f_21713},
{C_text("f_21723:library_2escm"),(void*)f_21723},
{C_text("f_21730:library_2escm"),(void*)f_21730},
{C_text("f_21962:library_2escm"),(void*)f_21962},
{C_text("f_22008:library_2escm"),(void*)f_22008},
{C_text("f_22011:library_2escm"),(void*)f_22011},
{C_text("f_22038:library_2escm"),(void*)f_22038},
{C_text("f_22062:library_2escm"),(void*)f_22062},
{C_text("f_22079:library_2escm"),(void*)f_22079},
{C_text("f_22195:library_2escm"),(void*)f_22195},
{C_text("f_22198:library_2escm"),(void*)f_22198},
{C_text("f_22208:library_2escm"),(void*)f_22208},
{C_text("f_22210:library_2escm"),(void*)f_22210},
{C_text("f_22216:library_2escm"),(void*)f_22216},
{C_text("f_22226:library_2escm"),(void*)f_22226},
{C_text("f_22229:library_2escm"),(void*)f_22229},
{C_text("f_22237:library_2escm"),(void*)f_22237},
{C_text("f_22239:library_2escm"),(void*)f_22239},
{C_text("f_22248:library_2escm"),(void*)f_22248},
{C_text("f_22257:library_2escm"),(void*)f_22257},
{C_text("f_22268:library_2escm"),(void*)f_22268},
{C_text("f_22270:library_2escm"),(void*)f_22270},
{C_text("f_22287:library_2escm"),(void*)f_22287},
{C_text("f_22291:library_2escm"),(void*)f_22291},
{C_text("f_22295:library_2escm"),(void*)f_22295},
{C_text("f_22299:library_2escm"),(void*)f_22299},
{C_text("f_22308:library_2escm"),(void*)f_22308},
{C_text("f_22328:library_2escm"),(void*)f_22328},
{C_text("f_22336:library_2escm"),(void*)f_22336},
{C_text("f_22351:library_2escm"),(void*)f_22351},
{C_text("f_22353:library_2escm"),(void*)f_22353},
{C_text("f_22378:library_2escm"),(void*)f_22378},
{C_text("f_22387:library_2escm"),(void*)f_22387},
{C_text("f_22390:library_2escm"),(void*)f_22390},
{C_text("f_22401:library_2escm"),(void*)f_22401},
{C_text("f_22403:library_2escm"),(void*)f_22403},
{C_text("f_22410:library_2escm"),(void*)f_22410},
{C_text("f_22421:library_2escm"),(void*)f_22421},
{C_text("f_22428:library_2escm"),(void*)f_22428},
{C_text("f_22452:library_2escm"),(void*)f_22452},
{C_text("f_22465:library_2escm"),(void*)f_22465},
{C_text("f_22486:library_2escm"),(void*)f_22486},
{C_text("f_22493:library_2escm"),(void*)f_22493},
{C_text("f_22498:library_2escm"),(void*)f_22498},
{C_text("f_22511:library_2escm"),(void*)f_22511},
{C_text("f_22525:library_2escm"),(void*)f_22525},
{C_text("f_22549:library_2escm"),(void*)f_22549},
{C_text("f_22555:library_2escm"),(void*)f_22555},
{C_text("f_22564:library_2escm"),(void*)f_22564},
{C_text("f_22567:library_2escm"),(void*)f_22567},
{C_text("f_22570:library_2escm"),(void*)f_22570},
{C_text("f_22584:library_2escm"),(void*)f_22584},
{C_text("f_22586:library_2escm"),(void*)f_22586},
{C_text("f_22596:library_2escm"),(void*)f_22596},
{C_text("f_22626:library_2escm"),(void*)f_22626},
{C_text("f_22643:library_2escm"),(void*)f_22643},
{C_text("f_22645:library_2escm"),(void*)f_22645},
{C_text("f_22655:library_2escm"),(void*)f_22655},
{C_text("f_22661:library_2escm"),(void*)f_22661},
{C_text("f_22683:library_2escm"),(void*)f_22683},
{C_text("f_22688:library_2escm"),(void*)f_22688},
{C_text("f_22693:library_2escm"),(void*)f_22693},
{C_text("f_22714:library_2escm"),(void*)f_22714},
{C_text("f_22739:library_2escm"),(void*)f_22739},
{C_text("f_22745:library_2escm"),(void*)f_22745},
{C_text("f_22751:library_2escm"),(void*)f_22751},
{C_text("f_22754:library_2escm"),(void*)f_22754},
{C_text("f_22795:library_2escm"),(void*)f_22795},
{C_text("f_22829:library_2escm"),(void*)f_22829},
{C_text("f_22832:library_2escm"),(void*)f_22832},
{C_text("f_22835:library_2escm"),(void*)f_22835},
{C_text("f_22838:library_2escm"),(void*)f_22838},
{C_text("f_22877:library_2escm"),(void*)f_22877},
{C_text("f_22883:library_2escm"),(void*)f_22883},
{C_text("f_22893:library_2escm"),(void*)f_22893},
{C_text("f_22898:library_2escm"),(void*)f_22898},
{C_text("f_22935:library_2escm"),(void*)f_22935},
{C_text("f_22942:library_2escm"),(void*)f_22942},
{C_text("f_22964:library_2escm"),(void*)f_22964},
{C_text("f_22980:library_2escm"),(void*)f_22980},
{C_text("f_22985:library_2escm"),(void*)f_22985},
{C_text("f_23016:library_2escm"),(void*)f_23016},
{C_text("f_23038:library_2escm"),(void*)f_23038},
{C_text("f_23041:library_2escm"),(void*)f_23041},
{C_text("f_23046:library_2escm"),(void*)f_23046},
{C_text("f_23064:library_2escm"),(void*)f_23064},
{C_text("f_23102:library_2escm"),(void*)f_23102},
{C_text("f_23108:library_2escm"),(void*)f_23108},
{C_text("f_23130:library_2escm"),(void*)f_23130},
{C_text("f_23133:library_2escm"),(void*)f_23133},
{C_text("f_23138:library_2escm"),(void*)f_23138},
{C_text("f_23189:library_2escm"),(void*)f_23189},
{C_text("f_23206:library_2escm"),(void*)f_23206},
{C_text("f_23213:library_2escm"),(void*)f_23213},
{C_text("f_23216:library_2escm"),(void*)f_23216},
{C_text("f_23219:library_2escm"),(void*)f_23219},
{C_text("f_23224:library_2escm"),(void*)f_23224},
{C_text("f_23296:library_2escm"),(void*)f_23296},
{C_text("f_23316:library_2escm"),(void*)f_23316},
{C_text("f_23329:library_2escm"),(void*)f_23329},
{C_text("f_23332:library_2escm"),(void*)f_23332},
{C_text("f_23335:library_2escm"),(void*)f_23335},
{C_text("f_23338:library_2escm"),(void*)f_23338},
{C_text("f_23357:library_2escm"),(void*)f_23357},
{C_text("f_23391:library_2escm"),(void*)f_23391},
{C_text("f_23469:library_2escm"),(void*)f_23469},
{C_text("f_23484:library_2escm"),(void*)f_23484},
{C_text("f_23487:library_2escm"),(void*)f_23487},
{C_text("f_23492:library_2escm"),(void*)f_23492},
{C_text("f_23502:library_2escm"),(void*)f_23502},
{C_text("f_23532:library_2escm"),(void*)f_23532},
{C_text("f_23556:library_2escm"),(void*)f_23556},
{C_text("f_23590:library_2escm"),(void*)f_23590},
{C_text("f_23613:library_2escm"),(void*)f_23613},
{C_text("f_23632:library_2escm"),(void*)f_23632},
{C_text("f_23635:library_2escm"),(void*)f_23635},
{C_text("f_23638:library_2escm"),(void*)f_23638},
{C_text("f_23643:library_2escm"),(void*)f_23643},
{C_text("f_23676:library_2escm"),(void*)f_23676},
{C_text("f_23697:library_2escm"),(void*)f_23697},
{C_text("f_23701:library_2escm"),(void*)f_23701},
{C_text("f_23704:library_2escm"),(void*)f_23704},
{C_text("f_23709:library_2escm"),(void*)f_23709},
{C_text("f_23736:library_2escm"),(void*)f_23736},
{C_text("f_23752:library_2escm"),(void*)f_23752},
{C_text("f_23768:library_2escm"),(void*)f_23768},
{C_text("f_23785:library_2escm"),(void*)f_23785},
{C_text("f_23799:library_2escm"),(void*)f_23799},
{C_text("f_23815:library_2escm"),(void*)f_23815},
{C_text("f_23828:library_2escm"),(void*)f_23828},
{C_text("f_23842:library_2escm"),(void*)f_23842},
{C_text("f_23858:library_2escm"),(void*)f_23858},
{C_text("f_23871:library_2escm"),(void*)f_23871},
{C_text("f_23885:library_2escm"),(void*)f_23885},
{C_text("f_23901:library_2escm"),(void*)f_23901},
{C_text("f_23914:library_2escm"),(void*)f_23914},
{C_text("f_23928:library_2escm"),(void*)f_23928},
{C_text("f_23944:library_2escm"),(void*)f_23944},
{C_text("f_23959:library_2escm"),(void*)f_23959},
{C_text("f_23961:library_2escm"),(void*)f_23961},
{C_text("f_23974:library_2escm"),(void*)f_23974},
{C_text("f_24002:library_2escm"),(void*)f_24002},
{C_text("f_24015:library_2escm"),(void*)f_24015},
{C_text("f_24033:library_2escm"),(void*)f_24033},
{C_text("f_24036:library_2escm"),(void*)f_24036},
{C_text("f_24119:library_2escm"),(void*)f_24119},
{C_text("f_24122:library_2escm"),(void*)f_24122},
{C_text("f_24125:library_2escm"),(void*)f_24125},
{C_text("f_24128:library_2escm"),(void*)f_24128},
{C_text("f_24131:library_2escm"),(void*)f_24131},
{C_text("f_24134:library_2escm"),(void*)f_24134},
{C_text("f_24137:library_2escm"),(void*)f_24137},
{C_text("f_24140:library_2escm"),(void*)f_24140},
{C_text("f_24143:library_2escm"),(void*)f_24143},
{C_text("f_24146:library_2escm"),(void*)f_24146},
{C_text("f_24149:library_2escm"),(void*)f_24149},
{C_text("f_24152:library_2escm"),(void*)f_24152},
{C_text("f_24155:library_2escm"),(void*)f_24155},
{C_text("f_24158:library_2escm"),(void*)f_24158},
{C_text("f_24163:library_2escm"),(void*)f_24163},
{C_text("f_24169:library_2escm"),(void*)f_24169},
{C_text("f_24185:library_2escm"),(void*)f_24185},
{C_text("f_24201:library_2escm"),(void*)f_24201},
{C_text("f_24207:library_2escm"),(void*)f_24207},
{C_text("f_24227:library_2escm"),(void*)f_24227},
{C_text("f_24231:library_2escm"),(void*)f_24231},
{C_text("f_24243:library_2escm"),(void*)f_24243},
{C_text("f_24249:library_2escm"),(void*)f_24249},
{C_text("f_24255:library_2escm"),(void*)f_24255},
{C_text("f_24287:library_2escm"),(void*)f_24287},
{C_text("f_24291:library_2escm"),(void*)f_24291},
{C_text("f_24301:library_2escm"),(void*)f_24301},
{C_text("f_24316:library_2escm"),(void*)f_24316},
{C_text("f_24326:library_2escm"),(void*)f_24326},
{C_text("f_24346:library_2escm"),(void*)f_24346},
{C_text("f_24353:library_2escm"),(void*)f_24353},
{C_text("f_24362:library_2escm"),(void*)f_24362},
{C_text("f_24369:library_2escm"),(void*)f_24369},
{C_text("f_24371:library_2escm"),(void*)f_24371},
{C_text("f_24377:library_2escm"),(void*)f_24377},
{C_text("f_24383:library_2escm"),(void*)f_24383},
{C_text("f_24401:library_2escm"),(void*)f_24401},
{C_text("f_24426:library_2escm"),(void*)f_24426},
{C_text("f_24442:library_2escm"),(void*)f_24442},
{C_text("f_24449:library_2escm"),(void*)f_24449},
{C_text("f_24462:library_2escm"),(void*)f_24462},
{C_text("f_24466:library_2escm"),(void*)f_24466},
{C_text("f_24470:library_2escm"),(void*)f_24470},
{C_text("f_24472:library_2escm"),(void*)f_24472},
{C_text("f_24478:library_2escm"),(void*)f_24478},
{C_text("f_24485:library_2escm"),(void*)f_24485},
{C_text("f_24489:library_2escm"),(void*)f_24489},
{C_text("f_24498:library_2escm"),(void*)f_24498},
{C_text("f_24506:library_2escm"),(void*)f_24506},
{C_text("f_24516:library_2escm"),(void*)f_24516},
{C_text("f_24522:library_2escm"),(void*)f_24522},
{C_text("f_24525:library_2escm"),(void*)f_24525},
{C_text("f_24529:library_2escm"),(void*)f_24529},
{C_text("f_24556:library_2escm"),(void*)f_24556},
{C_text("f_24572:library_2escm"),(void*)f_24572},
{C_text("f_24578:library_2escm"),(void*)f_24578},
{C_text("f_24601:library_2escm"),(void*)f_24601},
{C_text("f_24614:library_2escm"),(void*)f_24614},
{C_text("f_24618:library_2escm"),(void*)f_24618},
{C_text("f_24627:library_2escm"),(void*)f_24627},
{C_text("f_24673:library_2escm"),(void*)f_24673},
{C_text("f_24677:library_2escm"),(void*)f_24677},
{C_text("f_24681:library_2escm"),(void*)f_24681},
{C_text("f_24684:library_2escm"),(void*)f_24684},
{C_text("f_24687:library_2escm"),(void*)f_24687},
{C_text("f_24690:library_2escm"),(void*)f_24690},
{C_text("f_24692:library_2escm"),(void*)f_24692},
{C_text("f_24703:library_2escm"),(void*)f_24703},
{C_text("f_24714:library_2escm"),(void*)f_24714},
{C_text("f_24725:library_2escm"),(void*)f_24725},
{C_text("f_24736:library_2escm"),(void*)f_24736},
{C_text("f_24749:library_2escm"),(void*)f_24749},
{C_text("f_24751:library_2escm"),(void*)f_24751},
{C_text("f_24757:library_2escm"),(void*)f_24757},
{C_text("f_24762:library_2escm"),(void*)f_24762},
{C_text("f_24797:library_2escm"),(void*)f_24797},
{C_text("f_24810:library_2escm"),(void*)f_24810},
{C_text("f_24812:library_2escm"),(void*)f_24812},
{C_text("f_24818:library_2escm"),(void*)f_24818},
{C_text("f_24823:library_2escm"),(void*)f_24823},
{C_text("f_24858:library_2escm"),(void*)f_24858},
{C_text("f_24871:library_2escm"),(void*)f_24871},
{C_text("f_24873:library_2escm"),(void*)f_24873},
{C_text("f_24879:library_2escm"),(void*)f_24879},
{C_text("f_24884:library_2escm"),(void*)f_24884},
{C_text("f_24919:library_2escm"),(void*)f_24919},
{C_text("f_24931:library_2escm"),(void*)f_24931},
{C_text("f_24933:library_2escm"),(void*)f_24933},
{C_text("f_24939:library_2escm"),(void*)f_24939},
{C_text("f_24946:library_2escm"),(void*)f_24946},
{C_text("f_24956:library_2escm"),(void*)f_24956},
{C_text("f_24959:library_2escm"),(void*)f_24959},
{C_text("f_24962:library_2escm"),(void*)f_24962},
{C_text("f_24968:library_2escm"),(void*)f_24968},
{C_text("f_24971:library_2escm"),(void*)f_24971},
{C_text("f_24978:library_2escm"),(void*)f_24978},
{C_text("f_24982:library_2escm"),(void*)f_24982},
{C_text("f_24986:library_2escm"),(void*)f_24986},
{C_text("f_24990:library_2escm"),(void*)f_24990},
{C_text("f_24996:library_2escm"),(void*)f_24996},
{C_text("f_25009:library_2escm"),(void*)f_25009},
{C_text("f_25053:library_2escm"),(void*)f_25053},
{C_text("f_25063:library_2escm"),(void*)f_25063},
{C_text("f_25176:library_2escm"),(void*)f_25176},
{C_text("f_25180:library_2escm"),(void*)f_25180},
{C_text("f_25213:library_2escm"),(void*)f_25213},
{C_text("f_25219:library_2escm"),(void*)f_25219},
{C_text("f_25225:library_2escm"),(void*)f_25225},
{C_text("f_25231:library_2escm"),(void*)f_25231},
{C_text("f_25237:library_2escm"),(void*)f_25237},
{C_text("f_25241:library_2escm"),(void*)f_25241},
{C_text("f_25246:library_2escm"),(void*)f_25246},
{C_text("f_25252:library_2escm"),(void*)f_25252},
{C_text("f_25256:library_2escm"),(void*)f_25256},
{C_text("f_25261:library_2escm"),(void*)f_25261},
{C_text("f_25265:library_2escm"),(void*)f_25265},
{C_text("f_25270:library_2escm"),(void*)f_25270},
{C_text("f_25276:library_2escm"),(void*)f_25276},
{C_text("f_25280:library_2escm"),(void*)f_25280},
{C_text("f_25285:library_2escm"),(void*)f_25285},
{C_text("f_25289:library_2escm"),(void*)f_25289},
{C_text("f_25294:library_2escm"),(void*)f_25294},
{C_text("f_25299:library_2escm"),(void*)f_25299},
{C_text("f_25305:library_2escm"),(void*)f_25305},
{C_text("f_25309:library_2escm"),(void*)f_25309},
{C_text("f_25314:library_2escm"),(void*)f_25314},
{C_text("f_25319:library_2escm"),(void*)f_25319},
{C_text("f_25323:library_2escm"),(void*)f_25323},
{C_text("f_25328:library_2escm"),(void*)f_25328},
{C_text("f_25333:library_2escm"),(void*)f_25333},
{C_text("f_25339:library_2escm"),(void*)f_25339},
{C_text("f_25343:library_2escm"),(void*)f_25343},
{C_text("f_25348:library_2escm"),(void*)f_25348},
{C_text("f_25353:library_2escm"),(void*)f_25353},
{C_text("f_25358:library_2escm"),(void*)f_25358},
{C_text("f_25379:library_2escm"),(void*)f_25379},
{C_text("f_25386:library_2escm"),(void*)f_25386},
{C_text("f_25392:library_2escm"),(void*)f_25392},
{C_text("f_25410:library_2escm"),(void*)f_25410},
{C_text("f_25419:library_2escm"),(void*)f_25419},
{C_text("f_25432:library_2escm"),(void*)f_25432},
{C_text("f_25440:library_2escm"),(void*)f_25440},
{C_text("f_25445:library_2escm"),(void*)f_25445},
{C_text("f_25482:library_2escm"),(void*)f_25482},
{C_text("f_25494:library_2escm"),(void*)f_25494},
{C_text("f_25504:library_2escm"),(void*)f_25504},
{C_text("f_25520:library_2escm"),(void*)f_25520},
{C_text("f_25533:library_2escm"),(void*)f_25533},
{C_text("f_25543:library_2escm"),(void*)f_25543},
{C_text("f_25549:library_2escm"),(void*)f_25549},
{C_text("f_25562:library_2escm"),(void*)f_25562},
{C_text("f_25568:library_2escm"),(void*)f_25568},
{C_text("f_25575:library_2escm"),(void*)f_25575},
{C_text("f_25582:library_2escm"),(void*)f_25582},
{C_text("f_25586:library_2escm"),(void*)f_25586},
{C_text("f_25589:library_2escm"),(void*)f_25589},
{C_text("f_25599:library_2escm"),(void*)f_25599},
{C_text("f_25603:library_2escm"),(void*)f_25603},
{C_text("f_25611:library_2escm"),(void*)f_25611},
{C_text("f_25614:library_2escm"),(void*)f_25614},
{C_text("f_25621:library_2escm"),(void*)f_25621},
{C_text("f_25624:library_2escm"),(void*)f_25624},
{C_text("f_25627:library_2escm"),(void*)f_25627},
{C_text("f_25630:library_2escm"),(void*)f_25630},
{C_text("f_25638:library_2escm"),(void*)f_25638},
{C_text("f_25646:library_2escm"),(void*)f_25646},
{C_text("f_25648:library_2escm"),(void*)f_25648},
{C_text("f_25664:library_2escm"),(void*)f_25664},
{C_text("f_25691:library_2escm"),(void*)f_25691},
{C_text("f_25695:library_2escm"),(void*)f_25695},
{C_text("f_25699:library_2escm"),(void*)f_25699},
{C_text("f_25703:library_2escm"),(void*)f_25703},
{C_text("f_25707:library_2escm"),(void*)f_25707},
{C_text("f_25711:library_2escm"),(void*)f_25711},
{C_text("f_25715:library_2escm"),(void*)f_25715},
{C_text("f_25719:library_2escm"),(void*)f_25719},
{C_text("f_25723:library_2escm"),(void*)f_25723},
{C_text("f_25727:library_2escm"),(void*)f_25727},
{C_text("f_25731:library_2escm"),(void*)f_25731},
{C_text("f_25735:library_2escm"),(void*)f_25735},
{C_text("f_25739:library_2escm"),(void*)f_25739},
{C_text("f_25743:library_2escm"),(void*)f_25743},
{C_text("f_25747:library_2escm"),(void*)f_25747},
{C_text("f_25751:library_2escm"),(void*)f_25751},
{C_text("f_25755:library_2escm"),(void*)f_25755},
{C_text("f_25759:library_2escm"),(void*)f_25759},
{C_text("f_25766:library_2escm"),(void*)f_25766},
{C_text("f_25773:library_2escm"),(void*)f_25773},
{C_text("f_25774:library_2escm"),(void*)f_25774},
{C_text("f_25778:library_2escm"),(void*)f_25778},
{C_text("f_25781:library_2escm"),(void*)f_25781},
{C_text("f_25797:library_2escm"),(void*)f_25797},
{C_text("f_25808:library_2escm"),(void*)f_25808},
{C_text("f_25816:library_2escm"),(void*)f_25816},
{C_text("f_25828:library_2escm"),(void*)f_25828},
{C_text("f_25837:library_2escm"),(void*)f_25837},
{C_text("f_25842:library_2escm"),(void*)f_25842},
{C_text("f_25898:library_2escm"),(void*)f_25898},
{C_text("f_25912:library_2escm"),(void*)f_25912},
{C_text("f_25924:library_2escm"),(void*)f_25924},
{C_text("f_25930:library_2escm"),(void*)f_25930},
{C_text("f_25955:library_2escm"),(void*)f_25955},
{C_text("f_25973:library_2escm"),(void*)f_25973},
{C_text("f_25977:library_2escm"),(void*)f_25977},
{C_text("f_26033:library_2escm"),(void*)f_26033},
{C_text("f_26042:library_2escm"),(void*)f_26042},
{C_text("f_26055:library_2escm"),(void*)f_26055},
{C_text("f_26067:library_2escm"),(void*)f_26067},
{C_text("f_26085:library_2escm"),(void*)f_26085},
{C_text("f_26105:library_2escm"),(void*)f_26105},
{C_text("f_26108:library_2escm"),(void*)f_26108},
{C_text("f_26113:library_2escm"),(void*)f_26113},
{C_text("f_26115:library_2escm"),(void*)f_26115},
{C_text("f_26123:library_2escm"),(void*)f_26123},
{C_text("f_26127:library_2escm"),(void*)f_26127},
{C_text("f_26131:library_2escm"),(void*)f_26131},
{C_text("f_26135:library_2escm"),(void*)f_26135},
{C_text("f_26139:library_2escm"),(void*)f_26139},
{C_text("f_26141:library_2escm"),(void*)f_26141},
{C_text("f_26149:library_2escm"),(void*)f_26149},
{C_text("f_26152:library_2escm"),(void*)f_26152},
{C_text("f_26162:library_2escm"),(void*)f_26162},
{C_text("f_26164:library_2escm"),(void*)f_26164},
{C_text("f_26172:library_2escm"),(void*)f_26172},
{C_text("f_26175:library_2escm"),(void*)f_26175},
{C_text("f_26185:library_2escm"),(void*)f_26185},
{C_text("f_26187:library_2escm"),(void*)f_26187},
{C_text("f_26194:library_2escm"),(void*)f_26194},
{C_text("f_26197:library_2escm"),(void*)f_26197},
{C_text("f_26200:library_2escm"),(void*)f_26200},
{C_text("f_26203:library_2escm"),(void*)f_26203},
{C_text("f_26205:library_2escm"),(void*)f_26205},
{C_text("f_26211:library_2escm"),(void*)f_26211},
{C_text("f_26220:library_2escm"),(void*)f_26220},
{C_text("f_26228:library_2escm"),(void*)f_26228},
{C_text("f_26230:library_2escm"),(void*)f_26230},
{C_text("f_26244:library_2escm"),(void*)f_26244},
{C_text("f_26257:library_2escm"),(void*)f_26257},
{C_text("f_26261:library_2escm"),(void*)f_26261},
{C_text("f_26266:library_2escm"),(void*)f_26266},
{C_text("f_26270:library_2escm"),(void*)f_26270},
{C_text("f_26281:library_2escm"),(void*)f_26281},
{C_text("f_26292:library_2escm"),(void*)f_26292},
{C_text("f_26296:library_2escm"),(void*)f_26296},
{C_text("f_26320:library_2escm"),(void*)f_26320},
{C_text("f_26326:library_2escm"),(void*)f_26326},
{C_text("f_26336:library_2escm"),(void*)f_26336},
{C_text("f_26355:library_2escm"),(void*)f_26355},
{C_text("f_26379:library_2escm"),(void*)f_26379},
{C_text("f_26401:library_2escm"),(void*)f_26401},
{C_text("f_26414:library_2escm"),(void*)f_26414},
{C_text("f_26434:library_2escm"),(void*)f_26434},
{C_text("f_26440:library_2escm"),(void*)f_26440},
{C_text("f_26443:library_2escm"),(void*)f_26443},
{C_text("f_26451:library_2escm"),(void*)f_26451},
{C_text("f_26453:library_2escm"),(void*)f_26453},
{C_text("f_26466:library_2escm"),(void*)f_26466},
{C_text("f_26473:library_2escm"),(void*)f_26473},
{C_text("f_26482:library_2escm"),(void*)f_26482},
{C_text("f_26489:library_2escm"),(void*)f_26489},
{C_text("f_26491:library_2escm"),(void*)f_26491},
{C_text("f_26497:library_2escm"),(void*)f_26497},
{C_text("f_26507:library_2escm"),(void*)f_26507},
{C_text("f_26510:library_2escm"),(void*)f_26510},
{C_text("f_26520:library_2escm"),(void*)f_26520},
{C_text("f_26523:library_2escm"),(void*)f_26523},
{C_text("f_26551:library_2escm"),(void*)f_26551},
{C_text("f_26554:library_2escm"),(void*)f_26554},
{C_text("f_26558:library_2escm"),(void*)f_26558},
{C_text("f_26561:library_2escm"),(void*)f_26561},
{C_text("f_26571:library_2escm"),(void*)f_26571},
{C_text("f_26573:library_2escm"),(void*)f_26573},
{C_text("f_26577:library_2escm"),(void*)f_26577},
{C_text("f_26586:library_2escm"),(void*)f_26586},
{C_text("f_26590:library_2escm"),(void*)f_26590},
{C_text("f_26608:library_2escm"),(void*)f_26608},
{C_text("f_26629:library_2escm"),(void*)f_26629},
{C_text("f_26641:library_2escm"),(void*)f_26641},
{C_text("f_26652:library_2escm"),(void*)f_26652},
{C_text("f_26655:library_2escm"),(void*)f_26655},
{C_text("f_26691:library_2escm"),(void*)f_26691},
{C_text("f_26699:library_2escm"),(void*)f_26699},
{C_text("f_26701:library_2escm"),(void*)f_26701},
{C_text("f_26718:library_2escm"),(void*)f_26718},
{C_text("f_26731:library_2escm"),(void*)f_26731},
{C_text("f_26748:library_2escm"),(void*)f_26748},
{C_text("f_26765:library_2escm"),(void*)f_26765},
{C_text("f_26782:library_2escm"),(void*)f_26782},
{C_text("f_26799:library_2escm"),(void*)f_26799},
{C_text("f_26816:library_2escm"),(void*)f_26816},
{C_text("f_26833:library_2escm"),(void*)f_26833},
{C_text("f_26853:library_2escm"),(void*)f_26853},
{C_text("f_26861:library_2escm"),(void*)f_26861},
{C_text("f_26870:library_2escm"),(void*)f_26870},
{C_text("f_26877:library_2escm"),(void*)f_26877},
{C_text("f_26894:library_2escm"),(void*)f_26894},
{C_text("f_26901:library_2escm"),(void*)f_26901},
{C_text("f_26918:library_2escm"),(void*)f_26918},
{C_text("f_26925:library_2escm"),(void*)f_26925},
{C_text("f_26938:library_2escm"),(void*)f_26938},
{C_text("f_26943:library_2escm"),(void*)f_26943},
{C_text("f_26960:library_2escm"),(void*)f_26960},
{C_text("f_26975:library_2escm"),(void*)f_26975},
{C_text("f_26988:library_2escm"),(void*)f_26988},
{C_text("f_27010:library_2escm"),(void*)f_27010},
{C_text("f_27013:library_2escm"),(void*)f_27013},
{C_text("f_27042:library_2escm"),(void*)f_27042},
{C_text("f_27052:library_2escm"),(void*)f_27052},
{C_text("f_27068:library_2escm"),(void*)f_27068},
{C_text("f_27079:library_2escm"),(void*)f_27079},
{C_text("f_27086:library_2escm"),(void*)f_27086},
{C_text("f_27184:library_2escm"),(void*)f_27184},
{C_text("f_27190:library_2escm"),(void*)f_27190},
{C_text("f_27199:library_2escm"),(void*)f_27199},
{C_text("f_27213:library_2escm"),(void*)f_27213},
{C_text("f_27216:library_2escm"),(void*)f_27216},
{C_text("f_27227:library_2escm"),(void*)f_27227},
{C_text("f_27229:library_2escm"),(void*)f_27229},
{C_text("f_27232:library_2escm"),(void*)f_27232},
{C_text("f_27249:library_2escm"),(void*)f_27249},
{C_text("f_27254:library_2escm"),(void*)f_27254},
{C_text("f_27258:library_2escm"),(void*)f_27258},
{C_text("f_27261:library_2escm"),(void*)f_27261},
{C_text("f_27264:library_2escm"),(void*)f_27264},
{C_text("f_27274:library_2escm"),(void*)f_27274},
{C_text("f_27292:library_2escm"),(void*)f_27292},
{C_text("f_27295:library_2escm"),(void*)f_27295},
{C_text("f_27304:library_2escm"),(void*)f_27304},
{C_text("f_27307:library_2escm"),(void*)f_27307},
{C_text("f_27310:library_2escm"),(void*)f_27310},
{C_text("f_27316:library_2escm"),(void*)f_27316},
{C_text("f_27329:library_2escm"),(void*)f_27329},
{C_text("f_27333:library_2escm"),(void*)f_27333},
{C_text("f_27337:library_2escm"),(void*)f_27337},
{C_text("f_27348:library_2escm"),(void*)f_27348},
{C_text("f_27352:library_2escm"),(void*)f_27352},
{C_text("f_27355:library_2escm"),(void*)f_27355},
{C_text("f_27383:library_2escm"),(void*)f_27383},
{C_text("f_27438:library_2escm"),(void*)f_27438},
{C_text("f_27442:library_2escm"),(void*)f_27442},
{C_text("f_27449:library_2escm"),(void*)f_27449},
{C_text("f_27451:library_2escm"),(void*)f_27451},
{C_text("f_27455:library_2escm"),(void*)f_27455},
{C_text("f_27469:library_2escm"),(void*)f_27469},
{C_text("f_27475:library_2escm"),(void*)f_27475},
{C_text("f_27482:library_2escm"),(void*)f_27482},
{C_text("f_27489:library_2escm"),(void*)f_27489},
{C_text("f_27509:library_2escm"),(void*)f_27509},
{C_text("f_27538:library_2escm"),(void*)f_27538},
{C_text("f_27548:library_2escm"),(void*)f_27548},
{C_text("f_27551:library_2escm"),(void*)f_27551},
{C_text("f_27587:library_2escm"),(void*)f_27587},
{C_text("f_27589:library_2escm"),(void*)f_27589},
{C_text("f_27599:library_2escm"),(void*)f_27599},
{C_text("f_27602:library_2escm"),(void*)f_27602},
{C_text("f_27654:library_2escm"),(void*)f_27654},
{C_text("f_27656:library_2escm"),(void*)f_27656},
{C_text("f_27664:library_2escm"),(void*)f_27664},
{C_text("f_27666:library_2escm"),(void*)f_27666},
{C_text("f_27676:library_2escm"),(void*)f_27676},
{C_text("f_27691:library_2escm"),(void*)f_27691},
{C_text("f_27698:library_2escm"),(void*)f_27698},
{C_text("f_27718:library_2escm"),(void*)f_27718},
{C_text("f_27726:library_2escm"),(void*)f_27726},
{C_text("f_27728:library_2escm"),(void*)f_27728},
{C_text("f_27744:library_2escm"),(void*)f_27744},
{C_text("f_27751:library_2escm"),(void*)f_27751},
{C_text("f_27764:library_2escm"),(void*)f_27764},
{C_text("f_27770:library_2escm"),(void*)f_27770},
{C_text("f_27774:library_2escm"),(void*)f_27774},
{C_text("f_27781:library_2escm"),(void*)f_27781},
{C_text("f_27789:library_2escm"),(void*)f_27789},
{C_text("f_27794:library_2escm"),(void*)f_27794},
{C_text("f_27799:library_2escm"),(void*)f_27799},
{C_text("f_27803:library_2escm"),(void*)f_27803},
{C_text("f_27812:library_2escm"),(void*)f_27812},
{C_text("f_27818:library_2escm"),(void*)f_27818},
{C_text("f_27825:library_2escm"),(void*)f_27825},
{C_text("f_27842:library_2escm"),(void*)f_27842},
{C_text("f_27848:library_2escm"),(void*)f_27848},
{C_text("f_27858:library_2escm"),(void*)f_27858},
{C_text("f_27909:library_2escm"),(void*)f_27909},
{C_text("f_27918:library_2escm"),(void*)f_27918},
{C_text("f_27925:library_2escm"),(void*)f_27925},
{C_text("f_27929:library_2escm"),(void*)f_27929},
{C_text("f_27933:library_2escm"),(void*)f_27933},
{C_text("f_27942:library_2escm"),(void*)f_27942},
{C_text("f_27953:library_2escm"),(void*)f_27953},
{C_text("f_27975:library_2escm"),(void*)f_27975},
{C_text("f_28002:library_2escm"),(void*)f_28002},
{C_text("f_28034:library_2escm"),(void*)f_28034},
{C_text("f_28038:library_2escm"),(void*)f_28038},
{C_text("f_28040:library_2escm"),(void*)f_28040},
{C_text("f_28044:library_2escm"),(void*)f_28044},
{C_text("f_28047:library_2escm"),(void*)f_28047},
{C_text("f_28059:library_2escm"),(void*)f_28059},
{C_text("f_28079:library_2escm"),(void*)f_28079},
{C_text("f_28085:library_2escm"),(void*)f_28085},
{C_text("f_28095:library_2escm"),(void*)f_28095},
{C_text("f_28232:library_2escm"),(void*)f_28232},
{C_text("f_28239:library_2escm"),(void*)f_28239},
{C_text("f_28257:library_2escm"),(void*)f_28257},
{C_text("f_28263:library_2escm"),(void*)f_28263},
{C_text("f_28267:library_2escm"),(void*)f_28267},
{C_text("f_28303:library_2escm"),(void*)f_28303},
{C_text("f_28326:library_2escm"),(void*)f_28326},
{C_text("f_28344:library_2escm"),(void*)f_28344},
{C_text("f_28348:library_2escm"),(void*)f_28348},
{C_text("f_28355:library_2escm"),(void*)f_28355},
{C_text("f_28357:library_2escm"),(void*)f_28357},
{C_text("f_28361:library_2escm"),(void*)f_28361},
{C_text("f_28372:library_2escm"),(void*)f_28372},
{C_text("f_28392:library_2escm"),(void*)f_28392},
{C_text("f_28395:library_2escm"),(void*)f_28395},
{C_text("f_28398:library_2escm"),(void*)f_28398},
{C_text("f_28412:library_2escm"),(void*)f_28412},
{C_text("f_28418:library_2escm"),(void*)f_28418},
{C_text("f_28440:library_2escm"),(void*)f_28440},
{C_text("f_28452:library_2escm"),(void*)f_28452},
{C_text("f_28464:library_2escm"),(void*)f_28464},
{C_text("f_28473:library_2escm"),(void*)f_28473},
{C_text("f_28483:library_2escm"),(void*)f_28483},
{C_text("f_28492:library_2escm"),(void*)f_28492},
{C_text("f_28495:library_2escm"),(void*)f_28495},
{C_text("f_28513:library_2escm"),(void*)f_28513},
{C_text("f_28516:library_2escm"),(void*)f_28516},
{C_text("f_28537:library_2escm"),(void*)f_28537},
{C_text("f_28543:library_2escm"),(void*)f_28543},
{C_text("f_28546:library_2escm"),(void*)f_28546},
{C_text("f_28556:library_2escm"),(void*)f_28556},
{C_text("f_28575:library_2escm"),(void*)f_28575},
{C_text("f_28583:library_2escm"),(void*)f_28583},
{C_text("f_28585:library_2escm"),(void*)f_28585},
{C_text("f_28591:library_2escm"),(void*)f_28591},
{C_text("f_28622:library_2escm"),(void*)f_28622},
{C_text("f_28645:library_2escm"),(void*)f_28645},
{C_text("f_28659:library_2escm"),(void*)f_28659},
{C_text("f_28665:library_2escm"),(void*)f_28665},
{C_text("f_28690:library_2escm"),(void*)f_28690},
{C_text("f_28702:library_2escm"),(void*)f_28702},
{C_text("f_28714:library_2escm"),(void*)f_28714},
{C_text("f_28726:library_2escm"),(void*)f_28726},
{C_text("f_28738:library_2escm"),(void*)f_28738},
{C_text("f_28750:library_2escm"),(void*)f_28750},
{C_text("f_28771:library_2escm"),(void*)f_28771},
{C_text("f_28783:library_2escm"),(void*)f_28783},
{C_text("f_28786:library_2escm"),(void*)f_28786},
{C_text("f_28798:library_2escm"),(void*)f_28798},
{C_text("f_28810:library_2escm"),(void*)f_28810},
{C_text("f_28813:library_2escm"),(void*)f_28813},
{C_text("f_28825:library_2escm"),(void*)f_28825},
{C_text("f_28837:library_2escm"),(void*)f_28837},
{C_text("f_28849:library_2escm"),(void*)f_28849},
{C_text("f_28852:library_2escm"),(void*)f_28852},
{C_text("f_28857:library_2escm"),(void*)f_28857},
{C_text("f_28862:library_2escm"),(void*)f_28862},
{C_text("f_28868:library_2escm"),(void*)f_28868},
{C_text("f_28897:library_2escm"),(void*)f_28897},
{C_text("f_28909:library_2escm"),(void*)f_28909},
{C_text("f_28912:library_2escm"),(void*)f_28912},
{C_text("f_28915:library_2escm"),(void*)f_28915},
{C_text("f_28930:library_2escm"),(void*)f_28930},
{C_text("f_28939:library_2escm"),(void*)f_28939},
{C_text("f_28942:library_2escm"),(void*)f_28942},
{C_text("f_28948:library_2escm"),(void*)f_28948},
{C_text("f_28951:library_2escm"),(void*)f_28951},
{C_text("f_28957:library_2escm"),(void*)f_28957},
{C_text("f_29004:library_2escm"),(void*)f_29004},
{C_text("f_29023:library_2escm"),(void*)f_29023},
{C_text("f_29039:library_2escm"),(void*)f_29039},
{C_text("f_29045:library_2escm"),(void*)f_29045},
{C_text("f_29115:library_2escm"),(void*)f_29115},
{C_text("f_29127:library_2escm"),(void*)f_29127},
{C_text("f_29205:library_2escm"),(void*)f_29205},
{C_text("f_29279:library_2escm"),(void*)f_29279},
{C_text("f_29282:library_2escm"),(void*)f_29282},
{C_text("f_29285:library_2escm"),(void*)f_29285},
{C_text("f_29293:library_2escm"),(void*)f_29293},
{C_text("f_29303:library_2escm"),(void*)f_29303},
{C_text("f_29308:library_2escm"),(void*)f_29308},
{C_text("f_29311:library_2escm"),(void*)f_29311},
{C_text("f_29324:library_2escm"),(void*)f_29324},
{C_text("f_29327:library_2escm"),(void*)f_29327},
{C_text("f_29363:library_2escm"),(void*)f_29363},
{C_text("f_29379:library_2escm"),(void*)f_29379},
{C_text("f_29429:library_2escm"),(void*)f_29429},
{C_text("f_29433:library_2escm"),(void*)f_29433},
{C_text("f_29460:library_2escm"),(void*)f_29460},
{C_text("f_29466:library_2escm"),(void*)f_29466},
{C_text("f_29482:library_2escm"),(void*)f_29482},
{C_text("f_29522:library_2escm"),(void*)f_29522},
{C_text("f_29524:library_2escm"),(void*)f_29524},
{C_text("f_29531:library_2escm"),(void*)f_29531},
{C_text("f_29588:library_2escm"),(void*)f_29588},
{C_text("f_29595:library_2escm"),(void*)f_29595},
{C_text("f_29604:library_2escm"),(void*)f_29604},
{C_text("f_29616:library_2escm"),(void*)f_29616},
{C_text("f_29637:library_2escm"),(void*)f_29637},
{C_text("f_29652:library_2escm"),(void*)f_29652},
{C_text("f_29670:library_2escm"),(void*)f_29670},
{C_text("f_29688:library_2escm"),(void*)f_29688},
{C_text("f_29707:library_2escm"),(void*)f_29707},
{C_text("f_29717:library_2escm"),(void*)f_29717},
{C_text("f_29731:library_2escm"),(void*)f_29731},
{C_text("f_29734:library_2escm"),(void*)f_29734},
{C_text("f_29739:library_2escm"),(void*)f_29739},
{C_text("f_29758:library_2escm"),(void*)f_29758},
{C_text("f_29768:library_2escm"),(void*)f_29768},
{C_text("f_29782:library_2escm"),(void*)f_29782},
{C_text("f_29785:library_2escm"),(void*)f_29785},
{C_text("f_29792:library_2escm"),(void*)f_29792},
{C_text("f_29796:library_2escm"),(void*)f_29796},
{C_text("f_29800:library_2escm"),(void*)f_29800},
{C_text("f_29802:library_2escm"),(void*)f_29802},
{C_text("f_29809:library_2escm"),(void*)f_29809},
{C_text("f_29812:library_2escm"),(void*)f_29812},
{C_text("f_29815:library_2escm"),(void*)f_29815},
{C_text("f_29818:library_2escm"),(void*)f_29818},
{C_text("f_29820:library_2escm"),(void*)f_29820},
{C_text("f_29830:library_2escm"),(void*)f_29830},
{C_text("f_29836:library_2escm"),(void*)f_29836},
{C_text("f_29848:library_2escm"),(void*)f_29848},
{C_text("f_29851:library_2escm"),(void*)f_29851},
{C_text("f_29854:library_2escm"),(void*)f_29854},
{C_text("f_29871:library_2escm"),(void*)f_29871},
{C_text("f_29879:library_2escm"),(void*)f_29879},
{C_text("f_29903:library_2escm"),(void*)f_29903},
{C_text("f_29907:library_2escm"),(void*)f_29907},
{C_text("f_29920:library_2escm"),(void*)f_29920},
{C_text("f_29923:library_2escm"),(void*)f_29923},
{C_text("f_29932:library_2escm"),(void*)f_29932},
{C_text("f_29935:library_2escm"),(void*)f_29935},
{C_text("f_29963:library_2escm"),(void*)f_29963},
{C_text("f_29967:library_2escm"),(void*)f_29967},
{C_text("f_29976:library_2escm"),(void*)f_29976},
{C_text("f_29993:library_2escm"),(void*)f_29993},
{C_text("f_30000:library_2escm"),(void*)f_30000},
{C_text("f_30005:library_2escm"),(void*)f_30005},
{C_text("f_30029:library_2escm"),(void*)f_30029},
{C_text("f_30035:library_2escm"),(void*)f_30035},
{C_text("f_30038:library_2escm"),(void*)f_30038},
{C_text("f_30049:library_2escm"),(void*)f_30049},
{C_text("f_30052:library_2escm"),(void*)f_30052},
{C_text("f_30055:library_2escm"),(void*)f_30055},
{C_text("f_30078:library_2escm"),(void*)f_30078},
{C_text("f_30129:library_2escm"),(void*)f_30129},
{C_text("f_30204:library_2escm"),(void*)f_30204},
{C_text("f_30304:library_2escm"),(void*)f_30304},
{C_text("f_30309:library_2escm"),(void*)f_30309},
{C_text("f_30364:library_2escm"),(void*)f_30364},
{C_text("f_30370:library_2escm"),(void*)f_30370},
{C_text("f_30374:library_2escm"),(void*)f_30374},
{C_text("f_30382:library_2escm"),(void*)f_30382},
{C_text("f_30397:library_2escm"),(void*)f_30397},
{C_text("f_30404:library_2escm"),(void*)f_30404},
{C_text("f_30423:library_2escm"),(void*)f_30423},
{C_text("f_30459:library_2escm"),(void*)f_30459},
{C_text("f_30471:library_2escm"),(void*)f_30471},
{C_text("f_30477:library_2escm"),(void*)f_30477},
{C_text("f_30506:library_2escm"),(void*)f_30506},
{C_text("f_30516:library_2escm"),(void*)f_30516},
{C_text("f_30525:library_2escm"),(void*)f_30525},
{C_text("f_30534:library_2escm"),(void*)f_30534},
{C_text("f_30550:library_2escm"),(void*)f_30550},
{C_text("f_30588:library_2escm"),(void*)f_30588},
{C_text("f_30654:library_2escm"),(void*)f_30654},
{C_text("f_30657:library_2escm"),(void*)f_30657},
{C_text("f_30660:library_2escm"),(void*)f_30660},
{C_text("f_30667:library_2escm"),(void*)f_30667},
{C_text("f_30711:library_2escm"),(void*)f_30711},
{C_text("f_30714:library_2escm"),(void*)f_30714},
{C_text("f_30723:library_2escm"),(void*)f_30723},
{C_text("f_30736:library_2escm"),(void*)f_30736},
{C_text("f_30745:library_2escm"),(void*)f_30745},
{C_text("f_30755:library_2escm"),(void*)f_30755},
{C_text("f_30758:library_2escm"),(void*)f_30758},
{C_text("f_30784:library_2escm"),(void*)f_30784},
{C_text("f_30791:library_2escm"),(void*)f_30791},
{C_text("f_30807:library_2escm"),(void*)f_30807},
{C_text("f_30819:library_2escm"),(void*)f_30819},
{C_text("f_30822:library_2escm"),(void*)f_30822},
{C_text("f_30829:library_2escm"),(void*)f_30829},
{C_text("f_30838:library_2escm"),(void*)f_30838},
{C_text("f_30841:library_2escm"),(void*)f_30841},
{C_text("f_30888:library_2escm"),(void*)f_30888},
{C_text("f_30891:library_2escm"),(void*)f_30891},
{C_text("f_30900:library_2escm"),(void*)f_30900},
{C_text("f_30913:library_2escm"),(void*)f_30913},
{C_text("f_30916:library_2escm"),(void*)f_30916},
{C_text("f_30941:library_2escm"),(void*)f_30941},
{C_text("f_30945:library_2escm"),(void*)f_30945},
{C_text("f_30955:library_2escm"),(void*)f_30955},
{C_text("f_30958:library_2escm"),(void*)f_30958},
{C_text("f_30970:library_2escm"),(void*)f_30970},
{C_text("f_30974:library_2escm"),(void*)f_30974},
{C_text("f_30996:library_2escm"),(void*)f_30996},
{C_text("f_30998:library_2escm"),(void*)f_30998},
{C_text("f_31014:library_2escm"),(void*)f_31014},
{C_text("f_31019:library_2escm"),(void*)f_31019},
{C_text("f_31025:library_2escm"),(void*)f_31025},
{C_text("f_31031:library_2escm"),(void*)f_31031},
{C_text("f_31035:library_2escm"),(void*)f_31035},
{C_text("f_31038:library_2escm"),(void*)f_31038},
{C_text("f_31053:library_2escm"),(void*)f_31053},
{C_text("f_31056:library_2escm"),(void*)f_31056},
{C_text("f_31072:library_2escm"),(void*)f_31072},
{C_text("f_31078:library_2escm"),(void*)f_31078},
{C_text("f_31087:library_2escm"),(void*)f_31087},
{C_text("f_31093:library_2escm"),(void*)f_31093},
{C_text("f_31100:library_2escm"),(void*)f_31100},
{C_text("f_31103:library_2escm"),(void*)f_31103},
{C_text("f_31106:library_2escm"),(void*)f_31106},
{C_text("f_31115:library_2escm"),(void*)f_31115},
{C_text("f_31131:library_2escm"),(void*)f_31131},
{C_text("f_31150:library_2escm"),(void*)f_31150},
{C_text("f_31156:library_2escm"),(void*)f_31156},
{C_text("f_31162:library_2escm"),(void*)f_31162},
{C_text("f_31166:library_2escm"),(void*)f_31166},
{C_text("f_31169:library_2escm"),(void*)f_31169},
{C_text("f_31172:library_2escm"),(void*)f_31172},
{C_text("f_31176:library_2escm"),(void*)f_31176},
{C_text("f_31180:library_2escm"),(void*)f_31180},
{C_text("f_31184:library_2escm"),(void*)f_31184},
{C_text("f_31187:library_2escm"),(void*)f_31187},
{C_text("f_31190:library_2escm"),(void*)f_31190},
{C_text("f_31193:library_2escm"),(void*)f_31193},
{C_text("f_31205:library_2escm"),(void*)f_31205},
{C_text("f_31211:library_2escm"),(void*)f_31211},
{C_text("f_31215:library_2escm"),(void*)f_31215},
{C_text("f_31218:library_2escm"),(void*)f_31218},
{C_text("f_31221:library_2escm"),(void*)f_31221},
{C_text("f_31224:library_2escm"),(void*)f_31224},
{C_text("f_31227:library_2escm"),(void*)f_31227},
{C_text("f_31230:library_2escm"),(void*)f_31230},
{C_text("f_31235:library_2escm"),(void*)f_31235},
{C_text("f_31257:library_2escm"),(void*)f_31257},
{C_text("f_31263:library_2escm"),(void*)f_31263},
{C_text("f_31288:library_2escm"),(void*)f_31288},
{C_text("f_31295:library_2escm"),(void*)f_31295},
{C_text("f_31297:library_2escm"),(void*)f_31297},
{C_text("f_31304:library_2escm"),(void*)f_31304},
{C_text("f_31308:library_2escm"),(void*)f_31308},
{C_text("f_31315:library_2escm"),(void*)f_31315},
{C_text("f_31331:library_2escm"),(void*)f_31331},
{C_text("f_31335:library_2escm"),(void*)f_31335},
{C_text("f_31351:library_2escm"),(void*)f_31351},
{C_text("f_31366:library_2escm"),(void*)f_31366},
{C_text("f_31376:library_2escm"),(void*)f_31376},
{C_text("f_31381:library_2escm"),(void*)f_31381},
{C_text("f_31387:library_2escm"),(void*)f_31387},
{C_text("f_31401:library_2escm"),(void*)f_31401},
{C_text("f_31410:library_2escm"),(void*)f_31410},
{C_text("f_31421:library_2escm"),(void*)f_31421},
{C_text("f_31427:library_2escm"),(void*)f_31427},
{C_text("f_31430:library_2escm"),(void*)f_31430},
{C_text("f_31441:library_2escm"),(void*)f_31441},
{C_text("f_31450:library_2escm"),(void*)f_31450},
{C_text("f_31455:library_2escm"),(void*)f_31455},
{C_text("f_31461:library_2escm"),(void*)f_31461},
{C_text("f_31482:library_2escm"),(void*)f_31482},
{C_text("f_31485:library_2escm"),(void*)f_31485},
{C_text("f_31492:library_2escm"),(void*)f_31492},
{C_text("f_31499:library_2escm"),(void*)f_31499},
{C_text("f_31508:library_2escm"),(void*)f_31508},
{C_text("f_31519:library_2escm"),(void*)f_31519},
{C_text("f_31565:library_2escm"),(void*)f_31565},
{C_text("f_31569:library_2escm"),(void*)f_31569},
{C_text("f_31570:library_2escm"),(void*)f_31570},
{C_text("f_31580:library_2escm"),(void*)f_31580},
{C_text("f_31585:library_2escm"),(void*)f_31585},
{C_text("f_31595:library_2escm"),(void*)f_31595},
{C_text("f_31608:library_2escm"),(void*)f_31608},
{C_text("f_31619:library_2escm"),(void*)f_31619},
{C_text("f_31623:library_2escm"),(void*)f_31623},
{C_text("f_31627:library_2escm"),(void*)f_31627},
{C_text("f_31649:library_2escm"),(void*)f_31649},
{C_text("f_31653:library_2escm"),(void*)f_31653},
{C_text("f_31661:library_2escm"),(void*)f_31661},
{C_text("f_31677:library_2escm"),(void*)f_31677},
{C_text("f_31688:library_2escm"),(void*)f_31688},
{C_text("f_31707:library_2escm"),(void*)f_31707},
{C_text("f_31718:library_2escm"),(void*)f_31718},
{C_text("f_31729:library_2escm"),(void*)f_31729},
{C_text("f_31815:library_2escm"),(void*)f_31815},
{C_text("f_31825:library_2escm"),(void*)f_31825},
{C_text("f_31826:library_2escm"),(void*)f_31826},
{C_text("f_31839:library_2escm"),(void*)f_31839},
{C_text("f_31842:library_2escm"),(void*)f_31842},
{C_text("f_31845:library_2escm"),(void*)f_31845},
{C_text("f_31848:library_2escm"),(void*)f_31848},
{C_text("f_31856:library_2escm"),(void*)f_31856},
{C_text("f_31863:library_2escm"),(void*)f_31863},
{C_text("f_31866:library_2escm"),(void*)f_31866},
{C_text("f_31869:library_2escm"),(void*)f_31869},
{C_text("f_31892:library_2escm"),(void*)f_31892},
{C_text("f_31897:library_2escm"),(void*)f_31897},
{C_text("f_31907:library_2escm"),(void*)f_31907},
{C_text("f_31920:library_2escm"),(void*)f_31920},
{C_text("f_31961:library_2escm"),(void*)f_31961},
{C_text("f_32011:library_2escm"),(void*)f_32011},
{C_text("f_32014:library_2escm"),(void*)f_32014},
{C_text("f_32033:library_2escm"),(void*)f_32033},
{C_text("f_32038:library_2escm"),(void*)f_32038},
{C_text("f_32044:library_2escm"),(void*)f_32044},
{C_text("f_32047:library_2escm"),(void*)f_32047},
{C_text("f_32056:library_2escm"),(void*)f_32056},
{C_text("f_32062:library_2escm"),(void*)f_32062},
{C_text("f_32081:library_2escm"),(void*)f_32081},
{C_text("f_32100:library_2escm"),(void*)f_32100},
{C_text("f_32105:library_2escm"),(void*)f_32105},
{C_text("f_32115:library_2escm"),(void*)f_32115},
{C_text("f_32129:library_2escm"),(void*)f_32129},
{C_text("f_32136:library_2escm"),(void*)f_32136},
{C_text("f_32140:library_2escm"),(void*)f_32140},
{C_text("f_32144:library_2escm"),(void*)f_32144},
{C_text("f_32146:library_2escm"),(void*)f_32146},
{C_text("f_32149:library_2escm"),(void*)f_32149},
{C_text("f_32175:library_2escm"),(void*)f_32175},
{C_text("f_32178:library_2escm"),(void*)f_32178},
{C_text("f_32181:library_2escm"),(void*)f_32181},
{C_text("f_32188:library_2escm"),(void*)f_32188},
{C_text("f_32192:library_2escm"),(void*)f_32192},
{C_text("f_32198:library_2escm"),(void*)f_32198},
{C_text("f_32203:library_2escm"),(void*)f_32203},
{C_text("f_32213:library_2escm"),(void*)f_32213},
{C_text("f_32251:library_2escm"),(void*)f_32251},
{C_text("f_32254:library_2escm"),(void*)f_32254},
{C_text("f_32274:library_2escm"),(void*)f_32274},
{C_text("f_32292:library_2escm"),(void*)f_32292},
{C_text("f_32426:library_2escm"),(void*)f_32426},
{C_text("f_32443:library_2escm"),(void*)f_32443},
{C_text("f_32458:library_2escm"),(void*)f_32458},
{C_text("f_32462:library_2escm"),(void*)f_32462},
{C_text("f_32475:library_2escm"),(void*)f_32475},
{C_text("f_32483:library_2escm"),(void*)f_32483},
{C_text("f_32486:library_2escm"),(void*)f_32486},
{C_text("f_32490:library_2escm"),(void*)f_32490},
{C_text("f_32529:library_2escm"),(void*)f_32529},
{C_text("f_32532:library_2escm"),(void*)f_32532},
{C_text("f_32539:library_2escm"),(void*)f_32539},
{C_text("f_32543:library_2escm"),(void*)f_32543},
{C_text("f_32569:library_2escm"),(void*)f_32569},
{C_text("f_32600:library_2escm"),(void*)f_32600},
{C_text("f_32603:library_2escm"),(void*)f_32603},
{C_text("f_32615:library_2escm"),(void*)f_32615},
{C_text("f_32618:library_2escm"),(void*)f_32618},
{C_text("f_32621:library_2escm"),(void*)f_32621},
{C_text("f_32646:library_2escm"),(void*)f_32646},
{C_text("f_32652:library_2escm"),(void*)f_32652},
{C_text("f_32656:library_2escm"),(void*)f_32656},
{C_text("f_32660:library_2escm"),(void*)f_32660},
{C_text("f_32673:library_2escm"),(void*)f_32673},
{C_text("f_32675:library_2escm"),(void*)f_32675},
{C_text("f_32681:library_2escm"),(void*)f_32681},
{C_text("f_32686:library_2escm"),(void*)f_32686},
{C_text("f_32721:library_2escm"),(void*)f_32721},
{C_text("f_32727:library_2escm"),(void*)f_32727},
{C_text("f_32743:library_2escm"),(void*)f_32743},
{C_text("f_32765:library_2escm"),(void*)f_32765},
{C_text("f_32789:library_2escm"),(void*)f_32789},
{C_text("f_32801:library_2escm"),(void*)f_32801},
{C_text("f_32803:library_2escm"),(void*)f_32803},
{C_text("f_32822:library_2escm"),(void*)f_32822},
{C_text("f_32826:library_2escm"),(void*)f_32826},
{C_text("f_32838:library_2escm"),(void*)f_32838},
{C_text("f_32840:library_2escm"),(void*)f_32840},
{C_text("f_32884:library_2escm"),(void*)f_32884},
{C_text("f_32886:library_2escm"),(void*)f_32886},
{C_text("f_32920:library_2escm"),(void*)f_32920},
{C_text("f_32943:library_2escm"),(void*)f_32943},
{C_text("f_32950:library_2escm"),(void*)f_32950},
{C_text("f_32960:library_2escm"),(void*)f_32960},
{C_text("f_32962:library_2escm"),(void*)f_32962},
{C_text("f_33012:library_2escm"),(void*)f_33012},
{C_text("f_33014:library_2escm"),(void*)f_33014},
{C_text("f_33039:library_2escm"),(void*)f_33039},
{C_text("f_33048:library_2escm"),(void*)f_33048},
{C_text("f_33054:library_2escm"),(void*)f_33054},
{C_text("f_33058:library_2escm"),(void*)f_33058},
{C_text("f_33062:library_2escm"),(void*)f_33062},
{C_text("f_33070:library_2escm"),(void*)f_33070},
{C_text("f_33076:library_2escm"),(void*)f_33076},
{C_text("f_33107:library_2escm"),(void*)f_33107},
{C_text("f_33132:library_2escm"),(void*)f_33132},
{C_text("f_33157:library_2escm"),(void*)f_33157},
{C_text("f_33167:library_2escm"),(void*)f_33167},
{C_text("f_33172:library_2escm"),(void*)f_33172},
{C_text("f_33174:library_2escm"),(void*)f_33174},
{C_text("f_33181:library_2escm"),(void*)f_33181},
{C_text("f_33193:library_2escm"),(void*)f_33193},
{C_text("f_33201:library_2escm"),(void*)f_33201},
{C_text("f_33239:library_2escm"),(void*)f_33239},
{C_text("f_33243:library_2escm"),(void*)f_33243},
{C_text("f_33250:library_2escm"),(void*)f_33250},
{C_text("f_33253:library_2escm"),(void*)f_33253},
{C_text("f_33256:library_2escm"),(void*)f_33256},
{C_text("f_33257:library_2escm"),(void*)f_33257},
{C_text("f_33259:library_2escm"),(void*)f_33259},
{C_text("f_33263:library_2escm"),(void*)f_33263},
{C_text("f_33268:library_2escm"),(void*)f_33268},
{C_text("f_33280:library_2escm"),(void*)f_33280},
{C_text("f_33290:library_2escm"),(void*)f_33290},
{C_text("f_33302:library_2escm"),(void*)f_33302},
{C_text("f_33304:library_2escm"),(void*)f_33304},
{C_text("f_33311:library_2escm"),(void*)f_33311},
{C_text("f_33314:library_2escm"),(void*)f_33314},
{C_text("f_33323:library_2escm"),(void*)f_33323},
{C_text("f_33326:library_2escm"),(void*)f_33326},
{C_text("f_33329:library_2escm"),(void*)f_33329},
{C_text("f_33344:library_2escm"),(void*)f_33344},
{C_text("f_33350:library_2escm"),(void*)f_33350},
{C_text("f_33358:library_2escm"),(void*)f_33358},
{C_text("f_33362:library_2escm"),(void*)f_33362},
{C_text("f_33365:library_2escm"),(void*)f_33365},
{C_text("f_33368:library_2escm"),(void*)f_33368},
{C_text("f_33381:library_2escm"),(void*)f_33381},
{C_text("f_33385:library_2escm"),(void*)f_33385},
{C_text("f_33406:library_2escm"),(void*)f_33406},
{C_text("f_33422:library_2escm"),(void*)f_33422},
{C_text("f_33425:library_2escm"),(void*)f_33425},
{C_text("f_33431:library_2escm"),(void*)f_33431},
{C_text("f_33453:library_2escm"),(void*)f_33453},
{C_text("f_33458:library_2escm"),(void*)f_33458},
{C_text("f_33493:library_2escm"),(void*)f_33493},
{C_text("f_33503:library_2escm"),(void*)f_33503},
{C_text("f_33506:library_2escm"),(void*)f_33506},
{C_text("f_33509:library_2escm"),(void*)f_33509},
{C_text("f_33512:library_2escm"),(void*)f_33512},
{C_text("f_33515:library_2escm"),(void*)f_33515},
{C_text("f_33518:library_2escm"),(void*)f_33518},
{C_text("f_33525:library_2escm"),(void*)f_33525},
{C_text("f_33528:library_2escm"),(void*)f_33528},
{C_text("f_33531:library_2escm"),(void*)f_33531},
{C_text("f_33542:library_2escm"),(void*)f_33542},
{C_text("f_33565:library_2escm"),(void*)f_33565},
{C_text("f_33576:library_2escm"),(void*)f_33576},
{C_text("f_33580:library_2escm"),(void*)f_33580},
{C_text("f_33602:library_2escm"),(void*)f_33602},
{C_text("f_33613:library_2escm"),(void*)f_33613},
{C_text("f_33617:library_2escm"),(void*)f_33617},
{C_text("f_34116:library_2escm"),(void*)f_34116},
{C_text("f_34127:library_2escm"),(void*)f_34127},
{C_text("f_34131:library_2escm"),(void*)f_34131},
{C_text("f_34272:library_2escm"),(void*)f_34272},
{C_text("f_34274:library_2escm"),(void*)f_34274},
{C_text("f_34280:library_2escm"),(void*)f_34280},
{C_text("f_34284:library_2escm"),(void*)f_34284},
{C_text("f_34287:library_2escm"),(void*)f_34287},
{C_text("f_34296:library_2escm"),(void*)f_34296},
{C_text("f_34310:library_2escm"),(void*)f_34310},
{C_text("f_34318:library_2escm"),(void*)f_34318},
{C_text("f_34320:library_2escm"),(void*)f_34320},
{C_text("f_34324:library_2escm"),(void*)f_34324},
{C_text("f_34332:library_2escm"),(void*)f_34332},
{C_text("f_34340:library_2escm"),(void*)f_34340},
{C_text("f_34342:library_2escm"),(void*)f_34342},
{C_text("f_34352:library_2escm"),(void*)f_34352},
{C_text("f_34359:library_2escm"),(void*)f_34359},
{C_text("f_34369:library_2escm"),(void*)f_34369},
{C_text("f_34373:library_2escm"),(void*)f_34373},
{C_text("f_34377:library_2escm"),(void*)f_34377},
{C_text("f_34381:library_2escm"),(void*)f_34381},
{C_text("f_34383:library_2escm"),(void*)f_34383},
{C_text("f_34393:library_2escm"),(void*)f_34393},
{C_text("f_34404:library_2escm"),(void*)f_34404},
{C_text("f_34408:library_2escm"),(void*)f_34408},
{C_text("f_34413:library_2escm"),(void*)f_34413},
{C_text("f_34417:library_2escm"),(void*)f_34417},
{C_text("f_34422:library_2escm"),(void*)f_34422},
{C_text("f_34425:library_2escm"),(void*)f_34425},
{C_text("f_34428:library_2escm"),(void*)f_34428},
{C_text("f_34431:library_2escm"),(void*)f_34431},
{C_text("f_34433:library_2escm"),(void*)f_34433},
{C_text("f_34440:library_2escm"),(void*)f_34440},
{C_text("f_34443:library_2escm"),(void*)f_34443},
{C_text("f_34451:library_2escm"),(void*)f_34451},
{C_text("f_34458:library_2escm"),(void*)f_34458},
{C_text("f_34463:library_2escm"),(void*)f_34463},
{C_text("f_34466:library_2escm"),(void*)f_34466},
{C_text("f_34469:library_2escm"),(void*)f_34469},
{C_text("f_34472:library_2escm"),(void*)f_34472},
{C_text("f_34477:library_2escm"),(void*)f_34477},
{C_text("f_34480:library_2escm"),(void*)f_34480},
{C_text("f_34483:library_2escm"),(void*)f_34483},
{C_text("f_34486:library_2escm"),(void*)f_34486},
{C_text("f_34489:library_2escm"),(void*)f_34489},
{C_text("f_34492:library_2escm"),(void*)f_34492},
{C_text("f_34495:library_2escm"),(void*)f_34495},
{C_text("f_34498:library_2escm"),(void*)f_34498},
{C_text("f_34522:library_2escm"),(void*)f_34522},
{C_text("f_34526:library_2escm"),(void*)f_34526},
{C_text("f_34528:library_2escm"),(void*)f_34528},
{C_text("f_34536:library_2escm"),(void*)f_34536},
{C_text("f_34538:library_2escm"),(void*)f_34538},
{C_text("f_34542:library_2escm"),(void*)f_34542},
{C_text("f_34544:library_2escm"),(void*)f_34544},
{C_text("f_34551:library_2escm"),(void*)f_34551},
{C_text("f_34587:library_2escm"),(void*)f_34587},
{C_text("f_34590:library_2escm"),(void*)f_34590},
{C_text("f_34593:library_2escm"),(void*)f_34593},
{C_text("f_34596:library_2escm"),(void*)f_34596},
{C_text("f_34599:library_2escm"),(void*)f_34599},
{C_text("f_34615:library_2escm"),(void*)f_34615},
{C_text("f_34619:library_2escm"),(void*)f_34619},
{C_text("f_34628:library_2escm"),(void*)f_34628},
{C_text("f_34632:library_2escm"),(void*)f_34632},
{C_text("f_34634:library_2escm"),(void*)f_34634},
{C_text("f_34638:library_2escm"),(void*)f_34638},
{C_text("f_34640:library_2escm"),(void*)f_34640},
{C_text("f_34645:library_2escm"),(void*)f_34645},
{C_text("f_34647:library_2escm"),(void*)f_34647},
{C_text("f_34650:library_2escm"),(void*)f_34650},
{C_text("f_34670:library_2escm"),(void*)f_34670},
{C_text("f_34676:library_2escm"),(void*)f_34676},
{C_text("f_34686:library_2escm"),(void*)f_34686},
{C_text("f_34696:library_2escm"),(void*)f_34696},
{C_text("f_34731:library_2escm"),(void*)f_34731},
{C_text("f_34735:library_2escm"),(void*)f_34735},
{C_text("f_34740:library_2escm"),(void*)f_34740},
{C_text("f_34750:library_2escm"),(void*)f_34750},
{C_text("f_34760:library_2escm"),(void*)f_34760},
{C_text("f_34769:library_2escm"),(void*)f_34769},
{C_text("f_34772:library_2escm"),(void*)f_34772},
{C_text("f_34775:library_2escm"),(void*)f_34775},
{C_text("f_34779:library_2escm"),(void*)f_34779},
{C_text("f_34781:library_2escm"),(void*)f_34781},
{C_text("f_34784:library_2escm"),(void*)f_34784},
{C_text("f_34787:library_2escm"),(void*)f_34787},
{C_text("f_34790:library_2escm"),(void*)f_34790},
{C_text("f_34793:library_2escm"),(void*)f_34793},
{C_text("f_34802:library_2escm"),(void*)f_34802},
{C_text("f_34805:library_2escm"),(void*)f_34805},
{C_text("f_34808:library_2escm"),(void*)f_34808},
{C_text("f_34811:library_2escm"),(void*)f_34811},
{C_text("f_34814:library_2escm"),(void*)f_34814},
{C_text("f_34817:library_2escm"),(void*)f_34817},
{C_text("f_34820:library_2escm"),(void*)f_34820},
{C_text("f_34823:library_2escm"),(void*)f_34823},
{C_text("f_34830:library_2escm"),(void*)f_34830},
{C_text("f_34833:library_2escm"),(void*)f_34833},
{C_text("f_34849:library_2escm"),(void*)f_34849},
{C_text("f_34857:library_2escm"),(void*)f_34857},
{C_text("f_34860:library_2escm"),(void*)f_34860},
{C_text("f_34866:library_2escm"),(void*)f_34866},
{C_text("f_34875:library_2escm"),(void*)f_34875},
{C_text("f_34881:library_2escm"),(void*)f_34881},
{C_text("f_34890:library_2escm"),(void*)f_34890},
{C_text("f_34896:library_2escm"),(void*)f_34896},
{C_text("f_34902:library_2escm"),(void*)f_34902},
{C_text("f_34905:library_2escm"),(void*)f_34905},
{C_text("f_34911:library_2escm"),(void*)f_34911},
{C_text("f_34917:library_2escm"),(void*)f_34917},
{C_text("f_34920:library_2escm"),(void*)f_34920},
{C_text("f_34926:library_2escm"),(void*)f_34926},
{C_text("f_34965:library_2escm"),(void*)f_34965},
{C_text("f_35008:library_2escm"),(void*)f_35008},
{C_text("f_35015:library_2escm"),(void*)f_35015},
{C_text("f_35020:library_2escm"),(void*)f_35020},
{C_text("f_35036:library_2escm"),(void*)f_35036},
{C_text("f_35062:library_2escm"),(void*)f_35062},
{C_text("f_35065:library_2escm"),(void*)f_35065},
{C_text("f_35072:library_2escm"),(void*)f_35072},
{C_text("f_35077:library_2escm"),(void*)f_35077},
{C_text("f_35079:library_2escm"),(void*)f_35079},
{C_text("f_35083:library_2escm"),(void*)f_35083},
{C_text("f_35110:library_2escm"),(void*)f_35110},
{C_text("f_35120:library_2escm"),(void*)f_35120},
{C_text("f_35129:library_2escm"),(void*)f_35129},
{C_text("f_35136:library_2escm"),(void*)f_35136},
{C_text("f_35140:library_2escm"),(void*)f_35140},
{C_text("f_35154:library_2escm"),(void*)f_35154},
{C_text("f_35158:library_2escm"),(void*)f_35158},
{C_text("f_35165:library_2escm"),(void*)f_35165},
{C_text("f_35167:library_2escm"),(void*)f_35167},
{C_text("f_35189:library_2escm"),(void*)f_35189},
{C_text("f_35196:library_2escm"),(void*)f_35196},
{C_text("f_35201:library_2escm"),(void*)f_35201},
{C_text("f_35205:library_2escm"),(void*)f_35205},
{C_text("f_35208:library_2escm"),(void*)f_35208},
{C_text("f_35211:library_2escm"),(void*)f_35211},
{C_text("f_35216:library_2escm"),(void*)f_35216},
{C_text("f_35220:library_2escm"),(void*)f_35220},
{C_text("f_35246:library_2escm"),(void*)f_35246},
{C_text("f_35259:library_2escm"),(void*)f_35259},
{C_text("f_35262:library_2escm"),(void*)f_35262},
{C_text("f_35271:library_2escm"),(void*)f_35271},
{C_text("f_35274:library_2escm"),(void*)f_35274},
{C_text("f_35277:library_2escm"),(void*)f_35277},
{C_text("f_35283:library_2escm"),(void*)f_35283},
{C_text("f_35290:library_2escm"),(void*)f_35290},
{C_text("f_35292:library_2escm"),(void*)f_35292},
{C_text("f_35305:library_2escm"),(void*)f_35305},
{C_text("f_35318:library_2escm"),(void*)f_35318},
{C_text("f_35321:library_2escm"),(void*)f_35321},
{C_text("f_35324:library_2escm"),(void*)f_35324},
{C_text("f_35331:library_2escm"),(void*)f_35331},
{C_text("f_35383:library_2escm"),(void*)f_35383},
{C_text("f_35386:library_2escm"),(void*)f_35386},
{C_text("f_35389:library_2escm"),(void*)f_35389},
{C_text("f_35391:library_2escm"),(void*)f_35391},
{C_text("f_35395:library_2escm"),(void*)f_35395},
{C_text("f_35399:library_2escm"),(void*)f_35399},
{C_text("f_35405:library_2escm"),(void*)f_35405},
{C_text("f_35410:library_2escm"),(void*)f_35410},
{C_text("f_35414:library_2escm"),(void*)f_35414},
{C_text("f_35426:library_2escm"),(void*)f_35426},
{C_text("f_35438:library_2escm"),(void*)f_35438},
{C_text("f_35445:library_2escm"),(void*)f_35445},
{C_text("f_35451:library_2escm"),(void*)f_35451},
{C_text("f_35465:library_2escm"),(void*)f_35465},
{C_text("f_35504:library_2escm"),(void*)f_35504},
{C_text("f_35523:library_2escm"),(void*)f_35523},
{C_text("f_35545:library_2escm"),(void*)f_35545},
{C_text("f_35554:library_2escm"),(void*)f_35554},
{C_text("f_35561:library_2escm"),(void*)f_35561},
{C_text("f_35578:library_2escm"),(void*)f_35578},
{C_text("f_35586:library_2escm"),(void*)f_35586},
{C_text("f_35597:library_2escm"),(void*)f_35597},
{C_text("f_35605:library_2escm"),(void*)f_35605},
{C_text("f_35612:library_2escm"),(void*)f_35612},
{C_text("f_35674:library_2escm"),(void*)f_35674},
{C_text("f_35681:library_2escm"),(void*)f_35681},
{C_text("f_35684:library_2escm"),(void*)f_35684},
{C_text("f_35694:library_2escm"),(void*)f_35694},
{C_text("f_35698:library_2escm"),(void*)f_35698},
{C_text("f_35702:library_2escm"),(void*)f_35702},
{C_text("f_35705:library_2escm"),(void*)f_35705},
{C_text("f_35713:library_2escm"),(void*)f_35713},
{C_text("f_35722:library_2escm"),(void*)f_35722},
{C_text("f_35730:library_2escm"),(void*)f_35730},
{C_text("f_35743:library_2escm"),(void*)f_35743},
{C_text("f_35751:library_2escm"),(void*)f_35751},
{C_text("f_35755:library_2escm"),(void*)f_35755},
{C_text("f_35763:library_2escm"),(void*)f_35763},
{C_text("f_35771:library_2escm"),(void*)f_35771},
{C_text("f_35773:library_2escm"),(void*)f_35773},
{C_text("f_35779:library_2escm"),(void*)f_35779},
{C_text("f_35783:library_2escm"),(void*)f_35783},
{C_text("f_35791:library_2escm"),(void*)f_35791},
{C_text("f_35811:library_2escm"),(void*)f_35811},
{C_text("f_35819:library_2escm"),(void*)f_35819},
{C_text("f_35823:library_2escm"),(void*)f_35823},
{C_text("f_35838:library_2escm"),(void*)f_35838},
{C_text("f_35845:library_2escm"),(void*)f_35845},
{C_text("f_35857:library_2escm"),(void*)f_35857},
{C_text("f_35865:library_2escm"),(void*)f_35865},
{C_text("f_35871:library_2escm"),(void*)f_35871},
{C_text("f_35893:library_2escm"),(void*)f_35893},
{C_text("f_35897:library_2escm"),(void*)f_35897},
{C_text("f_35901:library_2escm"),(void*)f_35901},
{C_text("f_35903:library_2escm"),(void*)f_35903},
{C_text("f_35906:library_2escm"),(void*)f_35906},
{C_text("f_35909:library_2escm"),(void*)f_35909},
{C_text("f_35913:library_2escm"),(void*)f_35913},
{C_text("f_35916:library_2escm"),(void*)f_35916},
{C_text("f_35938:library_2escm"),(void*)f_35938},
{C_text("f_35944:library_2escm"),(void*)f_35944},
{C_text("f_35948:library_2escm"),(void*)f_35948},
{C_text("f_35965:library_2escm"),(void*)f_35965},
{C_text("f_35975:library_2escm"),(void*)f_35975},
{C_text("f_35979:library_2escm"),(void*)f_35979},
{C_text("f_35983:library_2escm"),(void*)f_35983},
{C_text("f_35995:library_2escm"),(void*)f_35995},
{C_text("f_36005:library_2escm"),(void*)f_36005},
{C_text("f_36014:library_2escm"),(void*)f_36014},
{C_text("f_36030:library_2escm"),(void*)f_36030},
{C_text("f_36034:library_2escm"),(void*)f_36034},
{C_text("f_36036:library_2escm"),(void*)f_36036},
{C_text("f_36042:library_2escm"),(void*)f_36042},
{C_text("f_36049:library_2escm"),(void*)f_36049},
{C_text("f_36054:library_2escm"),(void*)f_36054},
{C_text("f_36075:library_2escm"),(void*)f_36075},
{C_text("f_36085:library_2escm"),(void*)f_36085},
{C_text("f_36095:library_2escm"),(void*)f_36095},
{C_text("f_36108:library_2escm"),(void*)f_36108},
{C_text("f_36112:library_2escm"),(void*)f_36112},
{C_text("f_36115:library_2escm"),(void*)f_36115},
{C_text("f_36123:library_2escm"),(void*)f_36123},
{C_text("f_36133:library_2escm"),(void*)f_36133},
{C_text("f_36155:library_2escm"),(void*)f_36155},
{C_text("f_36159:library_2escm"),(void*)f_36159},
{C_text("f_36190:library_2escm"),(void*)f_36190},
{C_text("f_36193:library_2escm"),(void*)f_36193},
{C_text("f_36196:library_2escm"),(void*)f_36196},
{C_text("f_36202:library_2escm"),(void*)f_36202},
{C_text("f_36215:library_2escm"),(void*)f_36215},
{C_text("f_36218:library_2escm"),(void*)f_36218},
{C_text("f_36227:library_2escm"),(void*)f_36227},
{C_text("f_36233:library_2escm"),(void*)f_36233},
{C_text("f_36239:library_2escm"),(void*)f_36239},
{C_text("f_36245:library_2escm"),(void*)f_36245},
{C_text("f_36251:library_2escm"),(void*)f_36251},
{C_text("f_36268:library_2escm"),(void*)f_36268},
{C_text("f_36274:library_2escm"),(void*)f_36274},
{C_text("f_36289:library_2escm"),(void*)f_36289},
{C_text("f_36293:library_2escm"),(void*)f_36293},
{C_text("f_36297:library_2escm"),(void*)f_36297},
{C_text("f_36301:library_2escm"),(void*)f_36301},
{C_text("f_36322:library_2escm"),(void*)f_36322},
{C_text("f_36324:library_2escm"),(void*)f_36324},
{C_text("f_36330:library_2escm"),(void*)f_36330},
{C_text("f_36334:library_2escm"),(void*)f_36334},
{C_text("f_36343:library_2escm"),(void*)f_36343},
{C_text("f_36352:library_2escm"),(void*)f_36352},
{C_text("f_36395:library_2escm"),(void*)f_36395},
{C_text("f_36662:library_2escm"),(void*)f_36662},
{C_text("f_36668:library_2escm"),(void*)f_36668},
{C_text("f_36687:library_2escm"),(void*)f_36687},
{C_text("f_36689:library_2escm"),(void*)f_36689},
{C_text("f_36712:library_2escm"),(void*)f_36712},
{C_text("f_36758:library_2escm"),(void*)f_36758},
{C_text("f_36760:library_2escm"),(void*)f_36760},
{C_text("f_36767:library_2escm"),(void*)f_36767},
{C_text("f_36779:library_2escm"),(void*)f_36779},
{C_text("f_36823:library_2escm"),(void*)f_36823},
{C_text("f_36838:library_2escm"),(void*)f_36838},
{C_text("f_36846:library_2escm"),(void*)f_36846},
{C_text("f_36852:library_2escm"),(void*)f_36852},
{C_text("f_36860:library_2escm"),(void*)f_36860},
{C_text("f_36864:library_2escm"),(void*)f_36864},
{C_text("f_36872:library_2escm"),(void*)f_36872},
{C_text("f_36874:library_2escm"),(void*)f_36874},
{C_text("f_36884:library_2escm"),(void*)f_36884},
{C_text("f_36891:library_2escm"),(void*)f_36891},
{C_text("f_36895:library_2escm"),(void*)f_36895},
{C_text("f_36906:library_2escm"),(void*)f_36906},
{C_text("f_36913:library_2escm"),(void*)f_36913},
{C_text("f_36917:library_2escm"),(void*)f_36917},
{C_text("f_36928:library_2escm"),(void*)f_36928},
{C_text("f_36935:library_2escm"),(void*)f_36935},
{C_text("f_36939:library_2escm"),(void*)f_36939},
{C_text("f_36944:library_2escm"),(void*)f_36944},
{C_text("f_36950:library_2escm"),(void*)f_36950},
{C_text("f_36953:library_2escm"),(void*)f_36953},
{C_text("f_36956:library_2escm"),(void*)f_36956},
{C_text("f_36962:library_2escm"),(void*)f_36962},
{C_text("f_36971:library_2escm"),(void*)f_36971},
{C_text("f_36980:library_2escm"),(void*)f_36980},
{C_text("f_36986:library_2escm"),(void*)f_36986},
{C_text("f_36989:library_2escm"),(void*)f_36989},
{C_text("f_36992:library_2escm"),(void*)f_36992},
{C_text("f_37004:library_2escm"),(void*)f_37004},
{C_text("f_37007:library_2escm"),(void*)f_37007},
{C_text("f_37010:library_2escm"),(void*)f_37010},
{C_text("f_37013:library_2escm"),(void*)f_37013},
{C_text("f_37025:library_2escm"),(void*)f_37025},
{C_text("f_37028:library_2escm"),(void*)f_37028},
{C_text("f_37031:library_2escm"),(void*)f_37031},
{C_text("f_37034:library_2escm"),(void*)f_37034},
{C_text("f_37043:library_2escm"),(void*)f_37043},
{C_text("f_37046:library_2escm"),(void*)f_37046},
{C_text("f_37059:library_2escm"),(void*)f_37059},
{C_text("f_37060:library_2escm"),(void*)f_37060},
{C_text("f_37065:library_2escm"),(void*)f_37065},
{C_text("f_37066:library_2escm"),(void*)f_37066},
{C_text("f_37071:library_2escm"),(void*)f_37071},
{C_text("f_37072:library_2escm"),(void*)f_37072},
{C_text("f_37077:library_2escm"),(void*)f_37077},
{C_text("f_37078:library_2escm"),(void*)f_37078},
{C_text("f_37083:library_2escm"),(void*)f_37083},
{C_text("f_37084:library_2escm"),(void*)f_37084},
{C_text("f_37089:library_2escm"),(void*)f_37089},
{C_text("f_37091:library_2escm"),(void*)f_37091},
{C_text("f_37101:library_2escm"),(void*)f_37101},
{C_text("f_37104:library_2escm"),(void*)f_37104},
{C_text("f_37107:library_2escm"),(void*)f_37107},
{C_text("f_37110:library_2escm"),(void*)f_37110},
{C_text("f_37112:library_2escm"),(void*)f_37112},
{C_text("f_37126:library_2escm"),(void*)f_37126},
{C_text("f_37134:library_2escm"),(void*)f_37134},
{C_text("f_37138:library_2escm"),(void*)f_37138},
{C_text("f_37142:library_2escm"),(void*)f_37142},
{C_text("f_37146:library_2escm"),(void*)f_37146},
{C_text("f_37152:library_2escm"),(void*)f_37152},
{C_text("f_37159:library_2escm"),(void*)f_37159},
{C_text("f_37163:library_2escm"),(void*)f_37163},
{C_text("f_37167:library_2escm"),(void*)f_37167},
{C_text("f_37171:library_2escm"),(void*)f_37171},
{C_text("f_37189:library_2escm"),(void*)f_37189},
{C_text("f_37208:library_2escm"),(void*)f_37208},
{C_text("f_37211:library_2escm"),(void*)f_37211},
{C_text("f_37214:library_2escm"),(void*)f_37214},
{C_text("f_37217:library_2escm"),(void*)f_37217},
{C_text("f_37226:library_2escm"),(void*)f_37226},
{C_text("f_37232:library_2escm"),(void*)f_37232},
{C_text("f_37255:library_2escm"),(void*)f_37255},
{C_text("f_37277:library_2escm"),(void*)f_37277},
{C_text("f_37283:library_2escm"),(void*)f_37283},
{C_text("f_37303:library_2escm"),(void*)f_37303},
{C_text("f_37318:library_2escm"),(void*)f_37318},
{C_text("f_37322:library_2escm"),(void*)f_37322},
{C_text("f_37345:library_2escm"),(void*)f_37345},
{C_text("f_37349:library_2escm"),(void*)f_37349},
{C_text("f_37351:library_2escm"),(void*)f_37351},
{C_text("f_37381:library_2escm"),(void*)f_37381},
{C_text("f_37384:library_2escm"),(void*)f_37384},
{C_text("f_37386:library_2escm"),(void*)f_37386},
{C_text("f_37404:library_2escm"),(void*)f_37404},
{C_text("f_37411:library_2escm"),(void*)f_37411},
{C_text("f_37433:library_2escm"),(void*)f_37433},
{C_text("f_37442:library_2escm"),(void*)f_37442},
{C_text("f_37457:library_2escm"),(void*)f_37457},
{C_text("f_37460:library_2escm"),(void*)f_37460},
{C_text("f_37463:library_2escm"),(void*)f_37463},
{C_text("f_37466:library_2escm"),(void*)f_37466},
{C_text("f_37469:library_2escm"),(void*)f_37469},
{C_text("f_37472:library_2escm"),(void*)f_37472},
{C_text("f_37475:library_2escm"),(void*)f_37475},
{C_text("f_37478:library_2escm"),(void*)f_37478},
{C_text("f_37481:library_2escm"),(void*)f_37481},
{C_text("f_37484:library_2escm"),(void*)f_37484},
{C_text("f_37492:library_2escm"),(void*)f_37492},
{C_text("f_37495:library_2escm"),(void*)f_37495},
{C_text("f_37500:library_2escm"),(void*)f_37500},
{C_text("f_37506:library_2escm"),(void*)f_37506},
{C_text("f_37519:library_2escm"),(void*)f_37519},
{C_text("f_37521:library_2escm"),(void*)f_37521},
{C_text("f_37544:library_2escm"),(void*)f_37544},
{C_text("f_37551:library_2escm"),(void*)f_37551},
{C_text("f_37555:library_2escm"),(void*)f_37555},
{C_text("f_37557:library_2escm"),(void*)f_37557},
{C_text("f_37586:library_2escm"),(void*)f_37586},
{C_text("f_37588:library_2escm"),(void*)f_37588},
{C_text("f_37613:library_2escm"),(void*)f_37613},
{C_text("f_37622:library_2escm"),(void*)f_37622},
{C_text("f_37628:library_2escm"),(void*)f_37628},
{C_text("f_37652:library_2escm"),(void*)f_37652},
{C_text("f_37659:library_2escm"),(void*)f_37659},
{C_text("f_37663:library_2escm"),(void*)f_37663},
{C_text("f_37675:library_2escm"),(void*)f_37675},
{C_text("f_37683:library_2escm"),(void*)f_37683},
{C_text("f_37687:library_2escm"),(void*)f_37687},
{C_text("f_37696:library_2escm"),(void*)f_37696},
{C_text("f_37705:library_2escm"),(void*)f_37705},
{C_text("f_37713:library_2escm"),(void*)f_37713},
{C_text("f_37726:library_2escm"),(void*)f_37726},
{C_text("f_37734:library_2escm"),(void*)f_37734},
{C_text("f_37759:library_2escm"),(void*)f_37759},
{C_text("f_37768:library_2escm"),(void*)f_37768},
{C_text("f_37775:library_2escm"),(void*)f_37775},
{C_text("f_37778:library_2escm"),(void*)f_37778},
{C_text("f_37783:library_2escm"),(void*)f_37783},
{C_text("f_37815:library_2escm"),(void*)f_37815},
{C_text("f_37819:library_2escm"),(void*)f_37819},
{C_text("f_37822:library_2escm"),(void*)f_37822},
{C_text("f_37827:library_2escm"),(void*)f_37827},
{C_text("f_37840:library_2escm"),(void*)f_37840},
{C_text("f_37865:library_2escm"),(void*)f_37865},
{C_text("f_37877:library_2escm"),(void*)f_37877},
{C_text("f_37902:library_2escm"),(void*)f_37902},
{C_text("f_37904:library_2escm"),(void*)f_37904},
{C_text("f_37918:library_2escm"),(void*)f_37918},
{C_text("f_37928:library_2escm"),(void*)f_37928},
{C_text("f_37931:library_2escm"),(void*)f_37931},
{C_text("f_37934:library_2escm"),(void*)f_37934},
{C_text("f_37939:library_2escm"),(void*)f_37939},
{C_text("f_38008:library_2escm"),(void*)f_38008},
{C_text("f_38022:library_2escm"),(void*)f_38022},
{C_text("f_38032:library_2escm"),(void*)f_38032},
{C_text("f_38035:library_2escm"),(void*)f_38035},
{C_text("f_38038:library_2escm"),(void*)f_38038},
{C_text("f_38043:library_2escm"),(void*)f_38043},
{C_text("f_38122:library_2escm"),(void*)f_38122},
{C_text("f_38132:library_2escm"),(void*)f_38132},
{C_text("f_38137:library_2escm"),(void*)f_38137},
{C_text("f_38150:library_2escm"),(void*)f_38150},
{C_text("f_38184:library_2escm"),(void*)f_38184},
{C_text("f_38198:library_2escm"),(void*)f_38198},
{C_text("f_38207:library_2escm"),(void*)f_38207},
{C_text("f_38212:library_2escm"),(void*)f_38212},
{C_text("f_38233:library_2escm"),(void*)f_38233},
{C_text("f_38238:library_2escm"),(void*)f_38238},
{C_text("f_38245:library_2escm"),(void*)f_38245},
{C_text("f_38247:library_2escm"),(void*)f_38247},
{C_text("f_38281:library_2escm"),(void*)f_38281},
{C_text("f_38305:library_2escm"),(void*)f_38305},
{C_text("f_38339:library_2escm"),(void*)f_38339},
{C_text("f_38362:library_2escm"),(void*)f_38362},
{C_text("f_38374:library_2escm"),(void*)f_38374},
{C_text("f_38384:library_2escm"),(void*)f_38384},
{C_text("f_38410:library_2escm"),(void*)f_38410},
{C_text("f_38424:library_2escm"),(void*)f_38424},
{C_text("f_38433:library_2escm"),(void*)f_38433},
{C_text("f_38438:library_2escm"),(void*)f_38438},
{C_text("f_38448:library_2escm"),(void*)f_38448},
{C_text("f_38460:library_2escm"),(void*)f_38460},
{C_text("f_38467:library_2escm"),(void*)f_38467},
{C_text("f_38469:library_2escm"),(void*)f_38469},
{C_text("f_38503:library_2escm"),(void*)f_38503},
{C_text("f_38527:library_2escm"),(void*)f_38527},
{C_text("f_38561:library_2escm"),(void*)f_38561},
{C_text("f_38584:library_2escm"),(void*)f_38584},
{C_text("f_38594:library_2escm"),(void*)f_38594},
{C_text("f_38603:library_2escm"),(void*)f_38603},
{C_text("f_38608:library_2escm"),(void*)f_38608},
{C_text("f_38629:library_2escm"),(void*)f_38629},
{C_text("f_38639:library_2escm"),(void*)f_38639},
{C_text("f_38653:library_2escm"),(void*)f_38653},
{C_text("f_38662:library_2escm"),(void*)f_38662},
{C_text("f_38667:library_2escm"),(void*)f_38667},
{C_text("f_38688:library_2escm"),(void*)f_38688},
{C_text("f_38693:library_2escm"),(void*)f_38693},
{C_text("f_38700:library_2escm"),(void*)f_38700},
{C_text("f_38702:library_2escm"),(void*)f_38702},
{C_text("f_38736:library_2escm"),(void*)f_38736},
{C_text("f_38760:library_2escm"),(void*)f_38760},
{C_text("f_38794:library_2escm"),(void*)f_38794},
{C_text("f_38817:library_2escm"),(void*)f_38817},
{C_text("f_38827:library_2escm"),(void*)f_38827},
{C_text("f_38838:library_2escm"),(void*)f_38838},
{C_text("f_38848:library_2escm"),(void*)f_38848},
{C_text("f_38865:library_2escm"),(void*)f_38865},
{C_text("f_38879:library_2escm"),(void*)f_38879},
{C_text("f_38888:library_2escm"),(void*)f_38888},
{C_text("f_38893:library_2escm"),(void*)f_38893},
{C_text("f_38903:library_2escm"),(void*)f_38903},
{C_text("f_38915:library_2escm"),(void*)f_38915},
{C_text("f_38922:library_2escm"),(void*)f_38922},
{C_text("f_38924:library_2escm"),(void*)f_38924},
{C_text("f_38958:library_2escm"),(void*)f_38958},
{C_text("f_38982:library_2escm"),(void*)f_38982},
{C_text("f_39016:library_2escm"),(void*)f_39016},
{C_text("f_39039:library_2escm"),(void*)f_39039},
{C_text("f_39043:library_2escm"),(void*)f_39043},
{C_text("f_39046:library_2escm"),(void*)f_39046},
{C_text("f_39049:library_2escm"),(void*)f_39049},
{C_text("f_39074:library_2escm"),(void*)f_39074},
{C_text("f_39080:library_2escm"),(void*)f_39080},
{C_text("f_39086:library_2escm"),(void*)f_39086},
{C_text("f_39090:library_2escm"),(void*)f_39090},
{C_text("f_39095:library_2escm"),(void*)f_39095},
{C_text("f_39098:library_2escm"),(void*)f_39098},
{C_text("f_39109:library_2escm"),(void*)f_39109},
{C_text("f_39134:library_2escm"),(void*)f_39134},
{C_text("f_39148:library_2escm"),(void*)f_39148},
{C_text("f_39176:library_2escm"),(void*)f_39176},
{C_text("f_39179:library_2escm"),(void*)f_39179},
{C_text("f_39182:library_2escm"),(void*)f_39182},
{C_text("f_39252:library_2escm"),(void*)f_39252},
{C_text("f_39281:library_2escm"),(void*)f_39281},
{C_text("f_39283:library_2escm"),(void*)f_39283},
{C_text("f_39303:library_2escm"),(void*)f_39303},
{C_text("f_39355:library_2escm"),(void*)f_39355},
{C_text("f_39365:library_2escm"),(void*)f_39365},
{C_text("f_39375:library_2escm"),(void*)f_39375},
{C_text("f_39388:library_2escm"),(void*)f_39388},
{C_text("f_39393:library_2escm"),(void*)f_39393},
{C_text("f_39406:library_2escm"),(void*)f_39406},
{C_text("f_39439:library_2escm"),(void*)f_39439},
{C_text("f_39448:library_2escm"),(void*)f_39448},
{C_text("f_39474:library_2escm"),(void*)f_39474},
{C_text("f_39482:library_2escm"),(void*)f_39482},
{C_text("f_39511:library_2escm"),(void*)f_39511},
{C_text("f_39539:library_2escm"),(void*)f_39539},
{C_text("f_39552:library_2escm"),(void*)f_39552},
{C_text("f_39601:library_2escm"),(void*)f_39601},
{C_text("f_39620:library_2escm"),(void*)f_39620},
{C_text("f_39640:library_2escm"),(void*)f_39640},
{C_text("f_39655:library_2escm"),(void*)f_39655},
{C_text("f_39659:library_2escm"),(void*)f_39659},
{C_text("f_39715:library_2escm"),(void*)f_39715},
{C_text("f_39719:library_2escm"),(void*)f_39719},
{C_text("f_39727:library_2escm"),(void*)f_39727},
{C_text("f_39730:library_2escm"),(void*)f_39730},
{C_text("f_39734:library_2escm"),(void*)f_39734},
{C_text("f_39745:library_2escm"),(void*)f_39745},
{C_text("f_39748:library_2escm"),(void*)f_39748},
{C_text("f_39754:library_2escm"),(void*)f_39754},
{C_text("f_39758:library_2escm"),(void*)f_39758},
{C_text("f_39778:library_2escm"),(void*)f_39778},
{C_text("f_39803:library_2escm"),(void*)f_39803},
{C_text("f_39873:library_2escm"),(void*)f_39873},
{C_text("f_39948:library_2escm"),(void*)f_39948},
{C_text("f_40033:library_2escm"),(void*)f_40033},
{C_text("f_40052:library_2escm"),(void*)f_40052},
{C_text("f_40055:library_2escm"),(void*)f_40055},
{C_text("f_40069:library_2escm"),(void*)f_40069},
{C_text("f_40081:library_2escm"),(void*)f_40081},
{C_text("f_40083:library_2escm"),(void*)f_40083},
{C_text("f_40091:library_2escm"),(void*)f_40091},
{C_text("f_40093:library_2escm"),(void*)f_40093},
{C_text("f_40100:library_2escm"),(void*)f_40100},
{C_text("f_40112:library_2escm"),(void*)f_40112},
{C_text("f_40132:library_2escm"),(void*)f_40132},
{C_text("f_40136:library_2escm"),(void*)f_40136},
{C_text("f_40139:library_2escm"),(void*)f_40139},
{C_text("f_40148:library_2escm"),(void*)f_40148},
{C_text("f_40150:library_2escm"),(void*)f_40150},
{C_text("f_40201:library_2escm"),(void*)f_40201},
{C_text("f_40226:library_2escm"),(void*)f_40226},
{C_text("f_40241:library_2escm"),(void*)f_40241},
{C_text("f_40251:library_2escm"),(void*)f_40251},
{C_text("f_40281:library_2escm"),(void*)f_40281},
{C_text("f_40309:library_2escm"),(void*)f_40309},
{C_text("f_40319:library_2escm"),(void*)f_40319},
{C_text("f_40324:library_2escm"),(void*)f_40324},
{C_text("f_40328:library_2escm"),(void*)f_40328},
{C_text("f_40334:library_2escm"),(void*)f_40334},
{C_text("f_40337:library_2escm"),(void*)f_40337},
{C_text("f_40344:library_2escm"),(void*)f_40344},
{C_text("f_40365:library_2escm"),(void*)f_40365},
{C_text("f_40375:library_2escm"),(void*)f_40375},
{C_text("f_40378:library_2escm"),(void*)f_40378},
{C_text("f_40392:library_2escm"),(void*)f_40392},
{C_text("f_40405:library_2escm"),(void*)f_40405},
{C_text("f_40423:library_2escm"),(void*)f_40423},
{C_text("f_40457:library_2escm"),(void*)f_40457},
{C_text("f_40460:library_2escm"),(void*)f_40460},
{C_text("f_40519:library_2escm"),(void*)f_40519},
{C_text("f_40527:library_2escm"),(void*)f_40527},
{C_text("f_40531:library_2escm"),(void*)f_40531},
{C_text("f_40535:library_2escm"),(void*)f_40535},
{C_text("f_40541:library_2escm"),(void*)f_40541},
{C_text("f_40545:library_2escm"),(void*)f_40545},
{C_text("f_40549:library_2escm"),(void*)f_40549},
{C_text("f_40571:library_2escm"),(void*)f_40571},
{C_text("f_40575:library_2escm"),(void*)f_40575},
{C_text("f_40579:library_2escm"),(void*)f_40579},
{C_text("f_40583:library_2escm"),(void*)f_40583},
{C_text("f_40587:library_2escm"),(void*)f_40587},
{C_text("f_40607:library_2escm"),(void*)f_40607},
{C_text("f_40615:library_2escm"),(void*)f_40615},
{C_text("f_40640:library_2escm"),(void*)f_40640},
{C_text("f_40657:library_2escm"),(void*)f_40657},
{C_text("f_40661:library_2escm"),(void*)f_40661},
{C_text("f_40664:library_2escm"),(void*)f_40664},
{C_text("f_40667:library_2escm"),(void*)f_40667},
{C_text("f_40677:library_2escm"),(void*)f_40677},
{C_text("f_40680:library_2escm"),(void*)f_40680},
{C_text("f_40682:library_2escm"),(void*)f_40682},
{C_text("f_40699:library_2escm"),(void*)f_40699},
{C_text("f_40726:library_2escm"),(void*)f_40726},
{C_text("f_40735:library_2escm"),(void*)f_40735},
{C_text("f_40755:library_2escm"),(void*)f_40755},
{C_text("f_40759:library_2escm"),(void*)f_40759},
{C_text("f_40763:library_2escm"),(void*)f_40763},
{C_text("f_40767:library_2escm"),(void*)f_40767},
{C_text("f_40771:library_2escm"),(void*)f_40771},
{C_text("f_40775:library_2escm"),(void*)f_40775},
{C_text("f_40779:library_2escm"),(void*)f_40779},
{C_text("f_40781:library_2escm"),(void*)f_40781},
{C_text("f_40790:library_2escm"),(void*)f_40790},
{C_text("f_40800:library_2escm"),(void*)f_40800},
{C_text("f_40825:library_2escm"),(void*)f_40825},
{C_text("f_40828:library_2escm"),(void*)f_40828},
{C_text("f_40830:library_2escm"),(void*)f_40830},
{C_text("f_40846:library_2escm"),(void*)f_40846},
{C_text("f_40881:library_2escm"),(void*)f_40881},
{C_text("f_40905:library_2escm"),(void*)f_40905},
{C_text("f_40909:library_2escm"),(void*)f_40909},
{C_text("f_40911:library_2escm"),(void*)f_40911},
{C_text("f_40915:library_2escm"),(void*)f_40915},
{C_text("f_40918:library_2escm"),(void*)f_40918},
{C_text("f_40931:library_2escm"),(void*)f_40931},
{C_text("f_40936:library_2escm"),(void*)f_40936},
{C_text("f_40951:library_2escm"),(void*)f_40951},
{C_text("f_40955:library_2escm"),(void*)f_40955},
{C_text("f_40964:library_2escm"),(void*)f_40964},
{C_text("f_40967:library_2escm"),(void*)f_40967},
{C_text("f_40970:library_2escm"),(void*)f_40970},
{C_text("f_40973:library_2escm"),(void*)f_40973},
{C_text("f_40976:library_2escm"),(void*)f_40976},
{C_text("f_40978:library_2escm"),(void*)f_40978},
{C_text("f_40988:library_2escm"),(void*)f_40988},
{C_text("f_41000:library_2escm"),(void*)f_41000},
{C_text("f_41008:library_2escm"),(void*)f_41008},
{C_text("f_41018:library_2escm"),(void*)f_41018},
{C_text("f_41034:library_2escm"),(void*)f_41034},
{C_text("f_41040:library_2escm"),(void*)f_41040},
{C_text("f_41043:library_2escm"),(void*)f_41043},
{C_text("f_41046:library_2escm"),(void*)f_41046},
{C_text("f_41047:library_2escm"),(void*)f_41047},
{C_text("f_41051:library_2escm"),(void*)f_41051},
{C_text("f_41057:library_2escm"),(void*)f_41057},
{C_text("f_41061:library_2escm"),(void*)f_41061},
{C_text("f_41063:library_2escm"),(void*)f_41063},
{C_text("f_41073:library_2escm"),(void*)f_41073},
{C_text("f_41090:library_2escm"),(void*)f_41090},
{C_text("f_41093:library_2escm"),(void*)f_41093},
{C_text("f_41097:library_2escm"),(void*)f_41097},
{C_text("f_41102:library_2escm"),(void*)f_41102},
{C_text("f_41108:library_2escm"),(void*)f_41108},
{C_text("f_41124:library_2escm"),(void*)f_41124},
{C_text("f_41132:library_2escm"),(void*)f_41132},
{C_text("f_41154:library_2escm"),(void*)f_41154},
{C_text("f_41172:library_2escm"),(void*)f_41172},
{C_text("f_41176:library_2escm"),(void*)f_41176},
{C_text("f_41188:library_2escm"),(void*)f_41188},
{C_text("f_41195:library_2escm"),(void*)f_41195},
{C_text("f_41210:library_2escm"),(void*)f_41210},
{C_text("f_41213:library_2escm"),(void*)f_41213},
{C_text("f_41216:library_2escm"),(void*)f_41216},
{C_text("f_41229:library_2escm"),(void*)f_41229},
{C_text("f_41252:library_2escm"),(void*)f_41252},
{C_text("f_41276:library_2escm"),(void*)f_41276},
{C_text("f_41286:library_2escm"),(void*)f_41286},
{C_text("f_41295:library_2escm"),(void*)f_41295},
{C_text("f_41336:library_2escm"),(void*)f_41336},
{C_text("f_41358:library_2escm"),(void*)f_41358},
{C_text("f_41367:library_2escm"),(void*)f_41367},
{C_text("f_41371:library_2escm"),(void*)f_41371},
{C_text("f_41376:library_2escm"),(void*)f_41376},
{C_text("f_41386:library_2escm"),(void*)f_41386},
{C_text("f_41396:library_2escm"),(void*)f_41396},
{C_text("f_41406:library_2escm"),(void*)f_41406},
{C_text("f_41416:library_2escm"),(void*)f_41416},
{C_text("f_41426:library_2escm"),(void*)f_41426},
{C_text("f_41436:library_2escm"),(void*)f_41436},
{C_text("f_41446:library_2escm"),(void*)f_41446},
{C_text("f_41456:library_2escm"),(void*)f_41456},
{C_text("f_41466:library_2escm"),(void*)f_41466},
{C_text("f_41476:library_2escm"),(void*)f_41476},
{C_text("f_41486:library_2escm"),(void*)f_41486},
{C_text("f_41496:library_2escm"),(void*)f_41496},
{C_text("f_41506:library_2escm"),(void*)f_41506},
{C_text("f_41522:library_2escm"),(void*)f_41522},
{C_text("f_41530:library_2escm"),(void*)f_41530},
{C_text("f_41546:library_2escm"),(void*)f_41546},
{C_text("f_41562:library_2escm"),(void*)f_41562},
{C_text("f_41572:library_2escm"),(void*)f_41572},
{C_text("f_41582:library_2escm"),(void*)f_41582},
{C_text("f_41601:library_2escm"),(void*)f_41601},
{C_text("f_41617:library_2escm"),(void*)f_41617},
{C_text("f_41630:library_2escm"),(void*)f_41630},
{C_text("f_41636:library_2escm"),(void*)f_41636},
{C_text("f_41668:library_2escm"),(void*)f_41668},
{C_text("f_41684:library_2escm"),(void*)f_41684},
{C_text("f_41688:library_2escm"),(void*)f_41688},
{C_text("f_41698:library_2escm"),(void*)f_41698},
{C_text("f_41704:library_2escm"),(void*)f_41704},
{C_text("f_41711:library_2escm"),(void*)f_41711},
{C_text("f_41729:library_2escm"),(void*)f_41729},
{C_text("f_41733:library_2escm"),(void*)f_41733},
{C_text("f_41741:library_2escm"),(void*)f_41741},
{C_text("f_41744:library_2escm"),(void*)f_41744},
{C_text("f_41757:library_2escm"),(void*)f_41757},
{C_text("f_41760:library_2escm"),(void*)f_41760},
{C_text("f_41772:library_2escm"),(void*)f_41772},
{C_text("f_41786:library_2escm"),(void*)f_41786},
{C_text("f_41789:library_2escm"),(void*)f_41789},
{C_text("f_41795:library_2escm"),(void*)f_41795},
{C_text("f_41798:library_2escm"),(void*)f_41798},
{C_text("f_41801:library_2escm"),(void*)f_41801},
{C_text("f_41808:library_2escm"),(void*)f_41808},
{C_text("f_41817:library_2escm"),(void*)f_41817},
{C_text("f_41833:library_2escm"),(void*)f_41833},
{C_text("f_41844:library_2escm"),(void*)f_41844},
{C_text("f_41855:library_2escm"),(void*)f_41855},
{C_text("f_41859:library_2escm"),(void*)f_41859},
{C_text("f_41908:library_2escm"),(void*)f_41908},
{C_text("f_41915:library_2escm"),(void*)f_41915},
{C_text("f_41928:library_2escm"),(void*)f_41928},
{C_text("f_41950:library_2escm"),(void*)f_41950},
{C_text("f_41974:library_2escm"),(void*)f_41974},
{C_text("f_41978:library_2escm"),(void*)f_41978},
{C_text("f_41995:library_2escm"),(void*)f_41995},
{C_text("f_42009:library_2escm"),(void*)f_42009},
{C_text("f_42017:library_2escm"),(void*)f_42017},
{C_text("f_42021:library_2escm"),(void*)f_42021},
{C_text("f_42036:library_2escm"),(void*)f_42036},
{C_text("f_42040:library_2escm"),(void*)f_42040},
{C_text("f_42054:library_2escm"),(void*)f_42054},
{C_text("f_42094:library_2escm"),(void*)f_42094},
{C_text("toplevel:library_2escm"),(void*)C_library_toplevel},
{NULL,NULL}};
#endif

static C_PTABLE_ENTRY *create_ptable(void){
#ifdef C_ENABLE_PTABLES
return ptable;
#else
return NULL;
#endif
}

/*
o|hiding unexported module binding: chicken.condition#prop-list->kind-prefixed-prop-list 
o|hiding unexported module binding: chicken.process-context#_getenv 
o|hiding unexported module binding: chicken.process-context#get-environment-entry 
o|hiding unexported module binding: chicken.gc#finalizer-tag 
o|hiding unexported module binding: chicken.gc#finalizer? 
o|hiding unexported module binding: chicken.platform#path-list-separator 
o|hiding unexported module binding: chicken.platform#chop-separator 
o|hiding unexported module binding: chicken.platform#->feature-id 
o|hiding unexported module binding: chicken.io#read-bytevector!/port 
o|hiding unexported module binding: chicken.io#read-string!/port 
o|hiding unexported module binding: chicken.io#read-string/port 
o|hiding unexported module binding: chicken.io#read-bytevector/port 
S|applied compiler syntax:
S|  scheme#for-each		11
S|  ##sys#map		1
S|  chicken.base#foldl		5
S|  ##sys#for-each		9
S|  scheme#map		18
o|eliminated procedure checks: 761 
o|folded constant expression: (scheme#char->integer (quote #\0)) 
o|folded constant expression: (scheme#char->integer (quote #\a)) 
o|folded constant expression: (scheme#char->integer (quote #\A)) 
o|folded constant expression: (scheme#integer->char (quote 11)) 
o|folded constant expression: (scheme#integer->char (quote 127)) 
o|folded constant expression: (scheme#integer->char (quote 27)) 
o|folded constant expression: (scheme#integer->char (quote 27)) 
o|folded constant expression: (scheme#integer->char (quote 7)) 
o|folded constant expression: (scheme#integer->char (quote 0)) 
o|folded constant expression: (scheme#integer->char (quote 0)) 
o|folded constant expression: (scheme#integer->char (quote 12)) 
o|folded constant expression: (scheme#integer->char (quote 8)) 
o|eliminated procedure checks: 1 
o|eliminated procedure checks: 1 
o|folded constant expression: (scheme#integer->char (quote 7)) 
o|folded constant expression: (scheme#integer->char (quote 11)) 
o|folded constant expression: (scheme#integer->char (quote 12)) 
o|eliminated procedure checks: 1 
o|folded constant expression: (scheme#expt (quote 1024) (quote 3)) 
o|folded constant expression: (scheme#expt (quote 1024) (quote 3)) 
o|folded constant expression: (scheme#expt (quote 1024) (quote 2)) 
o|folded constant expression: (scheme#expt (quote 1024) (quote 2)) 
o|specializations:
o|  1 (scheme#memq * list)
o|  2 (scheme#number->string fixnum)
o|  2 (scheme#string-append string string)
o|  1 (scheme#cdar (pair pair *))
o|  2 (scheme#cddr (pair * pair))
o|  1 (scheme#char>? char char)
o|  1 (scheme#char<? char char)
o|  2 (scheme#zero? integer)
o|  1 (chicken.base#char-foldcase char)
o|  14 (scheme#char=? char char)
o|  10 (scheme#string=? * *)
o|  2 (scheme#set-cdr! pair *)
o|  1 (scheme#set-car! pair *)
o|  16 (##sys#check-input-port * * *)
o|  29 (##sys#check-list (or pair list) *)
o|  1 (scheme#zero? number)
o|  2 (scheme#string-ci=? * *)
o|  15 (scheme#string-ref string fixnum)
o|  54 (scheme#cdr pair)
o|  7 (scheme#char<=? char char)
o|  6 (scheme#char>=? char char)
o|  4 (scheme#zero? *)
o|  78 (scheme#eqv? (or eof null fixnum char boolean symbol keyword) *)
o|  2 (scheme#> fixnum fixnum)
o|  1 (scheme#make-string fixnum char)
o|  6 (scheme#number->string * *)
o|  3 (scheme#integer? *)
o|  2 (scheme#even? *)
o|  5 (scheme#/ * *)
o|  1 (scheme#+ integer integer)
o|  5 (chicken.bitwise#integer-length *)
o|  2 (chicken.flonum#fp<= float float)
o|  7 (scheme#- *)
o|  1 (scheme#odd? *)
o|  1 (chicken.flonum#fp> float float)
o|  2 (scheme#angle cplxnum)
o|  5 (chicken.base#finite? *)
o|  13 (chicken.base#exact-integer? *)
o|  8 (scheme#abs *)
o|  17 (scheme#exact->inexact number)
o|  17 (scheme#string-length string)
o|  179 (scheme#eqv? * (or eof null fixnum char boolean symbol keyword))
o|  5 (##sys#debug-mode?)
o|  2 (scheme#- integer integer)
o|  15 (##sys#check-output-port * * *)
o|  5 (scheme#length list)
o|  13 (scheme#negative? *)
o|  6 (scheme#positive? *)
o|  1 (##sys#check-output-port * *)
o|  1 (##sys#check-input-port * *)
o|  56 (scheme#car pair)
(o e)|safe calls: 4345 
(o e)|dropped branches: 4 
(o e)|assignments to immediate values: 50 
o|dropping redundant toplevel assignment: scheme#make-list 
o|dropping redundant toplevel assignment: scheme#port? 
o|dropping redundant toplevel assignment: scheme#input-port-open? 
o|dropping redundant toplevel assignment: scheme#output-port-open? 
o|dropping redundant toplevel assignment: scheme#open-input-string 
o|dropping redundant toplevel assignment: scheme#open-output-string 
o|dropping redundant toplevel assignment: scheme#get-output-string 
o|dropping redundant toplevel assignment: scheme#open-input-bytevector 
o|dropping redundant toplevel assignment: scheme#open-output-bytevector 
o|dropping redundant toplevel assignment: scheme#get-output-bytevector 
o|dropping redundant toplevel assignment: chicken.base#warning 
o|dropping redundant toplevel assignment: chicken.base#notice 
o|dropping redundant toplevel assignment: chicken.base#enable-warnings 
o|dropping redundant toplevel assignment: ##sys#check-bytevector 
o|dropping redundant toplevel assignment: scheme#force 
o|dropping redundant toplevel assignment: scheme#append 
o|dropping redundant toplevel assignment: scheme#make-string 
o|dropping redundant toplevel assignment: scheme#string->list 
o|dropping redundant toplevel assignment: scheme#list->string 
o|dropping redundant toplevel assignment: scheme#string-fill! 
o|dropping redundant toplevel assignment: scheme#string-copy 
o|dropping redundant toplevel assignment: scheme#string-copy! 
o|dropping redundant toplevel assignment: scheme#substring 
o|dropping redundant toplevel assignment: scheme#string<? 
o|dropping redundant toplevel assignment: scheme#string>? 
o|dropping redundant toplevel assignment: scheme#string<=? 
o|dropping redundant toplevel assignment: scheme#string>=? 
o|dropping redundant toplevel assignment: scheme#string-ci<? 
o|dropping redundant toplevel assignment: scheme#string-ci>? 
o|dropping redundant toplevel assignment: scheme#string-ci<=? 
o|dropping redundant toplevel assignment: scheme#string-ci>=? 
o|dropping redundant toplevel assignment: scheme#string-append 
o|dropping redundant toplevel assignment: scheme#string 
o|dropping redundant toplevel assignment: chicken.base#chop 
o|dropping redundant toplevel assignment: scheme#make-rectangular 
o|dropping redundant toplevel assignment: scheme#make-polar 
o|dropping redundant toplevel assignment: scheme#real-part 
o|dropping redundant toplevel assignment: scheme#imag-part 
o|dropping redundant toplevel assignment: scheme#angle 
o|dropping redundant toplevel assignment: scheme#magnitude 
o|dropping redundant toplevel assignment: scheme#numerator 
o|dropping redundant toplevel assignment: scheme#denominator 
o|dropping redundant toplevel assignment: scheme#inexact->exact 
o|dropping redundant toplevel assignment: scheme#/ 
o|dropping redundant toplevel assignment: scheme#floor 
o|dropping redundant toplevel assignment: scheme#ceiling 
o|dropping redundant toplevel assignment: scheme#truncate 
o|dropping redundant toplevel assignment: scheme#round 
o|dropping redundant toplevel assignment: scheme#rationalize 
o|dropping redundant toplevel assignment: scheme#max 
o|dropping redundant toplevel assignment: scheme#min 
o|dropping redundant toplevel assignment: scheme#exp 
o|dropping redundant toplevel assignment: scheme#log 
o|dropping redundant toplevel assignment: scheme#sin 
o|dropping redundant toplevel assignment: scheme#cos 
o|dropping redundant toplevel assignment: scheme#tan 
o|dropping redundant toplevel assignment: scheme#asin 
o|dropping redundant toplevel assignment: scheme#acos 
o|dropping redundant toplevel assignment: scheme#atan 
o|dropping redundant toplevel assignment: scheme#sqrt 
o|dropping redundant toplevel assignment: scheme#truncate/ 
o|dropping redundant toplevel assignment: scheme#floor/ 
o|dropping redundant toplevel assignment: scheme#floor-remainder 
o|dropping redundant toplevel assignment: scheme#floor-quotient 
o|dropping redundant toplevel assignment: chicken.base#exact-integer-nth-root 
o|dropping redundant toplevel assignment: scheme#expt 
o|dropping redundant toplevel assignment: scheme#gcd 
o|dropping redundant toplevel assignment: scheme#lcm 
o|dropping redundant toplevel assignment: scheme#string->number 
o|dropping redundant toplevel assignment: ##sys#number->string 
o|dropping redundant toplevel assignment: chicken.base#equal=? 
o|dropping redundant toplevel assignment: scheme#symbol->string 
o|dropping redundant toplevel assignment: scheme#string->symbol 
o|dropping redundant toplevel assignment: chicken.base#string->uninterned-symbol 
o|dropping redundant toplevel assignment: chicken.base#gensym 
o|dropping redundant toplevel assignment: chicken.base#symbol-append 
o|dropping redundant toplevel assignment: ##sys#update-errno 
o|dropping redundant toplevel assignment: ##sys#errno 
o|safe globals: (chicken.keyword#keyword->string chicken.keyword#string->keyword chicken.keyword#keyword? chicken.base#symbol-append chicken.base#gensym chicken.base#string->uninterned-symbol scheme#string->symbol scheme#symbol->string ##sys#string->symbol ##sys#symbol->string ##sys#symbol->string/shared ##sys#string->symbol-name ##sys#interned-symbol? ##sys#make-symbol ##sys#intern-keyword ##sys#intern-symbol ##sys#snafu chicken.base#equal=? ##sys#number->string ##sys#integer->string ##sys#flonum->string ##sys#fixnum->string ##sys#string->number scheme#string->number ##sys#string->compnum round-quotient ldexp mantexp->dbl ##sys#extended-number->string ##sys#integer->string/recursive scheme#lcm ##sys#lcm scheme#gcd ##sys#gcd ##sys#internal-gcd scheme#expt ##sys#integer-power ##sys#exact-integer-nth-root/loc chicken.base#exact-integer-nth-root scheme#square scheme#floor-quotient scheme#floor-remainder scheme#floor/ scheme#truncate/ scheme#sqrt ##sys#sqrt/loc scheme#exact-integer-sqrt ##sys#exact-integer-sqrt scheme#atan scheme#acos scheme#asin scheme#tan scheme#cos scheme#sin scheme#log ##sys#log-1 scheme#exp scheme#min scheme#max scheme#rationalize find-ratio find-ratio-between scheme#round scheme#truncate scheme#ceiling scheme#floor ##sys#/-2 scheme#/ chicken.bitwise#arithmetic-shift chicken.bitwise#integer-length chicken.bitwise#bit->boolean chicken.bitwise#bitwise-not chicken.bitwise#bitwise-xor chicken.bitwise#bitwise-ior chicken.bitwise#bitwise-and scheme#inexact->exact flonum->ratnum ##sys#extended-signum scheme#denominator scheme#numerator ratnum scheme#magnitude scheme#angle scheme#imag-part scheme#real-part scheme#make-polar scheme#make-rectangular make-complex chicken.flonum#flonum-print-precision chicken.flonum#fpinteger? chicken.flonum#fpabs chicken.flonum#fpsqrt chicken.flonum#fplog chicken.flonum#fpexpt chicken.flonum#fpexp chicken.flonum#fpatanh chicken.flonum#fpacosh chicken.flonum#fpasinh chicken.flonum#fptanh chicken.flonum#fpcosh chicken.flonum#fpsinh chicken.flonum#fpatan2 chicken.flonum#fpatan chicken.flonum#fpacos chicken.flonum#fpasin chicken.flonum#fptan chicken.flonum#fpcos chicken.flonum#fpsin chicken.flonum#fpceiling chicken.flonum#fpround chicken.flonum#fptruncate chicken.flonum#fpfloor chicken.flonum#fpmin chicken.flonum#fpmax chicken.flonum#fpneg chicken.flonum#fp<= chicken.flonum#fp>= chicken.flonum#fp< chicken.flonum#fp> chicken.flonum#fp= chicken.flonum#fp/? chicken.flonum#fpgcd chicken.flonum#fp*+ chicken.flonum#fp/ chicken.flonum#fp* chicken.flonum#fp- chicken.flonum#fp+ chicken.flonum#flonum-minimum-decimal-exponent chicken.flonum#flonum-maximum-decimal-exponent chicken.flonum#flonum-minimum-exponent chicken.flonum#flonum-maximum-exponent chicken.flonum#flonum-decimal-precision chicken.flonum#flonum-precision chicken.flonum#flonum-epsilon chicken.flonum#flonum-radix chicken.flonum#minimum-flonum chicken.flonum#maximum-flonum chicken.base#chop ##sys#char->utf8-string scheme#string scheme#string-append ##sys#string-append scheme#string-ci>=? scheme#string-ci<=? scheme#string-ci>? scheme#string-ci<? scheme#string>=? scheme#string<=? scheme#string>? scheme#string<? scheme#substring ##sys#substring scheme#string-copy! scheme#string-copy scheme#string-fill! ##sys#reverse-list->string ##sys#list->string scheme#list->string ##sys#string->list scheme#string->list scheme#make-string ##sys#read-char/encoding ##sys#decode-char ##sys#encode-char ##sys#decode-buffer ##sys#encode-buffer ##sys#buffer->string/encoding ##sys#register-encoding ##sys#encoding-hook ##sys#binary-scanner ##sys#binary-encoder ##sys#binary-decoder ##sys#latin-scanner ##sys#latin-encoder ##sys#latin-decoder ##sys#utf-scanner ##sys#utf-encoder ##sys#utf-decoder ##sys#buffer->string ##sys#make-string ##sys#make-bytevector ##sys#fast-reverse scheme#append ##sys#error-bad-base ##sys#error-bad-real ##sys#error-bad-inexact ##sys#error-bad-exact-uinteger ##sys#error-bad-exact-integer ##sys#error-bad-integer ##sys#error-bad-number ##sys#error-not-a-proper-list ##sys#set-dlopen-flags! ##sys#dload scheme#force ##sys#check-closure ##sys#check-special ##sys#check-range/including ##sys#check-range ##sys#check-real ##sys#check-exact-uinteger ##sys#check-exact-integer ##sys#check-integer ##sys#check-locative ##sys#check-boolean ##sys#check-char ##sys#check-vector ##sys#check-keyword ##sys#check-symbol ##sys#check-inexact ##sys#check-exact ##sys#check-bytevector ##sys#check-fixnum ##sys#check-number ##sys#check-string ##sys#check-list ##sys#check-pair ##sys#check-blob ##sys#check-structure chicken.time#cpu-time chicken.time#current-seconds chicken.time#current-process-milliseconds ##sys#block-set! ##sys#copy-closure ##sys#apply-values ##sys#block-ref ##sys#become! ##sys#halt ##sys#undefined-value ##sys#void ##sys#byte ##sys#message ##sys#immediate? ##sys#stop-timer ##sys#start-timer ##sys#memory-info ##sys#symbol-table-info ##sys#ensure-heap-reserve ##sys#make-structure ##sys#allocate-bytevector ##sys#allocate-vector ##sys#setislot ##sys#setslot ##sys#gc ##sys#error/errno ##sys#notice ##sys#warn ##sys#error chicken.base#enable-warnings chicken.base#notice chicken.base#warning ##sys#notices-enabled ##sys#warnings-enabled ##sys#debug-mode? chicken.fixnum#fx/? chicken.fixnum#fx*? chicken.fixnum#fx-? chicken.fixnum#fx+? chicken.fixnum#fxrem chicken.fixnum#fxmod chicken.fixnum#fxgcd chicken.fixnum#fx/ chicken.fixnum#fxlen chicken.fixnum#fxeven? chicken.fixnum#fxodd? chicken.fixnum#fxshr chicken.fixnum#fxshl chicken.fixnum#fxnot chicken.fixnum#fxxor chicken.fixnum#fxior chicken.fixnum#fxand chicken.fixnum#fxneg chicken.fixnum#fxmax chicken.fixnum#fxmin chicken.fixnum#fx<= chicken.fixnum#fx>= chicken.fixnum#fx< chicken.fixnum#fx> chicken.fixnum#fx= chicken.fixnum#fx* chicken.fixnum#fx- chicken.fixnum#fx+ chicken.fixnum#fixnum-precision chicken.fixnum#fixnum-bits chicken.fixnum#most-negative-fixnum chicken.fixnum#most-positive-fixnum maximal-string-length scheme#get-output-bytevector scheme#open-output-bytevector scheme#open-input-bytevector scheme#get-output-string scheme#open-output-string scheme#open-input-string chicken.base#rassoc chicken.base#alist-ref chicken.base#alist-update chicken.base#alist-update! chicken.base#string-foldcase chicken.base#char-foldcase chicken.base#compress chicken.base#join chicken.base#flatten chicken.base#butlast chicken.base#intersperse chicken.base#tail? chicken.base#atom? chicken.base#weak-pair? chicken.base#weak-cons chicken.base#bwp-object? chicken.base#each chicken.base#list-of? chicken.base#o chicken.base#compose chicken.base#complement chicken.base#flip chicken.base#constantly chicken.base#disjoin chicken.base#conjoin chicken.base#identity chicken.base#symbol-escape chicken.base#parentheses-synonyms chicken.base#keyword-style chicken.base#case-sensitive chicken.base#emergency-exit chicken.base#exit chicken.base#on-exit chicken.base#cleanup-tasks chicken.base#exit-handler chicken.base#implicit-exit-handler chicken.base#foldr chicken.base#foldl chicken.base#make-promise ##sys#make-promise chicken.base#promise? chicken.base#flush-output chicken.base#port-closed? chicken.base#vector-resize chicken.base#subvector chicken.base#set-record-printer! chicken.base#record-printer chicken.base#setter chicken.base#procedure-information chicken.base#getter-with-setter chicken.base#char-name chicken.base#sleep chicken.base#void chicken.base#error chicken.base#current-error-port chicken.base#sub1 chicken.base#add1 chicken.base#print* chicken.base#print chicken.base#print-call-chain chicken.base#get-call-chain chicken.base#signum chicken.base#nan? chicken.base#infinite? chicken.base#finite? chicken.base#quotient&modulo chicken.base#quotient&remainder chicken.base#exact-integer-sqrt chicken.base#exact-integer? chicken.base#cplxnum? chicken.base#ratnum? chicken.base#bignum? chicken.base#flonum? chicken.base#fixnum? scheme#dynamic-wind scheme#map scheme#for-each scheme#load scheme#null-environment scheme#scheme-report-environment scheme#interaction-environment scheme#eval scheme#display scheme#write scheme#newline scheme#write-char scheme#read scheme#peek-char scheme#read-char scheme#char-ready? scheme#eof-object? scheme#with-output-to-file scheme#with-input-from-file scheme#call-with-output-file scheme#call-with-input-file scheme#close-output-port scheme#close-input-port scheme#open-output-file scheme#open-input-file scheme#current-output-port scheme#current-input-port scheme#output-port-open? scheme#input-port-open? scheme#port? scheme#textual-port? scheme#binary-port? scheme#output-port? scheme#input-port? scheme#call/cc scheme#call-with-current-continuation scheme#call-with-values scheme#values scheme#apply scheme#procedure? scheme.char#digit-value scheme#char-alphabetic? scheme#char-whitespace? scheme#char-numeric? scheme#char-lower-case? scheme#char-upper-case? scheme#char-ci<=? scheme#char-ci>=? scheme#char-ci<? scheme#char-ci>? scheme#char-ci=? scheme#char-downcase scheme#char-upcase scheme#char<=? scheme#char>=? scheme#char<? scheme#char>? scheme#char=? scheme#integer->char scheme#char->integer scheme#char? scheme#vector-fill! scheme#vector scheme#vector->list scheme#list->vector scheme#make-vector scheme#vector-set! scheme#vector-ref scheme#vector-length scheme#vector? scheme#symbol? scheme#number->string scheme#negative? scheme#positive? scheme#zero? scheme#inexact? scheme#exact? scheme#integer? scheme#rational? scheme#real? scheme#complex? scheme#number? scheme#<= scheme#>= scheme#< scheme#> scheme#= scheme#odd? scheme#even? scheme#modulo scheme#remainder scheme#quotient scheme#* scheme#- scheme#+ scheme#abs scheme#exact->inexact scheme#make-parameter scheme#inexact scheme#exact scheme#vector->string scheme#string->vector scheme#list-copy scheme#eof-object scheme#write-string scheme#list-set! scheme#make-list scheme#vector-for-each scheme#string-for-each scheme#vector-map scheme#string-map scheme#peek-u8 scheme#close-port scheme#call-with-port scheme#features scheme#string-ci=? scheme#string=? scheme#string-set! scheme#string-ref scheme#string-length scheme#string? scheme#list? scheme#assoc scheme#assv scheme#assq scheme#member scheme#memv scheme#memq scheme#reverse scheme#list-ref scheme#list-tail scheme#length scheme#list scheme#null? scheme#cdddar scheme#cddadr scheme#cddaar scheme#cdaddr scheme#cdadar scheme#cdaadr scheme#cdaaar scheme#caddar scheme#cadadr scheme#cadaar scheme#caaddr scheme#caadar scheme#caaadr scheme#caaaar scheme#cdddr scheme#cddar scheme#cdadr scheme#cdaar scheme#cadar scheme#caadr scheme#caaar scheme#cddr scheme#cdar scheme#caar scheme#cddddr scheme#cadddr scheme#caddr scheme#cadr scheme#set-cdr! scheme#set-car! scheme#cdr scheme#car scheme#cons scheme#pair? scheme#symbol=? scheme#boolean=? scheme#equal? scheme#eqv? scheme#eq? scheme#boolean? scheme#not c9526) 
o|inlining procedure: k11473 
o|inlining procedure: k11473 
o|inlining procedure: k11493 
o|inlining procedure: k11493 
o|inlining procedure: k11518 
o|inlining procedure: k11518 
o|inlining procedure: k11538 
o|inlining procedure: k11538 
o|inlining procedure: k11850 
o|inlining procedure: k11850 
o|inlining procedure: k11892 
o|inlining procedure: k11901 
o|inlining procedure: k11901 
o|inlining procedure: k11892 
o|inlining procedure: k11942 
o|inlining procedure: k11951 
o|inlining procedure: k11951 
o|inlining procedure: k11942 
o|inlining procedure: k12010 
o|inlining procedure: k12010 
o|inlining procedure: k12030 
o|inlining procedure: k12030 
o|inlining procedure: k12043 
o|inlining procedure: k12043 
o|inlining procedure: k12063 
o|inlining procedure: k12063 
o|inlining procedure: k12195 
o|inlining procedure: k12195 
o|inlining procedure: k12215 
o|inlining procedure: k12215 
o|inlining procedure: k12234 
o|inlining procedure: k12234 
o|inlining procedure: k12254 
o|inlining procedure: k12254 
o|inlining procedure: k12273 
o|inlining procedure: k12273 
o|inlining procedure: k12293 
o|inlining procedure: k12293 
o|inlining procedure: k12312 
o|inlining procedure: k12312 
o|inlining procedure: k12332 
o|inlining procedure: k12332 
o|inlining procedure: k12351 
o|inlining procedure: k12351 
o|inlining procedure: k12371 
o|inlining procedure: k12371 
o|inlining procedure: k12427 
o|inlining procedure: k12427 
o|inlining procedure: k12448 
o|inlining procedure: k12448 
o|inlining procedure: k12454 
o|inlining procedure: k12454 
o|inlining procedure: k12460 
o|inlining procedure: k12460 
o|inlining procedure: k12476 
o|inlining procedure: k12476 
o|inlining procedure: k12492 
o|inlining procedure: k12492 
o|substituted constant variable: a12499 
o|substituted constant variable: a12504 
o|inlining procedure: k12597 
o|inlining procedure: k12597 
o|inlining procedure: k12659 
o|inlining procedure: k12659 
o|inlining procedure: k12700 
o|inlining procedure: k12700 
o|inlining procedure: k12724 
o|inlining procedure: k12724 
o|inlining procedure: k12761 
o|inlining procedure: k12761 
o|inlining procedure: k12850 
o|inlining procedure: k12850 
o|inlining procedure: k12880 
o|inlining procedure: k12880 
o|inlining procedure: k12909 
o|inlining procedure: k12909 
o|inlining procedure: k12953 
o|inlining procedure: k12953 
o|inlining procedure: k12974 
o|propagated global variable: r1297542192 scheme#values 
o|inlining procedure: k12974 
o|inlining procedure: k12986 
o|propagated global variable: r1298742194 chicken.base#identity 
o|inlining procedure: k12986 
o|inlining procedure: k13004 
o|inlining procedure: k13004 
o|inlining procedure: k13033 
o|inlining procedure: k13033 
o|inlining procedure: k13045 
o|inlining procedure: k13045 
o|inlining procedure: k13069 
o|inlining procedure: k13069 
o|inlining procedure: k13103 
o|inlining procedure: k13103 
o|inlining procedure: k13146 
o|inlining procedure: k13146 
o|inlining procedure: k13171 
o|inlining procedure: k13171 
o|inlining procedure: k13210 
o|inlining procedure: k13210 
o|inlining procedure: k13236 
o|inlining procedure: k13236 
o|inlining procedure: k13283 
o|inlining procedure: k13283 
o|inlining procedure: k13304 
o|inlining procedure: k13304 
o|inlining procedure: k13337 
o|inlining procedure: k13337 
o|inlining procedure: k13352 
o|inlining procedure: k13352 
o|inlining procedure: k13443 
o|inlining procedure: k13443 
o|inlining procedure: k13459 
o|propagated global variable: r1346042224 scheme#assv 
o|inlining procedure: k13459 
o|inlining procedure: k13479 
o|inlining procedure: k13479 
o|inlining procedure: k13529 
o|inlining procedure: k13529 
o|inlining procedure: k13554 
o|inlining procedure: k13554 
o|inlining procedure: k13642 
o|inlining procedure: k13642 
o|inlining procedure: k13651 
o|propagated global variable: r1365242234 scheme#assv 
o|inlining procedure: k13651 
o|inlining procedure: k13671 
o|inlining procedure: k13671 
o|inlining procedure: k13689 
o|inlining procedure: k13689 
o|inlining procedure: k13748 
o|inlining procedure: k13748 
o|substituted constant variable: a13832 
o|substituted constant variable: a13833 
o|inlining procedure: k13834 
o|inlining procedure: k13834 
o|inlining procedure: k13887 
o|inlining procedure: k13887 
o|inlining procedure: k13900 
o|inlining procedure: k13900 
o|inlining procedure: k14014 
o|inlining procedure: k14014 
o|substituted constant variable: a14044 
o|inlining procedure: k14144 
o|inlining procedure: k14144 
o|inlining procedure: k14153 
o|inlining procedure: k14153 
o|inlining procedure: k14165 
o|inlining procedure: k14165 
o|propagated global variable: r1416642255 ##sys#warnings-enabled 
o|inlining procedure: k14179 
o|inlining procedure: k14179 
o|inlining procedure: k14282 
o|inlining procedure: k14282 
o|inlining procedure: k14315 
o|inlining procedure: k14315 
o|inlining procedure: k14326 
o|inlining procedure: k14326 
o|inlining procedure: k14337 
o|inlining procedure: k14337 
o|inlining procedure: k14348 
o|inlining procedure: k14348 
o|inlining procedure: k14359 
o|inlining procedure: k14359 
o|inlining procedure: k14370 
o|inlining procedure: k14370 
o|inlining procedure: k14381 
o|inlining procedure: k14381 
o|inlining procedure: k14392 
o|inlining procedure: k14392 
o|inlining procedure: k14403 
o|inlining procedure: k14403 
o|inlining procedure: k14414 
o|inlining procedure: k14414 
o|inlining procedure: k14425 
o|inlining procedure: k14425 
o|inlining procedure: k14436 
o|inlining procedure: k14436 
o|inlining procedure: k14447 
o|inlining procedure: k14447 
o|inlining procedure: k14458 
o|inlining procedure: k14458 
o|inlining procedure: k14469 
o|inlining procedure: k14469 
o|inlining procedure: k14480 
o|inlining procedure: k14480 
o|inlining procedure: k14491 
o|inlining procedure: k14491 
o|inlining procedure: k14498 
o|inlining procedure: k14498 
o|inlining procedure: k14508 
o|inlining procedure: k14508 
o|inlining procedure: k14515 
o|inlining procedure: k14515 
o|inlining procedure: k14525 
o|inlining procedure: k14538 
o|inlining procedure: k14538 
o|inlining procedure: k14525 
o|inlining procedure: k14549 
o|inlining procedure: k14549 
o|inlining procedure: k14556 
o|inlining procedure: k14556 
o|inlining procedure: k14566 
o|inlining procedure: k14566 
o|inlining procedure: k14577 
o|inlining procedure: k14577 
o|inlining procedure: k14588 
o|inlining procedure: k14588 
o|inlining procedure: k14598 
o|inlining procedure: k14598 
o|inlining procedure: k14608 
o|inlining procedure: k14608 
o|inlining procedure: k14619 
o|inlining procedure: k14634 
o|inlining procedure: k14634 
o|inlining procedure: k14652 
o|inlining procedure: k14673 
o|inlining procedure: k14673 
o|inlining procedure: k14701 
o|inlining procedure: k14701 
o|inlining procedure: k14652 
o|inlining procedure: k14619 
o|inlining procedure: k14875 
o|inlining procedure: k14875 
o|inlining procedure: k14887 
o|inlining procedure: k14887 
o|inlining procedure: k14906 
o|inlining procedure: k14906 
o|inlining procedure: k14960 
o|inlining procedure: k14960 
o|inlining procedure: k14984 
o|inlining procedure: k14984 
o|inlining procedure: k15044 
o|inlining procedure: k15044 
o|inlining procedure: k15112 
o|inlining procedure: k15112 
o|inlining procedure: k15130 
o|inlining procedure: k15130 
o|substituted constant variable: a15143 
o|substituted constant variable: a15145 
o|substituted constant variable: a15147 
o|inlining procedure: k15154 
o|inlining procedure: k15154 
o|inlining procedure: k15169 
o|inlining procedure: k15169 
o|inlining procedure: k15269 
o|inlining procedure: k15269 
o|inlining procedure: k15322 
o|inlining procedure: k15322 
o|inlining procedure: k15377 
o|inlining procedure: k15377 
o|inlining procedure: k15434 
o|inlining procedure: k15434 
o|inlining procedure: k15452 
o|inlining procedure: k15452 
o|inlining procedure: k15505 
o|inlining procedure: k15505 
o|inlining procedure: k15581 
o|inlining procedure: k15581 
o|inlining procedure: k15593 
o|inlining procedure: k15593 
o|inlining procedure: k15630 
o|inlining procedure: k15630 
o|inlining procedure: k15770 
o|inlining procedure: k15790 
o|inlining procedure: k15790 
o|inlining procedure: k15770 
o|inlining procedure: k15824 
o|inlining procedure: k15824 
o|inlining procedure: k15857 
o|inlining procedure: k15857 
o|inlining procedure: k15916 
o|inlining procedure: k15916 
o|inlining procedure: k15932 
o|inlining procedure: k15932 
o|inlining procedure: k15973 
o|inlining procedure: k15973 
o|inlining procedure: k15997 
o|inlining procedure: k15997 
o|inlining procedure: k16029 
o|inlining procedure: k16029 
o|inlining procedure: k16053 
o|inlining procedure: k16053 
o|inlining procedure: k16074 
o|inlining procedure: k16074 
o|inlining procedure: k16095 
o|inlining procedure: k16095 
o|inlining procedure: k16131 
o|inlining procedure: k16131 
o|inlining procedure: k16155 
o|inlining procedure: k16155 
o|inlining procedure: k16179 
o|inlining procedure: k16179 
o|inlining procedure: k16203 
o|inlining procedure: k16203 
o|inlining procedure: k16224 
o|inlining procedure: k16224 
o|inlining procedure: k16245 
o|inlining procedure: k16245 
o|inlining procedure: k16312 
o|inlining procedure: k16312 
o|inlining procedure: k16391 
o|inlining procedure: k16391 
o|inlining procedure: k16412 
o|inlining procedure: k16412 
o|contracted procedure: "(library.scm:2113) g23462347" 
o|inlining procedure: k16473 
o|inlining procedure: k16473 
o|contracted procedure: "(library.scm:2117) g23572358" 
o|inlining procedure: k16497 
o|inlining procedure: k16497 
o|contracted procedure: "(library.scm:2121) g23682369" 
o|inlining procedure: k16521 
o|inlining procedure: k16521 
o|contracted procedure: "(library.scm:2125) g23792380" 
o|inlining procedure: k16545 
o|inlining procedure: k16545 
o|inlining procedure: k16567 
o|inlining procedure: k16567 
o|inlining procedure: k16580 
o|inlining procedure: k16580 
o|contracted procedure: "(library.scm:2135) g23982399" 
o|inlining procedure: k16594 
o|inlining procedure: k16594 
o|contracted procedure: "(library.scm:2139) g24092410" 
o|inlining procedure: k16618 
o|inlining procedure: k16618 
o|contracted procedure: "(library.scm:2143) g24202421" 
o|inlining procedure: k16642 
o|inlining procedure: k16642 
o|contracted procedure: "(library.scm:2147) g24312432" 
o|inlining procedure: k16666 
o|inlining procedure: k16666 
o|contracted procedure: "(library.scm:2151) g24422443" 
o|inlining procedure: k16690 
o|inlining procedure: k16690 
o|contracted procedure: "(library.scm:2155) g24532454" 
o|inlining procedure: k16714 
o|inlining procedure: k16714 
o|contracted procedure: "(library.scm:2159) g24642465" 
o|inlining procedure: k16738 
o|inlining procedure: k16738 
o|contracted procedure: "(library.scm:2163) g24742475" 
o|inlining procedure: k16762 
o|inlining procedure: k16762 
o|contracted procedure: "(library.scm:2167) g24832484" 
o|inlining procedure: k16780 
o|inlining procedure: k16780 
o|contracted procedure: "(library.scm:2171) g24942495" 
o|inlining procedure: k16804 
o|inlining procedure: k16804 
o|contracted procedure: "(library.scm:2175) g25042505" 
o|inlining procedure: k16828 
o|inlining procedure: k16828 
o|contracted procedure: "(library.scm:2179) g25122513" 
o|inlining procedure: k16846 
o|inlining procedure: k16846 
o|contracted procedure: "(library.scm:2183) g25202521" 
o|inlining procedure: k16864 
o|inlining procedure: k16864 
o|contracted procedure: "(library.scm:2187) g25282529" 
o|inlining procedure: k16882 
o|inlining procedure: k16882 
o|contracted procedure: "(library.scm:2191) g25362537" 
o|inlining procedure: k16900 
o|inlining procedure: k16900 
o|contracted procedure: "(library.scm:2195) g25442545" 
o|inlining procedure: k16918 
o|inlining procedure: k16918 
o|contracted procedure: "(library.scm:2199) g25522553" 
o|inlining procedure: k16936 
o|inlining procedure: k16936 
o|contracted procedure: "(library.scm:2203) g25602561" 
o|inlining procedure: k16954 
o|inlining procedure: k16954 
o|contracted procedure: "(library.scm:2207) g25682569" 
o|inlining procedure: k16972 
o|inlining procedure: k16972 
o|contracted procedure: "(library.scm:2211) g25762577" 
o|inlining procedure: k16990 
o|inlining procedure: k16990 
o|contracted procedure: "(library.scm:2215) g25852586" 
o|inlining procedure: k17008 
o|inlining procedure: k17008 
o|contracted procedure: "(library.scm:2219) g25952596" 
o|inlining procedure: k17032 
o|inlining procedure: k17032 
o|contracted procedure: "(library.scm:2223) g26032604" 
o|inlining procedure: k17050 
o|inlining procedure: k17050 
o|contracted procedure: "(library.scm:2227) g26112612" 
o|inlining procedure: k17068 
o|inlining procedure: k17068 
o|contracted procedure: "(library.scm:2231) g26192620" 
o|inlining procedure: k17086 
o|inlining procedure: k17086 
o|contracted procedure: "(library.scm:2235) g26272628" 
o|inlining procedure: k17104 
o|inlining procedure: k17104 
o|contracted procedure: "(library.scm:2239) g26352636" 
o|inlining procedure: k17122 
o|inlining procedure: k17122 
o|contracted procedure: "(library.scm:2243) g26432644" 
o|inlining procedure: k17140 
o|inlining procedure: k17140 
o|contracted procedure: "(library.scm:2247) g26522653" 
o|inlining procedure: k17158 
o|inlining procedure: k17158 
o|contracted procedure: "(library.scm:2251) g26622663" 
o|inlining procedure: k17182 
o|inlining procedure: k17182 
o|contracted procedure: "(library.scm:2255) g26702671" 
o|inlining procedure: k17200 
o|inlining procedure: k17200 
o|contracted procedure: "(library.scm:2259) g26782679" 
o|inlining procedure: k17218 
o|inlining procedure: k17218 
o|contracted procedure: "(library.scm:2263) g26862687" 
o|inlining procedure: k17236 
o|inlining procedure: k17236 
o|inlining procedure: k17255 
o|inlining procedure: k17255 
o|inlining procedure: k17270 
o|inlining procedure: k17270 
o|inlining procedure: k17297 
o|inlining procedure: k17297 
o|inlining procedure: k17341 
o|contracted procedure: "(library.scm:2307) g27812782" 
o|inlining procedure: k17341 
o|inlining procedure: k17364 
o|contracted procedure: "(library.scm:2313) g27892790" 
o|inlining procedure: k17364 
o|inlining procedure: k17378 
o|inlining procedure: k17378 
o|inlining procedure: k17406 
o|contracted procedure: "(library.scm:2329) g28042805" 
o|contracted procedure: "(library.scm:2328) g28012802" 
o|inlining procedure: k17406 
o|inlining procedure: k17450 
o|inlining procedure: k17450 
o|contracted procedure: "(library.scm:2343) g28142815" 
o|inlining procedure: k17467 
o|contracted procedure: "(library.scm:2345) g28172818" 
o|contracted procedure: "(library.scm:2345) g28242825" 
o|contracted procedure: "(library.scm:2345) g28212822" 
o|inlining procedure: k17467 
o|contracted procedure: "(library.scm:2346) g28272828" 
o|inlining procedure: k17496 
o|inlining procedure: k17496 
o|inlining procedure: k17503 
o|inlining procedure: k17503 
o|inlining procedure: k17525 
o|contracted procedure: "(library.scm:2355) g28402841" 
o|inlining procedure: k17525 
o|inlining procedure: k17542 
o|inlining procedure: k17542 
o|inlining procedure: k17549 
o|inlining procedure: k17549 
o|inlining procedure: k17571 
o|contracted procedure: "(library.scm:2367) g28522853" 
o|inlining procedure: k17571 
o|inlining procedure: k17588 
o|contracted procedure: "(library.scm:2374) g28612862" 
o|inlining procedure: k17588 
o|inlining procedure: k17712 
o|inlining procedure: k17712 
o|inlining procedure: k17721 
o|contracted procedure: "(library.scm:2407) g28932894" 
o|inlining procedure: k17721 
o|contracted procedure: "(library.scm:2408) flonum->ratnum" 
o|inlining procedure: k17652 
o|contracted procedure: "(library.scm:2392) g28782879" 
o|inlining procedure: k17652 
o|contracted procedure: "(library.scm:2389) float-fraction-length2866" 
o|inlining procedure: k17629 
o|inlining procedure: k17629 
o|inlining procedure: k17680 
o|inlining procedure: k17680 
o|substituted constant variable: a17708 
o|inlining procedure: k17738 
o|contracted procedure: "(library.scm:2412) g28992900" 
o|contracted procedure: "(library.scm:2411) g28962897" 
o|inlining procedure: k17738 
o|inlining procedure: k17788 
o|inlining procedure: k17788 
o|inlining procedure: k17811 
o|inlining procedure: k17811 
o|inlining procedure: k17842 
o|contracted procedure: "(library.scm:2461) g29552956" 
o|contracted procedure: "(library.scm:2461) g29512952" 
o|contracted procedure: "(library.scm:2460) g29472948" 
o|inlining procedure: k17842 
o|inlining procedure: k17933 
o|inlining procedure: k17933 
o|inlining procedure: k17956 
o|contracted procedure: "(library.scm:2481) g29942995" 
o|contracted procedure: "(library.scm:2480) g29892990" 
o|contracted procedure: "(library.scm:2479) g29852986" 
o|contracted procedure: "(library.scm:2479) g29812982" 
o|contracted procedure: "(library.scm:2478) g29772978" 
o|contracted procedure: "(library.scm:2478) g29732974" 
o|inlining procedure: k17956 
o|contracted procedure: "(library.scm:2490) g30053006" 
o|contracted procedure: "(library.scm:2487) g29993000" 
o|inlining procedure: k18052 
o|contracted procedure: "(library.scm:2500) g30143015" 
o|contracted procedure: "(library.scm:2498) g30093010" 
o|inlining procedure: k18052 
o|inlining procedure: k18122 
o|inlining procedure: k18122 
o|inlining procedure: k18132 
o|contracted procedure: "(library.scm:2514) g30293030" 
o|contracted procedure: "(library.scm:2513) g30253026" 
o|inlining procedure: k18132 
o|inlining procedure: k18167 
o|inlining procedure: k18167 
o|inlining procedure: k18177 
o|contracted procedure: "(library.scm:2524) g30423043" 
o|contracted procedure: "(library.scm:2523) g30383039" 
o|inlining procedure: k18177 
o|inlining procedure: k18212 
o|inlining procedure: k18212 
o|inlining procedure: k18222 
o|contracted procedure: "(library.scm:2534) g30533054" 
o|contracted procedure: "(library.scm:2533) g30503051" 
o|inlining procedure: k18222 
o|inlining procedure: k18249 
o|inlining procedure: k18249 
o|inlining procedure: k18256 
o|contracted procedure: "(library.scm:2543) g30623063" 
o|inlining procedure: k18256 
o|inlining procedure: k18302 
o|inlining procedure: k18302 
o|inlining procedure: k18374 
o|inlining procedure: k18374 
o|inlining procedure: k18392 
o|inlining procedure: k18392 
o|inlining procedure: k18446 
o|inlining procedure: k18446 
o|contracted procedure: "(library.scm:2570) find-ratio" 
o|inlining procedure: k18478 
o|inlining procedure: k18478 
o|inlining procedure: k18522 
o|inlining procedure: k18522 
o|inlining procedure: k18559 
o|contracted procedure: "(library.scm:2603) g31253126" 
o|contracted procedure: "(library.scm:2602) g31213122" 
o|inlining procedure: k18559 
o|inlining procedure: k18601 
o|inlining procedure: k18601 
o|inlining procedure: k18653 
o|inlining procedure: k18653 
o|inlining procedure: k18682 
o|inlining procedure: k18682 
o|inlining procedure: k18716 
o|inlining procedure: k18716 
o|inlining procedure: k18750 
o|inlining procedure: k18750 
o|inlining procedure: k18775 
o|inlining procedure: k18775 
o|inlining procedure: k18814 
o|inlining procedure: k18814 
o|inlining procedure: k18823 
o|substituted constant variable: a18830 
o|inlining procedure: k18823 
o|inlining procedure: k18837 
o|inlining procedure: k18837 
o|inlining procedure: k18856 
o|inlining procedure: k18856 
o|inlining procedure: k18865 
o|substituted constant variable: a18872 
o|inlining procedure: k18865 
o|inlining procedure: k18882 
o|inlining procedure: k18882 
o|inlining procedure: k18940 
o|inlining procedure: k18958 
o|inlining procedure: k18958 
o|inlining procedure: k18976 
o|inlining procedure: k18976 
o|substituted constant variable: a18989 
o|substituted constant variable: a18991 
o|substituted constant variable: a18993 
o|substituted constant variable: a18998 
o|substituted constant variable: a19000 
o|inlining procedure: k18940 
o|substituted constant variable: a19031 
o|inlining procedure: k19066 
o|inlining procedure: k19066 
o|inlining procedure: k19140 
o|inlining procedure: k19140 
o|inlining procedure: k19191 
o|inlining procedure: k19207 
o|inlining procedure: k19207 
o|inlining procedure: k19191 
o|contracted procedure: "(library.scm:2744) g32673268" 
o|inlining procedure: k19241 
o|contracted procedure: "(library.scm:2747) g32723273" 
o|inlining procedure: k19265 
o|inlining procedure: k19265 
o|inlining procedure: k19241 
o|inlining procedure: k19314 
o|inlining procedure: k19314 
o|inlining procedure: k19405 
o|inlining procedure: k19405 
o|inlining procedure: k19450 
o|inlining procedure: k19450 
o|inlining procedure: k19522 
o|inlining procedure: k19522 
o|inlining procedure: k19537 
o|contracted procedure: "(library.scm:2812) g33233324" 
o|inlining procedure: k19537 
o|inlining procedure: k19560 
o|inlining procedure: k19560 
o|contracted procedure: "(library.scm:2817) square3321" 
o|inlining procedure: k19616 
o|inlining procedure: k19616 
o|inlining procedure: k19636 
o|inlining procedure: k19636 
o|inlining procedure: k19654 
o|contracted procedure: "(library.scm:2837) g33513352" 
o|contracted procedure: "(library.scm:2836) g33483349" 
o|inlining procedure: k19654 
o|inlining procedure: k19691 
o|contracted procedure: "(library.scm:2846) g33583359" 
o|inlining procedure: k19726 
o|contracted procedure: "(library.scm:2848) g33633364" 
o|inlining procedure: k19726 
o|inlining procedure: k19691 
o|inlining procedure: k19760 
o|inlining procedure: k19760 
o|inlining procedure: k19778 
o|inlining procedure: k19778 
o|inlining procedure: k19797 
o|inlining procedure: k19797 
o|inlining procedure: k19834 
o|inlining procedure: k19834 
o|inlining procedure: k19866 
o|contracted procedure: "(library.scm:2874) g33883389" 
o|inlining procedure: k19879 
o|contracted procedure: "(library.scm:2877) g33933394" 
o|inlining procedure: k19879 
o|inlining procedure: k19866 
o|inlining procedure: k19907 
o|inlining procedure: k19907 
o|contracted procedure: "(library.scm:2884) g34023403" 
o|inlining procedure: k19942 
o|inlining procedure: k19942 
o|inlining procedure: k19962 
o|inlining procedure: k19962 
o|inlining procedure: k20007 
o|inlining procedure: k20007 
o|inlining procedure: k20027 
o|inlining procedure: k20027 
o|substituted constant variable: a20100 
o|inlining procedure: k20115 
o|contracted procedure: "(library.scm:2940) g34683469" 
o|contracted procedure: "(library.scm:2938) g34653466" 
o|inlining procedure: k20115 
o|inlining procedure: k20179 
o|inlining procedure: k20179 
o|contracted procedure: "(library.scm:2944) g34763477" 
o|contracted procedure: "(library.scm:2943) g34733474" 
o|inlining procedure: k20294 
o|inlining procedure: k20307 
o|inlining procedure: k20307 
o|inlining procedure: k20294 
o|contracted procedure: "(library.scm:2982) g35063507" 
o|inlining procedure: k20336 
o|inlining procedure: k20336 
o|inlining procedure: k20350 
o|inlining procedure: k20359 
o|inlining procedure: k20371 
o|inlining procedure: k20371 
o|inlining procedure: k20359 
o|inlining procedure: k20387 
o|inlining procedure: k20387 
o|inlining procedure: k20393 
o|contracted procedure: "(library.scm:3005) mantexp->dbl" 
o|inlining procedure: k20192 
o|inlining procedure: k20192 
o|contracted procedure: "(library.scm:2974) ldexp" 
o|propagated global variable: a20251 chicken.flonum#flonum-precision 
o|inlining procedure: k20393 
o|inlining procedure: k20350 
o|inlining procedure: k20436 
o|inlining procedure: k20436 
o|inlining procedure: k20460 
o|inlining procedure: k20460 
o|substituted constant variable: a20483 
o|inlining procedure: k20486 
o|inlining procedure: k20486 
o|inlining procedure: k20514 
o|inlining procedure: k20514 
o|substituted constant variable: a20521 
o|substituted constant variable: a20525 
o|substituted constant variable: a20529 
o|substituted constant variable: a20531 
o|inlining procedure: k20540 
o|inlining procedure: k20540 
o|inlining procedure: k20571 
o|inlining procedure: k20571 
o|inlining procedure: k20591 
o|inlining procedure: k20591 
o|inlining procedure: k20613 
o|inlining procedure: k20613 
o|inlining procedure: k20624 
o|inlining procedure: k20624 
o|inlining procedure: k20638 
o|inlining procedure: k20679 
o|inlining procedure: k20679 
o|substituted constant variable: a20686 
o|substituted constant variable: a20688 
o|inlining procedure: k20638 
o|inlining procedure: k20691 
o|inlining procedure: k20712 
o|inlining procedure: k20730 
o|inlining procedure: k20742 
o|inlining procedure: k20758 
o|inlining procedure: k20758 
o|inlining procedure: k20742 
o|inlining procedure: k20730 
o|inlining procedure: k20712 
o|inlining procedure: k20803 
o|inlining procedure: k20803 
o|inlining procedure: k20818 
o|inlining procedure: k20818 
o|inlining procedure: k20830 
o|inlining procedure: k20830 
o|inlining procedure: k20842 
o|inlining procedure: k20842 
o|inlining procedure: k20854 
o|inlining procedure: k20854 
o|substituted constant variable: a20867 
o|substituted constant variable: a20869 
o|substituted constant variable: a20871 
o|substituted constant variable: a20873 
o|substituted constant variable: a20875 
o|substituted constant variable: a20877 
o|substituted constant variable: a20879 
o|substituted constant variable: a20881 
o|substituted constant variable: a20883 
o|substituted constant variable: a20885 
o|inlining procedure: k20892 
o|inlining procedure: k20892 
o|inlining procedure: k20691 
o|inlining procedure: k20903 
o|inlining procedure: k20903 
o|inlining procedure: k20928 
o|inlining procedure: k20943 
o|inlining procedure: k20943 
o|inlining procedure: k20928 
o|inlining procedure: k20986 
o|inlining procedure: k20998 
o|inlining procedure: k21008 
o|inlining procedure: k21008 
o|inlining procedure: k20998 
o|inlining procedure: k20986 
o|inlining procedure: k21028 
o|inlining procedure: k21044 
o|inlining procedure: k21054 
o|inlining procedure: k21072 
o|inlining procedure: k21092 
o|inlining procedure: "(library.scm:3133) make-nan3520" 
o|inlining procedure: k21092 
o|substituted constant variable: a21119 
o|substituted constant variable: a21121 
o|substituted constant variable: a21123 
o|inlining procedure: k21072 
o|inlining procedure: k21054 
o|inlining procedure: k21044 
o|inlining procedure: k21028 
o|substituted constant variable: a21141 
o|inlining procedure: k21145 
o|inlining procedure: k21145 
o|inlining procedure: k21157 
o|inlining procedure: k21157 
o|inlining procedure: k21169 
o|inlining procedure: k21169 
o|inlining procedure: k21181 
o|inlining procedure: k21181 
o|substituted constant variable: a21194 
o|substituted constant variable: a21196 
o|substituted constant variable: a21198 
o|substituted constant variable: a21200 
o|substituted constant variable: a21202 
o|substituted constant variable: a21204 
o|substituted constant variable: a21206 
o|substituted constant variable: a21208 
o|substituted constant variable: a21210 
o|substituted constant variable: a21212 
o|substituted constant variable: a21214 
o|inlining procedure: k21226 
o|inlining procedure: k21226 
o|inlining procedure: k21245 
o|inlining procedure: k21268 
o|inlining procedure: k21290 
o|inlining procedure: k21300 
o|inlining procedure: k21300 
o|inlining procedure: k21290 
o|inlining procedure: k21323 
o|inlining procedure: k21323 
o|substituted constant variable: a21350 
o|inlining procedure: k21268 
o|inlining procedure: k21375 
o|inlining procedure: k21375 
o|inlining procedure: k21385 
o|substituted constant variable: a21398 
o|inlining procedure: k21410 
o|inlining procedure: k21410 
o|inlining procedure: "(library.scm:3162) make-nan3520" 
o|inlining procedure: k21385 
o|substituted constant variable: a21446 
o|substituted constant variable: a21448 
o|substituted constant variable: a21453 
o|substituted constant variable: a21455 
o|inlining procedure: k21462 
o|inlining procedure: k21462 
o|substituted constant variable: a21469 
o|substituted constant variable: a21471 
o|inlining procedure: k21245 
o|inlining procedure: k21478 
o|inlining procedure: k21490 
o|inlining procedure: k21490 
o|inlining procedure: k21500 
o|inlining procedure: k21500 
o|inlining procedure: k21478 
o|inlining procedure: k21507 
o|inlining procedure: k21507 
o|inlining procedure: k21523 
o|inlining procedure: k21523 
o|inlining procedure: k21559 
o|inlining procedure: k21578 
o|inlining procedure: k21593 
o|inlining procedure: k21593 
o|inlining procedure: k21578 
o|inlining procedure: k21559 
o|inlining procedure: k21636 
o|inlining procedure: k21636 
o|substituted constant variable: a21663 
o|substituted constant variable: a21668 
o|substituted constant variable: a21670 
o|substituted constant variable: a21675 
o|substituted constant variable: a21677 
o|substituted constant variable: a21679 
o|inlining procedure: k21732 
o|inlining procedure: k21750 
o|inlining procedure: k21750 
o|inlining procedure: k21763 
o|inlining procedure: k21763 
o|inlining procedure: k21794 
o|inlining procedure: k21794 
o|inlining procedure: k21807 
o|inlining procedure: k21807 
o|inlining procedure: k21838 
o|inlining procedure: k21838 
o|inlining procedure: k21851 
o|inlining procedure: k21851 
o|substituted constant variable: a21877 
o|substituted constant variable: a21879 
o|substituted constant variable: a21884 
o|substituted constant variable: a21886 
o|substituted constant variable: a21891 
o|substituted constant variable: a21893 
o|substituted constant variable: a21898 
o|substituted constant variable: a21900 
o|substituted constant variable: a21905 
o|substituted constant variable: a21907 
o|substituted constant variable: a21912 
o|substituted constant variable: a21914 
o|inlining procedure: k21732 
o|inlining procedure: k21923 
o|inlining procedure: k21923 
o|inlining procedure: k21946 
o|inlining procedure: k21946 
o|inlining procedure: k22019 
o|inlining procedure: k22040 
o|inlining procedure: k22040 
o|inlining procedure: k22019 
o|inlining procedure: k22084 
o|inlining procedure: k22084 
o|inlining procedure: k22093 
o|inlining procedure: k22093 
o|inlining procedure: k22105 
o|inlining procedure: k22105 
o|inlining procedure: k22117 
o|inlining procedure: k22117 
o|inlining procedure: k22126 
o|inlining procedure: k22126 
o|inlining procedure: k22135 
o|inlining procedure: k22135 
o|inlining procedure: k22152 
o|inlining procedure: k22152 
o|inlining procedure: k22171 
o|inlining procedure: k22171 
o|inlining procedure: k22309 
o|inlining procedure: k22309 
o|inlining procedure: "(library.scm:3330) err3983" 
o|inlining procedure: k22315 
o|inlining procedure: k22315 
o|inlining procedure: "(library.scm:3329) err3983" 
o|inlining procedure: k22355 
o|contracted procedure: "(library.scm:3339) g40054014" 
o|inlining procedure: k22355 
o|inlining procedure: k22405 
o|inlining procedure: k22405 
o|inlining procedure: k22432 
o|inlining procedure: k22432 
o|inlining procedure: k22467 
o|inlining procedure: k22467 
o|inlining procedure: k22500 
o|inlining procedure: k22500 
o|inlining procedure: k22533 
o|inlining procedure: k22533 
o|inlining procedure: k22551 
o|inlining procedure: k22551 
o|inlining procedure: k22672 
o|inlining procedure: k22672 
o|inlining procedure: k22695 
o|inlining procedure: k22695 
o|inlining procedure: k22740 
o|inlining procedure: k22740 
o|inlining procedure: k22758 
o|inlining procedure: k22758 
o|inlining procedure: k22824 
o|inlining procedure: k22824 
o|inlining procedure: k22843 
o|inlining procedure: k22843 
o|inlining procedure: k22885 
o|inlining procedure: k22900 
o|inlining procedure: k22900 
o|inlining procedure: k22885 
o|inlining procedure: k22947 
o|inlining procedure: k22947 
o|inlining procedure: k22966 
o|inlining procedure: k22966 
o|inlining procedure: k22987 
o|inlining procedure: k22987 
o|inlining procedure: k23048 
o|inlining procedure: k23048 
o|inlining procedure: k23140 
o|inlining procedure: k23140 
o|inlining procedure: k23226 
o|inlining procedure: k23226 
o|inlining procedure: k23254 
o|inlining procedure: k23254 
o|inlining procedure: k23339 
o|inlining procedure: k23359 
o|inlining procedure: k23359 
o|inlining procedure: k23339 
o|inlining procedure: k23393 
o|inlining procedure: k23393 
o|inlining procedure: k23427 
o|inlining procedure: k23427 
o|inlining procedure: k23494 
o|inlining procedure: k23494 
o|inlining procedure: k23534 
o|inlining procedure: k23534 
o|substituted constant variable: g44904493 
o|inlining procedure: k23558 
o|inlining procedure: k23558 
o|inlining procedure: k23592 
o|contracted procedure: "(library.scm:3628) g44354442" 
o|inlining procedure: k23592 
o|inlining procedure: k23645 
o|inlining procedure: k23645 
o|inlining procedure: k23711 
o|inlining procedure: k23711 
o|inlining procedure: k23754 
o|inlining procedure: k23754 
o|inlining procedure: k23777 
o|inlining procedure: k23777 
o|inlining procedure: k23801 
o|inlining procedure: k23801 
o|inlining procedure: k23824 
o|inlining procedure: k23824 
o|inlining procedure: k23844 
o|inlining procedure: k23844 
o|inlining procedure: k23867 
o|inlining procedure: k23867 
o|inlining procedure: k23887 
o|inlining procedure: k23887 
o|inlining procedure: k23910 
o|inlining procedure: k23910 
o|inlining procedure: k23930 
o|inlining procedure: k23930 
o|inlining procedure: k23953 
o|inlining procedure: k23953 
o|inlining procedure: k23976 
o|inlining procedure: k23976 
o|inlining procedure: k24007 
o|inlining procedure: k24007 
o|inlining procedure: k24037 
o|inlining procedure: k24037 
o|inlining procedure: k24107 
o|inlining procedure: k24107 
o|inlining procedure: k24171 
o|inlining procedure: k24171 
o|inlining procedure: k24209 
o|inlining procedure: k24209 
o|inlining procedure: k24257 
o|inlining procedure: k24257 
o|inlining procedure: k24275 
o|inlining procedure: k24275 
o|inlining procedure: k24303 
o|inlining procedure: k24318 
o|inlining procedure: k24318 
o|inlining procedure: k24303 
o|inlining procedure: k24354 
o|inlining procedure: k24354 
o|inlining procedure: k24385 
o|inlining procedure: k24403 
o|inlining procedure: k24403 
o|inlining procedure: k24385 
o|inlining procedure: k24450 
o|inlining procedure: k24450 
o|inlining procedure: k24527 
o|inlining procedure: k24527 
o|inlining procedure: k24561 
o|inlining procedure: k24561 
o|inlining procedure: k24694 
o|inlining procedure: k24694 
o|inlining procedure: k24705 
o|inlining procedure: k24705 
o|inlining procedure: k24716 
o|inlining procedure: k24716 
o|inlining procedure: k24727 
o|inlining procedure: k24727 
o|inlining procedure: k24738 
o|propagated global variable: r2473943044 ##sys#standard-input 
o|removed unused formal parameters: (convert?4974) 
o|inlining procedure: k24753 
o|inlining procedure: k24753 
o|removed unused parameter to known procedure: convert?4974 "(library.scm:4145) body49644973" 
o|inlining procedure: k24738 
o|inlining procedure: k24780 
o|inlining procedure: k24780 
o|removed unused parameter to known procedure: convert?4974 "(library.scm:4145) body49644973" 
o|inlining procedure: k24799 
o|propagated global variable: r2480043050 ##sys#standard-output 
o|removed unused formal parameters: (convert?4999) 
o|inlining procedure: k24814 
o|inlining procedure: k24814 
o|removed unused parameter to known procedure: convert?4999 "(library.scm:4155) body49894998" 
o|inlining procedure: k24799 
o|inlining procedure: k24841 
o|inlining procedure: k24841 
o|removed unused parameter to known procedure: convert?4999 "(library.scm:4155) body49894998" 
o|inlining procedure: k24860 
o|propagated global variable: r2486143056 ##sys#standard-error 
o|removed unused formal parameters: (convert?5024) 
o|inlining procedure: k24875 
o|inlining procedure: k24875 
o|removed unused parameter to known procedure: convert?5024 "(library.scm:4165) body50145023" 
o|inlining procedure: k24860 
o|inlining procedure: k24902 
o|inlining procedure: k24902 
o|removed unused parameter to known procedure: convert?5024 "(library.scm:4165) body50145023" 
o|inlining procedure: k24921 
o|inlining procedure: k24921 
o|inlining procedure: k24966 
o|inlining procedure: k24966 
o|inlining procedure: k24992 
o|inlining procedure: k24992 
o|inlining procedure: k24998 
o|inlining procedure: k24998 
o|inlining procedure: k25025 
o|inlining procedure: k25025 
o|inlining procedure: k25045 
o|inlining procedure: k25045 
o|inlining procedure: k25065 
o|inlining procedure: k25065 
o|inlining procedure: k25084 
o|inlining procedure: k25084 
o|substituted constant variable: a25098 
o|substituted constant variable: a25100 
o|substituted constant variable: a25105 
o|substituted constant variable: a25107 
o|inlining procedure: k25111 
o|inlining procedure: k25111 
o|substituted constant variable: a25124 
o|substituted constant variable: a25126 
o|substituted constant variable: a25128 
o|substituted constant variable: a25130 
o|inlining procedure: k25134 
o|inlining procedure: k25134 
o|substituted constant variable: a25147 
o|substituted constant variable: a25149 
o|substituted constant variable: a25151 
o|substituted constant variable: a25153 
o|substituted constant variable: a25158 
o|substituted constant variable: a25160 
o|substituted constant variable: a25165 
o|substituted constant variable: a25167 
o|substituted constant variable: a25172 
o|substituted constant variable: a25174 
o|inlining procedure: k25184 
o|inlining procedure: k25184 
o|inlining procedure: k25359 
o|inlining procedure: k25359 
o|substituted constant variable: a25375 
o|substituted constant variable: a25377 
o|substituted constant variable: a25398 
o|substituted constant variable: a25399 
o|inlining procedure: k25412 
o|inlining procedure: k25412 
o|inlining procedure: k25434 
o|inlining procedure: k25447 
o|inlining procedure: k25447 
o|inlining procedure: k25434 
o|inlining procedure: k25506 
o|inlining procedure: k25506 
o|inlining procedure: k25551 
o|inlining procedure: k25551 
o|inlining procedure: k25590 
o|inlining procedure: k25590 
o|inlining procedure: k25631 
o|inlining procedure: k25631 
o|inlining procedure: k25650 
o|inlining procedure: k25650 
o|inlining procedure: k25782 
o|inlining procedure: k25782 
o|inlining procedure: k25821 
o|inlining procedure: k25860 
o|inlining procedure: k25860 
o|inlining procedure: k25821 
o|inlining procedure: k25888 
o|inlining procedure: k25888 
o|substituted constant variable: a25936 
o|substituted constant variable: a25937 
o|substituted constant variable: a25961 
o|substituted constant variable: a25962 
o|inlining procedure: k25978 
o|inlining procedure: k25978 
o|substituted constant variable: a26036 
o|substituted constant variable: a26037 
o|inlining procedure: k26044 
o|inlining procedure: k26044 
o|substituted constant variable: a26073 
o|substituted constant variable: a26074 
o|substituted constant variable: a26091 
o|substituted constant variable: a26092 
o|inlining procedure: k26150 
o|inlining procedure: k26150 
o|inlining procedure: k26173 
o|inlining procedure: k26173 
o|inlining procedure: k26213 
o|inlining procedure: k26213 
o|inlining procedure: k26232 
o|inlining procedure: k26232 
o|inlining procedure: k26271 
o|inlining procedure: k26271 
o|inlining procedure: k26297 
o|inlining procedure: k26297 
o|inlining procedure: k26328 
o|inlining procedure: k26328 
o|inlining procedure: k26403 
o|inlining procedure: k26403 
o|inlining procedure: k26455 
o|inlining procedure: k26455 
o|inlining procedure: k26474 
o|inlining procedure: k26474 
o|inlining procedure: k26499 
o|inlining procedure: k26499 
o|inlining procedure: k26562 
o|inlining procedure: k26562 
o|inlining procedure: k26591 
o|inlining procedure: k26591 
o|inlining procedure: k26609 
o|inlining procedure: k26609 
o|inlining procedure: k26621 
o|inlining procedure: k26621 
o|inlining procedure: k26656 
o|inlining procedure: k26656 
o|inlining procedure: k26671 
o|inlining procedure: k26671 
o|substituted constant variable: a26678 
o|substituted constant variable: a26680 
o|substituted constant variable: a26682 
o|substituted constant variable: a26684 
o|substituted constant variable: a26689 
o|inlining procedure: k26703 
o|inlining procedure: k26703 
o|inlining procedure: k26719 
o|inlining procedure: k26719 
o|inlining procedure: k26753 
o|inlining procedure: k26753 
o|inlining procedure: k26787 
o|inlining procedure: k26787 
o|inlining procedure: k26821 
o|inlining procedure: k26821 
o|inlining procedure: k26862 
o|inlining procedure: k26862 
o|inlining procedure: k26910 
o|inlining procedure: k26910 
o|inlining procedure: k26945 
o|inlining procedure: k26945 
o|inlining procedure: k26967 
o|inlining procedure: k26967 
o|inlining procedure: k26992 
o|inlining procedure: k26992 
o|substituted constant variable: a27021 
o|substituted constant variable: a27023 
o|substituted constant variable: a27028 
o|substituted constant variable: a27030 
o|inlining procedure: k27031 
o|inlining procedure: k27031 
o|inlining procedure: k27094 
o|inlining procedure: k27094 
o|inlining procedure: k27106 
o|inlining procedure: k27106 
o|substituted constant variable: a27119 
o|substituted constant variable: a27121 
o|substituted constant variable: a27123 
o|substituted constant variable: a27125 
o|inlining procedure: k27129 
o|inlining procedure: k27129 
o|substituted constant variable: a27142 
o|substituted constant variable: a27144 
o|substituted constant variable: a27146 
o|substituted constant variable: a27148 
o|substituted constant variable: a27150 
o|substituted constant variable: a27152 
o|substituted constant variable: a27154 
o|substituted constant variable: a27156 
o|substituted constant variable: a27158 
o|substituted constant variable: a27160 
o|substituted constant variable: a27162 
o|substituted constant variable: a27164 
o|substituted constant variable: a27166 
o|substituted constant variable: a27168 
o|inlining procedure: k27169 
o|inlining procedure: k27169 
o|inlining procedure: k27201 
o|inlining procedure: k27201 
o|inlining procedure: k27192 
o|inlining procedure: k27234 
o|inlining procedure: k27234 
o|inlining procedure: k27265 
o|inlining procedure: k27265 
o|inlining procedure: k27284 
o|inlining procedure: k27317 
o|inlining procedure: k27317 
o|inlining procedure: k27359 
o|inlining procedure: k27359 
o|inlining procedure: k27375 
o|inlining procedure: k27375 
o|inlining procedure: "(library.scm:4841) build-symbol5569" 
o|substituted constant variable: a27397 
o|inlining procedure: k27404 
o|inlining procedure: k27404 
o|inlining procedure: k27416 
o|inlining procedure: k27416 
o|inlining procedure: k27284 
o|inlining procedure: k27192 
o|inlining procedure: k27456 
o|inlining procedure: k27456 
o|inlining procedure: k27477 
o|inlining procedure: k27477 
o|substituted constant variable: a27494 
o|inlining procedure: k27498 
o|inlining procedure: k27498 
o|inlining procedure: k27513 
o|inlining procedure: k27513 
o|inlining procedure: "(library.scm:4877) build-symbol5569" 
o|inlining procedure: k27523 
o|inlining procedure: k27523 
o|substituted constant variable: a27531 
o|substituted constant variable: a27532 
o|inlining procedure: k27540 
o|inlining procedure: k27561 
o|inlining procedure: k27561 
o|substituted constant variable: a27574 
o|inlining procedure: k27540 
o|inlining procedure: k27591 
o|inlining procedure: k27612 
o|inlining procedure: k27612 
o|substituted constant variable: a27625 
o|substituted constant variable: a27633 
o|inlining procedure: k27629 
o|inlining procedure: k27629 
o|substituted constant variable: a27641 
o|inlining procedure: k27591 
o|inlining procedure: k27668 
o|inlining procedure: k27668 
o|inlining procedure: k27704 
o|inlining procedure: k27704 
o|inlining procedure: k27711 
o|inlining procedure: k27711 
o|inlining procedure: k27730 
o|inlining procedure: k27730 
o|inlining procedure: "(library.scm:4929) build-symbol5569" 
o|inlining procedure: k27804 
o|inlining procedure: k27830 
o|inlining procedure: k27830 
o|inlining procedure: k27859 
o|inlining procedure: k27859 
o|inlining procedure: k27868 
o|inlining procedure: k27868 
o|inlining procedure: k27878 
o|inlining procedure: k27878 
o|inlining procedure: k27804 
o|inlining procedure: k27910 
o|inlining procedure: k27910 
o|inlining procedure: k27954 
o|inlining procedure: k27954 
o|inlining procedure: k27976 
o|inlining procedure: k27976 
o|inlining procedure: k28000 
o|inlining procedure: k28000 
o|substituted constant variable: a28007 
o|substituted constant variable: a28009 
o|substituted constant variable: a28011 
o|substituted constant variable: a28013 
o|inlining procedure: k28017 
o|inlining procedure: k28017 
o|inlining procedure: k28026 
o|inlining procedure: k28026 
o|inlining procedure: k28051 
o|contracted procedure: "(library.scm:4988) g58935894" 
o|inlining procedure: k28080 
o|inlining procedure: k28080 
o|inlining procedure: k28099 
o|inlining procedure: k28117 
o|inlining procedure: k28133 
o|substituted constant variable: a28157 
o|inlining procedure: k28133 
o|substituted constant variable: a28172 
o|inlining procedure: k28117 
o|substituted constant variable: a28187 
o|inlining procedure: k28099 
o|substituted constant variable: a28226 
o|substituted constant variable: a28240 
o|inlining procedure: k28242 
o|inlining procedure: k28242 
o|substituted constant variable: a28245 
o|inlining procedure: k28051 
o|inlining procedure: k28268 
o|inlining procedure: k28280 
o|inlining procedure: k28280 
o|inlining procedure: k28268 
o|inlining procedure: k28314 
o|inlining procedure: k28314 
o|inlining procedure: k28327 
o|inlining procedure: k28327 
o|substituted constant variable: a28340 
o|substituted constant variable: a28342 
o|inlining procedure: "(library.scm:5035) build-symbol5569" 
o|inlining procedure: k28405 
o|inlining procedure: k28420 
o|inlining procedure: k28420 
o|inlining procedure: k28405 
o|inlining procedure: k28444 
o|inlining procedure: k28444 
o|inlining procedure: k28465 
o|inlining procedure: k28465 
o|inlining procedure: k28484 
o|inlining procedure: k28505 
o|inlining procedure: k28529 
o|inlining procedure: k28529 
o|inlining procedure: k28560 
o|inlining procedure: k28560 
o|inlining procedure: k28593 
o|inlining procedure: k28593 
o|inlining procedure: k28572 
o|inlining procedure: k28572 
o|inlining procedure: k28632 
o|inlining procedure: k28632 
o|inlining procedure: k28505 
o|inlining procedure: k28667 
o|inlining procedure: k28667 
o|inlining procedure: k28682 
o|inlining procedure: k28682 
o|inlining procedure: k28706 
o|inlining procedure: k28706 
o|inlining procedure: k28730 
o|inlining procedure: k28730 
o|inlining procedure: k28754 
o|inlining procedure: k28754 
o|inlining procedure: k28775 
o|inlining procedure: k28775 
o|inlining procedure: k28802 
o|inlining procedure: k28802 
o|inlining procedure: k28829 
o|inlining procedure: k28829 
o|inlining procedure: k28870 
o|inlining procedure: k28870 
o|inlining procedure: k28901 
o|inlining procedure: k28901 
o|inlining procedure: k28943 
o|inlining procedure: k28943 
o|substituted constant variable: a28961 
o|substituted constant variable: a28966 
o|inlining procedure: k28963 
o|inlining procedure: k28963 
o|substituted constant variable: a28971 
o|substituted constant variable: a28983 
o|inlining procedure: k28980 
o|inlining procedure: k28980 
o|inlining procedure: "(library.scm:5188) build-symbol5569" 
o|inlining procedure: k29008 
o|inlining procedure: k29008 
o|inlining procedure: k29030 
o|inlining procedure: k29030 
o|substituted constant variable: a29033 
o|inlining procedure: k29047 
o|inlining procedure: k29047 
o|substituted constant variable: a29060 
o|substituted constant variable: a29062 
o|substituted constant variable: a29064 
o|substituted constant variable: a29066 
o|substituted constant variable: a29068 
o|substituted constant variable: a29070 
o|substituted constant variable: a29072 
o|substituted constant variable: a29074 
o|substituted constant variable: a29076 
o|substituted constant variable: a29078 
o|substituted constant variable: a29080 
o|substituted constant variable: a29082 
o|substituted constant variable: a29084 
o|substituted constant variable: a29086 
o|substituted constant variable: a29088 
o|substituted constant variable: a29090 
o|inlining procedure: k28484 
o|inlining procedure: k29107 
o|inlining procedure: k29107 
o|inlining procedure: k29131 
o|inlining procedure: k29131 
o|inlining procedure: k29152 
o|inlining procedure: k29152 
o|inlining procedure: k29167 
o|inlining procedure: k29167 
o|inlining procedure: k29185 
o|inlining procedure: k29185 
o|substituted constant variable: a29216 
o|substituted constant variable: a29218 
o|substituted constant variable: a29220 
o|substituted constant variable: a29222 
o|substituted constant variable: a29227 
o|substituted constant variable: a29229 
o|substituted constant variable: a29231 
o|substituted constant variable: a29233 
o|substituted constant variable: a29235 
o|substituted constant variable: a29237 
o|substituted constant variable: a29239 
o|substituted constant variable: a29241 
o|substituted constant variable: a29243 
o|substituted constant variable: a29245 
o|inlining procedure: k29249 
o|inlining procedure: k29249 
o|inlining procedure: k29268 
o|inlining procedure: k29268 
o|inlining procedure: k29283 
o|inlining procedure: k29283 
o|inlining procedure: k29316 
o|inlining procedure: k29337 
o|inlining procedure: k29337 
o|inlining procedure: k29355 
o|inlining procedure: k29355 
o|substituted constant variable: a29391 
o|substituted constant variable: a29396 
o|substituted constant variable: a29398 
o|substituted constant variable: a29403 
o|substituted constant variable: a29405 
o|inlining procedure: k29316 
o|inlining procedure: k29416 
o|inlining procedure: k29416 
o|substituted constant variable: a29423 
o|substituted constant variable: a29425 
o|substituted constant variable: a29427 
o|inlining procedure: k29434 
o|inlining procedure: k29434 
o|substituted constant variable: a29456 
o|substituted constant variable: a29458 
o|inlining procedure: k29468 
o|inlining procedure: k29484 
o|inlining procedure: k29484 
o|inlining procedure: k29503 
o|inlining procedure: k29503 
o|inlining procedure: k29535 
o|inlining procedure: k29535 
o|inlining procedure: k29468 
o|substituted constant variable: a29607 
o|substituted constant variable: a29608 
o|substituted constant variable: a29625 
o|substituted constant variable: a29626 
o|inlining procedure: k29639 
o|propagated global variable: r2964043413 ##sys#standard-output 
o|inlining procedure: k29639 
o|substituted constant variable: a29658 
o|substituted constant variable: a29659 
o|substituted constant variable: a29676 
o|substituted constant variable: a29677 
o|propagated global variable: a29690 ##sys#standard-output 
o|substituted constant variable: a29691 
o|substituted constant variable: a29692 
o|contracted procedure: "(library.scm:5331) g62436244" 
o|inlining procedure: k29709 
o|contracted procedure: "(library.scm:5326) g62496256" 
o|propagated global variable: g62646265 ##sys#print 
o|inlining procedure: k29709 
o|propagated global variable: a29741 ##sys#standard-output 
o|substituted constant variable: a29742 
o|substituted constant variable: a29743 
o|contracted procedure: "(library.scm:5338) g62756276" 
o|inlining procedure: k29760 
o|contracted procedure: "(library.scm:5326) g62816288" 
o|propagated global variable: g62966297 ##sys#print 
o|inlining procedure: k29760 
o|substituted constant variable: a29805 
o|substituted constant variable: a29806 
o|inlining procedure: k29822 
o|inlining procedure: k29822 
o|inlining procedure: k29924 
o|inlining procedure: k29924 
o|inlining procedure: k29956 
o|inlining procedure: k29956 
o|substituted constant variable: special-characters6320 
o|inlining procedure: k29968 
o|inlining procedure: k29968 
o|inlining procedure: k29986 
o|inlining procedure: k29986 
o|inlining procedure: k30007 
o|inlining procedure: k30007 
o|substituted constant variable: a30023 
o|substituted constant variable: a30076 
o|inlining procedure: k30083 
o|inlining procedure: k30083 
o|substituted constant variable: a30096 
o|inlining procedure: k30097 
o|inlining procedure: k30097 
o|inlining procedure: k30112 
o|inlining procedure: k30112 
o|inlining procedure: k30131 
o|inlining procedure: k30146 
o|substituted constant variable: a30170 
o|inlining procedure: k30146 
o|inlining procedure: k30177 
o|substituted constant variable: a30192 
o|inlining procedure: k30177 
o|inlining procedure: k30193 
o|inlining procedure: k30193 
o|inlining procedure: k30208 
o|inlining procedure: k30208 
o|inlining procedure: k30221 
o|substituted constant variable: a30242 
o|substituted constant variable: a30245 
o|inlining procedure: k30221 
o|inlining procedure: k30131 
o|inlining procedure: k30258 
o|inlining procedure: k30258 
o|inlining procedure: k30311 
o|inlining procedure: k30311 
o|inlining procedure: k30329 
o|inlining procedure: k30329 
o|inlining procedure: k30344 
o|inlining procedure: k30344 
o|inlining procedure: k30356 
o|inlining procedure: k30371 
o|inlining procedure: k30371 
o|inlining procedure: k30356 
o|inlining procedure: k30424 
o|inlining procedure: k30424 
o|inlining procedure: k30439 
o|inlining procedure: k30439 
o|inlining procedure: k30451 
o|inlining procedure: k30451 
o|substituted constant variable: a30482 
o|substituted constant variable: a30484 
o|inlining procedure: k30488 
o|inlining procedure: k30488 
o|inlining procedure: k30507 
o|inlining procedure: k30507 
o|inlining procedure: k30520 
o|inlining procedure: k30536 
o|inlining procedure: k30536 
o|inlining procedure: k30568 
o|inlining procedure: k30568 
o|inlining procedure: k30589 
o|inlining procedure: k30589 
o|inlining procedure: k30607 
o|inlining procedure: k30607 
o|inlining procedure: k30625 
o|inlining procedure: k30625 
o|inlining procedure: k30643 
o|inlining procedure: k30643 
o|substituted constant variable: a30675 
o|substituted constant variable: a30677 
o|substituted constant variable: a30679 
o|substituted constant variable: a30681 
o|substituted constant variable: a30683 
o|substituted constant variable: a30685 
o|substituted constant variable: a30687 
o|substituted constant variable: a30696 
o|substituted constant variable: a30698 
o|inlining procedure: k30520 
o|inlining procedure: k30706 
o|inlining procedure: k30725 
o|inlining procedure: k30725 
o|inlining procedure: k30706 
o|inlining procedure: k30792 
o|inlining procedure: k30792 
o|inlining procedure: k30808 
o|inlining procedure: k30808 
o|inlining procedure: k30830 
o|inlining procedure: k30855 
o|inlining procedure: k30855 
o|substituted constant variable: a30868 
o|substituted constant variable: a30870 
o|inlining procedure: k30830 
o|inlining procedure: k30877 
o|inlining procedure: k30877 
o|inlining procedure: k30902 
o|inlining procedure: k30902 
o|inlining procedure: k30946 
o|inlining procedure: k30946 
o|inlining procedure: k30963 
o|inlining procedure: k30963 
o|inlining procedure: k30978 
o|inlining procedure: k30978 
o|inlining procedure: k31009 
o|inlining procedure: k31039 
o|inlining procedure: k31039 
o|inlining procedure: k31009 
o|inlining procedure: k31123 
o|inlining procedure: k31123 
o|substituted constant variable: a31140 
o|substituted constant variable: a31142 
o|substituted constant variable: saved661466156627 
o|inlining procedure: k31249 
o|inlining procedure: k31249 
o|inlining procedure: k31353 
o|inlining procedure: k31353 
o|inlining procedure: k31368 
o|inlining procedure: k31389 
o|inlining procedure: k31389 
o|inlining procedure: k31368 
o|inlining procedure: k31422 
o|inlining procedure: k31422 
o|inlining procedure: k31463 
o|inlining procedure: k31463 
o|inlining procedure: k31500 
o|inlining procedure: k31500 
o|inlining procedure: k31540 
o|inlining procedure: k31540 
o|inlining procedure: k31587 
o|inlining procedure: k31587 
o|inlining procedure: k31610 
o|inlining procedure: k31636 
o|inlining procedure: k31636 
o|inlining procedure: k31610 
o|inlining procedure: k31690 
o|inlining procedure: k31690 
o|substituted constant variable: c6846 
o|contracted procedure: "(library.scm:5847) extract6823" 
o|substituted constant variable: c6846 
o|inlining procedure: k31767 
o|inlining procedure: k31767 
o|substituted constant variable: c6846 
o|substituted constant variable: c6846 
o|inlining procedure: k31849 
o|inlining procedure: k31849 
o|inlining procedure: k31874 
o|inlining procedure: k31874 
o|inlining procedure: k31880 
o|inlining procedure: k31880 
o|inlining procedure: k31817 
o|inlining procedure: k31899 
o|inlining procedure: k31899 
o|inlining procedure: k31817 
o|substituted constant variable: a31947 
o|substituted constant variable: a31948 
o|inlining procedure: k32019 
o|inlining procedure: "(library.scm:5895) break6922" 
o|inlining procedure: k32019 
o|inlining procedure: k32048 
o|inlining procedure: k32048 
o|inlining procedure: k32084 
o|inlining procedure: k32084 
o|inlining procedure: k32107 
o|contracted procedure: "(library.scm:5916) g69326939" 
o|inlining procedure: k32107 
o|inlining procedure: k32151 
o|inlining procedure: k32151 
o|inlining procedure: k32205 
o|contracted procedure: "(library.scm:5988) g70117018" 
o|inlining procedure: k32205 
o|inlining procedure: k32243 
o|inlining procedure: k32243 
o|inlining procedure: k32279 
o|inlining procedure: k32279 
o|inlining procedure: k32296 
o|inlining procedure: k32296 
o|inlining procedure: k32308 
o|inlining procedure: k32308 
o|inlining procedure: k32320 
o|inlining procedure: k32320 
o|inlining procedure: k32332 
o|inlining procedure: k32332 
o|inlining procedure: k32344 
o|inlining procedure: k32344 
o|inlining procedure: k32356 
o|inlining procedure: k32356 
o|inlining procedure: k32368 
o|inlining procedure: k32368 
o|substituted constant variable: a32375 
o|substituted constant variable: a32377 
o|substituted constant variable: a32379 
o|substituted constant variable: a32381 
o|substituted constant variable: a32383 
o|substituted constant variable: a32385 
o|substituted constant variable: a32387 
o|substituted constant variable: a32389 
o|substituted constant variable: a32391 
o|substituted constant variable: a32393 
o|substituted constant variable: a32395 
o|substituted constant variable: a32397 
o|substituted constant variable: a32399 
o|substituted constant variable: a32401 
o|substituted constant variable: a32437 
o|substituted constant variable: a32439 
o|substituted constant variable: a32441 
o|inlining procedure: k32445 
o|inlining procedure: k32445 
o|inlining procedure: k32509 
o|inlining procedure: k32545 
o|inlining procedure: k32545 
o|inlining procedure: k32557 
o|inlining procedure: k32571 
o|inlining procedure: k32571 
o|inlining procedure: k32557 
o|inlining procedure: k32509 
o|inlining procedure: k32607 
o|inlining procedure: k32607 
o|inlining procedure: k32662 
o|propagated global variable: r3266343619 ##sys#current-exception-handler 
o|removed unused formal parameters: (convert?7177) 
o|inlining procedure: k32677 
o|inlining procedure: k32677 
o|removed unused parameter to known procedure: convert?7177 "(library.scm:6142) body71677176" 
o|inlining procedure: k32662 
o|inlining procedure: k32704 
o|inlining procedure: k32704 
o|removed unused parameter to known procedure: convert?7177 "(library.scm:6142) body71677176" 
o|inlining procedure: k32729 
o|inlining procedure: k32729 
o|inlining procedure: k32842 
o|contracted procedure: "(library.scm:6170) g72627271" 
o|inlining procedure: k32842 
o|inlining procedure: k32888 
o|contracted procedure: "(library.scm:6169) g72357244" 
o|inlining procedure: k32888 
o|inlining procedure: k32922 
o|contracted procedure: "(library.scm:6166) g72127219" 
o|inlining procedure: k32922 
o|inlining procedure: k32964 
o|inlining procedure: k32964 
o|inlining procedure: k33016 
o|contracted procedure: "(library.scm:6175) g72957304" 
o|inlining procedure: k33016 
o|inlining procedure: k33078 
o|inlining procedure: k33078 
o|inlining procedure: k33134 
o|inlining procedure: k33134 
o|inlining procedure: k33176 
o|inlining procedure: k33176 
o|inlining procedure: k33206 
o|inlining procedure: k33221 
o|inlining procedure: k33221 
o|inlining procedure: k33206 
o|inlining procedure: k33282 
o|inlining procedure: k33282 
o|substituted constant variable: a33307 
o|substituted constant variable: a33308 
o|inlining procedure: k33315 
o|inlining procedure: k33336 
o|inlining procedure: k33336 
o|inlining procedure: k33366 
o|inlining procedure: k33366 
o|inlining procedure: k33395 
o|inlining procedure: k33395 
o|inlining procedure: k33315 
o|inlining procedure: k33463 
(o x)|known list op on rest arg sublist: ##core#rest-cdr args7434 0 
o|inlining procedure: k33463 
o|inlining procedure: k33498 
o|inlining procedure: k33498 
o|inlining procedure: k33544 
o|inlining procedure: k33567 
o|inlining procedure: k33567 
o|inlining procedure: k33544 
o|inlining procedure: k33604 
o|inlining procedure: k33604 
o|inlining procedure: k33618 
o|inlining procedure: k33618 
o|inlining procedure: k33636 
o|inlining procedure: k33636 
o|inlining procedure: k33654 
o|inlining procedure: k33654 
o|inlining procedure: k33672 
o|inlining procedure: k33672 
o|inlining procedure: k33690 
o|inlining procedure: k33690 
o|inlining procedure: k33708 
o|inlining procedure: k33708 
o|inlining procedure: k33726 
o|inlining procedure: k33726 
o|inlining procedure: k33744 
o|inlining procedure: k33744 
o|inlining procedure: k33762 
o|inlining procedure: k33762 
o|inlining procedure: k33780 
o|inlining procedure: k33780 
o|inlining procedure: k33798 
o|inlining procedure: k33798 
o|inlining procedure: k33816 
o|inlining procedure: k33816 
o|inlining procedure: k33834 
o|inlining procedure: k33834 
o|inlining procedure: k33852 
o|inlining procedure: k33852 
o|inlining procedure: k33870 
o|inlining procedure: k33870 
o|inlining procedure: k33888 
o|inlining procedure: k33888 
o|inlining procedure: k33906 
o|inlining procedure: k33906 
o|inlining procedure: k33924 
o|inlining procedure: k33924 
o|inlining procedure: k33942 
o|inlining procedure: k33942 
o|inlining procedure: k33960 
o|inlining procedure: k33960 
o|inlining procedure: k33978 
o|inlining procedure: k33978 
o|inlining procedure: k33996 
o|inlining procedure: k33996 
o|inlining procedure: k34014 
o|inlining procedure: k34014 
o|inlining procedure: k34032 
o|inlining procedure: k34032 
o|inlining procedure: k34050 
o|inlining procedure: k34050 
o|inlining procedure: k34068 
o|inlining procedure: k34068 
o|inlining procedure: k34086 
o|inlining procedure: k34086 
o|inlining procedure: k34118 
o|inlining procedure: k34118 
o|inlining procedure: k34132 
o|inlining procedure: k34132 
o|substituted constant variable: a34154 
o|substituted constant variable: a34156 
o|substituted constant variable: a34158 
o|substituted constant variable: a34160 
o|substituted constant variable: a34162 
o|substituted constant variable: a34164 
o|substituted constant variable: a34166 
o|substituted constant variable: a34168 
o|substituted constant variable: a34170 
o|substituted constant variable: a34172 
o|substituted constant variable: a34174 
o|substituted constant variable: a34176 
o|substituted constant variable: a34178 
o|substituted constant variable: a34180 
o|substituted constant variable: a34182 
o|substituted constant variable: a34184 
o|substituted constant variable: a34186 
o|substituted constant variable: a34188 
o|substituted constant variable: a34190 
o|substituted constant variable: a34192 
o|substituted constant variable: a34194 
o|substituted constant variable: a34196 
o|substituted constant variable: a34198 
o|substituted constant variable: a34200 
o|substituted constant variable: a34202 
o|substituted constant variable: a34204 
o|substituted constant variable: a34206 
o|substituted constant variable: a34208 
o|substituted constant variable: a34210 
o|substituted constant variable: a34212 
o|substituted constant variable: a34214 
o|substituted constant variable: a34216 
o|substituted constant variable: a34218 
o|substituted constant variable: a34220 
o|substituted constant variable: a34222 
o|substituted constant variable: a34224 
o|substituted constant variable: a34226 
o|substituted constant variable: a34228 
o|substituted constant variable: a34230 
o|substituted constant variable: a34232 
o|substituted constant variable: a34234 
o|substituted constant variable: a34236 
o|substituted constant variable: a34238 
o|substituted constant variable: a34240 
o|substituted constant variable: a34242 
o|substituted constant variable: a34244 
o|substituted constant variable: a34246 
o|substituted constant variable: a34248 
o|substituted constant variable: a34250 
o|substituted constant variable: a34252 
o|substituted constant variable: a34254 
o|substituted constant variable: a34256 
o|substituted constant variable: a34258 
o|substituted constant variable: a34260 
o|substituted constant variable: a34262 
o|substituted constant variable: a34264 
o|substituted constant variable: a34266 
o|substituted constant variable: a34268 
o|inlining procedure: k34435 
o|inlining procedure: k34435 
o|inlining procedure: k34453 
o|inlining procedure: k34453 
o|inlining procedure: k34500 
o|inlining procedure: k34500 
o|inlining procedure: k34506 
o|inlining procedure: k34506 
o|inlining procedure: k34559 
o|inlining procedure: k34559 
o|inlining procedure: k34601 
o|inlining procedure: k34601 
o|inlining procedure: k34678 
o|inlining procedure: k34678 
o|contracted procedure: "(library.scm:6553) fetch7716" 
o|contracted procedure: "(library.scm:6570) free7735" 
o|inlining procedure: k34725 
o|inlining procedure: k34725 
o|inlining procedure: k34742 
o|inlining procedure: k34742 
o|contracted procedure: "(library.scm:6565) fetch7734" 
o|inlining procedure: k34795 
o|inlining procedure: k34795 
o|propagated global variable: ct7824 ##sys#current-thread 
o|inlining procedure: k34946 
o|inlining procedure: k34946 
o|inlining procedure: k34970 
o|inlining procedure: k34994 
o|inlining procedure: k34994 
o|inlining procedure: k34970 
o|inlining procedure: k35025 
o|inlining procedure: k35025 
o|inlining procedure: k35084 
o|inlining procedure: k35084 
o|inlining procedure: k35112 
o|inlining procedure: k35112 
o|inlining procedure: k35169 
o|inlining procedure: k35169 
o|inlining procedure: k35209 
o|inlining procedure: k35221 
o|inlining procedure: k35221 
o|inlining procedure: k35209 
o|inlining procedure: k35248 
o|inlining procedure: k35248 
o|inlining procedure: k35294 
o|inlining procedure: k35294 
o|substituted constant variable: a35351 
o|inlining procedure: k35344 
o|inlining procedure: k35344 
o|substituted constant variable: a35364 
o|inlining procedure: k35375 
o|inlining procedure: k35415 
o|inlining procedure: k35453 
o|inlining procedure: k35453 
o|inlining procedure: k35415 
o|inlining procedure: k35546 
o|inlining procedure: k35546 
o|substituted constant variable: a35607 
o|substituted constant variable: a35609 
o|substituted constant variable: a35617 
o|substituted constant variable: a35622 
o|substituted constant variable: a35624 
o|substituted constant variable: a35638 
o|inlining procedure: k35631 
o|inlining procedure: k35631 
o|substituted constant variable: a35651 
o|inlining procedure: k35375 
o|substituted constant variable: a35666 
o|substituted constant variable: a35668 
o|inlining procedure: k35682 
o|inlining procedure: k35682 
o|contracted procedure: "(library.scm:6962) chicken.process-context#_getenv" 
o|inlining procedure: k35753 
o|inlining procedure: k35753 
o|inlining procedure: k35784 
o|substituted constant variable: a35796 
o|inlining procedure: k35793 
o|inlining procedure: k35793 
o|inlining procedure: k35784 
o|contracted procedure: "(library.scm:6987) chicken.process-context#get-environment-entry" 
o|inlining procedure: k35859 
o|inlining procedure: k35859 
o|inlining procedure: k35873 
o|inlining procedure: k35873 
o|contracted procedure: "(library.scm:7016) fetch-arg8109" 
o|inlining procedure: k35946 
o|inlining procedure: k35966 
o|inlining procedure: k35966 
o|inlining procedure: k35993 
o|inlining procedure: k35993 
o|inlining procedure: k35946 
o|inlining procedure: k36016 
o|inlining procedure: k36016 
o|inlining procedure: k36059 
o|inlining procedure: k36059 
o|inlining procedure: k36087 
o|inlining procedure: k36087 
o|inlining procedure: k36125 
o|inlining procedure: k36125 
o|inlining procedure: k36163 
o|inlining procedure: k36163 
o|inlining procedure: k36175 
o|inlining procedure: k36175 
o|inlining procedure: k36204 
o|inlining procedure: k36204 
o|inlining procedure: k36304 
o|inlining procedure: k36304 
o|inlining procedure: k36335 
o|inlining procedure: k36335 
o|inlining procedure: k36357 
o|inlining procedure: k36357 
o|inlining procedure: k36397 
o|inlining procedure: k36397 
o|inlining procedure: k36422 
o|inlining procedure: k36422 
o|inlining procedure: k36444 
o|inlining procedure: k36444 
o|inlining procedure: k36476 
o|inlining procedure: k36476 
o|inlining procedure: k36508 
o|inlining procedure: k36508 
o|inlining procedure: k36540 
o|inlining procedure: k36540 
o|inlining procedure: k36572 
o|inlining procedure: k36572 
o|substituted constant variable: a36620 
o|substituted constant variable: a36622 
o|substituted constant variable: a36624 
o|substituted constant variable: a36626 
o|substituted constant variable: a36628 
o|substituted constant variable: a36630 
o|substituted constant variable: a36632 
o|substituted constant variable: a36634 
o|substituted constant variable: a36636 
o|substituted constant variable: a36638 
o|inlining procedure: k36639 
o|inlining procedure: k36639 
o|inlining procedure: k36697 
o|inlining procedure: k36697 
o|inlining procedure: k36714 
o|inlining procedure: k36738 
o|inlining procedure: k36738 
o|inlining procedure: k36714 
o|inlining procedure: k36781 
o|inlining procedure: k36781 
o|inlining procedure: k36844 
o|inlining procedure: k36844 
o|inlining procedure: k36876 
o|inlining procedure: "(library.scm:7394) pstr8485" 
o|substituted constant variable: a36897 
o|inlining procedure: k36876 
o|inlining procedure: "(library.scm:7396) pstr8485" 
o|substituted constant variable: a36919 
o|inlining procedure: k36920 
o|inlining procedure: "(library.scm:7398) pstr8485" 
o|substituted constant variable: a36941 
o|inlining procedure: k36920 
o|inlining procedure: "(library.scm:7399) pstr8485" 
o|inlining procedure: "(library.scm:7425) pstr8485" 
o|inlining procedure: "(library.scm:7423) pstr8485" 
o|inlining procedure: "(library.scm:7421) pchr8486" 
o|inlining procedure: "(library.scm:7419) pstr8485" 
o|inlining procedure: "(library.scm:7415) pstr8485" 
o|inlining procedure: "(library.scm:7413) pchr8486" 
o|inlining procedure: "(library.scm:7411) pstr8485" 
o|inlining procedure: "(library.scm:7407) pstr8485" 
o|inlining procedure: "(library.scm:7405) pstr8485" 
o|inlining procedure: "(library.scm:7402) pstr8485" 
o|inlining procedure: k37147 
o|inlining procedure: k37169 
o|inlining procedure: k37169 
o|contracted procedure: "(library.scm:7501) get-config8590" 
o|inlining procedure: k37114 
o|inlining procedure: k37114 
o|substituted constant variable: a37127 
o|inlining procedure: k37203 
o|inlining procedure: k37203 
o|inlining procedure: k37147 
o|propagated global variable: r3714843976 ##sys#build-version 
o|inlining procedure: k37237 
o|inlining procedure: k37237 
o|inlining procedure: k37257 
o|inlining procedure: k37257 
o|inlining procedure: k37285 
o|inlining procedure: k37285 
o|inlining procedure: k37356 
o|inlining procedure: k37356 
o|substituted constant variable: a37371 
o|substituted constant variable: a37373 
o|removed side-effect free assignment to unused variable: prefix8717 
o|inlining procedure: k37406 
o|inlining procedure: k37406 
o|inlining procedure: k37421 
o|inlining procedure: k37421 
o|contracted procedure: "(library.scm:7598) err8716" 
o|inlining procedure: k37444 
o|inlining procedure: k37444 
o|inlining procedure: k37523 
o|contracted procedure: "(library.scm:7644) g87518758" 
o|inlining procedure: k37507 
o|inlining procedure: k37507 
o|inlining procedure: k37523 
o|inlining procedure: k37559 
o|inlining procedure: k37559 
o|inlining procedure: k37590 
o|inlining procedure: k37590 
o|inlining procedure: k37633 
o|inlining procedure: k37633 
o|inlining procedure: k37664 
o|inlining procedure: k37664 
o|inlining procedure: k37676 
o|inlining procedure: k37676 
o|inlining procedure: k37688 
o|inlining procedure: k37688 
o|inlining procedure: k37697 
o|inlining procedure: k37697 
o|inlining procedure: k37706 
o|inlining procedure: k37706 
o|inlining procedure: k37736 
o|contracted procedure: "(library.scm:7692) g88718880" 
o|inlining procedure: k37736 
o|inlining procedure: k37785 
o|inlining procedure: k37785 
o|inlining procedure: k37829 
o|inlining procedure: k37829 
o|inlining procedure: k37867 
o|inlining procedure: k37879 
o|inlining procedure: k37879 
o|inlining procedure: k37867 
o|inlining procedure: k37941 
o|inlining procedure: k37941 
o|inlining procedure: k37966 
o|inlining procedure: k37966 
o|inlining procedure: k38045 
o|inlining procedure: k38045 
o|inlining procedure: k38080 
o|inlining procedure: k38080 
o|inlining procedure: k38170 
o|contracted procedure: "(library.scm:7778) %string-map8999" 
o|inlining procedure: k38139 
o|inlining procedure: k38139 
o|inlining procedure: k38170 
o|inlining procedure: k38214 
o|inlining procedure: k38214 
o|inlining procedure: k38249 
o|inlining procedure: k38249 
o|inlining procedure: k38283 
o|inlining procedure: k38283 
o|inlining procedure: k38307 
o|inlining procedure: k38307 
o|inlining procedure: k38341 
o|contracted procedure: "(library.scm:7781) g90149021" 
o|inlining procedure: k38341 
o|inlining procedure: k38396 
o|contracted procedure: "(library.scm:7797) %string-for-each9125" 
o|inlining procedure: k38376 
o|inlining procedure: k38376 
o|inlining procedure: k38396 
o|inlining procedure: k38440 
o|inlining procedure: k38440 
o|inlining procedure: k38471 
o|inlining procedure: k38471 
o|inlining procedure: k38505 
o|inlining procedure: k38505 
o|inlining procedure: k38529 
o|inlining procedure: k38529 
o|inlining procedure: k38563 
o|contracted procedure: "(library.scm:7800) g91379144" 
o|inlining procedure: k38563 
o|inlining procedure: k38586 
o|inlining procedure: k38610 
o|inlining procedure: k38610 
o|inlining procedure: k38586 
o|inlining procedure: k38669 
o|inlining procedure: k38669 
o|inlining procedure: k38704 
o|inlining procedure: k38704 
o|inlining procedure: k38738 
o|inlining procedure: k38738 
o|inlining procedure: k38762 
o|inlining procedure: k38762 
o|inlining procedure: k38796 
o|contracted procedure: "(library.scm:7820) g92659272" 
o|inlining procedure: k38796 
o|inlining procedure: k38819 
o|inlining procedure: k38840 
o|inlining procedure: k38840 
o|inlining procedure: k38819 
o|inlining procedure: k38895 
o|inlining procedure: k38895 
o|inlining procedure: k38926 
o|inlining procedure: k38926 
o|inlining procedure: k38960 
o|inlining procedure: k38960 
o|inlining procedure: k38984 
o|inlining procedure: k38984 
o|inlining procedure: k39018 
o|contracted procedure: "(library.scm:7839) g93919398" 
o|inlining procedure: k39018 
o|inlining procedure: k39047 
o|inlining procedure: k39047 
o|inlining procedure: k39101 
o|inlining procedure: k39101 
o|substituted constant variable: a39130 
o|substituted constant variable: a39131 
o|inlining procedure: k39135 
o|inlining procedure: k39135 
o|substituted constant variable: c9526 
o|substituted constant variable: a39172 
o|substituted constant variable: a39173 
o|substituted constant variable: a39273 
o|substituted constant variable: a39274 
o|inlining procedure: k39285 
o|inlining procedure: k39285 
o|inlining procedure: k39312 
o|inlining procedure: k39312 
o|substituted constant variable: a39367 
o|substituted constant variable: a39368 
o|inlining procedure: k39372 
o|inlining procedure: k39372 
o|inlining procedure: k39395 
o|inlining procedure: k39395 
o|inlining procedure: k39413 
o|inlining procedure: k39413 
o|inlining procedure: k39422 
o|inlining procedure: k39422 
o|inlining procedure: k39440 
o|inlining procedure: k39440 
o|substituted constant variable: a39484 
o|substituted constant variable: a39486 
o|inlining procedure: k39494 
o|inlining procedure: k39494 
o|substituted constant variable: a39526 
o|substituted constant variable: a39527 
o|inlining procedure: k39541 
o|inlining procedure: k39541 
o|substituted constant variable: a39607 
o|substituted constant variable: a39608 
o|inlining procedure: k39642 
o|inlining procedure: k39642 
o|inlining procedure: k39663 
o|inlining procedure: k39663 
o|inlining procedure: k39735 
o|inlining procedure: k39735 
o|inlining procedure: k39759 
o|inlining procedure: k39759 
o|inlining procedure: k39795 
o|inlining procedure: k39795 
o|inlining procedure: k39840 
o|inlining procedure: k39840 
o|substituted constant variable: a39888 
o|substituted constant variable: a39889 
o|substituted constant variable: a39969 
o|substituted constant variable: a39970 
o|inlining procedure: k39990 
o|inlining procedure: k39990 
o|inlining procedure: k40035 
o|inlining procedure: k40035 
o|inlining procedure: k40047 
o|inlining procedure: k40047 
o|inlining procedure: k40101 
o|inlining procedure: k40101 
o|substituted constant variable: len9807 
o|substituted constant variable: len9807 
o|inlining procedure: k40140 
o|inlining procedure: k40140 
o|substituted constant variable: a40165 
o|substituted constant variable: a40166 
o|inlining procedure: k40167 
o|inlining procedure: k40167 
o|substituted constant variable: a40216 
o|substituted constant variable: a40217 
o|inlining procedure: k40218 
o|inlining procedure: k40218 
o|inlining procedure: k40243 
o|inlining procedure: k40243 
o|substituted constant variable: a40287 
o|substituted constant variable: a40288 
o|inlining procedure: k40292 
o|inlining procedure: k40292 
o|substituted constant variable: a40315 
o|substituted constant variable: a40316 
o|inlining procedure: k40329 
o|inlining procedure: k40329 
o|substituted constant variable: a40371 
o|substituted constant variable: a40372 
o|inlining procedure: k40379 
o|inlining procedure: k40379 
o|substituted constant variable: a40401 
o|substituted constant variable: a40402 
o|substituted constant variable: a40447 
o|substituted constant variable: a40448 
o|substituted constant variable: a40550 
o|contracted procedure: "(library.scm:7578) g86858686" 
o|inlining procedure: k40617 
o|inlining procedure: k40617 
o|inlining procedure: k40662 
o|inlining procedure: k40662 
o|inlining procedure: k40684 
o|inlining procedure: k40701 
o|contracted procedure: "(library.scm:7561) g86498656" 
o|inlining procedure: k40701 
o|inlining procedure: k40684 
o|inlining procedure: k40727 
o|inlining procedure: k40727 
o|inlining procedure: k40801 
o|inlining procedure: k40801 
o|inlining procedure: k40848 
o|inlining procedure: k40848 
o|substituted constant variable: a40863 
o|inlining procedure: k40865 
o|inlining procedure: k40865 
o|substituted constant variable: a40877 
o|inlining procedure: k40919 
o|inlining procedure: k40919 
o|inlining procedure: k40956 
o|inlining procedure: k40980 
o|inlining procedure: k40980 
o|inlining procedure: k41010 
o|contracted procedure: "(library.scm:6067) g70797086" 
o|inlining procedure: k41010 
o|inlining procedure: k40956 
o|inlining procedure: k41065 
o|inlining procedure: k41065 
o|inlining procedure: k41116 
o|inlining procedure: k41116 
o|inlining procedure: k41143 
o|inlining procedure: k41143 
o|inlining procedure: k41165 
o|inlining procedure: k41165 
o|inlining procedure: k41240 
o|inlining procedure: k41240 
o|inlining procedure: k41266 
o|inlining procedure: k41266 
o|inlining procedure: k41347 
o|inlining procedure: k41347 
o|inlining procedure: k41369 
o|inlining procedure: k41369 
o|inlining procedure: k41514 
o|inlining procedure: k41514 
o|inlining procedure: k41523 
o|inlining procedure: k41523 
o|inlining procedure: k41532 
o|inlining procedure: k41532 
o|inlining procedure: k41548 
o|inlining procedure: k41548 
o|inlining procedure: k41574 
o|inlining procedure: k41603 
o|inlining procedure: k41603 
o|inlining procedure: k41574 
o|inlining procedure: k41641 
o|inlining procedure: k41641 
o|inlining procedure: k41660 
o|inlining procedure: k41660 
o|inlining procedure: k41719 
o|inlining procedure: k41719 
o|inlining procedure: k41749 
o|inlining procedure: k41749 
o|inlining procedure: k41819 
o|inlining procedure: k41819 
o|inlining procedure: k41834 
o|inlining procedure: k41834 
o|inlining procedure: k41861 
o|inlining procedure: k41861 
o|inlining procedure: k41933 
o|inlining procedure: k41933 
o|inlining procedure: k41951 
o|inlining procedure: k41951 
o|inlining procedure: k41987 
o|inlining procedure: k41987 
o|substituted constant variable: sblen4917 
o|substituted constant variable: sblen4917 
o|replaced variables: 8399 
o|removed binding forms: 2444 
o|removed side-effect free assignment to unused variable: c9526 
o|substituted constant variable: r1149442102 
o|substituted constant variable: r1149442102 
o|substituted constant variable: r1153942108 
o|substituted constant variable: r1153942108 
o|substituted constant variable: r1190242114 
o|substituted constant variable: r1195242118 
o|substituted constant variable: r1203142124 
o|substituted constant variable: r1203142124 
o|substituted constant variable: r1206442130 
o|substituted constant variable: r1206442130 
o|substituted constant variable: r1221642136 
o|substituted constant variable: r1221642136 
o|substituted constant variable: r1225542142 
o|substituted constant variable: r1225542142 
o|substituted constant variable: r1229442148 
o|substituted constant variable: r1229442148 
o|substituted constant variable: r1233342154 
o|substituted constant variable: r1233342154 
o|substituted constant variable: r1237242160 
o|substituted constant variable: r1237242160 
o|substituted constant variable: r1242842163 
o|substituted constant variable: r1244942165 
o|substituted constant variable: r1245542167 
o|substituted constant variable: r1246142169 
o|substituted constant variable: r1247742171 
o|substituted constant variable: r1249342173 
o|inlining procedure: k12817 
o|substituted constant variable: r1288142187 
o|substituted constant variable: r1303442198 
o|substituted constant variable: r1304642201 
o|substituted constant variable: r1314742206 
o|substituted constant variable: r1321142211 
o|substituted constant variable: r1328442214 
o|substituted constant variable: r1333842218 
o|substituted constant variable: r1348042227 
o|substituted constant variable: r1367242236 
o|substituted constant variable: r1374942241 
o|substituted constant variable: r1388842244 
o|substituted constant variable: r1390142246 
o|converted assignments to bindings: (fail1334) 
o|substituted constant variable: r1449942296 
o|substituted constant variable: r1449942296 
o|substituted constant variable: r1451642302 
o|substituted constant variable: r1451642302 
o|substituted constant variable: r1453942307 
o|substituted constant variable: r1453942307 
o|substituted constant variable: r1455742314 
o|substituted constant variable: r1455742314 
o|substituted constant variable: r1459942324 
o|substituted constant variable: r1459942324 
o|substituted constant variable: r1470242335 
o|substituted constant variable: r1498542346 
o|substituted constant variable: r1498542346 
o|substituted constant variable: r1517042365 
o|substituted constant variable: r1532342368 
o|substituted constant variable: r1532342368 
o|substituted constant variable: r1593342397 
o|substituted constant variable: r1599842402 
o|substituted constant variable: r1599842402 
o|substituted constant variable: r1615642416 
o|substituted constant variable: r1615642416 
o|substituted constant variable: r1639242428 
o|substituted constant variable: loc2350 
o|substituted constant variable: loc2361 
o|substituted constant variable: loc2372 
o|substituted constant variable: loc2383 
o|substituted constant variable: r1658142445 
o|substituted constant variable: loc2402 
o|substituted constant variable: loc2413 
o|substituted constant variable: loc2424 
o|substituted constant variable: loc2435 
o|substituted constant variable: loc2446 
o|substituted constant variable: loc2457 
o|substituted constant variable: loc2468 
o|substituted constant variable: loc2477 
o|substituted constant variable: loc2487 
o|substituted constant variable: loc2498 
o|substituted constant variable: loc2507 
o|substituted constant variable: loc2515 
o|substituted constant variable: loc2523 
o|substituted constant variable: loc2531 
o|substituted constant variable: loc2539 
o|substituted constant variable: loc2547 
o|substituted constant variable: loc2555 
o|substituted constant variable: loc2563 
o|substituted constant variable: loc2571 
o|substituted constant variable: loc2579 
o|substituted constant variable: loc2589 
o|substituted constant variable: loc2598 
o|substituted constant variable: loc2606 
o|substituted constant variable: loc2614 
o|substituted constant variable: loc2622 
o|substituted constant variable: loc2630 
o|substituted constant variable: loc2638 
o|substituted constant variable: loc2646 
o|substituted constant variable: loc2656 
o|substituted constant variable: loc2665 
o|substituted constant variable: loc2673 
o|substituted constant variable: loc2681 
o|substituted constant variable: loc2689 
o|inlining procedure: k17284 
o|inlining procedure: k17284 
o|substituted constant variable: r1729842519 
o|substituted constant variable: r1737942524 
o|substituted constant variable: r1754342538 
o|converted assignments to bindings: (deliver2867) 
o|substituted constant variable: n3064 
o|substituted constant variable: d3065 
o|substituted constant variable: r1881542613 
o|substituted constant variable: r1882442615 
o|substituted constant variable: r1885742619 
o|substituted constant variable: r1886642621 
o|substituted constant variable: r1983542671 
o|substituted constant variable: r1994342678 
o|substituted constant variable: r2000842682 
o|substituted constant variable: r2018042689 
o|substituted constant variable: r2030842691 
o|substituted constant variable: r2030842691 
o|substituted constant variable: r2030842693 
o|substituted constant variable: r2030842693 
o|inlining procedure: k20344 
o|inlining procedure: k20344 
o|substituted constant variable: r2037242700 
o|substituted constant variable: r2038842703 
o|substituted constant variable: r2038842704 
o|substituted constant variable: r2035142709 
o|removed side-effect free assignment to unused variable: make-nan3520 
o|substituted constant variable: r2057242721 
o|substituted constant variable: r2059242723 
o|substituted constant variable: r2061442725 
o|substituted constant variable: r2062542727 
o|substituted constant variable: r2068042729 
o|substituted constant variable: r2068042730 
o|substituted constant variable: r2063942731 
o|substituted constant variable: r2074342744 
o|substituted constant variable: r2073142745 
o|substituted constant variable: r2069242761 
o|substituted constant variable: r2100942771 
o|substituted constant variable: r2099942772 
o|substituted constant variable: r2098742773 
o|substituted constant variable: r2107342781 
o|substituted constant variable: r2105542782 
o|substituted constant variable: r2104542783 
o|substituted constant variable: r2122742794 
o|substituted constant variable: r2130142798 
o|substituted constant variable: r2130142798 
o|substituted constant variable: r2130142800 
o|substituted constant variable: r2130142800 
o|substituted constant variable: r2132442805 
o|substituted constant variable: r2132442805 
o|substituted constant variable: r2141142813 
o|substituted constant variable: r2141142813 
o|substituted constant variable: r2138642816 
o|substituted constant variable: r2146342817 
o|substituted constant variable: r2146342818 
o|substituted constant variable: r2124642819 
o|substituted constant variable: r2150142824 
o|substituted constant variable: r2147942825 
o|substituted constant variable: r2152442829 
o|substituted constant variable: r2159442833 
o|substituted constant variable: r2157942834 
o|substituted constant variable: r2163742837 
o|substituted constant variable: r2175142840 
o|substituted constant variable: r2179542844 
o|substituted constant variable: r2183942848 
o|substituted constant variable: r2185242850 
o|substituted constant variable: r2194742857 
o|substituted constant variable: r2202042861 
o|substituted constant variable: r2210642866 
o|substituted constant variable: r2211842868 
o|substituted constant variable: r2212742871 
o|substituted constant variable: r2215342875 
o|substituted constant variable: r2217242877 
o|substituted constant variable: r2255242913 
o|substituted constant variable: r2267342915 
o|substituted constant variable: r2275942921 
o|substituted constant variable: r2284442925 
o|substituted constant variable: r2304942938 
o|substituted constant variable: r2377842970 
o|substituted constant variable: r2377842970 
o|substituted constant variable: r2382542976 
o|substituted constant variable: r2382542976 
o|substituted constant variable: r2386842982 
o|substituted constant variable: r2386842982 
o|substituted constant variable: r2391142988 
o|substituted constant variable: r2391142988 
o|substituted constant variable: r2395442994 
o|substituted constant variable: r2395442994 
o|substituted constant variable: r2397742997 
o|substituted constant variable: r2410843003 
o|removed call to pure procedure with unused result: "(library.scm:3844) ##sys#slot" 
o|substituted constant variable: r2445143023 
o|removed call to pure procedure with unused result: "(library.scm:3855) ##sys#slot" 
o|converted assignments to bindings: (continuation4796) 
o|removed unused formal parameters: (%convert?49624977) 
o|removed unused parameter to known procedure: %convert?49624977 "(library.scm:4145) def-set?49674976" 
o|removed unused parameter to known procedure: %convert?49624977 "(library.scm:4145) def-set?49674976" 
o|removed unused formal parameters: (%convert?49875002) 
o|removed unused parameter to known procedure: %convert?49875002 "(library.scm:4155) def-set?49925001" 
o|removed unused parameter to known procedure: %convert?49875002 "(library.scm:4155) def-set?49925001" 
o|removed unused formal parameters: (%convert?50125027) 
o|removed unused parameter to known procedure: %convert?50125027 "(library.scm:4165) def-set?50175026" 
o|removed unused parameter to known procedure: %convert?50125027 "(library.scm:4165) def-set?50175026" 
o|substituted constant variable: r2492243063 
o|substituted constant variable: r2499343068 
o|substituted constant variable: r2499343068 
o|substituted constant variable: r2499343070 
o|substituted constant variable: r2499343070 
o|substituted constant variable: r2536043088 
o|substituted constant variable: r2541343091 
o|substituted constant variable: r2550743097 
o|substituted constant variable: r2555243099 
o|substituted constant variable: r2559143101 
o|substituted constant variable: r2565143105 
o|inlining procedure: k25978 
o|substituted constant variable: r2604543120 
o|inlining procedure: k26056 
o|substituted constant variable: r2709543183 
o|inlining procedure: k27425 
o|converted assignments to bindings: (starting-line5699) 
o|substituted constant variable: r2752443238 
o|substituted constant variable: r2752443238 
o|substituted constant variable: r2786043269 
o|substituted constant variable: r2787943273 
o|substituted constant variable: r2802743287 
o|substituted constant variable: r2802743288 
o|inlining procedure: k28120 
o|inlining procedure: k28120 
o|inlining procedure: k28120 
o|substituted constant variable: r2811843296 
o|substituted constant variable: r2810043297 
o|removed side-effect free assignment to unused variable: build-symbol5569 
o|substituted constant variable: r2863343335 
o|substituted constant variable: r2896443359 
o|substituted constant variable: r2925043386 
o|substituted constant variable: r2926943387 
o|substituted constant variable: r2926943387 
o|substituted constant variable: r2926943389 
o|substituted constant variable: r2926943389 
o|substituted constant variable: r2933843396 
o|converted assignments to bindings: (fail6122) 
o|propagated global variable: port621343414 ##sys#standard-output 
o|substituted constant variable: r3008443439 
o|substituted constant variable: r3009843441 
o|substituted constant variable: r3011343443 
o|substituted constant variable: r3011343444 
o|substituted constant variable: r3017843449 
o|substituted constant variable: r3019443450 
o|substituted constant variable: r3020943452 
o|substituted constant variable: r3020943453 
o|inlining procedure: k30221 
o|substituted constant variable: r3022243456 
o|substituted constant variable: r3022243456 
o|folded constant expression: (scheme#not (quote #f)) 
o|substituted constant variable: r3025943460 
o|inlining procedure: k30734 
o|substituted constant variable: r3094743512 
o|substituted constant variable: r3096443514 
o|inlining procedure: k31104 
o|substituted constant variable: r3154143540 
o|substituted constant variable: r3169143549 
o|converted assignments to bindings: (break6922) 
o|substituted constant variable: r3224443581 
o|substituted constant variable: r3224443581 
o|substituted constant variable: r3224443583 
o|substituted constant variable: r3224443583 
o|substituted constant variable: r3229743589 
o|substituted constant variable: r3230943591 
o|substituted constant variable: r3232143593 
o|substituted constant variable: r3233343595 
o|substituted constant variable: r3234543597 
o|substituted constant variable: r3235743599 
o|substituted constant variable: r3236943601 
o|substituted constant variable: r3236943602 
o|substituted constant variable: r3254643608 
o|substituted constant variable: r3254643608 
o|inlining procedure: k32571 
o|inlining procedure: k32571 
o|removed unused formal parameters: (%convert?71657180) 
o|removed unused parameter to known procedure: %convert?71657180 "(library.scm:6142) def-set?71707179" 
o|removed unused parameter to known procedure: %convert?71657180 "(library.scm:6142) def-set?71707179" 
o|substituted constant variable: r3273043625 
o|substituted constant variable: r3307943637 
o|substituted constant variable: r3317743642 
o|substituted constant variable: r3320743646 
o|substituted constant variable: r3356843672 
o|substituted constant variable: r3356843672 
o|substituted constant variable: r3360543677 
o|substituted constant variable: r3360543677 
o|substituted constant variable: r3411943735 
o|substituted constant variable: r3411943735 
o|substituted constant variable: r3443643740 
o|substituted constant variable: r3445443742 
o|substituted constant variable: r3450743746 
o|substituted constant variable: r3460243750 
o|substituted constant variable: r3467943751 
o|substituted constant variable: r3472643755 
o|substituted constant variable: r3472643755 
o|substituted constant variable: r3474343757 
o|substituted constant variable: r3497143768 
o|inlining procedure: k35049 
o|inlining procedure: k35303 
o|converted assignments to bindings: (get/clear-str7969) 
o|substituted constant variable: r3575443806 
o|substituted constant variable: r3575443806 
o|substituted constant variable: r3578543812 
o|inlining procedure: k35946 
o|inlining procedure: k35946 
o|substituted constant variable: r3601743842 
o|substituted constant variable: r3671543884 
o|removed side-effect free assignment to unused variable: pstr8485 
o|removed side-effect free assignment to unused variable: pchr8486 
o|substituted constant variable: r3684543887 
o|substituted constant variable: r3684543887 
o|substituted constant variable: str849043893 
o|substituted constant variable: str849043899 
o|substituted constant variable: str849043905 
o|substituted constant variable: str849043911 
o|substituted constant variable: str849043916 
o|substituted constant variable: str849043921 
o|substituted constant variable: chr849143926 
o|substituted constant variable: str849043931 
o|substituted constant variable: str849043936 
o|substituted constant variable: chr849143941 
o|substituted constant variable: str849043946 
o|substituted constant variable: str849043951 
o|substituted constant variable: str849043956 
o|substituted constant variable: str849043961 
o|substituted constant variable: r3717043966 
o|substituted constant variable: r3717043966 
o|substituted constant variable: r3711543970 
o|converted assignments to bindings: (str8595) 
o|substituted constant variable: r3720443972 
o|substituted constant variable: r3720443972 
o|substituted constant variable: r3720443974 
o|substituted constant variable: r3720443974 
o|substituted constant variable: r3725843981 
o|substituted constant variable: r3756043998 
o|substituted constant variable: r3767744007 
o|substituted constant variable: r3770744013 
o|substituted constant variable: r3931344105 
o|substituted constant variable: r3949544117 
o|substituted constant variable: r3964344120 
o|substituted constant variable: r4003644136 
o|substituted constant variable: r4024444156 
o|substituted constant variable: r4029344159 
o|substituted constant variable: r4038044162 
o|inlining procedure: k40662 
o|substituted constant variable: r4068544173 
o|substituted constant variable: r4084944178 
o|substituted constant variable: r4114444194 
o|substituted constant variable: r4116644196 
o|substituted constant variable: r4126744202 
o|substituted constant variable: r4134844204 
o|removed call to pure procedure with unused result: "(library.scm:5726) ##sys#slot" 
o|substituted constant variable: r4152444213 
o|substituted constant variable: r4153344215 
o|substituted constant variable: r4154944217 
o|substituted constant variable: r4160444220 
o|converted assignments to bindings: (lookup-char4648) 
o|simplifications: ((let . 10)) 
o|replaced variables: 694 
o|removed binding forms: 6912 
o|removed conditional forms: 1 
o|inlining procedure: k12799 
o|substituted constant variable: r1281844284 
o|substituted constant variable: r1281844284 
o|inlining procedure: k14273 
o|inlining procedure: k14273 
o|inlining procedure: k14273 
o|inlining procedure: k14747 
o|inlining procedure: k14763 
o|inlining procedure: k14779 
o|inlining procedure: k14795 
o|inlining procedure: k14811 
o|inlining procedure: k14827 
o|inlining procedure: k14843 
o|inlining procedure: k14859 
o|inlining procedure: k16489 
o|inlining procedure: k16513 
o|inlining procedure: k16537 
o|inlining procedure: k16561 
o|inlining procedure: k16610 
o|inlining procedure: k16634 
o|inlining procedure: k16658 
o|inlining procedure: k16682 
o|inlining procedure: k16706 
o|inlining procedure: k16730 
o|inlining procedure: k16754 
o|inlining procedure: k16772 
o|inlining procedure: k16796 
o|inlining procedure: k16820 
o|inlining procedure: k16838 
o|inlining procedure: k16856 
o|inlining procedure: k16874 
o|inlining procedure: k16892 
o|inlining procedure: k16910 
o|inlining procedure: k16928 
o|inlining procedure: k16946 
o|inlining procedure: k16964 
o|inlining procedure: k16982 
o|inlining procedure: k17000 
o|inlining procedure: k17024 
o|inlining procedure: k17042 
o|inlining procedure: k17060 
o|inlining procedure: k17078 
o|inlining procedure: k17096 
o|inlining procedure: k17114 
o|inlining procedure: k17132 
o|inlining procedure: k17150 
o|inlining procedure: k17174 
o|inlining procedure: k17192 
o|inlining procedure: k17210 
o|inlining procedure: k17228 
o|inlining procedure: k17246 
o|inlining procedure: k17485 
o|inlining procedure: k17597 
o|inlining procedure: k17666 
o|inlining procedure: k17758 
o|inlining procedure: k17764 
o|inlining procedure: k17865 
o|inlining procedure: k18088 
o|inlining procedure: k18158 
o|inlining procedure: k18203 
o|inlining procedure: k18240 
o|inlining procedure: k18271 
o|inlining procedure: k18271 
o|inlining procedure: k18284 
o|inlining procedure: k18452 
o|inlining procedure: k18593 
o|inlining procedure: k19235 
o|inlining procedure: k19259 
o|inlining procedure: k19551 
o|inlining procedure: k19674 
o|inlining procedure: k19682 
o|inlining procedure: k19720 
o|inlining procedure: k19738 
o|inlining procedure: k19891 
o|inlining procedure: k19920 
o|inlining procedure: k20135 
o|inlining procedure: k20142 
o|inlining procedure: k20601 
o|inlining procedure: k21102 
o|inlining procedure: k21493 
o|inlining procedure: k21493 
o|inlining procedure: k21535 
o|inlining procedure: k21940 
o|inlining procedure: k21940 
o|inlining procedure: k21973 
o|inlining procedure: k22293 
o|inlining procedure: k22293 
o|inlining procedure: k22604 
o|contracted procedure: k24348 
o|contracted procedure: k24444 
o|inlining procedure: k25007 
o|inlining procedure: k25007 
o|inlining procedure: k25007 
o|inlining procedure: k25007 
o|inlining procedure: k25007 
o|inlining procedure: k25007 
o|inlining procedure: k25007 
o|inlining procedure: k25394 
o|propagated global variable: r2539545411 ##sys#standard-output 
o|propagated global variable: r2539545411 ##sys#standard-output 
o|inlining procedure: k25957 
o|propagated global variable: r2595845419 ##sys#standard-input 
o|propagated global variable: r2595845419 ##sys#standard-input 
o|inlining procedure: k26069 
o|propagated global variable: r2607045421 ##sys#standard-input 
o|propagated global variable: r2607045421 ##sys#standard-input 
o|inlining procedure: k26087 
o|propagated global variable: r2608845423 ##sys#standard-input 
o|propagated global variable: r2608845423 ##sys#standard-input 
o|inlining procedure: k27011 
o|inlining procedure: "(library.scm:4837) build-keyword5570" 
o|inlining procedure: "(library.scm:4838) build-keyword5570" 
o|inlining procedure: "(library.scm:4869) build-keyword5570" 
o|inlining procedure: "(library.scm:4929) build-keyword5570" 
o|inlining procedure: "(library.scm:5160) build-keyword5570" 
o|inlining procedure: k29654 
o|propagated global variable: r2965545483 ##sys#standard-output 
o|propagated global variable: r2965545483 ##sys#standard-output 
o|inlining procedure: k29672 
o|propagated global variable: r2967345485 ##sys#standard-output 
o|propagated global variable: r2967345485 ##sys#standard-output 
o|inlining procedure: k30066 
o|substituted constant variable: r3022244729 
o|folded constant expression: (scheme#not (quote #f)) 
o|inlining procedure: k32411 
o|inlining procedure: k34736 
o|inlining procedure: k34736 
o|inlining procedure: k35118 
o|inlining procedure: "(library.scm:6839) ##sys#format-here-doc-warning" 
o|inlining procedure: k35352 
o|inlining procedure: k35352 
o|inlining procedure: "(library.scm:6873) ##sys#format-here-doc-warning" 
o|inlining procedure: k35639 
o|inlining procedure: k35639 
o|inlining procedure: k36056 
o|inlining procedure: k36354 
o|inlining procedure: k36354 
o|inlining procedure: k36726 
o|inlining procedure: k36726 
o|inlining procedure: k37529 
o|inlining procedure: k37529 
o|inlining procedure: k40868 
o|inlining procedure: k40868 
o|contracted procedure: k41341 
o|inlining procedure: k41511 
o|inlining procedure: k41511 
o|replaced variables: 9 
o|removed binding forms: 949 
o|substituted constant variable: r1280045110 
o|substituted constant variable: r1474845151 
o|substituted constant variable: r1476445153 
o|substituted constant variable: r1478045155 
o|substituted constant variable: r1479645157 
o|substituted constant variable: r1481245159 
o|substituted constant variable: r1482845161 
o|substituted constant variable: r1484445163 
o|substituted constant variable: r1486045165 
o|contracted procedure: k17414 
o|contracted procedure: k17419 
o|contracted procedure: k17479 
o|contracted procedure: k17850 
o|contracted procedure: k17859 
o|contracted procedure: k17964 
o|contracted procedure: k17969 
o|contracted procedure: k17974 
o|contracted procedure: k17979 
o|contracted procedure: k17984 
o|contracted procedure: k17989 
o|contracted procedure: k18021 
o|contracted procedure: k18045 
o|contracted procedure: k18060 
o|contracted procedure: k18140 
o|contracted procedure: k18185 
o|contracted procedure: k18234 
o|substituted constant variable: r1827245257 
o|contracted procedure: k18576 
o|contracted procedure: k20154 
o|contracted procedure: k20159 
o|contracted procedure: k20291 
o|contracted procedure: k21406 
o|substituted constant variable: r2149445298 
o|substituted constant variable: r2194145304 
o|substituted constant variable: r2194145305 
o|substituted constant variable: r2229445309 
o|substituted constant variable: r2260545323 
o|substituted constant variable: tok593645443 
o|inlining procedure: k27381 
o|removed side-effect free assignment to unused variable: build-keyword5570 
o|substituted constant variable: r3257244782 
o|removed side-effect free assignment to unused variable: ##sys#format-here-doc-warning 
o|substituted constant variable: r3605745583 
o|substituted constant variable: r3635545593 
o|substituted constant variable: r3635545593 
o|substituted constant variable: r3672745594 
o|substituted constant variable: r3672745594 
o|substituted constant variable: r3672745595 
o|substituted constant variable: r3672745595 
o|inlining procedure: k37359 
o|inlining procedure: k37359 
o|substituted constant variable: r4086945700 
o|substituted constant variable: r4151245708 
o|substituted constant variable: r4151245708 
o|substituted constant variable: r4151245710 
o|substituted constant variable: r4151245710 
o|simplifications: ((let . 5)) 
o|replaced variables: 23 
o|removed binding forms: 133 
o|removed conditional forms: 12 
o|substituted constant variable: r2738245922 
o|substituted constant variable: r2738245922 
o|substituted constant variable: r3736046026 
o|simplifications: ((if . 1) (let . 1)) 
o|removed binding forms: 89 
o|removed conditional forms: 2 
o|simplifications: ((let . 1)) 
o|replaced variables: 2 
o|removed binding forms: 2 
o|removed binding forms: 1 
o|simplifications: ((if . 422) (let . 249) (##core#call . 3677)) 
o|  call simplifications:
o|    scheme#cdar	2
o|    scheme#set-cdr!	6
o|    scheme#list-tail
o|    ##sys#make-vector
o|    ##sys#cons	4
o|    scheme#vector-ref	2
o|    scheme#set-car!	8
o|    ##sys#generic-structure?
o|    chicken.fixnum#fx/
o|    scheme#read-char
o|    ##sys#list	6
o|    ##sys#context-switch	2
o|    ##sys#foreign-pointer-argument	3
o|    ##sys#null-pointer?
o|    scheme#caddr	3
o|    scheme#write-char
o|    scheme#equal?	2
o|    scheme#memv	2
o|    scheme#caar	3
o|    scheme#cddr	3
o|    ##sys#check-structure	2
o|    chicken.fixnum#fxmin	7
o|    ##sys#apply	2
o|    scheme#char-upper-case?
o|    ##sys#void	4
o|    scheme#string?	6
o|    scheme#string->list
o|    scheme#symbol?	8
o|    scheme#char-downcase
o|    scheme#member	8
o|    chicken.fixnum#fxior
o|    scheme#char-numeric?	9
o|    scheme#char<=?
o|    scheme#char>=?	2
o|    scheme#eof-object?	31
o|    scheme#char=?	10
o|    scheme#char-whitespace?	6
o|    scheme#vector?	3
o|    ##sys#immediate?	3
o|    chicken.fixnum#fxnot
o|    chicken.fixnum#fxand	8
o|    ##sys#call-with-current-continuation	3
o|    scheme#char?	5
o|    scheme#assq	7
o|    ##sys#check-vector	13
o|    ##sys#foreign-flonum-argument
o|    ##sys#foreign-fixnum-argument	4
o|    scheme#remainder
o|    chicken.base#fixnum?	2
o|    chicken.fixnum#fxshr	5
o|    chicken.fixnum#fxshl	5
o|    chicken.bitwise#bitwise-and	2
o|    chicken.fixnum#fxneg	5
o|    chicken.bitwise#arithmetic-shift	11
o|    scheme#>	7
o|    scheme#<	7
o|    scheme#cadr	20
o|    scheme#=	3
o|    scheme#>=	2
o|    scheme#quotient	17
o|    scheme#exact?
o|    chicken.base#ratnum?	14
o|    ##sys#check-number	10
o|    chicken.base#cplxnum?	17
o|    scheme#number?	9
o|    scheme#*	45
o|    scheme#inexact?	7
o|    chicken.base#flonum?	55
o|    scheme#length	6
o|    scheme#list->string
o|    scheme#string-length	21
o|    chicken.fixnum#fx<=	16
o|    chicken.fixnum#fxmax
o|    scheme#char->integer	18
o|    chicken.fixnum#fx>=	40
o|    scheme#string-set!	5
o|    scheme#string-ref	28
o|    chicken.fixnum#fx<	48
o|    scheme#memq	13
o|    chicken.fixnum#fx>	41
o|    chicken.fixnum#fx-	94
o|    chicken.fixnum#fx*	16
o|    chicken.fixnum#fx+	175
o|    ##sys#call-with-values	26
o|    ##sys#values	2
o|    chicken.fixnum#fx=	32
o|    ##sys#check-range	18
o|    scheme#procedure?	12
o|    scheme#string	3
o|    ##sys#check-bytevector	12
o|    scheme#vector	10
o|    scheme#integer->char	12
o|    ##sys#setislot	41
o|    scheme#list	28
o|    ##sys#setslot	87
o|    ##sys#size	83
o|    scheme#list?	4
o|    ##sys#check-pair	3
o|    chicken.base#void	3
o|    ##sys#check-list	27
o|    ##sys#make-structure	13
o|    ##sys#structure?	8
o|    scheme#apply	108
o|    scheme#-	21
o|    scheme#call-with-values	2
o|    scheme#+	26
o|    scheme#values	27
o|    scheme#not	103
o|    ##sys#check-fixnum	28
o|    ##sys#check-char	49
o|    ##sys#check-string	36
o|    scheme#pair?	130
o|    scheme#cons	180
o|    scheme#cdr	96
o|    scheme#car	190
o|    ##sys#check-symbol	13
o|    scheme#null?	262
o|    ##sys#check-boolean	3
o|    ##sys#slot	538
o|    scheme#eq?	472
o|contracted procedure: k11457 
o|contracted procedure: k11460 
o|contracted procedure: k11467 
o|contracted procedure: k11476 
o|contracted procedure: k11479 
o|contracted procedure: k11482 
o|contracted procedure: k11489 
o|contracted procedure: k11493 
o|contracted procedure: k11502 
o|contracted procedure: k11505 
o|contracted procedure: k11512 
o|contracted procedure: k11521 
o|contracted procedure: k11524 
o|contracted procedure: k11527 
o|contracted procedure: k11534 
o|contracted procedure: k11538 
o|contracted procedure: k11594 
o|contracted procedure: k11590 
o|contracted procedure: k11608 
o|contracted procedure: k11622 
o|contracted procedure: k11618 
o|contracted procedure: k11643 
o|contracted procedure: k11639 
o|contracted procedure: k11657 
o|contracted procedure: k11653 
o|contracted procedure: k11675 
o|contracted procedure: k11671 
o|contracted procedure: k11667 
o|contracted procedure: k11685 
o|contracted procedure: k11697 
o|contracted procedure: k11715 
o|contracted procedure: k11711 
o|contracted procedure: k11726 
o|contracted procedure: k11744 
o|contracted procedure: k11740 
o|contracted procedure: k11736 
o|contracted procedure: k11754 
o|contracted procedure: k11766 
o|contracted procedure: k11791 
o|contracted procedure: k11787 
o|contracted procedure: k11783 
o|contracted procedure: k11801 
o|contracted procedure: k11820 
o|contracted procedure: k11816 
o|contracted procedure: k11812 
o|contracted procedure: k11853 
o|contracted procedure: k11859 
o|contracted procedure: k11866 
o|contracted procedure: k11874 
o|contracted procedure: k11870 
o|contracted procedure: k11924 
o|contracted procedure: k11889 
o|contracted procedure: k11904 
o|contracted procedure: k11917 
o|contracted procedure: k11921 
o|contracted procedure: k11979 
o|contracted procedure: k11939 
o|contracted procedure: k11954 
o|contracted procedure: k11968 
o|contracted procedure: k11976 
o|contracted procedure: k11972 
o|contracted procedure: k12013 
o|contracted procedure: k12016 
o|contracted procedure: k12019 
o|contracted procedure: k12026 
o|contracted procedure: k12046 
o|contracted procedure: k12049 
o|contracted procedure: k12052 
o|contracted procedure: k12059 
o|contracted procedure: k12168 
o|contracted procedure: k12175 
o|contracted procedure: k12182 
o|contracted procedure: k12185 
o|contracted procedure: k12198 
o|contracted procedure: k12201 
o|contracted procedure: k12204 
o|contracted procedure: k12211 
o|contracted procedure: k12221 
o|contracted procedure: k12224 
o|contracted procedure: k12237 
o|contracted procedure: k12240 
o|contracted procedure: k12243 
o|contracted procedure: k12250 
o|contracted procedure: k12260 
o|contracted procedure: k12263 
o|contracted procedure: k12276 
o|contracted procedure: k12279 
o|contracted procedure: k12282 
o|contracted procedure: k12289 
o|contracted procedure: k12299 
o|contracted procedure: k12302 
o|contracted procedure: k12315 
o|contracted procedure: k12318 
o|contracted procedure: k12321 
o|contracted procedure: k12328 
o|contracted procedure: k12338 
o|contracted procedure: k12341 
o|contracted procedure: k12354 
o|contracted procedure: k12357 
o|contracted procedure: k12360 
o|contracted procedure: k12367 
o|contracted procedure: k12377 
o|contracted procedure: k12383 
o|contracted procedure: k12394 
o|contracted procedure: k12400 
o|contracted procedure: k12406 
o|contracted procedure: k12412 
o|contracted procedure: k12418 
o|contracted procedure: k12424 
o|contracted procedure: k12434 
o|contracted procedure: k12430 
o|contracted procedure: k12470 
o|contracted procedure: k12486 
o|contracted procedure: k12609 
o|contracted procedure: k12623 
o|contracted procedure: k12662 
o|contracted procedure: k12715 
o|contracted procedure: k12746 
o|contracted procedure: k12727 
o|contracted procedure: k12734 
o|contracted procedure: k12742 
o|contracted procedure: k12752 
o|contracted procedure: k12783 
o|contracted procedure: k12764 
o|contracted procedure: k12771 
o|contracted procedure: k12779 
o|contracted procedure: k12793 
o|contracted procedure: k12808 
o|contracted procedure: k12799 
o|contracted procedure: k12823 
o|contracted procedure: k1282044288 
o|contracted procedure: k12817 
o|contracted procedure: k12820 
o|contracted procedure: k12847 
o|contracted procedure: k12856 
o|contracted procedure: k12866 
o|contracted procedure: k12903 
o|contracted procedure: k12883 
o|contracted procedure: k12886 
o|contracted procedure: k12899 
o|contracted procedure: k12912 
o|contracted procedure: k12915 
o|contracted procedure: k12956 
o|contracted procedure: k12977 
o|contracted procedure: k12989 
o|contracted procedure: k12998 
o|contracted procedure: k13001 
o|contracted procedure: k13007 
o|contracted procedure: k13036 
o|contracted procedure: k13063 
o|contracted procedure: k13042 
o|contracted procedure: k13055 
o|contracted procedure: k13059 
o|contracted procedure: k13072 
o|contracted procedure: k13119 
o|contracted procedure: k13083 
o|contracted procedure: k13097 
o|contracted procedure: k13100 
o|contracted procedure: k13106 
o|contracted procedure: k13137 
o|contracted procedure: k13152 
o|contracted procedure: k13159 
o|contracted procedure: k13174 
o|contracted procedure: k13184 
o|contracted procedure: k13188 
o|contracted procedure: k13198 
o|contracted procedure: k13207 
o|contracted procedure: k13213 
o|contracted procedure: k13220 
o|contracted procedure: k13239 
o|contracted procedure: k13242 
o|contracted procedure: k13245 
o|contracted procedure: k13251 
o|contracted procedure: k13321 
o|contracted procedure: k13271 
o|contracted procedure: k13274 
o|contracted procedure: k13286 
o|contracted procedure: k13318 
o|contracted procedure: k13292 
o|contracted procedure: k13298 
o|contracted procedure: k13301 
o|contracted procedure: k13307 
o|contracted procedure: k13328 
o|contracted procedure: k13340 
o|contracted procedure: k13402 
o|contracted procedure: k13346 
o|contracted procedure: k13398 
o|contracted procedure: k13355 
o|contracted procedure: k13364 
o|contracted procedure: k13371 
o|contracted procedure: k13379 
o|contracted procedure: k13383 
o|contracted procedure: k13390 
o|contracted procedure: k13394 
o|contracted procedure: k13408 
o|contracted procedure: k13414 
o|contracted procedure: k13417 
o|contracted procedure: k13421 
o|contracted procedure: k13511 
o|contracted procedure: k13434 
o|contracted procedure: k13446 
o|contracted procedure: k13453 
o|contracted procedure: k13456 
o|contracted procedure: k13462 
o|contracted procedure: k13468 
o|contracted procedure: k13482 
o|contracted procedure: k13485 
o|contracted procedure: k13498 
o|contracted procedure: k13501 
o|contracted procedure: k13508 
o|contracted procedure: k13615 
o|contracted procedure: k13520 
o|contracted procedure: k13532 
o|contracted procedure: k13539 
o|contracted procedure: k13612 
o|contracted procedure: k13545 
o|contracted procedure: k13551 
o|contracted procedure: k13608 
o|contracted procedure: k13557 
o|contracted procedure: k13573 
o|contracted procedure: k13577 
o|contracted procedure: k13596 
o|contracted procedure: k13600 
o|contracted procedure: k13584 
o|contracted procedure: k13592 
o|contracted procedure: k13604 
o|contracted procedure: k13727 
o|contracted procedure: k13624 
o|contracted procedure: k13721 
o|contracted procedure: k13627 
o|contracted procedure: k13715 
o|contracted procedure: k13630 
o|contracted procedure: k13709 
o|contracted procedure: k13633 
o|contracted procedure: k13648 
o|contracted procedure: k13654 
o|contracted procedure: k13660 
o|contracted procedure: k13674 
o|contracted procedure: k13680 
o|contracted procedure: k13683 
o|contracted procedure: k13686 
o|contracted procedure: k13699 
o|contracted procedure: k13703 
o|contracted procedure: k13736 
o|contracted procedure: k13777 
o|contracted procedure: k13739 
o|contracted procedure: k13751 
o|contracted procedure: k13754 
o|contracted procedure: k13757 
o|contracted procedure: k13770 
o|contracted procedure: k13774 
o|contracted procedure: k13784 
o|contracted procedure: k13790 
o|contracted procedure: k13794 
o|contracted procedure: k13800 
o|contracted procedure: k13803 
o|contracted procedure: k13806 
o|contracted procedure: k13815 
o|contracted procedure: k13818 
o|contracted procedure: k13821 
o|contracted procedure: k13859 
o|contracted procedure: k13855 
o|contracted procedure: k13837 
o|contracted procedure: k13847 
o|contracted procedure: k13851 
o|contracted procedure: k13868 
o|contracted procedure: k13871 
o|contracted procedure: k13878 
o|contracted procedure: k13890 
o|contracted procedure: k13903 
o|contracted procedure: k13922 
o|contracted procedure: k13881 
o|contracted procedure: k13874 
o|contracted procedure: k13960 
o|contracted procedure: k13963 
o|contracted procedure: k13976 
o|contracted procedure: k13979 
o|contracted procedure: k13987 
o|contracted procedure: k13970 
o|contracted procedure: k13966 
o|contracted procedure: k14039 
o|contracted procedure: k14017 
o|contracted procedure: k14020 
o|contracted procedure: k14026 
o|contracted procedure: k14156 
o|contracted procedure: k14168 
o|contracted procedure: k14182 
o|contracted procedure: k14223 
o|contracted procedure: k14219 
o|contracted procedure: k14267 
o|contracted procedure: k14260 
o|contracted procedure: k14270 
o|contracted procedure: k14279 
o|contracted procedure: k14298 
o|contracted procedure: k14305 
o|contracted procedure: k14309 
o|contracted procedure: k14318 
o|contracted procedure: k14329 
o|contracted procedure: k14340 
o|contracted procedure: k14351 
o|contracted procedure: k14362 
o|contracted procedure: k14373 
o|contracted procedure: k14384 
o|contracted procedure: k14395 
o|contracted procedure: k14406 
o|contracted procedure: k14417 
o|contracted procedure: k14428 
o|contracted procedure: k14439 
o|contracted procedure: k14450 
o|contracted procedure: k14461 
o|contracted procedure: k14472 
o|contracted procedure: k14483 
o|contracted procedure: k14501 
o|contracted procedure: k14518 
o|contracted procedure: k14528 
o|contracted procedure: k14531 
o|contracted procedure: k14541 
o|contracted procedure: k14559 
o|contracted procedure: k14569 
o|contracted procedure: k14580 
o|contracted procedure: k14591 
o|contracted procedure: k14601 
o|contracted procedure: k14611 
o|contracted procedure: k14622 
o|contracted procedure: k14631 
o|contracted procedure: k14637 
o|contracted procedure: k14646 
o|contracted procedure: k14655 
o|contracted procedure: k14658 
o|contracted procedure: k14727 
o|contracted procedure: k14723 
o|contracted procedure: k14667 
o|contracted procedure: k14679 
o|contracted procedure: k14689 
o|contracted procedure: k14682 
o|contracted procedure: k14692 
o|contracted procedure: k14719 
o|contracted procedure: k14698 
o|contracted procedure: k14715 
o|contracted procedure: k14704 
o|contracted procedure: k14711 
o|contracted procedure: k14736 
o|contracted procedure: k14754 
o|contracted procedure: k14747 
o|contracted procedure: k14770 
o|contracted procedure: k14763 
o|contracted procedure: k14786 
o|contracted procedure: k14779 
o|contracted procedure: k14802 
o|contracted procedure: k14795 
o|contracted procedure: k14818 
o|contracted procedure: k14811 
o|contracted procedure: k14834 
o|contracted procedure: k14827 
o|contracted procedure: k14850 
o|contracted procedure: k14843 
o|contracted procedure: k14866 
o|contracted procedure: k14859 
o|contracted procedure: k14878 
o|contracted procedure: k14948 
o|contracted procedure: k14890 
o|contracted procedure: k14900 
o|contracted procedure: k14909 
o|contracted procedure: k14916 
o|contracted procedure: k14922 
o|contracted procedure: k14929 
o|contracted procedure: k14937 
o|contracted procedure: k14944 
o|contracted procedure: k14963 
o|contracted procedure: k14970 
o|contracted procedure: k14978 
o|contracted procedure: k14974 
o|contracted procedure: k14990 
o|contracted procedure: k14984 
o|contracted procedure: k15012 
o|contracted procedure: k14999 
o|contracted procedure: k15002 
o|contracted procedure: k15009 
o|contracted procedure: k15026 
o|contracted procedure: k15050 
o|contracted procedure: k15059 
o|contracted procedure: k15075 
o|contracted procedure: k15088 
o|contracted procedure: k15115 
o|contracted procedure: k15124 
o|contracted procedure: k15133 
o|contracted procedure: k15157 
o|contracted procedure: k15172 
o|contracted procedure: k15239 
o|contracted procedure: k15306 
o|contracted procedure: k15257 
o|contracted procedure: k15272 
o|contracted procedure: k15278 
o|contracted procedure: k15294 
o|contracted procedure: k15301 
o|contracted procedure: k15312 
o|contracted procedure: k15325 
o|contracted procedure: k15328 
o|contracted procedure: k15331 
o|contracted procedure: k15334 
o|contracted procedure: k15424 
o|contracted procedure: k15343 
o|contracted procedure: k15418 
o|contracted procedure: k15346 
o|contracted procedure: k15412 
o|contracted procedure: k15349 
o|contracted procedure: k15406 
o|contracted procedure: k15352 
o|contracted procedure: k15355 
o|contracted procedure: k15358 
o|contracted procedure: k15371 
o|contracted procedure: k15380 
o|contracted procedure: k15387 
o|contracted procedure: k15395 
o|contracted procedure: k15391 
o|contracted procedure: k15489 
o|contracted procedure: k15437 
o|contracted procedure: k15481 
o|contracted procedure: k15455 
o|contracted procedure: k15458 
o|contracted procedure: k15461 
o|contracted procedure: k15468 
o|contracted procedure: k15472 
o|contracted procedure: k15476 
o|contracted procedure: k15485 
o|contracted procedure: k15508 
o|contracted procedure: k15514 
o|contracted procedure: k15517 
o|contracted procedure: k15520 
o|contracted procedure: k15523 
o|contracted procedure: k15530 
o|contracted procedure: k15534 
o|contracted procedure: k15541 
o|contracted procedure: k15657 
o|contracted procedure: k15547 
o|contracted procedure: k15651 
o|contracted procedure: k15550 
o|contracted procedure: k15645 
o|contracted procedure: k15553 
o|contracted procedure: k15639 
o|contracted procedure: k15556 
o|contracted procedure: k15559 
o|contracted procedure: k15562 
o|contracted procedure: k15569 
o|contracted procedure: k15572 
o|contracted procedure: k15624 
o|contracted procedure: k15575 
o|contracted procedure: k15578 
o|contracted procedure: k15616 
o|contracted procedure: k15620 
o|contracted procedure: k15609 
o|contracted procedure: k15584 
o|contracted procedure: k15596 
o|contracted procedure: k15599 
o|contracted procedure: k15606 
o|contracted procedure: k15627 
o|contracted procedure: k15732 
o|contracted procedure: k15666 
o|contracted procedure: k15726 
o|contracted procedure: k15669 
o|contracted procedure: k15720 
o|contracted procedure: k15672 
o|contracted procedure: k15714 
o|contracted procedure: k15675 
o|contracted procedure: k15678 
o|contracted procedure: k15691 
o|contracted procedure: k15694 
o|contracted procedure: k15883 
o|contracted procedure: k15741 
o|contracted procedure: k15877 
o|contracted procedure: k15744 
o|contracted procedure: k15871 
o|contracted procedure: k15747 
o|contracted procedure: k15865 
o|contracted procedure: k15750 
o|contracted procedure: k15753 
o|contracted procedure: k15756 
o|contracted procedure: k15761 
o|contracted procedure: k15764 
o|contracted procedure: k15848 
o|contracted procedure: k15773 
o|contracted procedure: k15815 
o|contracted procedure: k15780 
o|contracted procedure: k15784 
o|contracted procedure: k15793 
o|contracted procedure: k15811 
o|contracted procedure: k15796 
o|contracted procedure: k15803 
o|contracted procedure: k15807 
o|contracted procedure: k15827 
o|contracted procedure: k15845 
o|contracted procedure: k15830 
o|contracted procedure: k15837 
o|contracted procedure: k15841 
o|contracted procedure: k15896 
o|contracted procedure: k15900 
o|contracted procedure: k15906 
o|contracted procedure: k15909 
o|contracted procedure: k15929 
o|contracted procedure: k15935 
o|contracted procedure: k15941 
o|contracted procedure: k15945 
o|contracted procedure: k15951 
o|contracted procedure: k15954 
o|contracted procedure: k16014 
o|contracted procedure: k15960 
o|contracted procedure: k15976 
o|contracted procedure: k15979 
o|contracted procedure: k15982 
o|contracted procedure: k16003 
o|contracted procedure: k15986 
o|contracted procedure: k15993 
o|contracted procedure: k16011 
o|contracted procedure: k16008 
o|contracted procedure: k16026 
o|contracted procedure: k16035 
o|contracted procedure: k16050 
o|contracted procedure: k16059 
o|contracted procedure: k16077 
o|contracted procedure: k16098 
o|contracted procedure: k16109 
o|contracted procedure: k16112 
o|contracted procedure: k16164 
o|contracted procedure: k16118 
o|contracted procedure: k16134 
o|contracted procedure: k16137 
o|contracted procedure: k16140 
o|contracted procedure: k16161 
o|contracted procedure: k16144 
o|contracted procedure: k16151 
o|contracted procedure: k16176 
o|contracted procedure: k16185 
o|contracted procedure: k16200 
o|contracted procedure: k16209 
o|contracted procedure: k16227 
o|contracted procedure: k16248 
o|contracted procedure: k16260 
o|contracted procedure: k16263 
o|contracted procedure: k16300 
o|contracted procedure: k16266 
o|contracted procedure: k16296 
o|contracted procedure: k16269 
o|contracted procedure: k16280 
o|contracted procedure: k16284 
o|contracted procedure: k16276 
o|contracted procedure: k16292 
o|contracted procedure: k16288 
o|contracted procedure: k16315 
o|contracted procedure: k16324 
o|contracted procedure: k16327 
o|contracted procedure: k16330 
o|contracted procedure: k16333 
o|contracted procedure: k16358 
o|contracted procedure: k16336 
o|contracted procedure: k16339 
o|contracted procedure: k16346 
o|contracted procedure: k16350 
o|contracted procedure: k16354 
o|contracted procedure: k16376 
o|contracted procedure: k16382 
o|contracted procedure: k16394 
o|contracted procedure: k16400 
o|contracted procedure: k16415 
o|contracted procedure: k16430 
o|contracted procedure: k16449 
o|contracted procedure: k16437 
o|contracted procedure: k16441 
o|contracted procedure: k16445 
o|contracted procedure: k16452 
o|contracted procedure: k16483 
o|contracted procedure: k16476 
o|contracted procedure: k16507 
o|contracted procedure: k16500 
o|contracted procedure: k16531 
o|contracted procedure: k16524 
o|contracted procedure: k16555 
o|contracted procedure: k16548 
o|contracted procedure: k16577 
o|contracted procedure: k16583 
o|contracted procedure: k16604 
o|contracted procedure: k16597 
o|contracted procedure: k16628 
o|contracted procedure: k16621 
o|contracted procedure: k16652 
o|contracted procedure: k16645 
o|contracted procedure: k16676 
o|contracted procedure: k16669 
o|contracted procedure: k16700 
o|contracted procedure: k16693 
o|contracted procedure: k16724 
o|contracted procedure: k16717 
o|contracted procedure: k16748 
o|contracted procedure: k16741 
o|contracted procedure: k16765 
o|contracted procedure: k16790 
o|contracted procedure: k16783 
o|contracted procedure: k16814 
o|contracted procedure: k16807 
o|contracted procedure: k16831 
o|contracted procedure: k16849 
o|contracted procedure: k16867 
o|contracted procedure: k16885 
o|contracted procedure: k16903 
o|contracted procedure: k16921 
o|contracted procedure: k16939 
o|contracted procedure: k16957 
o|contracted procedure: k16975 
o|contracted procedure: k16993 
o|contracted procedure: k17018 
o|contracted procedure: k17011 
o|contracted procedure: k17035 
o|contracted procedure: k17053 
o|contracted procedure: k17071 
o|contracted procedure: k17089 
o|contracted procedure: k17107 
o|contracted procedure: k17125 
o|contracted procedure: k17143 
o|contracted procedure: k17168 
o|contracted procedure: k17161 
o|contracted procedure: k17185 
o|contracted procedure: k17203 
o|contracted procedure: k17221 
o|contracted procedure: k17239 
o|contracted procedure: k17261 
o|contracted procedure: k17252 
o|contracted procedure: k17258 
o|contracted procedure: k17273 
o|contracted procedure: k17287 
o|contracted procedure: k17291 
o|contracted procedure: k17331 
o|contracted procedure: k17335 
o|contracted procedure: k17344 
o|contracted procedure: k17355 
o|contracted procedure: k17367 
o|contracted procedure: k17381 
o|contracted procedure: k17390 
o|contracted procedure: k17409 
o|contracted procedure: k17430 
o|contracted procedure: k17434 
o|contracted procedure: k17426 
o|contracted procedure: k17440 
o|contracted procedure: k17453 
o|contracted procedure: k17459 
o|contracted procedure: k17506 
o|contracted procedure: k17528 
o|contracted procedure: k17552 
o|contracted procedure: k17574 
o|contracted procedure: k17591 
o|contracted procedure: k17603 
o|contracted procedure: k17715 
o|contracted procedure: k17649 
o|contracted procedure: k17640 
o|contracted procedure: k17683 
o|contracted procedure: k17690 
o|contracted procedure: k17741 
o|contracted procedure: k17791 
o|contracted procedure: k17801 
o|contracted procedure: k17814 
o|contracted procedure: k17821 
o|contracted procedure: k17829 
o|contracted procedure: k17833 
o|contracted procedure: k17845 
o|contracted procedure: k17871 
o|contracted procedure: k17874 
o|contracted procedure: k17926 
o|contracted procedure: k17930 
o|contracted procedure: k17889 
o|contracted procedure: k17906 
o|contracted procedure: k17910 
o|contracted procedure: k17902 
o|contracted procedure: k17918 
o|contracted procedure: k17922 
o|contracted procedure: k17914 
o|contracted procedure: k17936 
o|contracted procedure: k17953 
o|contracted procedure: k17959 
o|contracted procedure: k18012 
o|contracted procedure: k18016 
o|contracted procedure: k17996 
o|contracted procedure: k18004 
o|contracted procedure: k18008 
o|contracted procedure: k18000 
o|contracted procedure: k18027 
o|contracted procedure: k18049 
o|contracted procedure: k18030 
o|contracted procedure: k18055 
o|contracted procedure: k18082 
o|contracted procedure: k18066 
o|contracted procedure: k18069 
o|contracted procedure: k18104 
o|contracted procedure: k18094 
o|contracted procedure: k18112 
o|contracted procedure: k18135 
o|contracted procedure: k18143 
o|contracted procedure: k18149 
o|contracted procedure: k18180 
o|contracted procedure: k18188 
o|contracted procedure: k18194 
o|contracted procedure: k18225 
o|contracted procedure: k18259 
o|contracted procedure: k18262 
o|contracted procedure: k18277 
o|contracted procedure: k18363 
o|contracted procedure: k18305 
o|contracted procedure: k18314 
o|contracted procedure: k18330 
o|contracted procedure: k18334 
o|contracted procedure: k18324 
o|contracted procedure: k18348 
o|contracted procedure: k18352 
o|contracted procedure: k18359 
o|contracted procedure: k18377 
o|contracted procedure: k18423 
o|contracted procedure: k18386 
o|contracted procedure: k18411 
o|contracted procedure: k18415 
o|contracted procedure: k18449 
o|contracted procedure: k18452 
o|contracted procedure: k18433 
o|contracted procedure: k18437 
o|contracted procedure: k18475 
o|contracted procedure: k18481 
o|contracted procedure: k18488 
o|contracted procedure: k18495 
o|contracted procedure: k18506 
o|contracted procedure: k18499 
o|contracted procedure: k18503 
o|contracted procedure: k18519 
o|contracted procedure: k18525 
o|contracted procedure: k18532 
o|contracted procedure: k18539 
o|contracted procedure: k18550 
o|contracted procedure: k18543 
o|contracted procedure: k18547 
o|contracted procedure: k18556 
o|contracted procedure: k18562 
o|contracted procedure: k18604 
o|contracted procedure: k18613 
o|contracted procedure: k18616 
o|contracted procedure: k18627 
o|contracted procedure: k18670 
o|contracted procedure: k18650 
o|contracted procedure: k18679 
o|contracted procedure: k18685 
o|contracted procedure: k18688 
o|contracted procedure: k18695 
o|contracted procedure: k18713 
o|contracted procedure: k18719 
o|contracted procedure: k18722 
o|contracted procedure: k18729 
o|contracted procedure: k18747 
o|contracted procedure: k18753 
o|contracted procedure: k18772 
o|contracted procedure: k18799 
o|contracted procedure: k18795 
o|contracted procedure: k18811 
o|contracted procedure: k18807 
o|contracted procedure: k18817 
o|contracted procedure: k18834 
o|contracted procedure: k18859 
o|contracted procedure: k18931 
o|contracted procedure: k18876 
o|contracted procedure: k18879 
o|contracted procedure: k18885 
o|contracted procedure: k18894 
o|contracted procedure: k18901 
o|contracted procedure: k18913 
o|contracted procedure: k18917 
o|contracted procedure: k19122 
o|contracted procedure: k18943 
o|contracted procedure: k18949 
o|contracted procedure: k18952 
o|contracted procedure: k18961 
o|contracted procedure: k18970 
o|contracted procedure: k18979 
o|contracted procedure: k19117 
o|contracted procedure: k19001 
o|contracted procedure: k19004 
o|contracted procedure: k19021 
o|contracted procedure: k19017 
o|contracted procedure: k19028 
o|contracted procedure: k19032 
o|contracted procedure: k19113 
o|contracted procedure: k19109 
o|contracted procedure: k19035 
o|contracted procedure: k19049 
o|contracted procedure: k19054 
o|contracted procedure: k19105 
o|contracted procedure: k19060 
o|contracted procedure: k19093 
o|contracted procedure: k19101 
o|contracted procedure: k19097 
o|contracted procedure: k19063 
o|contracted procedure: k19074 
o|contracted procedure: k19086 
o|contracted procedure: k19082 
o|contracted procedure: k19078 
o|contracted procedure: k19143 
o|contracted procedure: k19157 
o|contracted procedure: k19161 
o|contracted procedure: k19210 
o|contracted procedure: k19220 
o|contracted procedure: k19244 
o|contracted procedure: k19268 
o|contracted procedure: k19326 
o|contracted procedure: k19330 
o|contracted procedure: k19344 
o|contracted procedure: k19348 
o|contracted procedure: k19408 
o|contracted procedure: k19421 
o|contracted procedure: k19428 
o|contracted procedure: k19434 
o|contracted procedure: k19437 
o|contracted procedure: k19495 
o|contracted procedure: k19499 
o|contracted procedure: k19491 
o|contracted procedure: k19444 
o|contracted procedure: k19453 
o|contracted procedure: k19468 
o|contracted procedure: k19472 
o|contracted procedure: k19464 
o|contracted procedure: k19460 
o|contracted procedure: k19483 
o|contracted procedure: k19515 
o|contracted procedure: k19519 
o|contracted procedure: k19563 
o|contracted procedure: k19574 
o|contracted procedure: k19582 
o|contracted procedure: k19589 
o|contracted procedure: k19593 
o|contracted procedure: k19606 
o|contracted procedure: k19619 
o|contracted procedure: k19629 
o|contracted procedure: k19860 
o|contracted procedure: k19639 
o|contracted procedure: k19856 
o|contracted procedure: k19648 
o|contracted procedure: k19688 
o|contracted procedure: k19729 
o|contracted procedure: k19763 
o|contracted procedure: k19775 
o|contracted procedure: k19807 
o|contracted procedure: k19810 
o|contracted procedure: k19837 
o|contracted procedure: k19845 
o|contracted procedure: k19852 
o|contracted procedure: k19882 
o|contracted procedure: k19904 
o|contracted procedure: k19945 
o|contracted procedure: k19952 
o|contracted procedure: k19956 
o|contracted procedure: k19965 
o|contracted procedure: k19976 
o|contracted procedure: k19987 
o|contracted procedure: k20001 
o|contracted procedure: k19997 
o|contracted procedure: k20010 
o|contracted procedure: k20017 
o|contracted procedure: k20021 
o|contracted procedure: k20030 
o|contracted procedure: k20041 
o|contracted procedure: k20059 
o|contracted procedure: k20051 
o|contracted procedure: k20055 
o|contracted procedure: k20109 
o|contracted procedure: k20065 
o|contracted procedure: k20097 
o|contracted procedure: k20118 
o|contracted procedure: k20149 
o|contracted procedure: k20170 
o|contracted procedure: k20297 
o|contracted procedure: k20310 
o|contracted procedure: k20325 
o|contracted procedure: k20318 
o|contracted procedure: k20339 
o|contracted procedure: k20356 
o|contracted procedure: k20362 
o|contracted procedure: k20368 
o|contracted procedure: k20378 
o|contracted procedure: k20410 
o|contracted procedure: k20384 
o|contracted procedure: k20390 
o|contracted procedure: k20396 
o|contracted procedure: k20195 
o|contracted procedure: k20199 
o|contracted procedure: k20264 
o|contracted procedure: k20209 
o|contracted procedure: k20215 
o|contracted procedure: k20253 
o|contracted procedure: k20218 
o|contracted procedure: k20279 
o|contracted procedure: k20283 
o|contracted procedure: k20234 
o|contracted procedure: k20238 
o|contracted procedure: k20246 
o|contracted procedure: k20416 
o|contracted procedure: k21709 
o|contracted procedure: k21705 
o|contracted procedure: k20419 
o|contracted procedure: k21701 
o|contracted procedure: k21697 
o|contracted procedure: k20422 
o|contracted procedure: k21693 
o|contracted procedure: k21689 
o|contracted procedure: k20425 
o|contracted procedure: k20439 
o|contracted procedure: k20445 
o|contracted procedure: k20451 
o|contracted procedure: k20457 
o|contracted procedure: k20463 
o|contracted procedure: k20470 
o|contracted procedure: k20476 
o|contracted procedure: k20489 
o|contracted procedure: k20499 
o|contracted procedure: k20505 
o|contracted procedure: k20511 
o|contracted procedure: k20543 
o|contracted procedure: k20549 
o|contracted procedure: k20555 
o|contracted procedure: k20561 
o|contracted procedure: k20568 
o|contracted procedure: k20574 
o|contracted procedure: k20588 
o|contracted procedure: k20595 
o|contracted procedure: k20616 
o|contracted procedure: k20630 
o|contracted procedure: k20641 
o|contracted procedure: k20644 
o|contracted procedure: k20650 
o|contracted procedure: k20664 
o|contracted procedure: k20668 
o|contracted procedure: k20676 
o|contracted procedure: k20682 
o|contracted procedure: k20694 
o|contracted procedure: k20700 
o|contracted procedure: k20709 
o|contracted procedure: k20715 
o|contracted procedure: k20721 
o|contracted procedure: k20733 
o|contracted procedure: k20748 
o|contracted procedure: k20758 
o|contracted procedure: k20777 
o|contracted procedure: k20773 
o|contracted procedure: k20781 
o|contracted procedure: k20784 
o|contracted procedure: k20787 
o|contracted procedure: k20790 
o|contracted procedure: k20796 
o|contracted procedure: k20803 
o|contracted procedure: k20815 
o|contracted procedure: k20821 
o|contracted procedure: k20827 
o|contracted procedure: k20833 
o|contracted procedure: k20839 
o|contracted procedure: k20845 
o|contracted procedure: k20851 
o|contracted procedure: k20857 
o|contracted procedure: k20889 
o|contracted procedure: k20916 
o|contracted procedure: k21215 
o|contracted procedure: k20925 
o|contracted procedure: k20931 
o|contracted procedure: k20940 
o|contracted procedure: k20966 
o|contracted procedure: k20946 
o|contracted procedure: k20953 
o|contracted procedure: k20974 
o|contracted procedure: k20983 
o|contracted procedure: k20989 
o|contracted procedure: k21017 
o|contracted procedure: k21021 
o|contracted procedure: k21031 
o|contracted procedure: k21035 
o|contracted procedure: k21051 
o|contracted procedure: k21129 
o|contracted procedure: k21060 
o|contracted procedure: k21125 
o|contracted procedure: k21075 
o|contracted procedure: k21084 
o|contracted procedure: k21095 
o|contracted procedure: k21110 
o|contracted procedure: k21133 
o|contracted procedure: k21142 
o|contracted procedure: k21148 
o|contracted procedure: k21154 
o|contracted procedure: k21160 
o|contracted procedure: k21166 
o|contracted procedure: k21172 
o|contracted procedure: k21178 
o|contracted procedure: k21184 
o|contracted procedure: k21240 
o|contracted procedure: k21223 
o|contracted procedure: k21229 
o|contracted procedure: k21236 
o|contracted procedure: k21248 
o|contracted procedure: k21251 
o|contracted procedure: k21257 
o|contracted procedure: k21263 
o|contracted procedure: k21271 
o|contracted procedure: k21274 
o|contracted procedure: k21287 
o|contracted procedure: k21360 
o|contracted procedure: k21293 
o|contracted procedure: k21303 
o|contracted procedure: k21336 
o|contracted procedure: k21319 
o|contracted procedure: k21333 
o|contracted procedure: k21326 
o|contracted procedure: k21323 
o|contracted procedure: k21340 
o|contracted procedure: k21356 
o|contracted procedure: k21343 
o|contracted procedure: k21352 
o|contracted procedure: k21366 
o|contracted procedure: k21369 
o|contracted procedure: k21382 
o|contracted procedure: k21432 
o|contracted procedure: k21388 
o|contracted procedure: k21420 
o|contracted procedure: k21413 
o|contracted procedure: k21410 
o|contracted procedure: k21424 
o|contracted procedure: k21428 
o|contracted procedure: k21439 
o|contracted procedure: k21459 
o|contracted procedure: k21465 
o|contracted procedure: k21484 
o|contracted procedure: k21680 
o|contracted procedure: k21504 
o|contracted procedure: k21510 
o|contracted procedure: k21517 
o|contracted procedure: k21520 
o|contracted procedure: k21554 
o|contracted procedure: k21526 
o|contracted procedure: k21550 
o|contracted procedure: k21532 
o|contracted procedure: k21535 
o|contracted procedure: k21562 
o|contracted procedure: k21565 
o|contracted procedure: k21575 
o|contracted procedure: k21619 
o|contracted procedure: k21581 
o|contracted procedure: k21613 
o|contracted procedure: k21587 
o|inlining procedure: k21590 
o|contracted procedure: k21607 
o|inlining procedure: k21590 
o|contracted procedure: k21629 
o|contracted procedure: k21653 
o|contracted procedure: k21639 
o|contracted procedure: k21657 
o|contracted procedure: k21955 
o|contracted procedure: k21715 
o|contracted procedure: k21718 
o|contracted procedure: k21916 
o|contracted procedure: k21738 
o|contracted procedure: k21744 
o|contracted procedure: k21747 
o|contracted procedure: k21753 
o|contracted procedure: k21760 
o|contracted procedure: k21766 
o|contracted procedure: k21769 
o|contracted procedure: k21775 
o|contracted procedure: k21782 
o|contracted procedure: k21788 
o|contracted procedure: k21791 
o|contracted procedure: k21797 
o|contracted procedure: k21804 
o|contracted procedure: k21810 
o|contracted procedure: k21813 
o|contracted procedure: k21819 
o|contracted procedure: k21826 
o|contracted procedure: k21832 
o|contracted procedure: k21835 
o|contracted procedure: k21841 
o|contracted procedure: k21848 
o|contracted procedure: k21854 
o|contracted procedure: k21857 
o|contracted procedure: k21863 
o|contracted procedure: k21870 
o|contracted procedure: k21937 
o|contracted procedure: k21926 
o|contracted procedure: k21933 
o|contracted procedure: k21949 
o|contracted procedure: k21940 
o|contracted procedure: k21997 
o|contracted procedure: k21964 
o|contracted procedure: k21991 
o|contracted procedure: k21967 
o|contracted procedure: k21985 
o|contracted procedure: k21970 
o|contracted procedure: k21979 
o|contracted procedure: k21973 
o|contracted procedure: k22013 
o|contracted procedure: k22016 
o|contracted procedure: k22022 
o|contracted procedure: k22025 
o|contracted procedure: k22031 
o|contracted procedure: k22043 
o|contracted procedure: k22050 
o|contracted procedure: k22054 
o|contracted procedure: k22067 
o|contracted procedure: k22071 
o|contracted procedure: k22075 
o|contracted procedure: k22081 
o|contracted procedure: k22090 
o|contracted procedure: k22096 
o|contracted procedure: k22108 
o|contracted procedure: k22114 
o|contracted procedure: k22120 
o|contracted procedure: k22142 
o|contracted procedure: k22146 
o|contracted procedure: k22155 
o|contracted procedure: k22165 
o|contracted procedure: k22161 
o|contracted procedure: k22168 
o|contracted procedure: k22181 
o|contracted procedure: k22174 
o|contracted procedure: k22200 
o|contracted procedure: k22203 
o|contracted procedure: k22212 
o|contracted procedure: k22218 
o|contracted procedure: k22221 
o|contracted procedure: k22241 
o|contracted procedure: k22250 
o|contracted procedure: k22259 
o|contracted procedure: k22278 
o|contracted procedure: k22300 
o|contracted procedure: k22303 
o|contracted procedure: k22338 
o|contracted procedure: k22358 
o|contracted procedure: k22361 
o|contracted procedure: k22364 
o|contracted procedure: k22372 
o|contracted procedure: k22380 
o|contracted procedure: k22343 
o|contracted procedure: k22392 
o|contracted procedure: k22418 
o|contracted procedure: k22444 
o|contracted procedure: k22423 
o|contracted procedure: k22429 
o|contracted procedure: k22435 
o|contracted procedure: k22454 
o|contracted procedure: k22461 
o|contracted procedure: k22470 
o|contracted procedure: k22477 
o|contracted procedure: k22481 
o|contracted procedure: k22488 
o|contracted procedure: k22503 
o|contracted procedure: k22506 
o|contracted procedure: k22518 
o|contracted procedure: k22542 
o|contracted procedure: k22527 
o|contracted procedure: k22530 
o|contracted procedure: k22533 
o|contracted procedure: k22557 
o|contracted procedure: k22572 
o|contracted procedure: k22575 
o|contracted procedure: k22579 
o|contracted procedure: k22619 
o|contracted procedure: k22588 
o|contracted procedure: k22591 
o|contracted procedure: k22601 
o|contracted procedure: k22616 
o|contracted procedure: k22604 
o|contracted procedure: k22628 
o|contracted procedure: k22631 
o|contracted procedure: k22634 
o|contracted procedure: k22638 
o|contracted procedure: k22647 
o|contracted procedure: k22650 
o|contracted procedure: k22663 
o|contracted procedure: k22666 
o|contracted procedure: k22669 
o|contracted procedure: k22679 
o|contracted procedure: k22675 
o|contracted procedure: k22698 
o|contracted procedure: k22701 
o|contracted procedure: k22704 
o|contracted procedure: k22788 
o|contracted procedure: k22716 
o|contracted procedure: k22782 
o|contracted procedure: k22719 
o|contracted procedure: k22776 
o|contracted procedure: k22722 
o|contracted procedure: k22770 
o|contracted procedure: k22725 
o|contracted procedure: k22728 
o|contracted procedure: k22731 
o|contracted procedure: k22734 
o|contracted procedure: k22755 
o|contracted procedure: k22761 
o|contracted procedure: k22870 
o|contracted procedure: k22797 
o|contracted procedure: k22864 
o|contracted procedure: k22800 
o|contracted procedure: k22858 
o|contracted procedure: k22803 
o|contracted procedure: k22852 
o|contracted procedure: k22806 
o|contracted procedure: k22809 
o|contracted procedure: k22812 
o|contracted procedure: k22815 
o|contracted procedure: k22818 
o|contracted procedure: k22821 
o|contracted procedure: k22840 
o|contracted procedure: k22846 
o|contracted procedure: k22888 
o|contracted procedure: k22903 
o|contracted procedure: k22906 
o|contracted procedure: k22909 
o|contracted procedure: k22918 
o|contracted procedure: k22921 
o|contracted procedure: k22931 
o|contracted procedure: k22937 
o|contracted procedure: k22950 
o|contracted procedure: k22947 
o|contracted procedure: k22956 
o|contracted procedure: k23012 
o|contracted procedure: k22969 
o|contracted procedure: k22975 
o|contracted procedure: k22990 
o|contracted procedure: k23008 
o|contracted procedure: k22993 
o|contracted procedure: k23000 
o|contracted procedure: k23004 
o|contracted procedure: k23095 
o|contracted procedure: k23018 
o|contracted procedure: k23089 
o|contracted procedure: k23021 
o|contracted procedure: k23083 
o|contracted procedure: k23024 
o|contracted procedure: k23077 
o|contracted procedure: k23027 
o|contracted procedure: k23030 
o|contracted procedure: k23033 
o|contracted procedure: k23051 
o|contracted procedure: k23058 
o|contracted procedure: k23066 
o|contracted procedure: k23182 
o|contracted procedure: k23110 
o|contracted procedure: k23176 
o|contracted procedure: k23113 
o|contracted procedure: k23170 
o|contracted procedure: k23116 
o|contracted procedure: k23164 
o|contracted procedure: k23119 
o|contracted procedure: k23122 
o|contracted procedure: k23125 
o|contracted procedure: k23143 
o|contracted procedure: k23146 
o|contracted procedure: k23153 
o|contracted procedure: k23289 
o|contracted procedure: k23191 
o|contracted procedure: k23283 
o|contracted procedure: k23194 
o|contracted procedure: k23277 
o|contracted procedure: k23197 
o|contracted procedure: k23271 
o|contracted procedure: k23200 
o|contracted procedure: k23203 
o|contracted procedure: k23208 
o|contracted procedure: k23229 
o|contracted procedure: k23247 
o|contracted procedure: k23232 
o|contracted procedure: k23239 
o|contracted procedure: k23243 
o|contracted procedure: k23251 
o|contracted procedure: k23264 
o|contracted procedure: k23268 
o|contracted procedure: k23462 
o|contracted procedure: k23298 
o|contracted procedure: k23456 
o|contracted procedure: k23301 
o|contracted procedure: k23450 
o|contracted procedure: k23304 
o|contracted procedure: k23444 
o|contracted procedure: k23307 
o|contracted procedure: k23310 
o|contracted procedure: k23313 
o|contracted procedure: k23318 
o|contracted procedure: k23321 
o|contracted procedure: k23324 
o|contracted procedure: k23417 
o|contracted procedure: k23342 
o|contracted procedure: k23349 
o|contracted procedure: k23384 
o|contracted procedure: k23353 
o|contracted procedure: k23362 
o|contracted procedure: k23380 
o|contracted procedure: k23365 
o|contracted procedure: k23372 
o|contracted procedure: k23376 
o|contracted procedure: k23396 
o|contracted procedure: k23414 
o|contracted procedure: k23399 
o|contracted procedure: k23406 
o|contracted procedure: k23410 
o|contracted procedure: k23424 
o|contracted procedure: k23437 
o|contracted procedure: k23441 
o|contracted procedure: k23479 
o|contracted procedure: k23497 
o|contracted procedure: k23511 
o|contracted procedure: k23517 
o|contracted procedure: k23521 
o|contracted procedure: k23525 
o|contracted procedure: k23537 
o|contracted procedure: k23544 
o|contracted procedure: k23552 
o|contracted procedure: k23548 
o|contracted procedure: k23561 
o|contracted procedure: k23583 
o|contracted procedure: k23579 
o|contracted procedure: k23564 
o|contracted procedure: k23567 
o|contracted procedure: k23575 
o|contracted procedure: k23595 
o|contracted procedure: k23609 
o|contracted procedure: k23598 
o|contracted procedure: k23605 
o|contracted procedure: k23669 
o|contracted procedure: k23615 
o|contracted procedure: k23618 
o|contracted procedure: k23621 
o|contracted procedure: k23624 
o|contracted procedure: k23627 
o|contracted procedure: k23648 
o|contracted procedure: k23666 
o|contracted procedure: k23662 
o|contracted procedure: k23651 
o|contracted procedure: k23658 
o|contracted procedure: k23690 
o|contracted procedure: k23678 
o|contracted procedure: k23681 
o|contracted procedure: k23684 
o|contracted procedure: k23714 
o|contracted procedure: k23728 
o|contracted procedure: k23717 
o|contracted procedure: k23724 
o|contracted procedure: k23732 
o|contracted procedure: k23738 
o|contracted procedure: k23741 
o|contracted procedure: k23748 
o|contracted procedure: k23757 
o|contracted procedure: k23760 
o|contracted procedure: k23763 
o|contracted procedure: k23773 
o|contracted procedure: k23777 
o|contracted procedure: k23787 
o|contracted procedure: k23790 
o|contracted procedure: k23804 
o|contracted procedure: k23807 
o|contracted procedure: k23810 
o|contracted procedure: k23820 
o|contracted procedure: k23830 
o|contracted procedure: k23833 
o|contracted procedure: k23847 
o|contracted procedure: k23850 
o|contracted procedure: k23853 
o|contracted procedure: k23863 
o|contracted procedure: k23873 
o|contracted procedure: k23876 
o|contracted procedure: k23890 
o|contracted procedure: k23893 
o|contracted procedure: k23896 
o|contracted procedure: k23906 
o|contracted procedure: k23916 
o|contracted procedure: k23919 
o|contracted procedure: k23933 
o|contracted procedure: k23936 
o|contracted procedure: k23939 
o|contracted procedure: k23949 
o|contracted procedure: k23963 
o|contracted procedure: k23970 
o|contracted procedure: k23979 
o|contracted procedure: k23982 
o|contracted procedure: k23999 
o|contracted procedure: k23988 
o|contracted procedure: k23995 
o|contracted procedure: k24113 
o|contracted procedure: k24004 
o|contracted procedure: k24010 
o|contracted procedure: k24025 
o|contracted procedure: k24028 
o|contracted procedure: k24040 
o|contracted procedure: k24043 
o|contracted procedure: k24057 
o|contracted procedure: k24053 
o|contracted procedure: k24061 
o|contracted procedure: k24084 
o|contracted procedure: k24065 
o|contracted procedure: k24076 
o|contracted procedure: k24080 
o|contracted procedure: k24072 
o|contracted procedure: k24098 
o|contracted procedure: k24094 
o|contracted procedure: k24087 
o|contracted procedure: k24101 
o|contracted procedure: k24104 
o|contracted procedure: k24174 
o|contracted procedure: k24180 
o|contracted procedure: k24190 
o|contracted procedure: k24194 
o|contracted procedure: k24212 
o|contracted procedure: k24218 
o|contracted procedure: k24233 
o|contracted procedure: k24237 
o|contracted procedure: k24260 
o|contracted procedure: k24263 
o|contracted procedure: k24269 
o|contracted procedure: k24278 
o|contracted procedure: k24293 
o|contracted procedure: k24306 
o|contracted procedure: k24309 
o|contracted procedure: k24321 
o|contracted procedure: k24331 
o|contracted procedure: k24335 
o|contracted procedure: k24342 
o|contracted procedure: k24357 
o|contracted procedure: k24388 
o|contracted procedure: k24391 
o|contracted procedure: k24394 
o|contracted procedure: k24406 
o|contracted procedure: k24409 
o|contracted procedure: k24412 
o|contracted procedure: k24420 
o|contracted procedure: k24428 
o|contracted procedure: k24438 
o|contracted procedure: k24453 
o|contracted procedure: k24511 
o|contracted procedure: k24491 
o|contracted procedure: k24501 
o|contracted procedure: k24533 
o|contracted procedure: k24544 
o|contracted procedure: k24548 
o|contracted procedure: k24540 
o|contracted procedure: k24558 
o|contracted procedure: k24567 
o|contracted procedure: k24581 
o|contracted procedure: k24573 
o|contracted procedure: k24585 
o|contracted procedure: k24589 
o|contracted procedure: k24610 
o|contracted procedure: k24592 
o|contracted procedure: k24596 
o|contracted procedure: k24606 
o|contracted procedure: k24623 
o|contracted procedure: k24629 
o|contracted procedure: k24632 
o|contracted procedure: k24635 
o|contracted procedure: k24638 
o|contracted procedure: k24641 
o|contracted procedure: k24644 
o|contracted procedure: k24647 
o|contracted procedure: k24650 
o|contracted procedure: k24653 
o|contracted procedure: k24656 
o|contracted procedure: k24659 
o|contracted procedure: k24662 
o|contracted procedure: k41638 
o|contracted procedure: k41644 
o|contracted procedure: k41651 
o|contracted procedure: k41707 
o|contracted procedure: k41657 
o|contracted procedure: k41663 
o|contracted procedure: k41672 
o|contracted procedure: k41694 
o|contracted procedure: k41713 
o|contracted procedure: k41716 
o|contracted procedure: k41734 
o|contracted procedure: k41746 
o|contracted procedure: k41752 
o|contracted procedure: k41768 
o|contracted procedure: k41761 
o|contracted procedure: k41778 
o|contracted procedure: k41782 
o|contracted procedure: k41803 
o|contracted procedure: k41822 
o|contracted procedure: k41828 
o|contracted procedure: k41837 
o|contracted procedure: k41864 
o|contracted procedure: k41871 
o|contracted procedure: k41875 
o|contracted procedure: k41879 
o|contracted procedure: k41889 
o|contracted procedure: k41893 
o|contracted procedure: k41897 
o|contracted procedure: k41901 
o|contracted procedure: k41910 
o|contracted procedure: k41920 
o|contracted procedure: k41924 
o|contracted procedure: k41930 
o|contracted procedure: k41936 
o|contracted procedure: k41945 
o|contracted procedure: k41954 
o|contracted procedure: k41964 
o|contracted procedure: k41968 
o|contracted procedure: k41980 
o|contracted procedure: k41984 
o|contracted procedure: k41990 
o|contracted procedure: k41999 
o|contracted procedure: k42027 
o|contracted procedure: k42002 
o|contracted procedure: k42023 
o|contracted procedure: k42064 
o|contracted procedure: k42060 
o|contracted procedure: k42045 
o|contracted procedure: k42056 
o|contracted procedure: k42082 
o|contracted procedure: k42078 
o|contracted procedure: k42067 
o|contracted procedure: k42074 
o|contracted procedure: k42085 
o|contracted procedure: k24666 
o|contracted procedure: k24697 
o|contracted procedure: k24708 
o|contracted procedure: k24719 
o|contracted procedure: k24730 
o|contracted procedure: k24741 
o|contracted procedure: k24744 
o|contracted procedure: k24770 
o|contracted procedure: k24776 
o|contracted procedure: k24783 
o|contracted procedure: k24789 
o|contracted procedure: k24802 
o|contracted procedure: k24805 
o|contracted procedure: k24831 
o|contracted procedure: k24837 
o|contracted procedure: k24844 
o|contracted procedure: k24850 
o|contracted procedure: k24863 
o|contracted procedure: k24866 
o|contracted procedure: k24892 
o|contracted procedure: k24898 
o|contracted procedure: k24905 
o|contracted procedure: k24911 
o|contracted procedure: k24924 
o|contracted procedure: k24948 
o|contracted procedure: k24951 
o|contracted procedure: k24963 
o|contracted procedure: k25001 
o|contracted procedure: k25004 
o|contracted procedure: k25014 
o|contracted procedure: k25017 
o|contracted procedure: k25020 
o|contracted procedure: k2501445384 
o|contracted procedure: k25028 
o|contracted procedure: k25031 
o|contracted procedure: k2501445388 
o|contracted procedure: k25038 
o|contracted procedure: k25041 
o|contracted procedure: k2501445392 
o|contracted procedure: k25048 
o|contracted procedure: k2501445396 
o|contracted procedure: k25058 
o|contracted procedure: k2501445400 
o|contracted procedure: k25068 
o|contracted procedure: k25071 
o|contracted procedure: k2501445404 
o|contracted procedure: k25078 
o|contracted procedure: k25081 
o|contracted procedure: k2501445408 
o|contracted procedure: k25108 
o|contracted procedure: k25114 
o|contracted procedure: k25131 
o|contracted procedure: k25137 
o|contracted procedure: k25181 
o|contracted procedure: k25205 
o|contracted procedure: k25209 
o|contracted procedure: k25201 
o|contracted procedure: k25187 
o|contracted procedure: k25197 
o|contracted procedure: k25190 
o|contracted procedure: k25362 
o|contracted procedure: k25368 
o|contracted procedure: k25388 
o|contracted procedure: k25381 
o|contracted procedure: k25403 
o|contracted procedure: k25394 
o|contracted procedure: k25421 
o|contracted procedure: k25428 
o|contracted procedure: k25450 
o|contracted procedure: k25467 
o|contracted procedure: k25456 
o|contracted procedure: k25463 
o|contracted procedure: k25471 
o|contracted procedure: k25474 
o|contracted procedure: k25490 
o|contracted procedure: k25529 
o|contracted procedure: k25500 
o|contracted procedure: k25509 
o|contracted procedure: k25512 
o|contracted procedure: k25525 
o|contracted procedure: k25535 
o|contracted procedure: k25545 
o|contracted procedure: k25538 
o|contracted procedure: k25558 
o|contracted procedure: k25554 
o|contracted procedure: k25570 
o|contracted procedure: k25578 
o|contracted procedure: k25605 
o|contracted procedure: k25682 
o|contracted procedure: k25616 
o|contracted procedure: k25640 
o|contracted procedure: k25653 
o|contracted procedure: k25660 
o|contracted procedure: k25670 
o|contracted procedure: k25666 
o|contracted procedure: k25673 
o|contracted procedure: k25761 
o|contracted procedure: k25921 
o|contracted procedure: k25768 
o|contracted procedure: k25782 
o|contracted procedure: k25791 
o|contracted procedure: k25799 
o|contracted procedure: k25803 
o|contracted procedure: k25809 
o|contracted procedure: k25818 
o|contracted procedure: k25824 
o|contracted procedure: k25834 
o|contracted procedure: k25850 
o|contracted procedure: k25856 
o|contracted procedure: k25863 
o|contracted procedure: k25869 
o|contracted procedure: k25879 
o|contracted procedure: k25885 
o|contracted procedure: k25891 
o|contracted procedure: k25900 
o|contracted procedure: k25918 
o|contracted procedure: k25906 
o|contracted procedure: k25914 
o|contracted procedure: k25948 
o|contracted procedure: k25932 
o|contracted procedure: k25945 
o|contracted procedure: k25938 
o|contracted procedure: k25966 
o|contracted procedure: k25957 
o|contracted procedure: k25981 
o|contracted procedure: k25995 
o|contracted procedure: k25991 
o|contracted procedure: k25984 
o|inlining procedure: k25978 
o|contracted procedure: k26001 
o|contracted procedure: k26012 
o|contracted procedure: k26008 
o|inlining procedure: k25978 
o|contracted procedure: k26016 
o|contracted procedure: k26019 
o|contracted procedure: k26029 
o|contracted procedure: k26022 
o|contracted procedure: k26047 
o|contracted procedure: k26063 
o|contracted procedure: k26050 
o|contracted procedure: k26056 
o|contracted procedure: k26078 
o|contracted procedure: k26069 
o|contracted procedure: k26096 
o|contracted procedure: k26087 
o|contracted procedure: k26153 
o|contracted procedure: k26176 
o|contracted procedure: k26189 
o|contracted procedure: k26245 
o|contracted procedure: k26252 
o|contracted procedure: k26274 
o|contracted procedure: k26288 
o|contracted procedure: k26284 
o|contracted procedure: k26316 
o|contracted procedure: k26300 
o|contracted procedure: k26306 
o|contracted procedure: k26331 
o|contracted procedure: k26359 
o|contracted procedure: k26340 
o|contracted procedure: k26383 
o|contracted procedure: k26364 
o|contracted procedure: k26391 
o|contracted procedure: k26394 
o|contracted procedure: k26406 
o|contracted procedure: k26409 
o|contracted procedure: k26419 
o|contracted procedure: k26436 
o|contracted procedure: k26422 
o|contracted procedure: k26461 
o|contracted procedure: k26477 
o|contracted procedure: k26502 
o|contracted procedure: k26527 
o|contracted procedure: k26530 
o|contracted procedure: k26540 
o|contracted procedure: k26544 
o|contracted procedure: k26594 
o|contracted procedure: k26603 
o|contracted procedure: k26612 
o|contracted procedure: k26624 
o|contracted procedure: k26685 
o|contracted procedure: k26636 
o|contracted procedure: k26646 
o|contracted procedure: k26659 
o|contracted procedure: k26668 
o|contracted procedure: k26712 
o|contracted procedure: k26722 
o|contracted procedure: k26733 
o|contracted procedure: k26739 
o|contracted procedure: k26750 
o|contracted procedure: k26756 
o|contracted procedure: k26767 
o|contracted procedure: k26773 
o|contracted procedure: k26784 
o|contracted procedure: k26790 
o|contracted procedure: k26801 
o|contracted procedure: k26807 
o|contracted procedure: k26818 
o|contracted procedure: k26824 
o|contracted procedure: k26835 
o|contracted procedure: k26841 
o|contracted procedure: k26844 
o|contracted procedure: k26855 
o|contracted procedure: k26865 
o|contracted procedure: k26883 
o|contracted procedure: k26879 
o|contracted procedure: k26889 
o|contracted procedure: k26907 
o|contracted procedure: k26903 
o|contracted procedure: k26913 
o|contracted procedure: k26927 
o|contracted procedure: k26933 
o|contracted procedure: k26948 
o|contracted procedure: k26951 
o|contracted procedure: k26964 
o|contracted procedure: k26979 
o|contracted procedure: k26995 
o|contracted procedure: k27074 
o|contracted procedure: k27070 
o|contracted procedure: k27062 
o|contracted procedure: k27058 
o|contracted procedure: k27043 
o|contracted procedure: k27054 
o|contracted procedure: k27088 
o|contracted procedure: k27091 
o|contracted procedure: k27097 
o|contracted procedure: k27103 
o|contracted procedure: k27109 
o|contracted procedure: k27126 
o|contracted procedure: k27132 
o|contracted procedure: k27172 
o|contracted procedure: k27186 
o|contracted procedure: k27195 
o|contracted procedure: k27204 
o|contracted procedure: k27237 
o|contracted procedure: k27278 
o|contracted procedure: k27287 
o|contracted procedure: k27299 
o|contracted procedure: k27311 
o|contracted procedure: k27320 
o|contracted procedure: k27338 
o|contracted procedure: k27356 
o|contracted procedure: k27359 
o|contracted procedure: k27369 
o|contracted procedure: k27390 
o|contracted procedure: k27401 
o|contracted procedure: k27407 
o|contracted procedure: k27413 
o|contracted procedure: k27422 
o|contracted procedure: k27425 
o|contracted procedure: k27459 
o|contracted procedure: k27534 
o|contracted procedure: k27526 
o|contracted procedure: k27501 
o|contracted procedure: k27543 
o|contracted procedure: k27555 
o|contracted procedure: k27564 
o|contracted procedure: k27594 
o|contracted procedure: k27606 
o|contracted procedure: k27615 
o|contracted procedure: k27671 
o|contracted procedure: k27683 
o|inlining procedure: k27700 
o|inlining procedure: k27700 
o|contracted procedure: k27708 
o|contracted procedure: k27733 
o|contracted procedure: k27753 
o|contracted procedure: k27760 
o|contracted procedure: k27807 
o|contracted procedure: k27827 
o|contracted procedure: k27862 
o|contracted procedure: k27875 
o|contracted procedure: k27881 
o|contracted procedure: k27895 
o|contracted procedure: k27891 
o|contracted procedure: k27901 
o|contracted procedure: k27913 
o|contracted procedure: k27937 
o|contracted procedure: k27947 
o|contracted procedure: k27957 
o|contracted procedure: k27964 
o|contracted procedure: k27970 
o|contracted procedure: k27979 
o|contracted procedure: k27989 
o|inlining procedure: k27996 
o|inlining procedure: k27996 
o|contracted procedure: k28014 
o|contracted procedure: k28023 
o|contracted procedure: k28029 
o|contracted procedure: k28048 
o|contracted procedure: k28054 
o|contracted procedure: k28071 
o|contracted procedure: k28074 
o|contracted procedure: k28096 
o|contracted procedure: k28221 
o|contracted procedure: k28102 
o|contracted procedure: k28217 
o|contracted procedure: k28209 
o|contracted procedure: k28213 
o|contracted procedure: k28205 
o|contracted procedure: k28105 
o|contracted procedure: k28108 
o|contracted procedure: k28201 
o|contracted procedure: k28197 
o|contracted procedure: k28193 
o|contracted procedure: k28189 
o|contracted procedure: k28174 
o|contracted procedure: k28182 
o|contracted procedure: k28178 
o|contracted procedure: k28114 
o|contracted procedure: k28126 
o|contracted procedure: k28159 
o|contracted procedure: k28167 
o|contracted procedure: k28163 
o|contracted procedure: k28130 
o|contracted procedure: k28136 
o|contracted procedure: k28144 
o|contracted procedure: k28152 
o|contracted procedure: k28148 
o|contracted procedure: k28140 
o|contracted procedure: k28227 
o|contracted procedure: k28250 
o|contracted procedure: k28271 
o|contracted procedure: k28277 
o|contracted procedure: k28294 
o|contracted procedure: k28283 
o|contracted procedure: k28290 
o|contracted procedure: k28307 
o|contracted procedure: k28317 
o|contracted procedure: k28314 
o|contracted procedure: k28330 
o|contracted procedure: k28366 
o|contracted procedure: k28399 
o|contracted procedure: k28423 
o|contracted procedure: k28435 
o|contracted procedure: k28447 
o|contracted procedure: k28459 
o|contracted procedure: k28468 
o|contracted procedure: k28487 
o|contracted procedure: k28499 
o|contracted procedure: k28508 
o|contracted procedure: k28517 
o|contracted procedure: k28523 
o|contracted procedure: k28532 
o|contracted procedure: k28551 
o|contracted procedure: k28557 
o|contracted procedure: k28596 
o|contracted procedure: k28611 
o|contracted procedure: k28614 
o|contracted procedure: k28629 
o|contracted procedure: k28639 
o|contracted procedure: k28646 
o|contracted procedure: k28670 
o|contracted procedure: k28679 
o|contracted procedure: k28685 
o|contracted procedure: k28697 
o|contracted procedure: k28709 
o|contracted procedure: k28721 
o|contracted procedure: k28733 
o|contracted procedure: k28745 
o|contracted procedure: k28757 
o|contracted procedure: k28766 
o|contracted procedure: k28778 
o|contracted procedure: k28793 
o|contracted procedure: k28805 
o|contracted procedure: k28820 
o|contracted procedure: k28832 
o|contracted procedure: k28844 
o|contracted procedure: k28893 
o|contracted procedure: k28882 
o|contracted procedure: k28889 
o|contracted procedure: k28904 
o|contracted procedure: k28924 
o|contracted procedure: k28920 
o|contracted procedure: k28934 
o|contracted procedure: k28974 
o|contracted procedure: k28986 
o|contracted procedure: k28995 
o|contracted procedure: k29005 
o|contracted procedure: k29011 
o|contracted procedure: k29024 
o|contracted procedure: k29027 
o|contracted procedure: k29050 
o|contracted procedure: k29095 
o|contracted procedure: k29101 
o|contracted procedure: k29110 
o|contracted procedure: k29122 
o|contracted procedure: k29134 
o|contracted procedure: k29143 
o|contracted procedure: k29146 
o|contracted procedure: k29155 
o|contracted procedure: k29161 
o|contracted procedure: k29170 
o|contracted procedure: k29179 
o|contracted procedure: k29188 
o|contracted procedure: k29197 
o|contracted procedure: k29200 
o|contracted procedure: k29260 
o|contracted procedure: k29246 
o|contracted procedure: k29256 
o|contracted procedure: k29274 
o|contracted procedure: k29264 
o|contracted procedure: k29271 
o|contracted procedure: k29286 
o|contracted procedure: k29319 
o|contracted procedure: k29407 
o|contracted procedure: k29331 
o|contracted procedure: k29340 
o|contracted procedure: k29343 
o|contracted procedure: k29349 
o|contracted procedure: k29352 
o|contracted procedure: k29358 
o|contracted procedure: k29367 
o|contracted procedure: k29370 
o|contracted procedure: k29381 
o|contracted procedure: k29413 
o|contracted procedure: k29437 
o|contracted procedure: k29446 
o|contracted procedure: k29471 
o|contracted procedure: k29478 
o|contracted procedure: k29487 
o|contracted procedure: k29494 
o|contracted procedure: k29500 
o|contracted procedure: k29506 
o|contracted procedure: k29513 
o|contracted procedure: k29568 
o|contracted procedure: k29560 
o|contracted procedure: k29564 
o|contracted procedure: k29526 
o|contracted procedure: k29532 
o|contracted procedure: k29538 
o|contracted procedure: k29545 
o|contracted procedure: k29552 
o|contracted procedure: k29577 
o|contracted procedure: k29583 
o|contracted procedure: k29600 
o|contracted procedure: k29590 
o|contracted procedure: k29609 
o|contracted procedure: k29630 
o|contracted procedure: k29618 
o|contracted procedure: k29621 
o|contracted procedure: k29645 
o|contracted procedure: k29639 
o|contracted procedure: k29663 
o|contracted procedure: k29654 
o|contracted procedure: k29681 
o|contracted procedure: k29672 
o|contracted procedure: k29700 
o|contracted procedure: k29712 
o|contracted procedure: k29722 
o|contracted procedure: k29726 
o|contracted procedure: k29751 
o|contracted procedure: k29763 
o|contracted procedure: k29773 
o|contracted procedure: k29777 
o|contracted procedure: k29825 
o|contracted procedure: k29831 
o|contracted procedure: k29840 
o|contracted procedure: k29843 
o|contracted procedure: k29859 
o|propagated global variable: r29860 ##sys#undefined-value 
o|contracted procedure: k29862 
o|contracted procedure: k29881 
o|contracted procedure: k29899 
o|contracted procedure: k29884 
o|contracted procedure: k29895 
o|contracted procedure: k29891 
o|contracted procedure: k29915 
o|contracted procedure: k29908 
o|contracted procedure: k29927 
o|contracted procedure: k29940 
o|propagated global variable: r29941 ##sys#undefined-value 
o|contracted procedure: k29944 
o|contracted procedure: k29950 
o|contracted procedure: k29953 
o|contracted procedure: k29971 
o|contracted procedure: k29983 
o|contracted procedure: k29995 
o|contracted procedure: k30010 
o|contracted procedure: k30016 
o|contracted procedure: k30024 
o|contracted procedure: k30030 
o|contracted procedure: k30043 
o|contracted procedure: k30060 
o|contracted procedure: k30063 
o|contracted procedure: k30066 
o|contracted procedure: k30080 
o|contracted procedure: k30086 
o|contracted procedure: k30092 
o|contracted procedure: k30100 
o|contracted procedure: k30103 
o|contracted procedure: k30115 
o|contracted procedure: k30125 
o|contracted procedure: k30134 
o|contracted procedure: k30137 
o|contracted procedure: k30143 
o|contracted procedure: k30149 
o|contracted procedure: k30152 
o|contracted procedure: k30155 
o|contracted procedure: k30165 
o|contracted procedure: k30174 
o|contracted procedure: k30180 
o|contracted procedure: k30187 
o|contracted procedure: k30196 
o|contracted procedure: k30214 
o|contracted procedure: k30224 
o|contracted procedure: k30230 
o|contracted procedure: k30237 
o|contracted procedure: k30221 
o|contracted procedure: k30249 
o|contracted procedure: k30261 
o|contracted procedure: k30288 
o|contracted procedure: k30267 
o|contracted procedure: k30277 
o|contracted procedure: k30284 
o|contracted procedure: k30299 
o|contracted procedure: k30314 
o|contracted procedure: k30323 
o|contracted procedure: k30332 
o|contracted procedure: k30365 
o|contracted procedure: k30389 
o|contracted procedure: k30392 
o|contracted procedure: k30433 
o|contracted procedure: k30485 
o|contracted procedure: k30448 
o|contracted procedure: k30454 
o|contracted procedure: k30466 
o|contracted procedure: k30497 
o|contracted procedure: k30530 
o|contracted procedure: k30539 
o|contracted procedure: k30700 
o|contracted procedure: k30545 
o|contracted procedure: k30555 
o|contracted procedure: k30559 
o|contracted procedure: k30562 
o|contracted procedure: k30571 
o|contracted procedure: k30580 
o|contracted procedure: k30583 
o|contracted procedure: k30592 
o|contracted procedure: k30601 
o|contracted procedure: k30610 
o|contracted procedure: k30619 
o|contracted procedure: k30628 
o|contracted procedure: k30637 
o|contracted procedure: k30646 
o|contracted procedure: k30668 
o|contracted procedure: k30719 
o|contracted procedure: k30728 
o|contracted procedure: k30731 
o|contracted procedure: k30750 
o|contracted procedure: k30740 
o|contracted procedure: k30763 
o|contracted procedure: k30767 
o|contracted procedure: k30776 
o|contracted procedure: k30833 
o|contracted procedure: k30846 
o|contracted procedure: k30849 
o|contracted procedure: k30858 
o|contracted procedure: k30874 
o|contracted procedure: k30880 
o|contracted procedure: k30896 
o|contracted procedure: k30905 
o|contracted procedure: k30921 
o|contracted procedure: k30925 
o|contracted procedure: k30929 
o|contracted procedure: k30933 
o|contracted procedure: k30960 
o|contracted procedure: k30975 
o|contracted procedure: k30978 
o|contracted procedure: k30989 
o|contracted procedure: k30985 
o|contracted procedure: k31000 
o|contracted procedure: k31003 
o|contracted procedure: k31143 
o|contracted procedure: k31006 
o|contracted procedure: k31042 
o|contracted procedure: k31065 
o|contracted procedure: k31045 
o|contracted procedure: k31061 
o|contracted procedure: k31080 
o|contracted procedure: k31110 
o|contracted procedure: k31120 
o|contracted procedure: k31126 
o|contracted procedure: k31136 
o|contracted procedure: k31237 
o|contracted procedure: k31240 
o|contracted procedure: k31243 
o|contracted procedure: k31246 
o|contracted procedure: k31252 
o|contracted procedure: k31274 
o|contracted procedure: k31258 
o|contracted procedure: k31264 
o|contracted procedure: k31267 
o|contracted procedure: k31277 
o|contracted procedure: k41134 
o|contracted procedure: k41137 
o|contracted procedure: k41140 
o|contracted procedure: k41146 
o|contracted procedure: k41149 
o|contracted procedure: k41156 
o|contracted procedure: k41159 
o|contracted procedure: k41162 
o|contracted procedure: k41168 
o|contracted procedure: k41177 
o|contracted procedure: k41180 
o|contracted procedure: k41190 
o|contracted procedure: k41196 
o|contracted procedure: k41199 
o|contracted procedure: k41206 
o|contracted procedure: k41218 
o|contracted procedure: k41221 
o|contracted procedure: k41248 
o|contracted procedure: k41224 
o|contracted procedure: k41234 
o|contracted procedure: k41230 
o|contracted procedure: k41237 
o|contracted procedure: k41240 
o|contracted procedure: k41254 
o|contracted procedure: k41257 
o|contracted procedure: k41260 
o|contracted procedure: k41263 
o|contracted procedure: k41269 
o|contracted procedure: k41291 
o|contracted procedure: k41282 
o|contracted procedure: k41300 
o|contracted procedure: k41314 
o|contracted procedure: k41310 
o|contracted procedure: k41303 
o|contracted procedure: k41325 
o|contracted procedure: k41329 
o|contracted procedure: k41321 
o|contracted procedure: k41338 
o|contracted procedure: k41344 
o|contracted procedure: k41350 
o|contracted procedure: k41353 
o|contracted procedure: k41359 
o|contracted procedure: k31284 
o|contracted procedure: k31558 
o|contracted procedure: k31290 
o|contracted procedure: k31299 
o|contracted procedure: k31310 
o|contracted procedure: k31317 
o|contracted procedure: k31327 
o|contracted procedure: k31320 
o|contracted procedure: k31337 
o|contracted procedure: k31347 
o|contracted procedure: k31340 
o|contracted procedure: k31371 
o|contracted procedure: k31405 
o|contracted procedure: k31415 
o|contracted procedure: k31435 
o|contracted procedure: k31469 
o|contracted procedure: k31476 
o|contracted procedure: k31503 
o|contracted procedure: k31513 
o|contracted procedure: k31524 
o|contracted procedure: k31527 
o|contracted procedure: k31534 
o|contracted procedure: k31537 
o|contracted procedure: k31555 
o|contracted procedure: k31543 
o|contracted procedure: k31551 
o|contracted procedure: k31575 
o|contracted procedure: k31590 
o|contracted procedure: k31600 
o|contracted procedure: k31604 
o|contracted procedure: k31629 
o|contracted procedure: k31639 
o|inlining procedure: k31632 
o|inlining procedure: k31632 
o|contracted procedure: k31808 
o|contracted procedure: k31663 
o|contracted procedure: k31802 
o|contracted procedure: k31666 
o|contracted procedure: k31796 
o|contracted procedure: k31669 
o|contracted procedure: k31790 
o|contracted procedure: k31672 
o|contracted procedure: k31780 
o|contracted procedure: k31678 
o|contracted procedure: k31681 
o|contracted procedure: k31693 
o|contracted procedure: k31774 
o|contracted procedure: k31696 
o|contracted procedure: k31702 
o|contracted procedure: k31754 
o|contracted procedure: k31724 
o|contracted procedure: k31743 
o|contracted procedure: k31731 
o|contracted procedure: k31739 
o|contracted procedure: k31735 
o|contracted procedure: k31712 
o|contracted procedure: k31720 
o|contracted procedure: k31750 
o|contracted procedure: k31761 
o|contracted procedure: k31764 
o|contracted procedure: k31787 
o|contracted procedure: k31820 
o|contracted procedure: k31828 
o|contracted procedure: k31831 
o|contracted procedure: k31834 
o|contracted procedure: k31874 
o|contracted procedure: k31887 
o|contracted procedure: k31902 
o|contracted procedure: k31912 
o|contracted procedure: k31916 
o|contracted procedure: k32004 
o|contracted procedure: k31922 
o|contracted procedure: k31998 
o|contracted procedure: k31925 
o|contracted procedure: k31992 
o|contracted procedure: k31928 
o|contracted procedure: k31986 
o|contracted procedure: k31931 
o|contracted procedure: k31980 
o|contracted procedure: k31934 
o|contracted procedure: k31974 
o|contracted procedure: k31937 
o|contracted procedure: k31968 
o|contracted procedure: k31940 
o|contracted procedure: k31962 
o|contracted procedure: k31943 
o|contracted procedure: k31949 
o|contracted procedure: k31952 
o|contracted procedure: k32022 
o|contracted procedure: k32039 
o|contracted procedure: k32051 
o|contracted procedure: k32077 
o|contracted procedure: k32070 
o|contracted procedure: k32087 
o|contracted procedure: k32095 
o|contracted procedure: k32110 
o|contracted procedure: k32120 
o|contracted procedure: k32124 
o|contracted procedure: k32154 
o|contracted procedure: k32161 
o|contracted procedure: k32167 
o|contracted procedure: k32170 
o|contracted procedure: k32208 
o|contracted procedure: k32218 
o|contracted procedure: k32222 
o|contracted procedure: k32225 
o|contracted procedure: k32228 
o|contracted procedure: k32246 
o|contracted procedure: k32255 
o|contracted procedure: k32258 
o|contracted procedure: k32261 
o|contracted procedure: k32276 
o|contracted procedure: k32286 
o|contracted procedure: k32279 
o|inlining procedure: k32268 
o|inlining procedure: k32268 
o|contracted procedure: k32293 
o|contracted procedure: k32299 
o|contracted procedure: k32305 
o|contracted procedure: k32311 
o|contracted procedure: k32317 
o|contracted procedure: k32323 
o|contracted procedure: k32329 
o|contracted procedure: k32335 
o|contracted procedure: k32341 
o|contracted procedure: k32347 
o|contracted procedure: k32353 
o|contracted procedure: k32359 
o|contracted procedure: k32365 
o|contracted procedure: k32371 
o|contracted procedure: k32408 
o|contracted procedure: k32411 
o|contracted procedure: k32427 
o|contracted procedure: k32420 
o|contracted procedure: k32448 
o|contracted procedure: k32471 
o|contracted procedure: k32467 
o|contracted procedure: k32499 
o|contracted procedure: k32495 
o|contracted procedure: k32502 
o|contracted procedure: k32506 
o|contracted procedure: k32512 
o|contracted procedure: k32515 
o|contracted procedure: k32518 
o|contracted procedure: k32521 
o|contracted procedure: k32524 
o|contracted procedure: k32545 
o|contracted procedure: k32551 
o|contracted procedure: k32554 
o|contracted procedure: k32560 
o|contracted procedure: k32574 
o|contracted procedure: k32571 
o|contracted procedure: k32583 
o|contracted procedure: k32642 
o|contracted procedure: k32595 
o|contracted procedure: k32638 
o|contracted procedure: k32610 
o|contracted procedure: k32634 
o|contracted procedure: k32630 
o|contracted procedure: k32626 
o|contracted procedure: k32665 
o|contracted procedure: k32668 
o|contracted procedure: k32694 
o|contracted procedure: k32700 
o|contracted procedure: k32707 
o|contracted procedure: k32713 
o|contracted procedure: k32732 
o|contracted procedure: k32785 
o|contracted procedure: k32738 
o|contracted procedure: k32770 
o|contracted procedure: k32751 
o|contracted procedure: k32759 
o|contracted procedure: k32755 
o|contracted procedure: k32781 
o|contracted procedure: k32777 
o|contracted procedure: k32795 
o|contracted procedure: k32805 
o|contracted procedure: k32828 
o|contracted procedure: k32845 
o|contracted procedure: k32867 
o|contracted procedure: k32863 
o|contracted procedure: k32848 
o|contracted procedure: k32851 
o|contracted procedure: k32859 
o|contracted procedure: k32874 
o|contracted procedure: k32891 
o|contracted procedure: k32913 
o|contracted procedure: k32909 
o|contracted procedure: k32894 
o|contracted procedure: k32897 
o|contracted procedure: k32905 
o|contracted procedure: k32925 
o|contracted procedure: k32939 
o|contracted procedure: k32928 
o|contracted procedure: k32935 
o|contracted procedure: k32945 
o|contracted procedure: k32955 
o|contracted procedure: k32967 
o|contracted procedure: k32989 
o|contracted procedure: k32985 
o|contracted procedure: k32970 
o|contracted procedure: k32973 
o|contracted procedure: k32981 
o|contracted procedure: k32996 
o|contracted procedure: k33019 
o|contracted procedure: k33022 
o|contracted procedure: k33025 
o|contracted procedure: k33033 
o|contracted procedure: k33041 
o|contracted procedure: k33005 
o|contracted procedure: k33059 
o|contracted procedure: k33072 
o|contracted procedure: k33081 
o|contracted procedure: k33119 
o|contracted procedure: k33087 
o|contracted procedure: k33101 
o|contracted procedure: k33097 
o|contracted procedure: k33115 
o|contracted procedure: k33122 
o|contracted procedure: k33125 
o|contracted procedure: k33137 
o|contracted procedure: k33140 
o|contracted procedure: k33143 
o|contracted procedure: k33151 
o|contracted procedure: k33159 
o|contracted procedure: k33189 
o|contracted procedure: k33185 
o|contracted procedure: k33195 
o|contracted procedure: k33198 
o|contracted procedure: k33203 
o|contracted procedure: k33235 
o|contracted procedure: k33209 
o|contracted procedure: k33231 
o|contracted procedure: k33212 
o|contracted procedure: k33273 
o|contracted procedure: k33285 
o|contracted procedure: k33295 
o|contracted procedure: k33299 
o|contracted procedure: k33330 
o|contracted procedure: k33355 
o|contracted procedure: k33339 
o|contracted procedure: k33372 
o|contracted procedure: k33392 
o|contracted procedure: k33398 
o|contracted procedure: k33411 
o|contracted procedure: k33417 
o|contracted procedure: k33436 
o|contracted procedure: k33450 
o|contracted procedure: k33439 
o|contracted procedure: k33446 
o|contracted procedure: k33466 
o|contracted procedure: k33472 
o|contracted procedure: k33479 
o|contracted procedure: k33485 
o|contracted procedure: k33535 
o|contracted procedure: k33495 
o|contracted procedure: k33547 
o|contracted procedure: k33550 
o|contracted procedure: k33553 
o|contracted procedure: k33556 
o|contracted procedure: k33567 
o|contracted procedure: k33584 
o|contracted procedure: k33587 
o|contracted procedure: k33590 
o|contracted procedure: k33593 
o|contracted procedure: k33604 
o|contracted procedure: k33621 
o|contracted procedure: k33630 
o|contracted procedure: k33639 
o|contracted procedure: k33648 
o|contracted procedure: k33657 
o|contracted procedure: k33666 
o|contracted procedure: k33675 
o|contracted procedure: k33684 
o|contracted procedure: k33693 
o|contracted procedure: k33702 
o|contracted procedure: k33711 
o|contracted procedure: k33720 
o|contracted procedure: k33729 
o|contracted procedure: k33738 
o|contracted procedure: k33747 
o|contracted procedure: k33756 
o|contracted procedure: k33765 
o|contracted procedure: k33774 
o|contracted procedure: k33783 
o|contracted procedure: k33792 
o|contracted procedure: k33801 
o|contracted procedure: k33810 
o|contracted procedure: k33819 
o|contracted procedure: k33828 
o|contracted procedure: k33837 
o|contracted procedure: k33846 
o|contracted procedure: k33855 
o|contracted procedure: k33864 
o|contracted procedure: k33873 
o|contracted procedure: k33882 
o|contracted procedure: k33891 
o|contracted procedure: k33900 
o|contracted procedure: k33909 
o|contracted procedure: k33918 
o|contracted procedure: k33927 
o|contracted procedure: k33936 
o|contracted procedure: k33945 
o|contracted procedure: k33954 
o|contracted procedure: k33963 
o|contracted procedure: k33972 
o|contracted procedure: k33981 
o|contracted procedure: k33990 
o|contracted procedure: k33999 
o|contracted procedure: k34008 
o|contracted procedure: k34017 
o|contracted procedure: k34026 
o|contracted procedure: k34035 
o|contracted procedure: k34044 
o|contracted procedure: k34053 
o|contracted procedure: k34062 
o|contracted procedure: k34071 
o|contracted procedure: k34080 
o|contracted procedure: k34089 
o|contracted procedure: k34098 
o|contracted procedure: k34101 
o|contracted procedure: k34104 
o|contracted procedure: k34107 
o|contracted procedure: k34118 
o|contracted procedure: k34135 
o|contracted procedure: k34144 
o|contracted procedure: k34290 
o|contracted procedure: k34312 
o|contracted procedure: k34297 
o|contracted procedure: k34304 
o|contracted procedure: k34326 
o|contracted procedure: k34334 
o|contracted procedure: k34348 
o|contracted procedure: k34354 
o|contracted procedure: k34360 
o|contracted procedure: k34389 
o|contracted procedure: k34395 
o|contracted procedure: k34509 
o|contracted procedure: k34512 
o|contracted procedure: k34547 
o|contracted procedure: k34578 
o|contracted procedure: k34553 
o|contracted procedure: k34556 
o|contracted procedure: k34575 
o|contracted procedure: k34571 
o|contracted procedure: k34562 
o|contracted procedure: k34611 
o|contracted procedure: k34604 
o|contracted procedure: k34624 
o|contracted procedure: k34681 
o|contracted procedure: k34698 
o|contracted procedure: k34660 
o|contracted procedure: k34664 
o|contracted procedure: k34725 
o|contracted procedure: k34745 
o|contracted procedure: k34762 
o|contracted procedure: k34712 
o|contracted procedure: k34716 
o|contracted procedure: k34825 
o|contracted procedure: k34839 
o|contracted procedure: k34843 
o|contracted procedure: k34851 
o|contracted procedure: k34868 
o|contracted procedure: k34883 
o|contracted procedure: k34928 
o|contracted procedure: k34931 
o|contracted procedure: k34934 
o|contracted procedure: k34955 
o|contracted procedure: k34937 
o|contracted procedure: k34940 
o|contracted procedure: k34943 
o|contracted procedure: k34949 
o|contracted procedure: k34967 
o|contracted procedure: k34973 
o|contracted procedure: k34976 
o|contracted procedure: k35004 
o|contracted procedure: k34982 
o|contracted procedure: k34985 
o|contracted procedure: k34988 
o|contracted procedure: k34991 
o|contracted procedure: k34997 
o|contracted procedure: k34994 
o|contracted procedure: k35010 
o|contracted procedure: k35022 
o|contracted procedure: k35028 
o|contracted procedure: k35031 
o|contracted procedure: k35040 
o|contracted procedure: k35043 
o|contracted procedure: k35046 
o|contracted procedure: k35052 
o|contracted procedure: k35049 
o|contracted procedure: k35067 
o|contracted procedure: k35106 
o|contracted procedure: k35087 
o|contracted procedure: k35096 
o|contracted procedure: k35115 
o|contracted procedure: k35172 
o|contracted procedure: k35175 
o|contracted procedure: k35181 
o|contracted procedure: k35224 
o|contracted procedure: k35240 
o|contracted procedure: k35233 
o|contracted procedure: k35670 
o|contracted procedure: k35251 
o|contracted procedure: k35266 
o|contracted procedure: k35369 
o|contracted procedure: k35278 
o|contracted procedure: k35297 
o|contracted procedure: k35300 
o|contracted procedure: k35309 
o|contracted procedure: k3514945557 
o|contracted procedure: k35338 
o|contracted procedure: k35366 
o|contracted procedure: k35348 
o|contracted procedure: k35361 
o|contracted procedure: k35378 
o|contracted procedure: k35656 
o|contracted procedure: k35400 
o|contracted procedure: k35418 
o|contracted procedure: k35421 
o|contracted procedure: k35430 
o|contracted procedure: k35433 
o|contracted procedure: k35447 
o|contracted procedure: k35456 
o|contracted procedure: k35511 
o|contracted procedure: k35469 
o|contracted procedure: k35472 
o|contracted procedure: k35481 
o|contracted procedure: k35498 
o|contracted procedure: k35492 
o|contracted procedure: k35514 
o|contracted procedure: k3514945570 
o|contracted procedure: k35532 
o|contracted procedure: k35528 
o|contracted procedure: k35540 
o|contracted procedure: k35549 
o|contracted procedure: k35565 
o|contracted procedure: k35580 
o|contracted procedure: k35572 
o|contracted procedure: k35599 
o|contracted procedure: k35591 
o|contracted procedure: k35625 
o|contracted procedure: k35653 
o|contracted procedure: k35635 
o|contracted procedure: k35648 
o|contracted procedure: k35676 
o|contracted procedure: k35685 
o|contracted procedure: k35745 
o|contracted procedure: k35756 
o|contracted procedure: k35765 
o|contracted procedure: k35798 
o|contracted procedure: k35805 
o|contracted procedure: k35813 
o|contracted procedure: k35825 
o|contracted procedure: k35834 
o|contracted procedure: k35739 
o|contracted procedure: k35867 
o|contracted procedure: k35876 
o|contracted procedure: k35883 
o|contracted procedure: k35887 
o|contracted procedure: k35932 
o|contracted procedure: k35917 
o|contracted procedure: k35924 
o|contracted procedure: k35928 
o|contracted procedure: k35939 
o|contracted procedure: k35952 
o|contracted procedure: k35959 
o|contracted procedure: k35990 
o|contracted procedure: k35986 
o|contracted procedure: k36010 
o|contracted procedure: k36019 
o|contracted procedure: k36026 
o|contracted procedure: k36068 
o|contracted procedure: k36056 
o|contracted procedure: k36081 
o|contracted procedure: k36077 
o|contracted procedure: k36090 
o|contracted procedure: k36100 
o|contracted procedure: k36104 
o|contracted procedure: k36116 
o|contracted procedure: k36128 
o|contracted procedure: k36138 
o|contracted procedure: k36142 
o|contracted procedure: k36148 
o|contracted procedure: k36160 
o|contracted procedure: k36169 
o|contracted procedure: k36181 
o|contracted procedure: k36185 
o|contracted procedure: k36197 
o|contracted procedure: k36207 
o|contracted procedure: k36280 
o|contracted procedure: k36210 
o|contracted procedure: k36223 
o|contracted procedure: k36264 
o|contracted procedure: k36253 
o|contracted procedure: k36260 
o|contracted procedure: k36310 
o|contracted procedure: k36348 
o|contracted procedure: k36338 
o|contracted procedure: k36366 
o|contracted procedure: k36400 
o|contracted procedure: k36409 
o|contracted procedure: k36412 
o|contracted procedure: k36419 
o|contracted procedure: k36415 
o|contracted procedure: k36425 
o|contracted procedure: k36432 
o|contracted procedure: k36428 
o|contracted procedure: k36438 
o|contracted procedure: k36441 
o|contracted procedure: k36447 
o|contracted procedure: k36450 
o|contracted procedure: k36457 
o|contracted procedure: k36453 
o|contracted procedure: k36463 
o|contracted procedure: k36466 
o|contracted procedure: k36473 
o|contracted procedure: k36469 
o|contracted procedure: k36479 
o|contracted procedure: k36482 
o|contracted procedure: k36489 
o|contracted procedure: k36485 
o|contracted procedure: k36495 
o|contracted procedure: k36498 
o|contracted procedure: k36505 
o|contracted procedure: k36501 
o|contracted procedure: k36511 
o|contracted procedure: k36514 
o|contracted procedure: k36521 
o|contracted procedure: k36517 
o|contracted procedure: k36527 
o|contracted procedure: k36530 
o|contracted procedure: k36537 
o|contracted procedure: k36533 
o|contracted procedure: k36543 
o|contracted procedure: k36546 
o|contracted procedure: k36553 
o|contracted procedure: k36549 
o|contracted procedure: k36559 
o|contracted procedure: k36562 
o|contracted procedure: k36569 
o|contracted procedure: k36565 
o|contracted procedure: k36575 
o|contracted procedure: k36578 
o|contracted procedure: k36585 
o|contracted procedure: k36581 
o|contracted procedure: k36591 
o|contracted procedure: k36594 
o|contracted procedure: k36601 
o|contracted procedure: k36597 
o|contracted procedure: k36616 
o|contracted procedure: k36612 
o|contracted procedure: k36604 
o|contracted procedure: k36608 
o|contracted procedure: k36642 
o|contracted procedure: k36645 
o|contracted procedure: k36652 
o|contracted procedure: k36648 
o|contracted procedure: k36664 
o|contracted procedure: k36676 
o|contracted procedure: k36670 
o|contracted procedure: k36673 
o|contracted procedure: k36691 
o|contracted procedure: k36704 
o|contracted procedure: k36700 
o|contracted procedure: k36708 
o|contracted procedure: k36752 
o|contracted procedure: k36717 
o|contracted procedure: k36720 
o|contracted procedure: k36723 
o|contracted procedure: k36748 
o|contracted procedure: k36735 
o|contracted procedure: k36738 
o|contracted procedure: k36762 
o|contracted procedure: k36768 
o|contracted procedure: k36775 
o|contracted procedure: k36784 
o|contracted procedure: k36790 
o|contracted procedure: k36793 
o|contracted procedure: k36796 
o|contracted procedure: k36802 
o|contracted procedure: k36809 
o|contracted procedure: k36815 
o|contracted procedure: k36819 
o|contracted procedure: k36866 
o|contracted procedure: k36879 
o|contracted procedure: k36901 
o|contracted procedure: k36923 
o|contracted procedure: k36957 
o|contracted procedure: k36963 
o|contracted procedure: k36966 
o|contracted procedure: k36972 
o|contracted procedure: k36975 
o|contracted procedure: k36981 
o|contracted procedure: k36996 
o|contracted procedure: k36999 
o|contracted procedure: k37020 
o|contracted procedure: k37038 
o|contracted procedure: k37051 
o|contracted procedure: k37219 
o|contracted procedure: k37093 
o|contracted procedure: k37172 
o|contracted procedure: k37117 
o|contracted procedure: k37191 
o|contracted procedure: k37195 
o|contracted procedure: k37199 
o|contracted procedure: k37244 
o|contracted procedure: k37234 
o|contracted procedure: k37240 
o|contracted procedure: k37251 
o|contracted procedure: k37260 
o|contracted procedure: k37339 
o|contracted procedure: k37266 
o|contracted procedure: k37272 
o|contracted procedure: k37279 
o|contracted procedure: k37288 
o|contracted procedure: k37294 
o|contracted procedure: k37308 
o|contracted procedure: k37324 
o|contracted procedure: k37328 
o|contracted procedure: k37335 
o|contracted procedure: k37375 
o|contracted procedure: k37353 
o|contracted procedure: k37365 
o|contracted procedure: k37415 
o|contracted procedure: k37424 
o|contracted procedure: k40597 
o|contracted procedure: k40593 
o|contracted procedure: k40589 
o|contracted procedure: k37439 
o|contracted procedure: k37447 
o|contracted procedure: k37451 
o|contracted procedure: k37486 
o|contracted procedure: k40521 
o|contracted procedure: k37496 
o|contracted procedure: k37526 
o|contracted procedure: k37540 
o|contracted procedure: k37510 
o|contracted procedure: k3753645605 
o|contracted procedure: k37514 
o|contracted procedure: k3753645609 
o|contracted procedure: k37546 
o|contracted procedure: k37562 
o|contracted procedure: k37565 
o|contracted procedure: k37568 
o|contracted procedure: k37574 
o|contracted procedure: k37593 
o|contracted procedure: k37596 
o|contracted procedure: k37599 
o|contracted procedure: k37607 
o|contracted procedure: k37615 
o|contracted procedure: k37630 
o|contracted procedure: k37639 
o|contracted procedure: k37646 
o|contracted procedure: k37654 
o|contracted procedure: k37715 
o|contracted procedure: k37727 
o|contracted procedure: k37739 
o|contracted procedure: k37742 
o|contracted procedure: k37745 
o|contracted procedure: k37753 
o|contracted procedure: k37761 
o|contracted procedure: k37808 
o|contracted procedure: k37770 
o|contracted procedure: k37788 
o|contracted procedure: k37795 
o|contracted procedure: k37799 
o|contracted procedure: k37802 
o|contracted procedure: k37832 
o|contracted procedure: k37845 
o|contracted procedure: k37849 
o|contracted procedure: k37852 
o|contracted procedure: k37858 
o|contracted procedure: k37870 
o|contracted procedure: k37882 
o|contracted procedure: k37889 
o|contracted procedure: k38001 
o|contracted procedure: k37906 
o|contracted procedure: k37995 
o|contracted procedure: k37909 
o|contracted procedure: k37989 
o|contracted procedure: k37912 
o|contracted procedure: k37983 
o|contracted procedure: k37915 
o|contracted procedure: k37920 
o|contracted procedure: k37923 
o|contracted procedure: k37944 
o|contracted procedure: k37947 
o|contracted procedure: k37954 
o|contracted procedure: k37958 
o|contracted procedure: k37963 
o|contracted procedure: k37976 
o|contracted procedure: k37980 
o|contracted procedure: k38115 
o|contracted procedure: k38010 
o|contracted procedure: k38109 
o|contracted procedure: k38013 
o|contracted procedure: k38103 
o|contracted procedure: k38016 
o|contracted procedure: k38097 
o|contracted procedure: k38019 
o|contracted procedure: k38024 
o|contracted procedure: k38027 
o|contracted procedure: k38048 
o|contracted procedure: k38054 
o|contracted procedure: k38057 
o|contracted procedure: k38064 
o|contracted procedure: k38068 
o|contracted procedure: k38077 
o|contracted procedure: k38073 
o|contracted procedure: k38090 
o|contracted procedure: k38094 
o|contracted procedure: k38173 
o|contracted procedure: k38127 
o|contracted procedure: k38142 
o|contracted procedure: k38151 
o|contracted procedure: k38159 
o|contracted procedure: k38163 
o|contracted procedure: k38167 
o|contracted procedure: k38179 
o|contracted procedure: k38193 
o|contracted procedure: k38199 
o|contracted procedure: k38217 
o|contracted procedure: k38220 
o|contracted procedure: k38227 
o|contracted procedure: k38235 
o|contracted procedure: k38252 
o|contracted procedure: k38255 
o|contracted procedure: k38258 
o|contracted procedure: k38266 
o|contracted procedure: k38274 
o|contracted procedure: k38286 
o|contracted procedure: k38293 
o|contracted procedure: k38301 
o|contracted procedure: k38297 
o|contracted procedure: k38310 
o|contracted procedure: k38332 
o|contracted procedure: k38328 
o|contracted procedure: k38313 
o|contracted procedure: k38316 
o|contracted procedure: k38324 
o|contracted procedure: k38344 
o|contracted procedure: k38358 
o|contracted procedure: k38347 
o|contracted procedure: k38354 
o|contracted procedure: k38399 
o|contracted procedure: k38367 
o|contracted procedure: k38379 
o|contracted procedure: k38389 
o|contracted procedure: k38393 
o|contracted procedure: k38405 
o|contracted procedure: k38419 
o|contracted procedure: k38425 
o|contracted procedure: k38443 
o|contracted procedure: k38453 
o|contracted procedure: k38457 
o|contracted procedure: k38474 
o|contracted procedure: k38477 
o|contracted procedure: k38480 
o|contracted procedure: k38488 
o|contracted procedure: k38496 
o|contracted procedure: k38508 
o|contracted procedure: k38515 
o|contracted procedure: k38523 
o|contracted procedure: k38519 
o|contracted procedure: k38532 
o|contracted procedure: k38554 
o|contracted procedure: k38550 
o|contracted procedure: k38535 
o|contracted procedure: k38538 
o|contracted procedure: k38546 
o|contracted procedure: k38566 
o|contracted procedure: k38580 
o|contracted procedure: k38569 
o|contracted procedure: k38576 
o|contracted procedure: k38589 
o|contracted procedure: k38595 
o|contracted procedure: k38598 
o|contracted procedure: k38613 
o|contracted procedure: k38616 
o|contracted procedure: k38623 
o|contracted procedure: k38631 
o|contracted procedure: k38634 
o|contracted procedure: k38648 
o|contracted procedure: k38654 
o|contracted procedure: k38672 
o|contracted procedure: k38675 
o|contracted procedure: k38682 
o|contracted procedure: k38690 
o|contracted procedure: k38707 
o|contracted procedure: k38710 
o|contracted procedure: k38713 
o|contracted procedure: k38721 
o|contracted procedure: k38729 
o|contracted procedure: k38741 
o|contracted procedure: k38748 
o|contracted procedure: k38756 
o|contracted procedure: k38752 
o|contracted procedure: k38765 
o|contracted procedure: k38787 
o|contracted procedure: k38783 
o|contracted procedure: k38768 
o|contracted procedure: k38771 
o|contracted procedure: k38779 
o|contracted procedure: k38799 
o|contracted procedure: k38813 
o|contracted procedure: k38802 
o|contracted procedure: k38809 
o|contracted procedure: k38822 
o|contracted procedure: k38828 
o|contracted procedure: k38831 
o|contracted procedure: k38843 
o|contracted procedure: k38853 
o|contracted procedure: k38857 
o|contracted procedure: k38860 
o|contracted procedure: k38874 
o|contracted procedure: k38880 
o|contracted procedure: k38898 
o|contracted procedure: k38908 
o|contracted procedure: k38912 
o|contracted procedure: k38929 
o|contracted procedure: k38932 
o|contracted procedure: k38935 
o|contracted procedure: k38943 
o|contracted procedure: k38951 
o|contracted procedure: k38963 
o|contracted procedure: k38970 
o|contracted procedure: k38978 
o|contracted procedure: k38974 
o|contracted procedure: k38987 
o|contracted procedure: k39009 
o|contracted procedure: k39005 
o|contracted procedure: k38990 
o|contracted procedure: k38993 
o|contracted procedure: k39001 
o|contracted procedure: k39021 
o|contracted procedure: k39035 
o|contracted procedure: k39024 
o|contracted procedure: k39031 
o|contracted procedure: k39060 
o|contracted procedure: k39053 
o|contracted procedure: k39070 
o|contracted procedure: k39063 
o|contracted procedure: k39104 
o|contracted procedure: k39113 
o|contracted procedure: k39122 
o|contracted procedure: k39125 
o|contracted procedure: k39138 
o|contracted procedure: k39245 
o|contracted procedure: k39150 
o|contracted procedure: k39239 
o|contracted procedure: k39153 
o|contracted procedure: k39233 
o|contracted procedure: k39156 
o|contracted procedure: k39227 
o|contracted procedure: k39159 
o|contracted procedure: k39221 
o|contracted procedure: k39162 
o|contracted procedure: k39215 
o|contracted procedure: k39165 
o|contracted procedure: k39168 
o|contracted procedure: k39183 
o|contracted procedure: k39200 
o|contracted procedure: k39186 
o|contracted procedure: k39196 
o|contracted procedure: k39189 
o|contracted procedure: k39348 
o|contracted procedure: k39254 
o|contracted procedure: k39342 
o|contracted procedure: k39257 
o|contracted procedure: k39336 
o|contracted procedure: k39260 
o|contracted procedure: k39330 
o|contracted procedure: k39263 
o|contracted procedure: k39324 
o|contracted procedure: k39266 
o|contracted procedure: k39318 
o|contracted procedure: k39269 
o|contracted procedure: k39288 
o|contracted procedure: k39291 
o|contracted procedure: k39305 
o|contracted procedure: k39309 
o|contracted procedure: k39357 
o|contracted procedure: k39360 
o|contracted procedure: k39491 
o|contracted procedure: k39369 
o|contracted procedure: k39383 
o|contracted procedure: k39398 
o|contracted procedure: k39410 
o|contracted procedure: k39416 
o|contracted procedure: k39425 
o|contracted procedure: k39434 
o|contracted procedure: k39443 
o|contracted procedure: k39458 
o|contracted procedure: k39465 
o|contracted procedure: k39468 
o|contracted procedure: k39476 
o|contracted procedure: k39504 
o|contracted procedure: k39497 
o|contracted procedure: k39594 
o|contracted procedure: k39513 
o|contracted procedure: k39588 
o|contracted procedure: k39516 
o|contracted procedure: k39582 
o|contracted procedure: k39519 
o|contracted procedure: k39576 
o|contracted procedure: k39522 
o|contracted procedure: k39528 
o|contracted procedure: k39535 
o|contracted procedure: k39544 
o|contracted procedure: k39556 
o|contracted procedure: k39566 
o|contracted procedure: k39570 
o|contracted procedure: k39603 
o|contracted procedure: k39609 
o|contracted procedure: k39612 
o|contracted procedure: k39633 
o|contracted procedure: k39615 
o|contracted procedure: k39629 
o|contracted procedure: k39625 
o|contracted procedure: k39645 
o|contracted procedure: k39711 
o|contracted procedure: k39648 
o|contracted procedure: k39707 
o|contracted procedure: k39703 
o|contracted procedure: k39660 
o|contracted procedure: k39666 
o|contracted procedure: k39672 
o|contracted procedure: k39675 
o|contracted procedure: k39682 
o|contracted procedure: k39686 
o|contracted procedure: k39690 
o|contracted procedure: k39720 
o|contracted procedure: k39738 
o|contracted procedure: k39762 
o|contracted procedure: k39771 
o|contracted procedure: k39780 
o|contracted procedure: k39783 
o|contracted procedure: k39786 
o|contracted procedure: k39789 
o|contracted procedure: k39792 
o|contracted procedure: k39798 
o|contracted procedure: k39807 
o|contracted procedure: k39817 
o|contracted procedure: k39821 
o|contracted procedure: k39827 
o|contracted procedure: k39837 
o|contracted procedure: k39843 
o|contracted procedure: k39850 
o|contracted procedure: k39854 
o|contracted procedure: k39858 
o|contracted procedure: k39862 
o|contracted procedure: k39869 
o|contracted procedure: k39941 
o|contracted procedure: k39875 
o|contracted procedure: k39935 
o|contracted procedure: k39878 
o|contracted procedure: k39929 
o|contracted procedure: k39881 
o|contracted procedure: k39923 
o|contracted procedure: k39884 
o|contracted procedure: k39890 
o|contracted procedure: k39893 
o|contracted procedure: k39900 
o|contracted procedure: k39910 
o|contracted procedure: k39917 
o|contracted procedure: k40026 
o|contracted procedure: k39950 
o|contracted procedure: k40020 
o|contracted procedure: k39953 
o|contracted procedure: k40014 
o|contracted procedure: k39956 
o|contracted procedure: k40008 
o|contracted procedure: k39959 
o|contracted procedure: k40002 
o|contracted procedure: k39962 
o|contracted procedure: k39996 
o|contracted procedure: k39965 
o|contracted procedure: k39971 
o|contracted procedure: k39974 
o|contracted procedure: k39977 
o|contracted procedure: k39980 
o|contracted procedure: k39983 
o|contracted procedure: k40038 
o|contracted procedure: k40044 
o|contracted procedure: k40059 
o|contracted procedure: k40075 
o|contracted procedure: k40128 
o|contracted procedure: k40095 
o|contracted procedure: k40104 
o|contracted procedure: k40107 
o|contracted procedure: k40117 
o|contracted procedure: k40124 
o|contracted procedure: k40143 
o|contracted procedure: k40194 
o|contracted procedure: k40152 
o|contracted procedure: k40188 
o|contracted procedure: k40155 
o|contracted procedure: k40182 
o|contracted procedure: k40158 
o|contracted procedure: k40176 
o|contracted procedure: k40161 
o|contracted procedure: k40167 
o|contracted procedure: k40270 
o|contracted procedure: k40203 
o|contracted procedure: k40264 
o|contracted procedure: k40206 
o|contracted procedure: k40258 
o|contracted procedure: k40209 
o|contracted procedure: k40252 
o|contracted procedure: k40212 
o|contracted procedure: k40221 
o|contracted procedure: k40234 
o|contracted procedure: k40230 
o|contracted procedure: k40246 
o|contracted procedure: k40302 
o|contracted procedure: k40283 
o|contracted procedure: k40299 
o|contracted procedure: k40289 
o|contracted procedure: k40358 
o|contracted procedure: k40311 
o|contracted procedure: k40355 
o|contracted procedure: k40348 
o|contracted procedure: k40385 
o|contracted procedure: k40367 
o|contracted procedure: k40382 
o|contracted procedure: k40416 
o|contracted procedure: k40394 
o|contracted procedure: k40397 
o|contracted procedure: k40413 
o|contracted procedure: k40406 
o|contracted procedure: k40510 
o|contracted procedure: k40425 
o|contracted procedure: k40504 
o|contracted procedure: k40428 
o|contracted procedure: k40498 
o|contracted procedure: k40431 
o|contracted procedure: k40492 
o|contracted procedure: k40434 
o|contracted procedure: k40486 
o|contracted procedure: k40437 
o|contracted procedure: k40480 
o|contracted procedure: k40440 
o|contracted procedure: k40443 
o|contracted procedure: k40449 
o|contracted procedure: k40452 
o|contracted procedure: k40461 
o|contracted procedure: k40471 
o|contracted procedure: k40464 
o|contracted procedure: k40553 
o|contracted procedure: k40557 
o|contracted procedure: k40561 
o|contracted procedure: k40565 
o|contracted procedure: k40602 
o|contracted procedure: k40608 
o|contracted procedure: k40620 
o|contracted procedure: k40623 
o|contracted procedure: k40626 
o|contracted procedure: k40634 
o|contracted procedure: k40642 
o|contracted procedure: k40687 
o|contracted procedure: k40704 
o|contracted procedure: k40718 
o|contracted procedure: k40707 
o|contracted procedure: k40714 
o|contracted procedure: k40742 
o|contracted procedure: k40749 
o|contracted procedure: k40783 
o|contracted procedure: k40792 
o|contracted procedure: k40795 
o|contracted procedure: k40804 
o|contracted procedure: k40819 
o|contracted procedure: k40815 
o|contracted procedure: k40832 
o|contracted procedure: k40835 
o|contracted procedure: k40842 
o|contracted procedure: k40851 
o|contracted procedure: k40854 
o|contracted procedure: k40857 
o|contracted procedure: k40883 
o|contracted procedure: k40874 
o|contracted procedure: k40893 
o|contracted procedure: k40896 
o|contracted procedure: k40942 
o|contracted procedure: k40945 
o|contracted procedure: k40959 
o|contracted procedure: k40983 
o|contracted procedure: k40993 
o|contracted procedure: k41013 
o|contracted procedure: k41023 
o|contracted procedure: k41027 
o|contracted procedure: k41068 
o|contracted procedure: k41078 
o|contracted procedure: k41082 
o|contracted procedure: k41125 
o|contracted procedure: k41110 
o|contracted procedure: k41113 
o|contracted procedure: k41363 
o|contracted procedure: k41382 
o|contracted procedure: k41392 
o|contracted procedure: k41402 
o|contracted procedure: k41412 
o|contracted procedure: k41422 
o|contracted procedure: k41432 
o|contracted procedure: k41442 
o|contracted procedure: k41452 
o|contracted procedure: k41462 
o|contracted procedure: k41472 
o|contracted procedure: k41482 
o|contracted procedure: k41492 
o|contracted procedure: k41502 
o|contracted procedure: k41508 
o|contracted procedure: k41511 
o|contracted procedure: k41535 
o|contracted procedure: k41542 
o|contracted procedure: k41551 
o|contracted procedure: k41558 
o|contracted procedure: k41577 
o|contracted procedure: k41586 
o|contracted procedure: k41597 
o|contracted procedure: k41593 
o|contracted procedure: k41606 
o|contracted procedure: k41613 
o|contracted procedure: k41623 
o|contracted procedure: k41619 
o|contracted procedure: k41568 
o|contracted procedure: k41564 
o|simplifications: ((if . 30) (let . 994)) 
o|removed binding forms: 3262 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest152155 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest152155 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest175178 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest175178 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest880881 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest880881 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest893894 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest893894 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? fns944 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? fns951 0 
(o x)|known list op on rest arg sublist: ##core#rest-car lst1035 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest10741078 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest10741078 0 
o|inlining procedure: k13491 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest11031107 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest11031107 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest11291132 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest11291132 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest11291132 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest11291132 0 
(o x)|known list op on rest arg sublist: ##core#rest-car tst1163 0 
(o x)|known list op on rest arg sublist: ##core#rest-car bool1489 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1571 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1574 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1578 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1581 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1584 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1587 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1590 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1593 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1596 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1599 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1602 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1605 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1608 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1611 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1614 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1617 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1620 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1624 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1628 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1635 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1641 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1646 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1649 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc1654 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest16821684 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest16821684 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest16951697 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest16951697 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest17081710 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest17081710 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest17211723 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest17211723 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest17341736 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest17341736 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest17471749 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest17471749 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest17601762 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest17601762 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest17731775 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest17731775 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest18031805 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest18031805 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest18151817 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest18151817 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest19681970 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest19681970 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest19681970 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest19681970 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest20232026 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest20232026 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest20232026 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest20232026 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest20592061 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest20592061 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest20592061 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest20592061 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest20862090 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest20862090 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest20862090 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest20862090 0 
(o x)|known list op on rest arg sublist: ##core#rest-car end2132 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest26962697 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest26962697 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? args2932 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest31413143 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest31413143 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest31813183 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest31813183 0 
o|contracted procedure: k19657 
(o x)|known list op on rest arg sublist: ##core#rest-null? ns3419 0 
o|inlining procedure: k21277 
o|inlining procedure: k21277 
o|inlining procedure: k21277 
o|inlining procedure: k21277 
o|inlining procedure: k21277 
o|inlining procedure: k21372 
o|inlining procedure: k21372 
o|inlining procedure: k21372 
o|inlining procedure: k21372 
o|inlining procedure: k21372 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest38433845 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest38433845 0 
o|contracted procedure: k21735 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest38993901 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest38993901 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest38993901 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest38993901 0 
(o x)|known list op on rest arg sublist: ##core#rest-car str-or-sym3982 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest40474050 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest40474050 0 
o|inlining procedure: k22509 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest40984100 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest40984100 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest41324134 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest41324134 0 
o|inlining procedure: k22594 
o|inlining procedure: k22594 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest41844186 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest41844186 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest41844186 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest41844186 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest42184222 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest42184222 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest42184222 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest42184222 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest42984300 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest42984300 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest42984300 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest42984300 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest43224325 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest43224325 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest43224325 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest43224325 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest43494351 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest43494351 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest43494351 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest43494351 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest43844388 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest43844388 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest43844388 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest43844388 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest45124515 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest45124515 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest45394542 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest45394542 0 
(o x)|known list op on rest arg sublist: ##core#rest-car y4658 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? lsts4719 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? lsts4747 0 
o|contracted procedure: k41813 
(o x)|known list op on rest arg sublist: ##core#rest-car loc4949 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc4953 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc4956 0 
(o x)|known list op on rest arg sublist: ##core#rest-car loc4959 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest51945195 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest51945195 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest52845287 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest52845287 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest53425344 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest53425344 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest53975398 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest53975398 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest54105411 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest54105411 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest54425443 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest54425443 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest54535454 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest54535454 0 
o|contracted procedure: k26235 
o|inlining procedure: k26412 
o|contracted procedure: k27736 
o|contracted procedure: k27833 
o|contracted procedure: k28402 
(o x)|known list op on rest arg sublist: ##core#rest-null? xs5942 0 
(o x)|known list op on rest arg sublist: ##core#rest-car xs5942 0 
o|contracted procedure: k28569 
(o x)|known list op on rest arg sublist: ##core#rest-null? xs5989 0 
(o x)|known list op on rest arg sublist: ##core#rest-car xs5989 0 
o|contracted procedure: k28649 
(o x)|known list op on rest arg sublist: ##core#rest-null? xs5997 0 
(o x)|known list op on rest arg sublist: ##core#rest-car xs5997 0 
o|contracted procedure: k28873 
(o x)|known list op on rest arg sublist: ##core#rest-null? xs6059 0 
(o x)|known list op on rest arg sublist: ##core#rest-car xs6059 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest61986200 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest61986200 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest62116212 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest62116212 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest62216223 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest62216223 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest62336235 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest62336235 0 
o|inlining procedure: k29905 
o|inlining procedure: k29905 
o|inlining procedure: "(library.scm:5420) specialchar?6324" 
o|inlining procedure: "(library.scm:5442) specialchar?6324" 
o|contracted procedure: k30255 
o|contracted procedure: k30270 
o|inlining procedure: "(library.scm:5446) specialchar?6324" 
o|inlining procedure: k41297 
o|inlining procedure: k41297 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest67296734 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest67296734 0 
o|contracted procedure: k31445 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest68326833 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest68326833 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest68326833 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest68326833 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest69026903 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest69026903 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest69026903 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest69026903 0 
o|inlining procedure: k32488 
o|inlining procedure: k32488 
o|contracted procedure: k33318 
(o x)|known list op on rest arg sublist: ##core#rest-null? args7434 0 
(o x)|known list op on rest arg sublist: ##core#rest-car args7434 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? _%rest74387490 1 
(o x)|known list op on rest arg sublist: ##core#rest-car _%rest74387490 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr _%rest74387490 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest75037506 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest75037506 0 
(o x)|known list op on rest arg sublist: ##core#rest-car args7524 0 
(o x)|known list op on rest arg sublist: ##core#rest-car args7524 0 
(o x)|known list op on rest arg sublist: ##core#rest-car args7524 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest76607662 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest76607662 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest82248225 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest82248225 0 
(o x)|known list op on rest arg sublist: ##core#rest-car arg8313 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest84258428 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest84258428 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest85838584 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest85838584 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest86068607 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest86068607 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest88938895 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest88938895 0 
o|inlining procedure: k37838 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest89318933 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest89318933 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest89318933 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest89318933 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest89658967 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest89658967 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest89658967 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest89658967 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? more8998 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? more9124 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? more9247 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? more9374 0 
(o x)|known list op on rest arg sublist: ##core#rest-length rvar95109519 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rvar95109519 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rvar95109519 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest95309532 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest95309532 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest95309532 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest95309532 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest95729573 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest95729573 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest95729573 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest95729573 0 
(o x)|known list op on rest arg sublist: ##core#rest-car args9598 0 
o|inlining procedure: k39455 
o|inlining procedure: k39455 
(o x)|known list op on rest arg sublist: ##core#rest-cdr args9598 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest96369637 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest96369637 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest96369637 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest96369637 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest97449747 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest97449747 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest97449747 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest97449747 0 
o|contracted procedure: k39906 
o|inlining procedure: k39897 
o|inlining procedure: k39897 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest97699771 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest97699771 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest97699771 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest97699771 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest98339834 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest98339834 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest98339834 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest98339834 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest98519852 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest98519852 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest98519852 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest98519852 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest98819882 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest98819882 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? port9892 0 
(o x)|known list op on rest arg sublist: ##core#rest-car port9892 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest99099910 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest99099910 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest99239925 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest99239925 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest99409942 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest99409942 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest99409942 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest99409942 0 
o|inlining procedure: k40798 
o|inlining procedure: k40826 
o|inlining procedure: k40887 
o|inlining procedure: k40887 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest69596960 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest69596960 0 
o|replaced variables: 4 
o|removed binding forms: 21 
o|substituted constant variable: r1349248634 
(o x)|known list op on rest arg sublist: ##core#rest-null? r13628 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r13628 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r13628 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r13628 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r15347 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r15347 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r15347 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r15347 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r15551 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r15551 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r15551 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r15551 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r15670 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r15670 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r15670 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r15670 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r15745 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r15745 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r15745 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r15745 1 
o|substituted constant variable: r2127848700 
o|substituted constant variable: r2127848700 
o|substituted constant variable: r2127848701 
o|substituted constant variable: r2127848701 
o|substituted constant variable: r2137348704 
o|substituted constant variable: r2137348704 
o|substituted constant variable: r2137348705 
o|substituted constant variable: r2137348705 
o|substituted constant variable: r2137348706 
o|substituted constant variable: r2137348706 
(o x)|known list op on rest arg sublist: ##core#rest-null? r21968 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r21968 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r21968 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r21968 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r22720 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r22720 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r22720 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r22720 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r22801 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r22801 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r22801 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r22801 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r23022 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r23022 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r23022 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r23022 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r23114 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r23114 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r23114 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r23114 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r23195 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r23195 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r23195 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r23195 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r23302 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r23302 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r23302 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r23302 1 
o|removed side-effect free assignment to unused variable: specialchar?6324 
(o x)|known list op on rest arg sublist: ##core#rest-null? r31667 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r31667 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r31667 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r31667 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r31926 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r31926 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r31926 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r31926 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r37910 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r37910 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r37910 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r37910 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r38014 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r38014 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r38014 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r38014 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39154 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r39154 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39154 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r39154 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39258 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r39258 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39258 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r39258 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39517 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r39517 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39517 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r39517 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39879 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r39879 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39879 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r39879 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39954 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r39954 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39954 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r39954 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r40156 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r40156 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r40156 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r40156 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r40207 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r40207 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r40207 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r40207 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r40429 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r40429 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r40429 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r40429 1 
o|substituted constant variable: r4088849042 
o|replaced variables: 10 
o|removed binding forms: 22 
o|removed conditional forms: 6 
o|inlining procedure: k30109 
o|inlining procedure: k30211 
(o x)|known list op on rest arg sublist: ##core#rest-null? r31932 2 
(o x)|known list op on rest arg sublist: ##core#rest-car r31932 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r31932 2 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r31932 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39160 2 
(o x)|known list op on rest arg sublist: ##core#rest-car r39160 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39160 2 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r39160 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39264 2 
(o x)|known list op on rest arg sublist: ##core#rest-car r39264 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39264 2 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r39264 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39960 2 
(o x)|known list op on rest arg sublist: ##core#rest-car r39960 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r39960 2 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r39960 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r40435 2 
(o x)|known list op on rest arg sublist: ##core#rest-car r40435 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r40435 2 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r40435 2 
o|removed binding forms: 61 
o|contracted procedure: k30292 
(o x)|known list op on rest arg sublist: ##core#rest-null? r31938 3 
(o x)|known list op on rest arg sublist: ##core#rest-car r31938 3 
(o x)|known list op on rest arg sublist: ##core#rest-null? r31938 3 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r31938 3 
o|removed binding forms: 12 
o|removed binding forms: 2 
o|direct leaf routine/allocation: loop26 0 
o|direct leaf routine/allocation: loop39 0 
o|direct leaf routine/allocation: loop206 0 
o|direct leaf routine/allocation: loop218 0 
o|direct leaf routine/allocation: loop381 0 
o|direct leaf routine/allocation: loop395 0 
o|direct leaf routine/allocation: loop409 0 
o|direct leaf routine/allocation: loop423 0 
o|direct leaf routine/allocation: loop437 0 
o|direct leaf routine/allocation: loop996 0 
o|direct leaf routine/allocation: doloop20482049 0 
o|direct leaf routine/allocation: doloop21062107 0 
o|direct leaf routine/allocation: doloop21122113 0 
o|direct leaf routine/allocation: ratnum 21 
o|direct leaf routine/allocation: go-inexact!3518 0 
o|direct leaf routine/allocation: loop4169 0 
o|direct leaf routine/allocation: loop4257 0 
o|direct leaf routine/allocation: loop4290 0 
o|direct leaf routine/allocation: doloop43374338 0 
o|direct leaf routine/allocation: doloop43684369 0 
o|direct leaf routine/allocation: doloop44094410 0 
o|direct leaf routine/allocation: doloop44154416 0 
o|direct leaf routine/allocation: foldl44914496 0 
o|direct leaf routine/allocation: for-each-loop44344452 0 
o|direct leaf routine/allocation: doloop45284529 0 
o|direct leaf routine/allocation: doloop45564557 0 
o|direct leaf routine/allocation: loop4652 0 
o|direct leaf routine/allocation: body49644973 0 
o|direct leaf routine/allocation: def-set?49674976 0 
o|direct leaf routine/allocation: def-convert?49664978 0 
o|direct leaf routine/allocation: body49894998 0 
o|direct leaf routine/allocation: def-set?49925001 0 
o|direct leaf routine/allocation: def-convert?49915003 0 
o|direct leaf routine/allocation: body50145023 0 
o|direct leaf routine/allocation: def-set?50175026 0 
o|direct leaf routine/allocation: def-convert?50165028 0 
o|direct leaf routine/allocation: register-shared!5510 6 
o|direct leaf routine/allocation: complain5601 0 
o|direct leaf routine/allocation: body71677176 0 
o|direct leaf routine/allocation: def-set?71707179 0 
o|direct leaf routine/allocation: def-convert?71697181 0 
o|direct leaf routine/allocation: for-each-loop72117222 0 
o|direct leaf routine/allocation: loop8440 0 
o|direct leaf routine/allocation: doloop89508951 0 
o|direct leaf routine/allocation: g90919100 0 
o|direct leaf routine/allocation: foldl90439074 0 
o|direct leaf routine/allocation: for-each-loop90139031 0 
o|direct leaf routine/allocation: g92149223 0 
o|direct leaf routine/allocation: foldl91669197 0 
o|direct leaf routine/allocation: for-each-loop91369154 0 
o|direct leaf routine/allocation: g93429351 0 
o|direct leaf routine/allocation: foldl92949325 0 
o|direct leaf routine/allocation: for-each-loop92649282 0 
o|direct leaf routine/allocation: g94689477 0 
o|direct leaf routine/allocation: foldl94209451 0 
o|direct leaf routine/allocation: for-each-loop93909408 0 
o|direct leaf routine/allocation: finish9700 0 
o|direct leaf routine/allocation: for-each-loop86488659 0 
o|converted assignments to bindings: (loop26) 
o|converted assignments to bindings: (loop39) 
o|converted assignments to bindings: (loop206) 
o|converted assignments to bindings: (loop218) 
o|converted assignments to bindings: (loop381) 
o|converted assignments to bindings: (loop395) 
o|converted assignments to bindings: (loop409) 
o|converted assignments to bindings: (loop423) 
o|converted assignments to bindings: (loop437) 
o|converted assignments to bindings: (loop996) 
o|converted assignments to bindings: (doloop20482049) 
o|converted assignments to bindings: (doloop21062107) 
o|converted assignments to bindings: (doloop21122113) 
o|contracted procedure: "(library.scm:3059) k20601" 
o|contracted procedure: "(library.scm:3101) k20909" 
o|contracted procedure: "(library.scm:3106) k20934" 
o|contracted procedure: "(library.scm:3113) k20980" 
o|contracted procedure: "(library.scm:3151) k21312" 
o|contracted procedure: "(library.scm:3161) k21399" 
o|converted assignments to bindings: (loop4169) 
o|converted assignments to bindings: (loop4257) 
o|converted assignments to bindings: (loop4290) 
o|converted assignments to bindings: (doloop43374338) 
o|converted assignments to bindings: (doloop43684369) 
o|converted assignments to bindings: (doloop44094410) 
o|converted assignments to bindings: (doloop44154416) 
o|contracted procedure: k23476 
o|contracted procedure: k23528 
o|converted assignments to bindings: (foldl44914496) 
o|converted assignments to bindings: (for-each-loop44344452) 
o|converted assignments to bindings: (doloop45284529) 
o|converted assignments to bindings: (doloop45564557) 
o|converted assignments to bindings: (loop4652) 
o|inlining procedure: "(library.scm:4145) k24767" 
o|inlining procedure: "(library.scm:4145) k24767" 
o|inlining procedure: "(library.scm:4155) k24828" 
o|inlining procedure: "(library.scm:4155) k24828" 
o|inlining procedure: "(library.scm:4165) k24889" 
o|inlining procedure: "(library.scm:4165) k24889" 
o|contracted procedure: "(library.scm:4696) k26618" 
o|contracted procedure: "(library.scm:4708) k26665" 
o|contracted procedure: "(library.scm:5094) k28538" 
o|inlining procedure: "(library.scm:6142) k32691" 
o|inlining procedure: "(library.scm:6142) k32691" 
o|contracted procedure: k32813 
o|converted assignments to bindings: (for-each-loop72117222) 
o|contracted procedure: k36694 
o|converted assignments to bindings: (loop8440) 
o|converted assignments to bindings: (doloop89508951) 
o|contracted procedure: k38190 
o|contracted procedure: k38202 
o|contracted procedure: "(library.scm:7786) k38270" 
o|converted assignments to bindings: (foldl90439074) 
o|converted assignments to bindings: (for-each-loop90139031) 
o|contracted procedure: k38416 
o|contracted procedure: k38428 
o|contracted procedure: "(library.scm:7805) k38492" 
o|converted assignments to bindings: (foldl91669197) 
o|converted assignments to bindings: (for-each-loop91369154) 
o|contracted procedure: k38645 
o|contracted procedure: k38657 
o|contracted procedure: "(library.scm:7825) k38725" 
o|converted assignments to bindings: (foldl92949325) 
o|converted assignments to bindings: (for-each-loop92649282) 
o|contracted procedure: k38871 
o|contracted procedure: k38883 
o|contracted procedure: "(library.scm:7844) k38947" 
o|converted assignments to bindings: (foldl94209451) 
o|converted assignments to bindings: (for-each-loop93909408) 
o|contracted procedure: k40695 
o|converted assignments to bindings: (for-each-loop86488659) 
o|simplifications: ((let . 37)) 
o|removed binding forms: 26 
o|contracted procedure: "(library.scm:4145) k24767" 
o|contracted procedure: "(library.scm:4155) k24828" 
o|contracted procedure: "(library.scm:4165) k24889" 
o|contracted procedure: "(library.scm:6142) k32691" 
o|removed binding forms: 4 
x|number of unboxed float variables: 0
x|number of inline operations replaced with unboxed ones: 70
o|customizable procedures: (cleanup-before-exit g71047111 for-each-loop71037115 for-each-loop70787090 loop8126 k37087 map-loop86908707 check8731 k37473 k37476 k37479 k37482 loop9899 loop9808 loop9713 readb9699 recount9723 loop9674 loop9648 k39363 loop9615 g96109611 doloop95869587 k39174 k39177 map-loop94279444 map-loop94629487 doloop94579458 doloop93809381 map-loop93019318 map-loop93369361 doloop93319332 doloop92549255 map-loop91739190 map-loop92089233 doloop92039204 lp9129 map-loop90509067 map-loop90859110 doloop90809081 loop9004 v->s8978 loop8984 s->v8944 lp8924 doloop89118912 doloop89018902 map-loop88658883 loop8805 map-loop87738790 loop8797 for-each-loop87508762 loop8625 str8595 pmem8489 round-to8488 pnum8487 k36765 loop8465 loop8304 doloop82768277 for-each-loop82448254 for-each-loop82028216 doloop81158116 scan8098 loop8095 read-escaped-sexp7909 get/clear-str7969 loop7980 loop28003 readln7908 doloop79477956 loop7923 doloop79127913 loop7887 again7859 loop7754 loop7728 def-port74397488 def-header74407486 body74377446 g74607461 writeargs7411 g74177424 for-each-loop74167428 g73527361 map-loop73467371 loop7364 map-loop72897307 map-loop73167333 map-loop72297247 map-loop72567274 chicken.condition#prop-list->kind-prefixed-prop-list k32741 loop7192 k32249 k32252 k32272 for-each-loop70107022 for-each-loop69316942 loop6927 g68726879 for-each-loop68716892 k31861 k31705 loop6852 g68036810 for-each-loop68026813 k31425 conc16745 conc6744 getline6746 loop6760 grow6743 k41227 doloop65316532 doloop65026503 out6434 doloop64716472 outsym6325 g64506451 loop6406 k30202 loop6371 outchr6323 sym-is-readable?6327 outreadablesym6326 outstr6321 outstr06322 for-each-loop62806298 for-each-loop62486266 k29529 loop26170 loop6160 retry6164 k29322 fail6122 unthunkify!5512 r-symbol5563 k28946 r-ext-symbol5567 r-comment5566 r-char5565 r-vector5557 r-number-with-radix5560 r-number-with-exactness5559 r-digits5562 g59865987 r-quote5568 loop5922 r-token5561 k28230 k28077 k27792 k27810 r-string5555 loop5831 k27816 k27846 loop5811 k27674 read-unreserved-char-05509 loop5796 r-number5558 r-list5556 k27259 k27302 r-xtoken5564 loop5704 readrec5513 r-spaces5552 starting-line5699 info5506 k26916 k26936 k27040 eat-ws5669 r-usequence5553 r-xsequence5554 loop5635 k26639 loop5609 parse5600 abort5602 loop5586 skip-to-eol5507 loop5571 doloop55455546 loop!5537 unthunk5511 reserved-character5508 skip5518 k25806 def-convert?53715383 def-set?53725381 body53695378 assign5353 k25776 loop5229 loop5210 doloop52175218 close5045 open5044 k25051 k25061 doloop50535054 k41913 loop4918 k41806 loop4899 ##sys#dynamic-unwind loop4774 map-loop47504767 loop4737 for-each-loop47224732 lp4709 loop4695 loop4684 lookup-char4648 loop4633 loop4616 loop4599 loop4582 loop4565 ##sys#vector-resize map-loop44604477 doloop45014502 copy!4399 copy4362 loop4312 loop4253 k22827 k22743 loop4083 loop4075 map-loop39994018 compare-slots3918 loop3930 walk3919 ##sys#string->compnum scan-prefix3853 scan-real3747 k21254 k21309 scan-ureal3677 k20906 k20977 scan-decimal-tail3604 scan-digits+hashes3571 k20706 k20718 scan-exponent3591 k20745 safe-exponent3519 k20647 scan-digits3544 scan-hashes3563 lp3565 k20492 lp3546 round-quotient k20224 loop3420 loop3410 k19766 slow-expt3342 log-expt3341 lp3326 k19411 lp3314 k18840 k18846 k18778 k18784 loop3110 loop3098 find-ratio-between sr3075 ##sys#internal-gcd loop2933 deliver2867 doloop28692870 make-complex k16570 doloop22982299 loop2291 loop2267 compare2198 loop2207 compare2142 loop2151 k15912 k15919 k15682 k15566 loop2006 loop1993 loop1982 loop1953 k15160 loop1795 copy1785 loop1783 k14676 lp1656 fail1334 add1303 k13945 loop1165 loop1150 k13636 loop1113 loop1091 k13437 loop1051 loop1037 loop1022 loop1014 loop1008 loop978 loop963 loop952 loop922 loop910 loop867 loop858 loop184 loop161 loop134) 
o|calls to known targets: 1062 
o|identified direct recursive calls: f_11471 2 
o|identified direct recursive calls: f_11516 2 
o|identified direct recursive calls: f_11848 1 
o|unused rest argument: rest152155 f_11887 
o|unused rest argument: rest175178 f_11937 
o|identified direct recursive calls: f_12008 2 
o|identified direct recursive calls: f_12041 2 
o|identified direct recursive calls: f_12193 2 
o|identified direct recursive calls: f_12232 2 
o|identified direct recursive calls: f_12271 2 
o|identified direct recursive calls: f_12310 2 
o|identified direct recursive calls: f_12349 2 
o|unused rest argument: env525 f_12527 
o|unused rest argument: evaluator532 f_12551 
o|unused rest argument: _830 f_12672 
o|identified direct recursive calls: f_12759 1 
o|unused rest argument: rest880881 f_12797 
o|unused rest argument: rest893894 f_12815 
o|unused rest argument: _934 f_12918 
o|unused rest argument: _935 f_12920 
o|unused rest argument: _976 f_13075 
o|identified direct recursive calls: f_13144 1 
o|identified direct recursive calls: f_13169 1 
o|identified direct recursive calls: f_13205 1 
o|identified direct recursive calls: f_13234 2 
o|identified direct recursive calls: f_13281 1 
o|identified direct recursive calls: f_13335 2 
o|identified direct recursive calls: f_13477 1 
o|unused rest argument: rest10741078 f_13432 
o|unused rest argument: rest11031107 f_13518 
o|unused rest argument: rest11291132 f_13622 
o|identified direct recursive calls: f_14629 1 
o|unused rest argument: rest16821684 f_14745 
o|unused rest argument: rest16951697 f_14761 
o|unused rest argument: rest17081710 f_14777 
o|unused rest argument: rest17211723 f_14793 
o|unused rest argument: rest17341736 f_14809 
o|unused rest argument: rest17471749 f_14825 
o|unused rest argument: rest17601762 f_14841 
o|unused rest argument: rest17731775 f_14857 
o|identified direct recursive calls: f_14904 1 
o|identified direct recursive calls: f_14958 1 
o|unused rest argument: rest18031805 f_14982 
o|unused rest argument: rest18151817 f_14997 
o|identified direct recursive calls: f_15375 1 
o|unused rest argument: rest19681970 f_15341 
o|identified direct recursive calls: f_15450 1 
o|identified direct recursive calls: f_15503 1 
o|identified direct recursive calls: f_15591 1 
o|unused rest argument: rest20232026 f_15545 
o|unused rest argument: rest20592061 f_15664 
o|identified direct recursive calls: f_15788 1 
o|identified direct recursive calls: f_15822 1 
o|unused rest argument: rest20862090 f_15739 
o|identified direct recursive calls: f_15971 1 
o|identified direct recursive calls: f_16129 1 
o|identified direct recursive calls: f_16310 1 
o|identified direct recursive calls: f_16410 1 
o|unused rest argument: rest26962697 f_17250 
o|identified direct recursive calls: f_18291 1 
o|identified direct recursive calls: f_18473 1 
o|identified direct recursive calls: f_18517 1 
o|unused rest argument: rest31413143 f_18648 
o|unused rest argument: rest31813183 f_18874 
o|identified direct recursive calls: f_19558 2 
o|identified direct recursive calls: f_20434 1 
o|identified direct recursive calls: f_20538 1 
o|identified direct recursive calls: f_21730 6 
o|unused rest argument: rest38433845 f_21713 
o|unused rest argument: rest38993901 f_21962 
o|identified direct recursive calls: f_22079 1 
o|unused rest argument: rest40474050 f_22421 
o|identified direct recursive calls: f_22465 1 
o|identified direct recursive calls: f_22498 1 
o|unused rest argument: rest40984100 f_22525 
o|unused rest argument: rest41324134 f_22586 
o|identified direct recursive calls: f_22693 1 
o|unused rest argument: rest41844186 f_22714 
o|unused rest argument: rest42184222 f_22795 
o|identified direct recursive calls: f_22898 1 
o|identified direct recursive calls: f_22883 1 
o|identified direct recursive calls: f_22985 1 
o|identified direct recursive calls: f_23046 1 
o|unused rest argument: rest42984300 f_23016 
o|identified direct recursive calls: f_23138 1 
o|unused rest argument: rest43224325 f_23108 
o|identified direct recursive calls: f_23224 1 
o|unused rest argument: rest43494351 f_23189 
o|identified direct recursive calls: f_23357 1 
o|identified direct recursive calls: f_23391 1 
o|unused rest argument: rest43844388 f_23296 
o|identified direct recursive calls: f_23590 1 
o|identified direct recursive calls: f_23532 1 
o|identified direct recursive calls: f_23556 1 
o|identified direct recursive calls: f_23643 1 
o|unused rest argument: rest45124515 f_23613 
o|unused rest argument: rest45394542 f_23676 
o|identified direct recursive calls: f_23709 1 
o|identified direct recursive calls: f_23974 1 
o|identified direct recursive calls: f_24556 1 
o|identified direct recursive calls: f_41817 1 
o|identified direct recursive calls: f_24996 3 
o|unused rest argument: rest51945195 f_25392 
o|identified direct recursive calls: f_25445 1 
o|unused rest argument: rest52845287 f_25614 
o|unused rest argument: rest53425344 f_25766 
o|unused rest argument: rest53975398 f_25930 
o|unused rest argument: rest54105411 f_25955 
o|unused rest argument: rest54425443 f_26067 
o|unused rest argument: rest54535454 f_26085 
o|identified direct recursive calls: f_26326 1 
o|unused rest argument: xs5942 f_28418 
o|unused rest argument: xs5989 f_28591 
o|unused rest argument: xs5997 f_28665 
o|unused rest argument: xs6059 f_29045 
o|identified direct recursive calls: f_29482 1 
o|unused rest argument: rest61986200 f_29616 
o|unused rest argument: rest62116212 f_29637 
o|unused rest argument: rest62216223 f_29652 
o|unused rest argument: rest62336235 f_29670 
o|identified direct recursive calls: f_30129 1 
o|unused rest argument: rest67296734 f_31288 
o|unused rest argument: rest68326833 f_31661 
o|unused rest argument: rest69026903 f_31920 
o|unused rest argument: args6975 f_32146 
o|identified direct recursive calls: f_32920 1 
o|identified direct recursive calls: f_32840 1 
o|identified direct recursive calls: f_32886 1 
o|identified direct recursive calls: f_32962 1 
o|identified direct recursive calls: f_33076 2 
o|unused rest argument: args7434 f_33302 
o|unused rest argument: rest75037506 f_33493 
o|unused rest argument: rest76607662 f_34551 
o|unused rest argument: _7833 f_34917 
o|identified direct recursive calls: f_35110 1 
o|identified direct recursive calls: f_35451 1 
o|identified direct recursive calls: f_35791 1 
o|unused rest argument: rest82248225 f_36054 
o|unused rest argument: rest84258428 f_36668 
o|identified direct recursive calls: f_36712 1 
o|identified direct recursive calls: f_36779 1 
o|unused rest argument: rest85838584 f_37091 
o|unused rest argument: rest86068607 f_37232 
o|identified direct recursive calls: f_37283 1 
o|identified direct recursive calls: f_37557 2 
o|identified direct recursive calls: f_37783 1 
o|unused rest argument: rest88938895 f_37768 
o|identified direct recursive calls: f_37827 1 
o|identified direct recursive calls: f_37877 1 
o|identified direct recursive calls: f_37939 1 
o|unused rest argument: rest89318933 f_37904 
o|identified direct recursive calls: f_38043 1 
o|unused rest argument: rest89658967 f_38008 
o|identified direct recursive calls: f_38339 1 
o|identified direct recursive calls: f_38281 1 
o|identified direct recursive calls: f_38247 1 
o|identified direct recursive calls: f_38305 1 
o|identified direct recursive calls: f_38561 1 
o|identified direct recursive calls: f_38503 1 
o|identified direct recursive calls: f_38469 1 
o|identified direct recursive calls: f_38527 1 
o|identified direct recursive calls: f_38794 1 
o|identified direct recursive calls: f_38736 1 
o|identified direct recursive calls: f_38702 1 
o|identified direct recursive calls: f_38760 1 
o|identified direct recursive calls: f_39016 1 
o|identified direct recursive calls: f_38958 1 
o|identified direct recursive calls: f_38924 1 
o|identified direct recursive calls: f_38982 1 
o|unused rest argument: rvar95109519 f_39098 
o|unused rest argument: rest95309532 f_39148 
o|unused rest argument: rest95729573 f_39252 
o|unused rest argument: rest96369637 f_39511 
o|unused rest argument: rest97449747 f_39873 
o|unused rest argument: rest97699771 f_39948 
o|unused rest argument: rest98339834 f_40150 
o|unused rest argument: rest98519852 f_40201 
o|unused rest argument: rest98819882 f_40281 
o|unused rest argument: port9892 f_40309 
o|unused rest argument: rest99099910 f_40365 
o|unused rest argument: rest99239925 f_40392 
o|unused rest argument: rest99409942 f_40423 
o|identified direct recursive calls: f_40699 1 
o|unused rest argument: args7068 f_41090 
o|unused rest argument: rest69596960 f_41108 
o|fast box initializations: 227 
o|fast global references: 103 
o|fast global assignments: 24 
o|dropping unused closure argument: f_12008 
o|dropping unused closure argument: f_12041 
o|dropping unused closure argument: f_12193 
o|dropping unused closure argument: f_12232 
o|dropping unused closure argument: f_12271 
o|dropping unused closure argument: f_12310 
o|dropping unused closure argument: f_12349 
o|dropping unused closure argument: f_15949 
o|dropping unused closure argument: f_16107 
o|dropping unused closure argument: f_17268 
o|dropping unused closure argument: f_17448 
o|dropping unused closure argument: f_18291 
o|dropping unused closure argument: f_19600 
o|dropping unused closure argument: f_19614 
o|dropping unused closure argument: f_19864 
o|dropping unused closure argument: f_20287 
o|dropping unused closure argument: f_20330 
o|dropping unused closure argument: f_23206 
o|dropping unused closure argument: f_23316 
o|dropping unused closure argument: f_23532 
o|dropping unused closure argument: f_23590 
o|dropping unused closure argument: f_23697 
o|dropping unused closure argument: f_24556 
o|dropping unused closure argument: f_24946 
o|dropping unused closure argument: f_25176 
o|dropping unused closure argument: f_29879 
o|dropping unused closure argument: f_32033 
o|dropping unused closure argument: f_32721 
o|dropping unused closure argument: f_32920 
o|dropping unused closure argument: f_33257 
o|dropping unused closure argument: f_35154 
o|dropping unused closure argument: f_35201 
o|dropping unused closure argument: f_36838 
o|dropping unused closure argument: f_36852 
o|dropping unused closure argument: f_37112 
o|dropping unused closure argument: f_37442 
o|dropping unused closure argument: f_37918 
o|dropping unused closure argument: f_38022 
o|dropping unused closure argument: f_38281 
o|dropping unused closure argument: f_38339 
o|dropping unused closure argument: f_38503 
o|dropping unused closure argument: f_38561 
o|dropping unused closure argument: f_38736 
o|dropping unused closure argument: f_38794 
o|dropping unused closure argument: f_38958 
o|dropping unused closure argument: f_39016 
o|dropping unused closure argument: f_40699 
*/
/* end of file */
