/* Generated from scheduler.scm by the CHICKEN compiler
   http://www.call-cc.org
   Version 6.0.0pre1 ((HEAD detached at 6.0.0pre1)) (rev 05be15d4)
   linux-unix-gnu-x86-64 [ 64bit dload ptables ]
   command line: scheduler.scm -optimize-level 2 -include-path . -include-path ./ -inline -ignore-repository -feature chicken-bootstrap -no-warnings -specialize -consult-types-file ./types.db -explicit-use -no-trace -output-file scheduler.c
   unit: scheduler
   uses: extras library
*/
#include "chicken.h"

#ifdef HAVE_ERRNO_H
# include <errno.h>
# define C_signal_interrupted_p     C_mk_bool(errno == EINTR)
#else
# define C_signal_interrupted_p     C_SCHEME_FALSE
#endif

#ifdef _WIN32
/* TODO: Winsock select() only works for sockets */
# include <winsock2.h>
/* Beware: winsock2.h must come BEFORE windows.h */
# define C_msleep(n)   (Sleep((DWORD)C_num_to_uint64(n)), C_SCHEME_TRUE)
#else
# include <sys/time.h>
static C_word C_msleep(C_word ms);
C_word C_msleep(C_word ms) {
#ifdef __CYGWIN__
  if(usleep((useconds_t)C_num_to_uint64(ms) * 1000) == -1) return C_SCHEME_FALSE;
#else
  struct timespec ts;
  C_word ab[C_SIZEOF_FIX_BIGNUM], *a = ab,
         sec = C_s_a_u_i_integer_quotient(&a, 2, ms, C_fix(1000)),
         msec = C_s_a_u_i_integer_remainder(&a, 2, ms, C_fix(1000));
  ts.tv_sec = (time_t)C_num_to_uint64(sec);
  ts.tv_nsec = (long)C_unfix(msec) * 1000000;
  
  if(nanosleep(&ts, NULL) == -1) return C_SCHEME_FALSE;
#endif
  return C_SCHEME_TRUE;
}
#endif

#ifdef NO_POSIX_POLL

/* Shouldn't we include <sys/select.h> here? */
static fd_set C_fdset_input, C_fdset_output;

#define C_fd_input_ready(fd,pos)  C_mk_bool(FD_ISSET(C_unfix(fd), &C_fdset_input))
#define C_fd_output_ready(fd,pos)  C_mk_bool(FD_ISSET(C_unfix(fd), &C_fdset_output))

inline static int C_ready_fds_timeout(int to, unsigned int tm) {
  struct timeval timeout;
  timeout.tv_sec = tm / 1000;
  timeout.tv_usec = fmod(tm, 1000) * 1000;
  /* we use FD_SETSIZE, but really should use max fd */
  return select(FD_SETSIZE, &C_fdset_input, &C_fdset_output, NULL, to ? &timeout : NULL);
}

inline static void C_prepare_fdset(int length) {
  FD_ZERO(&C_fdset_input);
  FD_ZERO(&C_fdset_output);
}

inline static void C_fdset_add(int fd, int input, int output) {
  if (input) FD_SET(fd, &C_fdset_input);
  if (output) FD_SET(fd, &C_fdset_output);
}

#else
#  include <poll.h>
#  include <assert.h>

static int C_fdset_nfds;
static struct pollfd *C_fdset_set = NULL;

inline static int C_fd_ready(int fd, int pos, int what) {
  assert(fd == C_fdset_set[pos].fd); /* Must match position in fd-list! */
  return(C_fdset_set[pos].revents & what);
}

#define C_fd_input_ready(fd,pos)  C_mk_bool(C_fd_ready(C_unfix(fd), C_unfix(pos),POLLIN|POLLERR|POLLHUP|POLLNVAL))
#define C_fd_output_ready(fd,pos)  C_mk_bool(C_fd_ready(C_unfix(fd), C_unfix(pos),POLLOUT|POLLERR|POLLHUP|POLLNVAL))

inline static int C_ready_fds_timeout(int to, unsigned int tm) {
  return poll(C_fdset_set, C_fdset_nfds, to ? tm : -1);
}

inline static void C_prepare_fdset(int length) {
  /* TODO: Only realloc when needed? */
  C_fdset_set = realloc(C_fdset_set, sizeof(struct pollfd) * length);
  if (C_fdset_set == NULL)
    C_halt(C_SCHEME_FALSE); /* Ugly: no message */
  C_fdset_nfds = 0;
}

/* This *must* be called in order, so position will match fd-list */
inline static void C_fdset_add(int fd, int input, int output) {
  C_fdset_set[C_fdset_nfds].events = ((input ? POLLIN : 0) | (output ? POLLOUT : 0));
  C_fdset_set[C_fdset_nfds++].fd = fd;
}
#endif

static C_PTABLE_ENTRY *create_ptable(void);
C_noret_decl(C_extras_toplevel)
C_extern void C_ccall C_extras_toplevel(C_word c,C_word *av) C_noret;
C_noret_decl(C_library_toplevel)
C_extern void C_ccall C_library_toplevel(C_word c,C_word *av) C_noret;

static C_word lf[74];
static double C_possibly_force_alignment;
static C_char li0[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li1[] C_aligned={C_lihdr(0,0,12),40,100,101,108,113,32,120,32,108,115,116,41,0,0,0,0};
static C_char li2[] C_aligned={C_lihdr(0,0,7),40,108,111,111,112,50,41,0};
static C_char li3[] C_aligned={C_lihdr(0,0,20),40,108,111,111,112,50,32,116,104,114,101,97,100,115,32,107,101,101,112,41,0,0,0,0};
static C_char li4[] C_aligned={C_lihdr(0,0,16),40,108,111,111,112,32,110,32,112,111,115,32,108,115,116,41};
static C_char li5[] C_aligned={C_lihdr(0,0,8),40,103,52,48,50,32,116,41};
static C_char li6[] C_aligned={C_lihdr(0,0,23),40,102,111,114,45,101,97,99,104,45,108,111,111,112,52,48,49,32,103,52,48,56,41,0};
static C_char li7[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li8[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li9[] C_aligned={C_lihdr(0,0,7),40,108,111,111,112,49,41,0};
static C_char li10[] C_aligned={C_lihdr(0,0,16),40,35,35,115,121,115,35,115,99,104,101,100,117,108,101,41};
static C_char li11[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,102,111,114,99,101,45,112,114,105,109,111,114,100,105,97,108,41};
static C_char li12[] C_aligned={C_lihdr(0,0,19),40,35,35,115,121,115,35,114,101,97,100,121,45,113,117,101,117,101,41,0,0,0,0,0};
static C_char li13[] C_aligned={C_lihdr(0,0,33),40,35,35,115,121,115,35,97,100,100,45,116,111,45,114,101,97,100,121,45,113,117,101,117,101,32,116,104,114,101,97,100,41,0,0,0,0,0,0,0};
static C_char li14[] C_aligned={C_lihdr(0,0,34),40,35,35,115,121,115,35,117,112,100,97,116,101,45,116,104,114,101,97,100,45,115,116,97,116,101,45,98,117,102,102,101,114,41,0,0,0,0,0,0};
static C_char li15[] C_aligned={C_lihdr(0,0,7),40,97,49,51,49,56,41,0};
static C_char li16[] C_aligned={C_lihdr(0,0,35),40,35,35,115,121,115,35,105,110,116,101,114,114,117,112,116,45,104,111,111,107,32,114,101,97,115,111,110,32,115,116,97,116,101,41,0,0,0,0,0};
static C_char li17[] C_aligned={C_lihdr(0,0,21),40,35,35,115,121,115,35,116,105,109,101,111,117,116,45,113,117,101,117,101,41,0,0,0};
static C_char li18[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,112,114,101,118,41,0,0,0,0,0};
static C_char li19[] C_aligned={C_lihdr(0,0,34),40,35,35,115,121,115,35,114,101,109,111,118,101,45,102,114,111,109,45,116,105,109,101,111,117,116,45,108,105,115,116,32,116,41,0,0,0,0,0,0};
static C_char li20[] C_aligned={C_lihdr(0,0,14),40,108,111,111,112,32,116,108,32,112,114,101,118,41,0,0};
static C_char li21[] C_aligned={C_lihdr(0,0,38),40,35,35,115,121,115,35,116,104,114,101,97,100,45,98,108,111,99,107,45,102,111,114,45,116,105,109,101,111,117,116,33,32,116,32,116,109,41,0,0};
static C_char li22[] C_aligned={C_lihdr(0,0,42),40,35,35,115,121,115,35,116,104,114,101,97,100,45,98,108,111,99,107,45,102,111,114,45,116,101,114,109,105,110,97,116,105,111,110,33,32,116,32,116,50,41,0,0,0,0,0,0};
static C_char li23[] C_aligned={C_lihdr(0,0,9),40,103,51,52,51,32,116,50,41,0,0,0,0,0,0,0};
static C_char li24[] C_aligned={C_lihdr(0,0,23),40,102,111,114,45,101,97,99,104,45,108,111,111,112,51,52,50,32,103,51,52,57,41,0};
static C_char li25[] C_aligned={C_lihdr(0,0,23),40,102,111,114,45,101,97,99,104,45,108,111,111,112,51,48,56,32,103,51,49,53,41,0};
static C_char li26[] C_aligned={C_lihdr(0,0,23),40,102,111,114,45,101,97,99,104,45,108,111,111,112,50,57,52,32,103,51,48,49,41,0};
static C_char li27[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,116,104,114,101,97,100,45,107,105,108,108,33,32,116,32,115,41};
static C_char li28[] C_aligned={C_lihdr(0,0,31),40,35,35,115,121,115,35,116,104,114,101,97,100,45,98,97,115,105,99,45,117,110,98,108,111,99,107,33,32,116,41,0};
static C_char li29[] C_aligned={C_lihdr(0,0,7),40,97,49,55,49,56,41,0};
static C_char li30[] C_aligned={C_lihdr(0,0,37),40,35,35,115,121,115,35,100,101,102,97,117,108,116,45,101,120,99,101,112,116,105,111,110,45,104,97,110,100,108,101,114,32,97,114,103,41,0,0,0};
static C_char li31[] C_aligned={C_lihdr(0,0,16),40,35,35,115,121,115,35,102,100,45,113,117,101,117,101,41};
static C_char li32[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li33[] C_aligned={C_lihdr(0,0,38),40,35,35,115,121,115,35,116,104,114,101,97,100,45,98,108,111,99,107,45,102,111,114,45,105,47,111,33,32,116,32,102,100,32,105,47,111,41,0,0};
static C_char li34[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,115,116,41,0,0,0,0,0,0};
static C_char li35[] C_aligned={C_lihdr(0,0,37),40,35,35,115,121,115,35,99,108,101,97,114,45,105,47,111,45,115,116,97,116,101,45,102,111,114,45,116,104,114,101,97,100,33,32,116,41,0,0,0};
static C_char li36[] C_aligned={C_lihdr(0,0,27),40,102,95,50,52,57,54,32,113,117,101,117,101,32,97,114,103,32,118,97,108,32,105,110,105,116,41,0,0,0,0,0};
static C_char li37[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,108,41};
static C_char li38[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,32,105,41,0,0,0,0,0,0};
static C_char li39[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,32,105,41,0,0,0,0,0,0};
static C_char li40[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,108,32,105,41,0,0,0,0,0,0};
static C_char li41[] C_aligned={C_lihdr(0,0,26),40,35,35,115,121,115,35,97,108,108,45,116,104,114,101,97,100,115,32,46,32,114,101,115,116,41,0,0,0,0,0,0};
static C_char li42[] C_aligned={C_lihdr(0,0,31),40,35,35,115,121,115,35,102,101,116,99,104,45,97,110,100,45,99,108,101,97,114,45,116,104,114,101,97,100,115,41,0};
static C_char li43[] C_aligned={C_lihdr(0,0,27),40,35,35,115,121,115,35,114,101,115,116,111,114,101,45,116,104,114,101,97,100,115,32,118,101,99,41,0,0,0,0,0};
static C_char li44[] C_aligned={C_lihdr(0,0,25),40,35,35,115,121,115,35,116,104,114,101,97,100,45,117,110,98,108,111,99,107,33,32,116,41,0,0,0,0,0,0,0};
static C_char li45[] C_aligned={C_lihdr(0,0,7),40,97,50,53,56,51,41,0};
static C_char li46[] C_aligned={C_lihdr(0,0,14),40,97,50,53,55,49,32,114,101,116,117,114,110,41,0,0};
static C_char li47[] C_aligned={C_lihdr(0,0,24),40,35,35,115,121,115,35,116,104,114,101,97,100,45,115,108,101,101,112,33,32,116,109,41};
static C_char li48[] C_aligned={C_lihdr(0,0,27),40,99,104,105,99,107,101,110,46,98,97,115,101,35,115,108,101,101,112,45,104,111,111,107,32,110,41,0,0,0,0,0};
static C_char li49[] C_aligned={C_lihdr(0,0,9),40,115,117,115,112,101,110,100,41,0,0,0,0,0,0,0};
static C_char li50[] C_aligned={C_lihdr(0,0,6),40,103,54,53,53,41,0,0};
static C_char li51[] C_aligned={C_lihdr(0,0,18),40,102,111,114,45,101,97,99,104,45,108,111,111,112,54,53,52,41,0,0,0,0,0,0};
static C_char li52[] C_aligned={C_lihdr(0,0,18),40,102,111,114,45,101,97,99,104,45,108,111,111,112,54,56,55,41,0,0,0,0,0,0};
static C_char li53[] C_aligned={C_lihdr(0,0,6),40,103,54,54,53,41,0,0};
static C_char li54[] C_aligned={C_lihdr(0,0,18),40,102,111,114,45,101,97,99,104,45,108,111,111,112,54,54,52,41,0,0,0,0,0,0};
static C_char li55[] C_aligned={C_lihdr(0,0,32),40,35,35,115,121,115,35,107,105,108,108,45,111,116,104,101,114,45,116,104,114,101,97,100,115,32,116,104,117,110,107,41};
static C_char li56[] C_aligned={C_lihdr(0,0,10),40,116,111,112,108,101,118,101,108,41,0,0,0,0,0,0};


/* from g514 */
C_regparm static C_word stub518(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_truep(C_a0);
unsigned int t1=(unsigned int )C_num_to_unsigned_int(C_a1);
C_r=C_fix((C_word)C_ready_fds_timeout(t0,t1));
return C_r;}

/* from g445 */
C_regparm static C_word stub450(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
int t1=(int )C_truep(C_a1);
int t2=(int )C_truep(C_a2);
C_fdset_add(t0,t1,t2);
return C_r;}

/* from g388 */
C_regparm static C_word stub391(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_prepare_fdset(t0);
return C_r;}

C_noret_decl(f_1003)
static void f_1003(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1007)
static void C_ccall f_1007(C_word c,C_word *av) C_noret;
C_noret_decl(f_1010)
static void C_ccall f_1010(C_word c,C_word *av) C_noret;
C_noret_decl(f_1015)
static void f_1015(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1019)
static void f_1019(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1079)
static void f_1079(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1113)
static void C_ccall f_1113(C_word c,C_word *av) C_noret;
C_noret_decl(f_1116)
static void C_ccall f_1116(C_word c,C_word *av) C_noret;
C_noret_decl(f_1128)
static void f_1128(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1134)
static void C_ccall f_1134(C_word c,C_word *av) C_noret;
C_noret_decl(f_1146)
static void C_ccall f_1146(C_word c,C_word *av) C_noret;
C_noret_decl(f_1154)
static void C_ccall f_1154(C_word c,C_word *av) C_noret;
C_noret_decl(f_1188)
static void C_ccall f_1188(C_word c,C_word *av) C_noret;
C_noret_decl(f_1199)
static void C_ccall f_1199(C_word c,C_word *av) C_noret;
C_noret_decl(f_1202)
static void C_ccall f_1202(C_word c,C_word *av) C_noret;
C_noret_decl(f_1247)
static C_word f_1247(C_word t0);
C_noret_decl(f_1301)
static void C_ccall f_1301(C_word c,C_word *av) C_noret;
C_noret_decl(f_1305)
static void C_ccall f_1305(C_word c,C_word *av) C_noret;
C_noret_decl(f_1319)
static void C_ccall f_1319(C_word c,C_word *av) C_noret;
C_noret_decl(f_1326)
static void C_ccall f_1326(C_word c,C_word *av) C_noret;
C_noret_decl(f_1329)
static void C_ccall f_1329(C_word c,C_word *av) C_noret;
C_noret_decl(f_1335)
static C_word f_1335(C_word t0,C_word t1,C_word t2);
C_noret_decl(f_1370)
static void C_ccall f_1370(C_word c,C_word *av) C_noret;
C_noret_decl(f_1380)
static void C_ccall f_1380(C_word c,C_word *av) C_noret;
C_noret_decl(f_1391)
static void f_1391(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_1439)
static void C_ccall f_1439(C_word c,C_word *av) C_noret;
C_noret_decl(f_1504)
static void C_ccall f_1504(C_word c,C_word *av) C_noret;
C_noret_decl(f_1520)
static void f_1520(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1530)
static void C_ccall f_1530(C_word c,C_word *av) C_noret;
C_noret_decl(f_1546)
static void f_1546(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1569)
static void C_ccall f_1569(C_word c,C_word *av) C_noret;
C_noret_decl(f_1573)
static void C_ccall f_1573(C_word c,C_word *av) C_noret;
C_noret_decl(f_1579)
static void f_1579(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1582)
static void C_ccall f_1582(C_word c,C_word *av) C_noret;
C_noret_decl(f_1585)
static void C_ccall f_1585(C_word c,C_word *av) C_noret;
C_noret_decl(f_1603)
static void C_ccall f_1603(C_word c,C_word *av) C_noret;
C_noret_decl(f_1610)
static void f_1610(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1629)
static void f_1629(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1639)
static void C_ccall f_1639(C_word c,C_word *av) C_noret;
C_noret_decl(f_1660)
static void C_ccall f_1660(C_word c,C_word *av) C_noret;
C_noret_decl(f_1677)
static void C_ccall f_1677(C_word c,C_word *av) C_noret;
C_noret_decl(f_1683)
static void C_ccall f_1683(C_word c,C_word *av) C_noret;
C_noret_decl(f_1695)
static void C_ccall f_1695(C_word c,C_word *av) C_noret;
C_noret_decl(f_1699)
static void C_ccall f_1699(C_word c,C_word *av) C_noret;
C_noret_decl(f_1705)
static void C_ccall f_1705(C_word c,C_word *av) C_noret;
C_noret_decl(f_1719)
static void C_ccall f_1719(C_word c,C_word *av) C_noret;
C_noret_decl(f_1723)
static void C_ccall f_1723(C_word c,C_word *av) C_noret;
C_noret_decl(f_1732)
static void C_ccall f_1732(C_word c,C_word *av) C_noret;
C_noret_decl(f_1746)
static void f_1746(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1757)
static void f_1757(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1800)
static void C_ccall f_1800(C_word c,C_word *av) C_noret;
C_noret_decl(f_1806)
static void C_ccall f_1806(C_word c,C_word *av) C_noret;
C_noret_decl(f_1809)
static void C_ccall f_1809(C_word c,C_word *av) C_noret;
C_noret_decl(f_1812)
static void C_ccall f_1812(C_word c,C_word *av) C_noret;
C_noret_decl(f_1815)
static void C_ccall f_1815(C_word c,C_word *av) C_noret;
C_noret_decl(f_1818)
static void C_ccall f_1818(C_word c,C_word *av) C_noret;
C_noret_decl(f_1821)
static void C_ccall f_1821(C_word c,C_word *av) C_noret;
C_noret_decl(f_1842)
static void C_ccall f_1842(C_word c,C_word *av) C_noret;
C_noret_decl(f_1854)
static void f_1854(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1864)
static void C_ccall f_1864(C_word c,C_word *av) C_noret;
C_noret_decl(f_1879)
static void C_ccall f_1879(C_word c,C_word *av) C_noret;
C_noret_decl(f_1913)
static void C_ccall f_1913(C_word c,C_word *av) C_noret;
C_noret_decl(f_1919)
static void C_ccall f_1919(C_word c,C_word *av) C_noret;
C_noret_decl(f_1922)
static void C_ccall f_1922(C_word c,C_word *av) C_noret;
C_noret_decl(f_1925)
static void C_ccall f_1925(C_word c,C_word *av) C_noret;
C_noret_decl(f_1928)
static void C_ccall f_1928(C_word c,C_word *av) C_noret;
C_noret_decl(f_1931)
static void C_ccall f_1931(C_word c,C_word *av) C_noret;
C_noret_decl(f_1934)
static void C_ccall f_1934(C_word c,C_word *av) C_noret;
C_noret_decl(f_1937)
static void C_ccall f_1937(C_word c,C_word *av) C_noret;
C_noret_decl(f_1940)
static void C_ccall f_1940(C_word c,C_word *av) C_noret;
C_noret_decl(f_1958)
static void C_ccall f_1958(C_word c,C_word *av) C_noret;
C_noret_decl(f_1962)
static void C_ccall f_1962(C_word c,C_word *av) C_noret;
C_noret_decl(f_1977)
static void f_1977(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2025)
static void C_ccall f_2025(C_word c,C_word *av) C_noret;
C_noret_decl(f_2034)
static void C_ccall f_2034(C_word c,C_word *av) C_noret;
C_noret_decl(f_2058)
static void C_ccall f_2058(C_word c,C_word *av) C_noret;
C_noret_decl(f_2060)
static void f_2060(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_2087)
static void f_2087(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2122)
static void C_ccall f_2122(C_word c,C_word *av) C_noret;
C_noret_decl(f_2156)
static void C_ccall f_2156(C_word c,C_word *av) C_noret;
C_noret_decl(f_2159)
static void C_ccall f_2159(C_word c,C_word *av) C_noret;
C_noret_decl(f_2180)
static void C_ccall f_2180(C_word c,C_word *av) C_noret;
C_noret_decl(f_2186)
static void C_ccall f_2186(C_word c,C_word *av) C_noret;
C_noret_decl(f_2189)
static void C_ccall f_2189(C_word c,C_word *av) C_noret;
C_noret_decl(f_2192)
static void C_ccall f_2192(C_word c,C_word *av) C_noret;
C_noret_decl(f_2195)
static void C_ccall f_2195(C_word c,C_word *av) C_noret;
C_noret_decl(f_2198)
static void C_ccall f_2198(C_word c,C_word *av) C_noret;
C_noret_decl(f_2201)
static void C_ccall f_2201(C_word c,C_word *av) C_noret;
C_noret_decl(f_2209)
static void f_2209(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2212)
static void C_ccall f_2212(C_word c,C_word *av) C_noret;
C_noret_decl(f_2215)
static void C_ccall f_2215(C_word c,C_word *av) C_noret;
C_noret_decl(f_2256)
static void C_ccall f_2256(C_word c,C_word *av) C_noret;
C_noret_decl(f_2276)
static void C_ccall f_2276(C_word c,C_word *av) C_noret;
C_noret_decl(f_2287)
static void C_ccall f_2287(C_word c,C_word *av) C_noret;
C_noret_decl(f_2292)
static void f_2292(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2306)
static void C_ccall f_2306(C_word c,C_word *av) C_noret;
C_noret_decl(f_2308)
static void f_2308(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2330)
static void C_ccall f_2330(C_word c,C_word *av) C_noret;
C_noret_decl(f_2349)
static void C_ccall f_2349(C_word c,C_word *av) C_noret;
C_noret_decl(f_2361)
static void C_ccall f_2361(C_word c,C_word *av) C_noret;
C_noret_decl(f_2379)
static void f_2379(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2395)
static void C_ccall f_2395(C_word c,C_word *av) C_noret;
C_noret_decl(f_2402)
static void f_2402(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2421)
static void C_ccall f_2421(C_word c,C_word *av) C_noret;
C_noret_decl(f_2426)
static void f_2426(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2444)
static void C_ccall f_2444(C_word c,C_word *av) C_noret;
C_noret_decl(f_2451)
static void f_2451(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2467)
static void C_ccall f_2467(C_word c,C_word *av) C_noret;
C_noret_decl(f_2496)
static void C_ccall f_2496(C_word c,C_word *av) C_noret;
C_noret_decl(f_2505)
static void C_ccall f_2505(C_word c,C_word *av) C_noret;
C_noret_decl(f_2515)
static void C_ccall f_2515(C_word c,C_word *av) C_noret;
C_noret_decl(f_2534)
static void C_ccall f_2534(C_word c,C_word *av) C_noret;
C_noret_decl(f_2547)
static void C_ccall f_2547(C_word c,C_word *av) C_noret;
C_noret_decl(f_2550)
static void C_ccall f_2550(C_word c,C_word *av) C_noret;
C_noret_decl(f_2566)
static void C_ccall f_2566(C_word c,C_word *av) C_noret;
C_noret_decl(f_2572)
static void C_ccall f_2572(C_word c,C_word *av) C_noret;
C_noret_decl(f_2579)
static void C_ccall f_2579(C_word c,C_word *av) C_noret;
C_noret_decl(f_2584)
static void C_ccall f_2584(C_word c,C_word *av) C_noret;
C_noret_decl(f_2590)
static void C_ccall f_2590(C_word c,C_word *av) C_noret;
C_noret_decl(f_2604)
static void C_ccall f_2604(C_word c,C_word *av) C_noret;
C_noret_decl(f_2607)
static C_word f_2607(C_word t0,C_word t1);
C_noret_decl(f_2633)
static C_word f_2633(C_word t0,C_word t1);
C_noret_decl(f_2645)
static C_word f_2645(C_word t0,C_word t1);
C_noret_decl(f_2654)
static C_word f_2654(C_word t0,C_word t1);
C_noret_decl(f_2683)
static void C_ccall f_2683(C_word c,C_word *av) C_noret;
C_noret_decl(f_2688)
static C_word f_2688(C_word t0,C_word t1);
C_noret_decl(f_2711)
static C_word f_2711(C_word t0,C_word t1);
C_noret_decl(f_919)
static void C_ccall f_919(C_word c,C_word *av) C_noret;
C_noret_decl(f_922)
static void C_ccall f_922(C_word c,C_word *av) C_noret;
C_noret_decl(f_924)
static void f_924(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_930)
static void f_930(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_957)
static void C_ccall f_957(C_word c,C_word *av) C_noret;
C_noret_decl(f_967)
static void C_ccall f_967(C_word c,C_word *av) C_noret;
C_noret_decl(f_998)
static void C_ccall f_998(C_word c,C_word *av) C_noret;
C_noret_decl(C_scheduler_toplevel)
C_extern void C_ccall C_scheduler_toplevel(C_word c,C_word *av) C_noret;

C_noret_decl(trf_1003)
static void C_ccall trf_1003(C_word c,C_word *av) C_noret;
static void C_ccall trf_1003(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1003(t0,t1);}

C_noret_decl(trf_1015)
static void C_ccall trf_1015(C_word c,C_word *av) C_noret;
static void C_ccall trf_1015(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1015(t0,t1);}

C_noret_decl(trf_1019)
static void C_ccall trf_1019(C_word c,C_word *av) C_noret;
static void C_ccall trf_1019(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1019(t0,t1);}

C_noret_decl(trf_1079)
static void C_ccall trf_1079(C_word c,C_word *av) C_noret;
static void C_ccall trf_1079(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1079(t0,t1,t2);}

C_noret_decl(trf_1128)
static void C_ccall trf_1128(C_word c,C_word *av) C_noret;
static void C_ccall trf_1128(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1128(t0,t1);}

C_noret_decl(trf_1391)
static void C_ccall trf_1391(C_word c,C_word *av) C_noret;
static void C_ccall trf_1391(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_1391(t0,t1,t2,t3);}

C_noret_decl(trf_1520)
static void C_ccall trf_1520(C_word c,C_word *av) C_noret;
static void C_ccall trf_1520(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1520(t0,t1,t2);}

C_noret_decl(trf_1546)
static void C_ccall trf_1546(C_word c,C_word *av) C_noret;
static void C_ccall trf_1546(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1546(t0,t1,t2);}

C_noret_decl(trf_1579)
static void C_ccall trf_1579(C_word c,C_word *av) C_noret;
static void C_ccall trf_1579(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1579(t0,t1);}

C_noret_decl(trf_1610)
static void C_ccall trf_1610(C_word c,C_word *av) C_noret;
static void C_ccall trf_1610(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1610(t0,t1,t2);}

C_noret_decl(trf_1629)
static void C_ccall trf_1629(C_word c,C_word *av) C_noret;
static void C_ccall trf_1629(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1629(t0,t1,t2);}

C_noret_decl(trf_1746)
static void C_ccall trf_1746(C_word c,C_word *av) C_noret;
static void C_ccall trf_1746(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1746(t0,t1,t2);}

C_noret_decl(trf_1757)
static void C_ccall trf_1757(C_word c,C_word *av) C_noret;
static void C_ccall trf_1757(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1757(t0,t1,t2);}

C_noret_decl(trf_1854)
static void C_ccall trf_1854(C_word c,C_word *av) C_noret;
static void C_ccall trf_1854(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1854(t0,t1,t2);}

C_noret_decl(trf_1977)
static void C_ccall trf_1977(C_word c,C_word *av) C_noret;
static void C_ccall trf_1977(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1977(t0,t1,t2);}

C_noret_decl(trf_2060)
static void C_ccall trf_2060(C_word c,C_word *av) C_noret;
static void C_ccall trf_2060(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_2060(t0,t1,t2,t3,t4);}

C_noret_decl(trf_2087)
static void C_ccall trf_2087(C_word c,C_word *av) C_noret;
static void C_ccall trf_2087(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_2087(t0,t1,t2,t3);}

C_noret_decl(trf_2209)
static void C_ccall trf_2209(C_word c,C_word *av) C_noret;
static void C_ccall trf_2209(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_2209(t0,t1);}

C_noret_decl(trf_2292)
static void C_ccall trf_2292(C_word c,C_word *av) C_noret;
static void C_ccall trf_2292(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_2292(t0,t1);}

C_noret_decl(trf_2308)
static void C_ccall trf_2308(C_word c,C_word *av) C_noret;
static void C_ccall trf_2308(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_2308(t0,t1,t2);}

C_noret_decl(trf_2379)
static void C_ccall trf_2379(C_word c,C_word *av) C_noret;
static void C_ccall trf_2379(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_2379(t0,t1,t2,t3);}

C_noret_decl(trf_2402)
static void C_ccall trf_2402(C_word c,C_word *av) C_noret;
static void C_ccall trf_2402(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_2402(t0,t1,t2,t3);}

C_noret_decl(trf_2426)
static void C_ccall trf_2426(C_word c,C_word *av) C_noret;
static void C_ccall trf_2426(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_2426(t0,t1,t2);}

C_noret_decl(trf_2451)
static void C_ccall trf_2451(C_word c,C_word *av) C_noret;
static void C_ccall trf_2451(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_2451(t0,t1,t2,t3);}

C_noret_decl(trf_924)
static void C_ccall trf_924(C_word c,C_word *av) C_noret;
static void C_ccall trf_924(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_924(t0,t1,t2);}

C_noret_decl(trf_930)
static void C_ccall trf_930(C_word c,C_word *av) C_noret;
static void C_ccall trf_930(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_930(t0,t1,t2);}

/* loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_1003(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(21,0,3)))){
C_save_and_reclaim_args((void *)trf_1003,2,t0,t1);}
a=C_alloc(21);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1007,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_i_nullp(lf[5]))){
t3=t2;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_1007(2,av2);}}
else{
t3=C_a_i_current_process_milliseconds(&a,1,C_SCHEME_FALSE);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1079,a[2]=t3,a[3]=t5,a[4]=((C_word*)t0)[3],a[5]=((C_word)li8),tmp=(C_word)a,a+=6,tmp));
t7=((C_word*)t5)[1];
f_1079(t7,t2,lf[5]);}}

/* k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1007(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_1007,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1010,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)((C_word*)t0)[4])[1])){
t3=(
/* scheduler.scm:223: ##sys#update-thread-state-buffer */
  f_1247(((C_word*)t0)[5])
);
/* scheduler.scm:224: ##sys#force-primordial */
t4=*((C_word*)lf[19]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
if(C_truep(C_i_nullp(lf[6]))){
t3=C_SCHEME_UNDEFINED;
t4=t2;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
f_1010(2,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2025,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1879,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* scheduler.scm:405: ##sys#length */
t5=*((C_word*)lf[40]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=lf[6];
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}}}

/* k1008 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1010(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_1010,c,av);}
a=C_alloc(7);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1015,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word)li2),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_1015(t5,((C_word*)t0)[3]);}

/* loop2 in k1008 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_1015(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_1015,2,t0,t1);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1019,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t3=lf[17];
t4=C_i_nullp(lf[17]);
if(C_truep(C_i_not(t4))){
t5=C_u_i_cdr(lf[17]);
t6=C_mutate(&lf[17] /* (set! ready-queue-head ...) */,t5);
t7=C_eqp(C_SCHEME_END_OF_LIST,t5);
if(C_truep(t7)){
t8=lf[18] /* ready-queue-tail */ =C_SCHEME_END_OF_LIST;;
t9=t2;
f_1019(t9,C_u_i_car(t3));}
else{
t8=t2;
f_1019(t8,C_u_i_car(t3));}}
else{
t5=t2;
f_1019(t5,C_SCHEME_FALSE);}}

/* k1017 in loop2 in k1008 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_1019(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,2)))){
C_save_and_reclaim_args((void *)trf_1019,2,t0,t1);}
if(C_truep(C_i_not(t1))){
if(C_truep(C_i_nullp(lf[5]))){
if(C_truep(C_i_nullp(lf[6]))){
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_halt(lf[7]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* scheduler.scm:233: loop1 */
t2=((C_word*)((C_word*)t0)[3])[1];
f_1003(t2,((C_word*)t0)[2]);}}
else{
/* scheduler.scm:233: loop1 */
t2=((C_word*)((C_word*)t0)[3])[1];
f_1003(t2,((C_word*)t0)[2]);}}
else{
t2=C_slot(t1,C_fix(3));
t3=C_eqp(t2,lf[8]);
if(C_truep(t3)){
t4=C_mutate((C_word*)lf[3]+1 /* (set! ##sys#current-thread ...) */,t1);
t5=C_i_setslot(t1,C_fix(3),lf[9]);
t6=C_slot(t1,C_fix(5));
t7=C_slot(t6,C_fix(0));
t8=C_mutate((C_word*)lf[10]+1 /* (set! ##sys#dynamic-winds ...) */,t7);
t9=C_slot(t6,C_fix(1));
t10=C_mutate((C_word*)lf[11]+1 /* (set! ##sys#standard-input ...) */,t9);
t11=C_slot(t6,C_fix(2));
t12=C_mutate((C_word*)lf[12]+1 /* (set! ##sys#standard-output ...) */,t11);
t13=C_slot(t6,C_fix(3));
t14=C_mutate((C_word*)lf[13]+1 /* (set! ##sys#standard-error ...) */,t13);
t15=C_slot(t6,C_fix(4));
t16=C_mutate((C_word*)lf[14]+1 /* (set! ##sys#current-exception-handler ...) */,t15);
t17=C_slot(t6,C_fix(5));
t18=C_mutate((C_word*)lf[15]+1 /* (set! ##sys#current-parameter-vector ...) */,t17);
t19=C_slot(t1,C_fix(9));
t20=C_set_initial_timer_interrupt_period(t19);
/* scheduler.scm:175: ##sys#call-with-cthulhu */
t21=*((C_word*)lf[16]+1);{
C_word av2[3];
av2[0]=t21;
av2[1]=((C_word*)t0)[2];
av2[2]=C_slot(t1,C_fix(1));
((C_proc)(void*)(*((C_word*)t21+1)))(3,av2);}}
else{
/* scheduler.scm:235: loop2 */
t4=((C_word*)((C_word*)t0)[4])[1];
f_1015(t4,((C_word*)t0)[2]);}}}

/* loop in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_1079(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_1079,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_nullp(t2))){
t3=lf[5] /* timeout-list */ =C_SCHEME_END_OF_LIST;;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_u_i_caar(t2);
t4=C_u_i_car(t2);
t5=C_u_i_cdr(t4);
t6=C_slot(t5,C_fix(4));
if(C_truep(C_i_equalp(t3,t6))){
if(C_truep(C_i_greater_or_equalp(((C_word*)t0)[2],t3))){
t7=C_i_set_i_slot(t5,C_fix(13),C_SCHEME_TRUE);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1113,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,a[5]=t5,tmp=(C_word)a,a+=6,tmp);
/* scheduler.scm:200: ##sys#clear-i/o-state-for-thread! */
f_2292(t8,t5);}
else{
t7=C_mutate(&lf[5] /* (set! timeout-list ...) */,t2);
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1128,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_nullp(lf[17]))){
t9=C_i_nullp(lf[6]);
t10=t8;
f_1128(t10,(C_truep(t9)?C_i_pairp(lf[5]):C_SCHEME_FALSE));}
else{
t9=t8;
f_1128(t9,C_SCHEME_FALSE);}}}
else{
/* scheduler.scm:219: loop */
t11=t1;
t12=C_u_i_cdr(t2);
t1=t11;
t2=t12;
goto loop;}}}

/* k1111 in loop in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1113(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_1113,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1116,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:201: ##sys#thread-basic-unblock! */
t3=*((C_word*)lf[20]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k1114 in k1111 in loop in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1116(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_1116,c,av);}
/* scheduler.scm:202: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_1079(t2,((C_word*)t0)[3],C_u_i_cdr(((C_word*)t0)[4]));}

/* k1126 in loop in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_1128(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,2)))){
C_save_and_reclaim_args((void *)trf_1128,2,t0,t1);}
a=C_alloc(8);
if(C_truep(t1)){
t2=C_u_i_caar(lf[5]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1134,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1154,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* scheduler.scm:212: scheme#round */
t5=*((C_word*)lf[37]+1);{
C_word av2[3];
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}
else{
t2=((C_word*)t0)[3];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k1132 in k1126 in loop in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1134(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(33,c,3)))){
C_save_and_reclaim((void *)f_1134,c,av);}
a=C_alloc(33);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1146,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_s_a_i_minus(&a,2,t1,((C_word*)t0)[4]);
/* scheduler.scm:216: scheme#max */
t4=*((C_word*)lf[35]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t2;
av2[2]=C_fix(0);
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k1144 in k1132 in k1126 in loop in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1146(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1146,c,av);}
if(C_truep(C_i_not(C_msleep(t1)))){
t2=C_mk_bool(C_signal_interrupted_p);
t3=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t2=C_set_block_item(((C_word*)t0)[2],0,C_SCHEME_FALSE);
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k1152 in k1126 in loop in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1154(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_1154,c,av);}
/* scheduler.scm:212: scheme#inexact->exact */
t2=*((C_word*)lf[36]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* ##sys#force-primordial in k920 in k917 */
static void C_ccall f_1188(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_1188,c,av);}
t2=C_i_set_i_slot(*((C_word*)lf[43]+1),C_fix(13),C_SCHEME_FALSE);
/* scheduler.scm:240: ##sys#thread-unblock! */
t3=*((C_word*)lf[44]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t1;
av2[2]=*((C_word*)lf[43]+1);
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* ##sys#ready-queue in k920 in k917 */
static void C_ccall f_1199(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1199,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=lf[17];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#add-to-ready-queue in k920 in k917 */
static void C_ccall f_1202(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_1202,c,av);}
a=C_alloc(3);
t3=C_i_setslot(t2,C_fix(3),lf[8]);
t4=C_a_i_cons(&a,2,t2,C_SCHEME_END_OF_LIST);
t5=C_eqp(C_SCHEME_END_OF_LIST,lf[17]);
if(C_truep(t5)){
t6=C_mutate(&lf[17] /* (set! ready-queue-head ...) */,t4);
t7=C_mutate(&lf[18] /* (set! ready-queue-tail ...) */,t4);
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t6=C_i_setslot(lf[18],C_fix(1),t4);
t7=C_mutate(&lf[18] /* (set! ready-queue-tail ...) */,t4);
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}

/* ##sys#update-thread-state-buffer in k920 in k917 */
static C_word f_1247(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;{}
t2=C_slot(t1,C_fix(5));
t3=C_i_setslot(t2,C_fix(0),*((C_word*)lf[10]+1));
t4=C_i_setslot(t2,C_fix(1),*((C_word*)lf[11]+1));
t5=C_i_setslot(t2,C_fix(2),*((C_word*)lf[12]+1));
t6=C_i_setslot(t2,C_fix(3),*((C_word*)lf[13]+1));
t7=C_i_setslot(t2,C_fix(4),*((C_word*)lf[14]+1));
return(C_i_setslot(t2,C_fix(5),*((C_word*)lf[15]+1)));}

/* ##sys#interrupt-hook in k920 in k917 */
static void C_ccall f_1301(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_1301,c,av);}
a=C_alloc(12);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1305,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
t5=C_eqp(t2,C_fix(255));
if(C_truep(t5)){
t6=*((C_word*)lf[3]+1);
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1319,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=t3,a[5]=((C_word)li15),tmp=(C_word)a,a+=6,tmp);
t8=C_i_setslot(*((C_word*)lf[3]+1),C_fix(1),t7);
/* scheduler.scm:287: ##sys#schedule */
t9=*((C_word*)lf[2]+1);{
C_word *av2=av;
av2[0]=t9;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}
else{
/* scheduler.scm:288: oldhook */
t6=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t6;
av2[1]=t1;
av2[2]=t2;
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}}

/* k1303 in ##sys#interrupt-hook in k920 in k917 */
static void C_ccall f_1305(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1305,c,av);}
/* scheduler.scm:288: oldhook */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* a1318 in ##sys#interrupt-hook in k920 in k917 */
static void C_ccall f_1319(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1319,c,av);}
/* scheduler.scm:286: oldhook */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* ##sys#timeout-queue in k920 in k917 */
static void C_ccall f_1326(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1326,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=lf[5];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#remove-from-timeout-list in k920 in k917 */
static void C_ccall f_1329(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_1329,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1335,a[2]=t2,a[3]=((C_word)li18),tmp=(C_word)a,a+=4,tmp);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=(
  f_1335(t3,lf[5],C_SCHEME_FALSE)
);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* loop in ##sys#remove-from-timeout-list in k920 in k917 */
static C_word f_1335(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
loop:{}
if(C_truep(C_i_nullp(t1))){
return(t1);}
else{
t3=C_slot(t1,C_fix(0));
t4=C_slot(t1,C_fix(1));
t5=C_slot(t3,C_fix(1));
t6=C_eqp(t5,((C_word*)t0)[2]);
if(C_truep(t6)){
if(C_truep(t2)){
return(C_i_setslot(t2,C_fix(1),t4));}
else{
t7=C_mutate(&lf[5] /* (set! timeout-list ...) */,t4);
return(t7);}}
else{
t9=t4;
t10=t1;
t1=t9;
t2=t10;
goto loop;}}}

/* ##sys#thread-block-for-timeout! in k920 in k917 */
static void C_ccall f_1370(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,4)))){
C_save_and_reclaim((void *)f_1370,c,av);}
a=C_alloc(13);
if(C_truep(C_i_greaterp(t3,C_fix(0)))){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1380,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1391,a[2]=t3,a[3]=t2,a[4]=t6,a[5]=((C_word)li20),tmp=(C_word)a,a+=6,tmp));
t8=((C_word*)t6)[1];
f_1391(t8,t4,lf[5],C_SCHEME_FALSE);}
else{
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* k1378 in ##sys#thread-block-for-timeout! in k920 in k917 */
static void C_ccall f_1380(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1380,c,av);}
t2=C_i_setslot(((C_word*)t0)[2],C_fix(3),lf[49]);
t3=C_i_set_i_slot(((C_word*)t0)[2],C_fix(13),C_SCHEME_FALSE);
t4=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_i_setslot(((C_word*)t0)[2],C_fix(4),((C_word*)t0)[4]);
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* loop in ##sys#thread-block-for-timeout! in k920 in k917 */
static void f_1391(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(6,0,3)))){
C_save_and_reclaim_args((void *)trf_1391,4,t0,t1,t2,t3);}
a=C_alloc(6);
t4=C_i_nullp(t2);
t5=(C_truep(t4)?t4:C_i_lessp(((C_word*)t0)[2],C_u_i_caar(t2)));
if(C_truep(t5)){
if(C_truep(t3)){
t6=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t7=C_a_i_cons(&a,2,t6,t2);
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=C_i_setslot(t3,C_fix(1),t7);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t6=C_a_i_cons(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t7=C_a_i_cons(&a,2,t6,t2);
t8=C_mutate(&lf[5] /* (set! timeout-list ...) */,t7);
t9=t1;{
C_word av2[2];
av2[0]=t9;
av2[1]=t8;
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}}
else{
/* scheduler.scm:315: loop */
t10=t1;
t11=C_u_i_cdr(t2);
t12=t2;
t1=t10;
t2=t11;
t3=t12;
goto loop;}}

/* ##sys#thread-block-for-termination! in k920 in k917 */
static void C_ccall f_1439(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_1439,c,av);}
a=C_alloc(3);
t4=C_slot(t3,C_fix(3));
t5=C_eqp(t4,lf[51]);
t6=(C_truep(t5)?t5:C_eqp(t4,lf[52]));
if(C_truep(t6)){
t7=C_SCHEME_UNDEFINED;
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t7=C_slot(t3,C_fix(12));
t8=C_a_i_cons(&a,2,t2,t7);
t9=C_i_setslot(t3,C_fix(12),t8);
t10=C_i_setslot(t2,C_fix(3),lf[49]);
t11=C_i_set_i_slot(t2,C_fix(13),C_SCHEME_FALSE);
t12=t1;{
C_word *av2=av;
av2[0]=t12;
av2[1]=C_i_setslot(t2,C_fix(11),t3);
((C_proc)(void*)(*((C_word*)t12+1)))(2,av2);}}}

/* k1502 in for-each-loop294 in ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1504(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_1504,c,av);}
t2=C_i_set_i_slot(((C_word*)t0)[2],C_fix(3),C_SCHEME_END_OF_LIST);
t3=((C_word*)((C_word*)t0)[3])[1];
f_1546(t3,((C_word*)t0)[4],C_slot(((C_word*)t0)[5],C_fix(1)));}

/* for-each-loop308 in for-each-loop294 in ##sys#thread-kill! in k920 in k917 */
static void f_1520(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_1520,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1530,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:342: ##sys#thread-unblock! */
t4=*((C_word*)lf[44]+1);{
C_word av2[3];
av2[0]=t4;
av2[1]=t3;
av2[2]=C_slot(t2,C_fix(0));
((C_proc)(void*)(*((C_word*)t4+1)))(3,av2);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k1528 in for-each-loop308 in for-each-loop294 in ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1530(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_1530,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_1520(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* for-each-loop294 in ##sys#thread-kill! in k920 in k917 */
static void f_1546(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(12,0,3)))){
C_save_and_reclaim_args((void *)trf_1546,3,t0,t1,t2);}
a=C_alloc(12);
if(C_truep(C_i_pairp(t2))){
t3=C_slot(t2,C_fix(0));
t4=C_i_set_i_slot(t3,C_fix(2),C_SCHEME_FALSE);
t5=C_i_set_i_slot(t3,C_fix(4),C_SCHEME_TRUE);
t6=C_i_set_i_slot(t3,C_fix(5),C_SCHEME_FALSE);
t7=C_slot(t3,C_fix(3));
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1504,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=t1,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
if(C_truep(C_i_nullp(t7))){
t9=C_i_set_i_slot(t3,C_fix(3),C_SCHEME_END_OF_LIST);
t13=t1;
t14=C_slot(t2,C_fix(1));
t1=t13;
t2=t14;
goto loop;}
else{
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1520,a[2]=t10,a[3]=((C_word)li25),tmp=(C_word)a,a+=4,tmp));
t12=((C_word*)t10)[1];
f_1520(t12,t8,t7);}}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1569(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_1569,c,av);}
a=C_alloc(11);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1573,a[2]=t2,a[3]=t3,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t5=C_slot(t2,C_fix(8));
if(C_truep(C_i_nullp(t5))){
t6=C_SCHEME_UNDEFINED;
t7=t4;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
f_1573(2,av2);}}
else{
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1546,a[2]=t7,a[3]=((C_word)li26),tmp=(C_word)a,a+=4,tmp));
t9=((C_word*)t7)[1];
f_1546(t9,t4,t5);}}

/* k1571 in ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1573(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_1573,c,av);}
a=C_alloc(9);
t2=C_slot(((C_word*)t0)[2],C_fix(11));
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1579,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_i_structurep(t2,lf[54]))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1660,a[2]=t3,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:353: delq */
f_924(t4,((C_word*)t0)[2],C_slot(t2,C_fix(2)));}
else{
if(C_truep(C_i_structurep(t2,lf[55]))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1677,a[2]=t3,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:355: delq */
f_924(t4,((C_word*)t0)[2],C_slot(t2,C_fix(12)));}
else{
t4=C_SCHEME_UNDEFINED;
t5=t3;
f_1579(t5,t4);}}}

/* k1577 in k1571 in ##sys#thread-kill! in k920 in k917 */
static void f_1579(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_1579,2,t0,t1);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1582,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:356: ##sys#remove-from-timeout-list */
t3=*((C_word*)lf[21]+1);{
C_word av2[3];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k1580 in k1577 in k1571 in ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1582(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_1582,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1585,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:357: ##sys#clear-i/o-state-for-thread! */
f_2292(t2,((C_word*)t0)[2]);}

/* k1583 in k1580 in k1577 in k1571 in ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1585(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,3)))){
C_save_and_reclaim((void *)f_1585,c,av);}
a=C_alloc(15);
t2=C_i_setslot(((C_word*)t0)[2],C_fix(3),((C_word*)t0)[3]);
t3=C_i_set_i_slot(((C_word*)t0)[2],C_fix(4),C_SCHEME_FALSE);
t4=C_i_set_i_slot(((C_word*)t0)[2],C_fix(11),C_SCHEME_FALSE);
t5=C_i_set_i_slot(((C_word*)t0)[2],C_fix(8),C_SCHEME_END_OF_LIST);
t6=C_slot(((C_word*)t0)[2],C_fix(12));
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1603,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_i_nullp(t6))){
t8=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t8;
av2[1]=C_i_set_i_slot(((C_word*)t0)[2],C_fix(12),C_SCHEME_END_OF_LIST);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1610,a[2]=((C_word*)t0)[2],a[3]=((C_word)li23),tmp=(C_word)a,a+=4,tmp);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1629,a[2]=t10,a[3]=t8,a[4]=((C_word)li24),tmp=(C_word)a,a+=5,tmp));
t12=((C_word*)t10)[1];
f_1629(t12,t7,t6);}}

/* k1601 in k1583 in k1580 in k1577 in k1571 in ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1603(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1603,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_set_i_slot(((C_word*)t0)[3],C_fix(12),C_SCHEME_END_OF_LIST);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* g343 in k1583 in k1580 in k1577 in k1571 in ##sys#thread-kill! in k920 in k917 */
static void f_1610(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,0,2)))){
C_save_and_reclaim_args((void *)trf_1610,3,t0,t1,t2);}
t3=C_slot(t2,C_fix(11));
t4=C_eqp(t3,((C_word*)t0)[2]);
if(C_truep(t4)){
/* scheduler.scm:368: ##sys#thread-basic-unblock! */
t5=*((C_word*)lf[20]+1);{
C_word av2[3];
av2[0]=t5;
av2[1]=t1;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}
else{
t5=C_SCHEME_UNDEFINED;
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* for-each-loop342 in k1583 in k1580 in k1577 in k1571 in ##sys#thread-kill! in k920 in k917 */
static void f_1629(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_1629,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1639,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:364: g343 */
t4=((C_word*)t0)[3];
f_1610(t4,t3,C_slot(t2,C_fix(0)));}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k1637 in for-each-loop342 in k1583 in k1580 in k1577 in k1571 in ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1639(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_1639,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_1629(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k1658 in k1571 in ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1660(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1660,c,av);}
t2=((C_word*)t0)[2];
f_1579(t2,C_i_setslot(((C_word*)t0)[3],C_fix(2),t1));}

/* k1675 in k1571 in ##sys#thread-kill! in k920 in k917 */
static void C_ccall f_1677(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1677,c,av);}
t2=((C_word*)t0)[2];
f_1579(t2,C_i_setslot(((C_word*)t0)[3],C_fix(12),t1));}

/* ##sys#thread-basic-unblock! in k920 in k917 */
static void C_ccall f_1683(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_1683,c,av);}
t3=C_i_set_i_slot(t2,C_fix(11),C_SCHEME_FALSE);
t4=C_i_set_i_slot(t2,C_fix(4),C_SCHEME_FALSE);
/* scheduler.scm:376: ##sys#add-to-ready-queue */
t5=*((C_word*)lf[42]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t1;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* ##sys#default-exception-handler in k920 in k917 */
static void C_ccall f_1695(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_1695,c,av);}
a=C_alloc(10);
t3=*((C_word*)lf[3]+1);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1699,a[2]=t3,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_mk_bool(C_abort_on_thread_exceptions))){
t5=*((C_word*)lf[43]+1);
t6=C_slot(*((C_word*)lf[43]+1),C_fix(1));
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1719,a[2]=t6,a[3]=t2,a[4]=((C_word)li29),tmp=(C_word)a,a+=5,tmp);
t8=C_i_setslot(*((C_word*)lf[43]+1),C_fix(1),t7);
/* scheduler.scm:390: ##sys#thread-unblock! */
t9=*((C_word*)lf[44]+1);{
C_word *av2=av;
av2[0]=t9;
av2[1]=t4;
av2[2]=*((C_word*)lf[43]+1);
((C_proc)(void*)(*((C_word*)t9+1)))(3,av2);}}
else{
/* scheduler.scm:392: ##sys#show-exception-warning */
t5=*((C_word*)lf[58]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t5;
av2[1]=t4;
av2[2]=t2;
av2[3]=lf[59];
av2[4]=t3;
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}}

/* k1697 in ##sys#default-exception-handler in k920 in k917 */
static void C_ccall f_1699(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_1699,c,av);}
a=C_alloc(3);
t2=C_i_setslot(((C_word*)t0)[2],C_fix(7),((C_word*)t0)[3]);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1705,a[2]=((C_word*)t0)[4],tmp=(C_word)a,a+=3,tmp);
/* scheduler.scm:394: ##sys#thread-kill! */
t4=*((C_word*)lf[53]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=((C_word*)t0)[2];
av2[3]=lf[52];
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k1703 in k1697 in ##sys#default-exception-handler in k920 in k917 */
static void C_ccall f_1705(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1705,c,av);}
/* scheduler.scm:395: ##sys#schedule */
t2=*((C_word*)lf[2]+1);{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* a1718 in ##sys#default-exception-handler in k920 in k917 */
static void C_ccall f_1719(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_1719,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1723,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:388: chicken.condition#signal */
t3=*((C_word*)lf[57]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k1721 in a1718 in ##sys#default-exception-handler in k920 in k917 */
static void C_ccall f_1723(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1723,c,av);}
/* scheduler.scm:389: ptx */
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#fd-queue in k920 in k917 */
static void C_ccall f_1732(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1732,c,av);}
t2=t1;{
C_word *av2=av;
av2[0]=t2;
av2[1]=lf[6];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_1746(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(25,0,3)))){
C_save_and_reclaim_args((void *)trf_1746,3,t0,t1,t2);}
a=C_alloc(25);
if(C_truep(C_i_nullp(t2))){
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=C_u_i_caar(t2);
t4=C_SCHEME_FALSE;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_SCHEME_FALSE;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1757,a[2]=t5,a[3]=t7,a[4]=t3,a[5]=((C_word)li5),tmp=(C_word)a,a+=6,tmp);
t9=C_u_i_car(t2);
t10=C_u_i_cdr(t9);
t11=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_1842,a[2]=t5,a[3]=t7,a[4]=t3,a[5]=((C_word*)t0)[2],a[6]=t1,a[7]=t2,tmp=(C_word)a,a+=8,tmp);
t12=C_SCHEME_UNDEFINED;
t13=(*a=C_VECTOR_TYPE|1,a[1]=t12,tmp=(C_word)a,a+=2,tmp);
t14=C_set_block_item(t13,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1854,a[2]=t13,a[3]=t8,a[4]=((C_word)li6),tmp=(C_word)a,a+=5,tmp));
t15=((C_word*)t13)[1];
f_1854(t15,t11,t10);}}

/* g402 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_1757(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_1757,3,t0,t1,t2);}
a=C_alloc(5);
t3=C_slot(t2,C_fix(11));
if(C_truep(C_i_pairp(t3))){
t4=C_u_i_cdr(t3);
t5=C_eqp(t4,C_SCHEME_TRUE);
t6=(C_truep(t5)?t5:C_eqp(t4,lf[29]));
if(C_truep(t6)){
t7=C_set_block_item(((C_word*)t0)[2],0,C_SCHEME_TRUE);
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
t7=C_eqp(t4,C_SCHEME_FALSE);
t8=(C_truep(t7)?t7:C_eqp(t4,lf[30]));
if(C_truep(t8)){
t9=C_set_block_item(((C_word*)t0)[3],0,C_SCHEME_TRUE);
t10=t1;{
C_word av2[2];
av2[0]=t10;
av2[1]=t9;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
t9=C_eqp(t4,lf[31]);
if(C_truep(t9)){
t10=C_set_block_item(((C_word*)t0)[2],0,C_SCHEME_TRUE);
t11=C_set_block_item(((C_word*)t0)[3],0,C_SCHEME_TRUE);
t12=t1;{
C_word av2[2];
av2[0]=t12;
av2[1]=t11;
((C_proc)(void*)(*((C_word*)t12+1)))(2,av2);}}
else{
t10=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1800,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=t4,tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:428: scheme#open-output-string */
t11=*((C_word*)lf[28]+1);{
C_word av2[2];
av2[0]=t11;
av2[1]=t10;
((C_proc)(void*)(*((C_word*)t11+1)))(2,av2);}}}}}
else{
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* k1798 in g402 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1800(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_1800,c,av);}
a=C_alloc(6);
t2=C_i_check_port_2(t1,C_fix(2),C_SCHEME_TRUE,lf[22]);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1806,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* scheduler.scm:428: ##sys#print */
t4=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[39];
av2[3]=C_SCHEME_FALSE;
av2[4]=t1;
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}

/* k1804 in k1798 in g402 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1806(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_1806,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1809,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:428: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=C_SCHEME_TRUE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k1807 in k1804 in k1798 in g402 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1809(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_1809,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1812,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:428: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[38];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k1810 in k1807 in k1804 in k1798 in g402 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1812(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_1812,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1815,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:428: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=C_SCHEME_TRUE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k1813 in k1810 in k1807 in k1804 in k1798 in g402 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1815(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_1815,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1818,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:428: ##sys#write-char-0 */
t3=*((C_word*)lf[24]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_make_character(41);
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k1816 in k1813 in k1810 in k1807 in k1804 in k1798 in g402 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1818(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_1818,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1821,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* scheduler.scm:428: scheme#get-output-string */
t3=*((C_word*)lf[23]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k1819 in k1816 in k1813 in k1810 in k1807 in k1804 in k1798 in g402 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1821(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1821,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_halt(t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k1840 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1842(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_1842,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
t3=((C_word*)((C_word*)t0)[3])[1];
t4=stub450(C_SCHEME_UNDEFINED,((C_word*)t0)[4],t2,t3);
/* scheduler.scm:433: loop */
t5=((C_word*)((C_word*)t0)[5])[1];
f_1746(t5,((C_word*)t0)[6],C_u_i_cdr(((C_word*)t0)[7]));}

/* for-each-loop401 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_1854(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_1854,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1864,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:411: g402 */
t4=((C_word*)t0)[3];
f_1757(t4,t3,C_slot(t2,C_fix(0)));}
else{
t3=C_SCHEME_UNDEFINED;
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k1862 in for-each-loop401 in loop in k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1864(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_1864,c,av);}
t2=((C_word*)((C_word*)t0)[2])[1];
f_1854(t2,((C_word*)t0)[3],C_slot(((C_word*)t0)[4],C_fix(1)));}

/* k1877 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1879(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,3)))){
C_save_and_reclaim((void *)f_1879,c,av);}
a=C_alloc(6);
t2=stub391(C_SCHEME_UNDEFINED,t1);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1746,a[2]=t4,a[3]=((C_word)li7),tmp=(C_word)a,a+=4,tmp));
t6=((C_word*)t4)[1];
f_1746(t6,((C_word*)t0)[2],lf[6]);}

/* k1911 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1913(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_1913,c,av);}
a=C_alloc(7);
t2=C_i_check_port_2(t1,C_fix(2),C_SCHEME_TRUE,lf[22]);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1919,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
/* scheduler.scm:441: ##sys#print */
t4=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[34];
av2[3]=C_SCHEME_FALSE;
av2[4]=t1;
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}

/* k1917 in k1911 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1919(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_1919,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1922,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* scheduler.scm:441: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
av2[3]=C_SCHEME_TRUE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k1920 in k1917 in k1911 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1922(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_1922,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1925,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* scheduler.scm:441: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[33];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k1923 in k1920 in k1917 in k1911 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1925(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_1925,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1928,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:441: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=C_SCHEME_TRUE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k1926 in k1923 in k1920 in k1917 in k1911 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1928(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_1928,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1931,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:441: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[32];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k1929 in k1926 in k1923 in k1920 in k1917 in k1911 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1931(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_1931,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1934,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:441: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=C_SCHEME_TRUE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k1932 in k1929 in k1926 in k1923 in k1920 in k1917 in k1911 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1934(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_1934,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1937,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:441: ##sys#write-char-0 */
t3=*((C_word*)lf[24]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_make_character(41);
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k1935 in k1932 in k1929 in k1926 in k1923 in k1920 in k1917 in k1911 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1937(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_1937,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1940,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* scheduler.scm:441: scheme#get-output-string */
t3=*((C_word*)lf[23]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k1938 in k1935 in k1932 in k1929 in k1926 in k1923 in k1920 in k1917 in k1911 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_1940(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1940,c,av);}
t2=((C_word*)t0)[2];
f_2209(t2,C_halt(t1));}

/* ##sys#thread-block-for-i/o! in k920 in k917 */
static void C_ccall f_1958(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,3)))){
C_save_and_reclaim((void *)f_1958,c,av);}
a=C_alloc(14);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1962,a[2]=t2,a[3]=t3,a[4]=t4,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1977,a[2]=t3,a[3]=t2,a[4]=t7,a[5]=((C_word)li32),tmp=(C_word)a,a+=6,tmp));
t9=((C_word*)t7)[1];
f_1977(t9,t5,lf[6]);}

/* k1960 in ##sys#thread-block-for-i/o! in k920 in k917 */
static void C_ccall f_1962(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_1962,c,av);}
a=C_alloc(3);
t2=C_i_setslot(((C_word*)t0)[2],C_fix(3),lf[49]);
t3=C_i_set_i_slot(((C_word*)t0)[2],C_fix(13),C_SCHEME_FALSE);
t4=C_a_i_cons(&a,2,((C_word*)t0)[3],((C_word*)t0)[4]);
t5=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_i_setslot(((C_word*)t0)[2],C_fix(11),t4);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* loop in ##sys#thread-block-for-i/o! in k920 in k917 */
static void f_1977(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(9,0,2)))){
C_save_and_reclaim_args((void *)trf_1977,3,t0,t1,t2);}
a=C_alloc(9);
if(C_truep(C_i_nullp(t2))){
t3=C_a_i_list2(&a,2,((C_word*)t0)[2],((C_word*)t0)[3]);
t4=C_a_i_cons(&a,2,t3,lf[6]);
t5=C_mutate(&lf[6] /* (set! fd-list ...) */,t4);
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t3=C_u_i_car(t2);
t4=C_u_i_car(t3);
t5=C_eqp(((C_word*)t0)[2],t4);
if(C_truep(t5)){
t6=C_u_i_cdr(t3);
t7=C_a_i_cons(&a,2,((C_word*)t0)[3],t6);
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=C_i_setslot(t3,C_fix(1),t7);
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}
else{
/* scheduler.scm:454: loop */
t9=t1;
t10=C_u_i_cdr(t2);
t1=t9;
t2=t10;
goto loop;}}}

/* k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2025(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_2025,c,av);}
a=C_alloc(11);
t2=C_i_pairp(lf[5]);
t3=C_i_pairp(lf[17]);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2034,a[2]=t3,a[3]=t2,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
t5=(C_truep(t2)?C_i_not(t3):C_SCHEME_FALSE);
if(C_truep(t5)){
t6=C_u_i_caar(lf[5]);
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2276,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2287,a[2]=t7,tmp=(C_word)a,a+=3,tmp);
/* scheduler.scm:466: scheme#round */
t9=*((C_word*)lf[37]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t9;
av2[1]=t8;
av2[2]=t6;
((C_proc)(void*)(*((C_word*)t9+1)))(3,av2);}}
else{
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_fix(0);
f_2034(2,av2);}}}

/* k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2034(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,5)))){
C_save_and_reclaim((void *)f_2034,c,av);}
a=C_alloc(9);
t2=(C_truep(((C_word*)t0)[2])?stub518(C_SCHEME_UNDEFINED,((C_word*)t0)[2],t1):stub518(C_SCHEME_UNDEFINED,((C_word*)t0)[3],t1));
t3=C_eqp(C_fix(-1),t2);
if(C_truep(t3)){
/* scheduler.scm:476: ##sys#force-primordial */
t4=*((C_word*)lf[19]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
if(C_truep(C_fixnum_greaterp(t2,C_fix(0)))){
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2058,a[2]=((C_word*)t0)[4],tmp=(C_word)a,a+=3,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2060,a[2]=t6,a[3]=((C_word)li4),tmp=(C_word)a,a+=4,tmp));
t8=((C_word*)t6)[1];
f_2060(t8,t4,t2,C_fix(0),lf[6]);}
else{
t4=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
f_1010(2,av2);}}}}

/* k2056 in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2058(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2058,c,av);}
t2=C_mutate(&lf[6] /* (set! fd-list ...) */,t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
f_1010(2,av2);}}

/* loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_2060(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(33,0,4)))){
C_save_and_reclaim_args((void *)trf_2060,5,t0,t1,t2,t3,t4);}
a=C_alloc(33);
t5=C_i_zerop(t2);
t6=(C_truep(t5)?t5:C_i_nullp(t4));
if(C_truep(t6)){
t7=t1;{
C_word av2[2];
av2[0]=t7;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t7=C_u_i_car(t4);
t8=C_u_i_car(t7);
t9=C_fd_input_ready(t8,t3);
t10=C_fd_output_ready(t8,t3);
t11=(C_truep(t9)?t9:t10);
if(C_truep(t11)){
t12=C_u_i_cdr(t7);
t13=C_SCHEME_UNDEFINED;
t14=(*a=C_VECTOR_TYPE|1,a[1]=t13,tmp=(C_word)a,a+=2,tmp);
t15=C_set_block_item(t14,0,(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_2087,a[2]=t2,a[3]=t3,a[4]=((C_word*)t0)[2],a[5]=t4,a[6]=t8,a[7]=t14,a[8]=t9,a[9]=t10,a[10]=((C_word)li3),tmp=(C_word)a,a+=11,tmp));
t16=((C_word*)t14)[1];
f_2087(t16,t1,t12,C_SCHEME_END_OF_LIST);}
else{
t12=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2256,a[2]=t1,a[3]=t7,tmp=(C_word)a,a+=4,tmp);
t13=C_s_a_i_plus(&a,2,t3,C_fix(1));
/* scheduler.scm:517: loop */
t17=t12;
t18=t2;
t19=t13;
t20=C_u_i_cdr(t4);
t1=t17;
t2=t18;
t3=t19;
t4=t20;
goto loop;}}}

/* loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_2087(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(65,0,4)))){
C_save_and_reclaim_args((void *)trf_2087,4,t0,t1,t2,t3);}
a=C_alloc(65);
if(C_truep(C_i_nullp(t2))){
if(C_truep(C_i_nullp(t3))){
t4=C_s_a_i_minus(&a,2,((C_word*)t0)[2],C_fix(1));
t5=C_s_a_i_plus(&a,2,((C_word*)t0)[3],C_fix(1));
/* scheduler.scm:493: loop */
t6=((C_word*)((C_word*)t0)[4])[1];
f_2060(t6,t1,t4,t5,C_u_i_cdr(((C_word*)t0)[5]));}
else{
t4=C_a_i_cons(&a,2,((C_word*)t0)[6],t3);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2122,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
t6=C_s_a_i_minus(&a,2,((C_word*)t0)[2],C_fix(1));
t7=C_s_a_i_plus(&a,2,((C_word*)t0)[3],C_fix(1));
/* scheduler.scm:495: loop */
t8=((C_word*)((C_word*)t0)[4])[1];
f_2060(t8,t5,t6,t7,C_u_i_cdr(((C_word*)t0)[5]));}}
else{
t4=C_u_i_car(t2);
t5=C_slot(t4,C_fix(11));
if(C_truep(C_slot(t4,C_fix(13)))){
/* scheduler.scm:501: loop2 */
t18=t1;
t19=C_u_i_cdr(t2);
t20=t3;
t1=t18;
t2=t19;
t3=t20;
goto loop;}
else{
t6=C_i_pairp(t5);
if(C_truep(C_i_not(t6))){
t7=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2156,a[2]=((C_word*)t0)[7],a[3]=t1,a[4]=t2,a[5]=t3,a[6]=t4,tmp=(C_word)a,a+=7,tmp);
if(C_truep(C_slot(t4,C_fix(4)))){
/* scheduler.scm:506: ##sys#remove-from-timeout-list */
t8=*((C_word*)lf[21]+1);{
C_word av2[3];
av2[0]=t8;
av2[1]=t7;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t8+1)))(3,av2);}}
else{
t8=t7;{
C_word av2[2];
av2[0]=t8;
av2[1]=C_SCHEME_UNDEFINED;
f_2156(2,av2);}}}
else{
t7=C_u_i_car(t5);
t8=C_eqp(((C_word*)t0)[6],t7);
if(C_truep(C_i_not(t8))){
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2180,a[2]=t1,a[3]=((C_word*)t0)[6],a[4]=t5,tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:510: scheme#open-output-string */
t10=*((C_word*)lf[28]+1);{
C_word av2[2];
av2[0]=t10;
av2[1]=t9;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
t9=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2209,a[2]=((C_word*)t0)[7],a[3]=t1,a[4]=t2,a[5]=t3,a[6]=t4,tmp=(C_word)a,a+=7,tmp);
t10=C_u_i_cdr(t5);
t11=C_eqp(t10,C_SCHEME_TRUE);
t12=(C_truep(t11)?t11:C_eqp(t10,lf[29]));
if(C_truep(t12)){
t13=t9;
f_2209(t13,((C_word*)t0)[8]);}
else{
t13=C_eqp(t10,C_SCHEME_FALSE);
t14=(C_truep(t13)?t13:C_eqp(t10,lf[30]));
if(C_truep(t14)){
t15=t9;
f_2209(t15,((C_word*)t0)[9]);}
else{
t15=C_eqp(t10,lf[31]);
if(C_truep(t15)){
t16=t9;
f_2209(t16,(C_truep(((C_word*)t0)[8])?((C_word*)t0)[8]:((C_word*)t0)[9]));}
else{
t16=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1913,a[2]=t9,a[3]=((C_word*)t0)[9],a[4]=((C_word*)t0)[8],a[5]=t10,tmp=(C_word)a,a+=6,tmp);
/* scheduler.scm:441: scheme#open-output-string */
t17=*((C_word*)lf[28]+1);{
C_word av2[2];
av2[0]=t17;
av2[1]=t16;
((C_proc)(void*)(*((C_word*)t17+1)))(2,av2);}}}}}}}}}

/* k2120 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2122(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_2122,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k2154 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2156(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_2156,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2159,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* scheduler.scm:507: ##sys#thread-basic-unblock! */
t3=*((C_word*)lf[20]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k2157 in k2154 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2159(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2159,c,av);}
/* scheduler.scm:508: loop2 */
t2=((C_word*)((C_word*)t0)[2])[1];
f_2087(t2,((C_word*)t0)[3],C_u_i_cdr(((C_word*)t0)[4]),((C_word*)t0)[5]);}

/* k2178 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2180(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_2180,c,av);}
a=C_alloc(6);
t2=C_i_check_port_2(t1,C_fix(2),C_SCHEME_TRUE,lf[22]);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2186,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* scheduler.scm:510: ##sys#print */
t4=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t4;
av2[1]=t3;
av2[2]=lf[27];
av2[3]=C_SCHEME_FALSE;
av2[4]=t1;
((C_proc)(void*)(*((C_word*)t4+1)))(5,av2);}}

/* k2184 in k2178 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2186(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_2186,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2189,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:510: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_u_i_car(((C_word*)t0)[5]);
av2[3]=C_SCHEME_TRUE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k2187 in k2184 in k2178 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2189(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_2189,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2192,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:510: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[26];
av2[3]=C_SCHEME_FALSE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k2190 in k2187 in k2184 in k2178 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2192(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,4)))){
C_save_and_reclaim((void *)f_2192,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2195,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:510: ##sys#print */
t3=*((C_word*)lf[25]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=C_SCHEME_TRUE;
av2[4]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k2193 in k2190 in k2187 in k2184 in k2178 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2195(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_2195,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2198,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:510: ##sys#write-char-0 */
t3=*((C_word*)lf[24]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=C_make_character(41);
av2[3]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}

/* k2196 in k2193 in k2190 in k2187 in k2184 in k2178 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2198(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_2198,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2201,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* scheduler.scm:510: scheme#get-output-string */
t3=*((C_word*)lf[23]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k2199 in k2196 in k2193 in k2190 in k2187 in k2184 in k2178 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2201(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2201,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_halt(t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k2207 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void f_2209(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_2209,2,t0,t1);}
a=C_alloc(7);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2212,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(C_slot(((C_word*)t0)[6],C_fix(4)))){
/* scheduler.scm:513: ##sys#remove-from-timeout-list */
t3=*((C_word*)lf[21]+1);{
C_word av2[3];
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}
else{
t3=t2;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_2212(2,av2);}}}
else{
t2=C_u_i_cdr(((C_word*)t0)[4]);
t3=C_a_i_cons(&a,2,((C_word*)t0)[6],((C_word*)t0)[5]);
/* scheduler.scm:516: loop2 */
t4=((C_word*)((C_word*)t0)[2])[1];
f_2087(t4,((C_word*)t0)[3],t2,t3);}}

/* k2210 in k2207 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2212(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_2212,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2215,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* scheduler.scm:514: ##sys#thread-basic-unblock! */
t3=*((C_word*)lf[20]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[6];
((C_proc)(void*)(*((C_word*)t3+1)))(3,av2);}}

/* k2213 in k2210 in k2207 in loop2 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2215(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2215,c,av);}
/* scheduler.scm:515: loop2 */
t2=((C_word*)((C_word*)t0)[2])[1];
f_2087(t2,((C_word*)t0)[3],C_u_i_cdr(((C_word*)t0)[4]),((C_word*)t0)[5]);}

/* k2254 in loop in k2032 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2256(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_2256,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k2274 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2276(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(36,c,3)))){
C_save_and_reclaim((void *)f_2276,c,av);}
a=C_alloc(36);
t2=C_a_i_current_process_milliseconds(&a,1,C_SCHEME_FALSE);
t3=C_s_a_i_minus(&a,2,t1,t2);
/* scheduler.scm:468: scheme#max */
t4=*((C_word*)lf[35]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t4;
av2[1]=((C_word*)t0)[2];
av2[2]=C_fix(0);
av2[3]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(4,av2);}}

/* k2285 in k2023 in k1005 in loop1 in k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_2287(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_2287,c,av);}
/* scheduler.scm:466: scheme#inexact->exact */
t2=*((C_word*)lf[36]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* ##sys#clear-i/o-state-for-thread! in k920 in k917 */
static void f_2292(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,3)))){
C_save_and_reclaim_args((void *)trf_2292,2,t1,t2);}
a=C_alloc(11);
t3=C_slot(t2,C_fix(11));
if(C_truep(C_i_pairp(t3))){
t4=C_slot(t2,C_fix(11));
t5=C_u_i_car(t4);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2306,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2308,a[2]=t5,a[3]=t2,a[4]=t8,a[5]=((C_word)li34),tmp=(C_word)a,a+=6,tmp));
t10=((C_word*)t8)[1];
f_2308(t10,t6,lf[6]);}
else{
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* k2304 in ##sys#clear-i/o-state-for-thread! in k920 in k917 */
static void C_ccall f_2306(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2306,c,av);}
t2=C_mutate(&lf[6] /* (set! fd-list ...) */,t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* loop in ##sys#clear-i/o-state-for-thread! in k920 in k917 */
static void f_2308(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(5,0,3)))){
C_save_and_reclaim_args((void *)trf_2308,3,t0,t1,t2);}
a=C_alloc(5);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=C_SCHEME_END_OF_LIST;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_u_i_car(t2);
t4=C_u_i_car(t3);
t5=C_eqp(((C_word*)t0)[2],t4);
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2330,a[2]=t1,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:532: delq */
f_924(t6,((C_word*)t0)[3],C_u_i_cdr(t3));}
else{
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2349,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:537: loop */
t8=t6;
t9=C_u_i_cdr(t2);
t1=t8;
t2=t9;
goto loop;}}}

/* k2328 in loop in ##sys#clear-i/o-state-for-thread! in k920 in k917 */
static void C_ccall f_2330(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2330,c,av);}
if(C_truep(C_i_nullp(t1))){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_u_i_cdr(((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=C_i_setslot(((C_word*)t0)[4],C_fix(1),t1);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k2347 in loop in ##sys#clear-i/o-state-for-thread! in k920 in k917 */
static void C_ccall f_2349(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_2349,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#all-threads in k920 in k917 */
static void C_ccall f_2361(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,6)))){
C_save_and_reclaim((void *)f_2361,c,av);}
a=C_alloc(10);
t2=C_rest_nullp(c,2);
t3=(C_truep(t2)?(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2496,a[2]=((C_word)li36),tmp=(C_word)a,a+=3,tmp):C_get_rest_arg(c,2,av,2,t0));
t4=C_rest_nullp(c,2);
t5=C_rest_nullp(c,3);
t6=(C_truep(t5)?C_SCHEME_END_OF_LIST:C_get_rest_arg(c,3,av,2,t0));
t7=C_rest_nullp(c,3);
t8=C_SCHEME_UNDEFINED;
t9=(*a=C_VECTOR_TYPE|1,a[1]=t8,tmp=(C_word)a,a+=2,tmp);
t10=C_set_block_item(t9,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2379,a[2]=t9,a[3]=t3,a[4]=((C_word)li40),tmp=(C_word)a,a+=5,tmp));
t11=((C_word*)t9)[1];
f_2379(t11,t1,lf[17],t6);}

/* loop in ##sys#all-threads in k920 in k917 */
static void f_2379(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,5)))){
C_save_and_reclaim_args((void *)trf_2379,4,t0,t1,t2,t3);}
a=C_alloc(7);
if(C_truep(C_i_pairp(t2))){
t4=C_u_i_cdr(t2);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2395,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
/* scheduler.scm:550: cns */
t6=((C_word*)t0)[3];{
C_word av2[6];
av2[0]=t6;
av2[1]=t5;
av2[2]=lf[8];
av2[3]=C_SCHEME_FALSE;
av2[4]=C_u_i_car(t2);
av2[5]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(6,av2);}}
else{
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2402,a[2]=t5,a[3]=((C_word*)t0)[3],a[4]=((C_word)li39),tmp=(C_word)a,a+=5,tmp));
t7=((C_word*)t5)[1];
f_2402(t7,t1,lf[6],t3);}}

/* k2393 in loop in ##sys#all-threads in k920 in k917 */
static void C_ccall f_2395(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2395,c,av);}
/* scheduler.scm:550: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_2379(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* loop in loop in ##sys#all-threads in k920 in k917 */
static void f_2402(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,0,4)))){
C_save_and_reclaim_args((void *)trf_2402,4,t0,t1,t2,t3);}
a=C_alloc(14);
if(C_truep(C_i_pairp(t2))){
t4=C_u_i_cdr(t2);
t5=C_u_i_caar(t2);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2421,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
t7=C_u_i_car(t2);
t8=C_u_i_cdr(t7);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t10,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2426,a[2]=t3,a[3]=((C_word*)t0)[3],a[4]=t5,a[5]=t10,a[6]=((C_word)li37),tmp=(C_word)a,a+=7,tmp));
t12=((C_word*)t10)[1];
f_2426(t12,t6,t8);}
else{
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2451,a[2]=t5,a[3]=((C_word*)t0)[3],a[4]=((C_word)li38),tmp=(C_word)a,a+=5,tmp));
t7=((C_word*)t5)[1];
f_2451(t7,t1,lf[5],t3);}}

/* k2419 in loop in loop in ##sys#all-threads in k920 in k917 */
static void C_ccall f_2421(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2421,c,av);}
/* scheduler.scm:553: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_2402(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* loop in loop in loop in ##sys#all-threads in k920 in k917 */
static void f_2426(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(6,0,2)))){
C_save_and_reclaim_args((void *)trf_2426,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_u_i_car(t2);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2444,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=((C_word*)t0)[4],a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* scheduler.scm:557: loop */
t6=t4;
t7=C_u_i_cdr(t2);
t1=t6;
t2=t7;
goto loop;}}

/* k2442 in loop in loop in loop in ##sys#all-threads in k920 in k917 */
static void C_ccall f_2444(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2444,c,av);}
/* scheduler.scm:557: cns */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=lf[63];
av2[3]=((C_word*)t0)[4];
av2[4]=((C_word*)t0)[5];
av2[5]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* loop in loop in loop in ##sys#all-threads in k920 in k917 */
static void f_2451(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,5)))){
C_save_and_reclaim_args((void *)trf_2451,4,t0,t1,t2,t3);}
a=C_alloc(5);
if(C_truep(C_i_pairp(t2))){
t4=C_u_i_cdr(t2);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2467,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
t6=C_u_i_caar(t2);
t7=C_u_i_car(t2);
/* scheduler.scm:560: cns */
t8=((C_word*)t0)[3];{
C_word av2[6];
av2[0]=t8;
av2[1]=t5;
av2[2]=lf[64];
av2[3]=t6;
av2[4]=C_u_i_cdr(t7);
av2[5]=t3;
((C_proc)(void*)(*((C_word*)t8+1)))(6,av2);}}
else{
t4=t1;{
C_word av2[2];
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}}

/* k2465 in loop in loop in loop in ##sys#all-threads in k920 in k917 */
static void C_ccall f_2467(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2467,c,av);}
/* scheduler.scm:560: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_2451(t2,((C_word*)t0)[3],((C_word*)t0)[4],t1);}

/* f_2496 in ##sys#all-threads in k920 in k917 */
static void C_ccall f_2496(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_2496,c,av);}
a=C_alloc(3);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_a_i_cons(&a,2,t4,t5);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* ##sys#fetch-and-clear-threads in k920 in k917 */
static void C_ccall f_2505(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,1)))){
C_save_and_reclaim((void *)f_2505,c,av);}
a=C_alloc(5);
t2=C_a_i_vector4(&a,4,lf[17],lf[18],lf[6],lf[5]);
t3=lf[17] /* ready-queue-head */ =C_SCHEME_END_OF_LIST;;
t4=lf[18] /* ready-queue-tail */ =C_SCHEME_END_OF_LIST;;
t5=lf[6] /* fd-list */ =C_SCHEME_END_OF_LIST;;
t6=lf[5] /* timeout-list */ =C_SCHEME_END_OF_LIST;;
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* ##sys#restore-threads in k920 in k917 */
static void C_ccall f_2515(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2515,c,av);}
t3=C_slot(t2,C_fix(0));
t4=C_mutate(&lf[17] /* (set! ready-queue-head ...) */,t3);
t5=C_slot(t2,C_fix(1));
t6=C_mutate(&lf[18] /* (set! ready-queue-tail ...) */,t5);
t7=C_slot(t2,C_fix(2));
t8=C_mutate(&lf[6] /* (set! fd-list ...) */,t7);
t9=C_slot(t2,C_fix(3));
t10=C_mutate(&lf[5] /* (set! timeout-list ...) */,t9);
t11=t1;{
C_word *av2=av;
av2[0]=t11;
av2[1]=t10;
((C_proc)(void*)(*((C_word*)t11+1)))(2,av2);}}

/* ##sys#thread-unblock! in k920 in k917 */
static void C_ccall f_2534(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_2534,c,av);}
a=C_alloc(4);
t3=C_slot(t2,C_fix(3));
t4=C_eqp(lf[49],t3);
t5=(C_truep(t4)?t4:C_eqp(lf[67],C_slot(t2,C_fix(3))));
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2547,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:589: ##sys#remove-from-timeout-list */
t7=*((C_word*)lf[21]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
av2[2]=t2;
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}
else{
t6=C_SCHEME_UNDEFINED;
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}

/* k2545 in ##sys#thread-unblock! in k920 in k917 */
static void C_ccall f_2547(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_2547,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2550,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:590: ##sys#clear-i/o-state-for-thread! */
f_2292(t2,((C_word*)t0)[3]);}

/* k2548 in k2545 in ##sys#thread-unblock! in k920 in k917 */
static void C_ccall f_2550(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_2550,c,av);}
/* scheduler.scm:591: ##sys#thread-basic-unblock! */
t2=*((C_word*)lf[20]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* ##sys#thread-sleep! in k920 in k917 */
static void C_ccall f_2566(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_2566,c,av);}
a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2572,a[2]=t2,a[3]=((C_word)li46),tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:597: ##sys#call-with-current-continuation */{
C_word *av2=av;
av2[0]=0;
av2[1]=t1;
av2[2]=t3;
C_call_cc(3,av2);}}

/* a2571 in ##sys#thread-sleep! in k920 in k917 */
static void C_ccall f_2572(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_2572,c,av);}
a=C_alloc(7);
t3=*((C_word*)lf[3]+1);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2584,a[2]=t2,a[3]=((C_word)li45),tmp=(C_word)a,a+=4,tmp);
t5=C_i_setslot(*((C_word*)lf[3]+1),C_fix(1),t4);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2579,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* scheduler.scm:601: ##sys#thread-block-for-timeout! */
t7=*((C_word*)lf[48]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t7;
av2[1]=t6;
av2[2]=*((C_word*)lf[3]+1);
av2[3]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t7+1)))(4,av2);}}

/* k2577 in a2571 in ##sys#thread-sleep! in k920 in k917 */
static void C_ccall f_2579(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2579,c,av);}
/* scheduler.scm:602: ##sys#schedule */
t2=*((C_word*)lf[2]+1);{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* a2583 in a2571 in ##sys#thread-sleep! in k920 in k917 */
static void C_ccall f_2584(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,2)))){
C_save_and_reclaim((void *)f_2584,c,av);}
/* scheduler.scm:600: return */
t2=((C_word*)t0)[2];{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t2;
av2[1]=t1;
av2[2]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(3,av2);}}

/* chicken.base#sleep-hook in k920 in k917 */
static void C_ccall f_2590(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(69,c,2)))){
C_save_and_reclaim((void *)f_2590,c,av);}
a=C_alloc(69);
t3=C_s_a_i_times(&a,2,lf[70],t2);
t4=C_s_a_i_plus(&a,2,C_a_i_current_process_milliseconds(&a,1,C_SCHEME_FALSE),t3);
/* scheduler.scm:609: ##sys#thread-sleep! */
t5=*((C_word*)lf[68]+1);{
C_word *av2=av;
av2[0]=t5;
av2[1]=t1;
av2[2]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(3,av2);}}

/* ##sys#kill-other-threads in k920 in k917 */
static void C_ccall f_2604(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(31,c,2)))){
C_save_and_reclaim((void *)f_2604,c,av);}
a=C_alloc(31);
t3=*((C_word*)lf[3]+1);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2607,a[2]=t3,a[3]=((C_word)li49),tmp=(C_word)a,a+=4,tmp);
t5=C_mutate((C_word*)lf[43]+1 /* (set! ##sys#primordial-thread ...) */,*((C_word*)lf[3]+1));
t6=C_a_i_list1(&a,1,*((C_word*)lf[3]+1));
t7=C_mutate(&lf[17] /* (set! ready-queue-head ...) */,t6);
t8=C_mutate(&lf[18] /* (set! ready-queue-tail ...) */,lf[17]);
t9=(
/* scheduler.scm:629: suspend */
  f_2607(t4,*((C_word*)lf[3]+1))
);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2633,a[2]=t4,a[3]=((C_word)li50),tmp=(C_word)a,a+=4,tmp);
t11=lf[5];
t12=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2711,a[2]=t10,a[3]=((C_word)li51),tmp=(C_word)a,a+=4,tmp);
t13=(
  f_2711(t12,lf[5])
);
t14=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2654,a[2]=t4,a[3]=((C_word)li52),tmp=(C_word)a,a+=4,tmp);
t15=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2645,a[2]=t14,a[3]=((C_word)li53),tmp=(C_word)a,a+=4,tmp);
t16=lf[6];
t17=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2688,a[2]=t15,a[3]=((C_word)li54),tmp=(C_word)a,a+=4,tmp);
t18=(
  f_2688(t17,lf[6])
);
t19=lf[5] /* timeout-list */ =C_SCHEME_END_OF_LIST;;
t20=lf[6] /* fd-list */ =C_SCHEME_END_OF_LIST;;
t21=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2683,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:634: thunk */
t22=t2;{
C_word *av2=av;
av2[0]=t22;
av2[1]=t21;
((C_proc)(void*)(*((C_word*)t22+1)))(2,av2);}}

/* suspend in ##sys#kill-other-threads in k920 in k917 */
static C_word f_2607(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;{}
t2=C_eqp(t1,((C_word*)t0)[2]);
t3=(C_truep(t2)?C_SCHEME_UNDEFINED:C_i_setslot(t1,C_fix(3),lf[73]));
t4=C_i_set_i_slot(t1,C_fix(11),C_SCHEME_FALSE);
return(C_i_set_i_slot(t1,C_fix(12),C_SCHEME_END_OF_LIST));}

/* g655 in ##sys#kill-other-threads in k920 in k917 */
static C_word f_2633(C_word t0,C_word t1){
C_word tmp;
C_word t2;{}
return((
/* scheduler.scm:630: suspend */
  f_2607(((C_word*)t0)[2],C_u_i_cdr(t1))
));}

/* g665 in ##sys#kill-other-threads in k920 in k917 */
static C_word f_2645(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;{}
t2=C_u_i_cdr(t1);
return((
  f_2654(((C_word*)t0)[2],t2)
));}

/* for-each-loop687 in ##sys#kill-other-threads in k920 in k917 */
static C_word f_2654(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=(
/* scheduler.scm:631: g688 */
  f_2607(((C_word*)t0)[2],C_slot(t1,C_fix(0)))
);
t4=C_slot(t1,C_fix(1));
t1=t4;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* k2681 in ##sys#kill-other-threads in k920 in k917 */
static void C_ccall f_2683(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2683,c,av);}
/* scheduler.scm:635: exit */
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* for-each-loop664 in ##sys#kill-other-threads in k920 in k917 */
static C_word f_2688(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=(
/* scheduler.scm:631: g665 */
  f_2645(((C_word*)t0)[2],C_slot(t1,C_fix(0)))
);
t4=C_slot(t1,C_fix(1));
t1=t4;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* for-each-loop654 in ##sys#kill-other-threads in k920 in k917 */
static C_word f_2711(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
loop:{}
if(C_truep(C_i_pairp(t1))){
t2=(
/* scheduler.scm:630: g655 */
  f_2633(((C_word*)t0)[2],C_slot(t1,C_fix(0)))
);
t4=C_slot(t1,C_fix(1));
t1=t4;
goto loop;}
else{
t2=C_SCHEME_UNDEFINED;
return(t2);}}

/* k917 */
static void C_ccall f_919(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_919,c,av);}
a=C_alloc(11);
t2=C_a_i_provide(&a,1,lf[0]);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_922,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);{
C_word *av2=av;
av2[0]=C_SCHEME_UNDEFINED;
av2[1]=t3;
C_library_toplevel(2,av2);}}

/* k920 in k917 */
static void C_ccall f_922(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(74,c,5)))){
C_save_and_reclaim((void *)f_922,c,av);}
a=C_alloc(74);
t2=C_mutate(&lf[1] /* (set! delq ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_924,a[2]=((C_word)li1),tmp=(C_word)a,a+=3,tmp));
t3=C_mutate((C_word*)lf[2]+1 /* (set! ##sys#schedule ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_967,a[2]=((C_word)li10),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[19]+1 /* (set! ##sys#force-primordial ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1188,a[2]=((C_word)li11),tmp=(C_word)a,a+=3,tmp));
t5=lf[17] /* ready-queue-head */ =C_SCHEME_END_OF_LIST;;
t6=lf[18] /* ready-queue-tail */ =C_SCHEME_END_OF_LIST;;
t7=C_mutate((C_word*)lf[45]+1 /* (set! ##sys#ready-queue ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1199,a[2]=((C_word)li12),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate((C_word*)lf[42]+1 /* (set! ##sys#add-to-ready-queue ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1202,a[2]=((C_word)li13),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate(&lf[4] /* (set! ##sys#update-thread-state-buffer ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1247,a[2]=((C_word)li14),tmp=(C_word)a,a+=3,tmp));
t10=*((C_word*)lf[46]+1);
t11=C_mutate((C_word*)lf[46]+1 /* (set! ##sys#interrupt-hook ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1301,a[2]=t10,a[3]=((C_word)li16),tmp=(C_word)a,a+=4,tmp));
t12=lf[5] /* timeout-list */ =C_SCHEME_END_OF_LIST;;
t13=C_mutate((C_word*)lf[47]+1 /* (set! ##sys#timeout-queue ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1326,a[2]=((C_word)li17),tmp=(C_word)a,a+=3,tmp));
t14=C_mutate((C_word*)lf[21]+1 /* (set! ##sys#remove-from-timeout-list ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1329,a[2]=((C_word)li19),tmp=(C_word)a,a+=3,tmp));
t15=C_mutate((C_word*)lf[48]+1 /* (set! ##sys#thread-block-for-timeout! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1370,a[2]=((C_word)li21),tmp=(C_word)a,a+=3,tmp));
t16=C_mutate((C_word*)lf[50]+1 /* (set! ##sys#thread-block-for-termination! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1439,a[2]=((C_word)li22),tmp=(C_word)a,a+=3,tmp));
t17=C_mutate((C_word*)lf[53]+1 /* (set! ##sys#thread-kill! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1569,a[2]=((C_word)li27),tmp=(C_word)a,a+=3,tmp));
t18=C_mutate((C_word*)lf[20]+1 /* (set! ##sys#thread-basic-unblock! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1683,a[2]=((C_word)li28),tmp=(C_word)a,a+=3,tmp));
t19=C_mutate((C_word*)lf[56]+1 /* (set! ##sys#default-exception-handler ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1695,a[2]=((C_word)li30),tmp=(C_word)a,a+=3,tmp));
t20=lf[6] /* fd-list */ =C_SCHEME_END_OF_LIST;;
t21=C_mutate((C_word*)lf[60]+1 /* (set! ##sys#fd-queue ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1732,a[2]=((C_word)li31),tmp=(C_word)a,a+=3,tmp));
t22=C_mutate((C_word*)lf[61]+1 /* (set! ##sys#thread-block-for-i/o! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1958,a[2]=((C_word)li33),tmp=(C_word)a,a+=3,tmp));
t23=C_mutate(&lf[41] /* (set! ##sys#clear-i/o-state-for-thread! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2292,a[2]=((C_word)li35),tmp=(C_word)a,a+=3,tmp));
t24=C_mutate((C_word*)lf[62]+1 /* (set! ##sys#all-threads ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2361,a[2]=((C_word)li41),tmp=(C_word)a,a+=3,tmp));
t25=C_mutate((C_word*)lf[65]+1 /* (set! ##sys#fetch-and-clear-threads ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2505,a[2]=((C_word)li42),tmp=(C_word)a,a+=3,tmp));
t26=C_mutate((C_word*)lf[66]+1 /* (set! ##sys#restore-threads ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2515,a[2]=((C_word)li43),tmp=(C_word)a,a+=3,tmp));
t27=C_mutate((C_word*)lf[44]+1 /* (set! ##sys#thread-unblock! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2534,a[2]=((C_word)li44),tmp=(C_word)a,a+=3,tmp));
t28=C_mutate((C_word*)lf[68]+1 /* (set! ##sys#thread-sleep! ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2566,a[2]=((C_word)li47),tmp=(C_word)a,a+=3,tmp));
t29=C_mutate((C_word*)lf[69]+1 /* (set! chicken.base#sleep-hook ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2590,a[2]=((C_word)li48),tmp=(C_word)a,a+=3,tmp));
t30=*((C_word*)lf[71]+1);
t31=C_mutate((C_word*)lf[72]+1 /* (set! ##sys#kill-other-threads ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2604,a[2]=t30,a[3]=((C_word)li55),tmp=(C_word)a,a+=4,tmp));
t32=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t32;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t32+1)))(2,av2);}}

/* delq in k920 in k917 */
static void f_924(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_924,3,t1,t2,t3);}
a=C_alloc(7);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_930,a[2]=t2,a[3]=t5,a[4]=((C_word)li0),tmp=(C_word)a,a+=5,tmp));
t7=((C_word*)t5)[1];
f_930(t7,t1,t3);}

/* loop in delq in k920 in k917 */
static void f_930(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_930,3,t0,t1,t2);}
a=C_alloc(4);
if(C_truep(C_i_nullp(t2))){
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_slot(t2,C_fix(0));
t4=C_eqp(((C_word*)t0)[2],t3);
if(C_truep(t4)){
t5=t1;{
C_word av2[2];
av2[0]=t5;
av2[1]=C_slot(t2,C_fix(1));
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t5=C_slot(t2,C_fix(0));
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_957,a[2]=t1,a[3]=t5,tmp=(C_word)a,a+=4,tmp);
/* scheduler.scm:162: loop */
t8=t6;
t9=C_slot(t2,C_fix(1));
t1=t8;
t2=t9;
goto loop;}}}

/* k955 in loop in delq in k920 in k917 */
static void C_ccall f_957(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_957,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_cons(&a,2,((C_word*)t0)[3],t1);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* ##sys#schedule in k920 in k917 */
static void C_ccall f_967(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_967,c,av);}
a=C_alloc(7);
t2=*((C_word*)lf[3]+1);
t3=C_SCHEME_FALSE;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_slot(*((C_word*)lf[3]+1),C_fix(3));
t6=(
/* scheduler.scm:180: ##sys#update-thread-state-buffer */
  f_1247(*((C_word*)lf[3]+1))
);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_998,a[2]=t4,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t8=C_eqp(t5,lf[9]);
t9=(C_truep(t8)?t8:C_eqp(t5,lf[8]));
if(C_truep(t9)){
t10=C_i_set_i_slot(*((C_word*)lf[3]+1),C_fix(13),C_SCHEME_FALSE);
/* scheduler.scm:184: ##sys#add-to-ready-queue */
t11=*((C_word*)lf[42]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t11;
av2[1]=t7;
av2[2]=*((C_word*)lf[3]+1);
((C_proc)(void*)(*((C_word*)t11+1)))(3,av2);}}
else{
t10=t7;{
C_word *av2=av;
av2[0]=t10;
av2[1]=C_SCHEME_UNDEFINED;
f_998(2,av2);}}}

/* k996 in ##sys#schedule in k920 in k917 */
static void C_ccall f_998(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_998,c,av);}
a=C_alloc(8);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1003,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word)li9),tmp=(C_word)a,a+=6,tmp));
t5=((C_word*)t3)[1];
f_1003(t5,((C_word*)t0)[4]);}

/* toplevel */
static int toplevel_initialized=0;

void C_ccall C_scheduler_toplevel(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(toplevel_initialized) {C_kontinue(t1,C_SCHEME_UNDEFINED);}
else C_toplevel_entry(C_text("scheduler"));
C_check_nursery_minimum(C_calculate_demand(3,c,2));
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void*)C_scheduler_toplevel,c,av);}
toplevel_initialized=1;
if(C_unlikely(!C_demand_2(403))){
C_save(t1);
C_rereclaim2(403*sizeof(C_word),1);
t1=C_restore;}
a=C_alloc(3);
C_initialize_lf(lf,74);
lf[0]=C_h_intern(&lf[0],9, C_text("scheduler"));
lf[2]=C_h_intern(&lf[2],14, C_text("##sys#schedule"));
lf[3]=C_h_intern(&lf[3],20, C_text("##sys#current-thread"));
lf[7]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\011\144\145\141\144\154\157\143\153\000"));
lf[8]=C_h_intern(&lf[8],5, C_text("ready"));
lf[9]=C_h_intern(&lf[9],7, C_text("running"));
lf[10]=C_h_intern(&lf[10],19, C_text("##sys#dynamic-winds"));
lf[11]=C_h_intern(&lf[11],20, C_text("##sys#standard-input"));
lf[12]=C_h_intern(&lf[12],21, C_text("##sys#standard-output"));
lf[13]=C_h_intern(&lf[13],20, C_text("##sys#standard-error"));
lf[14]=C_h_intern(&lf[14],31, C_text("##sys#current-exception-handler"));
lf[15]=C_h_intern(&lf[15],30, C_text("##sys#current-parameter-vector"));
lf[16]=C_h_intern(&lf[16],23, C_text("##sys#call-with-cthulhu"));
lf[19]=C_h_intern(&lf[19],22, C_text("##sys#force-primordial"));
lf[20]=C_h_intern(&lf[20],27, C_text("##sys#thread-basic-unblock!"));
lf[21]=C_h_intern(&lf[21],30, C_text("##sys#remove-from-timeout-list"));
lf[22]=C_h_intern(&lf[22],6, C_text("format"));
lf[23]=C_h_intern(&lf[23],24, C_text("scheme#get-output-string"));
lf[24]=C_h_intern(&lf[24],18, C_text("##sys#write-char-0"));
lf[25]=C_h_intern(&lf[25],11, C_text("##sys#print"));
lf[26]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\014\040\050\145\170\160\145\143\164\145\144\040\000"));
lf[27]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\072\164\150\162\145\141\144\040\151\163\040\162\145\147\151\163\164\145\162\145\144\040\146\157\162\040\111\057\117\040\157\156\040\165\156\153\156\157\167\156\040\146\151\154\145\055\144\145\163\143\162\151\160\164\157\162\072\040\000"));
lf[28]=C_h_intern(&lf[28],25, C_text("scheme#open-output-string"));
lf[29]=C_h_intern_kw(&lf[29],5, C_text("input"));
lf[30]=C_h_intern_kw(&lf[30],6, C_text("output"));
lf[31]=C_h_intern_kw(&lf[31],3, C_text("all"));
lf[32]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\007\054\040\157\040\075\040\000"));
lf[33]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\007\040\050\151\040\075\040\000"));
lf[34]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\044\146\144\163\145\164\055\164\145\163\164\072\040\151\156\166\141\154\151\144\040\151\057\157\040\144\151\162\145\143\164\151\157\156\072\040\000"));
lf[35]=C_h_intern(&lf[35],10, C_text("scheme#max"));
lf[36]=C_h_intern(&lf[36],21, C_text("scheme#inexact->exact"));
lf[37]=C_h_intern(&lf[37],12, C_text("scheme#round"));
lf[38]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\010\040\050\146\144\040\075\040\000"));
lf[39]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\046\143\162\145\141\164\145\055\146\144\163\145\164\072\040\151\156\166\141\154\151\144\040\151\057\157\040\144\151\162\145\143\164\151\157\156\072\040\000"));
lf[40]=C_h_intern(&lf[40],12, C_text("##sys#length"));
lf[42]=C_h_intern(&lf[42],24, C_text("##sys#add-to-ready-queue"));
lf[43]=C_h_intern(&lf[43],23, C_text("##sys#primordial-thread"));
lf[44]=C_h_intern(&lf[44],21, C_text("##sys#thread-unblock!"));
lf[45]=C_h_intern(&lf[45],17, C_text("##sys#ready-queue"));
lf[46]=C_h_intern(&lf[46],20, C_text("##sys#interrupt-hook"));
lf[47]=C_h_intern(&lf[47],19, C_text("##sys#timeout-queue"));
lf[48]=C_h_intern(&lf[48],31, C_text("##sys#thread-block-for-timeout!"));
lf[49]=C_h_intern(&lf[49],7, C_text("blocked"));
lf[50]=C_h_intern(&lf[50],35, C_text("##sys#thread-block-for-termination!"));
lf[51]=C_h_intern(&lf[51],4, C_text("dead"));
lf[52]=C_h_intern(&lf[52],10, C_text("terminated"));
lf[53]=C_h_intern(&lf[53],18, C_text("##sys#thread-kill!"));
lf[54]=C_h_intern(&lf[54],18, C_text("condition-variable"));
lf[55]=C_h_intern(&lf[55],6, C_text("thread"));
lf[56]=C_h_intern(&lf[56],31, C_text("##sys#default-exception-handler"));
lf[57]=C_h_intern(&lf[57],24, C_text("chicken.condition#signal"));
lf[58]=C_h_intern(&lf[58],28, C_text("##sys#show-exception-warning"));
lf[59]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\012\151\156\040\164\150\162\145\141\144\000"));
lf[60]=C_h_intern(&lf[60],14, C_text("##sys#fd-queue"));
lf[61]=C_h_intern(&lf[61],27, C_text("##sys#thread-block-for-i/o!"));
lf[62]=C_h_intern(&lf[62],17, C_text("##sys#all-threads"));
lf[63]=C_h_intern(&lf[63],3, C_text("i/o"));
lf[64]=C_h_intern(&lf[64],7, C_text("timeout"));
lf[65]=C_h_intern(&lf[65],29, C_text("##sys#fetch-and-clear-threads"));
lf[66]=C_h_intern(&lf[66],21, C_text("##sys#restore-threads"));
lf[67]=C_h_intern(&lf[67],8, C_text("sleeping"));
lf[68]=C_h_intern(&lf[68],19, C_text("##sys#thread-sleep!"));
lf[69]=C_h_intern(&lf[69],23, C_text("chicken.base#sleep-hook"));
lf[70]=C_decode_literal(C_heaptop,C_text("\376\1251000.0\000"));
lf[71]=C_h_intern(&lf[71],17, C_text("chicken.base#exit"));
lf[72]=C_h_intern(&lf[72],24, C_text("##sys#kill-other-threads"));
lf[73]=C_h_intern(&lf[73],9, C_text("suspended"));
C_register_lf2(lf,74,create_ptable());{}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_919,a[2]=t1,tmp=(C_word)a,a+=3,tmp);{
C_word *av2=av;
av2[0]=C_SCHEME_UNDEFINED;
av2[1]=t2;
C_extras_toplevel(2,av2);}}

#ifdef C_ENABLE_PTABLES
static C_PTABLE_ENTRY ptable[136] = {
{C_text("f_1003:scheduler_2escm"),(void*)f_1003},
{C_text("f_1007:scheduler_2escm"),(void*)f_1007},
{C_text("f_1010:scheduler_2escm"),(void*)f_1010},
{C_text("f_1015:scheduler_2escm"),(void*)f_1015},
{C_text("f_1019:scheduler_2escm"),(void*)f_1019},
{C_text("f_1079:scheduler_2escm"),(void*)f_1079},
{C_text("f_1113:scheduler_2escm"),(void*)f_1113},
{C_text("f_1116:scheduler_2escm"),(void*)f_1116},
{C_text("f_1128:scheduler_2escm"),(void*)f_1128},
{C_text("f_1134:scheduler_2escm"),(void*)f_1134},
{C_text("f_1146:scheduler_2escm"),(void*)f_1146},
{C_text("f_1154:scheduler_2escm"),(void*)f_1154},
{C_text("f_1188:scheduler_2escm"),(void*)f_1188},
{C_text("f_1199:scheduler_2escm"),(void*)f_1199},
{C_text("f_1202:scheduler_2escm"),(void*)f_1202},
{C_text("f_1247:scheduler_2escm"),(void*)f_1247},
{C_text("f_1301:scheduler_2escm"),(void*)f_1301},
{C_text("f_1305:scheduler_2escm"),(void*)f_1305},
{C_text("f_1319:scheduler_2escm"),(void*)f_1319},
{C_text("f_1326:scheduler_2escm"),(void*)f_1326},
{C_text("f_1329:scheduler_2escm"),(void*)f_1329},
{C_text("f_1335:scheduler_2escm"),(void*)f_1335},
{C_text("f_1370:scheduler_2escm"),(void*)f_1370},
{C_text("f_1380:scheduler_2escm"),(void*)f_1380},
{C_text("f_1391:scheduler_2escm"),(void*)f_1391},
{C_text("f_1439:scheduler_2escm"),(void*)f_1439},
{C_text("f_1504:scheduler_2escm"),(void*)f_1504},
{C_text("f_1520:scheduler_2escm"),(void*)f_1520},
{C_text("f_1530:scheduler_2escm"),(void*)f_1530},
{C_text("f_1546:scheduler_2escm"),(void*)f_1546},
{C_text("f_1569:scheduler_2escm"),(void*)f_1569},
{C_text("f_1573:scheduler_2escm"),(void*)f_1573},
{C_text("f_1579:scheduler_2escm"),(void*)f_1579},
{C_text("f_1582:scheduler_2escm"),(void*)f_1582},
{C_text("f_1585:scheduler_2escm"),(void*)f_1585},
{C_text("f_1603:scheduler_2escm"),(void*)f_1603},
{C_text("f_1610:scheduler_2escm"),(void*)f_1610},
{C_text("f_1629:scheduler_2escm"),(void*)f_1629},
{C_text("f_1639:scheduler_2escm"),(void*)f_1639},
{C_text("f_1660:scheduler_2escm"),(void*)f_1660},
{C_text("f_1677:scheduler_2escm"),(void*)f_1677},
{C_text("f_1683:scheduler_2escm"),(void*)f_1683},
{C_text("f_1695:scheduler_2escm"),(void*)f_1695},
{C_text("f_1699:scheduler_2escm"),(void*)f_1699},
{C_text("f_1705:scheduler_2escm"),(void*)f_1705},
{C_text("f_1719:scheduler_2escm"),(void*)f_1719},
{C_text("f_1723:scheduler_2escm"),(void*)f_1723},
{C_text("f_1732:scheduler_2escm"),(void*)f_1732},
{C_text("f_1746:scheduler_2escm"),(void*)f_1746},
{C_text("f_1757:scheduler_2escm"),(void*)f_1757},
{C_text("f_1800:scheduler_2escm"),(void*)f_1800},
{C_text("f_1806:scheduler_2escm"),(void*)f_1806},
{C_text("f_1809:scheduler_2escm"),(void*)f_1809},
{C_text("f_1812:scheduler_2escm"),(void*)f_1812},
{C_text("f_1815:scheduler_2escm"),(void*)f_1815},
{C_text("f_1818:scheduler_2escm"),(void*)f_1818},
{C_text("f_1821:scheduler_2escm"),(void*)f_1821},
{C_text("f_1842:scheduler_2escm"),(void*)f_1842},
{C_text("f_1854:scheduler_2escm"),(void*)f_1854},
{C_text("f_1864:scheduler_2escm"),(void*)f_1864},
{C_text("f_1879:scheduler_2escm"),(void*)f_1879},
{C_text("f_1913:scheduler_2escm"),(void*)f_1913},
{C_text("f_1919:scheduler_2escm"),(void*)f_1919},
{C_text("f_1922:scheduler_2escm"),(void*)f_1922},
{C_text("f_1925:scheduler_2escm"),(void*)f_1925},
{C_text("f_1928:scheduler_2escm"),(void*)f_1928},
{C_text("f_1931:scheduler_2escm"),(void*)f_1931},
{C_text("f_1934:scheduler_2escm"),(void*)f_1934},
{C_text("f_1937:scheduler_2escm"),(void*)f_1937},
{C_text("f_1940:scheduler_2escm"),(void*)f_1940},
{C_text("f_1958:scheduler_2escm"),(void*)f_1958},
{C_text("f_1962:scheduler_2escm"),(void*)f_1962},
{C_text("f_1977:scheduler_2escm"),(void*)f_1977},
{C_text("f_2025:scheduler_2escm"),(void*)f_2025},
{C_text("f_2034:scheduler_2escm"),(void*)f_2034},
{C_text("f_2058:scheduler_2escm"),(void*)f_2058},
{C_text("f_2060:scheduler_2escm"),(void*)f_2060},
{C_text("f_2087:scheduler_2escm"),(void*)f_2087},
{C_text("f_2122:scheduler_2escm"),(void*)f_2122},
{C_text("f_2156:scheduler_2escm"),(void*)f_2156},
{C_text("f_2159:scheduler_2escm"),(void*)f_2159},
{C_text("f_2180:scheduler_2escm"),(void*)f_2180},
{C_text("f_2186:scheduler_2escm"),(void*)f_2186},
{C_text("f_2189:scheduler_2escm"),(void*)f_2189},
{C_text("f_2192:scheduler_2escm"),(void*)f_2192},
{C_text("f_2195:scheduler_2escm"),(void*)f_2195},
{C_text("f_2198:scheduler_2escm"),(void*)f_2198},
{C_text("f_2201:scheduler_2escm"),(void*)f_2201},
{C_text("f_2209:scheduler_2escm"),(void*)f_2209},
{C_text("f_2212:scheduler_2escm"),(void*)f_2212},
{C_text("f_2215:scheduler_2escm"),(void*)f_2215},
{C_text("f_2256:scheduler_2escm"),(void*)f_2256},
{C_text("f_2276:scheduler_2escm"),(void*)f_2276},
{C_text("f_2287:scheduler_2escm"),(void*)f_2287},
{C_text("f_2292:scheduler_2escm"),(void*)f_2292},
{C_text("f_2306:scheduler_2escm"),(void*)f_2306},
{C_text("f_2308:scheduler_2escm"),(void*)f_2308},
{C_text("f_2330:scheduler_2escm"),(void*)f_2330},
{C_text("f_2349:scheduler_2escm"),(void*)f_2349},
{C_text("f_2361:scheduler_2escm"),(void*)f_2361},
{C_text("f_2379:scheduler_2escm"),(void*)f_2379},
{C_text("f_2395:scheduler_2escm"),(void*)f_2395},
{C_text("f_2402:scheduler_2escm"),(void*)f_2402},
{C_text("f_2421:scheduler_2escm"),(void*)f_2421},
{C_text("f_2426:scheduler_2escm"),(void*)f_2426},
{C_text("f_2444:scheduler_2escm"),(void*)f_2444},
{C_text("f_2451:scheduler_2escm"),(void*)f_2451},
{C_text("f_2467:scheduler_2escm"),(void*)f_2467},
{C_text("f_2496:scheduler_2escm"),(void*)f_2496},
{C_text("f_2505:scheduler_2escm"),(void*)f_2505},
{C_text("f_2515:scheduler_2escm"),(void*)f_2515},
{C_text("f_2534:scheduler_2escm"),(void*)f_2534},
{C_text("f_2547:scheduler_2escm"),(void*)f_2547},
{C_text("f_2550:scheduler_2escm"),(void*)f_2550},
{C_text("f_2566:scheduler_2escm"),(void*)f_2566},
{C_text("f_2572:scheduler_2escm"),(void*)f_2572},
{C_text("f_2579:scheduler_2escm"),(void*)f_2579},
{C_text("f_2584:scheduler_2escm"),(void*)f_2584},
{C_text("f_2590:scheduler_2escm"),(void*)f_2590},
{C_text("f_2604:scheduler_2escm"),(void*)f_2604},
{C_text("f_2607:scheduler_2escm"),(void*)f_2607},
{C_text("f_2633:scheduler_2escm"),(void*)f_2633},
{C_text("f_2645:scheduler_2escm"),(void*)f_2645},
{C_text("f_2654:scheduler_2escm"),(void*)f_2654},
{C_text("f_2683:scheduler_2escm"),(void*)f_2683},
{C_text("f_2688:scheduler_2escm"),(void*)f_2688},
{C_text("f_2711:scheduler_2escm"),(void*)f_2711},
{C_text("f_919:scheduler_2escm"),(void*)f_919},
{C_text("f_922:scheduler_2escm"),(void*)f_922},
{C_text("f_924:scheduler_2escm"),(void*)f_924},
{C_text("f_930:scheduler_2escm"),(void*)f_930},
{C_text("f_957:scheduler_2escm"),(void*)f_957},
{C_text("f_967:scheduler_2escm"),(void*)f_967},
{C_text("f_998:scheduler_2escm"),(void*)f_998},
{C_text("toplevel:scheduler_2escm"),(void*)C_scheduler_toplevel},
{NULL,NULL}};
#endif

static C_PTABLE_ENTRY *create_ptable(void){
#ifdef C_ENABLE_PTABLES
return ptable;
#else
return NULL;
#endif
}

/*
S|applied compiler syntax:
S|  chicken.format#sprintf		3
S|  scheme#for-each		6
S|  ##sys#for-each		1
o|eliminated procedure checks: 137 
o|specializations:
o|  3 (chicken.base#add1 *)
o|  2 (chicken.base#sub1 *)
o|  1 (scheme#zero? *)
o|  3 (##sys#check-output-port * * *)
o|  10 (scheme#eqv? * (or eof null fixnum char boolean symbol keyword))
o|  3 (scheme#car pair)
o|  20 (scheme#cdr pair)
o|  4 (scheme#cdar (pair pair *))
(o e)|safe calls: 249 
(o e)|assignments to immediate values: 12 
o|inlining procedure: k932 
o|inlining procedure: k932 
o|inlining procedure: k1020 
o|inlining procedure: k1020 
o|contracted procedure: "(scheduler.scm:234) switch168" 
o|contracted procedure: "(scheduler.scm:170) ##sys#restore-thread-state-buffer" 
o|contracted procedure: "(scheduler.scm:229) remove-from-ready-queue" 
o|inlining procedure: k1224 
o|inlining procedure: k1224 
o|propagated global variable: first-pair229 ready-queue-head 
o|inlining procedure: k1063 
o|inlining procedure: k1063 
o|contracted procedure: "(scheduler.scm:226) ##sys#unblock-threads-for-i/o" 
o|inlining procedure: k2040 
o|inlining procedure: k2040 
o|inlining procedure: k2062 
o|inlining procedure: k2062 
o|inlining procedure: k2089 
o|inlining procedure: k2089 
o|inlining procedure: k2148 
o|inlining procedure: k2148 
o|substituted constant variable: a2182 
o|substituted constant variable: a2183 
o|inlining procedure: k2204 
o|inlining procedure: k2204 
o|contracted procedure: "(scheduler.scm:511) fdset-test" 
o|inlining procedure: k1883 
o|inlining procedure: k1883 
o|inlining procedure: k1901 
o|substituted constant variable: a1915 
o|substituted constant variable: a1916 
o|inlining procedure: k1901 
o|substituted constant variable: a1942 
o|substituted constant variable: a1947 
o|substituted constant variable: a1949 
o|substituted constant variable: a1954 
o|substituted constant variable: a1956 
o|contracted procedure: "(scheduler.scm:471) g514515" 
o|contracted procedure: "(scheduler.scm:461) create-fdset" 
o|inlining procedure: k1748 
o|inlining procedure: k1762 
o|inlining procedure: k1779 
o|inlining procedure: k1779 
o|substituted constant variable: a1802 
o|substituted constant variable: a1803 
o|substituted constant variable: a1823 
o|substituted constant variable: a1828 
o|substituted constant variable: a1830 
o|substituted constant variable: a1835 
o|substituted constant variable: a1837 
o|inlining procedure: k1762 
o|inlining procedure: k1748 
o|contracted procedure: "(scheduler.scm:408) g445446" 
o|inlining procedure: k1856 
o|inlining procedure: k1856 
o|contracted procedure: "(scheduler.scm:404) g388389" 
o|inlining procedure: k1081 
o|inlining procedure: k1081 
o|inlining procedure: k1102 
o|inlining procedure: k1102 
o|inlining procedure: k1136 
o|inlining procedure: k1136 
o|inlining procedure: k1158 
o|inlining procedure: k1158 
o|propagated global variable: ct174 ##sys#current-thread 
o|inlining procedure: k1210 
o|inlining procedure: k1210 
o|inlining procedure: k1303 
o|propagated global variable: ct253 ##sys#current-thread 
o|inlining procedure: k1303 
o|inlining procedure: k1337 
o|inlining procedure: k1337 
o|inlining procedure: k1355 
o|inlining procedure: k1355 
o|inlining procedure: k1372 
o|inlining procedure: k1393 
o|inlining procedure: k1393 
o|inlining procedure: k1372 
o|inlining procedure: k1444 
o|inlining procedure: k1444 
o|inlining procedure: k1601 
o|inlining procedure: k1612 
o|inlining procedure: k1612 
o|inlining procedure: k1601 
o|inlining procedure: k1631 
o|inlining procedure: k1631 
o|inlining procedure: k1665 
o|inlining procedure: k1665 
o|contracted procedure: "(scheduler.scm:349) ##sys#abandon-mutexes" 
o|inlining procedure: k1482 
o|inlining procedure: k1482 
o|inlining procedure: k1548 
o|contracted procedure: "(scheduler.scm:332) g295302" 
o|inlining procedure: k1502 
o|inlining procedure: k1502 
o|inlining procedure: k1522 
o|contracted procedure: "(scheduler.scm:339) g309316" 
o|inlining procedure: k1522 
o|inlining procedure: k1548 
o|propagated global variable: pt378 ##sys#primordial-thread 
o|inlining procedure: k1979 
o|inlining procedure: k1979 
o|inlining procedure: k2294 
o|inlining procedure: k2310 
o|inlining procedure: k2310 
o|inlining procedure: k2331 
o|inlining procedure: k2331 
o|inlining procedure: k2294 
o|inlining procedure: k2381 
o|inlining procedure: k2381 
o|inlining procedure: k2404 
o|inlining procedure: k2428 
o|inlining procedure: k2428 
o|inlining procedure: k2404 
o|inlining procedure: k2453 
o|inlining procedure: k2453 
o|inlining procedure: k2536 
o|inlining procedure: k2536 
o|propagated global variable: ct644 ##sys#current-thread 
o|propagated global variable: primordial650 ##sys#current-thread 
o|inlining procedure: k2656 
o|inlining procedure: k2656 
o|inlining procedure: k2690 
o|inlining procedure: k2690 
o|propagated global variable: g671683 fd-list 
o|inlining procedure: k2713 
o|inlining procedure: k2713 
o|propagated global variable: g661676 timeout-list 
o|propagated global variable: primordial650 ##sys#current-thread 
o|replaced variables: 442 
o|removed binding forms: 186 
o|inlining procedure: k1234 
o|inlining procedure: k1234 
o|substituted constant variable: r12252738 
o|inlining procedure: k2265 
o|inlining procedure: k2265 
o|substituted constant variable: r11372769 
o|substituted constant variable: r11592772 
o|substituted constant variable: r23112834 
o|converted assignments to bindings: (suspend651) 
o|simplifications: ((let . 1)) 
o|replaced variables: 69 
o|removed binding forms: 371 
o|inlining procedure: k1029 
o|inlining procedure: k1845 
o|replaced variables: 8 
o|removed binding forms: 52 
o|substituted constant variable: r10302952 
o|contracted procedure: k976 
o|contracted procedure: k1739 
o|removed binding forms: 11 
o|removed conditional forms: 1 
o|removed binding forms: 2 
o|simplifications: ((if . 17) (let . 19) (##core#call . 242)) 
o|  call simplifications:
o|    scheme#*
o|    scheme#+
o|    ##sys#call-with-current-continuation
o|    scheme#vector
o|    scheme#list	2
o|    ##sys#structure?	2
o|    scheme#>
o|    scheme#<
o|    chicken.fixnum#fx=	2
o|    scheme#set-cdr!	3
o|    scheme#equal?
o|    scheme#>=
o|    ##sys#setislot	18
o|    scheme#caar	7
o|    scheme#-	2
o|    chicken.fixnum#fx>
o|    scheme#pair?	16
o|    scheme#car	12
o|    scheme#cdr	8
o|    scheme#not	6
o|    ##sys#setslot	30
o|    scheme#null?	26
o|    scheme#eq?	26
o|    scheme#cons	16
o|    ##sys#slot	57
o|contracted procedure: k935 
o|contracted procedure: k963 
o|contracted procedure: k941 
o|contracted procedure: k951 
o|contracted procedure: k959 
o|contracted procedure: k990 
o|contracted procedure: k1023 
o|contracted procedure: k1035 
o|contracted procedure: k1029 
o|contracted procedure: k1054 
o|contracted procedure: k1044 
o|contracted procedure: k973 
o|contracted procedure: k1273 
o|contracted procedure: k1277 
o|contracted procedure: k1281 
o|contracted procedure: k1285 
o|contracted procedure: k1289 
o|contracted procedure: k1293 
o|contracted procedure: k1297 
o|contracted procedure: k980 
o|contracted procedure: k987 
o|contracted procedure: k1243 
o|contracted procedure: k1227 
o|contracted procedure: k1230 
o|propagated global variable: first-pair229 ready-queue-head 
o|contracted procedure: k1238 
o|contracted procedure: k1066 
o|contracted procedure: k2026 
o|contracted procedure: k2029 
o|contracted procedure: k2037 
o|contracted procedure: k2043 
o|contracted procedure: k2052 
o|contracted procedure: k2066 
o|contracted procedure: k2069 
o|contracted procedure: k2072 
o|contracted procedure: k2078 
o|contracted procedure: k2092 
o|contracted procedure: k2098 
o|contracted procedure: k2109 
o|contracted procedure: k2116 
o|contracted procedure: k2128 
o|contracted procedure: k2131 
o|contracted procedure: k2134 
o|contracted procedure: k2140 
o|contracted procedure: k2247 
o|contracted procedure: k2151 
o|contracted procedure: k2165 
o|contracted procedure: k2243 
o|contracted procedure: k2239 
o|contracted procedure: k2174 
o|contracted procedure: k2221 
o|contracted procedure: k2233 
o|contracted procedure: k1886 
o|contracted procedure: k1889 
o|contracted procedure: k1895 
o|contracted procedure: k1898 
o|contracted procedure: k1904 
o|contracted procedure: k2268 
o|contracted procedure: k2271 
o|contracted procedure: k2281 
o|contracted procedure: k1751 
o|contracted procedure: k1754 
o|contracted procedure: k1759 
o|contracted procedure: k1765 
o|contracted procedure: k1772 
o|contracted procedure: k1775 
o|contracted procedure: k1782 
o|contracted procedure: k1785 
o|contracted procedure: k1792 
o|contracted procedure: k1859 
o|contracted procedure: k1869 
o|contracted procedure: k1873 
o|contracted procedure: k1072 
o|contracted procedure: k1084 
o|contracted procedure: k1088 
o|contracted procedure: k1093 
o|contracted procedure: k1099 
o|contracted procedure: k1105 
o|contracted procedure: k1108 
o|contracted procedure: k1129 
o|contracted procedure: k1139 
o|contracted procedure: k1148 
o|contracted procedure: k1155 
o|contracted procedure: k1161 
o|contracted procedure: k1172 
o|contracted procedure: k1175 
o|contracted procedure: k1178 
o|propagated global variable: ct174 ##sys#current-thread 
o|contracted procedure: k1190 
o|contracted procedure: k1204 
o|contracted procedure: k1207 
o|contracted procedure: k1214 
o|contracted procedure: k1210 
o|contracted procedure: k1249 
o|contracted procedure: k1252 
o|contracted procedure: k1255 
o|contracted procedure: k1258 
o|contracted procedure: k1261 
o|contracted procedure: k1264 
o|contracted procedure: k1309 
o|contracted procedure: k1312 
o|contracted procedure: k1340 
o|contracted procedure: k1343 
o|contracted procedure: k1346 
o|contracted procedure: k1366 
o|contracted procedure: k1352 
o|contracted procedure: k1375 
o|contracted procedure: k1381 
o|contracted procedure: k1384 
o|contracted procedure: k1396 
o|contracted procedure: k1413 
o|contracted procedure: k1409 
o|contracted procedure: k1421 
o|contracted procedure: k1417 
o|contracted procedure: k1428 
o|contracted procedure: k1435 
o|contracted procedure: k1441 
o|contracted procedure: k1447 
o|contracted procedure: k1450 
o|contracted procedure: k1470 
o|contracted procedure: k1466 
o|contracted procedure: k1453 
o|contracted procedure: k1456 
o|contracted procedure: k1459 
o|contracted procedure: k1574 
o|contracted procedure: k1586 
o|contracted procedure: k1589 
o|contracted procedure: k1592 
o|contracted procedure: k1595 
o|contracted procedure: k1598 
o|contracted procedure: k1607 
o|contracted procedure: k1622 
o|contracted procedure: k1615 
o|contracted procedure: k1634 
o|contracted procedure: k1644 
o|contracted procedure: k1648 
o|contracted procedure: k1651 
o|contracted procedure: k1662 
o|contracted procedure: k1668 
o|contracted procedure: k1679 
o|contracted procedure: k1479 
o|contracted procedure: k1485 
o|contracted procedure: k1551 
o|contracted procedure: k1561 
o|contracted procedure: k1565 
o|contracted procedure: k1490 
o|contracted procedure: k1493 
o|contracted procedure: k1496 
o|contracted procedure: k1499 
o|contracted procedure: k1508 
o|contracted procedure: k1525 
o|contracted procedure: k1535 
o|contracted procedure: k1539 
o|contracted procedure: k1685 
o|contracted procedure: k1688 
o|contracted procedure: k1700 
o|contracted procedure: k1709 
o|contracted procedure: k1712 
o|propagated global variable: pt378 ##sys#primordial-thread 
o|propagated global variable: pt378 ##sys#primordial-thread 
o|contracted procedure: k1963 
o|contracted procedure: k1966 
o|contracted procedure: k1973 
o|contracted procedure: k1982 
o|contracted procedure: k1990 
o|contracted procedure: k1986 
o|contracted procedure: k1993 
o|contracted procedure: k2017 
o|contracted procedure: k1999 
o|contracted procedure: k2006 
o|contracted procedure: k2357 
o|contracted procedure: k2297 
o|contracted procedure: k2353 
o|contracted procedure: k2300 
o|contracted procedure: k2313 
o|contracted procedure: k2316 
o|contracted procedure: k2319 
o|contracted procedure: k2325 
o|contracted procedure: k2334 
o|contracted procedure: k2338 
o|contracted procedure: k2493 
o|contracted procedure: k2363 
o|contracted procedure: k2487 
o|contracted procedure: k2366 
o|contracted procedure: k2481 
o|contracted procedure: k2369 
o|contracted procedure: k2475 
o|contracted procedure: k2372 
o|contracted procedure: k2384 
o|contracted procedure: k2407 
o|contracted procedure: k2416 
o|contracted procedure: k2431 
o|contracted procedure: k2438 
o|contracted procedure: k2456 
o|contracted procedure: k2469 
o|contracted procedure: k2507 
o|contracted procedure: k2518 
o|contracted procedure: k2522 
o|contracted procedure: k2526 
o|contracted procedure: k2530 
o|contracted procedure: k2562 
o|contracted procedure: k2539 
o|contracted procedure: k2558 
o|contracted procedure: k2574 
o|propagated global variable: ct644 ##sys#current-thread 
o|contracted procedure: k2600 
o|contracted procedure: k2596 
o|contracted procedure: k2618 
o|contracted procedure: k2609 
o|contracted procedure: k2612 
o|contracted procedure: k2626 
o|contracted procedure: k2639 
o|contracted procedure: k2647 
o|contracted procedure: k2659 
o|contracted procedure: k2669 
o|contracted procedure: k2673 
o|contracted procedure: k2693 
o|contracted procedure: k2703 
o|contracted procedure: k2707 
o|contracted procedure: k2716 
o|contracted procedure: k2726 
o|contracted procedure: k2730 
o|propagated global variable: primordial650 ##sys#current-thread 
o|simplifications: ((if . 2) (let . 67)) 
o|removed binding forms: 217 
o|contracted procedure: k1399 
o|inlining procedure: k1554 
o|inlining procedure: k1554 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest591592 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest591592 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest591592 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest591592 0 
o|contracted procedure: k2542 
o|removed binding forms: 2 
(o x)|known list op on rest arg sublist: ##core#rest-null? r2367 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r2367 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r2367 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r2367 1 
o|removed binding forms: 1 
o|removed binding forms: 2 
o|direct leaf routine/allocation: ##sys#update-thread-state-buffer 0 
o|direct leaf routine/allocation: loop260 0 
o|direct leaf routine/allocation: suspend651 0 
o|direct leaf routine/allocation: g655675 0 
o|contracted procedure: "(scheduler.scm:180) k993" 
o|contracted procedure: "(scheduler.scm:223) k1057" 
o|propagated global variable: ct174 ##sys#current-thread 
o|propagated global variable: ct174 ##sys#current-thread 
o|converted assignments to bindings: (loop260) 
o|contracted procedure: "(scheduler.scm:629) k2630" 
o|contracted procedure: "(scheduler.scm:631) k2662" 
o|contracted procedure: "(scheduler.scm:630) k2719" 
o|simplifications: ((let . 1)) 
o|removed binding forms: 5 
o|direct leaf routine/allocation: for-each-loop687697 0 
o|direct leaf routine/allocation: for-each-loop654678 0 
o|contracted procedure: k2642 
o|converted assignments to bindings: (for-each-loop687697) 
o|converted assignments to bindings: (for-each-loop654678) 
o|simplifications: ((let . 2)) 
o|removed binding forms: 1 
o|direct leaf routine with hoistable closures/allocation: g665682 (for-each-loop687697) 0 
o|contracted procedure: "(scheduler.scm:631) k2696" 
o|removed binding forms: 2 
o|direct leaf routine/allocation: for-each-loop664701 0 
o|contracted procedure: k2676 
o|converted assignments to bindings: (for-each-loop664701) 
o|simplifications: ((let . 1)) 
o|removed binding forms: 1 
o|customizable procedures: (loop617 loop614 loop610 loop607 loop576 loop498 for-each-loop308319 for-each-loop294327 delq k1577 g343350 for-each-loop342353 loop269 k1126 ##sys#clear-i/o-state-for-thread! loop183 g402409 for-each-loop401441 loop394 k2207 loop2543 loop529 k1017 loop2200 loop1181 loop160) 
o|calls to known targets: 73 
o|identified direct recursive calls: f_930 1 
o|identified direct recursive calls: f_2087 1 
o|identified direct recursive calls: f_2060 1 
o|identified direct recursive calls: f_1079 1 
o|identified direct recursive calls: f_1335 1 
o|identified direct recursive calls: f_1391 1 
o|identified direct recursive calls: f_1546 1 
o|identified direct recursive calls: f_1977 1 
o|identified direct recursive calls: f_2308 1 
o|identified direct recursive calls: f_2426 1 
o|unused rest argument: rest591592 f_2361 
o|identified direct recursive calls: f_2711 1 
o|identified direct recursive calls: f_2654 1 
o|identified direct recursive calls: f_2688 1 
o|fast box initializations: 18 
o|fast global references: 48 
o|fast global assignments: 31 
o|dropping unused closure argument: f_1247 
o|dropping unused closure argument: f_2292 
o|dropping unused closure argument: f_924 
*/
/* end of file */
