/* Generated from tcp.scm by the CHICKEN compiler
   http://www.call-cc.org
   Version 6.0.0pre1 ((HEAD detached at 6.0.0pre1)) (rev 05be15d4)
   linux-unix-gnu-x86-64 [ 64bit dload ptables ]
   command line: tcp.scm -optimize-level 2 -include-path . -include-path ./ -inline -ignore-repository -feature chicken-bootstrap -no-warnings -specialize -consult-types-file ./types.db -explicit-use -no-trace -output-file tcp.c -emit-import-library chicken.tcp
   unit: tcp
   uses: scheduler port library
*/
#include "chicken.h"

#ifdef _WIN32
# include <winsock2.h>
# include <ws2tcpip.h>
/* Beware: winsock2.h must come BEFORE windows.h */
# define socklen_t	 int
static WSADATA wsa;
# ifndef SHUT_RD
#  define SHUT_RD	  SD_RECEIVE
# endif
# ifndef SHUT_WR
#  define SHUT_WR	  SD_SEND
# endif

# define typecorrect_getsockopt(socket, level, optname, optval, optlen)	\
    getsockopt(socket, level, optname, (char *)optval, optlen)

static C_word make_socket_nonblocking (C_word sock) {
  int fd = C_unfix(sock);
  C_return(C_mk_bool(ioctlsocket(fd, FIONBIO, (void *)&fd) != SOCKET_ERROR)) ;
}

/* This is a bit of a hack, but it keeps things simple */
static C_char *last_wsa_errorstring = NULL;

static char *errormsg_from_code(int code) {
  int bufsize;
  if (last_wsa_errorstring != NULL) {
    LocalFree(last_wsa_errorstring);
    last_wsa_errorstring = NULL;
  }
  bufsize = FormatMessage(
	FORMAT_MESSAGE_ALLOCATE_BUFFER |
	FORMAT_MESSAGE_FROM_SYSTEM |
	FORMAT_MESSAGE_IGNORE_INSERTS,
	NULL, code, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
	(LPTSTR) &last_wsa_errorstring, 0, NULL);
  if (bufsize == 0) return "ERROR WHILE FETCHING ERROR";
  return last_wsa_errorstring;
}

# define get_last_socket_error()  WSAGetLastError()
# define should_retry_call()      (WSAGetLastError() == WSAEWOULDBLOCK)
/* Not EINPROGRESS in winsock.  Nonblocking connect returns EWOULDBLOCK... */
# define call_in_progress()       (WSAGetLastError() == WSAEWOULDBLOCK)
# define call_was_interrupted()   (WSAGetLastError() == WSAEINTR) /* ? */

#else
# include <errno.h>
# include <fcntl.h>
# include <sys/socket.h>
# include <sys/time.h>
# include <netinet/in.h>
# include <netdb.h>
# include <signal.h>
# define closesocket     close
# define INVALID_SOCKET  -1
# define SOCKET_ERROR    -1
# define typecorrect_getsockopt getsockopt

static C_word make_socket_nonblocking (C_word sock) {
  int fd = C_unfix(sock);
  int val = fcntl(fd, F_GETFL, 0);
  if(val == -1) C_return(C_SCHEME_FALSE);
  C_return(C_mk_bool(fcntl(fd, F_SETFL, val | O_NONBLOCK) != -1));
}

# define get_last_socket_error()  errno
# define errormsg_from_code(e)    strerror(e)

# define should_retry_call()      (errno == EAGAIN || errno == EWOULDBLOCK)
# define call_was_interrupted()   (errno == EINTR)
# define call_in_progress()       (errno == EINPROGRESS)
#endif

#ifdef ECOS
#include <sys/sockio.h>
#endif

#ifndef h_addr
# define h_addr  h_addr_list[ 0 ]
#endif

static char addr_buffer[ 20 ];

static int C_set_socket_options(int socket)
{
  int yes = 1; 
  int r;

  r = setsockopt(socket, SOL_SOCKET, SO_REUSEADDR, (const char *)&yes, sizeof(int));
  
  if(r != 0) return r;

#ifdef SO_NOSIGPIPE
  /*
   * Avoid SIGPIPE (iOS uses *only* SIGPIPE otherwise, not returning EPIPE).
   * For consistency we do this everywhere the option is supported.
   */
  r = setsockopt(socket, SOL_SOCKET, SO_NOSIGPIPE, (const char *)&yes, sizeof(int));
#endif

  return r;
}


static C_PTABLE_ENTRY *create_ptable(void);
C_noret_decl(C_scheduler_toplevel)
C_extern void C_ccall C_scheduler_toplevel(C_word c,C_word *av) C_noret;
C_noret_decl(C_port_toplevel)
C_extern void C_ccall C_port_toplevel(C_word c,C_word *av) C_noret;
C_noret_decl(C_library_toplevel)
C_extern void C_ccall C_library_toplevel(C_word c,C_word *av) C_noret;

static C_word lf[112];
static double C_possibly_force_alignment;
static C_char li0[] C_aligned={C_lihdr(0,0,50),40,99,104,105,99,107,101,110,46,116,99,112,35,103,101,116,104,111,115,116,97,100,100,114,32,115,97,100,100,114,50,54,57,32,104,111,115,116,50,55,48,32,112,111,114,116,50,55,49,41,0,0,0,0,0,0};
static C_char li1[] C_aligned={C_lihdr(0,0,36),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,108,105,115,116,101,110,32,112,111,114,116,32,46,32,114,101,115,116,41,0,0,0,0};
static C_char li2[] C_aligned={C_lihdr(0,0,29),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,108,105,115,116,101,110,101,114,63,32,120,41,0,0,0};
static C_char li3[] C_aligned={C_lihdr(0,0,28),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,99,108,111,115,101,32,116,99,112,108,41,0,0,0,0};
static C_char li4[] C_aligned={C_lihdr(0,0,10),40,102,95,49,54,57,56,32,120,41,0,0,0,0,0,0};
static C_char li5[] C_aligned={C_lihdr(0,0,11),40,99,104,101,99,107,32,108,111,99,41,0,0,0,0,0};
static C_char li6[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li7[] C_aligned={C_lihdr(0,0,12),40,114,101,97,100,45,105,110,112,117,116,41,0,0,0,0};
static C_char li8[] C_aligned={C_lihdr(0,0,7),40,97,49,57,49,56,41,0};
static C_char li9[] C_aligned={C_lihdr(0,0,21),40,108,111,111,112,32,108,101,110,32,111,102,102,115,101,116,32,100,108,119,41,0,0,0};
static C_char li10[] C_aligned={C_lihdr(0,0,21),40,97,49,56,53,52,32,98,117,102,32,115,116,97,114,116,32,108,101,110,41,0,0,0};
static C_char li11[] C_aligned={C_lihdr(0,0,23),40,111,117,116,112,117,116,45,116,111,45,115,111,99,107,101,116,32,98,118,32,110,41,0};
static C_char li12[] C_aligned={C_lihdr(0,0,10),40,108,111,111,112,32,110,32,112,41,0,0,0,0,0,0};
static C_char li13[] C_aligned={C_lihdr(0,0,17),40,97,100,100,45,116,111,45,98,117,102,32,98,118,32,110,41,0,0,0,0,0,0,0};
static C_char li14[] C_aligned={C_lihdr(0,0,11),40,97,50,48,54,48,32,112,32,99,41,0,0,0,0,0};
static C_char li15[] C_aligned={C_lihdr(0,0,20),40,97,50,48,55,53,32,112,32,98,118,32,102,114,111,109,32,116,111,41,0,0,0,0};
static C_char li16[] C_aligned={C_lihdr(0,0,11),40,97,50,48,57,54,32,112,32,100,41,0,0,0,0,0};
static C_char li17[] C_aligned={C_lihdr(0,0,9),40,97,50,49,53,57,32,112,41,0,0,0,0,0,0,0};
static C_char li18[] C_aligned={C_lihdr(0,0,19),40,97,50,49,57,52,32,98,117,102,32,115,116,97,114,116,32,110,41,0,0,0,0,0};
static C_char li19[] C_aligned={C_lihdr(0,0,7),40,97,50,49,55,53,41,0};
static C_char li20[] C_aligned={C_lihdr(0,0,7),40,97,50,50,48,55,41,0};
static C_char li21[] C_aligned={C_lihdr(0,0,7),40,97,50,50,52,57,41,0};
static C_char li22[] C_aligned={C_lihdr(0,0,19),40,97,50,51,49,56,32,98,117,102,32,115,116,97,114,116,32,110,41,0,0,0,0,0};
static C_char li23[] C_aligned={C_lihdr(0,0,7),40,97,50,50,57,57,41,0};
static C_char li24[] C_aligned={C_lihdr(0,0,16),40,108,111,111,112,32,110,32,109,32,115,116,97,114,116,41};
static C_char li25[] C_aligned={C_lihdr(0,0,22),40,97,50,51,50,55,32,112,32,110,32,100,101,115,116,32,115,116,97,114,116,41,0,0};
static C_char li26[] C_aligned={C_lihdr(0,0,11),40,97,50,52,49,54,32,112,111,115,41,0,0,0,0,0};
static C_char li27[] C_aligned={C_lihdr(0,0,7),40,97,50,52,48,54,41,0};
static C_char li28[] C_aligned={C_lihdr(0,0,28),40,97,50,52,54,54,32,110,101,120,116,32,108,105,110,101,32,102,117,108,108,45,108,105,110,101,63,41,0,0,0,0};
static C_char li29[] C_aligned={C_lihdr(0,0,15),40,97,50,51,56,56,32,112,32,108,105,109,105,116,41,0};
static C_char li30[] C_aligned={C_lihdr(0,0,9),40,97,50,53,49,49,32,112,41,0,0,0,0,0,0,0};
static C_char li31[] C_aligned={C_lihdr(0,0,33),40,99,104,105,99,107,101,110,46,116,99,112,35,105,111,45,112,111,114,116,115,32,108,111,99,32,102,100,32,101,110,99,41,0,0,0,0,0,0,0};
static C_char li32[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li33[] C_aligned={C_lihdr(0,0,36),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,97,99,99,101,112,116,32,116,99,112,108,32,46,32,114,101,115,116,41,0,0,0,0};
static C_char li34[] C_aligned={C_lihdr(0,0,36),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,97,99,99,101,112,116,45,114,101,97,100,121,63,32,116,99,112,108,41,0,0,0,0};
static C_char li35[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0};
static C_char li36[] C_aligned={C_lihdr(0,0,8),40,108,111,111,112,32,105,41};
static C_char li37[] C_aligned={C_lihdr(0,0,7),40,97,50,57,56,49,41,0};
static C_char li38[] C_aligned={C_lihdr(0,0,23),40,97,50,57,56,55,32,104,111,115,116,55,54,55,32,112,111,114,116,55,54,56,41,0};
static C_char li39[] C_aligned={C_lihdr(0,0,37),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,99,111,110,110,101,99,116,32,104,111,115,116,32,46,32,114,101,115,116,41,0,0,0};
static C_char li40[] C_aligned={C_lihdr(0,0,36),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,112,111,114,116,45,62,102,105,108,101,110,111,32,112,32,108,111,99,41,0,0,0,0};
static C_char li41[] C_aligned={C_lihdr(0,0,29),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,97,100,100,114,101,115,115,101,115,32,112,41,0,0,0};
static C_char li42[] C_aligned={C_lihdr(0,0,32),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,112,111,114,116,45,110,117,109,98,101,114,115,32,112,41};
static C_char li43[] C_aligned={C_lihdr(0,0,36),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,108,105,115,116,101,110,101,114,45,112,111,114,116,32,116,99,112,108,41,0,0,0,0};
static C_char li44[] C_aligned={C_lihdr(0,0,32),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,97,98,97,110,100,111,110,45,112,111,114,116,32,112,41};
static C_char li45[] C_aligned={C_lihdr(0,0,35),40,99,104,105,99,107,101,110,46,116,99,112,35,116,99,112,45,108,105,115,116,101,110,101,114,45,102,105,108,101,110,111,32,108,41,0,0,0,0,0};
static C_char li46[] C_aligned={C_lihdr(0,0,10),40,116,111,112,108,101,118,101,108,41,0,0,0,0,0,0};


#define return(x) C_cblock C_r = (C_fix((C_word)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub743(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int socket=(int )C_unfix(C_a0);
int err, optlen;
optlen = sizeof(err);
if (typecorrect_getsockopt(socket, SOL_SOCKET, SO_ERROR, &err, (socklen_t *)&optlen) == SOCKET_ERROR)
  C_return(SOCKET_ERROR);
C_return(err);
C_ret:
#undef return

return C_r;}

#define return(x) C_cblock C_r = (((C_word)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub404(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
void * saddr=(void * )C_data_pointer(C_a0);
unsigned short port=(unsigned short )(unsigned short)C_unfix(C_a1);
struct sockaddr_in *addr = (struct sockaddr_in *)saddr;
memset(addr, 0, sizeof(struct sockaddr_in));
addr->sin_family = AF_INET;
addr->sin_port = htons(port);
addr->sin_addr.s_addr = htonl(INADDR_ANY);
C_ret:
#undef return

return C_r;}

#define return(x) C_cblock C_r = (C_mk_bool((x))); goto C_ret; C_cblockend
C_regparm static C_word stub272(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
void * saddr=(void * )C_data_pointer(C_a0);
char * host=(char * )C_string_or_null(C_a1);
unsigned short port=(unsigned short )(unsigned short)C_unfix(C_a2);
struct hostent *he = gethostbyname(host);
struct sockaddr_in *addr = (struct sockaddr_in *)saddr;
if(he == NULL) C_return(0);
memset(addr, 0, sizeof(struct sockaddr_in));
addr->sin_family = AF_INET;
addr->sin_port = htons((short)port);
addr->sin_addr = *((struct in_addr *)he->h_addr);
C_return(1);
C_ret:
#undef return

return C_r;}

#define return(x) C_cblock C_r = (C_fix((C_word)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub260(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
char * serv=(char * )C_string_or_null(C_a0);
char * proto=(char * )C_string_or_null(C_a1);
struct servent *se;
     if((se = getservbyname(serv, proto)) == NULL) C_return(0);
     else C_return(ntohs(se->s_port));
C_ret:
#undef return

return C_r;}

#define return(x) C_cblock C_r = (C_mk_bool((x))); goto C_ret; C_cblockend
C_regparm static C_word stub255(C_word C_buf){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
#ifdef _WIN32
     C_return(WSAStartup(MAKEWORD(1, 1), &wsa) == 0);
#else
     signal(SIGPIPE, SIG_IGN);
     C_return(1);
#endif
C_ret:
#undef return

return C_r;}

#define return(x) C_cblock C_r = (C_mpointer(&C_a,(void*)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub250(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int s=(int )C_unfix(C_a0);
struct sockaddr_in sa;
unsigned char *ptr;
unsigned int len = sizeof(struct sockaddr_in);
if(getpeername(s, (struct sockaddr *)&sa, ((socklen_t *)&len)) != 0) C_return(NULL);
ptr = (unsigned char *)&sa.sin_addr;
C_snprintf(addr_buffer, sizeof(addr_buffer), "%d.%d.%d.%d", ptr[ 0 ], ptr[ 1 ], ptr[ 2 ], ptr[ 3 ]);
C_return(addr_buffer);
C_ret:
#undef return

return C_r;}

#define return(x) C_cblock C_r = (C_fix((C_word)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub245(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int s=(int )C_unfix(C_a0);
struct sockaddr_in sa;
int len = sizeof(struct sockaddr_in);
if(getpeername(s, (struct sockaddr *)&sa, (socklen_t *)(&len)) != 0) C_return(-1);
else C_return(ntohs(sa.sin_port));
C_ret:
#undef return

return C_r;}

#define return(x) C_cblock C_r = (C_fix((C_word)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub240(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int s=(int )C_unfix(C_a0);
struct sockaddr_in sa;
int len = sizeof(struct sockaddr_in);
if(getsockname(s, (struct sockaddr *)&sa, (socklen_t *)(&len)) != 0) C_return(-1);
else C_return(ntohs(sa.sin_port));
C_ret:
#undef return

return C_r;}

#define return(x) C_cblock C_r = (C_mpointer(&C_a,(void*)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub234(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int s=(int )C_unfix(C_a0);
struct sockaddr_in sa;
unsigned char *ptr;
int len = sizeof(struct sockaddr_in);
if(getsockname(s, (struct sockaddr *)&sa, (socklen_t *)&len) != 0) C_return(NULL);
ptr = (unsigned char *)&sa.sin_addr;
C_snprintf(addr_buffer, sizeof(addr_buffer), "%d.%d.%d.%d", ptr[ 0 ], ptr[ 1 ], ptr[ 2 ], ptr[ 3 ]);
C_return(addr_buffer);
C_ret:
#undef return

return C_r;}

#define return(x) C_cblock C_r = (C_fix((C_word)(x))); goto C_ret; C_cblockend
C_regparm static C_word stub223(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2,C_word C_a3,C_word C_a4){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int s=(int )C_unfix(C_a0);
void * msg=(void * )C_data_pointer_or_null(C_a1);
int offset=(int )C_unfix(C_a2);
int len=(int )C_unfix(C_a3);
int flags=(int )C_unfix(C_a4);
C_return(send(s, (char *)msg+offset, len, flags));
C_ret:
#undef return

return C_r;}

/* from k1229 */
C_regparm static C_word stub214(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_r=C_fix((C_word)C_set_socket_options(t0));
return C_r;}

/* from k1222 */
C_regparm static C_word stub209(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_r=C_fix((C_word)C_check_fd_ready(t0));
return C_r;}

/* from k1212 */
C_regparm static C_word stub200(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
void * t1=(void * )C_data_pointer_or_null(C_a1);
int t2=(int )C_unfix(C_a2);
C_r=C_fix((C_word)connect(t0,t1,t2));
return C_r;}

/* from k1197 */
C_regparm static C_word stub192(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
int t1=(int )C_unfix(C_a1);
C_r=C_fix((C_word)shutdown(t0,t1));
return C_r;}

/* from k1183 */
C_regparm static C_word stub181(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2,C_word C_a3){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
void * t1=(void * )C_data_pointer_or_null(C_a1);
int t2=(int )C_unfix(C_a2);
int t3=(int )C_unfix(C_a3);
C_r=C_fix((C_word)recv(t0,t1,t2,t3));
return C_r;}

/* from k1164 */
C_regparm static C_word stub173(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_r=C_fix((C_word)closesocket(t0));
return C_r;}

/* from k1151 */
C_regparm static C_word stub162(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
void * t1=(void * )C_c_pointer_or_null(C_a1);
void * t2=(void * )C_c_pointer_or_null(C_a2);
C_r=C_fix((C_word)accept(t0,t1,t2));
return C_r;}

/* from k1136 */
C_regparm static C_word stub154(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
int t1=(int )C_unfix(C_a1);
C_r=C_fix((C_word)listen(t0,t1));
return C_r;}

/* from k1122 */
C_regparm static C_word stub144(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
void * t1=(void * )C_data_pointer_or_null(C_a1);
int t2=(int )C_unfix(C_a2);
C_r=C_fix((C_word)bind(t0,t1,t2));
return C_r;}

/* from k1107 */
C_regparm static C_word stub135(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
int t1=(int )C_unfix(C_a1);
int t2=(int )C_unfix(C_a2);
C_r=C_fix((C_word)socket(t0,t1,t2));
return C_r;}

/* from chicken.tcp#interrupted? */
C_regparm static C_word stub129(C_word C_buf){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_r=C_mk_bool(call_was_interrupted());
return C_r;}

/* from chicken.tcp#in-progress? */
C_regparm static C_word stub126(C_word C_buf){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_r=C_mk_bool(call_in_progress());
return C_r;}

/* from chicken.tcp#retry? */
C_regparm static C_word stub123(C_word C_buf){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_r=C_mk_bool(should_retry_call());
return C_r;}

/* from k1083 */
C_regparm static C_word stub118(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_r=C_mpointer(&C_a,(void*)errormsg_from_code(t0));
return C_r;}

/* from chicken.tcp#last-error-code */
C_regparm static C_word stub114(C_word C_buf){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_r=C_fix((C_word)get_last_socket_error());
return C_r;}

C_noret_decl(f3609)
static void C_ccall f3609(C_word c,C_word *av) C_noret;
C_noret_decl(f_1065)
static void C_ccall f_1065(C_word c,C_word *av) C_noret;
C_noret_decl(f_1068)
static void C_ccall f_1068(C_word c,C_word *av) C_noret;
C_noret_decl(f_1071)
static void C_ccall f_1071(C_word c,C_word *av) C_noret;
C_noret_decl(f_1299)
static void C_ccall f_1299(C_word c,C_word *av) C_noret;
C_noret_decl(f_1306)
static void C_ccall f_1306(C_word c,C_word *av) C_noret;
C_noret_decl(f_1310)
static void C_ccall f_1310(C_word c,C_word *av) C_noret;
C_noret_decl(f_1326)
static void f_1326(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_1335)
static void C_ccall f_1335(C_word c,C_word *av) C_noret;
C_noret_decl(f_1358)
static void f_1358(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1383)
static void C_ccall f_1383(C_word c,C_word *av) C_noret;
C_noret_decl(f_1387)
static void C_ccall f_1387(C_word c,C_word *av) C_noret;
C_noret_decl(f_1390)
static void f_1390(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1393)
static void C_ccall f_1393(C_word c,C_word *av) C_noret;
C_noret_decl(f_1403)
static void C_ccall f_1403(C_word c,C_word *av) C_noret;
C_noret_decl(f_1407)
static void C_ccall f_1407(C_word c,C_word *av) C_noret;
C_noret_decl(f_1411)
static void C_ccall f_1411(C_word c,C_word *av) C_noret;
C_noret_decl(f_1446)
static void C_ccall f_1446(C_word c,C_word *av) C_noret;
C_noret_decl(f_1449)
static void C_ccall f_1449(C_word c,C_word *av) C_noret;
C_noret_decl(f_1455)
static void C_ccall f_1455(C_word c,C_word *av) C_noret;
C_noret_decl(f_1458)
static void C_ccall f_1458(C_word c,C_word *av) C_noret;
C_noret_decl(f_1461)
static void C_ccall f_1461(C_word c,C_word *av) C_noret;
C_noret_decl(f_1477)
static void C_ccall f_1477(C_word c,C_word *av) C_noret;
C_noret_decl(f_1481)
static void C_ccall f_1481(C_word c,C_word *av) C_noret;
C_noret_decl(f_1485)
static void C_ccall f_1485(C_word c,C_word *av) C_noret;
C_noret_decl(f_1501)
static void C_ccall f_1501(C_word c,C_word *av) C_noret;
C_noret_decl(f_1505)
static void C_ccall f_1505(C_word c,C_word *av) C_noret;
C_noret_decl(f_1509)
static void C_ccall f_1509(C_word c,C_word *av) C_noret;
C_noret_decl(f_1531)
static void C_ccall f_1531(C_word c,C_word *av) C_noret;
C_noret_decl(f_1540)
static void C_ccall f_1540(C_word c,C_word *av) C_noret;
C_noret_decl(f_1559)
static void C_ccall f_1559(C_word c,C_word *av) C_noret;
C_noret_decl(f_1565)
static void f_1565(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1568)
static void C_ccall f_1568(C_word c,C_word *av) C_noret;
C_noret_decl(f_1587)
static void C_ccall f_1587(C_word c,C_word *av) C_noret;
C_noret_decl(f_1591)
static void C_ccall f_1591(C_word c,C_word *av) C_noret;
C_noret_decl(f_1595)
static void C_ccall f_1595(C_word c,C_word *av) C_noret;
C_noret_decl(f_1639)
static void C_ccall f_1639(C_word c,C_word *av) C_noret;
C_noret_decl(f_1648)
static void C_ccall f_1648(C_word c,C_word *av) C_noret;
C_noret_decl(f_1668)
static void C_ccall f_1668(C_word c,C_word *av) C_noret;
C_noret_decl(f_1672)
static void C_ccall f_1672(C_word c,C_word *av) C_noret;
C_noret_decl(f_1676)
static void C_ccall f_1676(C_word c,C_word *av) C_noret;
C_noret_decl(f_1690)
static void C_ccall f_1690(C_word c,C_word *av) C_noret;
C_noret_decl(f_1696)
static void f_1696(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1698)
static void C_ccall f_1698(C_word c,C_word *av) C_noret;
C_noret_decl(f_1713)
static void C_ccall f_1713(C_word c,C_word *av) C_noret;
C_noret_decl(f_1717)
static void C_ccall f_1717(C_word c,C_word *av) C_noret;
C_noret_decl(f_1721)
static void C_ccall f_1721(C_word c,C_word *av) C_noret;
C_noret_decl(f_1725)
static void C_ccall f_1725(C_word c,C_word *av) C_noret;
C_noret_decl(f_1727)
static void f_1727(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_1731)
static void C_ccall f_1731(C_word c,C_word *av) C_noret;
C_noret_decl(f_1734)
static void C_ccall f_1734(C_word c,C_word *av) C_noret;
C_noret_decl(f_1740)
static void C_ccall f_1740(C_word c,C_word *av) C_noret;
C_noret_decl(f_1743)
static void C_ccall f_1743(C_word c,C_word *av) C_noret;
C_noret_decl(f_1744)
static void f_1744(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1748)
static void C_ccall f_1748(C_word c,C_word *av) C_noret;
C_noret_decl(f_1751)
static void f_1751(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1756)
static void C_ccall f_1756(C_word c,C_word *av) C_noret;
C_noret_decl(f_1775)
static void C_ccall f_1775(C_word c,C_word *av) C_noret;
C_noret_decl(f_1778)
static void C_ccall f_1778(C_word c,C_word *av) C_noret;
C_noret_decl(f_1781)
static void C_ccall f_1781(C_word c,C_word *av) C_noret;
C_noret_decl(f_1784)
static void C_ccall f_1784(C_word c,C_word *av) C_noret;
C_noret_decl(f_1812)
static void C_ccall f_1812(C_word c,C_word *av) C_noret;
C_noret_decl(f_1816)
static void C_ccall f_1816(C_word c,C_word *av) C_noret;
C_noret_decl(f_1820)
static void C_ccall f_1820(C_word c,C_word *av) C_noret;
C_noret_decl(f_1838)
static void C_ccall f_1838(C_word c,C_word *av) C_noret;
C_noret_decl(f_1841)
static void C_ccall f_1841(C_word c,C_word *av) C_noret;
C_noret_decl(f_1842)
static void f_1842(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_1846)
static void C_ccall f_1846(C_word c,C_word *av) C_noret;
C_noret_decl(f_1855)
static void C_ccall f_1855(C_word c,C_word *av) C_noret;
C_noret_decl(f_1863)
static void f_1863(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1865)
static void f_1865(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_1887)
static void C_ccall f_1887(C_word c,C_word *av) C_noret;
C_noret_decl(f_1890)
static void C_ccall f_1890(C_word c,C_word *av) C_noret;
C_noret_decl(f_1893)
static void C_ccall f_1893(C_word c,C_word *av) C_noret;
C_noret_decl(f_1896)
static void C_ccall f_1896(C_word c,C_word *av) C_noret;
C_noret_decl(f_1919)
static void C_ccall f_1919(C_word c,C_word *av) C_noret;
C_noret_decl(f_1930)
static void C_ccall f_1930(C_word c,C_word *av) C_noret;
C_noret_decl(f_1934)
static void C_ccall f_1934(C_word c,C_word *av) C_noret;
C_noret_decl(f_1938)
static void C_ccall f_1938(C_word c,C_word *av) C_noret;
C_noret_decl(f_1978)
static void C_ccall f_1978(C_word c,C_word *av) C_noret;
C_noret_decl(f_1985)
static void C_ccall f_1985(C_word c,C_word *av) C_noret;
C_noret_decl(f_1986)
static void f_1986(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_1992)
static void f_1992(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2014)
static void C_ccall f_2014(C_word c,C_word *av) C_noret;
C_noret_decl(f_2036)
static void C_ccall f_2036(C_word c,C_word *av) C_noret;
C_noret_decl(f_2045)
static void C_ccall f_2045(C_word c,C_word *av) C_noret;
C_noret_decl(f_2048)
static void C_ccall f_2048(C_word c,C_word *av) C_noret;
C_noret_decl(f_2061)
static void C_ccall f_2061(C_word c,C_word *av) C_noret;
C_noret_decl(f_2065)
static void C_ccall f_2065(C_word c,C_word *av) C_noret;
C_noret_decl(f_2076)
static void C_ccall f_2076(C_word c,C_word *av) C_noret;
C_noret_decl(f_2097)
static void C_ccall f_2097(C_word c,C_word *av) C_noret;
C_noret_decl(f_2105)
static void f_2105(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2108)
static void f_2108(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2114)
static void f_2114(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2121)
static void C_ccall f_2121(C_word c,C_word *av) C_noret;
C_noret_decl(f_2125)
static void C_ccall f_2125(C_word c,C_word *av) C_noret;
C_noret_decl(f_2129)
static void C_ccall f_2129(C_word c,C_word *av) C_noret;
C_noret_decl(f_2154)
static void C_ccall f_2154(C_word c,C_word *av) C_noret;
C_noret_decl(f_2160)
static void C_ccall f_2160(C_word c,C_word *av) C_noret;
C_noret_decl(f_2170)
static void C_ccall f_2170(C_word c,C_word *av) C_noret;
C_noret_decl(f_2176)
static void C_ccall f_2176(C_word c,C_word *av) C_noret;
C_noret_decl(f_2180)
static void C_ccall f_2180(C_word c,C_word *av) C_noret;
C_noret_decl(f_2195)
static void C_ccall f_2195(C_word c,C_word *av) C_noret;
C_noret_decl(f_2208)
static void C_ccall f_2208(C_word c,C_word *av) C_noret;
C_noret_decl(f_2221)
static void C_ccall f_2221(C_word c,C_word *av) C_noret;
C_noret_decl(f_2234)
static void C_ccall f_2234(C_word c,C_word *av) C_noret;
C_noret_decl(f_2238)
static void C_ccall f_2238(C_word c,C_word *av) C_noret;
C_noret_decl(f_2242)
static void C_ccall f_2242(C_word c,C_word *av) C_noret;
C_noret_decl(f_2250)
static void C_ccall f_2250(C_word c,C_word *av) C_noret;
C_noret_decl(f_2258)
static void f_2258(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2264)
static void f_2264(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2271)
static void C_ccall f_2271(C_word c,C_word *av) C_noret;
C_noret_decl(f_2275)
static void C_ccall f_2275(C_word c,C_word *av) C_noret;
C_noret_decl(f_2279)
static void C_ccall f_2279(C_word c,C_word *av) C_noret;
C_noret_decl(f_2300)
static void C_ccall f_2300(C_word c,C_word *av) C_noret;
C_noret_decl(f_2304)
static void C_ccall f_2304(C_word c,C_word *av) C_noret;
C_noret_decl(f_2319)
static void C_ccall f_2319(C_word c,C_word *av) C_noret;
C_noret_decl(f_2328)
static void C_ccall f_2328(C_word c,C_word *av) C_noret;
C_noret_decl(f_2334)
static void f_2334(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_2378)
static void C_ccall f_2378(C_word c,C_word *av) C_noret;
C_noret_decl(f_2389)
static void C_ccall f_2389(C_word c,C_word *av) C_noret;
C_noret_decl(f_2393)
static void C_ccall f_2393(C_word c,C_word *av) C_noret;
C_noret_decl(f_2407)
static void C_ccall f_2407(C_word c,C_word *av) C_noret;
C_noret_decl(f_2417)
static void C_ccall f_2417(C_word c,C_word *av) C_noret;
C_noret_decl(f_2433)
static void C_ccall f_2433(C_word c,C_word *av) C_noret;
C_noret_decl(f_2467)
static void C_ccall f_2467(C_word c,C_word *av) C_noret;
C_noret_decl(f_2512)
static void C_ccall f_2512(C_word c,C_word *av) C_noret;
C_noret_decl(f_2522)
static void C_ccall f_2522(C_word c,C_word *av) C_noret;
C_noret_decl(f_2549)
static void C_ccall f_2549(C_word c,C_word *av) C_noret;
C_noret_decl(f_2553)
static void C_ccall f_2553(C_word c,C_word *av) C_noret;
C_noret_decl(f_2557)
static void C_ccall f_2557(C_word c,C_word *av) C_noret;
C_noret_decl(f_2561)
static void C_ccall f_2561(C_word c,C_word *av) C_noret;
C_noret_decl(f_2574)
static void C_ccall f_2574(C_word c,C_word *av) C_noret;
C_noret_decl(f_2577)
static void f_2577(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2582)
static void C_ccall f_2582(C_word c,C_word *av) C_noret;
C_noret_decl(f_2586)
static void C_ccall f_2586(C_word c,C_word *av) C_noret;
C_noret_decl(f_2589)
static void C_ccall f_2589(C_word c,C_word *av) C_noret;
C_noret_decl(f_2592)
static void C_ccall f_2592(C_word c,C_word *av) C_noret;
C_noret_decl(f_2595)
static void C_ccall f_2595(C_word c,C_word *av) C_noret;
C_noret_decl(f_2623)
static void C_ccall f_2623(C_word c,C_word *av) C_noret;
C_noret_decl(f_2627)
static void C_ccall f_2627(C_word c,C_word *av) C_noret;
C_noret_decl(f_2631)
static void C_ccall f_2631(C_word c,C_word *av) C_noret;
C_noret_decl(f_2657)
static void C_ccall f_2657(C_word c,C_word *av) C_noret;
C_noret_decl(f_2665)
static void C_ccall f_2665(C_word c,C_word *av) C_noret;
C_noret_decl(f_2675)
static void C_ccall f_2675(C_word c,C_word *av) C_noret;
C_noret_decl(f_2688)
static void C_ccall f_2688(C_word c,C_word *av) C_noret;
C_noret_decl(f_2692)
static void C_ccall f_2692(C_word c,C_word *av) C_noret;
C_noret_decl(f_2696)
static void C_ccall f_2696(C_word c,C_word *av) C_noret;
C_noret_decl(f_2715)
static void C_ccall f_2715(C_word c,C_word *av) C_noret;
C_noret_decl(f_2731)
static void C_ccall f_2731(C_word c,C_word *av) C_noret;
C_noret_decl(f_2734)
static void f_2734(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2737)
static void C_ccall f_2737(C_word c,C_word *av) C_noret;
C_noret_decl(f_2743)
static void C_ccall f_2743(C_word c,C_word *av) C_noret;
C_noret_decl(f_2749)
static void C_ccall f_2749(C_word c,C_word *av) C_noret;
C_noret_decl(f_2755)
static void C_ccall f_2755(C_word c,C_word *av) C_noret;
C_noret_decl(f_2758)
static void C_ccall f_2758(C_word c,C_word *av) C_noret;
C_noret_decl(f_2761)
static void C_ccall f_2761(C_word c,C_word *av) C_noret;
C_noret_decl(f_2764)
static void C_ccall f_2764(C_word c,C_word *av) C_noret;
C_noret_decl(f_2770)
static void C_ccall f_2770(C_word c,C_word *av) C_noret;
C_noret_decl(f_2789)
static void C_ccall f_2789(C_word c,C_word *av) C_noret;
C_noret_decl(f_2793)
static void C_ccall f_2793(C_word c,C_word *av) C_noret;
C_noret_decl(f_2797)
static void C_ccall f_2797(C_word c,C_word *av) C_noret;
C_noret_decl(f_2815)
static void C_ccall f_2815(C_word c,C_word *av) C_noret;
C_noret_decl(f_2819)
static void C_ccall f_2819(C_word c,C_word *av) C_noret;
C_noret_decl(f_2823)
static void C_ccall f_2823(C_word c,C_word *av) C_noret;
C_noret_decl(f_2827)
static void C_ccall f_2827(C_word c,C_word *av) C_noret;
C_noret_decl(f_2843)
static void C_ccall f_2843(C_word c,C_word *av) C_noret;
C_noret_decl(f_2846)
static void C_ccall f_2846(C_word c,C_word *av) C_noret;
C_noret_decl(f_2874)
static void C_ccall f_2874(C_word c,C_word *av) C_noret;
C_noret_decl(f_2878)
static void C_ccall f_2878(C_word c,C_word *av) C_noret;
C_noret_decl(f_2882)
static void C_ccall f_2882(C_word c,C_word *av) C_noret;
C_noret_decl(f_2901)
static void C_ccall f_2901(C_word c,C_word *av) C_noret;
C_noret_decl(f_2905)
static void C_ccall f_2905(C_word c,C_word *av) C_noret;
C_noret_decl(f_2909)
static void C_ccall f_2909(C_word c,C_word *av) C_noret;
C_noret_decl(f_2927)
static void C_ccall f_2927(C_word c,C_word *av) C_noret;
C_noret_decl(f_2931)
static void C_ccall f_2931(C_word c,C_word *av) C_noret;
C_noret_decl(f_2935)
static void C_ccall f_2935(C_word c,C_word *av) C_noret;
C_noret_decl(f_2951)
static void C_ccall f_2951(C_word c,C_word *av) C_noret;
C_noret_decl(f_2955)
static void C_ccall f_2955(C_word c,C_word *av) C_noret;
C_noret_decl(f_2959)
static void C_ccall f_2959(C_word c,C_word *av) C_noret;
C_noret_decl(f_2968)
static void C_ccall f_2968(C_word c,C_word *av) C_noret;
C_noret_decl(f_2974)
static void C_ccall f_2974(C_word c,C_word *av) C_noret;
C_noret_decl(f_2982)
static void C_ccall f_2982(C_word c,C_word *av) C_noret;
C_noret_decl(f_2988)
static void C_ccall f_2988(C_word c,C_word *av) C_noret;
C_noret_decl(f_2999)
static void C_ccall f_2999(C_word c,C_word *av) C_noret;
C_noret_decl(f_3025)
static void f_3025(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3029)
static void C_ccall f_3029(C_word c,C_word *av) C_noret;
C_noret_decl(f_3043)
static void C_ccall f_3043(C_word c,C_word *av) C_noret;
C_noret_decl(f_3049)
static void C_ccall f_3049(C_word c,C_word *av) C_noret;
C_noret_decl(f_3056)
static void C_ccall f_3056(C_word c,C_word *av) C_noret;
C_noret_decl(f_3059)
static void C_ccall f_3059(C_word c,C_word *av) C_noret;
C_noret_decl(f_3063)
static void C_ccall f_3063(C_word c,C_word *av) C_noret;
C_noret_decl(f_3066)
static void C_ccall f_3066(C_word c,C_word *av) C_noret;
C_noret_decl(f_3073)
static void C_ccall f_3073(C_word c,C_word *av) C_noret;
C_noret_decl(f_3077)
static void C_ccall f_3077(C_word c,C_word *av) C_noret;
C_noret_decl(f_3081)
static void C_ccall f_3081(C_word c,C_word *av) C_noret;
C_noret_decl(f_3094)
static void C_ccall f_3094(C_word c,C_word *av) C_noret;
C_noret_decl(f_3098)
static void C_ccall f_3098(C_word c,C_word *av) C_noret;
C_noret_decl(f_3102)
static void C_ccall f_3102(C_word c,C_word *av) C_noret;
C_noret_decl(f_3110)
static void C_ccall f_3110(C_word c,C_word *av) C_noret;
C_noret_decl(f_3116)
static void C_ccall f_3116(C_word c,C_word *av) C_noret;
C_noret_decl(f_3125)
static void C_ccall f_3125(C_word c,C_word *av) C_noret;
C_noret_decl(f_3128)
static void C_ccall f_3128(C_word c,C_word *av) C_noret;
C_noret_decl(f_3141)
static void C_ccall f_3141(C_word c,C_word *av) C_noret;
C_noret_decl(f_3145)
static void C_ccall f_3145(C_word c,C_word *av) C_noret;
C_noret_decl(f_3149)
static void C_ccall f_3149(C_word c,C_word *av) C_noret;
C_noret_decl(f_3165)
static void C_ccall f_3165(C_word c,C_word *av) C_noret;
C_noret_decl(f_3169)
static void C_ccall f_3169(C_word c,C_word *av) C_noret;
C_noret_decl(f_3173)
static void C_ccall f_3173(C_word c,C_word *av) C_noret;
C_noret_decl(f_3181)
static void C_ccall f_3181(C_word c,C_word *av) C_noret;
C_noret_decl(f_3194)
static void C_ccall f_3194(C_word c,C_word *av) C_noret;
C_noret_decl(f_3204)
static void C_ccall f_3204(C_word c,C_word *av) C_noret;
C_noret_decl(f_3208)
static void C_ccall f_3208(C_word c,C_word *av) C_noret;
C_noret_decl(f_3212)
static void C_ccall f_3212(C_word c,C_word *av) C_noret;
C_noret_decl(f_3220)
static void C_ccall f_3220(C_word c,C_word *av) C_noret;
C_noret_decl(f_3230)
static void C_ccall f_3230(C_word c,C_word *av) C_noret;
C_noret_decl(f_3236)
static void C_ccall f_3236(C_word c,C_word *av) C_noret;
C_noret_decl(f_3247)
static void C_ccall f_3247(C_word c,C_word *av) C_noret;
C_noret_decl(f_3251)
static void C_ccall f_3251(C_word c,C_word *av) C_noret;
C_noret_decl(f_3255)
static void C_ccall f_3255(C_word c,C_word *av) C_noret;
C_noret_decl(f_3259)
static void C_ccall f_3259(C_word c,C_word *av) C_noret;
C_noret_decl(C_tcp_toplevel)
C_extern void C_ccall C_tcp_toplevel(C_word c,C_word *av) C_noret;

C_noret_decl(trf_1326)
static void C_ccall trf_1326(C_word c,C_word *av) C_noret;
static void C_ccall trf_1326(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_1326(t0,t1,t2,t3);}

C_noret_decl(trf_1358)
static void C_ccall trf_1358(C_word c,C_word *av) C_noret;
static void C_ccall trf_1358(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_1358(t0,t1,t2);}

C_noret_decl(trf_1390)
static void C_ccall trf_1390(C_word c,C_word *av) C_noret;
static void C_ccall trf_1390(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1390(t0,t1);}

C_noret_decl(trf_1565)
static void C_ccall trf_1565(C_word c,C_word *av) C_noret;
static void C_ccall trf_1565(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1565(t0,t1);}

C_noret_decl(trf_1696)
static void C_ccall trf_1696(C_word c,C_word *av) C_noret;
static void C_ccall trf_1696(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1696(t0,t1);}

C_noret_decl(trf_1727)
static void C_ccall trf_1727(C_word c,C_word *av) C_noret;
static void C_ccall trf_1727(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_1727(t0,t1,t2,t3,t4);}

C_noret_decl(trf_1744)
static void C_ccall trf_1744(C_word c,C_word *av) C_noret;
static void C_ccall trf_1744(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1744(t0,t1);}

C_noret_decl(trf_1751)
static void C_ccall trf_1751(C_word c,C_word *av) C_noret;
static void C_ccall trf_1751(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1751(t0,t1);}

C_noret_decl(trf_1842)
static void C_ccall trf_1842(C_word c,C_word *av) C_noret;
static void C_ccall trf_1842(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_1842(t0,t1,t2,t3);}

C_noret_decl(trf_1863)
static void C_ccall trf_1863(C_word c,C_word *av) C_noret;
static void C_ccall trf_1863(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_1863(t0,t1);}

C_noret_decl(trf_1865)
static void C_ccall trf_1865(C_word c,C_word *av) C_noret;
static void C_ccall trf_1865(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_1865(t0,t1,t2,t3,t4);}

C_noret_decl(trf_1986)
static void C_ccall trf_1986(C_word c,C_word *av) C_noret;
static void C_ccall trf_1986(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_1986(t0,t1,t2,t3);}

C_noret_decl(trf_1992)
static void C_ccall trf_1992(C_word c,C_word *av) C_noret;
static void C_ccall trf_1992(C_word c,C_word *av){
C_word t0=av[3];
C_word t1=av[2];
C_word t2=av[1];
C_word t3=av[0];
f_1992(t0,t1,t2,t3);}

C_noret_decl(trf_2105)
static void C_ccall trf_2105(C_word c,C_word *av) C_noret;
static void C_ccall trf_2105(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_2105(t0,t1);}

C_noret_decl(trf_2108)
static void C_ccall trf_2108(C_word c,C_word *av) C_noret;
static void C_ccall trf_2108(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_2108(t0,t1);}

C_noret_decl(trf_2114)
static void C_ccall trf_2114(C_word c,C_word *av) C_noret;
static void C_ccall trf_2114(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_2114(t0,t1);}

C_noret_decl(trf_2258)
static void C_ccall trf_2258(C_word c,C_word *av) C_noret;
static void C_ccall trf_2258(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_2258(t0,t1);}

C_noret_decl(trf_2264)
static void C_ccall trf_2264(C_word c,C_word *av) C_noret;
static void C_ccall trf_2264(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_2264(t0,t1);}

C_noret_decl(trf_2334)
static void C_ccall trf_2334(C_word c,C_word *av) C_noret;
static void C_ccall trf_2334(C_word c,C_word *av){
C_word t0=av[4];
C_word t1=av[3];
C_word t2=av[2];
C_word t3=av[1];
C_word t4=av[0];
f_2334(t0,t1,t2,t3,t4);}

C_noret_decl(trf_2577)
static void C_ccall trf_2577(C_word c,C_word *av) C_noret;
static void C_ccall trf_2577(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_2577(t0,t1);}

C_noret_decl(trf_2734)
static void C_ccall trf_2734(C_word c,C_word *av) C_noret;
static void C_ccall trf_2734(C_word c,C_word *av){
C_word t0=av[1];
C_word t1=av[0];
f_2734(t0,t1);}

C_noret_decl(trf_3025)
static void C_ccall trf_3025(C_word c,C_word *av) C_noret;
static void C_ccall trf_3025(C_word c,C_word *av){
C_word t0=av[2];
C_word t1=av[1];
C_word t2=av[0];
f_3025(t0,t1,t2);}

/* f3609 in loop in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f3609(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f3609,c,av);}
/* tcp.scm:651: ##sys#thread-yield! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[35]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[35]+1);
av2[1]=((C_word*)t0)[2];
tp(2,av2);}}

/* k1063 */
static void C_ccall f_1065(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void *)f_1065,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1068,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);{
C_word *av2=av;
av2[0]=C_SCHEME_UNDEFINED;
av2[1]=t2;
C_scheduler_toplevel(2,av2);}}

/* k1066 in k1063 */
static void C_ccall f_1068(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(19,c,2)))){
C_save_and_reclaim((void *)f_1068,c,av);}
a=C_alloc(19);
t2=C_a_i_provide(&a,1,lf[0]);
t3=C_a_i_provide(&a,1,lf[1]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1071,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);{
C_word *av2=av;
av2[0]=C_SCHEME_UNDEFINED;
av2[1]=t4;
C_library_toplevel(2,av2);}}

/* k1069 in k1066 in k1063 */
static void C_ccall f_1071(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,3)))){
C_save_and_reclaim((void *)f_1071,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1299,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep(stub255(C_SCHEME_UNDEFINED))){
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_1299(2,av2);}}
else{
/* tcp.scm:238: ##sys#signal-hook */
t3=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[7];
av2[3]=lf[111];
((C_proc)(void*)(*((C_word*)t3+1)))(4,av2);}}}

/* k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1299(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,c,5)))){
C_save_and_reclaim((void *)f_1299,c,av);}
a=C_alloc(15);
t2=C_mutate(&lf[2] /* (set! chicken.tcp#gethostaddr ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1326,a[2]=((C_word)li0),tmp=(C_word)a,a+=3,tmp));
t3=C_mutate((C_word*)lf[4]+1 /* (set! chicken.tcp#tcp-listen ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1540,a[2]=((C_word)li1),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[22]+1 /* (set! chicken.tcp#tcp-listener? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1639,a[2]=((C_word)li2),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[23]+1 /* (set! chicken.tcp#tcp-close ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1648,a[2]=((C_word)li3),tmp=(C_word)a,a+=3,tmp));
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1690,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* tcp.scm:346: scheme#make-parameter */
t7=*((C_word*)lf[106]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t7;
av2[1]=t6;
av2[2]=C_SCHEME_FALSE;
((C_proc)(void*)(*((C_word*)t7+1)))(3,av2);}}

/* k1304 in k1385 in k1381 in loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1306(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_1306,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1310,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)t0)[3])){
/* tcp.scm:241: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[3]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[3]+1);
av2[1]=t2;
av2[2]=C_i_foreign_string_argumentp(((C_word*)t0)[3]);
tp(3,av2);}}
else{
t3=((C_word*)t0)[2];
f_1390(t3,stub260(C_SCHEME_UNDEFINED,t1,C_SCHEME_FALSE));}}

/* k1308 in k1304 in k1385 in k1381 in loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1310(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1310,c,av);}
t2=((C_word*)t0)[2];
f_1390(t2,stub260(C_SCHEME_UNDEFINED,((C_word*)t0)[3],t1));}

/* chicken.tcp#gethostaddr in k1297 in k1069 in k1066 in k1063 */
static void f_1326(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_1326,4,t1,t2,t3,t4);}
a=C_alloc(5);
t5=C_i_foreign_block_argumentp(t2);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1335,a[2]=t1,a[3]=t5,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
if(C_truep(t3)){
/* tcp.scm:247: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[3]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[3]+1);
av2[1]=t6;
av2[2]=C_i_foreign_string_argumentp(t3);
tp(3,av2);}}
else{
t7=C_fix((C_word)sizeof(unsigned short) * CHAR_BIT);
t8=t1;{
C_word av2[2];
av2[0]=t8;
av2[1]=stub272(C_SCHEME_UNDEFINED,t5,C_SCHEME_FALSE,C_i_foreign_unsigned_ranged_integer_argumentp(t4,t7));
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}

/* k1333 in chicken.tcp#gethostaddr in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1335(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1335,c,av);}
t2=C_fix((C_word)sizeof(unsigned short) * CHAR_BIT);
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=stub272(C_SCHEME_UNDEFINED,((C_word*)t0)[3],t1,C_i_foreign_unsigned_ranged_integer_argumentp(((C_word*)t0)[4],t2));
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1358(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(6,0,4)))){
C_save_and_reclaim_args((void *)trf_1358,3,t0,t1,t2);}
a=C_alloc(6);
if(C_truep(C_fixnum_greater_or_equal_p(t2,((C_word*)t0)[2]))){
/* tcp.scm:283: scheme#values */{
C_word av2[4];
av2[0]=0;
av2[1]=t1;
av2[2]=((C_word*)t0)[3];
av2[3]=C_SCHEME_FALSE;
C_values(4,av2);}}
else{
t3=C_i_string_ref(((C_word*)t0)[3],t2);
if(C_truep(C_u_i_char_equalp(t3,C_make_character(58)))){
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1383,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
/* tcp.scm:287: substring */
t5=*((C_word*)lf[86]+1);{
C_word av2[5];
av2[0]=t5;
av2[1]=t4;
av2[2]=((C_word*)t0)[3];
av2[3]=C_fixnum_plus(t2,C_fix(1));
av2[4]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t5+1)))(5,av2);}}
else{
/* tcp.scm:293: loop */
t6=t1;
t7=C_fixnum_plus(t2,C_fix(1));
t1=t6;
t2=t7;
goto loop;}}}

/* k1381 in loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1383(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,4)))){
C_save_and_reclaim((void *)f_1383,c,av);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1387,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* tcp.scm:288: substring */
t3=*((C_word*)lf[86]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=((C_word*)t0)[4];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t3+1)))(5,av2);}}

/* k1385 in k1381 in loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1387(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_1387,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1390,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1306,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
if(C_truep(t1)){
/* tcp.scm:241: ##sys#make-c-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[3]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[3]+1);
av2[1]=t3;
av2[2]=C_i_foreign_string_argumentp(t1);
tp(3,av2);}}
else{
t4=t3;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_FALSE;
f_1306(2,av2);}}}

/* k1388 in k1385 in k1381 in loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1390(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,0,3)))){
C_save_and_reclaim_args((void *)trf_1390,2,t0,t1);}
a=C_alloc(12);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1393,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t3=C_eqp(C_fix(0),t1);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1403,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1407,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t5;
av2[2]=lf[85];
av2[3]=lf[13];
tp(4,av2);}}
else{
/* tcp.scm:286: scheme#values */{
C_word av2[4];
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
C_values(4,av2);}}}

/* k1391 in k1388 in k1385 in k1381 in loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1393(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1393,c,av);}
/* tcp.scm:286: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
C_values(4,av2);}}

/* k1401 in k1388 in k1385 in k1381 in loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1403(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_1403,c,av);}
/* tcp.scm:291: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[75];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k1405 in k1388 in k1385 in k1381 in loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1407(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_1407,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1411,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k1409 in k1405 in k1388 in k1385 in k1381 in loop in a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1411(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1411,c,av);}
/* tcp.scm:291: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1446(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,4)))){
C_save_and_reclaim((void *)f_1446,c,av);}
a=C_alloc(12);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1449,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t0)[4])){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1531,a[2]=t2,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* tcp.scm:306: gethostaddr */
f_1326(t3,t1,((C_word*)t0)[4],((C_word*)t0)[5]);}
else{
t3=C_i_foreign_block_argumentp(t1);
t4=C_fix((C_word)sizeof(unsigned short) * CHAR_BIT);
t5=t2;{
C_word *av2=av;
av2[0]=t5;
av2[1]=stub404(C_SCHEME_UNDEFINED,t3,C_i_foreign_unsigned_ranged_integer_argumentp(((C_word*)t0)[5],t4));
f_1449(2,av2);}}}

/* k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1449(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_1449,c,av);}
a=C_alloc(7);
t2=C_fix((C_word)AF_INET);
t3=stub135(C_SCHEME_UNDEFINED,C_i_foreign_fixnum_argumentp(t2),C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]),C_fix(0));
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1455,a[2]=((C_word*)t0)[3],a[3]=t3,a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
t5=C_eqp(C_fix((C_word)INVALID_SOCKET),t3);
if(C_truep(t5)){
/* tcp.scm:313: ##sys#error */
t6=*((C_word*)lf[16]+1);{
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=t6;
av2[1]=t4;
av2[2]=lf[17];
((C_proc)(void*)(*((C_word*)t6+1)))(3,av2);}}
else{
t6=t4;{
C_word *av2=av;
av2[0]=t6;
av2[1]=C_SCHEME_UNDEFINED;
f_1455(2,av2);}}}

/* k1453 in k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1455(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,3)))){
C_save_and_reclaim((void *)f_1455,c,av);}
a=C_alloc(14);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1458,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
t3=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
t4=C_eqp(C_fix((C_word)SOCKET_ERROR),stub214(C_SCHEME_UNDEFINED,t3));
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1501,a[2]=t2,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1505,a[2]=t5,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t6;
av2[2]=lf[15];
av2[3]=lf[13];
tp(4,av2);}}
else{
t5=t2;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_UNDEFINED;
f_1458(2,av2);}}}

/* k1456 in k1453 in k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1458(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(14,c,3)))){
C_save_and_reclaim((void *)f_1458,c,av);}
a=C_alloc(14);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1461,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=C_fix((C_word)sizeof(struct sockaddr_in));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
t5=(C_truep(((C_word*)t0)[4])?C_i_foreign_block_argumentp(((C_word*)t0)[4]):C_SCHEME_FALSE);
t6=C_i_foreign_fixnum_argumentp(t3);
t7=C_eqp(C_fix((C_word)SOCKET_ERROR),stub144(C_SCHEME_UNDEFINED,t4,t5,t6));
if(C_truep(t7)){
t8=stub114(C_SCHEME_UNDEFINED);
t9=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
t10=stub173(C_SCHEME_UNDEFINED,t9);
t11=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1477,a[2]=t2,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
t12=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1481,a[2]=t11,a[3]=t8,tmp=(C_word)a,a+=4,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t12;
av2[2]=lf[14];
av2[3]=lf[13];
tp(4,av2);}}
else{
t8=((C_word*)t0)[2];
f_1565(t8,((C_word*)t0)[3]);}}

/* k1459 in k1456 in k1453 in k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1461(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1461,c,av);}
t2=((C_word*)t0)[2];
f_1565(t2,((C_word*)t0)[3]);}

/* k1475 in k1456 in k1453 in k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1477(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,7)))){
C_save_and_reclaim((void *)f_1477,c,av);}
/* tcp.scm:318: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 8) {
  av2=av;
} else {
  av2=C_alloc(8);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[8];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
av2[6]=((C_word*)t0)[4];
av2[7]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t2+1)))(8,av2);}}

/* k1479 in k1456 in k1453 in k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1481(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_1481,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1485,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
/* tcp.scm:172: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub118(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k1483 in k1479 in k1456 in k1453 in k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1485(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1485,c,av);}
/* tcp.scm:318: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k1499 in k1453 in k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1501(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_1501,c,av);}
/* tcp.scm:316: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[8];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k1503 in k1453 in k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1505(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_1505,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1509,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k1507 in k1503 in k1453 in k1447 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1509(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1509,c,av);}
/* tcp.scm:316: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k1529 in k1444 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1531(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_1531,c,av);}
if(C_truep(t1)){
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
f_1449(2,av2);}}
else{
/* tcp.scm:307: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[8];
av2[4]=lf[18];
av2[5]=((C_word*)t0)[3];
av2[6]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(7,av2);}}}

/* chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1540(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,5)))){
C_save_and_reclaim((void *)f_1540,c,av);}
a=C_alloc(6);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?C_fix(100):C_get_rest_arg(c,3,av,3,t0));
t5=C_rest_nullp(c,3);
t6=C_rest_nullp(c,4);
t7=(C_truep(t6)?C_SCHEME_FALSE:C_get_rest_arg(c,4,av,3,t0));
t8=C_rest_nullp(c,4);
t9=C_i_check_fixnum(t2);
t10=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1559,a[2]=t4,a[3]=t1,a[4]=t2,a[5]=t7,tmp=(C_word)a,a+=6,tmp);
t11=C_fixnum_lessp(t2,C_fix(0));
if(C_truep(t11)){
if(C_truep(t11)){
/* tcp.scm:326: ##sys#signal-hook */
t12=*((C_word*)lf[6]+1);{
C_word av2[6];
av2[0]=t12;
av2[1]=t10;
av2[2]=lf[20];
av2[3]=lf[8];
av2[4]=lf[21];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t12+1)))(6,av2);}}
else{
t12=t10;{
C_word *av2=av;
av2[0]=t12;
av2[1]=C_SCHEME_UNDEFINED;
f_1559(2,av2);}}}
else{
if(C_truep(C_fixnum_greaterp(t2,C_fix(65535)))){
/* tcp.scm:326: ##sys#signal-hook */
t12=*((C_word*)lf[6]+1);{
C_word av2[6];
av2[0]=t12;
av2[1]=t10;
av2[2]=lf[20];
av2[3]=lf[8];
av2[4]=lf[21];
av2[5]=t2;
((C_proc)(void*)(*((C_word*)t12+1)))(6,av2);}}
else{
t12=t10;{
C_word *av2=av;
av2[0]=t12;
av2[1]=C_SCHEME_UNDEFINED;
f_1559(2,av2);}}}}

/* k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1559(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_1559,c,av);}
a=C_alloc(11);
t2=C_i_check_fixnum(((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1565,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t4=C_fix((C_word)SOCK_STREAM);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1446,a[2]=t4,a[3]=t3,a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t6=C_fix((C_word)sizeof(struct sockaddr_in));
/* ##sys#make-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[19]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[19]+1);
av2[1]=t5;
av2[2]=t6;
av2[3]=C_make_character(32);
tp(4,av2);}}

/* k1563 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void f_1565(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,0,3)))){
C_save_and_reclaim_args((void *)trf_1565,2,t0,t1);}
a=C_alloc(13);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1568,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_i_foreign_fixnum_argumentp(t1);
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
t5=C_eqp(C_fix((C_word)SOCKET_ERROR),stub154(C_SCHEME_UNDEFINED,t3,t4));
if(C_truep(t5)){
t6=stub114(C_SCHEME_UNDEFINED);
t7=C_i_foreign_fixnum_argumentp(t1);
t8=stub173(C_SCHEME_UNDEFINED,t7);
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1587,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1591,a[2]=t9,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t10;
av2[2]=lf[12];
av2[3]=lf[13];
tp(4,av2);}}
else{
t6=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t6;
av2[1]=C_a_i_record2(&a,2,lf[5],t1);
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}}

/* k1566 in k1563 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1568(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,1)))){
C_save_and_reclaim((void *)f_1568,c,av);}
a=C_alloc(3);
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_a_i_record2(&a,2,lf[5],((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k1585 in k1563 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1587(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_1587,c,av);}
/* tcp.scm:330: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[8];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
av2[6]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(7,av2);}}

/* k1589 in k1563 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1591(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_1591,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1595,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
/* tcp.scm:172: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub118(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k1593 in k1589 in k1563 in k1557 in chicken.tcp#tcp-listen in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1595(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1595,c,av);}
/* tcp.scm:330: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* chicken.tcp#tcp-listener? in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1639(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1639,c,av);}
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=(C_truep(C_blockp(t2))?C_i_structurep(t2,lf[5]):C_SCHEME_FALSE);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* chicken.tcp#tcp-close in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1648(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_1648,c,av);}
a=C_alloc(7);
t3=C_i_check_structure(t2,lf[5]);
t4=C_slot(t2,C_fix(1));
t5=C_i_foreign_fixnum_argumentp(t4);
t6=C_eqp(C_fix((C_word)SOCKET_ERROR),stub173(C_SCHEME_UNDEFINED,t5));
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1668,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1672,a[2]=t7,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t8;
av2[2]=lf[25];
av2[3]=lf[13];
tp(4,av2);}}
else{
t7=C_SCHEME_UNDEFINED;
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}

/* k1666 in chicken.tcp#tcp-close in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1668(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_1668,c,av);}
/* tcp.scm:341: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[24];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k1670 in chicken.tcp#tcp-close in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1672(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_1672,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1676,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k1674 in k1670 in chicken.tcp#tcp-close in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1676(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1676,c,av);}
/* tcp.scm:341: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1690(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(16,c,3)))){
C_save_and_reclaim((void *)f_1690,c,av);}
a=C_alloc(16);
t2=C_mutate((C_word*)lf[26]+1 /* (set! chicken.tcp#tcp-buffer-size ...) */,t1);
t3=C_set_block_item(lf[27] /* chicken.tcp#tcp-read-timeout */,0,C_SCHEME_UNDEFINED);
t4=C_set_block_item(lf[28] /* chicken.tcp#tcp-write-timeout */,0,C_SCHEME_UNDEFINED);
t5=C_set_block_item(lf[29] /* chicken.tcp#tcp-connect-timeout */,0,C_SCHEME_UNDEFINED);
t6=C_set_block_item(lf[30] /* chicken.tcp#tcp-accept-timeout */,0,C_SCHEME_UNDEFINED);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_SCHEME_UNDEFINED;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1696,a[2]=((C_word)li5),tmp=(C_word)a,a+=3,tmp));
t12=C_fixnum_times(C_fix(60),C_fix(1000));
t13=C_set_block_item(t10,0,t12);
t14=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1713,a[2]=((C_word*)t0)[2],a[3]=t8,a[4]=t10,tmp=(C_word)a,a+=5,tmp);
t15=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3259,a[2]=t14,a[3]=t10,tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:357: check */
f_1696(t15,lf[110]);}

/* check in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1696(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,3)))){
C_save_and_reclaim_args((void *)trf_1696,2,t1,t2);}
a=C_alloc(4);
t3=t1;{
C_word av2[2];
av2[0]=t3;
av2[1]=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1698,a[2]=t2,a[3]=((C_word)li4),tmp=(C_word)a,a+=4,tmp);
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* f_1698 in check in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1698(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1698,c,av);}
if(C_truep(t2)){
t3=C_i_check_fixnum_2(t2,((C_word*)t0)[2]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}}

/* k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1713(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_1713,c,av);}
a=C_alloc(8);
t2=C_mutate((C_word*)lf[27]+1 /* (set! chicken.tcp#tcp-read-timeout ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1717,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3255,a[2]=t3,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:358: check */
f_1696(t4,lf[109]);}

/* k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1717(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_1717,c,av);}
a=C_alloc(7);
t2=C_mutate((C_word*)lf[28]+1 /* (set! chicken.tcp#tcp-write-timeout ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1721,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3251,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* tcp.scm:359: check */
f_1696(t4,lf[108]);}

/* k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1721(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_1721,c,av);}
a=C_alloc(6);
t2=C_mutate((C_word*)lf[29]+1 /* (set! chicken.tcp#tcp-connect-timeout ...) */,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1725,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3247,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* tcp.scm:360: check */
f_1696(t4,lf[107]);}

/* k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1725(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(31,c,5)))){
C_save_and_reclaim((void *)f_1725,c,av);}
a=C_alloc(31);
t2=C_mutate((C_word*)lf[30]+1 /* (set! chicken.tcp#tcp-accept-timeout ...) */,t1);
t3=*((C_word*)lf[26]+1);
t4=C_mutate(&lf[31] /* (set! chicken.tcp#io-ports ...) */,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1727,a[2]=t3,a[3]=((C_word)li31),tmp=(C_word)a,a+=4,tmp));
t5=C_mutate((C_word*)lf[66]+1 /* (set! chicken.tcp#tcp-accept ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2561,a[2]=((C_word)li33),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[71]+1 /* (set! chicken.tcp#tcp-accept-ready? ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2665,a[2]=((C_word)li34),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[74]+1 /* (set! chicken.tcp#tcp-connect ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2715,a[2]=((C_word)li39),tmp=(C_word)a,a+=3,tmp));
t8=C_mutate(&lf[87] /* (set! chicken.tcp#tcp-port->fileno ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3025,a[2]=((C_word)li40),tmp=(C_word)a,a+=3,tmp));
t9=C_mutate((C_word*)lf[91]+1 /* (set! chicken.tcp#tcp-addresses ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3043,a[2]=((C_word)li41),tmp=(C_word)a,a+=3,tmp));
t10=C_mutate((C_word*)lf[95]+1 /* (set! chicken.tcp#tcp-port-numbers ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3110,a[2]=((C_word)li42),tmp=(C_word)a,a+=3,tmp));
t11=C_mutate((C_word*)lf[99]+1 /* (set! chicken.tcp#tcp-listener-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3181,a[2]=((C_word)li43),tmp=(C_word)a,a+=3,tmp));
t12=C_mutate((C_word*)lf[102]+1 /* (set! chicken.tcp#tcp-abandon-port ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3220,a[2]=((C_word)li44),tmp=(C_word)a,a+=3,tmp));
t13=C_mutate((C_word*)lf[104]+1 /* (set! chicken.tcp#tcp-listener-fileno ...) */,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3236,a[2]=((C_word)li45),tmp=(C_word)a,a+=3,tmp));
t14=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t14;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t14+1)))(2,av2);}}

/* chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1727(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(15,0,3)))){
C_save_and_reclaim_args((void *)trf_1727,5,t0,t1,t2,t3,t4);}
a=C_alloc(15);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1731,a[2]=t3,a[3]=t4,a[4]=t1,a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
if(C_truep(make_socket_nonblocking(t3))){
t6=t5;{
C_word av2[2];
av2[0]=t6;
av2[1]=C_SCHEME_UNDEFINED;
f_1731(2,av2);}}
else{
t6=stub114(C_SCHEME_UNDEFINED);
t7=C_i_foreign_fixnum_argumentp(t3);
t8=stub173(C_SCHEME_UNDEFINED,t7);
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2549,a[2]=t5,a[3]=t2,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2553,a[2]=t9,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t10;
av2[2]=lf[65];
av2[3]=lf[13];
tp(4,av2);}}}

/* k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1731(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_1731,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1734,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* tcp.scm:367: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[46]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[46]+1);
av2[1]=t2;
av2[2]=C_fix(1024);
tp(3,av2);}}

/* k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1734(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(25,c,2)))){
C_save_and_reclaim((void *)f_1734,c,av);}
a=C_alloc(25);
t2=C_a_i_vector5(&a,5,((C_word*)t0)[2],C_SCHEME_FALSE,C_SCHEME_FALSE,t1,C_fix(0));
t3=C_fix(0);
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_fix(0);
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_SCHEME_FALSE;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_SCHEME_FALSE;
t10=(*a=C_VECTOR_TYPE|1,a[1]=t9,tmp=(C_word)a,a+=2,tmp);
t11=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_1740,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t4,a[5]=t2,a[6]=t6,a[7]=t10,a[8]=t8,a[9]=((C_word*)t0)[3],a[10]=((C_word*)t0)[4],tmp=(C_word)a,a+=11,tmp);
/* tcp.scm:373: tbs */
t12=((C_word*)t0)[5];{
C_word *av2=av;
av2[0]=t12;
av2[1]=t11;
((C_proc)(void*)(*((C_word*)t12+1)))(2,av2);}}

/* k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1740(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,2)))){
C_save_and_reclaim((void *)f_1740,c,av);}
a=C_alloc(12);
t2=(*a=C_CLOSURE_TYPE|11,a[1]=(C_word)f_1743,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t1,a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],a[10]=((C_word*)t0)[9],a[11]=((C_word*)t0)[10],tmp=(C_word)a,a+=12,tmp);
if(C_truep(t1)){
if(C_truep(C_fixnum_greaterp(t1,C_fix(0)))){
/* tcp.scm:376: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[46]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[46]+1);
av2[1]=t2;
av2[2]=t1;
tp(3,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
f_1743(2,av2);}}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_FALSE;
f_1743(2,av2);}}}

/* k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1743(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(73,c,12)))){
C_save_and_reclaim((void *)f_1743,c,av);}
a=C_alloc(73);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_1744,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word)li7),tmp=(C_word)a,a+=8,tmp);
t3=C_SCHEME_FALSE;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=(*a=C_CLOSURE_TYPE|11,a[1]=(C_word)f_1841,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],a[5]=t1,a[6]=((C_word*)t0)[8],a[7]=((C_word*)t0)[9],a[8]=((C_word*)t0)[5],a[9]=t4,a[10]=((C_word*)t0)[10],a[11]=((C_word*)t0)[11],tmp=(C_word)a,a+=12,tmp);
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2176,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=t4,a[5]=((C_word*)t0)[3],a[6]=t2,a[7]=((C_word)li19),tmp=(C_word)a,a+=8,tmp);
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2208,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],a[5]=((C_word)li20),tmp=(C_word)a,a+=6,tmp);
t8=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2250,a[2]=((C_word*)t0)[9],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[8],a[5]=((C_word*)t0)[5],a[6]=((C_word)li21),tmp=(C_word)a,a+=7,tmp);
t9=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2300,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=t4,a[5]=((C_word*)t0)[3],a[6]=t2,a[7]=((C_word)li23),tmp=(C_word)a,a+=8,tmp);
t10=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2328,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=((C_word)li25),tmp=(C_word)a,a+=7,tmp);
t11=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2389,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=t2,a[6]=t4,a[7]=((C_word)li29),tmp=(C_word)a,a+=8,tmp);
t12=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2512,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[3],a[5]=t4,a[6]=((C_word)li30),tmp=(C_word)a,a+=7,tmp);
/* tcp.scm:405: chicken.port#make-input-port */
t13=*((C_word*)lf[60]+1);{
C_word *av2;
if(c >= 13) {
  av2=av;
} else {
  av2=C_alloc(13);
}
av2[0]=t13;
av2[1]=t5;
av2[2]=t6;
av2[3]=t7;
av2[4]=t8;
av2[5]=lf[61];
av2[6]=t9;
av2[7]=lf[62];
av2[8]=t10;
av2[9]=lf[63];
av2[10]=t11;
av2[11]=lf[64];
av2[12]=t12;
((C_proc)(void*)(*((C_word*)t13+1)))(13,av2);}}

/* read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1744(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,2)))){
C_save_and_reclaim_args((void *)trf_1744,2,t0,t1);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_1748,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=t1,tmp=(C_word)a,a+=8,tmp);
/* tcp.scm:379: tcp-read-timeout */
t3=*((C_word*)lf[27]+1);{
C_word av2[2];
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1748(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,2)))){
C_save_and_reclaim((void *)f_1748,c,av);}
a=C_alloc(13);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_1751,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
if(C_truep(t1)){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1838,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:380: chicken.time#current-process-milliseconds */
t4=*((C_word*)lf[41]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=t2;
f_1751(t3,C_SCHEME_FALSE);}}

/* k1749 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1751(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,0,2)))){
C_save_and_reclaim_args((void *)trf_1751,2,t0,t1);}
a=C_alloc(13);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_1756,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=((C_word*)t0)[4],a[6]=t1,a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],a[9]=((C_word*)t0)[7],a[10]=((C_word)li6),tmp=(C_word)a,a+=11,tmp));
t5=((C_word*)t3)[1];{
C_word av2[2];
av2[0]=t5;
av2[1]=((C_word*)t0)[8];
f_1756(2,av2);}}

/* loop in k1749 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1756(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,3)))){
C_save_and_reclaim((void *)f_1756,c,av);}
a=C_alloc(7);
t2=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t3=(C_truep(((C_word*)t0)[3])?C_i_foreign_block_argumentp(((C_word*)t0)[3]):C_SCHEME_FALSE);
t4=C_fix(1024);
t5=C_fix(0);
t6=stub181(C_SCHEME_UNDEFINED,t2,t3,t4,t5);
t7=C_eqp(C_fix((C_word)SOCKET_ERROR),t6);
if(C_truep(t7)){
if(C_truep(stub123(C_SCHEME_UNDEFINED))){
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1775,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[2],tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)t0)[6])){
/* tcp.scm:386: ##sys#thread-block-for-timeout! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[38]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[38]+1);
av2[1]=t8;
av2[2]=*((C_word*)lf[32]+1);
av2[3]=((C_word*)t0)[6];
tp(4,av2);}}
else{
t9=t8;{
C_word *av2=av;
av2[0]=t9;
av2[1]=C_SCHEME_UNDEFINED;
f_1775(2,av2);}}}
else{
if(C_truep(stub129(C_SCHEME_UNDEFINED))){
/* tcp.scm:396: ##sys#dispatch-interrupt */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[39]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[39]+1);
av2[1]=t1;
av2[2]=((C_word*)((C_word*)t0)[4])[1];
tp(3,av2);}}
else{
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1812,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1816,a[2]=t8,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t9;
av2[2]=lf[40];
av2[3]=lf[13];
tp(4,av2);}}}}
else{
t8=C_set_block_item(((C_word*)t0)[7],0,t6);
t9=C_i_set_i_slot(((C_word*)t0)[8],C_fix(4),t6);
t10=C_set_block_item(((C_word*)t0)[9],0,C_fix(0));
t11=t1;{
C_word *av2=av;
av2[0]=t11;
av2[1]=t10;
((C_proc)(void*)(*((C_word*)t11+1)))(2,av2);}}}

/* k1773 in loop in k1749 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1775(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,4)))){
C_save_and_reclaim((void *)f_1775,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1778,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* tcp.scm:388: ##sys#thread-block-for-i/o! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[36]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[36]+1);
av2[1]=t2;
av2[2]=*((C_word*)lf[32]+1);
av2[3]=((C_word*)t0)[5];
av2[4]=lf[37];
tp(5,av2);}}

/* k1776 in k1773 in loop in k1749 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1778(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_1778,c,av);}
a=C_alloc(6);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1781,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* tcp.scm:389: ##sys#thread-yield! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[35]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[35]+1);
av2[1]=t2;
tp(2,av2);}}

/* k1779 in k1776 in k1773 in loop in k1749 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1781(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,5)))){
C_save_and_reclaim((void *)f_1781,c,av);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1784,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(C_slot(*((C_word*)lf[32]+1),C_fix(13)))){
/* tcp.scm:391: ##sys#signal-hook */
t3=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[33];
av2[3]=lf[34];
av2[4]=((C_word*)t0)[4];
av2[5]=((C_word*)t0)[5];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}
else{
/* tcp.scm:394: loop */
t3=((C_word*)((C_word*)t0)[2])[1];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[3];
f_1756(2,av2);}}}

/* k1782 in k1779 in k1776 in k1773 in loop in k1749 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 in ... */
static void C_ccall f_1784(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_1784,c,av);}
/* tcp.scm:394: loop */
t2=((C_word*)((C_word*)t0)[2])[1];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
f_1756(2,av2);}}

/* k1810 in loop in k1749 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1812(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_1812,c,av);}
/* tcp.scm:398: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=C_SCHEME_FALSE;
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k1814 in loop in k1749 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1816(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_1816,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1820,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k1818 in k1814 in loop in k1749 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1820(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1820,c,av);}
/* tcp.scm:398: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k1836 in k1746 in read-input in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1838(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,1)))){
C_save_and_reclaim((void *)f_1838,c,av);}
a=C_alloc(29);
t2=((C_word*)t0)[2];
f_1751(t2,C_s_a_i_plus(&a,2,t1,((C_word*)t0)[3]));}

/* k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1841(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(61,c,6)))){
C_save_and_reclaim((void *)f_1841,c,av);}
a=C_alloc(61);
t2=C_SCHEME_FALSE;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1842,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word)li11),tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1986,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t4,a[6]=((C_word)li13),tmp=(C_word)a,a+=7,tmp);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2061,a[2]=((C_word*)t0)[5],a[3]=t5,a[4]=t4,a[5]=((C_word)li14),tmp=(C_word)a,a+=6,tmp);
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2076,a[2]=((C_word*)t0)[5],a[3]=t5,a[4]=t4,a[5]=((C_word)li15),tmp=(C_word)a,a+=6,tmp);
t8=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_2097,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[7],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[3],a[8]=t4,a[9]=((C_word)li16),tmp=(C_word)a,a+=10,tmp);
t9=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2160,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[3],a[4]=t4,a[5]=((C_word)li17),tmp=(C_word)a,a+=6,tmp);
t10=C_a_i_vector(&a,10,C_SCHEME_FALSE,C_SCHEME_FALSE,t6,t7,t8,t9,C_SCHEME_FALSE,C_SCHEME_FALSE,C_SCHEME_FALSE,C_SCHEME_FALSE);
t11=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2036,a[2]=t1,a[3]=((C_word*)t0)[9],a[4]=t3,a[5]=((C_word*)t0)[10],a[6]=((C_word*)t0)[11],a[7]=((C_word*)t0)[8],tmp=(C_word)a,a+=8,tmp);
/* tcp.scm:577: ##sys#make-port */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[51]+1));
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[51]+1);
av2[1]=t11;
av2[2]=C_fix(2);
av2[3]=t10;
av2[4]=lf[52];
av2[5]=lf[49];
tp(6,av2);}}

/* output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1842(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,2)))){
C_save_and_reclaim_args((void *)trf_1842,4,t0,t1,t2,t3);}
a=C_alloc(7);
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1846,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t2,a[6]=t3,tmp=(C_word)a,a+=7,tmp);
/* tcp.scm:498: tcp-write-timeout */
t5=*((C_word*)lf[28]+1);{
C_word av2[2];
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1846(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,c,6)))){
C_save_and_reclaim((void *)f_1846,c,av);}
a=C_alloc(5);
t2=C_slot(((C_word*)((C_word*)t0)[2])[1],C_fix(15));
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1855,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=((C_word)li10),tmp=(C_word)a,a+=5,tmp);
/* tcp.scm:499: ##sys#encode-buffer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[45]+1));
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[45]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[5];
av2[3]=C_fix(0);
av2[4]=((C_word*)t0)[6];
av2[5]=t2;
av2[6]=t3;
tp(7,av2);}}

/* a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1855(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(12,c,2)))){
C_save_and_reclaim((void *)f_1855,c,av);}
a=C_alloc(12);
t5=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_1863,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word*)t0)[3],a[5]=t1,a[6]=t4,a[7]=t3,tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)t0)[3])){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1985,a[2]=t5,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:504: chicken.time#current-process-milliseconds */
t7=*((C_word*)lf[41]+1);{
C_word *av2=av;
av2[0]=t7;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}
else{
t6=t5;
f_1863(t6,C_SCHEME_FALSE);}}

/* k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1863(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,0,5)))){
C_save_and_reclaim_args((void *)trf_1863,2,t0,t1);}
a=C_alloc(9);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1865,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=((C_word*)t0)[4],a[6]=((C_word)li9),tmp=(C_word)a,a+=7,tmp));
t5=((C_word*)t3)[1];
f_1865(t5,((C_word*)t0)[5],((C_word*)t0)[6],((C_word*)t0)[7],t1);}

/* loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1865(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(9,0,4)))){
C_save_and_reclaim_args((void *)trf_1865,5,t0,t1,t2,t3,t4);}
a=C_alloc(9);
t5=C_i_fixnum_min(C_fix(8192),t2);
t6=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t7=(C_truep(((C_word*)t0)[3])?C_i_foreign_block_argumentp(((C_word*)t0)[3]):C_SCHEME_FALSE);
t8=C_i_foreign_fixnum_argumentp(t3);
t9=C_i_foreign_fixnum_argumentp(t5);
t10=C_fix(0);
t11=stub223(C_SCHEME_UNDEFINED,t6,t7,t8,t9,t10);
t12=C_eqp(C_fix((C_word)SOCKET_ERROR),t11);
if(C_truep(t12)){
if(C_truep(stub123(C_SCHEME_UNDEFINED))){
t13=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_1887,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=t2,a[5]=t3,a[6]=t4,a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[2],tmp=(C_word)a,a+=9,tmp);
if(C_truep(t4)){
/* tcp.scm:510: ##sys#thread-block-for-timeout! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[38]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[38]+1);
av2[1]=t13;
av2[2]=*((C_word*)lf[32]+1);
av2[3]=t4;
tp(4,av2);}}
else{
t14=t13;{
C_word av2[2];
av2[0]=t14;
av2[1]=C_SCHEME_UNDEFINED;
f_1887(2,av2);}}}
else{
if(C_truep(stub129(C_SCHEME_UNDEFINED))){
t13=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1919,a[2]=((C_word*)t0)[4],a[3]=t2,a[4]=t3,a[5]=t4,a[6]=((C_word)li8),tmp=(C_word)a,a+=7,tmp);
/* tcp.scm:518: ##sys#dispatch-interrupt */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[39]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[39]+1);
av2[1]=t1;
av2[2]=t13;
tp(3,av2);}}
else{
t13=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1930,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t14=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1934,a[2]=t13,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t14;
av2[2]=lf[44];
av2[3]=lf[13];
tp(4,av2);}}}}
else{
if(C_truep(C_fixnum_lessp(t11,t2))){
t13=C_fixnum_difference(t2,t11);
t14=C_fixnum_plus(t3,t11);
t15=C_eqp(t11,C_fix(0));
if(C_truep(t15)){
/* tcp.scm:523: loop */
t18=t1;
t19=t13;
t20=t14;
t21=((C_word*)t0)[5];
t1=t18;
t2=t19;
t3=t20;
t4=t21;
goto loop;}
else{
if(C_truep(((C_word*)t0)[5])){
t16=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1978,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[4],a[4]=t1,a[5]=t13,a[6]=t14,tmp=(C_word)a,a+=7,tmp);
/* tcp.scm:527: chicken.time#current-process-milliseconds */
t17=*((C_word*)lf[41]+1);{
C_word av2[2];
av2[0]=t17;
av2[1]=t16;
((C_proc)(void*)(*((C_word*)t17+1)))(2,av2);}}
else{
/* tcp.scm:523: loop */
t18=t1;
t19=t13;
t20=t14;
t21=C_SCHEME_FALSE;
t1=t18;
t2=t19;
t3=t20;
t4=t21;
goto loop;}}}
else{
t13=t1;{
C_word av2[2];
av2[0]=t13;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t13+1)))(2,av2);}}}}

/* k1885 in loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1887(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,4)))){
C_save_and_reclaim((void *)f_1887,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_1890,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* tcp.scm:511: ##sys#thread-block-for-i/o! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[36]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[36]+1);
av2[1]=t2;
av2[2]=*((C_word*)lf[32]+1);
av2[3]=((C_word*)t0)[8];
av2[4]=lf[43];
tp(5,av2);}}

/* k1888 in k1885 in loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 in ... */
static void C_ccall f_1890(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,2)))){
C_save_and_reclaim((void *)f_1890,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_1893,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
/* tcp.scm:512: ##sys#thread-yield! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[35]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[35]+1);
av2[1]=t2;
tp(2,av2);}}

/* k1891 in k1888 in k1885 in loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in ... */
static void C_ccall f_1893(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,5)))){
C_save_and_reclaim((void *)f_1893,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1896,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(C_slot(*((C_word*)lf[32]+1),C_fix(13)))){
/* tcp.scm:514: ##sys#signal-hook */
t3=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[33];
av2[3]=lf[42];
av2[4]=((C_word*)t0)[7];
av2[5]=((C_word*)t0)[8];
((C_proc)(void*)(*((C_word*)t3+1)))(6,av2);}}
else{
/* tcp.scm:516: loop */
t3=((C_word*)((C_word*)t0)[2])[1];
f_1865(t3,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6]);}}

/* k1894 in k1891 in k1888 in k1885 in loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in ... */
static void C_ccall f_1896(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_1896,c,av);}
/* tcp.scm:516: loop */
t2=((C_word*)((C_word*)t0)[2])[1];
f_1865(t2,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6]);}

/* a1918 in loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1919(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_1919,c,av);}
/* tcp.scm:519: g639 */
t2=((C_word*)((C_word*)t0)[2])[1];
f_1865(t2,t1,((C_word*)t0)[3],((C_word*)t0)[4],((C_word*)t0)[5]);}

/* k1928 in loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1930(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_1930,c,av);}
/* tcp.scm:521: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=C_SCHEME_FALSE;
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k1932 in loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1934(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_1934,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1938,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k1936 in k1932 in loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 in ... */
static void C_ccall f_1938(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_1938,c,av);}
/* tcp.scm:521: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k1976 in loop in k1861 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1978(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,4)))){
C_save_and_reclaim((void *)f_1978,c,av);}
a=C_alloc(29);
t2=C_s_a_i_plus(&a,2,t1,((C_word*)t0)[2]);
/* tcp.scm:523: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_1865(t3,((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)t0)[6],t2);}

/* k1983 in a1854 in k1844 in output-to-socket in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_1985(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,1)))){
C_save_and_reclaim((void *)f_1985,c,av);}
a=C_alloc(29);
t2=((C_word*)t0)[2];
f_1863(t2,C_s_a_i_plus(&a,2,t1,((C_word*)t0)[3]));}

/* add-to-buf in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1986(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,4)))){
C_save_and_reclaim_args((void *)trf_1986,4,t0,t1,t2,t3);}
a=C_alloc(11);
t4=C_SCHEME_UNDEFINED;
t5=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t6=C_set_block_item(t5,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_1992,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t2,a[6]=t5,a[7]=((C_word*)t0)[5],a[8]=((C_word)li12),tmp=(C_word)a,a+=9,tmp));
t7=((C_word*)t5)[1];
f_1992(t7,t1,t3,C_fix(0));}

/* loop in add-to-buf in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_1992(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,0,3)))){
C_save_and_reclaim_args((void *)trf_1992,4,t0,t1,t2,t3);}
a=C_alloc(8);
t4=C_eqp(t2,C_fix(0));
if(C_truep(t4)){
t5=C_SCHEME_UNDEFINED;
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
t5=C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],t2);
if(C_truep(C_fixnum_greaterp(t5,((C_word*)t0)[3]))){
t6=C_fixnum_difference(((C_word*)t0)[3],((C_word*)((C_word*)t0)[2])[1]);
t7=C_copy_memory_with_offset(((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)((C_word*)t0)[2])[1],t3,t6);
t8=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2014,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[6],a[4]=t1,a[5]=t2,a[6]=t6,a[7]=t3,tmp=(C_word)a,a+=8,tmp);
/* tcp.scm:537: output-to-socket */
t9=((C_word*)t0)[7];
f_1842(t9,t8,((C_word*)t0)[4],((C_word*)t0)[3]);}
else{
t6=C_copy_memory_with_offset(((C_word*)t0)[4],((C_word*)t0)[5],((C_word*)((C_word*)t0)[2])[1],t3,t2);
t7=C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],t2);
t8=C_set_block_item(((C_word*)t0)[2],0,t7);
t9=t1;{
C_word av2[2];
av2[0]=t9;
av2[1]=t8;
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}}}

/* k2012 in loop in add-to-buf in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2014(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2014,c,av);}
t2=C_set_block_item(((C_word*)t0)[2],0,C_fix(0));
/* tcp.scm:539: loop */
t3=((C_word*)((C_word*)t0)[3])[1];
f_1992(t3,((C_word*)t0)[4],C_fixnum_difference(((C_word*)t0)[5],((C_word*)t0)[6]),C_fixnum_plus(((C_word*)t0)[7],((C_word*)t0)[6]));}

/* k2034 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2036(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2036,c,av);}
a=C_alloc(9);
t2=C_i_setslot(((C_word*)t0)[2],C_fix(3),lf[48]);
t3=C_i_setslot(((C_word*)t0)[2],C_fix(7),lf[49]);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2045,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],a[5]=t1,a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
/* tcp.scm:580: ##sys#set-port-data! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[50]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[50]+1);
av2[1]=t4;
av2[2]=((C_word*)t0)[2];
av2[3]=((C_word*)t0)[7];
tp(4,av2);}}

/* k2043 in k2034 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2045(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_2045,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2048,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* tcp.scm:581: ##sys#set-port-data! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[50]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[50]+1);
av2[1]=t2;
av2[2]=((C_word*)t0)[5];
av2[3]=((C_word*)t0)[8];
tp(4,av2);}}

/* k2046 in k2043 in k2034 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2048(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2048,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,((C_word*)t0)[3]);
t3=C_mutate(((C_word *)((C_word*)t0)[4])+1,((C_word*)t0)[5]);
t4=C_i_setslot(((C_word*)t0)[3],C_fix(15),((C_word*)t0)[6]);
t5=C_i_setslot(((C_word*)t0)[5],C_fix(15),((C_word*)t0)[6]);
/* tcp.scm:586: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[7];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[5];
C_values(4,av2);}}

/* a2060 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2061(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_2061,c,av);}
a=C_alloc(7);
t4=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2065,a[2]=t3,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t1,a[6]=((C_word*)t0)[4],tmp=(C_word)a,a+=7,tmp);
/* tcp.scm:549: ##sys#make-bytevector */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[46]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[46]+1);
av2[1]=t4;
av2[2]=C_fix(4);
tp(3,av2);}}

/* k2063 in a2060 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2065(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2065,c,av);}
t2=C_utf_insert(t1,C_fix(0),((C_word*)t0)[2]);
if(C_truep(((C_word*)t0)[3])){
/* tcp.scm:552: add-to-buf */
t3=((C_word*)t0)[4];
f_1986(t3,((C_word*)t0)[5],t1,t2);}
else{
/* tcp.scm:553: output-to-socket */
t3=((C_word*)t0)[6];
f_1842(t3,((C_word*)t0)[5],t1,t2);}}

/* a2075 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2076(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2076,c,av);}
t6=C_fixnum_difference(t5,t4);
if(C_truep(C_fixnum_greaterp(t6,C_fix(0)))){
if(C_truep(((C_word*)t0)[2])){
/* tcp.scm:558: add-to-buf */
t7=((C_word*)t0)[3];
f_1986(t7,t1,t3,t6);}
else{
/* tcp.scm:559: output-to-socket */
t7=((C_word*)t0)[4];
f_1842(t7,t1,t3,t6);}}
else{
t7=C_SCHEME_UNDEFINED;
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}

/* a2096 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2097(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_2097,c,av);}
a=C_alloc(10);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}
else{
t4=C_set_block_item(((C_word*)t0)[2],0,C_SCHEME_TRUE);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2105,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
t6=(C_truep(((C_word*)t0)[6])?C_fixnum_greaterp(((C_word*)((C_word*)t0)[7])[1],C_fix(0)):C_SCHEME_FALSE);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2154,a[2]=((C_word*)t0)[7],a[3]=t5,tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:564: output-to-socket */
t8=((C_word*)t0)[8];
f_1842(t8,t7,((C_word*)t0)[6],((C_word*)((C_word*)t0)[7])[1]);}
else{
t7=t5;
f_2105(t7,C_SCHEME_UNDEFINED);}}}

/* k2103 in a2096 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_2105(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_2105,2,t0,t1);}
a=C_alloc(5);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2108,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_slot(((C_word*)t0)[5],C_fix(2)))){
t3=t2;
f_2108(t3,C_SCHEME_UNDEFINED);}
else{
t3=C_fix((C_word)SHUT_WR);
t4=t2;
f_2108(t4,stub192(C_SCHEME_UNDEFINED,C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]),C_i_foreign_fixnum_argumentp(t3)));}}

/* k2106 in k2103 in a2096 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_2108(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_2108,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2114,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)((C_word*)t0)[4])[1])){
t3=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
t4=t2;
f_2114(t4,C_eqp(C_fix((C_word)SOCKET_ERROR),stub173(C_SCHEME_UNDEFINED,t3)));}
else{
t3=t2;
f_2114(t3,C_SCHEME_FALSE);}}

/* k2112 in k2106 in k2103 in a2096 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_2114(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_2114,2,t0,t1);}
a=C_alloc(7);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2121,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2125,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t3;
av2[2]=lf[47];
av2[3]=lf[13];
tp(4,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k2119 in k2112 in k2106 in k2103 in a2096 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2121(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2121,c,av);}
/* tcp.scm:568: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=C_SCHEME_FALSE;
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k2123 in k2112 in k2106 in k2103 in a2096 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2125(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2125,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2129,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k2127 in k2123 in k2112 in k2106 in k2103 in a2096 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2129(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2129,c,av);}
/* tcp.scm:568: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k2152 in a2096 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2154(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2154,c,av);}
t2=C_set_block_item(((C_word*)t0)[2],0,C_fix(0));
t3=((C_word*)t0)[3];
f_2105(t3,t2);}

/* a2159 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2160(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_2160,c,av);}
a=C_alloc(4);
t3=(C_truep(((C_word*)t0)[2])?C_fixnum_greaterp(((C_word*)((C_word*)t0)[3])[1],C_fix(0)):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2170,a[2]=((C_word*)t0)[3],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:571: output-to-socket */
t5=((C_word*)t0)[4];
f_1842(t5,t4,((C_word*)t0)[2],((C_word*)((C_word*)t0)[3])[1]);}
else{
t4=C_SCHEME_UNDEFINED;
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=t4;
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}}

/* k2168 in a2159 in k1839 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2170(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2170,c,av);}
t2=C_set_block_item(((C_word*)t0)[2],0,C_fix(0));
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* a2175 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2176(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_2176,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2180,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]))){
/* tcp.scm:408: read-input */
t3=((C_word*)t0)[6];
f_1744(t3,t2);}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_2180(2,av2);}}}

/* k2178 in a2175 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2180(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,c,6)))){
C_save_and_reclaim((void *)f_2180,c,av);}
a=C_alloc(4);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]))){
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=C_slot(((C_word*)((C_word*)t0)[5])[1],C_fix(15));
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2195,a[2]=((C_word*)t0)[2],a[3]=((C_word)li18),tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:411: ##sys#decode-buffer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[53]+1));
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[53]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[6];
av2[3]=((C_word*)((C_word*)t0)[2])[1];
av2[4]=C_fix(1);
av2[5]=t2;
av2[6]=t3;
tp(7,av2);}}}

/* a2194 in k2178 in a2175 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2195(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2195,c,av);}
t5=C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],t4);
t6=C_set_block_item(((C_word*)t0)[2],0,t5);
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_utf_decode(t2,t3);
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}

/* a2207 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2208(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_2208,c,av);}
a=C_alloc(11);
t2=C_fixnum_lessp(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]);
if(C_truep(t2)){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=C_i_foreign_fixnum_argumentp(((C_word*)t0)[4]);
t4=stub209(C_SCHEME_UNDEFINED,t3);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2221,a[2]=t1,a[3]=t4,tmp=(C_word)a,a+=4,tmp);
t6=C_eqp(C_fix((C_word)SOCKET_ERROR),t4);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2234,a[2]=t5,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2238,a[2]=t7,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t8;
av2[2]=lf[54];
av2[3]=lf[13];
tp(4,av2);}}
else{
t7=t1;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_eqp(t4,C_fix(1));
((C_proc)(void*)(*((C_word*)t7+1)))(2,av2);}}}}

/* k2219 in a2207 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2221(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2221,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_eqp(((C_word*)t0)[3],C_fix(1));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k2232 in a2207 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2234(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2234,c,av);}
/* tcp.scm:421: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=C_SCHEME_FALSE;
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k2236 in a2207 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2238(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2238,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2242,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k2240 in k2236 in a2207 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2242(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2242,c,av);}
/* tcp.scm:421: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* a2249 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2250(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,2)))){
C_save_and_reclaim((void *)f_2250,c,av);}
a=C_alloc(5);
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
t2=C_SCHEME_UNDEFINED;
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t2=C_set_block_item(((C_word*)t0)[2],0,C_SCHEME_TRUE);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2258,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(C_slot(((C_word*)t0)[5],C_fix(1)))){
t4=t3;
f_2258(t4,C_SCHEME_UNDEFINED);}
else{
t4=C_fix((C_word)SHUT_RD);
t5=t3;
f_2258(t5,stub192(C_SCHEME_UNDEFINED,C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]),C_i_foreign_fixnum_argumentp(t4)));}}}

/* k2256 in a2249 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_2258(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(4,0,2)))){
C_save_and_reclaim_args((void *)trf_2258,2,t0,t1);}
a=C_alloc(4);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2264,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)((C_word*)t0)[4])[1])){
t3=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
t4=t2;
f_2264(t4,C_eqp(C_fix((C_word)SOCKET_ERROR),stub173(C_SCHEME_UNDEFINED,t3)));}
else{
t3=t2;
f_2264(t3,C_SCHEME_FALSE);}}

/* k2262 in k2256 in a2249 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_2264(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_2264,2,t0,t1);}
a=C_alloc(7);
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2271,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2275,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t3;
av2[2]=lf[55];
av2[3]=lf[13];
tp(4,av2);}}
else{
t2=((C_word*)t0)[2];{
C_word av2[2];
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}}

/* k2269 in k2262 in k2256 in a2249 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2271(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2271,c,av);}
/* tcp.scm:428: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=C_SCHEME_FALSE;
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k2273 in k2262 in k2256 in a2249 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2275(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2275,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2279,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k2277 in k2273 in k2262 in k2256 in a2249 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2279(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2279,c,av);}
/* tcp.scm:428: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* a2299 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2300(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(7,c,2)))){
C_save_and_reclaim((void *)f_2300,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2304,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]))){
/* tcp.scm:432: read-input */
t3=((C_word*)t0)[6];
f_1744(t3,t2);}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_2304(2,av2);}}}

/* k2302 in a2299 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2304(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,6)))){
C_save_and_reclaim((void *)f_2304,c,av);}
a=C_alloc(3);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]))){
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=C_slot(((C_word*)((C_word*)t0)[5])[1],C_fix(15));
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2319,a[2]=((C_word)li22),tmp=(C_word)a,a+=3,tmp);
/* tcp.scm:435: ##sys#decode-buffer */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[53]+1));
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[53]+1);
av2[1]=((C_word*)t0)[4];
av2[2]=((C_word*)t0)[6];
av2[3]=((C_word*)((C_word*)t0)[2])[1];
av2[4]=C_fix(1);
av2[5]=t2;
av2[6]=t3;
tp(7,av2);}}}

/* a2318 in k2302 in a2299 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2319(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2319,c,av);}
t5=t1;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_utf_decode(t2,t3);
((C_proc)(void*)(*((C_word*)t5+1)))(2,av2);}}

/* a2327 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2328(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5=av[5];
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,5)))){
C_save_and_reclaim((void *)f_2328,c,av);}
a=C_alloc(11);
t6=C_SCHEME_UNDEFINED;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_set_block_item(t7,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2334,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t4,a[5]=((C_word*)t0)[4],a[6]=t7,a[7]=((C_word*)t0)[5],a[8]=((C_word)li24),tmp=(C_word)a,a+=9,tmp));
t9=((C_word*)t7)[1];
f_2334(t9,t1,t3,C_fix(0),t5);}

/* loop in a2327 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_2334(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word *a;
loop:
if(C_unlikely(!C_demand(C_calculate_demand(8,0,4)))){
C_save_and_reclaim_args((void *)trf_2334,5,t0,t1,t2,t3,t4);}
a=C_alloc(8);
t5=C_eqp(t2,C_fix(0));
if(C_truep(t5)){
t6=t1;{
C_word av2[2];
av2[0]=t6;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}
else{
if(C_truep(C_fixnum_lessp(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]))){
t6=C_fixnum_difference(((C_word*)((C_word*)t0)[3])[1],((C_word*)((C_word*)t0)[2])[1]);
t7=C_fixnum_lessp(t2,t6);
t8=(C_truep(t7)?t2:t6);
t9=C_copy_memory_with_offset(((C_word*)t0)[4],((C_word*)t0)[5],t4,((C_word*)((C_word*)t0)[2])[1],t8);
t10=C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],t8);
t11=C_set_block_item(((C_word*)t0)[2],0,t10);
/* tcp.scm:448: loop */
t13=t1;
t14=C_fixnum_difference(t2,t8);
t15=C_fixnum_plus(t3,t8);
t16=C_fixnum_plus(t4,t8);
t1=t13;
t2=t14;
t3=t15;
t4=t16;
goto loop;}
else{
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2378,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t3,a[5]=((C_word*)t0)[6],a[6]=t2,a[7]=t4,tmp=(C_word)a,a+=8,tmp);
/* tcp.scm:450: read-input */
t7=((C_word*)t0)[7];
f_1744(t7,t6);}}}

/* k2376 in loop in a2327 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2378(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_2378,c,av);}
t2=C_eqp(((C_word*)((C_word*)t0)[2])[1],C_fix(0));
if(C_truep(t2)){
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
/* tcp.scm:453: loop */
t3=((C_word*)((C_word*)t0)[5])[1];
f_2334(t3,((C_word*)t0)[3],((C_word*)t0)[6],((C_word*)t0)[4],((C_word*)t0)[7]);}}

/* a2388 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2389(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_2389,c,av);}
a=C_alloc(10);
t4=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_2393,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=t3,a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],a[9]=t2,tmp=(C_word)a,a+=10,tmp);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]))){
/* tcp.scm:457: read-input */
t5=((C_word*)t0)[5];
f_1744(t5,t4);}
else{
t5=t4;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_UNDEFINED;
f_2393(2,av2);}}}

/* k2391 in a2388 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2393(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(16,c,5)))){
C_save_and_reclaim((void *)f_2393,c,av);}
a=C_alloc(16);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]))){
t2=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_END_OF_FILE;
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
t2=(C_truep(((C_word*)t0)[5])?((C_word*)t0)[5]:C_fixnum_difference(*((C_word*)lf[56]+1),((C_word*)((C_word*)t0)[2])[1]));
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2407,a[2]=((C_word*)t0)[2],a[3]=t4,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word)li27),tmp=(C_word)a,a+=9,tmp);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2467,a[2]=((C_word*)t0)[9],a[3]=((C_word*)t0)[2],a[4]=((C_word)li28),tmp=(C_word)a,a+=5,tmp);
/* tcp.scm:461: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[4];
av2[2]=t5;
av2[3]=t6;
C_call_with_values(4,av2);}}}

/* a2406 in k2391 in a2388 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2407(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,6)))){
C_save_and_reclaim((void *)f_2407,c,av);}
a=C_alloc(8);
t2=C_fixnum_plus(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]);
t3=C_i_fixnum_min(((C_word*)((C_word*)t0)[4])[1],t2);
t4=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2417,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word)li26),tmp=(C_word)a,a+=8,tmp);
/* tcp.scm:462: ##sys#scan-buffer-line */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[57]+1));
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=*((C_word*)lf[57]+1);
av2[1]=t1;
av2[2]=((C_word*)t0)[5];
av2[3]=t3;
av2[4]=((C_word*)((C_word*)t0)[2])[1];
av2[5]=t4;
av2[6]=C_slot(((C_word*)((C_word*)t0)[7])[1],C_fix(15));
tp(7,av2);}}

/* a2416 in a2406 in k2391 in a2388 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2417(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_2417,c,av);}
a=C_alloc(8);
t3=C_fixnum_difference(t2,((C_word*)((C_word*)t0)[2])[1]);
if(C_truep(C_fixnum_greater_or_equal_p(t3,((C_word*)((C_word*)t0)[3])[1]))){
/* tcp.scm:469: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=t1;
av2[2]=C_SCHEME_FALSE;
av2[3]=t2;
av2[4]=C_SCHEME_FALSE;
C_values(5,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2433,a[2]=((C_word*)t0)[3],a[3]=t3,a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[4],a[6]=t1,a[7]=((C_word*)t0)[5],tmp=(C_word)a,a+=8,tmp);
/* tcp.scm:470: read-input */
t5=((C_word*)t0)[6];
f_1744(t5,t4);}}

/* k2431 in a2416 in a2406 in k2391 in a2388 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2433(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_2433,c,av);}
t2=C_fixnum_difference(((C_word*)((C_word*)t0)[2])[1],((C_word*)t0)[3]);
t3=C_set_block_item(((C_word*)t0)[2],0,t2);
if(C_truep(C_fixnum_lessp(((C_word*)((C_word*)t0)[4])[1],((C_word*)((C_word*)t0)[5])[1]))){
t4=C_fixnum_plus(((C_word*)((C_word*)t0)[4])[1],((C_word*)((C_word*)t0)[2])[1]);
/* tcp.scm:473: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[6];
av2[2]=((C_word*)t0)[7];
av2[3]=((C_word*)((C_word*)t0)[4])[1];
av2[4]=C_i_fixnum_min(((C_word*)((C_word*)t0)[5])[1],t4);
C_values(5,av2);}}
else{
/* tcp.scm:476: scheme#values */{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=0;
av2[1]=((C_word*)t0)[6];
av2[2]=C_SCHEME_FALSE;
av2[3]=((C_word*)((C_word*)t0)[4])[1];
av2[4]=C_SCHEME_FALSE;
C_values(5,av2);}}}

/* a2466 in k2391 in a2388 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2467(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4=av[4];
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2467,c,av);}
if(C_truep(t4)){
t5=C_slot(((C_word*)t0)[2],C_fix(4));
t6=C_fixnum_plus(t5,C_fix(1));
t7=C_i_set_i_slot(((C_word*)t0)[2],C_fix(4),t6);
t8=C_i_set_i_slot(((C_word*)t0)[2],C_fix(5),C_fix(0));
t9=C_mutate(((C_word *)((C_word*)t0)[3])+1,t2);
t10=t1;{
C_word *av2=av;
av2[0]=t10;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}
else{
t5=C_slot(((C_word*)t0)[2],C_fix(5));
t6=C_i_string_length(t3);
t7=C_fixnum_plus(t5,t6);
t8=C_i_set_i_slot(((C_word*)t0)[2],C_fix(5),t7);
t9=C_mutate(((C_word *)((C_word*)t0)[3])+1,t2);
t10=t1;{
C_word *av2=av;
av2[0]=t10;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t10+1)))(2,av2);}}}

/* a2511 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2512(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(5,c,5)))){
C_save_and_reclaim((void *)f_2512,c,av);}
a=C_alloc(5);
if(C_truep(C_fixnum_greater_or_equal_p(((C_word*)((C_word*)t0)[2])[1],((C_word*)((C_word*)t0)[3])[1]))){
t3=t1;{
C_word *av2=av;
av2[0]=t3;
av2[1]=lf[58];
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2522,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* tcp.scm:491: ##sys#buffer->string/encoding */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[59]+1));
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=*((C_word*)lf[59]+1);
av2[1]=t3;
av2[2]=((C_word*)t0)[4];
av2[3]=((C_word*)((C_word*)t0)[2])[1];
av2[4]=((C_word*)((C_word*)t0)[3])[1];
av2[5]=C_slot(((C_word*)((C_word*)t0)[5])[1],C_fix(15));
tp(6,av2);}}}

/* k2520 in a2511 in k1741 in k1738 in k1732 in k1729 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2522(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2522,c,av);}
t2=C_mutate(((C_word *)((C_word*)t0)[2])+1,((C_word*)((C_word*)t0)[3])[1]);
t3=((C_word*)t0)[4];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
((C_proc)(void*)(*((C_word*)t3+1)))(2,av2);}}

/* k2547 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2549(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2549,c,av);}
/* tcp.scm:366: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=((C_word*)t0)[3];
av2[4]=t1;
av2[5]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k2551 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2553(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2553,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2557,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
/* tcp.scm:172: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub118(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k2555 in k2551 in chicken.tcp#io-ports in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2557(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2557,c,av);}
/* tcp.scm:366: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2561(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(6,c,2)))){
C_save_and_reclaim((void *)f_2561,c,av);}
a=C_alloc(6);
t3=C_rest_nullp(c,3);
t4=(C_truep(t3)?lf[67]:C_get_rest_arg(c,3,av,3,t0));
t5=C_i_check_structure(t2,lf[5]);
t6=C_slot(t2,C_fix(1));
t7=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2574,a[2]=t6,a[3]=t4,a[4]=t2,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
/* tcp.scm:591: tcp-accept-timeout */
t8=*((C_word*)lf[30]+1);{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}

/* k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2574(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,2)))){
C_save_and_reclaim((void *)f_2574,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2577,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=t1,a[6]=((C_word*)t0)[5],tmp=(C_word)a,a+=7,tmp);
if(C_truep(t1)){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2657,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:592: chicken.time#current-process-milliseconds */
t4=*((C_word*)lf[41]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=t2;
f_2577(t3,C_SCHEME_FALSE);}}

/* k2575 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_2577(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,0,2)))){
C_save_and_reclaim_args((void *)trf_2577,2,t0,t1);}
a=C_alloc(11);
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2582,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=t1,a[8]=((C_word)li32),tmp=(C_word)a,a+=9,tmp));
t5=((C_word*)t3)[1];{
C_word av2[2];
av2[0]=t5;
av2[1]=((C_word*)t0)[6];
f_2582(2,av2);}}

/* loop in k2575 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2582(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(8,c,3)))){
C_save_and_reclaim((void *)f_2582,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2586,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)t0)[7])){
/* tcp.scm:595: ##sys#thread-block-for-timeout! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[38]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[38]+1);
av2[1]=t2;
av2[2]=*((C_word*)lf[32]+1);
av2[3]=((C_word*)t0)[7];
tp(4,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_2586(2,av2);}}}

/* k2584 in loop in k2575 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2586(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,4)))){
C_save_and_reclaim((void *)f_2586,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2589,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* tcp.scm:596: ##sys#thread-block-for-i/o! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[36]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[36]+1);
av2[1]=t2;
av2[2]=*((C_word*)lf[32]+1);
av2[3]=((C_word*)t0)[2];
av2[4]=lf[37];
tp(5,av2);}}

/* k2587 in k2584 in loop in k2575 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2589(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(8,c,2)))){
C_save_and_reclaim((void *)f_2589,c,av);}
a=C_alloc(8);
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2592,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
/* tcp.scm:597: ##sys#thread-yield! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[35]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[35]+1);
av2[1]=t2;
tp(2,av2);}}

/* k2590 in k2587 in k2584 in loop in k2575 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2592(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,6)))){
C_save_and_reclaim((void *)f_2592,c,av);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2595,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],tmp=(C_word)a,a+=7,tmp);
if(C_truep(C_slot(*((C_word*)lf[32]+1),C_fix(13)))){
/* tcp.scm:599: ##sys#signal-hook */
t3=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=t3;
av2[1]=t2;
av2[2]=lf[33];
av2[3]=lf[68];
av2[4]=lf[70];
av2[5]=((C_word*)t0)[7];
av2[6]=((C_word*)t0)[2];
((C_proc)(void*)(*((C_word*)t3+1)))(7,av2);}}
else{
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_2595(2,av2);}}}

/* k2593 in k2590 in k2587 in k2584 in loop in k2575 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2595(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,c,4)))){
C_save_and_reclaim((void *)f_2595,c,av);}
a=C_alloc(7);
t2=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t3=stub162(C_SCHEME_UNDEFINED,t2,C_SCHEME_FALSE,C_SCHEME_FALSE);
t4=C_eqp(C_fix((C_word)INVALID_SOCKET),t3);
if(C_truep(C_i_not(t4))){
/* tcp.scm:605: io-ports */
t5=lf[31];
f_1727(t5,((C_word*)t0)[3],lf[68],t3,((C_word*)t0)[4]);}
else{
if(C_truep(stub129(C_SCHEME_UNDEFINED))){
/* tcp.scm:607: ##sys#dispatch-interrupt */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[39]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[39]+1);
av2[1]=((C_word*)t0)[3];
av2[2]=((C_word*)((C_word*)t0)[5])[1];
tp(3,av2);}}
else{
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2623,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[6],tmp=(C_word)a,a+=4,tmp);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2627,a[2]=t5,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t6;
av2[2]=lf[69];
av2[3]=lf[13];
tp(4,av2);}}}}

/* k2621 in k2593 in k2590 in k2587 in k2584 in loop in k2575 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2623(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2623,c,av);}
/* tcp.scm:609: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[68];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k2625 in k2593 in k2590 in k2587 in k2584 in loop in k2575 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2627(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2627,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2631,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k2629 in k2625 in k2593 in k2590 in k2587 in k2584 in loop in k2575 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2631(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2631,c,av);}
/* tcp.scm:609: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k2655 in k2572 in chicken.tcp#tcp-accept in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2657(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,1)))){
C_save_and_reclaim((void *)f_2657,c,av);}
a=C_alloc(29);
t2=((C_word*)t0)[2];
f_2577(t2,C_s_a_i_plus(&a,2,((C_word*)t0)[3],t1));}

/* chicken.tcp#tcp-accept-ready? in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2665(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_2665,c,av);}
a=C_alloc(11);
t3=C_i_check_structure_2(t2,lf[5],lf[72]);
t4=C_slot(t2,C_fix(1));
t5=C_i_foreign_fixnum_argumentp(t4);
t6=stub209(C_SCHEME_UNDEFINED,t5);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2675,a[2]=t1,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
t8=C_eqp(C_fix((C_word)SOCKET_ERROR),t6);
if(C_truep(t8)){
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2688,a[2]=t7,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2692,a[2]=t9,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t10;
av2[2]=lf[73];
av2[3]=lf[13];
tp(4,av2);}}
else{
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=C_eqp(C_fix(1),t6);
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}}

/* k2673 in chicken.tcp#tcp-accept-ready? in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2675(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2675,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_eqp(C_fix(1),((C_word*)t0)[3]);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k2686 in chicken.tcp#tcp-accept-ready? in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2688(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2688,c,av);}
/* tcp.scm:616: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[72];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k2690 in chicken.tcp#tcp-accept-ready? in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2692(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2692,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2696,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k2694 in k2690 in chicken.tcp#tcp-accept-ready? in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2696(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2696,c,av);}
/* tcp.scm:616: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2715(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word *a;
if(c<3) C_bad_min_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_2715,c,av);}
a=C_alloc(10);
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_rest_nullp(c,3);
t5=(C_truep(t4)?C_SCHEME_FALSE:C_get_rest_arg(c,3,av,3,t0));
t6=t5;
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=C_rest_nullp(c,3);
t9=C_rest_nullp(c,4);
t10=(C_truep(t9)?lf[67]:C_get_rest_arg(c,4,av,3,t0));
t11=C_rest_nullp(c,4);
t12=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2731,a[2]=t3,a[3]=t7,a[4]=t1,a[5]=t10,tmp=(C_word)a,a+=6,tmp);
/* tcp.scm:628: tcp-connect-timeout */
t13=*((C_word*)lf[29]+1);{
C_word *av2=av;
av2[0]=t13;
av2[1]=t12;
((C_proc)(void*)(*((C_word*)t13+1)))(2,av2);}}

/* k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2731(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,2)))){
C_save_and_reclaim((void *)f_2731,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2734,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
if(C_truep(t1)){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2999,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:629: chicken.time#current-process-milliseconds */
t4=*((C_word*)lf[41]+1);{
C_word *av2=av;
av2[0]=t4;
av2[1]=t3;
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}
else{
t3=t2;
f_2734(t3,C_SCHEME_FALSE);}}

/* k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_2734(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(7,0,3)))){
C_save_and_reclaim_args((void *)trf_2734,2,t0,t1);}
a=C_alloc(7);
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2737,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
t3=C_fix((C_word)sizeof(struct sockaddr_in));
/* ##sys#make-string */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[19]+1));
C_word av2[4];
av2[0]=*((C_word*)lf[19]+1);
av2[1]=t2;
av2[2]=t3;
av2[3]=C_make_character(32);
tp(4,av2);}}

/* k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2737(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(22,c,4)))){
C_save_and_reclaim((void *)f_2737,c,av);}
a=C_alloc(22);
t2=C_i_check_string(((C_word*)((C_word*)t0)[2])[1]);
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2743,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t1,a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[2],tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)((C_word*)t0)[3])[1])){
t4=t3;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_SCHEME_UNDEFINED;
f_2743(2,av2);}}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2974,a[2]=((C_word*)t0)[3],a[3]=t3,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2982,a[2]=((C_word*)t0)[2],a[3]=((C_word)li37),tmp=(C_word)a,a+=4,tmp);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2988,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word)li38),tmp=(C_word)a,a+=5,tmp);
/* tcp.scm:633: ##sys#call-with-values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=t4;
av2[2]=t5;
av2[3]=t6;
C_call_with_values(4,av2);}}}

/* k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2743(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,4)))){
C_save_and_reclaim((void *)f_2743,c,av);}
a=C_alloc(12);
t2=C_i_check_fixnum(((C_word*)((C_word*)t0)[2])[1]);
t3=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2749,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[2],tmp=(C_word)a,a+=8,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2968,a[2]=t3,a[3]=((C_word*)t0)[7],tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:636: gethostaddr */
f_1326(t4,((C_word*)t0)[5],((C_word*)((C_word*)t0)[7])[1],((C_word*)((C_word*)t0)[2])[1]);}

/* k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2749(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(17,c,3)))){
C_save_and_reclaim((void *)f_2749,c,av);}
a=C_alloc(17);
t2=C_fix((C_word)AF_INET);
t3=C_fix((C_word)SOCK_STREAM);
t4=stub135(C_SCHEME_UNDEFINED,C_i_foreign_fixnum_argumentp(t2),C_i_foreign_fixnum_argumentp(t3),C_fix(0));
t5=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2755,a[2]=t4,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[7],tmp=(C_word)a,a+=9,tmp);
t6=C_eqp(C_fix((C_word)INVALID_SOCKET),t4);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2951,a[2]=t5,a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],tmp=(C_word)a,a+=5,tmp);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2955,a[2]=t7,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t8;
av2[2]=lf[81];
av2[3]=lf[13];
tp(4,av2);}}
else{
t7=t5;{
C_word *av2=av;
av2[0]=t7;
av2[1]=C_SCHEME_UNDEFINED;
f_2755(2,av2);}}}

/* k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2755(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(17,c,3)))){
C_save_and_reclaim((void *)f_2755,c,av);}
a=C_alloc(17);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2758,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
t3=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t4=C_eqp(C_fix((C_word)SOCKET_ERROR),stub214(C_SCHEME_UNDEFINED,t3));
if(C_truep(t4)){
t5=stub114(C_SCHEME_UNDEFINED);
t6=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t7=stub173(C_SCHEME_UNDEFINED,t6);
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2927,a[2]=t2,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2931,a[2]=t8,a[3]=t5,tmp=(C_word)a,a+=4,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t9;
av2[2]=lf[80];
av2[3]=lf[13];
tp(4,av2);}}
else{
t5=t2;{
C_word *av2=av;
av2[0]=t5;
av2[1]=C_SCHEME_UNDEFINED;
f_2758(2,av2);}}}

/* k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2758(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(17,c,3)))){
C_save_and_reclaim((void *)f_2758,c,av);}
a=C_alloc(17);
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2761,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
if(C_truep(make_socket_nonblocking(((C_word*)t0)[2]))){
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=C_SCHEME_UNDEFINED;
f_2761(2,av2);}}
else{
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t5=stub173(C_SCHEME_UNDEFINED,t4);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2901,a[2]=t2,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2905,a[2]=t6,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t7;
av2[2]=lf[79];
av2[3]=lf[13];
tp(4,av2);}}}

/* k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2761(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(16,c,2)))){
C_save_and_reclaim((void *)f_2761,c,av);}
a=C_alloc(16);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2764,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2827,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=t4,a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word)li35),tmp=(C_word)a,a+=9,tmp));
t6=((C_word*)t4)[1];{
C_word *av2=av;
av2[0]=t6;
av2[1]=t2;
f_2827(2,av2);}}

/* k2762 in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2764(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,4)))){
C_save_and_reclaim((void *)f_2764,c,av);}
a=C_alloc(13);
t2=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t3=stub743(C_SCHEME_UNDEFINED,t2);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2770,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t5=C_eqp(C_fix((C_word)SOCKET_ERROR),t3);
if(C_truep(t5)){
t6=stub114(C_SCHEME_UNDEFINED);
t7=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t8=stub173(C_SCHEME_UNDEFINED,t7);
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2789,a[2]=t4,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2793,a[2]=t9,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t10;
av2[2]=lf[76];
av2[3]=lf[13];
tp(4,av2);}}
else{
if(C_truep(C_fixnum_greaterp(t3,C_fix(0)))){
t6=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t7=stub173(C_SCHEME_UNDEFINED,t6);
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2815,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2819,a[2]=t8,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t9;
av2[2]=lf[77];
av2[3]=lf[13];
tp(4,av2);}}
else{
/* tcp.scm:663: io-ports */
t6=lf[31];
f_1727(t6,((C_word*)t0)[3],lf[75],((C_word*)t0)[2],((C_word*)t0)[4]);}}}

/* k2768 in k2762 in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2770(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_2770,c,av);}
/* tcp.scm:663: io-ports */
t2=lf[31];
f_1727(t2,((C_word*)t0)[2],lf[75],((C_word*)t0)[3],((C_word*)t0)[4]);}

/* k2787 in k2762 in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2789(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2789,c,av);}
/* tcp.scm:659: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[75];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k2791 in k2762 in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2793(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2793,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2797,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
/* tcp.scm:172: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub118(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k2795 in k2791 in k2762 in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2797(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2797,c,av);}
/* tcp.scm:659: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k2813 in k2762 in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2815(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_2815,c,av);}
/* tcp.scm:662: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[75];
av2[4]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}

/* k2817 in k2762 in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2819(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2819,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2823,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
/* tcp.scm:172: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub118(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k2821 in k2817 in k2762 in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2823(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2823,c,av);}
/* tcp.scm:662: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* loop in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2827(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(10,c,4)))){
C_save_and_reclaim((void *)f_2827,c,av);}
a=C_alloc(10);
t2=C_fix((C_word)sizeof(struct sockaddr_in));
t3=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t4=(C_truep(((C_word*)t0)[3])?C_i_foreign_block_argumentp(((C_word*)t0)[3]):C_SCHEME_FALSE);
t5=C_i_foreign_fixnum_argumentp(t2);
t6=C_eqp(C_fix((C_word)SOCKET_ERROR),stub200(C_SCHEME_UNDEFINED,t3,t4,t5));
if(C_truep(t6)){
if(C_truep(stub126(C_SCHEME_UNDEFINED))){
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2843,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
if(C_truep(((C_word*)t0)[4])){
/* tcp.scm:649: ##sys#thread-block-for-timeout! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[38]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[38]+1);
av2[1]=t7;
av2[2]=*((C_word*)lf[32]+1);
av2[3]=((C_word*)t0)[4];
tp(4,av2);}}
else{
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f3609,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* tcp.scm:650: ##sys#thread-block-for-i/o! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[36]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[36]+1);
av2[1]=t8;
av2[2]=*((C_word*)lf[32]+1);
av2[3]=((C_word*)t0)[2];
av2[4]=lf[43];
tp(5,av2);}}}
else{
if(C_truep(stub129(C_SCHEME_UNDEFINED))){
/* tcp.scm:653: ##sys#dispatch-interrupt */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[39]+1));
C_word *av2;
if(c >= 3) {
  av2=av;
} else {
  av2=C_alloc(3);
}
av2[0]=*((C_word*)lf[39]+1);
av2[1]=t1;
av2[2]=((C_word*)((C_word*)t0)[5])[1];
tp(3,av2);}}
else{
t7=stub114(C_SCHEME_UNDEFINED);
t8=C_i_foreign_fixnum_argumentp(((C_word*)t0)[2]);
t9=stub173(C_SCHEME_UNDEFINED,t8);
t10=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2874,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[7],tmp=(C_word)a,a+=6,tmp);
t11=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2878,a[2]=t10,a[3]=t7,tmp=(C_word)a,a+=4,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t11;
av2[2]=lf[78];
av2[3]=lf[13];
tp(4,av2);}}}}
else{
t7=C_SCHEME_UNDEFINED;
t8=t1;{
C_word *av2=av;
av2[0]=t8;
av2[1]=t7;
((C_proc)(void*)(*((C_word*)t8+1)))(2,av2);}}}

/* k2841 in loop in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2843(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(3,c,4)))){
C_save_and_reclaim((void *)f_2843,c,av);}
a=C_alloc(3);
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2846,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* tcp.scm:650: ##sys#thread-block-for-i/o! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[36]+1));
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=*((C_word*)lf[36]+1);
av2[1]=t2;
av2[2]=*((C_word*)lf[32]+1);
av2[3]=((C_word*)t0)[3];
av2[4]=lf[43];
tp(5,av2);}}

/* k2844 in k2841 in loop in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2846(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2846,c,av);}
/* tcp.scm:651: ##sys#thread-yield! */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[35]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[35]+1);
av2[1]=((C_word*)t0)[2];
tp(2,av2);}}

/* k2872 in loop in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2874(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,7)))){
C_save_and_reclaim((void *)f_2874,c,av);}
/* tcp.scm:655: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 8) {
  av2=av;
} else {
  av2=C_alloc(8);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[75];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
av2[6]=((C_word*)((C_word*)t0)[4])[1];
av2[7]=((C_word*)((C_word*)t0)[5])[1];
((C_proc)(void*)(*((C_word*)t2+1)))(8,av2);}}

/* k2876 in loop in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2878(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2878,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2882,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
/* tcp.scm:172: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub118(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k2880 in k2876 in loop in k2759 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2882(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2882,c,av);}
/* tcp.scm:655: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k2899 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2901(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2901,c,av);}
/* tcp.scm:644: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[75];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k2903 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2905(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2905,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2909,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
/* tcp.scm:172: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub118(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k2907 in k2903 in k2756 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2909(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2909,c,av);}
/* tcp.scm:644: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k2925 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2927(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2927,c,av);}
/* tcp.scm:642: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[75];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k2929 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2931(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2931,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2935,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[3]);
/* tcp.scm:172: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub118(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k2933 in k2929 in k2753 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2935(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2935,c,av);}
/* tcp.scm:642: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k2949 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2951(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_2951,c,av);}
/* tcp.scm:640: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[75];
av2[4]=t1;
av2[5]=((C_word*)((C_word*)t0)[3])[1];
av2[6]=((C_word*)((C_word*)t0)[4])[1];
((C_proc)(void*)(*((C_word*)t2+1)))(7,av2);}}

/* k2953 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2955(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2955,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2959,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k2957 in k2953 in k2747 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2959(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_2959,c,av);}
/* tcp.scm:640: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k2966 in k2741 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2968(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2968,c,av);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_SCHEME_UNDEFINED;
f_2749(2,av2);}}
else{
/* tcp.scm:637: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[75];
av2[4]=lf[82];
av2[5]=((C_word*)((C_word*)t0)[3])[1];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}}

/* k2972 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2974(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_2974,c,av);}
if(C_truep(((C_word*)((C_word*)t0)[2])[1])){
t2=C_SCHEME_UNDEFINED;
t3=((C_word*)t0)[3];{
C_word *av2=av;
av2[0]=t3;
av2[1]=t2;
f_2743(2,av2);}}
else{
/* tcp.scm:634: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
av2[2]=lf[20];
av2[3]=lf[75];
av2[4]=lf[83];
av2[5]=((C_word*)((C_word*)t0)[4])[1];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}}

/* a2981 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2982(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_2982,c,av);}
a=C_alloc(9);
t2=((C_word*)((C_word*)t0)[2])[1];
t3=lf[84];
t4=C_i_string_length(t2);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1358,a[2]=t4,a[3]=t2,a[4]=t3,a[5]=t6,a[6]=((C_word)li36),tmp=(C_word)a,a+=7,tmp));
t8=((C_word*)t6)[1];
f_1358(t8,t1,C_fix(0));}

/* a2987 in k2735 in k2732 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2988(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3=av[3];
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_2988,c,av);}
t4=C_mutate(((C_word *)((C_word*)t0)[2])+1,t2);
t5=C_mutate(((C_word *)((C_word*)t0)[3])+1,t3);
t6=t1;{
C_word *av2=av;
av2[0]=t6;
av2[1]=t5;
((C_proc)(void*)(*((C_word*)t6+1)))(2,av2);}}

/* k2997 in k2729 in chicken.tcp#tcp-connect in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_2999(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(29,c,1)))){
C_save_and_reclaim((void *)f_2999,c,av);}
a=C_alloc(29);
t2=((C_word*)t0)[2];
f_2734(t2,C_s_a_i_plus(&a,2,t1,((C_word*)t0)[3]));}

/* chicken.tcp#tcp-port->fileno in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void f_3025(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(5,0,2)))){
C_save_and_reclaim_args((void *)trf_3025,3,t1,t2,t3);}
a=C_alloc(5);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3029,a[2]=t1,a[3]=t3,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* tcp.scm:666: ##sys#port-data */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[90]+1));
C_word av2[3];
av2[0]=*((C_word*)lf[90]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}

/* k3027 in chicken.tcp#tcp-port->fileno in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3029(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,4)))){
C_save_and_reclaim((void *)f_3029,c,av);}
if(C_truep(C_i_vectorp(t1))){
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_slot(t1,C_fix(0));
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}
else{
/* tcp.scm:669: chicken.base#error */
t2=*((C_word*)lf[88]+1);{
C_word *av2;
if(c >= 5) {
  av2=av;
} else {
  av2=C_alloc(5);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=lf[89];
av2[4]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(5,av2);}}}

/* chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3043(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_3043,c,av);}
a=C_alloc(4);
t3=C_i_check_port_2(t2,C_fix(0),C_SCHEME_TRUE,lf[92]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3049,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:673: tcp-port->fileno */
f_3025(t4,t2,lf[92]);}

/* k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3049(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_3049,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3056,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(t1);
/* tcp.scm:193: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub234(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3056(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_3056,c,av);}
a=C_alloc(12);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3059,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
if(C_truep(t1)){
t3=t2;{
C_word *av2=av;
av2[0]=t3;
av2[1]=t1;
f_3059(2,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3094,a[2]=t2,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3098,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t4;
av2[2]=lf[94];
av2[3]=lf[13];
tp(4,av2);}}}

/* k3057 in k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3059(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(10,c,3)))){
C_save_and_reclaim((void *)f_3059,c,av);}
a=C_alloc(10);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3063,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t3=C_a_i_bytevector(&a,1,C_fix(3));
t4=C_i_foreign_fixnum_argumentp(((C_word*)t0)[4]);
/* tcp.scm:217: ##sys#peek-c-string */
t5=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t5;
av2[1]=t2;
av2[2]=stub250(t3,t4);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t5+1)))(4,av2);}}

/* k3061 in k3057 in k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3063(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(11,c,3)))){
C_save_and_reclaim((void *)f_3063,c,av);}
a=C_alloc(11);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3066,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep(t1)){
/* tcp.scm:674: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
C_values(4,av2);}}
else{
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3073,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3077,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t4;
av2[2]=lf[93];
av2[3]=lf[13];
tp(4,av2);}}}

/* k3064 in k3061 in k3057 in k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3066(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3066,c,av);}
/* tcp.scm:674: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
C_values(4,av2);}}

/* k3071 in k3061 in k3057 in k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3073(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_3073,c,av);}
/* tcp.scm:678: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[92];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k3075 in k3061 in k3057 in k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3077(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_3077,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3081,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k3079 in k3075 in k3061 in k3057 in k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3081(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3081,c,av);}
/* tcp.scm:678: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k3092 in k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3094(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_3094,c,av);}
/* tcp.scm:676: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[92];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k3096 in k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3098(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_3098,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3102,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k3100 in k3096 in k3054 in k3047 in chicken.tcp#tcp-addresses in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3102(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3102,c,av);}
/* tcp.scm:676: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3110(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,3)))){
C_save_and_reclaim((void *)f_3110,c,av);}
a=C_alloc(4);
t3=C_i_check_port_2(t2,C_fix(0),C_SCHEME_TRUE,lf[96]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3116,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:682: tcp-port->fileno */
f_3025(t4,t2,lf[96]);}

/* k3114 in chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3116(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(13,c,3)))){
C_save_and_reclaim((void *)f_3116,c,av);}
a=C_alloc(13);
t2=C_i_foreign_fixnum_argumentp(t1);
t3=stub240(C_SCHEME_UNDEFINED,t2);
t4=C_i_foreign_fixnum_argumentp(t1);
t5=stub245(C_SCHEME_UNDEFINED,t4);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3125,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=t5,a[5]=((C_word*)t0)[3],tmp=(C_word)a,a+=6,tmp);
t7=C_eqp(C_fix(-1),t3);
if(C_truep(t7)){
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3165,a[2]=t6,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3169,a[2]=t8,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t9;
av2[2]=lf[98];
av2[3]=lf[13];
tp(4,av2);}}
else{
t8=t6;{
C_word *av2=av;
av2[0]=t8;
av2[1]=C_SCHEME_UNDEFINED;
f_3125(2,av2);}}}

/* k3123 in k3114 in chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3125(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_3125,c,av);}
a=C_alloc(12);
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3128,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=C_eqp(C_fix(-1),((C_word*)t0)[4]);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3141,a[2]=t2,a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3145,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t5;
av2[2]=lf[97];
av2[3]=lf[13];
tp(4,av2);}}
else{
/* tcp.scm:689: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
C_values(4,av2);}}}

/* k3126 in k3123 in k3114 in chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3128(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3128,c,av);}
/* tcp.scm:689: scheme#values */{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=0;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=((C_word*)t0)[4];
C_values(4,av2);}}

/* k3139 in k3123 in k3114 in chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3141(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_3141,c,av);}
/* tcp.scm:688: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[96];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k3143 in k3123 in k3114 in chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3145(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_3145,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3149,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k3147 in k3143 in k3123 in k3114 in chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3149(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3149,c,av);}
/* tcp.scm:688: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k3163 in k3114 in chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3165(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,5)))){
C_save_and_reclaim((void *)f_3165,c,av);}
/* tcp.scm:686: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 6) {
  av2=av;
} else {
  av2=C_alloc(6);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[96];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(6,av2);}}

/* k3167 in k3114 in chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3169(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_3169,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3173,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k3171 in k3167 in k3114 in chicken.tcp#tcp-port-numbers in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3173(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3173,c,av);}
/* tcp.scm:686: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* chicken.tcp#tcp-listener-port in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3181(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(12,c,3)))){
C_save_and_reclaim((void *)f_3181,c,av);}
a=C_alloc(12);
t3=C_i_check_structure_2(t2,lf[5],lf[100]);
t4=C_slot(t2,C_fix(1));
t5=C_i_foreign_fixnum_argumentp(t4);
t6=stub240(C_SCHEME_UNDEFINED,t5);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3194,a[2]=t1,a[3]=t6,tmp=(C_word)a,a+=4,tmp);
t8=C_eqp(C_fix(-1),t6);
if(C_truep(t8)){
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3204,a[2]=t7,a[3]=t2,a[4]=t4,tmp=(C_word)a,a+=5,tmp);
t10=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3208,a[2]=t9,tmp=(C_word)a,a+=3,tmp);
/* ##sys#string-append */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[11]+1));
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=*((C_word*)lf[11]+1);
av2[1]=t10;
av2[2]=lf[101];
av2[3]=lf[13];
tp(4,av2);}}
else{
t9=t1;{
C_word *av2=av;
av2[0]=t9;
av2[1]=t6;
((C_proc)(void*)(*((C_word*)t9+1)))(2,av2);}}}

/* k3192 in chicken.tcp#tcp-listener-port in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3194(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_3194,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=((C_word*)t0)[3];
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* k3202 in chicken.tcp#tcp-listener-port in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3204(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,6)))){
C_save_and_reclaim((void *)f_3204,c,av);}
/* tcp.scm:696: ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);{
C_word *av2;
if(c >= 7) {
  av2=av;
} else {
  av2=C_alloc(7);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=lf[7];
av2[3]=lf[100];
av2[4]=t1;
av2[5]=((C_word*)t0)[3];
av2[6]=((C_word*)t0)[4];
((C_proc)(void*)(*((C_word*)t2+1)))(7,av2);}}

/* k3206 in chicken.tcp#tcp-listener-port in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3208(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(9,c,3)))){
C_save_and_reclaim((void *)f_3208,c,av);}
a=C_alloc(9);
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3212,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t3=stub114(C_SCHEME_UNDEFINED);
t4=C_a_i_bytevector(&a,1,C_fix(3));
t5=C_i_foreign_fixnum_argumentp(t3);
/* tcp.scm:172: ##sys#peek-c-string */
t6=*((C_word*)lf[10]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t6;
av2[1]=t2;
av2[2]=stub118(t4,t5);
av2[3]=C_fix(0);
((C_proc)(void*)(*((C_word*)t6+1)))(4,av2);}}

/* k3210 in k3206 in chicken.tcp#tcp-listener-port in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3212(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3212,c,av);}
/* tcp.scm:696: scheme#string-append */
t2=*((C_word*)lf[9]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)t0)[3];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* chicken.tcp#tcp-abandon-port in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3220(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(4,c,2)))){
C_save_and_reclaim((void *)f_3220,c,av);}
a=C_alloc(4);
t3=C_i_check_port_2(t2,C_fix(0),C_SCHEME_TRUE,lf[103]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3230,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* tcp.scm:701: ##sys#port-data */
{C_proc tp=(C_proc)C_fast_retrieve_proc(*((C_word*)lf[90]+1));
C_word *av2=av;
av2[0]=*((C_word*)lf[90]+1);
av2[1]=t4;
av2[2]=t2;
tp(3,av2);}}

/* k3228 in chicken.tcp#tcp-abandon-port in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3230(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_3230,c,av);}
t2=((C_word*)t0)[2];{
C_word *av2=av;
av2[0]=t2;
av2[1]=C_i_set_i_slot(t1,C_slot(((C_word*)t0)[3],C_fix(1)),C_SCHEME_TRUE);
((C_proc)(void*)(*((C_word*)t2+1)))(2,av2);}}

/* chicken.tcp#tcp-listener-fileno in k1723 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3236(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2=av[2];
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(C_unlikely(!C_demand(C_calculate_demand(0,c,1)))){
C_save_and_reclaim((void *)f_3236,c,av);}
t3=C_i_check_structure_2(t2,lf[5],lf[105]);
t4=t1;{
C_word *av2=av;
av2[0]=t4;
av2[1]=C_slot(t2,C_fix(1));
((C_proc)(void*)(*((C_word*)t4+1)))(2,av2);}}

/* k3245 in k1719 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3247(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3247,c,av);}
/* tcp.scm:360: scheme#make-parameter */
t2=*((C_word*)lf[106]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_SCHEME_FALSE;
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k3249 in k1715 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3251(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3251,c,av);}
/* tcp.scm:359: scheme#make-parameter */
t2=*((C_word*)lf[106]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=C_SCHEME_FALSE;
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k3253 in k1711 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3255(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3255,c,av);}
/* tcp.scm:358: scheme#make-parameter */
t2=*((C_word*)lf[106]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* k3257 in k1688 in k1297 in k1069 in k1066 in k1063 */
static void C_ccall f_3259(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word *a;
if(C_unlikely(!C_demand(C_calculate_demand(0,c,3)))){
C_save_and_reclaim((void *)f_3259,c,av);}
/* tcp.scm:357: scheme#make-parameter */
t2=*((C_word*)lf[106]+1);{
C_word *av2;
if(c >= 4) {
  av2=av;
} else {
  av2=C_alloc(4);
}
av2[0]=t2;
av2[1]=((C_word*)t0)[2];
av2[2]=((C_word*)((C_word*)t0)[3])[1];
av2[3]=t1;
((C_proc)(void*)(*((C_word*)t2+1)))(4,av2);}}

/* toplevel */
static int toplevel_initialized=0;

void C_ccall C_tcp_toplevel(C_word c,C_word *av){
C_word tmp;
C_word t0=av[0];
C_word t1=av[1];
C_word t2;
C_word t3;
C_word *a;
if(toplevel_initialized) {C_kontinue(t1,C_SCHEME_UNDEFINED);}
else C_toplevel_entry(C_text("tcp"));
C_check_nursery_minimum(C_calculate_demand(3,c,2));
if(C_unlikely(!C_demand(C_calculate_demand(3,c,2)))){
C_save_and_reclaim((void*)C_tcp_toplevel,c,av);}
toplevel_initialized=1;
if(C_unlikely(!C_demand_2(490))){
C_save(t1);
C_rereclaim2(490*sizeof(C_word),1);
t1=C_restore;}
a=C_alloc(3);
C_initialize_lf(lf,112);
lf[0]=C_h_intern(&lf[0],3, C_text("tcp"));
lf[1]=C_h_intern(&lf[1],12, C_text("chicken.tcp#"));
lf[3]=C_h_intern(&lf[3],19, C_text("##sys#make-c-string"));
lf[4]=C_h_intern(&lf[4],22, C_text("chicken.tcp#tcp-listen"));
lf[5]=C_h_intern(&lf[5],12, C_text("tcp-listener"));
lf[6]=C_h_intern(&lf[6],17, C_text("##sys#signal-hook"));
lf[7]=C_h_intern_kw(&lf[7],13, C_text("network-error"));
lf[8]=C_h_intern(&lf[8],10, C_text("tcp-listen"));
lf[9]=C_h_intern(&lf[9],20, C_text("scheme#string-append"));
lf[10]=C_h_intern(&lf[10],19, C_text("##sys#peek-c-string"));
lf[11]=C_h_intern(&lf[11],19, C_text("##sys#string-append"));
lf[12]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\030\143\141\156\156\157\164\040\154\151\163\164\145\156\040\157\156\040\163\157\143\153\145\164\000"));
lf[13]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\040\055\040\000"));
lf[14]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\026\143\141\156\156\157\164\040\142\151\156\144\040\164\157\040\163\157\143\153\145\164\000"));
lf[15]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\145\162\162\157\162\040\167\150\151\154\145\040\163\145\164\164\151\156\147\040\165\160\040\163\157\143\153\145\164\000"));
lf[16]=C_h_intern(&lf[16],11, C_text("##sys#error"));
lf[17]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\025\143\141\156\156\157\164\040\143\162\145\141\164\145\040\163\157\143\153\145\164\000"));
lf[18]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\040\147\145\164\164\151\156\147\040\154\151\163\164\145\156\145\162\040\150\157\163\164\040\111\120\040\146\141\151\154\145\144\000"));
lf[19]=C_h_intern(&lf[19],17, C_text("##sys#make-string"));
lf[20]=C_h_intern_kw(&lf[20],12, C_text("domain-error"));
lf[21]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\151\156\166\141\154\151\144\040\160\157\162\164\040\156\165\155\142\145\162\000"));
lf[22]=C_h_intern(&lf[22],25, C_text("chicken.tcp#tcp-listener?"));
lf[23]=C_h_intern(&lf[23],21, C_text("chicken.tcp#tcp-close"));
lf[24]=C_h_intern(&lf[24],9, C_text("tcp-close"));
lf[25]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\030\143\141\156\156\157\164\040\143\154\157\163\145\040\124\103\120\040\163\157\143\153\145\164\000"));
lf[26]=C_h_intern(&lf[26],27, C_text("chicken.tcp#tcp-buffer-size"));
lf[27]=C_h_intern(&lf[27],28, C_text("chicken.tcp#tcp-read-timeout"));
lf[28]=C_h_intern(&lf[28],29, C_text("chicken.tcp#tcp-write-timeout"));
lf[29]=C_h_intern(&lf[29],31, C_text("chicken.tcp#tcp-connect-timeout"));
lf[30]=C_h_intern(&lf[30],30, C_text("chicken.tcp#tcp-accept-timeout"));
lf[32]=C_h_intern(&lf[32],20, C_text("##sys#current-thread"));
lf[33]=C_h_intern_kw(&lf[33],21, C_text("network-timeout-error"));
lf[34]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\162\145\141\144\040\157\160\145\162\141\164\151\157\156\040\164\151\155\145\144\040\157\165\164\000"));
lf[35]=C_h_intern(&lf[35],19, C_text("##sys#thread-yield!"));
lf[36]=C_h_intern(&lf[36],27, C_text("##sys#thread-block-for-i/o!"));
lf[37]=C_h_intern_kw(&lf[37],5, C_text("input"));
lf[38]=C_h_intern(&lf[38],31, C_text("##sys#thread-block-for-timeout!"));
lf[39]=C_h_intern(&lf[39],24, C_text("##sys#dispatch-interrupt"));
lf[40]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\030\143\141\156\156\157\164\040\162\145\141\144\040\146\162\157\155\040\163\157\143\153\145\164\000"));
lf[41]=C_h_intern(&lf[41],41, C_text("chicken.time#current-process-milliseconds"));
lf[42]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\032\167\162\151\164\145\040\157\160\145\162\141\164\151\157\156\040\164\151\155\145\144\040\157\165\164\000"));
lf[43]=C_h_intern_kw(&lf[43],6, C_text("output"));
lf[44]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\027\143\141\156\156\157\164\040\167\162\151\164\145\040\164\157\040\163\157\143\153\145\164\000"));
lf[45]=C_h_intern(&lf[45],19, C_text("##sys#encode-buffer"));
lf[46]=C_h_intern(&lf[46],21, C_text("##sys#make-bytevector"));
lf[47]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\040\143\141\156\156\157\164\040\143\154\157\163\145\040\163\157\143\153\145\164\040\157\165\164\160\165\164\040\160\157\162\164\000"));
lf[48]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\006\050\164\143\160\051\000"));
lf[49]=C_h_intern(&lf[49],6, C_text("socket"));
lf[50]=C_h_intern(&lf[50],20, C_text("##sys#set-port-data!"));
lf[51]=C_h_intern(&lf[51],15, C_text("##sys#make-port"));
lf[52]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\006\050\164\143\160\051\000"));
lf[53]=C_h_intern(&lf[53],19, C_text("##sys#decode-buffer"));
lf[54]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\143\141\156\156\157\164\040\143\150\145\143\153\040\163\157\143\153\145\164\040\146\157\162\040\151\156\160\165\164\000"));
lf[55]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\143\141\156\156\157\164\040\143\154\157\163\145\040\163\157\143\153\145\164\040\151\156\160\165\164\040\160\157\162\164\000"));
lf[56]=C_h_intern(&lf[56],35, C_text("chicken.fixnum#most-positive-fixnum"));
lf[57]=C_h_intern(&lf[57],22, C_text("##sys#scan-buffer-line"));
lf[58]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\001\000"));
lf[59]=C_h_intern(&lf[59],29, C_text("##sys#buffer->string/encoding"));
lf[60]=C_h_intern(&lf[60],28, C_text("chicken.port#make-input-port"));
lf[61]=C_h_intern_kw(&lf[61],9, C_text("peek-char"));
lf[62]=C_h_intern_kw(&lf[62],15, C_text("read-bytevector"));
lf[63]=C_h_intern_kw(&lf[63],9, C_text("read-line"));
lf[64]=C_h_intern_kw(&lf[64],13, C_text("read-buffered"));
lf[65]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\030\143\141\156\156\157\164\040\143\162\145\141\164\145\040\124\103\120\040\160\157\162\164\163\000"));
lf[66]=C_h_intern(&lf[66],22, C_text("chicken.tcp#tcp-accept"));
lf[67]=C_h_intern(&lf[67],5, C_text("utf-8"));
lf[68]=C_h_intern(&lf[68],10, C_text("tcp-accept"));
lf[69]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\037\143\157\165\154\144\040\156\157\164\040\141\143\143\145\160\164\040\146\162\157\155\040\154\151\163\164\145\156\145\162\000"));
lf[70]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\141\143\143\145\160\164\040\157\160\145\162\141\164\151\157\156\040\164\151\155\145\144\040\157\165\164\000"));
lf[71]=C_h_intern(&lf[71],29, C_text("chicken.tcp#tcp-accept-ready?"));
lf[72]=C_h_intern(&lf[72],17, C_text("tcp-accept-ready?"));
lf[73]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\143\141\156\156\157\164\040\143\150\145\143\153\040\163\157\143\153\145\164\040\146\157\162\040\151\156\160\165\164\000"));
lf[74]=C_h_intern(&lf[74],23, C_text("chicken.tcp#tcp-connect"));
lf[75]=C_h_intern(&lf[75],11, C_text("tcp-connect"));
lf[76]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\024\147\145\164\163\157\143\153\157\160\164\050\051\040\146\141\151\154\145\144\000"));
lf[77]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\025\143\141\156\156\157\164\040\143\162\145\141\164\145\040\163\157\143\153\145\164\000"));
lf[78]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\143\141\156\156\157\164\040\143\157\156\156\145\143\164\040\164\157\040\163\157\143\153\145\164\000"));
lf[79]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\017\146\143\156\164\154\050\051\040\146\141\151\154\145\144\000"));
lf[80]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\145\162\162\157\162\040\167\150\151\154\145\040\163\145\164\164\151\156\147\040\165\160\040\163\157\143\153\145\164\000"));
lf[81]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\025\143\141\156\156\157\164\040\143\162\145\141\164\145\040\163\157\143\153\145\164\000"));
lf[82]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\031\143\141\156\156\157\164\040\146\151\156\144\040\150\157\163\164\040\141\144\144\162\145\163\163\000"));
lf[83]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\022\156\157\040\160\157\162\164\040\163\160\145\143\151\146\151\145\144\000"));
lf[84]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\004\164\143\160\000"));
lf[85]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\041\143\141\156\156\157\164\040\143\157\155\160\165\164\145\040\160\157\162\164\040\146\162\157\155\040\163\145\162\166\151\143\145\000"));
lf[86]=C_h_intern(&lf[86],16, C_text("scheme#substring"));
lf[88]=C_h_intern(&lf[88],18, C_text("chicken.base#error"));
lf[89]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\052\141\162\147\165\155\145\156\164\040\144\157\145\163\040\156\157\164\040\141\160\160\145\141\162\040\164\157\040\142\145\040\141\040\124\103\120\040\160\157\162\164\000"));
lf[90]=C_h_intern(&lf[90],15, C_text("##sys#port-data"));
lf[91]=C_h_intern(&lf[91],25, C_text("chicken.tcp#tcp-addresses"));
lf[92]=C_h_intern(&lf[92],13, C_text("tcp-addresses"));
lf[93]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\036\143\141\156\156\157\164\040\143\157\155\160\165\164\145\040\162\145\155\157\164\145\040\141\144\144\162\145\163\163\000"));
lf[94]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\035\143\141\156\156\157\164\040\143\157\155\160\165\164\145\040\154\157\143\141\154\040\141\144\144\162\145\163\163\000"));
lf[95]=C_h_intern(&lf[95],28, C_text("chicken.tcp#tcp-port-numbers"));
lf[96]=C_h_intern(&lf[96],16, C_text("tcp-port-numbers"));
lf[97]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\033\143\141\156\156\157\164\040\143\157\155\160\165\164\145\040\162\145\155\157\164\145\040\160\157\162\164\000"));
lf[98]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\032\143\141\156\156\157\164\040\143\157\155\160\165\164\145\040\154\157\143\141\154\040\160\157\162\164\000"));
lf[99]=C_h_intern(&lf[99],29, C_text("chicken.tcp#tcp-listener-port"));
lf[100]=C_h_intern(&lf[100],17, C_text("tcp-listener-port"));
lf[101]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\034\143\141\156\156\157\164\040\157\142\164\141\151\156\040\154\151\163\164\145\156\145\162\040\160\157\162\164\000"));
lf[102]=C_h_intern(&lf[102],28, C_text("chicken.tcp#tcp-abandon-port"));
lf[103]=C_h_intern(&lf[103],16, C_text("tcp-abandon-port"));
lf[104]=C_h_intern(&lf[104],31, C_text("chicken.tcp#tcp-listener-fileno"));
lf[105]=C_h_intern(&lf[105],19, C_text("tcp-listener-fileno"));
lf[106]=C_h_intern(&lf[106],21, C_text("scheme#make-parameter"));
lf[107]=C_h_intern(&lf[107],18, C_text("tcp-accept-timeout"));
lf[108]=C_h_intern(&lf[108],19, C_text("tcp-connect-timeout"));
lf[109]=C_h_intern(&lf[109],17, C_text("tcp-write-timeout"));
lf[110]=C_h_intern(&lf[110],16, C_text("tcp-read-timeout"));
lf[111]=C_decode_literal(C_heaptop,C_text("\376\002\000\000\032\143\141\156\156\157\164\040\151\156\151\164\151\141\154\151\172\145\040\127\151\156\163\157\143\153\000"));
C_register_lf2(lf,112,create_ptable());{}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1065,a[2]=t1,tmp=(C_word)a,a+=3,tmp);{
C_word *av2=av;
av2[0]=C_SCHEME_UNDEFINED;
av2[1]=t2;
C_port_toplevel(2,av2);}}

#ifdef C_ENABLE_PTABLES
static C_PTABLE_ENTRY ptable[223] = {
{C_text("f3609:tcp_2escm"),(void*)f3609},
{C_text("f_1065:tcp_2escm"),(void*)f_1065},
{C_text("f_1068:tcp_2escm"),(void*)f_1068},
{C_text("f_1071:tcp_2escm"),(void*)f_1071},
{C_text("f_1299:tcp_2escm"),(void*)f_1299},
{C_text("f_1306:tcp_2escm"),(void*)f_1306},
{C_text("f_1310:tcp_2escm"),(void*)f_1310},
{C_text("f_1326:tcp_2escm"),(void*)f_1326},
{C_text("f_1335:tcp_2escm"),(void*)f_1335},
{C_text("f_1358:tcp_2escm"),(void*)f_1358},
{C_text("f_1383:tcp_2escm"),(void*)f_1383},
{C_text("f_1387:tcp_2escm"),(void*)f_1387},
{C_text("f_1390:tcp_2escm"),(void*)f_1390},
{C_text("f_1393:tcp_2escm"),(void*)f_1393},
{C_text("f_1403:tcp_2escm"),(void*)f_1403},
{C_text("f_1407:tcp_2escm"),(void*)f_1407},
{C_text("f_1411:tcp_2escm"),(void*)f_1411},
{C_text("f_1446:tcp_2escm"),(void*)f_1446},
{C_text("f_1449:tcp_2escm"),(void*)f_1449},
{C_text("f_1455:tcp_2escm"),(void*)f_1455},
{C_text("f_1458:tcp_2escm"),(void*)f_1458},
{C_text("f_1461:tcp_2escm"),(void*)f_1461},
{C_text("f_1477:tcp_2escm"),(void*)f_1477},
{C_text("f_1481:tcp_2escm"),(void*)f_1481},
{C_text("f_1485:tcp_2escm"),(void*)f_1485},
{C_text("f_1501:tcp_2escm"),(void*)f_1501},
{C_text("f_1505:tcp_2escm"),(void*)f_1505},
{C_text("f_1509:tcp_2escm"),(void*)f_1509},
{C_text("f_1531:tcp_2escm"),(void*)f_1531},
{C_text("f_1540:tcp_2escm"),(void*)f_1540},
{C_text("f_1559:tcp_2escm"),(void*)f_1559},
{C_text("f_1565:tcp_2escm"),(void*)f_1565},
{C_text("f_1568:tcp_2escm"),(void*)f_1568},
{C_text("f_1587:tcp_2escm"),(void*)f_1587},
{C_text("f_1591:tcp_2escm"),(void*)f_1591},
{C_text("f_1595:tcp_2escm"),(void*)f_1595},
{C_text("f_1639:tcp_2escm"),(void*)f_1639},
{C_text("f_1648:tcp_2escm"),(void*)f_1648},
{C_text("f_1668:tcp_2escm"),(void*)f_1668},
{C_text("f_1672:tcp_2escm"),(void*)f_1672},
{C_text("f_1676:tcp_2escm"),(void*)f_1676},
{C_text("f_1690:tcp_2escm"),(void*)f_1690},
{C_text("f_1696:tcp_2escm"),(void*)f_1696},
{C_text("f_1698:tcp_2escm"),(void*)f_1698},
{C_text("f_1713:tcp_2escm"),(void*)f_1713},
{C_text("f_1717:tcp_2escm"),(void*)f_1717},
{C_text("f_1721:tcp_2escm"),(void*)f_1721},
{C_text("f_1725:tcp_2escm"),(void*)f_1725},
{C_text("f_1727:tcp_2escm"),(void*)f_1727},
{C_text("f_1731:tcp_2escm"),(void*)f_1731},
{C_text("f_1734:tcp_2escm"),(void*)f_1734},
{C_text("f_1740:tcp_2escm"),(void*)f_1740},
{C_text("f_1743:tcp_2escm"),(void*)f_1743},
{C_text("f_1744:tcp_2escm"),(void*)f_1744},
{C_text("f_1748:tcp_2escm"),(void*)f_1748},
{C_text("f_1751:tcp_2escm"),(void*)f_1751},
{C_text("f_1756:tcp_2escm"),(void*)f_1756},
{C_text("f_1775:tcp_2escm"),(void*)f_1775},
{C_text("f_1778:tcp_2escm"),(void*)f_1778},
{C_text("f_1781:tcp_2escm"),(void*)f_1781},
{C_text("f_1784:tcp_2escm"),(void*)f_1784},
{C_text("f_1812:tcp_2escm"),(void*)f_1812},
{C_text("f_1816:tcp_2escm"),(void*)f_1816},
{C_text("f_1820:tcp_2escm"),(void*)f_1820},
{C_text("f_1838:tcp_2escm"),(void*)f_1838},
{C_text("f_1841:tcp_2escm"),(void*)f_1841},
{C_text("f_1842:tcp_2escm"),(void*)f_1842},
{C_text("f_1846:tcp_2escm"),(void*)f_1846},
{C_text("f_1855:tcp_2escm"),(void*)f_1855},
{C_text("f_1863:tcp_2escm"),(void*)f_1863},
{C_text("f_1865:tcp_2escm"),(void*)f_1865},
{C_text("f_1887:tcp_2escm"),(void*)f_1887},
{C_text("f_1890:tcp_2escm"),(void*)f_1890},
{C_text("f_1893:tcp_2escm"),(void*)f_1893},
{C_text("f_1896:tcp_2escm"),(void*)f_1896},
{C_text("f_1919:tcp_2escm"),(void*)f_1919},
{C_text("f_1930:tcp_2escm"),(void*)f_1930},
{C_text("f_1934:tcp_2escm"),(void*)f_1934},
{C_text("f_1938:tcp_2escm"),(void*)f_1938},
{C_text("f_1978:tcp_2escm"),(void*)f_1978},
{C_text("f_1985:tcp_2escm"),(void*)f_1985},
{C_text("f_1986:tcp_2escm"),(void*)f_1986},
{C_text("f_1992:tcp_2escm"),(void*)f_1992},
{C_text("f_2014:tcp_2escm"),(void*)f_2014},
{C_text("f_2036:tcp_2escm"),(void*)f_2036},
{C_text("f_2045:tcp_2escm"),(void*)f_2045},
{C_text("f_2048:tcp_2escm"),(void*)f_2048},
{C_text("f_2061:tcp_2escm"),(void*)f_2061},
{C_text("f_2065:tcp_2escm"),(void*)f_2065},
{C_text("f_2076:tcp_2escm"),(void*)f_2076},
{C_text("f_2097:tcp_2escm"),(void*)f_2097},
{C_text("f_2105:tcp_2escm"),(void*)f_2105},
{C_text("f_2108:tcp_2escm"),(void*)f_2108},
{C_text("f_2114:tcp_2escm"),(void*)f_2114},
{C_text("f_2121:tcp_2escm"),(void*)f_2121},
{C_text("f_2125:tcp_2escm"),(void*)f_2125},
{C_text("f_2129:tcp_2escm"),(void*)f_2129},
{C_text("f_2154:tcp_2escm"),(void*)f_2154},
{C_text("f_2160:tcp_2escm"),(void*)f_2160},
{C_text("f_2170:tcp_2escm"),(void*)f_2170},
{C_text("f_2176:tcp_2escm"),(void*)f_2176},
{C_text("f_2180:tcp_2escm"),(void*)f_2180},
{C_text("f_2195:tcp_2escm"),(void*)f_2195},
{C_text("f_2208:tcp_2escm"),(void*)f_2208},
{C_text("f_2221:tcp_2escm"),(void*)f_2221},
{C_text("f_2234:tcp_2escm"),(void*)f_2234},
{C_text("f_2238:tcp_2escm"),(void*)f_2238},
{C_text("f_2242:tcp_2escm"),(void*)f_2242},
{C_text("f_2250:tcp_2escm"),(void*)f_2250},
{C_text("f_2258:tcp_2escm"),(void*)f_2258},
{C_text("f_2264:tcp_2escm"),(void*)f_2264},
{C_text("f_2271:tcp_2escm"),(void*)f_2271},
{C_text("f_2275:tcp_2escm"),(void*)f_2275},
{C_text("f_2279:tcp_2escm"),(void*)f_2279},
{C_text("f_2300:tcp_2escm"),(void*)f_2300},
{C_text("f_2304:tcp_2escm"),(void*)f_2304},
{C_text("f_2319:tcp_2escm"),(void*)f_2319},
{C_text("f_2328:tcp_2escm"),(void*)f_2328},
{C_text("f_2334:tcp_2escm"),(void*)f_2334},
{C_text("f_2378:tcp_2escm"),(void*)f_2378},
{C_text("f_2389:tcp_2escm"),(void*)f_2389},
{C_text("f_2393:tcp_2escm"),(void*)f_2393},
{C_text("f_2407:tcp_2escm"),(void*)f_2407},
{C_text("f_2417:tcp_2escm"),(void*)f_2417},
{C_text("f_2433:tcp_2escm"),(void*)f_2433},
{C_text("f_2467:tcp_2escm"),(void*)f_2467},
{C_text("f_2512:tcp_2escm"),(void*)f_2512},
{C_text("f_2522:tcp_2escm"),(void*)f_2522},
{C_text("f_2549:tcp_2escm"),(void*)f_2549},
{C_text("f_2553:tcp_2escm"),(void*)f_2553},
{C_text("f_2557:tcp_2escm"),(void*)f_2557},
{C_text("f_2561:tcp_2escm"),(void*)f_2561},
{C_text("f_2574:tcp_2escm"),(void*)f_2574},
{C_text("f_2577:tcp_2escm"),(void*)f_2577},
{C_text("f_2582:tcp_2escm"),(void*)f_2582},
{C_text("f_2586:tcp_2escm"),(void*)f_2586},
{C_text("f_2589:tcp_2escm"),(void*)f_2589},
{C_text("f_2592:tcp_2escm"),(void*)f_2592},
{C_text("f_2595:tcp_2escm"),(void*)f_2595},
{C_text("f_2623:tcp_2escm"),(void*)f_2623},
{C_text("f_2627:tcp_2escm"),(void*)f_2627},
{C_text("f_2631:tcp_2escm"),(void*)f_2631},
{C_text("f_2657:tcp_2escm"),(void*)f_2657},
{C_text("f_2665:tcp_2escm"),(void*)f_2665},
{C_text("f_2675:tcp_2escm"),(void*)f_2675},
{C_text("f_2688:tcp_2escm"),(void*)f_2688},
{C_text("f_2692:tcp_2escm"),(void*)f_2692},
{C_text("f_2696:tcp_2escm"),(void*)f_2696},
{C_text("f_2715:tcp_2escm"),(void*)f_2715},
{C_text("f_2731:tcp_2escm"),(void*)f_2731},
{C_text("f_2734:tcp_2escm"),(void*)f_2734},
{C_text("f_2737:tcp_2escm"),(void*)f_2737},
{C_text("f_2743:tcp_2escm"),(void*)f_2743},
{C_text("f_2749:tcp_2escm"),(void*)f_2749},
{C_text("f_2755:tcp_2escm"),(void*)f_2755},
{C_text("f_2758:tcp_2escm"),(void*)f_2758},
{C_text("f_2761:tcp_2escm"),(void*)f_2761},
{C_text("f_2764:tcp_2escm"),(void*)f_2764},
{C_text("f_2770:tcp_2escm"),(void*)f_2770},
{C_text("f_2789:tcp_2escm"),(void*)f_2789},
{C_text("f_2793:tcp_2escm"),(void*)f_2793},
{C_text("f_2797:tcp_2escm"),(void*)f_2797},
{C_text("f_2815:tcp_2escm"),(void*)f_2815},
{C_text("f_2819:tcp_2escm"),(void*)f_2819},
{C_text("f_2823:tcp_2escm"),(void*)f_2823},
{C_text("f_2827:tcp_2escm"),(void*)f_2827},
{C_text("f_2843:tcp_2escm"),(void*)f_2843},
{C_text("f_2846:tcp_2escm"),(void*)f_2846},
{C_text("f_2874:tcp_2escm"),(void*)f_2874},
{C_text("f_2878:tcp_2escm"),(void*)f_2878},
{C_text("f_2882:tcp_2escm"),(void*)f_2882},
{C_text("f_2901:tcp_2escm"),(void*)f_2901},
{C_text("f_2905:tcp_2escm"),(void*)f_2905},
{C_text("f_2909:tcp_2escm"),(void*)f_2909},
{C_text("f_2927:tcp_2escm"),(void*)f_2927},
{C_text("f_2931:tcp_2escm"),(void*)f_2931},
{C_text("f_2935:tcp_2escm"),(void*)f_2935},
{C_text("f_2951:tcp_2escm"),(void*)f_2951},
{C_text("f_2955:tcp_2escm"),(void*)f_2955},
{C_text("f_2959:tcp_2escm"),(void*)f_2959},
{C_text("f_2968:tcp_2escm"),(void*)f_2968},
{C_text("f_2974:tcp_2escm"),(void*)f_2974},
{C_text("f_2982:tcp_2escm"),(void*)f_2982},
{C_text("f_2988:tcp_2escm"),(void*)f_2988},
{C_text("f_2999:tcp_2escm"),(void*)f_2999},
{C_text("f_3025:tcp_2escm"),(void*)f_3025},
{C_text("f_3029:tcp_2escm"),(void*)f_3029},
{C_text("f_3043:tcp_2escm"),(void*)f_3043},
{C_text("f_3049:tcp_2escm"),(void*)f_3049},
{C_text("f_3056:tcp_2escm"),(void*)f_3056},
{C_text("f_3059:tcp_2escm"),(void*)f_3059},
{C_text("f_3063:tcp_2escm"),(void*)f_3063},
{C_text("f_3066:tcp_2escm"),(void*)f_3066},
{C_text("f_3073:tcp_2escm"),(void*)f_3073},
{C_text("f_3077:tcp_2escm"),(void*)f_3077},
{C_text("f_3081:tcp_2escm"),(void*)f_3081},
{C_text("f_3094:tcp_2escm"),(void*)f_3094},
{C_text("f_3098:tcp_2escm"),(void*)f_3098},
{C_text("f_3102:tcp_2escm"),(void*)f_3102},
{C_text("f_3110:tcp_2escm"),(void*)f_3110},
{C_text("f_3116:tcp_2escm"),(void*)f_3116},
{C_text("f_3125:tcp_2escm"),(void*)f_3125},
{C_text("f_3128:tcp_2escm"),(void*)f_3128},
{C_text("f_3141:tcp_2escm"),(void*)f_3141},
{C_text("f_3145:tcp_2escm"),(void*)f_3145},
{C_text("f_3149:tcp_2escm"),(void*)f_3149},
{C_text("f_3165:tcp_2escm"),(void*)f_3165},
{C_text("f_3169:tcp_2escm"),(void*)f_3169},
{C_text("f_3173:tcp_2escm"),(void*)f_3173},
{C_text("f_3181:tcp_2escm"),(void*)f_3181},
{C_text("f_3194:tcp_2escm"),(void*)f_3194},
{C_text("f_3204:tcp_2escm"),(void*)f_3204},
{C_text("f_3208:tcp_2escm"),(void*)f_3208},
{C_text("f_3212:tcp_2escm"),(void*)f_3212},
{C_text("f_3220:tcp_2escm"),(void*)f_3220},
{C_text("f_3230:tcp_2escm"),(void*)f_3230},
{C_text("f_3236:tcp_2escm"),(void*)f_3236},
{C_text("f_3247:tcp_2escm"),(void*)f_3247},
{C_text("f_3251:tcp_2escm"),(void*)f_3251},
{C_text("f_3255:tcp_2escm"),(void*)f_3255},
{C_text("f_3259:tcp_2escm"),(void*)f_3259},
{C_text("toplevel:tcp_2escm"),(void*)C_tcp_toplevel},
{NULL,NULL}};
#endif

static C_PTABLE_ENTRY *create_ptable(void){
#ifdef C_ENABLE_PTABLES
return ptable;
#else
return NULL;
#endif
}

/*
o|hiding unexported module binding: chicken.tcp#d 
o|hiding unexported module binding: chicken.tcp#define-alias 
o|hiding unexported module binding: chicken.tcp#last-error-code 
o|hiding unexported module binding: chicken.tcp#error-code->message 
o|hiding unexported module binding: chicken.tcp#retry? 
o|hiding unexported module binding: chicken.tcp#in-progress? 
o|hiding unexported module binding: chicken.tcp#interrupted? 
o|hiding unexported module binding: chicken.tcp#socket 
o|hiding unexported module binding: chicken.tcp#bind 
o|hiding unexported module binding: chicken.tcp#listen 
o|hiding unexported module binding: chicken.tcp#accept 
o|hiding unexported module binding: chicken.tcp#close 
o|hiding unexported module binding: chicken.tcp#recv 
o|hiding unexported module binding: chicken.tcp#shutdown 
o|hiding unexported module binding: chicken.tcp#connect 
o|hiding unexported module binding: chicken.tcp#check-fd-ready 
o|hiding unexported module binding: chicken.tcp#set-socket-options 
o|hiding unexported module binding: chicken.tcp#send 
o|hiding unexported module binding: chicken.tcp#getsockname 
o|hiding unexported module binding: chicken.tcp#getsockport 
o|hiding unexported module binding: chicken.tcp#getpeerport 
o|hiding unexported module binding: chicken.tcp#getpeername 
o|hiding unexported module binding: chicken.tcp#startup 
o|hiding unexported module binding: chicken.tcp#getservbyname 
o|hiding unexported module binding: chicken.tcp#gethostaddr 
o|hiding unexported module binding: chicken.tcp#network-error 
o|hiding unexported module binding: chicken.tcp#network-error/close 
o|hiding unexported module binding: chicken.tcp#network-error/code 
o|hiding unexported module binding: chicken.tcp#parse-host 
o|hiding unexported module binding: chicken.tcp#fresh-addr 
o|hiding unexported module binding: chicken.tcp#bind-socket 
o|hiding unexported module binding: chicken.tcp#io-ports 
o|hiding unexported module binding: chicken.tcp#get-socket-error 
o|hiding unexported module binding: chicken.tcp#tcp-port->fileno 
o|eliminated procedure checks: 69 
o|specializations:
o|  3 (##sys#check-open-port * *)
o|  2 (scheme#make-string fixnum)
o|  24 (scheme#string-append string string)
o|  1 (scheme#char=? char char)
(o e)|safe calls: 364 
(o e)|assignments to immediate values: 10 
o|safe globals: (chicken.tcp#startup chicken.tcp#getpeername chicken.tcp#getpeerport chicken.tcp#getsockport chicken.tcp#getsockname chicken.tcp#send chicken.tcp#set-socket-options chicken.tcp#check-fd-ready chicken.tcp#connect chicken.tcp#shutdown chicken.tcp#recv chicken.tcp#close chicken.tcp#accept chicken.tcp#listen chicken.tcp#bind chicken.tcp#socket chicken.tcp#interrupted? chicken.tcp#in-progress? chicken.tcp#retry? chicken.tcp#error-code->message chicken.tcp#last-error-code) 
o|inlining procedure: k1360 
o|inlining procedure: k1360 
o|substituted constant variable: a1376 
o|inlining procedure: k1391 
o|inlining procedure: "(tcp.scm:291) chicken.tcp#last-error-code" 
o|substituted constant variable: a1416 
o|substituted constant variable: a1417 
o|inlining procedure: k1391 
o|contracted procedure: "(tcp.scm:289) chicken.tcp#getservbyname" 
o|inlining procedure: k1308 
o|inlining procedure: k1308 
o|inlining procedure: k1566 
o|substituted constant variable: a1596 
o|substituted constant variable: a1597 
o|inlining procedure: "(tcp.scm:330) chicken.tcp#close" 
o|inlining procedure: "(tcp.scm:330) chicken.tcp#last-error-code" 
o|inlining procedure: k1566 
o|contracted procedure: "(tcp.scm:329) chicken.tcp#listen" 
o|contracted procedure: "(tcp.scm:328) chicken.tcp#bind-socket" 
o|inlining procedure: k1459 
o|substituted constant variable: a1486 
o|substituted constant variable: a1487 
o|inlining procedure: "(tcp.scm:318) chicken.tcp#close" 
o|inlining procedure: "(tcp.scm:318) chicken.tcp#last-error-code" 
o|inlining procedure: k1459 
o|contracted procedure: "(tcp.scm:317) chicken.tcp#bind" 
o|inlining procedure: "(tcp.scm:316) chicken.tcp#last-error-code" 
o|substituted constant variable: a1514 
o|substituted constant variable: a1515 
o|inlining procedure: "(tcp.scm:315) chicken.tcp#set-socket-options" 
o|inlining procedure: k1526 
o|inlining procedure: k1526 
o|contracted procedure: "(tcp.scm:310) chicken.tcp#fresh-addr" 
o|inlining procedure: k1641 
o|inlining procedure: k1641 
o|inlining procedure: k1656 
o|inlining procedure: "(tcp.scm:341) chicken.tcp#last-error-code" 
o|substituted constant variable: a1681 
o|substituted constant variable: a1682 
o|inlining procedure: k1656 
o|inlining procedure: "(tcp.scm:340) chicken.tcp#close" 
o|inlining procedure: k1700 
o|inlining procedure: k1700 
o|inlining procedure: k1761 
o|inlining procedure: k1782 
o|inlining procedure: k1782 
o|inlining procedure: k1797 
o|inlining procedure: k1797 
o|inlining procedure: "(tcp.scm:398) chicken.tcp#last-error-code" 
o|substituted constant variable: a1825 
o|substituted constant variable: a1826 
o|inlining procedure: "(tcp.scm:395) chicken.tcp#interrupted?" 
o|inlining procedure: "(tcp.scm:384) chicken.tcp#retry?" 
o|inlining procedure: k1761 
o|contracted procedure: "(tcp.scm:382) chicken.tcp#recv" 
o|inlining procedure: k1873 
o|inlining procedure: k1909 
o|inlining procedure: k1909 
o|inlining procedure: "(tcp.scm:521) chicken.tcp#last-error-code" 
o|substituted constant variable: a1943 
o|substituted constant variable: a1944 
o|inlining procedure: "(tcp.scm:517) chicken.tcp#interrupted?" 
o|inlining procedure: "(tcp.scm:508) chicken.tcp#retry?" 
o|inlining procedure: k1873 
o|inlining procedure: k1963 
o|inlining procedure: k1963 
o|contracted procedure: "(tcp.scm:506) chicken.tcp#send" 
o|inlining procedure: k1994 
o|inlining procedure: k1994 
o|inlining procedure: k2066 
o|inlining procedure: k2066 
o|inlining procedure: k2081 
o|inlining procedure: k2081 
o|inlining procedure: k2099 
o|inlining procedure: k2099 
o|inlining procedure: "(tcp.scm:568) chicken.tcp#last-error-code" 
o|substituted constant variable: a2134 
o|substituted constant variable: a2135 
o|inlining procedure: "(tcp.scm:567) chicken.tcp#close" 
o|inlining procedure: k2162 
o|inlining procedure: k2162 
o|inlining procedure: k2181 
o|inlining procedure: k2181 
o|inlining procedure: k2213 
o|inlining procedure: k2213 
o|inlining procedure: "(tcp.scm:421) chicken.tcp#last-error-code" 
o|substituted constant variable: a2247 
o|substituted constant variable: a2248 
o|inlining procedure: "(tcp.scm:419) chicken.tcp#check-fd-ready" 
o|inlining procedure: k2252 
o|inlining procedure: k2252 
o|inlining procedure: "(tcp.scm:428) chicken.tcp#last-error-code" 
o|substituted constant variable: a2284 
o|substituted constant variable: a2285 
o|inlining procedure: "(tcp.scm:427) chicken.tcp#close" 
o|inlining procedure: k2305 
o|inlining procedure: k2305 
o|inlining procedure: k2336 
o|inlining procedure: k2336 
o|inlining procedure: k2379 
o|inlining procedure: k2379 
o|inlining procedure: k2394 
o|inlining procedure: k2394 
o|inlining procedure: k2422 
o|inlining procedure: k2422 
o|inlining procedure: k2469 
o|inlining procedure: k2469 
o|inlining procedure: k2514 
o|inlining procedure: k2514 
o|inlining procedure: k2528 
o|inlining procedure: k2528 
o|substituted constant variable: a2558 
o|substituted constant variable: a2559 
o|inlining procedure: "(tcp.scm:366) chicken.tcp#close" 
o|inlining procedure: "(tcp.scm:366) chicken.tcp#last-error-code" 
o|inlining procedure: k2599 
o|inlining procedure: k2599 
o|inlining procedure: "(tcp.scm:609) chicken.tcp#last-error-code" 
o|substituted constant variable: a2636 
o|substituted constant variable: a2637 
o|inlining procedure: "(tcp.scm:606) chicken.tcp#interrupted?" 
o|contracted procedure: "(tcp.scm:603) chicken.tcp#accept" 
o|inlining procedure: k1151 
o|inlining procedure: k1151 
o|inlining procedure: k2673 
o|inlining procedure: "(tcp.scm:616) chicken.tcp#last-error-code" 
o|substituted constant variable: a2701 
o|substituted constant variable: a2702 
o|inlining procedure: k2673 
o|inlining procedure: "(tcp.scm:614) chicken.tcp#check-fd-ready" 
o|substituted constant variable: a2798 
o|substituted constant variable: a2799 
o|inlining procedure: "(tcp.scm:659) chicken.tcp#close" 
o|inlining procedure: "(tcp.scm:659) chicken.tcp#last-error-code" 
o|inlining procedure: k2800 
o|substituted constant variable: a2824 
o|substituted constant variable: a2825 
o|inlining procedure: "(tcp.scm:661) chicken.tcp#close" 
o|inlining procedure: k2800 
o|contracted procedure: "(tcp.scm:657) chicken.tcp#get-socket-error" 
o|inlining procedure: k2829 
o|inlining procedure: k2853 
o|inlining procedure: k2853 
o|substituted constant variable: a2883 
o|substituted constant variable: a2884 
o|inlining procedure: "(tcp.scm:655) chicken.tcp#close" 
o|inlining procedure: "(tcp.scm:655) chicken.tcp#last-error-code" 
o|inlining procedure: "(tcp.scm:652) chicken.tcp#interrupted?" 
o|contracted procedure: "(tcp.scm:647) chicken.tcp#in-progress?" 
o|inlining procedure: k2829 
o|contracted procedure: "(tcp.scm:646) chicken.tcp#connect" 
o|substituted constant variable: a2910 
o|substituted constant variable: a2911 
o|inlining procedure: "(tcp.scm:644) chicken.tcp#close" 
o|inlining procedure: "(tcp.scm:644) chicken.tcp#last-error-code" 
o|substituted constant variable: a2936 
o|substituted constant variable: a2937 
o|inlining procedure: "(tcp.scm:642) chicken.tcp#close" 
o|inlining procedure: "(tcp.scm:642) chicken.tcp#last-error-code" 
o|inlining procedure: "(tcp.scm:641) chicken.tcp#set-socket-options" 
o|inlining procedure: "(tcp.scm:640) chicken.tcp#last-error-code" 
o|substituted constant variable: a2964 
o|substituted constant variable: a2965 
o|inlining procedure: k2975 
o|inlining procedure: k2975 
o|inlining procedure: k3030 
o|inlining procedure: k3030 
o|substituted constant variable: a3046 
o|inlining procedure: k3064 
o|inlining procedure: k3064 
o|inlining procedure: "(tcp.scm:678) chicken.tcp#last-error-code" 
o|substituted constant variable: a3086 
o|substituted constant variable: a3087 
o|contracted procedure: "(tcp.scm:677) chicken.tcp#getpeername" 
o|inlining procedure: "(tcp.scm:676) chicken.tcp#last-error-code" 
o|substituted constant variable: a3107 
o|substituted constant variable: a3108 
o|contracted procedure: "(tcp.scm:675) chicken.tcp#getsockname" 
o|substituted constant variable: a3113 
o|inlining procedure: k3126 
o|inlining procedure: "(tcp.scm:688) chicken.tcp#last-error-code" 
o|substituted constant variable: a3154 
o|substituted constant variable: a3155 
o|inlining procedure: k3126 
o|inlining procedure: "(tcp.scm:686) chicken.tcp#last-error-code" 
o|substituted constant variable: a3178 
o|substituted constant variable: a3179 
o|contracted procedure: "(tcp.scm:684) chicken.tcp#getpeerport" 
o|inlining procedure: "(tcp.scm:683) chicken.tcp#getsockport" 
o|inlining procedure: k3192 
o|inlining procedure: "(tcp.scm:696) chicken.tcp#last-error-code" 
o|substituted constant variable: a3217 
o|substituted constant variable: a3218 
o|inlining procedure: k3192 
o|inlining procedure: "(tcp.scm:694) chicken.tcp#getsockport" 
o|substituted constant variable: a3223 
o|contracted procedure: "(tcp.scm:237) chicken.tcp#startup" 
o|replaced variables: 595 
o|removed binding forms: 154 
o|removed side-effect free assignment to unused variable: chicken.tcp#last-error-code 
o|removed side-effect free assignment to unused variable: chicken.tcp#retry? 
o|removed side-effect free assignment to unused variable: chicken.tcp#interrupted? 
o|removed side-effect free assignment to unused variable: chicken.tcp#close 
o|removed side-effect free assignment to unused variable: chicken.tcp#check-fd-ready 
o|removed side-effect free assignment to unused variable: chicken.tcp#set-socket-options 
o|removed side-effect free assignment to unused variable: chicken.tcp#getsockport 
o|substituted constant variable: r16423317 
o|substituted constant variable: int180187 
o|substituted constant variable: int179186 
o|inlining procedure: k1963 
o|substituted constant variable: flags222230 
o|substituted constant variable: r21823376 
o|inlining procedure: k2219 
o|substituted constant variable: r23063396 
o|substituted constant variable: r23953402 
o|substituted constant variable: r25153414 
o|substituted constant variable: r25293417 
o|substituted constant variable: c-pointer161168 
o|substituted constant variable: c-pointer161168 
o|substituted constant variable: r11523431 
o|substituted constant variable: r11523431 
o|substituted constant variable: c-pointer160167 
o|substituted constant variable: c-pointer160167 
o|inlining procedure: k2768 
o|contracted procedure: "(tcp.scm:633) chicken.tcp#parse-host" 
o|substituted constant variable: r13093277 
o|substituted constant variable: r13093277 
o|replaced variables: 148 
o|removed binding forms: 504 
o|removed conditional forms: 2 
o|inlining procedure: k1599 
o|inlining procedure: k1489 
o|inlining procedure: k1511 
o|inlining procedure: k1517 
o|inlining procedure: k1605 
o|inlining procedure: k1678 
o|inlining procedure: k1684 
o|inlining procedure: k1822 
o|inlining procedure: k1894 
o|inlining procedure: k1940 
o|substituted constant variable: r19643543 
o|inlining procedure: k2131 
o|inlining procedure: k2140 
o|inlining procedure: k2244 
o|inlining procedure: k2281 
o|inlining procedure: k2290 
o|inlining procedure: k2633 
o|contracted procedure: k1147 
o|inlining procedure: k2698 
o|inlining procedure: k2841 
o|inlining procedure: k2886 
o|inlining procedure: k2939 
o|inlining procedure: k2961 
o|inlining procedure: k1413 
o|inlining procedure: k3083 
o|inlining procedure: k3104 
o|inlining procedure: k3151 
o|inlining procedure: k3175 
o|inlining procedure: k3214 
o|inlining procedure: k3260 
o|replaced variables: 1 
o|removed binding forms: 171 
o|contracted procedure: k1575 
o|contracted procedure: k1578 
o|contracted procedure: k1465 
o|contracted procedure: k1468 
o|contracted procedure: k1758 
o|contracted procedure: k1770 
o|contracted procedure: k1800 
o|contracted procedure: k1870 
o|contracted procedure: k1882 
o|contracted procedure: k1912 
o|contracted procedure: k2216 
o|contracted procedure: k2537 
o|contracted procedure: k2540 
o|contracted procedure: k2596 
o|substituted constant variable: r1148 
o|contracted procedure: k2611 
o|contracted procedure: k2670 
o|contracted procedure: k2765 
o|contracted procedure: k2777 
o|contracted procedure: k2780 
o|contracted procedure: k2806 
o|contracted procedure: k2838 
o|contracted procedure: k2856 
o|contracted procedure: k2862 
o|contracted procedure: k2865 
o|contracted procedure: k2889 
o|contracted procedure: k2892 
o|contracted procedure: k2915 
o|contracted procedure: k2918 
o|contracted procedure: k3117 
o|contracted procedure: k3120 
o|contracted procedure: k3189 
o|simplifications: ((let . 8)) 
o|replaced variables: 1 
o|removed binding forms: 61 
o|removed binding forms: 2 
o|simplifications: ((if . 18) (##core#call . 213) (let . 27)) 
o|  call simplifications:
o|    chicken.fixnum#fx*
o|    scheme#vector?
o|    ##sys#check-string
o|    scheme#string-ref
o|    scheme#not
o|    ##sys#call-with-values	2
o|    scheme#string-length	2
o|    chicken.fixnum#fx>=	9
o|    scheme#vector	2
o|    ##sys#setslot	4
o|    scheme#values	11
o|    chicken.fixnum#fxmin	3
o|    chicken.fixnum#fx-	9
o|    chicken.fixnum#fx+	14
o|    chicken.fixnum#fx=
o|    scheme#+	5
o|    ##sys#setislot	5
o|    ##sys#check-structure	5
o|    ##sys#slot	19
o|    ##sys#structure?
o|    scheme#car	5
o|    scheme#null?	9
o|    scheme#cdr	4
o|    chicken.fixnum#fx<	6
o|    chicken.fixnum#fx>	7
o|    ##sys#check-fixnum	4
o|    scheme#eq?	27
o|    ##sys#make-structure	2
o|    ##sys#foreign-block-argument	6
o|    ##sys#foreign-string-argument	3
o|    ##sys#foreign-unsigned-ranged-integer-argument	2
o|    ##sys#foreign-fixnum-argument	41
o|contracted procedure: k1083 
o|contracted procedure: k1099 
o|contracted procedure: k1103 
o|contracted procedure: k1107 
o|contracted procedure: k1193 
o|contracted procedure: k1197 
o|contracted procedure: k1329 
o|contracted procedure: k1337 
o|contracted procedure: k1345 
o|contracted procedure: k1632 
o|contracted procedure: k1542 
o|contracted procedure: k1626 
o|contracted procedure: k1545 
o|contracted procedure: k1620 
o|contracted procedure: k1548 
o|contracted procedure: k1614 
o|contracted procedure: k1551 
o|contracted procedure: k1554 
o|contracted procedure: k1560 
o|contracted procedure: k1132 
o|contracted procedure: k1136 
o|contracted procedure: k1572 
o|contracted procedure: k11643289 
o|contracted procedure: k1114 
o|contracted procedure: k1118 
o|contracted procedure: k1122 
o|contracted procedure: k1462 
o|contracted procedure: k11643303 
o|contracted procedure: k12293313 
o|contracted procedure: k1492 
o|contracted procedure: k1520 
o|contracted procedure: k1433 
o|contracted procedure: k1437 
o|contracted procedure: k1602 
o|contracted procedure: k1605 
o|contracted procedure: k1650 
o|contracted procedure: k1653 
o|contracted procedure: k11643326 
o|contracted procedure: k1659 
o|contracted procedure: k1700 
o|contracted procedure: k1707 
o|contracted procedure: k1735 
o|contracted procedure: k1171 
o|contracted procedure: k1175 
o|contracted procedure: k1179 
o|contracted procedure: k1183 
o|contracted procedure: k1764 
o|contracted procedure: k1788 
o|contracted procedure: k1828 
o|contracted procedure: k1851 
o|contracted procedure: k1867 
o|contracted procedure: k1236 
o|contracted procedure: k1240 
o|contracted procedure: k1244 
o|contracted procedure: k1248 
o|contracted procedure: k1252 
o|contracted procedure: k1876 
o|contracted procedure: k1900 
o|contracted procedure: k1948 
o|contracted procedure: k1955 
o|contracted procedure: k1959 
o|contracted procedure: k1966 
o|contracted procedure: k1963 
o|contracted procedure: k1997 
o|contracted procedure: k2000 
o|contracted procedure: k2006 
o|contracted procedure: k2009 
o|contracted procedure: k2020 
o|contracted procedure: k2024 
o|contracted procedure: k2028 
o|contracted procedure: k2078 
o|contracted procedure: k2084 
o|contracted procedure: k11643373 
o|contracted procedure: k2143 
o|contracted procedure: k2149 
o|contracted procedure: k2165 
o|contracted procedure: k2031 
o|contracted procedure: k2037 
o|contracted procedure: k2040 
o|contracted procedure: k2051 
o|contracted procedure: k2054 
o|contracted procedure: k2184 
o|contracted procedure: k2191 
o|contracted procedure: k2198 
o|contracted procedure: k2201 
o|contracted procedure: k2210 
o|contracted procedure: k12223386 
o|contracted procedure: k2225 
o|contracted procedure: k11643395 
o|contracted procedure: k2293 
o|contracted procedure: k2308 
o|contracted procedure: k2315 
o|contracted procedure: k2321 
o|contracted procedure: k2339 
o|contracted procedure: k2345 
o|contracted procedure: k2348 
o|contracted procedure: k2373 
o|contracted procedure: k2351 
o|contracted procedure: k2355 
o|contracted procedure: k2362 
o|contracted procedure: k2366 
o|contracted procedure: k2370 
o|contracted procedure: k2382 
o|contracted procedure: k2397 
o|contracted procedure: k2400 
o|contracted procedure: k2463 
o|contracted procedure: k2413 
o|contracted procedure: k2419 
o|contracted procedure: k2425 
o|contracted procedure: k2435 
o|contracted procedure: k2441 
o|contracted procedure: k2452 
o|contracted procedure: k2448 
o|contracted procedure: k2459 
o|contracted procedure: k2484 
o|contracted procedure: k2480 
o|contracted procedure: k2473 
o|inlining procedure: k2469 
o|contracted procedure: k2495 
o|contracted procedure: k2499 
o|contracted procedure: k2491 
o|inlining procedure: k2469 
o|contracted procedure: k2505 
o|contracted procedure: k2517 
o|contracted procedure: k2525 
o|contracted procedure: k2531 
o|contracted procedure: k11643423 
o|contracted procedure: k2658 
o|contracted procedure: k2563 
o|contracted procedure: k2566 
o|contracted procedure: k2569 
o|contracted procedure: k1143 
o|contracted procedure: k2639 
o|contracted procedure: k2602 
o|contracted procedure: k2642 
o|contracted procedure: k2667 
o|contracted procedure: k2704 
o|contracted procedure: k12223449 
o|contracted procedure: k2679 
o|contracted procedure: k3018 
o|contracted procedure: k2717 
o|contracted procedure: k3012 
o|contracted procedure: k2720 
o|contracted procedure: k3006 
o|contracted procedure: k2723 
o|contracted procedure: k3000 
o|contracted procedure: k2726 
o|contracted procedure: k2738 
o|contracted procedure: k2744 
o|contracted procedure: k2711 
o|contracted procedure: k2774 
o|contracted procedure: k11643455 
o|contracted procedure: k2803 
o|contracted procedure: k11643463 
o|contracted procedure: k1204 
o|contracted procedure: k1208 
o|contracted procedure: k1212 
o|contracted procedure: k2832 
o|contracted procedure: k11643473 
o|contracted procedure: k11643482 
o|contracted procedure: k12293496 
o|contracted procedure: k2912 
o|contracted procedure: k11643489 
o|contracted procedure: k2942 
o|contracted procedure: k1351 
o|contracted procedure: k1363 
o|contracted procedure: k1369 
o|contracted procedure: k1394 
o|contracted procedure: k1315 
o|contracted procedure: k1322 
o|contracted procedure: k1419 
o|contracted procedure: k1426 
o|contracted procedure: k3033 
o|contracted procedure: k1291 
o|contracted procedure: k1266 
o|contracted procedure: k12733525 
o|contracted procedure: k1280 
o|contracted procedure: k3132 
o|contracted procedure: k3156 
o|contracted procedure: k3183 
o|contracted procedure: k3186 
o|contracted procedure: k12733536 
o|contracted procedure: k3195 
o|contracted procedure: k3232 
o|contracted procedure: k3238 
o|simplifications: ((let . 45)) 
o|removed binding forms: 183 
o|inlining procedure: k1333 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest436438 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest436438 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest436438 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest436438 0 
o|inlining procedure: "(tcp.scm:330) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:318) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:316) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:311) chicken.tcp#socket" 
o|inlining procedure: "(tcp.scm:341) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:398) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:521) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:568) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:566) chicken.tcp#shutdown" 
o|inlining procedure: "(tcp.scm:421) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:428) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:426) chicken.tcp#shutdown" 
o|inlining procedure: "(tcp.scm:366) chicken.tcp#error-code->message" 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest704706 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest704706 0 
o|inlining procedure: "(tcp.scm:609) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:616) chicken.tcp#error-code->message" 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest750752 0 
(o x)|known list op on rest arg sublist: ##core#rest-car rest750752 0 
(o x)|known list op on rest arg sublist: ##core#rest-null? rest750752 0 
(o x)|known list op on rest arg sublist: ##core#rest-cdr rest750752 0 
o|inlining procedure: "(tcp.scm:659) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:662) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:655) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:644) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:642) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:640) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:638) chicken.tcp#socket" 
o|inlining procedure: "(tcp.scm:291) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:678) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:676) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:688) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:686) chicken.tcp#error-code->message" 
o|inlining procedure: "(tcp.scm:696) chicken.tcp#error-code->message" 
o|removed binding forms: 1 
o|removed side-effect free assignment to unused variable: chicken.tcp#error-code->message 
o|removed side-effect free assignment to unused variable: chicken.tcp#socket 
o|removed side-effect free assignment to unused variable: chicken.tcp#shutdown 
o|substituted constant variable: r13343699 
(o x)|known list op on rest arg sublist: ##core#rest-null? r1546 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r1546 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r1546 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r1546 1 
o|substituted constant variable: int1341393716 
(o x)|known list op on rest arg sublist: ##core#rest-null? r2721 1 
(o x)|known list op on rest arg sublist: ##core#rest-car r2721 1 
(o x)|known list op on rest arg sublist: ##core#rest-null? r2721 1 
(o x)|known list op on rest arg sublist: ##core#rest-cdr r2721 1 
o|substituted constant variable: int1341393798 
o|replaced variables: 39 
o|removed binding forms: 49 
o|contracted procedure: k1450 
o|contracted procedure: k2750 
o|removed binding forms: 2 
o|customizable procedures: (check482 chicken.tcp#tcp-port->fileno k2732 loop390 k1388 k2575 chicken.tcp#io-ports loop572 k2256 k2262 read-input516 k2103 k2106 k2112 add-to-buf648 output-to-socket611 loop651 k1861 loop618 k1749 chicken.tcp#gethostaddr k1563) 
o|calls to known targets: 90 
o|unused rest argument: rest436438 f_1540 
o|identified direct recursive calls: f_1865 2 
o|identified direct recursive calls: f_2334 1 
o|unused rest argument: rest704706 f_2561 
o|identified direct recursive calls: f_1358 1 
o|unused rest argument: rest750752 f_2715 
o|fast box initializations: 8 
o|fast global references: 7 
o|fast global assignments: 3 
o|dropping unused closure argument: f_1326 
o|dropping unused closure argument: f_1696 
o|dropping unused closure argument: f_3025 
*/
/* end of file */
